 
 
 
 
c-----------------------------------------------------------------------
c
c 2017.11.22 ---
c     Mattia has found that on his system, the stack arrays are not
c     getting initialized properly.  He has also found that the position
c     recorded in the XYVIQ[0,1,2,3] files gets corrupted.  We should
c     either use a different dclip/rclip while in the "critical" area of
c     writing files, or we should declare them as local variables.  It
c     isn't the routine and its dependent variables that are being
c     overwritten... but just the return vehicle.  Both should be easy
c     to fix.
c
c-----------------------------------------------------------------------
c
c 2017.10.26 ---
c
c     Mattia found a bug; apparently I'm not doing as good of a job
c     as I thought ensuring that stars at the boundaries are recorded
c     only once.  I will now go and focus more carefully on the boundaries
c     and get rid of the 0.5-pixel gray zone.  There's still a way
c     to do things right, but for now this works.  Apparently I thought
c     I was putting things into the master list, and then checking
c     the master list before I put anything else in, but that's apparently
c     not the case.
c
c-----------------------------------------------------------------------
c
c there's something wrong about the NIMFO errors for meth#2 and meth#3
c
 
c-----------------------------------------------------------------------
c
c Q: is there any reason why it does method#2 before method#1?
c
 
c-----------------------------------------------------------------------
c
c 2015.05.06 ---
c * add _PSFTAPERR1_ and _PSFTAPERR2_ to allow tapering of the PSF...
c * at some point, this should be image specific, but not yet...
 
 
c-----------------------------------------------------------------------
c
c 2015.01.26 ---
c * fixed artstar hash to LOGA (from LOGR)
c * I think I fixed the problem that premag stars could sometimes
c   get output more than once
c * add info on which AS is being done out of how many
c * more graceful bomb when too many ASs given for a given tile
c * added some clipping to the standard AS output
c * allow for more than 99 tiles in format statement
c
 
c-----------------------------------------------------------------------
c
c 2014.03.01 --- Flight back from IfA with JLu
c
c * Folded in changes made while at IfA
*   --- Re-allowed the byte type in the image output;
c       (did this more flexibly than before; it saves
c       everything as integer*2, even through the strip
c       phase, but allows you to update a byte mosaic
c       rather than an integer*2 mosaic).
c   --- Re-implemented the x2 mosaic capability; this
c       is particularly useful for working with wfc3/ir
c       images, where x1 is woefully undersampled and
c       not representative of dithered datasets.
c
c * TODO LIST
c   --- For smallish images, it would be good to be able
c       to save as a mosaic *all* of the info for all
c       of the finding waves.  This can be done by flag,
c       since most datasets wouldn't benefit from this.
c       But it would be very useful to be able to show
c       the progression.  This can already be done on
c       a by-tile basis, but it wouldn't be insane to be
c       able to show the whole shebang.
c   --- Allow more precise homing-in on positions (possibly
c       as a flag).
c   --- Show *why* a star was not found in a particular
c       pixel; interesting algorithm issues. (Flag to disable?)
c   --- Make sure the noise is properly added for ASs
c       in IR images
c   --- get 950 format to tell more...
c
c
 
 
c-------------------------------------------------------
c
c setenv OMP_STACKSIZE 800M
c
 
c there are some conflicts when I make
c the arrays too large...
 
c
c need to make AG... double precision!
c
 
c unit numbers... 10--> 30 for readfits...
c others unique ; critical access important
 
 
c
c This now compiles with -fopenmp (!!!!)
c
c I figured out how to specify private variables
c    on different lines
c
c NEXT: need to remove lots of print statements...
c
 
 
c
c FOR REFERENCE, from test.F
c
c !$omp parallel  private(i)
c !$omp parallel  private(j)
c !$omp parallel  shared(fx)
c !$omp do
c       do i = 1, 1000000
c          do j = 1, 1000
c             fx(i) = sqrt(i*1.0)
c             enddo
c          enddo
c !$omp enddo
c !$omp end parallel
c
 
 
 
 
 
c
c the goal of reconfig is to try to allocat the memory as locally as possible...
c
 
 
 
c      real    (kind=4), dimension(:,:,:), allocatable :: pixv_n ! the value image
c      allocate (pixv_n(_TDIM_,_TDIM_,_NDIM_))    ! the value image
 
 
 
 
c--------------------------------------------------------------
c homework...
c
c * let lobad/hibad be specified for each exposure, maybe...
c * shouldn't let different filters to have different positions...
c * need to do pix area correction for HRC
c * need to flip the _lf to be _fl (really?)
c * yet to do: stacking with true pixel boundaries ; for
c             rigorous flux preservation
c
c--------------------------------------------------------------
 
 
 
 
c--------------------------------------------------------------
c
c these top params are now in a default file... "_PARAMS_.KS2"
c
c--------------------------------------------------------------
 
#define _LINUX_ .true.
#define _DOBYTE_ .true.
 
#define _PXDIMX1_ 01200        /* x1 dimensions of the ref frame */
#define _PXDIMY1_ 01200
#define _PXDIMX2_ 02400        /* x2 dimensions of the ref frame */
#define _PXDIMY2_ 02400
 
#define _FDIM_     2           /* number of filters to go through            */
#define _CDIM_     3           /* max num chips/exposure (2 for ACS/UVIS)    */
#define _NDIM_    35           /* max num chips with some projn on any tile  */
#define _GDIM_    35           /* total number of exposures                  */
 
#define _BLANK_     .false.    /* will end up zeroing out images, for tests  */
#define _NONOISE_   .false.    /* if true, then do not add noise to ASs      */
#define _HISTO_SKY_ .false.    /* should go thru the histo-sky documt'n?     */
#define _STACK_REJ_ .false.    /* should we go thru the stack-reject phase?  */
 
 
c------------------------------------------------
c
c how should the images be scaled?
c
#define _MAT_FRAT_ .true.      /* get the image scaling from the MAT file    */
#define _EXP_FRAT_ .false.     /* get the image scaling from the EXP time    */
 
 
c------------------------------------------------
c
c master frame offsets
c
#define _XOFF_   100          /* orig (0,0) in mast frame --> (_XOFF,_YOFF) */
#define _YOFF_   150
 
 
c-----------------------------------------------
c
c pixel limits/values
c
#define _SATVAL_ 99999        /* replacement value for saturated pixels     */
#define _LOBAD_ -50           /* LOBAD value for rejecting pixel value      */
 
#define _MASKFAC_ 2.00        /* scaling for respecting the finding mask    */
#define _OTHRFAC_ 1.00        /* scaling for respecting neighbor-star flux  */
 
 
c------------------------------------------------
c
c numbers of stars
c
#define _NMATMX_   49999       /* max number of stars in a mat file         */
#define _NSTMAX_  199999       /* max number of stars to be used            */
#define _ARTMAX_  199999       /* max number of art stars possible          */
#define _BDIM_      3500       /* max number of brite stars allowed         */
#define _BRITE_DMAX_ 750       /* maximum dist for caring about brite stars */
 
 
 
c------------------------------------
c
c which stacks to make and how?
c
#define _STACK_HOW_ 1
 
#define _MOSAIC_X1_  .true.       /* should ks2 output the x1 master frame? */
#define _MOSAIC_X2_  .false.      /* should ks2 output the x2 master frame? */
!!!#define _MOSAIC_X2_  .true.       /* should ks2 output the x2 master frame? */
 
#define _MOSAIC_SHN_ .false.      /* non-linear scaling above pix valu 6000 */
#define _MOSAIC_FSH_ .false.      /* TRUE = flush panels ; FALSE. = panes   */
#define _DEFPANE_i2_ -32025       /* i2 value for the default pane          */
#define _DEFPANE_b1_ -32001       /* b1 value for the default pane          */
 
#define _MOSAIC_PIX_ .true.       /* output the reg stack?        V */
#define _MOSAIC_SUB_ .true.       /* output the subtracted stack? S */
#define _MOSAIC_MSK_ .true.       /* output the avg mask value?   M */
#define _MOSAIC_NUM_ .true.       /* output the num of images?    N */
#define _MOSAIC_PKM_ .true.       /* output the peak maps?     PQDC */
 
c-------------------------------------------------------------------
c
c need to have SHOW_TILE and SHOW_FIND subdirectories
c
#define _SHOW_TILES_ .false.      /* show locl tiles gen'd at each itern  */
#define _SHOW_TILE_  .false.      /* show locl tiles gen'd for last itern */
 
c-------------------------------------------------------------------
c
c need to have INDIV subdirectory
c
#define _SHOW_MOS_  .false.       /* show mosaic of indiv obsns? */
#define _SHOW_PIXV_ (_SHOW_MOS_)  /* show indiv pixel images?    */
#define _SHOW_PIXU_ (_SHOW_MOS_)  /* show indiv qual images?     */
#define _SHOW_PIXE_ (_SHOW_MOS_)  /* show indiv error images?    */
#define _SHOW_PIXT_ (_SHOW_MOS_)  /* show indiv trans images?    */
#define _SHOW_PIXF_ (_SHOW_MOS_)  /* show indiv model images?    */
#define _SHOW_PIXS_ (_SHOW_MOS_)  /* show indiv subt images?     */
#define _SHOW_PIXM_ (_SHOW_MOS_)  /* show indiv mask images?     */
 
 
c-----------------------------------------------------------------------
c
c the following params will be kept with the program
c
#define _LDIM_   2999             /* max num of stars in a tile       */
 
#define _HASHDM_   99             /* num of hash bins for ASs/PREMAGs */
#define _HASHMX_  999             /* depth of hash table              */
 
#define _SDIM_     99             /* max num of pixels for sky detmn  */
 
 
c--------------------------------------------------
c
c these should never ever change; they're hard-coded
c in some places and soft-coded with these params in
c other places; changing it here would NOT improve
c things
c
#define _HDIM_     151            /* half of _TDIM_ + 1               */
#define _HCEN_     076            /* center of _HDIM_                 */
#define _TDIM_     301            /* size of tile                     */
#define _TCEN_     151            /* center of tile                   */
#define _TTAB_      31            /* num of way-pts in tile for trans */
#define _TRAT_      10            /* num of pixels in each trans tab  */
c _TRAT_ = (_TDIM_-1)/(_TTAB_-1)
 
 
c-------------------------------------------------
c
c this allows a re-tapering of the PSF as it is read in
c
#define _PSFTAPERR1_  6.0         /* within this radius, the PSF is as original */
#define _PSFTAPERR2_ 11.0         /* beyond this radius, the PSF is zero ; between tapered */
 
 
c-------------------------------------------
c
c pixu =  0 : normal pixel
c pixu =  1 : saturated
c pixu =  2 : bad pixel
c pixu =  3 : lobad
c
c-------------------------------------------
 
 
 
 
 
 
c
c
c   *****************************************************************
c   *****************************************************************
c   *****                                                       *****
c   *****                                                       *****
c   *****   KS2 means KS2                                       *****
c   *****                                                       *****
c   *****                                                       *****
c   *****************************************************************
c   *****************************************************************
c
c
      program ks2
      implicit none
 
 
 
 
 
 
c *****************************************************************
c *****************************************************************
c *****
c ***** BASIC GLOBAL VARIABLES VARIABILES
c *****
c ***** THESE ARE ALL PUBLIC VARIABLES
c ***** 1) MANY WILL BE CHANGED ONLY BY KS_SETUP
c ***** 2) THOSE THAT WILL BE MODIFIED CRITICALLY
c *****    GIVEN AT THE END
c *****
c *****************************************************************
c *****************************************************************
 
c
c ********************************************************************
c *****
c ***** 1) MANY WILL BE CHANGED ONLY BY KS_SETUP
c *****
c
      integer iargc
 
      character*80 INFILENAME
      character*80 DIRECT        ! overarching directory
      integer      NDIRECT       ! number of char in dir
      character*7  LABEL7
 
      integer UMIN_KS2, UMAX_KS2
      integer VMIN_KS2, VMAX_KS2
      character*80 FILEO
 
      integer NITMINU
      integer NITMAXU
      common /NITMINMAXU_/NITMINU,NITMAXU
      data    NITMINU/-1/
      data    NITMAXU/-1/
 
      integer ITMINU, ITMAXU
      integer JTMINU, JTMAXU
      common /IJTMINMAXU_/ITMINU,ITMAXU,JTMINU,JTMAXU
      data    ITMINU/-1/
      data    ITMAXU/-1/
      data    JTMINU/-1/
      data    JTMAXU/-1/
 
      integer      Gs
      integer      Fs
      integer      Cs
 
      character*80, dimension(:), allocatable :: FILENAME_G
      character*80, dimension(:), allocatable ::   SUBDIR_G
      integer*4   , dimension(:), allocatable ::  NSUBDIR_G
      character*80, dimension(:), allocatable ::  FILEPSF_G
      character*80, dimension(:), allocatable ::  FILEGCS_G
      integer*4   , dimension(:), allocatable ::      FFF_G ! filter number ! order
      integer*4   , dimension(:), allocatable ::      RAP_G ! aperture to use
      integer*4   , dimension(:), allocatable ::      KKK_G ! the kind of chip
      integer*4   , dimension(:), allocatable ::      FLT_G ! the dist-corr filtnum
      character*9 , dimension(:), allocatable ::      POS_G ! use for positions
      character*9 , dimension(:), allocatable ::      FND_G ! use for any finding?
      real*4      , dimension(:), allocatable ::      SKY_G ! avg sky value for image
      real*4      , dimension(:), allocatable ::      ZPU_G ! a ZP to override
      real*4      , dimension(:), allocatable ::      MSK_G ! mask-scaling for image #G
      real*4      , dimension(:), allocatable ::      OTH_G ! other-scaling for image#G
 
      real*4      , dimension(:), allocatable ::      EXP_F  ! standard exposure time for this filter
      real*4      , dimension(:), allocatable ::      EXP_G  ! exposure time for this image
      real*4      , dimension(:), allocatable ::      SCL_F  ! supplementary scaling for output image
 
      real*8      , dimension(:,:), allocatable :: ucen_cg, vcen_cg
      integer*4   , dimension(:,:), allocatable :: icen_cg, jcen_cg
      real*8      , dimension(:,:), allocatable :: xcen_cg, ycen_cg
      real*8      , dimension(:,:), allocatable :: AG_CG, BG_CG
      real*8      , dimension(:,:), allocatable :: CG_CG, DG_CG
      real*8      , dimension(:,:), allocatable :: GA_CG, GB_CG
      real*8      , dimension(:,:), allocatable :: GC_CG, GD_CG
      real*4      , dimension(:,:), allocatable :: ZP_CG, SC_CG
 
      real*4      , dimension(:,:,:,:,:), allocatable :: psf_f
      real*4      , dimension(:,:,:)    , allocatable :: psf_mask_f
 
      logical ONEOFF
      data    ONEOFF/.false./
      integer ONEOFFX, ONEOFFY
      data    ONEOFFX/0000/
      data    ONEOFFY/0000/
 
c-----------------------------------------------
c
c     bright-star information ; this stores the info for all the bright stars;
c     these stars have special status in that they can influence things over
c     the scale of more than one tile; the tiles have buffers of 10 pixels or so
c     around the edges, most stars can only influence things within their own
c     tile, but these have wings and diffraction spikes that reach...
c
      integer B                                         ! current bright stars number
      integer Bs                                        ! total number of bright stars
      real*8   , dimension(:),   allocatable :: uref_b  ! location of bright star
      real*8   , dimension(:),   allocatable :: vref_b  ! location of bright star
      real     , dimension(:,:), allocatable :: zref_bf ! location of bright star
      integer*4, dimension(:),   allocatable :: nref_b
 
c---------------------------------------------
c the hash info for organizing the master list
c
      integer*2 , dimension(:,:),   allocatable :: nash_000  ! can have more than 256 in a patch, so int*2
      integer   , dimension(:,:,:), allocatable :: hash_000  ! can have more than 32000 in image, need int*4
 
 
 
c ********************************************************************
c *****
c ***** 2) THOSE THAT WILL BE MODIFIED CRITICALLY
c *****    GIVEN AT THE END
c *****
 
c---------------------------------------------
c master list variables
c
      integer NMAST      ! current master-star number
      integer NMASTs     ! total number of mast-list stars
      integer NMASTi     ! number of master-stars at get-go
      integer NMASTsho   ! number to show in output files ; if AS test...
 
 
c---------------------------------------------
c meth0: this is the official "found" position ;
c        the position comes from averages of indiv images ;
c        the flux comes from lsq, simultaneous fitting
c        of fixed-pos sources within single exposures,
c        then averaging.
c
      real*8    , dimension(:),   allocatable ::  umast0
      real*8    , dimension(:),   allocatable ::  vmast0
      real*4    , dimension(:,:), allocatable ::  zmast0
      real*4    , dimension(:,:), allocatable :: szmast0
      real*4    , dimension(:),   allocatable ::  xmast0  ! x-position in tile
      real*4    , dimension(:),   allocatable ::  ymast0  ! y-position in tile
      integer*4 , dimension(:),   allocatable ::  wmast0  ! iteration number where found
      real*4    , dimension(:,:), allocatable ::  smast0  ! sky background
      real*4    , dimension(:,:), allocatable :: ssmast0  ! sigma sky background
      integer*2 , dimension(:,:), allocatable ::  fmast0
      integer*2 , dimension(:,:), allocatable ::  gmast0
 
c--------------------------------------------
c meth1: this is the position that comes from
c        fitting for (x,y,z) in each exposure,
c        with neighbors subtracted
c
      real*4    , dimension(:,:), allocatable ::  zmast1
      real*4    , dimension(:,:), allocatable :: szmast1
      real*4    , dimension(:,:), allocatable ::  qmast1
      real*4    , dimension(:,:), allocatable ::  omast1
      integer*2 , dimension(:,:), allocatable ::  fmast1
      integer*2 , dimension(:,:), allocatable ::  gmast1
 
c--------------------------------------------
c meth2: this is the position that comes
c        from fitting for (z) in each
c        exposure, with fixed position and
c        neighbors subtracted
c
      real*4    , dimension(:,:), allocatable ::  zmast2
      real*4    , dimension(:,:), allocatable :: szmast2
      real*4    , dimension(:,:), allocatable ::  qmast2
      real*4    , dimension(:,:), allocatable ::  omast2
      integer*2 , dimension(:,:), allocatable ::  fmast2
      integer*2 , dimension(:,:), allocatable ::  gmast2
 
 
c--------------------------------------------
c meth3: this is the position that comes
c        from fitting for (z) in each
c        exposure, with fixed position and
c        neighbors subtracted
c
      real      , dimension(:,:), allocatable ::  zmast3
      real      , dimension(:,:), allocatable :: szmast3
      real      , dimension(:,:), allocatable ::  qmast3
      real      , dimension(:,:), allocatable ::  omast3
      integer*2 , dimension(:,:), allocatable ::  fmast3
      integer*2 , dimension(:,:), allocatable ::  gmast3
 
c--------------------------------------------
c general info for each source
c
      real*4     , dimension(:,:), allocatable ::  barsky
      real*4     , dimension(:,:), allocatable ::  rmssky
 
c-----------------------------------------------------------
c
c this contains the strips of the stacks; for more efficient
c writing...
c
      integer (kind=2), dimension(:,:,:), allocatable ::  stackv_sf1 ! strip val stack for filt F
      integer (kind=2), dimension(:,:,:), allocatable ::  stackd_sf1 ! strip sub stack for filt F
      integer (kind=2), dimension(:,:,:), allocatable ::  stackm_sf1 ! strip mask stack for filt F
      integer (kind=2), dimension(:,:,:), allocatable ::  stackn_sf1 ! strip num stack for filt F
      integer (kind=2), dimension(:,:)  , allocatable ::   stackp_s1 ! strip peak stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stackq_s1 ! strip qual stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stackd_s1 ! strip prox stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stackc_s1 ! strip find stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stacky_s1 ! strip find stack
      byte            , dimension(:,:)  , allocatable :: stack_b1_s1 ! strip byte-hold
 
      integer (kind=2), dimension(:,:,:), allocatable ::  stackv_sf2 ! strip val stack for filt F
      integer (kind=2), dimension(:,:,:), allocatable ::  stackd_sf2 ! strip sub stack for filt F
      integer (kind=2), dimension(:,:,:), allocatable ::  stackm_sf2 ! strip mask stack for filt F
      integer (kind=2), dimension(:,:,:), allocatable ::  stackn_sf2 ! strip num stack for filt F
      integer (kind=2), dimension(:,:)  , allocatable ::   stackp_s2 ! strip peak stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stackq_s2 ! strip qual stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stackd_s2 ! strip prox stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stackc_s2 ! strip find stack
      integer (kind=2), dimension(:,:)  , allocatable ::   stacky_s2 ! strip find stack
      byte            , dimension(:,:)  , allocatable :: stack_b1_s2 ! strip byte-hold
 
c-----------------------------------------------------
c
c used for putting the strip into the stack; delicate!
c
      integer i2min, i2max
      integer j2min, j2max
      integer i1min, i1max
      integer j1min, j1max
      integer iulo,  ivlo
 
c------------------------------------------
c
c info for artificial stars
c
      integer (kind=2), dimension(:,:),   allocatable :: nash_ART
      integer (kind=4), dimension(:,:,:), allocatable :: hash_ART
 
      character CMODE ! 'R' = real/find
                      ! 'D' = real/drive
                      ! 'A' = art/one-at-a-time
                      ! 'C' = art/all-at-once
 
      real*8 , dimension(:)  , allocatable :: uart0 ! master-frame position for art stars
      real*8 , dimension(:)  , allocatable :: vart0
      real*8 , dimension(:,:), allocatable :: zart0 ! master-frame flux for art stars
 
c----------------------------------------
c
c temp variables for outputting the NIMFO
c
      real*8 uu_tuv, vv_tuv  ! tile master (u,v) for each individual meast
      real   xr_txy, yr_txy  ! abs position in raw frames for indiv meast
      real   xt_tuv, yt_tuv  ! abs position in raw frames for indiv meast
      real*8 uu, vv          ! abs master position for indiv meast
      real   magu            ! flux to mag...
      real   ut, vt
      real   xt0,yt0
      real   xr0,yr0
      real   xr1,yr1
 
c---------------------------------------------------
c
c basic flags (global)
c
      logical LOGNIMFO
      common/LOGNIMFO_/LOGNIMFO
      data LOGNIMFO/.false./
 
      logical LOGFINFO
      common/LOGFINFO_/LOGFINFO
      data LOGFINFO/.false./
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
      data   VERBOSE/.false./
 
 
      logical SHOW_TILE
      common /SHOW_TILE_/SHOW_TILE
      data    SHOW_TILE/_SHOW_TILE_/
 
      logical SHOW_TILES
      common /SHOW_TILES_/SHOW_TILES
      data    SHOW_TILES /_SHOW_TILES_/
 
      logical MOSAIC_X1
      common /MOSAIC_X1_/MOSAIC_X1
      data    MOSAIC_X1 /_MOSAIC_X1_/
 
      logical MOSAIC_X2
      common /MOSAIC_X2_/MOSAIC_X2
      data    MOSAIC_X2 /_MOSAIC_X2_/
 
      real    MASKFAC
      common /MASKFAC_/MASKFAC
      data    MASKFAC /_MASKFAC_/
 
      real    OTHRFAC
      common /OTHRFAC_/OTHRFAC
      data    OTHRFAC /_OTHRFAC_/
 
c-------------------------------------------
c
c global defaults for finding parameters...
c
      integer     HMIN_NIT(10)
      real        SSIG_NIT(10)
 
      integer     QMIN_NIT(10)
      real        QSEL_NIT(10)
      real        QSEP_NIT(10)
 
      integer     DMIN_NIT(10)
      real        DSEP_NIT(10)
 
      integer     PMIN_NIT(10)
      real        PSEP_NIT(10)
 
      real        OPRX_NIT(10)
      real        OPRV_NIT(10)
 
      real        RSIZ_NIT(11)
      character*7 RCOL_NIT(11)
      integer     RWID_NIT(11)
 
      common /HMIN_NIT/HMIN_NIT
      common /SSIG_NIT/SSIG_NIT
 
      common /QMIN_NIT/QMIN_NIT
      common /QSEL_NIT/QSEL_NIT
      common /QSEP_NIT/QSEP_NIT
 
      common /DMIN_NIT/DMIN_NIT
      common /DSEP_NIT/DSEP_NIT
 
      common /PMIN_NIT/PMIN_NIT
      common /PSEP_NIT/PSEP_NIT
 
      common /OPRX_NIT/OPRX_NIT
      common /OPRV_NIT/OPRV_NIT
 
      common /RSIZ_NIT/RSIZ_NIT
      common /RCOL_NIT/RCOL_NIT
      common /RWID_NIT/RWID_NIT
 
      data HMIN_NIT / 5, 4, 3, 2, 2, 1, 1,99, 9, 9/
      data SSIG_NIT / 2.50, 2.50, 2.50, 2.50, 2.50,
     .                2.50, 2.50,99.99,99.99,99.99/
 
      data QMIN_NIT / 1, 1, 1, 2,99,99,99,99,99,99/
      data QSEL_NIT / 0.90, 0.90, 0.90, 0.90, 9.90,
     .                9.90, 9.90, 9.99, 9.99, 9.99/
      data QSEP_NIT / 0.50, 0.50, 0.50, 0.50, 0.50,
     .                0.50, 0.50, 0.50, 0.50, 0.50/
 
      data DMIN_NIT / 2, 2, 2, 2, 3, 3, 4,99,99,99/
      data DSEP_NIT / 0.25, 0.25, 0.25, 0.25, 0.25,
     .                0.25, 0.25, 0.25, 0.25, 0.25/
 
      data PMIN_NIT / 2, 2, 2, 3, 3, 4, 4,99,99,99/
      data PSEP_NIT / 0.75, 0.75, 0.75, 0.75, 0.75,
     .                0.75, 0.75, 0.75, 0.75, 0.75/
 
      data OPRX_NIT / 2.50, 2.50, 2.50, 2.50, 2.50,
     .                2.50, 2.50, 2.50, 2.50, 2.50/
      data OPRV_NIT / 4.50, 4.50, 4.50, 4.50, 4.50,
     .                4.50, 4.50, 4.50, 4.50, 4.50/
 
      data RSIZ_NIT / 3.50, 0.90, 0.80, 0.70, 0.60,
     .                0.50, 0.40, 0.35, 0.25, 0.15,
     .                5.00/
      data RCOL_NIT / 'green  ','cyan  ','red    ',
     .                'magenta','blue  ','yellow ',
     .                'green  ','cyan  ','red    ',
     .                'magenta','blue  '/
      data RWID_NIT / 2, 2, 1, 1, 1, 1, 1, 1, 1, 1,
     .                3/
 
c---------------------------------------------------------------
c
c should the strip be added to the stack?
c
      logical UPDATE_STACK
 
c---------------------------------------------------------------
c
c filling this variable will also be critical
c
      integer GG, G, H
      integer (kind=4), dimension(:,:,:), allocatable :: sky_stat
 
 
c---------------------------------------------------------------
c
c general purpose ; only used here in critical way
c
      real    rclip
      real*8  dclip
      real    loc_flux
      real    loc_mask
 
c---------------------------------------------------------------
c
c this is a global variable
c
      integer JT                ! global vertical tile reference
      integer VREF_T
 
 
 
 
 
 
c
c   **********************************************************************************************************
c   **********************************************************************************************************
c   *****
c   ***** LOCAL (PRIVATE) VARIABLES VARIABILES
c   *****
c   **********************************************************************************************************
c   **********************************************************************************************************
 
 
c------------------------------------------------
c
c location of local tile
c
      integer UREF_T            ! center of tile in ref frame
 
      integer UMINP, UMAXP      ! region over which this tile is prime
      integer VMINP, VMAXP
 
      integer UMIN_TU, UMAX_TU  ! region to actually analyze
      integer VMIN_TU, VMAX_TU  !   within the tile
 
      integer NMASTo            ! number of mast-list stars at the beginning of tile
 
 
c----------------------------
c
c finding through local tile
c
      integer NIT, NITu
 
c------------------------------------------------
c
c filled in from initialization
c
      integer     Ns
      integer*4  , dimension(:), allocatable :: GGG_N  ! the image number
      integer*4  , dimension(:), allocatable :: KKK_N  ! the detector it corresponds to
      integer*4  , dimension(:), allocatable :: FFF_N  ! the filter it applies to
      integer*4  , dimension(:), allocatable :: RAP_N  ! the aperture to use for this image
      real*4     , dimension(:), allocatable :: ZPU_N  ! the zeropoint
      real*4     , dimension(:), allocatable :: SCL_N  ! the scaling that will be applied
      real*4     , dimension(:), allocatable :: SKY_N  ! the scaling that will be applied
      integer*4  , dimension(:), allocatable :: CCC_N  ! the chip number
      integer*4  , dimension(:), allocatable :: FLT_N  ! the filter number (for distortion)
      character*9, dimension(:), allocatable :: FND_N  ! iteration to use for finding at all
      character*9, dimension(:), allocatable :: POS_N  ! iteration to use for finding position
      real*4     , dimension(:), allocatable :: EXP_N  ! exposure time for this image
      real*4     , dimension(:), allocatable :: MSK_N  ! ? not sure what this is
      real*4     , dimension(:), allocatable :: OTH_N  ! ? not sure what this is
 
      real*8     , dimension(:), allocatable :: AG_N, BG_N, CG_N, DG_N
      real*8     , dimension(:), allocatable :: GA_N, GB_N, GC_N, GD_N
 
      integer*4  , dimension(:), allocatable :: ICEN_N, JCEN_N     ! the reference pixel
      real*8     , dimension(:), allocatable :: UCEN_N, VCEN_N     ! the master-frame pos of ref pixel
      real*8     , dimension(:), allocatable :: XCEN_N, YCEN_N     ! the dist-corr ref pixel
 
      integer*4  , dimension(:), allocatable :: ITIL_N, JTIL_N     ! the reference pixel
      real*8     , dimension(:), allocatable :: UTIL_N, VTIL_N     ! the master-frame pos of ref pixel
      real*8     , dimension(:), allocatable :: XTIL_N, YTIL_N     ! the dist-corr ref pixel
 
      real*4     , dimension(:,:,:), allocatable :: UTAB_N, VTAB_N ! tabular-based transformations
      real*4     , dimension(:,:,:), allocatable :: XTAB_N, YTAB_N ! tabular-based transformations
 
      character*80,dimension(:)    , allocatable :: FILEPSF_N
      character*80,dimension(:)    , allocatable :: FILEGCS_N
      character*80,dimension(:)    , allocatable :: FILEPIX_N
 
      integer BBs                            ! bright stars relevant to tile
 
c-------------------------------------------------------------------------
c
c     these images be allocated within each tile, and deallocated after each
c     tile; to be efficient, we need to know how many chips Ns overlap the
c     tile before we can say how much space to allocate; we want to allocate
c     the mimimum, particularly if we're going to do things in parallel
c
      real    (kind=4), dimension(:,:,:), allocatable :: pixv_n ! the value image
      real    (kind=4), dimension(:,:,:), allocatable :: pixf_n ! the model image
      real    (kind=4), dimension(:,:,:), allocatable :: pixd_n ! the subtracted image
      real    (kind=4), dimension(:,:,:), allocatable :: pixt_n ! the transformed image
      real    (kind=4), dimension(:,:,:), allocatable :: pixe_n ! the error image
      real    (kind=4), dimension(:,:,:), allocatable :: pixm_n ! the mask image
      byte            , dimension(:,:,:), allocatable :: pixu_n ! the flag image
      real    (kind=4), dimension(:,:,:), allocatable :: pixv_h ! "hold" of the value image (a copy)
      real    (kind=4), dimension(:,:,:), allocatable :: pixe_h ! "hold" of the error image (a copy)
 
      real    (kind=4), dimension(:,:,:), allocatable ::  psf_n ! the net PSF for each image
 
 
c----------------------------------------------
c
c info on the stars found in the tile
c
      integer L     ! star number within the tile
      integer Ls    ! number of stars in the tile
      integer Lo    ! number of beginning stars in the tile
      integer Lh    ! number of beginning stars in the find_tile run
      integer Lprox ! the closest
 
c--------------------------------------------------------------
c finding statistics...
c
      real      , dimension(:), allocatable ::   uF_l, vF_l     ! the initial found coordinates (master frame)
      real      , dimension(:), allocatable ::   mF_l           !     (the rough flund flux in exposure#1)
      integer*4 , dimension(:), allocatable ::   y0_l           ! why was this found? 1=quality, 2=proximity, 3=quantity
      integer*4 , dimension(:), allocatable :: cfnd_l
      integer*4 , dimension(:), allocatable :: qmin_l, qfnd_l   ! info on the q-based finding criteria
      integer*4 , dimension(:), allocatable :: dmin_l, dfnd_l   ! info on the d-based finding criteria
      integer*4 , dimension(:), allocatable :: pmin_l, pfnd_l   ! info on the p-based finding criteria
      real*8    , dimension(:), allocatable :: ubri_l, vbri_l   ! proximity to bright star
      real*4    , dimension(:), allocatable :: zbri_l           ! mask value at central pixel
      real*4    , dimension(:), allocatable :: flux_l           ! flux over sky from stacked image#1
      real*4    , dimension(:), allocatable :: mask_l           ! mask value at central pixel
 
 
 
 
c-------------------------------------------------------------------
c
c these are the parameters for which things will be modeled
c
      real*4    , dimension(:), allocatable :: um_l
      real*4    , dimension(:), allocatable :: vm_l
      real*4    , dimension(:), allocatable :: zm_l
      logical*4 , dimension(:), allocatable :: gg_l  ! good to record
      real*8    , dimension(:), allocatable :: zu_l  ! the flux to use for final subtraction
 
 
 
c--------------------------------------------------------------
c meth0: this is the position that comes from the least-squares
c        fitting for (z) in each exposure, with fixed position;
c        neighbors done simultaneously
c
      real*8    , dimension(:), allocatable ::  uu_l, vv_l
      real*4    , dimension(:), allocatable ::  u0_l, v0_l
      real*4    , dimension(:), allocatable :: su0_l,sv0_l
 
 
      real*4    , dimension(:,:), allocatable :: u0_ln
      real*4    , dimension(:,:), allocatable :: v0_ln
      real*4    , dimension(:,:), allocatable :: z0_ln
      real*4    , dimension(:,:), allocatable ::sz0_ln
      integer*2 , dimension(:,:), allocatable ::gz0_ln
      integer*2 , dimension(:,:), allocatable ::gp0_ln
 
      real*4    , dimension(:,:), allocatable :: z0_lf
      real*4    , dimension(:,:), allocatable ::sz0_lf
 
      integer*4 , dimension(:),   allocatable :: b0_l
      integer*4 , dimension(:),   allocatable :: n0_l
      integer*4 , dimension(:),   allocatable :: o0_l
      real*4    , dimension(:),   allocatable :: r0_l
      integer*4 , dimension(:),   allocatable :: w0_l
      integer*2 , dimension(:,:), allocatable :: f0_lf
      integer*2 , dimension(:,:), allocatable :: g0_lf
 
 
 
 
c---------------------------------------------------------
c
c meth1: this contains the measuring parameters for the
c        tile-based measts that fit for all three (x,y,z),
c        with meth0 neighbors subtracted
c
      real*4    , dimension(:,:), allocatable :: u1_ln,  v1_ln
      real*4    , dimension(:,:), allocatable :: x1_ln,  y1_ln
      real*4    , dimension(:,:), allocatable :: z1_ln, sz1_ln
      real*4    , dimension(:,:), allocatable :: s1_ln, ss1_ln
      real*4    , dimension(:,:), allocatable :: q1_ln
      real*4    , dimension(:,:), allocatable :: o1_ln
      integer*2 , dimension(:,:), allocatable :: f1_ln
      integer*2 , dimension(:,:), allocatable :: g1_ln
 
c---------------------------------------------------------
c
c meth2: the measuring parameters for meth2 (z-only)
c        this assumes fixed positions and just does
c        simple PSF-based aperture photometry (PBAP)
c
      real*4    , dimension(:,:), allocatable :: x2_ln,  y2_ln
      real*4    , dimension(:,:), allocatable :: z2_ln, sz2_ln
      real*4    , dimension(:,:), allocatable :: s2_ln, ss2_ln
      real*4    , dimension(:,:), allocatable :: q2_ln
      real*4    , dimension(:,:), allocatable :: o2_ln
      integer*2 , dimension(:,:), allocatable :: f2_ln
      integer*2 , dimension(:,:), allocatable :: g2_ln
 
 
c---------------------------------------------------------
c
c meth3: the measuring parameters for meth3 (local z-only)
c        this assumes fixed positions and just does
c        simple PSF-based aperture photometry (PBAP); sky
c        determined uber-locally
c
      real*4    , dimension(:,:), allocatable :: x3_ln,  y3_ln
      real*4    , dimension(:,:), allocatable :: z3_ln, sz3_ln
      real*4    , dimension(:,:), allocatable :: s3_ln, ss3_ln
      real*4    , dimension(:,:), allocatable :: q3_ln
      real*4    , dimension(:,:), allocatable :: o3_ln
      integer*2 , dimension(:,:), allocatable :: f3_ln
      integer*2 , dimension(:,:), allocatable :: g3_ln
 
 
c---------------------------------------------------------
c
c rmssky...
c
       real bar_lf(_LDIM_,_FDIM_), barc_lf(_LDIM_,_FDIM_)
       real rms_lf(_LDIM_,_FDIM_), rmsc_lf(_LDIM_,_FDIM_)
 
c----------------------------------------------
c
c this contains the by-filter averages for the
c tile-based measurements
c
      real*4    , dimension(:,:), allocatable :: u1_lf, su1_lf
      real*4    , dimension(:,:), allocatable :: v1_lf, sv1_lf
      real*4    , dimension(:,:), allocatable :: x1_lf,  y1_lf
      real*4    , dimension(:,:), allocatable :: z1_lf, sz1_lf
      real*4    , dimension(:,:), allocatable :: s1_lf, ss1_lf
      real*4    , dimension(:,:), allocatable :: q1_lf
      real*4    , dimension(:,:), allocatable :: o1_lf
      integer*2 , dimension(:,:), allocatable :: f1_lf
      integer*2 , dimension(:,:), allocatable :: g1_lf
 
      real*4    , dimension(:,:), allocatable :: x2_lf,  y2_lf
      real*4    , dimension(:,:), allocatable :: z2_lf, sz2_lf
      real*4    , dimension(:,:), allocatable :: s2_lf, ss2_lf
      real*4    , dimension(:,:), allocatable :: q2_lf
      real*4    , dimension(:,:), allocatable :: o2_lf
      integer*2 , dimension(:,:), allocatable :: f2_lf
      integer*2 , dimension(:,:), allocatable :: g2_lf
 
      real*4    , dimension(:,:), allocatable :: x3_lf,  y3_lf
      real*4    , dimension(:,:), allocatable :: z3_lf, sz3_lf
      real*4    , dimension(:,:), allocatable :: s3_lf, ss3_lf
      real*4    , dimension(:,:), allocatable :: q3_lf
      real*4    , dimension(:,:), allocatable :: o3_lf
      integer*2 , dimension(:,:), allocatable :: f3_lf
      integer*2 , dimension(:,:), allocatable :: g3_lf
 
 
c---------------------------------------------------
c
c this contains the stack info for each tile
c
 
      real    (kind=4), dimension(:,:,:), allocatable :: stackv_tf ! the pixel value
      real    (kind=4), dimension(:,:,:), allocatable :: stackf_tf ! the model
      real    (kind=4), dimension(:,:,:), allocatable :: stacks_tf ! the subtracted: value-model
      real    (kind=4), dimension(:,:,:), allocatable :: stackm_tf ! the mask
      integer (kind=2), dimension(:,:,:), allocatable :: stackp_tf ! the peak map
      integer (kind=2), dimension(:,:,:), allocatable :: stackn_tf ! the num available for peak
 
      integer (kind=2), dimension(:,:),   allocatable :: stacky_t  ! total covg possible
      integer (kind=2), dimension(:,:),   allocatable :: stackc_t  ! total covg possible
      integer (kind=2), dimension(:,:),   allocatable :: stackq_t  ! total quality peaks
      integer (kind=2), dimension(:,:),   allocatable :: stackd_t  ! total proximate peaks
      integer (kind=2), dimension(:,:),   allocatable :: stackp_t  ! total quantity peaks
      integer (kind=2), dimension(:,:),   allocatable :: stackpu   ! peak: hold variable to upsample
      integer (kind=2), dimension(:,:),   allocatable :: stackqu   ! qual: hold variable to upsample
      integer (kind=2), dimension(:,:),   allocatable :: stackdu   ! prox: hold variable to upsample
      integer (kind=2), dimension(:,:),   allocatable :: stackcu   ! cuse: hold variable to upsample
      integer (kind=2), dimension(:,:),   allocatable :: stackyu   ! cuse: hold variable to upsample
 
      byte            , dimension(:,:),   allocatable :: stacktu   ! flag whether is prime in tile
 
 
 
 
c----------------------------------------------------
c
c local information for AS tests
c
      integer   NART                    ! current AS test
      integer   NARTs                   ! total number of AS tests to do
      integer   NARTi                   ! starting AS loop for this tile (1)
      integer   NARTf                   ! ending number of AS loop
      integer   NARTu                   ! total number of AS tests
      integer   NARTn(_HASHMX_)         ! the AS n-to-NART mapping for this tile
      integer   NARTo                   ! total number of AS tests output
 
      integer iumin, iumax
      integer ivmin, ivmax
 
c----------------------------------------------------
c local list of ASs
c
      real*8    uartn(_HASHMX_)
      real*8    vartn(_HASHMX_)
      real*8    zartn(_HASHMX_,_FDIM_)
 
      real*8    uartu, vartu  ! the current art star
      real      xartu, yartu  ! the current art star
      real      zartu(_FDIM_)
      real      sartu(_FDIM_)
      real      xartu_1(1)
      real      yartu_1(1)
 
      integer  findart_nit    ! store info about when found (if found)
      integer  findart_pmap
      integer  findart_qmap
      integer  findart_dmap
      integer  findart_cmap
 
 
 
c----------------------------------------------------
c general purpose variable (often needed within tile)
c
      integer F
      integer i, j, n
      integer ii,jj
      real    dd, ddmin
      integer NFND_NIT(9), NMASTh
 
      integer IT                ! local tile reference
 
 
 
c     CALL OMP_SET_NUM_THREADS(8)
 
c----------------------------------------------------------------------------
c
c   *************************************************************************
c   *****                                                               *****
c   *****                                                               *****
c   ***** BEGIN MAIN PROGRAM                                            *****
c   *****                                                               *****
c   *****                                                               *****
c   *************************************************************************
c
 
c------------------------------------------
c
c initialize the random number generator
c
      print*,'           '
      print*,'KS2 BEGIN! '
      print*,'           '
      dd = rand(int(time()))
      NARTs = 0
 
      !call log_zone(00,'initialize ') ! initialize
 
      if (iargc().ne.1) then
         print*,'NEED 1 ARG... INPUT FILE NAME!'
         stop
         endif
      call getarg(1,INFILENAME)
      call extract_GsFsCs(INFILENAME,Gs,Fs,Cs)
      write(*,'(''TOTAL IN FILE'',a80)') INFILENAME
      write(*,'('' Gs: '',i4)') Gs
      write(*,'('' Fs: '',i4)') Fs
      write(*,'('' Cs: '',i4)') Cs
      if (Gs.gt._GDIM_) stop 'Gs.gt._GDIM_'
      if (Fs.gt._FDIM_) stop 'Fs.gt._FDIM_'
      if (Cs.gt._CDIM_) stop 'Cs.gt._CDIM_'
 
 
c-------------------------------------------------------------------
c
c do the monster allocation...
c
      allocate(FILENAME_G(Gs))
      allocate(  SUBDIR_G(Gs))
      allocate( NSUBDIR_G(Gs))
      allocate( FILEPSF_G(Gs))
      allocate( FILEGCS_G(Gs))
      allocate(     FFF_G(Gs)) ! filter number ! order
      allocate(     RAP_G(Gs)) ! aperture to use
      allocate(     KKK_G(Gs)) ! the kind of chip
      allocate(     FLT_G(Gs)) ! the dist-corr filtnum
      allocate(     POS_G(Gs)) ! use for positions
      allocate(     FND_G(Gs)) ! use for any finding?
      allocate(     SKY_G(Gs)) ! avg sky value for image
      allocate(     ZPU_G(Gs)) ! a ZP to override
      allocate(     MSK_G(Gs)) ! mask-scaling for image #G
      allocate(     OTH_G(Gs)) ! other-scaling for image#G
      allocate(     EXP_G(Gs)) ! exposure time for this image
 
      allocate(  EXP_F(Fs))
      allocate(  SCL_F(Fs))
 
      allocate(ucen_cg(Cs,Gs),vcen_cg(_CDIM_,Gs))
      allocate(icen_cg(Cs,Gs),jcen_cg(_CDIM_,Gs))
      allocate(xcen_cg(Cs,Gs),ycen_cg(_CDIM_,Gs))
 
      allocate(AG_CG(Cs,Gs),BG_CG(_CDIM_,Gs))
      allocate(CG_CG(Cs,Gs),DG_CG(_CDIM_,Gs))
      allocate(GA_CG(Cs,Gs),GB_CG(_CDIM_,Gs))
      allocate(GC_CG(Cs,Gs),GD_CG(_CDIM_,Gs))
      allocate(ZP_CG(Cs,Gs))
      allocate(SC_CG(Cs,Gs))
 
      allocate(psf_f(101,101,09,10,Fs))   ! we have at most an array of 9x10 PSFs for each detector
      allocate(psf_mask_f(901,901,Fs))    ! this is the large-format PSF that is used for masking
 
      allocate(uref_b(_BDIM_))            ! location of bright star
      allocate(vref_b(_BDIM_))            ! location of bright star
      allocate(zref_bf(_BDIM_,Fs))        ! location of bright star
      allocate(nref_b(_BDIM_))
 
      allocate(nash_000(_HASHDM_,_HASHDM_))           ! can have more than 256 in a patch, so int*2
      allocate(hash_000(_HASHDM_,_HASHDM_,_HASHMX_))  ! can have more than 65535 in image, need int*4
 
      allocate( umast0(_NSTMAX_))
      allocate( vmast0(_NSTMAX_))
      allocate( zmast0(_NSTMAX_,Fs))
      allocate(szmast0(_NSTMAX_,Fs))
      allocate( xmast0(_NSTMAX_))        ! x-position in tile
      allocate( ymast0(_NSTMAX_))        ! y-position in tile
      allocate( wmast0(_NSTMAX_))        ! iteration number where found
      allocate( smast0(_NSTMAX_,Fs))     ! sky background
      allocate(ssmast0(_NSTMAX_,Fs))     ! sigma sky background
      allocate( fmast0(_NSTMAX_,Fs))
      allocate( gmast0(_NSTMAX_,Fs))
 
      allocate( zmast1(_NSTMAX_,Fs))
      allocate(szmast1(_NSTMAX_,Fs))
      allocate( qmast1(_NSTMAX_,Fs))
      allocate( omast1(_NSTMAX_,Fs))
      allocate( fmast1(_NSTMAX_,Fs))
      allocate( gmast1(_NSTMAX_,Fs))
 
      allocate( zmast2(_NSTMAX_,Fs))
      allocate(szmast2(_NSTMAX_,Fs))
      allocate( qmast2(_NSTMAX_,Fs))
      allocate( omast2(_NSTMAX_,Fs))
      allocate( fmast2(_NSTMAX_,Fs))
      allocate( gmast2(_NSTMAX_,Fs))
 
      allocate( zmast3(_NSTMAX_,Fs))
      allocate(szmast3(_NSTMAX_,Fs))
      allocate( qmast3(_NSTMAX_,Fs))
      allocate( omast3(_NSTMAX_,Fs))
      allocate( fmast3(_NSTMAX_,Fs))
      allocate( gmast3(_NSTMAX_,Fs))
 
      allocate(barsky(_NSTMAX_,Fs))
      allocate(rmssky(_NSTMAX_,Fs))
 
      allocate(nash_ART(_HASHDM_,_HASHDM_))
      allocate(hash_ART(_HASHDM_,_HASHDM_,_HASHMX_))
 
      allocate(uart0(_ARTMAX_))
      allocate(vart0(_ARTMAX_))
      allocate(zart0(_ARTMAX_,Fs))
 
c------------------------------------------------------
c
c will read in the background info for *all* images
c
      call ks2_setup(INFILENAME,LABEL7,DIRECT,NDIRECT,
     .                  UMIN_KS2,UMAX_KS2,VMIN_KS2,VMAX_KS2,
     .               Gs,FILENAME_G,SUBDIR_G,NSUBDIR_G,EXP_G,
     .                  FILEPSF_G, FILEGCS_G,
     .                  ucen_cg, vcen_cg,
     .                  icen_cg, jcen_cg,
     .                  xcen_cg, ycen_cg,
     .                  AG_CG,BG_CG,CG_CG,DG_CG,
     .                  GA_CG,GB_CG,GC_CG,GD_CG,
     .                  ZP_CG,SC_CG,
     .                  FFF_G,KKK_G,FLT_G,RAP_G,POS_G,FND_G,
     .                        SKY_G,ZPU_G,MSK_G,OTH_G,
     .                  psf_f, psf_mask_f,
     .               Bs,uref_b,vref_b,zref_bf,
     .               Fs,EXP_F,SCL_F,CMODE,ONEOFF,ONEOFFX,ONEOFFY,
     .               NMASTi, umast0, vmast0, zmast0, szmast0,
     .                       xmast0, ymast0, wmast0,
     .                       smast0, ssmast0,
     .               NARTs, uart0, vart0, zart0)
 
      call init_hash(nash_000,hash_000)
      call push_hash(nash_000,hash_000,0,NMASTi,umast0,vmast0)
      call show_hash(nash_000,'LOGR.HASH_000.fits')
 
      if (CMODE.eq.'A'.or.CMODE.eq.'C') then
         print*,'NARTs: ',NARTs
         call init_hash(nash_ART,hash_ART)
         call push_hash(nash_ART,hash_ART,0,NARTs,uart0,vart0)
         call show_hash(nash_ART,'LOGA.HASH_ART.fits')
         endif
 
      if (CMODE.eq.'D') then
         RSIZ_NIT(1)  = 0.50
         RWID_NIT(1)  =  1
         RCOL_NIT(1) = 'green    '
         endif
 
 
      write(*,'(''               '')')
      write(*,'(''KS2_SETUP HAS BEEN DONE...'')')
      write(*,'(''               '')')
      write(*,'(''        CMODE: '',a1)') CMODE
      write(*,'(''    U MIN/MAX: '',2i6)') UMIN_KS2,UMAX_KS2
      write(*,'(''    V MIN/MAX: '',2i6)') VMIN_KS2,VMAX_KS2
      write(*,'(''           Fs: '',i2)') Fs
      write(*,'(''           Bs: '',i8)') Bs
      write(*,'(''       NMASTi: '',i8)') NMASTi
      write(*,'(''        NARTs: '',i8)') NARTs
      write(*,'(''               '')')
      write(*,'(''   ITERATIONS: '')')
      write(*,'(''       NITMIN: '',i2)') NITMINU
      write(*,'(''       NITMAX: '',i2)') NITMAXU
      write(*,'(''               '')')
      do NIT = NITMINU, NITMAXU
         write(*,919) NIT,HMIN_NIT(NIT),SSIG_NIT(NIT),
     .                    QMIN_NIT(NIT),QSEL_NIT(NIT),QSEP_NIT(NIT),
     .                    DMIN_NIT(NIT),DSEP_NIT(NIT),
     .                    PMIN_NIT(NIT),PSEP_NIT(NIT),
     .                    OPRX_NIT(NIT),OPRV_NIT(NIT),
     .                    RSIZ_NIT(NIT),RWID_NIT(NIT),
     .                    RCOL_NIT(NIT)
  919    format(16x,'NIT',i2.2,1x,'HMIN=',i1,1x,'SSIG=',f4.2,
     .                         4x,'QMIN=',i3.3,1x,'QSEL=',f4.2,
     .                                       1x,'QSEP=',f4.2,
     .                         4x,'DMIN=',i3.3,1x,'DSEP=',f4.2,
     .                         4x,'PMIN=',i3.3,1x,'PSEP=',F4.2,
     .                         4x,'OPRX=',f4.2,
     .                         1x,'OPRV=',f4.2,
     .                         4x,'RSIZ=',f4.2,
     .                         1x,'RWID=',i1,
     .                         1x,'RCOL=',a7)
         enddo
      write(*,'(''               '')')
      NMASTs = NMASTi
 
c--------------------------------------------------------------------------
c
c allocate all the strip-stack...
c
      if (MOSAIC_X1.and.(CMODE.ne.'A')) then
         write(*,'(''ALLOCATE MOSAIC STRIP-STACKS...  '')')
         allocate ( stackv_sf1(_PXDIMX1_,_HDIM_,_FDIM_))
         allocate ( stackd_sf1(_PXDIMX1_,_HDIM_,_FDIM_))
         allocate ( stackm_sf1(_PXDIMX1_,_HDIM_,_FDIM_))
         allocate ( stackn_sf1(_PXDIMX1_,_HDIM_,_FDIM_))
         allocate (  stackp_s1(_PXDIMX1_,_HDIM_))
         allocate (  stackq_s1(_PXDIMX1_,_HDIM_))
         allocate (  stackd_s1(_PXDIMX1_,_HDIM_))
         allocate (  stackc_s1(_PXDIMX1_,_HDIM_))
         allocate (  stacky_s1(_PXDIMX1_,_HDIM_))
         allocate (stack_b1_s1(_PXDIMX1_,_HDIM_))
         endif
 
      if (MOSAIC_X2.and.(CMODE.ne.'A')) then
         write(*,'(''ALLOCATE MOSAIC STRIP-STACKS...  '')')
         allocate ( stackv_sf2(_PXDIMX2_,_TDIM_,_FDIM_))
         allocate ( stackd_sf2(_PXDIMX2_,_TDIM_,_FDIM_))
         allocate ( stackm_sf2(_PXDIMX2_,_TDIM_,_FDIM_))
         allocate ( stackn_sf2(_PXDIMX2_,_TDIM_,_FDIM_))
         allocate (  stackp_s2(_PXDIMX2_,_TDIM_))
         allocate (  stackq_s2(_PXDIMX2_,_TDIM_))
         allocate (  stackd_s2(_PXDIMX2_,_TDIM_))
         allocate (  stackc_s2(_PXDIMX2_,_TDIM_))
         allocate (  stacky_s2(_PXDIMX2_,_TDIM_))
         allocate (stack_b1_s2(_PXDIMX2_,_TDIM_))
         endif
 
c------------------------------------------
c
 
c------------------------------------------
c
c initialize the sky statistics
c
c      if (_HISTO_SKY_) then
c         write(*,'(''ALLOCATE HISTO_SKY...  '')')
c         allocate (sky_stat(201,_GDIM_,_GDIM_))
c         do G  = 1, _GDIM_
c         do GG = 1, _GDIM_
c         do H  = 1, 201
c            sky_stat(H,G,GG) = 0
c            enddo
c            enddo
c            enddo
c         endif
 
 
c---------------------------------------------
c
c initialize the mosaics we will eventually be
c filling in
c
      if (MOSAIC_X1.and.(CMODE.ne.'A')) then
         write(*,'(''INITIALIZE X1 MOSAICS...  '')')
         do F = 1, Fs
            if (_MOSAIC_PIX_) then
               write(FILEO,'(''LOGR.STACK_X1_V'',i1,''.fits'')') F
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,
     .                               SCL_F(F),1.)
               endif
            if (_MOSAIC_SUB_) then
               write(FILEO,'(''LOGR.STACK_X1_S'',i1,''.fits'')') F
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,
     .                               SCL_F(F),1.)
               endif
            if (_MOSAIC_MSK_) then
               write(FILEO,'(''LOGR.STACK_X1_M'',i1,''.fits'')') F
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,
     .                               SCL_F(F),1.)
               endif
            if (_MOSAIC_NUM_) then
               if (_DOBYTE_) then
                  write(FILEO,'(''LOGR.STACK_X1_N'',i1,''.fits'')') F
                  call writfits_b1_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.)
                  endif
               if (.not.(_DOBYTE_)) then
                  write(FILEO,'(''LOGR.STACK_X1_N'',i1,''.fits'')') F
                  call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.,1.)
                  endif
               endif
            enddo
         if (_MOSAIC_PKM_) then
            if (_DOBYTE_) then
               FILEO = 'LOGR.STACK_X1_P0.fits'
               call writfits_b1_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.)
               FILEO = 'LOGR.STACK_X1_Q0.fits'
               call writfits_b1_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.)
               FILEO = 'LOGR.STACK_X1_D0.fits'
               call writfits_b1_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.)
               FILEO = 'LOGR.STACK_X1_C0.fits'
               call writfits_b1_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.)
               FILEO = 'LOGR.STACK_X1_Y0.fits'
               call writfits_b1_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.)
               endif
            if (.not.(_DOBYTE_)) then
               FILEO = 'LOGR.STACK_X1_P0.fits'
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.,1.)
               FILEO = 'LOGR.STACK_X1_Q0.fits'
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.,1.)
               FILEO = 'LOGR.STACK_X1_D0.fits'
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.,1.)
               FILEO = 'LOGR.STACK_X1_C0.fits'
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.,1.)
               FILEO = 'LOGR.STACK_X1_Y0.fits'
               call writfits_j2_init(FILEO,_PXDIMX1_,_PXDIMY1_,1.,1.)
               endif
            endif
         endif
 
      if (MOSAIC_X2.and.(CMODE.ne.'A')) then
         write(*,'(''INITIALIZE X2 MOSAICS...  '')')
         do F = 1, Fs
            if (_MOSAIC_PIX_) then
               write(FILEO,'(''LOGR.STACK_X2_V'',i1,''.fits'')') F
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,
     .                               SCL_F(F),2.0)
               endif
            if (_MOSAIC_SUB_) then
               write(FILEO,'(''LOGR.STACK_X2_S'',i1,''.fits'')') F
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,
     .                               SCL_F(F),2.0)
               endif
            if (_MOSAIC_MSK_) then
               write(FILEO,'(''LOGR.STACK_X2_M'',i1,''.fits'')') F
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,
     .                               SCL_F(F),2.0)
               endif
            if (_MOSAIC_NUM_) then
               if (_DOBYTE_) then
                  write(FILEO,'(''LOGR.STACK_X2_N'',i1,''.fits'')') F
                  call writfits_b1_init(FILEO,_PXDIMX2_,_PXDIMY2_,2.)
                  endif
               if (.not.(_DOBYTE_)) then
                  write(FILEO,'(''LOGR.STACK_X2_N'',i1,''.fits'')') F
                  call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,1.,2.)
                  endif
               endif
            enddo
         if (_MOSAIC_PKM_) then
            if (_DOBYTE_) then
               FILEO = 'LOGR.STACK_X2_P0.fits'
               call writfits_b1_init(FILEO,_PXDIMX2_,_PXDIMY2_,2.)
               FILEO = 'LOGR.STACK_X2_Q0.fits'
               call writfits_b1_init(FILEO,_PXDIMX2_,_PXDIMY2_,2.)
               FILEO = 'LOGR.STACK_X2_D0.fits'
               call writfits_b1_init(FILEO,_PXDIMX2_,_PXDIMY2_,2.)
               FILEO = 'LOGR.STACK_X2_C0.fits'
               call writfits_b1_init(FILEO,_PXDIMX2_,_PXDIMY2_,2.)
               FILEO = 'LOGR.STACK_X2_Y0.fits'
               call writfits_b1_init(FILEO,_PXDIMX2_,_PXDIMY2_,2.)
               endif
            if (.not.(_DOBYTE_)) then
               FILEO = 'LOGR.STACK_X2_P0.fits'
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,1.,2.)
               FILEO = 'LOGR.STACK_X2_Q0.fits'
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,1.,2.)
               FILEO = 'LOGR.STACK_X2_D0.fits'
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,1.,2.)
               FILEO = 'LOGR.STACK_X2_C0.fits'
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,1.,2.)
               FILEO = 'LOGR.STACK_X2_Y0.fits'
               call writfits_j2_init(FILEO,_PXDIMX2_,_PXDIMY2_,1.,2.)
               endif
            endif
         endif
 
 
      open(48,file='LOGK.SETUP',status='unknown') ! the SETUP info
 
c
c---------------------------------------------------------------------
c
      write(*,'(''OPEN INPUT FILES...  '')')
      if (CMODE.eq.'A'.or.CMODE.eq.'C') then
         write(FILEO,'(''LOG'',a1,''.INPUT'')') CMODE
         open(50,file=FILEO,status='unknown')
         write(50,950)
         endif
      if (LOGFINFO) then
         write(FILEO,'(''LOG'',a1,''.FIND_AVG_Z0_F'')') CMODE
         open(51,file=FILEO,status='unknown') ! avg meth-0 info ; one line per filt per star
         write(FILEO,'(''LOG'',a1,''.FIND_AVG_Z2_F'')') CMODE
         open(52,file=FILEO,status='unknown') ! avg meth-2 info
         write(FILEO,'(''LOG'',a1,''.FIND_AVG_UV1_F'')') CMODE
         open(53,file=FILEO,status='unknown') ! avg meth-1 info
         write(51,951)
         write(52,952)
         write(53,953)
         endif
      if (LOGNIMFO) then
         write(FILEO,'(''LOG'',a1,''.FIND_NIMFO'')') CMODE
         open(54,file=FILEO,status='unknown')
         write(54,954)
         endif
      write(FILEO,'(''LOG'',a1,''.XYFIND'')') CMODE
      open(47,file=FILEO,status='unknown')            ! info on finding ; one line per star
      write(FILEO,'(''LOG'',a1,''.XYVIQ0'')') CMODE
      open(55,file=FILEO,status='unknown')            ! distilled meth#0 info ; one line per star
      write(FILEO,'(''LOG'',a1,''.XYVIQ1'')') CMODE
      open(56,file=FILEO,status='unknown')            ! distilled meth#1 info
      write(FILEO,'(''LOG'',a1,''.XYVIQ2'')') CMODE
      open(57,file=FILEO,status='unknown')            ! distilled meth#2 info
      write(FILEO,'(''LOG'',a1,''.XYVIQ3'')') CMODE
      open(49,file=FILEO,status='unknown')            ! distilled meth#3 info
      write(FILEO,'(''LOG'',a1,''.XYVIQS'')') CMODE
      open(69,file=FILEO,status='unknown')            ! background information
      write(55,955) (F,06+4*(F-1), 07+4*(F-1),
     .                 08+4*(F-1), 09+4*(F-1), F=1,_FDIM_)
      write(56,956) (F,05+6*(F-1), 06+6*(F-1), 07+6*(F-1),
     .                 08+6*(F-1), 09+6*(F-1), 10+6*(F-1),F=1,_FDIM_)
      write(57,957) (F,05+6*(F-1), 06+6*(F-1), 07+6*(F-1),
     .                 08+6*(F-1), 09+6*(F-1), 10+6*(F-1),F=1,_FDIM_)
      write(49,949) (F,05+6*(F-1), 06+6*(F-1), 07+6*(F-1),
     .                 08+6*(F-1), 09+6*(F-1), 10+6*(F-1),F=1,_FDIM_)
      write(69,969) (F,05+6*(F-1), 06+6*(F-1), 07+6*(F-1),F=1,_FDIM_)
      if (CMODE.eq.'R'.or.CMODE.eq.'D'.or.CMODE.eq.'C') then
         if (MOSAIC_X1) then
            write(FILEO,'(''LOG'',a1,''.found_uv1.reg'')') CMODE
            open(58,file=FILEO,status='unknown')
            write(58,'(''# Region file format: DS9 version 3.0'')')
            endif
         if (MOSAIC_X2) then
            write(FILEO,'(''LOG'',a1,''.found_uv2.reg'')') CMODE
            open(59,file=FILEO,status='unknown')
            write(59,'(''# Region file format: DS9 version 3.0'')')
            endif
         endif
 
 
c
c---------------------------------------------------------------------
c
      !call log_zone(01,'preamble ')
 
      NARTo = 0  ! total number of AS tests run
 
      if (ITMINU.eq.-1) then
         write(*,'(''DETERMINE TILES ON THE FLY...  '')')
         ITMINU = 1
         JTMINU = 1
         ITMAXU = 1 + (_PXDIMX1_-_HCEN_)/120
         JTMAXU = 1 + (_PXDIMY1_-_HCEN_)/120
         write(*,'(''----->  _PXDIMX1_: '',i5)') _PXDIMX1_
         write(*,'(''----->  _PXDIMY1_: '',i5)') _PXDIMY1_
         write(*,'('' '')')
         endif
      write(*,'(''TILES TO TO GO THROUGH...  '')')
      write(*,'(''-----> IT: '',2i4)')  ITMINU, ITMAXU
      write(*,'(''-----> JT: '',2i4)')  JTMINU, JTMAXU
      write(*,'('' '')')
 
c----------------------------------------------------------------
c
c outer loop up the reference frame ; this can be cannot be
c done in parallel...
c
 
      write(*,'('' '')')
      write(*,'(''START THE ITERATIONS...'')')
      write(*,'('' '')')
      do JT = JTMINU, JTMAXU
         VREF_T = _HCEN_ + 120*(JT-1)
         write(*,'('' '')')
         write(*,'(''******************************'')')
         write(*,'(''******************************'')')
         write(*,'(''*****                    *****'')')
         write(*,'(''*****      JT =  '',i5,3x,''*****'')') JT
         write(*,'(''*****  VREF_T =  '',i5,3x,''*****'')') VREF_T
         write(*,'(''*****                    *****'')')
         write(*,'(''******************************'')')
         write(*,'(''******************************'')')
         write(*,'('' '')')
         UPDATE_STACK = .false.
 
c-------------------------------------------------------------
c
c initialize the strip
c
         if (MOSAIC_X1.and.(CMODE.ne.'A')) then
            write(*,'(''INITIALIZE THE STRIP...  '')')
            do i = 1, _PXDIMX1_
            do j = 1, _HDIM_
               do F = 1, _FDIM_
                  stackv_sf1(i,j,F) = (_DEFPANE_i2_)
                  stackd_sf1(i,j,F) = (_DEFPANE_i2_)
                  stackm_sf1(i,j,F) = (_DEFPANE_i2_)
                  stackn_sf1(i,j,F) = (_DEFPANE_b1_)
                  enddo
               stackp_s1(i,j) = _DEFPANE_b1_
               stackq_s1(i,j) = _DEFPANE_b1_
               stackd_s1(i,j) = _DEFPANE_b1_
               stackc_s1(i,j) = _DEFPANE_b1_
               stacky_s1(i,j) = 0
               enddo
               enddo
            write(*,'(''INITIALIZE THE STRIP...  DONE'')')
            endif
 
         if (MOSAIC_X2.and.(CMODE.ne.'A')) then
            write(*,'(''INITIALIZE THE STRIP...  '')')
            do i = 1, _PXDIMX2_
            do j = 1, _TDIM_
               do F = 1, _FDIM_
                  stackv_sf2(i,j,F) = (_DEFPANE_i2_)
                  stackd_sf2(i,j,F) = (_DEFPANE_i2_)
                  stackm_sf2(i,j,F) = (_DEFPANE_i2_)
                  stackn_sf2(i,j,F) = (_DEFPANE_b1_)
                  enddo
               stackp_s2(i,j) = _DEFPANE_b1_
               stackq_s2(i,j) = _DEFPANE_b1_
               stackd_s2(i,j) = _DEFPANE_b1_
               stackc_s2(i,j) = _DEFPANE_b1_
               stacky_s2(i,j) = 0
               enddo
               enddo
            write(*,'(''INITIALIZE THE STRIP...  DONE'')')
            endif
 
 
 
c-------------------------------------------------------------------
c
c inner loop across the reference frame ; this can be done in
c parallel
c
 
!$omp parallel private(UREF_T,
!$omp& UMINP,UMAXP,VMINP,VMAXP,
!$omp& UMIN_TU,UMAX_TU,VMIN_TU,VMAX_TU,NMASTo,
!$omp& NIT,NITu,
!$omp& Ns,GGG_N,KKK_N,FFF_N,RAP_N,ZPU_N,SCL_N,SKY_N,CCC_N,
!$omp&    FLT_N,FND_N,POS_N,EXP_N,MSK_N,OTH_N,
!$omp& AG_N, BG_N,CG_N,DG_N,GA_N,GB_N,GC_N,GD_N,
!$omp& ICEN_N,JCEN_N,UCEN_N,VCEN_N,XCEN_N,YCEN_N,
!$omp& ITIL_N,JTIL_N,UTIL_N,VTIL_N,XTIL_N,YTIL_N,
!$omp& UTAB_N,VTAB_N,XTAB_N,YTAB_N,
!$omp& FILEPSF_N,FILEGCS_N,FILEPIX_N,
!$omp& BBs,
!$omp& pixv_n,pixf_n,pixd_n,pixt_n,pixe_n,
!$omp&        pixm_n,pixu_n,pixv_h,pixe_h,
!$omp& psf_n,
!$omp& L,Ls,Lo,Lh,Lprox,
!$omp& uF_l,vF_l,mF_l,y0_l,cfnd_l,qmin_l,qfnd_l,dmin_l,
!$omp&                     dfnd_l,pmin_l,pfnd_l,
!$omp& ubri_l,vbri_l,zbri_l,flux_l,mask_l,
!$omp& um_l,vm_l,zm_l,gg_l,zu_l,
!$omp& uu_l,vv_l,u0_l,v0_l,su0_l,sv0_l,
!$omp& u0_ln,v0_ln,z0_ln,sz0_ln,gz0_ln,gp0_ln,z0_lf,sz0_lf,
!$omp& b0_l,n0_l,o0_l,r0_l,w0_l,f0_lf,g0_lf,
!$omp& u1_ln,v1_ln,x1_ln,y1_ln,z1_ln,sz1_ln,s1_ln,ss1_ln,q1_ln,o1_ln,
!$omp&                                                   f1_ln,g1_ln,
!$omp& x2_ln,y2_ln,z2_ln,sz2_ln,s2_ln,ss2_ln,q2_ln,o2_ln,f2_ln,g2_ln,
!$omp& x3_ln,y3_ln,z3_ln,sz3_ln,s3_ln,ss3_ln,q3_ln,o3_ln,f3_ln,g3_ln,
!$omp& bar_lf,barc_lf,rms_lf,rmsc_lf,
!$omp& u1_lf,su1_lf,v1_lf,sv1_lf,
!$omp& x1_lf, y1_lf,z1_lf,sz1_lf,s1_lf,ss1_lf,q1_lf,o1_lf,f1_lf,g1_lf,
!$omp& x2_lf, y2_lf,z2_lf,sz2_lf,s2_lf,ss2_lf,q2_lf,o2_lf,f2_lf,g2_lf,
!$omp& x3_lf, y3_lf,z3_lf,sz3_lf,s3_lf,ss3_lf,q3_lf,o3_lf,f3_lf,g3_lf,
!$omp& stackv_tf,stackf_tf,stacks_tf,stackm_tf,stackp_tf,stackn_tf,
!$omp& stacky_t,stackc_t,stackq_t,stackd_t,stackp_t,
!$omp& stackpu,stackqu,stackdu,stackyu,stackcu,stacktu,
!$omp& NART,NARTs,NARTi,NARTf,NARTu,NARTn,NARTo,
!$omp& iumin,iumax,ivmin,ivmax,
!$omp& uartn,vartn,zartn,
!$omp& uartu,vartu,xartu,yartu,zartu,sartu,xartu_1,yartu_1,
!$omp& findart_nit,findart_pmap,findart_qmap,findart_dmap,findart_cmap,
!$omp& F,i,j,n,ii,jj,dd,ddmin,
!$omp& NFND_NIT,
!$omp& IT)
!$omp do schedule(dynamic,1)
c
c consider do schedule(dynamic,1)
c
c if seg fault:  export OMP_STACKSIZE=1GB
c
      do IT = ITMINU, ITMAXU
 
         do NIT = 1, 9
            NFND_NIT(NIT) = 0
            enddo
 
         if (IT.gt._HASHDM_) stop 'IT.gt._HASHDM_'
         if (JT.gt._HASHDM_) stop 'JT.gt._HASHDM_'
 
         if (CMODE.eq.'A'.and.nash_ART(IT,JT).eq.0) goto 2
 
         UREF_T = _HCEN_ + 120*(IT-1)         ! central point of the tile in ref frame
 
         UMIN_TU = UREF_T - (_TDIM_)/4        ! min/max values of the tile in the ref frame
         UMAX_TU = UREF_T + (_TDIM_)/4
         VMIN_TU = VREF_T - (_TDIM_)/4
         VMAX_TU = VREF_T + (_TDIM_)/4
 
         UMINP = UREF_T - 60                  ! region within which we are prime
         UMAXP = UREF_T + 60
         VMINP = VREF_T - 60
         VMAXP = VREF_T + 60
 
         if (VMIN_KS2.gt.VMAXP) goto 2
         if (VMAX_KS2.lt.VMINP) goto 2
         if (UMIN_KS2.gt.UMAXP) goto 2
         if (UMAX_KS2.lt.UMINP) goto 2
 
         if (ONEOFF) then
            if (ONEOFFY.gt.VMAXP) goto 2
            if (ONEOFFY.lt.VMINP) goto 2
            if (ONEOFFX.lt.UMINP) goto 2
            if (ONEOFFX.gt.UMAXP) goto 2
           !UREF_T = ONEOFFX               ! do it this way to center TILE on ONEOFF point
           !VREF_T = ONEOFFY
            endif
 
         if (VERBOSE) then
            write(*,*)
            write(*,'(''*****************************************'')')
            write(*,'(''*****************************************'')')
            write(*,'(''***         '')')
            write(*,'(''***     IT: '',3i4.2)') IT, ITMINU, ITMAXU
            write(*,'(''***     JT: '',3i4.2)') JT, JTMINU, JTMAXU
            write(*,'(''***         '')')
            write(*,'(''***      U: '',3i7.4)') 1*UREF_T,1*UMINP,1*UMAXP
            write(*,'(''***      V: '',3i7.4)') 1*VREF_T,1*VMINP,1*VMAXP
            write(*,'(''***    2xU: '',3i7.4)') 2*UREF_T,2*UMINP,2*UMAXP
            write(*,'(''***    2xV: '',3i7.4)') 2*VREF_T,2*VMINP,2*VMAXP
            write(*,'(''***         '')')
            write(*,'(''*** NMASTi: '',i7)') NMASTi
            write(*,'(''*** NMASTs: '',i7)') NMASTs
            write(*,'(''***  NARTs: '',i7)')  NARTs
            write(*,'(''***         '')')
            write(*,'(''*****************************************'')')
            write(*,'(''*****************************************'')')
            write(*,*)
            endif
 
 
         if (VERBOSE) write(*,'(''call init tile_a... UVREF'',i6)')
     .                            UREF_T, VREF_T
         write(*,855) IT,JT,UREF_T,VREF_T,0
 
         allocate(GGG_N(_NDIM_))              ! the image number
         allocate(KKK_N(_NDIM_))              ! the detector it corresponds to
         allocate(FFF_N(_NDIM_))              ! the filter it applies to
         allocate(RAP_N(_NDIM_))              ! the aperture to use for this image
         allocate(ZPU_N(_NDIM_))              ! the zeropoint
         allocate(SCL_N(_NDIM_))              ! the scaling that will be applied
         allocate(SKY_N(_NDIM_))              ! the scaling that will be applied
         allocate(CCC_N(_NDIM_))              ! the chip number
         allocate(FLT_N(_NDIM_))              ! the filter number (for distortion)
         allocate(FND_N(_NDIM_))              ! iteration to use for finding at all
         allocate(POS_N(_NDIM_))              ! iteration to use for finding position
         allocate(EXP_N(_NDIM_))              ! exposure time for this image
         allocate(MSK_N(_NDIM_))              ! ? not sure what this is
         allocate(OTH_N(_NDIM_))              ! ? not sure what this is
 
         allocate(AG_N(_NDIM_),BG_N(_NDIM_),CG_N(_NDIM_),DG_N(_NDIM_))
         allocate(GA_N(_NDIM_),GB_N(_NDIM_),GC_N(_NDIM_),GD_N(_NDIM_))
 
         allocate(UCEN_N(_NDIM_),VCEN_N(_NDIM_))      ! the master-frame pos of ref pixel
         allocate(ICEN_N(_NDIM_),JCEN_N(_NDIM_))      ! the reference pixel
         allocate(XCEN_N(_NDIM_),YCEN_N(_NDIM_))      ! the dist-corr ref pixel
 
         allocate(UTIL_N(_NDIM_),VTIL_N(_NDIM_))      ! the master-frame pos of ref pixel
         allocate(ITIL_N(_NDIM_),JTIL_N(_NDIM_))      ! the reference pixel
         allocate(XTIL_N(_NDIM_),YTIL_N(_NDIM_))      ! the dist-corr ref pixel
 
         allocate(UTAB_N(_TTAB_,_TTAB_,_NDIM_))    ! tabular-based transformations
         allocate(VTAB_N(_TTAB_,_TTAB_,_NDIM_))
         allocate(XTAB_N(_TTAB_,_TTAB_,_NDIM_))
         allocate(YTAB_N(_TTAB_,_TTAB_,_NDIM_))
 
         allocate(FILEPSF_N(_NDIM_))
         allocate(FILEGCS_N(_NDIM_))
         allocate(FILEPIX_N(_NDIM_))
 
         call init_tile_a(IT,JT,UREF_T,VREF_T,DIRECT,NDIRECT,
     .                    Gs,FILENAME_G,SUBDIR_G,NSUBDIR_G,
     .                       FILEPSF_G, FILEGCS_G,
     .                       ucen_cg,vcen_cg,icen_cg,jcen_cg,
     .                                       xcen_cg,ycen_cg,
     .                       AG_CG,BG_CG,CG_CG,DG_CG,
     .                       GA_CG,GB_CG,GC_CG,GD_CG,
     .                       FFF_G,RAP_G,SC_CG,KKK_G,FLT_G,ZP_CG,
     .                                               MSK_G,OTH_G,
     .                       POS_G,FND_G,SKY_G,EXP_G,EXP_F,
     .                    Ns,GGG_N,KKK_N,FFF_N,RAP_N,SCL_N,SKY_N,
     .                       CCC_N,FLT_N,ZPU_N,
     .                       POS_N,FND_N,EXP_N,MSK_N,OTH_N,
     .                       UCEN_N,VCEN_N,ICEN_N,JCEN_N,
     .                                     XCEN_N,YCEN_N,
     .                       UTIL_N,VTIL_N,ITIL_N,JTIL_N,
     .                                     XTIL_N,YTIL_N,
     .                       UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                       AG_N,BG_N,CG_N,DG_N,
     .                       GA_N,GB_N,GC_N,GD_N,
     .                       FILEPSF_N, FILEGCS_N, FILEPIX_N)
 
         if (Ns.gt._NDIM_) then
            print*,'Ns.gt._NDIM_...'
            print*,'    Ns: ',Ns
            print*,'_NDIM_: ',_NDIM_
            stop
            endif
         if (Ns.eq.0) goto 1 ! nothing to do here, move along...
         write(*,855) IT,JT,UREF_T,VREF_T,0,NARTi,NARTf,Ns
 
         if (VERBOSE) write(*,'(''allocate for Ns = '',i3)') Ns
 
         allocate(pixv_n(_TDIM_,_TDIM_,Ns))    ! the value image for each (xNs)
         allocate(pixe_n(_TDIM_,_TDIM_,Ns))    ! the error image for each (xNs)
         allocate(pixm_n(_TDIM_,_TDIM_,Ns))    ! the mask image for each (xNs)
         allocate(pixu_n(_TDIM_,_TDIM_,Ns))    ! the use image for each (xNs)
         allocate(pixf_n(_TDIM_,_TDIM_,Ns))    ! the mod image for each (xNs)
         allocate(pixd_n(_TDIM_,_TDIM_,Ns))    ! the dif image for each (xNs)
         allocate(pixt_n(_TDIM_,_TDIM_,Ns))    ! the drz image for each (xNs)
         allocate(pixv_h(_TDIM_,_TDIM_,Ns))    ! the hold value image for each (xNs)
         allocate(pixe_h(_TDIM_,_TDIM_,Ns))    ! the hold error image for each (xNs)
         allocate(psf_n(101,101,Ns))           ! the net PSF for each image (xNs)
 
         allocate(stackv_tf(_TDIM_,_TDIM_,_FDIM_)) ! the pixel value
         allocate(stackf_tf(_TDIM_,_TDIM_,_FDIM_)) ! the model
         allocate(stacks_tf(_TDIM_,_TDIM_,_FDIM_)) ! the subtracted: value-model
         allocate(stackm_tf(_TDIM_,_TDIM_,_FDIM_)) ! the mask
         allocate(stackp_tf(_TDIM_,_TDIM_,_FDIM_)) ! the peak map
         allocate(stackn_tf(_TDIM_,_TDIM_,_FDIM_)) ! the num available for peak
 
         allocate(stacky_t(_TDIM_,_TDIM_))         ! why not found?
         allocate(stackc_t(_TDIM_,_TDIM_))         ! total covg possible
         allocate(stackq_t(_TDIM_,_TDIM_))         ! total quality peaks
         allocate(stackd_t(_TDIM_,_TDIM_))         ! total proximate peaks
         allocate(stackp_t(_TDIM_,_TDIM_))         ! total quantity peaks
 
         allocate(stackpu(_TDIM_,_TDIM_))          ! peak: hold variable for upsample
         allocate(stackqu(_TDIM_,_TDIM_))          ! qual: hold variable for upsample
         allocate(stackdu(_TDIM_,_TDIM_))          ! prox: hold variable for upsample
         allocate(stackcu(_TDIM_,_TDIM_))          ! cuse: hold variable for upsample
         allocate(stackyu(_TDIM_,_TDIM_))          ! ynot: hold variable for upsample
 
         allocate(stacktu(_TDIM_,_TDIM_))          ! flag for whether pix is prime?
 
         call init_stacku(stacktu)                  ! demark where tile is prime
 
         if (VERBOSE) write(*,'(''call init tile_b... UVREF'',i6)')
     .                            UREF_T, VREF_T
         call init_tile_b(IT,JT,UREF_T,VREF_T,
     .                    Ns,GGG_N,KKK_N,FFF_N,RAP_N,SCL_N,SKY_N,
     .                       CCC_N,FLT_N,ZPU_N,
     .                       POS_N,FND_N,EXP_N,MSK_N,OTH_N,
     .                       UCEN_N,VCEN_N,ICEN_N,JCEN_N,
     .                                     XCEN_N,YCEN_N,
     .                       UTIL_N,VTIL_N,ITIL_N,JTIL_N,
     .                                     XTIL_N,YTIL_N,
     .                       UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                       AG_N,BG_N,CG_N,DG_N,
     .                       GA_N,GB_N,GC_N,GD_N,
     .                       pixv_n, pixe_n, pixm_n, pixu_n,
     .                       FILEPSF_N, FILEGCS_N, FILEPIX_N,
     .                    Bs,BBs,uref_b,vref_b,zref_bf)
 
 
         allocate(uF_l(_LDIM_),vF_l(_LDIM_))
         allocate(mF_l(_LDIM_),y0_l(_LDIM_))
         allocate(cfnd_l(_LDIM_))
         allocate(qmin_l(_LDIM_),qfnd_l(_LDIM_))
         allocate(dmin_l(_LDIM_),dfnd_l(_LDIM_))
         allocate(pmin_l(_LDIM_),pfnd_l(_LDIM_))
         allocate(ubri_l(_LDIM_),vbri_l(_LDIM_))
         allocate(zbri_l(_LDIM_))
         allocate(flux_l(_LDIM_))
         allocate(mask_l(_LDIM_))
 
         allocate(um_l(_LDIM_),vm_l(_LDIM_),zm_l(_LDIM_))
         allocate(gg_l(_LDIM_),zu_l(_LDIM_))
 
         allocate( uu_l(_LDIM_), vv_l(_LDIM_))
         allocate( u0_l(_LDIM_), v0_l(_LDIM_))
         allocate(su0_l(_LDIM_),sv0_l(_LDIM_))
 
         allocate( u0_ln(_LDIM_,Ns), v0_ln(_LDIM_,Ns))
         allocate( z0_ln(_LDIM_,Ns),sz0_ln(_LDIM_,Ns))
         allocate(gz0_ln(_LDIM_,Ns),gp0_ln(_LDIM_,Ns))
         allocate( z0_lf(_LDIM_,Fs),sz0_lf(_LDIM_,Fs))
         allocate( b0_l(_LDIM_), n0_l(_LDIM_))
         allocate( o0_l(_LDIM_), r0_l(_LDIM_))
         allocate( w0_l(_LDIM_))
         allocate(f0_lf(_LDIM_,Fs))
         allocate(g0_lf(_LDIM_,Fs))
 
         allocate( u1_ln(_LDIM_,Ns), v1_ln(_LDIM_,Ns))
         allocate( x1_ln(_LDIM_,Ns), y1_ln(_LDIM_,Ns))
         allocate( z1_ln(_LDIM_,Ns),sz1_ln(_LDIM_,Ns))
         allocate( s1_ln(_LDIM_,Ns),ss1_ln(_LDIM_,Ns))
         allocate( q1_ln(_LDIM_,Ns), o1_ln(_LDIM_,Ns))
         allocate( f1_ln(_LDIM_,Ns), g1_ln(_LDIM_,Ns))
 
         allocate( x2_ln(_LDIM_,Ns), y2_ln(_LDIM_,Ns))
         allocate( z2_ln(_LDIM_,Ns),sz2_ln(_LDIM_,Ns))
         allocate( s2_ln(_LDIM_,Ns),ss2_ln(_LDIM_,Ns))
         allocate( q2_ln(_LDIM_,Ns), o2_ln(_LDIM_,Ns))
         allocate( f2_ln(_LDIM_,Ns), g2_ln(_LDIM_,Ns))
 
         allocate( x3_ln(_LDIM_,Ns), y3_ln(_LDIM_,Ns))
         allocate( z3_ln(_LDIM_,Ns),sz3_ln(_LDIM_,Ns))
         allocate( s3_ln(_LDIM_,Ns),ss3_ln(_LDIM_,Ns))
         allocate( q3_ln(_LDIM_,Ns), o3_ln(_LDIM_,Ns))
         allocate( f3_ln(_LDIM_,Ns), g3_ln(_LDIM_,Ns))
 
         allocate( u1_lf(_LDIM_,Fs),su1_lf(_LDIM_,Fs))
         allocate( v1_lf(_LDIM_,Fs),sv1_lf(_LDIM_,Fs))
         allocate( x1_lf(_LDIM_,Fs), y1_lf(_LDIM_,Fs))
         allocate( z1_lf(_LDIM_,Fs),sz1_lf(_LDIM_,Fs))
         allocate( s1_lf(_LDIM_,Fs),ss1_lf(_LDIM_,Fs))
         allocate( q1_lf(_LDIM_,Fs), o1_lf(_LDIM_,Fs))
         allocate( f1_lf(_LDIM_,Fs), g1_lf(_LDIM_,Fs))
 
         allocate( x2_lf(_LDIM_,Fs), y2_lf(_LDIM_,Fs))
         allocate( z2_lf(_LDIM_,Fs),sz2_lf(_LDIM_,Fs))
         allocate( s2_lf(_LDIM_,Fs),ss2_lf(_LDIM_,Fs))
         allocate( q2_lf(_LDIM_,Fs), o2_lf(_LDIM_,Fs))
         allocate( f2_lf(_LDIM_,Fs), g2_lf(_LDIM_,Fs))
 
         allocate( x3_lf(_LDIM_,Fs), y3_lf(_LDIM_,Fs))
         allocate( z3_lf(_LDIM_,Fs),sz3_lf(_LDIM_,Fs))
         allocate( s3_lf(_LDIM_,Fs),ss3_lf(_LDIM_,Fs))
         allocate( q3_lf(_LDIM_,Fs), o3_lf(_LDIM_,Fs))
         allocate( f3_lf(_LDIM_,Fs), g3_lf(_LDIM_,Fs))
 
 
 
 
         uartu = 0.
         vartu = 0.
         do F = 1, Fs
            zartu(F) = 0.
            enddo
 
         if (VERBOSE) write(*,'(''init flags of gg_l, n0_l ...'')')
         do L = 1, _LDIM_
            gg_l(L) = .false.
            n0_l(L) = _NSTMAX_
            enddo
 
         if (VERBOSE) write(*,'(''update stack+...'')')
!$omp critical(update_stack)
         UPDATE_STACK = .true.
!$omp end critical(update_stack)
 
         if (_BLANK_) then
            if (VERBOSE) write(*,'(''blank images...'')')
            do N = 1, Ns
               do i = 001, _TDIM_
               do j = 001, _TDIM_
                  pixv_n(i,j,N) = 0.
                  pixe_n(i,j,N) = 4.0
                  if (pixu_n(i,j,N).eq.4) pixu_n(i,j,N) = 0
                  enddo
                  enddo
               enddo
            endif
 
!$omp critical(get_psfloc_Ns)
         if (VERBOSE) write(*,'(''get_loc_psf...'',f8.5)')
     .                        psf_f(51,51,1,1,1)
         call get_psfloc_Ns(Ns, ITIL_N, JTIL_N, FFF_N,  KKK_N,
     .                          psf_f,  psf_n,
     .                          FILEPSF_N)
c
c taper the PSF
c
         if (_PSFTAPERR1_.ne.0) then
            do N = 1, Ns
               call psf_taper(psf_n(1,1,N),_PSFTAPERR1_,
     .                                     _PSFTAPERR2_)
               enddo
            endif
 
 
 
!$omp end critical(get_psfloc_Ns)
 
         call init_stacks(Fs,stackv_tf,stacks_tf,stackf_tf,
     .                                 stackp_tf,stackn_tf)
 
c
c hold the original images, in case we're adding ASs...
c
         call hold_pixv(Ns,pixv_n,pixv_h)
         call hold_pixv(Ns,pixe_n,pixe_h)
 
         call init_pixsub(Ns,pixv_n,pixd_n,pixf_n)
 
         call reset_local(u0_l,v0_l,su0_L,sv0_l, z0_lf, sz0_lf,
     .                    b0_l, n0_l, o0_l, w0_l,
     .                    uF_l,vF_l,mF_L,y0_L,
     .                    cfnd_l,
     .                    qmin_l,qfnd_l,
     .                    dmin_l,dfnd_l,
     .                    pmin_l,pfnd_l,
     .                    ubri_l, vbri_l, zbri_l,
     .                    flux_l, mask_l)
 
         !call log_zone(02,'init_tile ')
 
         NARTi = 0  ! for real stars
         NARTf = 0
 
         if (CMODE.eq.'A'.or.CMODE.eq.'C') then             ! make a list of AS tests to run
            if (VERBOSE) open(41,file='LOGL.LOCAL_ART',status='unknown')
            NARTi = 1                                       !    for this tile
            NARTf = nash_ART(it,jt)
c           NMASTs = 0                                      ! JAY, IS THIS IMPORTANT??!?? ; I commented it out...
            do NARTu = 1, NARTf
               NARTn(NARTu) = hash_ART(it,jt,NARTu)         ! store the master-list number
               uartn(NARTu) = uart0(NARTn(NARTu))           ! store the master-frame location
               vartn(NARTu) = vart0(NARTn(NARTu))
               do F = 1, Fs
                  zartn(NARTu,F) = zart0(NARTn(NARTu),F)    ! store the master-frame fluxes
                  enddo
               if (VERBOSE)
     .         write(41,141) NARTu,NARTn(NARTu),
     .                       uartn(NARTu),vartn(NARTu),
     .                       (zartn(NARTu,F),F=1,Fs)
  141          format(1x,i3.3,1x,i7.7,
     .                4x,f10.3,1x,f10.3,
     .                4x,99(f10.1,1x))
               enddo
            if (VERBOSE) close(41)
            if (VERBOSE) then
               print*,'LOCAL ARTs...'
               print*,'   it: ',it,jt,nash_ART(it,jt)
               print*,'NARTf: ',NARTf
               endif
            endif
 
 
 
         if (CMODE.eq.'C') then ! CLUSTER MODE!
            do NARTu = NARTi, NARTf
               uartu = uartn(NARTu)
               vartu = vartn(NARTu)
               do F = 1, Fs
                  zartu(F) = zartn(NARTu,F)
                  enddo
               xartu = _TCEN_ + 2*(uartu-UREF_T)
               yartu = _TCEN_ + 2*(vartu-VREF_T)
               call add_art(Ns,pixv_n,pixe_n,pixu_n,psf_n,
     .                         xartu,yartu,zartu,sartu,
     .                         FFF_N,EXP_F,EXP_N,
     .                         UTAB_N,VTAB_N,XTAB_N,YTAB_N)
               enddo
            NARTi = 0
            NARTf = 0
            endif
 
         if (VERBOSE) then
            print*,' NARTi: ',NARTi
            print*,' NARTf: ',NARTf
            print*,' NARTo: ',NARTo
            endif
 
 
 
c----------------------------------------------------------------
c
c Go through the AS tests we need to do for this tile;
c if we're doing real stars, then just have NARTu = 0,0
c and the routine gets done only once; pretty brilliant.
c The goal is to have the AS tests and the real stars
c go through exactly the same code.
c
         do NARTu = NARTi, NARTf
 
            if (VERBOSE) print*,'NARTu: ',NARTu
 
            NARTo = NARTo+1
 
 
            iumin =  0001
            iumax = _TDIM_
            ivmin =  0001
            ivmax = _TDIM_
 
            if (CMODE.eq.'A') then
               uartu = uartn(NARTu)
               vartu = vartn(NARTu)
               do F = 1, Fs
                  zartu(F) = zartn(NARTu,F)
                  enddo
               xartu = _TCEN_ + 2*(uartu-UREF_T)
               yartu = _TCEN_ + 2*(vartu-VREF_T)
               iumin = max(1.*( 0001 ),xartu-40.) ! This tells the routine what region
               iumax = min(1.*(_TDIM_),xartu+40.) ! of the master frame to search for
               ivmin = max(1.*( 0001 ),yartu-40.) ! sources; if we're doing AS tests,
               ivmax = min(1.*(_TDIM_),yartu+40.) ! no need to search the whole tile.
               call hold_pixv(Ns,pixv_h,pixv_n)
               call hold_pixv(Ns,pixe_h,pixe_n)
               call add_art(Ns,pixv_n,pixe_n,pixu_n,psf_n,
     .                         xartu,yartu,zartu,sartu,
     .                         FFF_N,EXP_F,EXP_N,
     .                         UTAB_N,VTAB_N,XTAB_N,YTAB_N)
               xartu_1(1) = xartu
               yartu_1(1) = yartu
               call rmssky_xyz_tile(                                   ! load up the rmssky info
     .                     1,  xartu_1, yartu_1,                       ! for the exact place where
     .                     Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,            ! the star was thrown into
     .                         barc_lf,rmsc_lf,
     .                         pixv_n, pixe_n, pixm_n, pixu_n, psf_n,
     .                     Fs, FFF_N)
               findart_nit  = -1
               findart_pmap = -1
               findart_qmap = -1
               findart_cmap = -1
               endif
 
            UMIN_TU = UREF_T + (iumin-_TCEN_)/2.     ! min/max values of the tile in the ref frame
            UMAX_TU = UREF_T + (iumax-_TCEN_)/2.
            VMIN_TU = VREF_T + (ivmin-_TCEN_)/2.
            VMAX_TU = VREF_T + (ivmax-_TCEN_)/2.
 
            if (VERBOSE) then
               print*,'                                              '
               print*,'=============================================='
               print*,'                                              '
               print*,'    NARTu: ',NARTu,IT,JT
               if (NARTu.ne.0)
     .         print*,'    NARTn: ',NARTn(NARTu)
               print*,'    NARTf: ',NARTf
               print*,'         : ',uartu,vartu,zartu(1)
               print*,'        i: ',iumin,iumax
               print*,'        j: ',ivmin,ivmax
               print*,'                                              '
               print*,'  UMIN_TU: ',UMIN_TU,UMAX_TU
               print*,'  VMIN_TU: ',VMIN_TU,VMAX_TU
               print*,'                                              '
               print*,'  UMINP  : ',UMINP,UMAXP
               print*,'  VMINP  : ',VMINP,VMAXP
               print*,'                                              '
               print*,'=============================================='
               print*,'                                              '
               endif
 
c---------------------------------------------------------
c
c need to add the PREMAG sources we should take as "given"
c
            if (VERBOSE) then
               print*,'                                  '
               print*,'  KS2: LOAD IN STARTING SOURCES...'
               print*,'                                  '
               endif
            Ls = 0
            do i = max(it-1,0001), min(it+1,_HASHDM_)
            do j = max(jt-1,0001), min(jt+1,_HASHDM_)
               do n = 1, nash_000(i,j)
                  NMAST = hash_000(i,j,n)
                  if (umast0(NMAST).gt.UMIN_TU.and.
     .                umast0(NMAST).lt.UMAX_TU.and.
     .                vmast0(NMAST).gt.VMIN_TU.and.
     .                vmast0(NMAST).lt.VMAX_TU) then
                      Ls = Ls + 1
                      uu_l(Ls) = umast0(NMAST)
                      vv_l(Ls) = vmast0(NMAST)
                      u0_l(Ls) = _TCEN_ + 2*(umast0(NMAST)-UREF_T)
                      v0_l(Ls) = _TCEN_ + 2*(vmast0(NMAST)-VREF_T)
                      uF_l(Ls) = u0_l(Ls)
                      vF_l(Ls) = v0_l(Ls)
                      o0_l(Ls) = 0
                      w0_l(Ls) = wmast0(NMAST)
                      y0_l(Ls) = 0
                      b0_l(Ls) = 0
                      n0_l(Ls) = NMAST
                      gg_l(Ls) = uu_l(Ls).ge.UMINP.and.
     .                           uu_l(Ls).lt.UMAXP.and.
     .                           vv_l(Ls).ge.VMINP.and.
     .                           vv_l(Ls).lt.VMAXP
                      do F = 1, Fs
                          z0_lf(Ls,F) = zmast0(NMAST,F)
                          z1_lf(Ls,F) = zmast0(NMAST,F)
                          z2_lf(Ls,F) = zmast0(NMAST,F)
                         sz0_lf(Ls,F) = 0.
                          enddo
                      if (VERBOSE)
     .                write(*,663) Ls,NMAST,gg_l(Ls),
     .                             uu_l(Ls),vv_l(Ls),
     .                             u0_l(Ls),v0_l(Ls),
     .                             (z0_lf(Ls,F),F=1,Fs)
  663                 format('L',i4.4,1x,'R',i7.7,1x,l1,
     .                       1x,f10.3,1x,f10.3,
     .                       1x,f10.3,1x,f10.3,
     .                       1x,_FDIM_(f10.1))
                      endif
                  enddo
               enddo
               enddo
            !call log_zone(03,'starting_sources ')
            write(*,855) IT,JT,UREF_T,VREF_T,0,Ns,Ls,NARTi,NARTf
 
            Lo = Ls + 1      ! this will be the first new star...
 
            NMASTo = NMASTs  ! this corresponds to the number of master
                             !    stars at the beginning of this tile run
 
 
            if (_STACK_REJ_)
     .      call stack_tile_rej(Ns, FFF_N,
     .                              UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                              pixv_n, pixt_n, pixe_n,
     .                                      pixm_n, pixu_n,
     .                                stackv_tf,stackn_tf,NIT)
 
 
c!$omp critical(histo_sky)
c            if (_HISTO_SKY_) then
c               call histo_sky(Ns, FFF_N,
c     .                            UTAB_N, VTAB_N, XTAB_N, YTAB_N,
c     .                            pixv_n, pixe_n, pixm_n, pixu_n,
c     .                            GGG_N, sky_stat)
c               endif
c!$omp end critical(histo_sky)
 
            if (_SHOW_PIXT_) then
               call find_pixt(Ns, pixv_n, pixt_n,
     .                        UTAB_N, VTAB_N, XTAB_N, YTAB_N)
               call show_pixn_r4(pixt_n,'T',Ns)
               stop
               endif
 
!$omp critical(write48)
           write(48,148) IT, JT, UREF_T, VREF_T, Gs, Ns, BBs, Fs,
     .                                            Ls, NMASTs
!$omp end critical(write48)
  148       format(1x,i3.3,1x,i3.3,
     .             3x,i4.4,1x,i4.4,
     .             1x,'G',i3.3,
     .             1x,'N',i3.3,
     .             1x,'BB',i4.4,
     .             1x,'F',i3.3,1x,i4,1x,i7.7)
 
            if (CMODE.eq.'D') then
               Lo = 1
               goto 555
               endif
 
c-----------------------------------------------------------------------
c
c now, iterate finding/photing/subtracting several times to find the new sources...
c
            if (NITMINU.lt.0)
     .          stop 'need to define NITMIN and NITMAX in input file'
            do NIT = NITMINU, NITMAXU
 
               if (VERBOSE) then
                  write(*,'(''                     '')')
                  write(*,'(''**************************'')')
                  write(*,'(''***                    ***'')')
                  write(*,'(''***      NIT: '',i6,''   ***'')')  NIT
                  write(*,'(''***       IJ: '',2i3,''   ***'')') IT,JT
                  write(*,'(''***    NARTu: '',i6,''   ***'')')  NARTu
                  write(*,'(''***    NARTf: '',i6,''   ***'')')  NARTf
                  write(*,'(''***   UREF_T: '',i6,''   ***'')')  UREF_T
                  write(*,'(''***   VREF_T: '',i6,''   ***'')')  VREF_T
                  write(*,'(''***                    ***'')')
                  write(*,'(''***   NMASTo: '',i6,''   ***'')')  NMASTo
                  write(*,'(''***   NMASTs: '',i6,''   ***'')')  NMASTs
                  write(*,'(''***       Bs: '',i6,''   ***'')')  Bs
                  write(*,'(''***       Lo: '',i6,''   ***'')')  Lo
                  write(*,'(''***       Ls: '',i6,''   ***'')')  Ls
                  write(*,'(''***                    ***'')')
                  write(*,'(''**************************'')')
                  write(*,'(''                     '')')
                  endif
 
c
cc--------------------------------------------------------------------
c
               do N = 1, Ns
                  if (FND_N(N)(NIT:NIT).eq.'1') then
                     call mod_tile(u0_l,v0_l,z0_lf(1,FFF_N(N)),Ls,
     .                             UTAB_N(1,1,N),VTAB_N(1,1,N),
     .                             XTAB_N(1,1,N),YTAB_N(1,1,N),
     .                             psf_n(1,1,N),
     .                             pixf_n(1,1,N))
                     call sub_tile(pixv_n(1,1,N),pixf_n(1,1,N),
     .                             pixd_n(1,1,N),pixu_n(1,1,N))
                     endif
                  enddo
                  !call log_zone(04,'(NIT)mod_tile ')
c
cc--------------------------------------------------------------------
c
               if (SHOW_TILES) then
                  call stack_tile(Ns, FFF_N,
     .                            UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                            pixd_n, pixe_n,
     .                            pixm_n, pixu_n,
     .                            stacks_tf,stackp_tf,NIT,3.0)
                  call stack_tile(Ns, FFF_N,
     .                            UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                            pixm_n, pixe_n,
     .                            pixm_n, pixu_n,
     .                            stackm_tf,stackn_tf,NIT,99.9)
                  call stack_tile(Ns, FFF_N,
     .                            UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                            pixv_n, pixe_n,
     .                            pixm_n, pixu_n,
     .                            stackv_tf,stackn_tf,NIT,3.0)
                  do F = 1, _FDIM_
                     write(FILEO,313) NIT,'S',F
                     call writfits_r4_ltv(FILEO,stacks_tf(1,1,F),
     .                                      _TDIM_,_TDIM_,1.0)
                     write(FILEO,313)   0,'V',F
                     call writfits_r4_ltv(FILEO,stackv_tf(1,1,F),
     .                                      _TDIM_,_TDIM_,1.0)
                     write(FILEO,313) NIT,'N',F
                     call writfits_i2_ltv(FILEO,stackn_tf(1,1,F),
     .                                      _TDIM_,_TDIM_,1.0)
                     write(FILEO,313) NIT,'M',F
                     call writfits_r4_ltv(FILEO,stackm_tf(1,1,F),
     .                                      _TDIM_,_TDIM_,1.0)
                     enddo
                  !call log_zone(06,'(NIT)stack_tile ')
                  endif
c
cc--------------------------------------------------------------------
c
 
 
               if (VERBOSE) print*,'KS2: find_tile...'
               Lh = Ls
               call find_tile(Ls,u0_l,v0_l,w0_l,y0_l,
     .                           uF_l,vF_l,
     .                           cfnd_l,
     .                           qmin_l,qfnd_l,
     .                           dmin_l,dfnd_l,
     .                           pmin_l,pfnd_l,
     .                        NIT,iumin,iumax,ivmin,ivmax,
     .                        Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                            FFF_N, FND_N, MSK_N, OTH_N,
     .                            pixv_n, pixd_n, pixf_n,
     .                            pixe_n, pixm_n, pixu_n, psf_n,
     .                            stackp_t, stackq_t, stackd_t,
     .                            stacky_t, stackc_t,
     .                        IT)
               NFND_NIT(NIT) = Ls-Lh
c CRITICAL
               write(*,855) IT,JT,UREF_T,VREF_T,NIT,Ns,NARTi,NARTf,
     .                      Lo-1,(NFND_NIT(NITu),NITu=1,NIT)
  855          format(1x,'IT',i3.3,1x,'JT',i3.3,
     .                5x,i5.4,1x,i5.4,
     .                5x,'NIT',i1,
     .                5x,i3,'(Ns)',
     .                5x,i3,'/',i3,
     .                3x,i3,'(Lo)',
     .                9x,9i4,
     .                9x,i4,
     .                9x,a1,i7.7)
c LACITIRC
 
               if (CMODE.eq.'A') then
                  do ii = max(001,int(xartu-.5)), min(301,int(xartu+.5))
                  do jj = max(001,int(yartu-.5)), min(301,int(yartu+.5))
                     if (stackp_t(ii,jj).ge.findart_pmap) then
                        findart_pmap = stackp_t(ii,jj)
                        findart_qmap = stackq_t(ii,jj)
                        findart_dmap = stackd_t(ii,jj)
                        findart_cmap = stackc_t(ii,jj)
                        findart_nit  = NIT
                        if (VERBOSE) then
                           print*,'----> FILLFIND: ',ii,jj,
     .                                               findart_pmap,
     .                                               findart_qmap,
     .                                               findart_cmap,
     .                                               findart_nit
                           call writfits_i2('stackp_t.fits',
     .                                       stackp_t,301,301)
                           call writfits_i2('stackq_t.fits',
     .                                       stackq_t,301,301)
                           call writfits_i2('stackd_t.fits',
     .                                       stackd_t,301,301)
                           call writfits_i2('stackc_t.fits',
     .                                       stackc_t,301,301)
                           call writfits_i2('stacky_t.fits',
     .                                       stacky_t,301,301)
                           endif
                        endif
                     enddo
                     enddo
                  endif
 
               if (SHOW_TILES) then
                  if (VERBOSE) print*,'KS2: reg_tile... Ls: ',Ls
                  call reg_tile(Ls,u0_l,v0_l,w0_l,NIT)
                  endif
               !call log_zone(05,'(NIT)find_tile ')
c
cc--------------------------------------------------------------------
c
               if (SHOW_TILES) then
                  write(FILEO,313) NIT,'P',0
                  call writfits_i2_ltv(FILEO,stackp_t,_TDIM_,_TDIM_,1.)
                  write(FILEO,313) NIT,'D',0
                  call writfits_i2_ltv(FILEO,stackd_t,_TDIM_,_TDIM_,1.)
                  write(FILEO,313) NIT,'Q',0
                  call writfits_i2_ltv(FILEO,stackq_t,_TDIM_,_TDIM_,1.)
                  write(FILEO,313) NIT,'C',0
                  call writfits_i2_ltv(FILEO,stackc_t,_TDIM_,_TDIM_,1.)
                  write(FILEO,313) NIT,'Y',0
                  call writfits_i2_ltv(FILEO,stacky_t,_TDIM_,_TDIM_,1.)
                  !call log_zone(06,'(NIT)stack_tile ')
                  endif
c
cc--------------------------------------------------------------------
c
               if (VERBOSE) print*,'KS2: call meth0_xyz_tile: ',
     .                              Lo,Ls,NIT
               call meth0_xyz_tile(Lo, Ls,
     .                             u0_l,  v0_l,    z0_lf,
     .                            su0_l, sv0_l,   sz0_lf,
     .                            f0_lf,  g0_lf,   w0_l,
     .                             u0_ln, v0_ln,   z0_ln,
     .                            sz0_ln, gp0_ln, gz0_ln,
     .                             Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                                 pixv_n, pixe_n, pixm_n, pixu_n,
     .                                 psf_n,
     .                                 FFF_N, POS_N, FND_N, RAP_N, NIT)
               !call log_zone(07,'(NIT)meth0_xyz_tile ')
 
c
cc--------------------------------------------------------------------
c
               enddo ! NIT
 
  555       continue ! come here if we are in DRIVE mode...
 
c
c Q any need to find sky every time that meth0 is used?
c   what pixels should I use?
c
 
 
c---------------------------------------------------------------------
c
c now that all the stars that will be found have been found,
c do the simultaneous photing one last time, and do the
c subtraction image one last time...
c
            if (VERBOSE) then
               print*,' '
               write(*,'(''**************************************'')')
               print*,' '
               print*,'KS2: XYZ_TILE: ',Lo,Ls
               print*,' '
               print*,'KS2: call meth0_xyz_tile: ',
     .                              Lo,Ls,99
               endif
            call meth0_xyz_tile(Lo, Ls,
     .                           u0_l,  v0_l,   z0_lf,
     .                          su0_l, sv0_l,  sz0_lf,
     .                          f0_lf,  g0_lf,  w0_l,
     .                          u0_ln,  v0_ln,  z0_ln,
     .                         sz0_ln, gp0_ln, gz0_ln,
     .                          Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                              pixv_n, pixe_n, pixm_n, pixu_n,
     .                              psf_n,
     .                              FFF_n, POS_N, FND_N, RAP_N,99)
 
            !call log_zone(08,'meth0_xyz_tile ')
 
            if (VERBOSE) print*,'KS2: MOD_TILE...  1...Ns: ',Ns
            do N = 1, Ns
               call mod_tile(u0_l,v0_l,z0_lf(1,FFF_N(N)),Ls,
     .                       UTAB_N(1,1,N),VTAB_N(1,1,N),
     .                       XTAB_N(1,1,N),YTAB_N(1,1,N),
     .                       psf_n(1,1,N),
     .                       pixf_n(1,1,N))
               call sub_tile(pixv_n(1,1,N),pixf_n(1,1,N),
     .                       pixd_n(1,1,N),pixu_n(1,1,N))
               enddo
            !call log_zone(09,'mod_tile ')
 
c
c---------------------------------------------------------------------
c
 
            if (VERBOSE) print*,'KS2: METH2_XYZ_TILE...'
            call meth2_xyz_tile(Ls, u0_l, v0_l, z0_lf,           ! the "starting" fluxes for everything...
     .                          Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                              x2_ln, y2_ln, z2_ln, sz2_ln,
     .                                            s2_ln, ss2_ln,
     .                                            q2_ln,  o2_ln, f2_ln,
     .                              pixv_n, pixe_n, pixm_n,
     .                                      pixu_n, psf_n,
     .                              RAP_N, FFF_N, 2)
            !call log_zone(10,'meth2_xyz_tile ')
 
            if (VERBOSE) print*,'KS2: METH2_FIND_AVG_Z2...'
            call find_avg_z2(z2_ln, sz2_ln, s2_ln, ss2_ln,
     .                       q2_ln,  o2_ln, f2_ln, g2_ln, FFF_N,
     .                       Ns, Lo, Ls,
     .                       z2_lf,  sz2_lf,  s2_lf, ss2_lf,
     .                       q2_lf,   o2_lf,  f2_lf,  g2_lf,  Fs)
            !call log_zone(11,'meth2_avg ')
 
c
c---------------------------------------------------------------------
c
 
            if (VERBOSE) then
               print*,'KS2: METH1_XYZ_TILE...'
               print*,'------> about to enter...  Ls = ',Ls,_LDIM_
               print*,'------>                    Ns = ',Ns,_NDIM_
               endif
            call meth1_xyz_tile(Ls, u0_l, v0_l, z0_lf,           ! the "starting" fluxes for evthng.
     .                          Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                              u1_ln,  v1_ln, x1_ln,  y1_ln,
     .                              z1_ln, sz1_ln, s1_ln, ss1_ln,
     .                              q1_ln,  o1_ln, f1_ln,
     .                              pixv_n, pixe_n, pixm_n, pixu_n,
     .                              psf_n,  RAP_N, FFF_N)
 
            !call log_zone(12,'meth1_xyz_tile ')
 
            if (VERBOSE) print*,'KS2: METH1_FIND_AVG_UVZ1...'
            call find_avg_uvz1(u1_ln,  v1_ln,
     .                         z1_ln, sz1_ln, s1_ln, ss1_ln,
     .                         q1_ln,  o1_ln, f1_ln, g1_ln, FFF_N,
     .                         Ns, Lo, Ls,
     .                         u1_lf,   v1_lf, su1_lf, sv1_lf,
     .                         z1_lf,  sz1_lf,  s1_lf, ss1_lf,
     .                         q1_lf,   o1_lf,  f1_lf,  g1_lf, Fs)
            !call log_zone(13,'meth1_avg ')
c
c---------------------------------------------------------------------
c
 
            call meth2_xyz_tile(Ls, u0_l, v0_l, z0_lf,           ! the "starting" fluxes for everything...
     .                          Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                              x3_ln, y3_ln, z3_ln, sz3_ln,
     .                                            s3_ln, ss3_ln,
     .                                            q3_ln,  o3_ln, f3_ln,
     .                              pixv_n, pixe_n, pixm_n,
     .                                      pixu_n, psf_n,
     .                              RAP_N, FFF_N, 3)
            !call log_zone(14,'meth2_xyz_tile3')
            if (VERBOSE) print*,'KS2: METH3_FIND_AVG_Z3...'
            call find_avg_z2(z3_ln, sz3_ln, s3_ln, ss3_ln,
     .                       q3_ln,  o3_ln, f3_ln, g3_ln, FFF_N,
     .                       Ns, Lo, Ls,
     .                       z3_lf,  sz3_lf,  s3_lf, ss3_lf,
     .                       q3_lf,   o3_lf,  f3_lf,  g3_lf,  Fs)
            !call log_zone(15,'meth3_avg')
 
c
c---------------------------------------------------------------------
c
            if (VERBOSE) then
               print*,'KS2: RMSSKY_XYZ_TILE...'
               print*,'------> about to enter...  Ls = ',Ls,_LDIM_
               print*,'------>                    Ns = ',Ns,_NDIM_
               endif
            call rmssky_xyz_tile(
     .                  Ls, u0_l, v0_l,
     .                  Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                      bar_lf,rms_lf,
     .                      pixv_n, pixe_n, pixm_n, pixu_n, psf_n,
     .                  Fs, FFF_N)
            if (VERBOSE) then
               print*,'------> exit...'
               endif
            !call log_zone(16,'rmssky   ')
 
c
c---------------------------------------------------------------------
c
            if (CMODE.eq.'A') then                   ! find the closest star to what we threw in;
               Lprox = 0                             ! if there is none within 10 pixels, then add
               ddmin = 9.999                         ! a fake null star at tend so we can output sthg;
               do L = 1, Ls                          ! leave here with exactly one gg flagged star
                  uu_l(L) = UREF_T + (u0_l(L)-_TCEN_)*0.5
                  vv_l(L) = VREF_T + (v0_l(L)-_TCEN_)*0.5
                  dd = sqrt((uartu-uu_l(L))**2+(vartu-vv_l(L))**2)
                  if (dd.lt.ddmin) then
                     Lprox = L
                     ddmin = dd
                     endif
                  n0_l(L) = 0
                  gg_l(L) = .false.                  ! turn all of the flags off
                  enddo
               if (Lprox.eq.0) then
                  Ls = 1
                  Lprox = 1
                  call null_l(uu_l,   vv_l , u0_l, v0_l, w0_l,
     .                        z0_lf, sz0_lf,
     .                        z1_lf, sz1_lf, q1_lf, o1_lf, f1_lf, g1_lf,
     .                        z2_lf, sz2_lf, q2_lf, o2_lf, f2_lf, g2_lf,
     .                        z3_lf, sz3_lf, f3_lf, g3_lf,
     .                        bar_lf, rms_lf)
                  endif
               n0_l(Lprox) = NARTn(NARTu)
               gg_l(Lprox) = .true.
               endif
 
 
 
c-----------------------------------------------------
c
c go into critical mode for outputting...
c
c
c-----------------------------------------------------
 
!$omp critical(output)
            NMASTh = NMASTs
c           write(*,855) IT,JT,UREF_T,VREF_T,NIT,Ns,NARTi,NARTf,
c    .                   Lo-1,(NFND_NIT(NITu),NITu=1,9),0,
c    .                   CMODE,NMASTs
            if (VERBOSE) print*,'DO L = 1, Ls...  ',Ls
            do L = 1, Ls
               uu_l(L) = UREF_T + (u0_l(L)-_TCEN_)*0.5
               vv_l(L) = VREF_T + (v0_l(L)-_TCEN_)*0.5
               if (CMODE.ne.'A') then
                  if (n0_L(L).eq.0) then                        ! if this is a new star, see if
                      gg_L(L) = .false.                         !    if belongs in this tile
                      if (uu_l(L).ge.UMINP-0.0.and.
     .                    uu_l(L).lt.UMAXP+0.0.and.
     .                    vv_l(L).ge.VMINP-0.0.and.
     .                    vv_l(L).lt.VMAXP+0.0) then
                          NMASTs = NMASTs + 1
                          if (NMASTs.gt._NSTMAX_) then
                              print*,'              '
                              print*,'--->      L : ',L
                              print*,'--->   uu_L : ',uu_l(L)
                              print*,'--->   vv_L : ',vv_l(L)
                              print*,'---> NMASTs : ',NMASTs
                              print*,'--->_NSTMAX_: ',_NSTMAX_
                              print*,'              '
                              stop 'NMASTs.gt._NSTMAX_'
                              endif
                          n0_L(L) = NMASTs
                          gg_L(L) = .true.
                          endif
                      endif
                  endif
               if (gg_l(L)) then                                ! if this star is flagged to be
                   NMAST = n0_L(L)                              ! output... output it!
                   umast0(NMAST) = uu_l(L)
                   vmast0(NMAST) = vv_l(L)
                   xmast0(NMAST) = u0_l(L)
                   ymast0(NMAST) = v0_l(L)
                   wmast0(NMAST) = w0_l(L)
                   do F = 1, Fs
                       zmast0(NMAST,F) =  z0_lf(L,F)
                      szmast0(NMAST,F) = sz0_lf(L,F)
                       fmast0(NMAST,F) =  f0_lf(L,F)
                       gmast0(NMAST,F) =  g0_lf(L,F)
 
                       zmast1(NMAST,F) =  z1_lf(L,F)
                      szmast1(NMAST,F) = sz1_lf(L,F)
                       qmast1(NMAST,F) =  q1_lf(L,F)
                       omast1(NMAST,F) =  o1_lf(L,F)
                       fmast1(NMAST,F) =  f1_lf(L,F)
                       gmast1(NMAST,F) =  g1_lf(L,F)
 
                       zmast2(NMAST,F) =  z2_lf(L,F)
                      szmast2(NMAST,F) = sz2_lf(L,F)
                       qmast2(NMAST,F) =  q2_lf(L,F)
                       omast2(NMAST,F) =  o2_lf(L,F)
                       fmast2(NMAST,F) =  f2_lf(L,F)
                       gmast2(NMAST,F) =  g2_lf(L,F)
 
                       zmast3(NMAST,F) =  z3_lf(L,F)
                      szmast3(NMAST,F) = sz3_lf(L,F)
                       qmast3(NMAST,F) =  q3_lf(L,F)
                       omast3(NMAST,F) =  o3_lf(L,F)
                       fmast3(NMAST,F) =  f3_lf(L,F)
                       gmast3(NMAST,F) =  g3_lf(L,F)
 
                       barsky(NMAST,F) = bar_lf(L,F)
                       rmssky(NMAST,F) = rms_lf(L,F)
                      enddo
                   endif
               enddo
            !call log_zone(17,'update_NMASTs ')
            if (VERBOSE) print*,'       NMASTs: ',NMASTs
            if (LOGFINFO) then
               do L = 1, Ls
                  if (gg_l(L)) then  ! if it's one of the stars to output...
                     NMASTsho = n0_l(L)
                     if (CMODE.eq.'A') NMASTsho = NARTn(NARTu)
                     do F = 1, Fs
                        write(51,151)
     .                    uu_tuv(u0_l(L),v0_l(L),UREF_T,VREF_T),
     .                    vv_tuv(u0_l(L),v0_l(L),UREF_T,VREF_T),
     .                    z0_lf(L,F), sz0_lf(L,F),
     .                    f0_lf(L,F),  g0_lf(L,F),
     .                    L,F,w0_l(L),CMODE,NMASTsho
                        enddo
                     do F = 1, Fs
                        write(52,152)
     .                    uu_tuv(u0_l(L),v0_l(L),UREF_T,VREF_T),
     .                    vv_tuv(u0_l(L),v0_l(L),UREF_T,VREF_T),
     .                    z2_lf(L,F), sz2_lf(L,F),
     .                    q2_lf(L,F),  o2_lf(L,F),
     .                    f2_lf(L,F),
     .                    g2_lf(L,F),
     .                    L,F,w0_l(L),CMODE,NMASTsho
                        enddo
                     do F = 1, Fs
                        write(53,153)
     .                    uu_tuv(u1_lf(L,F),v1_lf(L,F),UREF_T,VREF_T),
     .                    vv_tuv(u1_lf(L,F),v1_lf(L,F),UREF_T,VREF_T),
     .                      z1_lf(L,F),
     .                      rclip(su1_lf(L,F)*0.5,0.00,9.99),
     .                      rclip(sv1_lf(L,F)*0.5,0.00,9.99),
     .                      rclip(sz1_lf(L,F),-9999.0,99999.0),
     .                      q1_lf(L,F),  o1_lf(L,F),
     .                      f1_lf(L,F),
     .                      g1_lf(L,F),
     .                      L,u0_l(L),v0_l(L),w0_l(L),F,
     .                      CMODE,NMASTsho
                        enddo
                     endif ! gg_l tells us whether this star should be recorded?
                  enddo
               endif
            !call log_zone(18,'output_averages ')
            if (LOGNIMFO) then
               do L = 1, Ls
                  if (gg_l(L)) then
                     NMASTsho = n0_l(L)
                     if (CMODE.eq.'A') NMASTsho = NARTn(NARTu)
                     do N = 1, Ns
                        if (f1_ln(L,N).eq.1.or.f2_ln(L,N).eq.1) then
                           magu = -2.5*log10(max(z1_ln(L,N),1.))
                           ut = u0_l(L)
                           vt = v0_l(L)
                           xt0 = xt_tuv(ut,vt,
     .                                  XTAB_N(1,1,N),
     .                                  YTAB_N(1,1,N))
                           yt0 = yt_tuv(ut,vt,
     .                                  XTAB_N(1,1,N),
     .                                  YTAB_N(1,1,N))
                           xr0 = xr_txy(xt0,yt0,ITIL_N(N), JTIL_N(N))
                           yr0 = yr_txy(xt0,yt0,ITIL_N(N), JTIL_N(N))
                           xr1 = 0.0
                           yr1 = 0.0
                           if (x1_ln(L,N).gt.0) then
                              xr1 = xr_txy(x1_ln(L,N),y1_ln(L,N),
     .                                     ITIL_N(N), JTIL_N(N))
                              yr1 = yr_txy(x1_ln(L,N),y1_ln(L,N),
     .                                     ITIL_N(N), JTIL_N(N))
                              endif
                           F = FFF_N(N)
                           write(54,154)
     .                      uu_tuv(u1_ln(L,N),v1_ln(L,N),UREF_T,VREF_T),
     .                      vv_tuv(u1_ln(L,N),v1_ln(L,N),UREF_T,VREF_T),
     .                      magu,
     .                      u0_ln(L,N),v0_ln(L,N),
     .                      rclip( z0_ln(L,N),-999999.,99999999.0),
     .                      rclip(sz0_ln(L,N), -99999.,  999999.0),
     .                      gp0_ln(L,N),gz0_ln(L,N),
c------------------------------------------------------------------------
     .                      u1_ln(L,N), v1_ln(L,N),
     .                      x1_ln(L,N), y1_ln(L,N),
     .                      xr1, yr1,
     .                      rclip( z1_ln(L,N),-999999.,99999999.0),
     .                      rclip(sz1_ln(L,N), -99999.,  999999.0),
     .                      rclip( q1_ln(L,N),      0.,       1.0),
     .                      rclip( o1_ln(L,N),      0.,    9999.0),
     .                             f1_ln(L,N), g1_ln(L,N),
c------------------------------------------------------------------------
     .                      xr0, yr0,
c------------------------------------------------------------------------
     .                      rclip( z2_ln(L,N),-999999.,99999999.0),
     .                      rclip(sz2_ln(L,N), -99999.,  999999.0),
     .                      rclip( q2_ln(L,N),      0.,       1.0),
     .                      rclip( o2_ln(L,N),      0.,    9999.0),
     .                             f2_ln(L,N), g2_ln(L,N),
c------------------------------------------------------------------------
     .                      rclip( z3_ln(L,N),-999999.,99999999.0),
     .                      rclip(sz3_ln(L,N), -99999.,  999999.0),
     .                      rclip( q3_ln(L,N),      0.,       1.0),
     .                      rclip( o3_ln(L,N),      0.,    9999.0),
     .                             f3_ln(L,N), g3_ln(L,N),
c------------------------------------------------------------------------
     .                      CMODE,n0_l(L),
     .                      L, N, GGG_N(N), CCC_N(N), FFF_N(N)
                           endif
                        enddo
                     endif
                  enddo
               endif
            !call log_zone(19,'output_nimfo ')
 
c-----------------------------------------------------------------------------
c
c now, output everything
c
            do L = 1, Ls
               if (gg_l(L)) then
                  NMAST = n0_l(L)
                  NITu = wmast0(NMAST)
                  if (NITu.eq.0) NITu = 11
                  NMASTsho = NMAST
                  if (CMODE.eq.'A') NMASTsho = NARTn(NARTu)
                  call find_brite_prox(umast0(NMAST),vmast0(NMAST),
     .                                 ubri_l(L),vbri_l(L),zbri_l(L),
     .                                 uref_b,vref_b,zref_bf,Bs)
                  flux_l(L) = loc_flux(uF_l(L),vf_l(L),stackv_tf(1,1,1))
                  mask_l(L) = loc_mask(uF_l(L),vf_l(L),stackm_tf(1,1,1))
                  mF_l(L) = -2.5*log10(max(z0_lf(L,1),1.0))
                  write(47,147)
     .               UREF_T+(uF_l(L)-_TCEN_)*0.5,
     .               VREF_T+(vF_l(L)-_TCEN_)*0.5,
     .               mF_l(L),
     .               uF_l(L),  vF_l(L),
     .               rclip(xmast0(NMAST),-9999.0,99999.0),
     .               rclip(ymast0(NMAST),-9999.0,99999.0),
     .               CMODE,NMASTsho,
     .               L,IT,JT,
     .               w0_l(L), y0_l(L),
     .               cfnd_l(L),
     .               qfnd_l(L), qmin_l(L),
     .               dfnd_l(L), dmin_l(L),
     .               pfnd_l(L), pmin_l(L),
     .               rclip(flux_l(L),-9999.9,99999.9),
     .               rclip(mask_l(L),-9999.9,99999.9),
     .               ubri_l(L), vbri_l(L), zbri_l(L)
  147             format(1x,f9.3,1x,f9.3,1x,f7.3,
     .                   3x,f7.3,1x,f7.3,
     .                   3x,f7.3,1x,f7.3,
     .                   3x,a1,i7.7,
     .                   3x,'L',i4.4,1x,'IT',i3.3,1x,'JT',i3.3,
     .                   3x,'W',i1,1x,'Y',i1,
     .                   3x,'C',i3.3,
     .                   1x,'Q',i3.3,'/',i3.3,
     .                   1x,'D',i3.3,'/',i3.3,
     .                   1x,'P',i3.3,'/',i3.3,
     .                   3x,f7.1,1x,f7.1,
     .                   3x,f7.1,1x,f7.1,1x,f11.1)
                  write(55,155)
     .               dclip(umast0(NMAST),-9999.0,99999.0),
     .               dclip(vmast0(NMAST),-9999.0,99999.0),
     .               -2.5*log10(max(zmast0(NMAST,1),1.0)),
     .               CMODE,NMASTsho,
     .              (rclip( zmast0(NMAST,F),-99999999.0,999999999.0),
     .               rclip(szmast0(NMAST,F),  -999999.0,  9999999.0),
     .                      fmast0(NMAST,F),
     .                      gmast0(NMAST,F),  F=1,Fs)
                  write(56,156)
     .               dclip(umast0(NMAST),-9999.0,99999.0),
     .               dclip(vmast0(NMAST),-9999.0,99999.0),
     .               -2.5*log10(max(zmast1(NMAST,1),1.0)),
     .               CMODE,NMASTsho,
     .              (rclip( zmast1(NMAST,F),-99999999.0,999999999.0),
     .               rclip(szmast1(NMAST,F),  -999999.0,  9999999.0),
     .               rclip( qmast1(NMAST,F),       -9.0,       99.0),
     .               rclip( omast1(NMAST,F),    -9999.0,    99999.0),
     .               fmast1(NMAST,F),
     .               gmast1(NMAST,F),F=1,Fs)
                  write(57,157)
     .               dclip(umast0(NMAST),-9999.0,99999.0),
     .               dclip(vmast0(NMAST),-9999.0,99999.0),
     .               -2.5*log10(max(zmast2(NMAST,1),1.0)),
     .               CMODE,NMASTsho,
     .              (rclip( zmast2(NMAST,F),-99999999.0,999999999.0),
     .               rclip(szmast2(NMAST,F),  -999999.0,  9999999.0),
     .               rclip( qmast2(NMAST,F),       -9.0,       99.0),
     .               rclip( omast2(NMAST,F),    -9999.0,    99999.0),
     .               fmast2(NMAST,F),
     .               gmast2(NMAST,F),F=1,Fs)
                  write(49,157)
     .               dclip(umast0(NMAST),-9999.0,99999.0),
     .               dclip(vmast0(NMAST),-9999.0,99999.0),
     .               -2.5*log10(max(zmast3(NMAST,1),1.0)),
     .               CMODE,NMASTsho,
     .              (rclip( zmast3(NMAST,F),-99999999.0,999999999.0),
     .               rclip(szmast3(NMAST,F),  -999999.0,  9999999.0),
     .               rclip( qmast3(NMAST,F),       -9.0,       99.0),
     .               rclip( omast3(NMAST,F),    -9999.0,    99999.0),
     .               fmast3(NMAST,F),
     .               gmast3(NMAST,F),F=1,Fs)
                  write(69,169) CMODE,NMASTsho,
     .                   (rclip(zmast3(NMAST,F),-99999.0,999999.0),
     .                    rclip(barsky(NMAST,F),     0.0,   999.9),
     .                    rclip(rmssky(NMAST,F),     0.0,   999.9),
     .                    F=1,Fs)
                  if (CMODE.ne.'A') then
                     if (MOSAIC_X1)
     .               write(58,112) 1*umast0(NMAST),1*vmast0(NMAST),
     .                             RSIZ_NIT(NITu),RCOL_NIT(NITu),
     .                             RWID_NIT(NITu)
                     if (MOSAIC_X2)
     .               write(59,112) 2*umast0(NMAST),2*vmast0(NMAST),
     .                             RSIZ_NIT(NITu),RCOL_NIT(NITu),
     .                             RWID_NIT(NITu)
                     endif
                  if (CMODE.eq.'A')
     .               write(50,150) uartu,vartu,
     .                             -2.5*log10(max(zartu(1),0.1)),
     .                             it,jt,NARTu,NARTf,
     .                             xartu,yartu,
     .                             iumin,iumax,ivmin,ivmax,
     .                             findart_nit,  findart_pmap,
     .                             findart_qmap, findart_cmap,
     .                             NARTn(NARTu),
     .                             (rclip(zartu(F),  -999999.,9999999.),
     .                              rclip(sartu(F),     -9999., 99999.),
     .                              rclip(barc_lf(1,F),-99999.,999999.),
     .                              rclip(rmsc_lf(1,F),  -999.,  9999.),
     .                                    F=1,Fs)
                  endif
               if (Ls.eq.0.and.CMODE.eq.'A') then
                  NMASTsho = NARTn(NARTu)
                  write(55,155) 0.,0.,0.,
     .                          CMODE,NMASTsho,
     .                          (0.,0.,F=1,Fs)
                  write(56,156) 0.,0.,
     .                          CMODE,NMASTsho,
     .                          (0.,0.,0.,0.,0,0,F=1,Fs)
                  write(57,156) 0.,0.,
     .                          CMODE,NMASTsho,
     .                          (0.,0.,0.,0.,0,0,F=1,Fs)
                  write(49,149) 0.,0.,
     .                          CMODE,NMASTsho,
     .                          (0.,0.,0.,0.,0,0,F=1,Fs)
                  write(50,150) uartu,vartu,
     .                          -2.5*log10(max(zartu(1),0.1)),
     .                          it,jt,NARTu,NARTf,
     .                          xartu,yartu,
     .                          iumin,iumax,ivmin,ivmax,
     .                          findart_nit,  findart_pmap,
     .                          findart_qmap, findart_cmap,
     .                          NARTn(NARTu),
     .                          (zartu(F),
     .                           sartu(F),
     .                           barc_lf(1,F),
     .                           rmsc_lf(1,F),F=1,Fs)
                  endif
               enddo!L
            write(*,855) IT,JT,UREF_T,VREF_T,NIT,Ns, NARTi,NARTf,
     .                   Lo-1,(NFND_NIT(NITu),NITu=1,9),
     .                   NMASTs-NMASTh,
     .                   CMODE,NMASTs
!$omp end critical(output)
 
c
c---------------------------------------------------------------------
c
            if (VERBOSE) print*,'KS2: SHOW_PIXV '
            if (_SHOW_PIXV_) call show_pixn_r4(pixv_n,'V',Ns)
            if (_SHOW_PIXE_) call show_pixn_r4(pixe_n,'E',Ns)
            if (_SHOW_PIXT_) call show_pixn_r4(pixt_n,'T',Ns)
            if (_SHOW_PIXS_) call show_pixn_r4(pixd_n,'S',Ns)
            if (_SHOW_PIXF_) call show_pixn_r4(pixf_n,'F',Ns)
            if (_SHOW_PIXM_) call show_pixn_r4(pixm_n,'M',Ns)
            if (_SHOW_PIXU_) call show_pixn_b1(pixu_n,'U',Ns)
 
 
 
 
c
c---------------------------------------------------------------------
c
c compute the stacks and save them... maybe
c
            if (CMODE.ne.'A') then
            if (SHOW_TILE.or.MOSAIC_X1.or.MOSAIC_X2) then
               if (SHOW_TILE) call reg_tile(Ls,u0_l,v0_l,w0_l,NIT)
               if (VERBOSE) print*,'KS2: MOD2_TILE...  1...Ns: ',Ns
               do N = 1, Ns
                  do L = 1, Ls
                     um_l(L) = u1_lf(L,FFF_N(N))
                     vm_l(L) = v1_lf(L,FFF_N(N))
                     zm_l(L) = z2_lf(L,FFF_N(N))
                     if (w0_l(L).eq.0.or.
     .                   abs(um_l(L)-u0_l(L)).gt.0.55.or.
     .                   abs(vm_l(L)-v0_l(L)).gt.0.55) then
                        um_l(L) = u0_l(L)
                        vm_l(L) = v0_l(L)
                        zm_l(L) = z0_lf(L,FFF_N(N))
                        endif
                     if (CMODE.eq.'D') then
                        um_l(L) = u0_l(L)
                        vm_l(L) = v0_l(L)
                        zm_l(L) = z2_lf(L,FFF_N(N))
                        endif
                     um_l(L) = u0_l(L)           ! for the moment, just use the
                     vm_l(L) = v0_l(L)           !     official "robust" flux
                     zm_l(L) = z0_lf(L,FFF_N(N))
                     enddo
                  call mod_tile(um_l,vm_l,zm_l,Ls,
     .                          UTAB_N(1,1,N),VTAB_N(1,1,N),
     .                          XTAB_N(1,1,N),YTAB_N(1,1,N),
     .                          psf_n(1,1,N),
     .                          pixf_n(1,1,N))
                  call sub_tile(pixv_n(1,1,N),pixf_n(1,1,N),
     .                          pixd_n(1,1,N),pixu_n(1,1,N))
                  enddo
               if (VERBOSE) print*,'KS2: STAK_TILE...  1...Ns: ',Ns
               call stack_tile(Ns, FFF_N,
     .                         UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                         pixd_n, pixe_n, pixm_n, pixu_n,
     .                         stacks_tf,stackp_tf,NIT,3.0)
               call stack_tile(Ns, FFF_N,
     .                         UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                         pixm_n, pixe_n, pixm_n, pixu_n,
     .                         stackm_tf,stackn_tf,NIT,99.0)
               call stack_tile(Ns, FFF_N,
     .                         UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                         pixf_n, pixe_n, pixm_n, pixu_n,
     .                         stackf_tf,stackp_tf,NIT,999.0)
               call stack_tile(Ns, FFF_N,
     .                         UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                         pixv_n, pixe_n, pixm_n, pixu_n,
     .                         stackv_tf,stackn_tf,NIT,3.0)
               !call log_zone(20,'stack_tiles ')
 
!$omp critical(fill_stack)
               if (SHOW_TILE) then
                  if (VERBOSE) print*,'KS2: SHOW_TILE...  1...Ns: ',Ns
                  do F = 1, Fs
                     write(FILEO,313) 9,'V',F
                     call writfits_r4_ltv(FILEO,
     .                                stackv_tf(1,1,F),_TDIM_,_TDIM_,1.)
                     write(FILEO,313) 9,'S',F
                     call writfits_r4_ltv(FILEO,
     .                                stacks_tf(1,1,F),_TDIM_,_TDIM_,1.)
                     write(FILEO,313) 9,'F',F
                     call writfits_r4_ltv(FILEO,
     .                                stackf_tf(1,1,F),_TDIM_,_TDIM_,1.)
                     write(FILEO,313) 9,'M',F
                     call writfits_r4_ltv(FILEO,
     .                                stackm_tf(1,1,F),_TDIM_,_TDIM_,1.)
                     write(FILEO,313) 9,'N',F
                     call writfits_i2_ltv(FILEO,
     .                                stackn_tf(1,1,F),_TDIM_,_TDIM_,1.)
 313                 format('AUX/SHOW_TILE_NIT',i1.1,'_',a1,i1,'.fits')
                     enddo
                  call writfits_i2_ltv('AUX/SHOW_TILE_NIT9_P0.fits',
     .                                 stackp_t,_TDIM_,_TDIM_,1.)
                  call writfits_i2_ltv('AUX/SHOW_TILE_NIT9_Q0.fits',
     .                                 stackq_t,_TDIM_,_TDIM_,1.)
                  call writfits_i2_ltv('AUX/SHOW_TILE_NIT9_D0.fits',
     .                                 stackd_t,_TDIM_,_TDIM_,1.)
                  call writfits_i2_ltv('AUX/SHOW_TILE_NIT9_C0.fits',
     .                                 stackc_t,_TDIM_,_TDIM_,1.)
                  call writfits_i2_ltv('AUX/SHOW_TILE_NIT9_Y0.fits',
     .                                 stacky_t,_TDIM_,_TDIM_,1.)
                  endif
 
               if (MOSAIC_X1.and.(CMODE.ne.'A')) then
                  if (VERBOSE) print*,'KS2: MOSAIC_X1...'
                  do F = 1, Fs
                     if (_MOSAIC_PIX_) then
                        call strip1_update_r4_j2(stackv_sf1(1,1,F),
     .                                           stackv_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T,
     .                                           SCL_F(F))
                        endif
                     if (_MOSAIC_SUB_) then
                        call strip1_update_r4_j2(stackd_sf1(1,1,F),
     .                                           stacks_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T,
     .                                           SCL_F(F))
                        endif
                     if (_MOSAIC_MSK_) then
                        call strip1_update_r4_j2(stackm_sf1(1,1,F),
     .                                           stackm_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T,
     .                                           SCL_F(F))
                        endif
                     if (_MOSAIC_NUM_) then
                        call strip1_update_i2_j2(stackn_sf1(1,1,F),
     .                                           stackn_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T)
                        endif
                     enddo
                  if (_MOSAIC_PKM_) then
                     do i = 1, _TDIM_
                     do j = 1, _TDIM_
                        stackpu(i,j) = stackp_t(i,j)
                        stackdu(i,j) = stackd_t(i,j)
                        stackqu(i,j) = stackq_t(i,j)
                        stackcu(i,j) = stackc_t(i,j)
                        stackyu(i,j) = stacky_t(i,j)
                        do ii = max(0001,i-1), min(_TDIM_,i+1)
                        do jj = max(0001,j-1), min(_TDIM_,j+1)
                           if (stackd_t(ii,jj).gt.stackdu(i,j)) then
                               stackdu(i,j) = stackd_t(ii,jj)
                               endif
                           if (stackq_t(ii,jj).gt.stackqu(i,j)) then
                               stackqu(i,j) = stackq_t(ii,jj)
                               endif
                           if (stackp_t(ii,jj).eq.stackpu(i,j).and.
     .                         stackc_t(ii,jj).lt.stackcu(i,j)) then
                               stackcu(i,j) = stackc_t(ii,jj)
                               endif
                           if (stacky_t(ii,jj).gt.stackyu(i,j)) then
                               stackyu(i,j) = stacky_t(ii,jj)
                               endif
                           if (stackp_t(ii,jj).gt.stackpu(i,j)) then
                               stackpu(i,j) = stackp_t(ii,jj)
                               stackcu(i,j) = stackc_t(ii,jj)
                               endif
                           enddo
                           enddo
                        enddo
                        enddo
                     call strip1_update_i2_j2(stackp_s1,
     .                                        stackpu ,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip1_update_i2_j2(stackd_s1,
     .                                        stackdu,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip1_update_i2_j2(stackq_s1,
     .                                        stackqu,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip1_update_i2_j2(stackc_s1,
     .                                        stackcu ,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip1_update_i2_j2(stacky_s1,
     .                                        stackyu ,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     endif
                  if (VERBOSE) print*,'   : MOSAIC_X1...'
                  endif
 
               if (MOSAIC_X2.and.(CMODE.ne.'A')) then
                  if (VERBOSE) print*,'KS2: MOSAIC_X1...'
                  do F = 1, Fs
                     if (_MOSAIC_PIX_) then
                        call strip2_update_r4_j2(stackv_sf2(1,1,F),
     .                                           stackv_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T,
     .                                           SCL_F(F))
                        endif
                     if (_MOSAIC_SUB_) then
                        call strip2_update_r4_j2(stackd_sf2(1,1,F),
     .                                           stacks_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T,
     .                                           SCL_F(F))
                        endif
                     if (_MOSAIC_MSK_) then
                        call strip2_update_r4_j2(stackm_sf2(1,1,F),
     .                                           stackm_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T,
     .                                           SCL_F(F))
                        endif
                     if (_MOSAIC_NUM_) then
                        call strip2_update_i2_j2(stackn_sf2(1,1,F),
     .                                           stackn_tf(1,1,F),
     .                                           stacktu(1,1),
     .                                           UREF_T,VREF_T)
                       endif
                     enddo
                  if (_MOSAIC_PKM_) then
                     call strip2_update_i2_j2(stackp_s2,
     .                                        stackp_t,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip2_update_i2_j2(stackd_s2,
     .                                        stackd_t,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip2_update_i2_j2(stackq_s2,
     .                                        stackq_t,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip2_update_i2_j2(stackc_s2,
     .                                        stackc_t,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     call strip2_update_i2_j2(stacky_s2,
     .                                        stacky_t,
     .                                        stacktu(1,1),
     .                                        UREF_T,VREF_T)
                     endif
                  if (VERBOSE) print*,'   : MOSAIC_X2...'
                  endif
 
 
               !call log_zone(21,'output_mosaics ')
!$omp end critical(fill_stack)
               endif! DO TILE STUFF?
               endif! DO ART
 
c
cc--------------------------------------------------------------------
c
 
            if (VERBOSE) then
               print*,'                '
               print*,'UPDATE NMASTs...'
               print*,'       NMASTs: ',NMASTs
               print*,'       UREF_T: ',UREF_T,VREF_T
               print*,'       UPRIME: ',UMINP,UMAXP
               print*,'       VPRIME: ',VMINP,VMAXP
               print*,'                '
               print*,'          '
               print*,'END TILE: ',IT,JT
               print*,'  NMASTo: ',NMASTo
               print*,'  NMASTs: ',NMASTs
               print*,'          '
               endif
 
            enddo!NARTu
 
 
 
c        call log_report(IT,JT,UREF_T,VREF_T)
 
 
c------------------------------------------------------
c
c deallocate all the temporary arrays
c
         deallocate(pixv_n,pixf_n,pixd_n,pixt_n,pixe_n)
         deallocate(pixm_n,pixu_n,pixv_h,pixe_h, psf_n)
 
         deallocate(stackv_tf,stackf_tf,stacks_tf)
         deallocate(stackm_tf,stackp_tf,stackn_tf)
 
         deallocate (stacky_t,stackc_t,stackq_t,stackd_t,stackp_t)
 
         deallocate (stackpu,stackqu,stackdu,stackyu,stackcu,stacktu)
 
         deallocate(uF_l,     vF_l,   mF_l,   y0_l, cfnd_l)
         deallocate(qmin_l, qfnd_l, dmin_l, dfnd_l, pmin_l, pfnd_l)
         deallocate(ubri_l, vbri_l, zbri_l, flux_l, mask_l)
 
         deallocate(um_l, vm_l, zm_l, gg_l, zu_l)
 
         deallocate( uu_l, vv_l, u0_l, v0_l, su0_l,sv0_l)
 
         deallocate( u0_ln, v0_ln, z0_ln,sz0_ln,gz0_ln,gp0_ln)
         deallocate(               z0_lf,sz0_lf, b0_l, n0_l, o0_l)
         deallocate(               r0_l,  w0_l,  f0_lf,g0_lf)
 
         deallocate( u1_ln, v1_ln, x1_ln, y1_ln, z1_ln,sz1_ln)
         deallocate( s1_ln,ss1_ln, q1_ln, o1_ln, f1_ln, g1_ln)
 
         deallocate( x2_ln, y2_ln, z2_ln,sz2_ln, s2_ln,ss2_ln)
         deallocate(               q2_ln, o2_ln, f2_ln, g2_ln)
 
         deallocate( x3_ln, y3_ln, z3_ln,sz3_ln, s3_ln,ss3_ln)
         deallocate(               q3_ln, o3_ln, f3_ln, g3_ln)
 
         deallocate( u1_lf,su1_lf, v1_lf,sv1_lf, x1_lf, y1_lf)
         deallocate(               z1_lf,sz1_lf, s1_lf,ss1_lf)
         deallocate(               q1_lf, o1_lf, f1_lf, g1_lf)
 
         deallocate( x2_lf, y2_lf, z2_lf,sz2_lf, s2_lf,ss2_lf)
         deallocate(               q2_lf, o2_lf, f2_lf, g2_lf)
 
         deallocate( x3_lf, y3_lf, z3_lf,sz3_lf, s3_lf,ss3_lf)
         deallocate(               q3_lf, o3_lf, f3_lf, g3_lf)
 
 
    1    continue     ! come here if we're doing AS tests and there are
                      ! no ASs to do in this tile ; this way, we don't
                      ! have to read in the images and can move on
 
         deallocate(GGG_N,KKK_N,FFF_N,RAP_N,ZPU_N,SCL_N,SKY_N)
         deallocate(CCC_N,FLT_N,FND_N,POS_N,EXP_N,MSK_N,OTH_N)
 
         deallocate(AG_N,BG_N,CG_N,DG_N)
         deallocate(GA_N,GB_N,GC_N,GD_N)
 
         deallocate(UCEN_N,VCEN_N)      ! the master-frame pos of ref pixel
         deallocate(ICEN_N,JCEN_N)      ! the reference pixel
         deallocate(XCEN_N,YCEN_N)      ! the dist-corr ref pixel
 
         deallocate(UTIL_N,VTIL_N)      ! the master-frame pos of ref pixel
         deallocate(ITIL_N,JTIL_N)      ! the reference pixel
         deallocate(XTIL_N,YTIL_N)      ! the dist-corr ref pixel
 
         deallocate(UTAB_N,VTAB_N,XTAB_N,YTAB_N)
 
         deallocate(FILEPSF_N,FILEGCS_N,FILEPIX_N)
 
    2    continue     ! come here if didn't even allocate
 
         enddo ! IT
!$omp enddo
!$omp end parallel
 
         print*,'exit IT loop...',UPDATE_STACK
 
 
         if (CMODE.ne.'A'.and.MOSAIC_X1.and.UPDATE_STACK) then
            i1min =  0001
            i1max = _PXDIMX1_
            j1min =  0001 + 16
            j1max = _HDIM_- 16
            if (_MOSAIC_FSH_) then
               j1min =  0001 + 15
               j1max = _HDIM_- 15
               endif
            iulo =  0001
            ivlo = (j1min-_HCEN_) + VREF_T
            if (.false.) then
               call writfits_j2('stackv_sf1.fits',
     .                           stackv_sf1(1,1,1),_PXDIMX1_,_HDIM_)
               call writfits_j2('stackd_sf1.fits',
     .                           stackd_sf1(1,1,1),_PXDIMX1_,_HDIM_)
               call writfits_j2('stackm_sf1.fits',
     .                           stackm_sf1(1,1,1),_PXDIMX1_,_HDIM_)
               call writfits_j2('stackm_sn1.fits',
     .                           stackn_sf1(1,1,1),_PXDIMX1_,_HDIM_)
               call writfits_j2('stackq_s1.fits',
     .                           stackq_s1,_PXDIMX1_,_HDIM_)
               call writfits_j2('stackd_s1.fits',
     .                           stackd_s1,_PXDIMX1_,_HDIM_)
               call writfits_j2('stackp_s1.fits',
     .                           stackp_s1,_PXDIMX1_,_HDIM_)
               call writfits_j2('stackc_s1.fits',
     .                           stackc_s1,_PXDIMX1_,_HDIM_)
               call writfits_j2('stacky_s1.fits',
     .                           stacky_s1,_PXDIMX1_,_HDIM_)
              endif
            do F = 1, _FDIM_
               if (_MOSAIC_PIX_) then
                  write(FILEO,'(''LOGR.STACK_X1_V'',i1,''.fits'')') F
                  call writfits_j2_rastX(FILEO,stackv_sf1(1,1,F),
     .                                         iulo,ivlo,
     .                                         i1min,i1max,
     .                                         j1min,j1max,
     .                                         _PXDIMX1_, _HDIM_,
     .                                         _PXDIMX1_,_PXDIMY1_)
                  endif
               if (_MOSAIC_SUB_) then
                  write(FILEO,'(''LOGR.STACK_X1_S'',i1,''.fits'')') F
                  call writfits_j2_rastX(FILEO,stackd_sf1(1,1,F),
     .                                         iulo,ivlo,
     .                                         i1min,i1max,
     .                                          j1min,j1max,
     .                                         _PXDIMX1_, _HDIM_,
     .                                         _PXDIMX1_,_PXDIMY1_)
                  endif
               if (_MOSAIC_MSK_) then
                  write(FILEO,'(''LOGR.STACK_X1_M'',i1,''.fits'')') F
                  call writfits_j2_rastX(FILEO,stackm_sf1(1,1,F),
     .                                         iulo,ivlo,
     .                                         i1min,i1max,
     .                                         j1min,j1max,
     .                                         _PXDIMX1_, _HDIM_,
     .                                         _PXDIMX1_,_PXDIMY1_)
                  endif
               if (_MOSAIC_NUM_) then
                  write(FILEO,'(''LOGR.STACK_X1_N'',i1,''.fits'')') F
                  if (.not.(_DOBYTE_)) then
                     call writfits_j2_rastX(FILEO,stackn_sf1(1,1,F),
     .                                      iulo,ivlo,
     .                                      i1min,i1max,
     .                                      j1min,j1max,
     .                                      _PXDIMX1_, _HDIM_,
     .                                      _PXDIMX1_,_PXDIMY1_)
                     endif
                  if (_DOBYTE_) then
                     call writfits_b1_rastX(FILEO,stackn_sf1(1,1,F),
     .                                      iulo,ivlo,
     .                                      i1min,i1max,
     .                                      j1min,j1max,
     .                                      _PXDIMX1_, _HDIM_,
     .                                      _PXDIMX1_,_PXDIMY1_)
                     endif
                  endif
               enddo!F
            if (_MOSAIC_PKM_) then
            if (.not.(_DOBYTE_)) then
               FILEO = 'LOGR.STACK_X1_Q0.fits'
               call writfits_j2_rastX(FILEO,stackq_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_D0.fits'
               call writfits_j2_rastX(FILEO,stackd_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_P0.fits'
               call writfits_j2_rastX(FILEO,stackp_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_C0.fits'
               call writfits_j2_rastX(FILEO,stackc_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_Y0.fits'
               call writfits_j2_rastX(FILEO,stacky_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               endif
            if (_DOBYTE_) then
               FILEO = 'LOGR.STACK_X1_Q0.fits'
               call writfits_b1_rastX(FILEO,stackq_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_D0.fits'
               call writfits_b1_rastX(FILEO,stackd_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_P0.fits'
               call writfits_b1_rastX(FILEO,stackp_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_C0.fits'
               call writfits_b1_rastX(FILEO,stackc_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               FILEO = 'LOGR.STACK_X1_Y0.fits'
               call writfits_b1_rastX(FILEO,stacky_s1,
     .                                iulo,ivlo,
     .                                i1min,i1max,j1min,j1max,
     .                                _PXDIMX1_, _HDIM_,
     .                                _PXDIMX1_,_PXDIMY1_)
               endif
            endif
            endif ! CMODE.ne.'A'
 
         if (CMODE.ne.'A'.and.MOSAIC_X2.and.UPDATE_STACK) then
            i2min =  0001
            i2max = _PXDIMX2_
            j2min =  0001 + 32
            j2max = _TDIM_- 32
            if (_MOSAIC_FSH_) then
               j2min =  0001 + 30
               j2max = _TDIM_- 30
               endif
            iulo =  0002
            ivlo = (j2min-_TCEN_) + VREF_T*2
            if (.false.) then
               call writfits_j2('stackv_sf2.fits',
     .                           stackv_sf2(1,1,1),_PXDIMX2_,_TDIM_)
               call writfits_j2('stackd_sf2.fits',
     .                           stackd_sf2(1,1,1),_PXDIMX2_,_TDIM_)
               call writfits_j2('stackm_sf2.fits',
     .                           stackm_sf2(1,1,1),_PXDIMX2_,_TDIM_)
               call writfits_j2('stackm_sn2.fits',
     .                           stackn_sf2(1,1,1),_PXDIMX2_,_TDIM_)
               call writfits_j2('stackq_s2.fits',
     .                           stackq_s2,_PXDIMX2_,_TDIM_)
               call writfits_j2('stackd_s2.fits',
     .                           stackd_s2,_PXDIMX2_,_TDIM_)
               call writfits_j2('stackp_s2.fits',
     .                           stackp_s2,_PXDIMX2_,_TDIM_)
               call writfits_j2('stackc_s2.fits',
     .                           stackc_s2,_PXDIMX2_,_TDIM_)
               call writfits_j2('stacky_s2.fits',
     .                           stacky_s2,_PXDIMX2_,_TDIM_)
               endif
            do F = 1, _FDIM_
               if (_MOSAIC_PIX_) then
                  write(FILEO,'(''LOGR.STACK_X2_V'',i1,''.fits'')') F
                  print*,'call rastX...'
                  call writfits_j2_rastX(FILEO,stackv_sf2(1,1,F),
     .                                         iulo,ivlo,
     .                                         i2min,i2max,j2min,j2max,
     .                                         _PXDIMX2_, _TDIM_,
     .                                         _PXDIMX2_,_PXDIMY2_)
                  print*,'ret. rastX...'
                  endif
               if (_MOSAIC_SUB_) then
                  write(FILEO,'(''LOGR.STACK_X2_S'',i1,''.fits'')') F
                  call writfits_j2_rastX(FILEO,stackd_sf2(1,1,F),
     .                                         iulo,ivlo,
     .                                         i2min,i2max,j2min,j2max,
     .                                         _PXDIMX2_, _TDIM_,
     .                                         _PXDIMX2_,_PXDIMY2_)
                  endif
               if (_MOSAIC_MSK_) then
                  write(FILEO,'(''LOGR.STACK_X2_M'',i1,''.fits'')') F
                  call writfits_j2_rastX(FILEO,stackm_sf2(1,1,F),
     .                                         iulo,ivlo,
     .                                         i2min,i2max,j2min,j2max,
     .                                         _PXDIMX2_, _TDIM_,
     .                                         _PXDIMX2_,_PXDIMY2_)
                  endif
               if (_MOSAIC_NUM_) then
                  write(FILEO,'(''LOGR.STACK_X2_N'',i1,''.fits'')') F
                  if (.not.(_DOBYTE_)) then
                     call writfits_j2_rastX(FILEO,stackn_sf2(1,1,F),
     .                                      iulo,ivlo,
     .                                      i2min,i2max,j2min,j2max,
     .                                      _PXDIMX2_, _TDIM_,
     .                                      _PXDIMX2_,_PXDIMY2_)
                     endif
                  if (_DOBYTE_) then
                     call writfits_b1_rastX(FILEO,stackn_sf2(1,1,F),
     .                                      iulo,ivlo,
     .                                      i2min,i2max,j2min,j2max,
     .                                      _PXDIMX2_, _TDIM_,
     .                                      _PXDIMX2_,_PXDIMY2_)
                     endif
                  endif
               enddo
            if (.not.(_DOBYTE_)) then
               FILEO = 'LOGR.STACK_X2_Q0.fits'
               call writfits_j2_rastX(FILEO,stackq_s2,
     .                                iulo,ivlo,
     .                                i2min,i2max,j2min,j2max,
     .                                _PXDIMX2_, _TDIM_,
     .                                _PXDIMX2_,_PXDIMY2_)
               FILEO = 'LOGR.STACK_X2_D0.fits'
               call writfits_j2_rastX(FILEO,stackd_s2,
     .                                iulo,ivlo,
     .                                i2min,i2max,j2min,j2max,
     .                                _PXDIMX2_, _TDIM_,
     .                                _PXDIMX2_,_PXDIMY2_)
               FILEO = 'LOGR.STACK_X2_P0.fits'
               call writfits_j2_rastX(FILEO,stackp_s2,
     .                                iulo,ivlo,
     .                                i2min,i2max,j2min,j2max,
     .                                _PXDIMX2_, _TDIM_,
     .                                _PXDIMX2_,_PXDIMY2_)
               FILEO = 'LOGR.STACK_X2_C0.fits'
               call writfits_j2_rastX(FILEO,stackc_s2,
     .                                iulo,ivlo,
     .                                i2min,i2max,j2min,j2max,
     .                                _PXDIMX2_, _TDIM_,
     .                                _PXDIMX2_,_PXDIMY2_)
               FILEO = 'LOGR.STACK_X2_Y0.fits'
               call writfits_j2_rastX(FILEO,stacky_s2,
     .                                iulo,ivlo,
     .                                i2min,i2max,j2min,j2max,
     .                                _PXDIMX2_, _TDIM_,
     .                                _PXDIMX2_,_PXDIMY2_)
               endif
            if (_DOBYTE_) then
                FILEO = 'LOGR.STACK_X2_Q0.fits'
                call writfits_b1_rastX(FILEO,stackq_s2,
     .                                iulo,ivlo,
     .                                i2min,i2max,j2min,j2max,
     .                                _PXDIMX2_, _TDIM_,
     .                                _PXDIMX2_,_PXDIMY2_)
                FILEO = 'LOGR.STACK_X2_D0.fits'
                call writfits_b1_rastX(FILEO,stackd_s2,
     .                                iulo,ivlo,
     .                                i2min,i2max,j2min,j2max,
     .                                _PXDIMX2_, _TDIM_,
     .                                _PXDIMX2_,_PXDIMY2_)
                FILEO = 'LOGR.STACK_X2_P0.fits'
                call writfits_b1_rastX(FILEO,stackp_s2,
     .                                 iulo,ivlo,
     .                                 i2min,i2max,j2min,j2max,
     .                                 _PXDIMX2_, _TDIM_,
     .                                 _PXDIMX2_,_PXDIMY2_)
                FILEO = 'LOGR.STACK_X2_C0.fits'
                call writfits_b1_rastX(FILEO,stackc_s2,
     .                                 iulo,ivlo,
     .                                 i2min,i2max,j2min,j2max,
     .                                 _PXDIMX2_, _TDIM_,
     .                                 _PXDIMX2_,_PXDIMY2_)
                FILEO = 'LOGR.STACK_X2_Y0.fits'
                call writfits_b1_rastX(FILEO,stacky_s2,
     .                                 iulo,ivlo,
     .                                 i2min,i2max,j2min,j2max,
     .                                 _PXDIMX2_, _TDIM_,
     .                                 _PXDIMX2_,_PXDIMY2_)
               endif
            endif ! CMODE.ne.'A'
 
 
c         if (_HISTO_SKY_) then
c!$omp critical(log_histo_sky)
c            open(39,file='LOGK.HISTO_SKY',status='unknown')
c            do G  = 1, Gs
c            do GG = 1, Gs
c               if (FFF_G(G).eq.FFF_G(GG)) then ! filter number ! order
c                  do H  = 001, 201
c                     write(39,129) G, GG, H, sky_stat(H,G,GG)
c  129                format(1x,i3.3,1x,i3.3,1x,i3.3,1x,i9)
c                     enddo
c                  endif
c               enddo
c               enddo
c            close(39)
c!$omp end critical(log_histo_sky)
c            endif
         enddo ! JT
 
      close(55)
      close(56)
      close(57)
      close(49)
      close(58)
      close(59)
 
      STOP ! THIS IS THE END!
 
  150 format(f9.3,1x,f9.3,1x,f8.4,1x,
     .       5x,i3.3,1x,i3.3,1x,i3,1x,i3,
     .       5x,f6.2,1x,f6.2,1x,
     .       5x,i3,1x,i3,1x,i3,1x,i3,
     .       5x,i1,1x,i3,1x,i3,1x,i3,
     .       5x,'A',i7.7,
     .       5x,_FDIM_(1x,f10.1,1x,f8.2,1x,f8.2,1x,f8.3))
  112 format('linear;circle( ',f8.1,',',f8.1,',',f6.3,') # color=',
     .                        a7,' width=',i1)
  151 format(1x,f8.2,1x,f8.2,5x,f10.1,1x,f10.2,1x,i2,1x,i2,
     .       1x,'L',i4.4,1x,i1,1x,i1,1x,a1,i7.7)
  152 format(1x,f8.2,1x,f8.2,
     .       5x,f10.1,1x,f10.2,1x,
     .       5x,f8.4,1x,f10.1,1x,3x,i3,1x,i3,
     .       1x,'L',i4.4,1x,i1,1x,i1,1x,a1,i7.7)
  153 format(1x,f10.4,1x,f10.4,1x,f10.1,
     .       5x,f6.3,1x,f6.3,1x,f8.2,
     .       5x,f8.4,1x,f10.1,1x,
     .       3x,i2,1x,i2,1x,
     .       3x,'L',i4.4,1x,f8.2,1x,f8.2,1x,i1,1x,i1,1x,a1,i7.7)
  953 format('#',/,
     .       '#','    u1_lf ',
     .       1x,'     v1_lf ',
     .       1x,'   z1_lf  ',
     .       5x,'su1_lf',1x,'sv1_lf',1x,' sz1_lf ',
     .       5x,' q1_lf  ',1x,'  o1_lf   ',1x,
     .       3x,'f1',1x,'g1',1x,
     .       3x,'  L  ',1x,'   u0   ',1x,'   v0   ',1x,'W',1x,'F',/
     .       '#','    (1)  ',
     .       1x,'     (2)  ',
     .       1x,'    (3)   ',
     .       5x,' (4)  ',1x,' (5)  ',1x,'  (6)   ',
     .       5x,'  (7)  ',1x,'    (8)    ',1x,
     .       3x,' 9',1x,'10',1x,
     .       3x,' (11)',1x,'  (12)  ',1x,'  (13)  ','14',1x,'15',/,'#')
 
 
  155 format(3x,f8.2,1x,f8.2,1x,f8.4,
     .       1x,a1,i7.7,
     .       1x,_FDIM_(2x,f13.3,1x,f11.3,1x,i3,1x,i3))
  156 format(3x,f8.2,1x,f8.2,1x,f8.4,1x,a1,i7.7,
     .       1x,_FDIM_(2x,f13.3,1x,f11.3,
     .       1x,f5.3,1x,f8.2,1x,i3,1x,i3))
  157 format(3x,f8.2,1x,f8.2,1x,f8.4,1x,a1,i7.7,
     .       1x,_FDIM_(2x,f13.3,1x,f11.3,
     .       1x,f5.3,1x,f8.2,1x,i3,1x,i3))
  149 format(3x,f8.2,1x,f8.2,1x,a1,i7.7,
     .       1x,_FDIM_(2x,f13.2,1x,f11.3,1x,f11.3,
     .            1x, f8.2,1x,i3,1x,i3))
  169 format(3x,a1,i7.7,_FDIM_(3x,f13.2,1x,f8.2,1x,f8.2))
 
  950 format('#',/,'# uart_in',1x,
     .             '  vart_in',1x,
     .             '  NART.',5x,
     .             ' zart1_in ',1x,
     .             ' zart2_in ',/,'#',/,'#')
  951 format('#',/,
     .       '#',' umast0 '  ,1x,' vmast0 ',5x,
     .           '  zmast0  ',1x,' szmast0  ',1x,
     .           'f0',1x,'g0',1x,
     .           '   L ',1x,'F',1x,'N',/,
     .       '#','   (1)  '  ,1x,'   (2)  '  ,5x,
     .           '    (3)   ',1x,'    (4)   ',1x,
     .           '  (5)',1x,'6',1x,'7',/,'#')
  952 format('#',/,
     .       '#','  u0_l  '  ,1x,'  v0_l  '  ,5x,
     .           '   z2_lf  ',1x,'  sz2_lf  ',5x,
     .           '  q2_lf '  ,1x,'   o2_lf  ',1x,3x,
     .           ' f2',1x,' g2',1x,'  L  ',1x,'F',1x,'w',/,
     .       '#','   (1)  '  ,1x,'   (2)  '  ,5x,
     .           '    (3)   ',1x,'    (4)   ',5x,
     .           '   (5)  '  ,1x,'    (6)   ',1x,3x,
     .           '(7)',1x,'(8)',1x,' (9) ','11',1x,'12',/,'#')
  954 format('#',/,
     .       '#  umast      vmast      magu       utile   vtile     ',
     .       'z0        sz0  f0 g0   u1      v1          x1     y1  ',
     .       '       xraw1    yraw1          z1        sz1    q1    ',
     .       '  o1   f1 g1    x0       y0    ',
     .       '   z2         sz2      q2      o2  f2 g2 ',/,
     .       '#...(1).... ...(2).... ..(3)...  ..(4)... ..(5).. ..',
     .       '(6)... ...(7).. 8 9 ...(10).. ..(11).    ..(12). ..(13',
     .       ').    ..(14).. ..(15).. ......(16)... ...(17). .(18). ',
     .       '..(19). 0 1  ..(22).. ..(23).. ',
     .       '...(24)..... ..(25).. .(26). ..(27). 8 9 ',/,
     .       '...(30)..... ..(31).. .(32). ..(33). 4 5 ',/,
     .       '#')
  154 format(1x,f10.3,1x,f10.3,1x,f8.4,
     .       3x, f7.3,1x,f7.3,
     .       1x, f8.1,1x,f8.1,1x,i1,1x,i1,
     .       3x, f7.3,1x,f7.3,1x,
     .       3x, f7.3,1x,f7.3,1x,
     .       3x, f8.3,1x,f8.3,1x,
     .       3x,f10.1,1x,f8.1,1x,f6.4,1x,f7.1,1x,i1,1x,i1,
     .       3x, f8.3,1x,f8.3,1x,
     .       3x,f10.1,1x,f8.1,1x,f6.4,1x,f7.1,1x,i1,1x,i1,
     .       3x,f10.1,1x,f8.1,1x,f6.4,1x,f7.1,1x,i1,1x,i1,
     .       3x,a1,i7.7,
     .       2x,'L',i3.3,1x,'N',i3.3,
     .       2x,'G',i3.3,'.',i1,1x,'F',i1,
     .       1x,'C',i1,1x,'F',i1,1x,'SCL=',f8.3,
     .       4x,i4,1x,i4,1x,i1,1x,f10.2,1x,f10.3)
  955 format('#',/,
     .       '#  ',' umast0 ',1x,' vmast0 ',1x,' mmast0 ',
     .          3x,' ','NMAST ',
     .          1x,1(2x,'     zmast0  ',1x,'   szmast0  f0 p0'),/,
     .       '#  ','..(01)..',1x,'..(02)..',1x,' ..(3)..',
     .          3x,'.(04).',
     .          1x,_FDIM_(2x,'F',i1,'.....(',i2.2,')..',
     .                    1x,'.....(',i2.2,').. ',i2.2,1x,i2.2),/,'#')
  956 format('#',/,
     .       '#  ',' umast0 ',1x,' vmast0 ',1x,' mmast1 ',
     .          1x,' ','NMAST   ',
     .          1x,2x,_FDIM_(' ',1x,'    zmast1  ',
     .                           1x,'  szmast1  ',
     .                           1x,' q1  ',
     .                           1x,'   o1  ',
     .                           1x,'f1',
     .                           1x,'g1',2x),/,
     .       '#  ','..(01)..',1x,'..(02)..',1x,' ','.(03).',
     .          1x,' ','        ',
     .          1x,2x,_FDIM_('F',i1,'.....(',i2.2,')..',
     .                           1x,'.....(',i2.2,')..',
     .                           1x,'.(',i2.2,')',
     .                           1x,'...(',i2.2,').',
     .                           1x,i2.2,
     .                           1x,i2.2,2x),/,'#')
  957 format('#',/,
     .       '#  ',' umast0 ',1x,' vmast0 ',1x,' mmast2 ',
     .          1x,' ','NMAST   ',
     .          1x,2x,_FDIM_(' ',1x,'    zmast2  ',
     .                           1x,'  szmast2  ',
     .                           1x,' q2  ',
     .                           1x,'   o2  ',
     .                           1x,'f2',
     .                           1x,'g2',2x),/,
     .       '#  ','..(01)..',1x,'..(02)..',1x,' ','.(03).',
     .          1x,' ','        ',
     .          1x,2x,_FDIM_('F',i1,'.....(',i2.2,')..',
     .                           1x,'.....(',i2.2,')..',
     .                           1x,'.(',i2.2,')',
     .                           1x,'...(',i2.2,').',
     .                           1x,i2.2,
     .                           1x,i2.2,2x),/,'#')
  949 format('#',/,
     .       '#  ',' umast0 ',1x,' vmast0 ',1x,' ','NMAST   ',
     .          1x,2x,_FDIM_(' ',1x,'    zmast3  ',
     .                           1x,'  szmast3  ',
     .                           1x,' q3  ',
     .                           1x,'   o3  ',
     .                           1x,'f3',
     .                           1x,'g3',2x),/,
     .       '#  ','..(01)..',1x,'..(02)..',1x,' ','.(03).',
     .          1x,' ','        ',
     .          1x,2x,_FDIM_('F',i1,'.....(',i2.2,')..',
     .                           1x,'.....(',i2.2,')..',
     .                           1x,'.(',i2.2,')',
     .                           1x,'...(',i2.2,').',
     .                           1x,i2.2,
     .                           1x,i2.2,2x),/,'#')
  969 format('# ',/,
     .       '# NMAST',4x,_FDIM_('F  ','.............',1x,
     .                                 '........',1x,
     .                                 '........'),/,
     .       '#  (1) ',4x,_FDIM_('   ','     (',i2.2,')   ',1x,
     .                                 '  (',i2.2,')  ',1x,
     .                                 '  (',i2.2,')  ',1x),/,
     .       '# ')
 
      end
 
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/buff_work.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine buff2pix_r4(buff,pix,n1,nt)
      implicit none
      byte buff(2880)
      real pix(*)
      integer n1,nt
 
      byte b(4)
      real r
      equivalence(r,b)
 
      integer i, npu, nbu
 
      do i = 1, 720
         npu = n1+i-1
         nbu = (i-1)*4
         if (.not.(_LINUX_)) then
            b(1) = buff(nbu+1)
            b(2) = buff(nbu+2)
            b(3) = buff(nbu+3)
            b(4) = buff(nbu+4)
            endif
         if ((_LINUX_)) then
            b(4) = buff(nbu+1)
            b(3) = buff(nbu+2)
            b(2) = buff(nbu+3)
            b(1) = buff(nbu+4)
            endif
         if (npu.ge.1.and.npu.le.nt) pix(npu) = r
         enddo
 
      return
      end
 
 
c-------------------------------------------------------
c
c
      subroutine buff2pix_r4_edge(buff,pix,n1,nt,
     .                            NXP,NYP,NXF,NYF)
      implicit none
c     character buff(2880)
      byte buff(2880)
      integer NXP,NYP
      real pix(NXP,NYP)
      integer n1,nt
      integer NXF,NYF
 
      real pbuff(720)
      common /sneaky/pbuff
      integer i
      integer npu, nbu
      integer NX, NY
 
      byte b(4)
      real r
      equivalence(r,b)
 
      do i = 1, 720
         npu = n1+i-1
         nbu = (i-1)*4
         if (npu.ge.1.and.npu.le.nt) then
            NX = npu - (npu-1)/NXF*NXF
            NY = 1 + (npu-1)/NXF
            if (NX.le.NXP.and.NY.le.NYP) then
               if (.not.(_LINUX_)) then
                  b(1) = buff(nbu+1)
                  b(2) = buff(nbu+2)
                  b(3) = buff(nbu+3)
                  b(4) = buff(nbu+4)
                  endif
               if ((_LINUX_)) then
                  b(4) = buff(nbu+1)
                  b(3) = buff(nbu+2)
                  b(2) = buff(nbu+3)
                  b(1) = buff(nbu+4)
                  endif
               if (npu.ge.1.and.npu.le.nt) pix(NX,NY) = r
               endif
            endif
         enddo
 
      return
      end
 
 
 
c-------------------------------------------------------
c
c
      subroutine pix2buff_r4(buff,pix,n1,nt)
      implicit none
      byte buff(2880)
      real*4 pix(*)
      integer n1,nt
 
      byte b(4)
      real*4 r
      equivalence(r,b)
 
      integer i, npu, nbu
 
      do i = 1, 720
         npu = n1+i-1
         nbu = (i-1)*4
         if (npu.ge.1.and.npu.le.nt) r = pix(npu)
         if (.not.(_LINUX_)) then
            buff(nbu+1) = b(1)
            buff(nbu+2) = b(2)
            buff(nbu+3) = b(3)
            buff(nbu+4) = b(4)
            endif
         if ((_LINUX_)) then
            buff(nbu+1) = b(4)
            buff(nbu+2) = b(3)
            buff(nbu+3) = b(2)
            buff(nbu+4) = b(1)
            endif
         enddo
 
      return
      end
 
 
 
 
      subroutine buff2pix_i4(buff,pix,n1,nt)
      implicit none
      byte buff(2880)
      integer*4 pix(*)
      integer n1,nt
 
      byte b(4)
      integer ii
      equivalence(ii,b)
 
      integer i, npu, nbu
 
      do i = 1, 720
         npu = n1+i-1
         nbu = (i-1)*4
         if (.not.(_LINUX_)) then
            b(1) = buff(nbu+1)
            b(2) = buff(nbu+2)
            b(3) = buff(nbu+3)
            b(4) = buff(nbu+4)
            endif
         if ((_LINUX_)) then
            b(4) = buff(nbu+1)
            b(3) = buff(nbu+2)
            b(2) = buff(nbu+3)
            b(1) = buff(nbu+4)
            endif
         if (npu.ge.1.and.npu.le.nt) pix(npu) = ii
         enddo
 
      return
      end
 
 
 
      subroutine buff2pix_i2(buff,pix,n1,nt)
      implicit none
      byte buff(2880)
      integer*2 pix(*)
      integer n1,nt
 
      byte b(2)
      integer ii
      equivalence(ii,b)
 
      integer i, npu, nbu
 
      do i = 1, 1440
         npu = n1+i-1
         nbu = (i-1)*2
         if (.not.(_LINUX_)) then
            b(1) = buff(nbu+1)
            b(2) = buff(nbu+2)
            endif
         if ((_LINUX_)) then
            b(2) = buff(nbu+1)
            b(1) = buff(nbu+2)
            endif
         if (npu.ge.1.and.npu.le.nt) pix(npu) = ii
         enddo
 
      return
      end
 
 
      subroutine pix2buff_i2(buff,pix,n1,nt)
      implicit none
      byte buff(2880)
      integer*2 pix(*)
      integer n1,nt
 
      byte b(2)
      integer*2 ii
      equivalence(ii,b)
 
      integer i, npu, nbu
 
      do i = 1, 1440
         npu = n1+i-1
         nbu = (i-1)*2
         if (npu.ge.1.and.npu.le.nt) ii = pix(npu)
         if (.not.(_LINUX_)) then
            buff(nbu+1) = b(1)
            buff(nbu+2) = b(2)
            endif
         if ((_LINUX_)) then
            buff(nbu+1) = b(2)
            buff(nbu+2) = b(1)
            endif
         enddo
 
      return
      end
 
 
      subroutine pix2buff_i4(buff,pix,n1,nt)
      implicit none
      byte buff(2880)
      integer*4 pix(*)
      integer n1,nt
 
      byte b(4)
      integer ii
      equivalence(ii,b)
 
      integer i, npu, nbu
 
      do i = 1, 720
         npu = n1+i-1
         nbu = (i-1)*4
         if (npu.ge.1.and.npu.le.nt) ii = pix(npu)
         if (.not.(_LINUX_)) then
            buff(nbu+1) = b(1)
            buff(nbu+2) = b(2)
            buff(nbu+3) = b(3)
            buff(nbu+4) = b(4)
            endif
         if ((_LINUX_)) then
            buff(nbu+1) = b(4)
            buff(nbu+2) = b(3)
            buff(nbu+3) = b(2)
            buff(nbu+4) = b(1)
            endif
         enddo
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/query_hdr.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine query_hdr(filename,FIELDX,streamx)
      implicit none
 
      character filename*80
 
      character*8  field
      character*20 stream
 
      character*8  fieldx
      character*20 streamx
 
      integer  i
      integer ios, k
 
      character*2880 buff
 
      integer nread
 
 
c-----------------------------------------------
 
!$omp critical(query_hdr)
      open(11,file=FILENAME,status='old',
     .  err=900,recl=2880,form='UNFORMATTED',
     .  access='DIRECT')
 
      streamx = '0'
      i = 0
      nread = 0
 100  continue
      i = i + 1
      read(11,rec=i,iostat=ios) buff
      if (ios.lt.0) goto 900
      do k = 0, 35, 1
         field  = buff(k*80+01:k*80+08)
         stream = buff(k*80+11:k*80+31)
         if (field.eq.fieldx) then
            streamx = stream(1:20)
            goto 103
            endif
         if (field.eq.'END     ') goto 101
 109     continue
         enddo
      goto 100
 101  continue
      close(11)
 
      print*,'query_hdr... no fill: '
      print*,'---> FILENAME: ',FILENAME(1:40)
      print*,'--->   FIELDX: ',FIELDX
      stop
  900 continue
      close(11)
      print*,' '
      print*,'imginfo.e ERROR EXIT. '
      print*,' '
      print*,'ONE OF THE IMAGES WAS NOT IN STANDARD'
      print*,'HST FITS FORMAT.'
      print*,' '
      write(*,'(''PROBLEM FILE: '',a80)') FILENAME
      print*,' '
      print*,' FILENAME: ',FILENAME
      print*,'   FIELDX: ',FIELDX
      print*,' '
      stop
  103 continue
      close(11)
!$omp end critical(query_hdr)
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/readfits_i4.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------
c
c This routine reads in images stored in integer*4 format...
c
c to use:
c
c   input parameters:
c
c         FILE     is the filename
c         NX,NY    are the dimensions of the image to be
c                  read in
c
c
c  output parameters:
c
c         pix( , ) is an integer*4 image of dimensions NX,NY
c
c
c
      subroutine readfits_i4(FILE,pix,NX,NY)
      implicit none
 
      integer NX, NY
      character*80 FILE
      integer*4 pix(NX,NY)
 
      character*70 INFO(10)
      common / fitsinfo / INFO
 
      integer naxes
      integer laxis(3)
 
      character*8  field
      character*20 stream
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios, k
      integer ii, jj
      integer n
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer*4 ibuff(720)
 
      integer ifirst, i1, i2
      integer j
 
      integer np1, np2, npt
      integer nextend
      integer nread
      real bscale, bzero
      integer bitpix
 
      logical LINUX
      data LINUX/.true./
      logical DIAG
      data DIAG /.false./
 
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
      if (DIAG) then
         print*,'enter readfits...'
         print*,'FILE: ',FILE(1:60)
         endif
 
!$omp critical(readfits_i4)
      open(12,file=FILEU,status='old',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      if (DIAG) print*,'...opened'
 
      bscale = 1
      bzero  = 0
 
      naxes = -1
      laxis(1) = 1
      laxis(2) = 1
      laxis(3) = 1
      nextend = 0
 
      do i = 1, 10
         INFO(i) = ' '
         enddo
      do i = 1, 23
         HDR(i) = ' '
         enddo
 
      i = 0
      nread = 0
 100  continue
      i = i + 1
      read(12,rec=i,iostat=ios) buffc
      if (DIAG) print*,'READREC: ',i
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+80)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+31)
         if (field.eq.'NAXIS   ') read(stream,*) naxes
         if (field.eq.'NAXIS1  ') read(stream,*) laxis(1)
         if (field.eq.'NAXIS2  ') read(stream,*) laxis(2)
         if (field.eq.'NAXIS3  ') read(stream,*) laxis(3)
         if (field.eq.'NEXTEND ') read(stream,*) nextend
         if (field.eq.'BITPIX  ') read(stream,*) bitpix
         if (field.eq.'BSCALE  ') read(stream,*) bscale
         if (field.eq.'BZERO   ') read(stream,*) bzero
 
         if (field.eq.'EXPTIME ') INFO(01) = stream
         if (field.eq.'FILTNAM1') INFO(02) = stream
         if (field.eq.'FILENAME') INFO(03) = stream
         if (field.eq.'DATE-OBS') INFO(04) = stream
         if (field.eq.'TIME-OBS') INFO(05) = stream
         if (field.eq.'DEC_TARG') INFO(06) = stream
         if (field.eq.'RA_TARG ') INFO(07) = stream
         if (field.eq.'PA_V3   ') INFO(08) = stream
         if (field.eq.'PROPOSID') INFO(09) = stream
         if (field.eq.'CCDGAIN ') INFO(10) = stream
 
         if (field.eq.'CRPIX1  ') HDR(01) = stream
         if (field.eq.'CRPIX2  ') HDR(02) = stream
         if (field.eq.'CRVAL1  ') HDR(03) = stream
         if (field.eq.'CRVAL2  ') HDR(04) = stream
         if (field.eq.'CTYPE1  ') HDR(05) = stream
         if (field.eq.'CTYPE2  ') HDR(06) = stream
         if (field.eq.'CD1_1   ') HDR(07) = stream
         if (field.eq.'CD1_2   ') HDR(08) = stream
         if (field.eq.'CD2_1   ') HDR(09) = stream
         if (field.eq.'CD2_2   ') HDR(10) = stream
         if (field.eq.'ORIENTAT') HDR(11) = stream
         if (field.eq.'PA_APER ') HDR(12) = stream
         if (field.eq.'PA_V3   ') HDR(13) = stream
         if (field.eq.'DATE-OBS') HDR(14) = stream
         if (field.eq.'TIME-OBS') HDR(15) = stream
         if (field.eq.'EXPTIME ') HDR(16) = stream
         if (field.eq.'ROOTNAME') HDR(17) = stream
         if (field.eq.'TARGNAME') HDR(18) = stream
         if (field.eq.'RA_TARG ') HDR(19) = stream
         if (field.eq.'DEC_TARG') HDR(20) = stream
         if (field.eq.'PROPOSID') HDR(21) = stream
         if (field.eq.'FILTER1 ') HDR(22) = stream
         if (field.eq.'FILTER2 ') HDR(23) = stream
         if (field.eq.'VAFACTOR') HDR(24) = stream
 
 
         if (field.eq.'END     ') goto 101
         enddo
      goto 100
 101  continue
 
 
      if (laxis(1).ne.NX.or.laxis(2).ne.NY) then
         print*,'FITS image not the expected dimensions: '
         print*,'    input NX: ',nx
         print*,'    input NY: ',ny
         print*,'              '
         print*,'    laxis(1): ',laxis(1)
         print*,'    laxis(2): ',laxis(2)
         print*,'  '
         stop
         endif
 
      nread = nread + 1
      if (DIAG) then
         print*,'----------------------------------------'
         print*,'  NREAD: ',nread
         print*,'NEXTEND: ',nextend
         print*,'  NAXIS: ',naxes
         print*,'  LAXIS: ',laxis(1),laxis(2),laxis(3)
         print*,' BITPIX: ',bitpix
         print*,' BSCALE: ',bscale
         print*,'  BZERO: ',bzero
         endif
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      if (BITPIX.ne.32) then
         print*,'                '
         print*,'readfits_i4...: '
         print*,'                '
         print*,'   you called a routine to read in a'
         print*,'   long i*4 image, and the image you'
         print*,'   gave it has BITPIX = ',BITPIX
         print*,'   '
         print*,'   FILE: ',FILE
         print*,'   '
         stop
         endif
 
      nbper = 4*laxis(1)*laxis(2)
      npt   =   laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      do i = i1, i2, 1
         read(12,rec=i,iostat=ios) buffc
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         np2 = min(np2,npt)
         call buff2pix_i4(buffb,ibuff,0001,0720)
         do n = np1, np2, 1
            jj = n/NX   + 1
            ii = n-NX*(jj-1)
            pix(ii,jj) = ibuff(n-np1+1)*bscale+bzero
            enddo
         enddo
 
      if (DIAG) then
         print*,'  NBPER: ',nbper
         print*,'  NBYT1: ',nbyte1
         print*,'  NBYT2: ',nbyte2
         print*,' IFIRST: ',ifirst
         print*,'     I1: ',i1
         print*,'     I2: ',i2
         print*,'    NPT: ',NPT
         endif
 
      close(12)
      goto 901
 
 900  continue
      close(12)
      print*,'READFITS_I4 ERROR'
      print*,' FILEU: ',FILEU
      stop
 901  continue
!$omp end critical(readfits_i4)
      return
 
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/readfits_r4.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c
c
c
c
c
 
      subroutine readfits_r4(FILE,pix,NDIMX,NDIMY)
      implicit none
 
      character*80 FILE
      integer NDIMX,NDIMY
      real    pix(NDIMX,NDIMY)
 
      character*80 FILEU
      character*70 INFO(10)
      common / fitsinfo / INFO
 
      integer naxes
      integer laxis(3)
 
      character*8  field
      character*20 stream
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios, k
      integer j
 
      character*2880 buffc
      byte   buffb(2880)
      equivalence (buffc,buffb)
 
      real*4 buffr(0720)
      integer ii,nn,nx,ny
      integer nxx, nyy
      integer ifirst, i1, i2
 
      integer np1, np2, npt
      integer nextend
      integer nread
      real bscale, bzero
      integer bitpix
 
      logical DIAG
      data DIAG /.false./
 
      character*70 HDR(25)
      common/HDR/HDR
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
      do i = 1, 25
         HDR(i) = ' '
         enddo
 
 
      if (DIAG) then
         print*,'enter readfits_r4...'
         print*,'FILE: ',FILE(1:60)
         endif
 
!$omp critical(readfits_r4)
      open(13,file=FILEU,status='old',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      if (DIAG) print*,'...opened'
 
      naxes = -1
      laxis(1) = 1
      laxis(2) = 1
      laxis(3) = 1
      nextend = 0
 
      do i = 1, 10
         INFO(i) = ' '
         enddo
 
      i = 0
      nread = 0
 100  continue
      i = i + 1
      read(13,rec=i,iostat=ios) buffc
      if (DIAG) print*,'READREC: ',i
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+80)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+31)
         if (field.eq.'NAXIS   ') read(stream,*) naxes
         if (field.eq.'NAXIS1  ') read(stream,*) laxis(1)
         if (field.eq.'NAXIS2  ') read(stream,*) laxis(2)
         if (field.eq.'NAXIS3  ') read(stream,*) laxis(3)
         if (field.eq.'NEXTEND ') read(stream,*) nextend
         if (field.eq.'BITPIX  ') read(stream,*) bitpix
         if (field.eq.'BSCALE  ') read(stream,*) bscale
         if (field.eq.'BZERO   ') read(stream,*) bzero
 
         if (field.eq.'EXPTIME ') INFO(1) = stream
         if (field.eq.'FILTNAM1') INFO(2) = stream
         if (field.eq.'FILENAME') INFO(3) = stream
         if (field.eq.'DATE-OBS') INFO(4) = stream
         if (field.eq.'TIME-OBS') INFO(5) = stream
         if (field.eq.'DEC_TARG') INFO(6) = stream
         if (field.eq.'RA_TARG ') INFO(7) = stream
         if (field.eq.'PA_V3   ') INFO(8) = stream
         if (field.eq.'PROPOSID') INFO(9) = stream
 
         if (field.eq.'CRPIX1  ') HDR(01) = stream
         if (field.eq.'CRPIX2  ') HDR(02) = stream
         if (field.eq.'CRVAL1  ') HDR(03) = stream
         if (field.eq.'CRVAL2  ') HDR(04) = stream
         if (field.eq.'CTYPE1  ') HDR(05) = stream
         if (field.eq.'CTYPE2  ') HDR(06) = stream
         if (field.eq.'CD1_1   ') HDR(07) = stream
         if (field.eq.'CD1_2   ') HDR(08) = stream
         if (field.eq.'CD2_1   ') HDR(09) = stream
         if (field.eq.'CD2_2   ') HDR(10) = stream
         if (field.eq.'ORIENTAT') HDR(11) = stream
         if (field.eq.'PA_APER ') HDR(12) = stream
         if (field.eq.'PA_V3   ') HDR(13) = stream
         if (field.eq.'DATE-OBS') HDR(14) = stream
         if (field.eq.'TIME-OBS') HDR(15) = stream
         if (field.eq.'EXPTIME ') HDR(16) = stream
         if (field.eq.'ROOTNAME') HDR(17) = stream
         if (field.eq.'TARGNAME') HDR(18) = stream
         if (field.eq.'RA_TARG ') HDR(19) = stream
         if (field.eq.'DEC_TARG') HDR(20) = stream
         if (field.eq.'PROPOSID') HDR(21) = stream
         if (field.eq.'FILTER1 ') HDR(22) = stream
         if (field.eq.'FILTER2 ') HDR(23) = stream
         if (field.eq.'VAFACTOR') HDR(24) = stream
 
         if (field.eq.'END     ') goto 101
         enddo
      goto 100
 101  continue
 
 
      nread = nread + 1
      if (DIAG) then
         print*,'----------------------------------------'
         print*,'  NREAD: ',nread
         print*,'NEXTEND: ',nextend
         print*,'  NAXIS: ',naxes
         print*,'  LAXIS: ',laxis(1),laxis(2),laxis(3)
         print*,' BITPIX: ',bitpix
         print*,' BSCALE: ',bscale
         print*,'  BZERO: ',bzero
         endif
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  = 4*laxis(1)*laxis(2)
      npt    = laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      if (BITPIX.ne.-32) then
         print*,'prob'
         stop
         endif
 
      do i = i1, i2, 1
         read(13,rec=i,iostat=ios) buffc
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         call buff2pix_r4(buffb,buffr,0001,0720)
         do ii = 001, 720
            nn = np1 + (ii-1)
            ny = 1 + (nn-1)/laxis(1)
            nx = nn-(ny-1)*laxis(1)
            if (nx.ge.001.and.nx.le.NDIMX.and.
     .          ny.ge.001.and.ny.le.NDIMY) then
                pix(nx,ny) = buffr(ii)
                nxx = nx
                nyy = ny
                endif
            enddo
         if (ny.gt.NDIMY) goto 899
 
         if (DIAG) write(*,1115) i,np1,np2,npt,nxx,nyy
 1115    format(1x,i8,1x,i10,1x,i10,1x,i10,1x,2i6)
         enddo
 
  899 close(13)
      if (DIAG) write(*,1115) i,np1,np2,npt,nxx,nyy
      goto 901
 
  900 continue
      print*,'                '
      print*,'READFITS ERROR: '
      print*,'                '
      write(*,'(''   could not read in file:   '',80a)') FILEU
      print*,'                '
      stop
  901 continue
!$omp end critical(readfits_r4)
      return
 
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/readfits_wfc3ir_flt_rast.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c---------------------------------------------------------
c
c
      subroutine readfits_wfc3ir_flt_rast(FILENAME,
     .                                    pixr,pixe,pixu,
     .                                    ic,jc,NX,NY)
      implicit none
 
      character*80 FILENAME
      integer NX, NY
      real      pixr(NX,NY)
      real      pixe(NX,NY)
      byte      pixu(NX,NY)
      integer ic, jc
 
 
      character*80 FILEU
      character*70 INFO(10)
      common / fitsinfo / INFO
 
      integer naxes
      integer laxis(3)
      integer NXF
      integer NYF
      integer NEXTENU
 
      character*8  field
      character*40 stream
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios, k
      integer j
 
      real rsum, dd
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
      real      buffr(0720), pixru
      integer*2 buffi(1440), pixiu
 
 
      integer NXU, NYU
      integer ii1, ii2, ii, iu, ilo, ihi
      integer jj1, jj2, jj, ju, jlo, jhi
      integer ifirst, i1, i2, i2o
 
      integer np1, np2, npt, n
      integer nextend
      integer nread
      real bscale, bzero
      integer bitpix
 
      character*70 HDR(25)
      common/HDR/HDR
 
      logical DIAG
      data DIAG /.false./
      integer NEND
      integer N1, N2, N3
      integer NA, NB
      integer IIA,IIB
      integer JJA,JJB
 
      byte   pi2b(16)
      integer*2, dimension(:,:), allocatable :: pixv
 
!$omp critical(readfits_wfc3ir_flt_rast)
      allocate(pixv(301,301))
 
      if (DIAG) then
         print*,'   '
         print*,'ENTER readfits_wfc3ir_flt_rast...'
         print*,'FILENAME: ',FILENAME(1:60)
         print*,'      ic: ',ic,jc
         print*,'      NX: ',NX,NY
         print*,'   '
         endif
 
      N1 = 0
      N2 = 0
      N3 = 0
 
      ilo = ic - (NX-1)/2
      ihi = ic + (NX-1)/2
      jlo = jc - (NY-1)/2
      jhi = jc + (NY-1)/2
 
      FILEU = FILENAME
      do i = 75,2,-1
         if (FILENAME(i:i+4).eq.'.fits') FILEU = FILENAME(1:i+4)
         enddo
 
      if (DIAG) then
         print*,'enter readfits_r4...'
         print*,'FILE: ',FILENAME(1:60)
         endif
 
      open(19,file=FILEU,status='old',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      if (DIAG) print*,'...opened'
 
      naxes = -1
      laxis(1) = 1
      laxis(2) = 1
      laxis(3) = 1
      nextend = 0
 
      do i = 1, 10
         INFO(i) = ' '
         enddo
 
      BSCALE = 1.0
      BZERO  = 0.0
 
      NEND = 0
      i = 0
      nread = 0
 100  continue
      i = i + 1
      if (DIAG) print*,'READREC: ',i
      read(19,rec=i,iostat=ios) buffc
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+80)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+51)
         if (field.eq.'NAXIS   ') read(stream,*) naxes
         if (field.eq.'NAXIS1  ') read(stream,*) laxis(1)
         if (field.eq.'NAXIS2  ') read(stream,*) laxis(2)
         if (field.eq.'NAXIS3  ') read(stream,*) laxis(3)
         if (field.eq.'NEXTEND ') read(stream,*) nextend
         if (field.eq.'BITPIX  ') read(stream,*) bitpix
         if (field.eq.'BSCALE  ') read(stream,*) bscale
         if (field.eq.'BZERO   ') read(stream,*) bzero
 
         if (field.eq.'EXPTIME ') INFO(1) = stream
         if (field.eq.'FILTNAM1') INFO(2) = stream
         if (field.eq.'FILENAME') INFO(3) = stream
         if (field.eq.'DATE-OBS') INFO(4) = stream
         if (field.eq.'TIME-OBS') INFO(5) = stream
         if (field.eq.'DEC_TARG') INFO(6) = stream
         if (field.eq.'RA_TARG ') INFO(7) = stream
         if (field.eq.'PA_V3   ') INFO(8) = stream
         if (field.eq.'PROPOSID') INFO(9) = stream
 
         if (field.eq.'CRPIX1  ') HDR(01) = stream
         if (field.eq.'CRPIX2  ') HDR(02) = stream
         if (field.eq.'CRVAL1  ') HDR(03) = stream
         if (field.eq.'CRVAL2  ') HDR(04) = stream
         if (field.eq.'CTYPE1  ') HDR(05) = stream
         if (field.eq.'CTYPE2  ') HDR(06) = stream
         if (field.eq.'CD1_1   ') HDR(07) = stream
         if (field.eq.'CD1_2   ') HDR(08) = stream
         if (field.eq.'CD2_1   ') HDR(09) = stream
         if (field.eq.'CD2_2   ') HDR(10) = stream
         if (field.eq.'ORIENTAT') HDR(11) = stream
         if (field.eq.'PA_APER ') HDR(12) = stream
         if (field.eq.'PA_V3   ') HDR(13) = stream
         if (field.eq.'DATE-OBS') HDR(14) = stream
         if (field.eq.'TIME-OBS') HDR(15) = stream
         if (field.eq.'EXPTIME ') HDR(16) = stream
         if (field.eq.'ROOTNAME') HDR(17) = stream
         if (field.eq.'TARGNAME') HDR(18) = stream
         if (field.eq.'RA_TARG ') HDR(19) = stream
         if (field.eq.'DEC_TARG') HDR(20) = stream
         if (field.eq.'PROPOSID') HDR(21) = stream
         if (field.eq.'FILTER1 ') HDR(22) = stream
         if (field.eq.'FILTER2 ') HDR(23) = stream
         if (field.eq.'VAFACTOR') HDR(24) = stream
 
         if (field.eq.'END     ') then
            if (NEND.eq.1) goto 101
            NEND = NEND + 1
            endif
         enddo
      goto 100
 101  continue
 
 
      nread = nread + 1
      ifirst = i+1
      i1 = i
      i2 = i
      NXF = laxis(1)
      NYF = laxis(2)
 
      nbper  = 4*laxis(1)*laxis(2)
      npt    = laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      if (BITPIX.ne.-32) then
         print*,'prob'
         stop
         endif
 
      NXU = laxis(1)
      NYU = laxis(2)
 
      na = ((ilo-1) + (jlo-1)*NXU)
      nb = ((ihi-1) + (jhi-1)*NXU)
 
      N1 = 0
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         np2 = min(np2,npt)
         if (na.le.np2.and.nb.ge.np1) then
            read(19,rec=i,iostat=ios) buffc
            call buff2pix_r4(buffb,buffr,0001,0720)
            do n = np1, np2, 1
               jj = n/NXU   + 1
               ii = n-NXU*(jj-1)
               iu = ii - ilo + 1
               ju = jj - jlo + 1
               pixru = buffr(n-np1+1)
               if (iu.ge.1.and.iu.le.NX.and.
     .             ju.ge.1.and.ju.le.NY) then
                   N1 = N1 + 1
                   pixr(iu,ju) = pixru
                   endif
               enddo
            endif
         enddo
 
 
c--------------------------------------
c
c read in the error array now...
c
c--------------------------------------
 
      i = i2
 200  continue
      i = i + 1
      if (DIAG) print*,'READREC: ',i
      read(19,rec=i,iostat=ios) buffc
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+20)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+51)
         if (field.eq.'END     ') then
            NEND = NEND + 1
            if (NEND.eq.2) goto 201
            endif
         enddo
      goto 200
 201  continue
 
      nread = nread + 1
      ifirst = i+1
      i1 = i
      i2 = i
      NXF = laxis(1)
      NYF = laxis(2)
      nbper  = 4*laxis(1)*laxis(2)
      npt    = laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      NXU = laxis(1)
      NYU = laxis(2)
 
      na = ((ilo-1) + (jlo-1)*NXU)
      nb = ((ihi-1) + (jhi-1)*NXU)
 
      N2 = 0
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         np2 = min(np2,npt)
         if (na.le.np2.and.nb.ge.np1) then
            read(19,rec=i,iostat=ios) buffc
            call buff2pix_r4(buffb,buffr,0001,0720)
            do n = np1, np2, 1
               jj = n/NXU   + 1
               ii = n-NXU*(jj-1)
               iu = ii - ilo + 1
               ju = jj - jlo + 1
               pixru = buffr(n-np1+1)
               if (.not.(pixru.gt.0.15)) pixru = 0.15
               if (iu.ge.1.and.iu.le.NX.and.
     .             ju.ge.1.and.ju.le.NY) then
                   N2 = N2 + 1
                   pixe(iu,ju) = pixru
                   endif
               enddo
            endif
         enddo
 
 
c--------------------------------------
c
c read in the DQ-flag array now...
c
c--------------------------------------
 
      i = i2
 300  continue
      i = i + 1
      if (DIAG) print*,'READREC: ',i
      read(19,rec=i,iostat=ios) buffc
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+80)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+51)
         if (field.eq.'END     ') then
            NEND = NEND + 1
            if (NEND.eq.3) goto 301
            endif
         enddo
      goto 300
 301  continue
 
 
c-----------------------------------------------------------------------------
 
      nread = nread + 1
      ifirst = i+1
      i1 = i
      i2 = i
      NXF = laxis(1)
      NYF = laxis(2)
      nbper  = 2*laxis(1)*laxis(2)
      npt    = laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      NXU = laxis(1)
      NYU = laxis(2)
 
      na = ((ilo-1) + (jlo-1)*NXU)
      nb = ((ihi-1) + (jhi-1)*NXU)
 
      do i = 001, NX
      do j = 001, NY
         pixv(i,j) = 2
         enddo
         enddo
 
      N3 = 0
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/2 + 1
         np2 = (nbyteE-nbyte1)/2 + 1
         np2 = min(np2,npt)
         if (na.le.np2.and.nb.ge.np1) then
            read(19,rec=i,iostat=ios) buffc
            call buff2pix_i2(buffb,buffi,0001,1440)
            do n = np1, np2, 1
               jj = n/NXU   + 1
               ii = n-NXU*(jj-1)
               iu = ii - ilo + 1
               ju = jj - jlo + 1
               pixiu = buffi(n-np1+1)
               if (iu.ge.1.and.iu.le.NX.and.
     .             ju.ge.1.and.ju.le.NY) then
                   N3 = N3 + 1
                   pixv(iu,ju) = pixiu
                   endif
               enddo
            endif
         enddo
 
      do i = 0001, NX
      do j = 0001, NY
         i2o = pixv(i,j)
         i2  = i2o
         pi2b(16) = i2/32768
         i2 = i2-i2/32768*32768
         pi2b(15) = i2/16384
         i2 = i2-i2/16384*16384
         pi2b(14) = i2/08192
         i2 = i2-i2/08192*08192
         pi2b(13) = i2/04096
         i2 = i2-i2/04096*04096
         pi2b(12) = i2/02048
         i2 = i2-i2/02048*02048
         pi2b(11) = i2/01024
         i2 = i2-i2/01024*01024
         pi2b(10) = i2/00512
         i2 = i2-i2/00512*00512
         pi2b(09) = i2/00256
         i2 = i2-i2/00256*00256
         pi2b(08) = i2/00128
         i2 = i2-i2/00128*00128
         pi2b(07) = i2/00064
         i2 = i2-i2/00064*00064
         pi2b(06) = i2/00032
         i2 = i2-i2/00032*00032
         pi2b(05) = i2/00016
         i2 = i2-i2/00016*00016
         pi2b(04) = i2/00008
         i2 = i2-i2/00008*00008
         pi2b(03) = i2/00004
         i2 = i2-i2/00004*00004
         pi2b(02) = i2/00002
         i2 = i2-i2/00002*00002
         pi2b(01) = i2
         pixu(i,j) = 0
         if (pi2b(09).eq.1) pixu(i,j) = 2 ! 256 ; saturation
         if (pi2b(02).eq.1) pixu(i,j) = 1 !   2 ; off chip/subarray
         if (pi2b(03).eq.1) pixu(i,j) = 1 !   4 ; bad detector pixel
         if (pi2b(06).eq.1.and.
     .       abs(pixr(i,j)).lt.0.001.and.
     .       abs(pixe(i,j)).lt.0.001) pixu(i,j) = 1 !   4 ; bad detector pixel
         enddo
         enddo
 
      if (DIAG) then
         print*,' pixr(151,151): ',pixr(151,151)
         print*,' pixe(151,151): ',pixe(151,151)
         print*,' pixu(151,151): ',pixu(151,151)
         print*,' pixv(151,151): ',pixv(151,151)
         call writfits_r4('pixr.fits',pixr,301,301)
         call writfits_r4('pixe.fits',pixe,301,301)
         call writfits_b1('pixu.fits',pixu,301,301)
         call writfits_i2('pixv.fits',pixv,301,301)
         stop
         endif
 
 
      goto 901
 900  continue
      print*,'READFITS ERROR'
      stop
 
 901  continue
      close(19)
      deallocate(pixv)
!$omp end critical(readfits_wfc3ir_flt_rast)
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/readfits_wfc3uv_WJ2_rast.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
 
      subroutine readfits_wfc3uv_WJ2_rast(FILE,pixr,pixe,pixu,
     .                                    ic,jc,NX,NY)
      implicit none
 
      character*(*) FILE
      integer NX, NY
      real*4    pixr(NX,NY)
      real*4    pixe(NX,NY)
      byte      pixu(NX,NY)
      integer ic, jc
 
      integer ilo, ihi, iu
      integer jlo, jhi, ju
 
      integer naxes
      integer laxis(3)
 
      character*8  field
      character*20 stream
 
      real      pixrr
      integer*4 pixuu
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios, k
      integer ii, jj, jj1, jj2
      integer n
      integer NXU, NYU
 
      integer NR
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
      integer*2 ibuff(1440)
 
      integer ifirst, i1, i2
      integer j
 
      integer np1, np2, npt
      integer nextend
      integer nread
      real bscale, bzero
      integer bitpix
 
      integer r2i
 
      logical LINUX
      data LINUX/.true./
      logical DIAG
      data DIAG /.false./
c     data DIAG /.true./
 
 
      character*80 FILEU
      logical ISWJL
 
      do i = 001, NX
      do j = 001, NY
         pixr(i,j) = -500
         pixe(i,j) = 9999.9
         pixu(i,j) = 3
         enddo
         enddo
 
 
      ilo = ic - (NX-1)/2
      ihi = ic + (NX-1)/2
      jlo = jc - (NY-1)/2
      jhi = jc + (NY-1)/2
 
      if (DIAG) then
         print*,'ENTER readfits_wfc3uv_WJ2_rast'
         print*,'----> ilo,ihi: ',ilo,ihi
         print*,'----> jlo,jhi: ',jlo,jhi
         endif
 
      ISWJL = .false.
 
      FILEU = FILE
      i = 1
    1 if (FILE(i:i+7).eq.'WJL.fits') ISWJL = .true.
      if (FILE(i:i+4).ne.'.fits') then
         i = i + 1
         if (i.gt.300) then
            print*,'writfits_i2 bomb...'
            print*,'no .fits in filename...'
            print*,'FILE: ',FILE
            stop
            endif
         goto 1
         endif
      FILEU = FILE(1:i+4)
 
 
!$omp critical(read_WJ2_rast)
      open(14,file=FILEU,status='old',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      if (DIAG) print*,'...opened'
 
      bscale = 1
      bzero  = 0
 
      naxes = -1
      laxis(1) = 1
      laxis(2) = 1
      laxis(3) = 1
      nextend = 0
 
      i = 0
      nread = 0
 100  continue
      i = i + 1
      read(14,rec=i,iostat=ios) buffc
      if (DIAG) print*,'READREC: ',i
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+80)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+31)
         if (field.eq.'NAXIS   ') read(stream,*) naxes
         if (field.eq.'NAXIS1  ') read(stream,*) laxis(1)
         if (field.eq.'NAXIS2  ') read(stream,*) laxis(2)
         if (field.eq.'NAXIS3  ') read(stream,*) laxis(3)
         if (field.eq.'NEXTEND ') read(stream,*) nextend
         if (field.eq.'BITPIX  ') read(stream,*) bitpix
         if (field.eq.'BSCALE  ') read(stream,*) bscale
         if (field.eq.'BZERO   ') read(stream,*) bzero
 
         if (field.eq.'END     ') goto 101
         enddo
      goto 100
 101  continue
 
      nread = nread + 1
      if (DIAG) then
         print*,'----------------------------------------'
         print*,'  NREAD: ',nread
         print*,'NEXTEND: ',nextend
         print*,'  NAXIS: ',naxes
         print*,'  LAXIS: ',laxis(1),laxis(2),laxis(3)
         print*,' BITPIX: ',bitpix
         print*,' BSCALE: ',bscale
         print*,'  BZERO: ',bzero
         endif
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      if (BITPIX.ne.16) then
         print*,'readfits_i2...: '
         print*,'                '
         print*,'   you called a routine to read in an'
         print*,'   unsigned i2 image, and the image you'
         print*,'   gave it has BITPIX = ',BITPIX
         print*,'   '
         print*,'   FILEU: ',FILEU
         print*,'   '
         stop
         endif
 
      nbper = 2*laxis(1)*laxis(2)
      npt   =   laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      if (laxis(1).ne.4096.and.
     .    laxis(2).ne.4096) then
         print*,' not enough image space! '
         print*,' '
         print*,'  laxis1: ',laxis(1)
         print*,'      NX: ',NX
         print*,' '
         print*,'  laxis2: ',laxis(2)
         print*,'      NY: ',NY
         print*,' '
         stop
         endif
 
      NXU = laxis(1)
      NYU = laxis(2)
 
      if (DIAG) then
         print*,'     NX: ',NX
         print*,'     NY: ',NY
         print*,'  NBPER: ',nbper
         print*,'  NBYT1: ',nbyte1
         print*,'  NBYT2: ',nbyte2
         print*,' IFIRST: ',ifirst
         print*,'     I1: ',i1
         print*,'     I2: ',i2
         print*,'    NPT: ',NPT
         endif
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/2 + 1
         np2 = (nbyteE-nbyte1)/2 + 1
         np2 = min(np2,npt)
         jj1 = np1/NXU   + 1
         jj2 = np2/NXU   + 1
         if (jj1.le.jhi.and.jj2.ge.jlo) then
            read(14,rec=i,iostat=ios) buffc
            call buff2pix_i2(buffb,ibuff,0001,1440)
            do n = np1, np2, 1
               jj = n/NXU   + 1
               ii = n-NXU*(jj-1)
               pixuu = ibuff(n-np1+1)
               if (pixuu.gt.32768) pixuu=pixuu-65536
               iu = ii - ilo + 1
               ju = jj - jlo + 1
               if (iu.ge.1.and.iu.le.NX.and.
     .             ju.ge.1.and.ju.le.NX) then
                   pixrr = pixuu + 32000.
                   if (ISWJL) then
                      pixr(iu,ju) = pixrr
                      pixe(iu,ju) = sqrt(4.5**2+max(pixrr,1.))
                      pixu(iu,ju) = 0
                      if (pixr(iu,ju).le. -700) then
                         pixr(iu,ju) = 10000.0
                         pixe(iu,ju) = 99999.0
                         pixu(iu,ju) = 2
                         endif
                      if (pixrr.gt.6000) then
                         pixrr = 6000*(6001.0d0/6000.0d0)**(pixrr-6000.)
                         pixr(iu,ju) = pixrr
                         pixe(iu,ju) = sqrt(4.5**2+max(pixrr,1.))
                         pixu(iu,ju) = 0
                         endif
                      if (jj.ge.2048-3.and.jj.le.2049+3) then
                         pixr(iu,ju) = -750.0
                         pixe(iu,ju) = 9999.9
                         pixu(iu,ju) = 3
                         endif
                      endif
                   if (.not.ISWJL) then
                      if (pixrr.gt.55000) pixrr = 55000 +(pixrr-55000)*5
                      pixr(iu,ju) = pixrr
                      pixe(iu,ju) = sqrt(4.5**2+max(pixrr,1.))
                      pixu(iu,ju) = 0
                      if (pixrr.lt._LOBAD_) pixu(iu,ju) = 4
                      if (pixr(iu,ju).eq. -750) then
                         pixu(iu,ju) = 2
                         pixe(iu,ju) = 99999.0
                         pixr(iu,ju) = 10000.0
                         endif
                      if (pixr(iu,ju).eq. -750) then ! corral; flag as satd
                         pixu(iu,ju) = 1
                         pixe(iu,ju) = 99999.0
                         pixr(iu,ju) = 50000.0
                         endif
                      if (pixr(iu,ju).gt.60000) then
                         pixu(iu,ju) = 1
                         pixe(iu,ju) = 99999.0
                         endif
c                     if (pixr(iu,ju).gt.99000.or.
c    .                   pixr(iu,ju).gt.75000) then
c                        pixu(iu,ju) = 5
c                        pixe(iu,ju) = 99999.0
c                        endif
                      if (jj.ge.2048-3.and.jj.le.2049+3) then
                         pixr(iu,ju) = -750.0
                         pixe(iu,ju) = 9999.9
                         pixu(iu,ju) = 3
                         endif
                      endif
                   endif
               enddo
            endif
         enddo
 
      if (DIAG) then
         print*,'  NBPER: ',nbper
         print*,'  NBYT1: ',nbyte1
         print*,'  NBYT2: ',nbyte2
         print*,' IFIRST: ',ifirst
         print*,'     I1: ',i1
         print*,'     I2: ',i2
         print*,'    NPT: ',NPT
         endif
 
      goto 901
  900 continue
      close(14)
      print*,'READFITS_wfc3uv_wj2_rast ERROR'
      print*,'FILE: ',FILE(1:70)
      print*,'  ic: ',ic,jc
      print*,'  NX: ',NX,NY
      stop
  901 close(14)
!$omp end critical(read_WJ2_rast)
      return
 
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/strip1_update_r4_j2.f"
c****                                         
c*********************************************
                                              
 
c-----------------------------------------------------
c
c
      subroutine strip1_update_r4_j2(stackv_s1,
     .                               stackv,stacku,
     .                               UREF_T,VREF_T,SCLU)
      implicit none
 
      integer*2 stackv_s1(_PXDIMX1_,_HDIM_)
      real*4    stackv(_TDIM_,_TDIM_)
      byte      stacku(_TDIM_,_TDIM_)
      integer   UREF_T, VREF_T
      real      SCLU
 
      integer i1, j1
      integer i2, j2
      integer ii, jj
      integer iu, ju
 
      real    ftot, f
      real    ptot
      real    pval
      integer ival
      integer DIJ
 
      DIJ = 16
      if (_MOSAIC_FSH_) DIJ = 15
 
      !print*,'enter strip1_update_r4_j2...'
 
      do i1 = 0001+DIJ, _HDIM_-DIJ
      do j1 = 0001+DIJ, _HDIM_-DIJ
         iu = i1 + (UREF_T-_HCEN_)
         ju = j1
         if (iu.ge.0001.and.iu.le._PXDIMX1_.and.
     .       ju.ge.0001.and.ju.le._HDIM_) then
             i2 = 1 + (i1-1)*2
             j2 = 1 + (j1-1)*2
             ftot = 0.
             ptot = 0.
             if (stacku(i2,j2).eq.1) then
                do ii = max(i2-1,001), min(i2+1,_TDIM_)
                do jj = max(j2-1,001), min(j2+1,_TDIM_)
                   f = stacku(ii,jj)
                   if (ii.ne.i2) f = f*0.5
                   if (jj.ne.j2) f = f*0.5
                   ftot = ftot + f
                   ptot = ptot + f*stackv(ii,jj)
                   enddo
                   enddo
                pval = 0
                if (ftot.gt.0) pval = ptot/ftot
                pval = pval*SCLU
                if (_MOSAIC_SHN_) then
                   if (pval.gt.6000)
     .                 pval = 6000 + log(pval/6000.)/log(6001.0/6000.0)
                   endif
                ival = pval - 32000
                if (ival.lt.-32750) ival = -32750
                if (ival.gt. 32750) ival =  32750
                stackv_s1(iu,ju) = ival
                endif
             endif
         enddo
         enddo
      !print*,'exit  strip1_update...'
 
      return
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/strip2_update_r4_j2.f"
c****                                         
c*********************************************
                                              
 
 
      subroutine strip2_update_r4_j2(stackv_s2,
     .                               stackv,stacku,
     .                               UREF_T,VREF_T,SCLU)
      implicit none
 
      integer*2 stackv_s2(_PXDIMX2_,_TDIM_)
      real*4    stackv(_TDIM_,_TDIM_)
      byte      stacku(_TDIM_,_TDIM_)
      integer   UREF_T, VREF_T
      real      SCLU
 
      integer i2, j2
      integer ii, jj
      integer iu, ju
 
      real    ftot, f
      real    ptot
      real    pval
      integer ival
      integer DIJ
 
      DIJ = 32
      if (_MOSAIC_FSH_) DIJ = 30
 
      !print*,'enter strip2_update_r4_j2...'
 
      do i2 = 0001+DIJ, _TDIM_-DIJ
      do j2 = 0001+DIJ, _TDIM_-DIJ
         iu = i2 + (UREF_T-_HCEN_)*2
         ju = j2
         if (iu.ge.0001.and.iu.le._PXDIMX2_.and.
     .       ju.ge.0001.and.ju.le._TDIM_) then
             if (stacku(i2,j2).eq.1) then
                pval = stackv(i2,j2)
                pval = pval*SCLU
                if (_MOSAIC_SHN_) then
                   if (pval.gt.6000)
     .                 pval = 6000 + log(pval/6000.)/log(6001.0/6000.0)
                   endif
                ival = pval - 32000
                if (ival.lt.-32750) ival = -32750
                if (ival.gt. 32750) ival =  32750
                stackv_s2(iu,ju) = ival
                endif
             endif
         enddo
         enddo
      !print*,'exit  strip2_update_r4_j2...'
 
      return
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/strip1_update_i2_j2.f"
c****                                         
c*********************************************
                                              
 
c-----------------------------------------------------
c
c
      subroutine strip1_update_i2_j2(stackv_s1,
     .                               stackv,stacku,
     .                               UREF_T,VREF_T)
      implicit none
 
      integer*2 stackv_s1(_PXDIMX1_,_HDIM_)
      integer*2 stackv(_TDIM_,_TDIM_)
      byte      stacku(_TDIM_,_TDIM_)
 
      integer   UREF_T, VREF_T
 
      integer i1, j1
      integer i2, j2
      integer ii, jj
      integer iu, ju
 
      integer DIJ
 
      DIJ = 16
      if (_MOSAIC_FSH_) DIJ = 15
 
      !print*,'enter strip1_update_i2_j2...'
      do i1 = 0001+DIJ, _HDIM_-DIJ
      do j1 = 0001+DIJ, _HDIM_-DIJ
         iu = i1 + (UREF_T-_HCEN_)
         ju = j1
         if (iu.ge.0001.and.iu.le._PXDIMX1_.and.
     .       ju.ge.0001.and.ju.le._HDIM_) then
             i2 = 1 + (i1-1)*2
             j2 = 1 + (j1-1)*2
             if (stacku(i2,j2).eq.1) then
                stackv_s1(iu,ju) = stackv(i2,j2)-32000
                endif
             endif
         enddo
         enddo
      !print*,'exit  strip1_update_i2_j2...'
 
      return
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/strip2_update_i2_j2.f"
c****                                         
c*********************************************
                                              
 
c--------------------------------------------------
c
c
      subroutine strip2_update_i2_j2(stackv_s2,
     .                               stackv,stacku,
     .                               UREF_T,VREF_T)
      implicit none
 
      integer*2 stackv_s2(_PXDIMX2_,_TDIM_)
      integer*2 stackv(_TDIM_,_TDIM_)
      byte      stacku(_TDIM_,_TDIM_)
 
      integer   UREF_T, VREF_T
 
      integer i2, j2
      integer ii, jj
      integer iu, ju
 
      integer DIJ
 
      DIJ = 32
      if (_MOSAIC_FSH_) DIJ = 30
 
      !print*,'enter strip2_update_i2_j2...'
      do i2 = 0001+DIJ, _TDIM_-DIJ
      do j2 = 0001+DIJ, _TDIM_-DIJ
         iu = i2 + (UREF_T-_HCEN_)*2
         ju = j2
         if (iu.ge.0001.and.iu.le._PXDIMX2_.and.
     .       ju.ge.0001.and.ju.le._TDIM_) then
             if (stacku(i2,j2).eq.1) then
                stackv_s2(iu,ju) = stackv(i2,j2)-32000
                endif
             endif
         enddo
         enddo
      !print*,'exit  strip2_update_i2_j2...'
 
      return
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_b1.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine writfits_b1(FILE,pix,PXDIMX,PXDIMY)
      implicit none
 
      character*(*) FILE
      integer PXDIMX,PXDIMY
      byte pix(PXDIMX,PXDIMY)
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
 
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
 
 
c     write(*,'(''ENTER   writfits_b1: '',80a)') FILEU
 
!$omp critical(writfits_b1)
      open(15,file=FILEU,
     .     status='unknown',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T    '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  =  8  '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   = '',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  = '',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  = '',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE= '',9a)')
     .                          ' ''BYTE    '''
      write(buffc( 6*80+1: 7*80),'(''DATE    = '',11a)')
     .                          ' ''28/01/00'''
      write(buffc( 7*80+1: 8*80),'(''BSCALE  = '',i12)') 00001
      write(buffc( 8*80+1: 9*80),'(''BZERO   = '',i12)') 00000
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',a20)') 0.00
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',a20)') 0.00
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',a20)') 0.00
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',a20)') 0.00
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a20)') ''' '''
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a20)') ''' '''
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',a20)') 1.000
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',a20)') 0.000
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',a20)') 0.000
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',a20)') 1.000
      write(buffc(19*80+1:20*80),'(''ORIENTAT= '',a20)') HDR(11)
      write(buffc(20*80+1:21*80),'(''PA_APER = '',a20)') HDR(12)
      write(buffc(21*80+1:22*80),'(''PA_V3   = '',a20)') HDR(13)
      write(buffc(22*80+1:23*80),'(''DATE-OBS= '',a20)') HDR(14)
      write(buffc(23*80+1:24*80),'(''TIME-OBS= '',a20)') HDR(15)
      write(buffc(24*80+1:25*80),'(''EXPTIME = '',a20)') HDR(16)
      write(buffc(25*80+1:26*80),'(''ROOTNAME= '',a20)') HDR(17)
      write(buffc(26*80+1:27*80),'(''TARGNAME= '',a20)') HDR(18)
      write(buffc(27*80+1:28*80),'(''RA_TARG = '',a20)') HDR(19)
      write(buffc(28*80+1:29*80),'(''DEC_TARG= '',a20)') HDR(20)
      write(buffc(29*80+1:30*80),'(''PROPOSID= '',a20)') HDR(21)
      write(buffc(30*80+1:31*80),'(''FILTER1 = '',a20)') HDR(22)
      write(buffc(31*80+1:32*80),'(''FILTER2 = '',a20)') HDR(23)
      write(buffc(32*80+1:33*80),'(''VAFACTOR= '',a20)') HDR(24)
      write(buffc(34*80+1:35*80),'(''END       '')')
      write(buffc(35*80+1:36*80),'(''END       '')')
 
c     print*,buffc
      write(15,rec=i,iostat=ios) buffc
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  =   PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
 
c      print*,'nbyte1: ',nbyte1
c      print*,'nbyte2: ',nbyte1
c      print*,'    i1: ',i1
c      print*,'    i2: ',i2
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1) + 1
         np2 = (nbyteE-nbyte1)+ 1
        !if (i.lt.0010) print*,'i: ',i,i1,i2,np1,np2,nbyte0
        !if (i.gt.2900) print*,'i: ',i,i1,i2,np1,np2,nbyte0
         call pix2buff_b1(pix,buffb,np1,npt)
         write(15,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'WRITFITS.f ERROR'
      stop
  901 close(15)
!$omp end critical(writfits_b1)
      return
 
      end
 
      subroutine pix2buff_b1(pix,buffb,n1,nt)
      implicit none
      byte pix(10201)
      byte buffb(2880)
 
      integer   n1,nt
 
      integer i
      integer npu
 
      integer ipval
 
      do i = 1, 2880
         npu = (1+(n1-1)*2)+i-1
         npu = (1+(n1-1)*1)+i-1
         if (npu.ge.1.and.npu.le.nt) then
            ipval = pix(npu)
            buffb(i) = ipval
            endif
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_b1_ltv.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine writfits_b1_ltv(FILE,pix,PXDIMX,PXDIMY,SCL)
      implicit none
 
      character*80 FILE
      integer PXDIMX,PXDIMY
      byte pix(PXDIMX,PXDIMY)
      real SCL
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
 
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
c     write(*,'(''ENTER   writfits_b1: '',80a)') FILEU
 
!$omp critical(writfits_b1)
      open(16,file=FILEU,
     .     status='unknown',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T    '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  =  8  '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   = '',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  = '',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  = '',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE= '',9a)')
     .                          ' ''BYTE    '''
      write(buffc( 6*80+1: 7*80),'(''DATE    = '',11a)')
     .                          ' ''28/01/00'''
      write(buffc( 7*80+1: 8*80),'(''BSCALE  = '',i12)') 00001
      write(buffc( 8*80+1: 9*80),'(''BZERO   = '',i12)') 00000
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',15x,i5)') 1
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',15x,i5)') 1
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',f20.7)') 1.000
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',f20.7)') 1.000
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a10)') ''' '''
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a10)') ''' '''
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',e20.7)')  1.0/SCL
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',e20.7)')  0.0
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',e20.7)')  0.0
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',e20.7)')  1.0/SCL
      write(buffc(19*80+1:20*80),'(''COMMENT'')')
      write(buffc(20*80+1:21*80),'(''LTV1    = '',f20.7)') (1.0-SCL)
      write(buffc(21*80+1:22*80),'(''LTV2    = '',f20.7)') (1.0-SCL)
      write(buffc(22*80+1:23*80),'(''LTM1_1  = '',f20.7)') SCL
      write(buffc(23*80+1:24*80),'(''LTM1_2  = '',f20.7)') 0.00
      write(buffc(24*80+1:25*80),'(''LTM2_1  = '',f20.7)') 0.00
      write(buffc(25*80+1:26*80),'(''LTM2_2  = '',f20.7)') SCL
      write(buffc(26*80+1:27*80),'(''TARGNAME= '',a20)') 'PKMAP'
      write(buffc(27*80+1:28*80),'(''COMMENT'')')
      write(buffc(28*80+1:29*80),'(''COMMENT'')')
      write(buffc(29*80+1:30*80),'(''COMMENT'')')
      write(buffc(30*80+1:31*80),'(''COMMENT'')')
      write(buffc(31*80+1:32*80),'(''COMMENT'')')
      write(buffc(32*80+1:33*80),'(''COMMENT'')')
      write(buffc(33*80+1:34*80),'(''COMMENT'')')
      write(buffc(34*80+1:35*80),'(''COMMENT'')')
      write(buffc(35*80+1:36*80),'(''END       '')')
 
c     print*,buffc
      write(16,rec=i,iostat=ios) buffc
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  =   PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
 
c      print*,'nbyte1: ',nbyte1
c      print*,'nbyte2: ',nbyte1
c      print*,'    i1: ',i1
c      print*,'    i2: ',i2
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1) + 1
         np2 = (nbyteE-nbyte1)+ 1
        !if (i.lt.0010) print*,'i: ',i,i1,i2,np1,np2,nbyte0
        !if (i.gt.2900) print*,'i: ',i,i1,i2,np1,np2,nbyte0
         call pix2buff_b1_l(pix,buffb,np1,npt)
         write(16,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'WRITFITS.f ERROR'
      stop
  901 close(16)
!$omp end critical(writfits_b1)
      return
 
      end
 
      subroutine pix2buff_b1_l(pix,buffb,n1,nt)
      implicit none
      byte pix(1)
      byte buffb(2880)
 
      integer   n1,nt
 
      integer i
      integer npu
 
      integer ipval
 
      do i = 1, 2880
         npu = (1+(n1-1)*2)+i-1
         npu = (1+(n1-1)*1)+i-1
         if (npu.ge.1.and.npu.le.nt) then
            ipval = pix(npu)
            buffb(i) = ipval
            endif
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_b1_init.f"
c****                                         
c*********************************************
                                              
 
      subroutine writfits_b1_init(FILE,PXDIMX,PXDIMY,SCL)
      implicit none
 
      character*80 FILE
      integer PXDIMX,PXDIMY
      real    SCL
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
 
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
 
 
      write(*,'(''ENTER   writfits_b1_init: '',80a)') FILEU
 
!$omp critical(writfits_b1_init)
      open(17,file=FILEU,
     .     status='unknown',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T    '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  =  8  '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   = '',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  = '',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  = '',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE= '',9a)')
     .                          ' ''BYTE    '''
      write(buffc( 6*80+1: 7*80),'(''DATE    = '',11a)')
     .                          ' ''28/01/00'''
      write(buffc( 7*80+1: 8*80),'(''BSCALE  = '',i12)') 00001
      write(buffc( 8*80+1: 9*80),'(''BZERO   = '',i12)') 00000
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',15x,i5)') 0
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',15x,i5)') 0
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',f20.7)') 0.000
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',f20.7)') 0.000
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a10)') ''' '''
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a10)') ''' '''
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',e20.7)')  1.0/SCL
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',e20.7)')  0.0
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',e20.7)')  0.0
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',e20.7)')  1.0/SCL
      write(buffc(19*80+1:20*80),'(''COMMENT'')')
c     write(buffc(20*80+1:21*80),'(''LTV1    = '',f20.7)') (1.0-SCL)
c     write(buffc(21*80+1:22*80),'(''LTV2    = '',f20.7)') (1.0-SCL)
      write(buffc(20*80+1:21*80),'(''LTV1    = '',f20.7)') 0.0
      write(buffc(21*80+1:22*80),'(''LTV2    = '',f20.7)') 0.0
      write(buffc(22*80+1:23*80),'(''LTM1_1  = '',f20.7)') SCL
      write(buffc(23*80+1:24*80),'(''LTM1_2  = '',f20.7)') 0.00
      write(buffc(24*80+1:25*80),'(''LTM2_1  = '',f20.7)') 0.00
      write(buffc(25*80+1:26*80),'(''LTM2_2  = '',f20.7)') SCL
      write(buffc(26*80+1:27*80),'(''COMMENT   '')')
      write(buffc(27*80+1:28*80),'(''COMMENT   '')')
      write(buffc(28*80+1:29*80),'(''COMMENT   '')')
      write(buffc(29*80+1:30*80),'(''COMMENT   '')')
      write(buffc(30*80+1:31*80),'(''COMMENT   '')')
      write(buffc(31*80+1:32*80),'(''COMMENT   '')')
      write(buffc(32*80+1:33*80),'(''COMMENT   '')')
      write(buffc(33*80+1:34*80),'(''COMMENT   '')')
      write(buffc(34*80+1:35*80),'(''COMMENT   '')')
      write(buffc(35*80+1:36*80),'(''END       '')')
 
c     print*,buffc
      write(17,rec=i,iostat=ios) buffc
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  =   PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      do i = 0001, 2880
         buffb(i) = -1
         enddo
 
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1) + 1
         np2 = (nbyteE-nbyte1)+ 1
         write(17,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
 900  continue
      print*,'WRITFITS.f ERROR'
      stop
  901 close(17)
!$omp end critical(writfits_b1_init)
      return
 
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_b1_rastX.f"
c****                                         
c*********************************************
                                              
 
c-----------------------------------------------------------
c
c the "X" means that it will start at (i1,j1) instead of
c being centered...   (i1:i1+NX-1,j1:j1+NY-1)
c
c
 
      subroutine writfits_b1_rastX(FILE,pixi,
     .                                  i1c,j1c,
     .                                  imin,imax,jmin,jmax,
     .                                  NX,NY,
     .                                  NXLEN,NYLEN)
      implicit none
 
      character*(*) FILE
      integer NX, NY
      integer*2 pixi(NX,NY) ! now this takes a j2 style file...
      integer   i1c, j1c
      integer   imin, imax
      integer   jmin, jmax
      integer   NXLEN
      integer   NYLEN
 
      integer ilo, ihi, iu
      integer jlo, jhi, ju
 
      character*70 INFO(10)
      common / fitsinfo / INFO
 
      integer naxes
      integer laxis(3)
 
      character*8  field
      character*20 stream
 
      integer*4 pixu
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios, k
      integer ii, jj, jj1, jj2
      integer n
      integer NXU, NYU
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
      byte      bbuff(2880)
 
      integer ifirst, i1, i2
      integer j
 
      integer np1, np2, npt
      integer nextend
      integer nread
      real bscale, bzero
      integer bitpix
 
      integer r2i
 
      logical LINUX
      data LINUX/.true./
      logical DIAG
      data DIAG /.false./
 
      character*70 HDR(25)
      common/HDR/HDR
      character*80 FILEU
 
      integer ival
 
 
      ilo = i1c
      jlo = j1c
      ihi = i1c + (imax-imin)
      jhi = j1c + (jmax-jmin)
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
      write(*,'(''writfits_b1_rastX: '',80a)') FILEU
 
!$omp critical(writfits_b1_rastX)
      open(18,file=FILEU,status='old',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      if (DIAG) print*,'...opened'
 
      bscale = 1
      bzero  = 0
 
      naxes = -1
      laxis(1) = 1
      laxis(2) = 1
      laxis(3) = 1
      nextend = 0
 
      do i = 1, 10
         INFO(i) = ' '
         enddo
      do i = 1, 25
         HDR(i) = ' '
         enddo
      HDR(24) = '  1.000 '
 
      i = 0
      nread = 0
 100  continue
      i = i + 1
      read(18,rec=i,iostat=ios) buffc
      if (DIAG) print*,'READREC: ',i
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+80)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+31)
         if (field.eq.'NAXIS   ') read(stream,*) naxes
         if (field.eq.'NAXIS1  ') read(stream,*) laxis(1)
         if (field.eq.'NAXIS2  ') read(stream,*) laxis(2)
         if (field.eq.'NAXIS3  ') read(stream,*) laxis(3)
         if (field.eq.'NEXTEND ') read(stream,*) nextend
         if (field.eq.'BITPIX  ') read(stream,*) bitpix
         if (field.eq.'BSCALE  ') read(stream,*) bscale
         if (field.eq.'BZERO   ') read(stream,*) bzero
         if (field.eq.'END     ') goto 101
         enddo
      goto 100
 101  continue
 
      nread = nread + 1
      if (DIAG) then
         print*,'----------------------------------------'
         print*,'  NREAD: ',nread
         print*,'NEXTEND: ',nextend
         print*,'  NAXIS: ',naxes
         print*,'  LAXIS: ',laxis(1),laxis(2),laxis(3)
         print*,' BITPIX: ',bitpix
         print*,' BSCALE: ',bscale
         print*,'  BZERO: ',bzero
         endif
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      if (BITPIX.ne.8) then
         print*,'writfits_b1_rast...: '
         print*,'                '
         print*,'   you called a routine to read in an'
         print*,'   unsigned i2 image, and the image you'
         print*,'   gave it has BITPIX = ',BITPIX
         print*,'   '
         print*,'   FILEU: ',FILEU
         print*,'   '
         stop
         endif
 
      nbper =   laxis(1)*laxis(2)
      npt   =   laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      NXU = laxis(1)
      NYU = laxis(2)
      if (NXU.ne.NXLEN.or.
     .    NYU.ne.NYLEN) then
          print*,'           '
          print*,'writfits_i2_32K_rast: '
          print*,'           '
          print*,'   NXLEN = ',NXLEN
          print*,'   NYLEN = ',NYLEN
          print*,'     NXU = ',NXU
          print*,'     NYU = ',NYU
          print*,'           '
          print*,'   FILE  = ',FILE
          print*,'   FILEU = ',FILEU
          print*,'           '
          stop 'STOP writfits_i2_32K_rast...'
          endif
 
      if (DIAG) then
         print*,'     NX: ',NX
         print*,'     NY: ',NY
         print*,'  NBPER: ',nbper
         print*,'  NBYT1: ',nbyte1
         print*,'  NBYT2: ',nbyte2
         print*,' IFIRST: ',ifirst
         print*,'     I1: ',i1
         print*,'     I2: ',i2
         print*,'    NPT: ',NPT
         endif
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1) + 1
         np2 = (nbyteE-nbyte1) + 1
         np2 = min(np2,npt)
         jj1 = np1/NXU   + 1
         jj2 = np2/NXU   + 1
         if (jj1.le.jhi.and.jj2.ge.jlo) then
            read(18,rec=i,iostat=ios) buffc
            do n = np1, np2, 1
               jj = n/NXU   + 1
               ii = n-NXU*(jj-1)
               iu = imin + (ii-ilo)
               ju = jmin + (jj-jlo)
               if (iu.ge.imin.and.iu.le.imax.and.
     .             ju.ge.jmin.and.ju.le.jmax) then
                   ival = pixi(iu,ju)+32000
                   if (ival.lt.-25) ival = -25
                   if (ival.gt.125) ival = 125
                   buffb(n-np1+1) = ival
                   endif
               enddo
            write(18,rec=i,iostat=ios) buffc
            endif
         enddo
 
      if (DIAG) then
         print*,'  NBPER: ',nbper
         print*,'  NBYT1: ',nbyte1
         print*,'  NBYT2: ',nbyte2
         print*,' IFIRST: ',ifirst
         print*,'     I1: ',i1
         print*,'     I2: ',i2
         print*,'    NPT: ',NPT
         endif
 
      goto 901
  900 continue
      print*,'        '
      print*,'WRITFITS_I2_32K_RASTX ERROR'
      print*,'  FILE: ',FILE(1:40)
      print*,'   i1c: ',i1c,j1c
      print*,'    NX: ',NX,NY
      print*,'        '
      stop
  901 close(18)
!$omp end critical(writfits_b1_rastX)
      return
 
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_j2_init.f"
c****                                         
c*********************************************
                                              
 
      subroutine writfits_j2_init(FILE,PXDIMX,PXDIMY,SCLU,SCL)
      implicit none
 
      character*80 FILE
      integer      PXDIMX,PXDIMY
      real         SCLU
      real         SCL
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
      integer*2 pixi(1440)
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
      integer k
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
      write(*,'(''ENTER   writfits_j2_init: '',80a)') FILEU
 
!$omp critical(writfits_j2_init)
      open(21,file=FILEU,
     .     status='unknown',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
 
      i = 1
 
      do k = 000, 035
         write(buffc(k*80+1:k*80+80),'(''COMMENT'')')
         enddo
 
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = '',19x,''T'')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  = '',i20)') 16
      write(buffc( 2*80+1: 3*80),'(''NAXIS   = '',i20)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  = '',i20.4)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  = '',i20.4)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE= '',9a)')
     .                          ' ''INTEGER*2 '''
      write(buffc( 6*80+1: 7*80),'(''DATE    = '',11a)')
     .                          ' ''28/01/00'''
      write(buffc( 7*80+1: 8*80),'(''BSCALE  = '',f20.5)') 1.0/SCLU
      write(buffc( 8*80+1: 9*80),'(''BZERO   = '',f20.5)') 32000/SCLU
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',15x,i5)') 0
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',15x,i5)') 0
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',f20.7)') 0.000
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',f20.7)') 0.000
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a10)') ''' '''
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a10)') ''' '''
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',e20.7)')  1.0/SCL
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',e20.7)')  0.0
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',e20.7)')  0.0
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',e20.7)')  1.0/SCL
      write(buffc(19*80+1:20*80),'(''COMMENT'')')
c     write(buffc(20*80+1:21*80),'(''LTV1    = '',f20.7)') (1.0-SCL)
c     write(buffc(21*80+1:22*80),'(''LTV2    = '',f20.7)') (1.0-SCL)
      write(buffc(20*80+1:21*80),'(''LTV1    = '',f20.7)') 0.0
      write(buffc(21*80+1:22*80),'(''LTV2    = '',f20.7)') 0.0
      write(buffc(22*80+1:23*80),'(''LTM1_1  = '',f20.7)') SCL
      write(buffc(23*80+1:24*80),'(''LTM1_2  = '',f20.7)') 0.00
      write(buffc(24*80+1:25*80),'(''LTM2_1  = '',f20.7)') 0.00
      write(buffc(25*80+1:26*80),'(''LTM2_2  = '',f20.7)') SCL
      write(buffc(26*80+1:27*80),'(''COMMENT   '')')
      write(buffc(27*80+1:28*80),'(''COMMENT   '')')
      write(buffc(28*80+1:29*80),'(''COMMENT   '')')
      write(buffc(29*80+1:30*80),'(''COMMENT   '')')
      write(buffc(30*80+1:31*80),'(''COMMENT   '')')
      write(buffc(31*80+1:32*80),'(''COMMENT   '')')
      write(buffc(32*80+1:33*80),'(''COMMENT   '')')
      write(buffc(33*80+1:34*80),'(''COMMENT   '')')
      write(buffc(34*80+1:35*80),'(''COMMENT   '')')
      write(buffc(35*80+1:36*80),'(''END       '')')
 
      write(21,rec=i,iostat=ios) buffc
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  = 2*PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      do i = 0001, 1440
         pixi(i) = _DEFPANE_i2_
         enddo
 
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/2 + 1
         np2 = (nbyteE-nbyte1)/2 + 1
         call pix2buff_i2(buffb,pixi,0001,1440)
         write(21,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'WRITFITS.f ERROR'
      stop
  901 close(21)
!$omp end critical(writfits_j2_init)
      return
 
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_j2_rastX.f"
c****                                         
c*********************************************
                                              
 
c-----------------------------------------------------------
c
c the "X" means that it will start at (i1,j1) instead of
c being centered...   (i1:i1+NX-1,j1:j1+NY-1)
c
c
 
      subroutine writfits_j2_rastX(FILE,pixi,
     .                                  i1c,j1c,
     .                                  imin,imax,jmin,jmax,
     .                                  NX,NY,
     .                                  NXLEN,NYLEN)
      implicit none
 
      character*80 FILE
      integer NX, NY
      integer*2 pixi(NX,NY)
      integer i1c, j1c
      integer imin, imax
      integer jmin, jmax
      integer NXLEN
      integer NYLEN
 
      integer ilo, ihi, iu
      integer jlo, jhi, ju
 
      character*70 INFO(10)
      common / fitsinfo / INFO
 
      integer naxes
      integer laxis(3)
 
      character*8  field
      character*20 stream
 
      integer*4 pixu
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios, k
      integer ii, jj, jj1, jj2
      integer n
      integer NXU, NYU
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
      integer*2 ibuff(1440)
 
      integer ifirst, i1, i2
      integer j
 
      integer np1, np2, npt
      integer nextend
      integer nread
      real bscale, bzero
      integer bitpix
 
      integer r2i
 
      logical LINUX
      data LINUX/.true./
      logical DIAG
      data DIAG /.false./
 
      character*70 HDR(25)
      common/HDR/HDR
      character*80 FILEU
 
 
 
      ilo = i1c
      jlo = j1c
      ihi = i1c + (imax-imin)
      jhi = j1c + (jmax-jmin)
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
      write(*,'(''writfits_j2_rastX: '',80a)') FILEU
      if (.false.) then
         write(*,'(''writfits_j2_rastX: '',80a)') FILEU
         print*,'------> i1c,  j1c  : ',i1c,j1c
         print*,'------> imin, imax : ',imin,imax
         print*,'------> jmin, jmax : ',jmin,jmax
         print*,'------> NX  , NY   : ',NX,NY
         print*,'------> NXLEN,NYLEN: ',NXLEN,NYLEN
         print*,'             '
         print*,'   ilo: ',ilo
         print*,'   jlo: ',jlo
         print*,'   ihi: ',ihi
         print*,'   jhi: ',jhi
         print*,'     i: ',imin,imax
         print*,'     j: ',jmin,jmax
         print*,'             '
         endif
 
!$omp critical(writfits_j2_rastX)
      open(22,file=FILEU,status='old',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      if (DIAG) print*,'...opened'
 
      bscale = 1
      bzero  = 0
 
      naxes = -1
      laxis(1) = 1
      laxis(2) = 1
      laxis(3) = 1
      nextend = 0
 
      do i = 1, 10
         INFO(i) = ' '
         enddo
      do i = 1, 25
         HDR(i) = ' '
         enddo
      HDR(24) = '  1.000 '
 
      i = 0
      nread = 0
 100  continue
      i = i + 1
      read(22,rec=i,iostat=ios) buffc
      if (DIAG) print*,'READREC: ',i
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)')
     .                   i,k,buffc(k*80+1:k*80+80)
         field  = buffc(k*80+01:k*80+08)
         stream = buffc(k*80+11:k*80+31)
         if (field.eq.'NAXIS   ') read(stream,*) naxes
         if (field.eq.'NAXIS1  ') read(stream,*) laxis(1)
         if (field.eq.'NAXIS2  ') read(stream,*) laxis(2)
         if (field.eq.'NAXIS3  ') read(stream,*) laxis(3)
         if (field.eq.'NEXTEND ') read(stream,*) nextend
         if (field.eq.'BITPIX  ') read(stream,*) bitpix
         if (field.eq.'BSCALE  ') read(stream,*) bscale
         if (field.eq.'BZERO   ') read(stream,*) bzero
 
         if (field.eq.'EXPTIME ') INFO(01) = stream
         if (field.eq.'FILTNAM1') INFO(02) = stream
         if (field.eq.'FILENAME') INFO(03) = stream
         if (field.eq.'DATE-OBS') INFO(04) = stream
         if (field.eq.'TIME-OBS') INFO(05) = stream
         if (field.eq.'DEC_TARG') INFO(06) = stream
         if (field.eq.'RA_TARG ') INFO(07) = stream
         if (field.eq.'PA_V3   ') INFO(08) = stream
         if (field.eq.'PROPOSID') INFO(09) = stream
         if (field.eq.'CCDGAIN ') INFO(10) = stream
 
         if (field.eq.'CRPIX1  ') HDR(01) = stream
         if (field.eq.'CRPIX2  ') HDR(02) = stream
         if (field.eq.'CRVAL1  ') HDR(03) = stream
         if (field.eq.'CRVAL2  ') HDR(04) = stream
         if (field.eq.'CTYPE1  ') HDR(05) = stream
         if (field.eq.'CTYPE2  ') HDR(06) = stream
         if (field.eq.'CD1_1   ') HDR(07) = stream
         if (field.eq.'CD1_2   ') HDR(08) = stream
         if (field.eq.'CD2_1   ') HDR(09) = stream
         if (field.eq.'CD2_2   ') HDR(10) = stream
         if (field.eq.'ORIENTAT') HDR(11) = stream
         if (field.eq.'PA_APER ') HDR(12) = stream
         if (field.eq.'PA_V3   ') HDR(13) = stream
         if (field.eq.'DATE-OBS') HDR(14) = stream
         if (field.eq.'TIME-OBS') HDR(15) = stream
         if (field.eq.'EXPTIME ') HDR(16) = stream
         if (field.eq.'ROOTNAME') HDR(17) = stream
         if (field.eq.'TARGNAME') HDR(18) = stream
         if (field.eq.'RA_TARG ') HDR(19) = stream
         if (field.eq.'DEC_TARG') HDR(20) = stream
         if (field.eq.'PROPOSID') HDR(21) = stream
         if (field.eq.'FILTER1 ') HDR(22) = stream
         if (field.eq.'FILTER2 ') HDR(23) = stream
         if (field.eq.'VAFACTOR') HDR(24) = stream
 
         if (field.eq.'END     ') goto 101
         enddo
      goto 100
 101  continue
 
      nread = nread + 1
      if (DIAG) then
         print*,'----------------------------------------'
         print*,'  NREAD: ',nread
         print*,'NEXTEND: ',nextend
         print*,'  NAXIS: ',naxes
         print*,'  LAXIS: ',laxis(1),laxis(2),laxis(3)
         print*,' BITPIX: ',bitpix
         print*,' BSCALE: ',bscale
         print*,'  BZERO: ',bzero
         print*,'----------------------------------------'
         endif
 
c     if (bzero.ne.32000) then
c        print*,' THIS ROUTINE EXPECTS BZERO TO BE 32000'
c        print*,' BZERO = ',BZERO
c        stop
c        endif
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      if (BITPIX.ne.16) then
         print*,'readfits_i2...: '
         print*,'                '
         print*,'   you called a routine to read in an'
         print*,'   unsigned i2 image, and the image you'
         print*,'   gave it has BITPIX = ',BITPIX
         print*,'   '
         print*,'   FILEU: ',FILEU
         print*,'   '
         stop
         endif
 
      nbper = 2*laxis(1)*laxis(2)
      npt   =   laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      NXU = laxis(1)
      NYU = laxis(2)
      if (NXU.ne.NXLEN.or.
     .    NYU.ne.NYLEN) then
          print*,'writfits_i2_32K_rast: '
          print*,'   NXLEN = ',NXLEN
          print*,'   NYLEN = ',NYLEN
          print*,'     NXU = ',NXU
          print*,'     NYU = ',NYU
          stop
          endif
 
      if (DIAG) then
         print*,'----------------------------------------'
         print*,'     NX: ',NX
         print*,'     NY: ',NY
         print*,'  NBPER: ',nbper
         print*,'  NBYT1: ',nbyte1
         print*,'  NBYT2: ',nbyte2
         print*,' IFIRST: ',ifirst
         print*,'     I1: ',i1
         print*,'     I2: ',i2
         print*,'    NPT: ',NPT
         print*,'    ilo: ',ilo,ihi
         print*,'    jlo: ',jlo,jhi
         print*,'----------------------------------------'
         endif
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/2 + 1
         np2 = (nbyteE-nbyte1)/2 + 1
         np2 = min(np2,npt)
         jj1 = np1/NXU   + 1
         jj2 = np2/NXU   + 1
         if (jj1.le.jhi.and.jj2.ge.jlo) then
            read(22,rec=i,iostat=ios) buffc
            call buff2pix_i2(buffb,ibuff,0001,1440)
            do n = np1, np2, 1
               jj = n/NXU   + 1
               ii = n-NXU*(jj-1)
               pixu = ibuff(n-np1+1)
               if (pixu.gt.32768) pixu=pixu-65536
               iu = imin + (ii-ilo)
               ju = jmin + (jj-jlo)
               if (iu.ge.imin.and.iu.le.imax.and.
     .             ju.ge.jmin.and.ju.le.jmax) pixu = pixi(iu,ju)
               ibuff(n-np1+1) = pixu
               enddo
            call pix2buff_i2(buffb,ibuff,0001,1440)
            write(22,rec=i,iostat=ios) buffc
            endif
         enddo
 
      if (DIAG) then
         print*,'  NBPER: ',nbper
         print*,'  NBYT1: ',nbyte1
         print*,'  NBYT2: ',nbyte2
         print*,' IFIRST: ',ifirst
         print*,'     I1: ',i1
         print*,'     I2: ',i2
         print*,'    NPT: ',NPT
         endif
 
      goto 901
  900 continue
      print*,'        '
      print*,'WRITFITS_I2_32K_RASTX ERROR'
      print*,'  FILE: ',FILE(1:40)
      print*,'   i1c: ',i1c,j1c
      print*,'    NX: ',NX,NY
      print*,'        '
      stop
  901 close(22)
!$omp end critical(writfits_j2_rastX)
      return
 
      end
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_i2.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine writfits_i2(FILE,pix,PXDIMX,PXDIMY)
      implicit none
 
      integer PXDIMX,PXDIMY
      character*(*) FILE
      integer*2 pix(PXDIMX,PXDIMY)
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
 
      FILEU = FILE
      i = 1
    1 if (FILE(i:i+4).ne.'.fits') then
         i = i + 1
         if (i.gt.300) then
            print*,'writfits_i2 bomb...'
            print*,'no .fits in filename...'
            print*,'FILE: ',FILE
            stop
            endif
         goto 1
         endif
      FILEU = FILE(1:i+4)
 
      !write(*,'(''ENTER   writfits_i2: '',80a)') FILEU
 
!$omp critical(writfits_i2)
      open(19,file=FILEU,
     .     status='unknown',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T    '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  =  16  '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   = '',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  = '',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  = '',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE= '',9a)')
     .                          ' ''INTEGER*4 '''
      write(buffc( 6*80+1: 7*80),'(''DATE    = '',11a)')
     .                          ' ''28/01/00'''
      write(buffc( 7*80+1: 8*80),'(''BSCALE  = '',i12)') 00001
      write(buffc( 8*80+1: 9*80),'(''BZERO   = '',i12)') 00000
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',a20)') HDR(01)
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',a20)') HDR(02)
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',a20)') HDR(03)
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',a20)') HDR(04)
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a20)') HDR(05)
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a20)') HDR(06)
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',a20)') HDR(07)
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',a20)') HDR(08)
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',a20)') HDR(09)
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',a20)') HDR(10)
      write(buffc(19*80+1:20*80),'(''ORIENTAT= '',a20)') HDR(11)
      write(buffc(20*80+1:21*80),'(''PA_APER = '',a20)') HDR(12)
      write(buffc(21*80+1:22*80),'(''PA_V3   = '',a20)') HDR(13)
      write(buffc(22*80+1:23*80),'(''DATE-OBS= '',a20)') HDR(14)
      write(buffc(23*80+1:24*80),'(''TIME-OBS= '',a20)') HDR(15)
      write(buffc(24*80+1:25*80),'(''EXPTIME = '',a20)') HDR(16)
      write(buffc(25*80+1:26*80),'(''ROOTNAME= '',a20)') HDR(17)
      write(buffc(26*80+1:27*80),'(''TARGNAME= '',a20)') HDR(18)
      write(buffc(27*80+1:28*80),'(''RA_TARG = '',a20)') HDR(19)
      write(buffc(28*80+1:29*80),'(''DEC_TARG= '',a20)') HDR(20)
      write(buffc(29*80+1:30*80),'(''PROPOSID= '',a20)') HDR(21)
      write(buffc(30*80+1:31*80),'(''FILTER1 = '',a20)') HDR(22)
      write(buffc(31*80+1:32*80),'(''FILTER2 = '',a20)') HDR(23)
      write(buffc(32*80+1:33*80),'(''VAFACTOR= '',a20)') HDR(24)
      write(buffc(34*80+1:35*80),'(''END       '')')
      write(buffc(35*80+1:36*80),'(''END       '')')
 
      write(19,rec=i,iostat=ios) buffc
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  = 2*PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
 
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         np1 = (nbyte0-nbyte1)/2 + 1
         np2 = (nbyteE-nbyte1)/2 + 1
        !if (i.lt.0010) print*,'i: ',i,i1,i2,np1,np2,nbyte0
        !if (i.gt.2900) print*,'i: ',i,i1,i2,np1,np2,nbyte0
         call pix2buff_i2(buffb,pix,np1,npt)
         write(19,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'WRITFITS.f ERROR'
      stop
  901 close(19)
!$omp end critical(writfits_i2)
      return
 
 
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_j2.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine writfits_j2(FILE,pix,PXDIMX,PXDIMY)
      implicit none
 
      integer PXDIMX,PXDIMY
      character*(*) FILE
      integer*2 pix(PXDIMX,PXDIMY)
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
 
      FILEU = FILE
      i = 1
    1 if (FILE(i:i+4).ne.'.fits') then
         i = i + 1
         if (i.gt.300) then
            print*,'writfits_i2 bomb...'
            print*,'no .fits in filename...'
            print*,'FILE: ',FILE
            stop
            endif
         goto 1
         endif
      FILEU = FILE(1:i+4)
 
 
c     write(*,'(''ENTER   writfits_j2: '',80a)') FILEU
 
!$omp critical(writfits_j2)
      open(20,file=FILEU,
     .     status='unknown',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T    '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  =  16  '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   = '',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  = '',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  = '',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE= '',9a)')
     .                          ' ''INTEGER*2 '''
      write(buffc( 6*80+1: 7*80),'(''DATE    = '',11a)')
     .                          ' ''28/01/00'''
      write(buffc( 7*80+1: 8*80),'(''BSCALE  = '',i12)') 00001
      write(buffc( 8*80+1: 9*80),'(''BZERO   = '',i12)') 32000
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',a20)') HDR(01)
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',a20)') HDR(02)
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',a20)') HDR(03)
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',a20)') HDR(04)
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a20)') HDR(05)
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a20)') HDR(06)
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',a20)') HDR(07)
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',a20)') HDR(08)
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',a20)') HDR(09)
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',a20)') HDR(10)
      write(buffc(19*80+1:20*80),'(''ORIENTAT= '',a20)') HDR(11)
      write(buffc(20*80+1:21*80),'(''PA_APER = '',a20)') HDR(12)
      write(buffc(21*80+1:22*80),'(''PA_V3   = '',a20)') HDR(13)
      write(buffc(22*80+1:23*80),'(''DATE-OBS= '',a20)') HDR(14)
      write(buffc(23*80+1:24*80),'(''TIME-OBS= '',a20)') HDR(15)
      write(buffc(24*80+1:25*80),'(''EXPTIME = '',a20)') HDR(16)
      write(buffc(25*80+1:26*80),'(''ROOTNAME= '',a20)') HDR(17)
      write(buffc(26*80+1:27*80),'(''TARGNAME= '',a20)') HDR(18)
      write(buffc(27*80+1:28*80),'(''RA_TARG = '',a20)') HDR(19)
      write(buffc(28*80+1:29*80),'(''DEC_TARG= '',a20)') HDR(20)
      write(buffc(29*80+1:30*80),'(''PROPOSID= '',a20)') HDR(21)
      write(buffc(30*80+1:31*80),'(''FILTER1 = '',a20)') HDR(22)
      write(buffc(31*80+1:32*80),'(''FILTER2 = '',a20)') HDR(23)
      write(buffc(32*80+1:33*80),'(''VAFACTOR= '',a20)') HDR(24)
      write(buffc(33*80+1:34*80),'(''COMMENT   '')')
      write(buffc(34*80+1:35*80),'(''COMMENT   '')')
      write(buffc(35*80+1:36*80),'(''END       '')')
 
      write(20,rec=i,iostat=ios) buffc
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  = 2*PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
 
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         np1 = (nbyte0-nbyte1)/2 + 1
         np2 = (nbyteE-nbyte1)/2 + 1
        !if (i.lt.0010) print*,'i: ',i,i1,i2,np1,np2,nbyte0
        !if (i.gt.2900) print*,'i: ',i,i1,i2,np1,np2,nbyte0
         call pix2buff_i2(buffb,pix,np1,npt)
         write(20,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'WRITFITS.f ERROR'
      stop
  901 continue
      close(20)
!$omp end critical(writfits_j2)
      return
 
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_r4.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
 
      subroutine writfits_r4(FILE,pix,PXDIMX,PXDIMY)
      implicit none
 
      character*(*) FILE
      integer PXDIMX,PXDIMY
      real    pix(PXDIMX,PXDIMY)
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*80 FILEU
      character*70 HDR(25)
      common/HDR/HDR
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
c      write(*,'(''writfits_r4:  '',i5,''x'',i5,1x,80a)')
c     .            PXDIMX,PXDIMY,FILEU
 
!$omp critical(writfits_r4)
      open(23,file=FILEU,status='unknown',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T      '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  = -32    '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   ='',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  ='',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  ='',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE='',9a)')
     .                          ' ''REAL*4'''
      write(buffc( 6*80+1: 7*80),'(''DATE    ='',11a)')
     .                          ' ''28/01/00'''
      write(buffc(07*80+1:08*80),'(''COMMENT  '',a05)') '     '
      write(buffc(08*80+1:09*80),'(''COMMENT  '',a05)') '     '
      write(buffc(09*80+1:10*80),'(''CRPIX1  ='',f20.5)') 0.00
      write(buffc(10*80+1:11*80),'(''CRPIX2  ='',f20.5)') 0.00
      write(buffc(11*80+1:12*80),'(''CRVAL1  ='',f20.5)') 0.00
      write(buffc(12*80+1:13*80),'(''CRVAL2  ='',f20.5)') 0.00
      write(buffc(13*80+1:14*80),'(''CTYPE1  ='',a20)') ''' '''
      write(buffc(14*80+1:15*80),'(''CTYPE2  ='',a20)') ''' '''
      write(buffc(15*80+1:16*80),'(''CD1_1   ='',f20.9)') 1.00000
      write(buffc(16*80+1:17*80),'(''CD1_2   ='',f20.9)') 0.00000
      write(buffc(17*80+1:18*80),'(''CD2_1   ='',f20.9)') 0.00000
      write(buffc(18*80+1:19*80),'(''CD2_2   ='',f20.9)') 1.00000
      write(buffc(19*80+1:20*80),'(''ORIENTAT='',a20)') HDR(11)
      write(buffc(20*80+1:21*80),'(''PA_APER ='',a20)') HDR(12)
      write(buffc(21*80+1:22*80),'(''PA_V3   ='',a20)') HDR(13)
      write(buffc(22*80+1:23*80),'(''DATE-OBS='',a20)') HDR(14)
      write(buffc(23*80+1:24*80),'(''TIME-OBS='',a20)') HDR(15)
      write(buffc(24*80+1:25*80),'(''EXPTIME ='',a20)') HDR(16)
      write(buffc(25*80+1:26*80),'(''ROOTNAME='',a20)') HDR(17)
      write(buffc(26*80+1:27*80),'(''TARGNAME='',a20)') HDR(18)
      write(buffc(27*80+1:28*80),'(''RA_TARG ='',a20)') HDR(19)
      write(buffc(28*80+1:29*80),'(''DEC_TARG='',a20)') HDR(20)
      write(buffc(29*80+1:30*80),'(''PROPOSID='',a20)') HDR(21)
      write(buffc(30*80+1:31*80),'(''FILTER1 ='',a20)') HDR(22)
      write(buffc(31*80+1:32*80),'(''FILTER2 ='',a20)') HDR(23)
      write(buffc(33*80+1:34*80),'(''VAFACTOR='',a20)') HDR(24)
      write(buffc(32*80+1:33*80),'(''CCDGAIN ='',a20)') HDR(25)
      write(buffc(33*80+1:34*80),'(''COMMENT  '',a05)') '     '
      write(buffc(34*80+1:35*80),'(''COMMENT  '',a05)') '     '
      write(buffc(35*80+1:36*80),'(''END      '')')
 
      write(23,rec=i,iostat=ios) buffc
 
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  = 4*PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         call pix2buff_r4(buffb,pix,np1,npt)
         write(23,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'writfits_r4.f ERROR'
      print*,'   FILEU: ',FILEU
      stop
  901 continue
      close(23)
!$omp end critical(writfits_r4)
      return
 
 
      end
 
 
c--------------------------------------------------
c GC - DISTORTION CORRECTION
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/gc_cf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c
c generic distortion correction
c
 
      subroutine gc_cf(xraw,yraw,xcor,ycor,KKK,FLT,CCC,FILEGC)
      implicit none
 
      real*8 xraw, yraw
      real*8 xcor, ycor
      integer KKK
      integer FLT
      integer CCC
      character*80 FILEGC
 
      if (FILEGC(1:4).ne.'NULL') then
         call xryr2xcyc_stdgc(xraw,yraw,xcor,ycor,FILEGC,CCC)
         return
         endif
 
      if (KKK.eq.5.and.CCC.eq.1) then
         call wfc_gcf(xraw,yraw,xcor,ycor,1,FLT)
         return
         endif
 
      if (KKK.eq.5.and.CCC.eq.2) then
         call wfc_gcf(xraw,yraw,xcor,ycor,2,FLT)
         return
         endif
 
      if (KKK.eq.8.and.CCC.eq.1) then
c        call wfc3uv_gc(xraw,yraw,xcor,ycor,1)
         call wfc3uv_gc_meta_k(xraw,yraw-2048,2,FLT,xcor,ycor)
         return
         endif
 
      if (KKK.eq.8.and.CCC.eq.2) then
c        call wfc3uv_gc(xraw,yraw,xcor,ycor,2)
         call wfc3uv_gc_meta_k(xraw,yraw,1,FLT,xcor,ycor)
         return
         endif
 
      if (KKK.eq.9) then
         call wfc3ir_gc(xraw,yraw,xcor,ycor)
         return
         endif
 
      if (KKK.eq.7) then
         call hrc_gcf(xraw,yraw,xcor,ycor,FLT)
         return
         endif
 
      if (KKK.eq.1) then
         stop 'wfpc2 correction not matched to image'
        !call wfpc2gcK(xraw,yraw,xcor,ycor,KKK)
         return
         endif
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/cg_cf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c
c generic distortion rawrection
c
 
      subroutine cg_cf(xcor,ycor,xraw,yraw,KKK,FLT,CCC,FILEGC)
      implicit none
 
      real*8 xcor, ycor
      real*8 xraw, yraw
      integer KKK
      integer FLT
      integer CCC
      character*80 FILEGC
 
      integer CCCu
 
      if (FILEGC(1:4).ne.'NULL') then
         call xcyc2xryr_stdgc(xcor,ycor,xraw,yraw,FILEGC,CCC,CCCu)
         return
         endif
 
      if (KKK.eq.5.and.CCC.eq.1) then
         call wfc_cgf(xcor,ycor,xraw,yraw,1,FLT)
         return
         endif
 
      if (KKK.eq.5.and.CCC.eq.2) then
         call wfc_cgf(xcor,ycor,xraw,yraw,2,FLT)
         return
         endif
 
      if (KKK.eq.8.and.CCC.eq.1) then
c        call wfc3uv_cg(xcor,ycor,xraw,yraw,1)
         call wfc3uv_cg_meta(xcor,ycor,2,FLT,xraw,yraw)
         yraw = yraw + 2048.0
         return
         endif
 
      if (KKK.eq.8.and.CCC.eq.2) then
c        call wfc3uv_cg(xcor,ycor,xraw,yraw,2)
         call wfc3uv_cg_meta(xcor,ycor,1,FLT,xraw,yraw)
         return
         endif
 
      if (KKK.eq.9) then
         call wfc3ir_cg(xcor,ycor,xraw,yraw)
         return
         endif
 
      if (KKK.eq.7) then
         call hrc_cgf(xcor,ycor,xraw,yraw,FLT)
         return
         endif
 
      if (KKK.eq.1) then
         stop 'wfpc2 rawrection not matched to image'
        !call wfpc2cgK(xcor,ycor,xraw,yraw,KKK)
         return
         endif
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/hrc_cgf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c--------------------------------------------
c
c this performs the inverse HRC distortion correction
c
      subroutine hrc_cgf(xx,yy,x,y,ifilt)
      implicit none
 
      real*8 xx,yy
      real*8  x, y
      integer ifilt
      real*8  xe, ye
      real*8 xxe,yye
      real   dd
 
      integer NIT
 
 
c      if (xx.lt.-200.or.xx.gt.1200.or.
c     .    yy.lt.-200.or.yy.gt.1200)  continue
 
      xe = xx
      ye = yy
      do NIT = 01,25
         call hrc_gcf(xe,ye,xxe,yye,ifilt)
         xe = xe + (xx-xxe)*0.90
         ye = ye + (yy-yye)*0.90
         dd = sqrt((xx-xxe)**2+(yy-yye)**2)
         x = xe
         y = ye
         if (dd.lt.0.001) return
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/hrc_gcf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------
c
c this FORTRAN SUBROUTINE performs the filter-dependent
c HRC distortion correction
c
c (x ,y ) = the input position (real*8)
c (xx,yy) = the output position (real*8)
c
c       f = the filter number for look-up table correction
c           0 = (only polynomial solution)
c           1 = F220W    6 = F606W
c           2 = F330W    7 = F625W
c           3 = F435W    8 = F775W
c           4 = F475W    9 = F814W
c           5 = F555W   10 = F850LP
c
      subroutine hrc_gcf(x,y,xx,yy,f)
      implicit none
 
      real*8  x,  y  ! raw position
      real*8 xx, yy  ! distortion-corrected position
      integer f
 
      real*8 xh, yh
      real dx, dy, rtab
 
      real htabx(10,65,65)
      real htaby(10,65,65)
      common /htabx_/htabx
      common /htaby_/htaby
 
      xh = x
      yh = y
      call hrc_gc(xh,yh,xx,yy)  ! this is the filter-independent solution
      if (f.eq.0) return                  ! (no lookup table)
 
      dx = rtab(xh,yh,f,htabx)
      dy = rtab(xh,yh,f,htaby)
      xx = xx + dx
      yy = yy + dy
 
      return
      end
 
c----------------------------------------
c
c 2-d table interpolation
c
      real function rtab(x,y,f,tab)
      implicit none
 
      integer f
      real*8 x, y
      real   tab(10,65,65)
 
      real rx, ry
      integer ix, iy
      real fx, fy
 
      rtab = 0.
      if (f.lt.1.or.f.gt.10) return
 
      rx = 1 + (x/1024)*64
      ry = 1 + (y/1024)*64
      if (rx.lt.01) rx = 01
      if (ry.lt.01) ry = 01
      if (rx.gt.65) rx = 64.99
      if (ry.gt.65) ry = 64.99
      ix = int(rx)
      iy = int(ry)
      if (ix.lt.01) ix = 01
      if (iy.lt.01) iy = 01
      if (ix.gt.64) ix = 64
      if (iy.gt.64) iy = 64
      fx = rx-ix
      fy = ry-iy
      rtab =  (1-fx)*(1-fy)*tab(f,iy  ,ix  )
     .      + (1-fx)*( fy )*tab(f,iy+1,ix  )
     .      + ( fx )*(1-fy)*tab(f,iy  ,ix+1)
     .      + ( fx )*( fy )*tab(f,iy+1,ix+1)
 
      return
      end
 
 
 
 
c---------------------------------------------------
c
c this performs the polynomial portion of the
c solution (based on the polynomial found for F475W)
c
      subroutine hrc_gc(x,y,xx,yy)
      implicit none
 
      real*8  x,  y
      real*8 xx, yy
 
      real fx, fy
 
      integer i
 
      real polyx(15)
      real polyy(15)
      real polyr(15)
 
c
c in LINUX you need to do this to make sure
c that the variables stay in memory
c
      common /qq/ polyx,polyy
 
 
      logical first
      common /qqq/first
      data first / .true. /
 
      data polyx/
     .   0.000000,  0.000000,  0.000000, -0.864121,  2.355129,
     .  -0.183590,  0.009942,  0.000208,  0.051272,  0.001016,
     .   0.017420, -0.140388, -0.099512,  0.002582,  0.002776/
 
      data polyy/
     .   0.000000, 51.845219,-62.457410,  0.361129, -0.380593,
     .   2.622087,  0.053201,  0.034940, -0.072759,  0.067124,
     .   0.026491, -0.095819,  0.047346, -0.029614, -0.070042/
 
 
      xx = x
      yy = y
 
      fx = (x-512)/512.0
      fy = (y-512)/512.0
 
 
      polyr(01) = 1.0
      polyr(02) = fx
      polyr(03) = fy
      polyr(04) = fx*fx
      polyr(05) = fx*fy
      polyr(06) = fy*fy
      polyr(07) = fx*fx*fx
      polyr(08) = fx*fx*fy
      polyr(09) = fx*fy*fy
      polyr(10) = fy*fy*fy
      polyr(11) = fx*fx*fx*fx
      polyr(12) = fx*fx*fx*fy
      polyr(13) = fx*fx*fy*fy
      polyr(14) = fx*fy*fy*fy
      polyr(15) = fy*fy*fy*fy
 
 
      xx = x
      yy = y
      do i = 2, 15
         xx = xx + polyx(i)*polyr(i)
         yy = yy + polyy(i)*polyr(i)
         enddo
 
      return
      end
 
 
 
 
      block data xarray
      real htabx(10,65,65)
      common /htabx_/htabx
      data  htabx/
     c 0.632,0.462,0.428,0.070,0.209,0.462,0.298,0.327,0.452,0.016,
     c 0.642,0.451,0.426,0.065,0.205,0.460,0.296,0.321,0.446,0.018,
     c 0.653,0.438,0.423,0.060,0.201,0.458,0.295,0.315,0.440,0.020,
     c 0.658,0.423,0.420,0.053,0.195,0.454,0.292,0.308,0.434,0.022,
     c 0.661,0.409,0.417,0.046,0.189,0.449,0.287,0.301,0.428,0.023,
     c 0.657,0.396,0.413,0.038,0.184,0.442,0.282,0.294,0.422,0.024,
     c 0.655,0.388,0.408,0.030,0.177,0.433,0.277,0.288,0.417,0.024,
     c 0.652,0.381,0.402,0.022,0.169,0.425,0.272,0.281,0.412,0.023,
     c 0.652,0.378,0.397,0.014,0.161,0.418,0.266,0.275,0.407,0.022,
     c 0.652,0.372,0.393,0.008,0.153,0.412,0.261,0.268,0.402,0.021,
     c 0.652,0.364,0.390,0.002,0.146,0.407,0.256,0.261,0.397,0.021,
     c 0.652,0.352,0.387,-.001,0.140,0.404,0.252,0.255,0.391,0.025,
     c 0.654,0.341,0.382,-.004,0.135,0.401,0.249,0.249,0.386,0.031,
     c 0.657,0.330,0.376,-.004,0.131,0.398,0.246,0.242,0.380,0.038,
     c 0.661,0.321,0.370,-.003,0.127,0.394,0.242,0.236,0.375,0.045,
     c 0.661,0.314,0.365,-.002,0.123,0.390,0.239,0.229,0.370,0.050,
     c 0.657,0.307,0.360,0.000,0.120,0.387,0.234,0.223,0.367,0.054,
     c 0.649,0.301,0.357,0.003,0.117,0.384,0.231,0.219,0.365,0.058,
     c 0.636,0.293,0.354,0.006,0.115,0.384,0.227,0.216,0.365,0.062,
     c 0.620,0.286,0.352,0.009,0.115,0.383,0.225,0.214,0.367,0.068,
     c 0.604,0.280,0.348,0.011,0.114,0.383,0.224,0.213,0.369,0.073,
     c 0.589,0.276,0.344,0.013,0.114,0.382,0.223,0.211,0.370,0.078,
     c 0.575,0.272,0.340,0.015,0.113,0.381,0.222,0.208,0.369,0.079,
     c 0.563,0.269,0.335,0.016,0.111,0.379,0.221,0.204,0.367,0.077,
     c 0.555,0.266,0.330,0.016,0.107,0.377,0.220,0.200,0.364,0.073,
     c 0.550,0.263,0.325,0.016,0.104,0.374,0.219,0.196,0.361,0.069,
     c 0.546,0.260,0.321,0.015,0.101,0.372,0.218,0.194,0.359,0.063,
     c 0.543,0.256,0.317,0.014,0.098,0.370,0.216,0.193,0.358,0.056,
     c 0.542,0.253,0.315,0.014,0.095,0.370,0.215,0.191,0.358,0.050,
     c 0.540,0.248,0.313,0.014,0.093,0.370,0.213,0.189,0.357,0.044,
     c 0.538,0.245,0.313,0.013,0.090,0.371,0.212,0.187,0.355,0.038,
     c 0.534,0.243,0.312,0.013,0.088,0.370,0.211,0.184,0.352,0.032,
     c 0.530,0.242,0.312,0.012,0.086,0.368,0.209,0.181,0.349,0.024,
     c 0.524,0.242,0.312,0.011,0.084,0.366,0.208,0.179,0.346,0.015,
     c 0.517,0.241,0.311,0.009,0.084,0.363,0.205,0.177,0.343,0.004,
     c 0.512,0.241,0.310,0.006,0.084,0.361,0.202,0.176,0.341,-.007,
     c 0.510,0.238,0.308,0.004,0.085,0.359,0.199,0.174,0.338,-.019,
     c 0.510,0.235,0.305,0.002,0.085,0.358,0.197,0.173,0.335,-.030,
     c 0.511,0.231,0.304,-.001,0.086,0.358,0.195,0.171,0.332,-.041,
     c 0.514,0.229,0.303,-.002,0.088,0.358,0.193,0.170,0.330,-.051,
     c 0.517,0.229,0.303,-.004,0.089,0.359,0.193,0.169,0.328,-.062,
     c 0.521,0.233,0.304,-.006,0.092,0.359,0.193,0.169,0.326,-.072,
     c 0.523,0.238,0.305,-.008,0.094,0.359,0.194,0.170,0.325,-.082,
     c 0.525,0.243,0.305,-.010,0.096,0.359,0.195,0.172,0.325,-.091,
     c 0.527,0.248,0.305,-.012,0.098,0.358,0.195,0.174,0.325,-.099,
     c 0.527,0.253,0.303,-.014,0.097,0.358,0.195,0.174,0.327,-.106,
     c 0.530,0.255,0.301,-.016,0.095,0.356,0.193,0.173,0.328,-.113,
     c 0.533,0.259,0.300,-.018,0.093,0.355,0.192,0.172,0.329,-.121,
     c 0.539,0.264,0.300,-.020,0.092,0.355,0.192,0.172,0.331,-.130,
     c 0.544,0.270,0.301,-.021,0.091,0.355,0.193,0.171,0.333,-.138,
     c 0.550,0.278,0.303,-.022,0.091,0.356,0.197,0.173,0.335,-.144,
     c 0.552,0.286,0.305,-.023,0.091,0.358,0.202,0.174,0.336,-.147,
     c 0.554,0.294,0.307,-.025,0.092,0.361,0.207,0.177,0.338,-.145,
     c 0.553,0.303,0.308,-.027,0.092,0.362,0.211,0.179,0.339,-.140,
     c 0.555,0.311,0.309,-.029,0.093,0.365,0.213,0.181,0.340,-.134,
     c 0.556,0.319,0.311,-.032,0.094,0.367,0.215,0.183,0.341,-.128,
     c 0.559,0.327,0.313,-.035,0.096,0.371,0.217,0.187,0.344,-.123,
     c 0.560,0.335,0.315,-.039,0.098,0.374,0.219,0.190,0.347,-.120,
     c 0.563,0.343,0.317,-.043,0.102,0.377,0.221,0.194,0.352,-.119,
     c 0.564,0.351,0.320,-.047,0.107,0.381,0.223,0.197,0.357,-.118,
     c 0.565,0.360,0.322,-.051,0.113,0.385,0.226,0.200,0.362,-.118,
     c 0.567,0.368,0.324,-.054,0.121,0.388,0.228,0.204,0.366,-.116,
     c 0.572,0.377,0.326,-.056,0.129,0.391,0.231,0.207,0.369,-.115,
     c 0.580,0.389,0.328,-.059,0.139,0.394,0.233,0.209,0.370,-.114,
     c 0.587,0.401,0.330,-.061,0.148,0.397,0.235,0.211,0.372,-.113,
     c 0.625,0.445,0.421,0.061,0.198,0.454,0.293,0.316,0.447,0.013,
     c 0.636,0.433,0.418,0.056,0.194,0.452,0.291,0.310,0.441,0.015,
     c 0.646,0.421,0.416,0.051,0.190,0.450,0.290,0.304,0.435,0.017,
     c 0.652,0.408,0.413,0.045,0.185,0.447,0.287,0.298,0.429,0.019,
     c 0.655,0.396,0.409,0.038,0.181,0.442,0.283,0.291,0.423,0.019,
     c 0.652,0.386,0.405,0.031,0.176,0.436,0.278,0.285,0.417,0.019,
     c 0.648,0.379,0.401,0.024,0.170,0.428,0.272,0.279,0.413,0.018,
     c 0.644,0.372,0.396,0.017,0.164,0.421,0.266,0.273,0.408,0.017,
     c 0.641,0.367,0.392,0.010,0.157,0.415,0.260,0.268,0.405,0.015,
     c 0.638,0.361,0.388,0.004,0.150,0.410,0.255,0.262,0.400,0.015,
     c 0.637,0.353,0.384,-.002,0.144,0.407,0.251,0.256,0.396,0.016,
     c 0.635,0.342,0.381,-.006,0.139,0.404,0.247,0.250,0.390,0.019,
     c 0.634,0.332,0.377,-.009,0.135,0.401,0.245,0.243,0.385,0.024,
     c 0.635,0.323,0.372,-.011,0.131,0.397,0.242,0.238,0.380,0.029,
     c 0.637,0.316,0.366,-.011,0.127,0.394,0.239,0.232,0.376,0.034,
     c 0.637,0.310,0.362,-.010,0.124,0.390,0.236,0.226,0.372,0.038,
     c 0.635,0.304,0.358,-.008,0.121,0.387,0.232,0.221,0.369,0.040,
     c 0.629,0.298,0.354,-.006,0.118,0.385,0.229,0.217,0.368,0.043,
     c 0.620,0.292,0.352,-.003,0.117,0.384,0.227,0.214,0.368,0.046,
     c 0.608,0.286,0.350,0.000,0.116,0.384,0.226,0.213,0.369,0.049,
     c 0.595,0.280,0.347,0.003,0.115,0.384,0.225,0.212,0.369,0.053,
     c 0.583,0.276,0.343,0.005,0.114,0.383,0.224,0.210,0.370,0.057,
     c 0.571,0.273,0.339,0.007,0.113,0.382,0.223,0.208,0.370,0.057,
     c 0.561,0.270,0.335,0.009,0.111,0.380,0.222,0.205,0.368,0.055,
     c 0.554,0.267,0.331,0.009,0.108,0.378,0.221,0.202,0.366,0.052,
     c 0.549,0.265,0.327,0.010,0.105,0.376,0.220,0.199,0.364,0.047,
     c 0.546,0.263,0.323,0.010,0.103,0.374,0.219,0.197,0.363,0.041,
     c 0.544,0.261,0.320,0.010,0.101,0.372,0.218,0.195,0.362,0.034,
     c 0.543,0.258,0.318,0.011,0.099,0.372,0.217,0.194,0.362,0.028,
     c 0.544,0.255,0.317,0.011,0.097,0.372,0.216,0.192,0.360,0.022,
     c 0.544,0.253,0.316,0.012,0.096,0.373,0.215,0.190,0.359,0.015,
     c 0.544,0.252,0.316,0.013,0.094,0.372,0.215,0.187,0.357,0.009,
     c 0.542,0.252,0.316,0.013,0.093,0.371,0.215,0.184,0.355,0.002,
     c 0.538,0.252,0.316,0.012,0.093,0.369,0.213,0.182,0.353,-.006,
     c 0.533,0.252,0.315,0.011,0.093,0.367,0.211,0.181,0.350,-.016,
     c 0.529,0.251,0.314,0.010,0.093,0.365,0.209,0.180,0.348,-.025,
     c 0.527,0.249,0.313,0.009,0.094,0.364,0.206,0.178,0.346,-.035,
     c 0.527,0.247,0.311,0.008,0.094,0.363,0.203,0.177,0.344,-.044,
     c 0.528,0.245,0.310,0.007,0.095,0.363,0.202,0.176,0.342,-.052,
     c 0.529,0.244,0.309,0.006,0.097,0.364,0.201,0.175,0.341,-.060,
     c 0.531,0.244,0.310,0.005,0.098,0.364,0.201,0.175,0.340,-.068,
     c 0.533,0.246,0.310,0.004,0.099,0.365,0.201,0.176,0.339,-.076,
     c 0.535,0.249,0.311,0.003,0.101,0.365,0.202,0.177,0.339,-.083,
     c 0.536,0.253,0.311,0.001,0.102,0.365,0.203,0.178,0.338,-.089,
     c 0.537,0.257,0.311,0.000,0.102,0.365,0.204,0.180,0.338,-.095,
     c 0.538,0.261,0.311,-.002,0.100,0.365,0.204,0.180,0.339,-.099,
     c 0.541,0.264,0.310,-.003,0.097,0.364,0.203,0.179,0.340,-.105,
     c 0.545,0.267,0.310,-.005,0.095,0.364,0.202,0.178,0.341,-.111,
     c 0.550,0.272,0.310,-.006,0.093,0.365,0.202,0.179,0.344,-.118,
     c 0.555,0.277,0.312,-.007,0.092,0.365,0.204,0.180,0.346,-.124,
     c 0.559,0.283,0.313,-.008,0.091,0.367,0.207,0.182,0.348,-.129,
     c 0.561,0.289,0.314,-.009,0.090,0.368,0.211,0.184,0.350,-.130,
     c 0.562,0.295,0.315,-.011,0.091,0.370,0.216,0.187,0.351,-.129,
     c 0.561,0.302,0.316,-.012,0.091,0.372,0.219,0.188,0.352,-.124,
     c 0.563,0.310,0.317,-.014,0.092,0.374,0.221,0.190,0.353,-.120,
     c 0.565,0.317,0.319,-.016,0.093,0.377,0.223,0.192,0.354,-.115,
     c 0.567,0.325,0.321,-.019,0.095,0.379,0.224,0.195,0.356,-.110,
     c 0.569,0.332,0.323,-.022,0.098,0.382,0.225,0.198,0.359,-.107,
     c 0.570,0.339,0.325,-.026,0.102,0.385,0.227,0.201,0.362,-.105,
     c 0.570,0.347,0.327,-.029,0.108,0.388,0.229,0.204,0.367,-.103,
     c 0.570,0.355,0.329,-.032,0.115,0.391,0.231,0.207,0.371,-.101,
     c 0.573,0.365,0.331,-.035,0.123,0.394,0.233,0.210,0.374,-.100,
     c 0.578,0.375,0.333,-.037,0.132,0.398,0.236,0.213,0.377,-.099,
     c 0.585,0.387,0.336,-.040,0.142,0.401,0.238,0.215,0.378,-.098,
     c 0.592,0.399,0.338,-.043,0.152,0.404,0.240,0.217,0.380,-.097,
     c 0.618,0.428,0.414,0.051,0.188,0.446,0.287,0.306,0.443,0.010,
     c 0.629,0.416,0.411,0.047,0.183,0.444,0.285,0.299,0.437,0.012,
     c 0.647,0.404,0.409,0.043,0.179,0.444,0.285,0.294,0.431,0.013,
     c 0.658,0.392,0.406,0.038,0.175,0.441,0.283,0.286,0.424,0.015,
     c 0.659,0.382,0.404,0.031,0.173,0.436,0.280,0.279,0.416,0.015,
     c 0.653,0.376,0.400,0.025,0.170,0.430,0.274,0.273,0.409,0.013,
     c 0.644,0.371,0.395,0.018,0.166,0.424,0.265,0.268,0.405,0.011,
     c 0.636,0.366,0.390,0.011,0.161,0.418,0.258,0.264,0.404,0.008,
     c 0.630,0.358,0.385,0.005,0.154,0.412,0.252,0.260,0.402,0.005,
     c 0.625,0.350,0.381,-.002,0.147,0.408,0.247,0.254,0.400,0.004,
     c 0.620,0.341,0.378,-.009,0.142,0.406,0.242,0.249,0.395,0.006,
     c 0.615,0.333,0.376,-.014,0.140,0.404,0.240,0.243,0.390,0.011,
     c 0.612,0.324,0.373,-.018,0.138,0.402,0.239,0.238,0.385,0.017,
     c 0.612,0.315,0.369,-.021,0.135,0.399,0.238,0.232,0.380,0.022,
     c 0.614,0.311,0.362,-.022,0.129,0.393,0.235,0.227,0.376,0.028,
     c 0.616,0.309,0.356,-.022,0.124,0.388,0.230,0.222,0.373,0.031,
     c 0.618,0.307,0.352,-.020,0.122,0.384,0.227,0.218,0.371,0.032,
     c 0.614,0.301,0.351,-.016,0.121,0.384,0.225,0.214,0.370,0.029,
     c 0.608,0.293,0.351,-.012,0.120,0.384,0.224,0.211,0.369,0.029,
     c 0.599,0.285,0.349,-.008,0.120,0.387,0.225,0.211,0.370,0.033,
     c 0.586,0.280,0.346,-.005,0.119,0.387,0.227,0.213,0.372,0.039,
     c 0.572,0.276,0.343,-.002,0.118,0.387,0.227,0.214,0.372,0.042,
     c 0.561,0.272,0.340,0.000,0.115,0.385,0.225,0.212,0.372,0.042,
     c 0.555,0.268,0.336,0.002,0.112,0.383,0.224,0.209,0.371,0.039,
     c 0.548,0.266,0.332,0.003,0.110,0.380,0.222,0.204,0.369,0.034,
     c 0.543,0.266,0.328,0.004,0.107,0.377,0.222,0.201,0.368,0.028,
     c 0.541,0.266,0.324,0.005,0.105,0.374,0.221,0.199,0.367,0.022,
     c 0.541,0.265,0.321,0.006,0.103,0.372,0.221,0.199,0.367,0.016,
     c 0.542,0.264,0.320,0.007,0.102,0.373,0.219,0.198,0.366,0.007,
     c 0.547,0.263,0.319,0.009,0.101,0.374,0.218,0.196,0.366,-.001,
     c 0.553,0.262,0.318,0.011,0.101,0.375,0.218,0.192,0.364,-.008,
     c 0.558,0.261,0.319,0.013,0.101,0.375,0.220,0.189,0.361,-.014,
     c 0.560,0.262,0.319,0.014,0.100,0.375,0.223,0.186,0.359,-.022,
     c 0.556,0.264,0.320,0.015,0.100,0.373,0.223,0.184,0.359,-.030,
     c 0.548,0.265,0.320,0.015,0.100,0.371,0.220,0.183,0.358,-.039,
     c 0.542,0.263,0.319,0.015,0.101,0.369,0.216,0.183,0.356,-.048,
     c 0.539,0.261,0.318,0.015,0.102,0.368,0.212,0.183,0.355,-.055,
     c 0.539,0.259,0.316,0.015,0.103,0.367,0.210,0.183,0.353,-.061,
     c 0.541,0.259,0.315,0.014,0.104,0.368,0.209,0.182,0.353,-.067,
     c 0.542,0.258,0.314,0.015,0.105,0.368,0.208,0.180,0.353,-.072,
     c 0.542,0.258,0.314,0.015,0.107,0.370,0.207,0.180,0.354,-.077,
     c 0.543,0.259,0.316,0.015,0.108,0.371,0.208,0.182,0.354,-.082,
     c 0.545,0.261,0.318,0.015,0.110,0.372,0.211,0.185,0.353,-.087,
     c 0.545,0.263,0.320,0.014,0.110,0.373,0.212,0.187,0.352,-.090,
     c 0.544,0.264,0.319,0.013,0.108,0.373,0.213,0.187,0.351,-.091,
     c 0.544,0.267,0.318,0.011,0.104,0.373,0.213,0.186,0.351,-.093,
     c 0.547,0.272,0.319,0.010,0.100,0.373,0.212,0.185,0.351,-.096,
     c 0.555,0.276,0.320,0.008,0.096,0.373,0.211,0.184,0.353,-.101,
     c 0.563,0.280,0.322,0.007,0.093,0.373,0.209,0.183,0.355,-.108,
     c 0.571,0.284,0.323,0.006,0.092,0.375,0.211,0.185,0.359,-.116,
     c 0.572,0.287,0.325,0.005,0.091,0.377,0.217,0.190,0.361,-.119,
     c 0.572,0.292,0.325,0.005,0.089,0.379,0.223,0.196,0.364,-.116,
     c 0.570,0.295,0.325,0.003,0.086,0.380,0.226,0.196,0.364,-.113,
     c 0.569,0.300,0.325,0.002,0.085,0.382,0.228,0.196,0.365,-.110,
     c 0.568,0.306,0.326,0.000,0.087,0.383,0.229,0.196,0.365,-.107,
     c 0.572,0.314,0.327,-.001,0.090,0.385,0.230,0.199,0.365,-.103,
     c 0.577,0.322,0.329,-.003,0.092,0.387,0.230,0.202,0.365,-.097,
     c 0.581,0.329,0.330,-.005,0.094,0.389,0.229,0.205,0.367,-.092,
     c 0.579,0.334,0.332,-.008,0.099,0.391,0.230,0.208,0.370,-.088,
     c 0.575,0.341,0.333,-.011,0.106,0.393,0.232,0.210,0.375,-.086,
     c 0.573,0.351,0.335,-.014,0.115,0.397,0.234,0.214,0.380,-.084,
     c 0.576,0.362,0.339,-.016,0.126,0.402,0.238,0.217,0.384,-.082,
     c 0.583,0.374,0.342,-.018,0.135,0.405,0.240,0.220,0.385,-.081,
     c 0.590,0.386,0.343,-.021,0.145,0.407,0.242,0.221,0.386,-.082,
     c 0.597,0.398,0.345,-.024,0.155,0.410,0.244,0.223,0.387,-.081,
     c 0.612,0.411,0.409,0.041,0.176,0.440,0.282,0.296,0.438,0.007,
     c 0.621,0.400,0.406,0.037,0.173,0.438,0.281,0.290,0.432,0.009,
     c 0.641,0.388,0.403,0.034,0.168,0.437,0.281,0.283,0.427,0.012,
     c 0.651,0.377,0.399,0.030,0.165,0.435,0.280,0.276,0.420,0.014,
     c 0.654,0.371,0.396,0.025,0.163,0.430,0.277,0.270,0.411,0.014,
     c 0.650,0.369,0.392,0.019,0.161,0.425,0.271,0.265,0.404,0.011,
     c 0.641,0.365,0.388,0.013,0.159,0.421,0.261,0.261,0.401,0.006,
     c 0.630,0.359,0.385,0.008,0.155,0.416,0.253,0.258,0.400,0.002,
     c 0.619,0.349,0.381,0.002,0.150,0.412,0.246,0.254,0.400,0.001,
     c 0.612,0.339,0.377,-.005,0.144,0.409,0.241,0.250,0.399,0.001,
     c 0.605,0.331,0.373,-.011,0.141,0.407,0.238,0.244,0.394,0.004,
     c 0.599,0.325,0.371,-.017,0.140,0.406,0.237,0.239,0.389,0.007,
     c 0.592,0.318,0.369,-.022,0.139,0.404,0.237,0.233,0.384,0.011,
     c 0.589,0.311,0.365,-.026,0.136,0.400,0.236,0.228,0.380,0.014,
     c 0.588,0.307,0.360,-.029,0.130,0.394,0.232,0.224,0.377,0.017,
     c 0.589,0.304,0.355,-.029,0.125,0.389,0.228,0.221,0.376,0.020,
     c 0.592,0.302,0.351,-.028,0.123,0.387,0.226,0.217,0.374,0.020,
     c 0.592,0.297,0.350,-.025,0.123,0.387,0.225,0.213,0.372,0.015,
     c 0.592,0.292,0.349,-.020,0.122,0.387,0.225,0.210,0.371,0.013,
     c 0.587,0.287,0.347,-.016,0.121,0.390,0.227,0.209,0.370,0.014,
     c 0.577,0.283,0.345,-.012,0.120,0.391,0.229,0.211,0.371,0.018,
     c 0.567,0.277,0.343,-.009,0.117,0.390,0.229,0.213,0.371,0.021,
     c 0.561,0.274,0.340,-.007,0.114,0.387,0.228,0.213,0.371,0.020,
     c 0.557,0.271,0.337,-.004,0.112,0.385,0.226,0.211,0.371,0.018,
     c 0.552,0.271,0.333,-.003,0.110,0.383,0.225,0.208,0.371,0.013,
     c 0.546,0.270,0.330,-.001,0.109,0.381,0.224,0.205,0.371,0.008,
     c 0.541,0.270,0.328,-.000,0.107,0.378,0.224,0.203,0.371,0.002,
     c 0.541,0.270,0.326,0.002,0.105,0.377,0.223,0.202,0.371,-.005,
     c 0.545,0.271,0.325,0.005,0.105,0.377,0.222,0.202,0.370,-.015,
     c 0.552,0.272,0.325,0.008,0.105,0.377,0.221,0.200,0.369,-.024,
     c 0.561,0.272,0.324,0.011,0.107,0.378,0.222,0.197,0.368,-.030,
     c 0.569,0.272,0.324,0.014,0.108,0.379,0.225,0.194,0.366,-.036,
     c 0.572,0.273,0.324,0.016,0.109,0.379,0.228,0.191,0.366,-.044,
     c 0.571,0.276,0.324,0.017,0.109,0.378,0.230,0.189,0.366,-.051,
     c 0.566,0.277,0.325,0.019,0.110,0.377,0.228,0.189,0.366,-.058,
     c 0.562,0.276,0.325,0.020,0.111,0.376,0.224,0.189,0.364,-.063,
     c 0.559,0.275,0.324,0.021,0.112,0.375,0.220,0.189,0.363,-.068,
     c 0.559,0.274,0.323,0.022,0.113,0.374,0.218,0.188,0.362,-.072,
     c 0.560,0.275,0.322,0.023,0.114,0.375,0.217,0.188,0.363,-.077,
     c 0.560,0.276,0.322,0.024,0.115,0.376,0.216,0.187,0.364,-.081,
     c 0.559,0.277,0.323,0.026,0.116,0.377,0.217,0.188,0.367,-.083,
     c 0.558,0.277,0.324,0.027,0.117,0.379,0.218,0.191,0.367,-.085,
     c 0.558,0.275,0.326,0.027,0.117,0.380,0.220,0.193,0.367,-.086,
     c 0.557,0.274,0.327,0.026,0.116,0.382,0.221,0.195,0.366,-.086,
     c 0.556,0.274,0.326,0.026,0.112,0.382,0.222,0.194,0.364,-.086,
     c 0.557,0.277,0.326,0.025,0.107,0.382,0.222,0.192,0.363,-.086,
     c 0.561,0.283,0.328,0.024,0.102,0.382,0.223,0.191,0.363,-.087,
     c 0.568,0.288,0.331,0.023,0.098,0.384,0.222,0.192,0.366,-.090,
     c 0.576,0.291,0.334,0.022,0.095,0.386,0.222,0.193,0.369,-.096,
     c 0.581,0.293,0.335,0.021,0.094,0.388,0.224,0.197,0.372,-.101,
     c 0.582,0.295,0.335,0.020,0.092,0.390,0.229,0.203,0.375,-.101,
     c 0.581,0.296,0.334,0.020,0.088,0.392,0.234,0.208,0.377,-.096,
     c 0.579,0.297,0.333,0.019,0.084,0.393,0.236,0.208,0.378,-.092,
     c 0.578,0.301,0.334,0.017,0.082,0.393,0.237,0.208,0.379,-.091,
     c 0.578,0.306,0.335,0.016,0.084,0.394,0.239,0.207,0.379,-.091,
     c 0.582,0.314,0.336,0.016,0.088,0.396,0.240,0.209,0.379,-.089,
     c 0.588,0.322,0.337,0.014,0.091,0.398,0.239,0.211,0.378,-.084,
     c 0.590,0.328,0.338,0.013,0.093,0.400,0.237,0.214,0.379,-.078,
     c 0.586,0.332,0.339,0.010,0.098,0.400,0.237,0.216,0.380,-.073,
     c 0.580,0.338,0.341,0.008,0.106,0.401,0.238,0.219,0.384,-.069,
     c 0.577,0.347,0.343,0.006,0.116,0.405,0.241,0.222,0.388,-.066,
     c 0.579,0.359,0.347,0.005,0.128,0.410,0.245,0.225,0.391,-.064,
     c 0.587,0.373,0.350,0.002,0.138,0.414,0.247,0.227,0.392,-.064,
     c 0.596,0.387,0.352,-.004,0.149,0.416,0.248,0.226,0.393,-.067,
     c 0.604,0.399,0.354,-.007,0.158,0.419,0.249,0.227,0.394,-.066,
     c 0.604,0.394,0.402,0.029,0.165,0.432,0.276,0.284,0.434,0.003,
     c 0.612,0.384,0.399,0.026,0.162,0.430,0.275,0.279,0.428,0.005,
     c 0.624,0.370,0.396,0.024,0.156,0.429,0.274,0.272,0.423,0.010,
     c 0.633,0.361,0.392,0.022,0.154,0.427,0.274,0.267,0.417,0.014,
     c 0.637,0.358,0.388,0.018,0.153,0.423,0.272,0.262,0.409,0.014,
     c 0.635,0.357,0.385,0.014,0.152,0.419,0.265,0.258,0.402,0.010,
     c 0.627,0.354,0.381,0.010,0.150,0.415,0.257,0.254,0.399,0.003,
     c 0.615,0.348,0.378,0.005,0.148,0.412,0.249,0.251,0.398,-.002,
     c 0.604,0.337,0.375,0.001,0.144,0.409,0.242,0.248,0.398,-.003,
     c 0.597,0.327,0.372,-.005,0.140,0.406,0.238,0.244,0.397,-.002,
     c 0.591,0.320,0.368,-.011,0.138,0.405,0.235,0.239,0.392,-.000,
     c 0.583,0.316,0.366,-.017,0.138,0.404,0.234,0.233,0.387,0.001,
     c 0.574,0.312,0.364,-.022,0.137,0.403,0.235,0.228,0.382,-.000,
     c 0.566,0.306,0.362,-.027,0.133,0.399,0.234,0.224,0.379,-.000,
     c 0.563,0.300,0.358,-.030,0.127,0.393,0.230,0.222,0.379,0.001,
     c 0.564,0.296,0.353,-.032,0.122,0.389,0.226,0.219,0.378,0.003,
     c 0.567,0.294,0.349,-.032,0.121,0.388,0.225,0.216,0.377,0.001,
     c 0.570,0.291,0.347,-.029,0.122,0.388,0.225,0.211,0.375,-.005,
     c 0.574,0.290,0.346,-.025,0.121,0.388,0.226,0.207,0.373,-.010,
     c 0.573,0.288,0.345,-.021,0.120,0.389,0.227,0.205,0.372,-.012,
     c 0.567,0.285,0.343,-.018,0.117,0.389,0.228,0.206,0.371,-.011,
     c 0.560,0.280,0.341,-.016,0.113,0.388,0.228,0.208,0.371,-.010,
     c 0.558,0.277,0.339,-.013,0.110,0.385,0.226,0.209,0.371,-.011,
     c 0.559,0.276,0.336,-.011,0.109,0.384,0.224,0.209,0.371,-.013,
     c 0.556,0.277,0.333,-.009,0.108,0.383,0.223,0.207,0.373,-.016,
     c 0.547,0.278,0.332,-.007,0.107,0.382,0.223,0.204,0.374,-.019,
     c 0.540,0.277,0.330,-.005,0.106,0.380,0.223,0.202,0.374,-.024,
     c 0.538,0.277,0.330,-.002,0.106,0.379,0.222,0.201,0.373,-.032,
     c 0.543,0.278,0.330,0.001,0.107,0.379,0.222,0.201,0.372,-.043,
     c 0.553,0.279,0.331,0.005,0.109,0.379,0.222,0.200,0.371,-.050,
     c 0.562,0.280,0.330,0.008,0.112,0.380,0.223,0.198,0.371,-.053,
     c 0.571,0.281,0.329,0.012,0.115,0.381,0.226,0.196,0.372,-.056,
     c 0.576,0.282,0.328,0.014,0.117,0.381,0.229,0.194,0.372,-.061,
     c 0.577,0.284,0.328,0.017,0.119,0.381,0.230,0.193,0.373,-.065,
     c 0.576,0.285,0.328,0.019,0.120,0.381,0.229,0.192,0.372,-.069,
     c 0.575,0.285,0.329,0.022,0.121,0.381,0.225,0.191,0.370,-.071,
     c 0.576,0.285,0.329,0.025,0.121,0.380,0.222,0.190,0.368,-.074,
     c 0.577,0.286,0.329,0.027,0.121,0.380,0.220,0.190,0.367,-.078,
     c 0.578,0.288,0.329,0.029,0.122,0.380,0.219,0.190,0.369,-.084,
     c 0.577,0.290,0.330,0.032,0.123,0.382,0.220,0.190,0.373,-.087,
     c 0.575,0.291,0.330,0.033,0.123,0.383,0.221,0.192,0.376,-.087,
     c 0.571,0.290,0.331,0.035,0.122,0.384,0.223,0.195,0.379,-.085,
     c 0.569,0.287,0.332,0.035,0.120,0.385,0.226,0.197,0.379,-.083,
     c 0.567,0.284,0.332,0.036,0.118,0.386,0.226,0.198,0.377,-.081,
     c 0.568,0.283,0.331,0.036,0.113,0.387,0.227,0.197,0.375,-.080,
     c 0.570,0.287,0.332,0.036,0.107,0.387,0.228,0.195,0.374,-.080,
     c 0.573,0.294,0.335,0.036,0.102,0.389,0.230,0.196,0.375,-.080,
     c 0.578,0.299,0.340,0.036,0.099,0.392,0.231,0.198,0.379,-.081,
     c 0.583,0.302,0.342,0.035,0.097,0.395,0.231,0.201,0.381,-.084,
     c 0.586,0.302,0.343,0.035,0.095,0.399,0.234,0.205,0.384,-.087,
     c 0.586,0.302,0.341,0.034,0.093,0.401,0.238,0.210,0.387,-.084,
     c 0.585,0.302,0.340,0.034,0.089,0.402,0.240,0.215,0.390,-.077,
     c 0.585,0.302,0.339,0.033,0.085,0.403,0.241,0.217,0.391,-.073,
     c 0.585,0.304,0.341,0.032,0.085,0.403,0.241,0.216,0.393,-.073,
     c 0.586,0.309,0.343,0.032,0.088,0.404,0.243,0.216,0.394,-.076,
     c 0.591,0.317,0.345,0.031,0.093,0.407,0.245,0.217,0.394,-.077,
     c 0.596,0.324,0.345,0.031,0.096,0.409,0.245,0.218,0.394,-.073,
     c 0.597,0.328,0.346,0.030,0.098,0.410,0.244,0.221,0.394,-.068,
     c 0.591,0.331,0.347,0.028,0.103,0.410,0.244,0.224,0.394,-.062,
     c 0.583,0.335,0.349,0.026,0.111,0.410,0.245,0.227,0.397,-.057,
     c 0.579,0.344,0.352,0.025,0.121,0.414,0.248,0.230,0.400,-.052,
     c 0.580,0.357,0.355,0.024,0.133,0.418,0.251,0.231,0.401,-.049,
     c 0.589,0.371,0.358,0.019,0.143,0.421,0.253,0.231,0.400,-.049,
     c 0.598,0.385,0.359,0.011,0.152,0.423,0.252,0.229,0.400,-.055,
     c 0.606,0.398,0.360,0.007,0.161,0.426,0.253,0.229,0.400,-.056,
     c 0.594,0.379,0.397,0.017,0.156,0.425,0.270,0.274,0.429,-.003,
     c 0.600,0.370,0.394,0.015,0.153,0.423,0.268,0.269,0.423,-.001,
     c 0.605,0.358,0.390,0.014,0.148,0.422,0.267,0.265,0.419,0.006,
     c 0.611,0.349,0.386,0.013,0.145,0.419,0.267,0.260,0.414,0.011,
     c 0.614,0.345,0.383,0.011,0.145,0.416,0.263,0.256,0.407,0.010,
     c 0.613,0.343,0.379,0.009,0.143,0.413,0.258,0.252,0.401,0.004,
     c 0.606,0.340,0.376,0.007,0.142,0.410,0.251,0.249,0.398,-.005,
     c 0.595,0.334,0.373,0.004,0.140,0.408,0.246,0.246,0.397,-.011,
     c 0.586,0.326,0.370,0.001,0.137,0.405,0.241,0.242,0.396,-.012,
     c 0.581,0.317,0.368,-.003,0.135,0.403,0.236,0.238,0.394,-.012,
     c 0.577,0.311,0.365,-.007,0.134,0.401,0.234,0.233,0.390,-.012,
     c 0.569,0.309,0.362,-.012,0.133,0.401,0.234,0.228,0.386,-.015,
     c 0.559,0.307,0.360,-.017,0.132,0.400,0.235,0.224,0.382,-.018,
     c 0.551,0.302,0.358,-.021,0.127,0.397,0.234,0.223,0.380,-.021,
     c 0.549,0.298,0.356,-.025,0.122,0.393,0.230,0.222,0.380,-.021,
     c 0.550,0.293,0.352,-.028,0.118,0.389,0.226,0.220,0.381,-.020,
     c 0.553,0.290,0.348,-.029,0.117,0.388,0.226,0.217,0.380,-.021,
     c 0.557,0.290,0.346,-.028,0.119,0.388,0.227,0.212,0.378,-.029,
     c 0.560,0.292,0.345,-.026,0.119,0.388,0.227,0.207,0.376,-.037,
     c 0.560,0.293,0.343,-.023,0.116,0.388,0.227,0.204,0.376,-.043,
     c 0.554,0.290,0.342,-.021,0.112,0.386,0.227,0.204,0.376,-.045,
     c 0.549,0.286,0.340,-.019,0.108,0.384,0.226,0.205,0.374,-.046,
     c 0.550,0.284,0.339,-.017,0.105,0.382,0.224,0.206,0.373,-.047,
     c 0.555,0.285,0.336,-.015,0.104,0.381,0.222,0.207,0.373,-.048,
     c 0.554,0.287,0.334,-.012,0.104,0.381,0.221,0.205,0.375,-.049,
     c 0.546,0.288,0.333,-.010,0.104,0.382,0.221,0.203,0.376,-.051,
     c 0.536,0.287,0.333,-.008,0.104,0.381,0.221,0.200,0.376,-.055,
     c 0.533,0.287,0.333,-.005,0.105,0.380,0.220,0.200,0.375,-.063,
     c 0.540,0.286,0.334,-.002,0.108,0.379,0.219,0.200,0.373,-.073,
     c 0.550,0.287,0.335,0.001,0.111,0.380,0.219,0.199,0.373,-.077,
     c 0.560,0.288,0.334,0.005,0.116,0.381,0.220,0.198,0.374,-.076,
     c 0.568,0.289,0.333,0.009,0.120,0.382,0.223,0.197,0.376,-.073,
     c 0.573,0.291,0.331,0.012,0.122,0.383,0.226,0.196,0.377,-.074,
     c 0.576,0.291,0.330,0.015,0.125,0.384,0.226,0.195,0.377,-.075,
     c 0.578,0.292,0.331,0.019,0.126,0.384,0.225,0.194,0.375,-.074,
     c 0.579,0.292,0.332,0.023,0.127,0.384,0.223,0.192,0.373,-.074,
     c 0.582,0.293,0.333,0.027,0.127,0.384,0.221,0.190,0.371,-.075,
     c 0.584,0.295,0.333,0.030,0.127,0.385,0.219,0.190,0.370,-.080,
     c 0.585,0.298,0.334,0.033,0.128,0.386,0.219,0.190,0.373,-.086,
     c 0.584,0.300,0.334,0.036,0.128,0.388,0.220,0.191,0.377,-.090,
     c 0.581,0.301,0.335,0.039,0.127,0.389,0.223,0.194,0.383,-.087,
     c 0.577,0.300,0.335,0.040,0.123,0.389,0.226,0.196,0.386,-.082,
     c 0.573,0.296,0.335,0.041,0.121,0.389,0.228,0.198,0.386,-.078,
     c 0.571,0.293,0.335,0.042,0.117,0.390,0.229,0.199,0.384,-.076,
     c 0.573,0.293,0.334,0.043,0.113,0.390,0.229,0.198,0.382,-.075,
     c 0.576,0.298,0.336,0.044,0.107,0.392,0.232,0.198,0.382,-.075,
     c 0.579,0.305,0.340,0.045,0.103,0.395,0.236,0.200,0.386,-.075,
     c 0.581,0.311,0.345,0.046,0.101,0.400,0.237,0.202,0.389,-.075,
     c 0.583,0.313,0.348,0.046,0.099,0.404,0.238,0.205,0.392,-.076,
     c 0.585,0.313,0.348,0.046,0.098,0.408,0.240,0.208,0.394,-.077,
     c 0.586,0.311,0.346,0.047,0.096,0.410,0.243,0.213,0.397,-.074,
     c 0.587,0.310,0.345,0.047,0.093,0.411,0.244,0.217,0.400,-.067,
     c 0.588,0.310,0.345,0.047,0.091,0.411,0.243,0.220,0.403,-.062,
     c 0.590,0.313,0.347,0.046,0.093,0.412,0.241,0.221,0.404,-.063,
     c 0.593,0.317,0.350,0.045,0.098,0.413,0.243,0.221,0.405,-.068,
     c 0.598,0.323,0.352,0.045,0.103,0.417,0.246,0.223,0.406,-.070,
     c 0.601,0.328,0.353,0.045,0.107,0.420,0.247,0.224,0.406,-.068,
     c 0.600,0.331,0.355,0.045,0.109,0.421,0.248,0.227,0.407,-.062,
     c 0.593,0.333,0.357,0.043,0.113,0.420,0.249,0.230,0.408,-.055,
     c 0.586,0.338,0.360,0.042,0.120,0.421,0.251,0.235,0.410,-.048,
     c 0.581,0.348,0.362,0.041,0.131,0.424,0.255,0.237,0.412,-.042,
     c 0.582,0.360,0.365,0.039,0.141,0.428,0.257,0.237,0.412,-.039,
     c 0.589,0.372,0.365,0.034,0.149,0.430,0.258,0.235,0.409,-.041,
     c 0.601,0.384,0.364,0.023,0.155,0.430,0.256,0.232,0.406,-.048,
     c 0.608,0.395,0.365,0.019,0.163,0.432,0.256,0.231,0.405,-.049,
     c 0.584,0.368,0.391,0.005,0.149,0.418,0.263,0.264,0.423,-.009,
     c 0.588,0.358,0.388,0.005,0.146,0.416,0.261,0.260,0.418,-.007,
     c 0.589,0.345,0.385,0.004,0.142,0.415,0.259,0.257,0.415,-.001,
     c 0.593,0.336,0.381,0.004,0.140,0.413,0.257,0.253,0.410,0.002,
     c 0.595,0.331,0.379,0.005,0.139,0.410,0.255,0.249,0.404,0.001,
     c 0.592,0.328,0.375,0.005,0.138,0.407,0.251,0.246,0.400,-.007,
     c 0.584,0.324,0.372,0.004,0.136,0.405,0.246,0.243,0.397,-.018,
     c 0.574,0.320,0.369,0.003,0.134,0.404,0.243,0.239,0.395,-.025,
     c 0.568,0.314,0.367,0.001,0.133,0.402,0.239,0.235,0.394,-.028,
     c 0.566,0.307,0.364,-.001,0.132,0.399,0.235,0.231,0.392,-.030,
     c 0.565,0.302,0.361,-.003,0.131,0.397,0.233,0.226,0.389,-.033,
     c 0.559,0.302,0.358,-.007,0.130,0.397,0.233,0.222,0.384,-.038,
     c 0.550,0.302,0.356,-.010,0.128,0.397,0.234,0.220,0.382,-.042,
     c 0.544,0.300,0.354,-.013,0.123,0.395,0.233,0.220,0.381,-.044,
     c 0.544,0.297,0.353,-.016,0.117,0.391,0.229,0.221,0.382,-.044,
     c 0.548,0.294,0.350,-.019,0.114,0.389,0.226,0.220,0.382,-.044,
     c 0.551,0.292,0.347,-.021,0.114,0.388,0.226,0.217,0.381,-.046,
     c 0.552,0.293,0.345,-.021,0.116,0.387,0.227,0.213,0.380,-.054,
     c 0.552,0.296,0.344,-.021,0.115,0.386,0.228,0.209,0.380,-.064,
     c 0.549,0.297,0.343,-.020,0.112,0.385,0.227,0.205,0.380,-.072,
     c 0.543,0.294,0.342,-.019,0.108,0.383,0.227,0.203,0.381,-.078,
     c 0.538,0.290,0.341,-.018,0.103,0.381,0.225,0.203,0.379,-.081,
     c 0.541,0.288,0.341,-.017,0.100,0.379,0.223,0.204,0.376,-.083,
     c 0.549,0.290,0.339,-.015,0.099,0.379,0.221,0.205,0.375,-.083,
     c 0.552,0.292,0.337,-.013,0.100,0.380,0.220,0.204,0.376,-.082,
     c 0.544,0.294,0.336,-.011,0.101,0.381,0.220,0.201,0.377,-.080,
     c 0.534,0.294,0.336,-.009,0.102,0.381,0.220,0.199,0.378,-.082,
     c 0.532,0.294,0.335,-.007,0.104,0.379,0.218,0.199,0.377,-.089,
     c 0.538,0.293,0.336,-.005,0.108,0.378,0.216,0.198,0.376,-.097,
     c 0.549,0.293,0.337,-.002,0.112,0.378,0.215,0.197,0.375,-.099,
     c 0.558,0.294,0.336,0.002,0.116,0.380,0.217,0.196,0.376,-.093,
     c 0.564,0.296,0.334,0.005,0.121,0.382,0.220,0.195,0.378,-.087,
     c 0.568,0.298,0.332,0.009,0.124,0.384,0.222,0.194,0.378,-.084,
     c 0.570,0.297,0.332,0.012,0.127,0.384,0.222,0.194,0.378,-.081,
     c 0.571,0.296,0.333,0.016,0.129,0.385,0.222,0.193,0.376,-.077,
     c 0.572,0.295,0.334,0.021,0.130,0.386,0.221,0.191,0.375,-.073,
     c 0.574,0.297,0.335,0.026,0.130,0.387,0.220,0.189,0.373,-.072,
     c 0.577,0.299,0.335,0.031,0.130,0.389,0.219,0.188,0.374,-.076,
     c 0.579,0.301,0.336,0.035,0.131,0.392,0.219,0.188,0.376,-.083,
     c 0.579,0.303,0.337,0.039,0.131,0.394,0.220,0.190,0.382,-.085,
     c 0.576,0.305,0.338,0.041,0.128,0.394,0.223,0.193,0.387,-.081,
     c 0.573,0.304,0.338,0.043,0.124,0.393,0.227,0.196,0.390,-.075,
     c 0.570,0.302,0.339,0.044,0.121,0.393,0.229,0.198,0.390,-.070,
     c 0.570,0.301,0.338,0.046,0.117,0.393,0.229,0.199,0.388,-.069,
     c 0.573,0.303,0.338,0.047,0.113,0.394,0.230,0.200,0.387,-.069,
     c 0.576,0.308,0.340,0.049,0.109,0.396,0.235,0.201,0.389,-.070,
     c 0.578,0.315,0.345,0.050,0.106,0.401,0.239,0.203,0.394,-.070,
     c 0.578,0.320,0.349,0.052,0.105,0.406,0.242,0.206,0.399,-.070,
     c 0.579,0.322,0.352,0.052,0.104,0.412,0.243,0.208,0.401,-.070,
     c 0.580,0.322,0.352,0.053,0.103,0.416,0.245,0.209,0.402,-.069,
     c 0.581,0.321,0.351,0.054,0.102,0.417,0.247,0.212,0.405,-.066,
     c 0.584,0.320,0.350,0.056,0.101,0.418,0.247,0.217,0.410,-.059,
     c 0.588,0.320,0.351,0.056,0.101,0.417,0.244,0.221,0.413,-.055,
     c 0.592,0.322,0.353,0.056,0.103,0.418,0.241,0.223,0.413,-.056,
     c 0.596,0.325,0.356,0.055,0.109,0.419,0.242,0.225,0.413,-.062,
     c 0.599,0.328,0.358,0.056,0.115,0.422,0.244,0.226,0.413,-.065,
     c 0.601,0.331,0.359,0.056,0.118,0.426,0.247,0.227,0.414,-.064,
     c 0.598,0.332,0.362,0.056,0.121,0.427,0.249,0.230,0.415,-.059,
     c 0.594,0.335,0.365,0.055,0.125,0.427,0.252,0.235,0.415,-.050,
     c 0.589,0.342,0.368,0.053,0.132,0.429,0.256,0.239,0.417,-.042,
     c 0.586,0.352,0.371,0.052,0.141,0.433,0.259,0.241,0.420,-.036,
     c 0.586,0.363,0.373,0.050,0.149,0.437,0.261,0.240,0.420,-.034,
     c 0.592,0.373,0.372,0.043,0.154,0.438,0.261,0.237,0.417,-.036,
     c 0.602,0.381,0.369,0.032,0.158,0.437,0.259,0.235,0.413,-.043,
     c 0.608,0.391,0.370,0.027,0.164,0.438,0.260,0.234,0.412,-.045,
     c 0.573,0.360,0.385,-.006,0.142,0.412,0.255,0.254,0.417,-.018,
     c 0.575,0.350,0.382,-.005,0.140,0.410,0.253,0.251,0.412,-.018,
     c 0.576,0.337,0.379,-.005,0.137,0.408,0.251,0.249,0.409,-.013,
     c 0.578,0.327,0.376,-.004,0.135,0.407,0.249,0.246,0.405,-.012,
     c 0.579,0.320,0.373,-.002,0.133,0.404,0.246,0.242,0.400,-.016,
     c 0.575,0.315,0.371,0.000,0.132,0.402,0.244,0.239,0.397,-.025,
     c 0.567,0.311,0.367,0.001,0.130,0.400,0.242,0.237,0.395,-.036,
     c 0.557,0.309,0.364,0.001,0.129,0.400,0.240,0.234,0.393,-.044,
     c 0.553,0.306,0.362,0.000,0.130,0.400,0.237,0.230,0.392,-.048,
     c 0.555,0.301,0.360,-.001,0.130,0.397,0.233,0.225,0.389,-.052,
     c 0.555,0.297,0.357,-.002,0.129,0.394,0.230,0.220,0.386,-.059,
     c 0.551,0.297,0.354,-.003,0.127,0.392,0.229,0.217,0.382,-.066,
     c 0.544,0.299,0.351,-.004,0.125,0.393,0.230,0.216,0.380,-.071,
     c 0.541,0.300,0.350,-.006,0.120,0.391,0.229,0.217,0.380,-.073,
     c 0.544,0.299,0.350,-.007,0.115,0.389,0.226,0.218,0.381,-.073,
     c 0.550,0.296,0.348,-.008,0.112,0.387,0.223,0.217,0.381,-.073,
     c 0.552,0.295,0.346,-.010,0.112,0.386,0.224,0.215,0.381,-.076,
     c 0.550,0.296,0.345,-.011,0.113,0.386,0.226,0.212,0.380,-.083,
     c 0.546,0.299,0.345,-.012,0.112,0.385,0.227,0.209,0.382,-.092,
     c 0.540,0.300,0.344,-.012,0.109,0.383,0.227,0.205,0.384,-.101,
     c 0.533,0.297,0.343,-.013,0.104,0.382,0.226,0.203,0.385,-.109,
     c 0.530,0.293,0.342,-.013,0.100,0.379,0.225,0.202,0.383,-.113,
     c 0.535,0.292,0.343,-.013,0.097,0.377,0.222,0.202,0.379,-.115,
     c 0.546,0.294,0.342,-.012,0.096,0.378,0.221,0.203,0.376,-.113,
     c 0.551,0.297,0.341,-.011,0.098,0.379,0.221,0.202,0.377,-.109,
     c 0.545,0.299,0.339,-.010,0.099,0.381,0.221,0.201,0.379,-.103,
     c 0.535,0.299,0.338,-.009,0.101,0.381,0.221,0.200,0.381,-.102,
     c 0.532,0.299,0.337,-.008,0.104,0.378,0.218,0.200,0.380,-.107,
     c 0.539,0.299,0.337,-.006,0.108,0.376,0.215,0.199,0.379,-.113,
     c 0.549,0.299,0.337,-.004,0.112,0.376,0.213,0.197,0.378,-.112,
     c 0.556,0.300,0.336,-.001,0.116,0.377,0.214,0.194,0.379,-.106,
     c 0.560,0.302,0.335,0.002,0.120,0.380,0.216,0.193,0.380,-.097,
     c 0.562,0.304,0.333,0.005,0.124,0.382,0.218,0.193,0.379,-.091,
     c 0.562,0.303,0.333,0.009,0.128,0.383,0.220,0.193,0.379,-.086,
     c 0.560,0.301,0.334,0.013,0.131,0.384,0.221,0.192,0.378,-.079,
     c 0.558,0.299,0.335,0.018,0.131,0.386,0.222,0.191,0.378,-.072,
     c 0.558,0.301,0.336,0.024,0.131,0.388,0.222,0.190,0.378,-.068,
     c 0.560,0.302,0.337,0.029,0.131,0.392,0.221,0.189,0.379,-.070,
     c 0.565,0.305,0.337,0.034,0.132,0.395,0.220,0.189,0.382,-.075,
     c 0.568,0.306,0.339,0.038,0.132,0.397,0.221,0.191,0.387,-.077,
     c 0.569,0.308,0.340,0.041,0.130,0.398,0.224,0.194,0.392,-.072,
     c 0.568,0.310,0.342,0.044,0.126,0.397,0.228,0.197,0.394,-.065,
     c 0.568,0.311,0.343,0.045,0.122,0.396,0.230,0.199,0.394,-.062,
     c 0.570,0.311,0.343,0.046,0.119,0.396,0.230,0.201,0.392,-.062,
     c 0.573,0.313,0.344,0.048,0.115,0.397,0.232,0.203,0.391,-.064,
     c 0.576,0.318,0.345,0.050,0.112,0.400,0.237,0.206,0.395,-.065,
     c 0.576,0.324,0.349,0.052,0.110,0.405,0.242,0.210,0.402,-.065,
     c 0.575,0.328,0.353,0.053,0.109,0.411,0.244,0.213,0.407,-.065,
     c 0.573,0.330,0.355,0.054,0.109,0.417,0.245,0.214,0.409,-.064,
     c 0.573,0.330,0.356,0.054,0.109,0.420,0.246,0.214,0.409,-.062,
     c 0.575,0.330,0.355,0.056,0.110,0.423,0.249,0.215,0.412,-.058,
     c 0.579,0.330,0.355,0.058,0.110,0.423,0.249,0.219,0.418,-.052,
     c 0.585,0.330,0.356,0.059,0.111,0.422,0.246,0.224,0.420,-.049,
     c 0.590,0.332,0.359,0.059,0.114,0.422,0.243,0.227,0.421,-.049,
     c 0.594,0.333,0.361,0.059,0.119,0.423,0.243,0.229,0.419,-.055,
     c 0.596,0.334,0.362,0.060,0.124,0.425,0.245,0.230,0.418,-.059,
     c 0.595,0.334,0.363,0.060,0.127,0.427,0.247,0.230,0.418,-.059,
     c 0.594,0.334,0.365,0.061,0.129,0.429,0.250,0.232,0.417,-.055,
     c 0.593,0.337,0.369,0.060,0.133,0.430,0.254,0.236,0.417,-.047,
     c 0.592,0.345,0.373,0.059,0.139,0.434,0.259,0.239,0.417,-.040,
     c 0.592,0.355,0.376,0.057,0.147,0.439,0.261,0.240,0.420,-.034,
     c 0.593,0.365,0.378,0.055,0.153,0.443,0.262,0.240,0.422,-.033,
     c 0.596,0.372,0.376,0.048,0.157,0.444,0.262,0.239,0.421,-.036,
     c 0.603,0.379,0.374,0.038,0.159,0.442,0.262,0.238,0.419,-.040,
     c 0.607,0.387,0.373,0.032,0.164,0.443,0.263,0.237,0.419,-.043,
     c 0.565,0.354,0.376,-.015,0.137,0.404,0.246,0.243,0.409,-.030,
     c 0.565,0.344,0.374,-.013,0.135,0.403,0.244,0.241,0.405,-.031,
     c 0.564,0.331,0.372,-.013,0.132,0.404,0.242,0.240,0.402,-.028,
     c 0.566,0.321,0.369,-.011,0.129,0.402,0.240,0.237,0.398,-.030,
     c 0.567,0.313,0.367,-.008,0.128,0.399,0.238,0.233,0.394,-.035,
     c 0.564,0.306,0.364,-.005,0.127,0.397,0.238,0.232,0.393,-.045,
     c 0.556,0.303,0.361,-.003,0.125,0.396,0.237,0.231,0.392,-.054,
     c 0.549,0.302,0.359,-.002,0.125,0.396,0.235,0.230,0.391,-.061,
     c 0.547,0.301,0.357,-.002,0.126,0.396,0.231,0.226,0.389,-.067,
     c 0.549,0.296,0.354,-.002,0.126,0.393,0.227,0.221,0.385,-.074,
     c 0.551,0.292,0.350,-.002,0.125,0.389,0.223,0.215,0.381,-.085,
     c 0.548,0.292,0.346,-.002,0.123,0.387,0.221,0.211,0.378,-.096,
     c 0.542,0.296,0.344,-.001,0.121,0.388,0.222,0.211,0.377,-.103,
     c 0.541,0.298,0.344,-.001,0.118,0.387,0.221,0.212,0.378,-.105,
     c 0.546,0.298,0.345,0.000,0.114,0.386,0.220,0.212,0.379,-.105,
     c 0.553,0.296,0.344,0.001,0.111,0.385,0.219,0.211,0.380,-.106,
     c 0.555,0.295,0.343,0.001,0.111,0.385,0.221,0.210,0.380,-.108,
     c 0.551,0.296,0.343,0.001,0.111,0.385,0.223,0.208,0.381,-.113,
     c 0.544,0.299,0.344,-.001,0.109,0.385,0.225,0.206,0.383,-.120,
     c 0.536,0.299,0.343,-.002,0.105,0.383,0.225,0.203,0.384,-.129,
     c 0.529,0.297,0.342,-.003,0.101,0.381,0.225,0.201,0.386,-.136,
     c 0.527,0.294,0.341,-.004,0.098,0.378,0.223,0.199,0.384,-.140,
     c 0.533,0.295,0.342,-.005,0.096,0.376,0.221,0.199,0.379,-.140,
     c 0.543,0.298,0.341,-.005,0.095,0.377,0.220,0.200,0.377,-.136,
     c 0.549,0.302,0.341,-.005,0.097,0.379,0.220,0.201,0.378,-.128,
     c 0.544,0.303,0.339,-.006,0.099,0.381,0.221,0.202,0.381,-.119,
     c 0.536,0.303,0.337,-.006,0.101,0.381,0.221,0.202,0.383,-.114,
     c 0.535,0.302,0.335,-.006,0.104,0.379,0.219,0.202,0.384,-.117,
     c 0.542,0.301,0.334,-.006,0.108,0.376,0.215,0.201,0.382,-.120,
     c 0.550,0.301,0.334,-.005,0.112,0.375,0.212,0.198,0.382,-.118,
     c 0.556,0.302,0.334,-.003,0.116,0.377,0.213,0.195,0.381,-.111,
     c 0.558,0.305,0.334,0.000,0.121,0.379,0.215,0.193,0.381,-.102,
     c 0.558,0.307,0.333,0.003,0.126,0.382,0.217,0.194,0.381,-.095,
     c 0.557,0.307,0.334,0.006,0.131,0.383,0.219,0.195,0.381,-.087,
     c 0.553,0.306,0.335,0.010,0.134,0.384,0.222,0.195,0.381,-.078,
     c 0.548,0.305,0.337,0.015,0.134,0.386,0.224,0.195,0.383,-.069,
     c 0.546,0.307,0.337,0.019,0.133,0.389,0.225,0.195,0.385,-.062,
     c 0.549,0.309,0.337,0.024,0.133,0.392,0.224,0.195,0.386,-.062,
     c 0.556,0.311,0.338,0.029,0.134,0.396,0.222,0.195,0.388,-.066,
     c 0.564,0.311,0.339,0.033,0.134,0.398,0.222,0.196,0.392,-.066,
     c 0.570,0.313,0.342,0.037,0.132,0.399,0.224,0.198,0.396,-.061,
     c 0.574,0.316,0.344,0.040,0.128,0.398,0.228,0.201,0.399,-.055,
     c 0.576,0.319,0.346,0.042,0.124,0.398,0.230,0.203,0.398,-.054,
     c 0.579,0.321,0.347,0.043,0.121,0.399,0.230,0.205,0.396,-.056,
     c 0.581,0.324,0.348,0.045,0.118,0.401,0.232,0.208,0.397,-.058,
     c 0.581,0.327,0.350,0.047,0.115,0.404,0.237,0.213,0.401,-.058,
     c 0.579,0.331,0.353,0.048,0.113,0.408,0.242,0.219,0.408,-.058,
     c 0.575,0.334,0.355,0.049,0.113,0.412,0.244,0.223,0.414,-.058,
     c 0.572,0.335,0.357,0.050,0.112,0.417,0.243,0.223,0.414,-.058,
     c 0.571,0.334,0.358,0.050,0.113,0.421,0.244,0.221,0.414,-.056,
     c 0.572,0.333,0.358,0.052,0.115,0.425,0.247,0.220,0.416,-.052,
     c 0.576,0.334,0.359,0.054,0.117,0.426,0.248,0.223,0.422,-.048,
     c 0.582,0.335,0.360,0.055,0.119,0.426,0.246,0.228,0.425,-.045,
     c 0.588,0.336,0.363,0.056,0.122,0.425,0.244,0.233,0.424,-.046,
     c 0.591,0.336,0.364,0.057,0.126,0.426,0.245,0.235,0.423,-.049,
     c 0.591,0.336,0.364,0.058,0.130,0.428,0.247,0.235,0.422,-.052,
     c 0.591,0.336,0.364,0.059,0.133,0.429,0.249,0.235,0.421,-.053,
     c 0.592,0.336,0.366,0.059,0.134,0.430,0.251,0.236,0.418,-.050,
     c 0.595,0.340,0.369,0.059,0.136,0.432,0.254,0.237,0.415,-.044,
     c 0.598,0.348,0.373,0.058,0.141,0.436,0.258,0.239,0.414,-.039,
     c 0.601,0.357,0.377,0.057,0.147,0.442,0.260,0.239,0.417,-.034,
     c 0.602,0.365,0.379,0.055,0.152,0.447,0.261,0.239,0.422,-.033,
     c 0.603,0.370,0.378,0.049,0.156,0.448,0.262,0.240,0.424,-.036,
     c 0.603,0.377,0.377,0.040,0.160,0.447,0.264,0.241,0.424,-.040,
     c 0.605,0.384,0.376,0.035,0.165,0.448,0.266,0.242,0.426,-.043,
     c 0.556,0.348,0.369,-.022,0.131,0.398,0.239,0.232,0.399,-.046,
     c 0.555,0.338,0.366,-.020,0.129,0.397,0.237,0.231,0.396,-.046,
     c 0.552,0.327,0.364,-.020,0.126,0.399,0.234,0.230,0.393,-.046,
     c 0.552,0.316,0.362,-.017,0.124,0.397,0.232,0.228,0.389,-.049,
     c 0.553,0.308,0.361,-.014,0.123,0.395,0.231,0.225,0.387,-.053,
     c 0.552,0.301,0.358,-.010,0.122,0.392,0.231,0.225,0.387,-.060,
     c 0.547,0.298,0.355,-.007,0.121,0.391,0.230,0.227,0.388,-.067,
     c 0.543,0.298,0.353,-.006,0.121,0.392,0.229,0.227,0.388,-.073,
     c 0.542,0.297,0.351,-.005,0.122,0.393,0.226,0.224,0.385,-.081,
     c 0.545,0.292,0.347,-.005,0.121,0.390,0.222,0.218,0.380,-.092,
     c 0.547,0.287,0.342,-.004,0.119,0.385,0.218,0.211,0.375,-.107,
     c 0.544,0.287,0.338,-.003,0.117,0.383,0.216,0.207,0.372,-.120,
     c 0.541,0.291,0.338,-.001,0.115,0.384,0.216,0.206,0.372,-.129,
     c 0.542,0.294,0.339,0.001,0.113,0.384,0.217,0.206,0.374,-.132,
     c 0.549,0.295,0.341,0.004,0.111,0.384,0.217,0.206,0.376,-.134,
     c 0.557,0.294,0.341,0.007,0.109,0.385,0.218,0.204,0.378,-.134,
     c 0.559,0.292,0.341,0.009,0.109,0.386,0.220,0.204,0.380,-.135,
     c 0.553,0.294,0.342,0.011,0.108,0.386,0.222,0.204,0.381,-.138,
     c 0.544,0.297,0.343,0.010,0.106,0.386,0.224,0.202,0.382,-.144,
     c 0.535,0.298,0.342,0.009,0.102,0.385,0.224,0.200,0.382,-.151,
     c 0.527,0.296,0.340,0.008,0.098,0.382,0.224,0.197,0.383,-.156,
     c 0.525,0.295,0.339,0.007,0.095,0.378,0.223,0.196,0.382,-.158,
     c 0.530,0.298,0.339,0.006,0.094,0.376,0.221,0.196,0.379,-.156,
     c 0.539,0.303,0.339,0.004,0.094,0.376,0.220,0.197,0.377,-.150,
     c 0.543,0.307,0.339,0.002,0.096,0.378,0.220,0.199,0.378,-.141,
     c 0.540,0.307,0.337,0.000,0.098,0.380,0.221,0.201,0.381,-.131,
     c 0.535,0.306,0.335,-.002,0.101,0.381,0.221,0.202,0.383,-.125,
     c 0.535,0.304,0.333,-.003,0.104,0.379,0.219,0.203,0.383,-.124,
     c 0.543,0.303,0.333,-.005,0.108,0.377,0.216,0.202,0.382,-.125,
     c 0.553,0.302,0.333,-.005,0.112,0.377,0.214,0.199,0.382,-.121,
     c 0.557,0.303,0.334,-.005,0.117,0.379,0.214,0.196,0.381,-.113,
     c 0.558,0.305,0.335,-.003,0.122,0.382,0.217,0.195,0.382,-.104,
     c 0.559,0.309,0.335,-.001,0.128,0.385,0.219,0.197,0.382,-.095,
     c 0.558,0.311,0.337,0.002,0.134,0.387,0.222,0.199,0.384,-.087,
     c 0.554,0.312,0.338,0.005,0.137,0.388,0.225,0.201,0.385,-.077,
     c 0.548,0.312,0.340,0.008,0.137,0.389,0.228,0.202,0.388,-.066,
     c 0.544,0.315,0.339,0.012,0.136,0.391,0.229,0.203,0.390,-.057,
     c 0.548,0.317,0.338,0.015,0.135,0.394,0.228,0.204,0.392,-.054,
     c 0.559,0.318,0.338,0.019,0.135,0.396,0.226,0.203,0.394,-.057,
     c 0.571,0.318,0.339,0.023,0.135,0.399,0.225,0.204,0.398,-.057,
     c 0.580,0.319,0.342,0.027,0.133,0.400,0.226,0.205,0.402,-.052,
     c 0.587,0.322,0.345,0.030,0.129,0.401,0.230,0.207,0.404,-.046,
     c 0.591,0.325,0.348,0.033,0.125,0.402,0.232,0.208,0.404,-.046,
     c 0.592,0.327,0.351,0.035,0.122,0.405,0.232,0.210,0.403,-.049,
     c 0.592,0.329,0.353,0.037,0.119,0.407,0.233,0.214,0.403,-.051,
     c 0.589,0.330,0.356,0.039,0.117,0.410,0.238,0.219,0.407,-.050,
     c 0.585,0.332,0.358,0.040,0.115,0.412,0.242,0.225,0.413,-.049,
     c 0.579,0.333,0.360,0.040,0.114,0.415,0.243,0.229,0.416,-.050,
     c 0.575,0.333,0.361,0.040,0.113,0.418,0.242,0.228,0.416,-.052,
     c 0.573,0.331,0.361,0.040,0.113,0.422,0.242,0.225,0.414,-.052,
     c 0.573,0.330,0.361,0.041,0.116,0.426,0.245,0.224,0.415,-.052,
     c 0.576,0.331,0.362,0.043,0.119,0.429,0.247,0.226,0.419,-.050,
     c 0.582,0.333,0.364,0.045,0.123,0.429,0.247,0.231,0.421,-.049,
     c 0.588,0.335,0.366,0.046,0.126,0.429,0.247,0.236,0.422,-.047,
     c 0.590,0.336,0.367,0.047,0.130,0.430,0.248,0.238,0.421,-.047,
     c 0.590,0.337,0.367,0.049,0.134,0.433,0.251,0.239,0.422,-.047,
     c 0.590,0.338,0.367,0.050,0.136,0.434,0.251,0.238,0.421,-.048,
     c 0.593,0.338,0.368,0.051,0.136,0.434,0.252,0.238,0.418,-.045,
     c 0.598,0.342,0.370,0.052,0.137,0.436,0.254,0.239,0.413,-.041,
     c 0.604,0.349,0.374,0.052,0.139,0.440,0.256,0.239,0.411,-.036,
     c 0.606,0.357,0.378,0.051,0.143,0.446,0.258,0.239,0.414,-.034,
     c 0.606,0.363,0.381,0.050,0.148,0.450,0.260,0.241,0.421,-.034,
     c 0.605,0.367,0.381,0.046,0.153,0.452,0.263,0.244,0.426,-.036,
     c 0.603,0.374,0.380,0.038,0.158,0.452,0.267,0.245,0.427,-.043,
     c 0.604,0.380,0.379,0.035,0.163,0.453,0.271,0.246,0.430,-.046,
     c 0.548,0.343,0.359,-.026,0.126,0.391,0.232,0.222,0.390,-.062,
     c 0.546,0.333,0.357,-.024,0.126,0.390,0.231,0.221,0.388,-.062,
     c 0.541,0.322,0.355,-.024,0.122,0.391,0.227,0.221,0.385,-.063,
     c 0.539,0.312,0.354,-.022,0.121,0.389,0.226,0.221,0.383,-.064,
     c 0.541,0.305,0.353,-.018,0.122,0.387,0.225,0.219,0.382,-.066,
     c 0.541,0.299,0.350,-.014,0.122,0.385,0.224,0.219,0.384,-.069,
     c 0.539,0.298,0.347,-.011,0.123,0.385,0.224,0.222,0.386,-.073,
     c 0.537,0.298,0.346,-.009,0.123,0.387,0.222,0.223,0.386,-.079,
     c 0.537,0.297,0.344,-.008,0.123,0.388,0.220,0.220,0.382,-.090,
     c 0.539,0.290,0.340,-.007,0.121,0.385,0.218,0.214,0.377,-.105,
     c 0.539,0.285,0.334,-.007,0.117,0.381,0.215,0.208,0.372,-.122,
     c 0.538,0.285,0.331,-.005,0.114,0.379,0.215,0.204,0.370,-.136,
     c 0.537,0.289,0.331,-.002,0.112,0.380,0.215,0.202,0.371,-.144,
     c 0.542,0.294,0.334,0.002,0.111,0.381,0.217,0.201,0.373,-.148,
     c 0.551,0.295,0.337,0.006,0.110,0.382,0.218,0.200,0.375,-.150,
     c 0.560,0.294,0.338,0.011,0.108,0.383,0.219,0.199,0.377,-.152,
     c 0.562,0.293,0.339,0.015,0.107,0.385,0.220,0.199,0.379,-.152,
     c 0.557,0.295,0.340,0.018,0.106,0.386,0.222,0.200,0.380,-.154,
     c 0.548,0.299,0.341,0.019,0.104,0.386,0.223,0.199,0.381,-.160,
     c 0.538,0.301,0.339,0.019,0.101,0.384,0.224,0.197,0.380,-.166,
     c 0.529,0.301,0.337,0.019,0.098,0.381,0.225,0.195,0.381,-.169,
     c 0.527,0.301,0.336,0.018,0.096,0.378,0.224,0.194,0.381,-.168,
     c 0.530,0.305,0.336,0.016,0.095,0.376,0.223,0.194,0.380,-.164,
     c 0.536,0.311,0.337,0.014,0.096,0.376,0.222,0.196,0.378,-.157,
     c 0.540,0.315,0.337,0.010,0.099,0.378,0.221,0.197,0.379,-.149,
     c 0.538,0.316,0.336,0.007,0.101,0.380,0.221,0.198,0.380,-.140,
     c 0.536,0.314,0.334,0.004,0.104,0.381,0.221,0.199,0.381,-.135,
     c 0.539,0.312,0.332,0.000,0.107,0.380,0.219,0.200,0.381,-.133,
     c 0.548,0.310,0.332,-.003,0.111,0.379,0.218,0.200,0.381,-.131,
     c 0.557,0.309,0.334,-.005,0.115,0.380,0.217,0.199,0.382,-.125,
     c 0.561,0.308,0.336,-.007,0.120,0.383,0.218,0.196,0.382,-.115,
     c 0.561,0.309,0.337,-.007,0.126,0.387,0.221,0.196,0.384,-.106,
     c 0.562,0.313,0.338,-.005,0.133,0.391,0.223,0.199,0.385,-.096,
     c 0.563,0.317,0.339,-.003,0.138,0.393,0.226,0.203,0.388,-.087,
     c 0.560,0.320,0.341,-.002,0.141,0.394,0.228,0.205,0.390,-.077,
     c 0.553,0.322,0.342,0.000,0.142,0.395,0.230,0.208,0.392,-.066,
     c 0.550,0.325,0.341,0.001,0.140,0.396,0.231,0.209,0.394,-.056,
     c 0.555,0.327,0.339,0.003,0.139,0.397,0.231,0.210,0.396,-.052,
     c 0.568,0.327,0.338,0.006,0.139,0.398,0.229,0.210,0.400,-.052,
     c 0.582,0.325,0.339,0.009,0.138,0.399,0.227,0.210,0.404,-.051,
     c 0.592,0.325,0.342,0.013,0.136,0.401,0.229,0.211,0.408,-.046,
     c 0.599,0.328,0.345,0.016,0.132,0.404,0.232,0.212,0.410,-.041,
     c 0.602,0.331,0.349,0.019,0.129,0.407,0.233,0.213,0.410,-.041,
     c 0.603,0.332,0.352,0.021,0.126,0.412,0.234,0.215,0.410,-.044,
     c 0.602,0.333,0.357,0.024,0.124,0.415,0.235,0.218,0.411,-.044,
     c 0.597,0.333,0.361,0.025,0.122,0.417,0.238,0.223,0.414,-.041,
     c 0.591,0.333,0.363,0.026,0.121,0.417,0.241,0.228,0.418,-.040,
     c 0.586,0.333,0.365,0.027,0.119,0.418,0.241,0.231,0.419,-.042,
     c 0.582,0.331,0.364,0.026,0.117,0.419,0.240,0.229,0.417,-.045,
     c 0.580,0.328,0.364,0.026,0.117,0.423,0.241,0.226,0.414,-.049,
     c 0.580,0.326,0.363,0.027,0.118,0.427,0.243,0.224,0.414,-.052,
     c 0.583,0.327,0.363,0.029,0.122,0.430,0.246,0.226,0.416,-.053,
     c 0.589,0.330,0.365,0.030,0.126,0.432,0.247,0.231,0.417,-.052,
     c 0.593,0.334,0.368,0.031,0.130,0.432,0.249,0.235,0.418,-.048,
     c 0.594,0.337,0.371,0.033,0.134,0.434,0.251,0.238,0.419,-.045,
     c 0.592,0.340,0.372,0.035,0.138,0.438,0.253,0.240,0.422,-.043,
     c 0.592,0.342,0.372,0.037,0.139,0.439,0.253,0.240,0.423,-.042,
     c 0.595,0.343,0.372,0.038,0.139,0.439,0.252,0.240,0.420,-.039,
     c 0.600,0.346,0.374,0.040,0.138,0.440,0.253,0.240,0.415,-.035,
     c 0.604,0.352,0.377,0.041,0.138,0.443,0.255,0.240,0.413,-.032,
     c 0.605,0.358,0.380,0.042,0.141,0.449,0.256,0.241,0.416,-.032,
     c 0.605,0.362,0.383,0.042,0.146,0.453,0.259,0.244,0.423,-.034,
     c 0.604,0.367,0.383,0.040,0.152,0.455,0.264,0.248,0.429,-.038,
     c 0.602,0.374,0.382,0.034,0.158,0.454,0.270,0.247,0.430,-.046,
     c 0.601,0.379,0.383,0.032,0.163,0.456,0.274,0.250,0.434,-.051,
     c 0.540,0.337,0.352,-.027,0.123,0.386,0.227,0.214,0.383,-.078,
     c 0.539,0.329,0.350,-.025,0.124,0.385,0.226,0.214,0.382,-.077,
     c 0.532,0.320,0.347,-.025,0.122,0.382,0.224,0.216,0.380,-.077,
     c 0.530,0.311,0.345,-.023,0.122,0.381,0.222,0.216,0.379,-.076,
     c 0.532,0.305,0.344,-.020,0.125,0.380,0.221,0.214,0.379,-.073,
     c 0.533,0.301,0.342,-.016,0.127,0.379,0.221,0.214,0.382,-.073,
     c 0.533,0.302,0.340,-.013,0.129,0.380,0.220,0.216,0.384,-.075,
     c 0.531,0.303,0.339,-.010,0.130,0.382,0.219,0.218,0.384,-.083,
     c 0.530,0.301,0.338,-.009,0.129,0.384,0.218,0.215,0.381,-.095,
     c 0.530,0.295,0.334,-.009,0.126,0.382,0.218,0.211,0.375,-.113,
     c 0.529,0.290,0.329,-.008,0.120,0.379,0.218,0.206,0.371,-.130,
     c 0.529,0.290,0.326,-.005,0.117,0.378,0.219,0.204,0.370,-.142,
     c 0.531,0.294,0.327,-.002,0.115,0.379,0.220,0.202,0.372,-.149,
     c 0.539,0.298,0.331,0.002,0.113,0.380,0.221,0.200,0.374,-.153,
     c 0.549,0.300,0.335,0.008,0.111,0.381,0.222,0.197,0.375,-.155,
     c 0.557,0.299,0.337,0.014,0.108,0.381,0.222,0.195,0.377,-.158,
     c 0.560,0.299,0.338,0.019,0.106,0.383,0.222,0.196,0.379,-.159,
     c 0.556,0.302,0.339,0.023,0.105,0.385,0.223,0.198,0.379,-.162,
     c 0.549,0.308,0.339,0.026,0.103,0.385,0.224,0.198,0.379,-.168,
     c 0.540,0.311,0.338,0.027,0.101,0.384,0.226,0.196,0.378,-.173,
     c 0.533,0.311,0.335,0.028,0.099,0.382,0.227,0.195,0.379,-.174,
     c 0.531,0.312,0.334,0.027,0.099,0.380,0.228,0.195,0.381,-.170,
     c 0.535,0.317,0.335,0.026,0.099,0.380,0.227,0.196,0.382,-.165,
     c 0.541,0.324,0.336,0.023,0.101,0.380,0.227,0.196,0.382,-.160,
     c 0.544,0.328,0.337,0.019,0.104,0.382,0.226,0.197,0.382,-.154,
     c 0.544,0.328,0.336,0.014,0.108,0.384,0.226,0.196,0.381,-.147,
     c 0.545,0.326,0.335,0.009,0.111,0.384,0.225,0.196,0.381,-.143,
     c 0.549,0.325,0.334,0.004,0.114,0.384,0.223,0.197,0.381,-.141,
     c 0.557,0.324,0.335,-.001,0.117,0.384,0.222,0.198,0.382,-.137,
     c 0.565,0.322,0.337,-.005,0.121,0.386,0.222,0.198,0.383,-.129,
     c 0.567,0.319,0.339,-.008,0.126,0.390,0.224,0.196,0.385,-.119,
     c 0.566,0.318,0.340,-.010,0.132,0.394,0.226,0.197,0.387,-.109,
     c 0.566,0.321,0.341,-.010,0.138,0.398,0.229,0.201,0.389,-.099,
     c 0.567,0.325,0.341,-.010,0.143,0.400,0.230,0.205,0.392,-.091,
     c 0.565,0.328,0.343,-.010,0.146,0.402,0.231,0.208,0.394,-.082,
     c 0.559,0.331,0.345,-.011,0.146,0.403,0.232,0.210,0.396,-.072,
     c 0.557,0.334,0.344,-.011,0.145,0.403,0.233,0.212,0.397,-.062,
     c 0.564,0.336,0.342,-.011,0.144,0.403,0.233,0.214,0.400,-.055,
     c 0.578,0.335,0.341,-.009,0.144,0.403,0.232,0.214,0.403,-.053,
     c 0.591,0.333,0.342,-.007,0.144,0.405,0.231,0.215,0.408,-.050,
     c 0.599,0.334,0.345,-.003,0.142,0.406,0.232,0.216,0.411,-.045,
     c 0.603,0.336,0.349,-.000,0.139,0.410,0.235,0.217,0.413,-.040,
     c 0.605,0.338,0.352,0.003,0.136,0.415,0.237,0.218,0.413,-.040,
     c 0.605,0.339,0.356,0.005,0.133,0.420,0.237,0.220,0.414,-.040,
     c 0.605,0.338,0.361,0.008,0.132,0.423,0.238,0.223,0.416,-.038,
     c 0.602,0.338,0.366,0.010,0.131,0.424,0.240,0.227,0.419,-.034,
     c 0.597,0.338,0.369,0.011,0.130,0.423,0.241,0.230,0.421,-.031,
     c 0.592,0.336,0.369,0.011,0.128,0.422,0.241,0.231,0.422,-.033,
     c 0.589,0.332,0.368,0.011,0.126,0.423,0.240,0.229,0.419,-.037,
     c 0.588,0.329,0.367,0.011,0.124,0.426,0.241,0.226,0.417,-.041,
     c 0.589,0.327,0.366,0.012,0.125,0.431,0.244,0.225,0.415,-.046,
     c 0.594,0.329,0.365,0.013,0.128,0.435,0.247,0.227,0.416,-.048,
     c 0.599,0.332,0.367,0.014,0.131,0.436,0.249,0.231,0.416,-.047,
     c 0.602,0.336,0.370,0.015,0.134,0.437,0.251,0.236,0.417,-.041,
     c 0.601,0.341,0.374,0.017,0.138,0.439,0.254,0.239,0.419,-.036,
     c 0.597,0.344,0.377,0.019,0.141,0.443,0.256,0.241,0.424,-.034,
     c 0.595,0.347,0.378,0.021,0.143,0.445,0.256,0.241,0.426,-.033,
     c 0.596,0.348,0.378,0.024,0.142,0.445,0.255,0.242,0.425,-.031,
     c 0.598,0.350,0.379,0.027,0.140,0.445,0.256,0.242,0.422,-.027,
     c 0.600,0.354,0.381,0.029,0.140,0.448,0.257,0.242,0.420,-.027,
     c 0.600,0.358,0.383,0.031,0.142,0.452,0.258,0.243,0.422,-.030,
     c 0.600,0.363,0.385,0.032,0.147,0.456,0.262,0.246,0.427,-.037,
     c 0.599,0.368,0.385,0.031,0.152,0.457,0.267,0.251,0.432,-.043,
     c 0.599,0.375,0.385,0.029,0.158,0.457,0.273,0.250,0.433,-.050,
     c 0.598,0.381,0.386,0.029,0.163,0.458,0.277,0.253,0.437,-.057,
     c 0.533,0.329,0.344,-.026,0.121,0.381,0.224,0.206,0.377,-.091,
     c 0.533,0.323,0.343,-.025,0.123,0.380,0.223,0.207,0.377,-.090,
     c 0.527,0.315,0.338,-.025,0.122,0.376,0.222,0.209,0.375,-.089,
     c 0.527,0.309,0.337,-.023,0.125,0.375,0.221,0.208,0.375,-.087,
     c 0.529,0.305,0.335,-.021,0.130,0.374,0.220,0.206,0.375,-.083,
     c 0.531,0.304,0.334,-.017,0.134,0.375,0.220,0.204,0.378,-.081,
     c 0.530,0.306,0.332,-.014,0.136,0.376,0.221,0.205,0.381,-.082,
     c 0.528,0.308,0.333,-.012,0.138,0.379,0.220,0.207,0.381,-.089,
     c 0.526,0.305,0.333,-.011,0.136,0.380,0.220,0.207,0.378,-.103,
     c 0.524,0.300,0.330,-.010,0.133,0.379,0.220,0.204,0.373,-.120,
     c 0.522,0.296,0.325,-.009,0.127,0.377,0.222,0.202,0.370,-.135,
     c 0.521,0.297,0.323,-.007,0.123,0.376,0.223,0.202,0.371,-.145,
     c 0.525,0.300,0.325,-.003,0.121,0.378,0.224,0.201,0.374,-.149,
     c 0.533,0.304,0.330,0.002,0.118,0.379,0.224,0.198,0.375,-.152,
     c 0.543,0.305,0.334,0.007,0.113,0.379,0.224,0.193,0.375,-.156,
     c 0.550,0.305,0.335,0.014,0.109,0.379,0.224,0.191,0.375,-.159,
     c 0.552,0.306,0.336,0.020,0.105,0.380,0.223,0.191,0.376,-.161,
     c 0.550,0.309,0.336,0.024,0.102,0.382,0.223,0.193,0.376,-.165,
     c 0.546,0.315,0.336,0.028,0.101,0.383,0.224,0.194,0.375,-.171,
     c 0.540,0.319,0.335,0.031,0.100,0.383,0.226,0.193,0.374,-.175,
     c 0.536,0.320,0.334,0.032,0.100,0.383,0.228,0.194,0.377,-.175,
     c 0.537,0.322,0.333,0.032,0.101,0.383,0.229,0.194,0.381,-.170,
     c 0.543,0.327,0.334,0.031,0.103,0.384,0.230,0.196,0.384,-.166,
     c 0.550,0.333,0.337,0.029,0.106,0.386,0.231,0.196,0.385,-.163,
     c 0.554,0.338,0.338,0.024,0.110,0.387,0.232,0.195,0.384,-.159,
     c 0.555,0.338,0.338,0.019,0.114,0.389,0.231,0.193,0.384,-.154,
     c 0.556,0.337,0.337,0.013,0.118,0.389,0.230,0.193,0.383,-.151,
     c 0.560,0.336,0.337,0.007,0.120,0.388,0.229,0.194,0.384,-.149,
     c 0.567,0.336,0.339,0.001,0.123,0.389,0.228,0.196,0.385,-.144,
     c 0.573,0.334,0.341,-.005,0.126,0.391,0.229,0.195,0.387,-.135,
     c 0.573,0.329,0.343,-.011,0.131,0.395,0.230,0.194,0.389,-.125,
     c 0.570,0.327,0.343,-.014,0.136,0.399,0.232,0.195,0.391,-.115,
     c 0.568,0.327,0.343,-.017,0.141,0.402,0.233,0.199,0.393,-.107,
     c 0.568,0.330,0.343,-.019,0.145,0.405,0.233,0.204,0.395,-.100,
     c 0.566,0.333,0.345,-.020,0.148,0.407,0.233,0.208,0.397,-.092,
     c 0.562,0.336,0.347,-.022,0.149,0.409,0.233,0.211,0.398,-.083,
     c 0.562,0.339,0.347,-.024,0.148,0.409,0.234,0.213,0.398,-.073,
     c 0.571,0.341,0.346,-.024,0.148,0.409,0.235,0.214,0.400,-.066,
     c 0.585,0.340,0.346,-.024,0.148,0.410,0.235,0.215,0.404,-.060,
     c 0.596,0.338,0.348,-.022,0.148,0.411,0.235,0.216,0.408,-.055,
     c 0.600,0.338,0.351,-.020,0.147,0.413,0.236,0.218,0.411,-.050,
     c 0.600,0.341,0.355,-.017,0.145,0.416,0.239,0.219,0.412,-.045,
     c 0.599,0.344,0.358,-.014,0.143,0.421,0.240,0.221,0.413,-.043,
     c 0.600,0.344,0.361,-.011,0.141,0.426,0.241,0.223,0.414,-.042,
     c 0.602,0.344,0.365,-.009,0.141,0.429,0.242,0.226,0.416,-.037,
     c 0.602,0.344,0.369,-.007,0.140,0.429,0.243,0.229,0.419,-.031,
     c 0.599,0.344,0.371,-.005,0.139,0.426,0.242,0.231,0.421,-.027,
     c 0.595,0.341,0.371,-.005,0.137,0.425,0.241,0.232,0.421,-.027,
     c 0.593,0.336,0.370,-.004,0.134,0.426,0.240,0.229,0.420,-.029,
     c 0.593,0.332,0.369,-.004,0.133,0.430,0.241,0.227,0.418,-.031,
     c 0.596,0.331,0.368,-.003,0.133,0.435,0.243,0.225,0.418,-.035,
     c 0.602,0.333,0.367,-.002,0.135,0.438,0.247,0.227,0.418,-.036,
     c 0.607,0.336,0.369,-.001,0.137,0.439,0.249,0.231,0.417,-.035,
     c 0.609,0.339,0.372,-.000,0.139,0.440,0.252,0.235,0.417,-.029,
     c 0.607,0.343,0.376,-.000,0.142,0.442,0.254,0.238,0.420,-.025,
     c 0.602,0.347,0.379,0.002,0.144,0.446,0.257,0.240,0.426,-.025,
     c 0.597,0.349,0.381,0.005,0.145,0.448,0.258,0.241,0.430,-.026,
     c 0.595,0.350,0.382,0.008,0.145,0.449,0.258,0.241,0.430,-.026,
     c 0.595,0.351,0.383,0.011,0.143,0.449,0.260,0.241,0.428,-.023,
     c 0.595,0.353,0.384,0.014,0.142,0.451,0.262,0.241,0.426,-.024,
     c 0.595,0.356,0.385,0.017,0.144,0.453,0.263,0.241,0.427,-.031,
     c 0.596,0.361,0.385,0.019,0.147,0.456,0.266,0.244,0.431,-.042,
     c 0.595,0.367,0.385,0.020,0.152,0.457,0.270,0.248,0.433,-.050,
     c 0.594,0.374,0.387,0.021,0.157,0.456,0.274,0.249,0.434,-.056,
     c 0.593,0.381,0.388,0.023,0.161,0.457,0.278,0.253,0.437,-.063,
     c 0.526,0.322,0.338,-.024,0.119,0.377,0.221,0.202,0.374,-.100,
     c 0.527,0.318,0.337,-.023,0.122,0.376,0.221,0.201,0.373,-.100,
     c 0.527,0.313,0.333,-.023,0.126,0.373,0.221,0.202,0.372,-.101,
     c 0.528,0.310,0.332,-.022,0.130,0.372,0.220,0.200,0.371,-.101,
     c 0.532,0.308,0.331,-.020,0.136,0.373,0.220,0.196,0.372,-.098,
     c 0.533,0.309,0.330,-.017,0.140,0.374,0.221,0.194,0.374,-.095,
     c 0.532,0.312,0.329,-.015,0.143,0.376,0.222,0.196,0.377,-.095,
     c 0.529,0.313,0.330,-.013,0.145,0.378,0.222,0.198,0.378,-.101,
     c 0.525,0.310,0.331,-.012,0.145,0.379,0.222,0.200,0.376,-.112,
     c 0.522,0.306,0.329,-.011,0.141,0.377,0.223,0.198,0.372,-.127,
     c 0.520,0.304,0.326,-.010,0.137,0.376,0.224,0.198,0.371,-.139,
     c 0.519,0.305,0.324,-.007,0.133,0.376,0.225,0.199,0.373,-.145,
     c 0.523,0.308,0.326,-.003,0.129,0.378,0.225,0.199,0.377,-.148,
     c 0.531,0.310,0.329,0.002,0.125,0.378,0.224,0.196,0.377,-.150,
     c 0.539,0.311,0.333,0.007,0.118,0.378,0.224,0.191,0.376,-.153,
     c 0.543,0.311,0.334,0.013,0.111,0.377,0.223,0.187,0.375,-.156,
     c 0.543,0.312,0.334,0.019,0.106,0.377,0.222,0.187,0.375,-.159,
     c 0.541,0.316,0.334,0.024,0.102,0.379,0.222,0.188,0.374,-.164,
     c 0.539,0.321,0.334,0.028,0.101,0.381,0.223,0.190,0.372,-.170,
     c 0.536,0.326,0.334,0.031,0.101,0.383,0.224,0.191,0.372,-.173,
     c 0.536,0.327,0.334,0.033,0.102,0.384,0.227,0.193,0.375,-.172,
     c 0.540,0.329,0.334,0.034,0.104,0.386,0.229,0.194,0.380,-.169,
     c 0.548,0.333,0.335,0.034,0.107,0.388,0.230,0.196,0.385,-.168,
     c 0.555,0.339,0.338,0.031,0.110,0.390,0.232,0.196,0.386,-.167,
     c 0.559,0.343,0.340,0.027,0.114,0.392,0.234,0.195,0.387,-.165,
     c 0.561,0.344,0.340,0.022,0.119,0.393,0.235,0.195,0.387,-.161,
     c 0.563,0.344,0.340,0.016,0.122,0.393,0.234,0.195,0.388,-.158,
     c 0.566,0.344,0.340,0.009,0.124,0.392,0.234,0.196,0.389,-.156,
     c 0.571,0.345,0.342,0.001,0.126,0.393,0.233,0.197,0.390,-.152,
     c 0.577,0.344,0.345,-.006,0.129,0.395,0.234,0.197,0.392,-.144,
     c 0.578,0.340,0.347,-.013,0.133,0.399,0.235,0.196,0.394,-.134,
     c 0.575,0.336,0.348,-.018,0.138,0.402,0.236,0.197,0.396,-.124,
     c 0.572,0.335,0.347,-.022,0.142,0.405,0.236,0.201,0.398,-.116,
     c 0.570,0.336,0.346,-.025,0.146,0.408,0.235,0.207,0.400,-.110,
     c 0.568,0.337,0.347,-.028,0.149,0.411,0.234,0.212,0.402,-.104,
     c 0.566,0.340,0.350,-.031,0.151,0.412,0.235,0.215,0.403,-.096,
     c 0.568,0.343,0.352,-.033,0.152,0.414,0.236,0.217,0.403,-.086,
     c 0.577,0.345,0.352,-.035,0.152,0.415,0.237,0.218,0.403,-.077,
     c 0.590,0.344,0.353,-.035,0.152,0.416,0.238,0.218,0.406,-.070,
     c 0.598,0.342,0.356,-.035,0.153,0.417,0.239,0.220,0.409,-.062,
     c 0.597,0.342,0.359,-.033,0.152,0.419,0.240,0.222,0.411,-.056,
     c 0.593,0.345,0.362,-.031,0.151,0.421,0.242,0.224,0.412,-.052,
     c 0.590,0.349,0.364,-.029,0.150,0.426,0.243,0.225,0.412,-.049,
     c 0.591,0.350,0.365,-.026,0.149,0.430,0.244,0.226,0.413,-.045,
     c 0.595,0.351,0.368,-.023,0.148,0.432,0.245,0.229,0.416,-.040,
     c 0.598,0.352,0.370,-.021,0.147,0.432,0.246,0.232,0.418,-.034,
     c 0.597,0.351,0.372,-.019,0.146,0.429,0.245,0.234,0.419,-.029,
     c 0.594,0.347,0.372,-.018,0.144,0.427,0.242,0.234,0.419,-.025,
     c 0.591,0.342,0.372,-.017,0.141,0.429,0.241,0.232,0.419,-.023,
     c 0.591,0.338,0.372,-.016,0.140,0.433,0.242,0.230,0.420,-.022,
     c 0.596,0.338,0.372,-.015,0.141,0.438,0.244,0.229,0.421,-.023,
     c 0.602,0.340,0.371,-.015,0.142,0.441,0.246,0.230,0.421,-.024,
     c 0.608,0.342,0.371,-.015,0.143,0.441,0.249,0.233,0.420,-.022,
     c 0.610,0.344,0.373,-.015,0.143,0.441,0.251,0.236,0.419,-.018,
     c 0.607,0.346,0.377,-.014,0.145,0.443,0.254,0.238,0.422,-.017,
     c 0.603,0.349,0.380,-.013,0.147,0.447,0.257,0.240,0.427,-.020,
     c 0.598,0.351,0.381,-.011,0.149,0.450,0.259,0.241,0.431,-.024,
     c 0.594,0.351,0.382,-.008,0.148,0.451,0.262,0.241,0.432,-.025,
     c 0.591,0.350,0.383,-.005,0.147,0.450,0.264,0.240,0.431,-.023,
     c 0.591,0.351,0.385,-.001,0.146,0.451,0.266,0.239,0.430,-.024,
     c 0.593,0.354,0.385,0.002,0.147,0.453,0.267,0.239,0.430,-.032,
     c 0.594,0.359,0.385,0.004,0.149,0.454,0.269,0.241,0.432,-.045,
     c 0.593,0.367,0.386,0.008,0.152,0.455,0.271,0.245,0.434,-.055,
     c 0.591,0.375,0.389,0.013,0.157,0.454,0.273,0.249,0.434,-.059,
     c 0.589,0.382,0.390,0.016,0.160,0.455,0.276,0.252,0.436,-.069,
     c 0.522,0.317,0.334,-.021,0.117,0.376,0.219,0.199,0.372,-.105,
     c 0.524,0.315,0.333,-.021,0.122,0.375,0.220,0.197,0.372,-.105,
     c 0.527,0.313,0.331,-.020,0.128,0.373,0.221,0.196,0.371,-.110,
     c 0.531,0.312,0.330,-.020,0.134,0.372,0.221,0.193,0.370,-.113,
     c 0.535,0.311,0.330,-.019,0.140,0.372,0.221,0.189,0.370,-.112,
     c 0.536,0.313,0.329,-.017,0.145,0.373,0.222,0.187,0.372,-.109,
     c 0.535,0.315,0.329,-.015,0.148,0.376,0.224,0.190,0.375,-.108,
     c 0.531,0.316,0.331,-.014,0.151,0.377,0.225,0.194,0.377,-.112,
     c 0.528,0.314,0.331,-.013,0.152,0.378,0.224,0.195,0.375,-.121,
     c 0.525,0.311,0.330,-.012,0.149,0.376,0.225,0.194,0.371,-.133,
     c 0.522,0.310,0.327,-.010,0.144,0.375,0.225,0.194,0.371,-.141,
     c 0.522,0.311,0.326,-.007,0.140,0.376,0.226,0.195,0.374,-.145,
     c 0.526,0.312,0.327,-.002,0.136,0.378,0.226,0.196,0.378,-.146,
     c 0.533,0.314,0.329,0.002,0.131,0.379,0.225,0.193,0.380,-.147,
     c 0.539,0.314,0.331,0.007,0.123,0.378,0.223,0.189,0.379,-.149,
     c 0.540,0.314,0.331,0.013,0.115,0.377,0.223,0.185,0.377,-.153,
     c 0.538,0.315,0.330,0.018,0.109,0.377,0.223,0.183,0.376,-.157,
     c 0.535,0.319,0.330,0.022,0.106,0.379,0.223,0.184,0.374,-.162,
     c 0.533,0.325,0.331,0.026,0.104,0.381,0.224,0.186,0.372,-.167,
     c 0.531,0.329,0.332,0.029,0.104,0.384,0.226,0.189,0.372,-.169,
     c 0.533,0.331,0.333,0.032,0.105,0.386,0.227,0.191,0.375,-.168,
     c 0.539,0.332,0.334,0.033,0.107,0.388,0.228,0.193,0.380,-.168,
     c 0.547,0.336,0.336,0.033,0.110,0.391,0.229,0.194,0.385,-.169,
     c 0.554,0.340,0.339,0.031,0.112,0.392,0.231,0.195,0.387,-.173,
     c 0.558,0.344,0.341,0.028,0.115,0.393,0.234,0.196,0.388,-.172,
     c 0.560,0.345,0.343,0.022,0.120,0.395,0.237,0.198,0.391,-.169,
     c 0.561,0.346,0.343,0.016,0.123,0.395,0.238,0.199,0.393,-.165,
     c 0.564,0.348,0.344,0.009,0.125,0.395,0.238,0.201,0.394,-.164,
     c 0.570,0.350,0.346,0.001,0.126,0.395,0.237,0.202,0.394,-.160,
     c 0.576,0.350,0.349,-.007,0.129,0.397,0.238,0.201,0.396,-.154,
     c 0.580,0.347,0.352,-.014,0.134,0.401,0.239,0.200,0.399,-.144,
     c 0.580,0.344,0.353,-.020,0.138,0.404,0.239,0.201,0.401,-.134,
     c 0.578,0.343,0.352,-.025,0.141,0.407,0.238,0.205,0.403,-.126,
     c 0.577,0.342,0.351,-.029,0.145,0.410,0.238,0.212,0.406,-.121,
     c 0.575,0.342,0.352,-.032,0.149,0.413,0.239,0.218,0.408,-.115,
     c 0.573,0.344,0.354,-.035,0.152,0.415,0.240,0.221,0.409,-.108,
     c 0.574,0.346,0.356,-.038,0.154,0.417,0.241,0.222,0.408,-.099,
     c 0.582,0.348,0.358,-.040,0.155,0.419,0.242,0.222,0.408,-.089,
     c 0.591,0.346,0.359,-.041,0.155,0.420,0.242,0.222,0.409,-.079,
     c 0.596,0.343,0.362,-.042,0.156,0.421,0.243,0.224,0.411,-.070,
     c 0.592,0.344,0.366,-.041,0.155,0.423,0.244,0.226,0.412,-.062,
     c 0.585,0.348,0.368,-.040,0.155,0.426,0.246,0.228,0.413,-.058,
     c 0.581,0.352,0.368,-.038,0.155,0.429,0.246,0.229,0.413,-.055,
     c 0.583,0.355,0.369,-.036,0.154,0.433,0.248,0.231,0.414,-.051,
     c 0.588,0.356,0.370,-.033,0.153,0.435,0.250,0.233,0.416,-.045,
     c 0.593,0.357,0.372,-.030,0.152,0.434,0.251,0.235,0.417,-.040,
     c 0.593,0.356,0.373,-.028,0.150,0.432,0.250,0.237,0.418,-.034,
     c 0.590,0.352,0.374,-.026,0.148,0.431,0.248,0.237,0.418,-.028,
     c 0.587,0.348,0.375,-.025,0.146,0.433,0.247,0.235,0.418,-.022,
     c 0.588,0.345,0.376,-.024,0.145,0.437,0.247,0.233,0.420,-.018,
     c 0.593,0.347,0.376,-.024,0.145,0.441,0.248,0.232,0.422,-.017,
     c 0.600,0.349,0.375,-.025,0.146,0.442,0.250,0.233,0.423,-.016,
     c 0.605,0.349,0.374,-.026,0.146,0.441,0.252,0.235,0.422,-.015,
     c 0.607,0.350,0.375,-.027,0.147,0.441,0.254,0.237,0.421,-.013,
     c 0.605,0.351,0.376,-.028,0.148,0.443,0.256,0.239,0.423,-.014,
     c 0.602,0.353,0.378,-.027,0.150,0.447,0.258,0.240,0.427,-.018,
     c 0.596,0.354,0.380,-.026,0.152,0.450,0.261,0.241,0.431,-.024,
     c 0.592,0.353,0.381,-.023,0.153,0.451,0.264,0.241,0.432,-.025,
     c 0.589,0.351,0.383,-.020,0.152,0.450,0.267,0.239,0.432,-.022,
     c 0.589,0.351,0.385,-.016,0.151,0.450,0.270,0.238,0.431,-.021,
     c 0.592,0.353,0.386,-.013,0.151,0.451,0.270,0.237,0.431,-.028,
     c 0.593,0.359,0.386,-.009,0.152,0.451,0.271,0.238,0.432,-.041,
     c 0.591,0.367,0.387,-.003,0.153,0.452,0.272,0.242,0.433,-.054,
     c 0.587,0.376,0.391,0.005,0.157,0.452,0.273,0.247,0.434,-.061,
     c 0.585,0.383,0.392,0.011,0.159,0.452,0.274,0.251,0.436,-.073,
     c 0.517,0.311,0.330,-.018,0.116,0.375,0.218,0.196,0.371,-.107,
     c 0.520,0.311,0.330,-.017,0.121,0.374,0.219,0.195,0.371,-.108,
     c 0.526,0.313,0.329,-.017,0.130,0.373,0.220,0.192,0.371,-.113,
     c 0.529,0.313,0.329,-.017,0.136,0.372,0.220,0.189,0.371,-.117,
     c 0.533,0.313,0.330,-.017,0.141,0.372,0.220,0.187,0.371,-.117,
     c 0.535,0.314,0.330,-.016,0.145,0.373,0.223,0.187,0.373,-.116,
     c 0.535,0.316,0.330,-.015,0.149,0.375,0.225,0.191,0.377,-.115,
     c 0.533,0.317,0.331,-.013,0.152,0.378,0.226,0.195,0.379,-.118,
     c 0.529,0.316,0.332,-.012,0.154,0.378,0.226,0.196,0.376,-.126,
     c 0.526,0.315,0.330,-.011,0.152,0.377,0.226,0.193,0.372,-.135,
     c 0.525,0.315,0.329,-.009,0.148,0.376,0.226,0.190,0.370,-.142,
     c 0.526,0.316,0.328,-.006,0.143,0.377,0.226,0.191,0.373,-.144,
     c 0.530,0.316,0.328,-.001,0.139,0.379,0.225,0.192,0.377,-.143,
     c 0.535,0.316,0.329,0.003,0.133,0.380,0.224,0.192,0.380,-.144,
     c 0.539,0.316,0.329,0.008,0.126,0.380,0.223,0.188,0.380,-.147,
     c 0.539,0.317,0.329,0.012,0.119,0.378,0.223,0.184,0.380,-.151,
     c 0.536,0.318,0.327,0.016,0.114,0.379,0.224,0.181,0.378,-.157,
     c 0.532,0.322,0.327,0.020,0.111,0.380,0.225,0.180,0.376,-.161,
     c 0.529,0.327,0.328,0.023,0.109,0.383,0.226,0.183,0.374,-.165,
     c 0.528,0.330,0.330,0.026,0.109,0.385,0.227,0.186,0.374,-.166,
     c 0.529,0.332,0.332,0.029,0.109,0.387,0.228,0.190,0.377,-.165,
     c 0.535,0.334,0.333,0.030,0.111,0.390,0.228,0.191,0.381,-.165,
     c 0.542,0.337,0.335,0.030,0.111,0.391,0.227,0.192,0.385,-.169,
     c 0.548,0.339,0.338,0.029,0.112,0.392,0.229,0.193,0.387,-.175,
     c 0.551,0.342,0.342,0.026,0.114,0.394,0.233,0.196,0.389,-.176,
     c 0.553,0.345,0.344,0.021,0.118,0.396,0.238,0.200,0.393,-.173,
     c 0.555,0.347,0.345,0.015,0.122,0.397,0.239,0.203,0.396,-.170,
     c 0.558,0.350,0.346,0.009,0.123,0.396,0.238,0.204,0.397,-.170,
     c 0.563,0.353,0.348,0.001,0.125,0.396,0.237,0.205,0.396,-.168,
     c 0.571,0.354,0.352,-.006,0.128,0.399,0.238,0.205,0.397,-.164,
     c 0.578,0.352,0.356,-.013,0.132,0.403,0.239,0.205,0.400,-.155,
     c 0.582,0.351,0.358,-.019,0.135,0.406,0.240,0.206,0.403,-.145,
     c 0.584,0.349,0.357,-.024,0.138,0.409,0.240,0.210,0.406,-.137,
     c 0.584,0.348,0.356,-.028,0.142,0.412,0.241,0.216,0.409,-.131,
     c 0.582,0.346,0.357,-.032,0.146,0.415,0.243,0.221,0.411,-.127,
     c 0.580,0.346,0.359,-.035,0.150,0.418,0.245,0.225,0.413,-.121,
     c 0.580,0.348,0.361,-.037,0.153,0.420,0.246,0.225,0.413,-.113,
     c 0.585,0.348,0.363,-.040,0.155,0.421,0.247,0.225,0.412,-.103,
     c 0.590,0.346,0.365,-.041,0.156,0.423,0.246,0.225,0.412,-.091,
     c 0.591,0.344,0.367,-.043,0.157,0.425,0.247,0.227,0.413,-.079,
     c 0.585,0.345,0.370,-.043,0.157,0.426,0.248,0.229,0.414,-.071,
     c 0.578,0.349,0.372,-.042,0.158,0.429,0.249,0.231,0.415,-.066,
     c 0.574,0.354,0.372,-.041,0.158,0.432,0.249,0.232,0.415,-.062,
     c 0.577,0.357,0.373,-.039,0.158,0.435,0.250,0.234,0.416,-.058,
     c 0.583,0.358,0.373,-.036,0.156,0.437,0.252,0.236,0.417,-.053,
     c 0.589,0.359,0.375,-.034,0.154,0.437,0.253,0.237,0.418,-.048,
     c 0.590,0.358,0.376,-.032,0.152,0.436,0.253,0.239,0.418,-.042,
     c 0.588,0.355,0.378,-.030,0.150,0.436,0.252,0.239,0.418,-.032,
     c 0.585,0.352,0.379,-.029,0.149,0.437,0.252,0.237,0.418,-.024,
     c 0.587,0.352,0.379,-.029,0.148,0.440,0.253,0.235,0.419,-.018,
     c 0.591,0.354,0.380,-.030,0.148,0.443,0.254,0.234,0.422,-.015,
     c 0.598,0.356,0.378,-.032,0.148,0.443,0.255,0.235,0.424,-.013,
     c 0.603,0.357,0.377,-.034,0.148,0.442,0.257,0.236,0.424,-.012,
     c 0.604,0.356,0.376,-.037,0.149,0.441,0.258,0.238,0.424,-.011,
     c 0.603,0.357,0.377,-.039,0.150,0.443,0.260,0.239,0.424,-.012,
     c 0.600,0.358,0.378,-.039,0.152,0.447,0.262,0.241,0.427,-.017,
     c 0.594,0.359,0.379,-.038,0.155,0.450,0.264,0.241,0.430,-.023,
     c 0.589,0.358,0.380,-.037,0.156,0.451,0.267,0.241,0.431,-.023,
     c 0.586,0.355,0.382,-.033,0.156,0.450,0.269,0.239,0.430,-.017,
     c 0.588,0.353,0.385,-.029,0.155,0.449,0.270,0.237,0.429,-.013,
     c 0.591,0.353,0.386,-.025,0.155,0.449,0.270,0.236,0.430,-.017,
     c 0.593,0.358,0.387,-.019,0.155,0.448,0.270,0.236,0.431,-.031,
     c 0.589,0.367,0.389,-.012,0.156,0.448,0.271,0.240,0.432,-.047,
     c 0.585,0.375,0.393,0.000,0.157,0.450,0.272,0.247,0.434,-.060,
     c 0.581,0.382,0.395,0.007,0.159,0.450,0.272,0.250,0.436,-.075,
     c 0.513,0.308,0.327,-.014,0.113,0.376,0.217,0.194,0.369,-.108,
     c 0.516,0.310,0.327,-.014,0.118,0.375,0.217,0.192,0.371,-.110,
     c 0.519,0.312,0.327,-.014,0.126,0.375,0.218,0.190,0.371,-.111,
     c 0.521,0.313,0.328,-.013,0.133,0.374,0.218,0.188,0.372,-.115,
     c 0.524,0.314,0.329,-.013,0.137,0.373,0.220,0.189,0.374,-.116,
     c 0.529,0.316,0.329,-.013,0.140,0.375,0.223,0.191,0.377,-.116,
     c 0.531,0.317,0.329,-.013,0.143,0.377,0.227,0.196,0.381,-.114,
     c 0.531,0.319,0.329,-.012,0.147,0.380,0.229,0.199,0.382,-.117,
     c 0.527,0.320,0.330,-.011,0.149,0.381,0.228,0.199,0.379,-.124,
     c 0.524,0.322,0.329,-.010,0.148,0.379,0.227,0.194,0.373,-.133,
     c 0.522,0.323,0.328,-.008,0.144,0.378,0.225,0.189,0.369,-.139,
     c 0.523,0.323,0.327,-.005,0.140,0.379,0.224,0.188,0.370,-.141,
     c 0.526,0.322,0.327,-.001,0.136,0.381,0.224,0.190,0.374,-.141,
     c 0.530,0.321,0.328,0.003,0.132,0.383,0.222,0.191,0.377,-.142,
     c 0.534,0.322,0.330,0.008,0.126,0.383,0.221,0.189,0.380,-.145,
     c 0.535,0.323,0.329,0.012,0.120,0.382,0.222,0.185,0.381,-.151,
     c 0.533,0.325,0.328,0.015,0.116,0.383,0.224,0.181,0.380,-.156,
     c 0.529,0.328,0.327,0.018,0.114,0.384,0.226,0.180,0.377,-.160,
     c 0.526,0.331,0.327,0.020,0.113,0.387,0.227,0.183,0.376,-.163,
     c 0.524,0.334,0.329,0.022,0.112,0.388,0.228,0.186,0.375,-.163,
     c 0.525,0.336,0.330,0.024,0.112,0.390,0.228,0.188,0.378,-.163,
     c 0.530,0.338,0.332,0.026,0.112,0.392,0.226,0.188,0.381,-.163,
     c 0.536,0.340,0.334,0.027,0.111,0.393,0.225,0.189,0.385,-.167,
     c 0.539,0.342,0.337,0.026,0.110,0.394,0.227,0.190,0.386,-.174,
     c 0.541,0.344,0.341,0.023,0.111,0.396,0.232,0.194,0.389,-.175,
     c 0.544,0.347,0.345,0.020,0.115,0.398,0.237,0.198,0.392,-.173,
     c 0.547,0.350,0.346,0.015,0.118,0.400,0.239,0.202,0.396,-.172,
     c 0.549,0.353,0.347,0.009,0.119,0.399,0.237,0.204,0.397,-.173,
     c 0.553,0.356,0.349,0.003,0.120,0.399,0.235,0.206,0.396,-.175,
     c 0.561,0.357,0.353,-.004,0.122,0.401,0.235,0.207,0.396,-.172,
     c 0.570,0.357,0.358,-.010,0.126,0.405,0.237,0.207,0.398,-.166,
     c 0.577,0.356,0.361,-.016,0.130,0.409,0.239,0.208,0.402,-.157,
     c 0.582,0.355,0.361,-.021,0.132,0.412,0.241,0.211,0.405,-.149,
     c 0.583,0.353,0.360,-.025,0.135,0.415,0.244,0.216,0.407,-.144,
     c 0.582,0.349,0.360,-.029,0.139,0.418,0.247,0.221,0.409,-.142,
     c 0.581,0.348,0.362,-.032,0.143,0.420,0.250,0.224,0.411,-.137,
     c 0.581,0.349,0.365,-.034,0.147,0.422,0.251,0.225,0.412,-.130,
     c 0.584,0.350,0.367,-.035,0.150,0.425,0.252,0.226,0.413,-.119,
     c 0.586,0.348,0.369,-.037,0.152,0.427,0.252,0.226,0.413,-.106,
     c 0.585,0.347,0.371,-.038,0.154,0.429,0.253,0.228,0.414,-.092,
     c 0.579,0.348,0.373,-.038,0.155,0.431,0.254,0.230,0.414,-.082,
     c 0.572,0.352,0.376,-.038,0.157,0.433,0.254,0.232,0.415,-.077,
     c 0.570,0.356,0.377,-.037,0.158,0.435,0.253,0.233,0.417,-.072,
     c 0.573,0.358,0.378,-.035,0.157,0.438,0.253,0.235,0.418,-.068,
     c 0.579,0.358,0.378,-.034,0.154,0.440,0.254,0.237,0.418,-.064,
     c 0.585,0.358,0.379,-.032,0.152,0.440,0.255,0.238,0.419,-.058,
     c 0.587,0.358,0.380,-.031,0.150,0.441,0.255,0.239,0.419,-.049,
     c 0.586,0.357,0.381,-.030,0.149,0.441,0.256,0.239,0.418,-.038,
     c 0.584,0.357,0.382,-.031,0.148,0.442,0.256,0.238,0.418,-.028,
     c 0.586,0.358,0.383,-.032,0.147,0.444,0.257,0.235,0.419,-.021,
     c 0.590,0.361,0.383,-.034,0.147,0.445,0.258,0.234,0.420,-.018,
     c 0.596,0.363,0.381,-.037,0.147,0.445,0.259,0.235,0.423,-.016,
     c 0.601,0.363,0.380,-.040,0.148,0.444,0.261,0.238,0.424,-.014,
     c 0.603,0.362,0.380,-.043,0.148,0.444,0.263,0.240,0.425,-.012,
     c 0.601,0.363,0.380,-.046,0.149,0.445,0.264,0.241,0.426,-.012,
     c 0.597,0.366,0.381,-.047,0.152,0.448,0.265,0.242,0.427,-.016,
     c 0.591,0.367,0.380,-.047,0.155,0.451,0.267,0.242,0.429,-.020,
     c 0.586,0.366,0.381,-.046,0.156,0.451,0.269,0.242,0.429,-.020,
     c 0.584,0.364,0.383,-.043,0.157,0.451,0.270,0.240,0.428,-.012,
     c 0.587,0.360,0.385,-.038,0.157,0.450,0.270,0.238,0.428,-.004,
     c 0.591,0.358,0.387,-.032,0.157,0.450,0.269,0.237,0.429,-.006,
     c 0.592,0.361,0.389,-.025,0.157,0.449,0.269,0.237,0.431,-.019,
     c 0.588,0.368,0.392,-.016,0.157,0.448,0.270,0.241,0.432,-.039,
     c 0.582,0.375,0.395,-.004,0.157,0.449,0.271,0.247,0.434,-.060,
     c 0.578,0.381,0.397,0.004,0.158,0.448,0.271,0.250,0.435,-.077,
     c 0.509,0.306,0.324,-.011,0.109,0.375,0.214,0.192,0.370,-.108,
     c 0.511,0.308,0.324,-.010,0.114,0.375,0.215,0.192,0.371,-.110,
     c 0.512,0.309,0.324,-.009,0.123,0.375,0.216,0.189,0.373,-.109,
     c 0.512,0.312,0.326,-.008,0.128,0.375,0.217,0.189,0.376,-.112,
     c 0.515,0.314,0.327,-.009,0.130,0.375,0.220,0.191,0.379,-.113,
     c 0.522,0.315,0.326,-.009,0.131,0.376,0.224,0.194,0.382,-.112,
     c 0.528,0.317,0.326,-.010,0.134,0.380,0.228,0.199,0.386,-.110,
     c 0.529,0.320,0.326,-.009,0.138,0.383,0.230,0.201,0.387,-.112,
     c 0.525,0.323,0.326,-.008,0.140,0.384,0.230,0.200,0.384,-.119,
     c 0.520,0.327,0.326,-.008,0.140,0.383,0.227,0.195,0.376,-.128,
     c 0.518,0.329,0.325,-.006,0.137,0.380,0.224,0.189,0.371,-.134,
     c 0.517,0.328,0.325,-.004,0.133,0.380,0.221,0.187,0.370,-.136,
     c 0.518,0.326,0.326,-.001,0.131,0.382,0.220,0.188,0.372,-.136,
     c 0.520,0.325,0.328,0.002,0.128,0.384,0.218,0.190,0.376,-.137,
     c 0.525,0.326,0.330,0.006,0.124,0.385,0.218,0.190,0.380,-.140,
     c 0.529,0.329,0.332,0.009,0.119,0.385,0.219,0.188,0.383,-.145,
     c 0.530,0.331,0.331,0.012,0.117,0.386,0.222,0.185,0.383,-.149,
     c 0.529,0.333,0.329,0.015,0.115,0.387,0.224,0.183,0.381,-.152,
     c 0.527,0.335,0.329,0.017,0.114,0.389,0.226,0.185,0.379,-.155,
     c 0.524,0.336,0.329,0.018,0.113,0.390,0.226,0.188,0.379,-.156,
     c 0.524,0.338,0.330,0.020,0.112,0.391,0.225,0.189,0.381,-.156,
     c 0.528,0.341,0.332,0.022,0.112,0.392,0.224,0.188,0.384,-.157,
     c 0.532,0.344,0.335,0.023,0.111,0.394,0.223,0.187,0.387,-.161,
     c 0.534,0.346,0.338,0.023,0.109,0.396,0.225,0.189,0.388,-.167,
     c 0.536,0.348,0.342,0.022,0.109,0.398,0.230,0.193,0.389,-.168,
     c 0.539,0.350,0.346,0.019,0.111,0.400,0.235,0.196,0.392,-.167,
     c 0.542,0.353,0.348,0.015,0.114,0.401,0.237,0.200,0.396,-.167,
     c 0.542,0.356,0.348,0.011,0.114,0.401,0.235,0.203,0.397,-.170,
     c 0.544,0.358,0.350,0.006,0.113,0.400,0.233,0.205,0.396,-.175,
     c 0.551,0.359,0.354,0.000,0.115,0.402,0.233,0.207,0.396,-.177,
     c 0.559,0.360,0.359,-.005,0.119,0.405,0.236,0.208,0.398,-.174,
     c 0.567,0.360,0.363,-.011,0.122,0.409,0.239,0.209,0.400,-.167,
     c 0.573,0.359,0.364,-.016,0.125,0.412,0.242,0.211,0.403,-.160,
     c 0.576,0.355,0.363,-.020,0.128,0.415,0.246,0.214,0.404,-.157,
     c 0.576,0.350,0.363,-.024,0.131,0.418,0.249,0.218,0.405,-.155,
     c 0.578,0.348,0.365,-.026,0.136,0.420,0.252,0.221,0.407,-.151,
     c 0.580,0.350,0.368,-.028,0.140,0.423,0.255,0.224,0.411,-.144,
     c 0.583,0.352,0.370,-.028,0.144,0.426,0.256,0.226,0.414,-.133,
     c 0.585,0.352,0.371,-.029,0.147,0.429,0.257,0.228,0.416,-.119,
     c 0.582,0.351,0.373,-.029,0.150,0.432,0.259,0.229,0.416,-.105,
     c 0.576,0.352,0.376,-.029,0.152,0.434,0.260,0.230,0.416,-.094,
     c 0.570,0.355,0.379,-.028,0.154,0.436,0.260,0.232,0.418,-.087,
     c 0.569,0.358,0.381,-.027,0.155,0.438,0.259,0.234,0.420,-.082,
     c 0.572,0.358,0.382,-.027,0.154,0.440,0.257,0.236,0.422,-.078,
     c 0.578,0.357,0.382,-.026,0.151,0.441,0.257,0.237,0.422,-.072,
     c 0.583,0.356,0.383,-.026,0.148,0.442,0.257,0.238,0.423,-.066,
     c 0.586,0.356,0.383,-.026,0.147,0.443,0.258,0.240,0.423,-.055,
     c 0.586,0.357,0.383,-.027,0.146,0.443,0.259,0.240,0.423,-.042,
     c 0.585,0.359,0.384,-.030,0.146,0.444,0.259,0.238,0.422,-.031,
     c 0.585,0.361,0.384,-.032,0.145,0.445,0.260,0.235,0.421,-.026,
     c 0.589,0.364,0.385,-.036,0.145,0.446,0.261,0.234,0.422,-.024,
     c 0.595,0.366,0.384,-.039,0.146,0.446,0.262,0.235,0.424,-.023,
     c 0.600,0.366,0.383,-.043,0.146,0.446,0.264,0.239,0.426,-.019,
     c 0.602,0.366,0.384,-.046,0.147,0.446,0.266,0.241,0.428,-.014,
     c 0.600,0.367,0.385,-.049,0.149,0.447,0.267,0.242,0.429,-.012,
     c 0.594,0.370,0.385,-.050,0.151,0.448,0.269,0.243,0.430,-.014,
     c 0.587,0.372,0.384,-.051,0.154,0.451,0.270,0.242,0.431,-.018,
     c 0.583,0.373,0.384,-.049,0.156,0.451,0.272,0.241,0.430,-.018,
     c 0.584,0.370,0.385,-.046,0.157,0.451,0.272,0.239,0.429,-.010,
     c 0.588,0.366,0.387,-.041,0.157,0.451,0.272,0.237,0.429,0.000,
     c 0.592,0.363,0.389,-.034,0.159,0.450,0.270,0.237,0.431,0.000,
     c 0.593,0.364,0.391,-.026,0.159,0.449,0.270,0.239,0.433,-.012,
     c 0.588,0.368,0.394,-.016,0.159,0.448,0.270,0.242,0.434,-.034,
     c 0.580,0.374,0.396,-.005,0.158,0.447,0.270,0.246,0.434,-.060,
     c 0.576,0.379,0.399,0.004,0.158,0.446,0.270,0.250,0.435,-.078,
     c 0.505,0.306,0.321,-.008,0.105,0.375,0.211,0.191,0.370,-.109,
     c 0.507,0.309,0.322,-.007,0.109,0.376,0.213,0.191,0.372,-.110,
     c 0.506,0.308,0.322,-.004,0.116,0.375,0.214,0.189,0.374,-.110,
     c 0.507,0.312,0.323,-.003,0.120,0.377,0.216,0.190,0.377,-.111,
     c 0.511,0.315,0.325,-.003,0.121,0.377,0.219,0.192,0.380,-.112,
     c 0.520,0.316,0.324,-.005,0.120,0.379,0.224,0.194,0.383,-.110,
     c 0.529,0.318,0.323,-.006,0.121,0.382,0.227,0.197,0.386,-.107,
     c 0.530,0.322,0.322,-.006,0.125,0.385,0.230,0.199,0.387,-.108,
     c 0.526,0.327,0.322,-.006,0.127,0.386,0.230,0.198,0.385,-.113,
     c 0.519,0.330,0.322,-.006,0.128,0.385,0.226,0.193,0.379,-.121,
     c 0.515,0.332,0.322,-.005,0.125,0.382,0.220,0.187,0.373,-.127,
     c 0.511,0.330,0.322,-.004,0.124,0.382,0.216,0.185,0.371,-.129,
     c 0.509,0.327,0.323,-.002,0.123,0.383,0.215,0.186,0.372,-.129,
     c 0.511,0.325,0.326,0.000,0.122,0.384,0.214,0.188,0.376,-.129,
     c 0.517,0.327,0.330,0.003,0.118,0.386,0.213,0.191,0.381,-.131,
     c 0.524,0.331,0.333,0.006,0.115,0.387,0.215,0.191,0.385,-.134,
     c 0.529,0.334,0.334,0.009,0.114,0.388,0.217,0.189,0.386,-.136,
     c 0.531,0.336,0.332,0.011,0.113,0.390,0.220,0.188,0.385,-.139,
     c 0.529,0.337,0.332,0.013,0.112,0.390,0.222,0.190,0.383,-.142,
     c 0.527,0.337,0.332,0.014,0.111,0.391,0.222,0.192,0.383,-.145,
     c 0.526,0.340,0.333,0.016,0.110,0.391,0.222,0.192,0.384,-.147,
     c 0.529,0.344,0.334,0.019,0.110,0.393,0.221,0.191,0.387,-.149,
     c 0.533,0.348,0.338,0.021,0.109,0.396,0.221,0.190,0.390,-.153,
     c 0.534,0.350,0.341,0.022,0.106,0.399,0.223,0.191,0.390,-.158,
     c 0.536,0.351,0.345,0.022,0.105,0.401,0.228,0.193,0.390,-.159,
     c 0.538,0.353,0.348,0.021,0.106,0.402,0.233,0.196,0.392,-.158,
     c 0.540,0.355,0.351,0.019,0.108,0.403,0.235,0.199,0.396,-.159,
     c 0.539,0.357,0.351,0.016,0.107,0.402,0.233,0.203,0.398,-.164,
     c 0.539,0.359,0.352,0.012,0.105,0.402,0.231,0.206,0.397,-.170,
     c 0.544,0.361,0.355,0.007,0.105,0.403,0.233,0.209,0.397,-.176,
     c 0.550,0.363,0.360,0.002,0.109,0.406,0.236,0.211,0.398,-.176,
     c 0.556,0.363,0.363,-.003,0.113,0.409,0.240,0.211,0.401,-.172,
     c 0.561,0.362,0.365,-.009,0.117,0.412,0.243,0.212,0.402,-.168,
     c 0.564,0.357,0.365,-.014,0.120,0.416,0.247,0.214,0.403,-.166,
     c 0.567,0.353,0.365,-.018,0.123,0.418,0.250,0.217,0.403,-.165,
     c 0.571,0.351,0.368,-.020,0.128,0.421,0.253,0.221,0.406,-.162,
     c 0.577,0.354,0.371,-.021,0.132,0.424,0.255,0.225,0.411,-.156,
     c 0.583,0.358,0.373,-.021,0.136,0.427,0.257,0.227,0.416,-.145,
     c 0.585,0.359,0.374,-.020,0.139,0.431,0.259,0.229,0.418,-.132,
     c 0.582,0.359,0.375,-.019,0.142,0.434,0.262,0.229,0.418,-.117,
     c 0.576,0.360,0.377,-.018,0.145,0.436,0.264,0.230,0.419,-.107,
     c 0.572,0.362,0.380,-.017,0.147,0.438,0.264,0.231,0.421,-.100,
     c 0.571,0.363,0.383,-.017,0.148,0.440,0.263,0.234,0.424,-.095,
     c 0.575,0.361,0.383,-.017,0.147,0.441,0.262,0.236,0.426,-.089,
     c 0.580,0.359,0.383,-.017,0.145,0.441,0.262,0.237,0.427,-.083,
     c 0.584,0.357,0.383,-.018,0.143,0.442,0.262,0.238,0.427,-.075,
     c 0.587,0.357,0.383,-.020,0.142,0.443,0.262,0.239,0.428,-.063,
     c 0.587,0.359,0.383,-.023,0.142,0.445,0.262,0.240,0.428,-.050,
     c 0.586,0.361,0.384,-.026,0.142,0.445,0.263,0.239,0.428,-.040,
     c 0.586,0.365,0.385,-.030,0.142,0.446,0.264,0.236,0.426,-.036,
     c 0.590,0.369,0.385,-.034,0.142,0.446,0.265,0.234,0.426,-.036,
     c 0.595,0.370,0.385,-.038,0.142,0.447,0.266,0.235,0.427,-.035,
     c 0.600,0.370,0.386,-.042,0.143,0.447,0.267,0.238,0.429,-.030,
     c 0.602,0.370,0.387,-.045,0.145,0.447,0.269,0.241,0.432,-.021,
     c 0.599,0.371,0.389,-.048,0.146,0.448,0.271,0.242,0.433,-.015,
     c 0.590,0.374,0.390,-.049,0.149,0.449,0.272,0.241,0.434,-.014,
     c 0.583,0.376,0.389,-.048,0.152,0.450,0.274,0.240,0.434,-.018,
     c 0.580,0.376,0.388,-.047,0.154,0.450,0.275,0.239,0.432,-.020,
     c 0.583,0.374,0.389,-.044,0.155,0.449,0.276,0.236,0.431,-.014,
     c 0.588,0.371,0.390,-.038,0.156,0.449,0.275,0.235,0.431,-.005,
     c 0.592,0.367,0.392,-.031,0.158,0.449,0.273,0.236,0.434,-.004,
     c 0.592,0.367,0.394,-.023,0.159,0.449,0.272,0.239,0.436,-.015,
     c 0.587,0.370,0.396,-.013,0.159,0.447,0.271,0.244,0.436,-.037,
     c 0.579,0.374,0.397,-.004,0.158,0.445,0.270,0.247,0.435,-.063,
     c 0.574,0.377,0.400,0.004,0.158,0.444,0.269,0.250,0.436,-.081,
     c 0.504,0.309,0.322,-.005,0.101,0.377,0.209,0.192,0.372,-.109,
     c 0.506,0.313,0.323,-.004,0.104,0.378,0.212,0.192,0.375,-.109,
     c 0.504,0.313,0.321,-.000,0.108,0.378,0.212,0.191,0.377,-.110,
     c 0.506,0.317,0.323,0.002,0.111,0.381,0.216,0.192,0.380,-.110,
     c 0.513,0.322,0.325,0.002,0.111,0.381,0.219,0.193,0.382,-.110,
     c 0.523,0.323,0.325,0.001,0.109,0.382,0.222,0.194,0.383,-.107,
     c 0.532,0.323,0.323,-.001,0.109,0.384,0.225,0.195,0.384,-.104,
     c 0.533,0.326,0.321,-.002,0.111,0.387,0.227,0.196,0.385,-.104,
     c 0.528,0.331,0.321,-.002,0.114,0.389,0.227,0.195,0.384,-.108,
     c 0.521,0.334,0.321,-.003,0.115,0.388,0.223,0.192,0.381,-.114,
     c 0.516,0.334,0.322,-.003,0.114,0.386,0.217,0.187,0.377,-.119,
     c 0.510,0.332,0.322,-.002,0.114,0.385,0.213,0.185,0.376,-.120,
     c 0.506,0.328,0.323,-.001,0.114,0.386,0.212,0.185,0.376,-.120,
     c 0.507,0.326,0.326,-.000,0.114,0.387,0.212,0.188,0.379,-.120,
     c 0.514,0.328,0.331,0.002,0.113,0.388,0.212,0.191,0.383,-.121,
     c 0.523,0.332,0.335,0.005,0.111,0.389,0.212,0.192,0.386,-.122,
     c 0.530,0.336,0.336,0.007,0.110,0.391,0.214,0.193,0.388,-.124,
     c 0.535,0.337,0.335,0.009,0.110,0.392,0.216,0.193,0.388,-.125,
     c 0.535,0.338,0.335,0.011,0.109,0.392,0.217,0.195,0.386,-.129,
     c 0.532,0.338,0.335,0.013,0.108,0.393,0.218,0.196,0.385,-.133,
     c 0.532,0.341,0.336,0.016,0.108,0.393,0.219,0.197,0.387,-.135,
     c 0.535,0.345,0.338,0.019,0.107,0.396,0.220,0.197,0.390,-.138,
     c 0.538,0.350,0.342,0.023,0.106,0.399,0.220,0.197,0.392,-.143,
     c 0.540,0.353,0.345,0.026,0.103,0.402,0.221,0.197,0.393,-.149,
     c 0.541,0.354,0.348,0.028,0.101,0.404,0.225,0.197,0.392,-.150,
     c 0.542,0.355,0.352,0.028,0.101,0.405,0.230,0.198,0.394,-.150,
     c 0.542,0.357,0.354,0.028,0.102,0.406,0.233,0.202,0.397,-.150,
     c 0.540,0.358,0.356,0.027,0.101,0.406,0.232,0.206,0.399,-.155,
     c 0.540,0.360,0.357,0.024,0.098,0.406,0.232,0.210,0.400,-.162,
     c 0.542,0.363,0.359,0.020,0.098,0.407,0.234,0.214,0.400,-.168,
     c 0.546,0.364,0.362,0.015,0.101,0.410,0.238,0.215,0.402,-.171,
     c 0.550,0.365,0.365,0.009,0.105,0.412,0.241,0.216,0.404,-.169,
     c 0.552,0.363,0.366,0.002,0.110,0.416,0.245,0.216,0.406,-.167,
     c 0.554,0.359,0.366,-.004,0.113,0.418,0.248,0.218,0.405,-.167,
     c 0.557,0.356,0.368,-.009,0.116,0.420,0.250,0.220,0.406,-.168,
     c 0.564,0.356,0.371,-.012,0.121,0.422,0.252,0.224,0.408,-.166,
     c 0.573,0.360,0.374,-.012,0.125,0.425,0.253,0.228,0.413,-.162,
     c 0.582,0.365,0.377,-.012,0.128,0.429,0.255,0.231,0.419,-.154,
     c 0.585,0.368,0.378,-.011,0.131,0.434,0.258,0.231,0.421,-.142,
     c 0.584,0.369,0.378,-.010,0.134,0.437,0.262,0.230,0.421,-.130,
     c 0.579,0.370,0.379,-.009,0.136,0.438,0.264,0.230,0.421,-.121,
     c 0.576,0.371,0.381,-.007,0.138,0.439,0.264,0.231,0.423,-.115,
     c 0.577,0.370,0.383,-.007,0.139,0.441,0.263,0.233,0.426,-.109,
     c 0.581,0.368,0.383,-.007,0.139,0.441,0.264,0.235,0.429,-.102,
     c 0.585,0.365,0.383,-.008,0.138,0.441,0.265,0.236,0.430,-.095,
     c 0.589,0.362,0.383,-.010,0.137,0.442,0.265,0.238,0.431,-.086,
     c 0.591,0.362,0.383,-.012,0.137,0.444,0.265,0.239,0.432,-.075,
     c 0.590,0.364,0.384,-.016,0.137,0.446,0.266,0.241,0.434,-.062,
     c 0.589,0.368,0.385,-.020,0.137,0.447,0.268,0.240,0.434,-.053,
     c 0.589,0.372,0.386,-.025,0.137,0.447,0.269,0.238,0.433,-.049,
     c 0.593,0.376,0.387,-.029,0.137,0.447,0.270,0.236,0.431,-.050,
     c 0.598,0.378,0.387,-.033,0.138,0.448,0.270,0.236,0.432,-.049,
     c 0.602,0.378,0.389,-.036,0.139,0.449,0.271,0.238,0.433,-.043,
     c 0.603,0.378,0.391,-.039,0.141,0.449,0.272,0.240,0.435,-.032,
     c 0.597,0.378,0.394,-.041,0.143,0.449,0.273,0.240,0.436,-.022,
     c 0.587,0.378,0.395,-.042,0.146,0.449,0.274,0.239,0.437,-.020,
     c 0.579,0.379,0.395,-.041,0.149,0.449,0.276,0.238,0.437,-.024,
     c 0.577,0.379,0.394,-.040,0.151,0.449,0.277,0.236,0.435,-.027,
     c 0.582,0.377,0.393,-.037,0.153,0.448,0.278,0.235,0.433,-.025,
     c 0.587,0.374,0.393,-.032,0.155,0.448,0.277,0.234,0.434,-.018,
     c 0.591,0.370,0.394,-.024,0.157,0.448,0.274,0.236,0.436,-.017,
     c 0.591,0.369,0.395,-.017,0.158,0.448,0.272,0.240,0.438,-.027,
     c 0.586,0.371,0.397,-.009,0.158,0.446,0.271,0.245,0.438,-.046,
     c 0.579,0.374,0.399,-.001,0.158,0.445,0.269,0.247,0.437,-.067,
     c 0.574,0.376,0.401,0.007,0.159,0.444,0.268,0.251,0.437,-.084,
     c 0.505,0.312,0.322,-.004,0.096,0.379,0.208,0.191,0.375,-.108,
     c 0.508,0.317,0.323,-.003,0.097,0.381,0.211,0.192,0.377,-.108,
     c 0.505,0.319,0.322,0.001,0.098,0.382,0.213,0.192,0.379,-.109,
     c 0.508,0.326,0.324,0.003,0.099,0.385,0.217,0.193,0.382,-.108,
     c 0.515,0.331,0.326,0.004,0.098,0.386,0.219,0.194,0.383,-.108,
     c 0.525,0.331,0.326,0.003,0.097,0.385,0.221,0.193,0.383,-.105,
     c 0.533,0.331,0.325,0.002,0.096,0.386,0.223,0.192,0.383,-.102,
     c 0.533,0.333,0.324,0.001,0.098,0.389,0.225,0.192,0.383,-.103,
     c 0.529,0.336,0.323,-.000,0.101,0.390,0.224,0.191,0.383,-.106,
     c 0.524,0.338,0.324,-.001,0.102,0.390,0.221,0.189,0.382,-.110,
     c 0.520,0.337,0.325,-.001,0.101,0.389,0.216,0.187,0.382,-.112,
     c 0.514,0.334,0.326,-.000,0.103,0.390,0.214,0.186,0.382,-.112,
     c 0.509,0.330,0.326,-.000,0.105,0.391,0.214,0.186,0.382,-.111,
     c 0.509,0.328,0.328,0.001,0.107,0.392,0.214,0.187,0.383,-.112,
     c 0.515,0.330,0.332,0.002,0.106,0.391,0.215,0.190,0.384,-.113,
     c 0.524,0.334,0.335,0.004,0.105,0.392,0.214,0.192,0.387,-.115,
     c 0.533,0.337,0.337,0.006,0.105,0.393,0.214,0.193,0.389,-.116,
     c 0.538,0.338,0.337,0.008,0.105,0.394,0.214,0.194,0.388,-.118,
     c 0.540,0.339,0.337,0.010,0.105,0.394,0.215,0.196,0.387,-.122,
     c 0.538,0.339,0.337,0.013,0.104,0.394,0.217,0.198,0.386,-.127,
     c 0.537,0.340,0.338,0.017,0.104,0.395,0.219,0.200,0.387,-.130,
     c 0.539,0.344,0.340,0.022,0.103,0.398,0.220,0.201,0.390,-.133,
     c 0.543,0.349,0.343,0.028,0.101,0.401,0.221,0.202,0.393,-.138,
     c 0.545,0.353,0.346,0.033,0.098,0.404,0.221,0.201,0.394,-.144,
     c 0.545,0.354,0.349,0.037,0.096,0.405,0.224,0.200,0.394,-.146,
     c 0.545,0.355,0.352,0.040,0.096,0.407,0.228,0.200,0.395,-.146,
     c 0.543,0.356,0.356,0.042,0.096,0.408,0.232,0.203,0.398,-.146,
     c 0.542,0.357,0.359,0.042,0.095,0.409,0.233,0.207,0.401,-.150,
     c 0.542,0.359,0.361,0.040,0.093,0.411,0.234,0.212,0.402,-.156,
     c 0.543,0.362,0.363,0.036,0.092,0.412,0.236,0.216,0.403,-.162,
     c 0.545,0.362,0.365,0.030,0.095,0.414,0.239,0.218,0.406,-.163,
     c 0.546,0.362,0.366,0.023,0.098,0.417,0.243,0.219,0.408,-.162,
     c 0.546,0.361,0.366,0.015,0.101,0.419,0.245,0.220,0.409,-.162,
     c 0.546,0.358,0.366,0.007,0.104,0.421,0.248,0.220,0.409,-.164,
     c 0.549,0.357,0.368,-.000,0.108,0.422,0.250,0.222,0.409,-.167,
     c 0.558,0.359,0.371,-.004,0.112,0.423,0.251,0.226,0.411,-.167,
     c 0.569,0.365,0.376,-.005,0.115,0.426,0.252,0.230,0.416,-.166,
     c 0.580,0.371,0.379,-.005,0.118,0.430,0.254,0.232,0.421,-.161,
     c 0.584,0.374,0.380,-.004,0.121,0.435,0.258,0.232,0.424,-.152,
     c 0.584,0.375,0.380,-.004,0.123,0.437,0.261,0.230,0.422,-.143,
     c 0.580,0.375,0.381,-.003,0.125,0.437,0.262,0.227,0.421,-.137,
     c 0.579,0.375,0.382,-.002,0.127,0.438,0.262,0.227,0.422,-.131,
     c 0.581,0.375,0.382,-.002,0.129,0.439,0.263,0.229,0.425,-.125,
     c 0.585,0.373,0.381,-.002,0.129,0.440,0.264,0.232,0.428,-.118,
     c 0.588,0.370,0.381,-.004,0.130,0.440,0.266,0.233,0.429,-.110,
     c 0.591,0.368,0.382,-.005,0.130,0.441,0.267,0.234,0.430,-.102,
     c 0.593,0.367,0.383,-.007,0.130,0.443,0.268,0.237,0.432,-.091,
     c 0.593,0.370,0.384,-.011,0.131,0.446,0.269,0.239,0.434,-.079,
     c 0.591,0.373,0.386,-.015,0.131,0.446,0.272,0.239,0.435,-.069,
     c 0.592,0.377,0.388,-.019,0.130,0.447,0.274,0.238,0.435,-.065,
     c 0.595,0.381,0.389,-.023,0.131,0.447,0.275,0.236,0.434,-.065,
     c 0.600,0.383,0.389,-.027,0.132,0.447,0.274,0.236,0.434,-.064,
     c 0.602,0.384,0.391,-.029,0.134,0.448,0.273,0.236,0.434,-.058,
     c 0.601,0.383,0.393,-.033,0.135,0.448,0.273,0.237,0.435,-.047,
     c 0.594,0.382,0.396,-.035,0.138,0.447,0.273,0.237,0.436,-.035,
     c 0.584,0.381,0.397,-.035,0.142,0.447,0.274,0.237,0.437,-.031,
     c 0.576,0.381,0.398,-.034,0.146,0.447,0.275,0.236,0.438,-.035,
     c 0.575,0.380,0.397,-.033,0.149,0.446,0.277,0.234,0.436,-.040,
     c 0.580,0.378,0.395,-.031,0.151,0.446,0.278,0.233,0.435,-.040,
     c 0.585,0.374,0.394,-.026,0.153,0.446,0.277,0.233,0.435,-.035,
     c 0.588,0.371,0.394,-.019,0.155,0.446,0.274,0.235,0.437,-.034,
     c 0.587,0.369,0.395,-.012,0.156,0.445,0.271,0.239,0.439,-.043,
     c 0.583,0.371,0.397,-.005,0.156,0.444,0.269,0.243,0.438,-.059,
     c 0.577,0.373,0.398,0.001,0.157,0.443,0.269,0.245,0.437,-.074,
     c 0.573,0.374,0.400,0.008,0.158,0.442,0.268,0.248,0.437,-.088,
     c 0.507,0.318,0.325,-.004,0.092,0.383,0.208,0.193,0.378,-.107,
     c 0.511,0.324,0.326,-.002,0.091,0.385,0.212,0.193,0.380,-.107,
     c 0.511,0.329,0.325,0.001,0.088,0.388,0.215,0.194,0.382,-.107,
     c 0.514,0.337,0.327,0.003,0.087,0.391,0.219,0.195,0.385,-.107,
     c 0.519,0.342,0.329,0.004,0.087,0.391,0.220,0.194,0.386,-.107,
     c 0.527,0.343,0.330,0.004,0.086,0.390,0.220,0.193,0.386,-.106,
     c 0.533,0.342,0.329,0.003,0.085,0.390,0.221,0.191,0.385,-.104,
     c 0.533,0.343,0.328,0.002,0.087,0.391,0.223,0.191,0.384,-.104,
     c 0.530,0.345,0.329,0.002,0.089,0.392,0.223,0.191,0.384,-.106,
     c 0.527,0.346,0.330,0.001,0.089,0.392,0.220,0.190,0.385,-.107,
     c 0.526,0.346,0.332,0.002,0.090,0.393,0.217,0.190,0.388,-.106,
     c 0.521,0.343,0.332,0.003,0.093,0.396,0.217,0.191,0.390,-.104,
     c 0.517,0.340,0.332,0.004,0.098,0.398,0.219,0.191,0.389,-.103,
     c 0.516,0.338,0.333,0.005,0.102,0.398,0.220,0.191,0.388,-.104,
     c 0.521,0.338,0.335,0.006,0.102,0.396,0.220,0.192,0.387,-.106,
     c 0.528,0.341,0.338,0.007,0.101,0.396,0.218,0.195,0.389,-.109,
     c 0.536,0.343,0.339,0.009,0.102,0.396,0.216,0.196,0.391,-.112,
     c 0.541,0.344,0.340,0.010,0.102,0.397,0.215,0.198,0.391,-.116,
     c 0.542,0.344,0.340,0.013,0.102,0.398,0.215,0.200,0.389,-.121,
     c 0.540,0.344,0.340,0.016,0.101,0.398,0.217,0.202,0.388,-.126,
     c 0.539,0.345,0.341,0.022,0.100,0.399,0.220,0.204,0.389,-.128,
     c 0.540,0.347,0.342,0.029,0.099,0.401,0.222,0.205,0.392,-.131,
     c 0.543,0.350,0.344,0.036,0.097,0.404,0.222,0.206,0.394,-.136,
     c 0.545,0.353,0.347,0.043,0.094,0.406,0.222,0.205,0.395,-.141,
     c 0.545,0.355,0.349,0.050,0.091,0.407,0.223,0.203,0.395,-.144,
     c 0.543,0.355,0.351,0.055,0.090,0.408,0.226,0.202,0.396,-.145,
     c 0.541,0.356,0.355,0.058,0.091,0.409,0.230,0.205,0.399,-.145,
     c 0.541,0.358,0.358,0.059,0.090,0.412,0.233,0.209,0.402,-.149,
     c 0.542,0.361,0.362,0.058,0.090,0.415,0.235,0.214,0.404,-.153,
     c 0.545,0.363,0.365,0.054,0.089,0.417,0.238,0.218,0.407,-.157,
     c 0.546,0.363,0.367,0.047,0.090,0.419,0.241,0.221,0.409,-.157,
     c 0.546,0.362,0.368,0.039,0.092,0.420,0.243,0.222,0.412,-.155,
     c 0.544,0.360,0.367,0.029,0.094,0.422,0.245,0.222,0.413,-.156,
     c 0.543,0.360,0.366,0.019,0.096,0.422,0.247,0.222,0.413,-.159,
     c 0.546,0.360,0.368,0.011,0.098,0.423,0.249,0.224,0.413,-.163,
     c 0.554,0.364,0.371,0.006,0.101,0.424,0.250,0.227,0.414,-.164,
     c 0.566,0.370,0.376,0.003,0.105,0.427,0.252,0.232,0.419,-.164,
     c 0.577,0.375,0.379,0.001,0.108,0.431,0.256,0.234,0.425,-.161,
     c 0.582,0.378,0.381,0.001,0.112,0.435,0.260,0.235,0.427,-.156,
     c 0.581,0.378,0.382,0.001,0.114,0.437,0.263,0.232,0.426,-.149,
     c 0.579,0.377,0.383,0.001,0.117,0.436,0.263,0.229,0.424,-.145,
     c 0.578,0.377,0.383,0.001,0.119,0.437,0.262,0.227,0.423,-.142,
     c 0.580,0.378,0.382,-.000,0.120,0.439,0.263,0.228,0.426,-.137,
     c 0.583,0.377,0.381,-.001,0.121,0.440,0.265,0.231,0.428,-.131,
     c 0.586,0.375,0.381,-.002,0.122,0.441,0.267,0.233,0.429,-.124,
     c 0.589,0.372,0.383,-.004,0.123,0.442,0.269,0.234,0.430,-.117,
     c 0.591,0.372,0.385,-.005,0.124,0.444,0.270,0.237,0.432,-.106,
     c 0.590,0.374,0.387,-.008,0.125,0.445,0.272,0.239,0.434,-.094,
     c 0.589,0.378,0.389,-.012,0.124,0.446,0.275,0.240,0.436,-.083,
     c 0.590,0.382,0.391,-.016,0.123,0.446,0.278,0.240,0.436,-.077,
     c 0.593,0.385,0.392,-.019,0.125,0.446,0.278,0.239,0.435,-.076,
     c 0.597,0.387,0.392,-.021,0.127,0.446,0.276,0.237,0.435,-.076,
     c 0.599,0.388,0.392,-.024,0.130,0.446,0.274,0.237,0.435,-.071,
     c 0.597,0.387,0.394,-.027,0.133,0.446,0.273,0.237,0.435,-.061,
     c 0.590,0.385,0.396,-.029,0.136,0.445,0.272,0.238,0.436,-.051,
     c 0.580,0.383,0.398,-.030,0.140,0.445,0.272,0.237,0.437,-.047,
     c 0.574,0.382,0.399,-.029,0.145,0.445,0.274,0.236,0.437,-.051,
     c 0.574,0.381,0.397,-.027,0.147,0.444,0.275,0.235,0.436,-.056,
     c 0.579,0.379,0.395,-.025,0.150,0.443,0.276,0.234,0.435,-.057,
     c 0.583,0.376,0.393,-.021,0.151,0.443,0.276,0.234,0.436,-.053,
     c 0.585,0.372,0.394,-.015,0.153,0.444,0.273,0.236,0.437,-.052,
     c 0.583,0.370,0.395,-.007,0.154,0.443,0.270,0.240,0.439,-.059,
     c 0.580,0.371,0.397,-.001,0.155,0.442,0.268,0.243,0.438,-.072,
     c 0.574,0.372,0.398,0.004,0.156,0.441,0.268,0.244,0.437,-.083,
     c 0.570,0.373,0.399,0.009,0.157,0.440,0.267,0.246,0.436,-.094,
     c 0.513,0.325,0.328,-.004,0.089,0.388,0.210,0.194,0.383,-.104,
     c 0.516,0.331,0.329,-.002,0.087,0.390,0.213,0.195,0.384,-.104,
     c 0.520,0.338,0.329,-.000,0.080,0.393,0.217,0.194,0.385,-.104,
     c 0.523,0.346,0.331,0.002,0.078,0.396,0.220,0.195,0.387,-.105,
     c 0.528,0.352,0.333,0.003,0.078,0.396,0.221,0.193,0.388,-.107,
     c 0.533,0.353,0.333,0.003,0.077,0.395,0.220,0.191,0.389,-.108,
     c 0.536,0.351,0.332,0.003,0.076,0.395,0.221,0.191,0.388,-.106,
     c 0.536,0.350,0.332,0.002,0.077,0.396,0.223,0.192,0.387,-.105,
     c 0.534,0.352,0.334,0.002,0.078,0.397,0.223,0.192,0.387,-.105,
     c 0.534,0.353,0.335,0.003,0.079,0.396,0.221,0.192,0.390,-.104,
     c 0.535,0.354,0.337,0.004,0.080,0.398,0.219,0.195,0.393,-.099,
     c 0.532,0.353,0.338,0.006,0.085,0.401,0.220,0.198,0.396,-.094,
     c 0.527,0.351,0.338,0.008,0.092,0.404,0.223,0.198,0.395,-.092,
     c 0.526,0.349,0.339,0.009,0.098,0.403,0.225,0.198,0.393,-.094,
     c 0.528,0.349,0.340,0.011,0.100,0.401,0.224,0.198,0.392,-.097,
     c 0.533,0.351,0.341,0.013,0.100,0.400,0.222,0.200,0.393,-.102,
     c 0.538,0.352,0.342,0.014,0.100,0.400,0.219,0.202,0.395,-.106,
     c 0.541,0.352,0.343,0.016,0.101,0.401,0.217,0.203,0.395,-.112,
     c 0.543,0.353,0.344,0.019,0.100,0.402,0.216,0.204,0.394,-.118,
     c 0.541,0.352,0.344,0.024,0.099,0.402,0.218,0.205,0.392,-.123,
     c 0.538,0.351,0.345,0.031,0.097,0.403,0.221,0.207,0.393,-.125,
     c 0.539,0.351,0.346,0.039,0.096,0.404,0.224,0.209,0.395,-.127,
     c 0.541,0.352,0.347,0.047,0.094,0.407,0.224,0.210,0.396,-.132,
     c 0.543,0.354,0.348,0.056,0.091,0.408,0.223,0.208,0.397,-.137,
     c 0.541,0.355,0.349,0.063,0.088,0.409,0.223,0.206,0.397,-.141,
     c 0.539,0.355,0.350,0.069,0.086,0.409,0.224,0.205,0.398,-.142,
     c 0.537,0.357,0.352,0.073,0.086,0.410,0.228,0.207,0.401,-.144,
     c 0.538,0.360,0.356,0.075,0.086,0.413,0.232,0.211,0.404,-.148,
     c 0.542,0.364,0.361,0.074,0.086,0.417,0.236,0.216,0.407,-.151,
     c 0.546,0.367,0.365,0.070,0.085,0.420,0.239,0.220,0.409,-.153,
     c 0.548,0.366,0.368,0.063,0.085,0.421,0.241,0.222,0.412,-.151,
     c 0.548,0.365,0.369,0.053,0.086,0.422,0.243,0.223,0.415,-.149,
     c 0.547,0.363,0.368,0.043,0.086,0.423,0.243,0.223,0.417,-.150,
     c 0.547,0.363,0.366,0.032,0.087,0.423,0.245,0.223,0.418,-.153,
     c 0.548,0.365,0.367,0.022,0.089,0.423,0.246,0.225,0.418,-.156,
     c 0.555,0.369,0.370,0.015,0.092,0.425,0.249,0.228,0.420,-.156,
     c 0.566,0.375,0.375,0.010,0.095,0.428,0.252,0.232,0.424,-.156,
     c 0.575,0.379,0.378,0.007,0.099,0.432,0.257,0.235,0.429,-.155,
     c 0.579,0.380,0.381,0.006,0.103,0.435,0.262,0.236,0.431,-.151,
     c 0.578,0.378,0.383,0.004,0.107,0.436,0.265,0.234,0.431,-.147,
     c 0.576,0.377,0.384,0.003,0.109,0.435,0.265,0.231,0.428,-.145,
     c 0.576,0.378,0.384,0.002,0.111,0.436,0.264,0.229,0.427,-.144,
     c 0.577,0.380,0.383,-.000,0.113,0.438,0.264,0.230,0.429,-.141,
     c 0.579,0.380,0.382,-.002,0.114,0.440,0.266,0.232,0.430,-.138,
     c 0.581,0.377,0.383,-.004,0.116,0.442,0.268,0.235,0.430,-.134,
     c 0.584,0.374,0.385,-.005,0.118,0.443,0.270,0.236,0.431,-.128,
     c 0.586,0.374,0.387,-.006,0.121,0.444,0.271,0.238,0.433,-.116,
     c 0.587,0.376,0.389,-.007,0.122,0.445,0.274,0.240,0.435,-.104,
     c 0.586,0.380,0.391,-.010,0.121,0.445,0.277,0.242,0.437,-.093,
     c 0.586,0.383,0.393,-.013,0.121,0.445,0.279,0.242,0.437,-.086,
     c 0.589,0.387,0.393,-.016,0.124,0.445,0.279,0.242,0.436,-.084,
     c 0.593,0.389,0.393,-.018,0.127,0.444,0.276,0.240,0.436,-.085,
     c 0.595,0.390,0.393,-.019,0.131,0.445,0.274,0.238,0.435,-.082,
     c 0.593,0.388,0.394,-.022,0.133,0.444,0.273,0.239,0.436,-.073,
     c 0.588,0.386,0.396,-.025,0.137,0.443,0.271,0.240,0.435,-.065,
     c 0.579,0.384,0.397,-.025,0.141,0.442,0.271,0.239,0.436,-.063,
     c 0.574,0.383,0.398,-.024,0.145,0.443,0.273,0.237,0.437,-.066,
     c 0.574,0.382,0.397,-.022,0.147,0.442,0.274,0.236,0.436,-.072,
     c 0.578,0.380,0.395,-.021,0.148,0.441,0.275,0.235,0.435,-.074,
     c 0.582,0.377,0.393,-.016,0.150,0.441,0.274,0.236,0.436,-.070,
     c 0.582,0.374,0.394,-.010,0.151,0.441,0.272,0.238,0.438,-.069,
     c 0.580,0.372,0.395,-.003,0.152,0.441,0.269,0.240,0.439,-.075,
     c 0.577,0.371,0.396,0.002,0.153,0.440,0.267,0.242,0.438,-.085,
     c 0.572,0.372,0.397,0.006,0.155,0.439,0.267,0.242,0.437,-.092,
     c 0.568,0.372,0.398,0.011,0.156,0.438,0.266,0.244,0.436,-.100,
     c 0.520,0.333,0.331,-.003,0.088,0.394,0.212,0.196,0.385,-.101,
     c 0.522,0.338,0.332,-.001,0.084,0.396,0.215,0.197,0.386,-.100,
     c 0.528,0.344,0.333,-.001,0.075,0.399,0.220,0.196,0.387,-.099,
     c 0.531,0.351,0.334,0.000,0.071,0.401,0.223,0.196,0.387,-.100,
     c 0.534,0.356,0.335,0.001,0.070,0.401,0.222,0.194,0.388,-.104,
     c 0.538,0.356,0.335,0.001,0.069,0.402,0.222,0.193,0.390,-.106,
     c 0.539,0.353,0.335,0.001,0.068,0.403,0.224,0.194,0.390,-.104,
     c 0.538,0.352,0.335,0.001,0.068,0.404,0.226,0.196,0.390,-.101,
     c 0.537,0.353,0.336,0.002,0.068,0.403,0.226,0.196,0.390,-.100,
     c 0.539,0.356,0.338,0.003,0.069,0.402,0.223,0.197,0.392,-.096,
     c 0.541,0.359,0.340,0.006,0.071,0.403,0.222,0.201,0.396,-.091,
     c 0.539,0.360,0.342,0.009,0.078,0.406,0.223,0.205,0.399,-.085,
     c 0.535,0.359,0.344,0.012,0.087,0.409,0.225,0.206,0.398,-.082,
     c 0.533,0.356,0.344,0.015,0.095,0.408,0.226,0.205,0.397,-.083,
     c 0.533,0.355,0.344,0.018,0.098,0.406,0.225,0.206,0.397,-.087,
     c 0.535,0.356,0.345,0.021,0.099,0.405,0.223,0.208,0.400,-.091,
     c 0.537,0.357,0.345,0.023,0.100,0.405,0.221,0.210,0.402,-.097,
     c 0.540,0.357,0.346,0.026,0.100,0.406,0.219,0.211,0.402,-.103,
     c 0.542,0.358,0.347,0.030,0.100,0.407,0.219,0.210,0.399,-.109,
     c 0.541,0.359,0.348,0.035,0.098,0.408,0.221,0.210,0.398,-.114,
     c 0.539,0.357,0.349,0.042,0.095,0.408,0.223,0.211,0.398,-.117,
     c 0.538,0.355,0.350,0.050,0.093,0.409,0.225,0.212,0.399,-.120,
     c 0.540,0.354,0.351,0.058,0.090,0.410,0.225,0.213,0.399,-.124,
     c 0.540,0.354,0.351,0.066,0.088,0.412,0.224,0.212,0.399,-.129,
     c 0.537,0.355,0.350,0.073,0.085,0.412,0.222,0.210,0.399,-.132,
     c 0.534,0.355,0.349,0.079,0.083,0.412,0.224,0.210,0.400,-.135,
     c 0.533,0.356,0.350,0.082,0.081,0.413,0.228,0.211,0.403,-.138,
     c 0.536,0.361,0.353,0.083,0.081,0.416,0.232,0.214,0.405,-.142,
     c 0.541,0.366,0.358,0.083,0.080,0.420,0.236,0.218,0.407,-.146,
     c 0.546,0.370,0.362,0.080,0.080,0.423,0.239,0.222,0.410,-.147,
     c 0.549,0.370,0.366,0.073,0.079,0.424,0.241,0.223,0.412,-.146,
     c 0.551,0.368,0.367,0.064,0.079,0.424,0.242,0.223,0.415,-.144,
     c 0.550,0.366,0.367,0.053,0.079,0.424,0.242,0.223,0.419,-.144,
     c 0.549,0.366,0.366,0.042,0.079,0.424,0.243,0.223,0.422,-.145,
     c 0.549,0.369,0.367,0.032,0.081,0.425,0.245,0.225,0.423,-.145,
     c 0.554,0.373,0.370,0.023,0.083,0.427,0.248,0.229,0.425,-.144,
     c 0.561,0.377,0.373,0.017,0.087,0.429,0.251,0.232,0.427,-.144,
     c 0.569,0.380,0.376,0.013,0.091,0.433,0.256,0.234,0.431,-.144,
     c 0.573,0.379,0.379,0.009,0.096,0.435,0.261,0.235,0.433,-.143,
     c 0.574,0.377,0.382,0.007,0.100,0.436,0.264,0.233,0.432,-.142,
     c 0.573,0.376,0.384,0.004,0.103,0.435,0.265,0.231,0.431,-.142,
     c 0.574,0.378,0.385,0.002,0.105,0.436,0.264,0.230,0.430,-.142,
     c 0.574,0.380,0.384,-.001,0.107,0.438,0.265,0.232,0.431,-.141,
     c 0.575,0.381,0.384,-.004,0.108,0.441,0.267,0.235,0.432,-.141,
     c 0.576,0.378,0.385,-.007,0.111,0.443,0.269,0.238,0.432,-.141,
     c 0.579,0.375,0.387,-.007,0.115,0.444,0.270,0.239,0.432,-.136,
     c 0.581,0.374,0.389,-.006,0.119,0.444,0.271,0.240,0.433,-.123,
     c 0.583,0.377,0.390,-.006,0.121,0.444,0.273,0.242,0.435,-.110,
     c 0.582,0.381,0.392,-.008,0.121,0.444,0.276,0.243,0.437,-.100,
     c 0.583,0.385,0.394,-.011,0.122,0.445,0.278,0.244,0.438,-.093,
     c 0.586,0.387,0.394,-.013,0.125,0.444,0.277,0.244,0.436,-.092,
     c 0.589,0.389,0.393,-.014,0.128,0.443,0.275,0.242,0.435,-.093,
     c 0.591,0.390,0.393,-.016,0.132,0.443,0.273,0.240,0.435,-.092,
     c 0.590,0.389,0.394,-.018,0.134,0.443,0.272,0.241,0.435,-.085,
     c 0.585,0.386,0.395,-.020,0.137,0.442,0.271,0.242,0.434,-.080,
     c 0.578,0.384,0.396,-.021,0.140,0.441,0.270,0.241,0.434,-.078,
     c 0.574,0.383,0.397,-.019,0.144,0.441,0.271,0.238,0.435,-.082,
     c 0.575,0.383,0.397,-.018,0.145,0.441,0.273,0.237,0.435,-.088,
     c 0.578,0.381,0.395,-.015,0.146,0.440,0.274,0.236,0.435,-.090,
     c 0.580,0.378,0.393,-.011,0.147,0.440,0.273,0.237,0.436,-.087,
     c 0.580,0.375,0.393,-.005,0.148,0.440,0.270,0.239,0.437,-.086,
     c 0.577,0.372,0.395,0.002,0.149,0.440,0.268,0.240,0.438,-.091,
     c 0.574,0.371,0.396,0.006,0.150,0.438,0.266,0.241,0.437,-.098,
     c 0.570,0.371,0.396,0.008,0.152,0.438,0.266,0.241,0.436,-.101,
     c 0.567,0.370,0.397,0.012,0.154,0.437,0.266,0.241,0.435,-.106,
     c 0.525,0.341,0.334,-.001,0.089,0.398,0.212,0.199,0.390,-.097,
     c 0.526,0.345,0.335,0.000,0.084,0.400,0.216,0.200,0.390,-.097,
     c 0.530,0.349,0.334,-.001,0.075,0.404,0.222,0.201,0.389,-.094,
     c 0.531,0.354,0.335,-.001,0.069,0.406,0.225,0.202,0.389,-.093,
     c 0.533,0.358,0.336,0.000,0.067,0.406,0.225,0.200,0.389,-.097,
     c 0.536,0.356,0.335,0.000,0.065,0.407,0.226,0.199,0.391,-.098,
     c 0.536,0.353,0.335,0.000,0.064,0.409,0.228,0.202,0.392,-.096,
     c 0.535,0.351,0.336,0.001,0.063,0.410,0.230,0.204,0.393,-.092,
     c 0.536,0.353,0.337,0.002,0.064,0.410,0.229,0.205,0.393,-.090,
     c 0.540,0.358,0.338,0.004,0.066,0.408,0.225,0.205,0.394,-.088,
     c 0.543,0.363,0.340,0.008,0.070,0.408,0.223,0.207,0.398,-.083,
     c 0.542,0.365,0.344,0.012,0.077,0.410,0.223,0.211,0.401,-.079,
     c 0.538,0.364,0.346,0.017,0.087,0.412,0.225,0.213,0.401,-.076,
     c 0.536,0.360,0.348,0.021,0.095,0.412,0.226,0.213,0.401,-.077,
     c 0.536,0.358,0.347,0.026,0.100,0.410,0.225,0.214,0.403,-.080,
     c 0.536,0.358,0.347,0.030,0.101,0.408,0.224,0.216,0.408,-.083,
     c 0.536,0.359,0.347,0.033,0.102,0.409,0.222,0.218,0.410,-.087,
     c 0.539,0.361,0.348,0.037,0.102,0.410,0.221,0.218,0.409,-.092,
     c 0.542,0.362,0.349,0.041,0.101,0.411,0.222,0.217,0.406,-.097,
     c 0.542,0.363,0.350,0.047,0.099,0.411,0.223,0.216,0.405,-.101,
     c 0.541,0.361,0.351,0.053,0.095,0.411,0.225,0.216,0.404,-.105,
     c 0.539,0.358,0.352,0.060,0.092,0.411,0.225,0.217,0.404,-.108,
     c 0.539,0.357,0.353,0.067,0.089,0.412,0.225,0.217,0.403,-.113,
     c 0.538,0.356,0.353,0.073,0.087,0.414,0.223,0.216,0.402,-.117,
     c 0.534,0.356,0.351,0.079,0.085,0.414,0.223,0.215,0.402,-.119,
     c 0.530,0.357,0.349,0.082,0.082,0.414,0.224,0.215,0.404,-.121,
     c 0.531,0.359,0.349,0.084,0.079,0.415,0.228,0.216,0.406,-.124,
     c 0.536,0.363,0.351,0.084,0.078,0.418,0.232,0.219,0.408,-.130,
     c 0.542,0.368,0.354,0.084,0.077,0.421,0.235,0.221,0.409,-.135,
     c 0.547,0.373,0.359,0.082,0.076,0.424,0.237,0.224,0.411,-.139,
     c 0.549,0.373,0.362,0.076,0.075,0.425,0.239,0.224,0.413,-.139,
     c 0.550,0.371,0.364,0.068,0.075,0.425,0.239,0.223,0.417,-.139,
     c 0.550,0.369,0.364,0.058,0.074,0.424,0.239,0.222,0.421,-.139,
     c 0.548,0.369,0.364,0.047,0.075,0.424,0.240,0.223,0.425,-.138,
     c 0.545,0.372,0.365,0.037,0.076,0.426,0.242,0.225,0.428,-.136,
     c 0.546,0.375,0.368,0.028,0.079,0.428,0.246,0.228,0.429,-.133,
     c 0.551,0.378,0.372,0.021,0.083,0.431,0.249,0.230,0.430,-.132,
     c 0.558,0.380,0.374,0.015,0.088,0.433,0.253,0.231,0.431,-.135,
     c 0.565,0.379,0.376,0.011,0.093,0.434,0.257,0.230,0.432,-.138,
     c 0.569,0.377,0.379,0.007,0.097,0.435,0.260,0.229,0.432,-.141,
     c 0.571,0.377,0.382,0.004,0.100,0.434,0.261,0.228,0.431,-.142,
     c 0.572,0.379,0.384,0.000,0.102,0.435,0.262,0.229,0.432,-.142,
     c 0.573,0.382,0.385,-.003,0.104,0.438,0.264,0.233,0.434,-.143,
     c 0.572,0.384,0.385,-.007,0.106,0.441,0.267,0.237,0.435,-.145,
     c 0.573,0.381,0.387,-.009,0.109,0.443,0.269,0.240,0.435,-.147,
     c 0.576,0.378,0.388,-.009,0.115,0.443,0.269,0.242,0.434,-.141,
     c 0.579,0.377,0.388,-.006,0.121,0.442,0.269,0.242,0.434,-.128,
     c 0.580,0.380,0.389,-.005,0.124,0.442,0.270,0.243,0.436,-.115,
     c 0.580,0.385,0.391,-.006,0.125,0.442,0.273,0.244,0.438,-.106,
     c 0.581,0.388,0.393,-.008,0.125,0.443,0.275,0.245,0.438,-.099,
     c 0.584,0.390,0.393,-.009,0.128,0.442,0.274,0.245,0.437,-.099,
     c 0.586,0.391,0.392,-.010,0.131,0.441,0.272,0.244,0.435,-.102,
     c 0.587,0.392,0.392,-.012,0.134,0.441,0.271,0.242,0.435,-.102,
     c 0.586,0.390,0.393,-.014,0.136,0.441,0.271,0.243,0.435,-.097,
     c 0.582,0.387,0.393,-.016,0.138,0.439,0.269,0.244,0.434,-.094,
     c 0.577,0.385,0.394,-.016,0.140,0.438,0.268,0.242,0.434,-.095,
     c 0.574,0.385,0.396,-.015,0.143,0.439,0.269,0.239,0.434,-.098,
     c 0.575,0.384,0.395,-.013,0.144,0.439,0.271,0.238,0.435,-.104,
     c 0.577,0.382,0.394,-.010,0.145,0.438,0.272,0.237,0.436,-.107,
     c 0.578,0.379,0.392,-.006,0.145,0.438,0.271,0.238,0.437,-.104,
     c 0.577,0.376,0.392,0.000,0.147,0.438,0.268,0.240,0.438,-.103,
     c 0.574,0.373,0.394,0.006,0.147,0.437,0.266,0.241,0.438,-.107,
     c 0.571,0.371,0.395,0.010,0.148,0.436,0.264,0.240,0.437,-.110,
     c 0.568,0.370,0.395,0.010,0.151,0.436,0.265,0.239,0.436,-.109,
     c 0.565,0.368,0.395,0.013,0.153,0.436,0.264,0.239,0.435,-.111,
     c 0.530,0.350,0.338,0.002,0.092,0.401,0.213,0.202,0.392,-.094,
     c 0.529,0.353,0.339,0.002,0.087,0.403,0.217,0.205,0.393,-.093,
     c 0.527,0.354,0.337,0.001,0.078,0.408,0.224,0.209,0.393,-.089,
     c 0.526,0.358,0.338,0.001,0.072,0.410,0.228,0.210,0.392,-.087,
     c 0.527,0.360,0.339,0.001,0.069,0.411,0.229,0.209,0.392,-.090,
     c 0.529,0.358,0.339,0.001,0.067,0.412,0.230,0.210,0.393,-.090,
     c 0.530,0.354,0.339,0.001,0.065,0.415,0.233,0.213,0.395,-.087,
     c 0.530,0.352,0.340,0.002,0.065,0.416,0.234,0.215,0.395,-.083,
     c 0.533,0.357,0.340,0.004,0.067,0.415,0.232,0.214,0.395,-.082,
     c 0.538,0.363,0.340,0.006,0.070,0.413,0.227,0.212,0.395,-.082,
     c 0.542,0.370,0.342,0.010,0.075,0.413,0.224,0.214,0.399,-.080,
     c 0.542,0.372,0.345,0.016,0.082,0.415,0.224,0.218,0.402,-.078,
     c 0.540,0.370,0.349,0.021,0.090,0.416,0.226,0.220,0.403,-.076,
     c 0.539,0.365,0.351,0.027,0.097,0.415,0.227,0.220,0.404,-.076,
     c 0.537,0.361,0.351,0.033,0.102,0.413,0.227,0.221,0.407,-.077,
     c 0.537,0.361,0.350,0.037,0.104,0.412,0.226,0.223,0.413,-.079,
     c 0.536,0.362,0.350,0.042,0.105,0.412,0.225,0.224,0.415,-.081,
     c 0.539,0.364,0.350,0.046,0.105,0.413,0.224,0.224,0.413,-.083,
     c 0.542,0.365,0.350,0.050,0.103,0.414,0.225,0.223,0.410,-.085,
     c 0.544,0.367,0.351,0.055,0.100,0.414,0.226,0.222,0.409,-.088,
     c 0.543,0.365,0.352,0.060,0.097,0.413,0.226,0.222,0.409,-.092,
     c 0.541,0.362,0.353,0.065,0.093,0.413,0.226,0.221,0.407,-.098,
     c 0.539,0.360,0.354,0.070,0.091,0.413,0.225,0.221,0.405,-.104,
     c 0.535,0.359,0.354,0.074,0.089,0.415,0.224,0.220,0.404,-.107,
     c 0.530,0.360,0.353,0.077,0.086,0.416,0.224,0.220,0.405,-.107,
     c 0.526,0.360,0.351,0.078,0.083,0.416,0.226,0.221,0.407,-.107,
     c 0.528,0.362,0.351,0.078,0.080,0.417,0.230,0.222,0.410,-.110,
     c 0.535,0.366,0.352,0.078,0.077,0.419,0.233,0.222,0.411,-.116,
     c 0.541,0.371,0.354,0.077,0.076,0.422,0.235,0.224,0.411,-.122,
     c 0.544,0.375,0.357,0.075,0.076,0.424,0.236,0.226,0.413,-.128,
     c 0.546,0.376,0.360,0.071,0.075,0.424,0.237,0.226,0.415,-.132,
     c 0.547,0.374,0.362,0.064,0.074,0.424,0.237,0.225,0.418,-.133,
     c 0.546,0.372,0.362,0.056,0.074,0.424,0.236,0.223,0.422,-.134,
     c 0.543,0.372,0.363,0.047,0.074,0.425,0.237,0.224,0.427,-.132,
     c 0.537,0.374,0.365,0.037,0.076,0.427,0.241,0.226,0.431,-.128,
     c 0.534,0.377,0.369,0.028,0.079,0.429,0.245,0.228,0.432,-.124,
     c 0.537,0.379,0.372,0.021,0.083,0.432,0.249,0.230,0.432,-.125,
     c 0.545,0.381,0.374,0.015,0.088,0.434,0.252,0.229,0.431,-.130,
     c 0.554,0.380,0.376,0.010,0.093,0.434,0.255,0.228,0.431,-.136,
     c 0.562,0.379,0.378,0.005,0.097,0.434,0.256,0.227,0.432,-.141,
     c 0.567,0.380,0.382,0.001,0.101,0.434,0.258,0.226,0.432,-.144,
     c 0.570,0.383,0.384,-.002,0.103,0.434,0.260,0.228,0.434,-.144,
     c 0.569,0.386,0.386,-.006,0.105,0.436,0.263,0.233,0.436,-.144,
     c 0.569,0.389,0.388,-.009,0.107,0.439,0.267,0.239,0.437,-.148,
     c 0.570,0.387,0.389,-.011,0.110,0.442,0.269,0.242,0.437,-.151,
     c 0.573,0.383,0.389,-.009,0.116,0.441,0.269,0.243,0.435,-.145,
     c 0.575,0.381,0.388,-.005,0.124,0.440,0.267,0.243,0.435,-.132,
     c 0.577,0.384,0.388,-.003,0.128,0.440,0.268,0.243,0.436,-.119,
     c 0.577,0.389,0.390,-.003,0.128,0.440,0.271,0.245,0.438,-.111,
     c 0.578,0.391,0.392,-.004,0.129,0.441,0.273,0.246,0.439,-.106,
     c 0.581,0.393,0.393,-.005,0.131,0.440,0.272,0.247,0.437,-.107,
     c 0.582,0.393,0.392,-.007,0.134,0.439,0.270,0.245,0.435,-.111,
     c 0.583,0.393,0.392,-.008,0.136,0.439,0.270,0.244,0.435,-.112,
     c 0.582,0.392,0.393,-.009,0.138,0.439,0.270,0.245,0.435,-.109,
     c 0.579,0.389,0.393,-.011,0.139,0.437,0.268,0.245,0.434,-.109,
     c 0.575,0.386,0.394,-.011,0.140,0.436,0.267,0.244,0.433,-.111,
     c 0.573,0.386,0.395,-.010,0.143,0.436,0.268,0.240,0.434,-.113,
     c 0.575,0.385,0.395,-.008,0.144,0.436,0.270,0.238,0.435,-.119,
     c 0.576,0.383,0.393,-.005,0.143,0.436,0.270,0.238,0.436,-.123,
     c 0.575,0.381,0.392,-.001,0.143,0.436,0.269,0.240,0.438,-.121,
     c 0.573,0.378,0.392,0.005,0.144,0.436,0.267,0.241,0.438,-.120,
     c 0.570,0.374,0.394,0.011,0.145,0.435,0.265,0.241,0.438,-.123,
     c 0.567,0.371,0.394,0.013,0.146,0.434,0.264,0.239,0.437,-.123,
     c 0.566,0.371,0.394,0.012,0.150,0.434,0.264,0.238,0.435,-.117,
     c 0.563,0.368,0.394,0.013,0.153,0.434,0.263,0.237,0.434,-.115,
     c 0.533,0.357,0.343,0.005,0.097,0.403,0.214,0.208,0.395,-.091,
     c 0.531,0.359,0.343,0.005,0.093,0.406,0.218,0.211,0.396,-.090,
     c 0.527,0.361,0.343,0.004,0.085,0.411,0.225,0.216,0.397,-.086,
     c 0.524,0.364,0.344,0.004,0.079,0.413,0.228,0.218,0.396,-.085,
     c 0.523,0.365,0.344,0.004,0.076,0.414,0.229,0.218,0.396,-.087,
     c 0.526,0.362,0.344,0.003,0.075,0.416,0.230,0.219,0.397,-.086,
     c 0.528,0.358,0.345,0.004,0.075,0.418,0.234,0.223,0.399,-.082,
     c 0.530,0.357,0.346,0.005,0.075,0.420,0.235,0.225,0.400,-.078,
     c 0.534,0.362,0.346,0.007,0.077,0.419,0.233,0.223,0.399,-.077,
     c 0.540,0.370,0.345,0.009,0.081,0.418,0.228,0.220,0.399,-.079,
     c 0.543,0.377,0.345,0.013,0.085,0.418,0.226,0.221,0.402,-.079,
     c 0.543,0.379,0.347,0.019,0.091,0.420,0.226,0.225,0.404,-.078,
     c 0.543,0.377,0.351,0.025,0.096,0.421,0.227,0.227,0.404,-.077,
     c 0.543,0.372,0.352,0.031,0.101,0.419,0.228,0.227,0.405,-.077,
     c 0.542,0.368,0.353,0.036,0.104,0.418,0.229,0.228,0.409,-.077,
     c 0.541,0.367,0.353,0.041,0.106,0.416,0.228,0.229,0.413,-.078,
     c 0.539,0.368,0.352,0.045,0.107,0.416,0.227,0.228,0.415,-.078,
     c 0.540,0.369,0.353,0.049,0.107,0.416,0.227,0.227,0.413,-.078,
     c 0.543,0.370,0.352,0.053,0.106,0.417,0.227,0.226,0.411,-.078,
     c 0.545,0.371,0.352,0.056,0.103,0.416,0.228,0.226,0.410,-.080,
     c 0.544,0.370,0.352,0.059,0.099,0.415,0.228,0.226,0.411,-.084,
     c 0.541,0.367,0.353,0.062,0.096,0.414,0.226,0.225,0.409,-.092,
     c 0.537,0.363,0.354,0.064,0.094,0.414,0.225,0.224,0.406,-.099,
     c 0.532,0.362,0.354,0.066,0.092,0.415,0.225,0.224,0.405,-.102,
     c 0.527,0.363,0.354,0.067,0.090,0.416,0.226,0.224,0.407,-.101,
     c 0.525,0.363,0.354,0.066,0.086,0.416,0.229,0.226,0.411,-.099,
     c 0.528,0.365,0.354,0.065,0.082,0.417,0.232,0.226,0.414,-.100,
     c 0.534,0.368,0.354,0.064,0.080,0.418,0.234,0.227,0.414,-.105,
     c 0.538,0.373,0.355,0.064,0.079,0.420,0.235,0.228,0.414,-.111,
     c 0.540,0.378,0.358,0.062,0.079,0.421,0.235,0.229,0.415,-.118,
     c 0.541,0.379,0.360,0.059,0.079,0.422,0.234,0.229,0.417,-.123,
     c 0.542,0.377,0.361,0.054,0.079,0.423,0.234,0.228,0.420,-.126,
     c 0.543,0.375,0.361,0.048,0.078,0.423,0.234,0.226,0.424,-.126,
     c 0.539,0.374,0.363,0.040,0.077,0.425,0.235,0.226,0.429,-.124,
     c 0.532,0.377,0.366,0.032,0.078,0.427,0.239,0.228,0.432,-.121,
     c 0.528,0.380,0.370,0.024,0.081,0.431,0.244,0.231,0.434,-.119,
     c 0.530,0.382,0.373,0.017,0.085,0.433,0.249,0.232,0.434,-.120,
     c 0.537,0.382,0.375,0.012,0.090,0.434,0.252,0.232,0.432,-.126,
     c 0.547,0.382,0.376,0.006,0.095,0.434,0.254,0.231,0.432,-.133,
     c 0.556,0.382,0.379,0.002,0.100,0.434,0.255,0.230,0.433,-.139,
     c 0.562,0.384,0.382,-.002,0.103,0.433,0.257,0.229,0.434,-.142,
     c 0.565,0.387,0.384,-.005,0.105,0.432,0.259,0.230,0.436,-.142,
     c 0.565,0.391,0.387,-.008,0.107,0.433,0.263,0.235,0.438,-.142,
     c 0.565,0.394,0.389,-.011,0.109,0.436,0.267,0.240,0.439,-.147,
     c 0.567,0.394,0.391,-.012,0.113,0.438,0.269,0.244,0.439,-.151,
     c 0.571,0.390,0.390,-.009,0.119,0.438,0.268,0.244,0.436,-.146,
     c 0.574,0.386,0.388,-.004,0.127,0.437,0.266,0.243,0.435,-.134,
     c 0.575,0.387,0.388,-.001,0.131,0.437,0.266,0.244,0.437,-.123,
     c 0.575,0.391,0.390,-.001,0.131,0.438,0.269,0.246,0.439,-.117,
     c 0.576,0.394,0.392,-.001,0.132,0.439,0.271,0.248,0.439,-.112,
     c 0.578,0.395,0.393,-.002,0.134,0.439,0.270,0.248,0.437,-.114,
     c 0.579,0.394,0.393,-.003,0.136,0.437,0.269,0.247,0.436,-.120,
     c 0.579,0.394,0.393,-.004,0.138,0.437,0.270,0.246,0.435,-.122,
     c 0.579,0.392,0.392,-.005,0.139,0.437,0.270,0.247,0.435,-.121,
     c 0.576,0.389,0.392,-.007,0.139,0.435,0.268,0.247,0.433,-.123,
     c 0.574,0.386,0.393,-.007,0.140,0.433,0.266,0.245,0.432,-.127,
     c 0.573,0.386,0.394,-.005,0.142,0.434,0.267,0.242,0.433,-.130,
     c 0.575,0.385,0.395,-.003,0.142,0.434,0.269,0.239,0.435,-.136,
     c 0.575,0.384,0.394,0.000,0.142,0.434,0.269,0.239,0.437,-.140,
     c 0.574,0.381,0.392,0.004,0.141,0.433,0.268,0.241,0.439,-.139,
     c 0.571,0.378,0.392,0.010,0.142,0.433,0.266,0.242,0.439,-.137,
     c 0.568,0.375,0.393,0.014,0.143,0.432,0.263,0.241,0.438,-.138,
     c 0.566,0.372,0.393,0.015,0.145,0.432,0.263,0.238,0.437,-.134,
     c 0.565,0.371,0.392,0.011,0.151,0.433,0.262,0.236,0.435,-.121,
     c 0.562,0.368,0.392,0.012,0.153,0.433,0.262,0.235,0.434,-.116,
     c 0.537,0.367,0.349,0.011,0.105,0.406,0.217,0.215,0.399,-.088,
     c 0.535,0.368,0.349,0.011,0.102,0.410,0.221,0.218,0.401,-.086,
     c 0.531,0.371,0.349,0.010,0.095,0.414,0.224,0.224,0.403,-.083,
     c 0.527,0.374,0.350,0.009,0.091,0.417,0.227,0.226,0.404,-.082,
     c 0.526,0.373,0.351,0.009,0.089,0.419,0.228,0.226,0.405,-.084,
     c 0.529,0.369,0.351,0.008,0.089,0.420,0.230,0.228,0.407,-.083,
     c 0.532,0.365,0.353,0.008,0.089,0.423,0.234,0.233,0.409,-.078,
     c 0.536,0.366,0.354,0.010,0.091,0.425,0.236,0.235,0.411,-.073,
     c 0.540,0.372,0.354,0.011,0.093,0.425,0.235,0.233,0.410,-.073,
     c 0.544,0.379,0.351,0.013,0.096,0.424,0.232,0.231,0.409,-.075,
     c 0.546,0.385,0.350,0.017,0.099,0.425,0.231,0.232,0.410,-.078,
     c 0.546,0.386,0.351,0.021,0.102,0.426,0.231,0.234,0.410,-.078,
     c 0.546,0.385,0.353,0.026,0.104,0.426,0.232,0.237,0.410,-.078,
     c 0.549,0.381,0.354,0.031,0.106,0.425,0.232,0.237,0.409,-.076,
     c 0.549,0.378,0.355,0.036,0.108,0.423,0.233,0.237,0.412,-.075,
     c 0.548,0.377,0.355,0.040,0.110,0.422,0.233,0.237,0.415,-.076,
     c 0.545,0.377,0.356,0.043,0.112,0.422,0.231,0.235,0.416,-.076,
     c 0.543,0.377,0.357,0.046,0.112,0.422,0.230,0.233,0.414,-.076,
     c 0.544,0.377,0.356,0.048,0.110,0.422,0.230,0.232,0.413,-.075,
     c 0.544,0.378,0.356,0.049,0.107,0.421,0.231,0.232,0.413,-.076,
     c 0.542,0.378,0.355,0.050,0.104,0.419,0.231,0.232,0.414,-.081,
     c 0.539,0.374,0.354,0.051,0.101,0.417,0.229,0.230,0.412,-.089,
     c 0.535,0.370,0.354,0.051,0.100,0.416,0.227,0.228,0.410,-.098,
     c 0.531,0.368,0.355,0.051,0.098,0.416,0.226,0.227,0.409,-.103,
     c 0.527,0.368,0.356,0.050,0.095,0.417,0.228,0.228,0.412,-.101,
     c 0.526,0.368,0.357,0.049,0.092,0.417,0.231,0.230,0.417,-.098,
     c 0.530,0.369,0.357,0.047,0.087,0.417,0.234,0.231,0.419,-.097,
     c 0.535,0.372,0.357,0.046,0.085,0.418,0.235,0.231,0.420,-.100,
     c 0.538,0.377,0.358,0.045,0.085,0.419,0.236,0.232,0.419,-.105,
     c 0.538,0.383,0.360,0.045,0.086,0.421,0.236,0.234,0.420,-.110,
     c 0.538,0.386,0.361,0.043,0.087,0.422,0.235,0.234,0.421,-.114,
     c 0.540,0.383,0.361,0.040,0.086,0.424,0.235,0.233,0.423,-.116,
     c 0.541,0.380,0.362,0.036,0.085,0.425,0.234,0.232,0.426,-.116,
     c 0.539,0.380,0.365,0.031,0.084,0.426,0.235,0.231,0.429,-.115,
     c 0.534,0.383,0.369,0.024,0.084,0.428,0.239,0.232,0.433,-.113,
     c 0.530,0.386,0.373,0.019,0.086,0.432,0.244,0.236,0.436,-.113,
     c 0.531,0.388,0.375,0.013,0.090,0.434,0.249,0.238,0.435,-.115,
     c 0.537,0.388,0.377,0.009,0.094,0.435,0.253,0.239,0.435,-.121,
     c 0.545,0.387,0.378,0.004,0.099,0.434,0.254,0.239,0.436,-.128,
     c 0.552,0.388,0.380,-.000,0.104,0.434,0.255,0.238,0.438,-.133,
     c 0.557,0.389,0.382,-.004,0.108,0.433,0.257,0.237,0.438,-.136,
     c 0.559,0.393,0.385,-.006,0.110,0.432,0.259,0.236,0.438,-.136,
     c 0.559,0.396,0.387,-.008,0.112,0.432,0.263,0.238,0.439,-.137,
     c 0.561,0.400,0.390,-.010,0.114,0.433,0.266,0.242,0.440,-.142,
     c 0.565,0.402,0.393,-.011,0.118,0.435,0.268,0.245,0.440,-.148,
     c 0.570,0.397,0.391,-.007,0.124,0.435,0.266,0.245,0.437,-.145,
     c 0.573,0.393,0.389,-.001,0.131,0.435,0.264,0.245,0.436,-.135,
     c 0.573,0.392,0.388,0.002,0.135,0.435,0.265,0.245,0.438,-.127,
     c 0.573,0.395,0.391,0.002,0.136,0.437,0.268,0.247,0.441,-.123,
     c 0.576,0.398,0.393,0.003,0.137,0.439,0.270,0.250,0.441,-.119,
     c 0.577,0.399,0.394,0.003,0.138,0.438,0.269,0.251,0.439,-.122,
     c 0.577,0.397,0.394,0.002,0.139,0.436,0.269,0.250,0.437,-.129,
     c 0.576,0.396,0.394,0.001,0.141,0.435,0.270,0.249,0.436,-.133,
     c 0.576,0.394,0.393,-.000,0.141,0.435,0.270,0.251,0.436,-.134,
     c 0.575,0.392,0.393,-.001,0.141,0.434,0.268,0.250,0.434,-.138,
     c 0.573,0.388,0.393,-.001,0.141,0.432,0.266,0.248,0.433,-.143,
     c 0.574,0.388,0.395,0.001,0.142,0.432,0.267,0.244,0.434,-.147,
     c 0.577,0.387,0.395,0.003,0.143,0.432,0.268,0.241,0.436,-.153,
     c 0.577,0.387,0.394,0.006,0.142,0.432,0.268,0.241,0.438,-.156,
     c 0.575,0.385,0.392,0.009,0.142,0.432,0.267,0.242,0.439,-.154,
     c 0.572,0.382,0.391,0.012,0.143,0.432,0.265,0.243,0.439,-.151,
     c 0.570,0.378,0.391,0.015,0.144,0.431,0.263,0.241,0.438,-.148,
     c 0.567,0.375,0.391,0.015,0.147,0.431,0.262,0.238,0.437,-.140,
     c 0.566,0.374,0.391,0.010,0.153,0.433,0.262,0.236,0.435,-.122,
     c 0.562,0.371,0.391,0.010,0.156,0.434,0.261,0.234,0.434,-.115,
     c 0.540,0.372,0.355,0.017,0.113,0.410,0.221,0.221,0.404,-.084,
     c 0.537,0.374,0.354,0.017,0.111,0.414,0.224,0.225,0.406,-.082,
     c 0.536,0.379,0.354,0.016,0.108,0.418,0.226,0.230,0.409,-.079,
     c 0.531,0.380,0.354,0.016,0.105,0.421,0.228,0.232,0.411,-.078,
     c 0.530,0.378,0.354,0.015,0.104,0.422,0.229,0.233,0.413,-.080,
     c 0.532,0.373,0.355,0.014,0.104,0.424,0.230,0.235,0.415,-.078,
     c 0.536,0.370,0.357,0.014,0.105,0.427,0.234,0.239,0.419,-.073,
     c 0.540,0.371,0.359,0.014,0.106,0.429,0.237,0.242,0.421,-.067,
     c 0.544,0.377,0.360,0.015,0.108,0.430,0.237,0.241,0.420,-.067,
     c 0.547,0.383,0.357,0.016,0.109,0.430,0.236,0.239,0.419,-.071,
     c 0.546,0.387,0.354,0.017,0.111,0.430,0.235,0.240,0.418,-.074,
     c 0.544,0.389,0.354,0.020,0.112,0.431,0.236,0.242,0.418,-.076,
     c 0.545,0.387,0.354,0.023,0.112,0.431,0.235,0.244,0.416,-.076,
     c 0.550,0.385,0.354,0.027,0.113,0.430,0.236,0.245,0.415,-.075,
     c 0.553,0.383,0.355,0.030,0.114,0.429,0.237,0.245,0.417,-.074,
     c 0.553,0.382,0.356,0.032,0.115,0.429,0.238,0.243,0.419,-.075,
     c 0.549,0.382,0.358,0.035,0.117,0.429,0.236,0.240,0.419,-.076,
     c 0.546,0.381,0.359,0.036,0.118,0.429,0.234,0.237,0.417,-.076,
     c 0.542,0.381,0.359,0.035,0.116,0.427,0.234,0.237,0.416,-.075,
     c 0.539,0.382,0.358,0.034,0.113,0.426,0.235,0.237,0.417,-.075,
     c 0.535,0.382,0.357,0.033,0.110,0.424,0.235,0.237,0.418,-.080,
     c 0.532,0.379,0.355,0.031,0.107,0.421,0.233,0.234,0.417,-.088,
     c 0.530,0.375,0.355,0.029,0.105,0.418,0.230,0.231,0.415,-.098,
     c 0.528,0.372,0.355,0.027,0.104,0.417,0.229,0.229,0.415,-.103,
     c 0.528,0.370,0.356,0.026,0.101,0.417,0.229,0.230,0.417,-.103,
     c 0.530,0.370,0.358,0.024,0.097,0.417,0.230,0.231,0.421,-.100,
     c 0.534,0.370,0.358,0.023,0.093,0.417,0.233,0.232,0.423,-.098,
     c 0.538,0.372,0.359,0.022,0.091,0.418,0.234,0.233,0.424,-.100,
     c 0.540,0.379,0.360,0.022,0.091,0.420,0.236,0.234,0.423,-.102,
     c 0.539,0.385,0.361,0.023,0.092,0.421,0.237,0.235,0.423,-.104,
     c 0.538,0.388,0.361,0.023,0.093,0.423,0.238,0.236,0.424,-.106,
     c 0.539,0.386,0.361,0.022,0.093,0.425,0.237,0.236,0.425,-.106,
     c 0.541,0.383,0.362,0.021,0.092,0.426,0.235,0.234,0.426,-.106,
     c 0.540,0.383,0.365,0.018,0.091,0.427,0.235,0.232,0.428,-.106,
     c 0.537,0.387,0.369,0.014,0.091,0.428,0.238,0.233,0.431,-.106,
     c 0.535,0.392,0.373,0.011,0.092,0.431,0.243,0.236,0.433,-.107,
     c 0.537,0.393,0.376,0.008,0.095,0.433,0.247,0.239,0.434,-.110,
     c 0.541,0.391,0.377,0.005,0.100,0.433,0.250,0.242,0.434,-.115,
     c 0.546,0.390,0.379,0.002,0.105,0.433,0.252,0.244,0.437,-.121,
     c 0.550,0.391,0.381,-.001,0.110,0.434,0.254,0.244,0.439,-.125,
     c 0.552,0.392,0.382,-.004,0.113,0.433,0.255,0.242,0.440,-.127,
     c 0.553,0.395,0.384,-.006,0.115,0.431,0.257,0.240,0.438,-.128,
     c 0.553,0.398,0.385,-.008,0.117,0.430,0.260,0.240,0.438,-.131,
     c 0.556,0.402,0.388,-.009,0.119,0.430,0.263,0.243,0.438,-.137,
     c 0.561,0.405,0.392,-.009,0.123,0.431,0.265,0.245,0.438,-.144,
     c 0.567,0.401,0.390,-.005,0.129,0.432,0.263,0.246,0.437,-.143,
     c 0.570,0.396,0.388,0.001,0.136,0.432,0.262,0.245,0.436,-.136,
     c 0.571,0.394,0.388,0.004,0.139,0.433,0.263,0.245,0.438,-.131,
     c 0.571,0.398,0.391,0.005,0.139,0.435,0.266,0.247,0.441,-.129,
     c 0.573,0.400,0.393,0.006,0.140,0.437,0.267,0.250,0.441,-.127,
     c 0.574,0.400,0.394,0.006,0.141,0.436,0.267,0.251,0.439,-.130,
     c 0.574,0.398,0.394,0.006,0.141,0.434,0.267,0.251,0.437,-.138,
     c 0.573,0.396,0.394,0.005,0.143,0.433,0.269,0.251,0.437,-.144,
     c 0.573,0.395,0.393,0.005,0.143,0.433,0.270,0.252,0.436,-.147,
     c 0.572,0.392,0.392,0.004,0.143,0.432,0.268,0.251,0.435,-.151,
     c 0.572,0.389,0.392,0.004,0.143,0.430,0.266,0.248,0.433,-.156,
     c 0.575,0.389,0.394,0.005,0.145,0.431,0.266,0.244,0.434,-.159,
     c 0.579,0.389,0.395,0.006,0.145,0.431,0.266,0.241,0.435,-.163,
     c 0.580,0.389,0.394,0.008,0.145,0.431,0.266,0.240,0.437,-.165,
     c 0.579,0.388,0.391,0.009,0.145,0.431,0.264,0.242,0.437,-.161,
     c 0.577,0.386,0.388,0.009,0.146,0.430,0.262,0.242,0.436,-.154,
     c 0.574,0.382,0.387,0.010,0.148,0.430,0.261,0.239,0.434,-.148,
     c 0.570,0.379,0.387,0.009,0.151,0.431,0.260,0.235,0.434,-.137,
     c 0.564,0.376,0.389,0.007,0.156,0.433,0.260,0.234,0.432,-.119,
     c 0.560,0.372,0.390,0.007,0.159,0.434,0.260,0.231,0.432,-.111,
     c 0.541,0.377,0.360,0.023,0.122,0.416,0.226,0.229,0.408,-.080,
     c 0.538,0.379,0.359,0.023,0.121,0.420,0.228,0.232,0.410,-.079,
     c 0.539,0.384,0.358,0.023,0.121,0.425,0.230,0.237,0.415,-.075,
     c 0.536,0.385,0.357,0.023,0.120,0.428,0.232,0.240,0.417,-.074,
     c 0.534,0.382,0.357,0.022,0.119,0.429,0.232,0.240,0.419,-.075,
     c 0.536,0.377,0.358,0.021,0.118,0.430,0.234,0.242,0.421,-.072,
     c 0.540,0.374,0.361,0.020,0.119,0.432,0.236,0.245,0.424,-.068,
     c 0.545,0.376,0.363,0.019,0.119,0.435,0.239,0.247,0.425,-.064,
     c 0.548,0.382,0.363,0.019,0.120,0.436,0.240,0.247,0.424,-.065,
     c 0.548,0.387,0.361,0.018,0.120,0.435,0.240,0.247,0.423,-.068,
     c 0.545,0.390,0.358,0.017,0.120,0.436,0.240,0.247,0.422,-.072,
     c 0.541,0.390,0.357,0.017,0.120,0.435,0.239,0.248,0.421,-.075,
     c 0.540,0.389,0.357,0.018,0.120,0.435,0.238,0.249,0.420,-.076,
     c 0.545,0.388,0.356,0.019,0.119,0.435,0.238,0.250,0.419,-.076,
     c 0.551,0.387,0.356,0.021,0.120,0.435,0.240,0.250,0.421,-.075,
     c 0.555,0.387,0.357,0.022,0.121,0.436,0.242,0.248,0.422,-.076,
     c 0.553,0.386,0.359,0.023,0.123,0.436,0.240,0.245,0.421,-.077,
     c 0.548,0.385,0.361,0.022,0.124,0.435,0.239,0.243,0.421,-.078,
     c 0.541,0.384,0.362,0.019,0.122,0.434,0.239,0.243,0.421,-.077,
     c 0.535,0.385,0.361,0.015,0.119,0.433,0.241,0.244,0.422,-.076,
     c 0.529,0.385,0.359,0.010,0.115,0.430,0.240,0.244,0.423,-.079,
     c 0.525,0.384,0.358,0.006,0.112,0.427,0.238,0.241,0.423,-.085,
     c 0.524,0.380,0.357,0.003,0.111,0.423,0.235,0.237,0.421,-.094,
     c 0.525,0.376,0.357,-.000,0.109,0.421,0.232,0.233,0.420,-.100,
     c 0.528,0.374,0.357,-.001,0.107,0.420,0.230,0.232,0.421,-.101,
     c 0.533,0.373,0.359,-.003,0.103,0.420,0.230,0.232,0.424,-.100,
     c 0.538,0.373,0.359,-.004,0.099,0.420,0.231,0.234,0.425,-.099,
     c 0.542,0.374,0.360,-.004,0.097,0.421,0.233,0.235,0.426,-.099,
     c 0.543,0.380,0.361,-.002,0.097,0.423,0.236,0.237,0.426,-.099,
     c 0.541,0.386,0.362,-.000,0.098,0.424,0.239,0.238,0.425,-.099,
     c 0.539,0.389,0.361,0.002,0.099,0.426,0.240,0.237,0.425,-.099,
     c 0.539,0.386,0.361,0.003,0.099,0.427,0.239,0.236,0.425,-.099,
     c 0.541,0.384,0.362,0.004,0.099,0.428,0.237,0.234,0.425,-.099,
     c 0.541,0.386,0.365,0.005,0.098,0.428,0.236,0.232,0.425,-.100,
     c 0.541,0.392,0.368,0.004,0.097,0.429,0.237,0.232,0.427,-.101,
     c 0.542,0.397,0.372,0.004,0.099,0.431,0.240,0.235,0.429,-.101,
     c 0.545,0.399,0.375,0.004,0.102,0.432,0.244,0.239,0.430,-.104,
     c 0.548,0.397,0.377,0.003,0.106,0.433,0.247,0.242,0.432,-.108,
     c 0.550,0.395,0.380,0.001,0.111,0.433,0.249,0.245,0.434,-.112,
     c 0.551,0.396,0.381,-.001,0.116,0.434,0.250,0.247,0.438,-.115,
     c 0.551,0.398,0.382,-.003,0.119,0.433,0.252,0.246,0.438,-.118,
     c 0.551,0.399,0.382,-.005,0.120,0.431,0.254,0.243,0.436,-.121,
     c 0.551,0.401,0.383,-.006,0.121,0.429,0.256,0.241,0.434,-.125,
     c 0.553,0.404,0.386,-.007,0.123,0.428,0.259,0.243,0.434,-.133,
     c 0.559,0.407,0.389,-.006,0.127,0.429,0.261,0.246,0.435,-.141,
     c 0.565,0.405,0.389,-.002,0.133,0.429,0.259,0.246,0.434,-.142,
     c 0.568,0.400,0.388,0.002,0.139,0.431,0.259,0.246,0.435,-.139,
     c 0.568,0.398,0.388,0.006,0.141,0.432,0.261,0.246,0.438,-.136,
     c 0.569,0.401,0.391,0.007,0.141,0.434,0.264,0.248,0.441,-.135,
     c 0.571,0.404,0.393,0.009,0.142,0.436,0.265,0.251,0.441,-.134,
     c 0.572,0.403,0.394,0.010,0.143,0.435,0.265,0.253,0.439,-.138,
     c 0.572,0.400,0.395,0.010,0.144,0.434,0.267,0.253,0.437,-.145,
     c 0.570,0.399,0.394,0.010,0.146,0.434,0.270,0.253,0.437,-.149,
     c 0.569,0.397,0.393,0.010,0.147,0.434,0.271,0.254,0.437,-.151,
     c 0.569,0.395,0.391,0.009,0.148,0.433,0.269,0.253,0.435,-.153,
     c 0.569,0.393,0.392,0.009,0.148,0.432,0.267,0.250,0.434,-.156,
     c 0.574,0.393,0.394,0.008,0.151,0.432,0.266,0.245,0.433,-.157,
     c 0.580,0.393,0.395,0.008,0.152,0.432,0.265,0.242,0.434,-.160,
     c 0.584,0.394,0.394,0.007,0.153,0.433,0.263,0.242,0.434,-.159,
     c 0.583,0.393,0.390,0.006,0.153,0.433,0.262,0.243,0.432,-.153,
     c 0.581,0.391,0.387,0.005,0.153,0.432,0.261,0.242,0.430,-.144,
     c 0.577,0.387,0.385,0.004,0.154,0.431,0.260,0.238,0.429,-.136,
     c 0.572,0.383,0.385,0.002,0.156,0.432,0.259,0.234,0.429,-.126,
     c 0.563,0.379,0.388,0.003,0.159,0.434,0.259,0.232,0.429,-.112,
     c 0.558,0.375,0.388,0.002,0.161,0.435,0.258,0.230,0.428,-.103,
     c 0.539,0.380,0.363,0.028,0.131,0.422,0.230,0.239,0.414,-.076,
     c 0.537,0.382,0.363,0.029,0.131,0.425,0.232,0.241,0.416,-.075,
     c 0.539,0.387,0.363,0.030,0.134,0.433,0.236,0.245,0.421,-.073,
     c 0.536,0.389,0.362,0.030,0.134,0.435,0.237,0.247,0.422,-.073,
     c 0.535,0.385,0.362,0.029,0.132,0.434,0.237,0.247,0.422,-.073,
     c 0.537,0.380,0.363,0.028,0.131,0.434,0.237,0.247,0.424,-.070,
     c 0.542,0.379,0.365,0.026,0.131,0.436,0.238,0.249,0.424,-.067,
     c 0.547,0.381,0.367,0.024,0.131,0.439,0.240,0.250,0.425,-.065,
     c 0.550,0.387,0.367,0.022,0.130,0.439,0.241,0.251,0.424,-.067,
     c 0.549,0.391,0.366,0.020,0.130,0.439,0.243,0.251,0.424,-.069,
     c 0.543,0.394,0.364,0.017,0.130,0.439,0.244,0.252,0.424,-.072,
     c 0.536,0.395,0.363,0.014,0.129,0.438,0.242,0.252,0.423,-.075,
     c 0.533,0.394,0.362,0.012,0.127,0.437,0.238,0.252,0.422,-.078,
     c 0.537,0.393,0.360,0.011,0.126,0.436,0.238,0.252,0.422,-.080,
     c 0.545,0.393,0.360,0.011,0.126,0.436,0.240,0.252,0.423,-.079,
     c 0.552,0.393,0.360,0.011,0.127,0.437,0.242,0.250,0.424,-.079,
     c 0.552,0.392,0.362,0.009,0.128,0.438,0.242,0.248,0.424,-.079,
     c 0.548,0.390,0.364,0.006,0.129,0.438,0.241,0.247,0.424,-.079,
     c 0.540,0.388,0.365,-.000,0.127,0.437,0.243,0.249,0.426,-.078,
     c 0.532,0.388,0.364,-.007,0.124,0.436,0.244,0.251,0.427,-.076,
     c 0.524,0.388,0.363,-.013,0.120,0.434,0.244,0.251,0.428,-.077,
     c 0.520,0.387,0.362,-.019,0.118,0.431,0.242,0.248,0.428,-.081,
     c 0.519,0.384,0.361,-.024,0.116,0.428,0.239,0.243,0.427,-.087,
     c 0.521,0.381,0.360,-.027,0.116,0.425,0.236,0.239,0.426,-.092,
     c 0.526,0.379,0.360,-.029,0.114,0.423,0.233,0.236,0.426,-.095,
     c 0.532,0.378,0.361,-.030,0.111,0.423,0.231,0.235,0.426,-.095,
     c 0.538,0.377,0.361,-.030,0.107,0.423,0.231,0.236,0.426,-.095,
     c 0.541,0.377,0.362,-.029,0.106,0.424,0.233,0.239,0.427,-.095,
     c 0.541,0.381,0.363,-.027,0.105,0.425,0.236,0.240,0.427,-.094,
     c 0.539,0.386,0.363,-.024,0.106,0.426,0.239,0.240,0.427,-.092,
     c 0.538,0.388,0.363,-.020,0.106,0.427,0.241,0.238,0.426,-.091,
     c 0.538,0.386,0.362,-.016,0.107,0.429,0.239,0.236,0.426,-.091,
     c 0.540,0.385,0.363,-.012,0.107,0.429,0.237,0.234,0.424,-.092,
     c 0.542,0.389,0.365,-.008,0.106,0.429,0.235,0.231,0.424,-.094,
     c 0.544,0.397,0.368,-.005,0.106,0.429,0.236,0.231,0.425,-.094,
     c 0.548,0.403,0.371,-.002,0.107,0.430,0.239,0.233,0.427,-.094,
     c 0.552,0.405,0.374,-.000,0.110,0.431,0.241,0.237,0.428,-.096,
     c 0.554,0.404,0.377,0.001,0.114,0.431,0.243,0.241,0.430,-.099,
     c 0.554,0.402,0.380,0.001,0.119,0.432,0.244,0.244,0.433,-.102,
     c 0.553,0.404,0.382,0.001,0.124,0.432,0.246,0.247,0.436,-.105,
     c 0.552,0.406,0.382,-.001,0.126,0.432,0.247,0.246,0.436,-.108,
     c 0.551,0.407,0.381,-.002,0.127,0.430,0.249,0.243,0.434,-.112,
     c 0.552,0.407,0.382,-.003,0.127,0.427,0.251,0.242,0.431,-.118,
     c 0.555,0.408,0.384,-.003,0.129,0.425,0.253,0.243,0.430,-.128,
     c 0.559,0.410,0.387,-.002,0.132,0.425,0.254,0.245,0.431,-.138,
     c 0.564,0.408,0.387,0.001,0.138,0.426,0.254,0.246,0.432,-.141,
     c 0.566,0.403,0.386,0.005,0.142,0.427,0.255,0.246,0.434,-.141,
     c 0.565,0.401,0.387,0.008,0.144,0.430,0.258,0.246,0.438,-.140,
     c 0.565,0.404,0.390,0.010,0.145,0.432,0.261,0.249,0.441,-.139,
     c 0.568,0.407,0.392,0.013,0.146,0.434,0.263,0.252,0.441,-.137,
     c 0.570,0.406,0.394,0.015,0.148,0.434,0.263,0.254,0.440,-.139,
     c 0.570,0.404,0.395,0.015,0.150,0.435,0.266,0.254,0.439,-.143,
     c 0.568,0.402,0.395,0.015,0.153,0.436,0.270,0.254,0.440,-.144,
     c 0.567,0.401,0.393,0.015,0.156,0.437,0.272,0.254,0.439,-.142,
     c 0.565,0.400,0.391,0.013,0.158,0.436,0.270,0.253,0.437,-.141,
     c 0.566,0.398,0.391,0.012,0.159,0.434,0.267,0.250,0.435,-.141,
     c 0.570,0.397,0.394,0.010,0.162,0.433,0.264,0.246,0.434,-.142,
     c 0.577,0.397,0.396,0.008,0.163,0.432,0.262,0.243,0.433,-.143,
     c 0.581,0.398,0.395,0.006,0.165,0.433,0.260,0.243,0.431,-.141,
     c 0.582,0.397,0.391,0.003,0.164,0.433,0.258,0.244,0.428,-.134,
     c 0.580,0.395,0.388,0.001,0.164,0.433,0.258,0.242,0.426,-.125,
     c 0.576,0.392,0.386,-.001,0.163,0.433,0.258,0.238,0.425,-.118,
     c 0.569,0.388,0.386,-.002,0.163,0.434,0.257,0.234,0.425,-.110,
     c 0.560,0.383,0.387,-.000,0.164,0.435,0.256,0.232,0.427,-.102,
     c 0.554,0.379,0.387,-.001,0.165,0.436,0.255,0.229,0.427,-.095,
     c 0.539,0.380,0.365,0.033,0.140,0.427,0.235,0.247,0.420,-.071,
     c 0.537,0.384,0.366,0.034,0.140,0.430,0.237,0.249,0.421,-.072,
     c 0.537,0.388,0.367,0.036,0.144,0.438,0.241,0.254,0.425,-.073,
     c 0.534,0.391,0.369,0.037,0.145,0.439,0.243,0.255,0.425,-.073,
     c 0.533,0.389,0.370,0.036,0.144,0.438,0.242,0.254,0.425,-.073,
     c 0.536,0.385,0.370,0.034,0.142,0.438,0.242,0.253,0.425,-.072,
     c 0.542,0.384,0.371,0.032,0.141,0.440,0.243,0.253,0.425,-.071,
     c 0.547,0.385,0.372,0.030,0.141,0.442,0.244,0.254,0.425,-.071,
     c 0.551,0.390,0.372,0.026,0.140,0.443,0.246,0.255,0.425,-.072,
     c 0.550,0.394,0.371,0.022,0.139,0.443,0.248,0.257,0.427,-.073,
     c 0.544,0.398,0.370,0.017,0.138,0.442,0.249,0.258,0.427,-.074,
     c 0.536,0.400,0.370,0.012,0.137,0.440,0.246,0.257,0.427,-.076,
     c 0.531,0.401,0.369,0.007,0.135,0.438,0.241,0.256,0.426,-.080,
     c 0.534,0.401,0.367,0.004,0.133,0.436,0.238,0.256,0.425,-.083,
     c 0.543,0.400,0.366,0.001,0.131,0.436,0.240,0.256,0.426,-.083,
     c 0.552,0.399,0.366,-.001,0.131,0.437,0.243,0.254,0.426,-.081,
     c 0.555,0.397,0.367,-.004,0.131,0.438,0.243,0.253,0.428,-.080,
     c 0.552,0.394,0.368,-.010,0.132,0.438,0.244,0.253,0.429,-.078,
     c 0.544,0.391,0.369,-.018,0.130,0.437,0.246,0.254,0.430,-.076,
     c 0.535,0.390,0.368,-.027,0.127,0.436,0.247,0.256,0.431,-.075,
     c 0.527,0.390,0.367,-.035,0.124,0.436,0.247,0.256,0.432,-.074,
     c 0.522,0.390,0.367,-.042,0.122,0.434,0.246,0.254,0.432,-.075,
     c 0.521,0.388,0.366,-.048,0.122,0.432,0.244,0.249,0.432,-.079,
     c 0.523,0.386,0.365,-.051,0.122,0.429,0.241,0.245,0.431,-.083,
     c 0.527,0.385,0.365,-.053,0.122,0.428,0.238,0.241,0.430,-.086,
     c 0.532,0.383,0.365,-.054,0.120,0.427,0.236,0.240,0.428,-.088,
     c 0.536,0.381,0.364,-.054,0.118,0.426,0.235,0.241,0.427,-.090,
     c 0.537,0.380,0.365,-.053,0.117,0.427,0.236,0.243,0.427,-.091,
     c 0.536,0.382,0.366,-.050,0.116,0.427,0.239,0.245,0.426,-.090,
     c 0.535,0.387,0.366,-.045,0.115,0.428,0.241,0.243,0.426,-.087,
     c 0.535,0.389,0.365,-.039,0.115,0.428,0.242,0.240,0.426,-.084,
     c 0.537,0.387,0.364,-.033,0.115,0.429,0.240,0.237,0.425,-.083,
     c 0.540,0.387,0.365,-.025,0.115,0.430,0.238,0.235,0.425,-.084,
     c 0.544,0.392,0.367,-.018,0.115,0.430,0.237,0.233,0.425,-.086,
     c 0.548,0.401,0.369,-.012,0.114,0.430,0.238,0.233,0.426,-.085,
     c 0.553,0.408,0.371,-.006,0.116,0.430,0.240,0.236,0.428,-.085,
     c 0.558,0.410,0.374,-.002,0.118,0.430,0.242,0.238,0.428,-.087,
     c 0.561,0.410,0.377,0.001,0.122,0.430,0.243,0.241,0.429,-.091,
     c 0.559,0.409,0.379,0.002,0.126,0.430,0.243,0.244,0.432,-.094,
     c 0.557,0.410,0.381,0.003,0.131,0.431,0.244,0.246,0.435,-.097,
     c 0.555,0.413,0.381,0.003,0.134,0.431,0.246,0.245,0.435,-.100,
     c 0.556,0.414,0.380,0.002,0.134,0.430,0.247,0.243,0.433,-.104,
     c 0.558,0.413,0.380,0.002,0.134,0.426,0.249,0.242,0.430,-.110,
     c 0.561,0.412,0.381,0.002,0.136,0.423,0.250,0.242,0.428,-.120,
     c 0.564,0.412,0.383,0.003,0.138,0.422,0.250,0.243,0.428,-.132,
     c 0.567,0.410,0.383,0.005,0.143,0.423,0.250,0.244,0.429,-.137,
     c 0.567,0.406,0.383,0.009,0.147,0.425,0.252,0.245,0.432,-.138,
     c 0.566,0.405,0.384,0.012,0.149,0.427,0.256,0.246,0.436,-.137,
     c 0.565,0.407,0.387,0.014,0.151,0.429,0.260,0.250,0.441,-.136,
     c 0.567,0.410,0.390,0.018,0.153,0.432,0.261,0.253,0.442,-.133,
     c 0.570,0.409,0.393,0.020,0.156,0.434,0.262,0.255,0.442,-.131,
     c 0.571,0.407,0.395,0.021,0.159,0.436,0.265,0.255,0.442,-.131,
     c 0.570,0.405,0.395,0.020,0.163,0.438,0.270,0.254,0.442,-.129,
     c 0.568,0.405,0.394,0.019,0.166,0.439,0.272,0.254,0.441,-.125,
     c 0.565,0.404,0.392,0.016,0.168,0.437,0.270,0.253,0.437,-.122,
     c 0.565,0.403,0.391,0.013,0.170,0.435,0.266,0.250,0.434,-.121,
     c 0.568,0.401,0.393,0.010,0.172,0.432,0.262,0.246,0.432,-.121,
     c 0.573,0.401,0.396,0.007,0.173,0.431,0.259,0.243,0.430,-.121,
     c 0.576,0.401,0.395,0.004,0.175,0.431,0.256,0.243,0.428,-.118,
     c 0.576,0.400,0.392,0.002,0.175,0.432,0.256,0.243,0.425,-.111,
     c 0.575,0.398,0.389,0.000,0.174,0.433,0.256,0.241,0.423,-.104,
     c 0.571,0.394,0.388,-.002,0.173,0.433,0.257,0.236,0.423,-.098,
     c 0.564,0.390,0.387,-.003,0.171,0.434,0.256,0.232,0.424,-.094,
     c 0.558,0.386,0.387,-.002,0.169,0.435,0.255,0.231,0.425,-.091,
     c 0.552,0.383,0.386,-.003,0.168,0.436,0.254,0.228,0.425,-.087,
     c 0.539,0.382,0.365,0.036,0.147,0.431,0.239,0.256,0.425,-.067,
     c 0.537,0.386,0.368,0.037,0.148,0.434,0.241,0.257,0.426,-.069,
     c 0.533,0.391,0.372,0.041,0.152,0.441,0.245,0.262,0.428,-.073,
     c 0.530,0.395,0.375,0.042,0.153,0.443,0.247,0.262,0.428,-.075,
     c 0.529,0.395,0.376,0.041,0.152,0.442,0.247,0.260,0.427,-.076,
     c 0.531,0.392,0.377,0.039,0.151,0.442,0.247,0.259,0.427,-.076,
     c 0.537,0.390,0.376,0.036,0.150,0.444,0.247,0.259,0.427,-.076,
     c 0.544,0.389,0.376,0.033,0.149,0.446,0.248,0.261,0.427,-.077,
     c 0.549,0.392,0.376,0.028,0.148,0.447,0.250,0.263,0.429,-.077,
     c 0.550,0.396,0.376,0.022,0.147,0.447,0.253,0.265,0.432,-.074,
     c 0.546,0.402,0.377,0.016,0.145,0.447,0.255,0.266,0.433,-.071,
     c 0.539,0.406,0.377,0.009,0.143,0.444,0.251,0.266,0.433,-.073,
     c 0.534,0.408,0.376,0.003,0.141,0.441,0.245,0.264,0.431,-.077,
     c 0.537,0.408,0.375,-.003,0.139,0.438,0.241,0.263,0.431,-.082,
     c 0.546,0.407,0.373,-.007,0.137,0.436,0.242,0.263,0.431,-.083,
     c 0.556,0.404,0.372,-.012,0.135,0.436,0.244,0.261,0.431,-.080,
     c 0.561,0.401,0.372,-.017,0.135,0.437,0.245,0.259,0.432,-.078,
     c 0.559,0.397,0.372,-.024,0.134,0.438,0.246,0.259,0.434,-.075,
     c 0.551,0.394,0.372,-.033,0.132,0.437,0.247,0.259,0.435,-.074,
     c 0.542,0.393,0.372,-.043,0.130,0.436,0.248,0.259,0.435,-.072,
     c 0.534,0.394,0.372,-.052,0.128,0.436,0.247,0.259,0.435,-.071,
     c 0.529,0.395,0.371,-.060,0.127,0.436,0.247,0.257,0.434,-.070,
     c 0.527,0.394,0.371,-.066,0.128,0.435,0.247,0.254,0.434,-.072,
     c 0.528,0.393,0.371,-.070,0.130,0.433,0.246,0.250,0.434,-.075,
     c 0.531,0.392,0.370,-.072,0.131,0.432,0.244,0.247,0.433,-.079,
     c 0.534,0.390,0.369,-.073,0.130,0.431,0.242,0.246,0.431,-.084,
     c 0.536,0.387,0.368,-.073,0.129,0.430,0.240,0.246,0.429,-.087,
     c 0.535,0.384,0.368,-.071,0.128,0.429,0.241,0.248,0.427,-.090,
     c 0.534,0.385,0.369,-.068,0.127,0.429,0.242,0.248,0.426,-.089,
     c 0.534,0.389,0.368,-.062,0.126,0.428,0.243,0.246,0.425,-.085,
     c 0.536,0.391,0.367,-.054,0.125,0.428,0.243,0.242,0.424,-.081,
     c 0.539,0.390,0.367,-.045,0.124,0.429,0.242,0.240,0.425,-.080,
     c 0.543,0.391,0.369,-.035,0.124,0.430,0.240,0.239,0.426,-.079,
     c 0.547,0.396,0.370,-.025,0.124,0.431,0.240,0.239,0.427,-.079,
     c 0.552,0.404,0.371,-.016,0.123,0.431,0.242,0.240,0.429,-.078,
     c 0.557,0.411,0.372,-.009,0.123,0.430,0.244,0.242,0.430,-.078,
     c 0.561,0.414,0.374,-.004,0.125,0.429,0.245,0.243,0.430,-.081,
     c 0.563,0.414,0.377,0.000,0.128,0.429,0.244,0.243,0.431,-.086,
     c 0.561,0.414,0.379,0.004,0.133,0.429,0.244,0.244,0.432,-.090,
     c 0.558,0.416,0.380,0.006,0.137,0.430,0.245,0.245,0.435,-.092,
     c 0.558,0.419,0.380,0.006,0.140,0.431,0.247,0.246,0.435,-.093,
     c 0.560,0.421,0.379,0.007,0.142,0.430,0.248,0.244,0.434,-.095,
     c 0.564,0.420,0.378,0.007,0.143,0.428,0.249,0.243,0.431,-.100,
     c 0.567,0.417,0.379,0.008,0.144,0.425,0.250,0.242,0.429,-.111,
     c 0.570,0.416,0.380,0.009,0.146,0.423,0.249,0.243,0.427,-.122,
     c 0.572,0.414,0.380,0.011,0.149,0.423,0.249,0.244,0.428,-.127,
     c 0.571,0.411,0.380,0.014,0.153,0.425,0.251,0.245,0.431,-.127,
     c 0.568,0.411,0.381,0.017,0.156,0.426,0.255,0.248,0.435,-.125,
     c 0.565,0.412,0.384,0.020,0.158,0.428,0.259,0.251,0.440,-.122,
     c 0.567,0.415,0.388,0.023,0.160,0.430,0.259,0.254,0.442,-.119,
     c 0.570,0.415,0.392,0.024,0.163,0.432,0.260,0.255,0.444,-.115,
     c 0.573,0.413,0.395,0.024,0.167,0.435,0.263,0.255,0.443,-.113,
     c 0.574,0.410,0.396,0.022,0.172,0.438,0.267,0.254,0.443,-.110,
     c 0.572,0.409,0.395,0.019,0.175,0.438,0.268,0.254,0.440,-.106,
     c 0.569,0.408,0.392,0.016,0.176,0.436,0.266,0.251,0.436,-.104,
     c 0.567,0.406,0.391,0.012,0.177,0.433,0.262,0.248,0.431,-.103,
     c 0.567,0.405,0.392,0.008,0.179,0.431,0.258,0.244,0.428,-.103,
     c 0.568,0.404,0.394,0.005,0.180,0.429,0.255,0.242,0.426,-.102,
     c 0.570,0.403,0.393,0.003,0.182,0.430,0.253,0.241,0.424,-.098,
     c 0.570,0.402,0.391,0.001,0.182,0.431,0.253,0.241,0.422,-.092,
     c 0.569,0.400,0.389,-.001,0.181,0.432,0.255,0.238,0.422,-.086,
     c 0.566,0.398,0.389,-.003,0.180,0.434,0.256,0.234,0.423,-.082,
     c 0.561,0.394,0.388,-.003,0.177,0.435,0.255,0.231,0.424,-.080,
     c 0.555,0.390,0.387,-.003,0.172,0.436,0.254,0.231,0.424,-.081,
     c 0.549,0.387,0.386,-.004,0.170,0.437,0.253,0.228,0.424,-.079,
     c 0.539,0.383,0.366,0.037,0.153,0.435,0.243,0.264,0.430,-.061,
     c 0.537,0.388,0.370,0.038,0.155,0.437,0.245,0.264,0.430,-.065,
     c 0.534,0.395,0.375,0.043,0.158,0.442,0.248,0.268,0.431,-.070,
     c 0.530,0.400,0.379,0.044,0.160,0.444,0.250,0.267,0.430,-.075,
     c 0.527,0.401,0.382,0.042,0.159,0.445,0.251,0.264,0.430,-.078,
     c 0.527,0.399,0.382,0.040,0.159,0.446,0.252,0.264,0.430,-.079,
     c 0.533,0.396,0.381,0.037,0.158,0.448,0.252,0.265,0.430,-.080,
     c 0.541,0.394,0.379,0.032,0.156,0.449,0.253,0.268,0.430,-.080,
     c 0.548,0.394,0.379,0.027,0.154,0.450,0.255,0.270,0.433,-.078,
     c 0.551,0.398,0.380,0.020,0.152,0.451,0.258,0.273,0.437,-.072,
     c 0.549,0.404,0.381,0.013,0.150,0.451,0.260,0.274,0.439,-.066,
     c 0.544,0.409,0.383,0.005,0.148,0.448,0.256,0.274,0.438,-.065,
     c 0.539,0.411,0.383,-.002,0.146,0.444,0.249,0.272,0.437,-.069,
     c 0.542,0.410,0.382,-.009,0.143,0.440,0.244,0.271,0.436,-.075,
     c 0.551,0.407,0.380,-.016,0.141,0.439,0.244,0.269,0.435,-.077,
     c 0.562,0.404,0.379,-.022,0.139,0.439,0.247,0.267,0.435,-.076,
     c 0.568,0.400,0.378,-.029,0.137,0.439,0.248,0.265,0.436,-.074,
     c 0.565,0.397,0.377,-.037,0.136,0.439,0.248,0.263,0.437,-.073,
     c 0.557,0.396,0.376,-.046,0.134,0.437,0.248,0.262,0.438,-.071,
     c 0.549,0.396,0.376,-.056,0.133,0.436,0.247,0.260,0.437,-.070,
     c 0.542,0.397,0.376,-.065,0.132,0.437,0.247,0.259,0.436,-.069,
     c 0.538,0.399,0.376,-.072,0.133,0.438,0.247,0.257,0.435,-.068,
     c 0.535,0.399,0.377,-.078,0.135,0.437,0.249,0.256,0.436,-.068,
     c 0.535,0.398,0.376,-.083,0.138,0.436,0.250,0.254,0.436,-.071,
     c 0.536,0.398,0.375,-.085,0.140,0.435,0.249,0.252,0.436,-.075,
     c 0.538,0.396,0.373,-.086,0.140,0.434,0.247,0.251,0.434,-.080,
     c 0.538,0.392,0.372,-.085,0.139,0.433,0.245,0.250,0.431,-.086,
     c 0.538,0.389,0.371,-.083,0.138,0.431,0.244,0.250,0.428,-.090,
     c 0.538,0.389,0.371,-.078,0.136,0.429,0.244,0.249,0.426,-.091,
     c 0.539,0.392,0.370,-.071,0.135,0.428,0.244,0.247,0.424,-.089,
     c 0.542,0.395,0.369,-.062,0.133,0.427,0.244,0.244,0.424,-.085,
     c 0.545,0.394,0.369,-.051,0.133,0.428,0.242,0.243,0.425,-.082,
     c 0.548,0.395,0.371,-.039,0.133,0.430,0.242,0.244,0.428,-.080,
     c 0.551,0.398,0.373,-.028,0.132,0.431,0.244,0.247,0.430,-.077,
     c 0.554,0.405,0.374,-.018,0.131,0.430,0.246,0.248,0.432,-.074,
     c 0.556,0.411,0.374,-.010,0.131,0.429,0.247,0.249,0.434,-.074,
     c 0.559,0.415,0.376,-.004,0.132,0.428,0.247,0.249,0.433,-.079,
     c 0.560,0.416,0.378,0.001,0.134,0.427,0.246,0.247,0.433,-.085,
     c 0.559,0.417,0.380,0.004,0.137,0.427,0.245,0.246,0.434,-.089,
     c 0.557,0.419,0.379,0.007,0.142,0.429,0.246,0.247,0.436,-.089,
     c 0.558,0.422,0.379,0.009,0.146,0.430,0.248,0.248,0.437,-.088,
     c 0.562,0.425,0.378,0.011,0.148,0.431,0.250,0.247,0.437,-.088,
     c 0.567,0.425,0.379,0.012,0.150,0.431,0.252,0.246,0.435,-.092,
     c 0.571,0.422,0.380,0.014,0.151,0.429,0.252,0.245,0.432,-.100,
     c 0.575,0.420,0.380,0.016,0.153,0.427,0.251,0.245,0.431,-.109,
     c 0.576,0.418,0.380,0.018,0.156,0.426,0.250,0.246,0.431,-.112,
     c 0.575,0.417,0.380,0.021,0.159,0.427,0.252,0.248,0.433,-.110,
     c 0.570,0.417,0.381,0.023,0.162,0.428,0.256,0.251,0.436,-.105,
     c 0.566,0.418,0.384,0.025,0.164,0.429,0.259,0.254,0.440,-.101,
     c 0.566,0.420,0.388,0.027,0.167,0.430,0.259,0.256,0.443,-.098,
     c 0.570,0.421,0.393,0.027,0.170,0.432,0.259,0.257,0.445,-.095,
     c 0.575,0.419,0.396,0.026,0.174,0.435,0.261,0.256,0.445,-.092,
     c 0.578,0.416,0.397,0.023,0.178,0.437,0.264,0.255,0.443,-.090,
     c 0.576,0.413,0.396,0.019,0.180,0.436,0.264,0.253,0.440,-.089,
     c 0.572,0.411,0.393,0.015,0.181,0.434,0.262,0.249,0.434,-.089,
     c 0.568,0.409,0.391,0.010,0.181,0.432,0.258,0.245,0.429,-.090,
     c 0.566,0.407,0.391,0.007,0.182,0.430,0.256,0.241,0.426,-.088,
     c 0.565,0.407,0.391,0.004,0.184,0.430,0.254,0.240,0.424,-.086,
     c 0.566,0.406,0.391,0.002,0.185,0.431,0.253,0.240,0.423,-.082,
     c 0.566,0.405,0.389,0.001,0.185,0.433,0.253,0.239,0.422,-.077,
     c 0.566,0.404,0.389,-.001,0.184,0.434,0.254,0.237,0.423,-.073,
     c 0.564,0.402,0.389,-.002,0.183,0.435,0.255,0.233,0.425,-.071,
     c 0.559,0.399,0.388,-.003,0.180,0.436,0.255,0.231,0.426,-.070,
     c 0.553,0.395,0.386,-.003,0.174,0.437,0.254,0.231,0.424,-.073,
     c 0.548,0.391,0.386,-.004,0.171,0.437,0.253,0.229,0.424,-.072,
     c 0.539,0.385,0.367,0.036,0.159,0.437,0.247,0.271,0.434,-.058,
     c 0.539,0.390,0.372,0.036,0.161,0.440,0.249,0.270,0.434,-.062,
     c 0.539,0.396,0.378,0.041,0.163,0.442,0.249,0.270,0.432,-.066,
     c 0.536,0.402,0.383,0.042,0.165,0.445,0.251,0.268,0.432,-.073,
     c 0.531,0.404,0.386,0.040,0.166,0.447,0.253,0.266,0.433,-.078,
     c 0.530,0.404,0.387,0.037,0.165,0.449,0.255,0.266,0.434,-.081,
     c 0.535,0.402,0.385,0.033,0.164,0.450,0.256,0.269,0.433,-.081,
     c 0.544,0.399,0.384,0.028,0.162,0.451,0.256,0.272,0.433,-.079,
     c 0.552,0.398,0.383,0.022,0.159,0.451,0.258,0.275,0.435,-.074,
     c 0.555,0.400,0.384,0.015,0.157,0.452,0.261,0.277,0.439,-.065,
     c 0.553,0.405,0.386,0.007,0.154,0.453,0.263,0.278,0.441,-.057,
     c 0.548,0.408,0.388,-.001,0.152,0.451,0.260,0.278,0.441,-.056,
     c 0.543,0.409,0.389,-.009,0.150,0.448,0.253,0.276,0.440,-.060,
     c 0.544,0.408,0.388,-.016,0.147,0.444,0.248,0.274,0.439,-.066,
     c 0.552,0.404,0.387,-.024,0.144,0.442,0.248,0.272,0.438,-.070,
     c 0.563,0.400,0.386,-.031,0.142,0.442,0.250,0.270,0.437,-.072,
     c 0.569,0.398,0.384,-.039,0.140,0.442,0.251,0.267,0.438,-.072,
     c 0.567,0.396,0.383,-.046,0.138,0.441,0.250,0.263,0.439,-.071,
     c 0.559,0.396,0.381,-.055,0.136,0.438,0.249,0.261,0.439,-.070,
     c 0.552,0.396,0.380,-.063,0.135,0.437,0.248,0.258,0.438,-.069,
     c 0.547,0.398,0.380,-.070,0.137,0.438,0.247,0.256,0.436,-.068,
     c 0.544,0.400,0.381,-.077,0.139,0.438,0.248,0.255,0.435,-.067,
     c 0.542,0.400,0.382,-.083,0.141,0.439,0.251,0.255,0.436,-.068,
     c 0.542,0.400,0.382,-.087,0.144,0.438,0.253,0.255,0.438,-.070,
     c 0.542,0.401,0.381,-.089,0.147,0.438,0.253,0.254,0.439,-.073,
     c 0.543,0.400,0.378,-.089,0.148,0.438,0.252,0.253,0.437,-.078,
     c 0.544,0.397,0.376,-.088,0.147,0.435,0.249,0.251,0.435,-.084,
     c 0.544,0.393,0.375,-.085,0.145,0.432,0.247,0.250,0.431,-.090,
     c 0.546,0.393,0.374,-.080,0.143,0.429,0.246,0.248,0.427,-.093,
     c 0.549,0.396,0.372,-.072,0.140,0.427,0.245,0.246,0.424,-.092,
     c 0.552,0.398,0.371,-.062,0.139,0.426,0.244,0.244,0.424,-.090,
     c 0.553,0.398,0.371,-.050,0.140,0.426,0.243,0.245,0.426,-.087,
     c 0.554,0.397,0.373,-.038,0.140,0.428,0.243,0.248,0.429,-.084,
     c 0.554,0.399,0.375,-.026,0.140,0.430,0.246,0.252,0.432,-.078,
     c 0.553,0.404,0.375,-.017,0.139,0.430,0.248,0.254,0.435,-.074,
     c 0.553,0.409,0.376,-.009,0.138,0.428,0.249,0.254,0.436,-.073,
     c 0.553,0.413,0.377,-.003,0.138,0.427,0.248,0.252,0.436,-.079,
     c 0.553,0.415,0.379,0.002,0.138,0.426,0.245,0.249,0.435,-.086,
     c 0.554,0.417,0.379,0.006,0.140,0.426,0.244,0.247,0.435,-.090,
     c 0.554,0.420,0.379,0.009,0.144,0.427,0.245,0.248,0.436,-.089,
     c 0.556,0.424,0.378,0.011,0.148,0.429,0.247,0.250,0.437,-.085,
     c 0.560,0.427,0.378,0.013,0.152,0.431,0.250,0.250,0.438,-.083,
     c 0.566,0.427,0.380,0.015,0.155,0.432,0.253,0.250,0.437,-.084,
     c 0.571,0.425,0.381,0.018,0.156,0.432,0.254,0.249,0.436,-.090,
     c 0.574,0.422,0.383,0.021,0.158,0.430,0.252,0.249,0.434,-.096,
     c 0.576,0.421,0.383,0.024,0.160,0.430,0.252,0.250,0.434,-.096,
     c 0.575,0.420,0.382,0.026,0.163,0.431,0.254,0.252,0.436,-.090,
     c 0.570,0.420,0.383,0.028,0.166,0.432,0.259,0.255,0.439,-.083,
     c 0.565,0.421,0.386,0.030,0.169,0.432,0.261,0.257,0.442,-.078,
     c 0.564,0.423,0.390,0.030,0.171,0.433,0.261,0.259,0.445,-.075,
     c 0.570,0.424,0.394,0.030,0.174,0.435,0.260,0.259,0.446,-.073,
     c 0.577,0.423,0.397,0.028,0.178,0.438,0.261,0.258,0.446,-.071,
     c 0.580,0.420,0.398,0.024,0.181,0.439,0.262,0.256,0.445,-.071,
     c 0.579,0.416,0.397,0.020,0.182,0.437,0.261,0.253,0.441,-.073,
     c 0.574,0.412,0.394,0.015,0.182,0.434,0.259,0.248,0.435,-.077,
     c 0.568,0.409,0.391,0.010,0.182,0.433,0.257,0.243,0.430,-.078,
     c 0.565,0.408,0.389,0.007,0.183,0.433,0.256,0.239,0.426,-.076,
     c 0.564,0.408,0.389,0.004,0.184,0.434,0.255,0.238,0.424,-.073,
     c 0.565,0.408,0.388,0.003,0.185,0.435,0.254,0.239,0.423,-.069,
     c 0.566,0.408,0.387,0.002,0.184,0.437,0.254,0.239,0.423,-.067,
     c 0.566,0.407,0.387,0.001,0.184,0.438,0.256,0.238,0.425,-.065,
     c 0.563,0.405,0.387,0.000,0.182,0.438,0.256,0.235,0.427,-.064,
     c 0.559,0.403,0.387,-.002,0.179,0.438,0.255,0.233,0.427,-.064,
     c 0.552,0.397,0.385,-.002,0.172,0.438,0.253,0.233,0.424,-.067,
     c 0.546,0.394,0.385,-.003,0.170,0.438,0.252,0.231,0.424,-.067,
     c 0.540,0.390,0.370,0.032,0.164,0.440,0.252,0.277,0.438,-.054,
     c 0.541,0.394,0.375,0.033,0.166,0.442,0.253,0.276,0.438,-.058,
     c 0.545,0.397,0.381,0.037,0.169,0.445,0.252,0.274,0.437,-.061,
     c 0.544,0.402,0.387,0.037,0.171,0.447,0.252,0.271,0.436,-.067,
     c 0.539,0.406,0.391,0.034,0.172,0.449,0.254,0.269,0.437,-.073,
     c 0.537,0.408,0.392,0.031,0.173,0.451,0.257,0.271,0.439,-.075,
     c 0.543,0.408,0.391,0.027,0.172,0.452,0.259,0.274,0.438,-.074,
     c 0.553,0.405,0.390,0.022,0.169,0.451,0.260,0.277,0.437,-.070,
     c 0.561,0.403,0.390,0.017,0.166,0.451,0.263,0.279,0.438,-.063,
     c 0.563,0.405,0.391,0.009,0.163,0.453,0.265,0.281,0.442,-.054,
     c 0.561,0.409,0.393,0.002,0.160,0.455,0.268,0.282,0.444,-.047,
     c 0.555,0.411,0.395,-.006,0.158,0.454,0.265,0.281,0.445,-.046,
     c 0.549,0.410,0.396,-.014,0.156,0.451,0.260,0.279,0.445,-.051,
     c 0.548,0.408,0.396,-.022,0.153,0.448,0.255,0.277,0.444,-.058,
     c 0.554,0.404,0.395,-.030,0.150,0.447,0.254,0.275,0.442,-.063,
     c 0.563,0.401,0.394,-.038,0.147,0.447,0.255,0.272,0.440,-.067,
     c 0.568,0.399,0.392,-.045,0.144,0.447,0.256,0.268,0.440,-.070,
     c 0.564,0.399,0.390,-.052,0.142,0.444,0.254,0.264,0.440,-.070,
     c 0.557,0.399,0.388,-.058,0.140,0.441,0.252,0.260,0.440,-.069,
     c 0.550,0.400,0.386,-.064,0.140,0.438,0.250,0.257,0.439,-.067,
     c 0.548,0.401,0.386,-.069,0.141,0.438,0.249,0.255,0.437,-.067,
     c 0.548,0.402,0.387,-.074,0.143,0.439,0.251,0.254,0.437,-.067,
     c 0.548,0.402,0.388,-.078,0.146,0.440,0.254,0.254,0.438,-.069,
     c 0.548,0.403,0.389,-.082,0.149,0.440,0.256,0.255,0.440,-.069,
     c 0.548,0.404,0.388,-.083,0.152,0.441,0.257,0.256,0.441,-.070,
     c 0.549,0.404,0.385,-.082,0.154,0.441,0.256,0.256,0.441,-.073,
     c 0.549,0.402,0.382,-.080,0.153,0.438,0.254,0.254,0.439,-.079,
     c 0.551,0.399,0.379,-.077,0.151,0.434,0.252,0.252,0.434,-.085,
     c 0.554,0.400,0.377,-.072,0.147,0.429,0.250,0.250,0.430,-.089,
     c 0.557,0.403,0.374,-.064,0.144,0.426,0.247,0.248,0.426,-.090,
     c 0.559,0.404,0.373,-.054,0.143,0.425,0.245,0.246,0.425,-.089,
     c 0.559,0.403,0.373,-.042,0.144,0.426,0.244,0.247,0.426,-.087,
     c 0.558,0.403,0.375,-.030,0.146,0.428,0.245,0.250,0.429,-.083,
     c 0.555,0.403,0.377,-.020,0.146,0.430,0.247,0.254,0.433,-.077,
     c 0.551,0.406,0.377,-.011,0.145,0.429,0.248,0.256,0.435,-.071,
     c 0.547,0.409,0.377,-.004,0.144,0.428,0.249,0.256,0.437,-.070,
     c 0.546,0.413,0.379,0.001,0.142,0.427,0.247,0.253,0.436,-.077,
     c 0.546,0.415,0.380,0.006,0.141,0.426,0.244,0.250,0.436,-.084,
     c 0.547,0.417,0.380,0.009,0.142,0.426,0.242,0.248,0.435,-.088,
     c 0.549,0.421,0.379,0.011,0.145,0.426,0.242,0.249,0.435,-.086,
     c 0.552,0.424,0.378,0.013,0.149,0.428,0.244,0.251,0.436,-.082,
     c 0.556,0.427,0.379,0.015,0.153,0.431,0.248,0.253,0.437,-.079,
     c 0.560,0.427,0.381,0.018,0.157,0.434,0.251,0.253,0.437,-.078,
     c 0.565,0.425,0.383,0.021,0.159,0.435,0.253,0.252,0.437,-.081,
     c 0.569,0.423,0.385,0.025,0.161,0.434,0.252,0.252,0.437,-.082,
     c 0.572,0.422,0.386,0.028,0.163,0.434,0.252,0.253,0.437,-.079,
     c 0.571,0.421,0.386,0.030,0.165,0.436,0.255,0.257,0.439,-.071,
     c 0.567,0.422,0.387,0.032,0.169,0.437,0.260,0.259,0.442,-.062,
     c 0.563,0.422,0.389,0.033,0.172,0.438,0.263,0.261,0.445,-.056,
     c 0.563,0.425,0.393,0.034,0.174,0.438,0.263,0.262,0.447,-.054,
     c 0.570,0.427,0.396,0.033,0.177,0.441,0.262,0.262,0.448,-.053,
     c 0.578,0.428,0.398,0.030,0.180,0.443,0.262,0.262,0.448,-.052,
     c 0.583,0.425,0.399,0.027,0.181,0.443,0.262,0.259,0.447,-.054,
     c 0.582,0.421,0.398,0.022,0.181,0.441,0.261,0.255,0.443,-.059,
     c 0.576,0.417,0.395,0.018,0.181,0.438,0.259,0.249,0.438,-.065,
     c 0.569,0.413,0.392,0.014,0.181,0.437,0.258,0.243,0.433,-.067,
     c 0.565,0.412,0.390,0.010,0.181,0.438,0.258,0.240,0.428,-.065,
     c 0.564,0.412,0.389,0.008,0.182,0.440,0.258,0.240,0.426,-.061,
     c 0.566,0.412,0.388,0.006,0.182,0.442,0.257,0.242,0.426,-.059,
     c 0.568,0.412,0.387,0.005,0.182,0.443,0.257,0.242,0.426,-.059,
     c 0.567,0.410,0.386,0.004,0.180,0.443,0.258,0.241,0.428,-.059,
     c 0.562,0.408,0.386,0.003,0.179,0.442,0.258,0.239,0.429,-.059,
     c 0.556,0.405,0.386,0.001,0.175,0.442,0.256,0.237,0.428,-.059,
     c 0.549,0.399,0.385,-.000,0.170,0.440,0.252,0.235,0.425,-.062,
     c 0.544,0.396,0.384,-.002,0.167,0.440,0.250,0.233,0.424,-.062,
     c 0.542,0.396,0.372,0.025,0.167,0.443,0.256,0.280,0.440,-.053,
     c 0.543,0.398,0.377,0.025,0.169,0.444,0.257,0.280,0.440,-.055,
     c 0.548,0.397,0.382,0.028,0.173,0.448,0.255,0.279,0.440,-.055,
     c 0.550,0.399,0.388,0.028,0.175,0.449,0.255,0.277,0.440,-.060,
     c 0.547,0.404,0.392,0.025,0.177,0.451,0.257,0.276,0.441,-.064,
     c 0.546,0.408,0.395,0.023,0.178,0.452,0.261,0.278,0.443,-.064,
     c 0.553,0.410,0.396,0.019,0.178,0.453,0.264,0.281,0.443,-.062,
     c 0.563,0.409,0.396,0.015,0.176,0.452,0.266,0.283,0.441,-.058,
     c 0.571,0.407,0.397,0.010,0.173,0.452,0.269,0.284,0.441,-.052,
     c 0.573,0.408,0.397,0.003,0.169,0.453,0.272,0.285,0.443,-.044,
     c 0.570,0.411,0.399,-.004,0.166,0.455,0.274,0.286,0.447,-.039,
     c 0.565,0.413,0.401,-.012,0.164,0.457,0.273,0.286,0.449,-.041,
     c 0.560,0.412,0.402,-.019,0.163,0.455,0.270,0.284,0.450,-.047,
     c 0.558,0.410,0.402,-.026,0.159,0.453,0.265,0.281,0.449,-.053,
     c 0.561,0.407,0.401,-.034,0.156,0.451,0.265,0.279,0.446,-.058,
     c 0.566,0.406,0.401,-.041,0.152,0.450,0.264,0.275,0.443,-.063,
     c 0.567,0.405,0.399,-.048,0.150,0.450,0.264,0.271,0.441,-.067,
     c 0.561,0.405,0.397,-.053,0.147,0.447,0.261,0.267,0.441,-.069,
     c 0.553,0.406,0.394,-.057,0.144,0.443,0.258,0.262,0.441,-.068,
     c 0.548,0.406,0.392,-.061,0.144,0.440,0.255,0.258,0.440,-.066,
     c 0.549,0.406,0.390,-.064,0.145,0.439,0.254,0.255,0.438,-.065,
     c 0.551,0.405,0.391,-.067,0.146,0.439,0.255,0.254,0.437,-.067,
     c 0.553,0.405,0.392,-.069,0.147,0.439,0.257,0.255,0.437,-.069,
     c 0.554,0.406,0.393,-.070,0.149,0.440,0.259,0.257,0.439,-.068,
     c 0.555,0.407,0.393,-.070,0.152,0.442,0.260,0.258,0.441,-.067,
     c 0.555,0.408,0.391,-.068,0.155,0.443,0.259,0.258,0.442,-.067,
     c 0.554,0.406,0.387,-.066,0.154,0.440,0.258,0.257,0.440,-.070,
     c 0.556,0.404,0.384,-.063,0.152,0.436,0.256,0.256,0.436,-.075,
     c 0.558,0.404,0.380,-.058,0.148,0.430,0.254,0.254,0.432,-.079,
     c 0.560,0.406,0.377,-.051,0.144,0.427,0.251,0.252,0.428,-.081,
     c 0.561,0.407,0.374,-.042,0.143,0.425,0.249,0.249,0.426,-.082,
     c 0.560,0.407,0.374,-.031,0.145,0.426,0.247,0.248,0.425,-.082,
     c 0.558,0.406,0.376,-.022,0.147,0.428,0.248,0.250,0.427,-.079,
     c 0.555,0.406,0.376,-.013,0.147,0.429,0.249,0.252,0.430,-.072,
     c 0.549,0.408,0.376,-.006,0.146,0.429,0.249,0.254,0.432,-.066,
     c 0.544,0.409,0.377,-.000,0.145,0.429,0.249,0.254,0.433,-.066,
     c 0.540,0.411,0.379,0.005,0.143,0.428,0.247,0.251,0.433,-.072,
     c 0.540,0.412,0.380,0.009,0.142,0.428,0.244,0.249,0.433,-.079,
     c 0.542,0.413,0.380,0.011,0.142,0.426,0.241,0.248,0.432,-.082,
     c 0.545,0.416,0.379,0.013,0.144,0.426,0.240,0.249,0.431,-.081,
     c 0.548,0.419,0.378,0.014,0.148,0.428,0.241,0.251,0.430,-.078,
     c 0.552,0.421,0.378,0.015,0.152,0.432,0.245,0.253,0.431,-.075,
     c 0.555,0.421,0.380,0.017,0.156,0.436,0.249,0.253,0.432,-.073,
     c 0.559,0.421,0.383,0.021,0.159,0.438,0.252,0.253,0.433,-.073,
     c 0.563,0.420,0.385,0.025,0.160,0.438,0.252,0.253,0.434,-.072,
     c 0.566,0.420,0.386,0.028,0.161,0.438,0.252,0.255,0.436,-.067,
     c 0.566,0.420,0.387,0.030,0.164,0.440,0.255,0.258,0.438,-.058,
     c 0.564,0.420,0.388,0.032,0.167,0.441,0.260,0.261,0.441,-.049,
     c 0.562,0.421,0.390,0.033,0.170,0.442,0.263,0.262,0.444,-.043,
     c 0.563,0.424,0.392,0.034,0.173,0.443,0.264,0.263,0.446,-.042,
     c 0.571,0.427,0.394,0.033,0.176,0.446,0.262,0.264,0.446,-.042,
     c 0.581,0.429,0.395,0.031,0.177,0.448,0.261,0.263,0.446,-.043,
     c 0.587,0.428,0.396,0.028,0.178,0.447,0.261,0.260,0.444,-.047,
     c 0.585,0.424,0.396,0.025,0.177,0.445,0.260,0.255,0.440,-.053,
     c 0.579,0.421,0.394,0.021,0.176,0.443,0.259,0.249,0.436,-.058,
     c 0.571,0.417,0.392,0.017,0.176,0.443,0.260,0.243,0.431,-.061,
     c 0.566,0.415,0.390,0.014,0.176,0.445,0.261,0.240,0.428,-.059,
     c 0.566,0.414,0.389,0.011,0.176,0.447,0.260,0.241,0.426,-.056,
     c 0.569,0.414,0.388,0.009,0.176,0.448,0.259,0.243,0.426,-.056,
     c 0.569,0.413,0.386,0.008,0.175,0.448,0.258,0.244,0.426,-.057,
     c 0.566,0.410,0.385,0.007,0.173,0.447,0.259,0.243,0.427,-.058,
     c 0.559,0.407,0.384,0.006,0.170,0.446,0.258,0.241,0.427,-.058,
     c 0.552,0.403,0.383,0.004,0.167,0.444,0.255,0.239,0.426,-.058,
     c 0.546,0.399,0.382,0.001,0.163,0.442,0.250,0.236,0.422,-.059,
     c 0.541,0.396,0.381,-.001,0.160,0.441,0.248,0.234,0.420,-.059,
     c 0.542,0.401,0.376,0.016,0.170,0.443,0.259,0.281,0.441,-.053,
     c 0.544,0.402,0.381,0.016,0.173,0.444,0.260,0.281,0.442,-.053,
     c 0.550,0.398,0.384,0.017,0.177,0.447,0.260,0.285,0.444,-.050,
     c 0.553,0.398,0.389,0.017,0.179,0.448,0.261,0.284,0.444,-.052,
     c 0.552,0.402,0.394,0.015,0.182,0.450,0.264,0.284,0.447,-.053,
     c 0.553,0.409,0.398,0.013,0.184,0.452,0.268,0.287,0.450,-.051,
     c 0.560,0.412,0.400,0.011,0.185,0.452,0.271,0.290,0.450,-.048,
     c 0.570,0.411,0.402,0.008,0.185,0.451,0.273,0.291,0.448,-.046,
     c 0.577,0.410,0.402,0.004,0.182,0.451,0.275,0.290,0.447,-.043,
     c 0.579,0.411,0.402,-.001,0.177,0.452,0.278,0.291,0.449,-.038,
     c 0.578,0.414,0.404,-.007,0.174,0.455,0.282,0.291,0.453,-.035,
     c 0.575,0.416,0.406,-.013,0.173,0.457,0.281,0.291,0.456,-.039,
     c 0.571,0.416,0.407,-.020,0.172,0.458,0.279,0.289,0.457,-.045,
     c 0.569,0.415,0.407,-.026,0.169,0.456,0.277,0.287,0.455,-.050,
     c 0.570,0.413,0.407,-.033,0.165,0.454,0.275,0.285,0.452,-.052,
     c 0.572,0.412,0.407,-.040,0.161,0.453,0.274,0.281,0.448,-.057,
     c 0.570,0.413,0.406,-.045,0.158,0.452,0.272,0.278,0.446,-.062,
     c 0.561,0.413,0.404,-.049,0.156,0.449,0.269,0.273,0.444,-.065,
     c 0.552,0.414,0.401,-.052,0.153,0.445,0.266,0.268,0.444,-.064,
     c 0.549,0.413,0.398,-.054,0.152,0.442,0.262,0.263,0.443,-.061,
     c 0.551,0.411,0.396,-.054,0.151,0.441,0.260,0.260,0.441,-.060,
     c 0.555,0.410,0.395,-.055,0.151,0.440,0.259,0.257,0.439,-.062,
     c 0.558,0.409,0.396,-.055,0.150,0.438,0.259,0.258,0.439,-.063,
     c 0.561,0.409,0.397,-.054,0.151,0.439,0.260,0.260,0.440,-.062,
     c 0.561,0.411,0.397,-.053,0.153,0.441,0.260,0.261,0.442,-.059,
     c 0.559,0.411,0.395,-.050,0.156,0.443,0.260,0.261,0.443,-.057,
     c 0.558,0.410,0.392,-.048,0.156,0.441,0.260,0.260,0.441,-.058,
     c 0.558,0.407,0.388,-.045,0.153,0.437,0.258,0.260,0.438,-.061,
     c 0.559,0.406,0.384,-.042,0.149,0.431,0.257,0.259,0.435,-.065,
     c 0.559,0.407,0.380,-.037,0.146,0.427,0.254,0.256,0.431,-.069,
     c 0.558,0.408,0.377,-.029,0.145,0.426,0.252,0.253,0.427,-.073,
     c 0.558,0.408,0.376,-.021,0.147,0.427,0.251,0.250,0.425,-.074,
     c 0.558,0.407,0.376,-.014,0.149,0.428,0.251,0.250,0.426,-.072,
     c 0.555,0.407,0.376,-.008,0.148,0.429,0.251,0.252,0.427,-.066,
     c 0.550,0.408,0.376,-.003,0.147,0.428,0.250,0.252,0.430,-.061,
     c 0.544,0.408,0.377,0.002,0.146,0.428,0.250,0.252,0.431,-.061,
     c 0.539,0.408,0.379,0.007,0.145,0.429,0.249,0.250,0.432,-.066,
     c 0.538,0.407,0.380,0.010,0.144,0.429,0.246,0.249,0.432,-.071,
     c 0.540,0.407,0.381,0.012,0.144,0.427,0.243,0.249,0.431,-.073,
     c 0.544,0.408,0.380,0.013,0.145,0.426,0.242,0.250,0.429,-.073,
     c 0.548,0.411,0.379,0.013,0.148,0.428,0.242,0.251,0.428,-.072,
     c 0.552,0.412,0.379,0.013,0.152,0.432,0.246,0.252,0.428,-.070,
     c 0.554,0.413,0.380,0.015,0.156,0.436,0.250,0.252,0.429,-.068,
     c 0.557,0.415,0.382,0.018,0.158,0.439,0.251,0.252,0.430,-.067,
     c 0.560,0.416,0.384,0.021,0.160,0.440,0.251,0.252,0.432,-.064,
     c 0.561,0.417,0.385,0.024,0.160,0.440,0.251,0.255,0.434,-.058,
     c 0.561,0.418,0.386,0.026,0.162,0.442,0.254,0.258,0.438,-.051,
     c 0.561,0.418,0.388,0.028,0.165,0.443,0.258,0.260,0.441,-.043,
     c 0.561,0.419,0.389,0.029,0.168,0.445,0.261,0.261,0.443,-.039,
     c 0.565,0.421,0.391,0.030,0.171,0.445,0.261,0.262,0.444,-.038,
     c 0.573,0.425,0.391,0.030,0.174,0.447,0.259,0.262,0.444,-.040,
     c 0.582,0.427,0.390,0.029,0.175,0.449,0.258,0.260,0.443,-.042,
     c 0.588,0.427,0.390,0.028,0.174,0.449,0.257,0.256,0.440,-.047,
     c 0.587,0.425,0.391,0.025,0.173,0.448,0.257,0.252,0.436,-.053,
     c 0.580,0.422,0.391,0.022,0.172,0.447,0.257,0.247,0.432,-.058,
     c 0.571,0.418,0.390,0.019,0.172,0.447,0.259,0.243,0.429,-.060,
     c 0.566,0.415,0.390,0.016,0.171,0.449,0.261,0.241,0.427,-.058,
     c 0.566,0.413,0.389,0.013,0.170,0.450,0.260,0.242,0.426,-.056,
     c 0.568,0.412,0.387,0.012,0.169,0.451,0.259,0.244,0.426,-.057,
     c 0.567,0.411,0.385,0.011,0.167,0.450,0.257,0.244,0.426,-.059,
     c 0.562,0.407,0.383,0.010,0.165,0.449,0.257,0.242,0.426,-.059,
     c 0.554,0.403,0.381,0.008,0.162,0.447,0.256,0.240,0.425,-.058,
     c 0.547,0.399,0.380,0.005,0.159,0.445,0.253,0.237,0.423,-.057,
     c 0.544,0.397,0.378,0.002,0.155,0.442,0.248,0.237,0.420,-.057,
     c 0.538,0.394,0.377,-.000,0.152,0.441,0.245,0.235,0.417,-.057,
     c 0.542,0.408,0.380,0.006,0.172,0.442,0.262,0.282,0.441,-.056,
     c 0.544,0.408,0.385,0.006,0.176,0.443,0.263,0.284,0.443,-.054,
     c 0.549,0.404,0.387,0.005,0.180,0.444,0.263,0.288,0.446,-.047,
     c 0.552,0.403,0.392,0.005,0.184,0.445,0.265,0.289,0.448,-.045,
     c 0.553,0.408,0.397,0.005,0.186,0.448,0.270,0.291,0.452,-.043,
     c 0.555,0.414,0.402,0.005,0.189,0.451,0.275,0.295,0.456,-.041,
     c 0.563,0.418,0.405,0.005,0.192,0.452,0.278,0.298,0.457,-.039,
     c 0.572,0.417,0.407,0.003,0.192,0.451,0.279,0.298,0.456,-.039,
     c 0.577,0.416,0.407,0.001,0.189,0.449,0.281,0.296,0.455,-.039,
     c 0.578,0.417,0.407,-.003,0.186,0.450,0.284,0.296,0.456,-.036,
     c 0.578,0.420,0.408,-.007,0.184,0.453,0.286,0.296,0.458,-.035,
     c 0.577,0.422,0.410,-.012,0.184,0.457,0.287,0.295,0.461,-.040,
     c 0.576,0.423,0.412,-.017,0.183,0.459,0.287,0.294,0.461,-.046,
     c 0.576,0.422,0.412,-.022,0.180,0.458,0.285,0.291,0.459,-.049,
     c 0.578,0.422,0.412,-.028,0.176,0.456,0.284,0.289,0.456,-.050,
     c 0.578,0.422,0.412,-.033,0.172,0.454,0.281,0.287,0.452,-.052,
     c 0.574,0.422,0.411,-.037,0.169,0.453,0.279,0.284,0.450,-.057,
     c 0.564,0.422,0.410,-.040,0.166,0.451,0.276,0.280,0.449,-.061,
     c 0.555,0.421,0.407,-.042,0.163,0.448,0.273,0.276,0.449,-.060,
     c 0.552,0.419,0.404,-.043,0.161,0.446,0.269,0.271,0.448,-.056,
     c 0.554,0.417,0.401,-.042,0.160,0.444,0.267,0.267,0.446,-.053,
     c 0.558,0.415,0.400,-.041,0.157,0.442,0.264,0.265,0.444,-.054,
     c 0.561,0.413,0.399,-.040,0.155,0.440,0.263,0.265,0.443,-.055,
     c 0.563,0.414,0.400,-.038,0.154,0.440,0.261,0.266,0.443,-.054,
     c 0.563,0.416,0.399,-.035,0.155,0.442,0.261,0.266,0.444,-.051,
     c 0.560,0.417,0.398,-.032,0.157,0.443,0.261,0.265,0.444,-.048,
     c 0.558,0.415,0.395,-.030,0.157,0.442,0.260,0.265,0.441,-.049,
     c 0.558,0.413,0.391,-.028,0.155,0.438,0.259,0.265,0.438,-.052,
     c 0.558,0.411,0.387,-.026,0.152,0.433,0.257,0.264,0.435,-.056,
     c 0.557,0.410,0.383,-.023,0.149,0.429,0.255,0.261,0.431,-.061,
     c 0.556,0.410,0.381,-.018,0.149,0.427,0.253,0.258,0.428,-.066,
     c 0.556,0.409,0.379,-.013,0.151,0.428,0.253,0.255,0.425,-.069,
     c 0.558,0.408,0.378,-.009,0.152,0.429,0.253,0.255,0.425,-.067,
     c 0.557,0.408,0.377,-.005,0.151,0.429,0.253,0.255,0.426,-.061,
     c 0.553,0.408,0.377,-.002,0.149,0.428,0.252,0.255,0.428,-.057,
     c 0.547,0.408,0.378,0.002,0.148,0.428,0.251,0.254,0.430,-.058,
     c 0.541,0.406,0.380,0.006,0.148,0.429,0.250,0.252,0.431,-.062,
     c 0.539,0.404,0.382,0.009,0.148,0.430,0.249,0.251,0.432,-.065,
     c 0.541,0.402,0.383,0.011,0.148,0.428,0.247,0.252,0.431,-.065,
     c 0.547,0.403,0.383,0.011,0.148,0.427,0.245,0.252,0.430,-.065,
     c 0.552,0.406,0.382,0.011,0.151,0.428,0.245,0.253,0.428,-.065,
     c 0.556,0.408,0.382,0.011,0.154,0.432,0.248,0.253,0.427,-.065,
     c 0.558,0.410,0.383,0.012,0.157,0.436,0.250,0.252,0.427,-.064,
     c 0.559,0.413,0.384,0.014,0.159,0.439,0.251,0.252,0.429,-.061,
     c 0.560,0.415,0.385,0.016,0.160,0.441,0.251,0.253,0.431,-.058,
     c 0.559,0.417,0.386,0.018,0.160,0.441,0.250,0.254,0.434,-.054,
     c 0.558,0.418,0.387,0.020,0.161,0.443,0.251,0.257,0.437,-.050,
     c 0.559,0.419,0.389,0.021,0.163,0.445,0.254,0.259,0.440,-.045,
     c 0.562,0.419,0.390,0.023,0.166,0.446,0.256,0.260,0.442,-.043,
     c 0.566,0.421,0.390,0.024,0.169,0.447,0.256,0.260,0.443,-.043,
     c 0.573,0.424,0.388,0.024,0.170,0.448,0.255,0.259,0.441,-.045,
     c 0.581,0.426,0.387,0.024,0.170,0.450,0.254,0.257,0.439,-.048,
     c 0.585,0.427,0.386,0.023,0.169,0.450,0.253,0.253,0.435,-.052,
     c 0.582,0.425,0.386,0.022,0.167,0.449,0.253,0.249,0.430,-.057,
     c 0.574,0.421,0.386,0.020,0.166,0.448,0.253,0.245,0.427,-.061,
     c 0.565,0.417,0.386,0.018,0.165,0.449,0.256,0.243,0.426,-.062,
     c 0.560,0.413,0.386,0.015,0.163,0.450,0.258,0.243,0.426,-.060,
     c 0.559,0.410,0.386,0.013,0.161,0.451,0.258,0.245,0.426,-.059,
     c 0.561,0.409,0.385,0.012,0.160,0.452,0.256,0.246,0.427,-.059,
     c 0.561,0.408,0.383,0.011,0.159,0.451,0.254,0.246,0.427,-.060,
     c 0.557,0.404,0.380,0.010,0.156,0.450,0.253,0.243,0.425,-.059,
     c 0.550,0.400,0.377,0.008,0.152,0.448,0.252,0.240,0.423,-.057,
     c 0.543,0.397,0.375,0.006,0.150,0.446,0.249,0.238,0.419,-.057,
     c 0.542,0.396,0.374,0.002,0.148,0.442,0.246,0.239,0.418,-.057,
     c 0.537,0.393,0.372,-.000,0.145,0.440,0.243,0.237,0.415,-.058,
     c 0.541,0.414,0.384,-.005,0.173,0.439,0.263,0.283,0.441,-.055,
     c 0.543,0.414,0.388,-.005,0.177,0.441,0.265,0.285,0.444,-.052,
     c 0.546,0.412,0.393,-.006,0.184,0.441,0.265,0.288,0.446,-.046,
     c 0.549,0.411,0.398,-.006,0.188,0.443,0.270,0.291,0.450,-.043,
     c 0.550,0.416,0.403,-.004,0.191,0.446,0.276,0.293,0.455,-.039,
     c 0.553,0.422,0.407,-.002,0.194,0.450,0.282,0.298,0.460,-.034,
     c 0.559,0.425,0.410,-.001,0.197,0.452,0.284,0.301,0.463,-.033,
     c 0.566,0.424,0.411,-.001,0.198,0.451,0.284,0.301,0.462,-.034,
     c 0.570,0.423,0.411,-.002,0.196,0.449,0.285,0.299,0.460,-.035,
     c 0.570,0.424,0.411,-.004,0.194,0.449,0.287,0.298,0.460,-.033,
     c 0.570,0.427,0.412,-.006,0.193,0.452,0.290,0.297,0.461,-.033,
     c 0.571,0.429,0.414,-.009,0.195,0.457,0.291,0.296,0.462,-.038,
     c 0.574,0.429,0.417,-.011,0.195,0.460,0.291,0.294,0.462,-.044,
     c 0.578,0.429,0.417,-.015,0.193,0.459,0.290,0.292,0.460,-.047,
     c 0.582,0.429,0.416,-.019,0.189,0.457,0.288,0.290,0.457,-.046,
     c 0.583,0.429,0.415,-.023,0.185,0.455,0.285,0.288,0.454,-.047,
     c 0.579,0.428,0.415,-.026,0.181,0.455,0.283,0.287,0.454,-.052,
     c 0.569,0.427,0.413,-.028,0.177,0.454,0.281,0.285,0.454,-.055,
     c 0.561,0.424,0.411,-.030,0.174,0.452,0.278,0.281,0.455,-.053,
     c 0.557,0.421,0.408,-.030,0.171,0.449,0.276,0.278,0.454,-.048,
     c 0.558,0.418,0.405,-.029,0.168,0.447,0.273,0.276,0.452,-.044,
     c 0.560,0.416,0.403,-.027,0.165,0.445,0.270,0.274,0.450,-.043,
     c 0.562,0.415,0.402,-.025,0.161,0.443,0.267,0.273,0.449,-.044,
     c 0.562,0.416,0.402,-.023,0.158,0.442,0.265,0.273,0.448,-.045,
     c 0.561,0.418,0.401,-.020,0.158,0.443,0.264,0.272,0.447,-.044,
     c 0.557,0.420,0.399,-.017,0.160,0.444,0.264,0.269,0.445,-.043,
     c 0.555,0.420,0.396,-.015,0.159,0.442,0.263,0.268,0.441,-.045,
     c 0.555,0.418,0.393,-.014,0.158,0.438,0.261,0.268,0.438,-.048,
     c 0.556,0.415,0.390,-.013,0.155,0.434,0.259,0.268,0.435,-.051,
     c 0.555,0.413,0.387,-.012,0.153,0.430,0.257,0.265,0.431,-.056,
     c 0.553,0.412,0.385,-.010,0.153,0.428,0.255,0.262,0.428,-.062,
     c 0.555,0.411,0.384,-.008,0.155,0.429,0.255,0.260,0.425,-.064,
     c 0.557,0.409,0.382,-.005,0.156,0.430,0.255,0.260,0.425,-.061,
     c 0.558,0.408,0.380,-.004,0.155,0.429,0.255,0.260,0.426,-.056,
     c 0.554,0.407,0.379,-.002,0.153,0.428,0.254,0.259,0.427,-.053,
     c 0.548,0.406,0.380,0.000,0.152,0.428,0.252,0.257,0.428,-.056,
     c 0.543,0.404,0.383,0.003,0.152,0.430,0.251,0.254,0.429,-.060,
     c 0.540,0.401,0.385,0.006,0.152,0.431,0.250,0.253,0.431,-.061,
     c 0.542,0.399,0.387,0.007,0.152,0.430,0.249,0.254,0.432,-.059,
     c 0.548,0.400,0.388,0.008,0.152,0.428,0.248,0.255,0.431,-.058,
     c 0.555,0.403,0.387,0.008,0.154,0.429,0.248,0.254,0.429,-.058,
     c 0.560,0.406,0.387,0.008,0.156,0.432,0.249,0.253,0.429,-.059,
     c 0.562,0.409,0.387,0.008,0.158,0.437,0.251,0.253,0.430,-.058,
     c 0.562,0.412,0.388,0.009,0.160,0.440,0.251,0.253,0.431,-.056,
     c 0.561,0.415,0.389,0.010,0.160,0.442,0.250,0.254,0.433,-.054,
     c 0.558,0.416,0.388,0.012,0.160,0.443,0.249,0.254,0.435,-.052,
     c 0.556,0.417,0.388,0.013,0.162,0.445,0.249,0.255,0.437,-.051,
     c 0.558,0.418,0.390,0.013,0.163,0.446,0.250,0.257,0.439,-.049,
     c 0.562,0.420,0.390,0.014,0.166,0.447,0.252,0.258,0.440,-.048,
     c 0.567,0.421,0.390,0.015,0.167,0.447,0.252,0.259,0.440,-.048,
     c 0.572,0.424,0.387,0.015,0.166,0.448,0.251,0.257,0.438,-.049,
     c 0.577,0.425,0.385,0.015,0.165,0.449,0.251,0.255,0.435,-.050,
     c 0.578,0.425,0.383,0.015,0.162,0.450,0.250,0.251,0.430,-.053,
     c 0.573,0.423,0.382,0.014,0.160,0.449,0.249,0.247,0.425,-.057,
     c 0.563,0.419,0.381,0.014,0.157,0.448,0.249,0.244,0.422,-.060,
     c 0.553,0.413,0.380,0.012,0.155,0.448,0.251,0.243,0.422,-.061,
     c 0.549,0.407,0.380,0.011,0.152,0.449,0.254,0.244,0.424,-.059,
     c 0.549,0.404,0.380,0.010,0.150,0.450,0.254,0.247,0.426,-.058,
     c 0.552,0.403,0.380,0.010,0.150,0.450,0.253,0.249,0.428,-.058,
     c 0.554,0.403,0.379,0.010,0.149,0.450,0.251,0.249,0.428,-.057,
     c 0.553,0.401,0.376,0.010,0.147,0.449,0.250,0.246,0.426,-.055,
     c 0.548,0.398,0.373,0.008,0.143,0.448,0.249,0.243,0.422,-.054,
     c 0.543,0.395,0.371,0.005,0.141,0.445,0.246,0.241,0.418,-.054,
     c 0.541,0.394,0.370,0.002,0.140,0.441,0.243,0.241,0.416,-.058,
     c 0.537,0.391,0.368,-.001,0.138,0.439,0.240,0.240,0.412,-.058,
     c 0.538,0.420,0.387,-.015,0.173,0.437,0.264,0.283,0.441,-.054,
     c 0.541,0.421,0.392,-.015,0.178,0.439,0.267,0.286,0.445,-.051,
     c 0.543,0.420,0.398,-.016,0.185,0.439,0.268,0.288,0.447,-.047,
     c 0.546,0.421,0.404,-.015,0.190,0.441,0.273,0.290,0.451,-.044,
     c 0.547,0.426,0.408,-.013,0.194,0.446,0.280,0.293,0.457,-.040,
     c 0.549,0.431,0.411,-.009,0.197,0.450,0.285,0.298,0.462,-.034,
     c 0.553,0.433,0.413,-.007,0.200,0.453,0.288,0.302,0.465,-.030,
     c 0.558,0.432,0.413,-.006,0.202,0.452,0.287,0.302,0.464,-.031,
     c 0.560,0.432,0.413,-.005,0.202,0.450,0.288,0.300,0.461,-.031,
     c 0.559,0.433,0.413,-.006,0.201,0.450,0.289,0.299,0.460,-.028,
     c 0.560,0.436,0.414,-.006,0.202,0.452,0.292,0.298,0.460,-.027,
     c 0.562,0.437,0.416,-.007,0.205,0.457,0.293,0.297,0.461,-.031,
     c 0.569,0.437,0.419,-.007,0.207,0.460,0.295,0.295,0.461,-.037,
     c 0.577,0.437,0.419,-.008,0.205,0.460,0.294,0.293,0.459,-.039,
     c 0.584,0.437,0.418,-.011,0.202,0.457,0.292,0.291,0.458,-.039,
     c 0.587,0.436,0.417,-.013,0.198,0.456,0.288,0.290,0.457,-.041,
     c 0.583,0.434,0.417,-.015,0.194,0.456,0.285,0.290,0.459,-.045,
     c 0.574,0.431,0.415,-.017,0.189,0.455,0.284,0.289,0.460,-.048,
     c 0.565,0.427,0.413,-.018,0.184,0.453,0.283,0.287,0.461,-.046,
     c 0.561,0.424,0.409,-.018,0.180,0.451,0.281,0.285,0.461,-.040,
     c 0.562,0.420,0.407,-.017,0.176,0.449,0.278,0.284,0.459,-.034,
     c 0.562,0.418,0.405,-.015,0.172,0.447,0.275,0.282,0.457,-.033,
     c 0.562,0.417,0.405,-.013,0.167,0.445,0.273,0.281,0.455,-.036,
     c 0.561,0.418,0.404,-.010,0.164,0.445,0.270,0.280,0.453,-.039,
     c 0.558,0.421,0.402,-.007,0.163,0.445,0.269,0.277,0.450,-.041,
     c 0.555,0.424,0.400,-.004,0.164,0.445,0.269,0.274,0.446,-.043,
     c 0.552,0.425,0.397,-.002,0.163,0.443,0.268,0.272,0.442,-.046,
     c 0.553,0.423,0.395,-.002,0.162,0.439,0.266,0.272,0.439,-.048,
     c 0.554,0.420,0.392,-.003,0.160,0.435,0.264,0.271,0.437,-.049,
     c 0.553,0.418,0.390,-.004,0.158,0.432,0.262,0.269,0.434,-.053,
     c 0.552,0.416,0.390,-.004,0.159,0.431,0.260,0.266,0.431,-.056,
     c 0.552,0.414,0.389,-.004,0.160,0.432,0.260,0.263,0.429,-.057,
     c 0.554,0.412,0.387,-.004,0.161,0.432,0.259,0.263,0.428,-.054,
     c 0.555,0.410,0.385,-.004,0.159,0.431,0.258,0.263,0.428,-.050,
     c 0.551,0.408,0.384,-.004,0.158,0.430,0.257,0.262,0.427,-.050,
     c 0.546,0.407,0.385,-.003,0.157,0.430,0.255,0.259,0.426,-.054,
     c 0.541,0.404,0.387,-.001,0.158,0.431,0.253,0.256,0.427,-.058,
     c 0.539,0.401,0.389,0.001,0.157,0.432,0.252,0.255,0.430,-.058,
     c 0.540,0.399,0.391,0.003,0.157,0.432,0.251,0.256,0.432,-.056,
     c 0.546,0.400,0.393,0.004,0.157,0.431,0.250,0.256,0.432,-.054,
     c 0.552,0.404,0.393,0.004,0.157,0.432,0.250,0.255,0.431,-.054,
     c 0.557,0.407,0.392,0.004,0.158,0.435,0.250,0.254,0.431,-.054,
     c 0.560,0.411,0.392,0.003,0.160,0.439,0.251,0.254,0.432,-.052,
     c 0.561,0.414,0.392,0.003,0.160,0.442,0.252,0.254,0.434,-.051,
     c 0.560,0.415,0.391,0.004,0.160,0.444,0.251,0.254,0.434,-.051,
     c 0.557,0.416,0.389,0.005,0.160,0.445,0.249,0.254,0.435,-.051,
     c 0.554,0.416,0.388,0.006,0.162,0.446,0.248,0.254,0.436,-.052,
     c 0.556,0.418,0.389,0.006,0.163,0.448,0.248,0.255,0.437,-.052,
     c 0.561,0.420,0.389,0.006,0.165,0.448,0.249,0.257,0.438,-.052,
     c 0.566,0.423,0.389,0.006,0.164,0.448,0.250,0.258,0.438,-.051,
     c 0.569,0.424,0.386,0.006,0.163,0.448,0.250,0.257,0.436,-.051,
     c 0.571,0.425,0.383,0.006,0.160,0.448,0.250,0.255,0.432,-.050,
     c 0.569,0.425,0.381,0.006,0.156,0.449,0.249,0.252,0.426,-.052,
     c 0.562,0.423,0.380,0.007,0.152,0.448,0.248,0.248,0.421,-.055,
     c 0.553,0.419,0.378,0.007,0.149,0.447,0.247,0.244,0.418,-.057,
     c 0.544,0.413,0.376,0.007,0.145,0.446,0.247,0.243,0.418,-.058,
     c 0.540,0.406,0.374,0.007,0.141,0.446,0.249,0.244,0.422,-.055,
     c 0.542,0.402,0.374,0.007,0.140,0.447,0.249,0.248,0.426,-.054,
     c 0.546,0.401,0.375,0.008,0.141,0.448,0.249,0.251,0.428,-.054,
     c 0.550,0.402,0.374,0.009,0.141,0.448,0.248,0.251,0.428,-.054,
     c 0.551,0.401,0.371,0.009,0.139,0.448,0.248,0.250,0.426,-.052,
     c 0.549,0.398,0.369,0.007,0.136,0.446,0.246,0.248,0.422,-.052,
     c 0.545,0.395,0.367,0.004,0.134,0.444,0.243,0.246,0.418,-.054,
     c 0.541,0.393,0.366,0.001,0.133,0.440,0.240,0.244,0.414,-.058,
     c 0.536,0.390,0.364,-.002,0.131,0.438,0.238,0.242,0.411,-.060,
     c 0.535,0.425,0.390,-.025,0.172,0.435,0.265,0.283,0.442,-.050,
     c 0.540,0.427,0.395,-.024,0.178,0.438,0.269,0.286,0.446,-.049,
     c 0.544,0.428,0.402,-.025,0.185,0.439,0.271,0.289,0.448,-.049,
     c 0.548,0.430,0.407,-.024,0.191,0.442,0.275,0.291,0.452,-.048,
     c 0.550,0.434,0.411,-.020,0.195,0.446,0.282,0.294,0.458,-.044,
     c 0.550,0.438,0.413,-.016,0.198,0.451,0.287,0.298,0.462,-.037,
     c 0.552,0.440,0.413,-.012,0.201,0.453,0.289,0.302,0.464,-.032,
     c 0.555,0.438,0.413,-.010,0.204,0.453,0.288,0.302,0.462,-.030,
     c 0.557,0.438,0.412,-.009,0.205,0.451,0.288,0.301,0.460,-.028,
     c 0.556,0.440,0.411,-.009,0.206,0.451,0.289,0.300,0.459,-.024,
     c 0.555,0.442,0.412,-.008,0.209,0.453,0.292,0.300,0.460,-.021,
     c 0.559,0.442,0.415,-.006,0.213,0.457,0.295,0.300,0.461,-.022,
     c 0.567,0.442,0.417,-.005,0.215,0.460,0.297,0.299,0.462,-.027,
     c 0.578,0.443,0.418,-.005,0.214,0.460,0.298,0.298,0.461,-.028,
     c 0.588,0.444,0.417,-.005,0.212,0.458,0.296,0.297,0.461,-.029,
     c 0.592,0.442,0.416,-.007,0.209,0.457,0.292,0.296,0.462,-.032,
     c 0.586,0.439,0.416,-.008,0.205,0.456,0.289,0.296,0.464,-.038,
     c 0.576,0.436,0.415,-.009,0.199,0.455,0.288,0.295,0.465,-.041,
     c 0.567,0.432,0.412,-.009,0.193,0.453,0.286,0.293,0.466,-.038,
     c 0.565,0.428,0.409,-.009,0.187,0.451,0.284,0.291,0.466,-.032,
     c 0.565,0.425,0.407,-.008,0.182,0.450,0.281,0.290,0.465,-.027,
     c 0.566,0.422,0.406,-.006,0.178,0.449,0.279,0.288,0.462,-.026,
     c 0.565,0.421,0.406,-.003,0.174,0.448,0.276,0.287,0.459,-.031,
     c 0.565,0.421,0.405,0.000,0.171,0.447,0.274,0.286,0.456,-.037,
     c 0.561,0.424,0.403,0.002,0.169,0.447,0.273,0.282,0.452,-.042,
     c 0.556,0.426,0.401,0.004,0.169,0.446,0.273,0.278,0.448,-.045,
     c 0.553,0.428,0.399,0.005,0.168,0.443,0.273,0.276,0.444,-.047,
     c 0.554,0.428,0.397,0.005,0.167,0.441,0.270,0.276,0.442,-.047,
     c 0.555,0.425,0.395,0.003,0.166,0.438,0.268,0.276,0.441,-.047,
     c 0.554,0.423,0.394,0.001,0.164,0.436,0.267,0.274,0.440,-.048,
     c 0.552,0.421,0.393,0.000,0.164,0.436,0.265,0.270,0.437,-.050,
     c 0.552,0.419,0.393,-.002,0.165,0.436,0.264,0.267,0.434,-.050,
     c 0.552,0.416,0.392,-.003,0.165,0.436,0.263,0.266,0.433,-.048,
     c 0.552,0.413,0.390,-.005,0.164,0.435,0.262,0.266,0.431,-.046,
     c 0.549,0.410,0.389,-.006,0.163,0.434,0.260,0.264,0.430,-.046,
     c 0.545,0.408,0.389,-.006,0.163,0.434,0.257,0.260,0.428,-.051,
     c 0.541,0.406,0.391,-.005,0.164,0.435,0.256,0.257,0.427,-.055,
     c 0.539,0.403,0.393,-.004,0.164,0.437,0.254,0.256,0.429,-.056,
     c 0.540,0.401,0.395,-.002,0.162,0.437,0.254,0.256,0.432,-.054,
     c 0.544,0.402,0.396,-.001,0.161,0.437,0.253,0.257,0.432,-.052,
     c 0.549,0.405,0.396,0.000,0.161,0.437,0.252,0.255,0.431,-.052,
     c 0.554,0.409,0.395,-.001,0.160,0.440,0.252,0.254,0.432,-.052,
     c 0.557,0.412,0.393,-.001,0.160,0.443,0.252,0.254,0.433,-.051,
     c 0.560,0.414,0.391,-.002,0.159,0.446,0.252,0.255,0.435,-.050,
     c 0.560,0.414,0.389,-.001,0.159,0.447,0.252,0.255,0.434,-.051,
     c 0.557,0.413,0.386,0.000,0.158,0.447,0.250,0.254,0.434,-.052,
     c 0.555,0.413,0.385,0.000,0.160,0.449,0.248,0.254,0.434,-.054,
     c 0.556,0.416,0.385,0.000,0.162,0.450,0.247,0.255,0.435,-.055,
     c 0.561,0.419,0.385,-.001,0.162,0.451,0.247,0.256,0.435,-.054,
     c 0.565,0.422,0.384,-.001,0.161,0.449,0.248,0.257,0.435,-.052,
     c 0.567,0.423,0.382,-.001,0.159,0.448,0.248,0.257,0.433,-.051,
     c 0.565,0.424,0.381,0.000,0.156,0.449,0.248,0.256,0.430,-.050,
     c 0.561,0.424,0.380,0.000,0.152,0.450,0.248,0.254,0.425,-.051,
     c 0.555,0.424,0.379,0.001,0.148,0.450,0.246,0.251,0.420,-.053,
     c 0.548,0.421,0.376,0.002,0.144,0.448,0.244,0.246,0.416,-.056,
     c 0.542,0.415,0.373,0.003,0.139,0.446,0.243,0.244,0.418,-.056,
     c 0.541,0.408,0.370,0.004,0.135,0.445,0.243,0.245,0.422,-.053,
     c 0.543,0.404,0.370,0.006,0.133,0.445,0.243,0.250,0.427,-.051,
     c 0.548,0.403,0.370,0.007,0.134,0.445,0.243,0.253,0.429,-.052,
     c 0.552,0.403,0.369,0.009,0.135,0.446,0.244,0.254,0.428,-.053,
     c 0.554,0.402,0.366,0.009,0.133,0.446,0.244,0.253,0.426,-.053,
     c 0.553,0.399,0.364,0.007,0.130,0.445,0.243,0.251,0.422,-.054,
     c 0.549,0.396,0.363,0.003,0.128,0.442,0.240,0.250,0.418,-.056,
     c 0.542,0.393,0.362,0.000,0.126,0.439,0.237,0.247,0.413,-.060,
     c 0.537,0.390,0.360,-.004,0.124,0.437,0.234,0.245,0.409,-.062,
     c 0.533,0.427,0.392,-.032,0.169,0.435,0.269,0.283,0.443,-.046,
     c 0.540,0.429,0.397,-.031,0.175,0.438,0.272,0.286,0.447,-.046,
     c 0.548,0.433,0.404,-.033,0.183,0.441,0.274,0.291,0.450,-.048,
     c 0.555,0.435,0.410,-.031,0.188,0.444,0.278,0.293,0.453,-.050,
     c 0.558,0.440,0.413,-.026,0.192,0.448,0.284,0.296,0.457,-.047,
     c 0.557,0.443,0.414,-.022,0.196,0.451,0.289,0.300,0.460,-.040,
     c 0.557,0.443,0.414,-.018,0.199,0.453,0.291,0.303,0.461,-.035,
     c 0.559,0.441,0.413,-.015,0.202,0.453,0.290,0.302,0.460,-.032,
     c 0.561,0.441,0.412,-.014,0.205,0.453,0.289,0.301,0.458,-.029,
     c 0.560,0.443,0.410,-.012,0.208,0.453,0.290,0.300,0.457,-.024,
     c 0.559,0.443,0.410,-.011,0.212,0.455,0.293,0.301,0.459,-.020,
     c 0.563,0.443,0.412,-.008,0.216,0.458,0.297,0.303,0.462,-.019,
     c 0.572,0.443,0.415,-.005,0.219,0.461,0.301,0.303,0.464,-.020,
     c 0.585,0.445,0.417,-.003,0.220,0.462,0.303,0.303,0.464,-.020,
     c 0.594,0.447,0.416,-.003,0.219,0.461,0.302,0.303,0.464,-.021,
     c 0.596,0.447,0.416,-.004,0.216,0.460,0.299,0.303,0.464,-.025,
     c 0.588,0.444,0.416,-.005,0.212,0.459,0.296,0.302,0.466,-.031,
     c 0.576,0.441,0.415,-.005,0.205,0.457,0.294,0.300,0.466,-.035,
     c 0.567,0.437,0.412,-.005,0.197,0.455,0.291,0.297,0.466,-.034,
     c 0.565,0.434,0.408,-.004,0.190,0.453,0.287,0.295,0.465,-.030,
     c 0.567,0.430,0.407,-.002,0.185,0.453,0.285,0.293,0.464,-.026,
     c 0.569,0.427,0.407,0.000,0.182,0.452,0.282,0.292,0.462,-.026,
     c 0.570,0.425,0.407,0.003,0.178,0.452,0.280,0.290,0.459,-.031,
     c 0.570,0.424,0.407,0.006,0.175,0.451,0.279,0.289,0.456,-.037,
     c 0.567,0.426,0.406,0.008,0.173,0.450,0.278,0.286,0.452,-.043,
     c 0.561,0.428,0.404,0.009,0.173,0.448,0.278,0.283,0.449,-.046,
     c 0.557,0.430,0.403,0.009,0.172,0.446,0.277,0.281,0.446,-.047,
     c 0.556,0.430,0.402,0.009,0.171,0.445,0.276,0.281,0.445,-.046,
     c 0.557,0.428,0.400,0.007,0.170,0.444,0.274,0.281,0.446,-.044,
     c 0.557,0.426,0.399,0.004,0.169,0.443,0.273,0.278,0.445,-.043,
     c 0.554,0.424,0.398,0.002,0.168,0.443,0.271,0.274,0.442,-.044,
     c 0.553,0.422,0.397,0.000,0.168,0.444,0.270,0.271,0.438,-.045,
     c 0.553,0.419,0.396,-.003,0.168,0.443,0.268,0.269,0.436,-.043,
     c 0.553,0.415,0.395,-.006,0.167,0.442,0.266,0.268,0.435,-.042,
     c 0.550,0.412,0.395,-.008,0.166,0.441,0.263,0.266,0.434,-.042,
     c 0.547,0.410,0.395,-.009,0.167,0.441,0.261,0.262,0.431,-.046,
     c 0.544,0.408,0.396,-.009,0.168,0.443,0.259,0.258,0.430,-.050,
     c 0.543,0.405,0.397,-.008,0.167,0.444,0.258,0.256,0.430,-.051,
     c 0.543,0.403,0.397,-.007,0.165,0.445,0.258,0.257,0.431,-.051,
     c 0.544,0.404,0.398,-.006,0.164,0.445,0.257,0.257,0.431,-.052,
     c 0.548,0.407,0.397,-.005,0.162,0.445,0.256,0.256,0.430,-.052,
     c 0.552,0.411,0.395,-.005,0.161,0.446,0.255,0.255,0.431,-.052,
     c 0.556,0.413,0.393,-.006,0.160,0.449,0.255,0.255,0.432,-.051,
     c 0.559,0.413,0.390,-.006,0.157,0.451,0.255,0.256,0.433,-.051,
     c 0.560,0.412,0.387,-.006,0.155,0.452,0.254,0.255,0.432,-.053,
     c 0.559,0.409,0.384,-.005,0.154,0.452,0.253,0.254,0.431,-.054,
     c 0.556,0.408,0.382,-.005,0.155,0.452,0.250,0.253,0.430,-.056,
     c 0.556,0.410,0.382,-.005,0.157,0.453,0.248,0.253,0.430,-.056,
     c 0.559,0.413,0.381,-.005,0.157,0.453,0.247,0.255,0.430,-.055,
     c 0.561,0.416,0.381,-.005,0.156,0.452,0.247,0.257,0.430,-.052,
     c 0.560,0.417,0.380,-.005,0.153,0.450,0.247,0.258,0.429,-.050,
     c 0.556,0.417,0.379,-.004,0.151,0.451,0.247,0.258,0.428,-.049,
     c 0.552,0.419,0.379,-.003,0.148,0.453,0.247,0.257,0.424,-.050,
     c 0.547,0.420,0.379,-.001,0.145,0.453,0.245,0.254,0.420,-.054,
     c 0.543,0.419,0.377,0.001,0.141,0.451,0.243,0.249,0.417,-.057,
     c 0.542,0.415,0.373,0.003,0.135,0.448,0.241,0.246,0.419,-.056,
     c 0.544,0.409,0.370,0.005,0.130,0.446,0.240,0.247,0.423,-.052,
     c 0.548,0.406,0.369,0.007,0.128,0.445,0.239,0.251,0.427,-.051,
     c 0.553,0.405,0.368,0.008,0.129,0.445,0.239,0.254,0.428,-.053,
     c 0.556,0.405,0.366,0.009,0.129,0.445,0.241,0.255,0.427,-.057,
     c 0.558,0.403,0.364,0.009,0.127,0.445,0.242,0.254,0.424,-.058,
     c 0.556,0.400,0.362,0.006,0.123,0.445,0.241,0.253,0.421,-.058,
     c 0.551,0.395,0.361,0.002,0.121,0.442,0.238,0.252,0.416,-.060,
     c 0.541,0.391,0.359,-.002,0.119,0.439,0.235,0.249,0.412,-.062,
     c 0.536,0.387,0.357,-.006,0.117,0.436,0.232,0.248,0.407,-.064,
     c 0.534,0.430,0.394,-.037,0.168,0.437,0.274,0.284,0.448,-.038,
     c 0.542,0.433,0.399,-.035,0.174,0.440,0.276,0.288,0.451,-.040,
     c 0.554,0.436,0.406,-.037,0.181,0.444,0.279,0.293,0.454,-.044,
     c 0.564,0.439,0.411,-.035,0.187,0.447,0.282,0.297,0.456,-.047,
     c 0.568,0.443,0.415,-.030,0.192,0.450,0.287,0.300,0.459,-.045,
     c 0.567,0.445,0.416,-.025,0.195,0.452,0.292,0.303,0.461,-.039,
     c 0.566,0.445,0.416,-.021,0.199,0.453,0.294,0.305,0.462,-.034,
     c 0.567,0.443,0.414,-.018,0.202,0.454,0.292,0.303,0.461,-.033,
     c 0.570,0.443,0.413,-.016,0.205,0.454,0.291,0.301,0.459,-.032,
     c 0.570,0.444,0.411,-.015,0.209,0.455,0.292,0.301,0.460,-.028,
     c 0.569,0.444,0.410,-.012,0.213,0.457,0.296,0.302,0.462,-.024,
     c 0.573,0.443,0.412,-.009,0.218,0.460,0.301,0.304,0.466,-.022,
     c 0.583,0.444,0.415,-.005,0.222,0.464,0.305,0.305,0.468,-.022,
     c 0.595,0.447,0.417,-.003,0.224,0.465,0.307,0.306,0.467,-.020,
     c 0.602,0.450,0.417,-.003,0.223,0.464,0.307,0.306,0.466,-.020,
     c 0.600,0.451,0.417,-.003,0.221,0.463,0.304,0.306,0.466,-.023,
     c 0.588,0.450,0.417,-.004,0.217,0.462,0.302,0.305,0.466,-.029,
     c 0.574,0.448,0.416,-.003,0.210,0.460,0.299,0.302,0.465,-.033,
     c 0.566,0.445,0.412,-.002,0.202,0.458,0.294,0.298,0.464,-.034,
     c 0.565,0.441,0.409,-.001,0.194,0.456,0.290,0.296,0.463,-.032,
     c 0.568,0.438,0.407,0.001,0.189,0.456,0.288,0.294,0.462,-.030,
     c 0.572,0.434,0.408,0.004,0.186,0.456,0.287,0.293,0.460,-.030,
     c 0.575,0.431,0.409,0.007,0.183,0.456,0.286,0.292,0.457,-.032,
     c 0.576,0.429,0.410,0.010,0.181,0.455,0.285,0.291,0.455,-.036,
     c 0.573,0.430,0.409,0.011,0.179,0.453,0.285,0.290,0.453,-.040,
     c 0.567,0.431,0.409,0.012,0.177,0.451,0.284,0.287,0.450,-.043,
     c 0.561,0.433,0.408,0.012,0.176,0.450,0.283,0.285,0.448,-.044,
     c 0.560,0.433,0.408,0.011,0.175,0.449,0.281,0.284,0.448,-.044,
     c 0.561,0.433,0.407,0.009,0.175,0.450,0.280,0.284,0.449,-.043,
     c 0.561,0.430,0.405,0.007,0.174,0.450,0.278,0.281,0.449,-.041,
     c 0.559,0.428,0.403,0.004,0.173,0.451,0.277,0.277,0.446,-.041,
     c 0.556,0.426,0.402,0.001,0.172,0.451,0.275,0.274,0.443,-.041,
     c 0.556,0.423,0.401,-.002,0.171,0.450,0.273,0.272,0.441,-.041,
     c 0.556,0.419,0.400,-.006,0.170,0.449,0.270,0.271,0.441,-.039,
     c 0.555,0.416,0.400,-.009,0.171,0.448,0.267,0.269,0.440,-.038,
     c 0.553,0.414,0.401,-.010,0.172,0.448,0.265,0.266,0.438,-.039,
     c 0.551,0.413,0.400,-.011,0.172,0.449,0.263,0.262,0.436,-.042,
     c 0.551,0.411,0.400,-.011,0.171,0.451,0.262,0.260,0.435,-.045,
     c 0.550,0.409,0.400,-.010,0.168,0.451,0.262,0.259,0.435,-.047,
     c 0.549,0.409,0.399,-.009,0.166,0.451,0.261,0.259,0.434,-.050,
     c 0.551,0.412,0.398,-.008,0.164,0.451,0.259,0.258,0.433,-.051,
     c 0.554,0.414,0.396,-.008,0.163,0.453,0.258,0.257,0.434,-.051,
     c 0.557,0.416,0.393,-.009,0.161,0.454,0.258,0.257,0.434,-.050,
     c 0.561,0.415,0.390,-.009,0.158,0.456,0.259,0.258,0.434,-.051,
     c 0.562,0.412,0.387,-.009,0.155,0.456,0.258,0.257,0.431,-.052,
     c 0.560,0.407,0.385,-.008,0.153,0.456,0.256,0.255,0.429,-.054,
     c 0.557,0.405,0.383,-.008,0.153,0.455,0.254,0.252,0.427,-.056,
     c 0.555,0.405,0.382,-.008,0.153,0.456,0.251,0.252,0.427,-.056,
     c 0.556,0.409,0.381,-.008,0.153,0.455,0.249,0.254,0.426,-.054,
     c 0.556,0.411,0.380,-.007,0.152,0.454,0.248,0.256,0.427,-.050,
     c 0.552,0.410,0.379,-.006,0.150,0.452,0.247,0.257,0.426,-.048,
     c 0.547,0.410,0.379,-.004,0.149,0.453,0.246,0.258,0.426,-.048,
     c 0.541,0.413,0.380,-.002,0.147,0.455,0.245,0.258,0.425,-.049,
     c 0.538,0.416,0.379,0.001,0.145,0.455,0.244,0.256,0.422,-.053,
     c 0.537,0.417,0.377,0.003,0.140,0.454,0.242,0.252,0.420,-.056,
     c 0.539,0.414,0.374,0.006,0.135,0.451,0.240,0.249,0.421,-.054,
     c 0.543,0.411,0.371,0.008,0.129,0.449,0.238,0.251,0.425,-.050,
     c 0.550,0.409,0.369,0.010,0.125,0.447,0.236,0.254,0.429,-.049,
     c 0.556,0.408,0.367,0.011,0.125,0.446,0.236,0.255,0.429,-.054,
     c 0.559,0.408,0.365,0.011,0.124,0.446,0.237,0.255,0.427,-.059,
     c 0.559,0.406,0.362,0.010,0.122,0.446,0.239,0.256,0.424,-.062,
     c 0.556,0.401,0.360,0.007,0.119,0.446,0.240,0.256,0.421,-.062,
     c 0.550,0.396,0.359,0.002,0.116,0.443,0.237,0.254,0.416,-.062,
     c 0.541,0.391,0.357,-.003,0.114,0.439,0.233,0.252,0.412,-.063,
     c 0.535,0.386,0.356,-.007,0.112,0.436,0.231,0.250,0.408,-.065,
     c 0.534,0.431,0.396,-.040,0.165,0.439,0.277,0.285,0.453,-.033,
     c 0.543,0.434,0.400,-.038,0.171,0.442,0.279,0.289,0.455,-.035,
     c 0.555,0.436,0.404,-.040,0.179,0.446,0.281,0.293,0.458,-.038,
     c 0.566,0.439,0.409,-.038,0.185,0.450,0.284,0.298,0.459,-.041,
     c 0.571,0.443,0.413,-.033,0.190,0.452,0.288,0.301,0.460,-.040,
     c 0.570,0.446,0.414,-.028,0.193,0.453,0.293,0.304,0.462,-.036,
     c 0.568,0.447,0.415,-.024,0.198,0.453,0.295,0.305,0.463,-.032,
     c 0.571,0.445,0.415,-.020,0.201,0.453,0.294,0.303,0.463,-.032,
     c 0.575,0.445,0.413,-.018,0.204,0.454,0.293,0.300,0.462,-.034,
     c 0.576,0.445,0.411,-.017,0.207,0.455,0.293,0.299,0.463,-.033,
     c 0.577,0.443,0.410,-.014,0.212,0.457,0.297,0.300,0.465,-.031,
     c 0.582,0.442,0.412,-.011,0.217,0.460,0.302,0.301,0.468,-.030,
     c 0.592,0.442,0.415,-.007,0.221,0.464,0.306,0.303,0.469,-.028,
     c 0.603,0.446,0.417,-.005,0.223,0.466,0.308,0.305,0.468,-.026,
     c 0.607,0.450,0.417,-.005,0.223,0.466,0.307,0.306,0.465,-.025,
     c 0.600,0.453,0.417,-.006,0.222,0.465,0.304,0.306,0.463,-.026,
     c 0.585,0.454,0.417,-.006,0.218,0.464,0.302,0.305,0.462,-.031,
     c 0.571,0.453,0.416,-.004,0.212,0.462,0.298,0.301,0.460,-.035,
     c 0.562,0.450,0.412,-.003,0.204,0.460,0.294,0.297,0.458,-.037,
     c 0.563,0.448,0.408,-.001,0.197,0.459,0.291,0.295,0.457,-.038,
     c 0.567,0.445,0.407,0.002,0.192,0.459,0.290,0.294,0.457,-.037,
     c 0.572,0.441,0.408,0.005,0.189,0.459,0.291,0.292,0.457,-.035,
     c 0.576,0.437,0.410,0.008,0.187,0.459,0.291,0.292,0.455,-.034,
     c 0.579,0.436,0.411,0.010,0.185,0.459,0.290,0.291,0.454,-.034,
     c 0.577,0.436,0.411,0.011,0.182,0.457,0.289,0.291,0.453,-.035,
     c 0.571,0.436,0.411,0.011,0.181,0.455,0.288,0.289,0.451,-.037,
     c 0.565,0.437,0.411,0.011,0.179,0.454,0.287,0.287,0.450,-.040,
     c 0.563,0.437,0.412,0.010,0.177,0.454,0.285,0.285,0.450,-.042,
     c 0.564,0.435,0.411,0.009,0.177,0.454,0.283,0.284,0.451,-.043,
     c 0.564,0.433,0.409,0.006,0.177,0.454,0.282,0.282,0.450,-.042,
     c 0.562,0.430,0.406,0.004,0.177,0.455,0.281,0.278,0.448,-.040,
     c 0.559,0.428,0.404,-.000,0.176,0.455,0.279,0.274,0.446,-.040,
     c 0.558,0.426,0.403,-.003,0.174,0.454,0.275,0.272,0.444,-.040,
     c 0.558,0.423,0.403,-.007,0.173,0.452,0.271,0.271,0.444,-.039,
     c 0.557,0.421,0.403,-.010,0.174,0.452,0.268,0.270,0.445,-.037,
     c 0.556,0.420,0.403,-.012,0.176,0.452,0.266,0.269,0.444,-.036,
     c 0.555,0.418,0.403,-.013,0.175,0.453,0.264,0.266,0.442,-.037,
     c 0.554,0.416,0.402,-.013,0.172,0.454,0.262,0.263,0.440,-.040,
     c 0.552,0.413,0.400,-.013,0.169,0.454,0.262,0.262,0.439,-.044,
     c 0.550,0.413,0.398,-.012,0.166,0.454,0.261,0.262,0.437,-.048,
     c 0.550,0.415,0.396,-.011,0.165,0.455,0.260,0.261,0.437,-.050,
     c 0.552,0.417,0.394,-.012,0.164,0.456,0.259,0.260,0.437,-.049,
     c 0.554,0.418,0.392,-.012,0.163,0.458,0.260,0.260,0.437,-.048,
     c 0.557,0.416,0.390,-.013,0.160,0.459,0.260,0.259,0.434,-.048,
     c 0.559,0.411,0.388,-.013,0.156,0.459,0.258,0.257,0.431,-.050,
     c 0.557,0.405,0.385,-.012,0.153,0.458,0.256,0.253,0.428,-.052,
     c 0.552,0.401,0.384,-.012,0.151,0.457,0.254,0.251,0.425,-.055,
     c 0.549,0.401,0.383,-.011,0.150,0.456,0.252,0.250,0.424,-.055,
     c 0.548,0.404,0.381,-.010,0.149,0.456,0.250,0.251,0.424,-.052,
     c 0.547,0.406,0.380,-.008,0.148,0.454,0.248,0.253,0.423,-.049,
     c 0.543,0.406,0.379,-.006,0.147,0.452,0.247,0.254,0.423,-.047,
     c 0.536,0.405,0.378,-.003,0.147,0.452,0.244,0.255,0.423,-.046,
     c 0.531,0.407,0.378,-.000,0.146,0.454,0.243,0.256,0.423,-.048,
     c 0.529,0.411,0.377,0.003,0.144,0.455,0.242,0.255,0.422,-.051,
     c 0.529,0.413,0.375,0.006,0.139,0.454,0.241,0.253,0.421,-.053,
     c 0.532,0.412,0.372,0.008,0.133,0.452,0.240,0.251,0.422,-.051,
     c 0.538,0.410,0.369,0.011,0.126,0.450,0.237,0.252,0.425,-.046,
     c 0.546,0.410,0.367,0.012,0.122,0.448,0.234,0.253,0.427,-.047,
     c 0.554,0.409,0.365,0.012,0.120,0.447,0.232,0.254,0.426,-.054,
     c 0.557,0.408,0.361,0.011,0.119,0.447,0.233,0.254,0.424,-.061,
     c 0.554,0.406,0.358,0.009,0.117,0.447,0.236,0.255,0.422,-.064,
     c 0.549,0.401,0.356,0.005,0.113,0.446,0.237,0.256,0.420,-.063,
     c 0.543,0.395,0.356,-.000,0.110,0.442,0.235,0.255,0.416,-.063,
     c 0.537,0.389,0.354,-.006,0.109,0.437,0.231,0.253,0.411,-.064,
     c 0.530,0.384,0.353,-.011,0.107,0.433,0.229,0.251,0.407,-.066,
     c 0.536,0.431,0.397,-.040,0.162,0.442,0.280,0.285,0.458,-.029,
     c 0.545,0.435,0.400,-.038,0.168,0.445,0.281,0.288,0.459,-.031,
     c 0.555,0.435,0.403,-.040,0.175,0.449,0.282,0.292,0.463,-.032,
     c 0.565,0.438,0.406,-.038,0.182,0.453,0.284,0.296,0.463,-.035,
     c 0.570,0.444,0.409,-.033,0.187,0.454,0.288,0.299,0.462,-.035,
     c 0.568,0.448,0.410,-.028,0.191,0.453,0.292,0.302,0.463,-.033,
     c 0.567,0.449,0.412,-.024,0.195,0.453,0.294,0.303,0.465,-.030,
     c 0.570,0.448,0.414,-.020,0.198,0.453,0.294,0.301,0.466,-.031,
     c 0.576,0.447,0.414,-.018,0.201,0.454,0.292,0.298,0.466,-.034,
     c 0.580,0.447,0.412,-.017,0.204,0.455,0.293,0.296,0.466,-.034,
     c 0.581,0.445,0.411,-.015,0.208,0.456,0.296,0.297,0.469,-.033,
     c 0.586,0.442,0.412,-.012,0.213,0.460,0.300,0.299,0.471,-.030,
     c 0.596,0.442,0.414,-.009,0.217,0.463,0.303,0.302,0.470,-.029,
     c 0.606,0.445,0.415,-.008,0.219,0.466,0.304,0.304,0.467,-.027,
     c 0.607,0.450,0.415,-.008,0.219,0.466,0.303,0.305,0.462,-.026,
     c 0.598,0.454,0.415,-.008,0.219,0.466,0.301,0.305,0.459,-.028,
     c 0.582,0.456,0.416,-.008,0.216,0.465,0.299,0.304,0.457,-.033,
     c 0.568,0.455,0.415,-.006,0.211,0.464,0.296,0.300,0.455,-.037,
     c 0.562,0.454,0.413,-.004,0.205,0.462,0.292,0.296,0.453,-.041,
     c 0.563,0.452,0.409,-.001,0.199,0.462,0.290,0.294,0.453,-.043,
     c 0.568,0.451,0.408,0.002,0.195,0.462,0.292,0.294,0.455,-.042,
     c 0.573,0.448,0.409,0.005,0.192,0.464,0.293,0.293,0.456,-.039,
     c 0.578,0.445,0.410,0.007,0.190,0.464,0.293,0.292,0.455,-.034,
     c 0.581,0.443,0.411,0.009,0.188,0.464,0.291,0.291,0.455,-.031,
     c 0.579,0.442,0.411,0.010,0.186,0.463,0.290,0.292,0.455,-.029,
     c 0.574,0.442,0.412,0.010,0.184,0.462,0.289,0.291,0.454,-.029,
     c 0.570,0.441,0.413,0.009,0.182,0.460,0.287,0.289,0.453,-.033,
     c 0.568,0.440,0.414,0.009,0.180,0.459,0.284,0.287,0.453,-.037,
     c 0.570,0.438,0.414,0.007,0.179,0.458,0.283,0.285,0.454,-.040,
     c 0.569,0.435,0.412,0.005,0.180,0.459,0.283,0.282,0.453,-.039,
     c 0.566,0.432,0.409,0.002,0.181,0.459,0.283,0.278,0.451,-.038,
     c 0.561,0.429,0.406,-.002,0.180,0.459,0.281,0.274,0.449,-.038,
     c 0.560,0.428,0.404,-.005,0.179,0.457,0.277,0.271,0.448,-.039,
     c 0.560,0.427,0.404,-.008,0.179,0.455,0.272,0.270,0.447,-.040,
     c 0.559,0.426,0.404,-.011,0.180,0.454,0.268,0.270,0.448,-.039,
     c 0.557,0.425,0.405,-.012,0.181,0.455,0.266,0.270,0.447,-.037,
     c 0.556,0.423,0.404,-.013,0.179,0.455,0.264,0.268,0.446,-.036,
     c 0.554,0.419,0.402,-.014,0.175,0.456,0.263,0.266,0.444,-.038,
     c 0.551,0.416,0.400,-.014,0.171,0.456,0.262,0.265,0.442,-.041,
     c 0.547,0.414,0.397,-.014,0.168,0.456,0.261,0.263,0.440,-.046,
     c 0.546,0.414,0.395,-.014,0.166,0.457,0.260,0.263,0.439,-.048,
     c 0.548,0.416,0.393,-.015,0.165,0.458,0.259,0.262,0.438,-.047,
     c 0.551,0.417,0.391,-.016,0.164,0.460,0.260,0.261,0.437,-.044,
     c 0.553,0.414,0.389,-.016,0.161,0.460,0.259,0.259,0.434,-.043,
     c 0.555,0.409,0.387,-.016,0.157,0.460,0.257,0.256,0.430,-.045,
     c 0.553,0.402,0.385,-.016,0.153,0.458,0.255,0.252,0.428,-.049,
     c 0.548,0.398,0.384,-.016,0.150,0.457,0.252,0.249,0.426,-.053,
     c 0.543,0.397,0.382,-.015,0.149,0.456,0.250,0.249,0.426,-.053,
     c 0.541,0.401,0.381,-.013,0.147,0.455,0.249,0.251,0.426,-.050,
     c 0.541,0.404,0.379,-.010,0.146,0.453,0.247,0.252,0.425,-.047,
     c 0.538,0.404,0.377,-.006,0.146,0.451,0.245,0.252,0.423,-.045,
     c 0.533,0.404,0.376,-.002,0.146,0.451,0.243,0.252,0.423,-.045,
     c 0.528,0.405,0.374,0.002,0.145,0.453,0.242,0.254,0.423,-.046,
     c 0.527,0.409,0.373,0.005,0.142,0.454,0.242,0.254,0.423,-.047,
     c 0.527,0.411,0.371,0.008,0.137,0.453,0.242,0.254,0.422,-.048,
     c 0.529,0.411,0.368,0.010,0.131,0.451,0.241,0.253,0.423,-.045,
     c 0.535,0.410,0.366,0.011,0.125,0.450,0.237,0.254,0.424,-.041,
     c 0.544,0.410,0.364,0.012,0.119,0.448,0.233,0.254,0.425,-.042,
     c 0.553,0.409,0.362,0.011,0.117,0.447,0.231,0.253,0.423,-.050,
     c 0.556,0.407,0.358,0.008,0.115,0.447,0.231,0.253,0.421,-.059,
     c 0.552,0.404,0.355,0.005,0.113,0.447,0.234,0.254,0.420,-.062,
     c 0.544,0.398,0.353,0.001,0.109,0.445,0.235,0.256,0.418,-.062,
     c 0.537,0.392,0.352,-.004,0.107,0.440,0.233,0.255,0.415,-.062,
     c 0.533,0.387,0.352,-.010,0.106,0.435,0.230,0.253,0.410,-.065,
     c 0.527,0.381,0.350,-.015,0.103,0.431,0.227,0.252,0.406,-.067,
     c 0.538,0.433,0.398,-.037,0.159,0.445,0.282,0.286,0.460,-.026,
     c 0.546,0.436,0.401,-.036,0.164,0.448,0.282,0.289,0.462,-.028,
     c 0.555,0.438,0.402,-.037,0.170,0.452,0.281,0.292,0.466,-.027,
     c 0.563,0.442,0.404,-.035,0.176,0.454,0.281,0.295,0.466,-.031,
     c 0.567,0.448,0.405,-.031,0.181,0.455,0.284,0.297,0.464,-.034,
     c 0.565,0.453,0.406,-.027,0.184,0.453,0.287,0.300,0.464,-.034,
     c 0.564,0.454,0.408,-.023,0.188,0.452,0.289,0.301,0.465,-.033,
     c 0.568,0.453,0.412,-.019,0.192,0.453,0.290,0.299,0.466,-.033,
     c 0.575,0.453,0.413,-.017,0.195,0.454,0.289,0.296,0.466,-.033,
     c 0.580,0.452,0.412,-.015,0.198,0.455,0.289,0.296,0.467,-.032,
     c 0.581,0.450,0.411,-.014,0.202,0.457,0.291,0.297,0.470,-.027,
     c 0.586,0.447,0.412,-.012,0.207,0.460,0.295,0.300,0.472,-.022,
     c 0.595,0.446,0.413,-.010,0.210,0.463,0.298,0.303,0.471,-.020,
     c 0.604,0.447,0.413,-.010,0.212,0.465,0.299,0.306,0.466,-.019,
     c 0.605,0.450,0.412,-.010,0.212,0.466,0.298,0.307,0.461,-.020,
     c 0.597,0.454,0.413,-.010,0.212,0.467,0.296,0.306,0.457,-.024,
     c 0.582,0.456,0.414,-.009,0.211,0.466,0.294,0.304,0.455,-.030,
     c 0.570,0.457,0.415,-.007,0.207,0.465,0.292,0.300,0.452,-.037,
     c 0.566,0.457,0.413,-.005,0.203,0.464,0.290,0.297,0.450,-.042,
     c 0.568,0.457,0.411,-.002,0.199,0.465,0.290,0.297,0.452,-.045,
     c 0.572,0.457,0.411,0.001,0.196,0.466,0.292,0.297,0.455,-.045,
     c 0.576,0.455,0.411,0.003,0.195,0.468,0.293,0.296,0.457,-.041,
     c 0.579,0.452,0.412,0.006,0.193,0.470,0.291,0.294,0.458,-.035,
     c 0.581,0.450,0.412,0.008,0.191,0.471,0.288,0.294,0.458,-.029,
     c 0.581,0.448,0.411,0.008,0.190,0.470,0.287,0.294,0.459,-.025,
     c 0.578,0.447,0.412,0.008,0.188,0.469,0.285,0.294,0.460,-.023,
     c 0.575,0.445,0.413,0.007,0.186,0.467,0.283,0.292,0.459,-.026,
     c 0.574,0.443,0.415,0.006,0.184,0.465,0.280,0.291,0.459,-.031,
     c 0.575,0.441,0.415,0.004,0.184,0.464,0.280,0.289,0.458,-.034,
     c 0.574,0.438,0.414,0.001,0.186,0.464,0.281,0.286,0.457,-.033,
     c 0.569,0.434,0.411,-.002,0.187,0.464,0.282,0.282,0.455,-.032,
     c 0.563,0.432,0.408,-.005,0.187,0.463,0.280,0.277,0.453,-.032,
     c 0.561,0.431,0.405,-.008,0.186,0.460,0.275,0.273,0.451,-.036,
     c 0.561,0.431,0.405,-.010,0.186,0.457,0.270,0.271,0.450,-.039,
     c 0.561,0.431,0.405,-.012,0.187,0.457,0.267,0.271,0.449,-.040,
     c 0.558,0.430,0.405,-.012,0.187,0.458,0.265,0.271,0.448,-.039,
     c 0.556,0.427,0.404,-.013,0.184,0.458,0.264,0.270,0.448,-.037,
     c 0.553,0.422,0.402,-.013,0.179,0.459,0.263,0.268,0.446,-.038,
     c 0.548,0.417,0.400,-.014,0.174,0.459,0.262,0.266,0.443,-.041,
     c 0.543,0.414,0.397,-.015,0.171,0.459,0.261,0.265,0.440,-.045,
     c 0.542,0.414,0.394,-.016,0.168,0.459,0.259,0.264,0.438,-.047,
     c 0.544,0.415,0.392,-.017,0.166,0.459,0.258,0.263,0.436,-.045,
     c 0.548,0.415,0.389,-.018,0.163,0.459,0.258,0.262,0.434,-.042,
     c 0.550,0.413,0.386,-.019,0.160,0.459,0.256,0.260,0.431,-.041,
     c 0.552,0.407,0.384,-.020,0.155,0.458,0.253,0.257,0.429,-.044,
     c 0.551,0.401,0.382,-.020,0.152,0.457,0.250,0.254,0.428,-.048,
     c 0.546,0.397,0.381,-.019,0.149,0.455,0.248,0.252,0.428,-.051,
     c 0.539,0.397,0.380,-.018,0.147,0.454,0.247,0.253,0.430,-.051,
     c 0.537,0.400,0.378,-.016,0.145,0.453,0.246,0.255,0.430,-.048,
     c 0.537,0.404,0.376,-.012,0.144,0.452,0.245,0.256,0.429,-.046,
     c 0.536,0.406,0.374,-.007,0.144,0.451,0.243,0.255,0.426,-.045,
     c 0.533,0.406,0.372,-.001,0.144,0.451,0.242,0.254,0.424,-.045,
     c 0.531,0.407,0.370,0.003,0.143,0.452,0.241,0.255,0.424,-.044,
     c 0.531,0.409,0.368,0.006,0.140,0.453,0.242,0.257,0.425,-.045,
     c 0.532,0.412,0.367,0.007,0.135,0.452,0.243,0.258,0.424,-.045,
     c 0.533,0.413,0.365,0.008,0.130,0.451,0.242,0.258,0.424,-.041,
     c 0.537,0.413,0.364,0.009,0.124,0.450,0.239,0.259,0.425,-.037,
     c 0.546,0.412,0.362,0.008,0.119,0.449,0.235,0.258,0.424,-.039,
     c 0.555,0.410,0.359,0.006,0.116,0.447,0.232,0.257,0.422,-.047,
     c 0.557,0.406,0.356,0.003,0.114,0.447,0.232,0.256,0.419,-.055,
     c 0.552,0.403,0.353,-.001,0.111,0.446,0.234,0.257,0.418,-.058,
     c 0.543,0.398,0.351,-.005,0.108,0.443,0.235,0.258,0.417,-.058,
     c 0.535,0.391,0.350,-.010,0.105,0.437,0.232,0.257,0.413,-.061,
     c 0.530,0.386,0.349,-.016,0.104,0.432,0.228,0.254,0.408,-.066,
     c 0.523,0.380,0.348,-.020,0.101,0.428,0.225,0.253,0.404,-.069,
     c 0.539,0.435,0.399,-.033,0.157,0.449,0.283,0.288,0.462,-.025,
     c 0.546,0.438,0.401,-.032,0.161,0.451,0.283,0.290,0.463,-.026,
     c 0.553,0.442,0.402,-.033,0.165,0.454,0.281,0.293,0.467,-.025,
     c 0.561,0.447,0.403,-.032,0.169,0.456,0.280,0.294,0.467,-.029,
     c 0.565,0.453,0.403,-.029,0.172,0.455,0.281,0.297,0.466,-.035,
     c 0.563,0.457,0.403,-.025,0.174,0.453,0.283,0.299,0.464,-.038,
     c 0.561,0.457,0.405,-.020,0.178,0.453,0.285,0.300,0.465,-.039,
     c 0.566,0.457,0.409,-.017,0.182,0.454,0.286,0.298,0.466,-.037,
     c 0.574,0.457,0.412,-.014,0.186,0.457,0.287,0.296,0.466,-.034,
     c 0.578,0.457,0.412,-.013,0.190,0.459,0.288,0.295,0.467,-.028,
     c 0.579,0.455,0.412,-.013,0.195,0.462,0.290,0.297,0.470,-.020,
     c 0.581,0.452,0.412,-.012,0.199,0.464,0.293,0.301,0.472,-.012,
     c 0.590,0.449,0.412,-.011,0.202,0.466,0.295,0.305,0.471,-.008,
     c 0.600,0.449,0.412,-.010,0.203,0.467,0.296,0.308,0.465,-.007,
     c 0.602,0.451,0.411,-.011,0.204,0.468,0.296,0.308,0.461,-.010,
     c 0.595,0.453,0.412,-.011,0.204,0.468,0.294,0.307,0.458,-.017,
     c 0.583,0.454,0.413,-.010,0.204,0.468,0.292,0.304,0.455,-.026,
     c 0.573,0.456,0.415,-.008,0.201,0.467,0.290,0.301,0.452,-.035,
     c 0.571,0.458,0.415,-.006,0.199,0.466,0.289,0.299,0.451,-.041,
     c 0.573,0.459,0.414,-.003,0.197,0.467,0.291,0.300,0.454,-.045,
     c 0.576,0.460,0.414,-.001,0.196,0.469,0.294,0.301,0.458,-.046,
     c 0.578,0.459,0.414,0.002,0.195,0.473,0.294,0.300,0.461,-.042,
     c 0.579,0.457,0.414,0.004,0.194,0.476,0.291,0.298,0.462,-.037,
     c 0.581,0.454,0.413,0.006,0.193,0.478,0.288,0.296,0.463,-.029,
     c 0.581,0.451,0.413,0.006,0.193,0.477,0.286,0.297,0.465,-.024,
     c 0.580,0.448,0.413,0.006,0.192,0.475,0.284,0.297,0.466,-.021,
     c 0.579,0.447,0.414,0.005,0.191,0.473,0.281,0.295,0.465,-.023,
     c 0.579,0.445,0.416,0.003,0.190,0.471,0.278,0.293,0.464,-.027,
     c 0.579,0.443,0.417,0.001,0.190,0.470,0.277,0.292,0.462,-.029,
     c 0.575,0.440,0.416,-.002,0.192,0.470,0.279,0.289,0.460,-.028,
     c 0.569,0.436,0.413,-.005,0.193,0.469,0.280,0.285,0.457,-.026,
     c 0.564,0.433,0.409,-.008,0.193,0.467,0.279,0.280,0.455,-.027,
     c 0.562,0.432,0.407,-.010,0.191,0.464,0.274,0.276,0.453,-.032,
     c 0.562,0.433,0.405,-.012,0.191,0.461,0.269,0.273,0.451,-.037,
     c 0.562,0.434,0.405,-.012,0.192,0.460,0.266,0.272,0.449,-.040,
     c 0.561,0.433,0.404,-.012,0.191,0.461,0.266,0.271,0.447,-.041,
     c 0.558,0.430,0.403,-.012,0.188,0.462,0.265,0.270,0.446,-.040,
     c 0.554,0.424,0.401,-.012,0.182,0.462,0.264,0.269,0.444,-.040,
     c 0.547,0.418,0.398,-.013,0.177,0.462,0.262,0.267,0.441,-.042,
     c 0.541,0.414,0.396,-.014,0.174,0.462,0.260,0.265,0.437,-.045,
     c 0.540,0.412,0.393,-.016,0.170,0.460,0.258,0.263,0.434,-.047,
     c 0.543,0.412,0.390,-.018,0.166,0.459,0.256,0.262,0.431,-.047,
     c 0.546,0.412,0.386,-.019,0.161,0.457,0.254,0.260,0.428,-.045,
     c 0.549,0.410,0.382,-.021,0.157,0.455,0.252,0.259,0.426,-.045,
     c 0.551,0.406,0.379,-.022,0.152,0.454,0.248,0.257,0.425,-.047,
     c 0.549,0.402,0.377,-.022,0.149,0.454,0.246,0.256,0.426,-.050,
     c 0.544,0.399,0.377,-.021,0.146,0.453,0.245,0.256,0.428,-.052,
     c 0.538,0.398,0.375,-.020,0.144,0.452,0.244,0.258,0.431,-.051,
     c 0.535,0.400,0.374,-.017,0.142,0.451,0.243,0.261,0.433,-.049,
     c 0.536,0.404,0.372,-.013,0.141,0.450,0.243,0.261,0.431,-.048,
     c 0.536,0.405,0.371,-.008,0.140,0.450,0.242,0.259,0.427,-.048,
     c 0.535,0.406,0.369,-.002,0.139,0.451,0.241,0.258,0.424,-.048,
     c 0.535,0.406,0.367,0.002,0.138,0.451,0.240,0.259,0.424,-.047,
     c 0.537,0.409,0.365,0.004,0.136,0.452,0.241,0.261,0.425,-.047,
     c 0.538,0.411,0.364,0.004,0.132,0.451,0.242,0.263,0.425,-.046,
     c 0.539,0.413,0.363,0.004,0.128,0.451,0.242,0.264,0.425,-.043,
     c 0.541,0.414,0.362,0.004,0.124,0.450,0.240,0.264,0.425,-.038,
     c 0.548,0.413,0.361,0.002,0.120,0.449,0.237,0.263,0.424,-.039,
     c 0.555,0.410,0.358,-.001,0.116,0.447,0.235,0.261,0.421,-.045,
     c 0.556,0.407,0.355,-.005,0.114,0.446,0.234,0.261,0.419,-.052,
     c 0.551,0.403,0.352,-.009,0.111,0.444,0.236,0.261,0.417,-.055,
     c 0.542,0.398,0.350,-.014,0.107,0.440,0.236,0.261,0.416,-.056,
     c 0.534,0.391,0.349,-.018,0.104,0.434,0.233,0.259,0.412,-.060,
     c 0.527,0.385,0.347,-.021,0.102,0.429,0.227,0.255,0.407,-.067,
     c 0.520,0.379,0.346,-.025,0.100,0.425,0.223,0.253,0.403,-.070,
     c 0.538,0.436,0.399,-.026,0.156,0.453,0.283,0.288,0.461,-.025,
     c 0.544,0.439,0.400,-.026,0.158,0.455,0.283,0.290,0.462,-.026,
     c 0.551,0.443,0.403,-.027,0.160,0.457,0.281,0.294,0.466,-.024,
     c 0.558,0.448,0.404,-.027,0.162,0.458,0.280,0.295,0.466,-.027,
     c 0.561,0.453,0.402,-.025,0.163,0.457,0.280,0.297,0.466,-.034,
     c 0.560,0.456,0.401,-.022,0.164,0.456,0.281,0.298,0.465,-.039,
     c 0.559,0.456,0.402,-.018,0.167,0.456,0.283,0.299,0.465,-.041,
     c 0.563,0.456,0.406,-.015,0.171,0.459,0.285,0.297,0.466,-.039,
     c 0.571,0.457,0.410,-.013,0.176,0.463,0.287,0.295,0.465,-.034,
     c 0.575,0.458,0.412,-.012,0.181,0.466,0.288,0.295,0.466,-.026,
     c 0.574,0.456,0.413,-.011,0.186,0.469,0.290,0.297,0.469,-.015,
     c 0.575,0.454,0.414,-.011,0.191,0.470,0.292,0.301,0.472,-.005,
     c 0.582,0.451,0.414,-.010,0.194,0.470,0.294,0.305,0.470,0.000,
     c 0.593,0.450,0.413,-.010,0.195,0.471,0.295,0.308,0.466,-.001,
     c 0.597,0.450,0.412,-.010,0.196,0.472,0.295,0.308,0.463,-.005,
     c 0.592,0.449,0.413,-.010,0.198,0.472,0.294,0.307,0.461,-.013,
     c 0.581,0.450,0.414,-.009,0.197,0.471,0.292,0.305,0.459,-.022,
     c 0.573,0.452,0.415,-.007,0.196,0.470,0.289,0.303,0.456,-.032,
     c 0.572,0.454,0.416,-.005,0.194,0.469,0.289,0.302,0.455,-.038,
     c 0.575,0.457,0.417,-.003,0.195,0.470,0.292,0.303,0.457,-.042,
     c 0.578,0.459,0.417,-.001,0.195,0.472,0.295,0.305,0.461,-.042,
     c 0.579,0.459,0.418,0.001,0.196,0.476,0.295,0.304,0.465,-.040,
     c 0.579,0.457,0.417,0.003,0.195,0.479,0.292,0.302,0.466,-.036,
     c 0.580,0.454,0.417,0.004,0.194,0.482,0.289,0.300,0.468,-.030,
     c 0.582,0.451,0.415,0.005,0.195,0.482,0.287,0.300,0.469,-.024,
     c 0.582,0.448,0.415,0.005,0.195,0.480,0.285,0.299,0.470,-.021,
     c 0.582,0.446,0.415,0.005,0.195,0.477,0.282,0.297,0.468,-.023,
     c 0.580,0.445,0.417,0.003,0.194,0.475,0.278,0.294,0.466,-.026,
     c 0.577,0.443,0.417,0.001,0.195,0.474,0.278,0.292,0.463,-.028,
     c 0.572,0.440,0.417,-.002,0.197,0.474,0.279,0.289,0.460,-.026,
     c 0.566,0.436,0.414,-.005,0.198,0.473,0.280,0.285,0.457,-.023,
     c 0.562,0.432,0.410,-.008,0.195,0.471,0.277,0.281,0.454,-.023,
     c 0.560,0.431,0.407,-.010,0.193,0.467,0.272,0.278,0.453,-.028,
     c 0.561,0.431,0.405,-.011,0.192,0.464,0.268,0.276,0.450,-.035,
     c 0.562,0.433,0.403,-.011,0.193,0.463,0.266,0.274,0.447,-.040,
     c 0.562,0.433,0.402,-.011,0.192,0.464,0.265,0.273,0.444,-.041,
     c 0.560,0.429,0.400,-.010,0.188,0.464,0.265,0.272,0.442,-.041,
     c 0.556,0.425,0.398,-.010,0.183,0.465,0.263,0.270,0.440,-.042,
     c 0.549,0.419,0.396,-.011,0.179,0.465,0.261,0.268,0.438,-.044,
     c 0.542,0.414,0.394,-.012,0.176,0.464,0.259,0.266,0.434,-.046,
     c 0.540,0.410,0.391,-.014,0.171,0.461,0.256,0.264,0.430,-.049,
     c 0.543,0.409,0.388,-.016,0.166,0.458,0.253,0.262,0.426,-.050,
     c 0.545,0.409,0.383,-.018,0.159,0.454,0.249,0.260,0.423,-.050,
     c 0.547,0.407,0.378,-.019,0.153,0.451,0.245,0.259,0.420,-.050,
     c 0.548,0.405,0.375,-.021,0.148,0.450,0.242,0.258,0.419,-.052,
     c 0.546,0.402,0.372,-.021,0.145,0.450,0.241,0.258,0.421,-.055,
     c 0.541,0.400,0.372,-.021,0.142,0.451,0.241,0.259,0.424,-.055,
     c 0.535,0.399,0.371,-.020,0.140,0.450,0.241,0.262,0.428,-.053,
     c 0.533,0.400,0.369,-.017,0.137,0.448,0.241,0.264,0.429,-.052,
     c 0.534,0.401,0.368,-.013,0.135,0.448,0.241,0.263,0.427,-.053,
     c 0.535,0.402,0.367,-.009,0.134,0.448,0.240,0.262,0.423,-.055,
     c 0.535,0.401,0.366,-.004,0.133,0.449,0.239,0.260,0.420,-.055,
     c 0.536,0.401,0.364,-.001,0.132,0.449,0.238,0.261,0.420,-.054,
     c 0.538,0.403,0.363,0.000,0.130,0.448,0.238,0.263,0.421,-.053,
     c 0.539,0.406,0.362,0.000,0.127,0.448,0.239,0.265,0.422,-.052,
     c 0.539,0.410,0.361,-.002,0.126,0.449,0.240,0.266,0.422,-.048,
     c 0.541,0.412,0.361,-.003,0.123,0.448,0.239,0.266,0.422,-.044,
     c 0.545,0.412,0.359,-.005,0.120,0.447,0.238,0.265,0.422,-.043,
     c 0.550,0.409,0.357,-.009,0.117,0.445,0.237,0.264,0.420,-.047,
     c 0.550,0.406,0.354,-.013,0.114,0.444,0.237,0.263,0.418,-.052,
     c 0.545,0.402,0.352,-.018,0.111,0.442,0.237,0.263,0.416,-.055,
     c 0.538,0.398,0.349,-.022,0.107,0.437,0.237,0.262,0.414,-.056,
     c 0.532,0.392,0.348,-.025,0.104,0.432,0.232,0.260,0.409,-.060,
     c 0.524,0.384,0.345,-.027,0.101,0.426,0.225,0.255,0.405,-.068,
     c 0.518,0.378,0.344,-.031,0.098,0.422,0.221,0.253,0.401,-.072,
     c 0.534,0.437,0.398,-.018,0.155,0.458,0.283,0.288,0.458,-.028,
     c 0.539,0.440,0.399,-.019,0.156,0.459,0.282,0.289,0.459,-.028,
     c 0.545,0.442,0.403,-.021,0.156,0.461,0.281,0.293,0.461,-.024,
     c 0.552,0.446,0.404,-.021,0.156,0.463,0.281,0.295,0.462,-.026,
     c 0.555,0.450,0.403,-.020,0.156,0.463,0.281,0.296,0.463,-.031,
     c 0.554,0.452,0.401,-.018,0.155,0.462,0.282,0.297,0.463,-.036,
     c 0.553,0.452,0.402,-.016,0.157,0.463,0.282,0.298,0.464,-.038,
     c 0.558,0.453,0.405,-.013,0.161,0.466,0.285,0.296,0.465,-.036,
     c 0.566,0.455,0.409,-.011,0.166,0.470,0.287,0.295,0.464,-.031,
     c 0.569,0.456,0.412,-.011,0.170,0.474,0.289,0.295,0.464,-.023,
     c 0.566,0.455,0.413,-.011,0.175,0.475,0.290,0.296,0.467,-.013,
     c 0.566,0.453,0.415,-.010,0.179,0.476,0.292,0.299,0.469,-.004,
     c 0.572,0.452,0.416,-.009,0.183,0.476,0.293,0.304,0.469,0.000,
     c 0.582,0.451,0.416,-.008,0.185,0.476,0.294,0.307,0.466,-.002,
     c 0.587,0.450,0.415,-.007,0.187,0.477,0.294,0.309,0.465,-.006,
     c 0.583,0.448,0.416,-.007,0.190,0.478,0.294,0.308,0.465,-.013,
     c 0.573,0.447,0.417,-.006,0.190,0.478,0.291,0.308,0.464,-.021,
     c 0.567,0.449,0.417,-.005,0.190,0.476,0.288,0.306,0.461,-.028,
     c 0.567,0.452,0.418,-.003,0.189,0.475,0.289,0.306,0.459,-.033,
     c 0.571,0.455,0.419,-.002,0.190,0.476,0.292,0.308,0.460,-.036,
     c 0.574,0.458,0.420,0.000,0.193,0.478,0.296,0.309,0.463,-.036,
     c 0.575,0.459,0.421,0.002,0.194,0.480,0.296,0.308,0.465,-.035,
     c 0.576,0.458,0.421,0.004,0.194,0.483,0.293,0.306,0.466,-.033,
     c 0.578,0.455,0.420,0.005,0.194,0.485,0.290,0.304,0.467,-.028,
     c 0.580,0.452,0.419,0.006,0.194,0.485,0.289,0.303,0.468,-.024,
     c 0.580,0.450,0.417,0.006,0.194,0.483,0.287,0.303,0.468,-.022,
     c 0.579,0.449,0.416,0.006,0.195,0.480,0.284,0.300,0.467,-.024,
     c 0.575,0.447,0.416,0.006,0.195,0.479,0.281,0.296,0.464,-.027,
     c 0.569,0.445,0.416,0.004,0.197,0.478,0.279,0.293,0.461,-.029,
     c 0.563,0.442,0.415,0.001,0.198,0.478,0.279,0.289,0.457,-.028,
     c 0.557,0.436,0.413,-.002,0.198,0.477,0.278,0.285,0.453,-.026,
     c 0.554,0.431,0.409,-.005,0.194,0.474,0.275,0.282,0.451,-.025,
     c 0.554,0.428,0.406,-.007,0.191,0.470,0.270,0.280,0.449,-.029,
     c 0.554,0.428,0.403,-.008,0.190,0.467,0.266,0.279,0.447,-.036,
     c 0.556,0.430,0.400,-.008,0.190,0.466,0.263,0.278,0.443,-.041,
     c 0.558,0.431,0.398,-.008,0.189,0.466,0.262,0.276,0.440,-.043,
     c 0.558,0.429,0.396,-.007,0.185,0.466,0.261,0.275,0.438,-.043,
     c 0.555,0.426,0.394,-.007,0.181,0.467,0.260,0.274,0.436,-.044,
     c 0.548,0.421,0.392,-.008,0.177,0.466,0.257,0.272,0.434,-.046,
     c 0.541,0.415,0.390,-.008,0.174,0.465,0.255,0.270,0.431,-.048,
     c 0.538,0.410,0.388,-.010,0.169,0.462,0.253,0.268,0.427,-.050,
     c 0.539,0.408,0.384,-.012,0.162,0.458,0.249,0.265,0.423,-.052,
     c 0.540,0.407,0.380,-.013,0.154,0.453,0.244,0.263,0.419,-.054,
     c 0.541,0.406,0.375,-.015,0.148,0.449,0.240,0.261,0.415,-.056,
     c 0.541,0.405,0.371,-.017,0.143,0.447,0.237,0.260,0.414,-.057,
     c 0.540,0.403,0.368,-.018,0.140,0.448,0.237,0.260,0.414,-.059,
     c 0.536,0.402,0.367,-.018,0.137,0.449,0.238,0.261,0.417,-.057,
     c 0.532,0.401,0.366,-.017,0.134,0.448,0.238,0.263,0.420,-.055,
     c 0.530,0.400,0.365,-.016,0.131,0.446,0.238,0.265,0.421,-.054,
     c 0.530,0.399,0.363,-.013,0.128,0.445,0.238,0.264,0.419,-.058,
     c 0.531,0.399,0.363,-.009,0.126,0.446,0.237,0.263,0.416,-.061,
     c 0.531,0.398,0.362,-.006,0.124,0.446,0.236,0.262,0.414,-.061,
     c 0.530,0.397,0.361,-.005,0.123,0.445,0.234,0.262,0.414,-.059,
     c 0.531,0.398,0.360,-.005,0.122,0.444,0.234,0.263,0.415,-.059,
     c 0.532,0.401,0.359,-.006,0.121,0.444,0.235,0.265,0.416,-.058,
     c 0.532,0.405,0.358,-.008,0.121,0.445,0.235,0.265,0.417,-.055,
     c 0.532,0.408,0.358,-.010,0.120,0.445,0.236,0.263,0.417,-.050,
     c 0.535,0.409,0.357,-.013,0.118,0.443,0.236,0.263,0.418,-.050,
     c 0.537,0.407,0.355,-.016,0.115,0.442,0.236,0.262,0.417,-.052,
     c 0.536,0.403,0.352,-.020,0.112,0.440,0.236,0.262,0.415,-.056,
     c 0.532,0.400,0.350,-.025,0.110,0.439,0.236,0.261,0.413,-.058,
     c 0.528,0.396,0.348,-.029,0.106,0.435,0.234,0.261,0.410,-.059,
     c 0.525,0.391,0.346,-.032,0.102,0.429,0.230,0.258,0.406,-.063,
     c 0.519,0.383,0.344,-.033,0.100,0.424,0.223,0.255,0.403,-.071,
     c 0.515,0.378,0.342,-.036,0.097,0.420,0.219,0.253,0.399,-.076,
     c 0.530,0.437,0.395,-.009,0.154,0.460,0.280,0.287,0.456,-.032,
     c 0.535,0.439,0.397,-.010,0.154,0.462,0.280,0.288,0.457,-.031,
     c 0.540,0.438,0.401,-.013,0.155,0.465,0.282,0.291,0.457,-.026,
     c 0.546,0.441,0.403,-.014,0.154,0.467,0.283,0.292,0.458,-.026,
     c 0.550,0.446,0.402,-.015,0.152,0.468,0.283,0.294,0.460,-.028,
     c 0.550,0.447,0.401,-.014,0.151,0.467,0.282,0.295,0.461,-.031,
     c 0.550,0.447,0.402,-.013,0.151,0.468,0.282,0.296,0.463,-.033,
     c 0.554,0.448,0.405,-.012,0.155,0.471,0.284,0.295,0.464,-.032,
     c 0.560,0.450,0.408,-.011,0.159,0.475,0.285,0.294,0.463,-.028,
     c 0.562,0.451,0.410,-.011,0.161,0.477,0.287,0.294,0.463,-.021,
     c 0.558,0.450,0.412,-.010,0.165,0.478,0.288,0.295,0.464,-.012,
     c 0.557,0.450,0.415,-.009,0.168,0.477,0.289,0.297,0.465,-.007,
     c 0.562,0.450,0.417,-.007,0.171,0.477,0.289,0.300,0.466,-.006,
     c 0.572,0.452,0.418,-.005,0.175,0.478,0.290,0.303,0.466,-.009,
     c 0.577,0.451,0.418,-.004,0.179,0.479,0.291,0.306,0.467,-.012,
     c 0.573,0.448,0.419,-.002,0.182,0.481,0.291,0.308,0.468,-.016,
     c 0.565,0.446,0.419,-.002,0.184,0.482,0.289,0.309,0.468,-.020,
     c 0.559,0.447,0.419,-.001,0.183,0.482,0.287,0.309,0.464,-.024,
     c 0.559,0.450,0.419,0.001,0.183,0.481,0.287,0.310,0.462,-.026,
     c 0.564,0.453,0.420,0.002,0.186,0.481,0.291,0.312,0.462,-.027,
     c 0.568,0.455,0.422,0.004,0.189,0.482,0.295,0.313,0.463,-.027,
     c 0.570,0.457,0.423,0.005,0.192,0.484,0.295,0.312,0.464,-.027,
     c 0.571,0.457,0.424,0.006,0.192,0.485,0.293,0.309,0.464,-.027,
     c 0.573,0.454,0.422,0.007,0.192,0.485,0.290,0.307,0.464,-.025,
     c 0.575,0.451,0.421,0.007,0.191,0.484,0.289,0.306,0.464,-.022,
     c 0.575,0.450,0.418,0.008,0.192,0.483,0.287,0.304,0.465,-.021,
     c 0.572,0.449,0.416,0.009,0.192,0.481,0.284,0.302,0.464,-.023,
     c 0.565,0.448,0.414,0.009,0.193,0.480,0.281,0.299,0.462,-.026,
     c 0.556,0.445,0.413,0.007,0.195,0.480,0.279,0.296,0.460,-.029,
     c 0.550,0.441,0.412,0.005,0.197,0.479,0.277,0.292,0.456,-.030,
     c 0.546,0.435,0.410,0.003,0.196,0.477,0.275,0.288,0.451,-.030,
     c 0.545,0.429,0.407,0.000,0.192,0.474,0.272,0.286,0.448,-.030,
     c 0.544,0.425,0.403,-.001,0.189,0.470,0.267,0.285,0.446,-.033,
     c 0.545,0.424,0.400,-.002,0.187,0.468,0.262,0.285,0.443,-.038,
     c 0.547,0.425,0.396,-.003,0.187,0.467,0.260,0.284,0.441,-.041,
     c 0.551,0.427,0.394,-.003,0.186,0.466,0.259,0.282,0.438,-.042,
     c 0.553,0.427,0.391,-.003,0.182,0.466,0.257,0.280,0.437,-.041,
     c 0.551,0.425,0.389,-.003,0.177,0.466,0.256,0.279,0.435,-.041,
     c 0.546,0.421,0.387,-.003,0.174,0.465,0.254,0.277,0.432,-.041,
     c 0.539,0.415,0.386,-.004,0.171,0.464,0.252,0.275,0.430,-.042,
     c 0.535,0.409,0.383,-.005,0.165,0.461,0.250,0.273,0.428,-.045,
     c 0.534,0.406,0.380,-.006,0.158,0.456,0.247,0.270,0.424,-.048,
     c 0.535,0.405,0.377,-.008,0.149,0.451,0.242,0.267,0.420,-.051,
     c 0.535,0.404,0.373,-.009,0.143,0.446,0.237,0.265,0.415,-.055,
     c 0.535,0.403,0.369,-.011,0.139,0.444,0.235,0.264,0.412,-.057,
     c 0.534,0.402,0.365,-.012,0.137,0.445,0.235,0.262,0.411,-.058,
     c 0.531,0.401,0.364,-.013,0.134,0.445,0.236,0.262,0.413,-.056,
     c 0.527,0.401,0.362,-.014,0.130,0.444,0.236,0.264,0.415,-.053,
     c 0.526,0.399,0.360,-.013,0.126,0.442,0.235,0.265,0.416,-.053,
     c 0.525,0.398,0.358,-.012,0.123,0.442,0.235,0.265,0.415,-.056,
     c 0.525,0.397,0.357,-.011,0.120,0.442,0.234,0.264,0.413,-.059,
     c 0.523,0.395,0.357,-.009,0.117,0.441,0.233,0.263,0.412,-.059,
     c 0.522,0.394,0.356,-.009,0.116,0.440,0.232,0.262,0.411,-.058,
     c 0.522,0.395,0.356,-.010,0.115,0.439,0.231,0.262,0.412,-.058,
     c 0.523,0.398,0.355,-.012,0.115,0.439,0.231,0.262,0.413,-.058,
     c 0.522,0.402,0.354,-.014,0.116,0.440,0.232,0.261,0.414,-.057,
     c 0.523,0.405,0.354,-.016,0.116,0.440,0.232,0.259,0.414,-.054,
     c 0.524,0.405,0.353,-.019,0.114,0.438,0.232,0.258,0.414,-.054,
     c 0.523,0.402,0.351,-.023,0.112,0.436,0.232,0.258,0.414,-.056,
     c 0.522,0.397,0.349,-.027,0.110,0.435,0.232,0.258,0.413,-.060,
     c 0.519,0.393,0.348,-.031,0.108,0.433,0.231,0.258,0.411,-.062,
     c 0.518,0.390,0.346,-.034,0.105,0.430,0.229,0.258,0.409,-.064,
     c 0.517,0.386,0.344,-.036,0.101,0.425,0.225,0.256,0.405,-.068,
     c 0.514,0.380,0.341,-.037,0.099,0.421,0.220,0.253,0.402,-.074,
     c 0.512,0.376,0.339,-.039,0.097,0.417,0.216,0.251,0.399,-.079,
     c 0.527,0.438,0.392,0.001,0.153,0.463,0.278,0.286,0.455,-.036,
     c 0.532,0.440,0.395,-.001,0.154,0.465,0.279,0.288,0.456,-.033,
     c 0.536,0.439,0.399,-.003,0.155,0.468,0.282,0.289,0.456,-.029,
     c 0.541,0.441,0.402,-.005,0.155,0.471,0.283,0.291,0.457,-.026,
     c 0.545,0.446,0.402,-.007,0.153,0.472,0.283,0.292,0.458,-.027,
     c 0.545,0.447,0.402,-.008,0.151,0.471,0.282,0.293,0.460,-.029,
     c 0.545,0.447,0.402,-.008,0.151,0.472,0.281,0.295,0.463,-.030,
     c 0.548,0.447,0.404,-.008,0.153,0.475,0.282,0.295,0.463,-.030,
     c 0.552,0.448,0.407,-.008,0.156,0.478,0.284,0.295,0.463,-.027,
     c 0.553,0.448,0.408,-.008,0.158,0.479,0.285,0.295,0.462,-.022,
     c 0.550,0.447,0.410,-.008,0.159,0.479,0.287,0.296,0.462,-.016,
     c 0.548,0.447,0.413,-.007,0.161,0.478,0.287,0.295,0.461,-.014,
     c 0.554,0.449,0.416,-.004,0.163,0.477,0.287,0.295,0.462,-.016,
     c 0.563,0.453,0.418,-.002,0.167,0.479,0.286,0.298,0.463,-.019,
     c 0.569,0.452,0.419,0.001,0.170,0.481,0.288,0.302,0.466,-.020,
     c 0.566,0.449,0.420,0.002,0.174,0.483,0.289,0.304,0.468,-.020,
     c 0.559,0.446,0.421,0.004,0.176,0.485,0.289,0.307,0.468,-.020,
     c 0.554,0.447,0.421,0.005,0.177,0.485,0.287,0.308,0.465,-.020,
     c 0.555,0.450,0.420,0.006,0.178,0.486,0.287,0.311,0.463,-.019,
     c 0.559,0.452,0.421,0.008,0.181,0.486,0.290,0.314,0.463,-.017,
     c 0.562,0.455,0.422,0.009,0.186,0.487,0.294,0.316,0.464,-.017,
     c 0.564,0.457,0.424,0.010,0.189,0.488,0.295,0.314,0.463,-.019,
     c 0.565,0.457,0.425,0.011,0.189,0.488,0.293,0.311,0.461,-.020,
     c 0.567,0.454,0.424,0.011,0.189,0.487,0.290,0.307,0.460,-.020,
     c 0.568,0.450,0.422,0.010,0.188,0.485,0.287,0.305,0.459,-.018,
     c 0.568,0.449,0.418,0.011,0.188,0.483,0.285,0.304,0.459,-.018,
     c 0.563,0.448,0.415,0.011,0.188,0.482,0.282,0.302,0.460,-.019,
     c 0.555,0.447,0.412,0.012,0.189,0.481,0.279,0.301,0.459,-.023,
     c 0.546,0.443,0.409,0.011,0.192,0.481,0.276,0.299,0.458,-.027,
     c 0.540,0.439,0.408,0.009,0.194,0.480,0.273,0.296,0.455,-.030,
     c 0.538,0.434,0.406,0.007,0.194,0.478,0.270,0.293,0.450,-.031,
     c 0.538,0.428,0.403,0.005,0.191,0.474,0.267,0.292,0.446,-.033,
     c 0.537,0.424,0.400,0.004,0.187,0.471,0.263,0.292,0.443,-.035,
     c 0.537,0.421,0.396,0.004,0.186,0.469,0.259,0.292,0.441,-.039,
     c 0.540,0.422,0.393,0.003,0.185,0.467,0.256,0.290,0.438,-.041,
     c 0.545,0.424,0.390,0.003,0.183,0.466,0.255,0.287,0.437,-.039,
     c 0.549,0.425,0.387,0.002,0.179,0.465,0.254,0.284,0.436,-.036,
     c 0.549,0.425,0.385,0.002,0.174,0.464,0.252,0.282,0.434,-.034,
     c 0.545,0.422,0.383,0.001,0.171,0.463,0.250,0.281,0.432,-.033,
     c 0.538,0.416,0.382,0.001,0.166,0.461,0.249,0.279,0.430,-.033,
     c 0.533,0.410,0.379,0.001,0.160,0.458,0.248,0.277,0.429,-.036,
     c 0.531,0.407,0.377,-.000,0.153,0.454,0.245,0.275,0.426,-.040,
     c 0.531,0.406,0.375,-.001,0.145,0.448,0.240,0.272,0.421,-.045,
     c 0.532,0.405,0.372,-.002,0.140,0.443,0.235,0.269,0.416,-.050,
     c 0.532,0.404,0.369,-.004,0.138,0.441,0.233,0.266,0.412,-.054,
     c 0.530,0.402,0.365,-.006,0.135,0.442,0.233,0.265,0.411,-.054,
     c 0.527,0.402,0.362,-.007,0.132,0.443,0.234,0.264,0.411,-.052,
     c 0.523,0.401,0.360,-.009,0.128,0.442,0.234,0.265,0.413,-.048,
     c 0.520,0.401,0.357,-.011,0.124,0.440,0.233,0.266,0.414,-.048,
     c 0.519,0.400,0.354,-.011,0.120,0.439,0.233,0.266,0.414,-.051,
     c 0.518,0.399,0.353,-.011,0.116,0.438,0.232,0.266,0.414,-.053,
     c 0.516,0.398,0.353,-.011,0.113,0.438,0.232,0.264,0.413,-.053,
     c 0.516,0.397,0.352,-.011,0.111,0.436,0.230,0.262,0.413,-.052,
     c 0.516,0.397,0.351,-.013,0.110,0.436,0.229,0.261,0.414,-.052,
     c 0.517,0.400,0.351,-.015,0.110,0.436,0.229,0.260,0.415,-.054,
     c 0.517,0.404,0.351,-.018,0.112,0.437,0.230,0.259,0.414,-.054,
     c 0.517,0.406,0.350,-.021,0.112,0.436,0.230,0.257,0.413,-.053,
     c 0.517,0.405,0.349,-.024,0.110,0.434,0.229,0.256,0.413,-.055,
     c 0.515,0.398,0.348,-.028,0.108,0.431,0.228,0.255,0.413,-.058,
     c 0.512,0.391,0.346,-.032,0.106,0.429,0.227,0.255,0.412,-.062,
     c 0.510,0.385,0.345,-.036,0.105,0.428,0.225,0.255,0.411,-.066,
     c 0.510,0.383,0.343,-.038,0.104,0.425,0.223,0.255,0.409,-.069,
     c 0.510,0.380,0.341,-.039,0.101,0.422,0.220,0.254,0.407,-.072,
     c 0.511,0.378,0.339,-.040,0.100,0.419,0.218,0.252,0.402,-.078,
     c 0.509,0.375,0.337,-.041,0.099,0.416,0.214,0.251,0.400,-.081,
     c 0.525,0.438,0.388,0.009,0.151,0.464,0.273,0.285,0.453,-.041,
     c 0.528,0.439,0.391,0.008,0.152,0.466,0.275,0.287,0.453,-.037,
     c 0.531,0.441,0.395,0.006,0.155,0.469,0.278,0.288,0.455,-.033,
     c 0.535,0.443,0.399,0.004,0.156,0.472,0.281,0.289,0.455,-.029,
     c 0.537,0.447,0.400,0.001,0.155,0.472,0.280,0.290,0.457,-.028,
     c 0.537,0.447,0.400,-.002,0.153,0.471,0.278,0.291,0.459,-.030,
     c 0.536,0.446,0.401,-.003,0.153,0.472,0.276,0.294,0.461,-.032,
     c 0.538,0.447,0.403,-.004,0.155,0.475,0.277,0.295,0.462,-.034,
     c 0.540,0.447,0.405,-.005,0.158,0.478,0.279,0.296,0.462,-.032,
     c 0.541,0.445,0.406,-.005,0.158,0.479,0.282,0.297,0.461,-.028,
     c 0.539,0.443,0.407,-.005,0.158,0.479,0.284,0.297,0.460,-.024,
     c 0.538,0.443,0.410,-.004,0.158,0.477,0.285,0.295,0.458,-.026,
     c 0.544,0.446,0.413,-.002,0.159,0.477,0.284,0.292,0.457,-.031,
     c 0.553,0.450,0.415,-.000,0.161,0.478,0.284,0.293,0.458,-.034,
     c 0.561,0.450,0.416,0.003,0.164,0.480,0.285,0.296,0.460,-.031,
     c 0.561,0.447,0.417,0.004,0.167,0.482,0.287,0.298,0.462,-.029,
     c 0.556,0.445,0.418,0.006,0.169,0.484,0.287,0.300,0.462,-.026,
     c 0.552,0.445,0.419,0.008,0.170,0.485,0.285,0.302,0.460,-.023,
     c 0.553,0.447,0.419,0.010,0.173,0.486,0.285,0.306,0.460,-.018,
     c 0.556,0.450,0.419,0.012,0.177,0.488,0.287,0.311,0.461,-.015,
     c 0.558,0.453,0.421,0.013,0.182,0.490,0.290,0.314,0.462,-.013,
     c 0.558,0.456,0.422,0.013,0.185,0.490,0.291,0.313,0.461,-.014,
     c 0.558,0.456,0.422,0.013,0.186,0.489,0.289,0.309,0.457,-.015,
     c 0.560,0.451,0.421,0.012,0.185,0.487,0.286,0.305,0.454,-.016,
     c 0.562,0.446,0.419,0.011,0.184,0.485,0.282,0.301,0.452,-.016,
     c 0.562,0.444,0.416,0.010,0.184,0.483,0.279,0.299,0.452,-.016,
     c 0.557,0.443,0.411,0.011,0.184,0.481,0.277,0.298,0.453,-.018,
     c 0.548,0.442,0.407,0.011,0.184,0.480,0.273,0.298,0.453,-.020,
     c 0.540,0.438,0.404,0.010,0.185,0.479,0.269,0.297,0.452,-.024,
     c 0.536,0.435,0.402,0.008,0.188,0.477,0.265,0.297,0.450,-.028,
     c 0.536,0.431,0.400,0.007,0.188,0.475,0.262,0.295,0.446,-.031,
     c 0.537,0.426,0.398,0.006,0.186,0.473,0.260,0.295,0.443,-.033,
     c 0.535,0.422,0.395,0.006,0.184,0.470,0.257,0.295,0.439,-.037,
     c 0.535,0.419,0.391,0.005,0.182,0.467,0.253,0.294,0.436,-.040,
     c 0.537,0.418,0.388,0.005,0.181,0.465,0.251,0.291,0.434,-.040,
     c 0.542,0.419,0.385,0.005,0.178,0.463,0.249,0.287,0.433,-.037,
     c 0.546,0.421,0.382,0.005,0.175,0.462,0.247,0.283,0.433,-.033,
     c 0.547,0.421,0.380,0.004,0.171,0.460,0.245,0.280,0.432,-.030,
     c 0.544,0.418,0.377,0.004,0.167,0.458,0.243,0.279,0.429,-.029,
     c 0.538,0.414,0.375,0.004,0.162,0.456,0.242,0.278,0.428,-.028,
     c 0.532,0.410,0.373,0.004,0.155,0.454,0.241,0.277,0.427,-.031,
     c 0.530,0.408,0.372,0.005,0.148,0.450,0.238,0.275,0.425,-.036,
     c 0.530,0.408,0.372,0.004,0.141,0.444,0.233,0.272,0.421,-.042,
     c 0.531,0.408,0.371,0.003,0.138,0.440,0.228,0.269,0.416,-.048,
     c 0.531,0.405,0.367,0.001,0.136,0.437,0.226,0.266,0.412,-.052,
     c 0.528,0.403,0.364,-.001,0.134,0.438,0.227,0.265,0.410,-.053,
     c 0.523,0.402,0.361,-.004,0.130,0.439,0.229,0.265,0.410,-.050,
     c 0.517,0.402,0.358,-.007,0.126,0.439,0.229,0.264,0.411,-.047,
     c 0.513,0.402,0.354,-.010,0.122,0.437,0.228,0.264,0.412,-.047,
     c 0.511,0.402,0.351,-.012,0.117,0.435,0.227,0.264,0.412,-.050,
     c 0.510,0.402,0.349,-.012,0.113,0.434,0.228,0.264,0.412,-.053,
     c 0.510,0.401,0.348,-.013,0.110,0.433,0.227,0.263,0.412,-.053,
     c 0.511,0.399,0.347,-.014,0.107,0.432,0.226,0.260,0.413,-.052,
     c 0.513,0.399,0.346,-.016,0.106,0.431,0.224,0.259,0.413,-.053,
     c 0.514,0.402,0.346,-.019,0.107,0.432,0.225,0.258,0.413,-.054,
     c 0.515,0.406,0.347,-.022,0.108,0.432,0.225,0.257,0.412,-.055,
     c 0.515,0.408,0.347,-.025,0.109,0.431,0.226,0.255,0.410,-.055,
     c 0.514,0.405,0.346,-.029,0.107,0.429,0.225,0.254,0.410,-.056,
     c 0.512,0.396,0.344,-.033,0.104,0.426,0.223,0.252,0.410,-.060,
     c 0.509,0.387,0.342,-.037,0.102,0.423,0.221,0.252,0.409,-.066,
     c 0.506,0.380,0.341,-.041,0.102,0.421,0.219,0.251,0.408,-.072,
     c 0.506,0.377,0.339,-.043,0.102,0.418,0.217,0.251,0.407,-.076,
     c 0.506,0.376,0.338,-.043,0.101,0.416,0.214,0.250,0.406,-.079,
     c 0.506,0.374,0.336,-.042,0.102,0.415,0.214,0.250,0.402,-.082,
     c 0.505,0.372,0.334,-.043,0.101,0.414,0.211,0.249,0.399,-.085,
     c 0.522,0.435,0.384,0.017,0.148,0.463,0.268,0.282,0.450,-.047,
     c 0.525,0.437,0.387,0.015,0.150,0.465,0.272,0.284,0.451,-.042,
     c 0.526,0.442,0.391,0.015,0.154,0.469,0.275,0.288,0.453,-.035,
     c 0.528,0.444,0.395,0.013,0.157,0.471,0.280,0.289,0.454,-.030,
     c 0.529,0.446,0.397,0.009,0.157,0.471,0.279,0.289,0.455,-.028,
     c 0.529,0.445,0.398,0.006,0.156,0.470,0.275,0.291,0.457,-.031,
     c 0.527,0.444,0.399,0.004,0.156,0.470,0.273,0.292,0.459,-.034,
     c 0.528,0.444,0.402,0.002,0.159,0.473,0.273,0.293,0.460,-.038,
     c 0.531,0.444,0.404,-.000,0.161,0.477,0.275,0.295,0.461,-.038,
     c 0.533,0.442,0.404,-.001,0.161,0.479,0.279,0.298,0.461,-.036,
     c 0.533,0.438,0.405,-.001,0.160,0.478,0.283,0.299,0.460,-.034,
     c 0.532,0.438,0.407,-.001,0.160,0.477,0.286,0.295,0.458,-.037,
     c 0.537,0.441,0.409,-.000,0.160,0.476,0.286,0.291,0.455,-.042,
     c 0.546,0.444,0.411,0.002,0.161,0.477,0.285,0.290,0.455,-.044,
     c 0.555,0.445,0.412,0.003,0.162,0.479,0.286,0.292,0.457,-.040,
     c 0.558,0.442,0.413,0.005,0.164,0.480,0.288,0.293,0.458,-.036,
     c 0.557,0.440,0.414,0.007,0.166,0.482,0.287,0.293,0.457,-.033,
     c 0.555,0.440,0.416,0.009,0.168,0.483,0.285,0.295,0.455,-.030,
     c 0.555,0.442,0.417,0.012,0.172,0.485,0.284,0.299,0.456,-.024,
     c 0.556,0.445,0.418,0.014,0.177,0.488,0.285,0.305,0.458,-.019,
     c 0.556,0.449,0.419,0.015,0.181,0.490,0.287,0.309,0.460,-.016,
     c 0.553,0.453,0.419,0.014,0.183,0.490,0.288,0.310,0.459,-.015,
     c 0.552,0.452,0.419,0.013,0.183,0.489,0.287,0.307,0.454,-.015,
     c 0.555,0.447,0.417,0.011,0.182,0.486,0.283,0.302,0.450,-.015,
     c 0.558,0.441,0.415,0.010,0.181,0.483,0.278,0.297,0.447,-.016,
     c 0.558,0.438,0.411,0.009,0.181,0.481,0.274,0.295,0.447,-.016,
     c 0.553,0.437,0.407,0.008,0.180,0.479,0.271,0.294,0.447,-.017,
     c 0.545,0.435,0.402,0.008,0.179,0.477,0.268,0.294,0.447,-.018,
     c 0.539,0.432,0.398,0.006,0.180,0.475,0.263,0.294,0.445,-.021,
     c 0.537,0.429,0.396,0.005,0.181,0.473,0.259,0.294,0.444,-.024,
     c 0.539,0.426,0.394,0.003,0.181,0.472,0.257,0.293,0.442,-.028,
     c 0.540,0.424,0.391,0.003,0.179,0.470,0.255,0.294,0.438,-.031,
     c 0.539,0.420,0.388,0.003,0.177,0.467,0.252,0.294,0.435,-.036,
     c 0.539,0.417,0.385,0.003,0.175,0.464,0.249,0.293,0.431,-.039,
     c 0.540,0.415,0.382,0.004,0.174,0.462,0.245,0.289,0.429,-.040,
     c 0.544,0.415,0.380,0.005,0.172,0.459,0.243,0.284,0.429,-.037,
     c 0.546,0.416,0.377,0.005,0.169,0.457,0.241,0.279,0.430,-.034,
     c 0.546,0.416,0.374,0.005,0.167,0.455,0.239,0.276,0.429,-.032,
     c 0.543,0.414,0.371,0.005,0.163,0.453,0.236,0.275,0.427,-.032,
     c 0.538,0.411,0.368,0.006,0.158,0.451,0.235,0.275,0.425,-.032,
     c 0.532,0.409,0.367,0.007,0.151,0.449,0.234,0.274,0.424,-.035,
     c 0.528,0.409,0.367,0.007,0.144,0.446,0.232,0.273,0.422,-.040,
     c 0.528,0.410,0.367,0.007,0.139,0.441,0.227,0.270,0.419,-.045,
     c 0.530,0.410,0.367,0.006,0.136,0.437,0.221,0.267,0.414,-.050,
     c 0.530,0.407,0.365,0.003,0.135,0.435,0.220,0.265,0.411,-.053,
     c 0.527,0.404,0.362,0.001,0.133,0.435,0.222,0.265,0.409,-.054,
     c 0.520,0.402,0.360,-.003,0.129,0.437,0.225,0.265,0.409,-.052,
     c 0.511,0.402,0.357,-.007,0.125,0.436,0.225,0.262,0.410,-.050,
     c 0.506,0.403,0.353,-.010,0.121,0.434,0.224,0.259,0.409,-.052,
     c 0.504,0.404,0.350,-.012,0.116,0.432,0.223,0.259,0.409,-.056,
     c 0.505,0.403,0.347,-.014,0.112,0.430,0.222,0.259,0.408,-.060,
     c 0.507,0.402,0.345,-.015,0.109,0.429,0.222,0.259,0.408,-.061,
     c 0.510,0.399,0.343,-.017,0.106,0.427,0.220,0.257,0.410,-.061,
     c 0.512,0.399,0.342,-.019,0.106,0.426,0.218,0.255,0.410,-.062,
     c 0.514,0.402,0.343,-.022,0.106,0.426,0.219,0.254,0.410,-.062,
     c 0.515,0.406,0.344,-.025,0.108,0.426,0.220,0.254,0.408,-.062,
     c 0.515,0.408,0.345,-.028,0.109,0.425,0.222,0.252,0.407,-.060,
     c 0.514,0.404,0.344,-.032,0.107,0.423,0.222,0.251,0.408,-.060,
     c 0.512,0.395,0.342,-.036,0.103,0.419,0.221,0.249,0.408,-.063,
     c 0.510,0.385,0.339,-.041,0.101,0.416,0.219,0.248,0.407,-.070,
     c 0.507,0.378,0.337,-.044,0.101,0.414,0.217,0.247,0.405,-.077,
     c 0.505,0.374,0.336,-.046,0.102,0.412,0.215,0.247,0.404,-.083,
     c 0.504,0.372,0.334,-.046,0.103,0.411,0.213,0.247,0.403,-.085,
     c 0.502,0.370,0.333,-.043,0.105,0.413,0.213,0.247,0.401,-.086,
     c 0.501,0.367,0.331,-.044,0.105,0.412,0.211,0.247,0.399,-.089,
     c 0.519,0.434,0.382,0.023,0.144,0.461,0.262,0.279,0.448,-.053,
     c 0.522,0.436,0.384,0.022,0.148,0.463,0.266,0.281,0.448,-.047,
     c 0.522,0.440,0.387,0.023,0.152,0.468,0.274,0.287,0.450,-.037,
     c 0.524,0.442,0.390,0.022,0.156,0.470,0.280,0.289,0.451,-.030,
     c 0.525,0.442,0.392,0.018,0.159,0.469,0.278,0.289,0.452,-.027,
     c 0.524,0.441,0.393,0.014,0.159,0.468,0.274,0.290,0.454,-.029,
     c 0.523,0.441,0.396,0.011,0.160,0.469,0.270,0.291,0.456,-.034,
     c 0.523,0.441,0.399,0.009,0.162,0.471,0.269,0.291,0.457,-.040,
     c 0.527,0.442,0.401,0.007,0.164,0.474,0.271,0.293,0.458,-.043,
     c 0.532,0.440,0.402,0.005,0.164,0.477,0.275,0.296,0.460,-.042,
     c 0.534,0.437,0.403,0.004,0.163,0.477,0.281,0.298,0.460,-.042,
     c 0.533,0.435,0.404,0.003,0.162,0.475,0.285,0.295,0.458,-.046,
     c 0.535,0.437,0.406,0.003,0.163,0.475,0.286,0.291,0.456,-.050,
     c 0.542,0.440,0.407,0.003,0.163,0.476,0.286,0.290,0.455,-.050,
     c 0.552,0.440,0.408,0.004,0.164,0.478,0.287,0.291,0.456,-.045,
     c 0.557,0.438,0.409,0.005,0.166,0.479,0.288,0.291,0.456,-.042,
     c 0.559,0.436,0.411,0.007,0.168,0.479,0.286,0.291,0.453,-.041,
     c 0.557,0.436,0.414,0.009,0.170,0.480,0.284,0.291,0.451,-.039,
     c 0.556,0.438,0.415,0.012,0.174,0.482,0.282,0.294,0.451,-.035,
     c 0.554,0.441,0.416,0.014,0.179,0.485,0.282,0.300,0.454,-.029,
     c 0.550,0.445,0.417,0.014,0.182,0.486,0.284,0.305,0.456,-.025,
     c 0.547,0.449,0.416,0.014,0.183,0.487,0.285,0.307,0.455,-.021,
     c 0.546,0.448,0.415,0.012,0.182,0.485,0.283,0.305,0.452,-.019,
     c 0.549,0.442,0.412,0.009,0.180,0.483,0.279,0.302,0.448,-.018,
     c 0.553,0.436,0.409,0.007,0.179,0.479,0.273,0.297,0.445,-.019,
     c 0.553,0.433,0.406,0.005,0.178,0.477,0.268,0.294,0.444,-.020,
     c 0.549,0.432,0.402,0.004,0.177,0.475,0.265,0.292,0.444,-.021,
     c 0.541,0.430,0.397,0.003,0.175,0.472,0.262,0.292,0.442,-.021,
     c 0.536,0.427,0.393,0.002,0.174,0.470,0.258,0.291,0.440,-.022,
     c 0.536,0.424,0.390,-.000,0.173,0.468,0.255,0.291,0.438,-.024,
     c 0.539,0.423,0.387,-.002,0.172,0.468,0.253,0.292,0.438,-.027,
     c 0.542,0.423,0.384,-.002,0.170,0.466,0.251,0.293,0.435,-.031,
     c 0.543,0.420,0.381,-.001,0.168,0.464,0.248,0.293,0.431,-.036,
     c 0.543,0.417,0.378,-.000,0.167,0.461,0.244,0.292,0.427,-.040,
     c 0.544,0.415,0.376,0.001,0.165,0.458,0.240,0.288,0.426,-.040,
     c 0.545,0.414,0.374,0.002,0.163,0.455,0.237,0.283,0.426,-.039,
     c 0.543,0.414,0.371,0.003,0.161,0.452,0.234,0.278,0.426,-.039,
     c 0.542,0.414,0.367,0.004,0.160,0.450,0.232,0.276,0.426,-.040,
     c 0.538,0.412,0.364,0.005,0.158,0.449,0.230,0.275,0.424,-.042,
     c 0.533,0.409,0.361,0.006,0.153,0.447,0.230,0.274,0.422,-.044,
     c 0.528,0.408,0.360,0.007,0.147,0.446,0.229,0.274,0.422,-.047,
     c 0.525,0.410,0.360,0.007,0.141,0.443,0.227,0.273,0.420,-.050,
     c 0.525,0.411,0.362,0.007,0.138,0.440,0.223,0.270,0.417,-.053,
     c 0.528,0.411,0.362,0.006,0.136,0.436,0.218,0.268,0.413,-.055,
     c 0.528,0.409,0.361,0.003,0.135,0.435,0.217,0.267,0.411,-.058,
     c 0.524,0.406,0.359,-.000,0.132,0.435,0.220,0.268,0.410,-.058,
     c 0.515,0.405,0.357,-.003,0.128,0.435,0.223,0.266,0.410,-.057,
     c 0.505,0.405,0.356,-.007,0.124,0.434,0.223,0.263,0.410,-.056,
     c 0.499,0.407,0.353,-.010,0.120,0.432,0.221,0.257,0.409,-.059,
     c 0.499,0.407,0.349,-.012,0.117,0.429,0.219,0.255,0.407,-.065,
     c 0.502,0.406,0.346,-.014,0.114,0.427,0.218,0.256,0.405,-.070,
     c 0.505,0.404,0.343,-.016,0.111,0.425,0.217,0.257,0.406,-.072,
     c 0.508,0.401,0.341,-.018,0.109,0.422,0.215,0.256,0.407,-.074,
     c 0.510,0.400,0.340,-.020,0.108,0.420,0.213,0.254,0.408,-.075,
     c 0.511,0.402,0.340,-.023,0.109,0.419,0.213,0.252,0.407,-.074,
     c 0.511,0.405,0.341,-.026,0.110,0.418,0.215,0.250,0.405,-.072,
     c 0.511,0.407,0.342,-.029,0.111,0.417,0.218,0.249,0.405,-.068,
     c 0.511,0.403,0.342,-.033,0.110,0.416,0.220,0.249,0.406,-.067,
     c 0.511,0.395,0.339,-.037,0.106,0.414,0.219,0.248,0.407,-.069,
     c 0.509,0.386,0.337,-.041,0.104,0.411,0.218,0.246,0.405,-.074,
     c 0.507,0.379,0.334,-.045,0.105,0.409,0.217,0.245,0.403,-.081,
     c 0.504,0.374,0.332,-.047,0.106,0.408,0.216,0.245,0.401,-.087,
     c 0.502,0.371,0.331,-.047,0.108,0.408,0.214,0.245,0.401,-.090,
     c 0.498,0.367,0.329,-.043,0.110,0.411,0.213,0.245,0.400,-.089,
     c 0.496,0.364,0.328,-.043,0.111,0.411,0.211,0.245,0.398,-.091,
     c 0.516,0.430,0.378,0.027,0.141,0.458,0.256,0.274,0.444,-.059,
     c 0.519,0.432,0.380,0.026,0.145,0.459,0.260,0.276,0.444,-.053,
     c 0.523,0.436,0.383,0.030,0.150,0.465,0.270,0.283,0.445,-.042,
     c 0.526,0.437,0.384,0.029,0.155,0.466,0.276,0.285,0.445,-.034,
     c 0.527,0.437,0.386,0.025,0.159,0.466,0.275,0.286,0.447,-.031,
     c 0.526,0.436,0.388,0.021,0.161,0.466,0.271,0.287,0.449,-.033,
     c 0.524,0.437,0.391,0.018,0.163,0.467,0.267,0.287,0.451,-.038,
     c 0.525,0.439,0.394,0.015,0.165,0.469,0.266,0.287,0.452,-.045,
     c 0.530,0.442,0.397,0.013,0.167,0.472,0.267,0.288,0.454,-.049,
     c 0.537,0.441,0.399,0.011,0.166,0.474,0.271,0.290,0.456,-.050,
     c 0.540,0.437,0.399,0.009,0.165,0.474,0.277,0.292,0.457,-.050,
     c 0.538,0.436,0.401,0.007,0.165,0.473,0.281,0.290,0.456,-.054,
     c 0.538,0.437,0.403,0.006,0.165,0.473,0.283,0.287,0.455,-.056,
     c 0.544,0.439,0.404,0.005,0.167,0.475,0.283,0.287,0.455,-.053,
     c 0.552,0.439,0.405,0.004,0.169,0.477,0.283,0.289,0.456,-.047,
     c 0.559,0.436,0.406,0.005,0.170,0.477,0.283,0.290,0.455,-.045,
     c 0.561,0.435,0.408,0.006,0.172,0.477,0.281,0.290,0.451,-.045,
     c 0.559,0.434,0.410,0.008,0.174,0.477,0.279,0.289,0.447,-.046,
     c 0.555,0.435,0.413,0.011,0.178,0.478,0.278,0.292,0.447,-.043,
     c 0.549,0.438,0.414,0.012,0.182,0.480,0.278,0.296,0.449,-.039,
     c 0.544,0.442,0.414,0.012,0.184,0.481,0.279,0.301,0.451,-.034,
     c 0.540,0.445,0.413,0.011,0.183,0.480,0.280,0.303,0.450,-.029,
     c 0.540,0.443,0.411,0.009,0.181,0.479,0.278,0.303,0.448,-.025,
     c 0.544,0.438,0.407,0.006,0.178,0.476,0.273,0.301,0.445,-.024,
     c 0.548,0.432,0.403,0.004,0.177,0.473,0.266,0.297,0.443,-.026,
     c 0.547,0.429,0.399,0.002,0.176,0.471,0.261,0.293,0.442,-.029,
     c 0.540,0.428,0.396,0.001,0.174,0.469,0.258,0.291,0.441,-.030,
     c 0.532,0.426,0.392,-.001,0.171,0.467,0.256,0.290,0.439,-.028,
     c 0.528,0.423,0.388,-.003,0.167,0.464,0.253,0.290,0.436,-.027,
     c 0.530,0.421,0.385,-.005,0.165,0.463,0.251,0.290,0.435,-.028,
     c 0.535,0.421,0.381,-.006,0.162,0.463,0.250,0.291,0.434,-.031,
     c 0.540,0.421,0.378,-.006,0.160,0.463,0.248,0.291,0.432,-.035,
     c 0.543,0.420,0.375,-.005,0.159,0.461,0.244,0.292,0.429,-.039,
     c 0.546,0.417,0.373,-.004,0.157,0.458,0.239,0.291,0.425,-.042,
     c 0.547,0.415,0.371,-.003,0.156,0.455,0.235,0.289,0.423,-.042,
     c 0.545,0.414,0.369,-.001,0.153,0.452,0.232,0.285,0.423,-.042,
     c 0.540,0.414,0.366,0.000,0.151,0.449,0.230,0.281,0.423,-.044,
     c 0.536,0.414,0.363,0.002,0.150,0.447,0.228,0.279,0.422,-.048,
     c 0.532,0.412,0.359,0.003,0.149,0.445,0.227,0.277,0.420,-.054,
     c 0.529,0.409,0.357,0.004,0.146,0.444,0.226,0.276,0.418,-.058,
     c 0.525,0.409,0.357,0.005,0.141,0.444,0.227,0.275,0.417,-.063,
     c 0.523,0.410,0.357,0.005,0.138,0.442,0.226,0.274,0.417,-.065,
     c 0.524,0.412,0.358,0.005,0.136,0.439,0.222,0.271,0.415,-.066,
     c 0.527,0.411,0.358,0.004,0.135,0.436,0.217,0.269,0.412,-.066,
     c 0.527,0.410,0.357,0.002,0.134,0.434,0.216,0.268,0.411,-.067,
     c 0.522,0.408,0.356,-.001,0.131,0.433,0.218,0.270,0.411,-.067,
     c 0.512,0.408,0.355,-.004,0.126,0.432,0.221,0.269,0.411,-.066,
     c 0.502,0.409,0.353,-.007,0.123,0.431,0.221,0.264,0.411,-.065,
     c 0.497,0.409,0.351,-.010,0.121,0.429,0.219,0.258,0.410,-.067,
     c 0.498,0.410,0.349,-.011,0.119,0.426,0.217,0.255,0.408,-.073,
     c 0.501,0.409,0.346,-.013,0.117,0.424,0.216,0.256,0.406,-.078,
     c 0.505,0.406,0.342,-.015,0.115,0.421,0.215,0.257,0.407,-.082,
     c 0.508,0.403,0.340,-.017,0.114,0.418,0.212,0.256,0.409,-.085,
     c 0.508,0.400,0.338,-.020,0.113,0.415,0.210,0.253,0.409,-.087,
     c 0.506,0.401,0.337,-.023,0.113,0.413,0.209,0.250,0.407,-.086,
     c 0.504,0.403,0.338,-.026,0.114,0.412,0.211,0.247,0.405,-.083,
     c 0.504,0.403,0.338,-.029,0.114,0.411,0.214,0.246,0.405,-.079,
     c 0.504,0.400,0.338,-.031,0.113,0.410,0.216,0.246,0.407,-.076,
     c 0.505,0.393,0.336,-.035,0.111,0.409,0.216,0.245,0.408,-.076,
     c 0.504,0.385,0.334,-.038,0.110,0.408,0.216,0.244,0.406,-.080,
     c 0.503,0.378,0.332,-.042,0.111,0.407,0.216,0.243,0.402,-.085,
     c 0.501,0.373,0.330,-.044,0.113,0.406,0.216,0.243,0.400,-.090,
     c 0.498,0.369,0.328,-.044,0.115,0.407,0.215,0.244,0.400,-.092,
     c 0.496,0.366,0.326,-.040,0.117,0.410,0.213,0.243,0.399,-.090,
     c 0.495,0.363,0.325,-.040,0.118,0.411,0.213,0.244,0.398,-.091,
     c 0.511,0.423,0.374,0.027,0.136,0.454,0.249,0.268,0.438,-.063,
     c 0.515,0.425,0.376,0.027,0.141,0.456,0.253,0.270,0.439,-.059,
     c 0.525,0.429,0.379,0.033,0.146,0.459,0.262,0.274,0.438,-.052,
     c 0.529,0.430,0.380,0.033,0.152,0.461,0.267,0.276,0.438,-.047,
     c 0.532,0.430,0.381,0.030,0.157,0.462,0.267,0.278,0.441,-.045,
     c 0.531,0.431,0.382,0.027,0.160,0.463,0.264,0.280,0.443,-.046,
     c 0.528,0.433,0.386,0.024,0.163,0.465,0.261,0.280,0.445,-.050,
     c 0.526,0.437,0.389,0.021,0.165,0.467,0.260,0.280,0.446,-.055,
     c 0.532,0.441,0.392,0.018,0.166,0.469,0.261,0.281,0.447,-.058,
     c 0.540,0.441,0.394,0.015,0.165,0.470,0.264,0.283,0.448,-.059,
     c 0.543,0.438,0.395,0.013,0.164,0.470,0.269,0.285,0.450,-.060,
     c 0.541,0.436,0.397,0.010,0.165,0.470,0.273,0.283,0.450,-.062,
     c 0.540,0.437,0.399,0.008,0.166,0.470,0.274,0.281,0.449,-.060,
     c 0.544,0.439,0.401,0.006,0.168,0.472,0.274,0.281,0.450,-.054,
     c 0.553,0.438,0.401,0.005,0.170,0.474,0.273,0.285,0.451,-.047,
     c 0.560,0.435,0.402,0.004,0.172,0.474,0.273,0.288,0.450,-.045,
     c 0.563,0.433,0.403,0.004,0.173,0.474,0.272,0.288,0.447,-.046,
     c 0.559,0.433,0.406,0.006,0.176,0.474,0.271,0.288,0.442,-.047,
     c 0.553,0.433,0.408,0.008,0.179,0.474,0.271,0.290,0.441,-.045,
     c 0.545,0.434,0.409,0.009,0.182,0.475,0.272,0.292,0.441,-.043,
     c 0.539,0.437,0.409,0.009,0.182,0.475,0.273,0.296,0.443,-.039,
     c 0.535,0.438,0.407,0.008,0.180,0.474,0.273,0.298,0.443,-.034,
     c 0.536,0.437,0.405,0.006,0.177,0.473,0.271,0.299,0.442,-.030,
     c 0.539,0.433,0.401,0.004,0.175,0.470,0.266,0.298,0.439,-.030,
     c 0.542,0.429,0.396,0.001,0.173,0.467,0.260,0.294,0.437,-.034,
     c 0.539,0.425,0.393,-.001,0.172,0.465,0.255,0.291,0.436,-.039,
     c 0.531,0.424,0.390,-.002,0.169,0.464,0.252,0.289,0.435,-.041,
     c 0.522,0.422,0.387,-.004,0.165,0.462,0.250,0.289,0.433,-.038,
     c 0.517,0.420,0.383,-.006,0.160,0.460,0.249,0.289,0.431,-.036,
     c 0.519,0.417,0.380,-.008,0.155,0.460,0.247,0.290,0.429,-.036,
     c 0.524,0.417,0.376,-.009,0.151,0.460,0.245,0.289,0.428,-.038,
     c 0.531,0.418,0.373,-.009,0.149,0.459,0.242,0.289,0.426,-.042,
     c 0.537,0.418,0.370,-.009,0.148,0.458,0.238,0.290,0.423,-.045,
     c 0.543,0.417,0.368,-.008,0.147,0.456,0.234,0.290,0.420,-.046,
     c 0.545,0.415,0.366,-.006,0.146,0.453,0.231,0.289,0.419,-.045,
     c 0.542,0.414,0.364,-.005,0.143,0.451,0.229,0.287,0.418,-.045,
     c 0.536,0.414,0.362,-.003,0.141,0.448,0.227,0.285,0.418,-.049,
     c 0.530,0.413,0.360,-.002,0.140,0.446,0.226,0.283,0.416,-.056,
     c 0.527,0.412,0.357,0.000,0.139,0.444,0.225,0.281,0.414,-.063,
     c 0.524,0.410,0.356,0.001,0.137,0.443,0.225,0.278,0.412,-.070,
     c 0.523,0.410,0.356,0.002,0.134,0.442,0.226,0.276,0.411,-.075,
     c 0.523,0.411,0.356,0.002,0.132,0.441,0.226,0.274,0.411,-.077,
     c 0.525,0.412,0.356,0.002,0.132,0.439,0.223,0.271,0.410,-.077,
     c 0.528,0.411,0.355,0.001,0.132,0.436,0.217,0.268,0.409,-.076,
     c 0.528,0.410,0.353,0.000,0.131,0.434,0.215,0.268,0.408,-.077,
     c 0.521,0.409,0.352,-.002,0.128,0.432,0.216,0.270,0.409,-.078,
     c 0.510,0.409,0.350,-.005,0.124,0.429,0.217,0.270,0.409,-.077,
     c 0.501,0.410,0.348,-.006,0.121,0.427,0.217,0.266,0.410,-.075,
     c 0.497,0.410,0.347,-.008,0.120,0.425,0.216,0.260,0.410,-.076,
     c 0.499,0.410,0.346,-.009,0.121,0.423,0.215,0.257,0.409,-.081,
     c 0.504,0.409,0.343,-.010,0.120,0.420,0.214,0.257,0.408,-.086,
     c 0.508,0.406,0.340,-.012,0.119,0.418,0.214,0.257,0.409,-.089,
     c 0.509,0.403,0.337,-.015,0.117,0.415,0.212,0.256,0.410,-.092,
     c 0.506,0.400,0.335,-.019,0.116,0.412,0.209,0.252,0.410,-.094,
     c 0.501,0.398,0.333,-.022,0.116,0.409,0.208,0.248,0.407,-.095,
     c 0.496,0.398,0.332,-.024,0.116,0.407,0.209,0.244,0.405,-.093,
     c 0.494,0.397,0.332,-.026,0.116,0.407,0.211,0.243,0.405,-.089,
     c 0.494,0.394,0.331,-.028,0.116,0.407,0.212,0.243,0.407,-.088,
     c 0.495,0.388,0.331,-.031,0.116,0.407,0.212,0.243,0.408,-.087,
     c 0.496,0.381,0.330,-.034,0.115,0.407,0.213,0.241,0.405,-.088,
     c 0.496,0.374,0.328,-.036,0.117,0.407,0.214,0.239,0.401,-.091,
     c 0.495,0.369,0.326,-.038,0.120,0.407,0.215,0.239,0.398,-.093,
     c 0.495,0.366,0.324,-.038,0.123,0.408,0.215,0.241,0.398,-.092,
     c 0.495,0.365,0.324,-.035,0.123,0.412,0.214,0.242,0.398,-.091,
     c 0.495,0.362,0.323,-.034,0.124,0.413,0.214,0.244,0.398,-.090,
     c 0.502,0.415,0.367,0.023,0.131,0.447,0.241,0.260,0.433,-.067,
     c 0.509,0.418,0.370,0.025,0.136,0.449,0.245,0.262,0.434,-.065,
     c 0.521,0.423,0.374,0.033,0.144,0.452,0.249,0.264,0.433,-.063,
     c 0.527,0.424,0.376,0.035,0.150,0.454,0.254,0.266,0.434,-.062,
     c 0.532,0.426,0.376,0.033,0.155,0.457,0.254,0.269,0.437,-.064,
     c 0.531,0.427,0.378,0.030,0.159,0.459,0.254,0.271,0.439,-.065,
     c 0.526,0.430,0.381,0.027,0.161,0.461,0.253,0.272,0.441,-.066,
     c 0.523,0.435,0.384,0.024,0.163,0.462,0.253,0.272,0.441,-.067,
     c 0.527,0.439,0.386,0.021,0.163,0.463,0.253,0.274,0.442,-.067,
     c 0.535,0.439,0.388,0.018,0.162,0.464,0.255,0.276,0.442,-.067,
     c 0.539,0.436,0.389,0.015,0.161,0.463,0.258,0.278,0.443,-.068,
     c 0.537,0.434,0.391,0.013,0.163,0.463,0.261,0.276,0.443,-.067,
     c 0.536,0.435,0.394,0.010,0.165,0.463,0.262,0.274,0.443,-.063,
     c 0.540,0.436,0.395,0.007,0.168,0.465,0.262,0.274,0.444,-.054,
     c 0.550,0.435,0.395,0.005,0.170,0.467,0.261,0.279,0.446,-.045,
     c 0.559,0.433,0.395,0.003,0.171,0.468,0.260,0.283,0.445,-.042,
     c 0.563,0.432,0.396,0.003,0.172,0.468,0.260,0.286,0.442,-.043,
     c 0.561,0.431,0.398,0.004,0.174,0.468,0.262,0.285,0.438,-.044,
     c 0.554,0.430,0.400,0.005,0.177,0.468,0.264,0.286,0.436,-.043,
     c 0.546,0.430,0.400,0.005,0.179,0.469,0.265,0.287,0.436,-.042,
     c 0.540,0.432,0.400,0.005,0.178,0.469,0.265,0.289,0.437,-.040,
     c 0.537,0.433,0.399,0.004,0.176,0.468,0.264,0.292,0.438,-.035,
     c 0.537,0.433,0.396,0.003,0.173,0.467,0.262,0.293,0.437,-.031,
     c 0.538,0.431,0.392,0.001,0.170,0.464,0.258,0.292,0.435,-.033,
     c 0.537,0.428,0.387,-.001,0.168,0.461,0.253,0.289,0.432,-.040,
     c 0.533,0.425,0.383,-.003,0.167,0.460,0.249,0.287,0.430,-.047,
     c 0.524,0.423,0.381,-.005,0.164,0.459,0.246,0.287,0.429,-.049,
     c 0.515,0.421,0.379,-.006,0.159,0.458,0.245,0.288,0.427,-.046,
     c 0.510,0.419,0.376,-.008,0.153,0.457,0.243,0.289,0.426,-.043,
     c 0.510,0.417,0.373,-.010,0.147,0.456,0.242,0.289,0.424,-.043,
     c 0.514,0.416,0.370,-.011,0.142,0.455,0.240,0.288,0.422,-.047,
     c 0.520,0.417,0.367,-.011,0.139,0.454,0.236,0.286,0.419,-.051,
     c 0.528,0.417,0.365,-.011,0.138,0.453,0.231,0.286,0.417,-.053,
     c 0.537,0.416,0.363,-.010,0.138,0.452,0.228,0.286,0.415,-.052,
     c 0.541,0.415,0.361,-.009,0.137,0.450,0.227,0.287,0.414,-.049,
     c 0.539,0.414,0.359,-.008,0.134,0.448,0.225,0.287,0.413,-.050,
     c 0.532,0.414,0.358,-.007,0.132,0.445,0.224,0.286,0.413,-.054,
     c 0.527,0.414,0.356,-.006,0.131,0.443,0.223,0.285,0.412,-.062,
     c 0.524,0.413,0.355,-.004,0.131,0.442,0.223,0.283,0.410,-.069,
     c 0.522,0.413,0.355,-.003,0.129,0.441,0.224,0.280,0.408,-.074,
     c 0.523,0.414,0.356,-.002,0.128,0.439,0.225,0.277,0.408,-.079,
     c 0.525,0.414,0.356,-.001,0.127,0.438,0.225,0.275,0.409,-.081,
     c 0.529,0.414,0.354,-.001,0.127,0.436,0.222,0.271,0.409,-.080,
     c 0.530,0.412,0.352,-.001,0.129,0.434,0.217,0.268,0.408,-.079,
     c 0.528,0.411,0.349,-.002,0.129,0.431,0.213,0.267,0.408,-.082,
     c 0.521,0.411,0.346,-.003,0.125,0.428,0.212,0.269,0.408,-.084,
     c 0.510,0.412,0.343,-.004,0.121,0.424,0.211,0.269,0.409,-.084,
     c 0.501,0.412,0.342,-.005,0.120,0.422,0.210,0.266,0.409,-.083,
     c 0.500,0.411,0.341,-.006,0.121,0.420,0.209,0.261,0.410,-.084,
     c 0.504,0.410,0.340,-.006,0.122,0.419,0.209,0.258,0.411,-.087,
     c 0.509,0.409,0.339,-.008,0.122,0.416,0.210,0.257,0.411,-.091,
     c 0.512,0.407,0.336,-.010,0.121,0.414,0.211,0.257,0.411,-.093,
     c 0.511,0.403,0.334,-.013,0.120,0.412,0.210,0.255,0.412,-.094,
     c 0.505,0.400,0.331,-.017,0.120,0.410,0.208,0.251,0.411,-.098,
     c 0.497,0.397,0.328,-.020,0.119,0.407,0.206,0.246,0.408,-.099,
     c 0.489,0.396,0.326,-.022,0.119,0.406,0.206,0.243,0.406,-.099,
     c 0.484,0.394,0.324,-.024,0.120,0.405,0.207,0.241,0.406,-.099,
     c 0.483,0.391,0.324,-.025,0.121,0.406,0.207,0.241,0.408,-.099,
     c 0.485,0.385,0.324,-.026,0.121,0.407,0.208,0.239,0.408,-.099,
     c 0.487,0.378,0.324,-.027,0.122,0.408,0.209,0.236,0.404,-.099,
     c 0.488,0.371,0.323,-.029,0.125,0.408,0.211,0.234,0.399,-.099,
     c 0.490,0.366,0.321,-.030,0.128,0.408,0.213,0.234,0.398,-.097,
     c 0.493,0.365,0.320,-.030,0.130,0.410,0.213,0.237,0.399,-.093,
     c 0.496,0.365,0.322,-.027,0.129,0.414,0.214,0.243,0.399,-.091,
     c 0.497,0.364,0.321,-.027,0.131,0.416,0.214,0.245,0.399,-.088,
     c 0.492,0.406,0.359,0.016,0.124,0.438,0.232,0.253,0.427,-.071,
     c 0.499,0.410,0.362,0.020,0.130,0.441,0.236,0.255,0.428,-.071,
     c 0.508,0.414,0.369,0.028,0.138,0.444,0.239,0.255,0.428,-.072,
     c 0.516,0.418,0.372,0.032,0.144,0.448,0.243,0.257,0.429,-.074,
     c 0.524,0.420,0.373,0.031,0.150,0.451,0.245,0.260,0.432,-.077,
     c 0.525,0.423,0.375,0.029,0.154,0.453,0.246,0.263,0.435,-.078,
     c 0.521,0.427,0.377,0.027,0.156,0.455,0.247,0.264,0.437,-.075,
     c 0.517,0.431,0.378,0.025,0.157,0.456,0.248,0.266,0.437,-.072,
     c 0.520,0.434,0.380,0.022,0.157,0.456,0.247,0.268,0.437,-.070,
     c 0.526,0.433,0.381,0.019,0.156,0.455,0.248,0.271,0.437,-.070,
     c 0.529,0.430,0.383,0.016,0.156,0.454,0.249,0.272,0.436,-.071,
     c 0.527,0.427,0.385,0.013,0.158,0.454,0.251,0.270,0.436,-.070,
     c 0.527,0.427,0.386,0.011,0.162,0.456,0.252,0.268,0.436,-.063,
     c 0.532,0.427,0.388,0.008,0.165,0.458,0.253,0.269,0.438,-.053,
     c 0.542,0.426,0.388,0.006,0.166,0.460,0.252,0.274,0.440,-.044,
     c 0.552,0.426,0.388,0.003,0.167,0.462,0.252,0.279,0.441,-.041,
     c 0.558,0.426,0.389,0.002,0.168,0.462,0.253,0.281,0.438,-.042,
     c 0.558,0.426,0.391,0.002,0.169,0.463,0.255,0.280,0.434,-.043,
     c 0.554,0.426,0.392,0.002,0.171,0.462,0.257,0.279,0.432,-.043,
     c 0.548,0.426,0.392,0.002,0.173,0.463,0.257,0.280,0.432,-.043,
     c 0.544,0.427,0.391,0.001,0.172,0.462,0.256,0.282,0.433,-.041,
     c 0.541,0.427,0.390,0.000,0.169,0.462,0.254,0.285,0.433,-.037,
     c 0.539,0.428,0.388,-.001,0.166,0.461,0.253,0.287,0.433,-.033,
     c 0.537,0.427,0.384,-.002,0.164,0.459,0.251,0.287,0.431,-.034,
     c 0.534,0.426,0.380,-.004,0.162,0.457,0.248,0.284,0.428,-.042,
     c 0.529,0.424,0.376,-.006,0.159,0.455,0.244,0.283,0.426,-.051,
     c 0.522,0.421,0.373,-.007,0.156,0.455,0.242,0.284,0.425,-.053,
     c 0.513,0.420,0.371,-.008,0.152,0.454,0.240,0.287,0.423,-.051,
     c 0.508,0.419,0.369,-.009,0.146,0.453,0.239,0.289,0.421,-.050,
     c 0.506,0.417,0.367,-.010,0.139,0.452,0.238,0.288,0.417,-.051,
     c 0.508,0.416,0.364,-.011,0.133,0.450,0.234,0.285,0.414,-.057,
     c 0.512,0.415,0.362,-.012,0.129,0.448,0.229,0.282,0.410,-.062,
     c 0.518,0.415,0.360,-.012,0.128,0.447,0.225,0.280,0.409,-.064,
     c 0.528,0.414,0.359,-.012,0.129,0.447,0.224,0.281,0.408,-.062,
     c 0.534,0.413,0.357,-.012,0.128,0.446,0.223,0.282,0.408,-.059,
     c 0.534,0.413,0.355,-.011,0.126,0.444,0.223,0.283,0.407,-.059,
     c 0.530,0.413,0.353,-.011,0.125,0.442,0.221,0.284,0.407,-.064,
     c 0.525,0.414,0.353,-.010,0.124,0.440,0.221,0.284,0.407,-.069,
     c 0.523,0.415,0.353,-.008,0.124,0.438,0.221,0.282,0.407,-.073,
     c 0.522,0.416,0.353,-.007,0.123,0.437,0.222,0.280,0.408,-.075,
     c 0.523,0.417,0.354,-.005,0.122,0.436,0.223,0.278,0.409,-.076,
     c 0.526,0.417,0.354,-.004,0.122,0.434,0.223,0.277,0.411,-.076,
     c 0.528,0.416,0.352,-.003,0.124,0.433,0.222,0.274,0.412,-.074,
     c 0.528,0.412,0.349,-.003,0.126,0.431,0.219,0.271,0.412,-.074,
     c 0.524,0.411,0.346,-.003,0.127,0.429,0.214,0.268,0.412,-.077,
     c 0.515,0.411,0.342,-.003,0.125,0.424,0.210,0.268,0.411,-.081,
     c 0.505,0.413,0.339,-.004,0.121,0.420,0.207,0.268,0.409,-.084,
     c 0.499,0.413,0.337,-.004,0.120,0.418,0.205,0.265,0.410,-.085,
     c 0.500,0.412,0.336,-.005,0.122,0.417,0.204,0.261,0.411,-.087,
     c 0.506,0.411,0.336,-.005,0.123,0.416,0.206,0.258,0.413,-.091,
     c 0.511,0.409,0.335,-.007,0.123,0.414,0.208,0.256,0.413,-.093,
     c 0.514,0.407,0.333,-.009,0.123,0.413,0.209,0.256,0.413,-.093,
     c 0.511,0.404,0.331,-.013,0.123,0.411,0.208,0.254,0.413,-.093,
     c 0.503,0.401,0.328,-.016,0.123,0.410,0.207,0.250,0.411,-.096,
     c 0.492,0.397,0.325,-.018,0.123,0.408,0.205,0.246,0.408,-.099,
     c 0.482,0.395,0.322,-.020,0.124,0.407,0.204,0.242,0.406,-.102,
     c 0.476,0.393,0.319,-.020,0.126,0.407,0.204,0.241,0.407,-.105,
     c 0.475,0.389,0.318,-.020,0.126,0.408,0.204,0.241,0.408,-.108,
     c 0.477,0.383,0.319,-.020,0.127,0.410,0.205,0.239,0.407,-.110,
     c 0.480,0.375,0.320,-.020,0.128,0.411,0.206,0.235,0.403,-.109,
     c 0.484,0.368,0.320,-.020,0.131,0.411,0.209,0.233,0.399,-.106,
     c 0.488,0.365,0.319,-.020,0.134,0.412,0.212,0.234,0.398,-.101,
     c 0.493,0.365,0.319,-.020,0.136,0.414,0.214,0.238,0.399,-.095,
     c 0.496,0.367,0.322,-.018,0.135,0.417,0.214,0.244,0.400,-.092,
     c 0.498,0.366,0.322,-.018,0.136,0.419,0.215,0.247,0.401,-.088,
     c 0.481,0.396,0.349,0.007,0.116,0.428,0.224,0.246,0.420,-.078,
     c 0.489,0.401,0.354,0.011,0.122,0.432,0.227,0.248,0.421,-.077,
     c 0.494,0.405,0.362,0.021,0.131,0.437,0.233,0.250,0.422,-.075,
     c 0.504,0.409,0.367,0.025,0.137,0.441,0.236,0.251,0.423,-.077,
     c 0.516,0.414,0.370,0.026,0.142,0.445,0.239,0.254,0.427,-.079,
     c 0.522,0.419,0.371,0.026,0.146,0.448,0.241,0.255,0.430,-.079,
     c 0.519,0.423,0.372,0.025,0.148,0.449,0.243,0.258,0.433,-.074,
     c 0.515,0.426,0.373,0.024,0.150,0.449,0.244,0.261,0.434,-.068,
     c 0.515,0.427,0.374,0.022,0.151,0.448,0.243,0.265,0.434,-.065,
     c 0.519,0.426,0.375,0.019,0.150,0.446,0.243,0.268,0.433,-.067,
     c 0.521,0.421,0.376,0.016,0.151,0.445,0.243,0.269,0.432,-.070,
     c 0.518,0.418,0.378,0.014,0.153,0.446,0.244,0.267,0.431,-.070,
     c 0.517,0.416,0.379,0.012,0.157,0.450,0.247,0.266,0.433,-.064,
     c 0.522,0.416,0.380,0.009,0.160,0.453,0.248,0.267,0.436,-.054,
     c 0.530,0.416,0.380,0.007,0.162,0.455,0.248,0.271,0.439,-.045,
     c 0.539,0.418,0.382,0.004,0.163,0.457,0.247,0.275,0.439,-.043,
     c 0.546,0.420,0.383,0.002,0.163,0.458,0.247,0.277,0.436,-.045,
     c 0.549,0.422,0.384,0.001,0.165,0.458,0.249,0.275,0.432,-.047,
     c 0.548,0.423,0.385,-.000,0.166,0.457,0.250,0.274,0.430,-.049,
     c 0.547,0.423,0.384,-.001,0.167,0.457,0.249,0.274,0.430,-.050,
     c 0.546,0.424,0.383,-.002,0.166,0.457,0.246,0.275,0.430,-.049,
     c 0.545,0.424,0.382,-.004,0.163,0.458,0.244,0.279,0.430,-.043,
     c 0.541,0.424,0.381,-.005,0.160,0.457,0.244,0.281,0.430,-.038,
     c 0.536,0.424,0.378,-.005,0.158,0.456,0.244,0.282,0.428,-.038,
     c 0.532,0.423,0.374,-.006,0.155,0.453,0.242,0.281,0.426,-.045,
     c 0.529,0.420,0.370,-.008,0.151,0.452,0.240,0.280,0.424,-.052,
     c 0.524,0.417,0.366,-.009,0.148,0.452,0.237,0.282,0.423,-.055,
     c 0.518,0.417,0.364,-.010,0.144,0.451,0.236,0.285,0.421,-.055,
     c 0.512,0.417,0.362,-.010,0.139,0.450,0.235,0.286,0.418,-.056,
     c 0.509,0.416,0.361,-.011,0.133,0.448,0.233,0.285,0.413,-.061,
     c 0.508,0.415,0.360,-.011,0.126,0.445,0.229,0.281,0.408,-.068,
     c 0.509,0.414,0.358,-.012,0.121,0.442,0.225,0.278,0.403,-.074,
     c 0.513,0.414,0.357,-.012,0.120,0.442,0.222,0.276,0.402,-.075,
     c 0.521,0.413,0.355,-.012,0.121,0.442,0.222,0.278,0.402,-.072,
     c 0.529,0.413,0.353,-.012,0.121,0.442,0.222,0.279,0.402,-.068,
     c 0.531,0.413,0.351,-.012,0.120,0.440,0.222,0.280,0.402,-.068,
     c 0.529,0.414,0.349,-.012,0.119,0.438,0.220,0.281,0.402,-.072,
     c 0.526,0.415,0.348,-.012,0.120,0.436,0.219,0.281,0.404,-.076,
     c 0.525,0.417,0.348,-.011,0.121,0.435,0.219,0.280,0.407,-.077,
     c 0.524,0.418,0.349,-.009,0.121,0.434,0.220,0.279,0.409,-.075,
     c 0.524,0.419,0.350,-.007,0.121,0.433,0.220,0.279,0.413,-.072,
     c 0.525,0.417,0.350,-.006,0.122,0.432,0.222,0.279,0.417,-.069,
     c 0.526,0.414,0.349,-.004,0.124,0.431,0.222,0.278,0.419,-.066,
     c 0.524,0.410,0.347,-.003,0.128,0.430,0.221,0.275,0.420,-.064,
     c 0.517,0.409,0.344,-.002,0.129,0.427,0.217,0.272,0.419,-.068,
     c 0.508,0.410,0.341,-.003,0.127,0.423,0.211,0.271,0.416,-.074,
     c 0.499,0.413,0.337,-.004,0.124,0.419,0.207,0.269,0.413,-.079,
     c 0.496,0.414,0.334,-.004,0.123,0.417,0.204,0.266,0.413,-.082,
     c 0.500,0.413,0.333,-.005,0.124,0.417,0.204,0.262,0.414,-.086,
     c 0.506,0.410,0.333,-.006,0.126,0.417,0.206,0.259,0.416,-.091,
     c 0.511,0.408,0.333,-.007,0.127,0.416,0.208,0.258,0.417,-.092,
     c 0.512,0.406,0.331,-.009,0.127,0.415,0.209,0.257,0.415,-.091,
     c 0.508,0.404,0.328,-.012,0.127,0.414,0.208,0.256,0.414,-.089,
     c 0.500,0.401,0.326,-.014,0.128,0.413,0.206,0.253,0.412,-.091,
     c 0.490,0.397,0.323,-.016,0.130,0.412,0.204,0.250,0.410,-.096,
     c 0.481,0.395,0.320,-.015,0.132,0.411,0.202,0.247,0.408,-.102,
     c 0.475,0.392,0.318,-.014,0.133,0.411,0.202,0.246,0.408,-.107,
     c 0.474,0.388,0.317,-.013,0.133,0.413,0.203,0.245,0.409,-.112,
     c 0.478,0.381,0.318,-.012,0.134,0.415,0.204,0.244,0.408,-.114,
     c 0.483,0.373,0.320,-.011,0.135,0.415,0.205,0.242,0.405,-.113,
     c 0.488,0.367,0.321,-.009,0.137,0.416,0.208,0.241,0.401,-.109,
     c 0.493,0.365,0.321,-.008,0.139,0.418,0.212,0.242,0.401,-.103,
     c 0.497,0.366,0.322,-.007,0.141,0.420,0.214,0.245,0.402,-.097,
     c 0.501,0.370,0.324,-.007,0.140,0.422,0.215,0.249,0.402,-.092,
     c 0.503,0.371,0.325,-.006,0.141,0.424,0.216,0.251,0.403,-.088,
     c 0.470,0.386,0.337,-.006,0.107,0.416,0.213,0.238,0.411,-.091,
     c 0.478,0.391,0.344,-.000,0.113,0.421,0.217,0.240,0.412,-.089,
     c 0.480,0.395,0.352,0.009,0.119,0.427,0.224,0.244,0.413,-.080,
     c 0.493,0.401,0.359,0.014,0.125,0.432,0.228,0.245,0.414,-.079,
     c 0.508,0.407,0.362,0.017,0.130,0.436,0.231,0.246,0.418,-.078,
     c 0.517,0.414,0.363,0.018,0.134,0.438,0.234,0.247,0.423,-.074,
     c 0.517,0.418,0.364,0.019,0.138,0.439,0.237,0.250,0.426,-.067,
     c 0.513,0.420,0.364,0.018,0.140,0.439,0.237,0.255,0.429,-.061,
     c 0.512,0.420,0.365,0.017,0.142,0.438,0.236,0.260,0.430,-.059,
     c 0.513,0.418,0.367,0.015,0.142,0.437,0.235,0.264,0.429,-.063,
     c 0.512,0.415,0.368,0.013,0.143,0.436,0.235,0.265,0.427,-.069,
     c 0.509,0.411,0.370,0.011,0.146,0.438,0.237,0.265,0.427,-.072,
     c 0.506,0.409,0.370,0.010,0.150,0.442,0.240,0.264,0.429,-.068,
     c 0.508,0.408,0.370,0.008,0.153,0.447,0.242,0.265,0.433,-.059,
     c 0.513,0.409,0.371,0.005,0.155,0.450,0.242,0.269,0.437,-.051,
     c 0.519,0.412,0.372,0.003,0.156,0.451,0.240,0.272,0.437,-.049,
     c 0.525,0.417,0.374,0.001,0.156,0.452,0.239,0.272,0.433,-.052,
     c 0.529,0.421,0.376,-.001,0.158,0.451,0.239,0.271,0.429,-.056,
     c 0.533,0.422,0.376,-.003,0.159,0.450,0.240,0.269,0.427,-.061,
     c 0.536,0.424,0.375,-.005,0.159,0.449,0.237,0.268,0.426,-.064,
     c 0.539,0.424,0.373,-.007,0.158,0.449,0.233,0.269,0.426,-.063,
     c 0.539,0.424,0.372,-.008,0.155,0.451,0.231,0.273,0.425,-.057,
     c 0.535,0.422,0.372,-.009,0.152,0.451,0.233,0.277,0.424,-.049,
     c 0.529,0.421,0.371,-.010,0.150,0.451,0.235,0.278,0.423,-.047,
     c 0.525,0.420,0.368,-.011,0.147,0.449,0.235,0.277,0.422,-.051,
     c 0.524,0.417,0.363,-.012,0.143,0.448,0.233,0.277,0.421,-.057,
     c 0.523,0.413,0.359,-.013,0.139,0.447,0.231,0.278,0.420,-.060,
     c 0.519,0.412,0.356,-.013,0.135,0.447,0.229,0.281,0.418,-.061,
     c 0.514,0.413,0.354,-.013,0.131,0.445,0.228,0.281,0.415,-.065,
     c 0.510,0.414,0.354,-.013,0.125,0.442,0.226,0.279,0.409,-.071,
     c 0.508,0.414,0.354,-.012,0.118,0.438,0.222,0.275,0.403,-.080,
     c 0.506,0.413,0.353,-.012,0.114,0.436,0.219,0.273,0.398,-.086,
     c 0.508,0.414,0.352,-.012,0.113,0.436,0.218,0.272,0.397,-.086,
     c 0.514,0.414,0.350,-.011,0.114,0.437,0.220,0.274,0.398,-.082,
     c 0.521,0.414,0.349,-.012,0.114,0.438,0.221,0.275,0.398,-.077,
     c 0.524,0.414,0.346,-.012,0.114,0.435,0.220,0.275,0.397,-.077,
     c 0.524,0.415,0.344,-.013,0.114,0.433,0.218,0.276,0.398,-.082,
     c 0.524,0.417,0.342,-.013,0.115,0.432,0.216,0.276,0.400,-.085,
     c 0.523,0.418,0.341,-.012,0.117,0.431,0.216,0.275,0.404,-.085,
     c 0.522,0.419,0.341,-.011,0.118,0.429,0.217,0.275,0.409,-.081,
     c 0.521,0.419,0.341,-.009,0.120,0.428,0.217,0.275,0.414,-.077,
     c 0.519,0.416,0.342,-.007,0.122,0.428,0.219,0.276,0.418,-.071,
     c 0.518,0.412,0.343,-.006,0.125,0.428,0.220,0.276,0.422,-.067,
     c 0.513,0.407,0.342,-.004,0.129,0.428,0.221,0.275,0.423,-.064,
     c 0.506,0.406,0.341,-.004,0.130,0.426,0.218,0.272,0.422,-.067,
     c 0.498,0.409,0.338,-.004,0.129,0.422,0.212,0.270,0.420,-.073,
     c 0.492,0.413,0.335,-.005,0.126,0.419,0.208,0.269,0.416,-.079,
     c 0.493,0.415,0.332,-.006,0.126,0.418,0.206,0.266,0.414,-.084,
     c 0.498,0.413,0.330,-.008,0.128,0.418,0.207,0.262,0.416,-.090,
     c 0.504,0.410,0.329,-.009,0.129,0.417,0.209,0.259,0.418,-.094,
     c 0.507,0.407,0.328,-.010,0.130,0.417,0.210,0.257,0.417,-.095,
     c 0.507,0.405,0.326,-.011,0.130,0.416,0.210,0.257,0.415,-.093,
     c 0.503,0.403,0.324,-.013,0.131,0.416,0.208,0.256,0.413,-.090,
     c 0.497,0.400,0.323,-.014,0.132,0.415,0.205,0.256,0.411,-.091,
     c 0.489,0.396,0.321,-.014,0.134,0.414,0.202,0.253,0.409,-.097,
     c 0.483,0.393,0.318,-.012,0.136,0.413,0.200,0.251,0.406,-.104,
     c 0.479,0.391,0.316,-.009,0.137,0.414,0.202,0.250,0.406,-.110,
     c 0.480,0.388,0.317,-.007,0.137,0.416,0.203,0.251,0.407,-.115,
     c 0.486,0.381,0.319,-.005,0.137,0.418,0.204,0.252,0.408,-.117,
     c 0.492,0.373,0.321,-.002,0.138,0.419,0.205,0.252,0.406,-.114,
     c 0.497,0.369,0.322,-.000,0.140,0.421,0.208,0.252,0.404,-.109,
     c 0.500,0.368,0.323,0.002,0.142,0.423,0.211,0.254,0.404,-.103,
     c 0.502,0.371,0.325,0.003,0.143,0.425,0.214,0.255,0.404,-.099,
     c 0.506,0.374,0.327,0.003,0.144,0.427,0.215,0.254,0.403,-.095,
     c 0.508,0.376,0.328,0.004,0.145,0.429,0.216,0.255,0.403,-.092,
     c 0.458,0.375,0.326,-.020,0.097,0.404,0.201,0.229,0.400,-.107,
     c 0.467,0.381,0.332,-.015,0.102,0.409,0.206,0.231,0.402,-.102,
     c 0.471,0.386,0.341,-.006,0.108,0.416,0.214,0.236,0.402,-.090,
     c 0.484,0.392,0.348,-.000,0.113,0.421,0.219,0.237,0.404,-.084,
     c 0.499,0.400,0.352,0.003,0.118,0.425,0.223,0.238,0.409,-.080,
     c 0.509,0.407,0.353,0.006,0.122,0.427,0.225,0.239,0.414,-.073,
     c 0.510,0.413,0.354,0.008,0.126,0.428,0.227,0.243,0.419,-.065,
     c 0.507,0.414,0.355,0.009,0.130,0.429,0.228,0.248,0.423,-.058,
     c 0.506,0.414,0.356,0.009,0.133,0.429,0.226,0.254,0.425,-.057,
     c 0.506,0.412,0.358,0.008,0.133,0.427,0.225,0.257,0.424,-.063,
     c 0.504,0.409,0.360,0.006,0.134,0.427,0.225,0.259,0.422,-.071,
     c 0.501,0.406,0.362,0.005,0.136,0.429,0.226,0.259,0.422,-.075,
     c 0.497,0.404,0.362,0.005,0.140,0.434,0.229,0.260,0.425,-.073,
     c 0.496,0.404,0.361,0.004,0.143,0.438,0.232,0.262,0.430,-.065,
     c 0.496,0.406,0.360,0.002,0.145,0.441,0.231,0.265,0.433,-.058,
     c 0.498,0.410,0.362,-.000,0.146,0.442,0.229,0.266,0.432,-.056,
     c 0.502,0.415,0.364,-.003,0.147,0.442,0.228,0.266,0.429,-.058,
     c 0.507,0.419,0.365,-.005,0.148,0.441,0.227,0.265,0.425,-.064,
     c 0.513,0.421,0.365,-.007,0.149,0.440,0.226,0.264,0.423,-.070,
     c 0.520,0.422,0.363,-.009,0.149,0.439,0.223,0.262,0.422,-.075,
     c 0.525,0.422,0.362,-.011,0.147,0.440,0.219,0.263,0.421,-.075,
     c 0.526,0.421,0.361,-.012,0.145,0.441,0.219,0.266,0.419,-.069,
     c 0.523,0.418,0.361,-.013,0.143,0.443,0.222,0.270,0.417,-.061,
     c 0.516,0.417,0.361,-.014,0.141,0.444,0.226,0.273,0.417,-.056,
     c 0.513,0.415,0.359,-.014,0.138,0.444,0.228,0.273,0.417,-.056,
     c 0.514,0.412,0.355,-.015,0.134,0.443,0.227,0.273,0.417,-.058,
     c 0.516,0.409,0.351,-.016,0.130,0.442,0.225,0.273,0.416,-.060,
     c 0.514,0.408,0.348,-.016,0.127,0.441,0.223,0.274,0.414,-.063,
     c 0.510,0.409,0.347,-.015,0.123,0.439,0.221,0.273,0.411,-.068,
     c 0.507,0.410,0.347,-.014,0.118,0.436,0.219,0.271,0.405,-.076,
     c 0.505,0.411,0.347,-.013,0.112,0.432,0.216,0.268,0.399,-.085,
     c 0.502,0.411,0.346,-.013,0.108,0.429,0.214,0.267,0.394,-.091,
     c 0.503,0.412,0.345,-.012,0.107,0.430,0.215,0.268,0.394,-.090,
     c 0.507,0.413,0.344,-.011,0.108,0.432,0.217,0.270,0.396,-.086,
     c 0.512,0.414,0.342,-.011,0.109,0.432,0.219,0.271,0.397,-.081,
     c 0.515,0.414,0.340,-.012,0.109,0.430,0.219,0.271,0.396,-.082,
     c 0.516,0.414,0.337,-.013,0.108,0.428,0.217,0.271,0.396,-.087,
     c 0.517,0.416,0.336,-.013,0.110,0.426,0.215,0.271,0.399,-.092,
     c 0.517,0.417,0.334,-.013,0.112,0.425,0.215,0.269,0.402,-.094,
     c 0.515,0.418,0.333,-.012,0.115,0.424,0.215,0.268,0.406,-.091,
     c 0.513,0.417,0.333,-.010,0.118,0.423,0.215,0.267,0.410,-.087,
     c 0.511,0.414,0.334,-.008,0.122,0.423,0.217,0.268,0.415,-.082,
     c 0.508,0.409,0.335,-.007,0.126,0.424,0.219,0.269,0.418,-.077,
     c 0.503,0.405,0.335,-.006,0.130,0.425,0.220,0.268,0.421,-.073,
     c 0.497,0.405,0.335,-.006,0.132,0.425,0.218,0.267,0.421,-.075,
     c 0.491,0.409,0.333,-.006,0.131,0.422,0.214,0.267,0.419,-.080,
     c 0.490,0.413,0.331,-.007,0.129,0.421,0.210,0.265,0.417,-.085,
     c 0.493,0.415,0.329,-.009,0.129,0.420,0.210,0.263,0.415,-.090,
     c 0.500,0.413,0.326,-.010,0.131,0.419,0.211,0.260,0.415,-.095,
     c 0.505,0.409,0.325,-.012,0.132,0.418,0.212,0.258,0.417,-.099,
     c 0.507,0.406,0.323,-.013,0.134,0.418,0.211,0.256,0.416,-.099,
     c 0.506,0.403,0.321,-.013,0.134,0.417,0.210,0.255,0.414,-.096,
     c 0.502,0.401,0.320,-.013,0.134,0.417,0.208,0.256,0.411,-.093,
     c 0.498,0.397,0.319,-.013,0.135,0.416,0.204,0.256,0.409,-.094,
     c 0.493,0.393,0.317,-.011,0.135,0.415,0.202,0.255,0.406,-.100,
     c 0.490,0.390,0.316,-.008,0.136,0.414,0.202,0.253,0.404,-.107,
     c 0.489,0.388,0.315,-.005,0.137,0.415,0.204,0.253,0.403,-.112,
     c 0.492,0.384,0.317,-.002,0.138,0.418,0.206,0.254,0.404,-.115,
     c 0.499,0.379,0.319,0.001,0.139,0.421,0.208,0.257,0.405,-.115,
     c 0.506,0.373,0.322,0.005,0.140,0.423,0.208,0.259,0.406,-.110,
     c 0.510,0.371,0.323,0.008,0.143,0.425,0.210,0.261,0.406,-.103,
     c 0.510,0.372,0.325,0.010,0.145,0.427,0.212,0.262,0.406,-.099,
     c 0.510,0.375,0.327,0.012,0.146,0.430,0.214,0.262,0.406,-.098,
     c 0.513,0.378,0.329,0.012,0.147,0.432,0.217,0.259,0.404,-.095,
     c 0.514,0.380,0.331,0.013,0.148,0.434,0.217,0.259,0.403,-.093,
     c 0.449,0.366,0.314,-.036,0.085,0.392,0.189,0.219,0.387,-.126,
     c 0.456,0.373,0.321,-.030,0.090,0.397,0.194,0.222,0.390,-.119,
     c 0.461,0.378,0.330,-.023,0.096,0.404,0.201,0.227,0.391,-.108,
     c 0.473,0.385,0.336,-.017,0.100,0.409,0.207,0.229,0.394,-.100,
     c 0.485,0.394,0.340,-.013,0.104,0.413,0.211,0.231,0.399,-.093,
     c 0.494,0.402,0.341,-.009,0.108,0.414,0.213,0.232,0.405,-.084,
     c 0.495,0.407,0.342,-.006,0.112,0.416,0.216,0.236,0.411,-.075,
     c 0.494,0.408,0.344,-.004,0.116,0.418,0.216,0.241,0.415,-.068,
     c 0.494,0.407,0.347,-.002,0.120,0.419,0.216,0.247,0.416,-.066,
     c 0.495,0.406,0.349,-.002,0.121,0.419,0.214,0.249,0.415,-.071,
     c 0.495,0.404,0.352,-.003,0.122,0.420,0.214,0.250,0.414,-.077,
     c 0.493,0.403,0.353,-.003,0.124,0.422,0.215,0.251,0.413,-.080,
     c 0.490,0.403,0.352,-.003,0.127,0.426,0.218,0.253,0.416,-.078,
     c 0.488,0.404,0.351,-.003,0.130,0.429,0.220,0.256,0.420,-.073,
     c 0.485,0.405,0.350,-.004,0.132,0.432,0.219,0.258,0.423,-.067,
     c 0.484,0.409,0.350,-.006,0.133,0.432,0.217,0.259,0.422,-.064,
     c 0.485,0.413,0.352,-.007,0.134,0.431,0.215,0.259,0.419,-.066,
     c 0.489,0.415,0.353,-.009,0.135,0.430,0.215,0.259,0.417,-.071,
     c 0.494,0.416,0.352,-.011,0.135,0.429,0.214,0.258,0.416,-.077,
     c 0.501,0.417,0.350,-.012,0.135,0.429,0.210,0.258,0.415,-.082,
     c 0.508,0.417,0.349,-.014,0.133,0.430,0.208,0.258,0.414,-.081,
     c 0.510,0.415,0.349,-.015,0.132,0.432,0.208,0.261,0.411,-.076,
     c 0.507,0.412,0.349,-.015,0.130,0.434,0.213,0.265,0.410,-.068,
     c 0.502,0.411,0.349,-.016,0.129,0.436,0.218,0.268,0.410,-.062,
     c 0.500,0.411,0.348,-.016,0.127,0.437,0.221,0.269,0.411,-.058,
     c 0.503,0.411,0.346,-.016,0.123,0.437,0.220,0.268,0.411,-.057,
     c 0.506,0.409,0.343,-.016,0.121,0.436,0.219,0.268,0.412,-.058,
     c 0.506,0.409,0.341,-.016,0.119,0.435,0.217,0.267,0.410,-.061,
     c 0.503,0.409,0.340,-.015,0.116,0.433,0.216,0.266,0.407,-.067,
     c 0.501,0.409,0.340,-.014,0.112,0.430,0.215,0.264,0.402,-.076,
     c 0.499,0.408,0.340,-.013,0.107,0.426,0.213,0.262,0.396,-.085,
     c 0.498,0.409,0.340,-.012,0.103,0.424,0.212,0.261,0.392,-.091,
     c 0.498,0.411,0.338,-.011,0.102,0.426,0.213,0.263,0.392,-.091,
     c 0.500,0.413,0.337,-.011,0.103,0.428,0.216,0.265,0.395,-.088,
     c 0.504,0.413,0.335,-.011,0.104,0.428,0.217,0.265,0.396,-.085,
     c 0.505,0.413,0.333,-.011,0.103,0.425,0.217,0.265,0.395,-.086,
     c 0.505,0.413,0.332,-.012,0.103,0.423,0.215,0.265,0.395,-.093,
     c 0.505,0.414,0.331,-.013,0.104,0.421,0.215,0.265,0.398,-.099,
     c 0.506,0.416,0.329,-.013,0.107,0.420,0.215,0.263,0.400,-.103,
     c 0.504,0.416,0.327,-.012,0.111,0.420,0.215,0.261,0.403,-.102,
     c 0.503,0.416,0.326,-.011,0.115,0.419,0.215,0.260,0.405,-.100,
     c 0.501,0.414,0.326,-.009,0.119,0.420,0.217,0.260,0.408,-.096,
     c 0.498,0.410,0.327,-.008,0.124,0.422,0.219,0.261,0.411,-.092,
     c 0.494,0.407,0.327,-.007,0.129,0.424,0.220,0.262,0.413,-.089,
     c 0.491,0.407,0.327,-.007,0.131,0.425,0.218,0.262,0.415,-.090,
     c 0.488,0.411,0.327,-.007,0.131,0.425,0.216,0.262,0.415,-.093,
     c 0.490,0.415,0.327,-.008,0.130,0.424,0.214,0.262,0.413,-.096,
     c 0.496,0.416,0.325,-.010,0.131,0.424,0.215,0.261,0.412,-.099,
     c 0.503,0.413,0.323,-.011,0.132,0.423,0.216,0.259,0.412,-.102,
     c 0.507,0.409,0.322,-.012,0.134,0.422,0.215,0.257,0.413,-.105,
     c 0.509,0.405,0.320,-.013,0.136,0.421,0.213,0.256,0.413,-.104,
     c 0.508,0.402,0.318,-.012,0.136,0.420,0.211,0.256,0.410,-.101,
     c 0.506,0.399,0.316,-.011,0.136,0.420,0.209,0.257,0.408,-.097,
     c 0.504,0.394,0.315,-.009,0.135,0.419,0.207,0.257,0.406,-.098,
     c 0.503,0.389,0.314,-.007,0.134,0.417,0.206,0.257,0.404,-.102,
     c 0.502,0.385,0.313,-.005,0.133,0.417,0.206,0.255,0.401,-.108,
     c 0.502,0.383,0.314,-.001,0.134,0.418,0.210,0.255,0.400,-.112,
     c 0.506,0.381,0.316,0.003,0.136,0.422,0.213,0.257,0.401,-.113,
     c 0.513,0.377,0.320,0.006,0.139,0.426,0.215,0.261,0.404,-.110,
     c 0.520,0.375,0.323,0.010,0.142,0.429,0.215,0.264,0.405,-.104,
     c 0.523,0.376,0.325,0.014,0.145,0.431,0.216,0.267,0.407,-.097,
     c 0.522,0.379,0.326,0.017,0.147,0.434,0.216,0.268,0.407,-.094,
     c 0.520,0.382,0.329,0.020,0.148,0.436,0.217,0.267,0.406,-.093,
     c 0.523,0.383,0.332,0.020,0.150,0.438,0.219,0.264,0.403,-.095,
     c 0.523,0.385,0.334,0.023,0.152,0.440,0.219,0.263,0.402,-.094,
     c 0.437,0.359,0.302,-.052,0.074,0.379,0.175,0.210,0.376,-.144,
     c 0.445,0.365,0.309,-.046,0.079,0.384,0.181,0.213,0.379,-.137,
     c 0.453,0.372,0.315,-.040,0.084,0.389,0.186,0.216,0.381,-.130,
     c 0.459,0.379,0.321,-.035,0.088,0.394,0.191,0.220,0.385,-.121,
     c 0.466,0.387,0.325,-.030,0.092,0.397,0.196,0.223,0.390,-.112,
     c 0.471,0.392,0.328,-.025,0.096,0.401,0.199,0.226,0.395,-.103,
     c 0.475,0.397,0.331,-.021,0.099,0.403,0.201,0.229,0.400,-.096,
     c 0.478,0.399,0.333,-.018,0.103,0.406,0.202,0.233,0.403,-.090,
     c 0.480,0.400,0.336,-.015,0.106,0.407,0.204,0.235,0.405,-.086,
     c 0.481,0.400,0.339,-.013,0.108,0.409,0.204,0.238,0.405,-.084,
     c 0.483,0.400,0.341,-.012,0.110,0.411,0.205,0.240,0.405,-.085,
     c 0.483,0.401,0.342,-.011,0.113,0.414,0.206,0.243,0.406,-.084,
     c 0.482,0.402,0.342,-.011,0.114,0.416,0.206,0.244,0.407,-.084,
     c 0.480,0.404,0.341,-.011,0.116,0.418,0.207,0.247,0.408,-.082,
     c 0.478,0.406,0.341,-.011,0.118,0.419,0.206,0.248,0.409,-.080,
     c 0.476,0.407,0.340,-.011,0.119,0.420,0.205,0.250,0.410,-.079,
     c 0.474,0.408,0.340,-.012,0.120,0.419,0.204,0.250,0.409,-.080,
     c 0.476,0.409,0.339,-.013,0.121,0.419,0.202,0.250,0.409,-.082,
     c 0.479,0.409,0.339,-.014,0.121,0.419,0.200,0.250,0.408,-.084,
     c 0.483,0.409,0.338,-.015,0.121,0.419,0.200,0.251,0.407,-.084,
     c 0.487,0.408,0.337,-.016,0.120,0.420,0.200,0.253,0.406,-.083,
     c 0.489,0.407,0.336,-.016,0.119,0.422,0.201,0.255,0.405,-.079,
     c 0.490,0.407,0.336,-.016,0.118,0.423,0.204,0.258,0.405,-.073,
     c 0.491,0.407,0.336,-.016,0.117,0.425,0.207,0.260,0.405,-.066,
     c 0.491,0.407,0.336,-.016,0.115,0.426,0.210,0.262,0.406,-.061,
     c 0.493,0.409,0.336,-.015,0.114,0.426,0.212,0.262,0.407,-.058,
     c 0.494,0.409,0.336,-.015,0.112,0.426,0.212,0.262,0.406,-.058,
     c 0.495,0.410,0.335,-.014,0.111,0.426,0.212,0.260,0.405,-.062,
     c 0.496,0.409,0.335,-.014,0.108,0.424,0.211,0.259,0.402,-.068,
     c 0.495,0.409,0.334,-.013,0.106,0.423,0.211,0.258,0.399,-.076,
     c 0.494,0.408,0.333,-.012,0.103,0.421,0.210,0.257,0.395,-.083,
     c 0.494,0.409,0.332,-.012,0.101,0.421,0.211,0.257,0.394,-.088,
     c 0.494,0.409,0.331,-.011,0.100,0.420,0.211,0.257,0.393,-.091,
     c 0.494,0.410,0.330,-.011,0.099,0.420,0.212,0.258,0.393,-.092,
     c 0.494,0.411,0.328,-.011,0.099,0.419,0.212,0.258,0.394,-.093,
     c 0.494,0.411,0.327,-.011,0.100,0.418,0.213,0.258,0.396,-.095,
     c 0.493,0.411,0.327,-.011,0.101,0.416,0.213,0.258,0.397,-.099,
     c 0.492,0.412,0.326,-.012,0.102,0.415,0.213,0.257,0.398,-.104,
     c 0.491,0.412,0.324,-.012,0.105,0.414,0.214,0.256,0.400,-.108,
     c 0.491,0.413,0.323,-.011,0.109,0.414,0.215,0.255,0.401,-.111,
     c 0.490,0.412,0.322,-.011,0.113,0.416,0.216,0.254,0.403,-.111,
     c 0.490,0.411,0.320,-.010,0.118,0.417,0.217,0.254,0.404,-.110,
     c 0.488,0.410,0.320,-.009,0.123,0.420,0.217,0.255,0.406,-.108,
     c 0.487,0.409,0.320,-.009,0.127,0.422,0.218,0.256,0.408,-.107,
     c 0.486,0.410,0.320,-.009,0.130,0.424,0.218,0.257,0.409,-.106,
     c 0.488,0.411,0.321,-.009,0.132,0.426,0.218,0.259,0.410,-.106,
     c 0.491,0.412,0.321,-.009,0.133,0.427,0.218,0.260,0.410,-.107,
     c 0.496,0.412,0.321,-.009,0.134,0.427,0.218,0.260,0.411,-.108,
     c 0.501,0.411,0.320,-.010,0.136,0.427,0.217,0.260,0.411,-.108,
     c 0.506,0.407,0.319,-.010,0.137,0.426,0.217,0.260,0.410,-.107,
     c 0.508,0.403,0.317,-.010,0.138,0.426,0.216,0.260,0.410,-.106,
     c 0.510,0.399,0.315,-.009,0.138,0.425,0.214,0.260,0.409,-.104,
     c 0.512,0.394,0.313,-.007,0.137,0.423,0.213,0.261,0.408,-.103,
     c 0.513,0.389,0.312,-.005,0.136,0.422,0.212,0.261,0.406,-.102,
     c 0.515,0.385,0.311,-.003,0.134,0.421,0.212,0.260,0.405,-.103,
     c 0.517,0.381,0.312,0.000,0.134,0.422,0.213,0.261,0.404,-.104,
     c 0.520,0.378,0.314,0.003,0.135,0.424,0.215,0.262,0.404,-.105,
     c 0.524,0.377,0.317,0.007,0.138,0.427,0.218,0.264,0.405,-.104,
     c 0.528,0.377,0.320,0.011,0.141,0.430,0.220,0.267,0.406,-.102,
     c 0.531,0.379,0.324,0.016,0.146,0.434,0.221,0.269,0.408,-.098,
     c 0.533,0.381,0.327,0.020,0.149,0.437,0.221,0.271,0.408,-.095,
     c 0.534,0.383,0.329,0.023,0.151,0.439,0.221,0.271,0.407,-.092,
     c 0.534,0.386,0.331,0.026,0.153,0.441,0.221,0.270,0.406,-.092,
     c 0.533,0.388,0.334,0.028,0.154,0.443,0.221,0.269,0.404,-.092,
     c 0.533,0.390,0.336,0.030,0.155,0.445,0.222,0.268,0.403,-.091,
     c 0.426,0.350,0.290,-.068,0.063,0.366,0.163,0.201,0.365,-.161,
     c 0.434,0.357,0.297,-.063,0.068,0.371,0.168,0.204,0.368,-.154,
     c 0.442,0.364,0.303,-.057,0.073,0.376,0.174,0.207,0.370,-.147,
     c 0.446,0.372,0.308,-.051,0.077,0.381,0.179,0.211,0.375,-.137,
     c 0.453,0.379,0.312,-.045,0.080,0.384,0.184,0.215,0.380,-.127,
     c 0.457,0.385,0.316,-.040,0.084,0.388,0.187,0.219,0.386,-.117,
     c 0.461,0.389,0.319,-.035,0.087,0.391,0.189,0.222,0.391,-.108,
     c 0.464,0.392,0.323,-.030,0.091,0.394,0.191,0.225,0.395,-.101,
     c 0.468,0.393,0.326,-.026,0.094,0.397,0.193,0.227,0.397,-.096,
     c 0.470,0.393,0.330,-.023,0.097,0.400,0.194,0.230,0.397,-.093,
     c 0.474,0.395,0.332,-.021,0.099,0.402,0.195,0.232,0.397,-.092,
     c 0.474,0.397,0.333,-.019,0.101,0.405,0.196,0.235,0.398,-.091,
     c 0.474,0.399,0.333,-.018,0.103,0.407,0.196,0.237,0.398,-.091,
     c 0.471,0.402,0.332,-.017,0.104,0.408,0.196,0.240,0.399,-.090,
     c 0.467,0.404,0.330,-.017,0.105,0.409,0.195,0.241,0.400,-.089,
     c 0.463,0.405,0.329,-.016,0.107,0.409,0.194,0.243,0.401,-.088,
     c 0.460,0.405,0.328,-.017,0.107,0.408,0.193,0.243,0.401,-.089,
     c 0.460,0.404,0.327,-.017,0.108,0.408,0.191,0.244,0.401,-.090,
     c 0.462,0.404,0.326,-.018,0.108,0.408,0.189,0.244,0.401,-.091,
     c 0.466,0.402,0.326,-.018,0.109,0.409,0.188,0.246,0.400,-.091,
     c 0.470,0.401,0.325,-.019,0.108,0.410,0.189,0.247,0.399,-.090,
     c 0.474,0.400,0.324,-.018,0.108,0.412,0.192,0.250,0.398,-.085,
     c 0.476,0.400,0.324,-.018,0.107,0.414,0.195,0.252,0.398,-.078,
     c 0.478,0.401,0.324,-.017,0.105,0.415,0.199,0.255,0.400,-.070,
     c 0.480,0.403,0.325,-.017,0.104,0.417,0.203,0.256,0.401,-.063,
     c 0.482,0.406,0.326,-.016,0.104,0.418,0.205,0.257,0.402,-.058,
     c 0.485,0.408,0.327,-.015,0.103,0.419,0.206,0.256,0.403,-.058,
     c 0.487,0.408,0.328,-.014,0.103,0.418,0.206,0.254,0.402,-.061,
     c 0.489,0.408,0.328,-.014,0.102,0.417,0.206,0.252,0.399,-.068,
     c 0.489,0.407,0.328,-.013,0.100,0.416,0.207,0.251,0.396,-.076,
     c 0.489,0.406,0.327,-.012,0.098,0.415,0.207,0.250,0.393,-.084,
     c 0.489,0.406,0.326,-.011,0.096,0.415,0.208,0.251,0.392,-.089,
     c 0.489,0.407,0.324,-.011,0.095,0.414,0.209,0.252,0.391,-.093,
     c 0.488,0.408,0.323,-.010,0.095,0.414,0.210,0.252,0.392,-.095,
     c 0.486,0.408,0.322,-.010,0.095,0.413,0.210,0.253,0.394,-.097,
     c 0.485,0.408,0.321,-.010,0.096,0.412,0.211,0.253,0.395,-.100,
     c 0.482,0.409,0.321,-.011,0.097,0.410,0.211,0.252,0.397,-.105,
     c 0.481,0.409,0.320,-.011,0.099,0.409,0.212,0.251,0.398,-.111,
     c 0.479,0.410,0.319,-.012,0.102,0.408,0.213,0.250,0.398,-.117,
     c 0.480,0.410,0.318,-.012,0.106,0.409,0.214,0.249,0.399,-.121,
     c 0.480,0.410,0.316,-.011,0.111,0.411,0.216,0.248,0.399,-.123,
     c 0.480,0.410,0.314,-.011,0.116,0.414,0.217,0.247,0.400,-.123,
     c 0.480,0.409,0.313,-.011,0.122,0.417,0.217,0.248,0.401,-.122,
     c 0.480,0.409,0.313,-.010,0.126,0.421,0.218,0.250,0.403,-.121,
     c 0.481,0.410,0.314,-.010,0.130,0.424,0.219,0.253,0.405,-.119,
     c 0.485,0.411,0.315,-.010,0.133,0.427,0.220,0.255,0.407,-.118,
     c 0.490,0.412,0.316,-.010,0.135,0.429,0.221,0.257,0.408,-.117,
     c 0.497,0.411,0.317,-.010,0.137,0.430,0.221,0.259,0.408,-.116,
     c 0.502,0.409,0.317,-.010,0.139,0.430,0.221,0.260,0.409,-.115,
     c 0.507,0.406,0.316,-.010,0.140,0.429,0.220,0.261,0.408,-.113,
     c 0.511,0.401,0.314,-.009,0.141,0.429,0.219,0.262,0.408,-.111,
     c 0.514,0.396,0.312,-.007,0.141,0.427,0.217,0.262,0.407,-.108,
     c 0.516,0.390,0.310,-.005,0.140,0.426,0.215,0.263,0.406,-.106,
     c 0.520,0.385,0.308,-.002,0.137,0.424,0.215,0.263,0.405,-.104,
     c 0.524,0.379,0.308,0.001,0.134,0.423,0.216,0.263,0.404,-.104,
     c 0.528,0.376,0.309,0.004,0.133,0.424,0.218,0.264,0.404,-.104,
     c 0.533,0.373,0.312,0.008,0.134,0.427,0.220,0.266,0.404,-.103,
     c 0.538,0.374,0.316,0.012,0.138,0.430,0.224,0.269,0.405,-.101,
     c 0.542,0.376,0.321,0.016,0.143,0.435,0.226,0.272,0.407,-.098,
     c 0.545,0.379,0.325,0.021,0.148,0.439,0.227,0.275,0.409,-.093,
     c 0.546,0.383,0.328,0.026,0.152,0.442,0.226,0.276,0.409,-.090,
     c 0.547,0.387,0.331,0.030,0.155,0.445,0.226,0.276,0.409,-.088,
     c 0.545,0.390,0.334,0.033,0.157,0.446,0.225,0.275,0.407,-.089,
     c 0.545,0.392,0.336,0.035,0.158,0.448,0.225,0.274,0.405,-.088,
     c 0.545,0.395,0.338,0.037,0.159,0.450,0.226,0.273,0.404,-.088/
      end
 
      block data yarray
      real htaby(10,65,65)
      common /htaby_/htaby
      data  htaby/
     c 0.178,0.150,-.125,0.079,0.269,0.247,0.108,0.196,0.023,0.132,
     c 0.160,0.139,-.133,0.069,0.257,0.241,0.101,0.188,0.018,0.131,
     c 0.142,0.130,-.141,0.059,0.244,0.235,0.094,0.180,0.012,0.130,
     c 0.121,0.121,-.149,0.050,0.231,0.229,0.087,0.173,0.006,0.128,
     c 0.103,0.112,-.156,0.042,0.219,0.222,0.080,0.164,0.001,0.126,
     c 0.085,0.104,-.163,0.034,0.210,0.215,0.073,0.157,-.004,0.123,
     c 0.077,0.099,-.168,0.027,0.203,0.211,0.068,0.151,-.008,0.123,
     c 0.072,0.094,-.174,0.020,0.197,0.207,0.062,0.146,-.011,0.124,
     c 0.071,0.089,-.180,0.013,0.193,0.205,0.057,0.143,-.014,0.124,
     c 0.069,0.084,-.185,0.006,0.190,0.206,0.054,0.141,-.017,0.124,
     c 0.066,0.081,-.188,0.000,0.190,0.206,0.052,0.140,-.019,0.123,
     c 0.060,0.077,-.190,-.006,0.193,0.206,0.050,0.140,-.020,0.121,
     c 0.054,0.072,-.191,-.012,0.198,0.205,0.048,0.141,-.021,0.120,
     c 0.052,0.070,-.190,-.018,0.206,0.204,0.046,0.145,-.021,0.119,
     c 0.054,0.070,-.188,-.021,0.215,0.204,0.046,0.148,-.021,0.121,
     c 0.058,0.069,-.186,-.025,0.222,0.203,0.045,0.150,-.021,0.121,
     c 0.061,0.069,-.185,-.027,0.227,0.205,0.044,0.150,-.023,0.121,
     c 0.064,0.069,-.184,-.027,0.231,0.207,0.044,0.148,-.023,0.122,
     c 0.064,0.071,-.184,-.026,0.234,0.209,0.045,0.145,-.024,0.123,
     c 0.062,0.071,-.184,-.023,0.237,0.211,0.046,0.144,-.023,0.126,
     c 0.059,0.071,-.185,-.018,0.240,0.213,0.048,0.144,-.021,0.130,
     c 0.054,0.070,-.186,-.013,0.241,0.214,0.050,0.145,-.018,0.133,
     c 0.054,0.072,-.185,-.007,0.243,0.216,0.054,0.148,-.013,0.136,
     c 0.053,0.072,-.183,-.002,0.243,0.219,0.056,0.151,-.010,0.137,
     c 0.054,0.076,-.183,0.002,0.242,0.221,0.058,0.154,-.007,0.135,
     c 0.054,0.080,-.181,0.005,0.241,0.224,0.061,0.157,-.003,0.132,
     c 0.054,0.085,-.180,0.008,0.238,0.226,0.063,0.162,0.002,0.129,
     c 0.053,0.091,-.178,0.009,0.235,0.229,0.065,0.168,0.007,0.125,
     c 0.052,0.096,-.177,0.010,0.232,0.232,0.068,0.173,0.011,0.124,
     c 0.050,0.102,-.176,0.011,0.228,0.235,0.072,0.177,0.015,0.125,
     c 0.050,0.110,-.175,0.012,0.227,0.239,0.076,0.182,0.020,0.127,
     c 0.051,0.116,-.175,0.013,0.227,0.241,0.080,0.184,0.024,0.127,
     c 0.055,0.122,-.175,0.013,0.229,0.243,0.082,0.186,0.026,0.125,
     c 0.059,0.128,-.175,0.013,0.232,0.245,0.083,0.188,0.028,0.121,
     c 0.062,0.132,-.175,0.013,0.236,0.246,0.083,0.188,0.028,0.116,
     c 0.063,0.136,-.175,0.013,0.242,0.247,0.082,0.189,0.028,0.110,
     c 0.063,0.139,-.175,0.013,0.248,0.249,0.081,0.188,0.026,0.106,
     c 0.061,0.141,-.175,0.012,0.254,0.249,0.079,0.185,0.025,0.102,
     c 0.056,0.143,-.175,0.011,0.261,0.250,0.079,0.184,0.025,0.099,
     c 0.050,0.144,-.177,0.009,0.266,0.249,0.077,0.182,0.024,0.096,
     c 0.042,0.146,-.177,0.007,0.272,0.247,0.075,0.179,0.022,0.094,
     c 0.038,0.146,-.178,0.005,0.278,0.246,0.073,0.178,0.022,0.091,
     c 0.036,0.145,-.178,0.004,0.283,0.245,0.073,0.178,0.022,0.090,
     c 0.037,0.144,-.178,0.003,0.288,0.244,0.073,0.178,0.024,0.090,
     c 0.037,0.142,-.178,0.003,0.292,0.243,0.074,0.179,0.026,0.092,
     c 0.036,0.139,-.177,0.005,0.294,0.241,0.075,0.179,0.026,0.094,
     c 0.033,0.137,-.176,0.009,0.295,0.239,0.075,0.180,0.028,0.098,
     c 0.029,0.134,-.175,0.013,0.293,0.237,0.075,0.179,0.027,0.100,
     c 0.024,0.130,-.175,0.018,0.289,0.235,0.075,0.177,0.027,0.103,
     c 0.020,0.127,-.175,0.022,0.283,0.236,0.075,0.176,0.027,0.102,
     c 0.019,0.121,-.178,0.026,0.275,0.235,0.073,0.175,0.028,0.102,
     c 0.020,0.116,-.181,0.030,0.267,0.236,0.072,0.176,0.030,0.098,
     c 0.018,0.109,-.185,0.032,0.257,0.237,0.068,0.176,0.031,0.091,
     c 0.015,0.103,-.190,0.033,0.246,0.236,0.065,0.174,0.030,0.080,
     c 0.010,0.097,-.195,0.034,0.235,0.234,0.061,0.173,0.029,0.069,
     c 0.003,0.092,-.200,0.034,0.222,0.232,0.056,0.172,0.026,0.056,
     c -.004,0.085,-.204,0.033,0.209,0.230,0.051,0.168,0.021,0.048,
     c -.009,0.079,-.208,0.032,0.197,0.228,0.046,0.166,0.018,0.043,
     c -.015,0.072,-.209,0.030,0.186,0.227,0.042,0.164,0.015,0.041,
     c -.018,0.064,-.209,0.028,0.178,0.226,0.039,0.164,0.012,0.043,
     c -.020,0.055,-.210,0.025,0.172,0.225,0.036,0.163,0.009,0.044,
     c -.021,0.045,-.212,0.023,0.167,0.224,0.034,0.161,0.005,0.045,
     c -.019,0.036,-.216,0.022,0.164,0.224,0.031,0.160,-.000,0.046,
     c -.018,0.027,-.220,0.021,0.163,0.222,0.028,0.157,-.005,0.047,
     c -.016,0.017,-.224,0.021,0.162,0.220,0.026,0.153,-.011,0.047,
     c 0.169,0.139,-.133,0.069,0.259,0.239,0.097,0.183,0.011,0.122,
     c 0.152,0.128,-.141,0.059,0.247,0.232,0.090,0.176,0.005,0.122,
     c 0.134,0.119,-.149,0.049,0.235,0.226,0.083,0.168,-.001,0.121,
     c 0.114,0.110,-.157,0.040,0.222,0.220,0.076,0.160,-.007,0.119,
     c 0.097,0.102,-.164,0.031,0.211,0.213,0.070,0.151,-.012,0.118,
     c 0.081,0.094,-.171,0.023,0.202,0.207,0.064,0.145,-.016,0.117,
     c 0.073,0.089,-.176,0.016,0.195,0.203,0.059,0.140,-.019,0.118,
     c 0.067,0.083,-.182,0.008,0.189,0.199,0.054,0.135,-.022,0.118,
     c 0.066,0.079,-.188,0.001,0.185,0.197,0.049,0.133,-.024,0.119,
     c 0.065,0.073,-.192,-.005,0.183,0.198,0.046,0.132,-.026,0.119,
     c 0.062,0.071,-.194,-.010,0.183,0.198,0.044,0.132,-.027,0.119,
     c 0.057,0.067,-.196,-.015,0.187,0.198,0.043,0.134,-.027,0.120,
     c 0.052,0.064,-.196,-.019,0.193,0.198,0.042,0.136,-.027,0.120,
     c 0.051,0.062,-.195,-.023,0.201,0.198,0.040,0.140,-.026,0.121,
     c 0.053,0.062,-.193,-.025,0.210,0.198,0.041,0.144,-.025,0.124,
     c 0.057,0.061,-.192,-.027,0.217,0.199,0.041,0.146,-.025,0.124,
     c 0.060,0.061,-.191,-.027,0.222,0.201,0.041,0.146,-.026,0.124,
     c 0.062,0.061,-.190,-.026,0.226,0.203,0.041,0.144,-.026,0.124,
     c 0.063,0.062,-.189,-.024,0.230,0.205,0.042,0.142,-.026,0.124,
     c 0.062,0.063,-.189,-.021,0.233,0.207,0.042,0.141,-.025,0.125,
     c 0.059,0.063,-.190,-.016,0.236,0.210,0.044,0.140,-.022,0.128,
     c 0.056,0.064,-.189,-.012,0.238,0.212,0.047,0.141,-.019,0.131,
     c 0.055,0.068,-.188,-.006,0.240,0.214,0.050,0.144,-.014,0.133,
     c 0.054,0.070,-.187,-.001,0.239,0.216,0.053,0.147,-.011,0.133,
     c 0.056,0.075,-.187,0.003,0.238,0.218,0.054,0.150,-.008,0.131,
     c 0.057,0.080,-.185,0.006,0.236,0.221,0.057,0.154,-.004,0.127,
     c 0.058,0.085,-.184,0.008,0.234,0.223,0.059,0.159,0.000,0.123,
     c 0.058,0.090,-.182,0.010,0.231,0.226,0.062,0.164,0.004,0.118,
     c 0.057,0.094,-.181,0.011,0.228,0.229,0.065,0.169,0.009,0.115,
     c 0.055,0.100,-.180,0.012,0.224,0.232,0.068,0.174,0.013,0.114,
     c 0.054,0.107,-.178,0.013,0.224,0.235,0.071,0.178,0.018,0.114,
     c 0.054,0.112,-.178,0.012,0.224,0.237,0.074,0.181,0.021,0.113,
     c 0.057,0.117,-.178,0.012,0.225,0.239,0.076,0.183,0.023,0.111,
     c 0.059,0.122,-.177,0.011,0.229,0.240,0.077,0.184,0.024,0.108,
     c 0.062,0.126,-.177,0.011,0.233,0.242,0.078,0.185,0.025,0.105,
     c 0.062,0.131,-.176,0.010,0.240,0.243,0.077,0.185,0.025,0.100,
     c 0.062,0.134,-.176,0.009,0.245,0.244,0.076,0.184,0.023,0.096,
     c 0.060,0.136,-.177,0.008,0.251,0.244,0.075,0.182,0.022,0.093,
     c 0.056,0.140,-.177,0.008,0.258,0.245,0.075,0.181,0.021,0.090,
     c 0.051,0.141,-.179,0.005,0.264,0.244,0.074,0.179,0.021,0.086,
     c 0.045,0.142,-.180,0.003,0.269,0.243,0.073,0.178,0.020,0.084,
     c 0.041,0.143,-.181,-.000,0.275,0.242,0.071,0.177,0.020,0.082,
     c 0.040,0.142,-.181,-.002,0.280,0.243,0.070,0.177,0.020,0.081,
     c 0.040,0.142,-.180,-.003,0.285,0.242,0.071,0.177,0.021,0.081,
     c 0.038,0.140,-.180,-.003,0.290,0.242,0.072,0.179,0.022,0.083,
     c 0.036,0.138,-.179,-.001,0.292,0.240,0.073,0.178,0.023,0.085,
     c 0.032,0.136,-.178,0.004,0.292,0.239,0.073,0.179,0.025,0.088,
     c 0.027,0.134,-.178,0.008,0.289,0.237,0.072,0.178,0.025,0.090,
     c 0.022,0.130,-.178,0.013,0.285,0.235,0.072,0.176,0.026,0.093,
     c 0.019,0.126,-.178,0.018,0.277,0.235,0.071,0.175,0.025,0.093,
     c 0.018,0.121,-.179,0.022,0.269,0.235,0.069,0.174,0.027,0.093,
     c 0.019,0.117,-.182,0.026,0.261,0.236,0.067,0.174,0.028,0.090,
     c 0.018,0.112,-.186,0.028,0.252,0.236,0.063,0.174,0.029,0.084,
     c 0.015,0.107,-.190,0.029,0.242,0.235,0.060,0.173,0.028,0.075,
     c 0.010,0.103,-.194,0.030,0.231,0.234,0.057,0.172,0.027,0.066,
     c 0.004,0.099,-.199,0.030,0.220,0.232,0.052,0.171,0.024,0.057,
     c -.003,0.092,-.203,0.029,0.207,0.230,0.047,0.168,0.020,0.050,
     c -.009,0.086,-.206,0.027,0.197,0.229,0.043,0.166,0.017,0.045,
     c -.016,0.079,-.207,0.025,0.188,0.228,0.039,0.165,0.015,0.044,
     c -.022,0.069,-.209,0.022,0.182,0.227,0.036,0.165,0.013,0.044,
     c -.026,0.060,-.210,0.019,0.176,0.226,0.034,0.164,0.011,0.044,
     c -.027,0.050,-.213,0.017,0.173,0.225,0.031,0.161,0.007,0.045,
     c -.026,0.042,-.216,0.016,0.171,0.225,0.029,0.160,0.002,0.046,
     c -.025,0.032,-.220,0.016,0.170,0.223,0.026,0.157,-.003,0.046,
     c -.023,0.022,-.224,0.015,0.169,0.222,0.024,0.153,-.009,0.047,
     c 0.161,0.128,-.141,0.060,0.249,0.230,0.086,0.171,-.002,0.113,
     c 0.144,0.118,-.149,0.050,0.237,0.223,0.079,0.163,-.008,0.112,
     c 0.127,0.107,-.157,0.038,0.224,0.219,0.071,0.156,-.016,0.108,
     c 0.107,0.099,-.164,0.029,0.211,0.213,0.064,0.149,-.022,0.108,
     c 0.085,0.092,-.171,0.020,0.201,0.206,0.061,0.139,-.025,0.111,
     c 0.068,0.087,-.178,0.011,0.192,0.198,0.057,0.130,-.029,0.111,
     c 0.058,0.078,-.184,0.003,0.186,0.194,0.053,0.125,-.031,0.111,
     c 0.057,0.070,-.191,-.005,0.179,0.189,0.045,0.124,-.034,0.111,
     c 0.060,0.065,-.198,-.011,0.174,0.186,0.039,0.122,-.035,0.113,
     c 0.064,0.062,-.202,-.016,0.172,0.186,0.036,0.121,-.037,0.115,
     c 0.061,0.058,-.203,-.020,0.175,0.189,0.035,0.122,-.036,0.116,
     c 0.052,0.055,-.202,-.023,0.180,0.192,0.036,0.127,-.035,0.116,
     c 0.046,0.052,-.202,-.026,0.188,0.192,0.037,0.131,-.034,0.117,
     c 0.044,0.051,-.201,-.028,0.197,0.192,0.036,0.136,-.034,0.122,
     c 0.050,0.051,-.199,-.029,0.208,0.192,0.037,0.141,-.029,0.131,
     c 0.056,0.050,-.198,-.029,0.215,0.193,0.036,0.145,-.028,0.134,
     c 0.060,0.050,-.197,-.029,0.219,0.196,0.037,0.146,-.028,0.131,
     c 0.061,0.050,-.196,-.028,0.221,0.197,0.037,0.143,-.030,0.127,
     c 0.061,0.052,-.195,-.025,0.224,0.200,0.038,0.138,-.030,0.126,
     c 0.061,0.054,-.194,-.021,0.230,0.204,0.037,0.134,-.029,0.127,
     c 0.062,0.053,-.194,-.015,0.235,0.207,0.037,0.132,-.024,0.130,
     c 0.059,0.055,-.195,-.010,0.238,0.209,0.039,0.134,-.020,0.132,
     c 0.055,0.059,-.193,-.005,0.239,0.211,0.043,0.139,-.013,0.135,
     c 0.051,0.067,-.192,-.000,0.237,0.213,0.046,0.141,-.012,0.132,
     c 0.055,0.075,-.191,0.004,0.235,0.214,0.048,0.143,-.010,0.128,
     c 0.062,0.081,-.190,0.007,0.232,0.216,0.051,0.147,-.008,0.123,
     c 0.069,0.083,-.189,0.009,0.229,0.219,0.054,0.153,-.004,0.118,
     c 0.070,0.086,-.187,0.011,0.225,0.223,0.058,0.162,0.002,0.110,
     c 0.064,0.090,-.184,0.012,0.221,0.226,0.061,0.168,0.008,0.105,
     c 0.058,0.096,-.183,0.012,0.217,0.229,0.064,0.173,0.012,0.101,
     c 0.055,0.103,-.182,0.013,0.217,0.231,0.066,0.176,0.016,0.101,
     c 0.058,0.107,-.182,0.012,0.217,0.233,0.068,0.177,0.018,0.100,
     c 0.060,0.112,-.181,0.010,0.219,0.235,0.070,0.179,0.020,0.098,
     c 0.061,0.115,-.180,0.009,0.223,0.235,0.072,0.182,0.022,0.094,
     c 0.061,0.119,-.178,0.008,0.229,0.236,0.073,0.185,0.023,0.092,
     c 0.061,0.124,-.176,0.006,0.235,0.238,0.072,0.185,0.021,0.090,
     c 0.062,0.131,-.176,0.005,0.241,0.241,0.073,0.183,0.019,0.088,
     c 0.062,0.134,-.178,0.004,0.248,0.240,0.073,0.180,0.016,0.083,
     c 0.060,0.138,-.179,0.004,0.255,0.240,0.073,0.179,0.017,0.078,
     c 0.052,0.139,-.181,0.001,0.259,0.238,0.071,0.178,0.017,0.075,
     c 0.044,0.141,-.182,-.002,0.264,0.238,0.070,0.176,0.017,0.072,
     c 0.041,0.143,-.185,-.006,0.270,0.238,0.068,0.175,0.016,0.071,
     c 0.043,0.142,-.185,-.009,0.276,0.240,0.067,0.174,0.015,0.069,
     c 0.044,0.141,-.183,-.011,0.284,0.240,0.066,0.175,0.016,0.070,
     c 0.043,0.139,-.181,-.011,0.289,0.240,0.067,0.178,0.018,0.071,
     c 0.040,0.136,-.182,-.008,0.294,0.240,0.070,0.180,0.020,0.074,
     c 0.033,0.135,-.181,-.003,0.295,0.239,0.071,0.181,0.022,0.077,
     c 0.022,0.134,-.182,0.002,0.290,0.236,0.071,0.179,0.022,0.080,
     c 0.013,0.131,-.181,0.008,0.282,0.233,0.068,0.176,0.023,0.083,
     c 0.010,0.126,-.180,0.015,0.273,0.233,0.066,0.172,0.022,0.087,
     c 0.015,0.120,-.180,0.020,0.266,0.236,0.066,0.170,0.024,0.089,
     c 0.021,0.116,-.181,0.023,0.257,0.237,0.065,0.170,0.026,0.087,
     c 0.023,0.115,-.184,0.025,0.247,0.238,0.061,0.173,0.028,0.080,
     c 0.016,0.111,-.190,0.026,0.237,0.236,0.056,0.172,0.026,0.071,
     c 0.007,0.110,-.194,0.027,0.228,0.235,0.053,0.171,0.025,0.062,
     c 0.002,0.106,-.199,0.027,0.216,0.231,0.048,0.168,0.021,0.055,
     c -.001,0.101,-.202,0.026,0.205,0.230,0.043,0.168,0.018,0.049,
     c -.007,0.095,-.204,0.023,0.195,0.229,0.038,0.167,0.016,0.046,
     c -.018,0.087,-.205,0.019,0.188,0.230,0.035,0.166,0.014,0.044,
     c -.028,0.077,-.206,0.016,0.183,0.230,0.033,0.164,0.014,0.043,
     c -.034,0.068,-.208,0.012,0.180,0.229,0.030,0.166,0.013,0.042,
     c -.036,0.056,-.212,0.010,0.177,0.227,0.027,0.166,0.011,0.044,
     c -.035,0.047,-.216,0.010,0.176,0.227,0.026,0.164,0.006,0.046,
     c -.031,0.038,-.220,0.010,0.177,0.225,0.025,0.157,-.002,0.046,
     c -.029,0.028,-.224,0.010,0.176,0.223,0.023,0.154,-.007,0.046,
     c 0.153,0.117,-.149,0.053,0.239,0.220,0.076,0.160,-.013,0.103,
     c 0.136,0.106,-.157,0.042,0.227,0.214,0.069,0.152,-.019,0.103,
     c 0.117,0.095,-.166,0.029,0.213,0.209,0.059,0.143,-.030,0.098,
     c 0.099,0.087,-.173,0.018,0.201,0.204,0.052,0.135,-.036,0.099,
     c 0.080,0.081,-.179,0.009,0.192,0.197,0.050,0.125,-.038,0.104,
     c 0.065,0.077,-.186,-.001,0.184,0.190,0.048,0.117,-.041,0.106,
     c 0.056,0.068,-.194,-.009,0.178,0.185,0.044,0.114,-.043,0.107,
     c 0.052,0.060,-.201,-.017,0.171,0.180,0.037,0.112,-.045,0.105,
     c 0.055,0.054,-.208,-.023,0.166,0.177,0.029,0.111,-.045,0.107,
     c 0.058,0.051,-.210,-.027,0.163,0.178,0.026,0.111,-.046,0.110,
     c 0.057,0.049,-.210,-.030,0.167,0.180,0.027,0.114,-.044,0.113,
     c 0.050,0.047,-.209,-.032,0.173,0.183,0.028,0.121,-.042,0.115,
     c 0.045,0.044,-.207,-.033,0.182,0.185,0.030,0.127,-.040,0.119,
     c 0.045,0.043,-.206,-.034,0.192,0.185,0.030,0.131,-.038,0.126,
     c 0.050,0.044,-.204,-.032,0.203,0.187,0.031,0.136,-.034,0.135,
     c 0.055,0.043,-.204,-.031,0.211,0.188,0.032,0.139,-.031,0.138,
     c 0.058,0.043,-.204,-.029,0.214,0.191,0.033,0.140,-.033,0.134,
     c 0.059,0.043,-.203,-.026,0.217,0.193,0.035,0.139,-.034,0.127,
     c 0.060,0.044,-.201,-.023,0.220,0.197,0.035,0.135,-.034,0.124,
     c 0.062,0.045,-.199,-.018,0.225,0.200,0.034,0.131,-.032,0.124,
     c 0.064,0.044,-.199,-.013,0.230,0.204,0.034,0.128,-.026,0.126,
     c 0.061,0.048,-.198,-.008,0.234,0.207,0.036,0.131,-.020,0.129,
     c 0.056,0.056,-.196,-.003,0.236,0.210,0.041,0.135,-.014,0.131,
     c 0.052,0.066,-.194,0.001,0.234,0.211,0.044,0.138,-.012,0.129,
     c 0.055,0.076,-.194,0.004,0.231,0.211,0.045,0.139,-.011,0.124,
     c 0.064,0.082,-.194,0.007,0.228,0.213,0.047,0.142,-.010,0.119,
     c 0.073,0.083,-.194,0.010,0.224,0.216,0.051,0.148,-.006,0.113,
     c 0.075,0.086,-.192,0.012,0.220,0.220,0.055,0.157,0.000,0.104,
     c 0.070,0.088,-.188,0.013,0.217,0.223,0.059,0.163,0.006,0.096,
     c 0.062,0.093,-.187,0.014,0.213,0.226,0.061,0.168,0.010,0.090,
     c 0.059,0.099,-.185,0.014,0.213,0.228,0.061,0.171,0.014,0.087,
     c 0.060,0.103,-.185,0.012,0.213,0.229,0.062,0.172,0.015,0.084,
     c 0.061,0.107,-.183,0.009,0.216,0.231,0.063,0.174,0.017,0.082,
     c 0.061,0.109,-.181,0.007,0.220,0.231,0.066,0.178,0.019,0.080,
     c 0.059,0.113,-.179,0.005,0.226,0.232,0.068,0.181,0.020,0.081,
     c 0.059,0.119,-.177,0.003,0.232,0.233,0.068,0.181,0.018,0.082,
     c 0.060,0.125,-.178,0.002,0.238,0.236,0.068,0.179,0.015,0.080,
     c 0.061,0.129,-.180,0.000,0.245,0.235,0.068,0.176,0.012,0.074,
     c 0.060,0.134,-.181,-.000,0.253,0.234,0.068,0.176,0.013,0.068,
     c 0.054,0.135,-.182,-.003,0.258,0.233,0.068,0.175,0.014,0.064,
     c 0.049,0.137,-.185,-.006,0.262,0.233,0.068,0.174,0.015,0.062,
     c 0.047,0.139,-.188,-.011,0.267,0.234,0.066,0.174,0.015,0.061,
     c 0.048,0.138,-.189,-.015,0.273,0.237,0.064,0.174,0.013,0.061,
     c 0.047,0.138,-.186,-.018,0.281,0.238,0.064,0.175,0.013,0.062,
     c 0.043,0.138,-.183,-.017,0.288,0.240,0.065,0.177,0.014,0.062,
     c 0.038,0.135,-.184,-.014,0.292,0.240,0.068,0.178,0.016,0.063,
     c 0.030,0.135,-.184,-.008,0.292,0.239,0.069,0.180,0.019,0.066,
     c 0.020,0.134,-.185,-.003,0.285,0.235,0.068,0.179,0.020,0.069,
     c 0.011,0.131,-.185,0.004,0.276,0.232,0.064,0.175,0.021,0.073,
     c 0.008,0.126,-.183,0.011,0.267,0.233,0.061,0.171,0.022,0.077,
     c 0.014,0.119,-.181,0.016,0.259,0.235,0.060,0.168,0.024,0.079,
     c 0.022,0.116,-.181,0.019,0.251,0.236,0.059,0.169,0.025,0.077,
     c 0.024,0.117,-.184,0.021,0.242,0.236,0.055,0.171,0.026,0.072,
     c 0.016,0.116,-.190,0.022,0.232,0.235,0.051,0.170,0.024,0.065,
     c 0.007,0.117,-.195,0.024,0.223,0.233,0.048,0.169,0.023,0.059,
     c 0.003,0.115,-.199,0.024,0.213,0.231,0.044,0.168,0.020,0.055,
     c 0.002,0.110,-.200,0.022,0.203,0.230,0.040,0.168,0.019,0.053,
     c -.005,0.102,-.203,0.019,0.195,0.229,0.035,0.168,0.017,0.052,
     c -.019,0.093,-.204,0.014,0.190,0.230,0.033,0.166,0.015,0.048,
     c -.033,0.082,-.207,0.009,0.186,0.230,0.030,0.166,0.015,0.044,
     c -.042,0.072,-.210,0.006,0.184,0.230,0.028,0.167,0.015,0.041,
     c -.045,0.060,-.214,0.004,0.183,0.228,0.024,0.166,0.013,0.042,
     c -.042,0.051,-.217,0.004,0.183,0.228,0.024,0.164,0.008,0.045,
     c -.035,0.044,-.220,0.006,0.184,0.226,0.024,0.156,-.000,0.046,
     c -.032,0.035,-.223,0.006,0.184,0.224,0.023,0.152,-.005,0.047,
     c 0.145,0.105,-.158,0.047,0.230,0.211,0.066,0.151,-.023,0.096,
     c 0.129,0.094,-.165,0.035,0.218,0.205,0.060,0.143,-.028,0.096,
     c 0.111,0.082,-.176,0.021,0.204,0.199,0.049,0.131,-.039,0.090,
     c 0.094,0.073,-.182,0.009,0.191,0.193,0.042,0.122,-.045,0.093,
     c 0.079,0.068,-.187,-.002,0.183,0.186,0.040,0.112,-.047,0.099,
     c 0.065,0.063,-.193,-.012,0.176,0.180,0.039,0.106,-.049,0.101,
     c 0.057,0.056,-.201,-.021,0.170,0.176,0.036,0.104,-.051,0.100,
     c 0.051,0.049,-.208,-.029,0.163,0.172,0.028,0.103,-.053,0.097,
     c 0.052,0.045,-.214,-.034,0.158,0.169,0.021,0.102,-.054,0.099,
     c 0.055,0.043,-.216,-.037,0.155,0.170,0.018,0.102,-.054,0.104,
     c 0.055,0.043,-.216,-.039,0.159,0.171,0.018,0.106,-.052,0.110,
     c 0.049,0.042,-.214,-.041,0.166,0.174,0.019,0.114,-.049,0.115,
     c 0.044,0.039,-.213,-.041,0.175,0.176,0.021,0.120,-.046,0.120,
     c 0.044,0.040,-.211,-.040,0.186,0.178,0.022,0.125,-.044,0.128,
     c 0.049,0.042,-.209,-.036,0.198,0.180,0.025,0.128,-.039,0.136,
     c 0.053,0.041,-.209,-.032,0.206,0.183,0.027,0.130,-.037,0.138,
     c 0.054,0.041,-.209,-.028,0.210,0.187,0.029,0.133,-.038,0.130,
     c 0.056,0.041,-.208,-.024,0.212,0.190,0.033,0.134,-.039,0.121,
     c 0.059,0.041,-.205,-.019,0.215,0.194,0.035,0.133,-.038,0.116,
     c 0.062,0.040,-.203,-.015,0.219,0.198,0.034,0.130,-.034,0.116,
     c 0.065,0.040,-.201,-.010,0.224,0.202,0.035,0.129,-.028,0.119,
     c 0.062,0.044,-.200,-.005,0.228,0.205,0.038,0.132,-.020,0.123,
     c 0.057,0.055,-.197,-.001,0.231,0.208,0.044,0.137,-.013,0.125,
     c 0.051,0.067,-.195,0.003,0.229,0.210,0.046,0.139,-.011,0.122,
     c 0.054,0.078,-.195,0.006,0.227,0.210,0.045,0.140,-.011,0.118,
     c 0.063,0.085,-.196,0.009,0.224,0.211,0.046,0.141,-.010,0.113,
     c 0.074,0.086,-.197,0.012,0.221,0.214,0.049,0.146,-.007,0.107,
     c 0.078,0.088,-.194,0.014,0.219,0.218,0.053,0.153,-.002,0.098,
     c 0.073,0.089,-.191,0.016,0.217,0.222,0.058,0.159,0.003,0.089,
     c 0.065,0.094,-.188,0.016,0.213,0.224,0.059,0.164,0.007,0.081,
     c 0.060,0.099,-.186,0.015,0.213,0.225,0.057,0.167,0.010,0.075,
     c 0.060,0.103,-.185,0.013,0.213,0.226,0.056,0.168,0.012,0.070,
     c 0.060,0.107,-.184,0.010,0.216,0.228,0.057,0.170,0.013,0.068,
     c 0.058,0.108,-.181,0.008,0.221,0.230,0.061,0.173,0.016,0.068,
     c 0.056,0.110,-.179,0.005,0.227,0.231,0.064,0.176,0.017,0.072,
     c 0.055,0.115,-.179,0.003,0.232,0.232,0.064,0.175,0.015,0.075,
     c 0.057,0.121,-.181,0.000,0.237,0.233,0.064,0.173,0.012,0.073,
     c 0.058,0.125,-.183,-.002,0.244,0.230,0.063,0.170,0.010,0.066,
     c 0.058,0.129,-.183,-.003,0.252,0.230,0.064,0.171,0.011,0.059,
     c 0.055,0.130,-.183,-.006,0.258,0.229,0.065,0.170,0.013,0.056,
     c 0.053,0.132,-.186,-.010,0.261,0.231,0.066,0.171,0.015,0.055,
     c 0.053,0.134,-.190,-.015,0.265,0.233,0.065,0.172,0.015,0.055,
     c 0.053,0.134,-.190,-.019,0.270,0.236,0.064,0.174,0.014,0.057,
     c 0.050,0.136,-.187,-.021,0.277,0.238,0.062,0.176,0.013,0.059,
     c 0.043,0.137,-.184,-.020,0.284,0.241,0.063,0.177,0.014,0.059,
     c 0.037,0.136,-.184,-.017,0.287,0.241,0.067,0.177,0.015,0.058,
     c 0.031,0.135,-.185,-.011,0.286,0.240,0.069,0.178,0.017,0.059,
     c 0.022,0.134,-.186,-.005,0.278,0.236,0.068,0.178,0.019,0.062,
     c 0.013,0.132,-.187,0.001,0.269,0.233,0.062,0.176,0.022,0.065,
     c 0.010,0.128,-.185,0.008,0.260,0.232,0.057,0.172,0.024,0.069,
     c 0.015,0.122,-.183,0.013,0.252,0.233,0.054,0.169,0.026,0.071,
     c 0.022,0.120,-.182,0.016,0.245,0.234,0.052,0.169,0.027,0.071,
     c 0.023,0.121,-.185,0.018,0.237,0.234,0.049,0.171,0.026,0.066,
     c 0.016,0.123,-.190,0.019,0.228,0.233,0.045,0.169,0.024,0.061,
     c 0.007,0.125,-.195,0.021,0.220,0.233,0.043,0.169,0.022,0.057,
     c 0.004,0.123,-.198,0.020,0.211,0.230,0.040,0.167,0.021,0.055,
     c 0.003,0.116,-.199,0.018,0.203,0.229,0.038,0.168,0.020,0.056,
     c -.004,0.107,-.202,0.014,0.197,0.229,0.035,0.168,0.018,0.056,
     c -.020,0.097,-.206,0.008,0.193,0.229,0.033,0.166,0.016,0.053,
     c -.037,0.086,-.210,0.003,0.191,0.230,0.031,0.165,0.014,0.046,
     c -.048,0.075,-.214,-.001,0.190,0.229,0.027,0.165,0.014,0.041,
     c -.051,0.065,-.217,-.002,0.190,0.228,0.024,0.164,0.012,0.041,
     c -.046,0.057,-.218,-.001,0.191,0.228,0.023,0.161,0.007,0.045,
     c -.037,0.052,-.219,0.002,0.192,0.227,0.024,0.155,-.000,0.046,
     c -.033,0.042,-.222,0.002,0.193,0.226,0.023,0.151,-.005,0.048,
     c 0.139,0.092,-.165,0.043,0.221,0.203,0.058,0.144,-.030,0.089,
     c 0.124,0.081,-.172,0.030,0.209,0.197,0.051,0.134,-.035,0.090,
     c 0.106,0.068,-.184,0.015,0.195,0.189,0.042,0.123,-.043,0.088,
     c 0.090,0.058,-.191,0.002,0.182,0.182,0.035,0.113,-.049,0.091,
     c 0.076,0.052,-.194,-.010,0.173,0.176,0.033,0.104,-.050,0.095,
     c 0.065,0.048,-.199,-.021,0.167,0.170,0.031,0.098,-.053,0.096,
     c 0.057,0.042,-.206,-.030,0.162,0.168,0.028,0.096,-.055,0.092,
     c 0.050,0.037,-.212,-.038,0.157,0.165,0.021,0.095,-.058,0.089,
     c 0.049,0.036,-.217,-.042,0.153,0.163,0.014,0.093,-.060,0.091,
     c 0.051,0.036,-.219,-.046,0.150,0.164,0.011,0.093,-.061,0.098,
     c 0.052,0.037,-.219,-.048,0.153,0.164,0.011,0.097,-.059,0.107,
     c 0.048,0.036,-.219,-.049,0.159,0.167,0.012,0.106,-.056,0.115,
     c 0.043,0.034,-.217,-.049,0.169,0.170,0.015,0.113,-.052,0.123,
     c 0.042,0.036,-.215,-.047,0.181,0.172,0.017,0.118,-.049,0.130,
     c 0.044,0.039,-.213,-.041,0.194,0.176,0.021,0.121,-.044,0.137,
     c 0.046,0.039,-.213,-.035,0.202,0.179,0.023,0.123,-.041,0.136,
     c 0.048,0.040,-.213,-.029,0.206,0.184,0.026,0.126,-.042,0.127,
     c 0.053,0.039,-.211,-.022,0.209,0.189,0.030,0.130,-.041,0.117,
     c 0.057,0.038,-.208,-.017,0.211,0.193,0.034,0.131,-.040,0.111,
     c 0.061,0.036,-.205,-.012,0.214,0.197,0.034,0.130,-.035,0.112,
     c 0.064,0.035,-.203,-.007,0.218,0.201,0.037,0.130,-.027,0.115,
     c 0.062,0.041,-.201,-.002,0.223,0.204,0.041,0.135,-.019,0.117,
     c 0.057,0.053,-.198,0.002,0.227,0.207,0.048,0.141,-.012,0.118,
     c 0.051,0.066,-.195,0.005,0.226,0.209,0.049,0.143,-.011,0.114,
     c 0.051,0.078,-.196,0.008,0.225,0.209,0.047,0.143,-.010,0.109,
     c 0.059,0.085,-.197,0.012,0.223,0.209,0.046,0.143,-.010,0.105,
     c 0.071,0.088,-.197,0.015,0.221,0.212,0.048,0.146,-.007,0.100,
     c 0.076,0.091,-.194,0.017,0.220,0.217,0.052,0.151,-.002,0.091,
     c 0.074,0.092,-.191,0.019,0.219,0.220,0.056,0.156,0.002,0.082,
     c 0.066,0.096,-.188,0.019,0.216,0.223,0.057,0.160,0.003,0.073,
     c 0.060,0.103,-.186,0.018,0.215,0.223,0.054,0.162,0.006,0.067,
     c 0.058,0.107,-.184,0.015,0.216,0.225,0.052,0.163,0.008,0.061,
     c 0.058,0.110,-.183,0.013,0.219,0.227,0.054,0.165,0.010,0.058,
     c 0.056,0.111,-.180,0.010,0.225,0.230,0.059,0.168,0.013,0.060,
     c 0.053,0.112,-.179,0.008,0.230,0.232,0.062,0.170,0.014,0.065,
     c 0.051,0.115,-.180,0.005,0.234,0.232,0.062,0.170,0.013,0.070,
     c 0.052,0.120,-.184,0.001,0.238,0.232,0.061,0.169,0.010,0.068,
     c 0.053,0.122,-.185,-.001,0.244,0.229,0.059,0.166,0.008,0.061,
     c 0.054,0.126,-.183,-.003,0.253,0.228,0.060,0.167,0.011,0.054,
     c 0.054,0.127,-.183,-.007,0.258,0.229,0.062,0.167,0.013,0.051,
     c 0.054,0.128,-.185,-.012,0.261,0.230,0.064,0.169,0.015,0.052,
     c 0.056,0.131,-.188,-.017,0.263,0.232,0.064,0.172,0.016,0.054,
     c 0.055,0.133,-.188,-.021,0.266,0.235,0.063,0.175,0.015,0.058,
     c 0.051,0.137,-.185,-.022,0.273,0.239,0.061,0.178,0.015,0.060,
     c 0.044,0.140,-.181,-.020,0.279,0.243,0.063,0.178,0.016,0.059,
     c 0.040,0.138,-.181,-.016,0.282,0.244,0.067,0.176,0.015,0.057,
     c 0.035,0.137,-.182,-.010,0.280,0.243,0.070,0.178,0.017,0.058,
     c 0.027,0.136,-.184,-.005,0.272,0.238,0.069,0.178,0.021,0.061,
     c 0.018,0.134,-.185,0.001,0.263,0.233,0.063,0.178,0.025,0.065,
     c 0.012,0.131,-.184,0.007,0.255,0.232,0.057,0.176,0.028,0.068,
     c 0.014,0.126,-.182,0.012,0.248,0.232,0.052,0.173,0.029,0.071,
     c 0.020,0.124,-.182,0.014,0.241,0.233,0.049,0.171,0.027,0.071,
     c 0.021,0.126,-.184,0.016,0.234,0.233,0.046,0.171,0.025,0.066,
     c 0.014,0.129,-.189,0.017,0.227,0.234,0.043,0.169,0.022,0.060,
     c 0.006,0.131,-.194,0.018,0.220,0.234,0.041,0.167,0.021,0.056,
     c 0.003,0.128,-.197,0.017,0.212,0.232,0.039,0.165,0.021,0.054,
     c 0.003,0.121,-.198,0.014,0.205,0.230,0.038,0.166,0.021,0.056,
     c -.005,0.111,-.202,0.009,0.201,0.229,0.035,0.167,0.020,0.057,
     c -.022,0.100,-.207,0.003,0.199,0.229,0.034,0.165,0.015,0.055,
     c -.039,0.089,-.213,-.003,0.198,0.230,0.032,0.163,0.011,0.048,
     c -.050,0.080,-.217,-.007,0.198,0.229,0.029,0.162,0.010,0.041,
     c -.052,0.071,-.220,-.008,0.199,0.228,0.024,0.160,0.008,0.040,
     c -.046,0.065,-.219,-.005,0.200,0.229,0.024,0.157,0.004,0.045,
     c -.036,0.060,-.219,-.002,0.200,0.228,0.025,0.153,-.001,0.046,
     c -.032,0.051,-.220,-.000,0.200,0.227,0.024,0.149,-.004,0.048,
     c 0.134,0.079,-.172,0.041,0.214,0.196,0.051,0.137,-.034,0.086,
     c 0.120,0.068,-.179,0.027,0.203,0.190,0.044,0.127,-.039,0.087,
     c 0.101,0.055,-.190,0.011,0.188,0.181,0.036,0.118,-.045,0.086,
     c 0.086,0.044,-.196,-.003,0.175,0.175,0.029,0.107,-.050,0.088,
     c 0.075,0.037,-.199,-.016,0.165,0.168,0.026,0.098,-.052,0.091,
     c 0.066,0.033,-.203,-.027,0.160,0.163,0.024,0.092,-.055,0.089,
     c 0.058,0.028,-.208,-.036,0.157,0.162,0.021,0.090,-.058,0.085,
     c 0.050,0.026,-.214,-.043,0.154,0.161,0.015,0.089,-.061,0.081,
     c 0.048,0.027,-.218,-.048,0.151,0.160,0.010,0.087,-.064,0.083,
     c 0.051,0.030,-.221,-.051,0.149,0.160,0.008,0.087,-.067,0.091,
     c 0.053,0.031,-.223,-.053,0.152,0.160,0.008,0.090,-.066,0.102,
     c 0.050,0.030,-.223,-.055,0.157,0.162,0.008,0.099,-.062,0.113,
     c 0.046,0.029,-.220,-.055,0.166,0.165,0.011,0.107,-.057,0.123,
     c 0.042,0.031,-.217,-.052,0.178,0.169,0.015,0.112,-.052,0.131,
     c 0.041,0.036,-.215,-.045,0.191,0.173,0.020,0.115,-.046,0.138,
     c 0.041,0.039,-.215,-.038,0.201,0.177,0.023,0.117,-.042,0.137,
     c 0.043,0.040,-.215,-.030,0.205,0.183,0.026,0.122,-.041,0.127,
     c 0.050,0.040,-.213,-.022,0.208,0.188,0.030,0.127,-.040,0.117,
     c 0.056,0.039,-.209,-.015,0.210,0.193,0.033,0.129,-.037,0.112,
     c 0.060,0.036,-.206,-.010,0.212,0.197,0.034,0.129,-.032,0.112,
     c 0.063,0.035,-.204,-.005,0.216,0.200,0.038,0.130,-.025,0.114,
     c 0.062,0.040,-.203,0.000,0.221,0.203,0.044,0.135,-.017,0.114,
     c 0.058,0.052,-.199,0.005,0.225,0.207,0.051,0.142,-.011,0.112,
     c 0.051,0.065,-.196,0.008,0.225,0.209,0.052,0.144,-.010,0.106,
     c 0.050,0.076,-.196,0.010,0.225,0.209,0.049,0.145,-.010,0.101,
     c 0.056,0.083,-.197,0.014,0.223,0.209,0.048,0.145,-.009,0.098,
     c 0.067,0.088,-.196,0.017,0.223,0.211,0.049,0.147,-.006,0.095,
     c 0.074,0.092,-.194,0.020,0.222,0.216,0.052,0.151,-.002,0.087,
     c 0.074,0.095,-.191,0.022,0.222,0.220,0.055,0.153,0.000,0.079,
     c 0.067,0.099,-.188,0.021,0.219,0.222,0.056,0.156,0.001,0.071,
     c 0.059,0.106,-.185,0.020,0.219,0.223,0.053,0.158,0.003,0.065,
     c 0.056,0.111,-.184,0.018,0.219,0.224,0.051,0.159,0.005,0.060,
     c 0.056,0.114,-.182,0.016,0.223,0.227,0.054,0.161,0.008,0.057,
     c 0.055,0.114,-.179,0.014,0.229,0.231,0.059,0.165,0.011,0.058,
     c 0.053,0.113,-.179,0.012,0.234,0.233,0.062,0.168,0.013,0.062,
     c 0.049,0.115,-.181,0.009,0.238,0.233,0.062,0.168,0.013,0.066,
     c 0.049,0.119,-.184,0.005,0.240,0.233,0.060,0.167,0.009,0.064,
     c 0.049,0.121,-.185,0.001,0.245,0.230,0.058,0.165,0.008,0.057,
     c 0.050,0.125,-.183,-.002,0.252,0.229,0.058,0.166,0.010,0.052,
     c 0.051,0.126,-.183,-.006,0.256,0.230,0.060,0.166,0.012,0.051,
     c 0.052,0.127,-.184,-.012,0.257,0.231,0.063,0.168,0.014,0.053,
     c 0.054,0.130,-.187,-.017,0.258,0.231,0.063,0.172,0.014,0.057,
     c 0.054,0.133,-.186,-.020,0.260,0.234,0.062,0.177,0.014,0.062,
     c 0.051,0.138,-.182,-.021,0.267,0.239,0.061,0.181,0.016,0.064,
     c 0.047,0.143,-.178,-.018,0.273,0.245,0.063,0.180,0.017,0.062,
     c 0.046,0.142,-.177,-.014,0.276,0.247,0.067,0.178,0.017,0.058,
     c 0.043,0.141,-.177,-.008,0.275,0.245,0.071,0.178,0.018,0.059,
     c 0.034,0.139,-.180,-.003,0.268,0.240,0.070,0.179,0.022,0.063,
     c 0.023,0.136,-.182,0.003,0.259,0.235,0.065,0.180,0.027,0.068,
     c 0.015,0.133,-.183,0.008,0.251,0.234,0.058,0.180,0.030,0.072,
     c 0.014,0.128,-.182,0.012,0.246,0.233,0.052,0.177,0.029,0.075,
     c 0.017,0.126,-.182,0.014,0.240,0.234,0.049,0.173,0.026,0.074,
     c 0.018,0.128,-.185,0.015,0.234,0.235,0.045,0.171,0.023,0.068,
     c 0.012,0.130,-.189,0.015,0.227,0.237,0.043,0.167,0.019,0.061,
     c 0.006,0.132,-.193,0.015,0.221,0.237,0.041,0.165,0.018,0.055,
     c 0.003,0.130,-.196,0.013,0.214,0.234,0.039,0.163,0.020,0.051,
     c 0.002,0.122,-.197,0.009,0.208,0.232,0.037,0.164,0.021,0.052,
     c -.006,0.114,-.202,0.004,0.205,0.230,0.034,0.166,0.020,0.055,
     c -.021,0.104,-.207,-.003,0.205,0.230,0.033,0.165,0.013,0.053,
     c -.035,0.095,-.214,-.008,0.205,0.230,0.031,0.162,0.008,0.046,
     c -.044,0.088,-.218,-.012,0.205,0.229,0.027,0.159,0.005,0.038,
     c -.046,0.081,-.220,-.013,0.206,0.228,0.024,0.156,0.003,0.037,
     c -.040,0.076,-.219,-.010,0.207,0.229,0.024,0.154,-.000,0.042,
     c -.033,0.068,-.218,-.005,0.206,0.227,0.024,0.151,-.003,0.044,
     c -.030,0.060,-.219,-.003,0.207,0.227,0.025,0.148,-.005,0.047,
     c 0.129,0.065,-.177,0.040,0.208,0.190,0.045,0.130,-.038,0.084,
     c 0.116,0.056,-.184,0.026,0.197,0.183,0.038,0.121,-.043,0.083,
     c 0.098,0.043,-.194,0.009,0.184,0.175,0.028,0.113,-.047,0.083,
     c 0.084,0.035,-.201,-.005,0.170,0.169,0.022,0.103,-.053,0.084,
     c 0.075,0.027,-.204,-.018,0.161,0.163,0.018,0.092,-.057,0.085,
     c 0.069,0.021,-.207,-.030,0.156,0.159,0.016,0.086,-.059,0.082,
     c 0.062,0.017,-.211,-.038,0.155,0.158,0.013,0.085,-.061,0.078,
     c 0.053,0.016,-.216,-.045,0.153,0.158,0.010,0.084,-.065,0.074,
     c 0.049,0.021,-.220,-.050,0.152,0.157,0.007,0.083,-.068,0.076,
     c 0.051,0.024,-.223,-.053,0.151,0.158,0.006,0.083,-.071,0.084,
     c 0.055,0.026,-.226,-.055,0.152,0.158,0.006,0.087,-.070,0.096,
     c 0.054,0.025,-.226,-.057,0.156,0.160,0.006,0.096,-.065,0.108,
     c 0.051,0.025,-.223,-.057,0.165,0.164,0.010,0.104,-.058,0.120,
     c 0.047,0.030,-.219,-.054,0.177,0.169,0.015,0.109,-.052,0.130,
     c 0.044,0.037,-.216,-.047,0.190,0.174,0.022,0.112,-.045,0.138,
     c 0.043,0.041,-.216,-.040,0.199,0.178,0.026,0.114,-.040,0.138,
     c 0.045,0.044,-.216,-.031,0.204,0.185,0.029,0.119,-.037,0.131,
     c 0.053,0.045,-.213,-.022,0.209,0.190,0.032,0.125,-.034,0.122,
     c 0.059,0.044,-.208,-.015,0.211,0.194,0.034,0.127,-.032,0.116,
     c 0.062,0.042,-.205,-.008,0.214,0.198,0.035,0.127,-.028,0.116,
     c 0.065,0.041,-.203,-.003,0.217,0.201,0.039,0.129,-.022,0.116,
     c 0.065,0.046,-.202,0.002,0.221,0.203,0.045,0.134,-.016,0.114,
     c 0.063,0.056,-.199,0.007,0.225,0.207,0.051,0.139,-.012,0.108,
     c 0.056,0.066,-.197,0.010,0.225,0.209,0.052,0.141,-.012,0.102,
     c 0.052,0.074,-.197,0.012,0.225,0.209,0.050,0.142,-.011,0.098,
     c 0.055,0.082,-.197,0.016,0.225,0.209,0.049,0.145,-.009,0.097,
     c 0.063,0.086,-.197,0.019,0.225,0.211,0.049,0.148,-.006,0.095,
     c 0.071,0.092,-.194,0.022,0.225,0.216,0.051,0.150,-.003,0.089,
     c 0.072,0.094,-.191,0.023,0.225,0.220,0.054,0.151,-.001,0.082,
     c 0.066,0.099,-.188,0.023,0.223,0.222,0.055,0.152,-.002,0.075,
     c 0.058,0.107,-.185,0.023,0.223,0.224,0.053,0.154,-.000,0.070,
     c 0.055,0.111,-.183,0.021,0.224,0.224,0.053,0.156,0.003,0.066,
     c 0.056,0.113,-.181,0.019,0.227,0.227,0.055,0.159,0.006,0.062,
     c 0.057,0.113,-.178,0.018,0.231,0.230,0.060,0.164,0.011,0.060,
     c 0.055,0.112,-.178,0.017,0.236,0.233,0.062,0.168,0.014,0.062,
     c 0.051,0.114,-.180,0.013,0.239,0.233,0.061,0.169,0.013,0.063,
     c 0.050,0.118,-.184,0.009,0.240,0.233,0.059,0.167,0.009,0.060,
     c 0.050,0.121,-.185,0.005,0.244,0.231,0.057,0.165,0.007,0.054,
     c 0.051,0.125,-.184,0.001,0.250,0.231,0.058,0.166,0.009,0.050,
     c 0.051,0.127,-.183,-.005,0.252,0.231,0.059,0.166,0.010,0.051,
     c 0.051,0.128,-.185,-.011,0.252,0.231,0.062,0.168,0.010,0.055,
     c 0.051,0.130,-.187,-.016,0.252,0.230,0.062,0.172,0.011,0.060,
     c 0.050,0.133,-.186,-.020,0.254,0.232,0.062,0.179,0.011,0.065,
     c 0.049,0.138,-.182,-.019,0.260,0.237,0.061,0.182,0.014,0.068,
     c 0.048,0.143,-.177,-.016,0.267,0.244,0.063,0.182,0.016,0.064,
     c 0.050,0.144,-.174,-.012,0.270,0.247,0.067,0.179,0.017,0.059,
     c 0.048,0.143,-.174,-.006,0.269,0.246,0.069,0.179,0.018,0.059,
     c 0.039,0.140,-.177,-.001,0.263,0.241,0.069,0.180,0.022,0.063,
     c 0.027,0.136,-.180,0.004,0.256,0.236,0.063,0.182,0.027,0.070,
     c 0.017,0.132,-.182,0.009,0.249,0.236,0.057,0.182,0.030,0.074,
     c 0.014,0.127,-.183,0.012,0.244,0.236,0.053,0.180,0.029,0.076,
     c 0.015,0.124,-.184,0.014,0.239,0.237,0.050,0.175,0.025,0.074,
     c 0.015,0.125,-.187,0.014,0.234,0.238,0.046,0.171,0.020,0.068,
     c 0.011,0.128,-.191,0.014,0.227,0.239,0.043,0.166,0.015,0.060,
     c 0.006,0.131,-.193,0.013,0.221,0.238,0.042,0.163,0.016,0.053,
     c 0.004,0.129,-.195,0.010,0.215,0.235,0.039,0.161,0.018,0.048,
     c 0.002,0.122,-.197,0.005,0.210,0.233,0.035,0.163,0.021,0.048,
     c -.004,0.116,-.201,-.001,0.209,0.231,0.031,0.165,0.019,0.051,
     c -.016,0.110,-.206,-.008,0.210,0.231,0.029,0.165,0.012,0.049,
     c -.027,0.104,-.212,-.014,0.210,0.229,0.027,0.161,0.004,0.042,
     c -.033,0.099,-.217,-.018,0.210,0.227,0.023,0.157,0.000,0.034,
     c -.035,0.092,-.219,-.018,0.211,0.225,0.020,0.153,-.002,0.033,
     c -.031,0.086,-.218,-.014,0.212,0.227,0.022,0.152,-.003,0.038,
     c -.029,0.076,-.218,-.008,0.211,0.227,0.025,0.151,-.004,0.043,
     c -.027,0.067,-.218,-.005,0.213,0.227,0.026,0.149,-.006,0.046,
     c 0.124,0.053,-.182,0.041,0.202,0.185,0.040,0.123,-.042,0.083,
     c 0.112,0.044,-.189,0.026,0.192,0.178,0.033,0.115,-.047,0.080,
     c 0.095,0.035,-.198,0.010,0.181,0.171,0.022,0.106,-.052,0.077,
     c 0.084,0.027,-.205,-.005,0.168,0.165,0.015,0.097,-.059,0.076,
     c 0.078,0.020,-.208,-.018,0.160,0.159,0.011,0.086,-.063,0.076,
     c 0.074,0.014,-.212,-.029,0.155,0.155,0.009,0.080,-.066,0.073,
     c 0.067,0.009,-.215,-.038,0.154,0.155,0.007,0.079,-.067,0.070,
     c 0.056,0.010,-.219,-.045,0.152,0.155,0.004,0.079,-.069,0.067,
     c 0.050,0.016,-.223,-.050,0.151,0.154,0.003,0.079,-.073,0.068,
     c 0.051,0.021,-.226,-.053,0.150,0.155,0.003,0.081,-.076,0.075,
     c 0.056,0.024,-.229,-.055,0.151,0.156,0.003,0.086,-.073,0.085,
     c 0.057,0.024,-.229,-.057,0.155,0.159,0.004,0.094,-.066,0.097,
     c 0.055,0.025,-.226,-.056,0.163,0.164,0.009,0.102,-.058,0.110,
     c 0.053,0.032,-.221,-.053,0.174,0.169,0.015,0.106,-.050,0.122,
     c 0.052,0.041,-.217,-.047,0.187,0.176,0.024,0.109,-.043,0.132,
     c 0.052,0.046,-.216,-.039,0.196,0.181,0.029,0.112,-.037,0.136,
     c 0.055,0.050,-.215,-.031,0.202,0.187,0.033,0.118,-.034,0.131,
     c 0.062,0.052,-.211,-.022,0.208,0.192,0.036,0.124,-.030,0.124,
     c 0.067,0.052,-.206,-.014,0.212,0.196,0.037,0.127,-.027,0.118,
     c 0.068,0.052,-.202,-.007,0.215,0.199,0.037,0.128,-.024,0.118,
     c 0.070,0.051,-.201,-.001,0.219,0.201,0.040,0.129,-.020,0.117,
     c 0.071,0.055,-.200,0.004,0.221,0.203,0.045,0.133,-.016,0.113,
     c 0.070,0.063,-.198,0.008,0.224,0.207,0.050,0.136,-.013,0.106,
     c 0.063,0.070,-.196,0.011,0.225,0.209,0.051,0.137,-.013,0.100,
     c 0.057,0.076,-.197,0.014,0.226,0.210,0.050,0.139,-.013,0.098,
     c 0.055,0.082,-.197,0.018,0.227,0.210,0.049,0.143,-.010,0.100,
     c 0.060,0.086,-.197,0.021,0.228,0.212,0.049,0.148,-.005,0.101,
     c 0.066,0.091,-.195,0.023,0.228,0.216,0.050,0.150,-.002,0.096,
     c 0.069,0.094,-.192,0.025,0.228,0.220,0.053,0.150,-.002,0.089,
     c 0.064,0.099,-.188,0.025,0.227,0.223,0.054,0.150,-.003,0.083,
     c 0.058,0.105,-.184,0.025,0.228,0.224,0.053,0.151,-.001,0.080,
     c 0.055,0.109,-.182,0.024,0.229,0.224,0.053,0.154,0.001,0.075,
     c 0.057,0.111,-.180,0.023,0.230,0.226,0.055,0.159,0.005,0.070,
     c 0.059,0.111,-.178,0.022,0.233,0.228,0.059,0.165,0.010,0.064,
     c 0.058,0.111,-.178,0.021,0.236,0.231,0.061,0.169,0.012,0.063,
     c 0.054,0.114,-.180,0.018,0.238,0.232,0.060,0.169,0.011,0.061,
     c 0.053,0.119,-.184,0.014,0.238,0.232,0.059,0.168,0.007,0.057,
     c 0.052,0.122,-.186,0.009,0.241,0.231,0.057,0.166,0.005,0.052,
     c 0.052,0.128,-.184,0.004,0.246,0.232,0.058,0.166,0.007,0.050,
     c 0.050,0.130,-.184,-.003,0.248,0.233,0.060,0.166,0.008,0.052,
     c 0.049,0.131,-.185,-.009,0.248,0.233,0.063,0.168,0.008,0.057,
     c 0.048,0.132,-.187,-.015,0.247,0.231,0.063,0.173,0.008,0.062,
     c 0.046,0.133,-.186,-.018,0.248,0.232,0.063,0.179,0.009,0.067,
     c 0.045,0.137,-.182,-.018,0.253,0.236,0.062,0.183,0.013,0.069,
     c 0.045,0.141,-.177,-.015,0.259,0.242,0.063,0.183,0.015,0.065,
     c 0.048,0.142,-.174,-.011,0.263,0.246,0.065,0.179,0.015,0.057,
     c 0.048,0.143,-.172,-.005,0.263,0.245,0.066,0.179,0.017,0.056,
     c 0.040,0.140,-.175,-.000,0.258,0.241,0.064,0.180,0.020,0.060,
     c 0.028,0.135,-.179,0.005,0.252,0.237,0.060,0.183,0.025,0.067,
     c 0.018,0.130,-.182,0.010,0.247,0.238,0.056,0.184,0.028,0.072,
     c 0.014,0.124,-.185,0.013,0.243,0.239,0.052,0.182,0.028,0.075,
     c 0.015,0.121,-.187,0.015,0.239,0.240,0.049,0.178,0.024,0.073,
     c 0.015,0.122,-.190,0.014,0.234,0.239,0.045,0.173,0.018,0.066,
     c 0.012,0.125,-.193,0.013,0.227,0.238,0.043,0.167,0.014,0.058,
     c 0.009,0.128,-.195,0.011,0.221,0.237,0.041,0.164,0.014,0.052,
     c 0.006,0.127,-.197,0.008,0.215,0.233,0.038,0.162,0.016,0.047,
     c 0.002,0.122,-.198,0.002,0.211,0.231,0.033,0.163,0.018,0.046,
     c -.003,0.118,-.201,-.005,0.210,0.230,0.028,0.165,0.016,0.047,
     c -.012,0.115,-.205,-.012,0.212,0.229,0.025,0.165,0.008,0.046,
     c -.018,0.112,-.211,-.018,0.212,0.226,0.022,0.161,0.000,0.039,
     c -.023,0.108,-.216,-.022,0.211,0.222,0.019,0.155,-.005,0.031,
     c -.024,0.101,-.218,-.023,0.212,0.220,0.017,0.151,-.006,0.031,
     c -.022,0.094,-.218,-.017,0.214,0.223,0.021,0.152,-.006,0.036,
     c -.024,0.082,-.218,-.011,0.216,0.226,0.026,0.152,-.006,0.040,
     c -.024,0.073,-.218,-.006,0.218,0.227,0.027,0.151,-.006,0.043,
     c 0.118,0.041,-.187,0.042,0.197,0.179,0.036,0.116,-.046,0.080,
     c 0.108,0.035,-.194,0.028,0.188,0.173,0.029,0.109,-.051,0.075,
     c 0.095,0.028,-.203,0.012,0.178,0.167,0.018,0.101,-.056,0.070,
     c 0.085,0.022,-.210,-.002,0.166,0.161,0.012,0.092,-.064,0.065,
     c 0.081,0.015,-.214,-.016,0.158,0.156,0.008,0.082,-.069,0.064,
     c 0.078,0.008,-.217,-.028,0.153,0.153,0.005,0.075,-.071,0.062,
     c 0.070,0.005,-.219,-.037,0.152,0.151,0.003,0.074,-.072,0.060,
     c 0.058,0.007,-.222,-.044,0.150,0.150,0.001,0.074,-.075,0.058,
     c 0.050,0.015,-.225,-.049,0.149,0.151,-.001,0.075,-.078,0.059,
     c 0.051,0.021,-.228,-.052,0.148,0.153,-.000,0.077,-.080,0.063,
     c 0.055,0.024,-.230,-.053,0.149,0.155,0.000,0.083,-.075,0.072,
     c 0.057,0.024,-.229,-.054,0.152,0.159,0.002,0.092,-.066,0.083,
     c 0.057,0.027,-.226,-.053,0.160,0.165,0.007,0.099,-.056,0.096,
     c 0.058,0.035,-.221,-.050,0.171,0.170,0.014,0.103,-.049,0.109,
     c 0.059,0.045,-.216,-.044,0.182,0.176,0.023,0.106,-.042,0.121,
     c 0.062,0.051,-.215,-.037,0.192,0.182,0.030,0.111,-.036,0.128,
     c 0.066,0.055,-.213,-.029,0.199,0.188,0.035,0.118,-.032,0.127,
     c 0.072,0.057,-.209,-.020,0.206,0.192,0.038,0.125,-.028,0.121,
     c 0.075,0.058,-.204,-.012,0.212,0.196,0.039,0.129,-.026,0.116,
     c 0.073,0.059,-.200,-.005,0.215,0.199,0.038,0.130,-.023,0.116,
     c 0.073,0.059,-.198,0.000,0.219,0.201,0.040,0.132,-.019,0.115,
     c 0.073,0.063,-.198,0.005,0.221,0.204,0.044,0.134,-.016,0.111,
     c 0.074,0.069,-.196,0.009,0.224,0.208,0.048,0.135,-.014,0.105,
     c 0.068,0.073,-.195,0.012,0.225,0.211,0.049,0.135,-.015,0.101,
     c 0.060,0.078,-.197,0.016,0.229,0.213,0.049,0.137,-.013,0.102,
     c 0.056,0.083,-.198,0.019,0.232,0.213,0.049,0.143,-.009,0.106,
     c 0.058,0.088,-.197,0.022,0.233,0.215,0.050,0.149,-.004,0.108,
     c 0.063,0.093,-.194,0.024,0.234,0.218,0.051,0.152,-.001,0.103,
     c 0.067,0.095,-.190,0.026,0.233,0.221,0.053,0.151,-.001,0.097,
     c 0.065,0.099,-.185,0.026,0.233,0.224,0.054,0.150,-.003,0.092,
     c 0.059,0.105,-.181,0.027,0.234,0.226,0.054,0.151,-.002,0.090,
     c 0.056,0.107,-.180,0.026,0.234,0.225,0.054,0.154,-.000,0.085,
     c 0.058,0.108,-.180,0.026,0.234,0.226,0.056,0.159,0.003,0.077,
     c 0.060,0.109,-.178,0.025,0.235,0.227,0.059,0.166,0.007,0.069,
     c 0.059,0.111,-.178,0.024,0.236,0.229,0.060,0.170,0.010,0.065,
     c 0.055,0.116,-.181,0.022,0.237,0.230,0.059,0.170,0.010,0.061,
     c 0.054,0.120,-.185,0.017,0.236,0.231,0.058,0.168,0.005,0.056,
     c 0.053,0.124,-.186,0.012,0.238,0.231,0.057,0.167,0.003,0.052,
     c 0.051,0.130,-.185,0.007,0.241,0.233,0.059,0.168,0.005,0.051,
     c 0.049,0.132,-.185,-.000,0.244,0.235,0.061,0.169,0.007,0.053,
     c 0.046,0.133,-.185,-.007,0.244,0.235,0.063,0.170,0.008,0.057,
     c 0.043,0.132,-.186,-.013,0.244,0.233,0.063,0.173,0.009,0.061,
     c 0.039,0.132,-.185,-.016,0.244,0.233,0.063,0.178,0.010,0.064,
     c 0.037,0.134,-.181,-.016,0.248,0.235,0.062,0.181,0.012,0.065,
     c 0.038,0.137,-.178,-.014,0.253,0.239,0.062,0.181,0.014,0.060,
     c 0.042,0.140,-.174,-.010,0.257,0.243,0.062,0.177,0.014,0.051,
     c 0.044,0.142,-.172,-.005,0.258,0.242,0.061,0.177,0.015,0.048,
     c 0.039,0.140,-.174,0.001,0.254,0.239,0.058,0.178,0.017,0.051,
     c 0.030,0.134,-.178,0.007,0.250,0.236,0.055,0.181,0.022,0.059,
     c 0.022,0.129,-.182,0.012,0.245,0.238,0.053,0.184,0.025,0.066,
     c 0.019,0.124,-.186,0.015,0.242,0.240,0.051,0.183,0.025,0.070,
     c 0.019,0.121,-.189,0.016,0.239,0.240,0.048,0.179,0.021,0.068,
     c 0.018,0.122,-.193,0.015,0.234,0.238,0.044,0.174,0.016,0.062,
     c 0.016,0.124,-.195,0.014,0.228,0.236,0.041,0.169,0.012,0.055,
     c 0.013,0.128,-.197,0.012,0.222,0.234,0.040,0.167,0.012,0.050,
     c 0.009,0.127,-.199,0.007,0.217,0.231,0.037,0.164,0.013,0.046,
     c 0.004,0.122,-.200,0.001,0.212,0.229,0.032,0.164,0.013,0.045,
     c -.002,0.120,-.202,-.007,0.212,0.228,0.027,0.165,0.010,0.046,
     c -.009,0.121,-.206,-.015,0.213,0.227,0.025,0.164,0.003,0.045,
     c -.012,0.120,-.210,-.022,0.213,0.222,0.022,0.160,-.005,0.039,
     c -.014,0.116,-.215,-.026,0.212,0.218,0.019,0.154,-.009,0.032,
     c -.015,0.108,-.217,-.026,0.214,0.216,0.019,0.151,-.009,0.032,
     c -.015,0.099,-.217,-.020,0.217,0.221,0.023,0.153,-.008,0.036,
     c -.020,0.088,-.218,-.012,0.220,0.225,0.026,0.153,-.007,0.038,
     c -.022,0.077,-.219,-.007,0.222,0.226,0.029,0.153,-.007,0.039,
     c 0.112,0.032,-.193,0.043,0.194,0.174,0.032,0.109,-.050,0.076,
     c 0.103,0.027,-.200,0.030,0.185,0.169,0.026,0.102,-.055,0.069,
     c 0.093,0.023,-.208,0.016,0.174,0.163,0.017,0.096,-.060,0.059,
     c 0.085,0.018,-.215,0.002,0.163,0.159,0.011,0.089,-.067,0.052,
     c 0.082,0.011,-.219,-.012,0.156,0.154,0.007,0.079,-.072,0.051,
     c 0.080,0.004,-.223,-.025,0.151,0.150,0.004,0.073,-.074,0.050,
     c 0.073,0.003,-.224,-.035,0.149,0.148,0.002,0.072,-.075,0.050,
     c 0.060,0.006,-.225,-.043,0.147,0.146,-.001,0.071,-.078,0.049,
     c 0.052,0.014,-.227,-.048,0.147,0.147,-.002,0.072,-.081,0.049,
     c 0.053,0.020,-.228,-.050,0.146,0.151,-.001,0.075,-.082,0.052,
     c 0.056,0.024,-.228,-.051,0.147,0.155,0.001,0.082,-.076,0.059,
     c 0.058,0.025,-.226,-.050,0.151,0.159,0.003,0.090,-.065,0.069,
     c 0.058,0.029,-.222,-.048,0.158,0.165,0.008,0.097,-.055,0.081,
     c 0.059,0.038,-.218,-.045,0.168,0.170,0.014,0.100,-.048,0.092,
     c 0.063,0.048,-.215,-.039,0.178,0.176,0.021,0.104,-.041,0.105,
     c 0.069,0.053,-.213,-.032,0.187,0.181,0.028,0.110,-.036,0.114,
     c 0.074,0.057,-.211,-.025,0.195,0.187,0.034,0.119,-.032,0.116,
     c 0.078,0.059,-.206,-.017,0.203,0.191,0.038,0.126,-.029,0.112,
     c 0.077,0.061,-.201,-.009,0.210,0.195,0.039,0.130,-.026,0.110,
     c 0.073,0.062,-.198,-.003,0.214,0.198,0.038,0.132,-.023,0.111,
     c 0.071,0.063,-.197,0.001,0.218,0.201,0.040,0.134,-.019,0.112,
     c 0.070,0.066,-.196,0.005,0.221,0.205,0.043,0.135,-.016,0.109,
     c 0.071,0.072,-.195,0.009,0.225,0.210,0.047,0.136,-.013,0.105,
     c 0.067,0.077,-.195,0.012,0.228,0.215,0.049,0.136,-.014,0.103,
     c 0.061,0.082,-.197,0.016,0.233,0.218,0.051,0.139,-.012,0.106,
     c 0.056,0.086,-.198,0.019,0.238,0.219,0.052,0.146,-.007,0.110,
     c 0.057,0.090,-.196,0.021,0.240,0.220,0.053,0.153,-.001,0.112,
     c 0.062,0.095,-.192,0.024,0.240,0.222,0.053,0.155,0.001,0.108,
     c 0.068,0.099,-.187,0.025,0.240,0.224,0.055,0.154,0.000,0.103,
     c 0.068,0.102,-.182,0.027,0.239,0.226,0.056,0.152,-.002,0.099,
     c 0.063,0.107,-.179,0.028,0.240,0.228,0.056,0.153,-.002,0.098,
     c 0.060,0.107,-.178,0.028,0.240,0.228,0.056,0.155,-.001,0.093,
     c 0.061,0.108,-.179,0.028,0.238,0.227,0.057,0.161,0.001,0.084,
     c 0.061,0.108,-.179,0.028,0.237,0.228,0.059,0.167,0.006,0.075,
     c 0.059,0.111,-.180,0.027,0.237,0.229,0.060,0.171,0.009,0.068,
     c 0.054,0.116,-.182,0.024,0.236,0.229,0.059,0.171,0.009,0.063,
     c 0.052,0.121,-.185,0.019,0.234,0.230,0.057,0.169,0.005,0.058,
     c 0.050,0.125,-.186,0.014,0.235,0.230,0.056,0.168,0.004,0.055,
     c 0.049,0.130,-.184,0.009,0.237,0.233,0.058,0.170,0.006,0.054,
     c 0.046,0.132,-.184,0.002,0.240,0.236,0.060,0.171,0.009,0.056,
     c 0.042,0.133,-.183,-.004,0.241,0.237,0.062,0.172,0.011,0.058,
     c 0.038,0.133,-.183,-.009,0.242,0.236,0.062,0.174,0.012,0.059,
     c 0.032,0.132,-.181,-.013,0.242,0.235,0.061,0.177,0.011,0.059,
     c 0.029,0.133,-.180,-.014,0.245,0.236,0.059,0.178,0.013,0.058,
     c 0.029,0.136,-.178,-.012,0.249,0.238,0.059,0.177,0.014,0.052,
     c 0.035,0.138,-.175,-.009,0.252,0.240,0.058,0.174,0.014,0.042,
     c 0.039,0.142,-.173,-.004,0.254,0.240,0.056,0.174,0.015,0.037,
     c 0.039,0.141,-.174,0.002,0.252,0.238,0.054,0.175,0.016,0.039,
     c 0.034,0.136,-.176,0.008,0.249,0.236,0.051,0.178,0.019,0.048,
     c 0.029,0.131,-.181,0.013,0.245,0.239,0.050,0.180,0.021,0.057,
     c 0.027,0.125,-.185,0.017,0.242,0.240,0.049,0.180,0.021,0.062,
     c 0.026,0.123,-.189,0.018,0.239,0.240,0.046,0.177,0.018,0.061,
     c 0.024,0.123,-.192,0.017,0.235,0.237,0.041,0.173,0.013,0.055,
     c 0.021,0.125,-.196,0.015,0.230,0.235,0.038,0.169,0.010,0.049,
     c 0.017,0.127,-.198,0.013,0.225,0.233,0.038,0.168,0.010,0.046,
     c 0.013,0.126,-.200,0.008,0.219,0.230,0.035,0.165,0.009,0.043,
     c 0.006,0.122,-.202,0.001,0.214,0.228,0.031,0.164,0.007,0.043,
     c -.000,0.122,-.204,-.008,0.214,0.226,0.027,0.164,0.003,0.045,
     c -.005,0.125,-.206,-.016,0.215,0.225,0.027,0.162,-.003,0.045,
     c -.005,0.125,-.210,-.024,0.215,0.221,0.026,0.159,-.008,0.040,
     c -.006,0.121,-.213,-.028,0.215,0.217,0.023,0.155,-.011,0.035,
     c -.008,0.112,-.215,-.028,0.216,0.216,0.022,0.152,-.010,0.035,
     c -.010,0.103,-.216,-.021,0.220,0.221,0.026,0.154,-.008,0.037,
     c -.018,0.091,-.218,-.013,0.223,0.224,0.026,0.152,-.008,0.034,
     c -.022,0.080,-.219,-.008,0.226,0.225,0.028,0.152,-.008,0.034,
     c 0.106,0.025,-.198,0.044,0.193,0.169,0.028,0.101,-.055,0.072,
     c 0.099,0.021,-.205,0.031,0.184,0.165,0.022,0.096,-.060,0.063,
     c 0.091,0.018,-.213,0.019,0.173,0.161,0.016,0.093,-.064,0.047,
     c 0.084,0.015,-.219,0.005,0.162,0.157,0.010,0.087,-.070,0.040,
     c 0.082,0.008,-.224,-.009,0.155,0.153,0.006,0.078,-.074,0.039,
     c 0.080,0.003,-.227,-.022,0.150,0.149,0.003,0.073,-.076,0.040,
     c 0.076,0.002,-.228,-.033,0.148,0.146,-.000,0.071,-.077,0.041,
     c 0.064,0.006,-.228,-.042,0.146,0.144,-.002,0.071,-.079,0.041,
     c 0.057,0.014,-.228,-.047,0.146,0.145,-.002,0.071,-.081,0.041,
     c 0.058,0.019,-.227,-.049,0.146,0.150,0.001,0.075,-.080,0.044,
     c 0.061,0.023,-.225,-.049,0.147,0.155,0.004,0.082,-.073,0.051,
     c 0.060,0.027,-.222,-.047,0.150,0.160,0.008,0.090,-.063,0.059,
     c 0.060,0.032,-.218,-.043,0.157,0.165,0.012,0.096,-.053,0.068,
     c 0.062,0.042,-.215,-.038,0.166,0.169,0.015,0.099,-.046,0.076,
     c 0.068,0.051,-.212,-.032,0.176,0.175,0.021,0.104,-.040,0.089,
     c 0.075,0.055,-.211,-.025,0.184,0.179,0.026,0.111,-.035,0.100,
     c 0.079,0.058,-.208,-.018,0.193,0.185,0.033,0.120,-.032,0.105,
     c 0.081,0.060,-.203,-.011,0.202,0.190,0.038,0.127,-.029,0.103,
     c 0.078,0.062,-.199,-.004,0.209,0.194,0.039,0.130,-.026,0.103,
     c 0.071,0.064,-.197,0.000,0.214,0.197,0.038,0.132,-.023,0.106,
     c 0.067,0.065,-.196,0.003,0.218,0.201,0.039,0.133,-.018,0.110,
     c 0.064,0.070,-.196,0.006,0.223,0.207,0.042,0.136,-.014,0.110,
     c 0.065,0.077,-.195,0.009,0.229,0.213,0.047,0.137,-.012,0.108,
     c 0.062,0.082,-.196,0.011,0.233,0.220,0.050,0.138,-.012,0.107,
     c 0.058,0.086,-.198,0.014,0.240,0.223,0.052,0.141,-.010,0.110,
     c 0.055,0.090,-.197,0.017,0.245,0.225,0.055,0.148,-.005,0.114,
     c 0.056,0.093,-.195,0.019,0.248,0.226,0.056,0.155,0.001,0.115,
     c 0.063,0.098,-.190,0.021,0.247,0.227,0.056,0.157,0.003,0.111,
     c 0.069,0.102,-.184,0.023,0.246,0.228,0.058,0.156,0.001,0.107,
     c 0.071,0.106,-.180,0.026,0.245,0.230,0.060,0.155,-.001,0.105,
     c 0.068,0.110,-.177,0.028,0.246,0.232,0.061,0.156,-.001,0.105,
     c 0.065,0.109,-.177,0.029,0.245,0.232,0.061,0.158,-.000,0.100,
     c 0.066,0.108,-.178,0.029,0.243,0.232,0.061,0.162,0.003,0.091,
     c 0.065,0.108,-.179,0.029,0.241,0.231,0.061,0.168,0.007,0.081,
     c 0.060,0.111,-.180,0.028,0.239,0.231,0.061,0.172,0.011,0.074,
     c 0.055,0.116,-.182,0.025,0.236,0.231,0.058,0.172,0.011,0.067,
     c 0.051,0.121,-.183,0.020,0.233,0.231,0.056,0.170,0.008,0.063,
     c 0.049,0.125,-.184,0.015,0.233,0.231,0.055,0.169,0.007,0.059,
     c 0.048,0.130,-.181,0.011,0.235,0.234,0.057,0.171,0.010,0.059,
     c 0.045,0.133,-.180,0.005,0.236,0.237,0.058,0.173,0.012,0.060,
     c 0.041,0.134,-.179,-.000,0.238,0.239,0.059,0.174,0.014,0.059,
     c 0.035,0.134,-.178,-.005,0.239,0.238,0.058,0.175,0.014,0.057,
     c 0.028,0.134,-.177,-.009,0.239,0.237,0.057,0.176,0.012,0.054,
     c 0.022,0.135,-.177,-.011,0.241,0.237,0.055,0.176,0.013,0.051,
     c 0.021,0.136,-.177,-.010,0.245,0.238,0.055,0.175,0.014,0.045,
     c 0.025,0.138,-.176,-.008,0.248,0.239,0.056,0.172,0.014,0.036,
     c 0.032,0.142,-.175,-.003,0.251,0.239,0.055,0.172,0.015,0.031,
     c 0.034,0.141,-.175,0.002,0.251,0.238,0.052,0.172,0.016,0.032,
     c 0.034,0.136,-.177,0.008,0.248,0.237,0.049,0.174,0.018,0.040,
     c 0.032,0.130,-.180,0.014,0.244,0.239,0.048,0.175,0.018,0.049,
     c 0.031,0.125,-.185,0.017,0.241,0.241,0.047,0.175,0.017,0.054,
     c 0.031,0.123,-.188,0.018,0.239,0.240,0.044,0.172,0.014,0.052,
     c 0.028,0.124,-.191,0.017,0.235,0.238,0.040,0.170,0.012,0.046,
     c 0.024,0.125,-.194,0.016,0.231,0.235,0.037,0.168,0.010,0.040,
     c 0.020,0.126,-.197,0.014,0.226,0.234,0.037,0.167,0.011,0.038,
     c 0.016,0.125,-.201,0.009,0.220,0.231,0.035,0.164,0.009,0.036,
     c 0.010,0.122,-.204,0.001,0.216,0.229,0.032,0.162,0.005,0.038,
     c 0.003,0.124,-.206,-.007,0.215,0.228,0.029,0.162,0.001,0.041,
     c -.001,0.128,-.208,-.017,0.216,0.226,0.030,0.161,-.004,0.042,
     c -.001,0.128,-.209,-.025,0.217,0.223,0.029,0.158,-.007,0.040,
     c 0.000,0.125,-.212,-.029,0.217,0.219,0.026,0.155,-.009,0.037,
     c -.004,0.115,-.214,-.029,0.219,0.218,0.024,0.152,-.009,0.036,
     c -.009,0.105,-.215,-.022,0.223,0.222,0.027,0.153,-.008,0.036,
     c -.018,0.094,-.217,-.013,0.225,0.222,0.026,0.151,-.009,0.031,
     c -.023,0.083,-.219,-.008,0.228,0.223,0.027,0.150,-.009,0.029,
     c 0.102,0.018,-.205,0.045,0.194,0.165,0.024,0.094,-.059,0.066,
     c 0.096,0.016,-.210,0.032,0.185,0.161,0.019,0.090,-.063,0.056,
     c 0.087,0.016,-.217,0.021,0.175,0.158,0.012,0.087,-.068,0.039,
     c 0.081,0.013,-.222,0.008,0.164,0.155,0.007,0.083,-.074,0.031,
     c 0.080,0.007,-.226,-.006,0.157,0.151,0.003,0.076,-.078,0.030,
     c 0.080,0.002,-.230,-.020,0.152,0.148,0.000,0.072,-.079,0.032,
     c 0.078,0.002,-.231,-.031,0.149,0.144,-.002,0.071,-.079,0.034,
     c 0.069,0.006,-.231,-.041,0.147,0.142,-.004,0.071,-.079,0.034,
     c 0.064,0.013,-.230,-.046,0.146,0.144,-.003,0.072,-.079,0.036,
     c 0.065,0.018,-.227,-.047,0.146,0.150,0.002,0.077,-.077,0.040,
     c 0.067,0.023,-.223,-.046,0.147,0.156,0.008,0.085,-.069,0.047,
     c 0.066,0.029,-.219,-.042,0.149,0.160,0.013,0.093,-.059,0.054,
     c 0.065,0.037,-.214,-.038,0.155,0.164,0.018,0.098,-.050,0.059,
     c 0.068,0.047,-.212,-.031,0.163,0.168,0.019,0.102,-.043,0.065,
     c 0.075,0.056,-.209,-.023,0.173,0.173,0.022,0.106,-.038,0.076,
     c 0.082,0.060,-.208,-.016,0.183,0.178,0.026,0.113,-.034,0.088,
     c 0.085,0.063,-.204,-.010,0.192,0.185,0.033,0.121,-.031,0.096,
     c 0.085,0.065,-.199,-.003,0.202,0.191,0.039,0.127,-.028,0.098,
     c 0.080,0.067,-.196,0.002,0.209,0.195,0.040,0.131,-.025,0.100,
     c 0.073,0.069,-.194,0.005,0.214,0.199,0.038,0.132,-.021,0.105,
     c 0.067,0.071,-.195,0.006,0.220,0.203,0.039,0.134,-.016,0.112,
     c 0.063,0.076,-.195,0.007,0.226,0.209,0.042,0.137,-.012,0.114,
     c 0.062,0.084,-.195,0.009,0.234,0.217,0.047,0.140,-.008,0.113,
     c 0.060,0.089,-.195,0.010,0.239,0.223,0.051,0.140,-.008,0.113,
     c 0.058,0.092,-.196,0.011,0.247,0.227,0.053,0.143,-.007,0.116,
     c 0.056,0.093,-.194,0.013,0.252,0.229,0.055,0.149,-.002,0.119,
     c 0.059,0.095,-.191,0.015,0.254,0.230,0.056,0.156,0.003,0.119,
     c 0.065,0.099,-.187,0.017,0.253,0.230,0.057,0.158,0.005,0.115,
     c 0.073,0.105,-.182,0.020,0.251,0.231,0.059,0.157,0.004,0.113,
     c 0.076,0.110,-.178,0.023,0.251,0.234,0.062,0.157,0.002,0.113,
     c 0.074,0.114,-.176,0.026,0.252,0.237,0.063,0.159,0.002,0.114,
     c 0.072,0.112,-.176,0.028,0.250,0.237,0.063,0.160,0.003,0.109,
     c 0.072,0.111,-.178,0.029,0.247,0.237,0.063,0.164,0.006,0.100,
     c 0.071,0.110,-.178,0.029,0.244,0.236,0.063,0.169,0.010,0.090,
     c 0.065,0.112,-.179,0.028,0.241,0.234,0.062,0.173,0.013,0.082,
     c 0.059,0.117,-.180,0.025,0.237,0.233,0.058,0.173,0.014,0.075,
     c 0.055,0.122,-.180,0.021,0.234,0.233,0.056,0.172,0.011,0.070,
     c 0.053,0.127,-.179,0.016,0.233,0.234,0.055,0.171,0.011,0.065,
     c 0.052,0.133,-.176,0.013,0.234,0.237,0.057,0.173,0.014,0.064,
     c 0.049,0.136,-.175,0.008,0.235,0.240,0.058,0.174,0.016,0.064,
     c 0.045,0.137,-.174,0.004,0.236,0.242,0.059,0.175,0.017,0.063,
     c 0.037,0.138,-.173,-.001,0.236,0.242,0.057,0.176,0.016,0.058,
     c 0.028,0.138,-.172,-.005,0.236,0.242,0.055,0.177,0.014,0.054,
     c 0.019,0.138,-.172,-.007,0.239,0.241,0.055,0.177,0.013,0.051,
     c 0.015,0.137,-.174,-.008,0.242,0.240,0.056,0.177,0.014,0.046,
     c 0.017,0.138,-.176,-.007,0.245,0.241,0.057,0.174,0.015,0.040,
     c 0.021,0.141,-.176,-.003,0.248,0.241,0.056,0.173,0.017,0.035,
     c 0.023,0.140,-.177,0.002,0.248,0.240,0.052,0.172,0.018,0.036,
     c 0.025,0.134,-.179,0.008,0.246,0.240,0.049,0.172,0.019,0.042,
     c 0.026,0.128,-.182,0.012,0.243,0.241,0.047,0.173,0.017,0.049,
     c 0.027,0.123,-.186,0.015,0.240,0.241,0.046,0.171,0.015,0.051,
     c 0.027,0.122,-.189,0.017,0.237,0.241,0.043,0.169,0.012,0.047,
     c 0.025,0.123,-.190,0.017,0.234,0.239,0.039,0.167,0.011,0.040,
     c 0.021,0.123,-.192,0.015,0.230,0.237,0.037,0.166,0.011,0.033,
     c 0.019,0.125,-.196,0.014,0.225,0.235,0.038,0.166,0.012,0.031,
     c 0.017,0.124,-.200,0.009,0.219,0.232,0.036,0.163,0.010,0.031,
     c 0.011,0.124,-.204,0.002,0.214,0.230,0.034,0.161,0.005,0.033,
     c 0.005,0.127,-.207,-.007,0.214,0.229,0.032,0.160,0.001,0.037,
     c 0.001,0.131,-.209,-.016,0.215,0.229,0.033,0.160,-.001,0.039,
     c 0.002,0.131,-.210,-.024,0.217,0.227,0.032,0.158,-.003,0.039,
     c 0.001,0.128,-.211,-.029,0.218,0.223,0.027,0.155,-.005,0.038,
     c -.003,0.117,-.213,-.028,0.220,0.220,0.024,0.150,-.006,0.036,
     c -.010,0.107,-.215,-.022,0.223,0.222,0.025,0.150,-.008,0.034,
     c -.018,0.098,-.217,-.013,0.225,0.222,0.024,0.148,-.009,0.027,
     c -.025,0.086,-.219,-.007,0.229,0.221,0.024,0.146,-.010,0.023,
     c 0.099,0.012,-.210,0.044,0.196,0.162,0.020,0.090,-.061,0.059,
     c 0.093,0.011,-.215,0.031,0.188,0.158,0.015,0.086,-.066,0.050,
     c 0.086,0.013,-.221,0.021,0.179,0.154,0.009,0.081,-.073,0.034,
     c 0.080,0.012,-.225,0.008,0.168,0.152,0.004,0.077,-.079,0.026,
     c 0.079,0.006,-.229,-.006,0.161,0.149,-.001,0.072,-.082,0.025,
     c 0.079,0.002,-.232,-.020,0.155,0.146,-.004,0.069,-.083,0.026,
     c 0.077,0.001,-.233,-.031,0.151,0.143,-.006,0.069,-.081,0.027,
     c 0.070,0.005,-.233,-.040,0.148,0.142,-.007,0.071,-.079,0.027,
     c 0.068,0.012,-.232,-.045,0.146,0.145,-.004,0.074,-.077,0.030,
     c 0.070,0.018,-.228,-.045,0.145,0.152,0.003,0.080,-.072,0.037,
     c 0.073,0.024,-.223,-.043,0.145,0.158,0.011,0.089,-.065,0.045,
     c 0.072,0.033,-.217,-.038,0.146,0.162,0.017,0.096,-.056,0.050,
     c 0.070,0.042,-.212,-.031,0.151,0.166,0.021,0.101,-.048,0.053,
     c 0.073,0.053,-.209,-.024,0.159,0.169,0.022,0.105,-.042,0.057,
     c 0.081,0.062,-.207,-.015,0.171,0.175,0.024,0.110,-.036,0.068,
     c 0.088,0.066,-.204,-.007,0.182,0.180,0.028,0.115,-.032,0.083,
     c 0.091,0.070,-.200,-.000,0.193,0.188,0.035,0.122,-.029,0.095,
     c 0.091,0.073,-.195,0.006,0.203,0.195,0.041,0.129,-.025,0.101,
     c 0.086,0.075,-.192,0.009,0.211,0.199,0.043,0.133,-.022,0.105,
     c 0.079,0.077,-.190,0.011,0.217,0.203,0.041,0.135,-.017,0.112,
     c 0.073,0.080,-.191,0.010,0.223,0.207,0.041,0.137,-.012,0.119,
     c 0.068,0.085,-.192,0.009,0.231,0.212,0.044,0.141,-.007,0.122,
     c 0.068,0.093,-.192,0.009,0.239,0.219,0.049,0.145,-.004,0.122,
     c 0.067,0.097,-.191,0.009,0.246,0.225,0.052,0.146,-.004,0.123,
     c 0.066,0.099,-.191,0.009,0.253,0.228,0.052,0.148,-.002,0.125,
     c 0.065,0.098,-.189,0.009,0.257,0.230,0.054,0.152,0.002,0.126,
     c 0.068,0.098,-.186,0.010,0.259,0.232,0.056,0.158,0.006,0.126,
     c 0.074,0.102,-.182,0.012,0.258,0.232,0.057,0.160,0.008,0.123,
     c 0.081,0.108,-.178,0.015,0.257,0.233,0.059,0.160,0.007,0.122,
     c 0.084,0.114,-.176,0.019,0.256,0.237,0.061,0.160,0.006,0.123,
     c 0.081,0.118,-.174,0.023,0.257,0.241,0.063,0.162,0.007,0.124,
     c 0.080,0.116,-.175,0.026,0.255,0.242,0.063,0.162,0.007,0.118,
     c 0.079,0.115,-.177,0.027,0.251,0.241,0.062,0.164,0.009,0.110,
     c 0.077,0.115,-.178,0.028,0.247,0.239,0.062,0.169,0.013,0.101,
     c 0.071,0.116,-.178,0.027,0.243,0.237,0.061,0.174,0.016,0.094,
     c 0.066,0.121,-.178,0.024,0.240,0.235,0.059,0.175,0.016,0.087,
     c 0.063,0.127,-.177,0.020,0.236,0.237,0.058,0.174,0.015,0.081,
     c 0.060,0.132,-.174,0.017,0.236,0.238,0.058,0.174,0.016,0.076,
     c 0.059,0.139,-.171,0.015,0.237,0.242,0.061,0.175,0.018,0.073,
     c 0.057,0.141,-.170,0.011,0.236,0.244,0.062,0.177,0.019,0.072,
     c 0.052,0.143,-.169,0.007,0.236,0.245,0.062,0.178,0.019,0.070,
     c 0.045,0.144,-.168,0.003,0.236,0.246,0.060,0.180,0.018,0.066,
     c 0.034,0.143,-.166,-.001,0.236,0.246,0.058,0.181,0.016,0.062,
     c 0.024,0.141,-.167,-.004,0.238,0.246,0.057,0.182,0.015,0.059,
     c 0.017,0.139,-.171,-.006,0.240,0.244,0.058,0.181,0.016,0.056,
     c 0.014,0.137,-.175,-.006,0.243,0.243,0.059,0.178,0.016,0.051,
     c 0.014,0.138,-.177,-.002,0.246,0.243,0.058,0.176,0.018,0.048,
     c 0.013,0.136,-.180,0.002,0.246,0.243,0.053,0.175,0.019,0.048,
     c 0.015,0.131,-.182,0.007,0.245,0.242,0.049,0.175,0.020,0.051,
     c 0.017,0.125,-.186,0.011,0.241,0.243,0.047,0.174,0.018,0.054,
     c 0.020,0.121,-.189,0.013,0.238,0.242,0.046,0.172,0.014,0.054,
     c 0.021,0.121,-.190,0.015,0.235,0.241,0.044,0.169,0.011,0.048,
     c 0.018,0.122,-.190,0.015,0.231,0.239,0.040,0.168,0.011,0.039,
     c 0.016,0.123,-.191,0.014,0.227,0.238,0.038,0.167,0.012,0.032,
     c 0.016,0.125,-.194,0.013,0.223,0.236,0.039,0.166,0.013,0.031,
     c 0.015,0.126,-.199,0.009,0.217,0.232,0.038,0.163,0.010,0.031,
     c 0.011,0.128,-.204,0.002,0.212,0.231,0.037,0.160,0.005,0.033,
     c 0.005,0.132,-.207,-.006,0.212,0.230,0.035,0.159,0.003,0.035,
     c 0.000,0.136,-.209,-.015,0.214,0.230,0.035,0.159,0.002,0.038,
     c 0.001,0.136,-.210,-.023,0.216,0.229,0.033,0.157,0.000,0.040,
     c 0.000,0.132,-.212,-.028,0.217,0.226,0.028,0.154,-.001,0.039,
     c -.005,0.121,-.214,-.028,0.219,0.222,0.024,0.148,-.004,0.036,
     c -.012,0.111,-.215,-.021,0.222,0.222,0.022,0.145,-.007,0.031,
     c -.020,0.101,-.217,-.012,0.225,0.221,0.022,0.145,-.010,0.024,
     c -.027,0.090,-.219,-.006,0.228,0.219,0.021,0.142,-.012,0.019,
     c 0.097,0.006,-.216,0.042,0.200,0.159,0.016,0.086,-.063,0.053,
     c 0.091,0.006,-.220,0.029,0.191,0.156,0.011,0.082,-.067,0.044,
     c 0.084,0.009,-.224,0.018,0.183,0.152,0.006,0.076,-.074,0.031,
     c 0.078,0.008,-.227,0.006,0.173,0.149,0.001,0.073,-.080,0.024,
     c 0.076,0.005,-.231,-.008,0.164,0.146,-.005,0.068,-.084,0.023,
     c 0.075,0.001,-.235,-.022,0.156,0.144,-.008,0.066,-.084,0.022,
     c 0.074,0.002,-.236,-.032,0.151,0.143,-.008,0.068,-.082,0.022,
     c 0.069,0.005,-.236,-.041,0.145,0.143,-.008,0.070,-.079,0.022,
     c 0.070,0.012,-.234,-.045,0.143,0.147,-.004,0.075,-.075,0.025,
     c 0.075,0.018,-.230,-.043,0.141,0.156,0.004,0.083,-.070,0.033,
     c 0.079,0.025,-.224,-.039,0.140,0.161,0.012,0.090,-.063,0.041,
     c 0.078,0.035,-.218,-.033,0.141,0.165,0.018,0.097,-.056,0.046,
     c 0.075,0.045,-.212,-.025,0.145,0.168,0.022,0.101,-.049,0.048,
     c 0.077,0.057,-.208,-.017,0.154,0.172,0.023,0.106,-.042,0.053,
     c 0.083,0.068,-.204,-.006,0.167,0.178,0.025,0.111,-.036,0.066,
     c 0.091,0.073,-.201,0.001,0.180,0.185,0.029,0.116,-.031,0.084,
     c 0.095,0.079,-.197,0.008,0.193,0.194,0.037,0.123,-.027,0.099,
     c 0.095,0.083,-.191,0.013,0.205,0.200,0.045,0.130,-.023,0.109,
     c 0.091,0.087,-.187,0.016,0.214,0.205,0.047,0.136,-.018,0.115,
     c 0.085,0.088,-.185,0.017,0.220,0.208,0.046,0.140,-.012,0.122,
     c 0.081,0.090,-.186,0.015,0.228,0.212,0.046,0.144,-.006,0.129,
     c 0.077,0.096,-.187,0.012,0.236,0.216,0.048,0.148,-.001,0.131,
     c 0.079,0.102,-.186,0.011,0.245,0.222,0.052,0.152,0.003,0.132,
     c 0.079,0.105,-.185,0.008,0.251,0.227,0.054,0.153,0.003,0.132,
     c 0.080,0.105,-.184,0.007,0.258,0.230,0.054,0.155,0.005,0.133,
     c 0.080,0.104,-.181,0.006,0.262,0.232,0.055,0.158,0.008,0.135,
     c 0.083,0.102,-.178,0.006,0.263,0.233,0.057,0.163,0.012,0.134,
     c 0.088,0.106,-.176,0.007,0.263,0.234,0.058,0.164,0.013,0.133,
     c 0.092,0.113,-.173,0.010,0.262,0.236,0.060,0.165,0.013,0.133,
     c 0.093,0.118,-.172,0.014,0.262,0.240,0.061,0.166,0.012,0.134,
     c 0.090,0.122,-.172,0.019,0.263,0.244,0.062,0.166,0.012,0.134,
     c 0.086,0.120,-.173,0.022,0.259,0.245,0.061,0.165,0.012,0.128,
     c 0.084,0.120,-.175,0.024,0.255,0.243,0.061,0.166,0.013,0.121,
     c 0.081,0.121,-.176,0.026,0.251,0.241,0.060,0.171,0.016,0.114,
     c 0.076,0.123,-.176,0.025,0.247,0.239,0.061,0.175,0.019,0.108,
     c 0.073,0.128,-.175,0.023,0.244,0.238,0.061,0.177,0.019,0.103,
     c 0.071,0.134,-.173,0.020,0.240,0.240,0.061,0.177,0.018,0.096,
     c 0.069,0.140,-.169,0.018,0.240,0.243,0.063,0.177,0.019,0.089,
     c 0.067,0.146,-.167,0.016,0.240,0.246,0.065,0.179,0.021,0.084,
     c 0.066,0.149,-.167,0.014,0.238,0.248,0.066,0.180,0.021,0.082,
     c 0.061,0.149,-.166,0.010,0.237,0.249,0.066,0.182,0.021,0.080,
     c 0.055,0.149,-.165,0.007,0.237,0.250,0.064,0.184,0.020,0.076,
     c 0.045,0.147,-.163,0.003,0.236,0.252,0.062,0.186,0.018,0.073,
     c 0.035,0.145,-.163,0.000,0.238,0.251,0.061,0.188,0.018,0.071,
     c 0.027,0.141,-.167,-.002,0.241,0.249,0.062,0.187,0.018,0.068,
     c 0.020,0.137,-.172,-.003,0.243,0.247,0.062,0.183,0.018,0.064,
     c 0.016,0.136,-.176,-.000,0.245,0.246,0.060,0.181,0.020,0.061,
     c 0.012,0.134,-.180,0.003,0.246,0.246,0.055,0.180,0.022,0.059,
     c 0.012,0.128,-.184,0.007,0.245,0.245,0.051,0.180,0.023,0.060,
     c 0.014,0.124,-.187,0.010,0.241,0.245,0.048,0.179,0.020,0.061,
     c 0.017,0.120,-.190,0.012,0.237,0.243,0.047,0.176,0.016,0.058,
     c 0.017,0.121,-.191,0.013,0.233,0.241,0.045,0.172,0.012,0.051,
     c 0.014,0.123,-.190,0.013,0.229,0.240,0.042,0.170,0.011,0.042,
     c 0.011,0.123,-.191,0.013,0.225,0.238,0.039,0.168,0.011,0.036,
     c 0.011,0.126,-.193,0.012,0.220,0.236,0.039,0.167,0.011,0.034,
     c 0.010,0.129,-.198,0.008,0.214,0.232,0.038,0.163,0.008,0.034,
     c 0.007,0.132,-.203,0.002,0.210,0.230,0.037,0.160,0.004,0.034,
     c 0.002,0.137,-.206,-.005,0.211,0.228,0.035,0.159,0.003,0.035,
     c -.003,0.141,-.208,-.013,0.213,0.229,0.035,0.159,0.003,0.036,
     c -.004,0.141,-.210,-.021,0.215,0.229,0.033,0.157,0.003,0.039,
     c -.005,0.136,-.213,-.026,0.216,0.227,0.029,0.154,0.001,0.040,
     c -.009,0.127,-.215,-.026,0.218,0.223,0.024,0.147,-.003,0.037,
     c -.016,0.116,-.216,-.019,0.220,0.222,0.022,0.144,-.007,0.031,
     c -.021,0.106,-.217,-.009,0.223,0.220,0.020,0.143,-.010,0.021,
     c -.027,0.095,-.219,-.003,0.226,0.218,0.017,0.139,-.013,0.015,
     c 0.096,0.002,-.220,0.039,0.203,0.158,0.013,0.082,-.063,0.047,
     c 0.089,0.002,-.223,0.026,0.194,0.155,0.008,0.079,-.068,0.040,
     c 0.081,0.002,-.227,0.014,0.186,0.151,0.004,0.075,-.073,0.029,
     c 0.074,0.004,-.230,0.001,0.176,0.148,-.002,0.070,-.079,0.023,
     c 0.071,0.003,-.233,-.013,0.166,0.145,-.007,0.066,-.083,0.020,
     c 0.069,0.001,-.237,-.025,0.156,0.144,-.009,0.063,-.084,0.019,
     c 0.070,0.002,-.239,-.035,0.148,0.143,-.009,0.065,-.082,0.018,
     c 0.069,0.006,-.239,-.042,0.141,0.145,-.007,0.068,-.079,0.017,
     c 0.074,0.011,-.237,-.044,0.137,0.150,-.002,0.074,-.075,0.020,
     c 0.082,0.017,-.232,-.041,0.135,0.158,0.005,0.081,-.070,0.028,
     c 0.087,0.026,-.226,-.035,0.133,0.163,0.012,0.088,-.064,0.035,
     c 0.084,0.035,-.219,-.028,0.134,0.167,0.016,0.093,-.058,0.041,
     c 0.080,0.046,-.212,-.020,0.138,0.170,0.019,0.097,-.052,0.045,
     c 0.079,0.057,-.207,-.010,0.147,0.175,0.021,0.104,-.044,0.051,
     c 0.084,0.069,-.203,-.000,0.161,0.182,0.025,0.110,-.036,0.066,
     c 0.092,0.076,-.199,0.008,0.177,0.189,0.031,0.116,-.030,0.086,
     c 0.096,0.085,-.194,0.015,0.193,0.199,0.040,0.123,-.026,0.103,
     c 0.097,0.092,-.188,0.020,0.207,0.206,0.049,0.132,-.020,0.115,
     c 0.093,0.096,-.183,0.022,0.217,0.211,0.054,0.139,-.014,0.123,
     c 0.089,0.098,-.180,0.022,0.225,0.213,0.052,0.145,-.007,0.129,
     c 0.086,0.100,-.180,0.019,0.233,0.216,0.052,0.149,-.001,0.135,
     c 0.086,0.104,-.180,0.015,0.242,0.220,0.053,0.153,0.004,0.136,
     c 0.089,0.109,-.179,0.012,0.251,0.225,0.056,0.158,0.009,0.137,
     c 0.092,0.110,-.177,0.008,0.257,0.231,0.057,0.159,0.010,0.136,
     c 0.095,0.110,-.176,0.005,0.262,0.234,0.056,0.161,0.012,0.138,
     c 0.096,0.109,-.174,0.003,0.266,0.236,0.057,0.164,0.015,0.141,
     c 0.098,0.108,-.171,0.001,0.268,0.237,0.060,0.169,0.018,0.142,
     c 0.101,0.113,-.169,0.002,0.268,0.237,0.062,0.171,0.019,0.142,
     c 0.103,0.118,-.168,0.005,0.268,0.239,0.063,0.172,0.019,0.143,
     c 0.102,0.124,-.168,0.009,0.268,0.244,0.062,0.173,0.018,0.144,
     c 0.097,0.126,-.168,0.015,0.268,0.248,0.062,0.173,0.018,0.142,
     c 0.092,0.125,-.169,0.018,0.265,0.249,0.061,0.171,0.016,0.136,
     c 0.088,0.126,-.170,0.022,0.261,0.247,0.061,0.171,0.017,0.129,
     c 0.084,0.129,-.171,0.023,0.256,0.244,0.061,0.175,0.020,0.123,
     c 0.081,0.131,-.171,0.023,0.252,0.243,0.062,0.179,0.023,0.119,
     c 0.080,0.136,-.170,0.022,0.249,0.243,0.063,0.181,0.023,0.115,
     c 0.080,0.141,-.167,0.020,0.245,0.245,0.065,0.181,0.021,0.109,
     c 0.078,0.147,-.164,0.018,0.244,0.247,0.066,0.180,0.021,0.102,
     c 0.076,0.154,-.162,0.017,0.243,0.249,0.068,0.182,0.023,0.095,
     c 0.073,0.155,-.164,0.014,0.240,0.251,0.068,0.183,0.023,0.092,
     c 0.069,0.154,-.164,0.011,0.238,0.252,0.068,0.185,0.022,0.089,
     c 0.064,0.152,-.164,0.009,0.237,0.253,0.067,0.188,0.021,0.086,
     c 0.055,0.149,-.161,0.006,0.236,0.255,0.066,0.191,0.021,0.083,
     c 0.047,0.147,-.161,0.004,0.238,0.254,0.064,0.192,0.021,0.080,
     c 0.039,0.144,-.164,0.002,0.240,0.252,0.064,0.191,0.020,0.078,
     c 0.031,0.139,-.170,0.001,0.241,0.249,0.063,0.187,0.020,0.073,
     c 0.025,0.137,-.174,0.003,0.244,0.248,0.061,0.186,0.022,0.069,
     c 0.019,0.133,-.178,0.005,0.246,0.248,0.057,0.185,0.024,0.066,
     c 0.018,0.127,-.183,0.008,0.246,0.247,0.053,0.185,0.025,0.066,
     c 0.019,0.123,-.187,0.010,0.242,0.246,0.050,0.184,0.022,0.065,
     c 0.020,0.121,-.190,0.011,0.238,0.244,0.049,0.180,0.018,0.061,
     c 0.017,0.123,-.191,0.011,0.233,0.242,0.047,0.175,0.013,0.054,
     c 0.012,0.125,-.191,0.011,0.229,0.240,0.043,0.173,0.011,0.045,
     c 0.007,0.125,-.192,0.011,0.223,0.238,0.041,0.169,0.009,0.039,
     c 0.005,0.128,-.194,0.010,0.218,0.235,0.040,0.167,0.008,0.036,
     c 0.004,0.131,-.199,0.006,0.213,0.230,0.038,0.163,0.005,0.035,
     c -.000,0.135,-.202,0.001,0.210,0.228,0.036,0.159,0.002,0.033,
     c -.005,0.141,-.206,-.005,0.211,0.226,0.033,0.158,0.001,0.031,
     c -.011,0.144,-.208,-.012,0.213,0.226,0.032,0.158,0.002,0.031,
     c -.011,0.143,-.210,-.019,0.214,0.226,0.032,0.157,0.001,0.034,
     c -.011,0.140,-.213,-.023,0.215,0.225,0.030,0.153,-.001,0.036,
     c -.014,0.131,-.216,-.023,0.216,0.223,0.025,0.147,-.004,0.034,
     c -.018,0.122,-.216,-.015,0.218,0.222,0.023,0.144,-.008,0.029,
     c -.021,0.110,-.217,-.005,0.221,0.220,0.018,0.142,-.011,0.019,
     c -.025,0.099,-.218,0.001,0.223,0.217,0.014,0.138,-.014,0.013,
     c 0.098,-.003,-.225,0.037,0.206,0.157,0.011,0.080,-.064,0.042,
     c 0.089,-.002,-.227,0.023,0.197,0.154,0.007,0.077,-.069,0.035,
     c 0.076,-.002,-.229,0.009,0.189,0.151,0.002,0.073,-.072,0.026,
     c 0.067,0.001,-.231,-.004,0.179,0.148,-.004,0.069,-.078,0.021,
     c 0.064,0.001,-.235,-.017,0.168,0.146,-.008,0.064,-.082,0.018,
     c 0.064,0.002,-.239,-.028,0.156,0.144,-.010,0.061,-.085,0.016,
     c 0.068,0.003,-.241,-.037,0.146,0.144,-.008,0.062,-.084,0.015,
     c 0.071,0.007,-.241,-.042,0.137,0.146,-.005,0.065,-.081,0.013,
     c 0.079,0.012,-.239,-.043,0.132,0.151,-.001,0.071,-.077,0.016,
     c 0.089,0.018,-.234,-.038,0.129,0.158,0.005,0.078,-.072,0.023,
     c 0.094,0.027,-.227,-.031,0.128,0.163,0.010,0.083,-.067,0.031,
     c 0.091,0.036,-.220,-.023,0.128,0.166,0.013,0.088,-.061,0.038,
     c 0.084,0.046,-.213,-.013,0.132,0.170,0.016,0.093,-.054,0.045,
     c 0.080,0.056,-.208,-.004,0.141,0.177,0.019,0.101,-.045,0.053,
     c 0.083,0.068,-.203,0.006,0.156,0.185,0.025,0.110,-.036,0.068,
     c 0.091,0.077,-.199,0.014,0.173,0.192,0.032,0.116,-.029,0.086,
     c 0.096,0.088,-.193,0.020,0.190,0.202,0.042,0.123,-.023,0.102,
     c 0.098,0.097,-.185,0.024,0.206,0.209,0.052,0.132,-.017,0.114,
     c 0.095,0.103,-.179,0.027,0.218,0.214,0.058,0.141,-.010,0.123,
     c 0.090,0.107,-.175,0.026,0.228,0.217,0.058,0.148,-.002,0.131,
     c 0.088,0.108,-.174,0.022,0.238,0.220,0.057,0.151,0.004,0.136,
     c 0.089,0.111,-.175,0.017,0.247,0.224,0.057,0.156,0.010,0.136,
     c 0.094,0.114,-.173,0.013,0.257,0.230,0.059,0.160,0.015,0.136,
     c 0.100,0.114,-.171,0.008,0.263,0.236,0.060,0.162,0.016,0.137,
     c 0.105,0.114,-.170,0.003,0.268,0.239,0.059,0.165,0.018,0.139,
     c 0.107,0.114,-.167,-.000,0.272,0.242,0.061,0.170,0.021,0.143,
     c 0.108,0.114,-.165,-.003,0.274,0.243,0.064,0.175,0.023,0.146,
     c 0.110,0.119,-.162,-.003,0.274,0.243,0.067,0.178,0.025,0.147,
     c 0.111,0.124,-.162,0.000,0.275,0.245,0.067,0.179,0.025,0.149,
     c 0.110,0.129,-.163,0.004,0.274,0.249,0.066,0.181,0.024,0.149,
     c 0.104,0.130,-.163,0.011,0.274,0.253,0.065,0.181,0.023,0.147,
     c 0.098,0.130,-.164,0.015,0.271,0.254,0.064,0.179,0.020,0.140,
     c 0.092,0.132,-.164,0.019,0.267,0.252,0.063,0.179,0.021,0.133,
     c 0.087,0.135,-.165,0.021,0.263,0.250,0.064,0.182,0.024,0.128,
     c 0.085,0.138,-.166,0.022,0.259,0.249,0.066,0.186,0.027,0.126,
     c 0.085,0.142,-.165,0.021,0.255,0.249,0.067,0.187,0.026,0.123,
     c 0.087,0.147,-.162,0.019,0.252,0.250,0.068,0.185,0.024,0.118,
     c 0.086,0.152,-.160,0.017,0.249,0.251,0.068,0.183,0.024,0.112,
     c 0.083,0.158,-.159,0.016,0.247,0.252,0.068,0.185,0.025,0.105,
     c 0.079,0.157,-.161,0.014,0.242,0.252,0.068,0.186,0.024,0.101,
     c 0.074,0.155,-.162,0.011,0.239,0.253,0.069,0.188,0.023,0.098,
     c 0.069,0.152,-.162,0.009,0.237,0.255,0.068,0.190,0.022,0.094,
     c 0.063,0.149,-.159,0.008,0.236,0.256,0.067,0.193,0.021,0.090,
     c 0.056,0.148,-.159,0.007,0.236,0.256,0.066,0.194,0.022,0.088,
     c 0.050,0.146,-.162,0.005,0.237,0.254,0.064,0.193,0.022,0.084,
     c 0.043,0.143,-.167,0.004,0.239,0.251,0.063,0.189,0.021,0.080,
     c 0.036,0.140,-.171,0.005,0.242,0.250,0.062,0.188,0.023,0.075,
     c 0.028,0.134,-.175,0.007,0.245,0.250,0.060,0.188,0.025,0.071,
     c 0.026,0.128,-.179,0.008,0.246,0.249,0.057,0.188,0.026,0.070,
     c 0.026,0.125,-.184,0.008,0.244,0.247,0.054,0.186,0.023,0.068,
     c 0.025,0.124,-.188,0.008,0.239,0.244,0.051,0.181,0.019,0.064,
     c 0.019,0.125,-.190,0.008,0.234,0.241,0.047,0.176,0.014,0.056,
     c 0.011,0.127,-.191,0.008,0.229,0.240,0.044,0.172,0.011,0.047,
     c 0.004,0.126,-.193,0.007,0.223,0.237,0.041,0.169,0.008,0.041,
     c -.001,0.128,-.196,0.006,0.217,0.234,0.039,0.167,0.007,0.037,
     c -.003,0.132,-.200,0.002,0.213,0.230,0.037,0.163,0.004,0.033,
     c -.007,0.137,-.203,-.001,0.211,0.227,0.034,0.159,0.001,0.029,
     c -.012,0.142,-.206,-.005,0.212,0.225,0.030,0.157,-.001,0.024,
     c -.017,0.145,-.208,-.010,0.214,0.223,0.030,0.157,-.001,0.022,
     c -.017,0.143,-.210,-.015,0.214,0.223,0.031,0.156,-.002,0.025,
     c -.015,0.140,-.213,-.019,0.214,0.222,0.030,0.153,-.005,0.028,
     c -.015,0.133,-.215,-.017,0.214,0.221,0.027,0.148,-.008,0.029,
     c -.017,0.125,-.216,-.010,0.215,0.221,0.023,0.145,-.011,0.025,
     c -.020,0.114,-.216,-.001,0.218,0.219,0.016,0.142,-.013,0.016,
     c -.023,0.104,-.218,0.005,0.220,0.217,0.011,0.139,-.015,0.011,
     c 0.099,-.005,-.227,0.034,0.208,0.157,0.010,0.078,-.066,0.037,
     c 0.089,-.004,-.229,0.020,0.199,0.154,0.006,0.075,-.070,0.031,
     c 0.073,-.003,-.232,0.005,0.192,0.151,0.001,0.071,-.073,0.023,
     c 0.063,0.000,-.233,-.008,0.182,0.148,-.004,0.067,-.079,0.017,
     c 0.059,0.002,-.236,-.021,0.171,0.145,-.008,0.063,-.083,0.015,
     c 0.062,0.004,-.239,-.031,0.158,0.143,-.010,0.061,-.085,0.013,
     c 0.068,0.005,-.241,-.037,0.147,0.144,-.007,0.061,-.084,0.013,
     c 0.075,0.009,-.240,-.041,0.136,0.146,-.004,0.065,-.083,0.012,
     c 0.083,0.014,-.238,-.040,0.130,0.150,-.000,0.071,-.078,0.014,
     c 0.092,0.022,-.233,-.035,0.126,0.157,0.005,0.076,-.074,0.021,
     c 0.095,0.031,-.226,-.026,0.125,0.161,0.009,0.081,-.068,0.029,
     c 0.091,0.040,-.219,-.017,0.126,0.165,0.012,0.086,-.061,0.038,
     c 0.083,0.048,-.212,-.007,0.131,0.170,0.016,0.092,-.053,0.047,
     c 0.077,0.057,-.207,0.003,0.140,0.178,0.020,0.102,-.043,0.056,
     c 0.079,0.067,-.202,0.012,0.155,0.187,0.027,0.111,-.033,0.069,
     c 0.088,0.076,-.198,0.019,0.172,0.195,0.034,0.117,-.026,0.083,
     c 0.096,0.088,-.191,0.025,0.188,0.203,0.044,0.123,-.020,0.096,
     c 0.100,0.098,-.182,0.029,0.205,0.211,0.053,0.132,-.013,0.107,
     c 0.097,0.106,-.175,0.030,0.219,0.216,0.059,0.142,-.005,0.117,
     c 0.092,0.111,-.170,0.029,0.231,0.220,0.060,0.149,0.003,0.126,
     c 0.089,0.114,-.169,0.025,0.242,0.223,0.059,0.153,0.010,0.132,
     c 0.090,0.117,-.169,0.018,0.252,0.227,0.059,0.157,0.016,0.134,
     c 0.096,0.119,-.168,0.013,0.262,0.234,0.061,0.162,0.020,0.135,
     c 0.103,0.119,-.166,0.007,0.269,0.240,0.063,0.165,0.022,0.135,
     c 0.110,0.119,-.164,0.002,0.274,0.245,0.063,0.169,0.023,0.139,
     c 0.113,0.120,-.162,-.003,0.278,0.248,0.066,0.174,0.026,0.144,
     c 0.113,0.121,-.159,-.006,0.280,0.249,0.069,0.179,0.027,0.147,
     c 0.115,0.125,-.156,-.006,0.280,0.249,0.072,0.183,0.029,0.148,
     c 0.116,0.129,-.156,-.004,0.280,0.251,0.072,0.184,0.029,0.150,
     c 0.115,0.132,-.157,0.000,0.279,0.254,0.070,0.187,0.027,0.149,
     c 0.110,0.133,-.158,0.007,0.279,0.258,0.069,0.188,0.026,0.147,
     c 0.103,0.133,-.159,0.012,0.277,0.259,0.068,0.186,0.023,0.141,
     c 0.095,0.135,-.160,0.017,0.274,0.257,0.069,0.186,0.024,0.135,
     c 0.089,0.140,-.161,0.020,0.270,0.256,0.070,0.190,0.027,0.130,
     c 0.087,0.142,-.162,0.021,0.267,0.255,0.072,0.194,0.030,0.128,
     c 0.088,0.145,-.161,0.020,0.263,0.255,0.072,0.194,0.030,0.128,
     c 0.091,0.149,-.159,0.019,0.259,0.256,0.072,0.192,0.028,0.125,
     c 0.091,0.153,-.157,0.017,0.256,0.255,0.070,0.190,0.028,0.121,
     c 0.086,0.157,-.156,0.016,0.252,0.255,0.069,0.191,0.029,0.116,
     c 0.081,0.156,-.157,0.013,0.246,0.254,0.069,0.191,0.027,0.112,
     c 0.076,0.153,-.159,0.011,0.241,0.255,0.069,0.192,0.025,0.108,
     c 0.072,0.151,-.158,0.010,0.238,0.256,0.069,0.194,0.023,0.104,
     c 0.068,0.149,-.156,0.009,0.236,0.257,0.069,0.196,0.022,0.099,
     c 0.063,0.149,-.156,0.008,0.235,0.256,0.066,0.196,0.022,0.096,
     c 0.058,0.150,-.159,0.007,0.235,0.254,0.063,0.194,0.022,0.093,
     c 0.052,0.148,-.164,0.006,0.236,0.252,0.061,0.190,0.022,0.089,
     c 0.045,0.145,-.167,0.006,0.240,0.252,0.061,0.190,0.024,0.084,
     c 0.038,0.139,-.171,0.006,0.244,0.251,0.060,0.189,0.026,0.079,
     c 0.035,0.131,-.175,0.006,0.246,0.249,0.059,0.188,0.026,0.077,
     c 0.032,0.128,-.180,0.006,0.243,0.247,0.055,0.185,0.023,0.074,
     c 0.029,0.126,-.185,0.005,0.239,0.244,0.051,0.179,0.019,0.069,
     c 0.021,0.127,-.189,0.005,0.234,0.241,0.047,0.174,0.015,0.061,
     c 0.012,0.127,-.191,0.004,0.229,0.239,0.042,0.171,0.012,0.052,
     c 0.004,0.126,-.195,0.003,0.223,0.237,0.040,0.168,0.009,0.045,
     c -.002,0.128,-.198,0.002,0.218,0.234,0.038,0.167,0.007,0.039,
     c -.006,0.133,-.202,-.001,0.214,0.231,0.036,0.163,0.004,0.034,
     c -.009,0.137,-.204,-.004,0.212,0.229,0.033,0.159,-.000,0.027,
     c -.013,0.142,-.206,-.005,0.214,0.226,0.029,0.157,-.001,0.020,
     c -.018,0.144,-.208,-.008,0.215,0.224,0.029,0.155,-.003,0.014,
     c -.017,0.142,-.210,-.011,0.215,0.222,0.031,0.154,-.005,0.014,
     c -.014,0.140,-.212,-.012,0.213,0.221,0.031,0.152,-.009,0.017,
     c -.012,0.134,-.214,-.010,0.212,0.220,0.028,0.148,-.012,0.020,
     c -.013,0.127,-.215,-.003,0.213,0.220,0.022,0.146,-.014,0.019,
     c -.019,0.117,-.217,0.004,0.215,0.218,0.014,0.143,-.014,0.013,
     c -.021,0.108,-.218,0.010,0.216,0.216,0.008,0.140,-.016,0.010,
     c 0.100,-.006,-.229,0.031,0.209,0.156,0.009,0.075,-.069,0.033,
     c 0.089,-.004,-.231,0.017,0.200,0.153,0.005,0.073,-.072,0.027,
     c 0.074,-.002,-.233,0.002,0.194,0.150,0.000,0.069,-.075,0.020,
     c 0.063,0.001,-.235,-.012,0.183,0.148,-.005,0.067,-.079,0.013,
     c 0.059,0.003,-.237,-.023,0.172,0.145,-.009,0.065,-.082,0.011,
     c 0.063,0.005,-.239,-.032,0.159,0.143,-.010,0.064,-.083,0.010,
     c 0.071,0.008,-.239,-.037,0.149,0.145,-.007,0.066,-.083,0.012,
     c 0.077,0.012,-.238,-.040,0.138,0.147,-.003,0.069,-.082,0.012,
     c 0.083,0.018,-.236,-.038,0.132,0.151,-.000,0.074,-.078,0.015,
     c 0.088,0.027,-.231,-.031,0.127,0.156,0.005,0.079,-.073,0.020,
     c 0.090,0.037,-.224,-.022,0.126,0.160,0.009,0.083,-.066,0.028,
     c 0.085,0.046,-.217,-.011,0.127,0.165,0.013,0.089,-.058,0.038,
     c 0.078,0.052,-.210,-.001,0.132,0.172,0.018,0.097,-.049,0.048,
     c 0.072,0.058,-.205,0.009,0.142,0.181,0.024,0.107,-.039,0.057,
     c 0.074,0.067,-.200,0.019,0.157,0.190,0.032,0.115,-.029,0.067,
     c 0.083,0.076,-.196,0.025,0.172,0.197,0.038,0.120,-.021,0.077,
     c 0.094,0.087,-.189,0.030,0.188,0.205,0.045,0.125,-.016,0.087,
     c 0.101,0.097,-.179,0.033,0.205,0.212,0.053,0.132,-.009,0.098,
     c 0.100,0.106,-.171,0.034,0.220,0.218,0.059,0.142,-.001,0.109,
     c 0.095,0.114,-.166,0.032,0.234,0.222,0.061,0.150,0.007,0.119,
     c 0.092,0.119,-.164,0.027,0.246,0.226,0.061,0.155,0.015,0.127,
     c 0.092,0.122,-.164,0.020,0.256,0.230,0.062,0.160,0.021,0.131,
     c 0.098,0.124,-.162,0.014,0.267,0.237,0.065,0.166,0.026,0.133,
     c 0.106,0.124,-.160,0.007,0.274,0.244,0.067,0.170,0.027,0.134,
     c 0.114,0.126,-.158,0.001,0.280,0.250,0.069,0.175,0.028,0.138,
     c 0.117,0.127,-.155,-.004,0.283,0.253,0.071,0.179,0.030,0.143,
     c 0.117,0.127,-.152,-.007,0.284,0.255,0.074,0.184,0.031,0.146,
     c 0.117,0.129,-.151,-.009,0.284,0.254,0.075,0.186,0.031,0.146,
     c 0.118,0.130,-.151,-.008,0.283,0.255,0.075,0.188,0.031,0.147,
     c 0.118,0.131,-.153,-.004,0.282,0.258,0.074,0.191,0.029,0.147,
     c 0.113,0.131,-.155,0.002,0.282,0.262,0.073,0.193,0.028,0.147,
     c 0.104,0.131,-.156,0.008,0.281,0.262,0.074,0.191,0.025,0.143,
     c 0.095,0.135,-.157,0.013,0.278,0.261,0.075,0.191,0.026,0.138,
     c 0.089,0.140,-.158,0.016,0.275,0.260,0.076,0.195,0.030,0.134,
     c 0.086,0.142,-.159,0.019,0.273,0.260,0.078,0.199,0.033,0.133,
     c 0.088,0.145,-.159,0.019,0.270,0.261,0.078,0.200,0.033,0.133,
     c 0.091,0.148,-.158,0.018,0.266,0.261,0.076,0.198,0.031,0.132,
     c 0.090,0.151,-.156,0.016,0.261,0.259,0.073,0.196,0.031,0.131,
     c 0.086,0.153,-.154,0.016,0.256,0.258,0.071,0.197,0.032,0.127,
     c 0.080,0.153,-.155,0.013,0.248,0.257,0.070,0.197,0.031,0.124,
     c 0.075,0.151,-.155,0.012,0.243,0.257,0.071,0.197,0.028,0.120,
     c 0.073,0.150,-.154,0.011,0.239,0.257,0.071,0.198,0.026,0.115,
     c 0.070,0.149,-.153,0.010,0.237,0.258,0.070,0.198,0.024,0.109,
     c 0.067,0.151,-.153,0.009,0.235,0.257,0.066,0.197,0.024,0.105,
     c 0.064,0.154,-.157,0.007,0.235,0.255,0.062,0.195,0.025,0.103,
     c 0.059,0.153,-.162,0.005,0.235,0.254,0.059,0.191,0.025,0.099,
     c 0.053,0.150,-.164,0.005,0.239,0.254,0.059,0.190,0.026,0.094,
     c 0.046,0.144,-.168,0.004,0.242,0.253,0.059,0.189,0.026,0.088,
     c 0.041,0.136,-.172,0.002,0.244,0.251,0.058,0.186,0.026,0.085,
     c 0.036,0.131,-.178,0.001,0.242,0.248,0.055,0.182,0.022,0.080,
     c 0.030,0.128,-.183,0.000,0.238,0.244,0.050,0.177,0.019,0.075,
     c 0.022,0.127,-.187,0.000,0.234,0.242,0.045,0.173,0.017,0.067,
     c 0.013,0.126,-.191,0.000,0.229,0.240,0.041,0.171,0.014,0.059,
     c 0.005,0.125,-.195,-.001,0.224,0.237,0.039,0.168,0.011,0.051,
     c -.001,0.128,-.199,-.001,0.219,0.235,0.038,0.167,0.009,0.044,
     c -.005,0.133,-.202,-.003,0.216,0.233,0.035,0.163,0.005,0.037,
     c -.007,0.138,-.204,-.004,0.214,0.232,0.032,0.158,0.001,0.029,
     c -.010,0.141,-.206,-.004,0.216,0.228,0.028,0.155,-.001,0.018,
     c -.015,0.142,-.207,-.004,0.216,0.225,0.028,0.153,-.004,0.009,
     c -.015,0.140,-.210,-.005,0.214,0.222,0.031,0.153,-.007,0.006,
     c -.012,0.138,-.212,-.006,0.211,0.220,0.032,0.151,-.012,0.008,
     c -.010,0.133,-.214,-.003,0.210,0.218,0.028,0.148,-.015,0.012,
     c -.010,0.127,-.214,0.003,0.210,0.218,0.020,0.147,-.016,0.013,
     c -.018,0.118,-.218,0.009,0.212,0.215,0.011,0.142,-.016,0.010,
     c -.020,0.110,-.220,0.014,0.213,0.213,0.004,0.139,-.017,0.008,
     c 0.101,-.004,-.231,0.029,0.209,0.155,0.009,0.073,-.072,0.029,
     c 0.091,-.002,-.233,0.015,0.200,0.152,0.005,0.070,-.074,0.023,
     c 0.076,0.000,-.236,0.000,0.193,0.149,-.001,0.067,-.078,0.015,
     c 0.065,0.003,-.238,-.015,0.182,0.147,-.006,0.066,-.081,0.009,
     c 0.062,0.004,-.239,-.026,0.170,0.144,-.010,0.066,-.081,0.008,
     c 0.067,0.007,-.240,-.034,0.159,0.143,-.011,0.067,-.082,0.009,
     c 0.076,0.011,-.238,-.038,0.150,0.146,-.008,0.070,-.081,0.011,
     c 0.080,0.015,-.236,-.039,0.140,0.149,-.003,0.073,-.080,0.013,
     c 0.081,0.023,-.233,-.036,0.133,0.153,0.001,0.077,-.077,0.015,
     c 0.082,0.031,-.228,-.028,0.128,0.158,0.005,0.081,-.071,0.020,
     c 0.083,0.041,-.221,-.018,0.127,0.162,0.010,0.086,-.063,0.027,
     c 0.080,0.049,-.214,-.007,0.128,0.167,0.015,0.094,-.054,0.037,
     c 0.074,0.055,-.207,0.004,0.134,0.175,0.021,0.103,-.044,0.047,
     c 0.068,0.061,-.201,0.014,0.145,0.184,0.028,0.112,-.034,0.055,
     c 0.069,0.069,-.196,0.024,0.160,0.193,0.036,0.120,-.025,0.063,
     c 0.079,0.077,-.192,0.030,0.175,0.201,0.042,0.123,-.018,0.071,
     c 0.091,0.087,-.185,0.034,0.190,0.208,0.048,0.127,-.013,0.079,
     c 0.101,0.097,-.176,0.037,0.207,0.216,0.055,0.134,-.006,0.090,
     c 0.103,0.106,-.167,0.037,0.223,0.221,0.061,0.144,0.002,0.102,
     c 0.100,0.115,-.162,0.035,0.238,0.225,0.064,0.153,0.010,0.112,
     c 0.097,0.121,-.159,0.030,0.250,0.229,0.065,0.159,0.018,0.122,
     c 0.098,0.126,-.158,0.023,0.259,0.233,0.066,0.165,0.025,0.127,
     c 0.104,0.129,-.155,0.016,0.269,0.240,0.070,0.172,0.030,0.130,
     c 0.112,0.129,-.153,0.009,0.276,0.248,0.073,0.176,0.032,0.132,
     c 0.119,0.132,-.151,0.002,0.281,0.253,0.074,0.180,0.033,0.136,
     c 0.122,0.133,-.149,-.004,0.284,0.256,0.076,0.184,0.034,0.141,
     c 0.120,0.132,-.147,-.008,0.285,0.258,0.077,0.187,0.034,0.143,
     c 0.119,0.131,-.147,-.011,0.285,0.258,0.077,0.189,0.033,0.143,
     c 0.118,0.129,-.148,-.012,0.283,0.258,0.076,0.191,0.032,0.143,
     c 0.116,0.128,-.151,-.009,0.282,0.261,0.076,0.194,0.030,0.146,
     c 0.110,0.128,-.152,-.004,0.284,0.264,0.076,0.197,0.030,0.148,
     c 0.102,0.128,-.154,0.002,0.283,0.264,0.078,0.195,0.028,0.147,
     c 0.094,0.133,-.154,0.007,0.282,0.263,0.079,0.194,0.029,0.143,
     c 0.088,0.139,-.155,0.011,0.280,0.263,0.081,0.197,0.032,0.140,
     c 0.086,0.141,-.156,0.015,0.278,0.264,0.082,0.201,0.035,0.138,
     c 0.087,0.144,-.157,0.017,0.275,0.265,0.081,0.202,0.035,0.138,
     c 0.089,0.146,-.156,0.017,0.270,0.265,0.079,0.200,0.034,0.137,
     c 0.089,0.148,-.155,0.016,0.264,0.262,0.075,0.199,0.034,0.136,
     c 0.084,0.150,-.153,0.016,0.257,0.260,0.073,0.201,0.035,0.135,
     c 0.078,0.150,-.152,0.015,0.249,0.259,0.071,0.202,0.035,0.133,
     c 0.074,0.150,-.151,0.013,0.243,0.259,0.072,0.201,0.033,0.130,
     c 0.072,0.151,-.150,0.012,0.241,0.260,0.072,0.201,0.031,0.124,
     c 0.071,0.151,-.149,0.012,0.239,0.260,0.070,0.200,0.029,0.118,
     c 0.069,0.153,-.151,0.010,0.237,0.258,0.065,0.199,0.029,0.115,
     c 0.065,0.156,-.155,0.007,0.236,0.257,0.061,0.196,0.028,0.113,
     c 0.061,0.156,-.160,0.004,0.236,0.255,0.058,0.191,0.028,0.109,
     c 0.056,0.154,-.163,0.002,0.239,0.256,0.058,0.190,0.029,0.104,
     c 0.049,0.148,-.167,-.001,0.241,0.255,0.059,0.188,0.028,0.096,
     c 0.043,0.140,-.171,-.004,0.242,0.252,0.057,0.185,0.026,0.090,
     c 0.036,0.135,-.177,-.005,0.240,0.249,0.054,0.181,0.023,0.084,
     c 0.029,0.130,-.182,-.006,0.237,0.245,0.048,0.177,0.020,0.078,
     c 0.021,0.127,-.187,-.005,0.234,0.243,0.044,0.173,0.018,0.071,
     c 0.013,0.125,-.191,-.004,0.230,0.241,0.041,0.171,0.016,0.064,
     c 0.006,0.124,-.195,-.004,0.226,0.238,0.039,0.168,0.013,0.056,
     c -.000,0.128,-.198,-.003,0.221,0.236,0.038,0.166,0.010,0.048,
     c -.003,0.133,-.201,-.004,0.218,0.233,0.035,0.162,0.006,0.040,
     c -.004,0.138,-.202,-.004,0.216,0.232,0.031,0.157,0.002,0.031,
     c -.007,0.140,-.204,-.002,0.217,0.229,0.027,0.153,-.001,0.019,
     c -.012,0.139,-.207,0.000,0.217,0.224,0.027,0.151,-.005,0.007,
     c -.014,0.136,-.210,0.001,0.214,0.220,0.030,0.150,-.009,0.001,
     c -.012,0.134,-.212,0.000,0.210,0.218,0.030,0.149,-.014,0.002,
     c -.011,0.131,-.214,0.002,0.208,0.215,0.025,0.146,-.017,0.006,
     c -.011,0.127,-.216,0.008,0.208,0.214,0.017,0.145,-.018,0.009,
     c -.018,0.119,-.219,0.013,0.210,0.212,0.008,0.141,-.018,0.006,
     c -.021,0.112,-.222,0.017,0.210,0.210,-.000,0.139,-.019,0.006,
     c 0.102,-.000,-.232,0.028,0.208,0.153,0.009,0.071,-.075,0.024,
     c 0.092,0.001,-.234,0.013,0.198,0.150,0.004,0.069,-.077,0.019,
     c 0.079,0.002,-.237,-.002,0.189,0.149,-.001,0.065,-.080,0.011,
     c 0.068,0.004,-.239,-.017,0.178,0.148,-.006,0.064,-.082,0.007,
     c 0.066,0.006,-.240,-.028,0.167,0.145,-.011,0.064,-.082,0.007,
     c 0.071,0.010,-.239,-.036,0.157,0.144,-.012,0.066,-.081,0.009,
     c 0.079,0.015,-.236,-.039,0.149,0.147,-.008,0.070,-.080,0.012,
     c 0.081,0.021,-.233,-.039,0.141,0.151,-.003,0.073,-.079,0.014,
     c 0.080,0.028,-.230,-.035,0.135,0.155,-.000,0.077,-.076,0.015,
     c 0.079,0.035,-.225,-.027,0.129,0.160,0.005,0.081,-.070,0.018,
     c 0.080,0.043,-.218,-.016,0.127,0.165,0.009,0.086,-.061,0.025,
     c 0.079,0.050,-.211,-.005,0.129,0.170,0.014,0.095,-.052,0.035,
     c 0.075,0.056,-.203,0.007,0.136,0.177,0.021,0.105,-.043,0.044,
     c 0.069,0.063,-.197,0.017,0.147,0.186,0.028,0.114,-.033,0.052,
     c 0.069,0.072,-.191,0.027,0.162,0.196,0.038,0.121,-.024,0.060,
     c 0.076,0.081,-.187,0.033,0.177,0.203,0.045,0.125,-.017,0.067,
     c 0.088,0.091,-.182,0.038,0.192,0.211,0.050,0.130,-.012,0.076,
     c 0.100,0.100,-.173,0.040,0.208,0.218,0.057,0.138,-.005,0.086,
     c 0.104,0.108,-.165,0.041,0.224,0.224,0.063,0.147,0.003,0.098,
     c 0.104,0.117,-.159,0.039,0.239,0.229,0.066,0.156,0.011,0.108,
     c 0.103,0.123,-.156,0.034,0.251,0.232,0.068,0.163,0.020,0.117,
     c 0.105,0.128,-.153,0.027,0.260,0.237,0.070,0.169,0.027,0.122,
     c 0.111,0.131,-.150,0.020,0.269,0.243,0.074,0.175,0.032,0.125,
     c 0.119,0.133,-.147,0.012,0.274,0.250,0.077,0.179,0.034,0.127,
     c 0.126,0.136,-.145,0.004,0.279,0.255,0.078,0.183,0.036,0.131,
     c 0.128,0.138,-.144,-.003,0.282,0.258,0.078,0.186,0.037,0.137,
     c 0.125,0.135,-.143,-.010,0.283,0.259,0.078,0.189,0.036,0.139,
     c 0.121,0.131,-.144,-.015,0.283,0.259,0.077,0.191,0.035,0.139,
     c 0.118,0.127,-.147,-.017,0.282,0.259,0.076,0.193,0.034,0.141,
     c 0.114,0.125,-.149,-.016,0.282,0.262,0.077,0.197,0.033,0.146,
     c 0.107,0.125,-.150,-.011,0.285,0.266,0.079,0.200,0.033,0.150,
     c 0.099,0.126,-.151,-.006,0.286,0.266,0.081,0.198,0.032,0.151,
     c 0.093,0.132,-.151,-.000,0.285,0.266,0.083,0.197,0.032,0.149,
     c 0.090,0.139,-.151,0.005,0.284,0.266,0.084,0.198,0.034,0.146,
     c 0.088,0.142,-.152,0.010,0.282,0.268,0.085,0.200,0.036,0.144,
     c 0.089,0.145,-.152,0.014,0.279,0.268,0.083,0.200,0.036,0.141,
     c 0.090,0.147,-.152,0.016,0.273,0.268,0.080,0.198,0.034,0.139,
     c 0.088,0.147,-.152,0.017,0.266,0.265,0.076,0.197,0.034,0.137,
     c 0.083,0.149,-.151,0.017,0.258,0.263,0.073,0.200,0.036,0.137,
     c 0.077,0.149,-.150,0.017,0.250,0.262,0.072,0.202,0.037,0.137,
     c 0.073,0.150,-.148,0.016,0.244,0.262,0.072,0.202,0.037,0.135,
     c 0.072,0.152,-.147,0.015,0.243,0.262,0.072,0.202,0.037,0.130,
     c 0.070,0.151,-.147,0.013,0.241,0.262,0.070,0.201,0.035,0.125,
     c 0.068,0.153,-.149,0.010,0.240,0.260,0.066,0.199,0.034,0.122,
     c 0.064,0.156,-.153,0.006,0.238,0.258,0.062,0.195,0.032,0.120,
     c 0.060,0.156,-.158,0.001,0.238,0.257,0.060,0.191,0.031,0.117,
     c 0.054,0.155,-.162,-.002,0.239,0.258,0.060,0.190,0.031,0.111,
     c 0.047,0.150,-.167,-.007,0.239,0.256,0.059,0.187,0.029,0.101,
     c 0.040,0.142,-.171,-.010,0.239,0.252,0.057,0.185,0.026,0.093,
     c 0.032,0.137,-.177,-.012,0.237,0.248,0.053,0.181,0.022,0.085,
     c 0.025,0.131,-.182,-.012,0.235,0.244,0.048,0.177,0.019,0.078,
     c 0.017,0.128,-.187,-.010,0.233,0.242,0.044,0.174,0.017,0.072,
     c 0.010,0.125,-.191,-.008,0.231,0.240,0.041,0.171,0.015,0.065,
     c 0.004,0.124,-.195,-.006,0.227,0.237,0.039,0.167,0.012,0.058,
     c -.001,0.127,-.198,-.003,0.223,0.235,0.038,0.164,0.009,0.050,
     c -.003,0.132,-.199,-.002,0.219,0.232,0.035,0.160,0.006,0.041,
     c -.003,0.136,-.200,-.001,0.218,0.230,0.031,0.155,0.001,0.031,
     c -.005,0.137,-.203,0.002,0.218,0.226,0.026,0.152,-.002,0.018,
     c -.011,0.134,-.207,0.005,0.217,0.221,0.025,0.149,-.007,0.006,
     c -.015,0.131,-.211,0.006,0.214,0.217,0.027,0.148,-.011,-.001,
     c -.014,0.130,-.214,0.006,0.210,0.214,0.027,0.146,-.016,-.001,
     c -.014,0.128,-.216,0.007,0.207,0.212,0.022,0.143,-.019,0.002,
     c -.015,0.125,-.218,0.011,0.207,0.211,0.014,0.142,-.020,0.005,
     c -.020,0.119,-.221,0.016,0.207,0.209,0.005,0.139,-.020,0.003,
     c -.023,0.113,-.224,0.019,0.206,0.206,-.003,0.136,-.020,0.002,
     c 0.104,0.004,-.232,0.026,0.204,0.150,0.009,0.069,-.077,0.019,
     c 0.094,0.005,-.233,0.012,0.194,0.148,0.004,0.067,-.078,0.016,
     c 0.080,0.005,-.237,-.004,0.185,0.148,-.002,0.062,-.082,0.009,
     c 0.070,0.007,-.239,-.018,0.173,0.146,-.007,0.060,-.084,0.006,
     c 0.067,0.009,-.238,-.029,0.164,0.144,-.011,0.061,-.083,0.008,
     c 0.072,0.014,-.236,-.036,0.155,0.144,-.012,0.064,-.081,0.011,
     c 0.080,0.021,-.233,-.039,0.149,0.147,-.008,0.068,-.080,0.014,
     c 0.081,0.027,-.230,-.038,0.141,0.152,-.003,0.072,-.079,0.015,
     c 0.079,0.033,-.228,-.034,0.134,0.156,-.000,0.075,-.075,0.016,
     c 0.078,0.038,-.223,-.025,0.129,0.161,0.003,0.078,-.069,0.019,
     c 0.080,0.044,-.216,-.014,0.127,0.166,0.006,0.084,-.061,0.026,
     c 0.080,0.051,-.208,-.002,0.131,0.171,0.011,0.093,-.052,0.034,
     c 0.078,0.057,-.200,0.009,0.138,0.178,0.018,0.104,-.044,0.043,
     c 0.072,0.066,-.193,0.019,0.149,0.186,0.025,0.113,-.036,0.051,
     c 0.070,0.076,-.188,0.028,0.164,0.196,0.035,0.120,-.027,0.059,
     c 0.075,0.086,-.184,0.035,0.178,0.204,0.043,0.125,-.019,0.066,
     c 0.086,0.096,-.179,0.039,0.192,0.213,0.050,0.131,-.013,0.074,
     c 0.098,0.105,-.172,0.042,0.208,0.220,0.056,0.140,-.006,0.084,
     c 0.105,0.112,-.165,0.043,0.224,0.226,0.063,0.150,0.001,0.095,
     c 0.107,0.119,-.160,0.042,0.238,0.231,0.066,0.158,0.010,0.104,
     c 0.107,0.124,-.155,0.038,0.250,0.235,0.069,0.165,0.019,0.112,
     c 0.110,0.129,-.151,0.033,0.258,0.239,0.072,0.171,0.026,0.117,
     c 0.116,0.133,-.147,0.026,0.266,0.245,0.077,0.176,0.032,0.119,
     c 0.123,0.136,-.144,0.017,0.271,0.251,0.079,0.179,0.034,0.121,
     c 0.130,0.140,-.142,0.007,0.275,0.255,0.080,0.183,0.036,0.125,
     c 0.133,0.142,-.140,-.002,0.278,0.258,0.080,0.186,0.038,0.132,
     c 0.131,0.137,-.140,-.010,0.280,0.259,0.079,0.189,0.038,0.136,
     c 0.126,0.132,-.142,-.017,0.281,0.260,0.078,0.192,0.037,0.137,
     c 0.120,0.127,-.145,-.022,0.282,0.261,0.078,0.195,0.037,0.139,
     c 0.114,0.126,-.147,-.023,0.283,0.265,0.080,0.200,0.036,0.145,
     c 0.105,0.126,-.147,-.019,0.287,0.268,0.083,0.204,0.037,0.151,
     c 0.099,0.129,-.147,-.014,0.288,0.269,0.086,0.202,0.036,0.153,
     c 0.095,0.135,-.146,-.008,0.289,0.269,0.087,0.200,0.036,0.152,
     c 0.094,0.142,-.145,-.002,0.288,0.270,0.087,0.200,0.036,0.150,
     c 0.094,0.146,-.146,0.004,0.286,0.271,0.087,0.200,0.037,0.148,
     c 0.094,0.149,-.147,0.010,0.282,0.272,0.084,0.198,0.036,0.144,
     c 0.094,0.150,-.148,0.015,0.276,0.272,0.080,0.196,0.033,0.141,
     c 0.091,0.149,-.149,0.018,0.268,0.269,0.076,0.195,0.033,0.139,
     c 0.086,0.149,-.149,0.020,0.260,0.266,0.074,0.198,0.036,0.140,
     c 0.080,0.148,-.149,0.019,0.252,0.264,0.073,0.201,0.038,0.142,
     c 0.076,0.150,-.147,0.019,0.247,0.264,0.073,0.202,0.040,0.141,
     c 0.074,0.152,-.146,0.017,0.245,0.264,0.073,0.202,0.041,0.137,
     c 0.072,0.151,-.146,0.015,0.243,0.264,0.071,0.202,0.039,0.131,
     c 0.068,0.152,-.148,0.011,0.241,0.261,0.067,0.199,0.037,0.128,
     c 0.062,0.154,-.152,0.006,0.240,0.258,0.063,0.195,0.035,0.127,
     c 0.056,0.154,-.157,-.001,0.238,0.257,0.062,0.191,0.034,0.125,
     c 0.050,0.153,-.161,-.006,0.238,0.258,0.061,0.190,0.033,0.118,
     c 0.042,0.148,-.167,-.011,0.237,0.256,0.060,0.187,0.029,0.107,
     c 0.035,0.142,-.172,-.015,0.236,0.251,0.057,0.184,0.026,0.096,
     c 0.027,0.137,-.177,-.017,0.234,0.247,0.052,0.181,0.021,0.086,
     c 0.021,0.131,-.182,-.016,0.233,0.242,0.047,0.177,0.018,0.077,
     c 0.014,0.128,-.187,-.013,0.232,0.240,0.043,0.173,0.015,0.071,
     c 0.009,0.125,-.191,-.010,0.231,0.238,0.040,0.169,0.012,0.065,
     c 0.004,0.124,-.195,-.006,0.227,0.235,0.039,0.165,0.010,0.057,
     c -.001,0.127,-.197,-.002,0.223,0.233,0.037,0.162,0.007,0.049,
     c -.003,0.131,-.199,0.001,0.220,0.230,0.034,0.158,0.004,0.040,
     c -.003,0.134,-.200,0.004,0.219,0.228,0.030,0.155,-.000,0.030,
     c -.005,0.134,-.203,0.007,0.219,0.224,0.024,0.151,-.004,0.018,
     c -.012,0.130,-.208,0.010,0.218,0.218,0.023,0.148,-.009,0.005,
     c -.016,0.127,-.212,0.012,0.215,0.214,0.025,0.146,-.014,-.003,
     c -.017,0.127,-.215,0.011,0.211,0.211,0.024,0.144,-.018,-.004,
     c -.017,0.126,-.218,0.012,0.207,0.208,0.018,0.141,-.021,-.002,
     c -.018,0.124,-.220,0.015,0.206,0.207,0.011,0.139,-.022,0.001,
     c -.024,0.119,-.224,0.018,0.205,0.205,0.002,0.137,-.022,-.001,
     c -.026,0.114,-.227,0.020,0.203,0.202,-.006,0.134,-.023,-.000,
     c 0.104,0.011,-.232,0.024,0.199,0.148,0.008,0.068,-.078,0.014,
     c 0.095,0.010,-.233,0.010,0.190,0.147,0.003,0.066,-.078,0.013,
     c 0.083,0.008,-.235,-.005,0.180,0.145,-.003,0.060,-.081,0.010,
     c 0.072,0.009,-.236,-.019,0.170,0.145,-.008,0.058,-.083,0.009,
     c 0.068,0.011,-.235,-.030,0.161,0.143,-.011,0.059,-.082,0.011,
     c 0.072,0.018,-.233,-.036,0.154,0.143,-.011,0.063,-.080,0.013,
     c 0.079,0.026,-.230,-.038,0.148,0.148,-.007,0.067,-.078,0.016,
     c 0.081,0.033,-.227,-.036,0.141,0.152,-.003,0.072,-.076,0.016,
     c 0.079,0.038,-.225,-.031,0.135,0.157,-.001,0.075,-.073,0.017,
     c 0.077,0.042,-.220,-.022,0.129,0.161,0.001,0.078,-.068,0.021,
     c 0.079,0.046,-.213,-.011,0.128,0.166,0.004,0.083,-.060,0.027,
     c 0.080,0.052,-.206,0.001,0.132,0.172,0.007,0.093,-.051,0.035,
     c 0.079,0.059,-.198,0.011,0.140,0.178,0.014,0.103,-.044,0.043,
     c 0.075,0.068,-.192,0.020,0.151,0.186,0.021,0.112,-.037,0.051,
     c 0.073,0.079,-.187,0.028,0.165,0.196,0.031,0.118,-.029,0.059,
     c 0.076,0.089,-.184,0.035,0.178,0.204,0.040,0.124,-.021,0.066,
     c 0.086,0.099,-.179,0.040,0.191,0.213,0.047,0.131,-.015,0.073,
     c 0.098,0.107,-.174,0.044,0.206,0.221,0.054,0.140,-.008,0.081,
     c 0.105,0.113,-.167,0.046,0.221,0.227,0.061,0.149,0.000,0.090,
     c 0.107,0.119,-.162,0.046,0.235,0.232,0.065,0.158,0.008,0.098,
     c 0.108,0.124,-.157,0.044,0.247,0.235,0.068,0.164,0.017,0.105,
     c 0.110,0.129,-.152,0.040,0.255,0.239,0.072,0.171,0.025,0.110,
     c 0.116,0.135,-.146,0.033,0.263,0.244,0.078,0.176,0.031,0.113,
     c 0.122,0.139,-.142,0.024,0.267,0.250,0.080,0.179,0.034,0.115,
     c 0.129,0.144,-.140,0.012,0.272,0.254,0.080,0.182,0.036,0.120,
     c 0.133,0.145,-.138,0.001,0.275,0.258,0.081,0.186,0.038,0.128,
     c 0.134,0.141,-.137,-.010,0.278,0.260,0.081,0.190,0.039,0.133,
     c 0.130,0.135,-.138,-.019,0.280,0.261,0.081,0.193,0.039,0.135,
     c 0.123,0.130,-.141,-.026,0.283,0.263,0.082,0.198,0.040,0.139,
     c 0.115,0.129,-.144,-.029,0.285,0.267,0.084,0.204,0.041,0.145,
     c 0.106,0.132,-.144,-.027,0.289,0.271,0.088,0.209,0.042,0.151,
     c 0.100,0.135,-.143,-.023,0.292,0.273,0.091,0.209,0.041,0.154,
     c 0.098,0.142,-.141,-.017,0.292,0.273,0.093,0.206,0.041,0.153,
     c 0.100,0.150,-.140,-.009,0.292,0.274,0.093,0.205,0.041,0.152,
     c 0.101,0.153,-.141,-.001,0.289,0.275,0.091,0.203,0.040,0.151,
     c 0.101,0.156,-.142,0.007,0.285,0.275,0.087,0.200,0.038,0.148,
     c 0.100,0.156,-.144,0.014,0.279,0.275,0.084,0.197,0.035,0.145,
     c 0.097,0.152,-.146,0.018,0.272,0.272,0.080,0.195,0.034,0.145,
     c 0.092,0.150,-.147,0.021,0.264,0.270,0.078,0.198,0.037,0.147,
     c 0.086,0.148,-.148,0.022,0.255,0.268,0.076,0.201,0.039,0.150,
     c 0.082,0.150,-.147,0.020,0.249,0.267,0.077,0.203,0.042,0.150,
     c 0.079,0.152,-.146,0.018,0.246,0.266,0.076,0.203,0.043,0.145,
     c 0.075,0.151,-.146,0.015,0.244,0.265,0.073,0.202,0.040,0.139,
     c 0.070,0.151,-.147,0.010,0.242,0.262,0.069,0.199,0.038,0.135,
     c 0.063,0.152,-.151,0.004,0.240,0.259,0.066,0.196,0.036,0.134,
     c 0.055,0.151,-.156,-.003,0.237,0.258,0.063,0.192,0.035,0.131,
     c 0.046,0.150,-.161,-.009,0.236,0.257,0.062,0.190,0.034,0.123,
     c 0.037,0.145,-.168,-.014,0.235,0.255,0.060,0.187,0.030,0.111,
     c 0.030,0.140,-.173,-.018,0.234,0.250,0.056,0.184,0.025,0.098,
     c 0.023,0.135,-.178,-.019,0.232,0.245,0.051,0.180,0.019,0.086,
     c 0.017,0.130,-.182,-.017,0.231,0.240,0.046,0.176,0.015,0.076,
     c 0.012,0.127,-.186,-.014,0.232,0.238,0.042,0.170,0.011,0.069,
     c 0.008,0.125,-.190,-.009,0.230,0.236,0.039,0.166,0.009,0.063,
     c 0.003,0.123,-.194,-.004,0.227,0.233,0.037,0.162,0.007,0.055,
     c -.001,0.126,-.197,0.002,0.223,0.231,0.035,0.160,0.005,0.047,
     c -.004,0.129,-.199,0.006,0.221,0.228,0.032,0.157,0.002,0.038,
     c -.003,0.131,-.200,0.009,0.219,0.226,0.028,0.154,-.002,0.028,
     c -.006,0.130,-.204,0.012,0.220,0.221,0.023,0.150,-.006,0.017,
     c -.013,0.126,-.209,0.016,0.219,0.215,0.021,0.147,-.012,0.004,
     c -.018,0.122,-.213,0.017,0.216,0.211,0.022,0.145,-.016,-.003,
     c -.019,0.123,-.217,0.017,0.211,0.207,0.020,0.142,-.020,-.006,
     c -.020,0.123,-.220,0.017,0.207,0.204,0.015,0.138,-.023,-.005,
     c -.022,0.122,-.222,0.019,0.204,0.203,0.007,0.136,-.024,-.004,
     c -.027,0.118,-.226,0.020,0.202,0.201,-.001,0.134,-.024,-.004,
     c -.030,0.115,-.230,0.022,0.200,0.199,-.008,0.132,-.024,-.004,
     c 0.105,0.017,-.230,0.022,0.192,0.146,0.006,0.067,-.078,0.011,
     c 0.096,0.015,-.232,0.009,0.184,0.145,0.002,0.065,-.078,0.011,
     c 0.084,0.012,-.234,-.006,0.175,0.142,-.005,0.060,-.079,0.011,
     c 0.074,0.011,-.234,-.019,0.166,0.143,-.009,0.059,-.080,0.011,
     c 0.069,0.013,-.233,-.030,0.159,0.143,-.011,0.060,-.079,0.013,
     c 0.072,0.020,-.232,-.035,0.153,0.144,-.010,0.063,-.077,0.013,
     c 0.079,0.029,-.228,-.036,0.148,0.149,-.006,0.067,-.074,0.014,
     c 0.081,0.037,-.225,-.033,0.142,0.154,-.002,0.072,-.073,0.015,
     c 0.079,0.042,-.223,-.027,0.137,0.158,-.001,0.076,-.070,0.016,
     c 0.077,0.045,-.217,-.018,0.132,0.162,-.000,0.080,-.065,0.021,
     c 0.078,0.048,-.211,-.007,0.132,0.166,0.002,0.085,-.058,0.026,
     c 0.080,0.054,-.204,0.005,0.136,0.171,0.005,0.095,-.050,0.033,
     c 0.080,0.061,-.197,0.014,0.144,0.177,0.011,0.105,-.042,0.041,
     c 0.077,0.070,-.192,0.021,0.154,0.184,0.018,0.112,-.036,0.049,
     c 0.076,0.080,-.188,0.029,0.166,0.194,0.028,0.117,-.028,0.058,
     c 0.080,0.089,-.185,0.035,0.178,0.203,0.036,0.122,-.021,0.064,
     c 0.089,0.098,-.181,0.040,0.190,0.212,0.043,0.130,-.015,0.070,
     c 0.100,0.105,-.175,0.044,0.204,0.220,0.051,0.140,-.007,0.077,
     c 0.105,0.111,-.170,0.048,0.218,0.226,0.058,0.148,0.001,0.084,
     c 0.107,0.117,-.164,0.051,0.231,0.231,0.062,0.157,0.009,0.091,
     c 0.109,0.122,-.158,0.051,0.242,0.234,0.067,0.165,0.017,0.099,
     c 0.111,0.128,-.152,0.048,0.252,0.238,0.072,0.172,0.025,0.104,
     c 0.115,0.136,-.146,0.042,0.260,0.243,0.078,0.177,0.031,0.109,
     c 0.120,0.142,-.141,0.031,0.264,0.249,0.081,0.180,0.033,0.111,
     c 0.126,0.147,-.138,0.018,0.269,0.254,0.081,0.183,0.036,0.116,
     c 0.130,0.149,-.134,0.005,0.274,0.258,0.082,0.187,0.039,0.124,
     c 0.133,0.144,-.133,-.008,0.277,0.261,0.082,0.190,0.040,0.129,
     c 0.132,0.139,-.134,-.019,0.281,0.264,0.083,0.194,0.041,0.132,
     c 0.126,0.135,-.137,-.029,0.284,0.266,0.084,0.200,0.043,0.136,
     c 0.117,0.135,-.140,-.035,0.286,0.270,0.088,0.207,0.044,0.142,
     c 0.108,0.139,-.140,-.035,0.291,0.274,0.092,0.214,0.047,0.149,
     c 0.102,0.143,-.139,-.032,0.295,0.277,0.096,0.215,0.047,0.152,
     c 0.102,0.150,-.137,-.025,0.296,0.278,0.098,0.213,0.047,0.153,
     c 0.105,0.156,-.136,-.017,0.295,0.278,0.098,0.212,0.046,0.153,
     c 0.107,0.159,-.137,-.008,0.293,0.278,0.096,0.209,0.045,0.153,
     c 0.108,0.161,-.138,0.002,0.288,0.278,0.093,0.205,0.043,0.152,
     c 0.108,0.161,-.140,0.011,0.282,0.278,0.090,0.201,0.039,0.150,
     c 0.106,0.156,-.143,0.017,0.276,0.275,0.086,0.199,0.037,0.150,
     c 0.102,0.152,-.145,0.021,0.269,0.274,0.084,0.201,0.039,0.153,
     c 0.095,0.149,-.146,0.022,0.260,0.272,0.082,0.203,0.041,0.156,
     c 0.090,0.151,-.146,0.020,0.253,0.270,0.081,0.205,0.043,0.157,
     c 0.085,0.153,-.146,0.017,0.249,0.269,0.079,0.205,0.043,0.152,
     c 0.079,0.152,-.146,0.013,0.245,0.267,0.076,0.203,0.039,0.145,
     c 0.072,0.151,-.147,0.008,0.242,0.263,0.071,0.200,0.036,0.139,
     c 0.064,0.152,-.150,0.001,0.240,0.261,0.067,0.197,0.035,0.138,
     c 0.055,0.150,-.155,-.005,0.237,0.258,0.064,0.193,0.035,0.134,
     c 0.046,0.147,-.161,-.011,0.236,0.257,0.061,0.190,0.034,0.125,
     c 0.035,0.143,-.168,-.016,0.234,0.253,0.058,0.186,0.029,0.111,
     c 0.027,0.137,-.174,-.020,0.233,0.248,0.054,0.183,0.023,0.098,
     c 0.020,0.133,-.179,-.020,0.231,0.243,0.050,0.179,0.017,0.085,
     c 0.015,0.129,-.183,-.018,0.231,0.238,0.045,0.174,0.012,0.074,
     c 0.010,0.126,-.186,-.014,0.231,0.236,0.041,0.168,0.008,0.066,
     c 0.007,0.124,-.190,-.008,0.230,0.233,0.038,0.163,0.006,0.061,
     c 0.003,0.123,-.194,-.002,0.226,0.231,0.035,0.159,0.004,0.053,
     c -.001,0.124,-.196,0.005,0.223,0.229,0.033,0.158,0.003,0.045,
     c -.004,0.127,-.199,0.010,0.221,0.226,0.030,0.156,-.000,0.037,
     c -.004,0.128,-.201,0.013,0.220,0.223,0.027,0.153,-.004,0.027,
     c -.007,0.127,-.205,0.017,0.221,0.218,0.021,0.150,-.008,0.016,
     c -.013,0.122,-.210,0.021,0.220,0.212,0.019,0.146,-.014,0.004,
     c -.019,0.118,-.215,0.023,0.217,0.208,0.019,0.143,-.018,-.004,
     c -.022,0.119,-.218,0.022,0.211,0.204,0.017,0.140,-.022,-.008,
     c -.024,0.120,-.222,0.022,0.206,0.200,0.011,0.135,-.025,-.010,
     c -.025,0.121,-.225,0.023,0.203,0.199,0.004,0.133,-.026,-.008,
     c -.030,0.118,-.229,0.023,0.200,0.198,-.004,0.132,-.026,-.007,
     c -.033,0.116,-.233,0.023,0.197,0.195,-.011,0.129,-.026,-.007,
     c 0.106,0.023,-.229,0.020,0.185,0.145,0.005,0.066,-.078,0.009,
     c 0.097,0.020,-.230,0.008,0.178,0.145,0.001,0.065,-.077,0.010,
     c 0.087,0.016,-.232,-.007,0.170,0.142,-.006,0.061,-.077,0.012,
     c 0.077,0.013,-.233,-.020,0.161,0.143,-.010,0.060,-.078,0.013,
     c 0.072,0.014,-.233,-.029,0.156,0.144,-.010,0.062,-.076,0.013,
     c 0.073,0.020,-.231,-.034,0.152,0.147,-.008,0.064,-.074,0.010,
     c 0.079,0.029,-.227,-.033,0.149,0.153,-.005,0.067,-.072,0.010,
     c 0.081,0.037,-.224,-.030,0.145,0.157,-.002,0.071,-.071,0.011,
     c 0.079,0.042,-.220,-.023,0.141,0.160,-.000,0.076,-.068,0.013,
     c 0.077,0.045,-.215,-.013,0.137,0.163,0.001,0.081,-.065,0.018,
     c 0.079,0.049,-.208,-.001,0.138,0.166,0.003,0.088,-.057,0.022,
     c 0.082,0.054,-.202,0.009,0.143,0.170,0.005,0.098,-.049,0.026,
     c 0.083,0.061,-.197,0.017,0.150,0.176,0.010,0.107,-.041,0.033,
     c 0.081,0.070,-.193,0.023,0.157,0.183,0.016,0.113,-.035,0.043,
     c 0.081,0.079,-.189,0.030,0.167,0.192,0.025,0.117,-.029,0.053,
     c 0.084,0.087,-.186,0.035,0.177,0.200,0.033,0.121,-.022,0.060,
     c 0.091,0.095,-.181,0.040,0.188,0.209,0.040,0.129,-.015,0.066,
     c 0.100,0.101,-.176,0.046,0.201,0.217,0.049,0.139,-.006,0.072,
     c 0.104,0.107,-.170,0.051,0.214,0.224,0.056,0.148,0.003,0.079,
     c 0.108,0.114,-.163,0.056,0.226,0.229,0.062,0.157,0.012,0.086,
     c 0.111,0.120,-.156,0.058,0.237,0.234,0.067,0.166,0.021,0.094,
     c 0.115,0.128,-.150,0.056,0.247,0.239,0.074,0.174,0.028,0.102,
     c 0.118,0.137,-.144,0.050,0.256,0.245,0.080,0.180,0.033,0.107,
     c 0.120,0.144,-.139,0.038,0.262,0.251,0.083,0.183,0.035,0.110,
     c 0.123,0.150,-.135,0.024,0.267,0.256,0.083,0.185,0.038,0.114,
     c 0.127,0.151,-.131,0.008,0.272,0.260,0.084,0.188,0.040,0.120,
     c 0.131,0.148,-.130,-.006,0.276,0.263,0.084,0.191,0.041,0.124,
     c 0.132,0.144,-.130,-.019,0.280,0.265,0.084,0.194,0.042,0.126,
     c 0.128,0.140,-.133,-.031,0.283,0.267,0.086,0.200,0.045,0.130,
     c 0.120,0.141,-.136,-.040,0.286,0.271,0.090,0.208,0.047,0.137,
     c 0.111,0.146,-.136,-.042,0.292,0.276,0.095,0.216,0.051,0.144,
     c 0.106,0.150,-.135,-.040,0.297,0.279,0.099,0.218,0.052,0.148,
     c 0.106,0.155,-.133,-.035,0.299,0.281,0.102,0.218,0.052,0.150,
     c 0.110,0.159,-.133,-.026,0.298,0.281,0.102,0.216,0.051,0.151,
     c 0.112,0.161,-.133,-.016,0.295,0.281,0.100,0.213,0.050,0.151,
     c 0.113,0.163,-.135,-.004,0.291,0.280,0.097,0.209,0.047,0.150,
     c 0.114,0.163,-.137,0.006,0.286,0.280,0.095,0.206,0.042,0.148,
     c 0.113,0.159,-.140,0.014,0.280,0.278,0.092,0.203,0.040,0.147,
     c 0.109,0.155,-.142,0.020,0.274,0.278,0.089,0.205,0.041,0.149,
     c 0.103,0.152,-.144,0.020,0.266,0.276,0.087,0.206,0.043,0.153,
     c 0.097,0.153,-.144,0.018,0.258,0.274,0.086,0.207,0.043,0.155,
     c 0.090,0.154,-.145,0.014,0.252,0.271,0.083,0.207,0.042,0.152,
     c 0.082,0.152,-.146,0.009,0.246,0.268,0.078,0.204,0.038,0.146,
     c 0.074,0.152,-.147,0.003,0.243,0.264,0.073,0.201,0.034,0.141,
     c 0.065,0.151,-.150,-.003,0.240,0.262,0.069,0.198,0.033,0.138,
     c 0.056,0.149,-.155,-.008,0.237,0.259,0.065,0.193,0.033,0.133,
     c 0.046,0.146,-.161,-.013,0.236,0.256,0.061,0.190,0.032,0.123,
     c 0.034,0.141,-.169,-.018,0.234,0.251,0.057,0.186,0.027,0.109,
     c 0.025,0.135,-.175,-.021,0.233,0.246,0.053,0.182,0.021,0.095,
     c 0.018,0.131,-.180,-.021,0.230,0.241,0.048,0.178,0.014,0.082,
     c 0.013,0.127,-.183,-.018,0.230,0.236,0.044,0.172,0.009,0.072,
     c 0.009,0.124,-.187,-.013,0.231,0.234,0.040,0.166,0.005,0.064,
     c 0.006,0.123,-.190,-.007,0.230,0.231,0.036,0.161,0.003,0.058,
     c 0.002,0.122,-.194,0.000,0.226,0.228,0.033,0.157,0.001,0.051,
     c -.002,0.123,-.196,0.009,0.223,0.227,0.032,0.156,0.001,0.044,
     c -.004,0.125,-.198,0.014,0.221,0.224,0.029,0.154,-.001,0.035,
     c -.005,0.126,-.201,0.018,0.220,0.221,0.026,0.152,-.005,0.026,
     c -.007,0.123,-.206,0.023,0.222,0.216,0.020,0.149,-.010,0.015,
     c -.014,0.118,-.211,0.026,0.222,0.210,0.017,0.145,-.016,0.003,
     c -.021,0.113,-.216,0.028,0.218,0.204,0.016,0.142,-.021,-.005,
     c -.024,0.115,-.219,0.027,0.212,0.200,0.013,0.138,-.024,-.011,
     c -.027,0.118,-.223,0.027,0.205,0.197,0.007,0.132,-.027,-.014,
     c -.029,0.120,-.227,0.027,0.201,0.196,-.000,0.130,-.028,-.012,
     c -.033,0.118,-.232,0.025,0.198,0.194,-.006,0.129,-.028,-.010,
     c -.036,0.117,-.236,0.024,0.194,0.192,-.013,0.127,-.028,-.010,
     c 0.105,0.028,-.226,0.019,0.177,0.146,0.003,0.066,-.077,0.009,
     c 0.097,0.024,-.228,0.007,0.171,0.145,-.000,0.066,-.077,0.010,
     c 0.089,0.021,-.230,-.007,0.163,0.143,-.007,0.063,-.076,0.011,
     c 0.081,0.017,-.232,-.020,0.156,0.144,-.010,0.064,-.076,0.012,
     c 0.075,0.016,-.232,-.029,0.152,0.146,-.009,0.065,-.074,0.011,
     c 0.076,0.022,-.230,-.033,0.150,0.150,-.008,0.066,-.073,0.007,
     c 0.081,0.030,-.225,-.031,0.150,0.155,-.004,0.068,-.071,0.007,
     c 0.082,0.037,-.221,-.026,0.148,0.160,-.002,0.071,-.070,0.009,
     c 0.080,0.042,-.217,-.018,0.145,0.162,-.000,0.076,-.069,0.012,
     c 0.078,0.044,-.212,-.008,0.143,0.165,0.002,0.082,-.065,0.015,
     c 0.080,0.047,-.207,0.004,0.145,0.166,0.003,0.089,-.058,0.017,
     c 0.085,0.053,-.202,0.013,0.149,0.169,0.005,0.100,-.050,0.019,
     c 0.088,0.060,-.198,0.021,0.154,0.174,0.009,0.108,-.042,0.025,
     c 0.087,0.069,-.195,0.026,0.160,0.180,0.013,0.113,-.037,0.035,
     c 0.085,0.078,-.191,0.031,0.167,0.188,0.022,0.116,-.031,0.047,
     c 0.087,0.085,-.187,0.036,0.176,0.195,0.029,0.120,-.025,0.055,
     c 0.093,0.093,-.181,0.041,0.186,0.204,0.037,0.128,-.017,0.062,
     c 0.101,0.099,-.175,0.048,0.198,0.213,0.046,0.137,-.006,0.070,
     c 0.106,0.106,-.168,0.055,0.210,0.221,0.055,0.147,0.004,0.077,
     c 0.111,0.114,-.161,0.061,0.222,0.229,0.061,0.157,0.015,0.085,
     c 0.118,0.122,-.153,0.065,0.233,0.235,0.068,0.167,0.024,0.093,
     c 0.123,0.130,-.147,0.064,0.244,0.242,0.076,0.177,0.031,0.101,
     c 0.127,0.140,-.141,0.056,0.253,0.249,0.083,0.184,0.037,0.107,
     c 0.126,0.147,-.137,0.042,0.259,0.255,0.087,0.187,0.039,0.109,
     c 0.126,0.152,-.133,0.026,0.266,0.259,0.087,0.189,0.041,0.112,
     c 0.127,0.153,-.129,0.010,0.271,0.262,0.087,0.191,0.042,0.115,
     c 0.131,0.150,-.127,-.005,0.275,0.264,0.086,0.192,0.043,0.117,
     c 0.134,0.148,-.127,-.020,0.278,0.266,0.086,0.195,0.044,0.118,
     c 0.131,0.145,-.130,-.033,0.281,0.267,0.087,0.199,0.046,0.122,
     c 0.123,0.146,-.132,-.043,0.284,0.271,0.091,0.207,0.049,0.128,
     c 0.115,0.151,-.133,-.048,0.291,0.277,0.096,0.214,0.053,0.137,
     c 0.111,0.154,-.132,-.048,0.297,0.281,0.100,0.217,0.054,0.142,
     c 0.111,0.157,-.130,-.043,0.300,0.282,0.103,0.217,0.054,0.146,
     c 0.113,0.159,-.130,-.035,0.300,0.282,0.103,0.217,0.054,0.147,
     c 0.114,0.159,-.130,-.024,0.298,0.282,0.101,0.214,0.052,0.148,
     c 0.114,0.162,-.132,-.012,0.294,0.281,0.099,0.211,0.049,0.146,
     c 0.116,0.164,-.134,0.000,0.290,0.281,0.097,0.208,0.044,0.143,
     c 0.116,0.162,-.136,0.010,0.285,0.280,0.094,0.206,0.041,0.139,
     c 0.113,0.160,-.138,0.016,0.280,0.280,0.092,0.206,0.042,0.139,
     c 0.108,0.157,-.140,0.017,0.272,0.279,0.089,0.207,0.043,0.143,
     c 0.101,0.157,-.141,0.015,0.264,0.277,0.088,0.208,0.044,0.146,
     c 0.093,0.156,-.144,0.011,0.256,0.273,0.085,0.207,0.042,0.146,
     c 0.082,0.153,-.145,0.005,0.249,0.270,0.080,0.204,0.036,0.142,
     c 0.073,0.151,-.148,-.002,0.244,0.265,0.075,0.200,0.032,0.138,
     c 0.065,0.150,-.152,-.008,0.241,0.262,0.070,0.198,0.031,0.136,
     c 0.056,0.147,-.156,-.012,0.238,0.259,0.065,0.193,0.031,0.131,
     c 0.046,0.144,-.161,-.015,0.236,0.255,0.061,0.189,0.030,0.120,
     c 0.033,0.139,-.169,-.019,0.234,0.250,0.056,0.184,0.025,0.106,
     c 0.023,0.133,-.176,-.022,0.232,0.244,0.051,0.181,0.018,0.093,
     c 0.015,0.129,-.181,-.022,0.230,0.239,0.047,0.177,0.012,0.080,
     c 0.010,0.125,-.184,-.018,0.230,0.234,0.042,0.170,0.006,0.070,
     c 0.007,0.123,-.187,-.013,0.230,0.232,0.038,0.163,0.002,0.062,
     c 0.005,0.122,-.190,-.006,0.229,0.229,0.034,0.158,0.000,0.056,
     c 0.002,0.121,-.193,0.003,0.226,0.226,0.031,0.154,-.001,0.049,
     c -.002,0.122,-.196,0.012,0.223,0.225,0.030,0.154,-.002,0.042,
     c -.004,0.123,-.198,0.018,0.221,0.222,0.027,0.153,-.003,0.034,
     c -.005,0.123,-.201,0.023,0.221,0.219,0.024,0.151,-.007,0.025,
     c -.008,0.119,-.207,0.028,0.223,0.213,0.018,0.148,-.012,0.014,
     c -.015,0.114,-.212,0.032,0.223,0.207,0.015,0.144,-.018,0.003,
     c -.022,0.109,-.216,0.033,0.219,0.201,0.013,0.141,-.023,-.006,
     c -.026,0.112,-.221,0.033,0.212,0.197,0.010,0.136,-.027,-.013,
     c -.030,0.115,-.225,0.032,0.205,0.193,0.003,0.130,-.029,-.018,
     c -.032,0.118,-.229,0.030,0.200,0.192,-.003,0.128,-.030,-.017,
     c -.036,0.117,-.234,0.027,0.196,0.191,-.009,0.127,-.030,-.013,
     c -.039,0.117,-.239,0.024,0.191,0.189,-.015,0.125,-.030,-.012,
     c 0.103,0.031,-.224,0.018,0.168,0.147,0.002,0.068,-.076,0.010,
     c 0.096,0.027,-.226,0.005,0.164,0.147,-.001,0.068,-.075,0.011,
     c 0.090,0.024,-.227,-.008,0.157,0.144,-.007,0.067,-.076,0.012,
     c 0.082,0.020,-.230,-.020,0.152,0.145,-.010,0.068,-.076,0.012,
     c 0.076,0.019,-.230,-.029,0.150,0.148,-.009,0.070,-.074,0.010,
     c 0.076,0.025,-.228,-.032,0.149,0.152,-.008,0.070,-.072,0.007,
     c 0.081,0.033,-.223,-.029,0.150,0.157,-.006,0.071,-.071,0.007,
     c 0.082,0.039,-.217,-.023,0.149,0.160,-.004,0.072,-.070,0.011,
     c 0.080,0.043,-.214,-.014,0.148,0.163,-.002,0.076,-.069,0.015,
     c 0.079,0.044,-.210,-.003,0.147,0.165,-.000,0.082,-.066,0.017,
     c 0.081,0.045,-.206,0.008,0.149,0.166,0.002,0.090,-.057,0.016,
     c 0.088,0.050,-.203,0.018,0.153,0.169,0.004,0.100,-.049,0.017,
     c 0.093,0.057,-.200,0.025,0.157,0.173,0.008,0.108,-.042,0.022,
     c 0.093,0.066,-.197,0.030,0.161,0.178,0.012,0.113,-.039,0.031,
     c 0.091,0.075,-.193,0.034,0.167,0.185,0.019,0.117,-.034,0.042,
     c 0.092,0.082,-.188,0.038,0.175,0.192,0.026,0.120,-.028,0.052,
     c 0.096,0.091,-.181,0.044,0.185,0.200,0.035,0.126,-.020,0.059,
     c 0.103,0.099,-.174,0.051,0.196,0.209,0.044,0.135,-.009,0.068,
     c 0.110,0.108,-.166,0.059,0.208,0.219,0.054,0.146,0.004,0.075,
     c 0.118,0.117,-.158,0.067,0.220,0.230,0.062,0.157,0.015,0.084,
     c 0.127,0.125,-.150,0.072,0.231,0.238,0.070,0.168,0.025,0.092,
     c 0.133,0.134,-.144,0.069,0.242,0.246,0.078,0.178,0.033,0.099,
     c 0.136,0.144,-.139,0.059,0.251,0.254,0.086,0.186,0.040,0.105,
     c 0.134,0.149,-.135,0.044,0.258,0.260,0.091,0.191,0.042,0.107,
     c 0.131,0.153,-.132,0.026,0.264,0.263,0.091,0.194,0.045,0.109,
     c 0.131,0.153,-.129,0.009,0.270,0.265,0.091,0.196,0.047,0.111,
     c 0.134,0.152,-.126,-.006,0.274,0.266,0.089,0.197,0.047,0.112,
     c 0.137,0.150,-.126,-.021,0.277,0.266,0.088,0.198,0.047,0.113,
     c 0.135,0.149,-.128,-.034,0.280,0.268,0.090,0.200,0.049,0.116,
     c 0.127,0.150,-.130,-.045,0.284,0.272,0.094,0.206,0.051,0.122,
     c 0.119,0.154,-.129,-.051,0.291,0.278,0.098,0.211,0.054,0.131,
     c 0.116,0.157,-.128,-.053,0.296,0.281,0.101,0.213,0.055,0.139,
     c 0.116,0.159,-.127,-.050,0.300,0.283,0.103,0.214,0.054,0.143,
     c 0.116,0.159,-.127,-.043,0.300,0.283,0.102,0.215,0.054,0.146,
     c 0.115,0.158,-.128,-.032,0.299,0.282,0.101,0.214,0.053,0.147,
     c 0.114,0.160,-.129,-.019,0.297,0.281,0.099,0.212,0.050,0.145,
     c 0.115,0.164,-.131,-.007,0.292,0.281,0.097,0.209,0.045,0.139,
     c 0.114,0.164,-.133,0.003,0.288,0.280,0.094,0.206,0.041,0.133,
     c 0.113,0.164,-.134,0.010,0.284,0.281,0.091,0.206,0.041,0.130,
     c 0.109,0.162,-.136,0.012,0.276,0.280,0.090,0.207,0.043,0.132,
     c 0.102,0.161,-.138,0.010,0.268,0.278,0.089,0.207,0.044,0.136,
     c 0.093,0.159,-.141,0.006,0.259,0.274,0.086,0.206,0.041,0.137,
     c 0.081,0.155,-.144,0.000,0.250,0.270,0.081,0.203,0.035,0.135,
     c 0.071,0.152,-.149,-.007,0.244,0.265,0.075,0.199,0.031,0.132,
     c 0.063,0.149,-.152,-.012,0.241,0.262,0.070,0.196,0.029,0.131,
     c 0.055,0.145,-.157,-.015,0.238,0.258,0.065,0.192,0.029,0.126,
     c 0.045,0.142,-.162,-.017,0.237,0.254,0.060,0.188,0.028,0.116,
     c 0.032,0.137,-.170,-.021,0.234,0.247,0.055,0.183,0.023,0.103,
     c 0.021,0.131,-.177,-.023,0.232,0.242,0.050,0.180,0.016,0.090,
     c 0.013,0.126,-.182,-.022,0.230,0.237,0.045,0.175,0.009,0.078,
     c 0.008,0.123,-.184,-.019,0.229,0.233,0.041,0.168,0.003,0.067,
     c 0.005,0.122,-.187,-.013,0.230,0.229,0.037,0.161,-.001,0.060,
     c 0.003,0.122,-.190,-.005,0.229,0.226,0.033,0.155,-.003,0.054,
     c 0.001,0.121,-.193,0.005,0.225,0.224,0.029,0.152,-.004,0.047,
     c -.002,0.121,-.195,0.015,0.223,0.223,0.028,0.152,-.004,0.040,
     c -.005,0.122,-.198,0.023,0.221,0.220,0.026,0.151,-.005,0.032,
     c -.006,0.120,-.201,0.028,0.222,0.217,0.023,0.150,-.009,0.024,
     c -.009,0.116,-.207,0.033,0.224,0.210,0.017,0.147,-.014,0.013,
     c -.016,0.110,-.213,0.037,0.224,0.204,0.012,0.143,-.020,0.002,
     c -.023,0.105,-.218,0.039,0.220,0.198,0.010,0.139,-.025,-.007,
     c -.029,0.108,-.222,0.038,0.213,0.193,0.006,0.134,-.029,-.015,
     c -.034,0.112,-.228,0.036,0.205,0.189,0.001,0.128,-.031,-.021,
     c -.036,0.116,-.232,0.033,0.198,0.188,-.005,0.125,-.032,-.020,
     c -.039,0.116,-.237,0.027,0.194,0.188,-.011,0.125,-.031,-.014,
     c -.042,0.117,-.241,0.024,0.188,0.186,-.017,0.122,-.032,-.013,
     c 0.100,0.031,-.222,0.016,0.160,0.149,0.001,0.071,-.075,0.012,
     c 0.093,0.028,-.224,0.004,0.157,0.149,-.001,0.071,-.074,0.013,
     c 0.087,0.026,-.225,-.009,0.152,0.147,-.007,0.070,-.074,0.014,
     c 0.079,0.022,-.227,-.021,0.148,0.148,-.009,0.071,-.074,0.015,
     c 0.073,0.022,-.229,-.029,0.148,0.151,-.009,0.073,-.072,0.013,
     c 0.072,0.027,-.226,-.031,0.148,0.154,-.008,0.074,-.071,0.009,
     c 0.077,0.035,-.220,-.027,0.150,0.158,-.007,0.074,-.070,0.010,
     c 0.080,0.042,-.214,-.020,0.149,0.160,-.006,0.075,-.069,0.015,
     c 0.080,0.045,-.211,-.010,0.149,0.162,-.005,0.078,-.067,0.019,
     c 0.079,0.044,-.208,0.001,0.148,0.165,-.003,0.083,-.063,0.020,
     c 0.082,0.044,-.206,0.013,0.151,0.166,-.001,0.090,-.054,0.019,
     c 0.090,0.047,-.204,0.023,0.156,0.169,0.002,0.099,-.046,0.019,
     c 0.097,0.054,-.201,0.031,0.160,0.173,0.007,0.107,-.040,0.024,
     c 0.099,0.063,-.197,0.035,0.163,0.178,0.012,0.113,-.037,0.031,
     c 0.098,0.072,-.193,0.039,0.168,0.185,0.019,0.117,-.033,0.041,
     c 0.097,0.079,-.188,0.042,0.176,0.190,0.026,0.120,-.029,0.049,
     c 0.100,0.088,-.181,0.047,0.185,0.198,0.034,0.127,-.021,0.056,
     c 0.107,0.098,-.173,0.055,0.196,0.207,0.044,0.135,-.009,0.065,
     c 0.114,0.109,-.165,0.064,0.207,0.219,0.054,0.146,0.003,0.073,
     c 0.124,0.119,-.157,0.072,0.219,0.231,0.063,0.157,0.015,0.081,
     c 0.133,0.128,-.149,0.076,0.230,0.241,0.071,0.168,0.025,0.088,
     c 0.139,0.137,-.143,0.071,0.240,0.249,0.080,0.178,0.033,0.094,
     c 0.142,0.146,-.138,0.059,0.249,0.256,0.088,0.186,0.041,0.100,
     c 0.140,0.150,-.135,0.042,0.255,0.262,0.093,0.192,0.045,0.102,
     c 0.137,0.153,-.132,0.024,0.262,0.265,0.094,0.197,0.049,0.104,
     c 0.136,0.154,-.129,0.007,0.269,0.267,0.094,0.200,0.050,0.107,
     c 0.139,0.154,-.126,-.008,0.274,0.267,0.092,0.201,0.050,0.110,
     c 0.142,0.153,-.126,-.022,0.277,0.268,0.091,0.202,0.050,0.112,
     c 0.140,0.152,-.127,-.034,0.281,0.269,0.093,0.202,0.051,0.116,
     c 0.132,0.153,-.127,-.046,0.285,0.274,0.096,0.205,0.052,0.122,
     c 0.125,0.157,-.126,-.053,0.291,0.280,0.100,0.208,0.055,0.131,
     c 0.122,0.160,-.124,-.057,0.296,0.283,0.102,0.210,0.054,0.139,
     c 0.122,0.161,-.124,-.055,0.299,0.284,0.103,0.211,0.054,0.145,
     c 0.121,0.160,-.125,-.048,0.300,0.283,0.103,0.213,0.053,0.148,
     c 0.118,0.157,-.126,-.038,0.300,0.282,0.103,0.214,0.053,0.149,
     c 0.114,0.159,-.127,-.025,0.298,0.281,0.101,0.213,0.051,0.147,
     c 0.113,0.163,-.129,-.013,0.294,0.281,0.098,0.210,0.046,0.141,
     c 0.112,0.165,-.131,-.004,0.290,0.279,0.094,0.206,0.042,0.132,
     c 0.111,0.167,-.132,0.003,0.284,0.279,0.091,0.206,0.042,0.127,
     c 0.108,0.165,-.133,0.005,0.277,0.278,0.090,0.206,0.043,0.126,
     c 0.101,0.165,-.135,0.004,0.269,0.276,0.089,0.207,0.044,0.129,
     c 0.092,0.163,-.139,0.001,0.260,0.272,0.086,0.205,0.042,0.131,
     c 0.080,0.158,-.143,-.005,0.251,0.268,0.080,0.201,0.035,0.130,
     c 0.070,0.153,-.148,-.011,0.244,0.264,0.073,0.197,0.031,0.127,
     c 0.062,0.149,-.152,-.016,0.240,0.261,0.068,0.194,0.028,0.125,
     c 0.054,0.144,-.157,-.019,0.237,0.256,0.063,0.190,0.028,0.120,
     c 0.044,0.140,-.162,-.019,0.237,0.252,0.059,0.186,0.026,0.112,
     c 0.030,0.135,-.170,-.022,0.234,0.246,0.053,0.182,0.021,0.099,
     c 0.019,0.129,-.178,-.025,0.232,0.239,0.048,0.179,0.014,0.088,
     c 0.011,0.124,-.183,-.023,0.229,0.235,0.043,0.174,0.006,0.076,
     c 0.006,0.121,-.185,-.019,0.229,0.231,0.039,0.167,0.000,0.065,
     c 0.003,0.120,-.187,-.012,0.229,0.227,0.036,0.158,-.005,0.057,
     c 0.002,0.121,-.189,-.003,0.228,0.224,0.031,0.153,-.007,0.052,
     c 0.001,0.120,-.193,0.007,0.225,0.222,0.027,0.150,-.007,0.045,
     c -.002,0.120,-.195,0.019,0.223,0.221,0.026,0.150,-.006,0.039,
     c -.005,0.120,-.198,0.027,0.222,0.218,0.024,0.150,-.007,0.031,
     c -.007,0.117,-.202,0.033,0.222,0.214,0.021,0.149,-.011,0.023,
     c -.010,0.112,-.208,0.038,0.225,0.208,0.015,0.147,-.016,0.011,
     c -.016,0.106,-.214,0.042,0.225,0.201,0.010,0.142,-.022,0.001,
     c -.024,0.101,-.219,0.043,0.221,0.194,0.007,0.138,-.027,-.008,
     c -.031,0.103,-.225,0.041,0.213,0.190,0.004,0.133,-.031,-.015,
     c -.036,0.108,-.230,0.038,0.205,0.186,-.001,0.127,-.032,-.020,
     c -.039,0.113,-.234,0.034,0.198,0.186,-.006,0.124,-.033,-.019,
     c -.040,0.114,-.238,0.027,0.192,0.186,-.012,0.123,-.033,-.014,
     c -.043,0.116,-.243,0.023,0.186,0.184,-.018,0.120,-.033,-.013,
     c 0.099,0.032,-.219,0.015,0.153,0.151,0.001,0.075,-.074,0.013,
     c 0.093,0.029,-.221,0.003,0.152,0.151,-.001,0.074,-.073,0.014,
     c 0.082,0.025,-.223,-.010,0.147,0.150,-.005,0.071,-.072,0.017,
     c 0.075,0.022,-.226,-.022,0.145,0.152,-.007,0.071,-.072,0.018,
     c 0.068,0.023,-.227,-.029,0.147,0.154,-.007,0.073,-.070,0.017,
     c 0.066,0.029,-.226,-.030,0.148,0.156,-.008,0.075,-.069,0.013,
     c 0.071,0.037,-.220,-.026,0.150,0.159,-.007,0.076,-.067,0.013,
     c 0.076,0.044,-.214,-.018,0.150,0.160,-.008,0.077,-.067,0.016,
     c 0.079,0.048,-.211,-.008,0.149,0.161,-.007,0.080,-.064,0.020,
     c 0.079,0.046,-.208,0.004,0.150,0.164,-.006,0.084,-.059,0.021,
     c 0.083,0.044,-.206,0.017,0.154,0.167,-.003,0.090,-.049,0.021,
     c 0.091,0.047,-.203,0.028,0.160,0.170,0.001,0.097,-.040,0.023,
     c 0.100,0.052,-.199,0.037,0.164,0.175,0.008,0.104,-.035,0.028,
     c 0.103,0.060,-.195,0.041,0.167,0.181,0.014,0.111,-.033,0.035,
     c 0.102,0.068,-.191,0.045,0.172,0.186,0.021,0.116,-.031,0.041,
     c 0.099,0.075,-.187,0.047,0.178,0.190,0.027,0.121,-.027,0.046,
     c 0.100,0.085,-.181,0.051,0.185,0.196,0.034,0.127,-.020,0.051,
     c 0.106,0.097,-.174,0.058,0.195,0.205,0.044,0.136,-.009,0.059,
     c 0.115,0.110,-.166,0.067,0.206,0.217,0.054,0.147,0.003,0.068,
     c 0.125,0.120,-.157,0.074,0.217,0.230,0.064,0.158,0.015,0.076,
     c 0.134,0.128,-.150,0.076,0.228,0.241,0.072,0.168,0.024,0.083,
     c 0.140,0.136,-.144,0.069,0.237,0.249,0.080,0.176,0.032,0.089,
     c 0.142,0.144,-.139,0.056,0.246,0.256,0.087,0.184,0.039,0.093,
     c 0.141,0.148,-.135,0.039,0.251,0.262,0.092,0.191,0.044,0.096,
     c 0.140,0.152,-.132,0.021,0.259,0.265,0.093,0.197,0.049,0.099,
     c 0.139,0.154,-.128,0.004,0.267,0.267,0.094,0.201,0.052,0.104,
     c 0.143,0.155,-.125,-.010,0.273,0.268,0.093,0.203,0.052,0.110,
     c 0.146,0.157,-.124,-.023,0.278,0.269,0.093,0.204,0.051,0.114,
     c 0.144,0.157,-.124,-.034,0.282,0.272,0.095,0.203,0.052,0.119,
     c 0.137,0.158,-.124,-.045,0.286,0.277,0.099,0.204,0.053,0.125,
     c 0.130,0.161,-.122,-.053,0.292,0.282,0.102,0.205,0.055,0.134,
     c 0.127,0.163,-.121,-.058,0.295,0.284,0.104,0.207,0.054,0.141,
     c 0.126,0.164,-.121,-.057,0.297,0.284,0.104,0.209,0.053,0.147,
     c 0.124,0.162,-.123,-.052,0.298,0.283,0.105,0.213,0.053,0.150,
     c 0.119,0.158,-.124,-.042,0.299,0.282,0.105,0.215,0.054,0.150,
     c 0.113,0.158,-.125,-.030,0.299,0.281,0.104,0.215,0.052,0.147,
     c 0.109,0.161,-.128,-.019,0.295,0.280,0.101,0.212,0.047,0.141,
     c 0.107,0.163,-.131,-.010,0.290,0.277,0.095,0.207,0.042,0.132,
     c 0.106,0.167,-.132,-.004,0.284,0.275,0.091,0.206,0.041,0.126,
     c 0.104,0.166,-.133,-.002,0.276,0.273,0.089,0.207,0.042,0.124,
     c 0.099,0.167,-.134,-.002,0.268,0.272,0.089,0.208,0.043,0.126,
     c 0.091,0.166,-.138,-.005,0.260,0.269,0.084,0.206,0.042,0.128,
     c 0.081,0.161,-.141,-.009,0.251,0.266,0.078,0.201,0.036,0.127,
     c 0.072,0.156,-.146,-.014,0.244,0.262,0.071,0.196,0.032,0.124,
     c 0.063,0.150,-.151,-.019,0.240,0.259,0.065,0.192,0.029,0.121,
     c 0.055,0.144,-.156,-.021,0.237,0.255,0.061,0.187,0.027,0.116,
     c 0.043,0.139,-.162,-.021,0.237,0.250,0.057,0.184,0.025,0.108,
     c 0.029,0.133,-.171,-.024,0.234,0.243,0.052,0.181,0.018,0.097,
     c 0.017,0.126,-.179,-.026,0.232,0.237,0.047,0.178,0.012,0.086,
     c 0.008,0.122,-.184,-.024,0.229,0.233,0.042,0.173,0.004,0.073,
     c 0.004,0.119,-.186,-.019,0.228,0.229,0.038,0.165,-.003,0.063,
     c 0.002,0.119,-.187,-.012,0.229,0.225,0.034,0.156,-.008,0.055,
     c 0.002,0.121,-.189,-.002,0.228,0.222,0.029,0.150,-.010,0.050,
     c 0.001,0.120,-.192,0.009,0.225,0.219,0.026,0.147,-.009,0.043,
     c -.002,0.119,-.195,0.022,0.223,0.218,0.024,0.148,-.008,0.038,
     c -.005,0.118,-.198,0.030,0.222,0.216,0.022,0.149,-.008,0.030,
     c -.007,0.114,-.203,0.037,0.222,0.212,0.019,0.149,-.011,0.022,
     c -.010,0.108,-.210,0.042,0.225,0.205,0.013,0.146,-.017,0.010,
     c -.016,0.101,-.217,0.045,0.225,0.198,0.008,0.141,-.024,0.000,
     c -.023,0.096,-.223,0.045,0.221,0.191,0.005,0.137,-.029,-.008,
     c -.031,0.098,-.228,0.042,0.214,0.187,0.002,0.132,-.032,-.013,
     c -.037,0.103,-.233,0.037,0.206,0.184,-.001,0.127,-.033,-.016,
     c -.039,0.109,-.236,0.032,0.198,0.185,-.006,0.124,-.034,-.015,
     c -.042,0.111,-.240,0.026,0.190,0.184,-.013,0.122,-.034,-.011,
     c -.045,0.114,-.244,0.021,0.183,0.183,-.018,0.119,-.035,-.011,
     c 0.099,0.033,-.215,0.013,0.149,0.154,0.002,0.079,-.072,0.015,
     c 0.093,0.030,-.219,0.001,0.148,0.154,-.001,0.077,-.072,0.016,
     c 0.082,0.027,-.222,-.013,0.144,0.152,-.005,0.072,-.071,0.018,
     c 0.076,0.025,-.226,-.025,0.143,0.153,-.006,0.071,-.071,0.019,
     c 0.068,0.025,-.228,-.031,0.144,0.155,-.007,0.071,-.069,0.019,
     c 0.064,0.030,-.228,-.032,0.145,0.156,-.008,0.074,-.067,0.015,
     c 0.066,0.039,-.223,-.026,0.148,0.158,-.008,0.076,-.065,0.014,
     c 0.071,0.046,-.217,-.018,0.149,0.159,-.008,0.078,-.065,0.015,
     c 0.076,0.050,-.214,-.007,0.150,0.161,-.008,0.081,-.061,0.018,
     c 0.079,0.048,-.210,0.006,0.152,0.165,-.007,0.085,-.055,0.020,
     c 0.083,0.046,-.206,0.020,0.158,0.168,-.004,0.090,-.045,0.022,
     c 0.091,0.048,-.201,0.032,0.165,0.172,0.002,0.096,-.036,0.027,
     c 0.100,0.053,-.196,0.042,0.170,0.178,0.010,0.102,-.030,0.034,
     c 0.104,0.061,-.192,0.047,0.173,0.183,0.018,0.109,-.029,0.039,
     c 0.101,0.068,-.188,0.050,0.177,0.188,0.024,0.115,-.028,0.042,
     c 0.097,0.074,-.186,0.051,0.181,0.189,0.028,0.120,-.025,0.044,
     c 0.096,0.084,-.181,0.054,0.187,0.193,0.034,0.128,-.019,0.047,
     c 0.102,0.097,-.175,0.059,0.195,0.201,0.044,0.137,-.008,0.055,
     c 0.112,0.110,-.166,0.067,0.204,0.214,0.054,0.148,0.004,0.064,
     c 0.123,0.120,-.159,0.072,0.214,0.227,0.064,0.159,0.014,0.074,
     c 0.132,0.127,-.151,0.072,0.224,0.238,0.072,0.167,0.023,0.081,
     c 0.137,0.133,-.145,0.064,0.233,0.246,0.078,0.174,0.029,0.085,
     c 0.141,0.140,-.139,0.051,0.240,0.253,0.085,0.181,0.036,0.088,
     c 0.141,0.145,-.135,0.034,0.246,0.258,0.089,0.187,0.041,0.090,
     c 0.140,0.149,-.131,0.017,0.254,0.262,0.090,0.192,0.047,0.093,
     c 0.141,0.153,-.127,0.002,0.263,0.265,0.090,0.197,0.050,0.100,
     c 0.146,0.156,-.123,-.011,0.271,0.268,0.091,0.201,0.051,0.108,
     c 0.150,0.160,-.122,-.022,0.278,0.270,0.092,0.202,0.051,0.115,
     c 0.148,0.161,-.122,-.033,0.283,0.274,0.096,0.202,0.053,0.120,
     c 0.142,0.162,-.121,-.045,0.286,0.278,0.100,0.201,0.053,0.125,
     c 0.135,0.165,-.119,-.053,0.291,0.283,0.103,0.201,0.055,0.132,
     c 0.130,0.165,-.118,-.059,0.293,0.284,0.104,0.202,0.054,0.139,
     c 0.128,0.165,-.119,-.059,0.294,0.283,0.105,0.206,0.053,0.143,
     c 0.124,0.163,-.121,-.053,0.296,0.282,0.106,0.211,0.054,0.145,
     c 0.118,0.158,-.123,-.044,0.297,0.281,0.107,0.214,0.055,0.144,
     c 0.109,0.157,-.125,-.033,0.298,0.280,0.106,0.214,0.052,0.141,
     c 0.104,0.158,-.128,-.023,0.295,0.278,0.102,0.211,0.046,0.135,
     c 0.101,0.160,-.133,-.016,0.290,0.274,0.096,0.206,0.041,0.127,
     c 0.100,0.164,-.135,-.011,0.283,0.271,0.091,0.205,0.039,0.121,
     c 0.098,0.165,-.137,-.009,0.276,0.268,0.088,0.206,0.040,0.119,
     c 0.095,0.166,-.138,-.009,0.268,0.266,0.087,0.207,0.041,0.122,
     c 0.090,0.166,-.140,-.010,0.261,0.264,0.082,0.206,0.041,0.125,
     c 0.083,0.162,-.142,-.012,0.253,0.263,0.075,0.202,0.037,0.125,
     c 0.075,0.157,-.146,-.016,0.246,0.260,0.068,0.196,0.033,0.122,
     c 0.067,0.151,-.151,-.020,0.241,0.258,0.064,0.190,0.030,0.119,
     c 0.056,0.143,-.156,-.022,0.238,0.253,0.060,0.184,0.027,0.112,
     c 0.043,0.138,-.162,-.023,0.237,0.249,0.056,0.182,0.023,0.105,
     c 0.027,0.131,-.171,-.025,0.235,0.242,0.051,0.180,0.016,0.094,
     c 0.015,0.124,-.180,-.027,0.231,0.235,0.046,0.177,0.009,0.083,
     c 0.006,0.119,-.185,-.025,0.228,0.231,0.041,0.172,0.001,0.071,
     c 0.002,0.117,-.186,-.020,0.228,0.227,0.036,0.163,-.006,0.061,
     c 0.000,0.118,-.187,-.012,0.228,0.223,0.032,0.154,-.011,0.053,
     c -.001,0.120,-.189,-.001,0.228,0.220,0.027,0.148,-.012,0.049,
     c -.001,0.119,-.192,0.011,0.225,0.217,0.023,0.145,-.011,0.043,
     c -.003,0.118,-.195,0.023,0.223,0.216,0.022,0.147,-.009,0.037,
     c -.006,0.115,-.199,0.032,0.222,0.213,0.019,0.149,-.008,0.029,
     c -.009,0.110,-.205,0.038,0.222,0.208,0.016,0.149,-.011,0.021,
     c -.012,0.103,-.213,0.042,0.224,0.202,0.010,0.145,-.016,0.010,
     c -.017,0.096,-.221,0.044,0.224,0.195,0.005,0.140,-.024,0.000,
     c -.023,0.092,-.227,0.043,0.221,0.189,0.003,0.135,-.030,-.006,
     c -.030,0.094,-.232,0.039,0.215,0.185,0.001,0.130,-.033,-.009,
     c -.036,0.099,-.236,0.035,0.206,0.183,-.002,0.125,-.034,-.010,
     c -.039,0.105,-.238,0.030,0.197,0.183,-.006,0.123,-.034,-.009,
     c -.043,0.109,-.242,0.024,0.188,0.183,-.014,0.120,-.035,-.008,
     c -.046,0.112,-.245,0.018,0.180,0.181,-.019,0.117,-.036,-.008,
     c 0.099,0.033,-.212,0.012,0.148,0.158,0.002,0.083,-.070,0.017,
     c 0.094,0.032,-.217,-.000,0.146,0.156,-.000,0.080,-.070,0.018,
     c 0.089,0.033,-.221,-.015,0.142,0.153,-.005,0.074,-.071,0.017,
     c 0.083,0.031,-.226,-.027,0.140,0.153,-.007,0.070,-.071,0.019,
     c 0.074,0.030,-.230,-.034,0.140,0.153,-.008,0.070,-.069,0.018,
     c 0.066,0.033,-.231,-.035,0.141,0.153,-.009,0.073,-.068,0.014,
     c 0.063,0.041,-.227,-.029,0.144,0.155,-.009,0.075,-.065,0.013,
     c 0.066,0.047,-.222,-.021,0.146,0.157,-.009,0.078,-.064,0.014,
     c 0.073,0.051,-.217,-.009,0.149,0.160,-.009,0.081,-.060,0.017,
     c 0.078,0.050,-.212,0.005,0.153,0.165,-.007,0.086,-.054,0.019,
     c 0.083,0.049,-.206,0.020,0.160,0.170,-.003,0.091,-.043,0.023,
     c 0.091,0.052,-.199,0.034,0.169,0.175,0.003,0.096,-.032,0.032,
     c 0.099,0.058,-.193,0.044,0.175,0.181,0.012,0.102,-.026,0.041,
     c 0.102,0.066,-.189,0.050,0.178,0.186,0.020,0.109,-.025,0.046,
     c 0.098,0.073,-.186,0.053,0.181,0.189,0.026,0.116,-.024,0.046,
     c 0.093,0.078,-.184,0.054,0.183,0.188,0.029,0.121,-.023,0.045,
     c 0.092,0.088,-.180,0.055,0.187,0.191,0.035,0.129,-.018,0.046,
     c 0.099,0.100,-.174,0.059,0.194,0.199,0.044,0.139,-.007,0.054,
     c 0.110,0.113,-.166,0.064,0.203,0.211,0.055,0.150,0.005,0.064,
     c 0.122,0.123,-.159,0.068,0.212,0.225,0.063,0.159,0.014,0.075,
     c 0.132,0.127,-.152,0.066,0.221,0.236,0.070,0.166,0.021,0.082,
     c 0.136,0.131,-.147,0.057,0.228,0.243,0.076,0.172,0.027,0.084,
     c 0.139,0.137,-.140,0.045,0.235,0.249,0.081,0.178,0.034,0.085,
     c 0.139,0.141,-.135,0.029,0.241,0.254,0.084,0.182,0.039,0.086,
     c 0.139,0.146,-.131,0.013,0.250,0.258,0.085,0.187,0.044,0.089,
     c 0.141,0.151,-.126,-.001,0.260,0.262,0.085,0.192,0.047,0.096,
     c 0.146,0.156,-.122,-.012,0.269,0.265,0.087,0.197,0.049,0.106,
     c 0.150,0.161,-.120,-.022,0.277,0.269,0.090,0.200,0.051,0.113,
     c 0.150,0.164,-.120,-.033,0.282,0.273,0.094,0.200,0.052,0.118,
     c 0.144,0.166,-.120,-.044,0.285,0.278,0.098,0.198,0.053,0.121,
     c 0.136,0.168,-.118,-.053,0.288,0.281,0.101,0.198,0.054,0.126,
     c 0.130,0.167,-.117,-.059,0.290,0.281,0.103,0.198,0.053,0.131,
     c 0.127,0.166,-.118,-.059,0.291,0.281,0.104,0.203,0.053,0.135,
     c 0.122,0.163,-.120,-.053,0.293,0.280,0.105,0.209,0.055,0.135,
     c 0.114,0.159,-.122,-.044,0.295,0.280,0.106,0.213,0.055,0.134,
     c 0.105,0.157,-.124,-.033,0.297,0.279,0.105,0.213,0.052,0.131,
     c 0.099,0.157,-.128,-.025,0.295,0.277,0.101,0.208,0.045,0.126,
     c 0.096,0.159,-.134,-.020,0.290,0.271,0.095,0.202,0.039,0.118,
     c 0.095,0.162,-.138,-.016,0.284,0.267,0.089,0.201,0.036,0.113,
     c 0.093,0.163,-.141,-.015,0.276,0.263,0.086,0.203,0.036,0.112,
     c 0.090,0.164,-.142,-.014,0.269,0.262,0.085,0.205,0.037,0.115,
     c 0.088,0.164,-.143,-.014,0.263,0.261,0.079,0.204,0.038,0.119,
     c 0.085,0.160,-.144,-.015,0.255,0.261,0.073,0.201,0.036,0.120,
     c 0.079,0.156,-.147,-.017,0.248,0.260,0.067,0.195,0.034,0.119,
     c 0.070,0.150,-.151,-.021,0.242,0.257,0.063,0.189,0.031,0.116,
     c 0.058,0.142,-.156,-.022,0.239,0.253,0.060,0.182,0.026,0.109,
     c 0.043,0.136,-.162,-.023,0.238,0.247,0.056,0.180,0.021,0.101,
     c 0.027,0.129,-.171,-.026,0.235,0.240,0.050,0.178,0.014,0.090,
     c 0.014,0.121,-.181,-.027,0.231,0.234,0.044,0.175,0.007,0.080,
     c 0.005,0.116,-.186,-.025,0.228,0.229,0.039,0.170,-.001,0.067,
     c 0.000,0.114,-.188,-.020,0.228,0.225,0.034,0.161,-.008,0.058,
     c -.003,0.117,-.188,-.011,0.228,0.220,0.029,0.153,-.013,0.052,
     c -.004,0.120,-.190,-.001,0.228,0.217,0.024,0.147,-.014,0.048,
     c -.005,0.118,-.193,0.010,0.227,0.214,0.020,0.144,-.013,0.043,
     c -.008,0.117,-.196,0.022,0.226,0.213,0.018,0.146,-.010,0.036,
     c -.011,0.113,-.201,0.030,0.224,0.210,0.016,0.147,-.008,0.028,
     c -.014,0.107,-.208,0.036,0.223,0.205,0.012,0.147,-.010,0.020,
     c -.017,0.100,-.217,0.039,0.223,0.199,0.007,0.143,-.015,0.010,
     c -.021,0.094,-.225,0.040,0.223,0.193,0.003,0.137,-.022,0.002,
     c -.026,0.090,-.232,0.039,0.220,0.188,0.000,0.131,-.028,-.003,
     c -.031,0.092,-.237,0.036,0.213,0.184,-.002,0.127,-.032,-.003,
     c -.037,0.097,-.239,0.032,0.205,0.182,-.004,0.122,-.034,-.003,
     c -.040,0.103,-.240,0.027,0.195,0.182,-.007,0.120,-.035,-.002,
     c -.045,0.106,-.244,0.021,0.185,0.181,-.015,0.117,-.037,-.004,
     c -.048,0.109,-.246,0.016,0.176,0.179,-.020,0.114,-.038,-.005,
     c 0.099,0.035,-.209,0.011,0.147,0.161,0.003,0.088,-.067,0.019,
     c 0.096,0.034,-.214,-.002,0.145,0.159,-.000,0.083,-.067,0.019,
     c 0.099,0.037,-.220,-.017,0.142,0.155,-.006,0.076,-.069,0.019,
     c 0.095,0.034,-.226,-.030,0.139,0.154,-.009,0.071,-.070,0.019,
     c 0.085,0.033,-.231,-.037,0.138,0.151,-.011,0.070,-.070,0.018,
     c 0.073,0.036,-.233,-.038,0.137,0.150,-.012,0.072,-.069,0.013,
     c 0.065,0.042,-.230,-.033,0.139,0.152,-.013,0.075,-.067,0.012,
     c 0.065,0.047,-.225,-.024,0.142,0.155,-.012,0.077,-.065,0.014,
     c 0.070,0.051,-.219,-.013,0.147,0.159,-.011,0.081,-.061,0.017,
     c 0.076,0.051,-.213,0.002,0.152,0.165,-.007,0.087,-.053,0.021,
     c 0.081,0.052,-.206,0.018,0.161,0.171,-.002,0.094,-.042,0.027,
     c 0.090,0.057,-.198,0.032,0.170,0.178,0.005,0.102,-.030,0.038,
     c 0.098,0.064,-.192,0.044,0.177,0.184,0.015,0.108,-.023,0.048,
     c 0.100,0.073,-.187,0.050,0.180,0.188,0.022,0.114,-.021,0.053,
     c 0.096,0.080,-.184,0.053,0.182,0.190,0.028,0.120,-.020,0.052,
     c 0.091,0.085,-.182,0.054,0.184,0.190,0.031,0.124,-.019,0.049,
     c 0.091,0.094,-.178,0.054,0.188,0.192,0.036,0.131,-.014,0.049,
     c 0.098,0.106,-.171,0.056,0.195,0.199,0.046,0.141,-.004,0.057,
     c 0.109,0.118,-.164,0.060,0.203,0.211,0.057,0.152,0.007,0.068,
     c 0.122,0.127,-.158,0.061,0.211,0.224,0.064,0.160,0.016,0.079,
     c 0.131,0.130,-.153,0.058,0.218,0.234,0.069,0.166,0.021,0.084,
     c 0.135,0.132,-.148,0.049,0.225,0.240,0.073,0.170,0.025,0.085,
     c 0.136,0.136,-.142,0.037,0.232,0.245,0.077,0.175,0.032,0.085,
     c 0.136,0.138,-.137,0.022,0.237,0.249,0.079,0.179,0.037,0.085,
     c 0.136,0.142,-.133,0.008,0.246,0.252,0.079,0.183,0.043,0.089,
     c 0.138,0.146,-.128,-.004,0.257,0.257,0.080,0.188,0.047,0.097,
     c 0.143,0.152,-.124,-.014,0.267,0.261,0.083,0.194,0.049,0.106,
     c 0.148,0.160,-.121,-.023,0.275,0.267,0.087,0.199,0.050,0.113,
     c 0.148,0.165,-.120,-.032,0.281,0.271,0.092,0.200,0.052,0.116,
     c 0.144,0.168,-.120,-.042,0.283,0.275,0.095,0.199,0.052,0.117,
     c 0.136,0.171,-.118,-.051,0.286,0.278,0.097,0.198,0.053,0.120,
     c 0.129,0.169,-.118,-.056,0.287,0.278,0.100,0.198,0.052,0.124,
     c 0.125,0.167,-.118,-.055,0.288,0.278,0.101,0.202,0.053,0.126,
     c 0.121,0.164,-.120,-.049,0.291,0.277,0.102,0.208,0.055,0.126,
     c 0.114,0.161,-.121,-.040,0.294,0.278,0.103,0.212,0.055,0.125,
     c 0.105,0.158,-.123,-.031,0.297,0.278,0.102,0.211,0.051,0.122,
     c 0.099,0.158,-.127,-.024,0.295,0.276,0.099,0.206,0.044,0.117,
     c 0.095,0.159,-.133,-.021,0.291,0.270,0.093,0.200,0.038,0.110,
     c 0.093,0.161,-.138,-.019,0.285,0.265,0.088,0.200,0.035,0.104,
     c 0.089,0.161,-.142,-.018,0.278,0.261,0.084,0.201,0.034,0.104,
     c 0.086,0.161,-.144,-.017,0.271,0.259,0.082,0.202,0.034,0.106,
     c 0.085,0.160,-.145,-.017,0.264,0.258,0.076,0.202,0.035,0.109,
     c 0.084,0.157,-.146,-.017,0.257,0.260,0.071,0.200,0.034,0.112,
     c 0.080,0.154,-.148,-.018,0.250,0.259,0.066,0.195,0.033,0.112,
     c 0.071,0.148,-.152,-.020,0.244,0.257,0.064,0.188,0.031,0.111,
     c 0.059,0.141,-.156,-.022,0.240,0.253,0.061,0.182,0.026,0.105,
     c 0.043,0.134,-.162,-.023,0.238,0.247,0.057,0.180,0.021,0.097,
     c 0.027,0.126,-.172,-.025,0.235,0.239,0.050,0.177,0.013,0.085,
     c 0.015,0.116,-.182,-.026,0.231,0.232,0.043,0.173,0.006,0.074,
     c 0.006,0.111,-.189,-.024,0.227,0.227,0.037,0.168,-.003,0.061,
     c 0.000,0.111,-.191,-.019,0.227,0.222,0.031,0.160,-.010,0.053,
     c -.005,0.115,-.191,-.012,0.228,0.218,0.026,0.152,-.015,0.048,
     c -.008,0.118,-.193,-.002,0.229,0.215,0.020,0.146,-.016,0.046,
     c -.011,0.117,-.195,0.008,0.229,0.212,0.016,0.142,-.016,0.041,
     c -.014,0.114,-.198,0.019,0.229,0.211,0.015,0.144,-.013,0.034,
     c -.017,0.110,-.203,0.027,0.228,0.207,0.012,0.144,-.011,0.026,
     c -.020,0.104,-.210,0.032,0.225,0.203,0.009,0.143,-.011,0.019,
     c -.022,0.099,-.219,0.035,0.224,0.197,0.004,0.139,-.015,0.012,
     c -.026,0.094,-.228,0.036,0.222,0.192,0.000,0.132,-.021,0.007,
     c -.029,0.091,-.236,0.035,0.218,0.188,-.003,0.126,-.027,0.005,
     c -.034,0.093,-.241,0.032,0.212,0.185,-.005,0.121,-.031,0.005,
     c -.039,0.097,-.243,0.029,0.203,0.182,-.007,0.116,-.034,0.006,
     c -.043,0.102,-.244,0.024,0.192,0.181,-.010,0.115,-.036,0.005,
     c -.046,0.103,-.246,0.019,0.181,0.179,-.018,0.113,-.039,-.000,
     c -.050,0.105,-.248,0.013,0.171,0.177,-.022,0.111,-.041,-.003,
     c 0.100,0.038,-.206,0.010,0.149,0.164,0.003,0.091,-.062,0.021,
     c 0.098,0.037,-.212,-.003,0.147,0.161,-.001,0.086,-.064,0.021,
     c 0.103,0.037,-.218,-.018,0.143,0.158,-.006,0.079,-.066,0.021,
     c 0.102,0.035,-.224,-.031,0.139,0.155,-.010,0.074,-.069,0.021,
     c 0.092,0.035,-.229,-.039,0.137,0.152,-.013,0.071,-.070,0.019,
     c 0.078,0.037,-.232,-.041,0.136,0.149,-.015,0.072,-.070,0.013,
     c 0.067,0.043,-.229,-.036,0.136,0.151,-.015,0.074,-.069,0.011,
     c 0.064,0.047,-.225,-.029,0.138,0.153,-.014,0.076,-.067,0.013,
     c 0.067,0.051,-.219,-.017,0.144,0.158,-.012,0.082,-.062,0.018,
     c 0.073,0.051,-.213,-.003,0.150,0.164,-.007,0.090,-.053,0.023,
     c 0.078,0.054,-.206,0.013,0.160,0.171,0.000,0.100,-.041,0.030,
     c 0.086,0.059,-.198,0.028,0.169,0.179,0.008,0.109,-.029,0.041,
     c 0.094,0.067,-.192,0.039,0.177,0.186,0.018,0.116,-.021,0.052,
     c 0.096,0.076,-.187,0.047,0.180,0.190,0.025,0.121,-.018,0.057,
     c 0.093,0.084,-.182,0.051,0.183,0.193,0.030,0.125,-.017,0.056,
     c 0.090,0.090,-.179,0.051,0.185,0.193,0.033,0.128,-.015,0.053,
     c 0.090,0.099,-.173,0.051,0.188,0.196,0.039,0.135,-.009,0.054,
     c 0.098,0.109,-.166,0.052,0.196,0.204,0.049,0.145,0.001,0.063,
     c 0.108,0.122,-.160,0.053,0.204,0.215,0.059,0.154,0.011,0.073,
     c 0.119,0.130,-.155,0.052,0.211,0.226,0.064,0.161,0.017,0.083,
     c 0.126,0.133,-.152,0.047,0.218,0.234,0.067,0.165,0.021,0.087,
     c 0.129,0.134,-.150,0.038,0.224,0.238,0.069,0.168,0.024,0.087,
     c 0.130,0.136,-.146,0.026,0.230,0.241,0.072,0.172,0.030,0.087,
     c 0.128,0.136,-.142,0.013,0.236,0.244,0.073,0.176,0.035,0.088,
     c 0.128,0.138,-.138,0.001,0.244,0.247,0.074,0.180,0.041,0.093,
     c 0.130,0.141,-.133,-.010,0.254,0.251,0.076,0.185,0.045,0.102,
     c 0.136,0.146,-.128,-.018,0.264,0.257,0.080,0.192,0.047,0.110,
     c 0.141,0.155,-.124,-.025,0.273,0.264,0.084,0.197,0.049,0.115,
     c 0.143,0.162,-.121,-.031,0.279,0.270,0.089,0.200,0.050,0.117,
     c 0.140,0.168,-.120,-.039,0.281,0.274,0.092,0.200,0.051,0.117,
     c 0.135,0.173,-.118,-.046,0.283,0.276,0.094,0.200,0.053,0.119,
     c 0.129,0.172,-.117,-.049,0.285,0.275,0.097,0.201,0.053,0.121,
     c 0.126,0.170,-.118,-.047,0.287,0.275,0.099,0.204,0.054,0.123,
     c 0.123,0.168,-.119,-.041,0.290,0.276,0.100,0.209,0.055,0.122,
     c 0.117,0.164,-.121,-.033,0.294,0.276,0.100,0.212,0.055,0.120,
     c 0.108,0.161,-.123,-.026,0.297,0.276,0.099,0.211,0.051,0.116,
     c 0.102,0.160,-.127,-.021,0.296,0.275,0.097,0.206,0.044,0.111,
     c 0.098,0.159,-.132,-.020,0.293,0.269,0.092,0.201,0.039,0.104,
     c 0.094,0.161,-.136,-.019,0.288,0.264,0.088,0.202,0.036,0.099,
     c 0.087,0.160,-.141,-.019,0.280,0.260,0.084,0.202,0.034,0.098,
     c 0.082,0.159,-.144,-.019,0.273,0.257,0.080,0.203,0.033,0.099,
     c 0.080,0.157,-.146,-.018,0.266,0.256,0.074,0.202,0.032,0.101,
     c 0.080,0.154,-.147,-.018,0.258,0.258,0.069,0.199,0.032,0.103,
     c 0.077,0.151,-.150,-.018,0.251,0.257,0.065,0.195,0.032,0.105,
     c 0.069,0.146,-.153,-.020,0.244,0.255,0.064,0.190,0.030,0.105,
     c 0.057,0.139,-.158,-.021,0.240,0.250,0.062,0.184,0.025,0.100,
     c 0.043,0.132,-.163,-.022,0.238,0.245,0.057,0.181,0.020,0.091,
     c 0.028,0.121,-.173,-.023,0.235,0.238,0.050,0.178,0.012,0.079,
     c 0.016,0.111,-.184,-.024,0.231,0.231,0.043,0.172,0.004,0.066,
     c 0.007,0.105,-.192,-.023,0.227,0.226,0.036,0.165,-.006,0.052,
     c 0.001,0.105,-.195,-.020,0.226,0.220,0.029,0.157,-.013,0.045,
     c -.006,0.110,-.196,-.014,0.227,0.216,0.022,0.150,-.018,0.044,
     c -.011,0.114,-.197,-.005,0.229,0.212,0.016,0.144,-.019,0.044,
     c -.016,0.112,-.199,0.004,0.230,0.210,0.013,0.140,-.019,0.040,
     c -.019,0.110,-.201,0.014,0.231,0.209,0.011,0.140,-.017,0.033,
     c -.022,0.106,-.205,0.022,0.230,0.206,0.009,0.139,-.015,0.024,
     c -.023,0.102,-.212,0.028,0.227,0.202,0.006,0.137,-.015,0.019,
     c -.025,0.098,-.221,0.032,0.224,0.196,0.001,0.132,-.017,0.015,
     c -.028,0.095,-.230,0.033,0.220,0.192,-.003,0.127,-.021,0.014,
     c -.031,0.093,-.238,0.032,0.216,0.188,-.006,0.121,-.026,0.014,
     c -.035,0.096,-.244,0.030,0.209,0.185,-.010,0.116,-.030,0.014,
     c -.039,0.098,-.247,0.026,0.200,0.181,-.012,0.111,-.034,0.013,
     c -.043,0.101,-.248,0.022,0.188,0.180,-.015,0.109,-.038,0.009,
     c -.048,0.099,-.248,0.016,0.177,0.176,-.021,0.109,-.042,0.002,
     c -.052,0.100,-.251,0.011,0.165,0.174,-.026,0.107,-.045,-.002,
     c 0.099,0.041,-.203,0.009,0.151,0.168,0.003,0.095,-.057,0.023,
     c 0.099,0.040,-.209,-.004,0.148,0.164,-.001,0.090,-.060,0.023,
     c 0.103,0.038,-.215,-.019,0.146,0.162,-.007,0.083,-.062,0.024,
     c 0.103,0.037,-.221,-.032,0.142,0.159,-.011,0.078,-.067,0.024,
     c 0.093,0.036,-.226,-.041,0.139,0.154,-.014,0.074,-.070,0.020,
     c 0.079,0.039,-.229,-.043,0.136,0.151,-.016,0.075,-.071,0.013,
     c 0.066,0.043,-.227,-.040,0.134,0.151,-.016,0.076,-.070,0.009,
     c 0.061,0.047,-.223,-.033,0.136,0.153,-.014,0.078,-.067,0.011,
     c 0.062,0.051,-.218,-.023,0.141,0.156,-.011,0.083,-.061,0.017,
     c 0.066,0.052,-.212,-.009,0.149,0.163,-.005,0.093,-.052,0.023,
     c 0.071,0.055,-.205,0.007,0.159,0.170,0.003,0.104,-.039,0.030,
     c 0.077,0.060,-.199,0.021,0.169,0.178,0.011,0.115,-.027,0.041,
     c 0.085,0.066,-.193,0.032,0.176,0.185,0.021,0.122,-.020,0.051,
     c 0.088,0.074,-.188,0.040,0.180,0.190,0.027,0.125,-.017,0.057,
     c 0.088,0.083,-.182,0.045,0.182,0.193,0.032,0.128,-.014,0.058,
     c 0.086,0.090,-.177,0.046,0.185,0.195,0.034,0.131,-.011,0.057,
     c 0.088,0.099,-.170,0.045,0.189,0.200,0.041,0.137,-.005,0.059,
     c 0.095,0.110,-.162,0.044,0.196,0.209,0.051,0.147,0.005,0.067,
     c 0.103,0.122,-.156,0.044,0.205,0.219,0.060,0.156,0.014,0.076,
     c 0.112,0.132,-.153,0.041,0.213,0.228,0.064,0.162,0.018,0.085,
     c 0.118,0.135,-.152,0.034,0.219,0.235,0.066,0.163,0.019,0.089,
     c 0.121,0.135,-.152,0.025,0.224,0.237,0.066,0.165,0.021,0.089,
     c 0.121,0.136,-.150,0.015,0.230,0.239,0.067,0.168,0.026,0.089,
     c 0.118,0.134,-.147,0.003,0.235,0.240,0.069,0.172,0.031,0.091,
     c 0.118,0.134,-.144,-.008,0.243,0.243,0.070,0.177,0.037,0.098,
     c 0.120,0.136,-.138,-.016,0.252,0.247,0.073,0.182,0.041,0.106,
     c 0.126,0.140,-.132,-.022,0.262,0.254,0.077,0.188,0.044,0.113,
     c 0.132,0.149,-.126,-.025,0.271,0.262,0.082,0.194,0.046,0.116,
     c 0.136,0.158,-.122,-.029,0.277,0.269,0.087,0.199,0.048,0.118,
     c 0.136,0.167,-.120,-.033,0.279,0.273,0.091,0.201,0.050,0.118,
     c 0.133,0.174,-.117,-.037,0.282,0.275,0.094,0.203,0.054,0.121,
     c 0.131,0.174,-.117,-.038,0.283,0.274,0.096,0.203,0.055,0.122,
     c 0.130,0.173,-.118,-.036,0.286,0.273,0.098,0.205,0.055,0.123,
     c 0.128,0.171,-.120,-.030,0.289,0.273,0.098,0.209,0.055,0.121,
     c 0.123,0.168,-.123,-.024,0.293,0.274,0.097,0.211,0.053,0.118,
     c 0.114,0.165,-.126,-.020,0.297,0.274,0.096,0.210,0.049,0.113,
     c 0.108,0.162,-.128,-.018,0.298,0.273,0.095,0.206,0.044,0.106,
     c 0.102,0.160,-.131,-.018,0.295,0.268,0.092,0.203,0.040,0.099,
     c 0.095,0.161,-.135,-.018,0.291,0.264,0.089,0.205,0.039,0.096,
     c 0.086,0.159,-.139,-.019,0.283,0.259,0.085,0.207,0.036,0.095,
     c 0.079,0.158,-.142,-.019,0.275,0.256,0.081,0.206,0.033,0.096,
     c 0.075,0.156,-.145,-.019,0.267,0.254,0.073,0.204,0.031,0.095,
     c 0.074,0.152,-.147,-.018,0.259,0.254,0.068,0.200,0.030,0.096,
     c 0.071,0.148,-.151,-.019,0.251,0.253,0.065,0.196,0.030,0.099,
     c 0.063,0.143,-.156,-.020,0.244,0.251,0.064,0.191,0.028,0.100,
     c 0.052,0.136,-.160,-.022,0.239,0.246,0.062,0.185,0.023,0.096,
     c 0.040,0.128,-.165,-.022,0.238,0.241,0.057,0.182,0.018,0.087,
     c 0.026,0.117,-.174,-.023,0.235,0.235,0.050,0.178,0.010,0.073,
     c 0.015,0.106,-.184,-.024,0.231,0.229,0.042,0.171,0.002,0.059,
     c 0.006,0.100,-.192,-.023,0.226,0.224,0.035,0.162,-.008,0.046,
     c 0.000,0.101,-.197,-.021,0.226,0.218,0.027,0.154,-.016,0.041,
     c -.007,0.105,-.199,-.017,0.227,0.213,0.019,0.147,-.020,0.043,
     c -.013,0.109,-.201,-.010,0.228,0.210,0.012,0.143,-.022,0.046,
     c -.018,0.107,-.203,-.001,0.230,0.208,0.009,0.139,-.022,0.043,
     c -.021,0.105,-.205,0.009,0.231,0.207,0.008,0.138,-.021,0.036,
     c -.022,0.101,-.209,0.018,0.231,0.204,0.006,0.135,-.020,0.027,
     c -.023,0.099,-.214,0.024,0.227,0.200,0.002,0.131,-.020,0.022,
     c -.024,0.097,-.222,0.028,0.223,0.195,-.002,0.127,-.022,0.020,
     c -.027,0.096,-.231,0.030,0.218,0.190,-.006,0.123,-.024,0.021,
     c -.030,0.094,-.239,0.030,0.214,0.187,-.010,0.118,-.028,0.022,
     c -.033,0.096,-.246,0.028,0.207,0.183,-.014,0.113,-.031,0.021,
     c -.038,0.096,-.249,0.023,0.196,0.178,-.017,0.108,-.036,0.017,
     c -.042,0.097,-.250,0.019,0.183,0.176,-.021,0.105,-.041,0.012,
     c -.049,0.094,-.251,0.014,0.172,0.174,-.025,0.105,-.045,0.003,
     c -.054,0.093,-.254,0.008,0.160,0.171,-.029,0.102,-.050,-.002,
     c 0.099,0.046,-.201,0.007,0.153,0.170,0.002,0.099,-.053,0.028,
     c 0.099,0.044,-.206,-.006,0.150,0.167,-.001,0.094,-.057,0.027,
     c 0.099,0.042,-.212,-.020,0.149,0.164,-.005,0.087,-.059,0.026,
     c 0.099,0.041,-.218,-.034,0.145,0.162,-.009,0.082,-.066,0.026,
     c 0.091,0.039,-.222,-.043,0.141,0.157,-.012,0.079,-.070,0.021,
     c 0.077,0.041,-.226,-.046,0.136,0.153,-.015,0.079,-.071,0.012,
     c 0.064,0.044,-.225,-.043,0.134,0.153,-.014,0.080,-.068,0.007,
     c 0.057,0.047,-.222,-.038,0.135,0.154,-.012,0.082,-.065,0.008,
     c 0.056,0.051,-.217,-.028,0.140,0.157,-.009,0.086,-.058,0.013,
     c 0.058,0.053,-.210,-.015,0.148,0.162,-.004,0.095,-.049,0.021,
     c 0.062,0.055,-.204,0.000,0.158,0.169,0.004,0.106,-.037,0.028,
     c 0.067,0.058,-.199,0.013,0.167,0.176,0.013,0.116,-.027,0.038,
     c 0.074,0.063,-.195,0.023,0.173,0.183,0.022,0.122,-.020,0.048,
     c 0.080,0.070,-.191,0.031,0.177,0.187,0.027,0.125,-.017,0.054,
     c 0.083,0.079,-.185,0.036,0.180,0.191,0.031,0.127,-.013,0.057,
     c 0.085,0.088,-.177,0.038,0.183,0.195,0.035,0.130,-.009,0.058,
     c 0.088,0.098,-.169,0.037,0.188,0.202,0.042,0.137,-.003,0.061,
     c 0.093,0.109,-.161,0.036,0.195,0.211,0.051,0.146,0.006,0.068,
     c 0.100,0.121,-.155,0.033,0.204,0.221,0.060,0.155,0.013,0.076,
     c 0.106,0.132,-.153,0.029,0.213,0.230,0.063,0.160,0.017,0.085,
     c 0.111,0.136,-.153,0.021,0.220,0.235,0.064,0.161,0.017,0.090,
     c 0.114,0.137,-.153,0.012,0.226,0.236,0.063,0.162,0.017,0.091,
     c 0.113,0.137,-.153,0.004,0.232,0.237,0.064,0.165,0.022,0.091,
     c 0.110,0.134,-.151,-.006,0.236,0.238,0.065,0.169,0.025,0.092,
     c 0.109,0.132,-.149,-.015,0.242,0.240,0.066,0.173,0.030,0.098,
     c 0.111,0.133,-.143,-.021,0.250,0.244,0.070,0.178,0.035,0.105,
     c 0.117,0.137,-.136,-.024,0.259,0.251,0.073,0.183,0.038,0.110,
     c 0.124,0.146,-.129,-.024,0.269,0.259,0.078,0.190,0.042,0.112,
     c 0.129,0.155,-.123,-.024,0.275,0.267,0.084,0.196,0.046,0.114,
     c 0.132,0.166,-.118,-.025,0.277,0.272,0.090,0.201,0.050,0.116,
     c 0.132,0.175,-.116,-.025,0.280,0.274,0.095,0.204,0.055,0.121,
     c 0.132,0.177,-.116,-.025,0.282,0.273,0.098,0.205,0.057,0.123,
     c 0.134,0.176,-.118,-.023,0.285,0.272,0.099,0.206,0.056,0.123,
     c 0.134,0.174,-.122,-.019,0.289,0.271,0.098,0.208,0.054,0.121,
     c 0.129,0.170,-.126,-.016,0.293,0.271,0.096,0.209,0.051,0.116,
     c 0.120,0.167,-.129,-.014,0.297,0.270,0.094,0.208,0.047,0.110,
     c 0.112,0.165,-.131,-.015,0.298,0.269,0.093,0.205,0.042,0.103,
     c 0.105,0.162,-.133,-.017,0.297,0.265,0.091,0.203,0.040,0.096,
     c 0.097,0.162,-.134,-.017,0.293,0.262,0.090,0.207,0.039,0.094,
     c 0.087,0.160,-.137,-.018,0.286,0.259,0.087,0.209,0.036,0.094,
     c 0.078,0.158,-.139,-.018,0.278,0.255,0.082,0.208,0.032,0.095,
     c 0.073,0.155,-.143,-.017,0.269,0.252,0.074,0.204,0.029,0.093,
     c 0.070,0.150,-.146,-.017,0.260,0.251,0.068,0.200,0.027,0.092,
     c 0.064,0.144,-.152,-.019,0.252,0.248,0.065,0.196,0.027,0.094,
     c 0.055,0.139,-.158,-.021,0.244,0.245,0.063,0.191,0.025,0.095,
     c 0.045,0.131,-.163,-.022,0.239,0.240,0.062,0.184,0.020,0.091,
     c 0.035,0.124,-.167,-.022,0.238,0.236,0.057,0.180,0.015,0.083,
     c 0.023,0.113,-.175,-.023,0.236,0.231,0.050,0.175,0.007,0.070,
     c 0.013,0.103,-.184,-.024,0.232,0.226,0.042,0.167,-.001,0.055,
     c 0.004,0.097,-.192,-.025,0.227,0.222,0.033,0.157,-.011,0.043,
     c -.002,0.097,-.198,-.024,0.226,0.216,0.024,0.149,-.019,0.041,
     c -.008,0.101,-.201,-.021,0.228,0.211,0.016,0.144,-.022,0.047,
     c -.014,0.104,-.204,-.015,0.229,0.208,0.008,0.141,-.023,0.053,
     c -.018,0.102,-.206,-.006,0.230,0.206,0.005,0.137,-.024,0.051,
     c -.020,0.101,-.208,0.004,0.231,0.205,0.004,0.136,-.023,0.043,
     c -.020,0.098,-.212,0.013,0.231,0.201,0.003,0.132,-.024,0.033,
     c -.020,0.096,-.217,0.020,0.227,0.198,-.001,0.127,-.025,0.027,
     c -.022,0.095,-.225,0.026,0.222,0.192,-.006,0.123,-.027,0.025,
     c -.027,0.094,-.232,0.028,0.216,0.188,-.010,0.120,-.028,0.026,
     c -.031,0.093,-.240,0.028,0.211,0.185,-.014,0.118,-.030,0.026,
     c -.033,0.093,-.246,0.026,0.204,0.180,-.018,0.113,-.033,0.024,
     c -.037,0.091,-.250,0.021,0.193,0.175,-.021,0.107,-.038,0.019,
     c -.041,0.091,-.252,0.017,0.179,0.173,-.025,0.103,-.044,0.012,
     c -.051,0.089,-.254,0.011,0.167,0.172,-.029,0.101,-.049,0.003,
     c -.056,0.086,-.257,0.006,0.155,0.169,-.033,0.096,-.054,-.003,
     c 0.099,0.051,-.198,0.005,0.155,0.172,0.001,0.102,-.049,0.032,
     c 0.099,0.049,-.203,-.008,0.152,0.169,-.000,0.097,-.054,0.030,
     c 0.098,0.048,-.209,-.023,0.151,0.167,-.002,0.091,-.057,0.030,
     c 0.097,0.046,-.214,-.036,0.147,0.164,-.004,0.087,-.064,0.028,
     c 0.091,0.043,-.220,-.045,0.142,0.160,-.007,0.084,-.068,0.022,
     c 0.078,0.043,-.224,-.048,0.137,0.156,-.011,0.083,-.068,0.012,
     c 0.066,0.045,-.224,-.046,0.135,0.155,-.012,0.083,-.065,0.005,
     c 0.058,0.048,-.222,-.041,0.135,0.156,-.011,0.084,-.061,0.004,
     c 0.056,0.052,-.216,-.032,0.140,0.158,-.008,0.088,-.054,0.009,
     c 0.056,0.054,-.209,-.020,0.148,0.163,-.004,0.095,-.046,0.018,
     c 0.057,0.055,-.203,-.007,0.156,0.169,0.003,0.104,-.035,0.027,
     c 0.061,0.057,-.200,0.004,0.164,0.175,0.011,0.113,-.027,0.036,
     c 0.068,0.059,-.198,0.013,0.169,0.180,0.020,0.118,-.022,0.045,
     c 0.075,0.065,-.195,0.020,0.173,0.183,0.024,0.120,-.018,0.050,
     c 0.082,0.075,-.189,0.027,0.177,0.187,0.028,0.123,-.014,0.053,
     c 0.088,0.084,-.180,0.029,0.181,0.192,0.032,0.127,-.009,0.056,
     c 0.092,0.095,-.171,0.029,0.186,0.201,0.040,0.134,-.004,0.059,
     c 0.098,0.106,-.163,0.027,0.194,0.210,0.050,0.144,0.004,0.065,
     c 0.103,0.120,-.157,0.023,0.204,0.221,0.058,0.153,0.011,0.073,
     c 0.108,0.132,-.154,0.017,0.213,0.230,0.061,0.158,0.014,0.082,
     c 0.112,0.137,-.153,0.010,0.222,0.234,0.062,0.159,0.016,0.089,
     c 0.114,0.139,-.153,0.002,0.228,0.235,0.062,0.159,0.016,0.091,
     c 0.113,0.138,-.153,-.005,0.234,0.235,0.062,0.163,0.019,0.091,
     c 0.109,0.135,-.152,-.012,0.237,0.236,0.062,0.166,0.022,0.091,
     c 0.105,0.134,-.151,-.019,0.242,0.238,0.064,0.170,0.026,0.094,
     c 0.105,0.135,-.147,-.023,0.248,0.241,0.066,0.174,0.030,0.099,
     c 0.110,0.138,-.140,-.024,0.257,0.248,0.069,0.179,0.035,0.102,
     c 0.116,0.146,-.133,-.021,0.265,0.255,0.074,0.187,0.039,0.103,
     c 0.122,0.156,-.125,-.018,0.271,0.263,0.081,0.194,0.044,0.107,
     c 0.126,0.167,-.119,-.015,0.274,0.269,0.089,0.201,0.049,0.112,
     c 0.129,0.176,-.116,-.013,0.277,0.271,0.095,0.205,0.056,0.118,
     c 0.131,0.178,-.116,-.012,0.281,0.272,0.099,0.205,0.058,0.122,
     c 0.135,0.177,-.118,-.010,0.284,0.271,0.099,0.206,0.056,0.123,
     c 0.136,0.175,-.122,-.008,0.288,0.270,0.098,0.207,0.052,0.120,
     c 0.132,0.171,-.127,-.007,0.291,0.269,0.096,0.209,0.048,0.116,
     c 0.124,0.169,-.131,-.009,0.295,0.267,0.093,0.208,0.045,0.109,
     c 0.116,0.167,-.133,-.011,0.296,0.266,0.092,0.205,0.041,0.101,
     c 0.107,0.164,-.134,-.014,0.296,0.262,0.091,0.204,0.039,0.095,
     c 0.099,0.164,-.134,-.015,0.293,0.260,0.091,0.207,0.039,0.093,
     c 0.088,0.161,-.135,-.016,0.288,0.258,0.089,0.209,0.035,0.095,
     c 0.079,0.158,-.137,-.015,0.280,0.256,0.084,0.207,0.031,0.095,
     c 0.074,0.153,-.141,-.014,0.271,0.252,0.076,0.203,0.028,0.093,
     c 0.069,0.147,-.145,-.015,0.261,0.249,0.069,0.199,0.026,0.090,
     c 0.061,0.141,-.153,-.017,0.253,0.245,0.065,0.194,0.025,0.090,
     c 0.051,0.135,-.160,-.020,0.246,0.241,0.063,0.189,0.022,0.090,
     c 0.041,0.128,-.166,-.021,0.241,0.237,0.061,0.182,0.016,0.086,
     c 0.033,0.121,-.169,-.021,0.239,0.233,0.057,0.178,0.012,0.080,
     c 0.023,0.112,-.175,-.022,0.238,0.229,0.049,0.171,0.005,0.068,
     c 0.013,0.102,-.183,-.024,0.234,0.225,0.040,0.163,-.002,0.055,
     c 0.005,0.097,-.191,-.027,0.230,0.221,0.031,0.153,-.013,0.045,
     c 0.000,0.097,-.197,-.027,0.229,0.215,0.022,0.145,-.019,0.046,
     c -.005,0.099,-.202,-.025,0.230,0.210,0.013,0.141,-.022,0.054,
     c -.010,0.102,-.204,-.019,0.232,0.207,0.005,0.139,-.023,0.061,
     c -.014,0.101,-.207,-.010,0.232,0.204,0.001,0.136,-.024,0.059,
     c -.016,0.100,-.210,-.000,0.232,0.202,0.001,0.134,-.025,0.050,
     c -.015,0.096,-.215,0.009,0.231,0.199,-.001,0.129,-.027,0.038,
     c -.016,0.094,-.220,0.017,0.226,0.195,-.004,0.124,-.029,0.030,
     c -.021,0.093,-.227,0.023,0.220,0.190,-.010,0.120,-.031,0.027,
     c -.029,0.092,-.234,0.026,0.214,0.186,-.014,0.118,-.032,0.026,
     c -.036,0.090,-.240,0.026,0.208,0.182,-.018,0.117,-.033,0.025,
     c -.038,0.088,-.246,0.024,0.200,0.178,-.020,0.113,-.035,0.022,
     c -.040,0.085,-.251,0.020,0.189,0.173,-.024,0.106,-.040,0.017,
     c -.043,0.083,-.253,0.015,0.176,0.171,-.027,0.101,-.046,0.011,
     c -.054,0.083,-.256,0.009,0.164,0.171,-.031,0.096,-.052,0.002,
     c -.058,0.080,-.259,0.004,0.151,0.168,-.036,0.091,-.057,-.004,
     c 0.101,0.057,-.194,0.002,0.157,0.174,0.001,0.105,-.047,0.036,
     c 0.100,0.054,-.200,-.011,0.154,0.171,-.000,0.100,-.051,0.032,
     c 0.098,0.053,-.206,-.026,0.152,0.169,0.001,0.095,-.056,0.032,
     c 0.099,0.049,-.212,-.039,0.147,0.166,0.000,0.090,-.063,0.028,
     c 0.095,0.045,-.217,-.048,0.142,0.161,-.003,0.086,-.066,0.021,
     c 0.085,0.045,-.222,-.051,0.137,0.157,-.008,0.083,-.065,0.012,
     c 0.074,0.047,-.223,-.049,0.135,0.157,-.009,0.083,-.062,0.005,
     c 0.066,0.051,-.220,-.044,0.136,0.157,-.009,0.084,-.058,0.004,
     c 0.062,0.055,-.215,-.036,0.141,0.160,-.007,0.087,-.052,0.009,
     c 0.061,0.056,-.208,-.025,0.147,0.165,-.003,0.092,-.044,0.018,
     c 0.061,0.057,-.203,-.014,0.154,0.170,0.002,0.100,-.036,0.027,
     c 0.063,0.057,-.201,-.005,0.159,0.174,0.010,0.107,-.029,0.036,
     c 0.069,0.057,-.200,0.003,0.164,0.177,0.016,0.112,-.024,0.043,
     c 0.076,0.062,-.199,0.010,0.167,0.179,0.020,0.115,-.021,0.046,
     c 0.086,0.072,-.192,0.017,0.173,0.183,0.024,0.119,-.015,0.049,
     c 0.094,0.081,-.184,0.020,0.178,0.189,0.029,0.123,-.010,0.052,
     c 0.100,0.093,-.175,0.020,0.184,0.198,0.037,0.131,-.006,0.056,
     c 0.105,0.104,-.167,0.018,0.193,0.208,0.047,0.140,0.001,0.061,
     c 0.109,0.118,-.160,0.014,0.203,0.218,0.055,0.149,0.007,0.069,
     c 0.113,0.130,-.156,0.008,0.214,0.227,0.059,0.155,0.012,0.079,
     c 0.116,0.137,-.153,0.002,0.223,0.232,0.061,0.156,0.016,0.087,
     c 0.117,0.139,-.152,-.004,0.230,0.233,0.061,0.158,0.018,0.090,
     c 0.116,0.139,-.150,-.009,0.237,0.234,0.061,0.162,0.021,0.090,
     c 0.112,0.137,-.151,-.015,0.239,0.235,0.062,0.165,0.022,0.089,
     c 0.107,0.136,-.151,-.020,0.242,0.237,0.062,0.168,0.025,0.091,
     c 0.104,0.137,-.149,-.023,0.247,0.240,0.064,0.171,0.029,0.093,
     c 0.107,0.141,-.145,-.022,0.254,0.244,0.066,0.176,0.033,0.095,
     c 0.112,0.148,-.138,-.017,0.261,0.251,0.070,0.185,0.037,0.096,
     c 0.117,0.157,-.130,-.011,0.267,0.258,0.078,0.194,0.042,0.100,
     c 0.121,0.168,-.124,-.006,0.270,0.264,0.088,0.201,0.048,0.108,
     c 0.124,0.177,-.119,-.001,0.274,0.268,0.095,0.205,0.054,0.116,
     c 0.128,0.179,-.118,0.001,0.279,0.270,0.099,0.206,0.056,0.121,
     c 0.133,0.178,-.119,0.002,0.283,0.271,0.099,0.206,0.055,0.122,
     c 0.136,0.175,-.122,0.002,0.286,0.270,0.097,0.208,0.051,0.121,
     c 0.134,0.172,-.126,0.001,0.289,0.269,0.095,0.210,0.048,0.117,
     c 0.125,0.170,-.130,-.003,0.292,0.266,0.093,0.209,0.045,0.112,
     c 0.117,0.169,-.133,-.007,0.294,0.263,0.091,0.207,0.042,0.103,
     c 0.108,0.167,-.134,-.012,0.294,0.259,0.090,0.204,0.039,0.097,
     c 0.099,0.167,-.134,-.013,0.293,0.259,0.091,0.206,0.038,0.095,
     c 0.089,0.163,-.134,-.014,0.288,0.258,0.090,0.206,0.035,0.096,
     c 0.080,0.159,-.135,-.012,0.281,0.256,0.086,0.204,0.030,0.097,
     c 0.076,0.152,-.139,-.011,0.272,0.252,0.077,0.200,0.027,0.093,
     c 0.071,0.145,-.145,-.012,0.262,0.249,0.069,0.196,0.024,0.089,
     c 0.062,0.139,-.153,-.015,0.254,0.245,0.064,0.193,0.023,0.086,
     c 0.051,0.134,-.162,-.017,0.246,0.241,0.061,0.188,0.019,0.085,
     c 0.042,0.127,-.168,-.019,0.242,0.236,0.059,0.180,0.014,0.082,
     c 0.035,0.121,-.171,-.019,0.241,0.233,0.055,0.175,0.011,0.077,
     c 0.026,0.113,-.176,-.021,0.240,0.229,0.047,0.169,0.005,0.067,
     c 0.016,0.105,-.182,-.024,0.237,0.225,0.038,0.160,-.003,0.056,
     c 0.008,0.099,-.190,-.028,0.234,0.222,0.029,0.150,-.013,0.048,
     c 0.003,0.097,-.196,-.029,0.233,0.217,0.020,0.143,-.019,0.051,
     c -.002,0.099,-.200,-.027,0.234,0.212,0.012,0.139,-.022,0.060,
     c -.007,0.102,-.204,-.021,0.235,0.208,0.004,0.137,-.024,0.066,
     c -.010,0.101,-.207,-.013,0.234,0.205,0.000,0.134,-.025,0.063,
     c -.012,0.100,-.210,-.003,0.233,0.202,-.001,0.131,-.026,0.052,
     c -.012,0.097,-.216,0.007,0.230,0.199,-.004,0.125,-.029,0.037,
     c -.014,0.094,-.223,0.014,0.225,0.195,-.008,0.119,-.033,0.027,
     c -.022,0.093,-.231,0.020,0.218,0.190,-.014,0.116,-.035,0.022,
     c -.034,0.091,-.237,0.024,0.211,0.186,-.018,0.114,-.036,0.021,
     c -.043,0.087,-.242,0.024,0.205,0.182,-.020,0.114,-.036,0.020,
     c -.047,0.084,-.247,0.023,0.197,0.178,-.022,0.111,-.037,0.016,
     c -.048,0.080,-.252,0.018,0.185,0.173,-.025,0.104,-.041,0.012,
     c -.049,0.078,-.255,0.013,0.173,0.171,-.029,0.099,-.047,0.007,
     c -.058,0.078,-.258,0.007,0.161,0.170,-.033,0.093,-.054,-.000,
     c -.062,0.075,-.262,0.001,0.148,0.168,-.038,0.087,-.060,-.006,
     c 0.103,0.062,-.189,-.000,0.160,0.177,0.003,0.107,-.045,0.038,
     c 0.103,0.057,-.195,-.013,0.156,0.173,0.002,0.101,-.049,0.034,
     c 0.102,0.055,-.203,-.029,0.153,0.170,0.003,0.097,-.055,0.033,
     c 0.102,0.050,-.208,-.042,0.146,0.166,0.002,0.091,-.061,0.027,
     c 0.101,0.046,-.214,-.050,0.141,0.161,-.002,0.085,-.064,0.020,
     c 0.093,0.047,-.218,-.053,0.136,0.157,-.006,0.081,-.063,0.012,
     c 0.083,0.051,-.220,-.051,0.135,0.156,-.008,0.080,-.060,0.006,
     c 0.075,0.055,-.218,-.047,0.136,0.157,-.007,0.081,-.057,0.005,
     c 0.072,0.060,-.213,-.039,0.140,0.160,-.005,0.084,-.051,0.010,
     c 0.071,0.061,-.205,-.030,0.145,0.166,-.002,0.089,-.045,0.019,
     c 0.071,0.061,-.201,-.021,0.150,0.170,0.003,0.095,-.038,0.029,
     c 0.071,0.059,-.200,-.014,0.154,0.173,0.009,0.103,-.032,0.037,
     c 0.074,0.057,-.201,-.007,0.157,0.175,0.014,0.108,-.028,0.041,
     c 0.079,0.061,-.200,-.001,0.161,0.176,0.016,0.111,-.023,0.042,
     c 0.087,0.070,-.194,0.006,0.167,0.180,0.020,0.114,-.018,0.044,
     c 0.095,0.080,-.187,0.011,0.174,0.185,0.024,0.118,-.013,0.047,
     c 0.102,0.090,-.179,0.012,0.181,0.194,0.032,0.126,-.008,0.051,
     c 0.107,0.101,-.171,0.010,0.190,0.204,0.042,0.135,-.003,0.057,
     c 0.111,0.115,-.164,0.007,0.201,0.213,0.051,0.143,0.003,0.063,
     c 0.114,0.127,-.159,0.002,0.213,0.222,0.056,0.149,0.010,0.073,
     c 0.118,0.134,-.154,-.002,0.224,0.228,0.059,0.152,0.016,0.083,
     c 0.119,0.137,-.151,-.007,0.233,0.231,0.061,0.156,0.021,0.087,
     c 0.119,0.139,-.148,-.010,0.240,0.233,0.062,0.162,0.024,0.088,
     c 0.115,0.137,-.149,-.015,0.242,0.235,0.062,0.165,0.025,0.087,
     c 0.110,0.137,-.151,-.019,0.244,0.237,0.062,0.166,0.027,0.089,
     c 0.106,0.138,-.151,-.020,0.246,0.239,0.063,0.168,0.029,0.091,
     c 0.107,0.142,-.149,-.019,0.251,0.242,0.065,0.173,0.032,0.093,
     c 0.111,0.149,-.143,-.013,0.257,0.247,0.069,0.183,0.035,0.093,
     c 0.115,0.157,-.136,-.006,0.262,0.253,0.077,0.192,0.039,0.098,
     c 0.117,0.167,-.129,0.002,0.265,0.260,0.086,0.200,0.044,0.107,
     c 0.120,0.176,-.123,0.008,0.271,0.265,0.093,0.204,0.050,0.117,
     c 0.124,0.178,-.121,0.010,0.276,0.269,0.097,0.204,0.053,0.121,
     c 0.131,0.177,-.121,0.011,0.281,0.271,0.097,0.205,0.053,0.122,
     c 0.135,0.175,-.122,0.010,0.284,0.271,0.095,0.207,0.051,0.121,
     c 0.133,0.172,-.124,0.007,0.287,0.270,0.093,0.210,0.050,0.118,
     c 0.125,0.171,-.128,0.002,0.289,0.266,0.092,0.210,0.048,0.113,
     c 0.116,0.171,-.132,-.004,0.291,0.262,0.090,0.208,0.044,0.105,
     c 0.107,0.170,-.134,-.010,0.292,0.258,0.090,0.204,0.041,0.099,
     c 0.096,0.170,-.134,-.012,0.292,0.258,0.090,0.204,0.038,0.096,
     c 0.086,0.166,-.135,-.013,0.287,0.258,0.089,0.204,0.034,0.097,
     c 0.079,0.160,-.135,-.012,0.280,0.257,0.085,0.201,0.029,0.097,
     c 0.077,0.153,-.139,-.010,0.271,0.253,0.076,0.197,0.026,0.093,
     c 0.072,0.145,-.145,-.011,0.261,0.249,0.067,0.194,0.023,0.087,
     c 0.064,0.139,-.154,-.013,0.253,0.245,0.061,0.192,0.021,0.084,
     c 0.053,0.134,-.162,-.016,0.247,0.241,0.057,0.187,0.018,0.082,
     c 0.046,0.128,-.168,-.017,0.243,0.237,0.055,0.179,0.013,0.079,
     c 0.040,0.123,-.170,-.017,0.242,0.234,0.052,0.173,0.010,0.075,
     c 0.030,0.116,-.175,-.020,0.241,0.230,0.045,0.167,0.005,0.066,
     c 0.019,0.107,-.181,-.024,0.240,0.227,0.036,0.159,-.003,0.056,
     c 0.009,0.102,-.189,-.028,0.237,0.225,0.028,0.150,-.013,0.049,
     c 0.003,0.098,-.195,-.030,0.237,0.220,0.021,0.142,-.020,0.052,
     c -.002,0.099,-.199,-.028,0.238,0.215,0.014,0.138,-.023,0.060,
     c -.007,0.102,-.202,-.022,0.238,0.211,0.007,0.135,-.025,0.065,
     c -.010,0.101,-.205,-.014,0.236,0.207,0.002,0.131,-.027,0.060,
     c -.012,0.101,-.209,-.004,0.234,0.204,-.000,0.127,-.029,0.047,
     c -.012,0.098,-.216,0.004,0.230,0.199,-.004,0.120,-.032,0.032,
     c -.016,0.094,-.225,0.012,0.223,0.196,-.009,0.115,-.036,0.020,
     c -.025,0.092,-.234,0.018,0.217,0.190,-.015,0.111,-.039,0.015,
     c -.040,0.089,-.241,0.021,0.210,0.186,-.019,0.110,-.039,0.014,
     c -.051,0.084,-.245,0.022,0.203,0.182,-.021,0.109,-.039,0.013,
     c -.057,0.080,-.249,0.020,0.194,0.178,-.022,0.107,-.040,0.011,
     c -.057,0.076,-.253,0.016,0.183,0.173,-.025,0.101,-.044,0.008,
     c -.057,0.074,-.257,0.011,0.170,0.172,-.029,0.095,-.049,0.004,
     c -.062,0.075,-.260,0.004,0.159,0.170,-.035,0.089,-.056,-.001,
     c -.065,0.072,-.263,-.001,0.147,0.168,-.039,0.083,-.061,-.007,
     c 0.108,0.067,-.184,-.002,0.164,0.179,0.006,0.108,-.043,0.040,
     c 0.107,0.061,-.190,-.015,0.159,0.175,0.005,0.103,-.048,0.036,
     c 0.103,0.054,-.197,-.030,0.154,0.171,0.005,0.097,-.053,0.031,
     c 0.104,0.049,-.203,-.043,0.147,0.167,0.003,0.091,-.059,0.025,
     c 0.104,0.047,-.209,-.051,0.140,0.160,-.002,0.084,-.061,0.019,
     c 0.098,0.050,-.213,-.054,0.136,0.156,-.006,0.079,-.061,0.012,
     c 0.089,0.055,-.214,-.052,0.135,0.155,-.007,0.078,-.058,0.008,
     c 0.082,0.060,-.213,-.048,0.135,0.157,-.005,0.079,-.056,0.007,
     c 0.080,0.063,-.209,-.041,0.139,0.160,-.003,0.082,-.051,0.012,
     c 0.081,0.065,-.202,-.034,0.143,0.166,0.001,0.087,-.046,0.021,
     c 0.082,0.064,-.199,-.027,0.146,0.170,0.004,0.092,-.039,0.029,
     c 0.081,0.061,-.200,-.022,0.148,0.172,0.008,0.099,-.034,0.035,
     c 0.081,0.058,-.202,-.017,0.149,0.173,0.011,0.104,-.031,0.036,
     c 0.081,0.061,-.202,-.011,0.152,0.173,0.012,0.108,-.027,0.035,
     c 0.085,0.070,-.196,-.004,0.159,0.177,0.014,0.111,-.021,0.036,
     c 0.092,0.078,-.189,0.001,0.167,0.182,0.018,0.114,-.015,0.041,
     c 0.097,0.088,-.182,0.004,0.175,0.191,0.026,0.120,-.011,0.047,
     c 0.102,0.098,-.176,0.003,0.186,0.199,0.036,0.129,-.006,0.052,
     c 0.106,0.111,-.169,0.001,0.198,0.209,0.045,0.136,0.000,0.058,
     c 0.111,0.123,-.162,-.001,0.211,0.218,0.051,0.142,0.008,0.067,
     c 0.115,0.130,-.156,-.003,0.224,0.225,0.056,0.147,0.017,0.077,
     c 0.117,0.135,-.151,-.006,0.234,0.229,0.059,0.154,0.023,0.083,
     c 0.118,0.137,-.147,-.008,0.242,0.233,0.062,0.161,0.027,0.085,
     c 0.114,0.135,-.148,-.012,0.244,0.236,0.063,0.163,0.027,0.084,
     c 0.110,0.135,-.152,-.016,0.245,0.238,0.062,0.163,0.027,0.087,
     c 0.107,0.136,-.153,-.018,0.246,0.239,0.063,0.164,0.028,0.089,
     c 0.108,0.140,-.152,-.016,0.249,0.241,0.065,0.169,0.029,0.091,
     c 0.112,0.147,-.148,-.010,0.253,0.245,0.069,0.179,0.032,0.092,
     c 0.115,0.154,-.142,-.002,0.258,0.250,0.076,0.189,0.035,0.098,
     c 0.117,0.163,-.135,0.006,0.261,0.257,0.084,0.196,0.039,0.108,
     c 0.118,0.171,-.128,0.013,0.268,0.263,0.091,0.200,0.045,0.117,
     c 0.121,0.174,-.125,0.016,0.274,0.267,0.094,0.201,0.048,0.121,
     c 0.128,0.175,-.124,0.016,0.279,0.270,0.094,0.202,0.050,0.121,
     c 0.132,0.174,-.124,0.015,0.282,0.271,0.092,0.205,0.051,0.120,
     c 0.131,0.172,-.125,0.011,0.284,0.270,0.091,0.208,0.052,0.116,
     c 0.123,0.172,-.128,0.004,0.287,0.266,0.089,0.210,0.051,0.111,
     c 0.113,0.173,-.132,-.003,0.289,0.262,0.088,0.208,0.047,0.104,
     c 0.102,0.173,-.135,-.010,0.291,0.258,0.086,0.204,0.042,0.098,
     c 0.091,0.173,-.136,-.013,0.291,0.257,0.086,0.203,0.037,0.096,
     c 0.081,0.168,-.136,-.014,0.287,0.257,0.085,0.200,0.032,0.096,
     c 0.075,0.161,-.138,-.013,0.279,0.256,0.080,0.197,0.027,0.095,
     c 0.073,0.153,-.142,-.011,0.269,0.252,0.072,0.194,0.024,0.091,
     c 0.069,0.145,-.148,-.011,0.259,0.248,0.065,0.192,0.021,0.086,
     c 0.062,0.140,-.155,-.012,0.252,0.244,0.058,0.189,0.019,0.082,
     c 0.053,0.135,-.162,-.014,0.246,0.241,0.054,0.185,0.016,0.080,
     c 0.047,0.129,-.166,-.016,0.243,0.238,0.052,0.177,0.012,0.077,
     c 0.042,0.125,-.169,-.016,0.242,0.235,0.049,0.171,0.010,0.073,
     c 0.032,0.118,-.173,-.019,0.242,0.231,0.043,0.165,0.004,0.065,
     c 0.019,0.110,-.180,-.023,0.241,0.228,0.036,0.158,-.004,0.055,
     c 0.007,0.103,-.187,-.027,0.239,0.226,0.029,0.149,-.014,0.047,
     c 0.000,0.099,-.193,-.029,0.239,0.222,0.024,0.142,-.022,0.048,
     c -.005,0.099,-.197,-.026,0.240,0.218,0.018,0.137,-.025,0.054,
     c -.010,0.101,-.199,-.020,0.240,0.214,0.012,0.132,-.028,0.057,
     c -.013,0.101,-.202,-.013,0.238,0.210,0.006,0.127,-.030,0.053,
     c -.016,0.100,-.207,-.005,0.234,0.206,0.003,0.122,-.032,0.041,
     c -.017,0.098,-.216,0.003,0.229,0.201,-.003,0.116,-.036,0.026,
     c -.021,0.093,-.226,0.010,0.222,0.196,-.008,0.112,-.039,0.015,
     c -.031,0.090,-.237,0.016,0.216,0.190,-.014,0.108,-.042,0.011,
     c -.045,0.085,-.245,0.020,0.209,0.185,-.018,0.107,-.043,0.010,
     c -.057,0.080,-.249,0.020,0.202,0.180,-.019,0.105,-.043,0.010,
     c -.064,0.076,-.252,0.018,0.192,0.176,-.021,0.103,-.043,0.008,
     c -.066,0.073,-.255,0.014,0.180,0.172,-.025,0.097,-.046,0.007,
     c -.065,0.072,-.258,0.009,0.168,0.171,-.030,0.092,-.052,0.003,
     c -.068,0.073,-.262,0.002,0.157,0.170,-.036,0.087,-.057,-.003,
     c -.070,0.071,-.265,-.004,0.146,0.168,-.040,0.081,-.062,-.008,
     c 0.113,0.069,-.179,-.004,0.167,0.182,0.011,0.110,-.041,0.039,
     c 0.112,0.063,-.186,-.015,0.162,0.177,0.009,0.105,-.045,0.035,
     c 0.106,0.054,-.192,-.030,0.156,0.173,0.008,0.099,-.050,0.031,
     c 0.108,0.049,-.198,-.042,0.149,0.168,0.004,0.093,-.056,0.026,
     c 0.107,0.048,-.204,-.049,0.143,0.162,-.001,0.086,-.058,0.020,
     c 0.102,0.052,-.207,-.052,0.138,0.158,-.006,0.081,-.058,0.014,
     c 0.093,0.058,-.208,-.051,0.137,0.157,-.005,0.080,-.056,0.010,
     c 0.086,0.062,-.207,-.047,0.137,0.159,-.003,0.081,-.053,0.009,
     c 0.085,0.065,-.204,-.042,0.140,0.163,-.001,0.084,-.049,0.013,
     c 0.087,0.065,-.200,-.036,0.142,0.168,0.002,0.087,-.045,0.020,
     c 0.090,0.064,-.198,-.031,0.144,0.171,0.004,0.091,-.040,0.026,
     c 0.089,0.061,-.200,-.028,0.143,0.172,0.005,0.097,-.036,0.028,
     c 0.086,0.058,-.204,-.025,0.142,0.171,0.006,0.101,-.033,0.026,
     c 0.081,0.061,-.204,-.020,0.144,0.171,0.006,0.104,-.029,0.024,
     c 0.082,0.069,-.198,-.013,0.150,0.174,0.008,0.107,-.024,0.026,
     c 0.085,0.076,-.192,-.007,0.160,0.179,0.012,0.110,-.018,0.033,
     c 0.090,0.085,-.186,-.004,0.170,0.188,0.020,0.116,-.013,0.042,
     c 0.095,0.094,-.181,-.003,0.181,0.196,0.029,0.124,-.008,0.048,
     c 0.100,0.106,-.174,-.002,0.194,0.205,0.038,0.131,-.002,0.054,
     c 0.107,0.118,-.166,-.003,0.208,0.214,0.045,0.137,0.007,0.061,
     c 0.112,0.126,-.158,-.003,0.222,0.221,0.051,0.143,0.017,0.070,
     c 0.114,0.132,-.152,-.005,0.233,0.227,0.056,0.151,0.024,0.077,
     c 0.114,0.135,-.148,-.007,0.240,0.232,0.060,0.159,0.028,0.080,
     c 0.110,0.133,-.150,-.011,0.243,0.236,0.061,0.161,0.027,0.080,
     c 0.106,0.132,-.153,-.014,0.243,0.237,0.060,0.160,0.026,0.083,
     c 0.104,0.134,-.156,-.016,0.244,0.238,0.060,0.160,0.024,0.086,
     c 0.106,0.137,-.156,-.014,0.246,0.239,0.062,0.165,0.025,0.089,
     c 0.110,0.144,-.153,-.008,0.251,0.242,0.066,0.175,0.027,0.090,
     c 0.114,0.150,-.148,-.001,0.255,0.247,0.073,0.184,0.030,0.096,
     c 0.114,0.157,-.141,0.007,0.259,0.254,0.079,0.191,0.033,0.105,
     c 0.114,0.165,-.134,0.014,0.265,0.260,0.086,0.194,0.038,0.114,
     c 0.117,0.169,-.131,0.017,0.272,0.265,0.090,0.196,0.042,0.117,
     c 0.124,0.171,-.129,0.017,0.277,0.268,0.091,0.199,0.046,0.117,
     c 0.128,0.172,-.128,0.015,0.280,0.269,0.089,0.202,0.050,0.115,
     c 0.127,0.172,-.127,0.011,0.282,0.268,0.087,0.205,0.052,0.110,
     c 0.119,0.174,-.129,0.004,0.285,0.265,0.085,0.207,0.051,0.104,
     c 0.109,0.175,-.132,-.003,0.288,0.261,0.083,0.207,0.047,0.098,
     c 0.098,0.175,-.136,-.010,0.290,0.257,0.081,0.203,0.041,0.095,
     c 0.087,0.175,-.137,-.014,0.290,0.256,0.080,0.201,0.035,0.094,
     c 0.077,0.169,-.139,-.016,0.285,0.255,0.078,0.197,0.029,0.094,
     c 0.071,0.161,-.141,-.016,0.277,0.254,0.075,0.194,0.024,0.093,
     c 0.069,0.153,-.146,-.014,0.267,0.250,0.068,0.190,0.021,0.090,
     c 0.065,0.146,-.151,-.012,0.258,0.247,0.062,0.189,0.019,0.085,
     c 0.058,0.142,-.157,-.012,0.252,0.243,0.057,0.187,0.017,0.081,
     c 0.050,0.137,-.162,-.013,0.247,0.241,0.054,0.182,0.015,0.079,
     c 0.047,0.131,-.165,-.014,0.244,0.238,0.051,0.174,0.012,0.076,
     c 0.042,0.127,-.167,-.015,0.243,0.235,0.048,0.169,0.010,0.072,
     c 0.032,0.120,-.172,-.018,0.242,0.232,0.042,0.163,0.004,0.063,
     c 0.018,0.113,-.178,-.022,0.242,0.229,0.036,0.157,-.004,0.053,
     c 0.005,0.106,-.186,-.026,0.240,0.227,0.030,0.150,-.015,0.045,
     c -.002,0.101,-.191,-.026,0.240,0.223,0.026,0.142,-.023,0.044,
     c -.008,0.101,-.194,-.023,0.240,0.219,0.021,0.136,-.027,0.047,
     c -.012,0.102,-.196,-.017,0.239,0.215,0.015,0.131,-.030,0.051,
     c -.017,0.100,-.200,-.011,0.237,0.210,0.009,0.125,-.033,0.046,
     c -.020,0.100,-.205,-.003,0.233,0.207,0.005,0.120,-.035,0.036,
     c -.023,0.097,-.213,0.004,0.228,0.201,-.002,0.115,-.038,0.024,
     c -.027,0.092,-.224,0.011,0.221,0.196,-.007,0.112,-.041,0.015,
     c -.035,0.087,-.237,0.016,0.214,0.190,-.013,0.109,-.043,0.012,
     c -.047,0.081,-.246,0.019,0.207,0.184,-.016,0.107,-.044,0.011,
     c -.059,0.076,-.252,0.019,0.200,0.178,-.019,0.104,-.045,0.010,
     c -.066,0.073,-.255,0.017,0.189,0.173,-.021,0.100,-.046,0.008,
     c -.071,0.070,-.257,0.012,0.178,0.169,-.025,0.094,-.049,0.006,
     c -.071,0.071,-.259,0.006,0.166,0.169,-.030,0.090,-.053,0.003,
     c -.073,0.073,-.263,-.001,0.156,0.169,-.036,0.085,-.058,-.004,
     c -.075,0.072,-.266,-.008,0.146,0.167,-.041,0.080,-.062,-.009,
     c 0.118,0.072,-.174,-.005,0.170,0.184,0.016,0.111,-.038,0.040,
     c 0.116,0.065,-.181,-.016,0.165,0.180,0.014,0.107,-.042,0.036,
     c 0.111,0.056,-.188,-.028,0.160,0.176,0.012,0.102,-.046,0.032,
     c 0.112,0.051,-.195,-.039,0.153,0.171,0.008,0.097,-.051,0.027,
     c 0.112,0.051,-.200,-.046,0.147,0.166,0.002,0.091,-.054,0.023,
     c 0.106,0.055,-.203,-.049,0.142,0.162,-.002,0.087,-.054,0.017,
     c 0.096,0.061,-.203,-.048,0.141,0.162,-.002,0.086,-.052,0.014,
     c 0.087,0.065,-.202,-.045,0.141,0.164,-.000,0.087,-.049,0.012,
     c 0.086,0.066,-.201,-.041,0.142,0.167,0.001,0.089,-.045,0.015,
     c 0.089,0.065,-.198,-.036,0.143,0.172,0.002,0.091,-.042,0.020,
     c 0.092,0.064,-.198,-.033,0.143,0.173,0.003,0.093,-.039,0.022,
     c 0.091,0.060,-.202,-.032,0.140,0.172,0.002,0.095,-.037,0.021,
     c 0.086,0.057,-.206,-.030,0.137,0.170,0.002,0.098,-.035,0.016,
     c 0.080,0.059,-.207,-.025,0.137,0.169,0.001,0.101,-.032,0.013,
     c 0.078,0.067,-.201,-.018,0.144,0.173,0.004,0.103,-.026,0.017,
     c 0.080,0.073,-.194,-.012,0.154,0.178,0.008,0.107,-.020,0.027,
     c 0.082,0.081,-.190,-.008,0.165,0.186,0.016,0.113,-.015,0.038,
     c 0.087,0.089,-.185,-.006,0.177,0.194,0.025,0.121,-.009,0.046,
     c 0.094,0.101,-.179,-.005,0.190,0.202,0.034,0.128,-.002,0.052,
     c 0.102,0.114,-.171,-.004,0.204,0.210,0.040,0.134,0.007,0.058,
     c 0.109,0.123,-.162,-.003,0.217,0.217,0.046,0.141,0.016,0.067,
     c 0.110,0.129,-.155,-.005,0.227,0.222,0.051,0.149,0.023,0.073,
     c 0.109,0.132,-.152,-.007,0.235,0.228,0.055,0.157,0.026,0.076,
     c 0.104,0.130,-.153,-.011,0.238,0.232,0.057,0.159,0.024,0.077,
     c 0.100,0.130,-.157,-.014,0.240,0.234,0.057,0.158,0.022,0.080,
     c 0.097,0.132,-.159,-.015,0.242,0.234,0.057,0.157,0.019,0.083,
     c 0.100,0.136,-.159,-.013,0.244,0.235,0.059,0.162,0.019,0.086,
     c 0.105,0.141,-.157,-.007,0.249,0.238,0.062,0.171,0.021,0.086,
     c 0.109,0.146,-.152,0.000,0.253,0.243,0.068,0.179,0.025,0.090,
     c 0.110,0.152,-.146,0.007,0.257,0.250,0.073,0.184,0.027,0.098,
     c 0.110,0.160,-.139,0.014,0.264,0.256,0.079,0.189,0.032,0.106,
     c 0.112,0.164,-.135,0.016,0.271,0.261,0.084,0.192,0.037,0.110,
     c 0.119,0.168,-.133,0.016,0.276,0.264,0.087,0.195,0.042,0.110,
     c 0.123,0.171,-.131,0.014,0.279,0.265,0.086,0.198,0.047,0.108,
     c 0.123,0.172,-.129,0.010,0.282,0.265,0.084,0.202,0.050,0.102,
     c 0.116,0.174,-.129,0.004,0.285,0.262,0.081,0.204,0.049,0.096,
     c 0.107,0.175,-.131,-.003,0.288,0.260,0.079,0.205,0.045,0.092,
     c 0.096,0.175,-.135,-.010,0.290,0.256,0.075,0.202,0.039,0.091,
     c 0.085,0.173,-.138,-.014,0.288,0.254,0.074,0.199,0.032,0.093,
     c 0.076,0.167,-.142,-.018,0.282,0.253,0.072,0.195,0.025,0.094,
     c 0.071,0.160,-.146,-.018,0.274,0.251,0.069,0.191,0.021,0.094,
     c 0.068,0.153,-.150,-.016,0.265,0.248,0.065,0.188,0.019,0.091,
     c 0.063,0.147,-.155,-.013,0.258,0.246,0.061,0.187,0.017,0.086,
     c 0.057,0.144,-.158,-.012,0.253,0.243,0.057,0.185,0.016,0.083,
     c 0.051,0.140,-.161,-.012,0.249,0.242,0.054,0.180,0.015,0.080,
     c 0.048,0.134,-.163,-.012,0.246,0.239,0.051,0.173,0.013,0.077,
     c 0.043,0.130,-.165,-.013,0.245,0.237,0.047,0.168,0.011,0.073,
     c 0.032,0.124,-.170,-.016,0.244,0.233,0.042,0.163,0.004,0.065,
     c 0.018,0.117,-.177,-.020,0.243,0.230,0.036,0.158,-.004,0.056,
     c 0.005,0.111,-.183,-.023,0.241,0.228,0.031,0.152,-.014,0.047,
     c -.002,0.106,-.188,-.022,0.240,0.225,0.027,0.145,-.022,0.045,
     c -.007,0.105,-.192,-.018,0.240,0.220,0.022,0.139,-.026,0.046,
     c -.012,0.104,-.194,-.013,0.238,0.215,0.015,0.134,-.029,0.048,
     c -.018,0.101,-.198,-.007,0.235,0.210,0.010,0.127,-.033,0.045,
     c -.023,0.099,-.202,-.000,0.231,0.206,0.005,0.123,-.034,0.036,
     c -.027,0.095,-.210,0.006,0.225,0.201,-.001,0.119,-.036,0.026,
     c -.031,0.090,-.222,0.013,0.218,0.196,-.007,0.115,-.038,0.019,
     c -.038,0.085,-.236,0.018,0.212,0.190,-.013,0.112,-.040,0.017,
     c -.048,0.079,-.247,0.020,0.204,0.183,-.017,0.109,-.043,0.015,
     c -.058,0.074,-.254,0.019,0.195,0.177,-.020,0.105,-.046,0.012,
     c -.067,0.072,-.258,0.016,0.185,0.171,-.022,0.099,-.048,0.008,
     c -.073,0.070,-.260,0.010,0.174,0.168,-.026,0.093,-.050,0.005,
     c -.075,0.072,-.262,0.003,0.164,0.168,-.031,0.089,-.054,0.002,
     c -.077,0.074,-.265,-.005,0.156,0.168,-.037,0.085,-.058,-.006,
     c -.080,0.073,-.267,-.012,0.147,0.167,-.042,0.080,-.061,-.011,
     c 0.120,0.073,-.169,-.006,0.174,0.187,0.020,0.113,-.034,0.040,
     c 0.118,0.067,-.177,-.015,0.169,0.182,0.018,0.109,-.038,0.037,
     c 0.115,0.060,-.186,-.026,0.164,0.178,0.017,0.106,-.041,0.035,
     c 0.114,0.056,-.193,-.035,0.157,0.174,0.013,0.102,-.046,0.031,
     c 0.114,0.055,-.198,-.041,0.152,0.170,0.008,0.097,-.049,0.027,
     c 0.108,0.060,-.200,-.044,0.148,0.166,0.004,0.094,-.050,0.022,
     c 0.098,0.066,-.199,-.043,0.147,0.167,0.004,0.093,-.049,0.019,
     c 0.089,0.069,-.198,-.042,0.146,0.168,0.005,0.093,-.046,0.017,
     c 0.086,0.069,-.198,-.039,0.147,0.171,0.006,0.094,-.042,0.018,
     c 0.087,0.067,-.197,-.035,0.146,0.174,0.005,0.095,-.040,0.021,
     c 0.089,0.065,-.198,-.033,0.145,0.174,0.004,0.094,-.038,0.021,
     c 0.087,0.062,-.202,-.033,0.140,0.171,0.001,0.094,-.037,0.016,
     c 0.082,0.058,-.207,-.031,0.134,0.168,0.000,0.094,-.036,0.010,
     c 0.076,0.060,-.207,-.027,0.133,0.168,-.001,0.097,-.034,0.007,
     c 0.074,0.066,-.201,-.019,0.140,0.172,0.002,0.101,-.028,0.013,
     c 0.075,0.071,-.195,-.013,0.151,0.178,0.008,0.106,-.021,0.025,
     c 0.076,0.077,-.190,-.009,0.162,0.186,0.015,0.113,-.016,0.037,
     c 0.080,0.085,-.187,-.007,0.173,0.193,0.023,0.120,-.010,0.046,
     c 0.087,0.097,-.182,-.005,0.186,0.201,0.031,0.127,-.003,0.051,
     c 0.097,0.111,-.174,-.004,0.199,0.207,0.037,0.133,0.005,0.057,
     c 0.105,0.121,-.166,-.003,0.211,0.213,0.041,0.139,0.013,0.065,
     c 0.106,0.128,-.160,-.005,0.220,0.217,0.045,0.147,0.018,0.071,
     c 0.103,0.130,-.157,-.008,0.228,0.222,0.050,0.154,0.020,0.075,
     c 0.097,0.128,-.158,-.011,0.233,0.226,0.053,0.156,0.018,0.077,
     c 0.093,0.128,-.161,-.014,0.237,0.229,0.054,0.156,0.016,0.080,
     c 0.090,0.132,-.162,-.014,0.241,0.231,0.054,0.156,0.014,0.083,
     c 0.093,0.136,-.162,-.011,0.244,0.232,0.056,0.160,0.014,0.084,
     c 0.099,0.141,-.159,-.006,0.248,0.234,0.059,0.167,0.017,0.082,
     c 0.104,0.144,-.154,0.001,0.253,0.239,0.063,0.174,0.021,0.084,
     c 0.106,0.149,-.148,0.007,0.257,0.246,0.067,0.179,0.023,0.089,
     c 0.107,0.156,-.141,0.013,0.264,0.252,0.073,0.183,0.028,0.097,
     c 0.110,0.161,-.137,0.015,0.271,0.257,0.079,0.187,0.033,0.101,
     c 0.117,0.166,-.134,0.015,0.277,0.260,0.083,0.192,0.040,0.103,
     c 0.122,0.170,-.131,0.014,0.280,0.262,0.083,0.195,0.045,0.101,
     c 0.122,0.172,-.129,0.010,0.283,0.262,0.082,0.198,0.048,0.095,
     c 0.116,0.173,-.127,0.005,0.286,0.261,0.078,0.201,0.046,0.089,
     c 0.108,0.173,-.129,-.001,0.289,0.259,0.075,0.202,0.042,0.087,
     c 0.098,0.172,-.133,-.008,0.289,0.256,0.072,0.201,0.036,0.089,
     c 0.089,0.170,-.137,-.013,0.286,0.255,0.069,0.198,0.029,0.092,
     c 0.081,0.164,-.143,-.018,0.279,0.252,0.067,0.194,0.022,0.096,
     c 0.076,0.158,-.149,-.020,0.271,0.250,0.066,0.190,0.018,0.096,
     c 0.074,0.153,-.154,-.017,0.264,0.248,0.063,0.188,0.018,0.094,
     c 0.069,0.149,-.157,-.013,0.258,0.247,0.061,0.186,0.017,0.091,
     c 0.062,0.147,-.159,-.011,0.255,0.245,0.058,0.184,0.017,0.088,
     c 0.056,0.143,-.160,-.009,0.252,0.244,0.055,0.180,0.016,0.085,
     c 0.052,0.137,-.162,-.010,0.250,0.242,0.052,0.174,0.014,0.082,
     c 0.045,0.133,-.163,-.011,0.248,0.239,0.048,0.169,0.011,0.078,
     c 0.034,0.127,-.167,-.014,0.246,0.236,0.043,0.165,0.005,0.071,
     c 0.020,0.121,-.174,-.018,0.245,0.233,0.037,0.160,-.003,0.063,
     c 0.008,0.116,-.180,-.019,0.243,0.231,0.032,0.155,-.012,0.055,
     c 0.000,0.112,-.186,-.018,0.241,0.227,0.028,0.148,-.019,0.052,
     c -.005,0.110,-.190,-.013,0.239,0.221,0.022,0.143,-.023,0.051,
     c -.010,0.107,-.194,-.007,0.235,0.216,0.015,0.138,-.026,0.051,
     c -.017,0.102,-.198,-.002,0.232,0.210,0.009,0.132,-.029,0.047,
     c -.024,0.098,-.202,0.005,0.227,0.206,0.005,0.128,-.030,0.040,
     c -.029,0.094,-.210,0.011,0.221,0.201,-.002,0.123,-.031,0.030,
     c -.032,0.088,-.221,0.017,0.214,0.197,-.008,0.119,-.033,0.025,
     c -.038,0.083,-.235,0.021,0.207,0.191,-.014,0.115,-.036,0.023,
     c -.047,0.078,-.247,0.022,0.199,0.184,-.019,0.110,-.041,0.019,
     c -.057,0.074,-.255,0.020,0.190,0.176,-.023,0.105,-.045,0.014,
     c -.066,0.073,-.260,0.015,0.180,0.170,-.026,0.099,-.048,0.007,
     c -.074,0.073,-.263,0.008,0.170,0.167,-.029,0.093,-.051,0.002,
     c -.078,0.074,-.265,0.001,0.162,0.167,-.033,0.089,-.054,-.002,
     c -.080,0.074,-.266,-.008,0.156,0.168,-.038,0.086,-.057,-.008,
     c -.084,0.074,-.268,-.016,0.148,0.166,-.042,0.082,-.060,-.013,
     c 0.122,0.073,-.165,-.007,0.177,0.188,0.024,0.116,-.030,0.042,
     c 0.118,0.069,-.173,-.014,0.173,0.184,0.021,0.112,-.034,0.039,
     c 0.113,0.064,-.183,-.023,0.168,0.180,0.020,0.108,-.037,0.037,
     c 0.112,0.060,-.192,-.031,0.163,0.177,0.017,0.105,-.042,0.034,
     c 0.113,0.061,-.197,-.035,0.159,0.173,0.013,0.101,-.045,0.032,
     c 0.109,0.066,-.198,-.038,0.155,0.170,0.010,0.098,-.047,0.027,
     c 0.100,0.072,-.195,-.038,0.154,0.171,0.010,0.098,-.046,0.024,
     c 0.090,0.074,-.195,-.038,0.153,0.172,0.011,0.097,-.044,0.022,
     c 0.086,0.073,-.196,-.036,0.152,0.174,0.011,0.097,-.041,0.022,
     c 0.085,0.070,-.196,-.034,0.151,0.176,0.009,0.097,-.040,0.024,
     c 0.085,0.067,-.197,-.032,0.147,0.174,0.007,0.095,-.039,0.023,
     c 0.081,0.064,-.201,-.032,0.140,0.170,0.003,0.092,-.038,0.016,
     c 0.077,0.061,-.205,-.030,0.133,0.167,0.001,0.091,-.037,0.008,
     c 0.073,0.062,-.205,-.025,0.132,0.168,-.001,0.093,-.035,0.006,
     c 0.073,0.067,-.199,-.017,0.138,0.173,0.003,0.099,-.030,0.013,
     c 0.074,0.071,-.193,-.011,0.148,0.179,0.008,0.106,-.023,0.027,
     c 0.073,0.076,-.189,-.007,0.159,0.187,0.015,0.113,-.017,0.039,
     c 0.075,0.083,-.187,-.005,0.170,0.193,0.022,0.120,-.011,0.048,
     c 0.081,0.095,-.183,-.003,0.182,0.199,0.030,0.126,-.005,0.052,
     c 0.091,0.109,-.177,-.002,0.193,0.205,0.034,0.132,0.001,0.057,
     c 0.100,0.120,-.169,-.002,0.204,0.208,0.038,0.137,0.007,0.064,
     c 0.102,0.126,-.164,-.005,0.213,0.212,0.041,0.144,0.010,0.070,
     c 0.100,0.128,-.161,-.008,0.222,0.216,0.046,0.151,0.012,0.074,
     c 0.094,0.126,-.162,-.012,0.228,0.222,0.050,0.154,0.011,0.077,
     c 0.090,0.128,-.164,-.013,0.235,0.226,0.052,0.155,0.010,0.082,
     c 0.088,0.133,-.164,-.012,0.240,0.229,0.054,0.156,0.010,0.085,
     c 0.092,0.137,-.162,-.009,0.245,0.231,0.055,0.160,0.011,0.085,
     c 0.099,0.141,-.159,-.005,0.249,0.233,0.058,0.166,0.014,0.080,
     c 0.105,0.143,-.154,0.002,0.254,0.237,0.061,0.170,0.018,0.079,
     c 0.108,0.147,-.147,0.008,0.257,0.243,0.064,0.175,0.022,0.082,
     c 0.109,0.154,-.140,0.013,0.265,0.250,0.069,0.180,0.027,0.088,
     c 0.113,0.160,-.134,0.015,0.272,0.255,0.077,0.185,0.034,0.094,
     c 0.119,0.167,-.130,0.015,0.278,0.259,0.082,0.190,0.041,0.097,
     c 0.124,0.171,-.127,0.014,0.282,0.261,0.083,0.194,0.046,0.096,
     c 0.125,0.172,-.124,0.011,0.285,0.262,0.082,0.196,0.047,0.091,
     c 0.120,0.171,-.123,0.006,0.288,0.261,0.078,0.199,0.044,0.085,
     c 0.112,0.170,-.125,0.001,0.289,0.261,0.074,0.200,0.039,0.083,
     c 0.103,0.168,-.130,-.006,0.288,0.259,0.069,0.199,0.033,0.086,
     c 0.095,0.166,-.136,-.011,0.283,0.257,0.067,0.197,0.026,0.092,
     c 0.089,0.161,-.143,-.017,0.275,0.254,0.064,0.193,0.020,0.096,
     c 0.085,0.157,-.150,-.020,0.267,0.251,0.064,0.191,0.018,0.099,
     c 0.082,0.154,-.156,-.018,0.262,0.249,0.062,0.189,0.018,0.098,
     c 0.076,0.152,-.158,-.013,0.258,0.250,0.061,0.187,0.018,0.095,
     c 0.069,0.149,-.159,-.009,0.257,0.249,0.060,0.185,0.017,0.092,
     c 0.061,0.145,-.159,-.007,0.256,0.248,0.057,0.181,0.016,0.089,
     c 0.055,0.139,-.160,-.007,0.253,0.245,0.054,0.176,0.013,0.086,
     c 0.047,0.135,-.161,-.008,0.251,0.242,0.050,0.171,0.010,0.081,
     c 0.036,0.130,-.165,-.012,0.249,0.238,0.045,0.166,0.003,0.076,
     c 0.024,0.124,-.171,-.015,0.247,0.235,0.039,0.162,-.004,0.070,
     c 0.013,0.120,-.177,-.016,0.244,0.233,0.034,0.156,-.011,0.065,
     c 0.005,0.116,-.184,-.013,0.242,0.229,0.029,0.150,-.016,0.061,
     c -.001,0.113,-.190,-.008,0.238,0.223,0.023,0.145,-.020,0.058,
     c -.008,0.109,-.195,-.003,0.234,0.217,0.015,0.140,-.023,0.055,
     c -.016,0.102,-.200,0.003,0.229,0.211,0.009,0.135,-.026,0.050,
     c -.023,0.097,-.205,0.009,0.224,0.207,0.005,0.131,-.027,0.042,
     c -.028,0.092,-.212,0.015,0.217,0.202,-.002,0.126,-.028,0.033,
     c -.031,0.086,-.223,0.020,0.209,0.197,-.009,0.121,-.031,0.029,
     c -.037,0.081,-.236,0.024,0.202,0.192,-.016,0.115,-.034,0.026,
     c -.046,0.077,-.248,0.025,0.195,0.184,-.022,0.110,-.039,0.022,
     c -.055,0.075,-.256,0.021,0.185,0.176,-.027,0.104,-.045,0.015,
     c -.065,0.076,-.261,0.015,0.176,0.170,-.030,0.099,-.048,0.007,
     c -.074,0.076,-.265,0.006,0.168,0.166,-.032,0.094,-.050,0.000,
     c -.080,0.076,-.266,-.002,0.161,0.167,-.034,0.091,-.053,-.005,
     c -.083,0.075,-.267,-.011,0.156,0.167,-.038,0.088,-.057,-.010,
     c -.088,0.073,-.270,-.020,0.149,0.165,-.042,0.084,-.059,-.016,
     c 0.121,0.074,-.160,-.007,0.180,0.190,0.027,0.118,-.026,0.044,
     c 0.118,0.070,-.169,-.012,0.176,0.186,0.024,0.115,-.030,0.042,
     c 0.108,0.066,-.180,-.020,0.172,0.181,0.021,0.110,-.034,0.040,
     c 0.107,0.064,-.188,-.025,0.168,0.178,0.019,0.106,-.039,0.038,
     c 0.109,0.065,-.193,-.030,0.165,0.175,0.016,0.103,-.042,0.035,
     c 0.108,0.070,-.194,-.033,0.163,0.173,0.014,0.102,-.044,0.030,
     c 0.102,0.075,-.192,-.034,0.161,0.173,0.015,0.101,-.043,0.027,
     c 0.093,0.076,-.192,-.035,0.160,0.175,0.015,0.101,-.042,0.024,
     c 0.088,0.074,-.193,-.034,0.158,0.176,0.014,0.100,-.040,0.025,
     c 0.085,0.070,-.195,-.033,0.154,0.176,0.013,0.099,-.039,0.026,
     c 0.081,0.068,-.197,-.031,0.149,0.173,0.009,0.096,-.039,0.024,
     c 0.077,0.065,-.200,-.030,0.141,0.170,0.006,0.092,-.038,0.016,
     c 0.074,0.064,-.203,-.027,0.134,0.168,0.004,0.089,-.036,0.009,
     c 0.072,0.065,-.202,-.021,0.131,0.169,0.002,0.091,-.034,0.008,
     c 0.074,0.070,-.196,-.013,0.137,0.175,0.005,0.098,-.029,0.017,
     c 0.075,0.073,-.191,-.007,0.147,0.181,0.009,0.106,-.023,0.030,
     c 0.074,0.078,-.188,-.003,0.157,0.188,0.015,0.113,-.017,0.041,
     c 0.074,0.084,-.186,-.001,0.167,0.193,0.021,0.120,-.012,0.048,
     c 0.078,0.095,-.183,-.001,0.177,0.198,0.028,0.126,-.007,0.051,
     c 0.087,0.109,-.178,0.000,0.188,0.202,0.032,0.130,-.002,0.055,
     c 0.097,0.119,-.172,-.001,0.197,0.205,0.035,0.134,0.002,0.062,
     c 0.101,0.125,-.167,-.005,0.206,0.208,0.039,0.141,0.004,0.067,
     c 0.101,0.127,-.164,-.008,0.216,0.214,0.044,0.148,0.005,0.072,
     c 0.096,0.125,-.164,-.012,0.224,0.220,0.049,0.153,0.006,0.077,
     c 0.091,0.128,-.165,-.013,0.234,0.226,0.052,0.156,0.007,0.083,
     c 0.091,0.135,-.165,-.011,0.240,0.229,0.054,0.158,0.007,0.087,
     c 0.095,0.139,-.162,-.008,0.246,0.231,0.057,0.162,0.009,0.088,
     c 0.104,0.142,-.158,-.003,0.250,0.233,0.059,0.166,0.013,0.083,
     c 0.110,0.143,-.153,0.003,0.254,0.236,0.060,0.169,0.018,0.078,
     c 0.113,0.147,-.146,0.008,0.258,0.242,0.063,0.173,0.021,0.078,
     c 0.114,0.154,-.138,0.013,0.266,0.249,0.069,0.179,0.028,0.084,
     c 0.117,0.160,-.130,0.015,0.274,0.255,0.076,0.186,0.035,0.090,
     c 0.124,0.167,-.125,0.015,0.280,0.260,0.082,0.191,0.042,0.094,
     c 0.129,0.171,-.122,0.014,0.284,0.263,0.084,0.195,0.046,0.094,
     c 0.129,0.171,-.120,0.011,0.286,0.264,0.082,0.196,0.046,0.089,
     c 0.123,0.169,-.120,0.007,0.288,0.264,0.078,0.198,0.043,0.083,
     c 0.116,0.167,-.122,0.002,0.288,0.264,0.074,0.199,0.037,0.081,
     c 0.108,0.165,-.127,-.004,0.285,0.262,0.069,0.197,0.031,0.084,
     c 0.101,0.165,-.134,-.009,0.280,0.259,0.066,0.196,0.026,0.090,
     c 0.096,0.161,-.143,-.016,0.272,0.255,0.063,0.193,0.021,0.096,
     c 0.093,0.158,-.151,-.018,0.265,0.252,0.063,0.191,0.019,0.099,
     c 0.090,0.156,-.156,-.017,0.261,0.251,0.062,0.189,0.020,0.098,
     c 0.083,0.154,-.158,-.012,0.258,0.252,0.062,0.188,0.019,0.096,
     c 0.074,0.151,-.159,-.007,0.258,0.251,0.061,0.185,0.017,0.094,
     c 0.064,0.146,-.159,-.005,0.257,0.251,0.060,0.182,0.015,0.091,
     c 0.056,0.140,-.160,-.005,0.256,0.248,0.057,0.177,0.011,0.087,
     c 0.047,0.136,-.160,-.006,0.254,0.244,0.053,0.173,0.007,0.082,
     c 0.037,0.132,-.163,-.009,0.250,0.240,0.047,0.167,0.001,0.077,
     c 0.028,0.126,-.168,-.012,0.248,0.236,0.041,0.162,-.006,0.074,
     c 0.019,0.123,-.175,-.012,0.245,0.234,0.035,0.156,-.012,0.070,
     c 0.012,0.119,-.183,-.009,0.242,0.230,0.029,0.149,-.017,0.066,
     c 0.004,0.116,-.191,-.004,0.237,0.224,0.023,0.143,-.020,0.061,
     c -.005,0.110,-.198,0.001,0.232,0.217,0.015,0.139,-.024,0.057,
     c -.014,0.102,-.204,0.007,0.227,0.212,0.009,0.134,-.026,0.049,
     c -.022,0.096,-.210,0.014,0.221,0.207,0.005,0.130,-.028,0.042,
     c -.027,0.090,-.217,0.019,0.213,0.202,-.002,0.125,-.029,0.034,
     c -.030,0.084,-.227,0.024,0.205,0.198,-.008,0.119,-.032,0.031,
     c -.036,0.080,-.239,0.027,0.198,0.192,-.015,0.114,-.035,0.028,
     c -.045,0.077,-.249,0.026,0.191,0.184,-.022,0.108,-.041,0.023,
     c -.054,0.076,-.255,0.022,0.182,0.176,-.027,0.103,-.046,0.015,
     c -.063,0.078,-.260,0.015,0.173,0.170,-.031,0.099,-.049,0.006,
     c -.073,0.077,-.264,0.005,0.166,0.166,-.032,0.095,-.051,-.002,
     c -.079,0.077,-.266,-.004,0.160,0.166,-.034,0.094,-.053,-.008,
     c -.084,0.074,-.268,-.014,0.156,0.166,-.039,0.090,-.056,-.013,
     c -.091,0.072,-.271,-.024,0.150,0.164,-.042,0.087,-.059,-.020,
     c 0.119,0.075,-.157,-.005,0.183,0.192,0.030,0.122,-.022,0.049,
     c 0.116,0.072,-.165,-.010,0.181,0.188,0.028,0.118,-.026,0.046,
     c 0.106,0.068,-.175,-.015,0.177,0.182,0.022,0.112,-.031,0.042,
     c 0.106,0.067,-.184,-.019,0.174,0.179,0.021,0.108,-.037,0.040,
     c 0.108,0.068,-.189,-.023,0.172,0.176,0.018,0.105,-.040,0.037,
     c 0.109,0.072,-.190,-.027,0.170,0.174,0.017,0.105,-.041,0.031,
     c 0.104,0.076,-.188,-.029,0.169,0.175,0.017,0.105,-.040,0.028,
     c 0.097,0.076,-.189,-.031,0.166,0.177,0.017,0.104,-.039,0.025,
     c 0.092,0.073,-.192,-.032,0.164,0.177,0.015,0.103,-.038,0.025,
     c 0.086,0.068,-.195,-.031,0.158,0.177,0.013,0.101,-.038,0.025,
     c 0.080,0.066,-.197,-.029,0.150,0.173,0.010,0.098,-.037,0.023,
     c 0.074,0.066,-.199,-.027,0.141,0.170,0.008,0.093,-.036,0.018,
     c 0.071,0.066,-.201,-.023,0.134,0.169,0.007,0.089,-.033,0.012,
     c 0.071,0.069,-.200,-.017,0.132,0.172,0.006,0.091,-.030,0.012,
     c 0.075,0.074,-.195,-.009,0.137,0.178,0.008,0.098,-.025,0.022,
     c 0.077,0.078,-.191,-.003,0.145,0.183,0.011,0.105,-.020,0.034,
     c 0.075,0.082,-.188,-.000,0.154,0.188,0.016,0.113,-.015,0.042,
     c 0.074,0.087,-.186,0.001,0.164,0.193,0.021,0.120,-.009,0.047,
     c 0.076,0.096,-.183,0.002,0.173,0.197,0.027,0.126,-.005,0.048,
     c 0.084,0.108,-.179,0.002,0.182,0.200,0.030,0.129,-.003,0.052,
     c 0.095,0.118,-.173,0.001,0.190,0.203,0.033,0.132,-.001,0.057,
     c 0.102,0.124,-.169,-.004,0.199,0.207,0.037,0.138,0.000,0.063,
     c 0.104,0.126,-.166,-.008,0.211,0.213,0.043,0.147,0.002,0.068,
     c 0.100,0.125,-.165,-.012,0.221,0.220,0.049,0.153,0.004,0.074,
     c 0.096,0.129,-.166,-.014,0.232,0.226,0.053,0.158,0.007,0.082,
     c 0.095,0.136,-.164,-.012,0.239,0.230,0.056,0.161,0.008,0.090,
     c 0.100,0.141,-.161,-.008,0.245,0.232,0.059,0.164,0.010,0.093,
     c 0.109,0.143,-.158,-.003,0.250,0.234,0.061,0.167,0.013,0.089,
     c 0.115,0.144,-.153,0.003,0.254,0.236,0.061,0.169,0.018,0.084,
     c 0.117,0.147,-.146,0.008,0.259,0.242,0.064,0.173,0.023,0.082,
     c 0.117,0.154,-.137,0.012,0.267,0.250,0.069,0.181,0.030,0.086,
     c 0.120,0.160,-.129,0.014,0.276,0.257,0.077,0.188,0.036,0.092,
     c 0.126,0.166,-.123,0.014,0.283,0.262,0.082,0.194,0.043,0.097,
     c 0.129,0.169,-.119,0.012,0.286,0.265,0.084,0.197,0.046,0.097,
     c 0.128,0.168,-.118,0.009,0.287,0.266,0.082,0.198,0.046,0.092,
     c 0.122,0.166,-.119,0.005,0.287,0.265,0.078,0.199,0.043,0.085,
     c 0.116,0.164,-.122,0.001,0.285,0.265,0.073,0.200,0.037,0.082,
     c 0.109,0.164,-.127,-.004,0.282,0.263,0.069,0.197,0.032,0.085,
     c 0.105,0.165,-.134,-.008,0.277,0.260,0.065,0.196,0.027,0.091,
     c 0.102,0.162,-.143,-.014,0.270,0.256,0.063,0.193,0.023,0.096,
     c 0.099,0.160,-.150,-.016,0.264,0.253,0.062,0.192,0.022,0.098,
     c 0.096,0.157,-.156,-.014,0.261,0.252,0.062,0.190,0.022,0.097,
     c 0.088,0.155,-.158,-.010,0.258,0.253,0.062,0.187,0.020,0.095,
     c 0.077,0.152,-.159,-.005,0.257,0.253,0.062,0.185,0.017,0.094,
     c 0.066,0.147,-.160,-.002,0.257,0.252,0.060,0.182,0.013,0.091,
     c 0.056,0.142,-.160,-.001,0.257,0.249,0.057,0.178,0.009,0.087,
     c 0.047,0.139,-.160,-.002,0.255,0.245,0.053,0.174,0.004,0.081,
     c 0.038,0.135,-.163,-.005,0.252,0.240,0.048,0.168,-.001,0.075,
     c 0.032,0.130,-.168,-.008,0.249,0.237,0.041,0.161,-.007,0.073,
     c 0.025,0.127,-.175,-.008,0.245,0.234,0.035,0.155,-.013,0.070,
     c 0.017,0.123,-.185,-.005,0.241,0.229,0.028,0.148,-.017,0.067,
     c 0.007,0.118,-.194,-.001,0.236,0.223,0.022,0.142,-.021,0.061,
     c -.004,0.111,-.201,0.005,0.230,0.217,0.015,0.137,-.025,0.054,
     c -.014,0.102,-.208,0.011,0.225,0.212,0.009,0.133,-.028,0.047,
     c -.022,0.094,-.214,0.018,0.219,0.208,0.006,0.130,-.029,0.041,
     c -.028,0.087,-.222,0.023,0.210,0.203,-.000,0.125,-.031,0.035,
     c -.032,0.081,-.232,0.027,0.201,0.198,-.005,0.119,-.034,0.032,
     c -.038,0.077,-.243,0.028,0.194,0.192,-.012,0.113,-.037,0.029,
     c -.046,0.076,-.250,0.027,0.186,0.183,-.019,0.107,-.042,0.023,
     c -.054,0.076,-.255,0.022,0.179,0.175,-.024,0.102,-.047,0.014,
     c -.062,0.078,-.259,0.014,0.171,0.169,-.028,0.099,-.050,0.004,
     c -.071,0.077,-.263,0.003,0.164,0.166,-.030,0.096,-.052,-.004,
     c -.078,0.075,-.265,-.007,0.159,0.166,-.033,0.095,-.054,-.010,
     c -.085,0.073,-.268,-.017,0.155,0.164,-.040,0.091,-.056,-.016,
     c -.092,0.070,-.272,-.027,0.150,0.163,-.044,0.089,-.058,-.023,
     c 0.118,0.078,-.152,-.003,0.187,0.195,0.034,0.125,-.018,0.054,
     c 0.117,0.075,-.161,-.006,0.186,0.190,0.032,0.121,-.022,0.051,
     c 0.109,0.072,-.171,-.010,0.183,0.183,0.026,0.116,-.028,0.048,
     c 0.109,0.070,-.180,-.012,0.180,0.180,0.024,0.112,-.033,0.044,
     c 0.111,0.070,-.185,-.016,0.179,0.177,0.022,0.110,-.036,0.039,
     c 0.111,0.073,-.187,-.021,0.177,0.176,0.020,0.109,-.037,0.033,
     c 0.107,0.076,-.187,-.025,0.175,0.177,0.020,0.109,-.037,0.029,
     c 0.101,0.075,-.188,-.028,0.172,0.178,0.019,0.107,-.037,0.026,
     c 0.095,0.072,-.193,-.030,0.167,0.179,0.015,0.105,-.037,0.024,
     c 0.088,0.068,-.196,-.029,0.159,0.178,0.011,0.103,-.037,0.024,
     c 0.080,0.067,-.197,-.026,0.151,0.175,0.009,0.100,-.036,0.023,
     c 0.072,0.067,-.198,-.023,0.142,0.173,0.008,0.096,-.033,0.020,
     c 0.069,0.068,-.198,-.018,0.136,0.173,0.009,0.092,-.029,0.017,
     c 0.070,0.071,-.196,-.012,0.134,0.176,0.010,0.094,-.025,0.018,
     c 0.075,0.077,-.193,-.006,0.138,0.180,0.012,0.100,-.020,0.027,
     c 0.078,0.080,-.190,-.001,0.144,0.184,0.014,0.106,-.015,0.038,
     c 0.076,0.084,-.188,0.002,0.152,0.189,0.017,0.113,-.010,0.044,
     c 0.073,0.088,-.186,0.004,0.161,0.193,0.022,0.120,-.005,0.046,
     c 0.074,0.096,-.183,0.005,0.168,0.196,0.026,0.125,-.003,0.046,
     c 0.081,0.107,-.179,0.005,0.176,0.199,0.029,0.129,-.002,0.048,
     c 0.093,0.115,-.175,0.002,0.184,0.202,0.032,0.131,-.002,0.053,
     c 0.102,0.121,-.170,-.002,0.195,0.207,0.037,0.137,-.002,0.057,
     c 0.106,0.123,-.166,-.008,0.207,0.213,0.043,0.145,0.001,0.063,
     c 0.103,0.123,-.165,-.013,0.219,0.220,0.049,0.152,0.005,0.070,
     c 0.099,0.128,-.166,-.015,0.229,0.224,0.052,0.158,0.009,0.081,
     c 0.097,0.137,-.164,-.014,0.237,0.228,0.056,0.163,0.010,0.093,
     c 0.101,0.142,-.161,-.010,0.243,0.231,0.059,0.166,0.012,0.100,
     c 0.109,0.145,-.158,-.004,0.249,0.233,0.061,0.169,0.015,0.098,
     c 0.114,0.145,-.153,0.002,0.255,0.236,0.062,0.170,0.020,0.093,
     c 0.116,0.147,-.147,0.007,0.260,0.242,0.063,0.174,0.024,0.090,
     c 0.115,0.153,-.138,0.011,0.270,0.251,0.069,0.182,0.031,0.093,
     c 0.117,0.158,-.130,0.011,0.279,0.258,0.075,0.190,0.037,0.099,
     c 0.122,0.162,-.123,0.011,0.285,0.264,0.080,0.196,0.043,0.104,
     c 0.125,0.164,-.120,0.008,0.287,0.265,0.081,0.198,0.045,0.105,
     c 0.123,0.162,-.120,0.005,0.286,0.266,0.079,0.199,0.044,0.099,
     c 0.116,0.161,-.122,0.002,0.284,0.265,0.075,0.200,0.042,0.092,
     c 0.111,0.161,-.125,-.002,0.281,0.265,0.072,0.200,0.037,0.088,
     c 0.108,0.162,-.129,-.005,0.279,0.263,0.068,0.198,0.033,0.090,
     c 0.108,0.166,-.135,-.008,0.275,0.261,0.066,0.197,0.030,0.095,
     c 0.107,0.165,-.143,-.012,0.270,0.259,0.064,0.195,0.027,0.099,
     c 0.105,0.162,-.150,-.013,0.265,0.256,0.063,0.194,0.026,0.099,
     c 0.101,0.159,-.155,-.011,0.262,0.256,0.062,0.191,0.025,0.097,
     c 0.092,0.156,-.157,-.007,0.258,0.257,0.062,0.188,0.021,0.095,
     c 0.080,0.152,-.158,-.002,0.257,0.256,0.061,0.185,0.018,0.095,
     c 0.068,0.149,-.159,0.001,0.257,0.255,0.059,0.183,0.013,0.093,
     c 0.057,0.145,-.160,0.002,0.257,0.251,0.056,0.179,0.008,0.088,
     c 0.048,0.143,-.161,0.002,0.257,0.248,0.052,0.175,0.004,0.080,
     c 0.040,0.139,-.164,-.001,0.254,0.242,0.047,0.168,-.000,0.073,
     c 0.034,0.135,-.169,-.003,0.250,0.237,0.040,0.162,-.005,0.070,
     c 0.028,0.131,-.177,-.003,0.245,0.234,0.034,0.156,-.011,0.067,
     c 0.020,0.127,-.187,-.001,0.240,0.228,0.027,0.149,-.016,0.064,
     c 0.008,0.121,-.196,0.004,0.234,0.222,0.021,0.143,-.021,0.058,
     c -.003,0.112,-.204,0.010,0.228,0.217,0.014,0.138,-.025,0.051,
     c -.014,0.101,-.210,0.016,0.222,0.212,0.010,0.134,-.027,0.045,
     c -.022,0.093,-.215,0.022,0.215,0.209,0.007,0.132,-.028,0.041,
     c -.028,0.085,-.224,0.027,0.207,0.205,0.002,0.128,-.029,0.037,
     c -.034,0.078,-.234,0.029,0.197,0.200,-.003,0.122,-.033,0.035,
     c -.041,0.075,-.245,0.029,0.189,0.192,-.009,0.115,-.037,0.030,
     c -.049,0.074,-.253,0.026,0.182,0.183,-.015,0.108,-.042,0.023,
     c -.055,0.074,-.256,0.020,0.175,0.175,-.021,0.103,-.047,0.013,
     c -.062,0.076,-.259,0.011,0.168,0.168,-.025,0.099,-.051,0.002,
     c -.071,0.075,-.262,0.000,0.162,0.165,-.029,0.096,-.053,-.007,
     c -.078,0.074,-.265,-.010,0.158,0.164,-.033,0.095,-.055,-.013,
     c -.086,0.071,-.268,-.020,0.155,0.163,-.041,0.092,-.056,-.018,
     c -.093,0.068,-.271,-.030,0.151,0.161,-.046,0.089,-.058,-.025,
     c 0.120,0.082,-.149,-.000,0.192,0.199,0.039,0.129,-.015,0.060,
     c 0.118,0.078,-.157,-.002,0.191,0.194,0.036,0.125,-.019,0.055,
     c 0.114,0.075,-.167,-.003,0.189,0.186,0.032,0.121,-.024,0.053,
     c 0.114,0.072,-.175,-.005,0.188,0.184,0.030,0.118,-.028,0.048,
     c 0.115,0.072,-.181,-.009,0.187,0.181,0.027,0.115,-.031,0.042,
     c 0.113,0.074,-.185,-.014,0.184,0.179,0.025,0.113,-.033,0.034,
     c 0.110,0.077,-.186,-.020,0.182,0.180,0.024,0.112,-.034,0.031,
     c 0.105,0.077,-.190,-.025,0.177,0.181,0.021,0.108,-.036,0.027,
     c 0.099,0.074,-.194,-.027,0.171,0.180,0.016,0.105,-.037,0.025,
     c 0.092,0.071,-.196,-.026,0.161,0.180,0.011,0.103,-.037,0.025,
     c 0.084,0.070,-.197,-.023,0.153,0.178,0.008,0.102,-.035,0.024,
     c 0.075,0.070,-.196,-.018,0.145,0.177,0.010,0.099,-.031,0.023,
     c 0.071,0.070,-.195,-.014,0.140,0.178,0.012,0.096,-.026,0.021,
     c 0.073,0.072,-.193,-.009,0.137,0.180,0.013,0.097,-.021,0.024,
     c 0.079,0.077,-.191,-.003,0.139,0.183,0.015,0.102,-.017,0.032,
     c 0.082,0.080,-.189,0.001,0.144,0.185,0.016,0.108,-.012,0.042,
     c 0.079,0.083,-.187,0.004,0.150,0.189,0.018,0.114,-.008,0.047,
     c 0.076,0.087,-.185,0.006,0.159,0.193,0.022,0.121,-.003,0.048,
     c 0.075,0.094,-.182,0.008,0.165,0.197,0.027,0.126,-.001,0.047,
     c 0.081,0.102,-.179,0.007,0.172,0.200,0.030,0.129,-.001,0.048,
     c 0.092,0.109,-.175,0.004,0.181,0.203,0.033,0.131,-.002,0.050,
     c 0.101,0.115,-.171,-.001,0.191,0.207,0.037,0.135,-.002,0.054,
     c 0.107,0.118,-.167,-.008,0.205,0.212,0.043,0.142,0.002,0.058,
     c 0.104,0.120,-.166,-.014,0.217,0.218,0.048,0.149,0.006,0.067,
     c 0.099,0.127,-.166,-.018,0.228,0.222,0.050,0.156,0.011,0.080,
     c 0.096,0.136,-.164,-.016,0.236,0.226,0.055,0.162,0.013,0.095,
     c 0.098,0.143,-.161,-.012,0.243,0.229,0.059,0.166,0.015,0.105,
     c 0.104,0.146,-.158,-.006,0.249,0.232,0.061,0.169,0.018,0.105,
     c 0.108,0.146,-.154,0.000,0.256,0.236,0.062,0.169,0.023,0.100,
     c 0.109,0.148,-.147,0.005,0.263,0.243,0.064,0.174,0.027,0.096,
     c 0.108,0.153,-.139,0.008,0.272,0.252,0.068,0.182,0.033,0.098,
     c 0.110,0.156,-.131,0.008,0.280,0.259,0.073,0.190,0.038,0.104,
     c 0.115,0.158,-.125,0.006,0.285,0.263,0.076,0.194,0.042,0.110,
     c 0.117,0.158,-.123,0.004,0.286,0.264,0.076,0.195,0.043,0.111,
     c 0.115,0.156,-.123,0.001,0.283,0.263,0.074,0.196,0.042,0.106,
     c 0.109,0.155,-.126,-.002,0.281,0.262,0.071,0.197,0.039,0.098,
     c 0.106,0.157,-.129,-.005,0.277,0.263,0.069,0.198,0.036,0.094,
     c 0.106,0.161,-.133,-.007,0.276,0.263,0.067,0.198,0.033,0.095,
     c 0.109,0.167,-.137,-.008,0.274,0.263,0.066,0.198,0.031,0.098,
     c 0.111,0.167,-.144,-.009,0.270,0.262,0.065,0.197,0.030,0.101,
     c 0.109,0.165,-.149,-.009,0.267,0.261,0.064,0.197,0.029,0.100,
     c 0.103,0.162,-.153,-.007,0.264,0.261,0.063,0.195,0.028,0.098,
     c 0.093,0.158,-.155,-.003,0.260,0.262,0.063,0.191,0.025,0.096,
     c 0.082,0.154,-.155,0.001,0.257,0.261,0.061,0.188,0.021,0.097,
     c 0.071,0.152,-.156,0.005,0.257,0.260,0.058,0.185,0.016,0.097,
     c 0.060,0.148,-.158,0.007,0.257,0.256,0.054,0.181,0.012,0.092,
     c 0.050,0.147,-.160,0.007,0.258,0.252,0.051,0.177,0.009,0.082,
     c 0.041,0.143,-.164,0.005,0.256,0.246,0.046,0.171,0.004,0.072,
     c 0.036,0.139,-.170,0.003,0.253,0.239,0.040,0.164,-.001,0.067,
     c 0.029,0.136,-.179,0.003,0.246,0.234,0.034,0.158,-.008,0.064,
     c 0.021,0.130,-.189,0.006,0.239,0.228,0.026,0.152,-.013,0.060,
     c 0.008,0.123,-.198,0.010,0.232,0.222,0.020,0.145,-.019,0.054,
     c -.004,0.113,-.205,0.015,0.225,0.217,0.015,0.140,-.023,0.048,
     c -.012,0.101,-.211,0.021,0.218,0.213,0.011,0.136,-.025,0.043,
     c -.019,0.093,-.215,0.026,0.212,0.210,0.007,0.135,-.025,0.041,
     c -.025,0.084,-.224,0.029,0.203,0.205,0.002,0.132,-.026,0.039,
     c -.031,0.077,-.235,0.030,0.193,0.200,-.002,0.127,-.029,0.036,
     c -.039,0.073,-.246,0.028,0.185,0.191,-.009,0.119,-.034,0.030,
     c -.049,0.072,-.254,0.024,0.178,0.182,-.015,0.111,-.041,0.021,
     c -.056,0.071,-.257,0.017,0.172,0.173,-.021,0.104,-.046,0.010,
     c -.063,0.072,-.260,0.008,0.166,0.167,-.025,0.099,-.051,0.000,
     c -.071,0.072,-.262,-.003,0.161,0.163,-.030,0.095,-.055,-.009,
     c -.078,0.071,-.265,-.013,0.157,0.162,-.035,0.093,-.057,-.015,
     c -.085,0.068,-.268,-.022,0.155,0.161,-.042,0.092,-.057,-.020,
     c -.093,0.066,-.271,-.033,0.151,0.158,-.048,0.090,-.058,-.026,
     c 0.124,0.087,-.145,0.004,0.198,0.203,0.045,0.134,-.011,0.065,
     c 0.123,0.082,-.153,0.002,0.197,0.198,0.041,0.129,-.015,0.059,
     c 0.119,0.078,-.162,0.003,0.197,0.192,0.038,0.125,-.019,0.057,
     c 0.119,0.074,-.170,0.002,0.196,0.189,0.035,0.121,-.024,0.051,
     c 0.118,0.072,-.176,-.002,0.195,0.186,0.032,0.118,-.027,0.042,
     c 0.115,0.075,-.181,-.008,0.192,0.184,0.029,0.116,-.031,0.035,
     c 0.111,0.078,-.185,-.015,0.188,0.184,0.027,0.112,-.034,0.032,
     c 0.107,0.079,-.189,-.021,0.182,0.183,0.023,0.107,-.037,0.029,
     c 0.103,0.078,-.194,-.024,0.174,0.182,0.017,0.103,-.039,0.027,
     c 0.097,0.075,-.196,-.023,0.164,0.183,0.012,0.103,-.039,0.026,
     c 0.089,0.074,-.195,-.019,0.155,0.182,0.010,0.103,-.036,0.026,
     c 0.080,0.072,-.194,-.015,0.148,0.182,0.012,0.102,-.031,0.025,
     c 0.076,0.071,-.192,-.011,0.144,0.183,0.014,0.101,-.026,0.024,
     c 0.080,0.072,-.191,-.007,0.140,0.183,0.015,0.102,-.021,0.027,
     c 0.088,0.075,-.189,-.002,0.140,0.184,0.016,0.106,-.016,0.035,
     c 0.091,0.077,-.188,0.003,0.144,0.185,0.016,0.111,-.013,0.044,
     c 0.089,0.080,-.186,0.006,0.150,0.189,0.017,0.116,-.009,0.049,
     c 0.084,0.084,-.184,0.009,0.158,0.194,0.021,0.122,-.004,0.051,
     c 0.081,0.089,-.181,0.011,0.165,0.198,0.026,0.127,-.001,0.050,
     c 0.084,0.096,-.179,0.010,0.171,0.202,0.030,0.131,0.000,0.051,
     c 0.092,0.102,-.176,0.006,0.179,0.204,0.034,0.132,-.002,0.051,
     c 0.100,0.108,-.172,0.000,0.190,0.207,0.038,0.135,-.002,0.052,
     c 0.106,0.112,-.168,-.007,0.205,0.212,0.042,0.140,0.002,0.055,
     c 0.104,0.117,-.166,-.015,0.217,0.217,0.045,0.146,0.007,0.064,
     c 0.099,0.125,-.166,-.018,0.228,0.220,0.046,0.152,0.012,0.078,
     c 0.094,0.136,-.163,-.018,0.236,0.224,0.051,0.159,0.015,0.094,
     c 0.093,0.143,-.160,-.013,0.244,0.228,0.056,0.164,0.018,0.104,
     c 0.097,0.147,-.157,-.007,0.252,0.232,0.060,0.167,0.022,0.105,
     c 0.100,0.147,-.153,-.001,0.259,0.237,0.061,0.168,0.026,0.099,
     c 0.100,0.149,-.147,0.002,0.266,0.245,0.064,0.172,0.029,0.094,
     c 0.099,0.154,-.139,0.004,0.275,0.253,0.068,0.180,0.034,0.096,
     c 0.103,0.155,-.132,0.004,0.281,0.259,0.072,0.187,0.038,0.103,
     c 0.108,0.156,-.128,0.002,0.284,0.262,0.073,0.190,0.041,0.111,
     c 0.111,0.154,-.126,-.000,0.283,0.261,0.072,0.190,0.041,0.113,
     c 0.109,0.151,-.127,-.003,0.280,0.260,0.069,0.190,0.038,0.108,
     c 0.103,0.151,-.129,-.005,0.276,0.258,0.066,0.192,0.035,0.101,
     c 0.102,0.155,-.133,-.007,0.272,0.260,0.065,0.195,0.031,0.097,
     c 0.104,0.160,-.136,-.008,0.271,0.262,0.065,0.195,0.029,0.097,
     c 0.109,0.167,-.140,-.008,0.271,0.264,0.067,0.196,0.029,0.099,
     c 0.111,0.169,-.146,-.008,0.269,0.264,0.067,0.197,0.029,0.100,
     c 0.109,0.168,-.150,-.006,0.267,0.265,0.066,0.198,0.029,0.099,
     c 0.102,0.165,-.153,-.004,0.264,0.265,0.065,0.197,0.029,0.096,
     c 0.091,0.160,-.153,0.000,0.260,0.266,0.065,0.195,0.027,0.096,
     c 0.081,0.156,-.152,0.005,0.258,0.266,0.062,0.192,0.025,0.098,
     c 0.072,0.154,-.152,0.009,0.256,0.264,0.059,0.189,0.022,0.100,
     c 0.062,0.151,-.155,0.011,0.256,0.260,0.055,0.185,0.018,0.096,
     c 0.053,0.149,-.158,0.012,0.258,0.255,0.051,0.181,0.015,0.086,
     c 0.043,0.146,-.163,0.011,0.257,0.248,0.047,0.174,0.010,0.075,
     c 0.037,0.142,-.171,0.010,0.254,0.241,0.042,0.167,0.004,0.069,
     c 0.031,0.139,-.179,0.011,0.247,0.235,0.035,0.160,-.004,0.063,
     c 0.022,0.133,-.189,0.014,0.239,0.228,0.028,0.153,-.011,0.058,
     c 0.010,0.125,-.198,0.017,0.230,0.222,0.021,0.146,-.017,0.051,
     c -.002,0.114,-.205,0.022,0.222,0.218,0.016,0.141,-.022,0.045,
     c -.009,0.103,-.210,0.026,0.215,0.214,0.012,0.138,-.024,0.041,
     c -.014,0.094,-.215,0.030,0.209,0.210,0.008,0.137,-.023,0.040,
     c -.018,0.086,-.223,0.031,0.200,0.204,0.001,0.134,-.023,0.037,
     c -.025,0.078,-.234,0.029,0.189,0.197,-.005,0.129,-.028,0.033,
     c -.035,0.073,-.246,0.026,0.181,0.189,-.012,0.121,-.033,0.026,
     c -.045,0.070,-.254,0.020,0.174,0.179,-.018,0.112,-.041,0.016,
     c -.053,0.067,-.258,0.013,0.169,0.171,-.024,0.104,-.048,0.005,
     c -.062,0.067,-.261,0.004,0.164,0.165,-.029,0.098,-.054,-.006,
     c -.071,0.066,-.263,-.007,0.161,0.161,-.033,0.093,-.058,-.014,
     c -.078,0.067,-.265,-.016,0.157,0.161,-.038,0.091,-.059,-.019,
     c -.085,0.066,-.267,-.025,0.155,0.159,-.043,0.091,-.058,-.022,
     c -.093,0.065,-.269,-.034,0.151,0.156,-.049,0.090,-.059,-.027,
     c 0.128,0.092,-.141,0.007,0.203,0.208,0.050,0.138,-.008,0.070,
     c 0.126,0.087,-.150,0.006,0.202,0.202,0.046,0.133,-.012,0.062,
     c 0.124,0.080,-.157,0.008,0.204,0.199,0.043,0.128,-.016,0.058,
     c 0.123,0.075,-.165,0.008,0.203,0.195,0.039,0.123,-.021,0.049,
     c 0.120,0.072,-.171,0.004,0.201,0.191,0.035,0.118,-.026,0.040,
     c 0.116,0.075,-.177,-.003,0.198,0.188,0.030,0.116,-.030,0.034,
     c 0.112,0.079,-.181,-.010,0.193,0.187,0.027,0.112,-.035,0.033,
     c 0.108,0.081,-.187,-.018,0.185,0.185,0.023,0.106,-.039,0.031,
     c 0.105,0.081,-.193,-.021,0.176,0.183,0.017,0.102,-.041,0.028,
     c 0.101,0.078,-.195,-.021,0.165,0.183,0.013,0.102,-.042,0.027,
     c 0.094,0.076,-.194,-.017,0.158,0.184,0.011,0.103,-.038,0.027,
     c 0.085,0.073,-.193,-.014,0.152,0.185,0.013,0.104,-.033,0.027,
     c 0.082,0.071,-.193,-.010,0.146,0.184,0.014,0.104,-.027,0.027,
     c 0.087,0.072,-.192,-.007,0.142,0.183,0.014,0.106,-.022,0.030,
     c 0.097,0.075,-.190,-.001,0.141,0.183,0.014,0.110,-.017,0.038,
     c 0.102,0.077,-.189,0.004,0.144,0.184,0.014,0.114,-.013,0.047,
     c 0.099,0.081,-.186,0.008,0.150,0.189,0.015,0.118,-.009,0.053,
     c 0.094,0.084,-.183,0.012,0.158,0.195,0.020,0.123,-.004,0.056,
     c 0.090,0.090,-.180,0.014,0.165,0.200,0.026,0.128,0.000,0.056,
     c 0.090,0.095,-.179,0.013,0.172,0.204,0.030,0.133,0.001,0.056,
     c 0.094,0.099,-.178,0.008,0.180,0.206,0.034,0.134,0.000,0.055,
     c 0.099,0.104,-.175,0.001,0.191,0.208,0.037,0.135,-.001,0.053,
     c 0.104,0.109,-.170,-.006,0.206,0.212,0.040,0.138,0.003,0.055,
     c 0.103,0.115,-.167,-.013,0.218,0.216,0.041,0.142,0.007,0.063,
     c 0.098,0.125,-.166,-.017,0.229,0.219,0.041,0.148,0.011,0.076,
     c 0.092,0.136,-.162,-.016,0.239,0.223,0.046,0.156,0.015,0.091,
     c 0.090,0.143,-.159,-.012,0.247,0.228,0.053,0.162,0.019,0.099,
     c 0.092,0.147,-.155,-.007,0.255,0.233,0.058,0.166,0.024,0.098,
     c 0.094,0.148,-.151,-.003,0.263,0.239,0.061,0.166,0.028,0.092,
     c 0.095,0.150,-.145,-.001,0.268,0.246,0.063,0.170,0.030,0.087,
     c 0.096,0.155,-.139,0.001,0.275,0.253,0.067,0.178,0.034,0.090,
     c 0.100,0.156,-.134,-.000,0.279,0.258,0.070,0.184,0.037,0.098,
     c 0.106,0.155,-.130,-.001,0.280,0.260,0.070,0.187,0.039,0.108,
     c 0.109,0.153,-.129,-.003,0.278,0.259,0.068,0.187,0.038,0.111,
     c 0.107,0.149,-.131,-.005,0.274,0.257,0.065,0.187,0.033,0.107,
     c 0.101,0.149,-.133,-.007,0.270,0.255,0.062,0.188,0.029,0.100,
     c 0.099,0.153,-.135,-.008,0.266,0.257,0.062,0.191,0.025,0.097,
     c 0.101,0.159,-.139,-.009,0.265,0.259,0.063,0.191,0.023,0.097,
     c 0.106,0.167,-.143,-.008,0.265,0.262,0.066,0.193,0.024,0.098,
     c 0.108,0.169,-.149,-.007,0.264,0.263,0.066,0.195,0.025,0.098,
     c 0.105,0.168,-.153,-.005,0.263,0.264,0.067,0.197,0.026,0.096,
     c 0.097,0.164,-.155,-.002,0.261,0.265,0.066,0.197,0.028,0.094,
     c 0.087,0.159,-.154,0.002,0.258,0.267,0.066,0.196,0.027,0.094,
     c 0.079,0.155,-.152,0.007,0.257,0.268,0.064,0.195,0.027,0.099,
     c 0.072,0.153,-.151,0.012,0.255,0.266,0.061,0.193,0.025,0.102,
     c 0.065,0.150,-.152,0.015,0.255,0.262,0.058,0.189,0.022,0.100,
     c 0.057,0.149,-.156,0.017,0.256,0.257,0.054,0.185,0.019,0.092,
     c 0.047,0.146,-.162,0.017,0.256,0.250,0.050,0.178,0.014,0.083,
     c 0.041,0.143,-.170,0.018,0.253,0.242,0.045,0.171,0.008,0.077,
     c 0.036,0.141,-.178,0.020,0.247,0.236,0.038,0.163,-.000,0.069,
     c 0.028,0.137,-.187,0.022,0.239,0.229,0.030,0.155,-.009,0.062,
     c 0.015,0.129,-.196,0.025,0.229,0.224,0.023,0.148,-.016,0.052,
     c 0.003,0.117,-.204,0.028,0.221,0.219,0.018,0.143,-.022,0.045,
     c -.004,0.105,-.210,0.030,0.213,0.214,0.013,0.139,-.024,0.040,
     c -.008,0.096,-.215,0.032,0.207,0.209,0.008,0.138,-.023,0.039,
     c -.012,0.088,-.223,0.031,0.198,0.201,-.000,0.135,-.023,0.036,
     c -.019,0.081,-.234,0.028,0.187,0.193,-.007,0.129,-.028,0.029,
     c -.029,0.075,-.246,0.023,0.178,0.185,-.016,0.121,-.035,0.020,
     c -.040,0.070,-.254,0.017,0.172,0.176,-.023,0.112,-.043,0.010,
     c -.049,0.064,-.259,0.010,0.167,0.169,-.028,0.104,-.050,-.001,
     c -.059,0.062,-.261,0.000,0.163,0.163,-.032,0.097,-.056,-.012,
     c -.069,0.060,-.264,-.010,0.161,0.159,-.036,0.092,-.061,-.020,
     c -.076,0.062,-.265,-.018,0.158,0.159,-.039,0.090,-.061,-.022,
     c -.083,0.064,-.265,-.026,0.155,0.157,-.044,0.091,-.059,-.023,
     c -.091,0.063,-.267,-.036,0.152,0.154,-.049,0.090,-.059,-.027,
     c 0.133,0.096,-.138,0.010,0.209,0.213,0.054,0.142,-.006,0.074,
     c 0.130,0.090,-.146,0.009,0.207,0.207,0.049,0.136,-.011,0.065,
     c 0.127,0.084,-.155,0.012,0.208,0.202,0.045,0.129,-.015,0.056,
     c 0.125,0.079,-.162,0.012,0.206,0.197,0.039,0.123,-.021,0.044,
     c 0.120,0.076,-.168,0.008,0.203,0.192,0.034,0.118,-.025,0.035,
     c 0.114,0.078,-.173,0.001,0.200,0.189,0.028,0.116,-.030,0.031,
     c 0.110,0.081,-.178,-.007,0.195,0.187,0.024,0.112,-.035,0.032,
     c 0.106,0.082,-.184,-.015,0.186,0.184,0.020,0.106,-.040,0.031,
     c 0.105,0.082,-.190,-.019,0.176,0.181,0.015,0.101,-.042,0.029,
     c 0.103,0.080,-.193,-.019,0.166,0.181,0.012,0.101,-.042,0.028,
     c 0.097,0.077,-.193,-.016,0.159,0.183,0.010,0.103,-.039,0.029,
     c 0.089,0.074,-.193,-.013,0.154,0.184,0.011,0.105,-.035,0.030,
     c 0.085,0.071,-.194,-.010,0.148,0.183,0.012,0.106,-.028,0.031,
     c 0.090,0.072,-.194,-.007,0.143,0.181,0.011,0.109,-.022,0.035,
     c 0.101,0.077,-.192,-.001,0.142,0.182,0.012,0.114,-.016,0.043,
     c 0.107,0.081,-.190,0.005,0.146,0.184,0.013,0.118,-.011,0.051,
     c 0.105,0.086,-.186,0.010,0.152,0.191,0.015,0.121,-.007,0.056,
     c 0.100,0.089,-.182,0.015,0.160,0.197,0.020,0.125,-.002,0.059,
     c 0.095,0.094,-.179,0.017,0.167,0.203,0.027,0.129,0.002,0.060,
     c 0.094,0.098,-.179,0.015,0.174,0.207,0.031,0.134,0.003,0.061,
     c 0.094,0.100,-.178,0.010,0.182,0.209,0.034,0.136,0.001,0.059,
     c 0.096,0.103,-.177,0.003,0.193,0.210,0.036,0.137,0.000,0.056,
     c 0.100,0.109,-.172,-.004,0.207,0.212,0.038,0.138,0.002,0.057,
     c 0.101,0.115,-.168,-.010,0.220,0.216,0.038,0.140,0.005,0.065,
     c 0.099,0.126,-.165,-.013,0.232,0.219,0.038,0.146,0.009,0.078,
     c 0.094,0.135,-.160,-.013,0.242,0.224,0.044,0.154,0.013,0.090,
     c 0.092,0.141,-.155,-.010,0.251,0.229,0.051,0.161,0.018,0.095,
     c 0.093,0.144,-.151,-.006,0.259,0.235,0.056,0.166,0.024,0.092,
     c 0.094,0.146,-.147,-.004,0.266,0.240,0.059,0.166,0.028,0.086,
     c 0.096,0.149,-.143,-.003,0.269,0.246,0.060,0.170,0.028,0.083,
     c 0.098,0.154,-.139,-.003,0.273,0.252,0.063,0.176,0.031,0.087,
     c 0.103,0.155,-.135,-.003,0.275,0.256,0.066,0.183,0.033,0.095,
     c 0.108,0.154,-.134,-.004,0.275,0.258,0.066,0.186,0.035,0.104,
     c 0.110,0.152,-.133,-.004,0.273,0.257,0.065,0.186,0.034,0.107,
     c 0.107,0.149,-.134,-.005,0.269,0.255,0.062,0.186,0.029,0.104,
     c 0.100,0.149,-.135,-.007,0.264,0.253,0.059,0.187,0.024,0.098,
     c 0.096,0.153,-.138,-.009,0.260,0.254,0.058,0.189,0.020,0.096,
     c 0.097,0.158,-.142,-.010,0.258,0.256,0.060,0.188,0.018,0.097,
     c 0.101,0.165,-.146,-.009,0.257,0.258,0.063,0.189,0.018,0.098,
     c 0.103,0.167,-.152,-.008,0.256,0.259,0.064,0.191,0.019,0.098,
     c 0.100,0.165,-.157,-.006,0.255,0.260,0.065,0.193,0.021,0.095,
     c 0.092,0.161,-.160,-.002,0.255,0.261,0.065,0.195,0.024,0.092,
     c 0.083,0.156,-.159,0.003,0.254,0.265,0.066,0.196,0.025,0.092,
     c 0.078,0.152,-.155,0.008,0.254,0.267,0.064,0.195,0.027,0.098,
     c 0.074,0.150,-.153,0.014,0.253,0.266,0.062,0.194,0.026,0.103,
     c 0.070,0.147,-.153,0.018,0.253,0.262,0.059,0.190,0.023,0.103,
     c 0.062,0.146,-.156,0.021,0.254,0.258,0.056,0.187,0.021,0.099,
     c 0.052,0.144,-.163,0.022,0.253,0.251,0.052,0.181,0.016,0.093,
     c 0.047,0.142,-.169,0.024,0.252,0.244,0.047,0.175,0.011,0.087,
     c 0.043,0.143,-.177,0.027,0.246,0.238,0.040,0.168,0.003,0.079,
     c 0.036,0.141,-.185,0.030,0.238,0.232,0.033,0.159,-.005,0.069,
     c 0.024,0.134,-.194,0.032,0.229,0.227,0.026,0.151,-.014,0.058,
     c 0.010,0.123,-.202,0.033,0.220,0.222,0.020,0.146,-.020,0.049,
     c 0.000,0.110,-.209,0.034,0.213,0.216,0.015,0.143,-.022,0.044,
     c -.005,0.100,-.215,0.034,0.206,0.209,0.008,0.141,-.021,0.042,
     c -.010,0.092,-.224,0.032,0.196,0.199,-.000,0.137,-.022,0.036,
     c -.017,0.085,-.234,0.027,0.185,0.190,-.009,0.130,-.028,0.027,
     c -.026,0.079,-.246,0.021,0.176,0.182,-.018,0.121,-.035,0.017,
     c -.035,0.073,-.253,0.015,0.170,0.175,-.025,0.112,-.043,0.006,
     c -.045,0.065,-.257,0.007,0.166,0.168,-.031,0.105,-.050,-.004,
     c -.055,0.060,-.261,-.002,0.163,0.163,-.034,0.099,-.057,-.015,
     c -.065,0.058,-.263,-.011,0.161,0.159,-.037,0.093,-.061,-.022,
     c -.073,0.060,-.264,-.019,0.159,0.159,-.039,0.092,-.062,-.024,
     c -.081,0.062,-.263,-.027,0.155,0.156,-.044,0.092,-.060,-.023,
     c -.089,0.061,-.265,-.037,0.153,0.152,-.048,0.090,-.060,-.026,
     c 0.138,0.100,-.134,0.012,0.215,0.217,0.057,0.147,-.003,0.077,
     c 0.134,0.094,-.143,0.011,0.212,0.211,0.052,0.140,-.009,0.067,
     c 0.129,0.089,-.153,0.013,0.210,0.202,0.045,0.131,-.015,0.054,
     c 0.125,0.084,-.162,0.012,0.206,0.196,0.039,0.123,-.021,0.042,
     c 0.119,0.081,-.167,0.008,0.203,0.192,0.032,0.118,-.025,0.034,
     c 0.112,0.082,-.171,0.002,0.200,0.189,0.026,0.117,-.029,0.031,
     c 0.107,0.084,-.176,-.006,0.196,0.188,0.021,0.114,-.032,0.033,
     c 0.104,0.084,-.183,-.013,0.187,0.183,0.018,0.107,-.037,0.033,
     c 0.105,0.084,-.189,-.018,0.177,0.179,0.013,0.102,-.039,0.031,
     c 0.105,0.082,-.192,-.017,0.167,0.179,0.011,0.101,-.041,0.030,
     c 0.100,0.080,-.193,-.015,0.162,0.182,0.010,0.104,-.039,0.032,
     c 0.091,0.077,-.193,-.012,0.156,0.183,0.010,0.105,-.035,0.033,
     c 0.086,0.074,-.194,-.010,0.151,0.183,0.010,0.107,-.028,0.035,
     c 0.090,0.076,-.194,-.006,0.145,0.182,0.009,0.111,-.021,0.039,
     c 0.099,0.082,-.192,-.000,0.145,0.183,0.011,0.117,-.014,0.047,
     c 0.105,0.087,-.188,0.007,0.149,0.187,0.013,0.122,-.008,0.055,
     c 0.104,0.092,-.184,0.013,0.155,0.193,0.017,0.124,-.004,0.058,
     c 0.100,0.096,-.180,0.018,0.163,0.200,0.023,0.126,0.001,0.060,
     c 0.097,0.100,-.178,0.019,0.170,0.206,0.029,0.129,0.004,0.062,
     c 0.094,0.103,-.177,0.017,0.177,0.210,0.033,0.134,0.005,0.064,
     c 0.092,0.103,-.177,0.012,0.185,0.212,0.035,0.136,0.003,0.064,
     c 0.091,0.104,-.177,0.005,0.196,0.213,0.036,0.137,0.000,0.061,
     c 0.095,0.109,-.172,-.001,0.210,0.214,0.037,0.137,0.001,0.062,
     c 0.100,0.116,-.167,-.006,0.223,0.218,0.037,0.138,0.002,0.070,
     c 0.102,0.125,-.162,-.008,0.236,0.222,0.039,0.143,0.005,0.082,
     c 0.099,0.133,-.156,-.008,0.247,0.228,0.045,0.152,0.009,0.092,
     c 0.098,0.137,-.150,-.006,0.256,0.233,0.052,0.161,0.016,0.095,
     c 0.098,0.140,-.146,-.005,0.264,0.238,0.056,0.167,0.023,0.092,
     c 0.100,0.142,-.143,-.004,0.268,0.242,0.057,0.167,0.026,0.087,
     c 0.101,0.146,-.142,-.005,0.270,0.246,0.057,0.169,0.026,0.084,
     c 0.103,0.150,-.139,-.005,0.271,0.250,0.058,0.175,0.027,0.089,
     c 0.107,0.151,-.138,-.005,0.271,0.254,0.060,0.180,0.029,0.097,
     c 0.111,0.151,-.137,-.005,0.270,0.256,0.061,0.184,0.031,0.104,
     c 0.111,0.150,-.137,-.005,0.268,0.256,0.060,0.185,0.030,0.105,
     c 0.105,0.148,-.138,-.005,0.265,0.255,0.058,0.185,0.026,0.101,
     c 0.097,0.149,-.138,-.007,0.261,0.253,0.055,0.186,0.021,0.097,
     c 0.092,0.153,-.140,-.009,0.256,0.254,0.055,0.187,0.017,0.095,
     c 0.091,0.158,-.144,-.010,0.252,0.254,0.056,0.186,0.015,0.097,
     c 0.094,0.163,-.148,-.009,0.251,0.255,0.059,0.186,0.015,0.099,
     c 0.096,0.164,-.155,-.008,0.249,0.255,0.060,0.187,0.016,0.098,
     c 0.094,0.162,-.160,-.007,0.247,0.255,0.061,0.189,0.018,0.095,
     c 0.088,0.157,-.164,-.003,0.247,0.257,0.062,0.192,0.021,0.091,
     c 0.081,0.153,-.164,0.002,0.248,0.261,0.064,0.194,0.023,0.091,
     c 0.078,0.150,-.161,0.009,0.250,0.264,0.063,0.195,0.025,0.096,
     c 0.077,0.148,-.157,0.015,0.251,0.265,0.060,0.194,0.024,0.101,
     c 0.074,0.145,-.157,0.019,0.251,0.262,0.058,0.190,0.021,0.102,
     c 0.067,0.144,-.159,0.023,0.251,0.258,0.055,0.187,0.020,0.100,
     c 0.059,0.142,-.164,0.026,0.251,0.252,0.051,0.183,0.016,0.096,
     c 0.054,0.142,-.170,0.029,0.250,0.246,0.047,0.178,0.013,0.092,
     c 0.050,0.144,-.177,0.033,0.245,0.241,0.042,0.172,0.007,0.084,
     c 0.044,0.144,-.184,0.036,0.238,0.235,0.035,0.165,-.001,0.074,
     c 0.031,0.139,-.193,0.038,0.229,0.230,0.029,0.157,-.009,0.063,
     c 0.016,0.128,-.201,0.038,0.220,0.225,0.022,0.152,-.015,0.055,
     c 0.004,0.115,-.209,0.037,0.212,0.219,0.017,0.148,-.018,0.051,
     c -.004,0.105,-.215,0.036,0.205,0.211,0.010,0.146,-.017,0.047,
     c -.010,0.097,-.224,0.032,0.196,0.199,0.001,0.141,-.020,0.039,
     c -.017,0.090,-.234,0.027,0.185,0.190,-.008,0.132,-.026,0.028,
     c -.024,0.085,-.244,0.021,0.176,0.182,-.017,0.123,-.034,0.016,
     c -.032,0.079,-.250,0.014,0.170,0.176,-.025,0.116,-.041,0.007,
     c -.040,0.070,-.254,0.007,0.166,0.170,-.031,0.109,-.048,-.002,
     c -.051,0.064,-.258,-.002,0.163,0.164,-.035,0.104,-.054,-.013,
     c -.062,0.060,-.260,-.012,0.161,0.160,-.038,0.098,-.060,-.020,
     c -.070,0.061,-.261,-.020,0.159,0.158,-.039,0.095,-.061,-.022,
     c -.079,0.061,-.261,-.028,0.156,0.155,-.044,0.094,-.060,-.023,
     c -.087,0.058,-.263,-.037,0.153,0.151,-.048,0.091,-.061,-.026,
     c 0.143,0.104,-.130,0.014,0.222,0.222,0.061,0.152,-.000,0.080,
     c 0.137,0.098,-.139,0.012,0.217,0.215,0.054,0.144,-.006,0.070,
     c 0.130,0.093,-.152,0.012,0.211,0.204,0.045,0.134,-.015,0.056,
     c 0.125,0.088,-.161,0.010,0.205,0.197,0.038,0.125,-.021,0.044,
     c 0.119,0.086,-.166,0.006,0.202,0.193,0.032,0.120,-.025,0.037,
     c 0.111,0.086,-.171,0.000,0.200,0.192,0.026,0.119,-.028,0.035,
     c 0.106,0.087,-.176,-.006,0.197,0.191,0.023,0.116,-.029,0.037,
     c 0.103,0.087,-.182,-.012,0.189,0.186,0.019,0.110,-.032,0.036,
     c 0.105,0.086,-.188,-.016,0.179,0.181,0.016,0.105,-.035,0.033,
     c 0.107,0.086,-.190,-.015,0.171,0.181,0.014,0.104,-.037,0.032,
     c 0.104,0.085,-.190,-.012,0.166,0.183,0.012,0.106,-.036,0.032,
     c 0.095,0.083,-.190,-.009,0.161,0.185,0.012,0.107,-.033,0.033,
     c 0.089,0.080,-.191,-.007,0.155,0.185,0.011,0.108,-.027,0.034,
     c 0.090,0.082,-.190,-.003,0.149,0.184,0.010,0.113,-.020,0.038,
     c 0.098,0.088,-.187,0.004,0.149,0.186,0.012,0.120,-.012,0.046,
     c 0.103,0.092,-.183,0.011,0.153,0.190,0.015,0.125,-.006,0.053,
     c 0.102,0.097,-.180,0.018,0.159,0.196,0.020,0.127,-.001,0.056,
     c 0.099,0.101,-.176,0.022,0.166,0.202,0.026,0.128,0.003,0.058,
     c 0.097,0.105,-.174,0.022,0.174,0.207,0.031,0.130,0.006,0.061,
     c 0.093,0.108,-.173,0.019,0.181,0.211,0.034,0.134,0.006,0.065,
     c 0.089,0.106,-.174,0.013,0.189,0.214,0.036,0.136,0.003,0.067,
     c 0.086,0.105,-.174,0.005,0.199,0.214,0.036,0.137,0.000,0.065,
     c 0.091,0.109,-.170,-.000,0.213,0.216,0.037,0.136,-.001,0.067,
     c 0.099,0.115,-.164,-.004,0.226,0.220,0.038,0.136,-.001,0.074,
     c 0.104,0.124,-.158,-.004,0.240,0.225,0.041,0.141,0.001,0.085,
     c 0.106,0.131,-.151,-.004,0.252,0.231,0.048,0.151,0.006,0.094,
     c 0.105,0.134,-.146,-.003,0.261,0.237,0.053,0.161,0.014,0.098,
     c 0.104,0.136,-.143,-.003,0.268,0.242,0.056,0.168,0.022,0.095,
     c 0.105,0.139,-.141,-.004,0.271,0.244,0.055,0.168,0.025,0.091,
     c 0.106,0.143,-.141,-.006,0.270,0.247,0.053,0.169,0.024,0.089,
     c 0.108,0.147,-.140,-.006,0.270,0.249,0.053,0.173,0.024,0.094,
     c 0.110,0.148,-.140,-.006,0.269,0.252,0.055,0.177,0.026,0.100,
     c 0.111,0.148,-.140,-.005,0.268,0.255,0.057,0.180,0.027,0.105,
     c 0.108,0.147,-.141,-.005,0.267,0.256,0.057,0.182,0.027,0.105,
     c 0.101,0.147,-.141,-.005,0.264,0.255,0.055,0.183,0.023,0.100,
     c 0.092,0.149,-.141,-.007,0.260,0.254,0.053,0.184,0.020,0.095,
     c 0.087,0.153,-.143,-.009,0.254,0.255,0.052,0.185,0.016,0.094,
     c 0.085,0.157,-.146,-.011,0.248,0.254,0.053,0.184,0.014,0.096,
     c 0.087,0.162,-.150,-.010,0.245,0.253,0.055,0.184,0.014,0.097,
     c 0.089,0.161,-.156,-.009,0.241,0.251,0.056,0.184,0.015,0.097,
     c 0.089,0.159,-.162,-.007,0.240,0.251,0.057,0.186,0.016,0.094,
     c 0.084,0.155,-.167,-.003,0.240,0.253,0.059,0.190,0.020,0.091,
     c 0.079,0.152,-.168,0.002,0.242,0.258,0.062,0.193,0.022,0.090,
     c 0.077,0.150,-.165,0.008,0.246,0.261,0.061,0.194,0.023,0.093,
     c 0.077,0.148,-.162,0.014,0.248,0.262,0.059,0.194,0.022,0.097,
     c 0.076,0.145,-.161,0.018,0.249,0.260,0.057,0.190,0.019,0.097,
     c 0.070,0.143,-.162,0.022,0.249,0.257,0.053,0.186,0.017,0.094,
     c 0.062,0.141,-.167,0.026,0.248,0.252,0.049,0.182,0.015,0.091,
     c 0.057,0.140,-.172,0.031,0.248,0.247,0.045,0.179,0.013,0.088,
     c 0.053,0.143,-.177,0.036,0.244,0.243,0.041,0.175,0.009,0.081,
     c 0.047,0.145,-.184,0.039,0.238,0.237,0.037,0.169,0.003,0.072,
     c 0.035,0.142,-.192,0.041,0.229,0.232,0.032,0.162,-.003,0.063,
     c 0.019,0.133,-.200,0.041,0.220,0.228,0.025,0.157,-.009,0.057,
     c 0.006,0.121,-.208,0.039,0.212,0.222,0.019,0.152,-.012,0.054,
     c -.004,0.110,-.215,0.037,0.205,0.213,0.013,0.149,-.013,0.050,
     c -.012,0.102,-.223,0.032,0.196,0.201,0.004,0.143,-.017,0.040,
     c -.018,0.095,-.232,0.027,0.186,0.192,-.004,0.134,-.024,0.028,
     c -.023,0.091,-.240,0.021,0.178,0.184,-.014,0.126,-.032,0.018,
     c -.029,0.085,-.246,0.014,0.173,0.179,-.021,0.120,-.038,0.010,
     c -.037,0.077,-.249,0.007,0.168,0.173,-.028,0.115,-.045,0.003,
     c -.048,0.070,-.253,-.002,0.164,0.167,-.034,0.109,-.052,-.008,
     c -.060,0.065,-.256,-.011,0.161,0.161,-.037,0.102,-.058,-.017,
     c -.068,0.063,-.257,-.019,0.158,0.159,-.039,0.099,-.060,-.020,
     c -.076,0.058,-.259,-.028,0.155,0.154,-.044,0.095,-.060,-.023,
     c -.084,0.054,-.261,-.037,0.152,0.150,-.048,0.092,-.062,-.026,
     c 0.147,0.107,-.127,0.014,0.228,0.227,0.064,0.157,0.005,0.083,
     c 0.141,0.101,-.136,0.011,0.221,0.219,0.057,0.149,-.002,0.072,
     c 0.132,0.096,-.147,0.010,0.213,0.209,0.047,0.139,-.012,0.060,
     c 0.127,0.092,-.157,0.007,0.205,0.201,0.040,0.130,-.020,0.048,
     c 0.121,0.089,-.163,0.003,0.201,0.197,0.035,0.124,-.024,0.043,
     c 0.114,0.089,-.168,-.002,0.201,0.196,0.030,0.122,-.025,0.041,
     c 0.108,0.088,-.173,-.006,0.199,0.196,0.028,0.120,-.025,0.042,
     c 0.104,0.088,-.179,-.011,0.193,0.191,0.025,0.115,-.027,0.040,
     c 0.107,0.088,-.185,-.013,0.184,0.186,0.021,0.111,-.030,0.037,
     c 0.109,0.090,-.187,-.012,0.175,0.185,0.018,0.109,-.032,0.033,
     c 0.107,0.091,-.186,-.008,0.170,0.186,0.016,0.110,-.032,0.031,
     c 0.100,0.090,-.185,-.005,0.165,0.189,0.015,0.112,-.030,0.030,
     c 0.095,0.088,-.185,-.002,0.159,0.189,0.014,0.113,-.024,0.030,
     c 0.095,0.089,-.183,0.002,0.154,0.189,0.013,0.118,-.018,0.033,
     c 0.101,0.094,-.180,0.010,0.155,0.191,0.016,0.125,-.010,0.041,
     c 0.105,0.097,-.177,0.018,0.159,0.194,0.019,0.130,-.004,0.048,
     c 0.103,0.101,-.174,0.024,0.164,0.199,0.023,0.133,-.000,0.051,
     c 0.100,0.104,-.172,0.026,0.171,0.203,0.028,0.132,0.004,0.054,
     c 0.097,0.109,-.170,0.025,0.178,0.207,0.032,0.132,0.006,0.059,
     c 0.093,0.112,-.170,0.020,0.186,0.210,0.033,0.134,0.006,0.065,
     c 0.088,0.111,-.171,0.013,0.193,0.213,0.034,0.136,0.004,0.068,
     c 0.084,0.110,-.172,0.005,0.202,0.214,0.034,0.136,0.001,0.068,
     c 0.089,0.111,-.168,-.000,0.216,0.216,0.035,0.135,-.001,0.070,
     c 0.097,0.116,-.163,-.003,0.229,0.220,0.038,0.135,-.002,0.076,
     c 0.105,0.123,-.157,-.002,0.243,0.226,0.042,0.139,-.000,0.085,
     c 0.108,0.130,-.151,-.001,0.256,0.233,0.049,0.150,0.005,0.094,
     c 0.108,0.133,-.146,-.001,0.266,0.239,0.054,0.160,0.014,0.097,
     c 0.107,0.136,-.144,-.002,0.272,0.243,0.055,0.168,0.022,0.096,
     c 0.106,0.138,-.144,-.004,0.274,0.245,0.053,0.168,0.025,0.093,
     c 0.107,0.142,-.145,-.006,0.271,0.246,0.051,0.169,0.025,0.093,
     c 0.108,0.146,-.144,-.006,0.270,0.248,0.052,0.171,0.025,0.098,
     c 0.108,0.145,-.143,-.006,0.268,0.251,0.054,0.174,0.026,0.105,
     c 0.108,0.145,-.143,-.005,0.267,0.253,0.056,0.177,0.027,0.108,
     c 0.104,0.144,-.144,-.004,0.266,0.254,0.057,0.180,0.026,0.106,
     c 0.097,0.144,-.144,-.005,0.264,0.254,0.056,0.181,0.023,0.099,
     c 0.087,0.147,-.145,-.007,0.259,0.254,0.053,0.183,0.020,0.094,
     c 0.081,0.152,-.146,-.009,0.252,0.255,0.052,0.184,0.016,0.092,
     c 0.079,0.156,-.149,-.011,0.245,0.254,0.052,0.183,0.014,0.092,
     c 0.082,0.160,-.152,-.009,0.240,0.252,0.053,0.183,0.014,0.093,
     c 0.084,0.159,-.157,-.008,0.235,0.250,0.053,0.183,0.015,0.093,
     c 0.083,0.157,-.162,-.006,0.233,0.249,0.055,0.185,0.017,0.092,
     c 0.080,0.154,-.168,-.002,0.234,0.251,0.057,0.189,0.021,0.091,
     c 0.076,0.151,-.169,0.002,0.237,0.255,0.060,0.192,0.023,0.090,
     c 0.075,0.150,-.167,0.007,0.242,0.258,0.060,0.194,0.023,0.091,
     c 0.074,0.148,-.165,0.012,0.245,0.259,0.058,0.193,0.021,0.092,
     c 0.073,0.143,-.164,0.015,0.246,0.257,0.056,0.188,0.017,0.089,
     c 0.068,0.141,-.166,0.019,0.245,0.255,0.052,0.184,0.015,0.085,
     c 0.061,0.139,-.171,0.023,0.244,0.251,0.047,0.180,0.012,0.081,
     c 0.055,0.138,-.175,0.029,0.243,0.247,0.042,0.177,0.012,0.078,
     c 0.050,0.141,-.179,0.035,0.240,0.243,0.040,0.174,0.010,0.073,
     c 0.045,0.144,-.185,0.040,0.235,0.237,0.037,0.170,0.006,0.066,
     c 0.034,0.144,-.192,0.042,0.228,0.232,0.033,0.164,0.001,0.059,
     c 0.020,0.137,-.200,0.042,0.220,0.228,0.027,0.159,-.004,0.055,
     c 0.006,0.125,-.207,0.040,0.211,0.222,0.021,0.153,-.008,0.054,
     c -.005,0.114,-.214,0.037,0.204,0.215,0.015,0.150,-.010,0.050,
     c -.013,0.105,-.222,0.033,0.197,0.204,0.007,0.143,-.016,0.039,
     c -.019,0.097,-.230,0.027,0.188,0.194,-.001,0.135,-.024,0.027,
     c -.023,0.093,-.237,0.021,0.182,0.187,-.010,0.127,-.031,0.018,
     c -.028,0.088,-.242,0.015,0.176,0.182,-.018,0.122,-.037,0.013,
     c -.036,0.081,-.245,0.007,0.171,0.176,-.026,0.117,-.043,0.005,
     c -.047,0.074,-.249,-.001,0.166,0.169,-.032,0.112,-.051,-.006,
     c -.059,0.068,-.252,-.011,0.161,0.162,-.037,0.105,-.058,-.017,
     c -.066,0.064,-.254,-.019,0.158,0.159,-.039,0.101,-.060,-.021,
     c -.073,0.055,-.257,-.028,0.155,0.154,-.045,0.097,-.060,-.022,
     c -.080,0.049,-.259,-.037,0.152,0.149,-.049,0.093,-.062,-.026,
     c 0.152,0.111,-.124,0.013,0.234,0.231,0.067,0.160,0.010,0.085,
     c 0.145,0.105,-.133,0.010,0.226,0.222,0.059,0.152,0.003,0.075,
     c 0.136,0.099,-.141,0.008,0.217,0.215,0.050,0.145,-.005,0.063,
     c 0.130,0.094,-.150,0.004,0.207,0.206,0.042,0.136,-.015,0.052,
     c 0.125,0.091,-.156,0.001,0.203,0.201,0.037,0.129,-.021,0.048,
     c 0.119,0.089,-.162,-.003,0.202,0.200,0.034,0.127,-.022,0.047,
     c 0.112,0.088,-.167,-.006,0.201,0.200,0.033,0.125,-.022,0.048,
     c 0.107,0.087,-.174,-.009,0.195,0.196,0.030,0.120,-.023,0.045,
     c 0.108,0.089,-.180,-.010,0.187,0.190,0.026,0.117,-.026,0.041,
     c 0.110,0.092,-.182,-.008,0.178,0.188,0.023,0.115,-.029,0.036,
     c 0.110,0.096,-.182,-.004,0.172,0.189,0.019,0.115,-.028,0.032,
     c 0.106,0.097,-.181,0.000,0.167,0.191,0.018,0.117,-.026,0.028,
     c 0.102,0.095,-.180,0.003,0.162,0.192,0.018,0.119,-.021,0.028,
     c 0.102,0.095,-.178,0.008,0.158,0.192,0.018,0.124,-.015,0.031,
     c 0.106,0.098,-.175,0.016,0.160,0.194,0.021,0.131,-.009,0.038,
     c 0.109,0.099,-.173,0.023,0.164,0.197,0.023,0.136,-.004,0.045,
     c 0.107,0.102,-.171,0.028,0.168,0.201,0.026,0.138,-.000,0.048,
     c 0.103,0.105,-.170,0.029,0.175,0.203,0.028,0.136,0.003,0.051,
     c 0.099,0.111,-.169,0.026,0.183,0.206,0.030,0.135,0.004,0.056,
     c 0.095,0.116,-.169,0.020,0.190,0.209,0.030,0.135,0.004,0.063,
     c 0.090,0.116,-.170,0.012,0.197,0.212,0.031,0.136,0.003,0.067,
     c 0.086,0.115,-.171,0.004,0.206,0.214,0.031,0.136,0.001,0.068,
     c 0.088,0.115,-.168,-.001,0.218,0.216,0.033,0.135,-.000,0.070,
     c 0.094,0.117,-.164,-.003,0.231,0.220,0.036,0.135,-.002,0.076,
     c 0.101,0.123,-.160,-.002,0.245,0.226,0.040,0.139,-.000,0.084,
     c 0.105,0.130,-.155,-.001,0.258,0.233,0.047,0.150,0.006,0.092,
     c 0.106,0.134,-.151,-.002,0.267,0.239,0.051,0.160,0.014,0.096,
     c 0.105,0.136,-.150,-.003,0.273,0.243,0.052,0.167,0.022,0.096,
     c 0.105,0.139,-.149,-.005,0.275,0.244,0.050,0.168,0.026,0.095,
     c 0.106,0.142,-.149,-.007,0.272,0.245,0.049,0.169,0.026,0.096,
     c 0.106,0.146,-.148,-.006,0.271,0.248,0.051,0.171,0.028,0.102,
     c 0.106,0.145,-.147,-.004,0.269,0.250,0.055,0.174,0.029,0.109,
     c 0.105,0.143,-.146,-.003,0.267,0.252,0.058,0.178,0.029,0.112,
     c 0.102,0.142,-.146,-.003,0.265,0.253,0.059,0.180,0.027,0.109,
     c 0.096,0.142,-.147,-.004,0.262,0.253,0.057,0.182,0.023,0.102,
     c 0.087,0.144,-.147,-.008,0.257,0.253,0.054,0.183,0.020,0.095,
     c 0.080,0.149,-.149,-.010,0.249,0.254,0.052,0.184,0.016,0.091,
     c 0.078,0.153,-.151,-.010,0.241,0.254,0.051,0.183,0.015,0.090,
     c 0.079,0.157,-.153,-.008,0.235,0.252,0.052,0.184,0.016,0.090,
     c 0.080,0.157,-.157,-.005,0.230,0.250,0.053,0.184,0.017,0.090,
     c 0.078,0.155,-.161,-.003,0.228,0.248,0.054,0.186,0.019,0.090,
     c 0.075,0.153,-.166,-.000,0.229,0.249,0.055,0.189,0.022,0.090,
     c 0.072,0.150,-.169,0.003,0.233,0.253,0.058,0.191,0.023,0.090,
     c 0.070,0.148,-.168,0.006,0.238,0.255,0.058,0.192,0.022,0.089,
     c 0.069,0.146,-.168,0.009,0.241,0.256,0.056,0.190,0.019,0.087,
     c 0.066,0.141,-.169,0.011,0.241,0.254,0.053,0.185,0.014,0.083,
     c 0.061,0.139,-.172,0.015,0.240,0.252,0.049,0.181,0.012,0.078,
     c 0.054,0.136,-.176,0.020,0.239,0.248,0.043,0.177,0.010,0.073,
     c 0.048,0.136,-.180,0.026,0.237,0.244,0.039,0.173,0.010,0.070,
     c 0.044,0.139,-.183,0.033,0.235,0.240,0.037,0.171,0.008,0.065,
     c 0.040,0.143,-.187,0.038,0.231,0.235,0.036,0.167,0.007,0.059,
     c 0.032,0.145,-.192,0.041,0.225,0.230,0.034,0.162,0.002,0.053,
     c 0.019,0.139,-.199,0.042,0.218,0.226,0.029,0.157,-.002,0.051,
     c 0.005,0.127,-.206,0.040,0.210,0.222,0.023,0.152,-.006,0.051,
     c -.007,0.115,-.213,0.038,0.204,0.215,0.017,0.149,-.009,0.048,
     c -.014,0.104,-.220,0.033,0.198,0.205,0.010,0.142,-.016,0.038,
     c -.019,0.096,-.227,0.028,0.190,0.197,0.002,0.135,-.024,0.026,
     c -.023,0.092,-.234,0.022,0.184,0.189,-.007,0.127,-.030,0.018,
     c -.028,0.087,-.239,0.015,0.179,0.183,-.016,0.122,-.036,0.013,
     c -.036,0.080,-.243,0.007,0.173,0.177,-.024,0.118,-.042,0.005,
     c -.047,0.074,-.247,-.002,0.167,0.170,-.032,0.113,-.051,-.007,
     c -.058,0.067,-.250,-.011,0.161,0.163,-.038,0.105,-.058,-.018,
     c -.064,0.061,-.252,-.019,0.157,0.160,-.041,0.102,-.061,-.022,
     c -.071,0.052,-.255,-.028,0.155,0.154,-.045,0.098,-.060,-.021,
     c -.078,0.044,-.258,-.037,0.151,0.148,-.050,0.094,-.063,-.025,
     c 0.157,0.113,-.122,0.012,0.240,0.235,0.071,0.162,0.016,0.087,
     c 0.149,0.107,-.130,0.008,0.231,0.226,0.062,0.155,0.008,0.076,
     c 0.139,0.103,-.137,0.006,0.221,0.217,0.051,0.149,0.001,0.064,
     c 0.132,0.097,-.145,0.002,0.210,0.209,0.042,0.141,-.009,0.054,
     c 0.127,0.092,-.151,-.002,0.205,0.204,0.037,0.134,-.016,0.050,
     c 0.121,0.089,-.157,-.005,0.204,0.203,0.036,0.132,-.018,0.051,
     c 0.113,0.087,-.163,-.007,0.202,0.203,0.036,0.130,-.018,0.053,
     c 0.106,0.086,-.170,-.008,0.196,0.199,0.034,0.126,-.020,0.050,
     c 0.106,0.088,-.176,-.008,0.188,0.194,0.030,0.122,-.023,0.046,
     c 0.108,0.092,-.178,-.006,0.178,0.191,0.026,0.119,-.026,0.041,
     c 0.111,0.097,-.179,-.002,0.172,0.190,0.022,0.119,-.026,0.035,
     c 0.109,0.098,-.179,0.002,0.167,0.192,0.021,0.121,-.023,0.031,
     c 0.106,0.097,-.178,0.006,0.163,0.193,0.022,0.124,-.018,0.030,
     c 0.105,0.097,-.176,0.012,0.161,0.194,0.023,0.129,-.013,0.033,
     c 0.109,0.098,-.174,0.019,0.163,0.196,0.025,0.135,-.008,0.040,
     c 0.112,0.098,-.173,0.026,0.166,0.198,0.026,0.139,-.005,0.046,
     c 0.110,0.099,-.172,0.030,0.171,0.201,0.026,0.140,-.003,0.050,
     c 0.106,0.102,-.172,0.029,0.177,0.203,0.026,0.137,-.001,0.051,
     c 0.101,0.109,-.171,0.025,0.185,0.204,0.026,0.135,0.000,0.054,
     c 0.097,0.116,-.171,0.018,0.192,0.207,0.026,0.134,0.000,0.059,
     c 0.094,0.118,-.171,0.009,0.200,0.210,0.026,0.135,-.001,0.064,
     c 0.090,0.118,-.171,0.002,0.208,0.213,0.026,0.136,-.002,0.066,
     c 0.090,0.118,-.169,-.002,0.220,0.216,0.028,0.136,-.002,0.070,
     c 0.092,0.118,-.165,-.003,0.232,0.220,0.032,0.137,-.002,0.076,
     c 0.096,0.124,-.163,-.003,0.245,0.226,0.036,0.142,0.001,0.084,
     c 0.099,0.130,-.160,-.002,0.258,0.232,0.043,0.151,0.006,0.091,
     c 0.102,0.135,-.157,-.003,0.268,0.238,0.047,0.160,0.013,0.095,
     c 0.104,0.138,-.156,-.004,0.274,0.241,0.048,0.166,0.020,0.096,
     c 0.105,0.140,-.155,-.006,0.275,0.242,0.047,0.168,0.025,0.096,
     c 0.106,0.143,-.154,-.006,0.272,0.243,0.047,0.170,0.027,0.099,
     c 0.105,0.147,-.152,-.004,0.271,0.246,0.049,0.173,0.030,0.105,
     c 0.104,0.146,-.150,-.002,0.269,0.249,0.053,0.176,0.031,0.111,
     c 0.103,0.143,-.149,-.001,0.266,0.250,0.057,0.180,0.031,0.113,
     c 0.101,0.141,-.149,-.001,0.263,0.251,0.058,0.183,0.028,0.110,
     c 0.097,0.140,-.149,-.004,0.259,0.250,0.057,0.184,0.023,0.104,
     c 0.089,0.143,-.150,-.007,0.253,0.250,0.053,0.184,0.019,0.097,
     c 0.083,0.147,-.151,-.009,0.245,0.253,0.051,0.185,0.015,0.092,
     c 0.080,0.152,-.152,-.008,0.238,0.253,0.050,0.185,0.015,0.090,
     c 0.079,0.157,-.153,-.004,0.233,0.253,0.052,0.186,0.017,0.089,
     c 0.078,0.157,-.156,-.001,0.228,0.250,0.052,0.187,0.018,0.088,
     c 0.074,0.156,-.159,0.001,0.227,0.249,0.053,0.188,0.020,0.087,
     c 0.070,0.154,-.165,0.002,0.227,0.249,0.053,0.189,0.021,0.086,
     c 0.067,0.150,-.168,0.003,0.229,0.251,0.053,0.189,0.021,0.085,
     c 0.066,0.147,-.170,0.004,0.233,0.252,0.053,0.187,0.019,0.084,
     c 0.064,0.144,-.171,0.005,0.236,0.252,0.051,0.184,0.016,0.081,
     c 0.060,0.140,-.174,0.007,0.235,0.251,0.048,0.180,0.011,0.078,
     c 0.055,0.138,-.177,0.011,0.234,0.249,0.044,0.177,0.010,0.075,
     c 0.047,0.136,-.182,0.017,0.232,0.244,0.040,0.173,0.008,0.070,
     c 0.042,0.136,-.186,0.024,0.231,0.240,0.035,0.169,0.007,0.065,
     c 0.038,0.140,-.188,0.031,0.228,0.237,0.034,0.166,0.006,0.059,
     c 0.035,0.144,-.191,0.036,0.226,0.232,0.033,0.162,0.004,0.052,
     c 0.030,0.145,-.194,0.039,0.222,0.228,0.033,0.158,0.001,0.046,
     c 0.019,0.139,-.199,0.040,0.216,0.224,0.029,0.154,-.003,0.045,
     c 0.005,0.127,-.205,0.039,0.210,0.221,0.025,0.150,-.006,0.046,
     c -.007,0.114,-.211,0.037,0.205,0.216,0.020,0.148,-.009,0.044,
     c -.014,0.102,-.218,0.033,0.199,0.207,0.013,0.143,-.014,0.035,
     c -.017,0.093,-.225,0.028,0.193,0.199,0.005,0.137,-.022,0.024,
     c -.021,0.089,-.231,0.022,0.187,0.190,-.005,0.129,-.027,0.017,
     c -.027,0.085,-.237,0.015,0.181,0.183,-.014,0.124,-.033,0.011,
     c -.036,0.079,-.242,0.006,0.175,0.177,-.023,0.119,-.040,0.003,
     c -.048,0.072,-.246,-.003,0.168,0.170,-.031,0.113,-.049,-.009,
     c -.059,0.064,-.250,-.012,0.162,0.163,-.037,0.106,-.056,-.018,
     c -.064,0.056,-.252,-.020,0.158,0.160,-.040,0.102,-.060,-.021,
     c -.068,0.047,-.255,-.028,0.156,0.155,-.045,0.100,-.060,-.020,
     c -.075,0.038,-.258,-.036,0.152,0.149,-.050,0.096,-.063,-.023,
     c 0.162,0.113,-.121,0.010,0.246,0.237,0.073,0.163,0.020,0.087,
     c 0.153,0.107,-.129,0.006,0.236,0.227,0.064,0.156,0.012,0.077,
     c 0.141,0.104,-.136,0.003,0.225,0.218,0.052,0.150,0.007,0.063,
     c 0.133,0.098,-.143,-.002,0.214,0.209,0.042,0.143,-.004,0.053,
     c 0.127,0.093,-.149,-.005,0.208,0.205,0.036,0.137,-.011,0.050,
     c 0.119,0.090,-.155,-.008,0.206,0.205,0.035,0.134,-.015,0.051,
     c 0.110,0.087,-.160,-.009,0.203,0.205,0.037,0.132,-.015,0.053,
     c 0.101,0.086,-.166,-.009,0.196,0.202,0.036,0.129,-.018,0.052,
     c 0.099,0.088,-.172,-.008,0.187,0.197,0.032,0.125,-.021,0.049,
     c 0.102,0.090,-.175,-.006,0.178,0.194,0.028,0.121,-.024,0.044,
     c 0.107,0.093,-.176,-.002,0.171,0.193,0.024,0.120,-.024,0.039,
     c 0.106,0.095,-.177,0.003,0.167,0.194,0.022,0.122,-.021,0.034,
     c 0.103,0.094,-.176,0.007,0.165,0.195,0.023,0.125,-.017,0.033,
     c 0.101,0.094,-.175,0.012,0.163,0.196,0.023,0.129,-.014,0.035,
     c 0.104,0.095,-.174,0.020,0.165,0.197,0.025,0.133,-.011,0.042,
     c 0.108,0.095,-.173,0.026,0.167,0.198,0.025,0.136,-.009,0.049,
     c 0.108,0.096,-.173,0.029,0.171,0.200,0.024,0.137,-.007,0.052,
     c 0.105,0.099,-.174,0.027,0.177,0.201,0.023,0.135,-.006,0.052,
     c 0.101,0.105,-.173,0.021,0.185,0.202,0.022,0.132,-.006,0.052,
     c 0.098,0.113,-.173,0.014,0.193,0.204,0.021,0.132,-.006,0.055,
     c 0.097,0.118,-.173,0.006,0.200,0.208,0.021,0.133,-.006,0.059,
     c 0.094,0.119,-.172,-.001,0.209,0.211,0.022,0.135,-.005,0.062,
     c 0.093,0.120,-.169,-.004,0.221,0.215,0.024,0.137,-.004,0.068,
     c 0.091,0.119,-.166,-.004,0.233,0.220,0.027,0.140,-.003,0.076,
     c 0.091,0.124,-.165,-.003,0.245,0.226,0.032,0.145,-.000,0.084,
     c 0.094,0.130,-.163,-.003,0.257,0.232,0.039,0.153,0.004,0.091,
     c 0.098,0.135,-.161,-.004,0.267,0.237,0.044,0.160,0.010,0.095,
     c 0.102,0.138,-.159,-.005,0.273,0.239,0.045,0.166,0.017,0.097,
     c 0.105,0.140,-.158,-.006,0.275,0.240,0.044,0.168,0.022,0.098,
     c 0.106,0.143,-.156,-.006,0.272,0.241,0.043,0.171,0.025,0.101,
     c 0.104,0.147,-.154,-.003,0.270,0.243,0.045,0.175,0.028,0.106,
     c 0.101,0.146,-.153,-.000,0.267,0.245,0.049,0.178,0.030,0.109,
     c 0.100,0.143,-.153,0.001,0.264,0.247,0.052,0.181,0.030,0.110,
     c 0.100,0.141,-.152,0.001,0.260,0.247,0.053,0.184,0.027,0.107,
     c 0.099,0.140,-.152,-.002,0.255,0.246,0.051,0.185,0.022,0.101,
     c 0.092,0.143,-.152,-.006,0.249,0.247,0.048,0.185,0.017,0.096,
     c 0.086,0.148,-.152,-.007,0.242,0.250,0.046,0.187,0.014,0.092,
     c 0.082,0.153,-.153,-.006,0.236,0.251,0.047,0.187,0.015,0.091,
     c 0.079,0.158,-.154,-.001,0.232,0.252,0.050,0.189,0.018,0.089,
     c 0.075,0.160,-.156,0.003,0.228,0.250,0.051,0.189,0.019,0.086,
     c 0.069,0.159,-.159,0.004,0.227,0.249,0.051,0.189,0.018,0.082,
     c 0.064,0.156,-.165,0.004,0.226,0.247,0.049,0.188,0.017,0.079,
     c 0.062,0.152,-.169,0.002,0.226,0.248,0.048,0.185,0.015,0.076,
     c 0.062,0.148,-.172,0.001,0.228,0.248,0.047,0.182,0.014,0.075,
     c 0.060,0.144,-.174,0.001,0.229,0.248,0.044,0.179,0.012,0.074,
     c 0.058,0.141,-.178,0.003,0.229,0.247,0.043,0.176,0.010,0.074,
     c 0.053,0.140,-.181,0.008,0.228,0.245,0.041,0.174,0.009,0.073,
     c 0.045,0.139,-.186,0.015,0.227,0.240,0.037,0.170,0.008,0.069,
     c 0.039,0.138,-.190,0.022,0.227,0.236,0.034,0.166,0.006,0.063,
     c 0.035,0.142,-.193,0.029,0.224,0.233,0.032,0.162,0.002,0.055,
     c 0.033,0.145,-.195,0.034,0.223,0.228,0.031,0.158,-.001,0.046,
     c 0.028,0.145,-.197,0.037,0.220,0.225,0.030,0.153,-.004,0.039,
     c 0.018,0.139,-.201,0.038,0.216,0.222,0.028,0.150,-.006,0.037,
     c 0.005,0.126,-.205,0.037,0.210,0.219,0.024,0.148,-.008,0.040,
     c -.006,0.113,-.209,0.036,0.206,0.215,0.021,0.148,-.009,0.040,
     c -.010,0.101,-.215,0.033,0.201,0.208,0.015,0.145,-.013,0.032,
     c -.012,0.092,-.221,0.028,0.195,0.200,0.008,0.140,-.018,0.022,
     c -.015,0.088,-.228,0.022,0.189,0.191,-.002,0.134,-.023,0.014,
     c -.022,0.084,-.235,0.014,0.184,0.183,-.011,0.127,-.029,0.008,
     c -.033,0.078,-.241,0.004,0.178,0.176,-.020,0.121,-.037,0.000,
     c -.046,0.070,-.246,-.005,0.170,0.170,-.029,0.115,-.047,-.010,
     c -.058,0.060,-.250,-.014,0.164,0.164,-.035,0.108,-.055,-.017,
     c -.063,0.051,-.252,-.021,0.160,0.161,-.039,0.104,-.059,-.018,
     c -.066,0.043,-.255,-.028,0.157,0.156,-.044,0.101,-.061,-.017,
     c -.072,0.034,-.258,-.035,0.153,0.150,-.049,0.097,-.064,-.019,
     c 0.167,0.114,-.120,0.009,0.250,0.237,0.074,0.163,0.023,0.087,
     c 0.157,0.107,-.128,0.004,0.240,0.228,0.065,0.156,0.015,0.078,
     c 0.143,0.102,-.137,-.001,0.229,0.217,0.054,0.149,0.009,0.063,
     c 0.133,0.096,-.145,-.006,0.218,0.209,0.043,0.143,-.001,0.053,
     c 0.125,0.092,-.150,-.010,0.212,0.206,0.037,0.136,-.009,0.051,
     c 0.115,0.091,-.156,-.013,0.208,0.206,0.035,0.133,-.013,0.051,
     c 0.104,0.090,-.160,-.013,0.204,0.207,0.037,0.132,-.014,0.053,
     c 0.094,0.089,-.165,-.012,0.196,0.204,0.037,0.129,-.017,0.051,
     c 0.091,0.089,-.169,-.011,0.187,0.200,0.034,0.125,-.020,0.049,
     c 0.095,0.089,-.171,-.008,0.178,0.197,0.030,0.121,-.023,0.046,
     c 0.100,0.089,-.172,-.003,0.173,0.196,0.026,0.119,-.023,0.041,
     c 0.100,0.089,-.173,0.001,0.170,0.197,0.024,0.121,-.020,0.037,
     c 0.096,0.088,-.173,0.005,0.168,0.198,0.023,0.123,-.017,0.034,
     c 0.093,0.089,-.173,0.011,0.165,0.198,0.021,0.125,-.016,0.035,
     c 0.095,0.091,-.172,0.018,0.166,0.198,0.021,0.129,-.014,0.041,
     c 0.100,0.091,-.172,0.024,0.167,0.198,0.022,0.132,-.013,0.049,
     c 0.102,0.094,-.174,0.026,0.171,0.198,0.021,0.133,-.012,0.053,
     c 0.100,0.096,-.174,0.024,0.177,0.198,0.020,0.131,-.010,0.053,
     c 0.098,0.103,-.174,0.018,0.185,0.200,0.019,0.129,-.010,0.051,
     c 0.097,0.111,-.174,0.011,0.192,0.202,0.018,0.130,-.009,0.052,
     c 0.098,0.116,-.174,0.003,0.199,0.206,0.018,0.132,-.008,0.054,
     c 0.097,0.119,-.174,-.004,0.208,0.209,0.019,0.135,-.007,0.058,
     c 0.096,0.120,-.171,-.006,0.220,0.214,0.020,0.138,-.005,0.066,
     c 0.091,0.120,-.168,-.006,0.231,0.219,0.023,0.142,-.004,0.074,
     c 0.088,0.123,-.167,-.005,0.243,0.225,0.028,0.147,-.001,0.082,
     c 0.089,0.129,-.165,-.005,0.254,0.230,0.036,0.155,0.002,0.089,
     c 0.094,0.132,-.163,-.006,0.264,0.235,0.042,0.161,0.007,0.094,
     c 0.100,0.135,-.161,-.007,0.270,0.238,0.043,0.166,0.013,0.097,
     c 0.103,0.137,-.159,-.008,0.272,0.238,0.042,0.168,0.018,0.099,
     c 0.103,0.140,-.158,-.007,0.269,0.238,0.040,0.172,0.021,0.101,
     c 0.101,0.144,-.157,-.003,0.267,0.240,0.040,0.175,0.025,0.103,
     c 0.097,0.143,-.157,0.001,0.264,0.242,0.043,0.178,0.027,0.104,
     c 0.095,0.141,-.156,0.003,0.261,0.243,0.046,0.180,0.027,0.103,
     c 0.096,0.139,-.155,0.002,0.257,0.243,0.047,0.182,0.024,0.098,
     c 0.097,0.139,-.154,0.000,0.251,0.242,0.045,0.183,0.019,0.093,
     c 0.092,0.142,-.154,-.003,0.246,0.243,0.042,0.184,0.015,0.090,
     c 0.087,0.148,-.154,-.004,0.239,0.246,0.042,0.186,0.013,0.089,
     c 0.082,0.153,-.155,-.002,0.234,0.248,0.044,0.188,0.015,0.089,
     c 0.078,0.159,-.155,0.003,0.231,0.250,0.048,0.190,0.018,0.087,
     c 0.071,0.161,-.158,0.006,0.228,0.249,0.049,0.190,0.018,0.082,
     c 0.064,0.160,-.162,0.006,0.226,0.246,0.048,0.188,0.015,0.075,
     c 0.060,0.157,-.168,0.003,0.224,0.244,0.045,0.185,0.012,0.070,
     c 0.059,0.152,-.173,-.001,0.222,0.243,0.043,0.180,0.009,0.067,
     c 0.060,0.148,-.176,-.003,0.222,0.243,0.041,0.176,0.008,0.067,
     c 0.059,0.145,-.178,-.003,0.222,0.243,0.040,0.174,0.008,0.068,
     c 0.058,0.142,-.181,0.000,0.222,0.242,0.039,0.172,0.009,0.071,
     c 0.054,0.142,-.183,0.007,0.223,0.240,0.039,0.172,0.010,0.073,
     c 0.046,0.142,-.188,0.014,0.224,0.236,0.037,0.169,0.009,0.070,
     c 0.039,0.141,-.192,0.022,0.225,0.232,0.034,0.164,0.006,0.063,
     c 0.034,0.144,-.196,0.028,0.224,0.229,0.032,0.159,-.000,0.053,
     c 0.031,0.146,-.198,0.032,0.222,0.225,0.030,0.154,-.004,0.042,
     c 0.027,0.144,-.201,0.034,0.220,0.221,0.027,0.150,-.007,0.034,
     c 0.017,0.137,-.204,0.035,0.216,0.219,0.024,0.147,-.009,0.032,
     c 0.006,0.124,-.207,0.034,0.211,0.216,0.022,0.146,-.009,0.036,
     c -.002,0.112,-.209,0.034,0.207,0.213,0.019,0.147,-.010,0.038,
     c -.003,0.100,-.213,0.031,0.202,0.208,0.015,0.146,-.012,0.031,
     c -.003,0.092,-.218,0.027,0.196,0.201,0.008,0.142,-.017,0.021,
     c -.006,0.087,-.226,0.021,0.191,0.192,-.000,0.136,-.022,0.012,
     c -.015,0.082,-.233,0.012,0.186,0.184,-.008,0.130,-.028,0.005,
     c -.027,0.074,-.240,0.002,0.180,0.177,-.018,0.123,-.036,-.002,
     c -.041,0.065,-.246,-.007,0.173,0.170,-.027,0.116,-.047,-.011,
     c -.052,0.055,-.251,-.016,0.167,0.164,-.034,0.109,-.055,-.016,
     c -.059,0.047,-.253,-.021,0.162,0.161,-.037,0.105,-.060,-.015,
     c -.063,0.040,-.255,-.027,0.159,0.157,-.043,0.102,-.062,-.015,
     c -.069,0.031,-.258,-.034,0.155,0.152,-.048,0.098,-.066,-.015,
     c 0.172,0.114,-.121,0.009,0.254,0.236,0.074,0.162,0.024,0.088,
     c 0.161,0.107,-.129,0.003,0.244,0.228,0.065,0.155,0.016,0.079,
     c 0.146,0.098,-.138,-.004,0.234,0.218,0.056,0.148,0.010,0.066,
     c 0.134,0.093,-.146,-.010,0.222,0.212,0.046,0.141,0.000,0.057,
     c 0.123,0.090,-.152,-.015,0.216,0.209,0.039,0.135,-.009,0.055,
     c 0.111,0.091,-.156,-.017,0.210,0.209,0.037,0.132,-.014,0.053,
     c 0.100,0.092,-.160,-.017,0.205,0.208,0.039,0.131,-.015,0.053,
     c 0.088,0.093,-.163,-.016,0.196,0.205,0.040,0.129,-.017,0.050,
     c 0.085,0.092,-.166,-.014,0.186,0.201,0.036,0.126,-.019,0.048,
     c 0.090,0.089,-.167,-.011,0.178,0.199,0.032,0.122,-.021,0.047,
     c 0.097,0.087,-.169,-.006,0.175,0.199,0.029,0.120,-.021,0.045,
     c 0.096,0.085,-.170,-.002,0.173,0.200,0.026,0.120,-.020,0.040,
     c 0.091,0.083,-.171,0.002,0.170,0.200,0.023,0.121,-.019,0.035,
     c 0.086,0.084,-.172,0.007,0.167,0.198,0.018,0.122,-.020,0.033,
     c 0.088,0.087,-.171,0.015,0.166,0.197,0.017,0.124,-.019,0.038,
     c 0.093,0.089,-.172,0.021,0.168,0.196,0.017,0.128,-.017,0.046,
     c 0.096,0.093,-.173,0.024,0.171,0.196,0.018,0.130,-.015,0.052,
     c 0.095,0.096,-.175,0.022,0.178,0.197,0.018,0.130,-.012,0.054,
     c 0.093,0.103,-.175,0.017,0.185,0.198,0.018,0.129,-.011,0.052,
     c 0.094,0.110,-.175,0.009,0.192,0.201,0.017,0.130,-.009,0.052,
     c 0.097,0.115,-.176,0.001,0.199,0.204,0.018,0.132,-.008,0.053,
     c 0.098,0.118,-.176,-.006,0.207,0.207,0.018,0.135,-.006,0.056,
     c 0.097,0.120,-.175,-.009,0.218,0.211,0.019,0.139,-.004,0.063,
     c 0.090,0.119,-.173,-.009,0.228,0.216,0.021,0.143,-.004,0.071,
     c 0.086,0.121,-.172,-.009,0.238,0.222,0.025,0.149,-.002,0.078,
     c 0.085,0.125,-.170,-.009,0.249,0.228,0.033,0.156,0.001,0.085,
     c 0.090,0.127,-.168,-.010,0.258,0.233,0.039,0.161,0.005,0.090,
     c 0.094,0.129,-.165,-.011,0.264,0.235,0.041,0.165,0.010,0.093,
     c 0.098,0.132,-.163,-.011,0.265,0.235,0.039,0.167,0.014,0.096,
     c 0.099,0.136,-.162,-.009,0.263,0.236,0.037,0.170,0.016,0.098,
     c 0.097,0.140,-.161,-.004,0.262,0.238,0.037,0.174,0.020,0.099,
     c 0.093,0.140,-.161,-.000,0.260,0.240,0.039,0.176,0.023,0.098,
     c 0.091,0.139,-.159,0.003,0.258,0.241,0.042,0.178,0.023,0.094,
     c 0.092,0.138,-.157,0.004,0.254,0.240,0.043,0.180,0.021,0.089,
     c 0.093,0.137,-.155,0.002,0.249,0.240,0.042,0.181,0.017,0.084,
     c 0.090,0.141,-.154,0.000,0.244,0.241,0.040,0.182,0.014,0.082,
     c 0.086,0.147,-.154,-.001,0.238,0.244,0.040,0.185,0.013,0.085,
     c 0.081,0.152,-.155,0.001,0.233,0.246,0.043,0.187,0.015,0.087,
     c 0.075,0.158,-.156,0.005,0.231,0.247,0.047,0.190,0.019,0.086,
     c 0.068,0.160,-.160,0.007,0.228,0.246,0.048,0.190,0.018,0.080,
     c 0.060,0.159,-.165,0.006,0.225,0.243,0.045,0.187,0.014,0.073,
     c 0.057,0.156,-.172,0.002,0.222,0.240,0.041,0.182,0.009,0.067,
     c 0.056,0.151,-.177,-.003,0.218,0.238,0.040,0.177,0.005,0.064,
     c 0.058,0.148,-.181,-.006,0.217,0.238,0.039,0.173,0.004,0.064,
     c 0.057,0.146,-.182,-.006,0.217,0.238,0.038,0.170,0.006,0.067,
     c 0.057,0.143,-.184,-.001,0.217,0.238,0.038,0.169,0.009,0.071,
     c 0.054,0.144,-.185,0.007,0.220,0.237,0.039,0.170,0.012,0.074,
     c 0.047,0.143,-.188,0.016,0.222,0.234,0.038,0.167,0.011,0.071,
     c 0.039,0.142,-.192,0.023,0.225,0.230,0.036,0.163,0.007,0.064,
     c 0.032,0.144,-.196,0.027,0.224,0.226,0.033,0.158,0.001,0.054,
     c 0.029,0.144,-.200,0.030,0.223,0.221,0.029,0.154,-.004,0.043,
     c 0.025,0.141,-.204,0.031,0.220,0.217,0.025,0.148,-.007,0.034,
     c 0.017,0.133,-.207,0.031,0.215,0.214,0.021,0.145,-.009,0.031,
     c 0.009,0.121,-.209,0.031,0.210,0.212,0.019,0.144,-.010,0.035,
     c 0.005,0.110,-.210,0.031,0.207,0.210,0.017,0.146,-.011,0.038,
     c 0.006,0.099,-.212,0.029,0.202,0.206,0.014,0.144,-.014,0.033,
     c 0.006,0.090,-.216,0.026,0.197,0.200,0.008,0.140,-.019,0.022,
     c 0.001,0.084,-.224,0.020,0.192,0.192,0.001,0.135,-.024,0.011,
     c -.010,0.077,-.231,0.011,0.187,0.184,-.007,0.130,-.031,0.004,
     c -.021,0.067,-.239,0.001,0.182,0.177,-.016,0.123,-.039,-.003,
     c -.034,0.057,-.246,-.009,0.175,0.170,-.026,0.116,-.050,-.012,
     c -.045,0.047,-.251,-.016,0.169,0.164,-.033,0.108,-.058,-.016,
     c -.052,0.041,-.254,-.021,0.165,0.162,-.037,0.105,-.063,-.014,
     c -.060,0.037,-.256,-.026,0.160,0.158,-.042,0.101,-.065,-.012,
     c -.066,0.031,-.259,-.032,0.156,0.153,-.047,0.098,-.068,-.012,
     c 0.178,0.115,-.121,0.009,0.258,0.235,0.073,0.163,0.025,0.090,
     c 0.165,0.107,-.129,0.002,0.247,0.228,0.064,0.156,0.016,0.081,
     c 0.150,0.097,-.138,-.006,0.237,0.219,0.057,0.147,0.009,0.070,
     c 0.136,0.091,-.146,-.013,0.225,0.213,0.047,0.140,-.002,0.063,
     c 0.123,0.087,-.152,-.018,0.217,0.211,0.040,0.134,-.011,0.060,
     c 0.111,0.089,-.157,-.021,0.210,0.209,0.038,0.132,-.016,0.058,
     c 0.100,0.093,-.160,-.021,0.204,0.208,0.041,0.132,-.017,0.056,
     c 0.089,0.094,-.162,-.020,0.194,0.203,0.041,0.131,-.017,0.053,
     c 0.087,0.094,-.165,-.018,0.186,0.199,0.037,0.128,-.017,0.051,
     c 0.092,0.090,-.166,-.014,0.179,0.198,0.034,0.124,-.019,0.052,
     c 0.098,0.086,-.168,-.010,0.177,0.198,0.031,0.122,-.020,0.051,
     c 0.097,0.084,-.170,-.006,0.175,0.199,0.028,0.121,-.020,0.046,
     c 0.090,0.081,-.172,-.002,0.171,0.198,0.023,0.119,-.022,0.038,
     c 0.084,0.082,-.173,0.004,0.167,0.195,0.016,0.119,-.024,0.032,
     c 0.085,0.086,-.172,0.012,0.166,0.194,0.013,0.122,-.023,0.035,
     c 0.090,0.089,-.173,0.018,0.168,0.192,0.013,0.126,-.021,0.043,
     c 0.092,0.094,-.174,0.021,0.172,0.193,0.015,0.130,-.017,0.049,
     c 0.092,0.098,-.175,0.020,0.179,0.195,0.016,0.131,-.014,0.054,
     c 0.090,0.104,-.176,0.015,0.187,0.197,0.016,0.131,-.011,0.054,
     c 0.090,0.111,-.176,0.008,0.193,0.200,0.016,0.132,-.009,0.054,
     c 0.095,0.115,-.178,0.000,0.199,0.203,0.017,0.134,-.008,0.054,
     c 0.097,0.117,-.180,-.007,0.206,0.205,0.017,0.136,-.006,0.057,
     c 0.096,0.118,-.180,-.011,0.216,0.209,0.017,0.140,-.004,0.062,
     c 0.089,0.117,-.179,-.012,0.224,0.213,0.018,0.144,-.004,0.068,
     c 0.084,0.117,-.179,-.013,0.232,0.217,0.022,0.150,-.003,0.074,
     c 0.082,0.119,-.177,-.014,0.241,0.223,0.029,0.156,-.000,0.080,
     c 0.085,0.120,-.175,-.015,0.249,0.228,0.035,0.161,0.004,0.086,
     c 0.089,0.122,-.171,-.016,0.254,0.231,0.036,0.164,0.007,0.089,
     c 0.093,0.126,-.169,-.016,0.256,0.232,0.035,0.165,0.010,0.093,
     c 0.097,0.132,-.168,-.013,0.254,0.233,0.033,0.168,0.012,0.095,
     c 0.096,0.137,-.166,-.007,0.255,0.236,0.033,0.171,0.016,0.096,
     c 0.093,0.139,-.164,-.001,0.256,0.239,0.036,0.174,0.019,0.094,
     c 0.092,0.139,-.160,0.003,0.256,0.241,0.041,0.177,0.020,0.090,
     c 0.092,0.139,-.157,0.005,0.254,0.241,0.043,0.179,0.019,0.084,
     c 0.092,0.139,-.154,0.004,0.250,0.240,0.043,0.181,0.016,0.079,
     c 0.088,0.142,-.153,0.003,0.244,0.240,0.040,0.182,0.013,0.079,
     c 0.085,0.147,-.153,0.002,0.238,0.243,0.041,0.185,0.013,0.084,
     c 0.080,0.151,-.154,0.004,0.234,0.244,0.044,0.187,0.017,0.090,
     c 0.074,0.156,-.155,0.008,0.231,0.245,0.047,0.190,0.021,0.090,
     c 0.066,0.157,-.160,0.008,0.228,0.244,0.047,0.189,0.020,0.086,
     c 0.058,0.157,-.166,0.006,0.225,0.241,0.044,0.186,0.016,0.078,
     c 0.055,0.154,-.175,0.001,0.221,0.237,0.039,0.181,0.009,0.073,
     c 0.054,0.150,-.181,-.004,0.216,0.235,0.038,0.175,0.005,0.070,
     c 0.054,0.148,-.185,-.007,0.214,0.234,0.038,0.170,0.005,0.070,
     c 0.053,0.145,-.187,-.006,0.214,0.235,0.038,0.168,0.007,0.072,
     c 0.053,0.143,-.187,0.000,0.215,0.234,0.038,0.166,0.010,0.074,
     c 0.051,0.143,-.186,0.009,0.218,0.234,0.039,0.166,0.013,0.075,
     c 0.045,0.142,-.187,0.017,0.222,0.232,0.039,0.164,0.012,0.072,
     c 0.037,0.141,-.190,0.024,0.225,0.228,0.037,0.161,0.009,0.066,
     c 0.030,0.142,-.194,0.027,0.225,0.224,0.034,0.158,0.004,0.057,
     c 0.027,0.140,-.200,0.028,0.223,0.219,0.030,0.154,0.001,0.046,
     c 0.024,0.136,-.206,0.028,0.218,0.214,0.026,0.149,-.003,0.037,
     c 0.018,0.128,-.210,0.028,0.214,0.210,0.021,0.145,-.005,0.034,
     c 0.013,0.117,-.212,0.028,0.209,0.208,0.019,0.143,-.008,0.037,
     c 0.012,0.107,-.211,0.029,0.206,0.208,0.017,0.144,-.011,0.039,
     c 0.013,0.097,-.212,0.028,0.203,0.205,0.014,0.141,-.015,0.034,
     c 0.010,0.087,-.216,0.025,0.197,0.200,0.008,0.137,-.021,0.022,
     c 0.002,0.078,-.223,0.019,0.193,0.191,0.001,0.132,-.027,0.012,
     c -.010,0.068,-.231,0.010,0.188,0.184,-.007,0.127,-.035,0.004,
     c -.021,0.056,-.238,0.001,0.183,0.177,-.016,0.120,-.044,-.003,
     c -.031,0.045,-.246,-.009,0.176,0.170,-.025,0.113,-.054,-.011,
     c -.041,0.037,-.252,-.016,0.170,0.164,-.033,0.106,-.063,-.015,
     c -.048,0.035,-.254,-.020,0.165,0.161,-.036,0.103,-.068,-.014,
     c -.057,0.035,-.257,-.024,0.161,0.159,-.041,0.100,-.067,-.010,
     c -.063,0.031,-.260,-.030,0.157,0.154,-.046,0.097,-.071,-.010,
     c 0.183,0.117,-.122,0.010,0.260,0.234,0.071,0.164,0.024,0.093,
     c 0.169,0.108,-.130,0.002,0.250,0.227,0.063,0.156,0.015,0.085,
     c 0.155,0.100,-.138,-.007,0.239,0.220,0.056,0.146,0.007,0.075,
     c 0.140,0.091,-.147,-.015,0.227,0.215,0.046,0.138,-.006,0.067,
     c 0.125,0.086,-.153,-.020,0.217,0.211,0.038,0.132,-.016,0.063,
     c 0.112,0.088,-.157,-.024,0.209,0.207,0.035,0.130,-.021,0.060,
     c 0.102,0.091,-.160,-.024,0.202,0.204,0.038,0.131,-.020,0.059,
     c 0.093,0.093,-.163,-.024,0.193,0.199,0.038,0.131,-.019,0.055,
     c 0.092,0.093,-.165,-.021,0.185,0.195,0.034,0.129,-.018,0.054,
     c 0.097,0.090,-.166,-.018,0.179,0.195,0.031,0.125,-.019,0.056,
     c 0.103,0.086,-.169,-.014,0.177,0.196,0.030,0.122,-.020,0.057,
     c 0.102,0.084,-.172,-.010,0.175,0.197,0.028,0.120,-.022,0.052,
     c 0.095,0.081,-.175,-.005,0.171,0.195,0.022,0.117,-.024,0.041,
     c 0.089,0.081,-.177,0.000,0.166,0.191,0.013,0.117,-.028,0.033,
     c 0.089,0.085,-.175,0.008,0.165,0.190,0.010,0.120,-.028,0.034,
     c 0.092,0.089,-.175,0.015,0.168,0.189,0.010,0.126,-.024,0.042,
     c 0.092,0.096,-.176,0.018,0.173,0.191,0.012,0.131,-.020,0.049,
     c 0.090,0.101,-.177,0.017,0.181,0.193,0.013,0.133,-.015,0.054,
     c 0.086,0.107,-.178,0.012,0.188,0.196,0.013,0.134,-.012,0.055,
     c 0.086,0.112,-.178,0.006,0.194,0.199,0.013,0.135,-.010,0.056,
     c 0.090,0.114,-.180,-.002,0.200,0.202,0.014,0.136,-.009,0.056,
     c 0.093,0.116,-.183,-.009,0.207,0.204,0.015,0.138,-.007,0.058,
     c 0.092,0.116,-.185,-.013,0.215,0.206,0.014,0.142,-.005,0.061,
     c 0.085,0.114,-.186,-.015,0.221,0.209,0.014,0.145,-.006,0.065,
     c 0.080,0.114,-.186,-.017,0.227,0.212,0.017,0.149,-.004,0.069,
     c 0.078,0.115,-.184,-.018,0.234,0.218,0.023,0.155,-.000,0.075,
     c 0.080,0.115,-.181,-.020,0.241,0.223,0.029,0.160,0.003,0.080,
     c 0.084,0.117,-.177,-.020,0.245,0.227,0.031,0.162,0.006,0.085,
     c 0.090,0.122,-.174,-.019,0.246,0.227,0.030,0.163,0.007,0.089,
     c 0.096,0.129,-.172,-.015,0.246,0.229,0.028,0.165,0.009,0.092,
     c 0.099,0.136,-.169,-.008,0.250,0.233,0.029,0.169,0.014,0.094,
     c 0.099,0.140,-.165,-.002,0.253,0.238,0.034,0.173,0.018,0.092,
     c 0.098,0.142,-.160,0.003,0.256,0.241,0.040,0.177,0.020,0.089,
     c 0.097,0.144,-.156,0.005,0.256,0.241,0.044,0.181,0.019,0.083,
     c 0.094,0.145,-.153,0.005,0.252,0.240,0.043,0.183,0.016,0.078,
     c 0.090,0.147,-.152,0.005,0.247,0.241,0.041,0.185,0.014,0.079,
     c 0.086,0.150,-.151,0.005,0.240,0.243,0.042,0.187,0.014,0.087,
     c 0.080,0.153,-.152,0.007,0.235,0.243,0.044,0.188,0.019,0.095,
     c 0.073,0.157,-.154,0.010,0.233,0.244,0.047,0.191,0.024,0.098,
     c 0.064,0.158,-.159,0.009,0.230,0.242,0.046,0.190,0.024,0.095,
     c 0.056,0.156,-.166,0.006,0.227,0.239,0.043,0.186,0.019,0.088,
     c 0.052,0.153,-.175,0.001,0.224,0.235,0.039,0.180,0.013,0.083,
     c 0.050,0.149,-.182,-.004,0.219,0.233,0.038,0.173,0.008,0.079,
     c 0.048,0.147,-.188,-.006,0.216,0.232,0.038,0.168,0.008,0.077,
     c 0.046,0.145,-.190,-.004,0.215,0.232,0.038,0.165,0.010,0.076,
     c 0.046,0.142,-.190,0.002,0.215,0.232,0.038,0.163,0.012,0.075,
     c 0.045,0.141,-.188,0.011,0.218,0.231,0.038,0.162,0.014,0.073,
     c 0.040,0.140,-.188,0.019,0.221,0.230,0.038,0.160,0.013,0.069,
     c 0.034,0.139,-.190,0.024,0.225,0.227,0.037,0.158,0.011,0.064,
     c 0.027,0.139,-.193,0.027,0.225,0.223,0.034,0.157,0.008,0.057,
     c 0.024,0.137,-.200,0.027,0.222,0.218,0.032,0.155,0.005,0.048,
     c 0.022,0.132,-.207,0.027,0.217,0.212,0.028,0.150,0.002,0.039,
     c 0.018,0.125,-.212,0.026,0.212,0.208,0.024,0.147,-.002,0.035,
     c 0.015,0.115,-.213,0.027,0.209,0.206,0.021,0.144,-.007,0.037,
     c 0.015,0.106,-.212,0.030,0.207,0.207,0.020,0.143,-.011,0.039,
     c 0.014,0.095,-.213,0.029,0.204,0.205,0.016,0.139,-.016,0.032,
     c 0.007,0.083,-.218,0.026,0.198,0.200,0.009,0.134,-.023,0.021,
     c -.005,0.071,-.225,0.019,0.193,0.192,0.001,0.129,-.030,0.012,
     c -.018,0.058,-.232,0.010,0.189,0.184,-.008,0.123,-.039,0.005,
     c -.027,0.045,-.239,0.001,0.184,0.177,-.016,0.117,-.048,-.001,
     c -.034,0.034,-.246,-.008,0.176,0.170,-.025,0.110,-.058,-.009,
     c -.041,0.027,-.252,-.015,0.170,0.164,-.032,0.103,-.067,-.013,
     c -.046,0.029,-.255,-.019,0.165,0.161,-.036,0.100,-.071,-.012,
     c -.054,0.033,-.257,-.023,0.162,0.159,-.041,0.099,-.070,-.008,
     c -.059,0.032,-.261,-.028,0.157,0.155,-.046,0.095,-.073,-.008,
     c 0.188,0.119,-.123,0.011,0.262,0.235,0.070,0.165,0.025,0.096,
     c 0.174,0.110,-.131,0.003,0.251,0.229,0.061,0.156,0.014,0.088,
     c 0.159,0.103,-.139,-.006,0.240,0.220,0.053,0.146,0.004,0.080,
     c 0.143,0.094,-.147,-.015,0.228,0.215,0.043,0.135,-.009,0.071,
     c 0.128,0.087,-.154,-.021,0.217,0.209,0.033,0.128,-.020,0.065,
     c 0.115,0.086,-.158,-.025,0.208,0.204,0.029,0.125,-.026,0.060,
     c 0.106,0.088,-.161,-.026,0.200,0.200,0.031,0.126,-.025,0.059,
     c 0.099,0.090,-.165,-.026,0.191,0.195,0.030,0.126,-.023,0.057,
     c 0.098,0.090,-.168,-.024,0.184,0.192,0.027,0.124,-.021,0.056,
     c 0.102,0.088,-.169,-.021,0.178,0.192,0.026,0.121,-.022,0.058,
     c 0.108,0.086,-.171,-.017,0.176,0.194,0.026,0.119,-.022,0.060,
     c 0.106,0.085,-.174,-.013,0.173,0.195,0.025,0.118,-.024,0.055,
     c 0.101,0.082,-.177,-.009,0.169,0.193,0.019,0.117,-.026,0.044,
     c 0.095,0.082,-.179,-.003,0.164,0.190,0.011,0.117,-.030,0.035,
     c 0.095,0.086,-.177,0.005,0.165,0.189,0.007,0.121,-.029,0.036,
     c 0.095,0.091,-.177,0.011,0.168,0.188,0.007,0.127,-.026,0.043,
     c 0.093,0.098,-.178,0.014,0.174,0.190,0.009,0.131,-.022,0.049,
     c 0.087,0.104,-.179,0.013,0.181,0.192,0.009,0.133,-.018,0.053,
     c 0.083,0.110,-.180,0.008,0.188,0.195,0.009,0.135,-.015,0.055,
     c 0.082,0.112,-.181,0.002,0.194,0.198,0.008,0.136,-.012,0.056,
     c 0.085,0.113,-.184,-.005,0.200,0.201,0.010,0.137,-.011,0.057,
     c 0.087,0.113,-.187,-.011,0.207,0.203,0.011,0.139,-.010,0.057,
     c 0.086,0.114,-.189,-.015,0.214,0.205,0.011,0.142,-.009,0.059,
     c 0.081,0.112,-.190,-.018,0.219,0.207,0.010,0.145,-.009,0.061,
     c 0.077,0.113,-.191,-.021,0.224,0.209,0.012,0.148,-.006,0.064,
     c 0.075,0.113,-.189,-.022,0.229,0.214,0.017,0.153,-.002,0.069,
     c 0.077,0.112,-.185,-.023,0.234,0.219,0.023,0.158,0.003,0.075,
     c 0.081,0.114,-.181,-.023,0.237,0.223,0.026,0.162,0.005,0.080,
     c 0.089,0.119,-.177,-.020,0.239,0.223,0.026,0.163,0.006,0.085,
     c 0.097,0.126,-.174,-.016,0.240,0.225,0.025,0.164,0.008,0.088,
     c 0.103,0.135,-.169,-.009,0.245,0.229,0.027,0.168,0.013,0.091,
     c 0.105,0.140,-.165,-.002,0.251,0.235,0.032,0.172,0.018,0.091,
     c 0.105,0.145,-.159,0.003,0.256,0.239,0.038,0.178,0.021,0.088,
     c 0.103,0.149,-.155,0.005,0.257,0.240,0.042,0.182,0.020,0.082,
     c 0.098,0.150,-.153,0.006,0.254,0.240,0.043,0.184,0.017,0.077,
     c 0.092,0.152,-.152,0.006,0.249,0.240,0.041,0.185,0.015,0.079,
     c 0.087,0.154,-.152,0.007,0.242,0.242,0.041,0.187,0.016,0.089,
     c 0.081,0.156,-.152,0.009,0.236,0.242,0.043,0.188,0.021,0.098,
     c 0.074,0.160,-.154,0.011,0.233,0.242,0.045,0.190,0.026,0.102,
     c 0.064,0.160,-.158,0.011,0.231,0.240,0.045,0.189,0.026,0.099,
     c 0.055,0.157,-.165,0.007,0.230,0.238,0.042,0.185,0.022,0.093,
     c 0.049,0.153,-.174,0.002,0.227,0.234,0.039,0.179,0.017,0.087,
     c 0.045,0.149,-.181,-.002,0.222,0.232,0.039,0.172,0.012,0.082,
     c 0.041,0.147,-.188,-.004,0.219,0.230,0.039,0.167,0.011,0.078,
     c 0.038,0.143,-.191,-.002,0.219,0.230,0.038,0.163,0.012,0.075,
     c 0.037,0.139,-.192,0.003,0.218,0.229,0.036,0.160,0.013,0.071,
     c 0.037,0.138,-.191,0.011,0.219,0.228,0.035,0.159,0.014,0.067,
     c 0.035,0.137,-.191,0.018,0.222,0.226,0.034,0.156,0.012,0.062,
     c 0.030,0.136,-.192,0.023,0.225,0.224,0.033,0.155,0.010,0.059,
     c 0.025,0.136,-.194,0.026,0.225,0.222,0.032,0.156,0.008,0.055,
     c 0.023,0.134,-.200,0.027,0.223,0.218,0.031,0.155,0.006,0.048,
     c 0.021,0.130,-.208,0.027,0.217,0.212,0.029,0.152,0.003,0.040,
     c 0.017,0.123,-.213,0.027,0.213,0.209,0.025,0.148,-.002,0.035,
     c 0.014,0.114,-.215,0.030,0.211,0.208,0.023,0.145,-.007,0.035,
     c 0.012,0.105,-.214,0.033,0.210,0.209,0.022,0.144,-.011,0.035,
     c 0.009,0.093,-.216,0.032,0.206,0.207,0.018,0.140,-.016,0.029,
     c -.001,0.079,-.221,0.028,0.199,0.201,0.010,0.134,-.023,0.019,
     c -.016,0.064,-.229,0.020,0.193,0.193,-.000,0.126,-.031,0.011,
     c -.029,0.050,-.235,0.011,0.188,0.185,-.009,0.119,-.040,0.006,
     c -.036,0.036,-.241,0.002,0.182,0.178,-.017,0.113,-.050,0.001,
     c -.040,0.027,-.246,-.007,0.176,0.171,-.024,0.107,-.059,-.007,
     c -.044,0.022,-.252,-.014,0.169,0.164,-.030,0.101,-.067,-.011,
     c -.047,0.025,-.255,-.017,0.164,0.162,-.034,0.098,-.072,-.010,
     c -.052,0.032,-.258,-.021,0.162,0.161,-.041,0.097,-.071,-.007,
     c -.056,0.033,-.261,-.026,0.158,0.157,-.047,0.094,-.075,-.006,
     c 0.193,0.121,-.124,0.012,0.264,0.236,0.067,0.166,0.025,0.099,
     c 0.179,0.112,-.131,0.004,0.253,0.230,0.059,0.157,0.014,0.091,
     c 0.164,0.104,-.139,-.006,0.242,0.222,0.051,0.146,0.003,0.085,
     c 0.147,0.094,-.148,-.014,0.229,0.216,0.040,0.135,-.011,0.075,
     c 0.133,0.086,-.154,-.021,0.218,0.210,0.030,0.126,-.022,0.067,
     c 0.120,0.084,-.159,-.026,0.209,0.203,0.025,0.122,-.027,0.061,
     c 0.112,0.085,-.163,-.027,0.200,0.198,0.025,0.122,-.027,0.060,
     c 0.105,0.086,-.167,-.028,0.191,0.193,0.024,0.121,-.025,0.057,
     c 0.104,0.086,-.170,-.027,0.182,0.190,0.022,0.119,-.024,0.056,
     c 0.106,0.085,-.171,-.024,0.176,0.192,0.021,0.117,-.025,0.058,
     c 0.109,0.085,-.172,-.020,0.173,0.194,0.023,0.116,-.025,0.060,
     c 0.108,0.085,-.175,-.016,0.170,0.195,0.022,0.117,-.025,0.055,
     c 0.104,0.083,-.178,-.012,0.166,0.193,0.017,0.117,-.027,0.046,
     c 0.100,0.084,-.179,-.006,0.163,0.190,0.010,0.119,-.029,0.040,
     c 0.099,0.088,-.177,0.002,0.165,0.190,0.007,0.124,-.028,0.041,
     c 0.097,0.092,-.178,0.007,0.169,0.189,0.006,0.129,-.026,0.047,
     c 0.092,0.100,-.179,0.009,0.174,0.191,0.007,0.132,-.023,0.051,
     c 0.085,0.105,-.181,0.008,0.181,0.193,0.006,0.134,-.019,0.053,
     c 0.080,0.109,-.183,0.003,0.187,0.195,0.005,0.135,-.017,0.054,
     c 0.078,0.110,-.185,-.002,0.193,0.197,0.005,0.137,-.016,0.056,
     c 0.079,0.109,-.187,-.008,0.199,0.200,0.007,0.137,-.015,0.057,
     c 0.080,0.110,-.190,-.014,0.205,0.202,0.008,0.139,-.014,0.057,
     c 0.080,0.111,-.192,-.017,0.212,0.204,0.009,0.142,-.012,0.057,
     c 0.076,0.111,-.193,-.021,0.216,0.205,0.008,0.145,-.012,0.057,
     c 0.073,0.113,-.194,-.024,0.220,0.207,0.008,0.148,-.009,0.060,
     c 0.072,0.114,-.192,-.025,0.224,0.212,0.012,0.153,-.004,0.065,
     c 0.074,0.113,-.189,-.025,0.228,0.216,0.018,0.159,0.002,0.072,
     c 0.078,0.114,-.184,-.024,0.230,0.220,0.022,0.162,0.005,0.076,
     c 0.086,0.117,-.180,-.020,0.232,0.220,0.023,0.163,0.006,0.080,
     c 0.095,0.123,-.176,-.015,0.235,0.221,0.023,0.164,0.007,0.082,
     c 0.101,0.132,-.170,-.008,0.242,0.226,0.025,0.167,0.013,0.084,
     c 0.105,0.139,-.165,-.002,0.248,0.231,0.030,0.171,0.018,0.085,
     c 0.106,0.145,-.160,0.002,0.254,0.236,0.036,0.176,0.020,0.084,
     c 0.104,0.150,-.157,0.005,0.255,0.238,0.040,0.180,0.020,0.079,
     c 0.098,0.152,-.156,0.005,0.253,0.238,0.041,0.182,0.017,0.075,
     c 0.091,0.154,-.156,0.006,0.248,0.238,0.039,0.182,0.016,0.077,
     c 0.085,0.155,-.155,0.007,0.241,0.240,0.040,0.184,0.016,0.087,
     c 0.079,0.157,-.156,0.009,0.235,0.240,0.041,0.185,0.021,0.096,
     c 0.073,0.160,-.156,0.012,0.233,0.240,0.043,0.188,0.026,0.098,
     c 0.064,0.160,-.160,0.011,0.232,0.239,0.043,0.187,0.027,0.094,
     c 0.055,0.157,-.165,0.007,0.231,0.237,0.041,0.183,0.024,0.087,
     c 0.048,0.153,-.174,0.003,0.228,0.234,0.039,0.177,0.019,0.081,
     c 0.042,0.148,-.181,-.001,0.224,0.232,0.039,0.171,0.015,0.077,
     c 0.037,0.145,-.187,-.003,0.222,0.230,0.038,0.167,0.014,0.073,
     c 0.033,0.141,-.192,-.001,0.221,0.228,0.036,0.163,0.013,0.069,
     c 0.030,0.136,-.194,0.003,0.220,0.226,0.033,0.159,0.012,0.064,
     c 0.030,0.134,-.195,0.009,0.221,0.224,0.031,0.157,0.011,0.059,
     c 0.029,0.132,-.196,0.015,0.222,0.222,0.028,0.154,0.008,0.055,
     c 0.027,0.130,-.196,0.021,0.224,0.220,0.027,0.153,0.006,0.053,
     c 0.024,0.130,-.198,0.024,0.225,0.219,0.027,0.155,0.005,0.051,
     c 0.022,0.129,-.203,0.026,0.222,0.216,0.027,0.154,0.003,0.046,
     c 0.019,0.126,-.209,0.028,0.218,0.212,0.027,0.152,-.001,0.039,
     c 0.014,0.120,-.215,0.030,0.214,0.210,0.024,0.148,-.006,0.033,
     c 0.010,0.111,-.217,0.033,0.212,0.209,0.022,0.146,-.010,0.031,
     c 0.007,0.102,-.218,0.037,0.211,0.210,0.021,0.144,-.013,0.031,
     c 0.001,0.089,-.221,0.036,0.206,0.208,0.017,0.140,-.017,0.025,
     c -.011,0.073,-.227,0.031,0.199,0.203,0.008,0.133,-.023,0.017,
     c -.025,0.058,-.234,0.022,0.193,0.194,-.002,0.125,-.030,0.011,
     c -.036,0.044,-.238,0.013,0.187,0.186,-.010,0.117,-.039,0.007,
     c -.042,0.032,-.242,0.003,0.181,0.179,-.017,0.111,-.049,0.002,
     c -.044,0.025,-.246,-.005,0.175,0.172,-.023,0.106,-.058,-.006,
     c -.045,0.021,-.251,-.012,0.169,0.166,-.029,0.101,-.066,-.010,
     c -.047,0.025,-.254,-.015,0.164,0.164,-.033,0.098,-.071,-.009,
     c -.049,0.033,-.258,-.019,0.162,0.162,-.041,0.096,-.072,-.005,
     c -.053,0.034,-.262,-.024,0.158,0.159,-.048,0.092,-.076,-.005,
     c 0.197,0.122,-.124,0.013,0.265,0.239,0.065,0.167,0.025,0.101,
     c 0.184,0.112,-.131,0.005,0.254,0.232,0.057,0.157,0.014,0.094,
     c 0.170,0.104,-.139,-.004,0.244,0.225,0.049,0.148,0.003,0.088,
     c 0.156,0.095,-.146,-.012,0.231,0.218,0.039,0.137,-.010,0.080,
     c 0.143,0.087,-.153,-.019,0.220,0.211,0.031,0.128,-.020,0.072,
     c 0.131,0.083,-.158,-.023,0.210,0.205,0.025,0.125,-.024,0.065,
     c 0.124,0.083,-.162,-.026,0.201,0.199,0.024,0.125,-.025,0.062,
     c 0.116,0.084,-.167,-.027,0.192,0.193,0.022,0.124,-.025,0.060,
     c 0.112,0.085,-.171,-.027,0.183,0.191,0.020,0.121,-.025,0.057,
     c 0.110,0.083,-.172,-.026,0.176,0.192,0.020,0.119,-.026,0.058,
     c 0.109,0.084,-.173,-.023,0.173,0.194,0.021,0.118,-.026,0.059,
     c 0.105,0.085,-.175,-.019,0.169,0.195,0.020,0.120,-.025,0.057,
     c 0.102,0.085,-.178,-.015,0.166,0.194,0.016,0.120,-.026,0.050,
     c 0.099,0.086,-.179,-.009,0.164,0.192,0.010,0.123,-.026,0.046,
     c 0.098,0.090,-.178,-.003,0.166,0.191,0.008,0.127,-.025,0.048,
     c 0.095,0.093,-.179,0.001,0.170,0.191,0.007,0.131,-.024,0.051,
     c 0.090,0.100,-.181,0.002,0.175,0.192,0.006,0.133,-.023,0.053,
     c 0.083,0.103,-.184,0.001,0.181,0.193,0.004,0.134,-.021,0.054,
     c 0.078,0.106,-.186,-.002,0.186,0.194,0.003,0.135,-.020,0.055,
     c 0.075,0.105,-.189,-.007,0.190,0.195,0.002,0.137,-.019,0.057,
     c 0.075,0.104,-.191,-.012,0.195,0.197,0.004,0.137,-.018,0.058,
     c 0.075,0.105,-.193,-.017,0.201,0.200,0.006,0.139,-.017,0.058,
     c 0.074,0.108,-.194,-.019,0.208,0.202,0.007,0.143,-.015,0.058,
     c 0.072,0.110,-.195,-.023,0.212,0.205,0.006,0.146,-.015,0.057,
     c 0.070,0.112,-.195,-.026,0.215,0.206,0.005,0.149,-.011,0.060,
     c 0.070,0.114,-.194,-.027,0.219,0.210,0.008,0.154,-.005,0.065,
     c 0.072,0.113,-.191,-.026,0.221,0.214,0.013,0.159,0.000,0.071,
     c 0.075,0.114,-.188,-.024,0.223,0.217,0.017,0.162,0.002,0.073,
     c 0.081,0.116,-.184,-.020,0.225,0.217,0.020,0.163,0.003,0.074,
     c 0.089,0.122,-.180,-.015,0.229,0.218,0.021,0.163,0.004,0.074,
     c 0.095,0.130,-.174,-.009,0.237,0.222,0.023,0.165,0.009,0.076,
     c 0.099,0.136,-.168,-.003,0.244,0.228,0.027,0.168,0.013,0.077,
     c 0.099,0.142,-.165,0.001,0.249,0.232,0.032,0.173,0.016,0.076,
     c 0.097,0.147,-.162,0.003,0.250,0.234,0.036,0.175,0.017,0.073,
     c 0.092,0.148,-.162,0.004,0.249,0.234,0.038,0.176,0.016,0.071,
     c 0.084,0.150,-.162,0.005,0.245,0.235,0.037,0.177,0.015,0.074,
     c 0.079,0.152,-.162,0.006,0.239,0.236,0.038,0.179,0.017,0.082,
     c 0.075,0.154,-.162,0.008,0.235,0.236,0.039,0.181,0.021,0.089,
     c 0.071,0.157,-.162,0.011,0.233,0.237,0.041,0.184,0.026,0.090,
     c 0.064,0.157,-.166,0.010,0.231,0.236,0.040,0.184,0.026,0.084,
     c 0.057,0.154,-.170,0.007,0.230,0.235,0.039,0.181,0.024,0.076,
     c 0.050,0.151,-.177,0.003,0.228,0.232,0.037,0.176,0.021,0.071,
     c 0.044,0.146,-.182,-.001,0.225,0.230,0.036,0.171,0.017,0.068,
     c 0.038,0.142,-.189,-.002,0.223,0.228,0.035,0.166,0.015,0.065,
     c 0.033,0.137,-.193,-.001,0.222,0.225,0.033,0.163,0.013,0.062,
     c 0.028,0.132,-.197,0.002,0.221,0.222,0.029,0.158,0.010,0.057,
     c 0.027,0.128,-.198,0.007,0.220,0.219,0.025,0.156,0.008,0.053,
     c 0.026,0.125,-.201,0.012,0.220,0.216,0.022,0.152,0.004,0.049,
     c 0.025,0.121,-.202,0.017,0.222,0.214,0.020,0.151,0.002,0.048,
     c 0.023,0.120,-.203,0.022,0.222,0.214,0.020,0.152,-.001,0.046,
     c 0.022,0.119,-.207,0.026,0.220,0.213,0.022,0.152,-.003,0.042,
     c 0.018,0.117,-.212,0.028,0.217,0.210,0.022,0.149,-.008,0.036,
     c 0.013,0.112,-.217,0.032,0.213,0.208,0.019,0.145,-.012,0.029,
     c 0.008,0.103,-.220,0.035,0.211,0.208,0.017,0.142,-.016,0.027,
     c 0.003,0.094,-.223,0.039,0.210,0.209,0.016,0.141,-.017,0.025,
     c -.003,0.082,-.227,0.038,0.205,0.206,0.012,0.137,-.021,0.021,
     c -.014,0.067,-.232,0.032,0.198,0.201,0.004,0.131,-.025,0.016,
     c -.026,0.053,-.238,0.024,0.191,0.194,-.006,0.124,-.032,0.012,
     c -.036,0.042,-.240,0.014,0.186,0.187,-.013,0.117,-.039,0.009,
     c -.040,0.034,-.242,0.006,0.180,0.180,-.018,0.111,-.047,0.003,
     c -.042,0.029,-.245,-.002,0.175,0.174,-.023,0.107,-.055,-.005,
     c -.043,0.026,-.250,-.009,0.170,0.168,-.028,0.103,-.063,-.009,
     c -.044,0.029,-.253,-.013,0.167,0.167,-.033,0.099,-.068,-.007,
     c -.047,0.034,-.258,-.017,0.163,0.165,-.042,0.096,-.071,-.004,
     c -.050,0.035,-.262,-.023,0.160,0.161,-.049,0.092,-.076,-.003,
     c 0.204,0.121,-.123,0.014,0.267,0.241,0.064,0.168,0.026,0.105,
     c 0.192,0.112,-.130,0.006,0.255,0.234,0.056,0.159,0.015,0.098,
     c 0.178,0.104,-.137,-.002,0.244,0.227,0.047,0.150,0.004,0.091,
     c 0.168,0.097,-.144,-.009,0.232,0.220,0.040,0.143,-.007,0.085,
     c 0.157,0.090,-.150,-.015,0.222,0.213,0.034,0.137,-.014,0.080,
     c 0.148,0.086,-.155,-.020,0.211,0.206,0.029,0.133,-.019,0.072,
     c 0.139,0.084,-.159,-.022,0.203,0.202,0.025,0.132,-.020,0.068,
     c 0.130,0.083,-.164,-.025,0.194,0.197,0.023,0.130,-.023,0.063,
     c 0.122,0.083,-.168,-.026,0.186,0.195,0.020,0.129,-.024,0.060,
     c 0.115,0.083,-.171,-.025,0.178,0.194,0.019,0.127,-.026,0.058,
     c 0.108,0.083,-.173,-.024,0.173,0.194,0.017,0.125,-.026,0.056,
     c 0.103,0.085,-.175,-.021,0.170,0.194,0.016,0.125,-.026,0.055,
     c 0.099,0.085,-.176,-.017,0.168,0.194,0.014,0.125,-.025,0.055,
     c 0.096,0.088,-.178,-.014,0.167,0.193,0.010,0.127,-.025,0.054,
     c 0.094,0.091,-.179,-.009,0.169,0.193,0.009,0.130,-.023,0.054,
     c 0.091,0.094,-.181,-.007,0.172,0.192,0.007,0.132,-.023,0.055,
     c 0.086,0.097,-.184,-.006,0.175,0.193,0.005,0.135,-.023,0.055,
     c 0.082,0.098,-.186,-.007,0.179,0.193,0.004,0.136,-.023,0.056,
     c 0.078,0.100,-.189,-.009,0.184,0.193,0.003,0.137,-.022,0.058,
     c 0.075,0.101,-.191,-.012,0.188,0.194,0.002,0.138,-.021,0.059,
     c 0.072,0.101,-.193,-.015,0.192,0.195,0.002,0.139,-.020,0.059,
     c 0.070,0.102,-.194,-.019,0.197,0.197,0.003,0.141,-.018,0.059,
     c 0.070,0.105,-.195,-.021,0.202,0.200,0.004,0.145,-.015,0.060,
     c 0.070,0.107,-.195,-.024,0.205,0.203,0.005,0.148,-.013,0.061,
     c 0.070,0.109,-.196,-.025,0.209,0.206,0.005,0.152,-.010,0.063,
     c 0.069,0.112,-.195,-.026,0.212,0.208,0.007,0.156,-.007,0.066,
     c 0.071,0.113,-.193,-.025,0.214,0.210,0.009,0.159,-.004,0.068,
     c 0.074,0.116,-.191,-.023,0.217,0.212,0.012,0.161,-.002,0.068,
     c 0.078,0.119,-.187,-.020,0.221,0.214,0.015,0.161,0.000,0.068,
     c 0.082,0.123,-.183,-.015,0.225,0.217,0.018,0.162,0.001,0.068,
     c 0.086,0.130,-.178,-.010,0.231,0.221,0.021,0.165,0.004,0.069,
     c 0.088,0.134,-.174,-.006,0.236,0.223,0.025,0.167,0.007,0.068,
     c 0.089,0.139,-.171,-.002,0.241,0.226,0.028,0.169,0.010,0.068,
     c 0.086,0.143,-.169,0.001,0.243,0.228,0.031,0.171,0.012,0.069,
     c 0.083,0.145,-.169,0.003,0.243,0.229,0.034,0.172,0.014,0.070,
     c 0.077,0.147,-.169,0.004,0.242,0.230,0.036,0.174,0.016,0.073,
     c 0.073,0.149,-.169,0.005,0.239,0.232,0.037,0.176,0.017,0.076,
     c 0.069,0.150,-.171,0.006,0.236,0.232,0.037,0.177,0.019,0.077,
     c 0.066,0.152,-.172,0.007,0.235,0.233,0.038,0.180,0.022,0.076,
     c 0.062,0.150,-.174,0.007,0.233,0.233,0.037,0.180,0.023,0.073,
     c 0.057,0.149,-.178,0.005,0.230,0.231,0.036,0.178,0.022,0.069,
     c 0.052,0.146,-.183,0.003,0.228,0.229,0.034,0.174,0.020,0.064,
     c 0.047,0.142,-.187,0.000,0.225,0.228,0.032,0.170,0.016,0.061,
     c 0.041,0.138,-.191,0.000,0.223,0.224,0.029,0.166,0.013,0.058,
     c 0.035,0.133,-.195,0.000,0.222,0.221,0.027,0.161,0.010,0.054,
     c 0.030,0.127,-.199,0.002,0.220,0.217,0.024,0.156,0.006,0.051,
     c 0.028,0.123,-.201,0.006,0.220,0.215,0.021,0.154,0.004,0.049,
     c 0.026,0.118,-.203,0.010,0.219,0.212,0.018,0.151,0.001,0.046,
     c 0.024,0.114,-.206,0.014,0.219,0.210,0.017,0.150,-.003,0.043,
     c 0.022,0.111,-.208,0.019,0.217,0.209,0.016,0.148,-.007,0.039,
     c 0.020,0.107,-.211,0.024,0.216,0.207,0.015,0.146,-.011,0.035,
     c 0.017,0.104,-.215,0.028,0.214,0.206,0.014,0.144,-.014,0.031,
     c 0.013,0.099,-.219,0.032,0.211,0.205,0.012,0.141,-.018,0.027,
     c 0.007,0.091,-.224,0.034,0.208,0.203,0.009,0.137,-.021,0.022,
     c 0.001,0.084,-.228,0.036,0.205,0.202,0.007,0.134,-.023,0.020,
     c -.005,0.074,-.232,0.035,0.201,0.200,0.001,0.131,-.026,0.018,
     c -.013,0.063,-.236,0.031,0.195,0.197,-.004,0.126,-.031,0.016,
     c -.019,0.054,-.240,0.025,0.190,0.193,-.010,0.122,-.036,0.014,
     c -.027,0.046,-.242,0.017,0.185,0.187,-.015,0.117,-.042,0.010,
     c -.032,0.040,-.244,0.010,0.181,0.182,-.019,0.113,-.048,0.006,
     c -.036,0.036,-.247,0.002,0.176,0.177,-.024,0.108,-.054,0.001,
     c -.039,0.034,-.250,-.005,0.173,0.172,-.029,0.103,-.060,-.002,
     c -.041,0.036,-.253,-.010,0.169,0.171,-.034,0.101,-.065,-.003,
     c -.044,0.038,-.257,-.015,0.165,0.167,-.042,0.096,-.070,-.002,
     c -.047,0.038,-.262,-.020,0.161,0.164,-.049,0.092,-.075,-.002,
     c 0.211,0.121,-.122,0.016,0.268,0.243,0.062,0.170,0.026,0.109,
     c 0.199,0.112,-.129,0.008,0.257,0.236,0.055,0.160,0.015,0.102,
     c 0.186,0.104,-.136,0.000,0.246,0.229,0.046,0.151,0.004,0.095,
     c 0.177,0.097,-.142,-.007,0.234,0.222,0.040,0.145,-.006,0.089,
     c 0.167,0.089,-.148,-.013,0.223,0.215,0.033,0.139,-.012,0.084,
     c 0.159,0.085,-.154,-.018,0.213,0.208,0.028,0.136,-.017,0.076,
     c 0.151,0.082,-.159,-.021,0.204,0.203,0.025,0.136,-.019,0.071,
     c 0.140,0.082,-.163,-.024,0.194,0.198,0.021,0.134,-.022,0.065,
     c 0.129,0.081,-.168,-.026,0.186,0.195,0.018,0.132,-.024,0.061,
     c 0.119,0.082,-.171,-.027,0.178,0.195,0.017,0.130,-.026,0.058,
     c 0.110,0.082,-.173,-.025,0.173,0.194,0.015,0.129,-.026,0.057,
     c 0.102,0.085,-.175,-.023,0.169,0.194,0.014,0.128,-.026,0.057,
     c 0.097,0.085,-.176,-.021,0.167,0.194,0.012,0.128,-.024,0.058,
     c 0.094,0.089,-.178,-.018,0.167,0.194,0.010,0.130,-.023,0.058,
     c 0.092,0.092,-.180,-.014,0.169,0.194,0.008,0.133,-.022,0.058,
     c 0.089,0.094,-.182,-.013,0.172,0.193,0.006,0.135,-.022,0.058,
     c 0.085,0.096,-.185,-.012,0.175,0.194,0.005,0.136,-.023,0.057,
     c 0.081,0.096,-.189,-.013,0.179,0.193,0.003,0.138,-.024,0.058,
     c 0.076,0.097,-.192,-.014,0.182,0.192,0.001,0.138,-.024,0.059,
     c 0.072,0.098,-.194,-.016,0.186,0.193,0.000,0.139,-.023,0.060,
     c 0.069,0.097,-.196,-.019,0.189,0.193,0.000,0.139,-.023,0.060,
     c 0.065,0.099,-.197,-.022,0.193,0.195,0.001,0.142,-.021,0.060,
     c 0.065,0.102,-.197,-.023,0.198,0.198,0.002,0.145,-.017,0.061,
     c 0.066,0.105,-.197,-.026,0.201,0.201,0.002,0.149,-.015,0.062,
     c 0.067,0.108,-.198,-.027,0.204,0.204,0.002,0.153,-.012,0.063,
     c 0.067,0.111,-.197,-.027,0.206,0.206,0.003,0.157,-.008,0.065,
     c 0.068,0.112,-.196,-.026,0.208,0.208,0.005,0.159,-.006,0.066,
     c 0.070,0.116,-.194,-.024,0.211,0.209,0.008,0.161,-.004,0.065,
     c 0.074,0.118,-.191,-.020,0.215,0.211,0.011,0.160,-.003,0.063,
     c 0.077,0.123,-.187,-.016,0.219,0.214,0.015,0.161,-.002,0.062,
     c 0.080,0.129,-.182,-.011,0.226,0.217,0.018,0.163,0.001,0.062,
     c 0.082,0.133,-.178,-.007,0.231,0.220,0.022,0.164,0.004,0.061,
     c 0.082,0.137,-.175,-.003,0.236,0.222,0.025,0.166,0.006,0.062,
     c 0.080,0.140,-.174,-.001,0.239,0.224,0.029,0.167,0.009,0.063,
     c 0.077,0.142,-.174,0.002,0.240,0.225,0.032,0.168,0.012,0.066,
     c 0.072,0.144,-.175,0.003,0.240,0.226,0.034,0.170,0.015,0.069,
     c 0.068,0.147,-.175,0.005,0.237,0.228,0.035,0.172,0.017,0.071,
     c 0.065,0.147,-.177,0.005,0.236,0.229,0.035,0.174,0.019,0.071,
     c 0.064,0.149,-.178,0.007,0.235,0.230,0.036,0.177,0.022,0.069,
     c 0.061,0.147,-.180,0.006,0.233,0.230,0.035,0.177,0.022,0.065,
     c 0.057,0.146,-.182,0.004,0.231,0.229,0.034,0.176,0.022,0.060,
     c 0.053,0.144,-.187,0.002,0.229,0.227,0.031,0.173,0.020,0.055,
     c 0.048,0.139,-.190,0.000,0.226,0.225,0.029,0.169,0.017,0.052,
     c 0.042,0.135,-.194,-.001,0.224,0.222,0.026,0.165,0.013,0.050,
     c 0.034,0.130,-.198,-.001,0.222,0.218,0.023,0.160,0.009,0.048,
     c 0.029,0.123,-.202,0.000,0.220,0.213,0.019,0.155,0.004,0.045,
     c 0.026,0.118,-.204,0.004,0.219,0.210,0.016,0.152,0.001,0.043,
     c 0.024,0.112,-.207,0.007,0.218,0.207,0.013,0.149,-.003,0.040,
     c 0.022,0.106,-.210,0.012,0.217,0.205,0.011,0.147,-.007,0.038,
     c 0.021,0.103,-.212,0.017,0.215,0.204,0.010,0.145,-.013,0.034,
     c 0.020,0.099,-.215,0.023,0.214,0.203,0.010,0.143,-.017,0.031,
     c 0.016,0.095,-.218,0.028,0.212,0.203,0.009,0.140,-.020,0.027,
     c 0.011,0.091,-.222,0.033,0.210,0.202,0.007,0.138,-.023,0.022,
     c 0.005,0.083,-.228,0.036,0.206,0.201,0.004,0.133,-.026,0.018,
     c -.001,0.076,-.232,0.038,0.203,0.200,0.001,0.131,-.028,0.016,
     c -.008,0.067,-.236,0.036,0.199,0.198,-.004,0.128,-.030,0.015,
     c -.014,0.058,-.240,0.032,0.193,0.196,-.008,0.124,-.034,0.015,
     c -.019,0.051,-.243,0.026,0.189,0.192,-.014,0.120,-.038,0.014,
     c -.025,0.045,-.244,0.019,0.184,0.188,-.017,0.116,-.043,0.012,
     c -.030,0.041,-.245,0.012,0.181,0.183,-.021,0.113,-.047,0.008,
     c -.033,0.039,-.247,0.005,0.177,0.179,-.024,0.109,-.053,0.003,
     c -.036,0.038,-.249,-.002,0.174,0.175,-.029,0.104,-.058,-.001,
     c -.038,0.039,-.252,-.007,0.170,0.173,-.035,0.101,-.064,-.002,
     c -.042,0.041,-.257,-.013,0.166,0.170,-.042,0.097,-.069,-.001,
     c -.045,0.042,-.261,-.018,0.163,0.166,-.049,0.093,-.073,-.000/
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/hrc_zpa.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------------------------------
c Here is a tabulation of the following correction, you may find
c this useful:
c
c        0000   0064   0128   0192   0256   0320   0384   0448   0512   0576   0640   0704   0768   0832   0896   0960
c
c 1024  -0.023 -0.023 -0.022 -0.021 -0.021 -0.020 -0.019 -0.018 -0.018 -0.017 -0.016 -0.015 -0.014 -0.014 -0.013 -0.012
c  960  -0.021 -0.020 -0.020 -0.019 -0.018 -0.018 -0.017 -0.016 -0.015 -0.015 -0.014 -0.013 -0.012 -0.012 -0.011 -0.010
c  896  -0.019 -0.018 -0.017 -0.017 -0.016 -0.015 -0.015 -0.014 -0.013 -0.013 -0.012 -0.011 -0.010 -0.010 -0.009 -0.008
c  832  -0.017 -0.016 -0.015 -0.015 -0.014 -0.013 -0.013 -0.012 -0.011 -0.010 -0.010 -0.009 -0.008 -0.008 -0.007 -0.006
c  768  -0.014 -0.014 -0.013 -0.012 -0.012 -0.011 -0.010 -0.010 -0.009 -0.008 -0.008 -0.007 -0.006 -0.005 -0.005 -0.004
c  704  -0.012 -0.011 -0.011 -0.010 -0.009 -0.009 -0.008 -0.007 -0.007 -0.006 -0.005 -0.005 -0.004 -0.003 -0.003 -0.002
c  640  -0.010 -0.009 -0.008 -0.008 -0.007 -0.006 -0.006 -0.005 -0.004 -0.004 -0.003 -0.002 -0.002 -0.001  0.000  0.000
c  576  -0.008 -0.007 -0.006 -0.006 -0.005 -0.004 -0.004 -0.003 -0.002 -0.002 -0.001  0.000  0.000  0.001  0.002  0.002
c  512  -0.005 -0.005 -0.004 -0.003 -0.003 -0.002 -0.001 -0.001  0.000  0.001  0.001  0.002  0.003  0.003  0.004  0.004
c  448  -0.003 -0.002 -0.002 -0.001  0.000  0.000  0.001  0.002  0.002  0.003  0.003  0.004  0.005  0.005  0.006  0.007
c  384  -0.001  0.000  0.000  0.001  0.002  0.002  0.003  0.004  0.004  0.005  0.006  0.006  0.007  0.007  0.008  0.009
c  320   0.001  0.002  0.002  0.003  0.004  0.005  0.005  0.006  0.007  0.007  0.008  0.008  0.009  0.010  0.010  0.011
c  256   0.003  0.004  0.005  0.005  0.006  0.007  0.007  0.008  0.009  0.009  0.010  0.011  0.011  0.012  0.012  0.013
c  192   0.005  0.006  0.007  0.007  0.008  0.009  0.009  0.010  0.011  0.011  0.012  0.013  0.013  0.014  0.014  0.015
c  128   0.007  0.008  0.008  0.009  0.010  0.011  0.011  0.012  0.013  0.013  0.014  0.015  0.015  0.016  0.016  0.017
c   64   0.009  0.009  0.010  0.011  0.012  0.013  0.013  0.014  0.015  0.015  0.016  0.017  0.017  0.018  0.018  0.019
c    0   0.010  0.011  0.012  0.013  0.014  0.014  0.015  0.016  0.017  0.017  0.018  0.019  0.019  0.020  0.020  0.021
c
c        0000   0064   0128   0192   0256   0320   0384   0448   0512   0576   0640   0704   0768   0832   0896   0960
c
 
c----------------------------------------
c
c this routine will return the photometric correction
c that will account for the fact that the flat-fields
c have been constructed to preserve surface brightness
c rather than flux; photometry wants to measure flux
c so we must multiply by the pixel area
c
c this correction should be ADDED to an instrumental
c magnitude measured in a raw image:
c
c
c mcor = mraw + hrc_zpa(x,y)
c
c
      real function hrc_zpa(x,y)
      implicit none
 
      real*8 x, y
      integer i, j
      real*8 pixarea
 
      i = x
      j = y
 
      hrc_zpa = -2.5*log10(pixarea(i,j))  ! I have found experimentally
                                          ! that this is the right sign to
                                          ! use
 
      return
      end
 
 
 
 
 
      real*8 function pixarea(i,j)
      implicit none
 
      integer i,j
 
      real fx, fy
 
      real dxdx, dxdy
      real dydx, dydy
      real dxdx0,dxdy0
      real dydx0,dydy0
 
 
c
c in LINUX you need to do this to make sure
c that the variables stay in memory
c
      real polyx(15)
      real polyy(15)
      common /pareaq/ polyx,polyy
      data polyx/
     .  -0.000180,512.000000,  0.000000, -0.864121,  2.355129,
     .  -0.183590,  0.009942,  0.000208,  0.051272,  0.001016,
     .   0.017420, -0.140388, -0.099512,  0.002582,  0.002776/
 
      data polyy/
     .   0.013041, 51.847919,449.539581,  0.361129, -0.380593,
     .   2.622087,  0.053201,  0.034940, -0.072759,  0.067124,
     .   0.026491, -0.095819,  0.047346, -0.029614, -0.070042/
 
 
      fx = (i-512.0)/512.0
      fy = (j-512.0)/512.0
 
      dxdx = 1*polyx(02)
     .     + 2*polyx(04)*fx
     .     + 1*polyx(05)*fy
     .     + 3*polyx(07)*fx*fx
     .     + 2*polyx(08)*fx*fy
     .     + 1*polyx(09)*fy*fy
     .     + 4*polyx(11)*fx*fx*fx
     .     + 3*polyx(12)*fx*fx*fy
     .     + 2*polyx(13)*fx*fy*fy
     .     + 1*polyx(14)*fy*fy*fy
      dydx = 1*polyy(02)
     .     + 2*polyy(04)*fx
     .     + 1*polyy(05)*fy
     .     + 3*polyy(07)*fx*fx
     .     + 2*polyy(08)*fx*fy
     .     + 1*polyy(09)*fy*fy
     .     + 4*polyy(11)*fx*fx*fx
     .     + 3*polyy(12)*fx*fx*fy
     .     + 2*polyy(13)*fx*fy*fy
     .     + 1*polyy(14)*fy*fy*fy
      dxdy = 1*polyx(03)
     .     + 2*polyx(06)*fy
     .     + 1*polyx(05)*fx
     .     + 3*polyx(10)*fy*fy
     .     + 2*polyx(09)*fx*fy
     .     + 1*polyx(08)*fx*fx
     .     + 4*polyx(15)*fy*fy*fy
     .     + 3*polyx(14)*fx*fy*fy
     .     + 2*polyx(13)*fx*fx*fy
     .     + 1*polyx(12)*fx*fx*fx
      dydy = 1*polyy(03)
     .     + 2*polyy(06)*fy
     .     + 1*polyy(05)*fx
     .     + 3*polyy(10)*fy*fy
     .     + 2*polyy(09)*fx*fy
     .     + 1*polyy(08)*fx*fx
     .     + 4*polyy(15)*fy*fy*fy
     .     + 3*polyy(14)*fx*fy*fy
     .     + 2*polyy(13)*fx*fx*fy
     .     + 1*polyy(12)*fx*fx*fx
 
      dxdx0 = polyx(02)
      dxdy0 = polyx(03)
      dydx0 = polyy(02)
      dydy0 = polyy(03)
 
 
      pixarea = (dxdx *dydy  - dxdy *dydx )/
     .          (dxdx0*dydy0 - dxdy0*dydx0)
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc3ir_cg.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------
c
c this will perform the inverse
c distortion correction...
c
      subroutine wfc3ir_cg(xc,yc,xr,yr)
      implicit none
      real*8 xc,yc
      real*8 xr,yr
 
      real*8 xt, yt
      real*8 dx, dy, dd
      integer NIT
      real*8 xru, yru
 
c     print*,'WFC3IR_CG:  xc: ',xc,yc
 
      xr  = xc
      yr  = yc
      xru = xc
      yru = yc
      NIT = 0
 1    continue
      NIT = NIT + 1
      call wfc3ir_gc(xru,yru,xt,yt)
      dx = xc-xt
      dy = yc-yt
      dd = sqrt(dx**2+dy**2)
      xru = xru + (xc-xt)*0.5
      yru = yru + (yc-yt)*0.5
      if (dd.gt.0.001.and.NIT.lt.99) goto 1
 11   continue
 
      xr = xru
      yr = yru
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc3ir_gc.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c---------------------------------------
c
c developed by Jay at home Xmas 2009
c
      subroutine wfc3ir_gc(xr,yr,xc,yc)
      implicit none
 
      real*8 xr,yr
      real*8 xc,yc
 
      real xru,yru
 
      real x, y
      integer kinu
 
      real dxcor, dycor
 
      real polyx(10)
      common /IRpolyx_/polyx
      data polyx /
     .  507.000, 567.453,   1.767, -0.065,  7.171,
     .    0.033,  -0.002,   0.007,  0.003, -0.012/
 
      real polyy(10)
      common /IRpolyxyx_/polyy
      data polyy /
     .  507.000,   0.000, 507.000,  1.805, -0.049,
     .    7.866,   0.015,  -0.022,  0.032, -0.012/
 
      real xcor(11,11)
      common /IRxcor_/xcor
      data xcor /
     .0.1070,0.0915,0.0738,0.0580,0.0333,0.0178,
     .       0.0032,-.0196,-.0343,-.0387,-.0326,
     .0.0815,0.0691,0.0547,0.0387,0.0144,0.0040,
     .       -.0156,-.0389,-.0477,-.0479,-.0376,
     .0.0589,0.0498,0.0386,0.0244,0.0032,-.0044,
     .       -.0260,-.0462,-.0508,-.0468,-.0323,
     .0.0343,0.0328,0.0285,0.0243,0.0081,-.0089,
     .       -.0303,-.0391,-.0442,-.0346,-.0142,
     .0.0146,0.0084,0.0065,0.0175,0.0076,-.0127,
     .       -.0350,-.0348,-.0243,-.0165,-.0041,
     .0.0039,-.0020,-.0027,0.0071,0.0017,-.0049,
     .       -.0175,-.0209,-.0111,-.0005,0.0163,
     .-.0204,-.0184,-.0137,-.0036,-.0070,-.0009,
     .       -.0016,-.0085,-.0012,0.0149,0.0396,
     .-.0370,-.0347,-.0274,-.0081,-.0016,0.0032,
     .       0.0068,0.0141,0.0235,0.0401,0.0616,
     .-.0470,-.0455,-.0390,-.0224,-.0071,0.0043,
     .       0.0078,0.0223,0.0412,0.0543,0.0686,
     .-.0491,-.0480,-.0419,-.0229,-.0067,0.0074,
     .       0.0165,0.0343,0.0514,0.0656,0.0810,
     .-.0452,-.0444,-.0387,-.0196,-.0055,0.0127,
     .       0.0324,0.0497,0.0583,0.0736,0.0901/
 
      real ycor(11,11)
      common /IRycor_/ycor
      data ycor /
     .0.1085,0.0819,0.0633,0.0621,0.0369,0.0438,
     .       0.0580,0.0933,0.1052,0.1388,0.1840,
     .0.0703,0.0479,0.0336,0.0389,0.0233,0.0340,
     .       0.0343,0.0532,0.0650,0.0919,0.1305,
     .0.0360,0.0178,0.0077,0.0158,0.0050,0.0172,
     .       0.0097,0.0176,0.0252,0.0455,0.0773,
     .0.0100,-.0094,-.0184,-.0146,-.0162,-.0056,
     .       -.0190,-.0171,-.0240,-.0039,0.0324,
     .0.0013,-.0239,-.0373,-.0308,-.0363,-.0289,
     .       -.0336,-.0329,-.0470,-.0272,0.0105,
     .0.0193,-.0198,-.0428,-.0377,-.0466,-.0465,
     .       -.0521,-.0507,-.0556,-.0353,0.0008,
     .0.0367,-.0045,-.0324,-.0496,-.0577,-.0528,
     .       -.0624,-.0599,-.0466,-.0249,0.0115,
     .0.0634,0.0252,-.0033,-.0346,-.0489,-.0462,
     .       -.0542,-.0497,-.0351,-.0114,0.0275,
     .0.0930,0.0612,0.0357,0.0086,-.0063,-.0081,
     .       -.0110,-.0046,0.0092,0.0289,0.0584,
     .0.1118,0.0855,0.0653,0.0459,0.0339,0.0313,
     .       0.0298,0.0350,0.0435,0.0594,0.0851,
     .0.1303,0.1093,0.0945,0.0889,0.0813,0.0766,
     .       0.0771,0.0781,0.0802,0.0923,0.1143/
 
 
      real    rx, ry
      integer ix, iy
      real    fx, fy
 
      xc = xr
      yc = yr
 
      xru = xr
      yru = yr
 
      x = (xru-507.00d0)/507.0d0
      y = (yru-507.00d0)/507.0d0
      xc = polyx(01)
     .   + polyx(02)*x
     .   + polyx(03)*y
     .   + polyx(04)*x*x
     .   + polyx(05)*x*y
     .   + polyx(06)*y*y
     .   + polyx(07)*x*x*x
     .   + polyx(08)*x*x*y
     .   + polyx(09)*x*y*y
     .   + polyx(10)*y*y*y
      yc = polyy(01)
     .   + polyy(02)*x
     .   + polyy(03)*y
     .   + polyy(04)*x*x
     .   + polyy(05)*x*y
     .   + polyy(06)*y*y
     .   + polyy(07)*x*x*x
     .   + polyy(08)*x*x*y
     .   + polyy(09)*x*y*y
     .   + polyy(10)*y*y*y
 
 
      rx = 1 + xr/100
      ry = 1 + yr/100
      ix = int(rx)
      iy = int(ry)
      if (ix.lt.01) ix = 01
      if (iy.lt.01) iy = 01
      if (ix.gt.10) ix = 10
      if (iy.gt.10) iy = 10
      fx = rx-ix
      fy = ry-iy
 
      dxcor = (1-fx)*(1-fy)*xcor(ix  ,iy  )
     .      + (1-fx)*( fy )*xcor(ix  ,iy+1)
     .      + ( fx )*(1-fy)*xcor(ix+1,iy  )
     .      + ( fx )*( fy )*xcor(ix+1,iy+1)
 
      dycor = (1-fx)*(1-fy)*ycor(ix  ,iy  )
     .      + (1-fx)*( fy )*ycor(ix  ,iy+1)
     .      + ( fx )*(1-fy)*ycor(ix+1,iy  )
     .      + ( fx )*( fy )*ycor(ix+1,iy+1)
 
      xc = xc - dxcor
      yc = yc - dycor
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc3ir_zpa.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------
c
c
c
      real function wfc3ir_zpa(xr,yr)
      implicit none
 
      real*8 xr, yr
 
      real    ri,rj
      integer ii,jj
      real    fi,fj
 
      real wfc3ir_zp_arr(64,64)
      common /wfc3ir_zp_arr_/wfc3ir_zp_arr
 
      ri = 1 + (xr-8)/16.0
      rj = 1 + (yr-8)/16.0
      if (ri.le. 1.0) ri =  1.00
      if (rj.le. 1.0) rj =  1.00
      if (ri.ge.64.0) ri = 63.99
      if (rj.ge.64.0) rj = 63.99
      ii = int(ri)
      jj = int(rj)
      fi = ri-ii
      fj = rj-jj
 
      wfc3ir_zpa = (1-fi)*(1-fj)*wfc3ir_zp_arr(ii  ,jj  )
     .           + (1-fi)*( fj )*wfc3ir_zp_arr(ii  ,jj+1)
     .           + ( fi )*(1-fj)*wfc3ir_zp_arr(ii+1,jj  )
     .           + ( fi )*( fj )*wfc3ir_zp_arr(ii+1,jj+1)
 
      return
      end
 
 
 
c---------------------------------------------------------------------
c
c
c
      block data wfc3ir_zp_arr_BD
      real wfc3ir_zp_arr(64,64)
      common /wfc3ir_zp_arr_/wfc3ir_zp_arr
      data wfc3ir_zp_arr/
     . 0.0469, 0.0469, 0.0469, 0.0469, 0.0469, 0.0469, 0.0469, 0.0470,
     . 0.0470, 0.0470, 0.0470, 0.0470, 0.0471, 0.0471, 0.0471, 0.0471,
     . 0.0472, 0.0472, 0.0472, 0.0472, 0.0472, 0.0472, 0.0472, 0.0473,
     . 0.0473, 0.0474, 0.0475, 0.0475, 0.0475, 0.0475, 0.0475, 0.0476,
     . 0.0476, 0.0475, 0.0475, 0.0475, 0.0475, 0.0475, 0.0474, 0.0474,
     . 0.0474, 0.0474, 0.0474, 0.0474, 0.0475, 0.0475, 0.0475, 0.0476,
     . 0.0476, 0.0476, 0.0477, 0.0477, 0.0477, 0.0478, 0.0478, 0.0478,
     . 0.0479, 0.0479, 0.0479, 0.0479, 0.0479, 0.0480, 0.0480, 0.0480,
     . 0.0453, 0.0454, 0.0454, 0.0454, 0.0454, 0.0454, 0.0454, 0.0454,
     . 0.0454, 0.0455, 0.0455, 0.0455, 0.0455, 0.0456, 0.0456, 0.0456,
     . 0.0456, 0.0456, 0.0457, 0.0456, 0.0456, 0.0457, 0.0457, 0.0457,
     . 0.0458, 0.0459, 0.0459, 0.0459, 0.0460, 0.0460, 0.0460, 0.0460,
     . 0.0460, 0.0460, 0.0460, 0.0460, 0.0460, 0.0459, 0.0459, 0.0459,
     . 0.0459, 0.0459, 0.0459, 0.0459, 0.0460, 0.0460, 0.0460, 0.0460,
     . 0.0460, 0.0461, 0.0462, 0.0462, 0.0462, 0.0462, 0.0462, 0.0462,
     . 0.0463, 0.0464, 0.0464, 0.0464, 0.0464, 0.0464, 0.0464, 0.0465,
     . 0.0438, 0.0438, 0.0438, 0.0439, 0.0439, 0.0439, 0.0439, 0.0439,
     . 0.0439, 0.0439, 0.0440, 0.0440, 0.0440, 0.0440, 0.0440, 0.0441,
     . 0.0441, 0.0441, 0.0441, 0.0441, 0.0441, 0.0441, 0.0442, 0.0442,
     . 0.0442, 0.0444, 0.0444, 0.0444, 0.0444, 0.0445, 0.0445, 0.0445,
     . 0.0445, 0.0445, 0.0444, 0.0444, 0.0444, 0.0444, 0.0444, 0.0443,
     . 0.0443, 0.0443, 0.0443, 0.0443, 0.0444, 0.0444, 0.0445, 0.0445,
     . 0.0445, 0.0445, 0.0446, 0.0447, 0.0447, 0.0447, 0.0447, 0.0447,
     . 0.0448, 0.0448, 0.0448, 0.0449, 0.0449, 0.0449, 0.0449, 0.0449,
     . 0.0423, 0.0423, 0.0423, 0.0423, 0.0423, 0.0424, 0.0424, 0.0424,
     . 0.0424, 0.0424, 0.0424, 0.0424, 0.0425, 0.0425, 0.0425, 0.0425,
     . 0.0426, 0.0426, 0.0426, 0.0425, 0.0426, 0.0426, 0.0426, 0.0427,
     . 0.0427, 0.0428, 0.0429, 0.0429, 0.0429, 0.0429, 0.0430, 0.0429,
     . 0.0429, 0.0429, 0.0429, 0.0429, 0.0429, 0.0429, 0.0428, 0.0428,
     . 0.0428, 0.0428, 0.0428, 0.0428, 0.0429, 0.0429, 0.0429, 0.0430,
     . 0.0430, 0.0430, 0.0431, 0.0431, 0.0431, 0.0432, 0.0432, 0.0432,
     . 0.0433, 0.0433, 0.0433, 0.0433, 0.0433, 0.0434, 0.0434, 0.0434,
     . 0.0408, 0.0408, 0.0408, 0.0408, 0.0408, 0.0408, 0.0408, 0.0409,
     . 0.0409, 0.0409, 0.0409, 0.0409, 0.0409, 0.0410, 0.0410, 0.0410,
     . 0.0410, 0.0410, 0.0411, 0.0410, 0.0410, 0.0411, 0.0411, 0.0411,
     . 0.0412, 0.0413, 0.0413, 0.0414, 0.0414, 0.0414, 0.0414, 0.0414,
     . 0.0414, 0.0414, 0.0414, 0.0414, 0.0413, 0.0413, 0.0413, 0.0413,
     . 0.0413, 0.0413, 0.0412, 0.0412, 0.0414, 0.0414, 0.0414, 0.0414,
     . 0.0415, 0.0415, 0.0416, 0.0416, 0.0416, 0.0416, 0.0416, 0.0416,
     . 0.0417, 0.0418, 0.0418, 0.0418, 0.0418, 0.0418, 0.0418, 0.0419,
     . 0.0392, 0.0393, 0.0393, 0.0393, 0.0393, 0.0393, 0.0393, 0.0393,
     . 0.0393, 0.0394, 0.0394, 0.0394, 0.0394, 0.0394, 0.0394, 0.0395,
     . 0.0395, 0.0395, 0.0395, 0.0395, 0.0395, 0.0395, 0.0396, 0.0396,
     . 0.0396, 0.0398, 0.0398, 0.0398, 0.0399, 0.0399, 0.0399, 0.0399,
     . 0.0398, 0.0398, 0.0398, 0.0398, 0.0398, 0.0398, 0.0397, 0.0397,
     . 0.0397, 0.0397, 0.0397, 0.0397, 0.0398, 0.0399, 0.0399, 0.0399,
     . 0.0399, 0.0400, 0.0401, 0.0401, 0.0401, 0.0401, 0.0401, 0.0401,
     . 0.0402, 0.0402, 0.0403, 0.0403, 0.0403, 0.0403, 0.0403, 0.0403,
     . 0.0378, 0.0378, 0.0378, 0.0378, 0.0378, 0.0378, 0.0378, 0.0378,
     . 0.0379, 0.0379, 0.0379, 0.0379, 0.0379, 0.0379, 0.0379, 0.0380,
     . 0.0380, 0.0380, 0.0380, 0.0380, 0.0380, 0.0380, 0.0380, 0.0380,
     . 0.0381, 0.0382, 0.0382, 0.0383, 0.0383, 0.0383, 0.0383, 0.0382,
     . 0.0382, 0.0382, 0.0382, 0.0382, 0.0382, 0.0382, 0.0382, 0.0382,
     . 0.0382, 0.0382, 0.0382, 0.0382, 0.0384, 0.0384, 0.0384, 0.0384,
     . 0.0384, 0.0384, 0.0385, 0.0385, 0.0385, 0.0386, 0.0386, 0.0386,
     . 0.0387, 0.0387, 0.0387, 0.0387, 0.0387, 0.0388, 0.0388, 0.0388,
     . 0.0362, 0.0363, 0.0363, 0.0363, 0.0363, 0.0363, 0.0363, 0.0363,
     . 0.0363, 0.0364, 0.0364, 0.0364, 0.0364, 0.0364, 0.0364, 0.0364,
     . 0.0365, 0.0365, 0.0365, 0.0364, 0.0365, 0.0365, 0.0365, 0.0365,
     . 0.0365, 0.0367, 0.0367, 0.0367, 0.0367, 0.0368, 0.0368, 0.0367,
     . 0.0367, 0.0367, 0.0367, 0.0367, 0.0367, 0.0367, 0.0367, 0.0367,
     . 0.0367, 0.0367, 0.0367, 0.0367, 0.0368, 0.0369, 0.0369, 0.0369,
     . 0.0369, 0.0369, 0.0370, 0.0370, 0.0370, 0.0370, 0.0370, 0.0371,
     . 0.0372, 0.0372, 0.0372, 0.0372, 0.0372, 0.0372, 0.0373, 0.0373,
     . 0.0347, 0.0347, 0.0347, 0.0348, 0.0348, 0.0348, 0.0348, 0.0348,
     . 0.0348, 0.0348, 0.0349, 0.0349, 0.0349, 0.0349, 0.0349, 0.0349,
     . 0.0349, 0.0349, 0.0350, 0.0349, 0.0349, 0.0350, 0.0350, 0.0350,
     . 0.0350, 0.0352, 0.0352, 0.0352, 0.0352, 0.0352, 0.0353, 0.0352,
     . 0.0352, 0.0352, 0.0352, 0.0352, 0.0352, 0.0352, 0.0352, 0.0352,
     . 0.0352, 0.0352, 0.0352, 0.0352, 0.0353, 0.0353, 0.0353, 0.0354,
     . 0.0354, 0.0354, 0.0355, 0.0355, 0.0355, 0.0355, 0.0355, 0.0355,
     . 0.0356, 0.0357, 0.0357, 0.0357, 0.0357, 0.0357, 0.0357, 0.0357,
     . 0.0332, 0.0332, 0.0332, 0.0333, 0.0333, 0.0333, 0.0333, 0.0333,
     . 0.0333, 0.0333, 0.0333, 0.0334, 0.0334, 0.0334, 0.0334, 0.0334,
     . 0.0334, 0.0334, 0.0334, 0.0334, 0.0334, 0.0334, 0.0335, 0.0335,
     . 0.0335, 0.0337, 0.0337, 0.0337, 0.0337, 0.0337, 0.0337, 0.0336,
     . 0.0336, 0.0336, 0.0336, 0.0336, 0.0337, 0.0336, 0.0336, 0.0336,
     . 0.0336, 0.0336, 0.0336, 0.0337, 0.0338, 0.0338, 0.0338, 0.0338,
     . 0.0338, 0.0339, 0.0340, 0.0340, 0.0340, 0.0340, 0.0340, 0.0340,
     . 0.0341, 0.0341, 0.0341, 0.0342, 0.0342, 0.0342, 0.0342, 0.0342,
     . 0.0317, 0.0317, 0.0317, 0.0317, 0.0317, 0.0318, 0.0318, 0.0318,
     . 0.0318, 0.0318, 0.0318, 0.0318, 0.0318, 0.0318, 0.0319, 0.0319,
     . 0.0319, 0.0319, 0.0319, 0.0319, 0.0319, 0.0319, 0.0319, 0.0320,
     . 0.0320, 0.0321, 0.0321, 0.0322, 0.0322, 0.0322, 0.0322, 0.0321,
     . 0.0321, 0.0321, 0.0321, 0.0321, 0.0321, 0.0321, 0.0321, 0.0321,
     . 0.0321, 0.0321, 0.0321, 0.0321, 0.0323, 0.0323, 0.0323, 0.0323,
     . 0.0323, 0.0323, 0.0324, 0.0324, 0.0324, 0.0325, 0.0325, 0.0325,
     . 0.0326, 0.0326, 0.0326, 0.0326, 0.0326, 0.0327, 0.0327, 0.0327,
     . 0.0302, 0.0302, 0.0302, 0.0302, 0.0302, 0.0303, 0.0302, 0.0303,
     . 0.0303, 0.0303, 0.0303, 0.0303, 0.0303, 0.0303, 0.0303, 0.0304,
     . 0.0304, 0.0304, 0.0304, 0.0304, 0.0304, 0.0304, 0.0304, 0.0304,
     . 0.0305, 0.0306, 0.0306, 0.0306, 0.0307, 0.0307, 0.0307, 0.0306,
     . 0.0306, 0.0306, 0.0306, 0.0306, 0.0306, 0.0306, 0.0306, 0.0306,
     . 0.0306, 0.0306, 0.0306, 0.0306, 0.0308, 0.0308, 0.0308, 0.0308,
     . 0.0308, 0.0308, 0.0309, 0.0309, 0.0309, 0.0309, 0.0310, 0.0310,
     . 0.0311, 0.0311, 0.0311, 0.0311, 0.0311, 0.0311, 0.0311, 0.0312,
     . 0.0287, 0.0287, 0.0287, 0.0287, 0.0287, 0.0288, 0.0287, 0.0288,
     . 0.0288, 0.0288, 0.0288, 0.0288, 0.0288, 0.0288, 0.0288, 0.0288,
     . 0.0288, 0.0288, 0.0288, 0.0288, 0.0288, 0.0288, 0.0289, 0.0289,
     . 0.0289, 0.0291, 0.0291, 0.0291, 0.0291, 0.0291, 0.0291, 0.0290,
     . 0.0290, 0.0290, 0.0290, 0.0290, 0.0290, 0.0290, 0.0291, 0.0291,
     . 0.0291, 0.0291, 0.0291, 0.0291, 0.0292, 0.0292, 0.0292, 0.0292,
     . 0.0292, 0.0292, 0.0293, 0.0294, 0.0294, 0.0294, 0.0294, 0.0294,
     . 0.0295, 0.0296, 0.0296, 0.0296, 0.0296, 0.0297, 0.0297, 0.0297,
     . 0.0272, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273,
     . 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273,
     . 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0273, 0.0274,
     . 0.0274, 0.0275, 0.0275, 0.0275, 0.0276, 0.0276, 0.0276, 0.0275,
     . 0.0275, 0.0275, 0.0275, 0.0275, 0.0275, 0.0275, 0.0275, 0.0275,
     . 0.0276, 0.0276, 0.0276, 0.0276, 0.0277, 0.0277, 0.0277, 0.0277,
     . 0.0277, 0.0277, 0.0278, 0.0278, 0.0278, 0.0278, 0.0279, 0.0279,
     . 0.0280, 0.0280, 0.0281, 0.0281, 0.0281, 0.0282, 0.0282, 0.0282,
     . 0.0257, 0.0257, 0.0257, 0.0258, 0.0258, 0.0258, 0.0257, 0.0258,
     . 0.0258, 0.0258, 0.0258, 0.0258, 0.0258, 0.0258, 0.0258, 0.0258,
     . 0.0258, 0.0258, 0.0258, 0.0257, 0.0258, 0.0258, 0.0258, 0.0259,
     . 0.0259, 0.0260, 0.0260, 0.0260, 0.0260, 0.0260, 0.0260, 0.0260,
     . 0.0259, 0.0260, 0.0260, 0.0260, 0.0260, 0.0260, 0.0260, 0.0260,
     . 0.0260, 0.0261, 0.0261, 0.0261, 0.0262, 0.0262, 0.0262, 0.0262,
     . 0.0262, 0.0262, 0.0263, 0.0263, 0.0263, 0.0263, 0.0263, 0.0264,
     . 0.0265, 0.0265, 0.0266, 0.0266, 0.0266, 0.0267, 0.0267, 0.0267,
     . 0.0242, 0.0242, 0.0243, 0.0243, 0.0243, 0.0243, 0.0242, 0.0243,
     . 0.0243, 0.0243, 0.0243, 0.0243, 0.0243, 0.0243, 0.0243, 0.0243,
     . 0.0243, 0.0243, 0.0243, 0.0242, 0.0243, 0.0243, 0.0243, 0.0243,
     . 0.0244, 0.0245, 0.0245, 0.0245, 0.0245, 0.0245, 0.0245, 0.0244,
     . 0.0244, 0.0244, 0.0244, 0.0244, 0.0245, 0.0245, 0.0245, 0.0245,
     . 0.0245, 0.0246, 0.0246, 0.0246, 0.0247, 0.0247, 0.0246, 0.0246,
     . 0.0246, 0.0246, 0.0247, 0.0248, 0.0248, 0.0248, 0.0248, 0.0249,
     . 0.0250, 0.0250, 0.0250, 0.0251, 0.0251, 0.0251, 0.0252, 0.0252,
     . 0.0227, 0.0227, 0.0227, 0.0228, 0.0228, 0.0228, 0.0227, 0.0228,
     . 0.0228, 0.0228, 0.0228, 0.0228, 0.0228, 0.0228, 0.0228, 0.0228,
     . 0.0228, 0.0228, 0.0228, 0.0227, 0.0228, 0.0228, 0.0228, 0.0228,
     . 0.0229, 0.0229, 0.0229, 0.0229, 0.0230, 0.0230, 0.0230, 0.0229,
     . 0.0229, 0.0229, 0.0229, 0.0229, 0.0229, 0.0230, 0.0230, 0.0230,
     . 0.0230, 0.0231, 0.0231, 0.0231, 0.0231, 0.0231, 0.0231, 0.0231,
     . 0.0231, 0.0231, 0.0232, 0.0233, 0.0233, 0.0233, 0.0233, 0.0233,
     . 0.0235, 0.0235, 0.0235, 0.0236, 0.0236, 0.0236, 0.0237, 0.0237,
     . 0.0212, 0.0212, 0.0212, 0.0213, 0.0213, 0.0213, 0.0212, 0.0213,
     . 0.0213, 0.0213, 0.0213, 0.0213, 0.0213, 0.0213, 0.0213, 0.0213,
     . 0.0213, 0.0213, 0.0213, 0.0212, 0.0212, 0.0213, 0.0213, 0.0213,
     . 0.0214, 0.0214, 0.0214, 0.0214, 0.0214, 0.0214, 0.0214, 0.0214,
     . 0.0214, 0.0214, 0.0214, 0.0214, 0.0214, 0.0215, 0.0215, 0.0215,
     . 0.0215, 0.0216, 0.0216, 0.0216, 0.0216, 0.0216, 0.0216, 0.0216,
     . 0.0216, 0.0216, 0.0217, 0.0217, 0.0218, 0.0218, 0.0218, 0.0218,
     . 0.0219, 0.0220, 0.0220, 0.0220, 0.0221, 0.0221, 0.0221, 0.0222,
     . 0.0198, 0.0198, 0.0198, 0.0198, 0.0198, 0.0198, 0.0198, 0.0198,
     . 0.0198, 0.0198, 0.0198, 0.0198, 0.0198, 0.0198, 0.0198, 0.0198,
     . 0.0198, 0.0198, 0.0198, 0.0197, 0.0198, 0.0198, 0.0198, 0.0198,
     . 0.0199, 0.0199, 0.0199, 0.0199, 0.0199, 0.0199, 0.0199, 0.0199,
     . 0.0199, 0.0199, 0.0199, 0.0199, 0.0199, 0.0200, 0.0200, 0.0201,
     . 0.0201, 0.0201, 0.0201, 0.0201, 0.0201, 0.0201, 0.0201, 0.0201,
     . 0.0201, 0.0201, 0.0202, 0.0203, 0.0203, 0.0203, 0.0203, 0.0203,
     . 0.0205, 0.0205, 0.0205, 0.0206, 0.0206, 0.0206, 0.0207, 0.0207,
     . 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184,
     . 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184,
     . 0.0184, 0.0185, 0.0185, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184,
     . 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184, 0.0184,
     . 0.0184, 0.0184, 0.0185, 0.0185, 0.0185, 0.0186, 0.0187, 0.0187,
     . 0.0187, 0.0187, 0.0188, 0.0188, 0.0188, 0.0188, 0.0188, 0.0188,
     . 0.0188, 0.0189, 0.0190, 0.0190, 0.0190, 0.0190, 0.0191, 0.0191,
     . 0.0192, 0.0192, 0.0193, 0.0193, 0.0193, 0.0193, 0.0194, 0.0194,
     . 0.0169, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169,
     . 0.0169, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169,
     . 0.0170, 0.0170, 0.0170, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169,
     . 0.0169, 0.0168, 0.0168, 0.0169, 0.0169, 0.0169, 0.0169, 0.0169,
     . 0.0169, 0.0169, 0.0169, 0.0170, 0.0170, 0.0171, 0.0172, 0.0172,
     . 0.0172, 0.0172, 0.0173, 0.0173, 0.0173, 0.0173, 0.0173, 0.0174,
     . 0.0174, 0.0174, 0.0175, 0.0175, 0.0175, 0.0175, 0.0175, 0.0176,
     . 0.0177, 0.0177, 0.0177, 0.0178, 0.0178, 0.0178, 0.0178, 0.0179,
     . 0.0154, 0.0154, 0.0154, 0.0154, 0.0154, 0.0154, 0.0154, 0.0154,
     . 0.0154, 0.0154, 0.0154, 0.0154, 0.0154, 0.0154, 0.0154, 0.0155,
     . 0.0155, 0.0155, 0.0155, 0.0154, 0.0154, 0.0154, 0.0154, 0.0154,
     . 0.0154, 0.0153, 0.0153, 0.0153, 0.0153, 0.0154, 0.0154, 0.0153,
     . 0.0154, 0.0154, 0.0154, 0.0155, 0.0155, 0.0156, 0.0157, 0.0157,
     . 0.0157, 0.0157, 0.0158, 0.0158, 0.0158, 0.0159, 0.0159, 0.0159,
     . 0.0159, 0.0159, 0.0160, 0.0160, 0.0160, 0.0160, 0.0160, 0.0161,
     . 0.0161, 0.0162, 0.0162, 0.0162, 0.0162, 0.0163, 0.0163, 0.0163,
     . 0.0139, 0.0139, 0.0139, 0.0139, 0.0139, 0.0139, 0.0139, 0.0139,
     . 0.0139, 0.0139, 0.0139, 0.0139, 0.0139, 0.0140, 0.0140, 0.0140,
     . 0.0140, 0.0140, 0.0140, 0.0139, 0.0139, 0.0139, 0.0139, 0.0139,
     . 0.0139, 0.0138, 0.0138, 0.0138, 0.0138, 0.0138, 0.0138, 0.0138,
     . 0.0139, 0.0139, 0.0139, 0.0139, 0.0140, 0.0141, 0.0142, 0.0142,
     . 0.0142, 0.0142, 0.0143, 0.0143, 0.0144, 0.0144, 0.0144, 0.0144,
     . 0.0144, 0.0144, 0.0144, 0.0145, 0.0145, 0.0145, 0.0145, 0.0145,
     . 0.0146, 0.0146, 0.0147, 0.0147, 0.0147, 0.0147, 0.0148, 0.0148,
     . 0.0124, 0.0124, 0.0124, 0.0124, 0.0123, 0.0123, 0.0124, 0.0124,
     . 0.0124, 0.0124, 0.0124, 0.0124, 0.0124, 0.0125, 0.0125, 0.0125,
     . 0.0125, 0.0125, 0.0125, 0.0124, 0.0124, 0.0124, 0.0124, 0.0124,
     . 0.0124, 0.0123, 0.0123, 0.0123, 0.0123, 0.0123, 0.0123, 0.0123,
     . 0.0124, 0.0124, 0.0124, 0.0124, 0.0125, 0.0126, 0.0127, 0.0127,
     . 0.0127, 0.0128, 0.0128, 0.0128, 0.0129, 0.0129, 0.0129, 0.0129,
     . 0.0129, 0.0129, 0.0129, 0.0129, 0.0130, 0.0130, 0.0130, 0.0130,
     . 0.0131, 0.0131, 0.0131, 0.0132, 0.0132, 0.0132, 0.0132, 0.0133,
     . 0.0109, 0.0109, 0.0109, 0.0108, 0.0108, 0.0108, 0.0109, 0.0109,
     . 0.0109, 0.0109, 0.0109, 0.0109, 0.0109, 0.0110, 0.0110, 0.0110,
     . 0.0110, 0.0110, 0.0110, 0.0109, 0.0109, 0.0109, 0.0109, 0.0109,
     . 0.0109, 0.0108, 0.0108, 0.0108, 0.0108, 0.0108, 0.0108, 0.0108,
     . 0.0108, 0.0109, 0.0109, 0.0109, 0.0110, 0.0111, 0.0112, 0.0112,
     . 0.0112, 0.0113, 0.0113, 0.0113, 0.0114, 0.0114, 0.0114, 0.0114,
     . 0.0114, 0.0114, 0.0114, 0.0114, 0.0114, 0.0115, 0.0115, 0.0115,
     . 0.0116, 0.0116, 0.0116, 0.0116, 0.0117, 0.0117, 0.0117, 0.0117,
     . 0.0096, 0.0096, 0.0096, 0.0096, 0.0096, 0.0095, 0.0096, 0.0096,
     . 0.0095, 0.0095, 0.0095, 0.0095, 0.0096, 0.0096, 0.0096, 0.0097,
     . 0.0097, 0.0097, 0.0096, 0.0095, 0.0095, 0.0095, 0.0095, 0.0095,
     . 0.0095, 0.0094, 0.0094, 0.0094, 0.0094, 0.0094, 0.0094, 0.0094,
     . 0.0094, 0.0094, 0.0094, 0.0094, 0.0094, 0.0096, 0.0097, 0.0097,
     . 0.0097, 0.0097, 0.0097, 0.0098, 0.0099, 0.0099, 0.0100, 0.0100,
     . 0.0100, 0.0101, 0.0101, 0.0101, 0.0101, 0.0101, 0.0101, 0.0102,
     . 0.0102, 0.0102, 0.0103, 0.0103, 0.0103, 0.0103, 0.0103, 0.0104,
     . 0.0081, 0.0081, 0.0081, 0.0081, 0.0081, 0.0080, 0.0081, 0.0081,
     . 0.0081, 0.0080, 0.0080, 0.0080, 0.0081, 0.0081, 0.0081, 0.0081,
     . 0.0082, 0.0082, 0.0081, 0.0080, 0.0080, 0.0080, 0.0080, 0.0080,
     . 0.0080, 0.0079, 0.0079, 0.0079, 0.0079, 0.0079, 0.0079, 0.0079,
     . 0.0079, 0.0079, 0.0079, 0.0079, 0.0079, 0.0081, 0.0082, 0.0082,
     . 0.0082, 0.0082, 0.0082, 0.0083, 0.0084, 0.0084, 0.0085, 0.0085,
     . 0.0085, 0.0086, 0.0086, 0.0086, 0.0086, 0.0086, 0.0086, 0.0087,
     . 0.0087, 0.0087, 0.0088, 0.0088, 0.0088, 0.0088, 0.0088, 0.0089,
     . 0.0066, 0.0066, 0.0066, 0.0066, 0.0066, 0.0066, 0.0066, 0.0066,
     . 0.0066, 0.0065, 0.0065, 0.0065, 0.0066, 0.0066, 0.0066, 0.0066,
     . 0.0066, 0.0067, 0.0066, 0.0065, 0.0065, 0.0065, 0.0065, 0.0065,
     . 0.0065, 0.0064, 0.0064, 0.0064, 0.0064, 0.0064, 0.0064, 0.0064,
     . 0.0064, 0.0064, 0.0064, 0.0064, 0.0065, 0.0066, 0.0067, 0.0067,
     . 0.0067, 0.0067, 0.0067, 0.0067, 0.0069, 0.0069, 0.0069, 0.0070,
     . 0.0070, 0.0070, 0.0071, 0.0071, 0.0071, 0.0071, 0.0071, 0.0072,
     . 0.0072, 0.0072, 0.0073, 0.0073, 0.0073, 0.0073, 0.0073, 0.0074,
     . 0.0052, 0.0051, 0.0051, 0.0051, 0.0051, 0.0051, 0.0051, 0.0051,
     . 0.0051, 0.0050, 0.0050, 0.0050, 0.0051, 0.0051, 0.0051, 0.0051,
     . 0.0051, 0.0052, 0.0051, 0.0050, 0.0050, 0.0050, 0.0050, 0.0050,
     . 0.0050, 0.0050, 0.0050, 0.0050, 0.0050, 0.0050, 0.0050, 0.0049,
     . 0.0049, 0.0049, 0.0049, 0.0050, 0.0050, 0.0051, 0.0051, 0.0052,
     . 0.0052, 0.0052, 0.0052, 0.0052, 0.0054, 0.0054, 0.0054, 0.0055,
     . 0.0055, 0.0055, 0.0056, 0.0056, 0.0056, 0.0056, 0.0056, 0.0057,
     . 0.0057, 0.0057, 0.0058, 0.0058, 0.0058, 0.0058, 0.0058, 0.0059,
     . 0.0037, 0.0036, 0.0036, 0.0036, 0.0036, 0.0036, 0.0036, 0.0036,
     . 0.0036, 0.0036, 0.0035, 0.0035, 0.0036, 0.0036, 0.0036, 0.0036,
     . 0.0036, 0.0037, 0.0036, 0.0035, 0.0035, 0.0035, 0.0035, 0.0035,
     . 0.0035, 0.0035, 0.0035, 0.0035, 0.0035, 0.0035, 0.0035, 0.0034,
     . 0.0034, 0.0035, 0.0035, 0.0035, 0.0035, 0.0036, 0.0036, 0.0037,
     . 0.0037, 0.0037, 0.0037, 0.0037, 0.0039, 0.0039, 0.0039, 0.0040,
     . 0.0040, 0.0040, 0.0041, 0.0041, 0.0041, 0.0041, 0.0041, 0.0042,
     . 0.0042, 0.0042, 0.0043, 0.0043, 0.0043, 0.0043, 0.0043, 0.0044,
     . 0.0022, 0.0021, 0.0021, 0.0021, 0.0021, 0.0021, 0.0021, 0.0021,
     . 0.0021, 0.0021, 0.0020, 0.0020, 0.0021, 0.0021, 0.0021, 0.0021,
     . 0.0022, 0.0022, 0.0021, 0.0020, 0.0020, 0.0020, 0.0020, 0.0020,
     . 0.0020, 0.0020, 0.0020, 0.0020, 0.0020, 0.0020, 0.0020, 0.0020,
     . 0.0020, 0.0020, 0.0020, 0.0020, 0.0020, 0.0021, 0.0021, 0.0021,
     . 0.0022, 0.0022, 0.0022, 0.0022, 0.0024, 0.0024, 0.0024, 0.0025,
     . 0.0025, 0.0025, 0.0026, 0.0026, 0.0026, 0.0026, 0.0026, 0.0027,
     . 0.0027, 0.0028, 0.0028, 0.0028, 0.0028, 0.0028, 0.0028, 0.0029,
     . 0.0007, 0.0007, 0.0007, 0.0007, 0.0007, 0.0007, 0.0007, 0.0007,
     . 0.0007, 0.0007, 0.0007, 0.0007, 0.0007, 0.0008, 0.0007, 0.0007,
     . 0.0007, 0.0007, 0.0006, 0.0005, 0.0005, 0.0005, 0.0005, 0.0005,
     . 0.0005, 0.0005, 0.0005, 0.0006, 0.0006, 0.0006, 0.0006, 0.0006,
     . 0.0006, 0.0006, 0.0006, 0.0006, 0.0006, 0.0007, 0.0007, 0.0007,
     . 0.0007, 0.0008, 0.0008, 0.0008, 0.0010, 0.0010, 0.0011, 0.0011,
     . 0.0011, 0.0012, 0.0012, 0.0013, 0.0013, 0.0013, 0.0013, 0.0013,
     . 0.0014, 0.0014, 0.0015, 0.0015, 0.0015, 0.0015, 0.0015, 0.0016,
     .-0.0008,-0.0008,-0.0008,-0.0008,-0.0008,-0.0008,-0.0008,-0.0008,
     .-0.0008,-0.0008,-0.0008,-0.0008,-0.0007,-0.0007,-0.0007,-0.0008,
     .-0.0008,-0.0008,-0.0009,-0.0010,-0.0010,-0.0010,-0.0010,-0.0010,
     .-0.0010,-0.0009,-0.0009,-0.0009,-0.0009,-0.0009,-0.0008,-0.0009,
     .-0.0009,-0.0009,-0.0009,-0.0009,-0.0009,-0.0008,-0.0008,-0.0008,
     .-0.0008,-0.0007,-0.0007,-0.0007,-0.0005,-0.0005,-0.0004,-0.0004,
     .-0.0003,-0.0003,-0.0002,-0.0002,-0.0002,-0.0002,-0.0002,-0.0001,
     .-0.0001, 0.0000, 0.0000, 0.0000, 0.0000, 0.0001, 0.0001, 0.0001,
     .-0.0023,-0.0023,-0.0023,-0.0023,-0.0023,-0.0023,-0.0022,-0.0022,
     .-0.0022,-0.0022,-0.0023,-0.0023,-0.0022,-0.0022,-0.0022,-0.0023,
     .-0.0023,-0.0023,-0.0024,-0.0025,-0.0025,-0.0025,-0.0025,-0.0025,
     .-0.0025,-0.0024,-0.0024,-0.0024,-0.0024,-0.0023,-0.0023,-0.0024,
     .-0.0024,-0.0024,-0.0024,-0.0023,-0.0023,-0.0023,-0.0023,-0.0023,
     .-0.0023,-0.0022,-0.0022,-0.0022,-0.0020,-0.0020,-0.0019,-0.0019,
     .-0.0018,-0.0018,-0.0017,-0.0017,-0.0017,-0.0017,-0.0016,-0.0016,
     .-0.0015,-0.0015,-0.0015,-0.0015,-0.0015,-0.0014,-0.0014,-0.0014,
     .-0.0038,-0.0038,-0.0038,-0.0038,-0.0038,-0.0038,-0.0037,-0.0037,
     .-0.0037,-0.0037,-0.0037,-0.0037,-0.0037,-0.0037,-0.0037,-0.0038,
     .-0.0038,-0.0038,-0.0039,-0.0040,-0.0040,-0.0040,-0.0040,-0.0040,
     .-0.0039,-0.0039,-0.0039,-0.0039,-0.0038,-0.0038,-0.0038,-0.0038,
     .-0.0038,-0.0038,-0.0038,-0.0038,-0.0038,-0.0038,-0.0038,-0.0038,
     .-0.0038,-0.0037,-0.0037,-0.0037,-0.0035,-0.0035,-0.0034,-0.0034,
     .-0.0033,-0.0033,-0.0032,-0.0032,-0.0032,-0.0031,-0.0031,-0.0031,
     .-0.0030,-0.0030,-0.0030,-0.0030,-0.0029,-0.0029,-0.0029,-0.0029,
     .-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,
     .-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,-0.0052,
     .-0.0053,-0.0053,-0.0054,-0.0055,-0.0055,-0.0055,-0.0055,-0.0054,
     .-0.0054,-0.0054,-0.0053,-0.0053,-0.0053,-0.0053,-0.0053,-0.0053,
     .-0.0053,-0.0053,-0.0053,-0.0053,-0.0053,-0.0053,-0.0053,-0.0053,
     .-0.0052,-0.0052,-0.0052,-0.0052,-0.0050,-0.0050,-0.0049,-0.0049,
     .-0.0048,-0.0048,-0.0047,-0.0047,-0.0047,-0.0046,-0.0046,-0.0046,
     .-0.0045,-0.0045,-0.0045,-0.0044,-0.0044,-0.0044,-0.0044,-0.0044,
     .-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,
     .-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,-0.0067,
     .-0.0068,-0.0068,-0.0068,-0.0070,-0.0070,-0.0069,-0.0069,-0.0069,
     .-0.0069,-0.0068,-0.0068,-0.0068,-0.0068,-0.0068,-0.0067,-0.0068,
     .-0.0068,-0.0068,-0.0068,-0.0068,-0.0068,-0.0068,-0.0068,-0.0068,
     .-0.0067,-0.0067,-0.0067,-0.0067,-0.0065,-0.0065,-0.0064,-0.0064,
     .-0.0063,-0.0063,-0.0062,-0.0062,-0.0061,-0.0061,-0.0061,-0.0061,
     .-0.0060,-0.0060,-0.0059,-0.0059,-0.0059,-0.0059,-0.0059,-0.0058,
     .-0.0081,-0.0081,-0.0081,-0.0081,-0.0081,-0.0081,-0.0081,-0.0081,
     .-0.0081,-0.0081,-0.0081,-0.0081,-0.0081,-0.0080,-0.0081,-0.0081,
     .-0.0081,-0.0081,-0.0082,-0.0083,-0.0083,-0.0083,-0.0083,-0.0083,
     .-0.0083,-0.0082,-0.0082,-0.0082,-0.0082,-0.0081,-0.0081,-0.0082,
     .-0.0082,-0.0082,-0.0082,-0.0081,-0.0081,-0.0082,-0.0082,-0.0082,
     .-0.0081,-0.0081,-0.0081,-0.0081,-0.0079,-0.0079,-0.0079,-0.0078,
     .-0.0078,-0.0078,-0.0077,-0.0076,-0.0076,-0.0076,-0.0076,-0.0075,
     .-0.0075,-0.0074,-0.0074,-0.0074,-0.0074,-0.0073,-0.0073,-0.0073,
     .-0.0095,-0.0095,-0.0095,-0.0095,-0.0095,-0.0095,-0.0095,-0.0095,
     .-0.0095,-0.0095,-0.0095,-0.0095,-0.0094,-0.0094,-0.0094,-0.0094,
     .-0.0095,-0.0095,-0.0095,-0.0096,-0.0096,-0.0096,-0.0096,-0.0096,
     .-0.0097,-0.0096,-0.0096,-0.0096,-0.0096,-0.0096,-0.0095,-0.0096,
     .-0.0096,-0.0096,-0.0096,-0.0095,-0.0095,-0.0095,-0.0095,-0.0095,
     .-0.0095,-0.0095,-0.0095,-0.0094,-0.0093,-0.0093,-0.0093,-0.0093,
     .-0.0093,-0.0092,-0.0091,-0.0091,-0.0091,-0.0091,-0.0090,-0.0090,
     .-0.0089,-0.0089,-0.0089,-0.0089,-0.0088,-0.0088,-0.0088,-0.0088,
     .-0.0110,-0.0110,-0.0110,-0.0110,-0.0110,-0.0110,-0.0110,-0.0109,
     .-0.0109,-0.0109,-0.0109,-0.0109,-0.0109,-0.0109,-0.0109,-0.0109,
     .-0.0109,-0.0110,-0.0110,-0.0111,-0.0111,-0.0111,-0.0111,-0.0111,
     .-0.0111,-0.0111,-0.0111,-0.0111,-0.0110,-0.0110,-0.0110,-0.0111,
     .-0.0111,-0.0110,-0.0110,-0.0110,-0.0110,-0.0110,-0.0110,-0.0110,
     .-0.0110,-0.0110,-0.0109,-0.0109,-0.0108,-0.0108,-0.0108,-0.0108,
     .-0.0107,-0.0107,-0.0106,-0.0106,-0.0106,-0.0106,-0.0105,-0.0105,
     .-0.0104,-0.0104,-0.0104,-0.0104,-0.0103,-0.0103,-0.0103,-0.0103,
     .-0.0125,-0.0125,-0.0125,-0.0125,-0.0125,-0.0125,-0.0124,-0.0124,
     .-0.0124,-0.0124,-0.0124,-0.0124,-0.0124,-0.0123,-0.0124,-0.0124,
     .-0.0124,-0.0124,-0.0125,-0.0126,-0.0126,-0.0126,-0.0126,-0.0126,
     .-0.0126,-0.0126,-0.0125,-0.0125,-0.0125,-0.0125,-0.0125,-0.0126,
     .-0.0125,-0.0125,-0.0125,-0.0125,-0.0125,-0.0125,-0.0125,-0.0125,
     .-0.0124,-0.0124,-0.0124,-0.0124,-0.0123,-0.0123,-0.0123,-0.0122,
     .-0.0122,-0.0122,-0.0121,-0.0121,-0.0121,-0.0120,-0.0120,-0.0120,
     .-0.0119,-0.0119,-0.0119,-0.0118,-0.0118,-0.0118,-0.0118,-0.0118,
     .-0.0140,-0.0140,-0.0140,-0.0140,-0.0140,-0.0140,-0.0139,-0.0139,
     .-0.0139,-0.0139,-0.0139,-0.0139,-0.0138,-0.0138,-0.0138,-0.0139,
     .-0.0139,-0.0139,-0.0139,-0.0140,-0.0140,-0.0140,-0.0141,-0.0141,
     .-0.0141,-0.0140,-0.0140,-0.0140,-0.0140,-0.0140,-0.0140,-0.0140,
     .-0.0140,-0.0140,-0.0140,-0.0140,-0.0140,-0.0139,-0.0139,-0.0139,
     .-0.0139,-0.0139,-0.0139,-0.0138,-0.0138,-0.0138,-0.0137,-0.0137,
     .-0.0137,-0.0137,-0.0136,-0.0136,-0.0136,-0.0135,-0.0135,-0.0135,
     .-0.0134,-0.0134,-0.0134,-0.0133,-0.0133,-0.0133,-0.0133,-0.0132,
     .-0.0155,-0.0155,-0.0155,-0.0154,-0.0154,-0.0154,-0.0154,-0.0154,
     .-0.0154,-0.0154,-0.0154,-0.0154,-0.0153,-0.0153,-0.0153,-0.0153,
     .-0.0153,-0.0154,-0.0154,-0.0155,-0.0155,-0.0155,-0.0155,-0.0155,
     .-0.0155,-0.0155,-0.0155,-0.0155,-0.0155,-0.0155,-0.0155,-0.0155,
     .-0.0155,-0.0155,-0.0155,-0.0155,-0.0154,-0.0154,-0.0154,-0.0154,
     .-0.0154,-0.0153,-0.0153,-0.0153,-0.0153,-0.0152,-0.0152,-0.0152,
     .-0.0152,-0.0152,-0.0151,-0.0151,-0.0150,-0.0150,-0.0150,-0.0150,
     .-0.0149,-0.0149,-0.0149,-0.0148,-0.0148,-0.0148,-0.0148,-0.0147,
     .-0.0169,-0.0169,-0.0169,-0.0169,-0.0169,-0.0169,-0.0169,-0.0168,
     .-0.0168,-0.0168,-0.0168,-0.0168,-0.0168,-0.0167,-0.0167,-0.0168,
     .-0.0168,-0.0168,-0.0168,-0.0169,-0.0169,-0.0169,-0.0169,-0.0170,
     .-0.0170,-0.0170,-0.0170,-0.0170,-0.0170,-0.0169,-0.0169,-0.0169,
     .-0.0169,-0.0169,-0.0169,-0.0169,-0.0169,-0.0168,-0.0168,-0.0168,
     .-0.0168,-0.0168,-0.0168,-0.0167,-0.0167,-0.0167,-0.0167,-0.0166,
     .-0.0166,-0.0166,-0.0165,-0.0165,-0.0165,-0.0165,-0.0165,-0.0164,
     .-0.0164,-0.0163,-0.0163,-0.0163,-0.0163,-0.0163,-0.0162,-0.0162,
     .-0.0184,-0.0184,-0.0184,-0.0183,-0.0183,-0.0183,-0.0183,-0.0183,
     .-0.0182,-0.0182,-0.0182,-0.0182,-0.0182,-0.0181,-0.0181,-0.0181,
     .-0.0180,-0.0180,-0.0180,-0.0181,-0.0181,-0.0181,-0.0181,-0.0181,
     .-0.0181,-0.0181,-0.0181,-0.0181,-0.0181,-0.0181,-0.0181,-0.0181,
     .-0.0181,-0.0181,-0.0181,-0.0180,-0.0180,-0.0180,-0.0179,-0.0179,
     .-0.0179,-0.0179,-0.0179,-0.0179,-0.0178,-0.0178,-0.0178,-0.0178,
     .-0.0178,-0.0178,-0.0177,-0.0177,-0.0177,-0.0177,-0.0177,-0.0177,
     .-0.0176,-0.0176,-0.0176,-0.0176,-0.0176,-0.0176,-0.0176,-0.0176,
     .-0.0199,-0.0198,-0.0198,-0.0198,-0.0198,-0.0198,-0.0197,-0.0197,
     .-0.0197,-0.0197,-0.0197,-0.0197,-0.0196,-0.0196,-0.0196,-0.0195,
     .-0.0195,-0.0195,-0.0195,-0.0196,-0.0196,-0.0196,-0.0196,-0.0196,
     .-0.0196,-0.0196,-0.0196,-0.0196,-0.0196,-0.0196,-0.0196,-0.0196,
     .-0.0196,-0.0196,-0.0195,-0.0195,-0.0195,-0.0195,-0.0194,-0.0194,
     .-0.0194,-0.0194,-0.0194,-0.0193,-0.0193,-0.0193,-0.0193,-0.0193,
     .-0.0192,-0.0192,-0.0192,-0.0192,-0.0192,-0.0192,-0.0192,-0.0191,
     .-0.0191,-0.0191,-0.0191,-0.0191,-0.0191,-0.0191,-0.0191,-0.0191,
     .-0.0213,-0.0213,-0.0213,-0.0213,-0.0213,-0.0213,-0.0212,-0.0212,
     .-0.0212,-0.0212,-0.0212,-0.0212,-0.0211,-0.0210,-0.0210,-0.0210,
     .-0.0210,-0.0210,-0.0210,-0.0211,-0.0210,-0.0210,-0.0210,-0.0210,
     .-0.0210,-0.0210,-0.0210,-0.0210,-0.0210,-0.0210,-0.0210,-0.0211,
     .-0.0211,-0.0210,-0.0210,-0.0210,-0.0210,-0.0209,-0.0209,-0.0209,
     .-0.0209,-0.0208,-0.0208,-0.0208,-0.0208,-0.0208,-0.0207,-0.0207,
     .-0.0207,-0.0207,-0.0207,-0.0207,-0.0207,-0.0206,-0.0206,-0.0206,
     .-0.0206,-0.0206,-0.0206,-0.0206,-0.0206,-0.0206,-0.0206,-0.0206,
     .-0.0228,-0.0228,-0.0228,-0.0228,-0.0228,-0.0227,-0.0227,-0.0227,
     .-0.0227,-0.0227,-0.0227,-0.0226,-0.0226,-0.0225,-0.0225,-0.0225,
     .-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,
     .-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,
     .-0.0225,-0.0225,-0.0225,-0.0225,-0.0225,-0.0224,-0.0223,-0.0223,
     .-0.0223,-0.0223,-0.0223,-0.0223,-0.0222,-0.0222,-0.0222,-0.0222,
     .-0.0222,-0.0222,-0.0222,-0.0222,-0.0221,-0.0221,-0.0221,-0.0221,
     .-0.0221,-0.0221,-0.0221,-0.0221,-0.0221,-0.0221,-0.0221,-0.0221,
     .-0.0243,-0.0243,-0.0243,-0.0242,-0.0242,-0.0242,-0.0242,-0.0241,
     .-0.0241,-0.0241,-0.0241,-0.0241,-0.0241,-0.0240,-0.0240,-0.0240,
     .-0.0240,-0.0240,-0.0239,-0.0240,-0.0240,-0.0240,-0.0240,-0.0240,
     .-0.0239,-0.0240,-0.0240,-0.0240,-0.0240,-0.0240,-0.0240,-0.0240,
     .-0.0240,-0.0240,-0.0240,-0.0240,-0.0239,-0.0239,-0.0238,-0.0238,
     .-0.0238,-0.0238,-0.0238,-0.0237,-0.0237,-0.0237,-0.0237,-0.0237,
     .-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,
     .-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,-0.0236,
     .-0.0257,-0.0257,-0.0257,-0.0257,-0.0257,-0.0257,-0.0256,-0.0256,
     .-0.0256,-0.0256,-0.0256,-0.0256,-0.0255,-0.0255,-0.0255,-0.0254,
     .-0.0254,-0.0254,-0.0254,-0.0254,-0.0254,-0.0254,-0.0254,-0.0254,
     .-0.0254,-0.0254,-0.0254,-0.0254,-0.0254,-0.0254,-0.0254,-0.0255,
     .-0.0255,-0.0255,-0.0254,-0.0254,-0.0254,-0.0253,-0.0253,-0.0253,
     .-0.0252,-0.0252,-0.0252,-0.0252,-0.0251,-0.0251,-0.0251,-0.0251,
     .-0.0251,-0.0251,-0.0251,-0.0251,-0.0251,-0.0251,-0.0251,-0.0251,
     .-0.0251,-0.0251,-0.0251,-0.0251,-0.0251,-0.0251,-0.0251,-0.0250,
     .-0.0273,-0.0273,-0.0273,-0.0273,-0.0273,-0.0273,-0.0272,-0.0272,
     .-0.0272,-0.0272,-0.0272,-0.0272,-0.0271,-0.0270,-0.0270,-0.0270,
     .-0.0270,-0.0270,-0.0270,-0.0270,-0.0269,-0.0269,-0.0269,-0.0269,
     .-0.0269,-0.0269,-0.0269,-0.0269,-0.0269,-0.0269,-0.0269,-0.0270,
     .-0.0269,-0.0269,-0.0269,-0.0269,-0.0269,-0.0268,-0.0268,-0.0268,
     .-0.0268,-0.0267,-0.0267,-0.0267,-0.0267,-0.0267,-0.0267,-0.0267,
     .-0.0267,-0.0267,-0.0267,-0.0267,-0.0267,-0.0267,-0.0267,-0.0267,
     .-0.0267,-0.0266,-0.0266,-0.0266,-0.0266,-0.0266,-0.0266,-0.0266,
     .-0.0288,-0.0288,-0.0288,-0.0288,-0.0288,-0.0287,-0.0287,-0.0287,
     .-0.0287,-0.0287,-0.0286,-0.0286,-0.0286,-0.0285,-0.0285,-0.0285,
     .-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,
     .-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,
     .-0.0284,-0.0284,-0.0284,-0.0284,-0.0284,-0.0283,-0.0282,-0.0282,
     .-0.0282,-0.0282,-0.0282,-0.0282,-0.0282,-0.0282,-0.0281,-0.0281,
     .-0.0281,-0.0281,-0.0282,-0.0282,-0.0282,-0.0282,-0.0281,-0.0281,
     .-0.0281,-0.0281,-0.0281,-0.0281,-0.0281,-0.0281,-0.0281,-0.0280,
     .-0.0303,-0.0303,-0.0302,-0.0302,-0.0302,-0.0302,-0.0302,-0.0301,
     .-0.0301,-0.0301,-0.0301,-0.0301,-0.0300,-0.0300,-0.0299,-0.0299,
     .-0.0299,-0.0299,-0.0299,-0.0299,-0.0299,-0.0299,-0.0299,-0.0298,
     .-0.0298,-0.0299,-0.0298,-0.0298,-0.0298,-0.0298,-0.0298,-0.0299,
     .-0.0299,-0.0299,-0.0298,-0.0298,-0.0298,-0.0298,-0.0297,-0.0297,
     .-0.0297,-0.0297,-0.0297,-0.0297,-0.0296,-0.0296,-0.0296,-0.0296,
     .-0.0296,-0.0296,-0.0297,-0.0296,-0.0296,-0.0296,-0.0296,-0.0296,
     .-0.0296,-0.0296,-0.0296,-0.0296,-0.0296,-0.0295,-0.0295,-0.0295,
     .-0.0317,-0.0317,-0.0317,-0.0317,-0.0317,-0.0317,-0.0316,-0.0316,
     .-0.0316,-0.0316,-0.0316,-0.0316,-0.0315,-0.0314,-0.0314,-0.0314,
     .-0.0314,-0.0314,-0.0313,-0.0313,-0.0313,-0.0313,-0.0313,-0.0313,
     .-0.0313,-0.0313,-0.0313,-0.0313,-0.0313,-0.0313,-0.0313,-0.0313,
     .-0.0313,-0.0313,-0.0313,-0.0313,-0.0313,-0.0312,-0.0312,-0.0312,
     .-0.0312,-0.0311,-0.0311,-0.0311,-0.0311,-0.0311,-0.0311,-0.0311,
     .-0.0311,-0.0311,-0.0311,-0.0311,-0.0311,-0.0311,-0.0311,-0.0311,
     .-0.0311,-0.0310,-0.0310,-0.0310,-0.0310,-0.0310,-0.0310,-0.0310,
     .-0.0332,-0.0332,-0.0332,-0.0332,-0.0332,-0.0331,-0.0331,-0.0331,
     .-0.0331,-0.0330,-0.0330,-0.0330,-0.0330,-0.0329,-0.0329,-0.0329,
     .-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,
     .-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,-0.0328,
     .-0.0328,-0.0328,-0.0328,-0.0328,-0.0327,-0.0327,-0.0326,-0.0326,
     .-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,
     .-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,-0.0326,
     .-0.0325,-0.0325,-0.0325,-0.0325,-0.0325,-0.0325,-0.0325,-0.0325,
     .-0.0346,-0.0346,-0.0346,-0.0346,-0.0346,-0.0346,-0.0345,-0.0345,
     .-0.0345,-0.0345,-0.0345,-0.0345,-0.0344,-0.0343,-0.0343,-0.0343,
     .-0.0343,-0.0343,-0.0343,-0.0343,-0.0343,-0.0343,-0.0342,-0.0342,
     .-0.0342,-0.0342,-0.0342,-0.0342,-0.0342,-0.0342,-0.0342,-0.0342,
     .-0.0342,-0.0342,-0.0342,-0.0342,-0.0342,-0.0341,-0.0341,-0.0341,
     .-0.0341,-0.0341,-0.0341,-0.0341,-0.0340,-0.0340,-0.0340,-0.0340,
     .-0.0340,-0.0340,-0.0341,-0.0340,-0.0340,-0.0340,-0.0340,-0.0340,
     .-0.0340,-0.0340,-0.0340,-0.0340,-0.0340,-0.0339,-0.0339,-0.0339,
     .-0.0361,-0.0361,-0.0361,-0.0361,-0.0361,-0.0361,-0.0360,-0.0360,
     .-0.0360,-0.0360,-0.0360,-0.0360,-0.0359,-0.0358,-0.0358,-0.0357,
     .-0.0357,-0.0357,-0.0357,-0.0357,-0.0357,-0.0357,-0.0356,-0.0356,
     .-0.0356,-0.0356,-0.0356,-0.0356,-0.0356,-0.0356,-0.0356,-0.0357,
     .-0.0356,-0.0356,-0.0356,-0.0356,-0.0356,-0.0355,-0.0355,-0.0355,
     .-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,
     .-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,-0.0355,
     .-0.0354,-0.0354,-0.0354,-0.0354,-0.0354,-0.0354,-0.0354,-0.0354,
     .-0.0376,-0.0376,-0.0375,-0.0375,-0.0375,-0.0375,-0.0375,-0.0375,
     .-0.0374,-0.0374,-0.0374,-0.0374,-0.0373,-0.0373,-0.0372,-0.0372,
     .-0.0372,-0.0371,-0.0371,-0.0371,-0.0371,-0.0371,-0.0371,-0.0371,
     .-0.0371,-0.0371,-0.0371,-0.0371,-0.0371,-0.0371,-0.0371,-0.0371,
     .-0.0371,-0.0371,-0.0371,-0.0370,-0.0370,-0.0370,-0.0370,-0.0370,
     .-0.0370,-0.0369,-0.0369,-0.0369,-0.0370,-0.0370,-0.0370,-0.0370,
     .-0.0370,-0.0370,-0.0370,-0.0370,-0.0369,-0.0369,-0.0369,-0.0369,
     .-0.0369,-0.0369,-0.0369,-0.0369,-0.0369,-0.0369,-0.0368,-0.0368,
     .-0.0390,-0.0390,-0.0390,-0.0390,-0.0390,-0.0390,-0.0389,-0.0389,
     .-0.0389,-0.0389,-0.0389,-0.0389,-0.0388,-0.0387,-0.0387,-0.0387,
     .-0.0386,-0.0386,-0.0386,-0.0386,-0.0386,-0.0386,-0.0386,-0.0386,
     .-0.0385,-0.0385,-0.0385,-0.0385,-0.0385,-0.0385,-0.0385,-0.0385,
     .-0.0385,-0.0385,-0.0385,-0.0385,-0.0385,-0.0384,-0.0384,-0.0384,
     .-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,
     .-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,-0.0384,
     .-0.0384,-0.0384,-0.0384,-0.0383,-0.0383,-0.0383,-0.0383,-0.0383,
     .-0.0405,-0.0405,-0.0405,-0.0405,-0.0404,-0.0404,-0.0404,-0.0404,
     .-0.0404,-0.0404,-0.0403,-0.0403,-0.0403,-0.0402,-0.0401,-0.0401,
     .-0.0401,-0.0401,-0.0400,-0.0401,-0.0401,-0.0400,-0.0400,-0.0400,
     .-0.0400,-0.0400,-0.0400,-0.0400,-0.0400,-0.0400,-0.0400,-0.0400,
     .-0.0400,-0.0400,-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,
     .-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,
     .-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,-0.0399,-0.0398,
     .-0.0398,-0.0398,-0.0398,-0.0398,-0.0398,-0.0398,-0.0398,-0.0398,
     .-0.0419,-0.0419,-0.0419,-0.0419,-0.0419,-0.0419,-0.0418,-0.0418,
     .-0.0418,-0.0418,-0.0418,-0.0418,-0.0417,-0.0416,-0.0416,-0.0416,
     .-0.0416,-0.0415,-0.0415,-0.0415,-0.0415,-0.0415,-0.0415,-0.0415,
     .-0.0415,-0.0414,-0.0414,-0.0414,-0.0414,-0.0414,-0.0414,-0.0414,
     .-0.0414,-0.0414,-0.0414,-0.0414,-0.0414,-0.0414,-0.0413,-0.0413,
     .-0.0413,-0.0413,-0.0413,-0.0413,-0.0414,-0.0414,-0.0414,-0.0414,
     .-0.0414,-0.0414,-0.0414,-0.0413,-0.0413,-0.0413,-0.0413,-0.0413,
     .-0.0413,-0.0413,-0.0413,-0.0413,-0.0413,-0.0412,-0.0412,-0.0412,
     .-0.0434,-0.0434,-0.0434,-0.0434,-0.0434,-0.0433,-0.0433,-0.0433,
     .-0.0433,-0.0433,-0.0433,-0.0432,-0.0432,-0.0431,-0.0431,-0.0430,
     .-0.0430,-0.0430,-0.0430,-0.0430,-0.0430,-0.0430,-0.0429,-0.0429,
     .-0.0429,-0.0429,-0.0429,-0.0429,-0.0429,-0.0429,-0.0429,-0.0429,
     .-0.0429,-0.0428,-0.0428,-0.0428,-0.0428,-0.0428,-0.0428,-0.0428,
     .-0.0428,-0.0428,-0.0428,-0.0428,-0.0429,-0.0429,-0.0429,-0.0429,
     .-0.0429,-0.0429,-0.0428,-0.0428,-0.0428,-0.0428,-0.0428,-0.0428,
     .-0.0428,-0.0427,-0.0427,-0.0427,-0.0427,-0.0427,-0.0427,-0.0427,
     .-0.0448,-0.0448,-0.0448,-0.0448,-0.0448,-0.0448,-0.0448,-0.0447,
     .-0.0447,-0.0447,-0.0447,-0.0447,-0.0446,-0.0445,-0.0445,-0.0445,
     .-0.0445,-0.0444,-0.0444,-0.0444,-0.0444,-0.0444,-0.0444,-0.0444,
     .-0.0444,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,
     .-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,
     .-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,
     .-0.0443,-0.0443,-0.0443,-0.0443,-0.0443,-0.0442,-0.0442,-0.0442,
     .-0.0442,-0.0442,-0.0442,-0.0442,-0.0442,-0.0442,-0.0442,-0.0442,
     .-0.0463,-0.0463,-0.0463,-0.0463,-0.0463,-0.0462,-0.0462,-0.0462,
     .-0.0462,-0.0462,-0.0462,-0.0461,-0.0461,-0.0460,-0.0460,-0.0459,
     .-0.0459,-0.0459,-0.0459,-0.0459,-0.0459,-0.0459,-0.0459,-0.0459,
     .-0.0458,-0.0458,-0.0458,-0.0458,-0.0458,-0.0458,-0.0458,-0.0457,
     .-0.0457,-0.0457,-0.0457,-0.0457,-0.0457,-0.0457,-0.0457,-0.0457,
     .-0.0457,-0.0457,-0.0457,-0.0457,-0.0458,-0.0458,-0.0458,-0.0458,
     .-0.0458,-0.0458,-0.0457,-0.0457,-0.0457,-0.0457,-0.0457,-0.0457,
     .-0.0457,-0.0457,-0.0457,-0.0456,-0.0456,-0.0456,-0.0456,-0.0456/
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc3uv_zpa.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------
c
c
c
      real function wfc3uv_zpa(xr,yr,kin)
      implicit none
 
      real*8 xr, yr
      integer kin
 
      real    ri,rj
      integer ii,jj
      real    fi,fj
 
      real wfc3uv_zp_arr(64,64)
      common /wfc3uv_zp_arr_/wfc3uv_zp_arr
 
      ri = 1 + (xr-32)/64.0
      rj = 1 + (yr-32)/64.0
      if (ri.le. 1.0) ri =  1.00
      if (rj.le. 1.0) rj =  1.00
      if (ri.ge.64.0) ri = 63.99
      if (rj.ge.64.0) rj = 63.99
      ii = int(ri)
      jj = int(rj)
      fi = ri-ii
      fj = rj-jj
 
      wfc3uv_zpa = (1-fi)*(1-fj)*wfc3uv_zp_arr(ii  ,jj  )
     .           + (1-fi)*( fj )*wfc3uv_zp_arr(ii  ,jj+1)
     .           + ( fi )*(1-fj)*wfc3uv_zp_arr(ii+1,jj  )
     .           + ( fi )*( fj )*wfc3uv_zp_arr(ii+1,jj+1)
 
      return
      end
 
 
 
c--------------------------------
c
c
      block data wfc3uv_zp_arr_BD
      real wfc3uv_zp_arr(64,64)
      common /wfc3uv_zp_arr_/wfc3uv_zp_arr
      data wfc3uv_zp_arr/
     .-0.0008,-0.0014,-0.0020,-0.0026,-0.0033,-0.0038,-0.0044,-0.0051,
     .-0.0055,-0.0060,-0.0066,-0.0071,-0.0078,-0.0084,-0.0090,-0.0095,
     .-0.0101,-0.0107,-0.0113,-0.0119,-0.0126,-0.0132,-0.0137,-0.0143,
     .-0.0148,-0.0155,-0.0161,-0.0167,-0.0172,-0.0177,-0.0183,-0.0188,
     .-0.0194,-0.0200,-0.0208,-0.0214,-0.0220,-0.0225,-0.0230,-0.0236,
     .-0.0242,-0.0247,-0.0252,-0.0258,-0.0264,-0.0271,-0.0277,-0.0283,
     .-0.0289,-0.0295,-0.0302,-0.0308,-0.0314,-0.0319,-0.0326,-0.0332,
     .-0.0339,-0.0345,-0.0351,-0.0356,-0.0361,-0.0368,-0.0374,-0.0380,
     .-0.0001,-0.0007,-0.0013,-0.0018,-0.0025,-0.0031,-0.0037,-0.0043,
     .-0.0048,-0.0053,-0.0058,-0.0064,-0.0071,-0.0077,-0.0082,-0.0088,
     .-0.0094,-0.0100,-0.0106,-0.0112,-0.0119,-0.0125,-0.0130,-0.0136,
     .-0.0141,-0.0148,-0.0154,-0.0160,-0.0165,-0.0170,-0.0176,-0.0181,
     .-0.0188,-0.0194,-0.0201,-0.0207,-0.0213,-0.0218,-0.0223,-0.0229,
     .-0.0235,-0.0240,-0.0246,-0.0252,-0.0258,-0.0265,-0.0270,-0.0276,
     .-0.0283,-0.0289,-0.0295,-0.0302,-0.0307,-0.0313,-0.0319,-0.0326,
     .-0.0332,-0.0338,-0.0345,-0.0350,-0.0355,-0.0361,-0.0368,-0.0374,
     . 0.0006, 0.0000,-0.0006,-0.0011,-0.0018,-0.0024,-0.0030,-0.0036,
     .-0.0041,-0.0046,-0.0051,-0.0057,-0.0063,-0.0070,-0.0075,-0.0081,
     .-0.0086,-0.0093,-0.0099,-0.0105,-0.0112,-0.0118,-0.0123,-0.0129,
     .-0.0134,-0.0141,-0.0147,-0.0153,-0.0158,-0.0164,-0.0169,-0.0175,
     .-0.0181,-0.0187,-0.0195,-0.0201,-0.0207,-0.0212,-0.0217,-0.0223,
     .-0.0229,-0.0234,-0.0240,-0.0246,-0.0251,-0.0259,-0.0264,-0.0270,
     .-0.0276,-0.0283,-0.0289,-0.0295,-0.0301,-0.0307,-0.0313,-0.0319,
     .-0.0326,-0.0332,-0.0338,-0.0344,-0.0349,-0.0355,-0.0361,-0.0367,
     . 0.0014, 0.0008, 0.0001,-0.0004,-0.0010,-0.0017,-0.0022,-0.0028,
     .-0.0033,-0.0038,-0.0043,-0.0050,-0.0056,-0.0063,-0.0069,-0.0074,
     .-0.0079,-0.0086,-0.0092,-0.0098,-0.0105,-0.0111,-0.0116,-0.0122,
     .-0.0127,-0.0134,-0.0140,-0.0145,-0.0150,-0.0156,-0.0161,-0.0167,
     .-0.0174,-0.0180,-0.0188,-0.0194,-0.0199,-0.0205,-0.0210,-0.0216,
     .-0.0221,-0.0227,-0.0233,-0.0239,-0.0244,-0.0252,-0.0258,-0.0264,
     .-0.0270,-0.0276,-0.0282,-0.0288,-0.0294,-0.0300,-0.0307,-0.0313,
     .-0.0319,-0.0325,-0.0331,-0.0337,-0.0342,-0.0349,-0.0354,-0.0360,
     . 0.0020, 0.0015, 0.0009, 0.0003,-0.0003,-0.0009,-0.0015,-0.0021,
     .-0.0027,-0.0031,-0.0036,-0.0042,-0.0049,-0.0055,-0.0061,-0.0066,
     .-0.0072,-0.0078,-0.0084,-0.0091,-0.0097,-0.0104,-0.0110,-0.0115,
     .-0.0120,-0.0127,-0.0133,-0.0139,-0.0144,-0.0149,-0.0155,-0.0161,
     .-0.0168,-0.0174,-0.0182,-0.0188,-0.0193,-0.0199,-0.0204,-0.0210,
     .-0.0216,-0.0221,-0.0227,-0.0233,-0.0239,-0.0246,-0.0252,-0.0258,
     .-0.0264,-0.0270,-0.0277,-0.0283,-0.0289,-0.0295,-0.0301,-0.0307,
     .-0.0314,-0.0320,-0.0326,-0.0332,-0.0336,-0.0343,-0.0349,-0.0355,
     . 0.0027, 0.0021, 0.0016, 0.0010, 0.0003,-0.0002,-0.0008,-0.0015,
     .-0.0020,-0.0024,-0.0030,-0.0036,-0.0043,-0.0049,-0.0055,-0.0060,
     .-0.0066,-0.0072,-0.0078,-0.0084,-0.0091,-0.0097,-0.0103,-0.0109,
     .-0.0114,-0.0121,-0.0127,-0.0133,-0.0139,-0.0144,-0.0150,-0.0156,
     .-0.0163,-0.0169,-0.0176,-0.0182,-0.0188,-0.0193,-0.0198,-0.0205,
     .-0.0210,-0.0216,-0.0221,-0.0227,-0.0233,-0.0240,-0.0246,-0.0252,
     .-0.0258,-0.0264,-0.0270,-0.0276,-0.0282,-0.0288,-0.0294,-0.0300,
     .-0.0307,-0.0313,-0.0320,-0.0325,-0.0329,-0.0337,-0.0343,-0.0349,
     . 0.0033, 0.0027, 0.0021, 0.0016, 0.0009, 0.0003,-0.0002,-0.0009,
     .-0.0014,-0.0019,-0.0024,-0.0030,-0.0037,-0.0044,-0.0049,-0.0054,
     .-0.0060,-0.0066,-0.0071,-0.0078,-0.0085,-0.0091,-0.0097,-0.0103,
     .-0.0108,-0.0115,-0.0121,-0.0127,-0.0133,-0.0139,-0.0145,-0.0151,
     .-0.0156,-0.0163,-0.0170,-0.0176,-0.0182,-0.0188,-0.0193,-0.0199,
     .-0.0204,-0.0210,-0.0216,-0.0222,-0.0227,-0.0234,-0.0240,-0.0245,
     .-0.0251,-0.0257,-0.0264,-0.0270,-0.0276,-0.0281,-0.0288,-0.0294,
     .-0.0301,-0.0307,-0.0313,-0.0319,-0.0323,-0.0330,-0.0337,-0.0343,
     . 0.0038, 0.0033, 0.0027, 0.0022, 0.0015, 0.0009, 0.0003,-0.0003,
     .-0.0008,-0.0013,-0.0018,-0.0024,-0.0030,-0.0037,-0.0043,-0.0049,
     .-0.0054,-0.0060,-0.0065,-0.0072,-0.0079,-0.0085,-0.0090,-0.0096,
     .-0.0101,-0.0109,-0.0115,-0.0121,-0.0127,-0.0132,-0.0138,-0.0145,
     .-0.0150,-0.0157,-0.0163,-0.0169,-0.0176,-0.0181,-0.0187,-0.0193,
     .-0.0198,-0.0204,-0.0210,-0.0216,-0.0222,-0.0228,-0.0234,-0.0240,
     .-0.0245,-0.0251,-0.0257,-0.0263,-0.0269,-0.0275,-0.0281,-0.0287,
     .-0.0295,-0.0301,-0.0307,-0.0313,-0.0318,-0.0325,-0.0331,-0.0337,
     . 0.0045, 0.0039, 0.0033, 0.0028, 0.0022, 0.0016, 0.0010, 0.0003,
     .-0.0001,-0.0006,-0.0012,-0.0017,-0.0024,-0.0031,-0.0036,-0.0042,
     .-0.0047,-0.0054,-0.0059,-0.0066,-0.0072,-0.0079,-0.0085,-0.0090,
     .-0.0095,-0.0102,-0.0108,-0.0115,-0.0121,-0.0127,-0.0133,-0.0139,
     .-0.0145,-0.0150,-0.0157,-0.0163,-0.0169,-0.0175,-0.0181,-0.0187,
     .-0.0193,-0.0198,-0.0204,-0.0210,-0.0216,-0.0222,-0.0227,-0.0233,
     .-0.0239,-0.0245,-0.0251,-0.0257,-0.0262,-0.0269,-0.0275,-0.0281,
     .-0.0288,-0.0295,-0.0301,-0.0307,-0.0312,-0.0319,-0.0325,-0.0332,
     . 0.0050, 0.0045, 0.0039, 0.0034, 0.0028, 0.0023, 0.0016, 0.0010,
     . 0.0004, 0.0000,-0.0005,-0.0011,-0.0017,-0.0024,-0.0030,-0.0036,
     .-0.0042,-0.0048,-0.0053,-0.0061,-0.0067,-0.0073,-0.0079,-0.0084,
     .-0.0090,-0.0097,-0.0103,-0.0109,-0.0115,-0.0121,-0.0127,-0.0133,
     .-0.0138,-0.0144,-0.0150,-0.0157,-0.0163,-0.0169,-0.0174,-0.0180,
     .-0.0186,-0.0192,-0.0198,-0.0203,-0.0209,-0.0216,-0.0222,-0.0228,
     .-0.0233,-0.0239,-0.0245,-0.0251,-0.0257,-0.0263,-0.0269,-0.0275,
     .-0.0282,-0.0289,-0.0295,-0.0301,-0.0306,-0.0314,-0.0320,-0.0326,
     . 0.0057, 0.0051, 0.0046, 0.0040, 0.0035, 0.0029, 0.0023, 0.0017,
     . 0.0011, 0.0006, 0.0001,-0.0005,-0.0011,-0.0019,-0.0024,-0.0030,
     .-0.0036,-0.0042,-0.0048,-0.0055,-0.0061,-0.0067,-0.0073,-0.0078,
     .-0.0083,-0.0091,-0.0097,-0.0103,-0.0109,-0.0115,-0.0121,-0.0127,
     .-0.0133,-0.0138,-0.0144,-0.0151,-0.0157,-0.0163,-0.0168,-0.0174,
     .-0.0179,-0.0186,-0.0192,-0.0197,-0.0204,-0.0210,-0.0216,-0.0222,
     .-0.0228,-0.0233,-0.0239,-0.0245,-0.0251,-0.0257,-0.0263,-0.0269,
     .-0.0276,-0.0282,-0.0289,-0.0295,-0.0299,-0.0307,-0.0314,-0.0320,
     . 0.0063, 0.0057, 0.0052, 0.0046, 0.0041, 0.0035, 0.0029, 0.0022,
     . 0.0017, 0.0013, 0.0007, 0.0001,-0.0006,-0.0013,-0.0018,-0.0024,
     .-0.0031,-0.0037,-0.0042,-0.0049,-0.0055,-0.0061,-0.0067,-0.0072,
     .-0.0078,-0.0085,-0.0091,-0.0097,-0.0103,-0.0109,-0.0115,-0.0121,
     .-0.0127,-0.0133,-0.0139,-0.0145,-0.0151,-0.0157,-0.0162,-0.0168,
     .-0.0173,-0.0179,-0.0185,-0.0190,-0.0196,-0.0203,-0.0209,-0.0216,
     .-0.0221,-0.0227,-0.0233,-0.0239,-0.0244,-0.0251,-0.0257,-0.0262,
     .-0.0269,-0.0275,-0.0282,-0.0288,-0.0293,-0.0300,-0.0306,-0.0312,
     . 0.0068, 0.0063, 0.0058, 0.0052, 0.0047, 0.0041, 0.0035, 0.0028,
     . 0.0023, 0.0018, 0.0012, 0.0006, 0.0000,-0.0008,-0.0014,-0.0020,
     .-0.0026,-0.0032,-0.0037,-0.0044,-0.0049,-0.0056,-0.0062,-0.0068,
     .-0.0074,-0.0081,-0.0086,-0.0092,-0.0098,-0.0104,-0.0110,-0.0116,
     .-0.0121,-0.0127,-0.0134,-0.0140,-0.0145,-0.0151,-0.0156,-0.0163,
     .-0.0168,-0.0173,-0.0179,-0.0185,-0.0191,-0.0198,-0.0204,-0.0210,
     .-0.0216,-0.0222,-0.0228,-0.0234,-0.0240,-0.0246,-0.0252,-0.0258,
     .-0.0265,-0.0271,-0.0277,-0.0283,-0.0289,-0.0295,-0.0301,-0.0308,
     . 0.0074, 0.0069, 0.0064, 0.0058, 0.0053, 0.0047, 0.0041, 0.0034,
     . 0.0028, 0.0023, 0.0018, 0.0012, 0.0005,-0.0002,-0.0008,-0.0014,
     .-0.0020,-0.0026,-0.0031,-0.0038,-0.0043,-0.0050,-0.0056,-0.0062,
     .-0.0068,-0.0075,-0.0081,-0.0087,-0.0093,-0.0098,-0.0104,-0.0110,
     .-0.0115,-0.0121,-0.0128,-0.0134,-0.0140,-0.0146,-0.0151,-0.0157,
     .-0.0162,-0.0168,-0.0173,-0.0179,-0.0185,-0.0192,-0.0198,-0.0205,
     .-0.0211,-0.0216,-0.0223,-0.0229,-0.0235,-0.0242,-0.0248,-0.0253,
     .-0.0260,-0.0266,-0.0272,-0.0278,-0.0284,-0.0290,-0.0295,-0.0301,
     . 0.0080, 0.0075, 0.0070, 0.0065, 0.0059, 0.0053, 0.0047, 0.0040,
     . 0.0035, 0.0030, 0.0024, 0.0018, 0.0012, 0.0004,-0.0002,-0.0008,
     .-0.0013,-0.0019,-0.0025,-0.0031,-0.0037,-0.0044,-0.0050,-0.0056,
     .-0.0062,-0.0069,-0.0075,-0.0081,-0.0087,-0.0092,-0.0098,-0.0104,
     .-0.0109,-0.0115,-0.0122,-0.0128,-0.0133,-0.0139,-0.0144,-0.0151,
     .-0.0156,-0.0161,-0.0167,-0.0173,-0.0179,-0.0187,-0.0192,-0.0198,
     .-0.0205,-0.0210,-0.0216,-0.0223,-0.0229,-0.0235,-0.0242,-0.0248,
     .-0.0254,-0.0260,-0.0266,-0.0272,-0.0278,-0.0283,-0.0289,-0.0295,
     . 0.0086, 0.0081, 0.0076, 0.0071, 0.0065, 0.0059, 0.0053, 0.0046,
     . 0.0041, 0.0035, 0.0030, 0.0024, 0.0017, 0.0011, 0.0004,-0.0002,
     .-0.0008,-0.0013,-0.0019,-0.0025,-0.0031,-0.0037,-0.0043,-0.0050,
     .-0.0056,-0.0063,-0.0069,-0.0075,-0.0080,-0.0085,-0.0091,-0.0097,
     .-0.0103,-0.0109,-0.0115,-0.0121,-0.0127,-0.0133,-0.0138,-0.0145,
     .-0.0149,-0.0155,-0.0161,-0.0167,-0.0173,-0.0180,-0.0186,-0.0192,
     .-0.0198,-0.0203,-0.0209,-0.0216,-0.0223,-0.0228,-0.0235,-0.0240,
     .-0.0246,-0.0252,-0.0258,-0.0264,-0.0271,-0.0276,-0.0281,-0.0286,
     . 0.0093, 0.0087, 0.0082, 0.0077, 0.0071, 0.0065, 0.0059, 0.0052,
     . 0.0047, 0.0042, 0.0036, 0.0030, 0.0024, 0.0017, 0.0011, 0.0005,
     .-0.0001,-0.0007,-0.0013,-0.0018,-0.0024,-0.0030,-0.0036,-0.0042,
     .-0.0049,-0.0055,-0.0061,-0.0067,-0.0072,-0.0078,-0.0084,-0.0089,
     .-0.0095,-0.0102,-0.0108,-0.0114,-0.0120,-0.0125,-0.0131,-0.0137,
     .-0.0142,-0.0148,-0.0153,-0.0159,-0.0165,-0.0173,-0.0178,-0.0184,
     .-0.0190,-0.0196,-0.0201,-0.0208,-0.0214,-0.0221,-0.0227,-0.0232,
     .-0.0238,-0.0244,-0.0250,-0.0256,-0.0262,-0.0267,-0.0272,-0.0277,
     . 0.0099, 0.0094, 0.0088, 0.0082, 0.0077, 0.0071, 0.0066, 0.0059,
     . 0.0053, 0.0048, 0.0043, 0.0037, 0.0031, 0.0024, 0.0018, 0.0013,
     . 0.0006, 0.0000,-0.0006,-0.0011,-0.0017,-0.0022,-0.0028,-0.0034,
     .-0.0041,-0.0047,-0.0053,-0.0059,-0.0065,-0.0070,-0.0076,-0.0082,
     .-0.0088,-0.0094,-0.0101,-0.0107,-0.0113,-0.0118,-0.0123,-0.0130,
     .-0.0135,-0.0140,-0.0145,-0.0151,-0.0157,-0.0165,-0.0170,-0.0176,
     .-0.0182,-0.0188,-0.0194,-0.0200,-0.0207,-0.0212,-0.0219,-0.0224,
     .-0.0229,-0.0236,-0.0242,-0.0247,-0.0254,-0.0259,-0.0264,-0.0269,
     . 0.0106, 0.0100, 0.0095, 0.0089, 0.0083, 0.0078, 0.0072, 0.0066,
     . 0.0060, 0.0054, 0.0049, 0.0043, 0.0037, 0.0031, 0.0025, 0.0019,
     . 0.0013, 0.0007, 0.0000,-0.0005,-0.0011,-0.0016,-0.0022,-0.0027,
     .-0.0034,-0.0041,-0.0047,-0.0052,-0.0058,-0.0063,-0.0069,-0.0075,
     .-0.0081,-0.0087,-0.0094,-0.0100,-0.0106,-0.0112,-0.0117,-0.0124,
     .-0.0128,-0.0133,-0.0139,-0.0145,-0.0151,-0.0159,-0.0164,-0.0169,
     .-0.0176,-0.0182,-0.0187,-0.0194,-0.0201,-0.0207,-0.0213,-0.0218,
     .-0.0224,-0.0230,-0.0236,-0.0242,-0.0248,-0.0253,-0.0258,-0.0264,
     . 0.0113, 0.0108, 0.0102, 0.0096, 0.0090, 0.0085, 0.0079, 0.0073,
     . 0.0067, 0.0061, 0.0056, 0.0050, 0.0043, 0.0037, 0.0031, 0.0026,
     . 0.0020, 0.0014, 0.0007, 0.0001,-0.0004,-0.0009,-0.0015,-0.0021,
     .-0.0027,-0.0034,-0.0040,-0.0046,-0.0052,-0.0057,-0.0063,-0.0069,
     .-0.0074,-0.0081,-0.0088,-0.0093,-0.0099,-0.0105,-0.0111,-0.0118,
     .-0.0122,-0.0127,-0.0133,-0.0139,-0.0145,-0.0153,-0.0158,-0.0164,
     .-0.0170,-0.0176,-0.0181,-0.0189,-0.0195,-0.0201,-0.0207,-0.0213,
     .-0.0218,-0.0225,-0.0231,-0.0237,-0.0243,-0.0247,-0.0252,-0.0257,
     . 0.0120, 0.0114, 0.0109, 0.0102, 0.0097, 0.0091, 0.0086, 0.0080,
     . 0.0073, 0.0068, 0.0063, 0.0057, 0.0050, 0.0044, 0.0038, 0.0032,
     . 0.0026, 0.0020, 0.0013, 0.0007, 0.0002,-0.0003,-0.0009,-0.0015,
     .-0.0022,-0.0028,-0.0034,-0.0040,-0.0046,-0.0051,-0.0057,-0.0063,
     .-0.0069,-0.0075,-0.0082,-0.0087,-0.0094,-0.0100,-0.0105,-0.0113,
     .-0.0117,-0.0122,-0.0128,-0.0133,-0.0140,-0.0148,-0.0152,-0.0158,
     .-0.0164,-0.0170,-0.0176,-0.0183,-0.0189,-0.0195,-0.0201,-0.0207,
     .-0.0213,-0.0219,-0.0225,-0.0231,-0.0238,-0.0241,-0.0247,-0.0252,
     . 0.0127, 0.0121, 0.0115, 0.0109, 0.0103, 0.0098, 0.0092, 0.0086,
     . 0.0080, 0.0074, 0.0068, 0.0062, 0.0056, 0.0050, 0.0044, 0.0038,
     . 0.0032, 0.0027, 0.0019, 0.0014, 0.0007, 0.0002,-0.0003,-0.0009,
     .-0.0016,-0.0023,-0.0029,-0.0035,-0.0041,-0.0046,-0.0052,-0.0058,
     .-0.0063,-0.0069,-0.0076,-0.0082,-0.0089,-0.0094,-0.0100,-0.0107,
     .-0.0112,-0.0117,-0.0123,-0.0128,-0.0135,-0.0142,-0.0147,-0.0153,
     .-0.0158,-0.0164,-0.0170,-0.0176,-0.0183,-0.0189,-0.0195,-0.0200,
     .-0.0206,-0.0212,-0.0219,-0.0225,-0.0232,-0.0235,-0.0240,-0.0246,
     . 0.0133, 0.0127, 0.0121, 0.0115, 0.0109, 0.0103, 0.0098, 0.0092,
     . 0.0086, 0.0080, 0.0074, 0.0068, 0.0061, 0.0055, 0.0049, 0.0044,
     . 0.0038, 0.0032, 0.0025, 0.0019, 0.0013, 0.0007, 0.0002,-0.0004,
     .-0.0010,-0.0017,-0.0023,-0.0029,-0.0035,-0.0040,-0.0046,-0.0052,
     .-0.0058,-0.0064,-0.0070,-0.0076,-0.0083,-0.0088,-0.0094,-0.0101,
     .-0.0105,-0.0110,-0.0117,-0.0122,-0.0129,-0.0136,-0.0140,-0.0146,
     .-0.0153,-0.0158,-0.0164,-0.0170,-0.0177,-0.0183,-0.0188,-0.0194,
     .-0.0200,-0.0207,-0.0213,-0.0218,-0.0225,-0.0229,-0.0234,-0.0239,
     . 0.0138, 0.0132, 0.0126, 0.0120, 0.0114, 0.0109, 0.0104, 0.0098,
     . 0.0092, 0.0086, 0.0080, 0.0074, 0.0068, 0.0061, 0.0055, 0.0050,
     . 0.0044, 0.0038, 0.0032, 0.0025, 0.0020, 0.0014, 0.0008, 0.0002,
     .-0.0004,-0.0011,-0.0016,-0.0023,-0.0029,-0.0034,-0.0040,-0.0046,
     .-0.0051,-0.0057,-0.0064,-0.0070,-0.0077,-0.0082,-0.0087,-0.0093,
     .-0.0098,-0.0104,-0.0110,-0.0116,-0.0123,-0.0130,-0.0135,-0.0140,
     .-0.0147,-0.0152,-0.0158,-0.0165,-0.0171,-0.0177,-0.0183,-0.0188,
     .-0.0194,-0.0201,-0.0207,-0.0213,-0.0220,-0.0224,-0.0229,-0.0234,
     . 0.0144, 0.0138, 0.0132, 0.0126, 0.0120, 0.0115, 0.0110, 0.0104,
     . 0.0098, 0.0092, 0.0087, 0.0081, 0.0074, 0.0068, 0.0062, 0.0056,
     . 0.0051, 0.0045, 0.0038, 0.0032, 0.0025, 0.0019, 0.0013, 0.0008,
     . 0.0001,-0.0005,-0.0011,-0.0016,-0.0022,-0.0028,-0.0034,-0.0040,
     .-0.0046,-0.0052,-0.0058,-0.0064,-0.0070,-0.0076,-0.0080,-0.0086,
     .-0.0091,-0.0096,-0.0103,-0.0109,-0.0116,-0.0123,-0.0128,-0.0134,
     .-0.0141,-0.0146,-0.0152,-0.0159,-0.0166,-0.0171,-0.0177,-0.0182,
     .-0.0188,-0.0195,-0.0201,-0.0207,-0.0213,-0.0218,-0.0223,-0.0228,
     . 0.0150, 0.0144, 0.0138, 0.0131, 0.0126, 0.0120, 0.0115, 0.0110,
     . 0.0103, 0.0098, 0.0093, 0.0087, 0.0081, 0.0074, 0.0068, 0.0062,
     . 0.0057, 0.0051, 0.0044, 0.0038, 0.0031, 0.0025, 0.0019, 0.0014,
     . 0.0007, 0.0001,-0.0004,-0.0010,-0.0016,-0.0021,-0.0027,-0.0033,
     .-0.0039,-0.0045,-0.0051,-0.0057,-0.0064,-0.0069,-0.0074,-0.0079,
     .-0.0084,-0.0090,-0.0097,-0.0103,-0.0110,-0.0117,-0.0122,-0.0128,
     .-0.0135,-0.0140,-0.0146,-0.0154,-0.0160,-0.0165,-0.0171,-0.0176,
     .-0.0182,-0.0189,-0.0195,-0.0201,-0.0207,-0.0212,-0.0217,-0.0222,
     . 0.0155, 0.0149, 0.0143, 0.0137, 0.0132, 0.0126, 0.0121, 0.0116,
     . 0.0109, 0.0104, 0.0099, 0.0093, 0.0087, 0.0080, 0.0074, 0.0068,
     . 0.0063, 0.0057, 0.0051, 0.0044, 0.0037, 0.0032, 0.0026, 0.0020,
     . 0.0013, 0.0007, 0.0002,-0.0004,-0.0010,-0.0015,-0.0022,-0.0027,
     .-0.0033,-0.0039,-0.0045,-0.0051,-0.0058,-0.0063,-0.0067,-0.0073,
     .-0.0078,-0.0084,-0.0090,-0.0096,-0.0103,-0.0110,-0.0116,-0.0122,
     .-0.0128,-0.0134,-0.0141,-0.0147,-0.0154,-0.0159,-0.0165,-0.0170,
     .-0.0176,-0.0183,-0.0188,-0.0194,-0.0200,-0.0205,-0.0210,-0.0216,
     . 0.0161, 0.0155, 0.0150, 0.0144, 0.0138, 0.0132, 0.0127, 0.0121,
     . 0.0116, 0.0110, 0.0104, 0.0099, 0.0093, 0.0086, 0.0080, 0.0074,
     . 0.0069, 0.0063, 0.0057, 0.0050, 0.0044, 0.0038, 0.0032, 0.0026,
     . 0.0020, 0.0013, 0.0008, 0.0002,-0.0004,-0.0009,-0.0015,-0.0021,
     .-0.0027,-0.0032,-0.0039,-0.0045,-0.0051,-0.0057,-0.0062,-0.0067,
     .-0.0072,-0.0078,-0.0084,-0.0090,-0.0097,-0.0104,-0.0109,-0.0115,
     .-0.0122,-0.0127,-0.0134,-0.0141,-0.0147,-0.0153,-0.0158,-0.0164,
     .-0.0170,-0.0177,-0.0182,-0.0188,-0.0194,-0.0199,-0.0204,-0.0209,
     . 0.0166, 0.0161, 0.0156, 0.0149, 0.0144, 0.0138, 0.0133, 0.0128,
     . 0.0121, 0.0115, 0.0110, 0.0104, 0.0099, 0.0092, 0.0086, 0.0080,
     . 0.0074, 0.0069, 0.0064, 0.0057, 0.0051, 0.0045, 0.0039, 0.0033,
     . 0.0027, 0.0020, 0.0015, 0.0009, 0.0003,-0.0003,-0.0009,-0.0015,
     .-0.0020,-0.0026,-0.0032,-0.0039,-0.0045,-0.0050,-0.0056,-0.0062,
     .-0.0067,-0.0073,-0.0079,-0.0084,-0.0091,-0.0098,-0.0102,-0.0109,
     .-0.0115,-0.0121,-0.0128,-0.0135,-0.0141,-0.0147,-0.0153,-0.0158,
     .-0.0163,-0.0170,-0.0176,-0.0182,-0.0188,-0.0193,-0.0198,-0.0203,
     . 0.0173, 0.0167, 0.0161, 0.0155, 0.0151, 0.0144, 0.0139, 0.0134,
     . 0.0127, 0.0121, 0.0116, 0.0110, 0.0105, 0.0098, 0.0091, 0.0086,
     . 0.0081, 0.0075, 0.0069, 0.0063, 0.0057, 0.0051, 0.0045, 0.0039,
     . 0.0033, 0.0026, 0.0020, 0.0014, 0.0009, 0.0003,-0.0004,-0.0009,
     .-0.0014,-0.0020,-0.0026,-0.0033,-0.0039,-0.0045,-0.0050,-0.0057,
     .-0.0061,-0.0067,-0.0073,-0.0078,-0.0085,-0.0092,-0.0097,-0.0103,
     .-0.0110,-0.0115,-0.0122,-0.0129,-0.0136,-0.0142,-0.0147,-0.0152,
     .-0.0158,-0.0164,-0.0170,-0.0176,-0.0181,-0.0186,-0.0192,-0.0197,
     . 0.0179, 0.0173, 0.0167, 0.0161, 0.0157, 0.0151, 0.0145, 0.0140,
     . 0.0133, 0.0127, 0.0122, 0.0116, 0.0110, 0.0104, 0.0097, 0.0092,
     . 0.0087, 0.0081, 0.0075, 0.0069, 0.0063, 0.0057, 0.0051, 0.0045,
     . 0.0039, 0.0033, 0.0026, 0.0020, 0.0014, 0.0009, 0.0002,-0.0003,
     .-0.0009,-0.0014,-0.0020,-0.0026,-0.0033,-0.0039,-0.0045,-0.0051,
     .-0.0055,-0.0061,-0.0067,-0.0073,-0.0079,-0.0086,-0.0091,-0.0097,
     .-0.0104,-0.0109,-0.0116,-0.0123,-0.0130,-0.0136,-0.0141,-0.0146,
     .-0.0152,-0.0159,-0.0164,-0.0170,-0.0175,-0.0180,-0.0186,-0.0191,
     . 0.0185, 0.0179, 0.0174, 0.0168, 0.0163, 0.0157, 0.0152, 0.0145,
     . 0.0139, 0.0133, 0.0128, 0.0122, 0.0116, 0.0109, 0.0103, 0.0098,
     . 0.0093, 0.0087, 0.0081, 0.0075, 0.0069, 0.0064, 0.0058, 0.0052,
     . 0.0045, 0.0039, 0.0033, 0.0026, 0.0020, 0.0015, 0.0009, 0.0003,
     .-0.0002,-0.0008,-0.0014,-0.0020,-0.0027,-0.0033,-0.0039,-0.0045,
     .-0.0050,-0.0056,-0.0061,-0.0067,-0.0073,-0.0079,-0.0085,-0.0091,
     .-0.0098,-0.0103,-0.0110,-0.0117,-0.0124,-0.0130,-0.0135,-0.0140,
     .-0.0147,-0.0153,-0.0158,-0.0164,-0.0170,-0.0174,-0.0180,-0.0185,
     . 0.0188, 0.0182, 0.0176, 0.0170, 0.0164, 0.0158, 0.0153, 0.0146,
     . 0.0140, 0.0135, 0.0130, 0.0124, 0.0118, 0.0111, 0.0105, 0.0100,
     . 0.0093, 0.0088, 0.0080, 0.0077, 0.0071, 0.0066, 0.0060, 0.0054,
     . 0.0046, 0.0041, 0.0035, 0.0029, 0.0023, 0.0017, 0.0010, 0.0004,
     .-0.0001,-0.0008,-0.0013,-0.0019,-0.0024,-0.0030,-0.0034,-0.0042,
     .-0.0046,-0.0051,-0.0055,-0.0061,-0.0067,-0.0076,-0.0080,-0.0086,
     .-0.0092,-0.0098,-0.0104,-0.0110,-0.0116,-0.0122,-0.0128,-0.0135,
     .-0.0142,-0.0148,-0.0154,-0.0158,-0.0165,-0.0170,-0.0176,-0.0181,
     . 0.0195, 0.0189, 0.0183, 0.0177, 0.0171, 0.0165, 0.0159, 0.0152,
     . 0.0147, 0.0142, 0.0136, 0.0131, 0.0124, 0.0117, 0.0111, 0.0106,
     . 0.0100, 0.0094, 0.0086, 0.0083, 0.0078, 0.0072, 0.0066, 0.0060,
     . 0.0052, 0.0047, 0.0040, 0.0034, 0.0029, 0.0023, 0.0016, 0.0010,
     . 0.0005,-0.0001,-0.0007,-0.0013,-0.0018,-0.0023,-0.0028,-0.0036,
     .-0.0040,-0.0045,-0.0050,-0.0056,-0.0062,-0.0070,-0.0075,-0.0081,
     .-0.0086,-0.0092,-0.0099,-0.0104,-0.0110,-0.0116,-0.0122,-0.0129,
     .-0.0135,-0.0142,-0.0147,-0.0153,-0.0159,-0.0164,-0.0170,-0.0175,
     . 0.0202, 0.0196, 0.0189, 0.0183, 0.0178, 0.0171, 0.0166, 0.0159,
     . 0.0153, 0.0148, 0.0142, 0.0137, 0.0131, 0.0124, 0.0118, 0.0112,
     . 0.0106, 0.0101, 0.0093, 0.0089, 0.0084, 0.0079, 0.0073, 0.0066,
     . 0.0058, 0.0053, 0.0046, 0.0040, 0.0035, 0.0029, 0.0022, 0.0017,
     . 0.0011, 0.0005,-0.0001,-0.0006,-0.0012,-0.0017,-0.0023,-0.0030,
     .-0.0034,-0.0039,-0.0045,-0.0051,-0.0057,-0.0064,-0.0070,-0.0075,
     .-0.0081,-0.0087,-0.0093,-0.0099,-0.0104,-0.0110,-0.0116,-0.0123,
     .-0.0129,-0.0136,-0.0141,-0.0147,-0.0153,-0.0158,-0.0164,-0.0169,
     . 0.0208, 0.0202, 0.0196, 0.0190, 0.0184, 0.0178, 0.0173, 0.0166,
     . 0.0160, 0.0155, 0.0149, 0.0144, 0.0138, 0.0131, 0.0125, 0.0119,
     . 0.0113, 0.0107, 0.0099, 0.0096, 0.0091, 0.0085, 0.0079, 0.0072,
     . 0.0064, 0.0059, 0.0052, 0.0046, 0.0041, 0.0035, 0.0029, 0.0023,
     . 0.0018, 0.0012, 0.0006, 0.0001,-0.0005,-0.0010,-0.0016,-0.0024,
     .-0.0028,-0.0033,-0.0039,-0.0045,-0.0052,-0.0059,-0.0064,-0.0069,
     .-0.0075,-0.0081,-0.0087,-0.0093,-0.0099,-0.0105,-0.0111,-0.0118,
     .-0.0124,-0.0130,-0.0135,-0.0141,-0.0147,-0.0152,-0.0158,-0.0164,
     . 0.0216, 0.0209, 0.0203, 0.0196, 0.0191, 0.0184, 0.0179, 0.0172,
     . 0.0166, 0.0161, 0.0155, 0.0149, 0.0143, 0.0136, 0.0130, 0.0125,
     . 0.0119, 0.0113, 0.0105, 0.0102, 0.0096, 0.0091, 0.0085, 0.0078,
     . 0.0069, 0.0064, 0.0057, 0.0052, 0.0046, 0.0041, 0.0035, 0.0030,
     . 0.0024, 0.0018, 0.0012, 0.0006, 0.0001,-0.0005,-0.0011,-0.0018,
     .-0.0023,-0.0029,-0.0034,-0.0040,-0.0046,-0.0054,-0.0059,-0.0065,
     .-0.0069,-0.0075,-0.0081,-0.0087,-0.0093,-0.0099,-0.0105,-0.0111,
     .-0.0118,-0.0123,-0.0129,-0.0135,-0.0141,-0.0146,-0.0151,-0.0157,
     . 0.0222, 0.0216, 0.0210, 0.0203, 0.0197, 0.0190, 0.0185, 0.0177,
     . 0.0172, 0.0167, 0.0160, 0.0154, 0.0148, 0.0141, 0.0136, 0.0131,
     . 0.0125, 0.0119, 0.0111, 0.0107, 0.0102, 0.0096, 0.0089, 0.0082,
     . 0.0074, 0.0069, 0.0063, 0.0057, 0.0052, 0.0047, 0.0041, 0.0036,
     . 0.0030, 0.0025, 0.0019, 0.0012, 0.0006, 0.0001,-0.0005,-0.0013,
     .-0.0017,-0.0023,-0.0028,-0.0034,-0.0040,-0.0048,-0.0052,-0.0059,
     .-0.0063,-0.0069,-0.0075,-0.0081,-0.0087,-0.0093,-0.0099,-0.0105,
     .-0.0111,-0.0117,-0.0122,-0.0128,-0.0135,-0.0139,-0.0145,-0.0150,
     . 0.0229, 0.0222, 0.0216, 0.0209, 0.0203, 0.0196, 0.0190, 0.0183,
     . 0.0178, 0.0173, 0.0166, 0.0160, 0.0154, 0.0147, 0.0142, 0.0136,
     . 0.0131, 0.0125, 0.0117, 0.0114, 0.0108, 0.0102, 0.0095, 0.0088,
     . 0.0080, 0.0075, 0.0069, 0.0064, 0.0058, 0.0054, 0.0048, 0.0042,
     . 0.0038, 0.0031, 0.0025, 0.0019, 0.0012, 0.0006, 0.0001,-0.0007,
     .-0.0012,-0.0017,-0.0022,-0.0028,-0.0034,-0.0042,-0.0046,-0.0052,
     .-0.0057,-0.0063,-0.0069,-0.0075,-0.0081,-0.0088,-0.0093,-0.0099,
     .-0.0105,-0.0111,-0.0116,-0.0122,-0.0129,-0.0133,-0.0139,-0.0144,
     . 0.0235, 0.0229, 0.0222, 0.0215, 0.0209, 0.0203, 0.0196, 0.0190,
     . 0.0184, 0.0179, 0.0173, 0.0166, 0.0160, 0.0153, 0.0148, 0.0142,
     . 0.0137, 0.0131, 0.0123, 0.0119, 0.0114, 0.0108, 0.0102, 0.0095,
     . 0.0086, 0.0082, 0.0076, 0.0071, 0.0065, 0.0060, 0.0054, 0.0049,
     . 0.0043, 0.0037, 0.0031, 0.0024, 0.0018, 0.0012, 0.0006,-0.0001,
     .-0.0006,-0.0011,-0.0016,-0.0022,-0.0028,-0.0035,-0.0040,-0.0045,
     .-0.0051,-0.0057,-0.0063,-0.0069,-0.0075,-0.0081,-0.0087,-0.0093,
     .-0.0099,-0.0105,-0.0111,-0.0116,-0.0123,-0.0127,-0.0133,-0.0138,
     . 0.0242, 0.0235, 0.0228, 0.0221, 0.0215, 0.0208, 0.0202, 0.0196,
     . 0.0190, 0.0186, 0.0180, 0.0174, 0.0166, 0.0160, 0.0154, 0.0149,
     . 0.0143, 0.0137, 0.0129, 0.0125, 0.0120, 0.0114, 0.0108, 0.0101,
     . 0.0093, 0.0089, 0.0083, 0.0077, 0.0072, 0.0066, 0.0060, 0.0055,
     . 0.0049, 0.0043, 0.0037, 0.0030, 0.0024, 0.0018, 0.0012, 0.0005,
     . 0.0001,-0.0005,-0.0009,-0.0015,-0.0021,-0.0028,-0.0034,-0.0039,
     .-0.0045,-0.0052,-0.0058,-0.0063,-0.0070,-0.0075,-0.0081,-0.0087,
     .-0.0093,-0.0099,-0.0105,-0.0110,-0.0117,-0.0122,-0.0127,-0.0131,
     . 0.0248, 0.0241, 0.0234, 0.0227, 0.0221, 0.0215, 0.0208, 0.0202,
     . 0.0197, 0.0192, 0.0186, 0.0180, 0.0173, 0.0166, 0.0160, 0.0155,
     . 0.0149, 0.0142, 0.0135, 0.0131, 0.0126, 0.0120, 0.0114, 0.0108,
     . 0.0100, 0.0095, 0.0089, 0.0083, 0.0078, 0.0072, 0.0066, 0.0060,
     . 0.0054, 0.0048, 0.0042, 0.0036, 0.0030, 0.0024, 0.0018, 0.0011,
     . 0.0007, 0.0002,-0.0003,-0.0009,-0.0015,-0.0022,-0.0028,-0.0034,
     .-0.0039,-0.0046,-0.0052,-0.0057,-0.0063,-0.0069,-0.0075,-0.0081,
     .-0.0087,-0.0093,-0.0099,-0.0104,-0.0111,-0.0114,-0.0119,-0.0125,
     . 0.0255, 0.0248, 0.0241, 0.0234, 0.0227, 0.0220, 0.0214, 0.0207,
     . 0.0203, 0.0198, 0.0193, 0.0186, 0.0179, 0.0172, 0.0166, 0.0161,
     . 0.0155, 0.0148, 0.0141, 0.0137, 0.0132, 0.0127, 0.0121, 0.0114,
     . 0.0107, 0.0102, 0.0096, 0.0090, 0.0083, 0.0077, 0.0071, 0.0065,
     . 0.0060, 0.0054, 0.0048, 0.0043, 0.0036, 0.0031, 0.0025, 0.0018,
     . 0.0014, 0.0009, 0.0004,-0.0002,-0.0009,-0.0016,-0.0021,-0.0028,
     .-0.0033,-0.0040,-0.0046,-0.0051,-0.0057,-0.0063,-0.0069,-0.0075,
     .-0.0081,-0.0087,-0.0093,-0.0099,-0.0105,-0.0109,-0.0114,-0.0118,
     . 0.0260, 0.0254, 0.0247, 0.0240, 0.0233, 0.0226, 0.0220, 0.0213,
     . 0.0208, 0.0204, 0.0199, 0.0193, 0.0186, 0.0178, 0.0173, 0.0167,
     . 0.0161, 0.0154, 0.0147, 0.0143, 0.0139, 0.0133, 0.0127, 0.0121,
     . 0.0113, 0.0108, 0.0102, 0.0096, 0.0089, 0.0083, 0.0077, 0.0071,
     . 0.0066, 0.0060, 0.0054, 0.0049, 0.0043, 0.0037, 0.0032, 0.0024,
     . 0.0020, 0.0015, 0.0009, 0.0003,-0.0003,-0.0011,-0.0015,-0.0022,
     .-0.0028,-0.0034,-0.0040,-0.0045,-0.0050,-0.0057,-0.0063,-0.0069,
     .-0.0075,-0.0081,-0.0088,-0.0093,-0.0099,-0.0103,-0.0108,-0.0113,
     . 0.0266, 0.0260, 0.0253, 0.0246, 0.0240, 0.0233, 0.0226, 0.0220,
     . 0.0215, 0.0210, 0.0205, 0.0199, 0.0192, 0.0185, 0.0179, 0.0173,
     . 0.0167, 0.0161, 0.0154, 0.0150, 0.0145, 0.0140, 0.0134, 0.0127,
     . 0.0119, 0.0115, 0.0108, 0.0102, 0.0095, 0.0089, 0.0083, 0.0077,
     . 0.0071, 0.0066, 0.0061, 0.0055, 0.0049, 0.0043, 0.0037, 0.0030,
     . 0.0026, 0.0021, 0.0015, 0.0009, 0.0002,-0.0006,-0.0011,-0.0017,
     .-0.0022,-0.0028,-0.0034,-0.0039,-0.0045,-0.0051,-0.0057,-0.0063,
     .-0.0070,-0.0076,-0.0082,-0.0088,-0.0094,-0.0098,-0.0103,-0.0107,
     . 0.0272, 0.0265, 0.0259, 0.0252, 0.0246, 0.0239, 0.0233, 0.0226,
     . 0.0221, 0.0217, 0.0211, 0.0205, 0.0198, 0.0191, 0.0185, 0.0179,
     . 0.0173, 0.0168, 0.0160, 0.0157, 0.0152, 0.0146, 0.0140, 0.0133,
     . 0.0125, 0.0120, 0.0113, 0.0106, 0.0100, 0.0094, 0.0088, 0.0083,
     . 0.0077, 0.0072, 0.0066, 0.0061, 0.0055, 0.0048, 0.0042, 0.0036,
     . 0.0031, 0.0026, 0.0020, 0.0014, 0.0008, 0.0000,-0.0005,-0.0010,
     .-0.0016,-0.0022,-0.0028,-0.0033,-0.0039,-0.0045,-0.0051,-0.0058,
     .-0.0064,-0.0070,-0.0076,-0.0081,-0.0088,-0.0092,-0.0097,-0.0102,
     . 0.0278, 0.0272, 0.0265, 0.0259, 0.0253, 0.0246, 0.0240, 0.0233,
     . 0.0227, 0.0223, 0.0218, 0.0211, 0.0204, 0.0197, 0.0191, 0.0186,
     . 0.0180, 0.0175, 0.0168, 0.0164, 0.0159, 0.0153, 0.0146, 0.0139,
     . 0.0131, 0.0125, 0.0118, 0.0112, 0.0106, 0.0101, 0.0095, 0.0090,
     . 0.0084, 0.0079, 0.0073, 0.0067, 0.0061, 0.0055, 0.0049, 0.0041,
     . 0.0037, 0.0032, 0.0027, 0.0021, 0.0015, 0.0007, 0.0002,-0.0003,
     .-0.0009,-0.0016,-0.0021,-0.0026,-0.0032,-0.0038,-0.0044,-0.0050,
     .-0.0057,-0.0063,-0.0069,-0.0075,-0.0081,-0.0084,-0.0090,-0.0095,
     . 0.0283, 0.0276, 0.0270, 0.0264, 0.0257, 0.0251, 0.0245, 0.0238,
     . 0.0233, 0.0228, 0.0222, 0.0216, 0.0209, 0.0202, 0.0196, 0.0191,
     . 0.0186, 0.0180, 0.0174, 0.0170, 0.0164, 0.0158, 0.0152, 0.0144,
     . 0.0136, 0.0130, 0.0124, 0.0118, 0.0112, 0.0107, 0.0102, 0.0096,
     . 0.0091, 0.0084, 0.0078, 0.0072, 0.0066, 0.0060, 0.0054, 0.0047,
     . 0.0043, 0.0038, 0.0033, 0.0028, 0.0022, 0.0015, 0.0010, 0.0004,
     .-0.0002,-0.0009,-0.0014,-0.0019,-0.0025,-0.0031,-0.0037,-0.0043,
     .-0.0050,-0.0056,-0.0062,-0.0067,-0.0073,-0.0078,-0.0083,-0.0088,
     . 0.0287, 0.0281, 0.0274, 0.0268, 0.0262, 0.0255, 0.0250, 0.0243,
     . 0.0237, 0.0233, 0.0227, 0.0221, 0.0215, 0.0208, 0.0203, 0.0198,
     . 0.0193, 0.0187, 0.0180, 0.0176, 0.0170, 0.0164, 0.0157, 0.0150,
     . 0.0141, 0.0136, 0.0130, 0.0125, 0.0119, 0.0114, 0.0109, 0.0103,
     . 0.0098, 0.0091, 0.0084, 0.0078, 0.0072, 0.0066, 0.0060, 0.0054,
     . 0.0049, 0.0044, 0.0040, 0.0034, 0.0029, 0.0022, 0.0017, 0.0011,
     . 0.0005,-0.0002,-0.0008,-0.0013,-0.0018,-0.0024,-0.0030,-0.0037,
     .-0.0044,-0.0050,-0.0056,-0.0061,-0.0067,-0.0072,-0.0077,-0.0082,
     . 0.0293, 0.0286, 0.0280, 0.0274, 0.0268, 0.0262, 0.0256, 0.0249,
     . 0.0244, 0.0239, 0.0233, 0.0227, 0.0221, 0.0215, 0.0210, 0.0205,
     . 0.0200, 0.0194, 0.0186, 0.0182, 0.0177, 0.0170, 0.0163, 0.0156,
     . 0.0148, 0.0144, 0.0138, 0.0133, 0.0127, 0.0122, 0.0117, 0.0111,
     . 0.0105, 0.0098, 0.0091, 0.0084, 0.0078, 0.0072, 0.0067, 0.0060,
     . 0.0056, 0.0051, 0.0045, 0.0040, 0.0035, 0.0028, 0.0023, 0.0017,
     . 0.0011, 0.0005,-0.0001,-0.0006,-0.0012,-0.0018,-0.0024,-0.0031,
     .-0.0037,-0.0044,-0.0050,-0.0056,-0.0061,-0.0066,-0.0072,-0.0077,
     . 0.0300, 0.0294, 0.0288, 0.0282, 0.0276, 0.0269, 0.0263, 0.0257,
     . 0.0251, 0.0246, 0.0241, 0.0235, 0.0229, 0.0223, 0.0218, 0.0213,
     . 0.0207, 0.0201, 0.0193, 0.0188, 0.0182, 0.0176, 0.0170, 0.0164,
     . 0.0156, 0.0152, 0.0146, 0.0141, 0.0136, 0.0130, 0.0124, 0.0118,
     . 0.0111, 0.0105, 0.0097, 0.0091, 0.0085, 0.0079, 0.0074, 0.0067,
     . 0.0062, 0.0057, 0.0051, 0.0046, 0.0040, 0.0034, 0.0029, 0.0023,
     . 0.0017, 0.0011, 0.0005, 0.0000,-0.0006,-0.0012,-0.0018,-0.0025,
     .-0.0033,-0.0038,-0.0045,-0.0050,-0.0056,-0.0061,-0.0067,-0.0072,
     . 0.0307, 0.0301, 0.0295, 0.0289, 0.0283, 0.0277, 0.0271, 0.0264,
     . 0.0258, 0.0254, 0.0248, 0.0243, 0.0237, 0.0231, 0.0225, 0.0221,
     . 0.0214, 0.0207, 0.0198, 0.0194, 0.0188, 0.0182, 0.0177, 0.0171,
     . 0.0164, 0.0160, 0.0153, 0.0148, 0.0142, 0.0136, 0.0131, 0.0124,
     . 0.0117, 0.0111, 0.0103, 0.0097, 0.0091, 0.0086, 0.0080, 0.0073,
     . 0.0068, 0.0063, 0.0057, 0.0051, 0.0046, 0.0039, 0.0034, 0.0028,
     . 0.0023, 0.0017, 0.0011, 0.0006, 0.0000,-0.0005,-0.0012,-0.0020,
     .-0.0027,-0.0033,-0.0039,-0.0045,-0.0051,-0.0056,-0.0062,-0.0068,
     . 0.0316, 0.0310, 0.0303, 0.0297, 0.0291, 0.0285, 0.0278, 0.0271,
     . 0.0266, 0.0262, 0.0256, 0.0251, 0.0245, 0.0238, 0.0233, 0.0227,
     . 0.0220, 0.0213, 0.0204, 0.0200, 0.0195, 0.0189, 0.0184, 0.0179,
     . 0.0171, 0.0167, 0.0160, 0.0154, 0.0147, 0.0142, 0.0137, 0.0130,
     . 0.0124, 0.0117, 0.0110, 0.0104, 0.0098, 0.0093, 0.0087, 0.0080,
     . 0.0075, 0.0069, 0.0063, 0.0057, 0.0051, 0.0045, 0.0040, 0.0034,
     . 0.0029, 0.0023, 0.0017, 0.0013, 0.0007, 0.0001,-0.0006,-0.0014,
     .-0.0021,-0.0026,-0.0033,-0.0039,-0.0045,-0.0050,-0.0056,-0.0062,
     . 0.0322, 0.0316, 0.0309, 0.0302, 0.0296, 0.0289, 0.0284, 0.0277,
     . 0.0272, 0.0268, 0.0263, 0.0257, 0.0251, 0.0244, 0.0238, 0.0232,
     . 0.0225, 0.0217, 0.0209, 0.0205, 0.0200, 0.0195, 0.0190, 0.0185,
     . 0.0177, 0.0172, 0.0165, 0.0159, 0.0152, 0.0146, 0.0141, 0.0135,
     . 0.0129, 0.0123, 0.0116, 0.0111, 0.0105, 0.0099, 0.0094, 0.0086,
     . 0.0081, 0.0075, 0.0069, 0.0063, 0.0058, 0.0051, 0.0046, 0.0041,
     . 0.0036, 0.0029, 0.0023, 0.0018, 0.0012, 0.0007, 0.0000,-0.0008,
     .-0.0015,-0.0021,-0.0027,-0.0033,-0.0039,-0.0044,-0.0050,-0.0055,
     . 0.0327, 0.0321, 0.0314, 0.0307, 0.0301, 0.0294, 0.0288, 0.0282,
     . 0.0277, 0.0273, 0.0268, 0.0263, 0.0257, 0.0250, 0.0243, 0.0237,
     . 0.0229, 0.0223, 0.0215, 0.0211, 0.0206, 0.0202, 0.0197, 0.0191,
     . 0.0183, 0.0177, 0.0170, 0.0163, 0.0156, 0.0151, 0.0146, 0.0140,
     . 0.0136, 0.0129, 0.0122, 0.0116, 0.0110, 0.0105, 0.0100, 0.0092,
     . 0.0087, 0.0081, 0.0075, 0.0070, 0.0064, 0.0057, 0.0053, 0.0047,
     . 0.0041, 0.0035, 0.0028, 0.0024, 0.0018, 0.0012, 0.0005,-0.0002,
     .-0.0009,-0.0015,-0.0022,-0.0027,-0.0033,-0.0038,-0.0044,-0.0050,
     . 0.0333, 0.0327, 0.0320, 0.0313, 0.0306, 0.0300, 0.0294, 0.0289,
     . 0.0284, 0.0280, 0.0275, 0.0269, 0.0262, 0.0255, 0.0248, 0.0242,
     . 0.0235, 0.0228, 0.0221, 0.0218, 0.0214, 0.0209, 0.0203, 0.0197,
     . 0.0188, 0.0182, 0.0175, 0.0168, 0.0161, 0.0156, 0.0152, 0.0147,
     . 0.0142, 0.0135, 0.0128, 0.0122, 0.0116, 0.0111, 0.0105, 0.0098,
     . 0.0093, 0.0087, 0.0081, 0.0076, 0.0070, 0.0064, 0.0059, 0.0053,
     . 0.0047, 0.0040, 0.0034, 0.0030, 0.0024, 0.0018, 0.0010, 0.0004,
     .-0.0003,-0.0010,-0.0016,-0.0022,-0.0027,-0.0033,-0.0039,-0.0044,
     . 0.0339, 0.0332, 0.0326, 0.0319, 0.0313, 0.0306, 0.0300, 0.0295,
     . 0.0290, 0.0287, 0.0281, 0.0275, 0.0268, 0.0260, 0.0253, 0.0248,
     . 0.0241, 0.0235, 0.0228, 0.0225, 0.0220, 0.0216, 0.0209, 0.0202,
     . 0.0193, 0.0187, 0.0180, 0.0174, 0.0167, 0.0162, 0.0158, 0.0154,
     . 0.0148, 0.0142, 0.0134, 0.0128, 0.0123, 0.0117, 0.0111, 0.0105,
     . 0.0099, 0.0093, 0.0088, 0.0082, 0.0076, 0.0070, 0.0064, 0.0058,
     . 0.0053, 0.0046, 0.0040, 0.0035, 0.0029, 0.0023, 0.0016, 0.0009,
     . 0.0002,-0.0003,-0.0010,-0.0015,-0.0021,-0.0027,-0.0033,-0.0039,
     . 0.0344, 0.0338, 0.0331, 0.0324, 0.0319, 0.0313, 0.0307, 0.0302,
     . 0.0296, 0.0293, 0.0287, 0.0281, 0.0272, 0.0265, 0.0258, 0.0253,
     . 0.0247, 0.0242, 0.0235, 0.0232, 0.0227, 0.0221, 0.0214, 0.0207,
     . 0.0199, 0.0193, 0.0186, 0.0180, 0.0174, 0.0169, 0.0165, 0.0160,
     . 0.0155, 0.0148, 0.0141, 0.0134, 0.0129, 0.0123, 0.0117, 0.0110,
     . 0.0105, 0.0099, 0.0094, 0.0089, 0.0082, 0.0076, 0.0071, 0.0064,
     . 0.0059, 0.0052, 0.0046, 0.0041, 0.0035, 0.0028, 0.0022, 0.0015,
     . 0.0008, 0.0002,-0.0004,-0.0009,-0.0015,-0.0020,-0.0026,-0.0032,
     . 0.0349, 0.0343, 0.0337, 0.0330, 0.0325, 0.0320, 0.0314, 0.0308,
     . 0.0303, 0.0298, 0.0292, 0.0285, 0.0277, 0.0270, 0.0264, 0.0259,
     . 0.0253, 0.0248, 0.0241, 0.0238, 0.0232, 0.0227, 0.0219, 0.0212,
     . 0.0203, 0.0198, 0.0192, 0.0186, 0.0181, 0.0176, 0.0171, 0.0167,
     . 0.0161, 0.0154, 0.0147, 0.0141, 0.0135, 0.0129, 0.0123, 0.0117,
     . 0.0112, 0.0106, 0.0100, 0.0094, 0.0088, 0.0082, 0.0076, 0.0070,
     . 0.0064, 0.0058, 0.0051, 0.0046, 0.0040, 0.0035, 0.0028, 0.0021,
     . 0.0014, 0.0008, 0.0002,-0.0003,-0.0010,-0.0015,-0.0020,-0.0025,
     . 0.0353, 0.0348, 0.0342, 0.0336, 0.0331, 0.0326, 0.0320, 0.0314,
     . 0.0308, 0.0303, 0.0297, 0.0290, 0.0282, 0.0275, 0.0270, 0.0266,
     . 0.0260, 0.0255, 0.0248, 0.0244, 0.0238, 0.0231, 0.0224, 0.0217,
     . 0.0209, 0.0204, 0.0198, 0.0193, 0.0187, 0.0183, 0.0178, 0.0173,
     . 0.0167, 0.0161, 0.0153, 0.0147, 0.0141, 0.0135, 0.0130, 0.0123,
     . 0.0117, 0.0112, 0.0106, 0.0101, 0.0094, 0.0087, 0.0082, 0.0076,
     . 0.0070, 0.0063, 0.0057, 0.0053, 0.0046, 0.0040, 0.0034, 0.0027,
     . 0.0020, 0.0015, 0.0008, 0.0003,-0.0003,-0.0009,-0.0014,-0.0019,
     . 0.0359, 0.0353, 0.0348, 0.0343, 0.0338, 0.0332, 0.0326, 0.0320,
     . 0.0313, 0.0309, 0.0302, 0.0295, 0.0288, 0.0281, 0.0276, 0.0273,
     . 0.0267, 0.0262, 0.0255, 0.0250, 0.0243, 0.0236, 0.0229, 0.0222,
     . 0.0214, 0.0210, 0.0205, 0.0200, 0.0194, 0.0189, 0.0184, 0.0179,
     . 0.0173, 0.0166, 0.0158, 0.0152, 0.0147, 0.0141, 0.0135, 0.0128,
     . 0.0123, 0.0117, 0.0111, 0.0105, 0.0099, 0.0092, 0.0087, 0.0081,
     . 0.0075, 0.0068, 0.0062, 0.0058, 0.0052, 0.0046, 0.0039, 0.0032,
     . 0.0026, 0.0021, 0.0014, 0.0009, 0.0003,-0.0002,-0.0008,-0.0014,
     . 0.0364, 0.0359, 0.0354, 0.0348, 0.0344, 0.0338, 0.0332, 0.0325,
     . 0.0319, 0.0314, 0.0308, 0.0301, 0.0294, 0.0288, 0.0282, 0.0279,
     . 0.0273, 0.0267, 0.0259, 0.0254, 0.0248, 0.0241, 0.0235, 0.0228,
     . 0.0220, 0.0216, 0.0210, 0.0205, 0.0199, 0.0194, 0.0189, 0.0184,
     . 0.0178, 0.0171, 0.0164, 0.0158, 0.0153, 0.0147, 0.0141, 0.0134,
     . 0.0129, 0.0123, 0.0117, 0.0111, 0.0105, 0.0098, 0.0093, 0.0087,
     . 0.0081, 0.0074, 0.0069, 0.0065, 0.0059, 0.0053, 0.0046, 0.0039,
     . 0.0033, 0.0027, 0.0021, 0.0016, 0.0010, 0.0004,-0.0001,-0.0007,
     . 0.0369, 0.0364, 0.0359, 0.0353, 0.0349, 0.0344, 0.0337, 0.0330,
     . 0.0324, 0.0320, 0.0314, 0.0308, 0.0301, 0.0294, 0.0288, 0.0285,
     . 0.0279, 0.0273, 0.0264, 0.0260, 0.0253, 0.0247, 0.0240, 0.0233,
     . 0.0226, 0.0221, 0.0216, 0.0210, 0.0204, 0.0199, 0.0194, 0.0189,
     . 0.0183, 0.0177, 0.0169, 0.0164, 0.0158, 0.0152, 0.0147, 0.0140,
     . 0.0134, 0.0128, 0.0122, 0.0116, 0.0110, 0.0104, 0.0098, 0.0093,
     . 0.0087, 0.0080, 0.0075, 0.0071, 0.0065, 0.0059, 0.0053, 0.0046,
     . 0.0039, 0.0034, 0.0028, 0.0023, 0.0017, 0.0011, 0.0005,-0.0001,
     . 0.0375, 0.0370, 0.0365, 0.0359, 0.0355, 0.0350, 0.0342, 0.0336,
     . 0.0330, 0.0326, 0.0320, 0.0314, 0.0306, 0.0300, 0.0295, 0.0291,
     . 0.0284, 0.0278, 0.0270, 0.0265, 0.0258, 0.0252, 0.0245, 0.0239,
     . 0.0231, 0.0227, 0.0221, 0.0215, 0.0209, 0.0204, 0.0199, 0.0194,
     . 0.0188, 0.0182, 0.0175, 0.0169, 0.0164, 0.0158, 0.0152, 0.0145,
     . 0.0139, 0.0133, 0.0127, 0.0122, 0.0115, 0.0109, 0.0104, 0.0098,
     . 0.0092, 0.0087, 0.0081, 0.0077, 0.0071, 0.0066, 0.0058, 0.0053,
     . 0.0045, 0.0040, 0.0034, 0.0029, 0.0023, 0.0017, 0.0011, 0.0006/
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc_cgf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------
c
c this will perform the inverse
c distortion correction...
c
      subroutine wfc_cgf(xc,yc,xr,yr,kin,fin)
      implicit none
      real*8 xc,yc
      real*8 xr,yr
      integer kin, fin
 
      real*8 xt,yt
 
      real*8 dx, dy, dd
      integer NIT
      real*8 xr1, yr1
      real*8 xr2, yr2
 
      if (kin.eq.1) then
         xr1 = xc
         yr1 = yc
         NIT = 0
 1       continue
         NIT = NIT + 1
         call wfc_gcf(xr1,yr1,xt,yt,1,fin)
         dx = xc-xt
         dy = yc-yt
         dd = sqrt(dx**2+dy**2)
         xr1 = xr1 + (xc-xt)*0.5
         yr1 = yr1 + (yc-yt)*0.5
         if (dd.gt.0.001.and.NIT.lt.99) goto 1
 11      continue
         xr = xr1
         yr = yr1
         return
         endif
 
      if (kin.eq.2) then
         xr2 = xc
         yr2 = yc
         NIT = 0
 2       continue
         NIT = NIT + 1
         call wfc_gcf(xr2,yr2,xt,yt,2,fin)
         dx = xc-xt
         dy = yc-yt
         dd = sqrt(dx**2+dy**2)
         xr2 = xr2 + (xc-xt)*0.5
         yr2 = yr2 + (yc-yt)*0.5
         if (dd.gt.0.001.and.NIT.lt.99) goto 2
 22      continue
         xr = xr2
         yr = yr2
         return
         endif
 
      stop 'wfc_cg:   illegal k...'
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc_gcf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c------------------------------------
c
c HERE IS THE LATEST WFC DISTORTION CORRECTION
c
c I have not put too much effort into documenting this
c routine, so if you have any questions at all, don't
c hesitate to e-mail me.
c
c
c    Jay Andeson
c    jay@eeyore.rice.edu
c    Jun 03, 2004
c
c------------------------------------
 
c----------------------------
c
c k = chip number
c     1 = WFC1 top chip [4]
c     2 = WFC2 bot chip [1]
c
c----------------------------------
 
c----------------------------
c
c f = filter number
c
c  0) use no table correction, only the polynomial
c  1) F435W
c  2) F475W
c  3) F555W
c  4) F606W
c  5) F814W
c  6) F850L
c  7) F625W
c  8) F658N
c  9) F775W
c 10) F660N
c 11) F502N
c 12) F550M
c
c----------------------------
 
 
      subroutine wfc_gcf(xi,yi,xo,yo,ki,fi)
      implicit none
      real*8  xi, yi   ! input raw (x,y) position in chip
      real*8  xo, yo   ! output distortion corrected position in meta system
      integer ki       ! chip #:  ki=1 WFC1 (top chip)   ki=2 WFC2 (bot chip)
      integer fi       ! filt #:  1=F435W 2=F475W 3=F555W 4=F606W 5=F814W
                       !          0=NONE ---> so, no table correction
 
      real*8  xu, yu
      integer ku, fu
      real*8  fx, fy
      real*8 t(15)
 
 
      real*8 tab1xx_fn
      real*8 tab1yy_fn
      real*8 tab2xx_fn
      real*8 tab2yy_fn
 
      real*8 poly1x(15), poly1y(15) ! TOP CHIP WFC1
      real*8 poly2x(15), poly2y(15) ! BOT CHIP WFC2
 
      real*8 dxpoly, dypoly
      real*8 dxlut,  dylut
 
      integer NORD
 
      real*8  rx, ry
      integer ix, iy
      real*8  dx, dy
 
 
c----------------------------------------------------------
c in LINUX, the data statements have to come after the
c common statements, for some bizarre reason
c
      common /polyy/poly1x,poly1y,poly2x,poly2y
      data poly1x /
     .      4.222858,-25.810972,  7.522745, 35.110044,-15.458679,
     .      2.224611, -3.997423, -0.461412, -1.137435,  0.069899,
     .      0.365157,  0.297704,  0.451025, -0.059556,  0.164580/
      data poly1y /
     .   2090.829009,166.636444,-22.581991, -9.224829, 11.854841,
     .     -9.812475,  0.450533, -1.922356, -0.151181, -0.408813,
     .     -0.294261, -0.302678, -0.414122,  0.101310, -0.188003/
      data poly2x /
     .     -0.013903,  0.115885, -0.014278, 35.845661,-10.955353,
     .      2.264019, -4.018862, -0.189312, -1.135375,  0.008529,
     .      0.419362,  0.099082,  0.167527, -0.036017, -0.000001/
      data poly2y /
     .      0.023567,141.245503, 11.904442, -4.966731, 12.417648,
     .     -7.488638,  0.463892, -2.239110, -0.249694, -0.464881,
     .     -0.258344, -0.022357, -0.105517, -0.050072, -0.031641/
 
 
      xu = xi
      call fixcoll(xi,xu)
      yu = yi
      ku = ki
      fu = fi
      if (ki.ne.1.and.ki.ne.2) stop 'in this wfc_gcf, ku must be 1 or 2'
 
 
      if (ku.eq.1) yu = yu-2048.0
 
      fx = (xu-2048.0)/2048.0
      fy = (yu-1024.0)/1024.0
 
      t(01) = 1.0
 
      t(02) = fx
      t(03) = fy
 
      t(04) = fx*fx
      t(05) = fx*fy
      t(06) = fy*fy
 
      t(07) = fx*fx*fx
      t(08) = fx*fx*fy
      t(09) = fx*fy*fy
      t(10) = fy*fy*fy
 
      t(11) = fx*fx*fx*fx
      t(12) = fx*fx*fx*fy
      t(13) = fx*fx*fy*fy
      t(14) = fx*fy*fy*fy
      t(15) = fy*fy*fy*fy
 
      dxpoly = 0.0
      dypoly = 0.0
      if (ku.eq.1) then
         do NORD = 01, 15
            dxpoly = dxpoly + t(NORD)*poly1x(NORD)
            dypoly = dypoly + t(NORD)*poly1y(NORD)
            enddo
         endif
      if (ku.eq.2) then
         do NORD = 01, 15
            dxpoly = dxpoly + t(NORD)*poly2x(NORD)
            dypoly = dypoly + t(NORD)*poly2y(NORD)
            enddo
         endif
 
 
      rx = 1 + xu/64                ! the "real" location within the table
      ry = 1 + yu/64
      if (rx.lt.01) rx = 01.000     ! don't let it go off the table
      if (ry.lt.01) ry = 01.000
      if (rx.ge.65) rx = 64.999
      if (ry.ge.33) ry = 32.999
      ix = int(rx)
      iy = int(ry)
      dx = rx-ix
      dy = ry-iy
 
      dxlut = 0.
      dylut = 0.
 
      if (ku.eq.1.and.fu.ge.1.and.fu.le.12) then ! top chip
         dxlut = (1-dx)*(1-dy)*tab1xx_fn(ix  ,iy  ,fu)
     .         + (1-dx)*( dy )*tab1xx_fn(ix  ,iy+1,fu)
     .         + ( dx )*(1-dy)*tab1xx_fn(ix+1,iy  ,fu)
     .         + ( dx )*( dy )*tab1xx_fn(ix+1,iy+1,fu)
         dylut = (1-dx)*(1-dy)*tab1yy_fn(ix  ,iy  ,fu)
     .         + (1-dx)*( dy )*tab1yy_fn(ix  ,iy+1,fu)
     .         + ( dx )*(1-dy)*tab1yy_fn(ix+1,iy  ,fu)
     .         + ( dx )*( dy )*tab1yy_fn(ix+1,iy+1,fu)
         endif
 
      if (ku.eq.2.and.fu.ge.1.and.fu.le.12) then ! bot chip
         dxlut = (1-dx)*(1-dy)*tab2xx_fn(ix  ,iy  ,fu)
     .         + (1-dx)*( dy )*tab2xx_fn(ix  ,iy+1,fu)
     .         + ( dx )*(1-dy)*tab2xx_fn(ix+1,iy  ,fu)
     .         + ( dx )*( dy )*tab2xx_fn(ix+1,iy+1,fu)
         dylut = (1-dx)*(1-dy)*tab2yy_fn(ix  ,iy  ,fu)
     .         + (1-dx)*( dy )*tab2yy_fn(ix  ,iy+1,fu)
     .         + ( dx )*(1-dy)*tab2yy_fn(ix+1,iy  ,fu)
     .         + ( dx )*( dy )*tab2yy_fn(ix+1,iy+1,fu)
         endif
 
      xo = xu + dxpoly + dxlut
      yo = yu + dypoly + dylut
 
      return
      end
 
 
 
 
 
c------------------------------------------
c
c This routine will correct the column number (x value)
c for the 68.266666-column periodicity found in the
c flat fields.  What I have done (below) is tabulate the
c integrated correction at 500 points within the 68.2666-col
c phase.  The integrated correction came from the relative
c intensity of each column in the flat fields.
c
c I take a given x-coord, find out what its phase is,
c then interpolate the corr() array to get the correction.
c
c------------------------------------------
 
 
      subroutine fixcoll(xi,xo)
      implicit none
      real*8 xi
      real*8 xo
 
      real*8 xiu
      real*8 pctphase
      real    r
      integer i
      real    f
      real    corru
 
      real corr(501)
      data corr /
     . 0.00000,-0.00003,-0.00006,-0.00009,-0.00011,
     .-0.00014,-0.00016,-0.00018,-0.00020,-0.00022,
     .-0.00025,-0.00027,-0.00030,-0.00033,-0.00036,
     .-0.00040,-0.00045,-0.00049,-0.00053,-0.00058,
     .-0.00064,-0.00069,-0.00075,-0.00081,-0.00087,
     .-0.00093,-0.00100,-0.00107,-0.00114,-0.00121,
     .-0.00128,-0.00136,-0.00144,-0.00152,-0.00160,
     .-0.00168,-0.00175,-0.00182,-0.00189,-0.00196,
     .-0.00202,-0.00208,-0.00214,-0.00219,-0.00224,
     .-0.00229,-0.00235,-0.00240,-0.00246,-0.00252,
     .-0.00259,-0.00267,-0.00275,-0.00283,-0.00291,
     .-0.00299,-0.00305,-0.00311,-0.00315,-0.00318,
     .-0.00319,-0.00318,-0.00318,-0.00317,-0.00315,
     .-0.00313,-0.00311,-0.00309,-0.00307,-0.00304,
     .-0.00302,-0.00300,-0.00297,-0.00295,-0.00293,
     .-0.00292,-0.00291,-0.00291,-0.00290,-0.00290,
     .-0.00290,-0.00290,-0.00290,-0.00290,-0.00291,
     .-0.00292,-0.00293,-0.00294,-0.00296,-0.00297,
     .-0.00298,-0.00299,-0.00301,-0.00302,-0.00304,
     .-0.00307,-0.00310,-0.00314,-0.00318,-0.00322,
     .-0.00327,-0.00331,-0.00336,-0.00341,-0.00346,
     .-0.00352,-0.00357,-0.00363,-0.00369,-0.00375,
     .-0.00382,-0.00389,-0.00396,-0.00404,-0.00413,
     .-0.00421,-0.00430,-0.00439,-0.00447,-0.00456,
     .-0.00464,-0.00472,-0.00479,-0.00486,-0.00492,
     .-0.00497,-0.00502,-0.00507,-0.00511,-0.00515,
     .-0.00519,-0.00523,-0.00526,-0.00528,-0.00530,
     .-0.00532,-0.00532,-0.00532,-0.00532,-0.00530,
     .-0.00529,-0.00527,-0.00524,-0.00520,-0.00517,
     .-0.00513,-0.00509,-0.00504,-0.00499,-0.00494 ,
     .-0.00488,-0.00482,-0.00475,-0.00468,-0.00461,
     .-0.00454,-0.00447,-0.00439,-0.00432,-0.00424,
     .-0.00416,-0.00408,-0.00400,-0.00391,-0.00383,
     .-0.00375,-0.00368,-0.00360,-0.00353,-0.00347,
     .-0.00341,-0.00337,-0.00333,-0.00331,-0.00329,
     .-0.00328,-0.00329,-0.00331,-0.00334,-0.00338,
     .-0.00344,-0.00350,-0.00356,-0.00364,-0.00372,
     .-0.00380,-0.00388,-0.00397,-0.00406,-0.00415,
     .-0.00424,-0.00434,-0.00444,-0.00454,-0.00463,
     .-0.00473,-0.00484,-0.00493,-0.00503,-0.00512,
     .-0.00521,-0.00529,-0.00536,-0.00543,-0.00550,
     .-0.00556,-0.00562,-0.00568,-0.00573,-0.00579,
     .-0.00583,-0.00586,-0.00589,-0.00591,-0.00592,
     .-0.00592,-0.00590,-0.00588,-0.00585,-0.00580,
     .-0.00574,-0.00566,-0.00557,-0.00546,-0.00534,
     .-0.00521,-0.00506,-0.00491,-0.00474,-0.00455,
     .-0.00437,-0.00418,-0.00397,-0.00377,-0.00356,
     .-0.00335,-0.00314,-0.00293,-0.00273,-0.00253,
     .-0.00234,-0.00215,-0.00198,-0.00182,-0.00167,
     .-0.00154,-0.00141,-0.00130,-0.00120,-0.00112,
     .-0.00104,-0.00097,-0.00091,-0.00086,-0.00081,
     .-0.00078,-0.00075,-0.00074,-0.00073,-0.00074,
     .-0.00076,-0.00079,-0.00083,-0.00089,-0.00097,
     .-0.00106,-0.00117,-0.00130,-0.00145,-0.00161,
     .-0.00179,-0.00199,-0.00219,-0.00242,-0.00265,
     .-0.00289,-0.00313,-0.00336,-0.00359,-0.00380,
     .-0.00399,-0.00415,-0.00429,-0.00437,-0.00442,
     .-0.00443,-0.00441,-0.00435,-0.00427,-0.00417,
     .-0.00408,-0.00400,-0.00396,-0.00396,-0.00402,
     .-0.00413,-0.00430,-0.00452,-0.00477,-0.00502,
     .-0.00526,-0.00548,-0.00564,-0.00557,-0.00520,
     .-0.00457,-0.00372,-0.00267,-0.00141,-0.00008,
     . 0.00114, 0.00214, 0.00291, 0.00348, 0.00386,
     . 0.00404, 0.00406, 0.00402, 0.00398, 0.00394,
     . 0.00391, 0.00389, 0.00388, 0.00387, 0.00386,
     . 0.00385, 0.00385, 0.00384, 0.00384, 0.00383,
     . 0.00383, 0.00382, 0.00382, 0.00381, 0.00380,
     . 0.00378, 0.00377, 0.00376, 0.00374, 0.00373,
     . 0.00372, 0.00371, 0.00370, 0.00369, 0.00369,
     . 0.00368, 0.00368, 0.00367, 0.00366, 0.00366,
     . 0.00365, 0.00364, 0.00363, 0.00362, 0.00361,
     . 0.00360, 0.00359, 0.00358, 0.00357, 0.00356,
     . 0.00354, 0.00353, 0.00351, 0.00349, 0.00347,
     . 0.00345, 0.00343, 0.00340, 0.00338, 0.00336,
     . 0.00335, 0.00333, 0.00331, 0.00330, 0.00328,
     . 0.00326, 0.00324, 0.00322, 0.00320, 0.00318,
     . 0.00316, 0.00313, 0.00311, 0.00309, 0.00307,
     . 0.00305, 0.00302, 0.00300, 0.00298, 0.00296,
     . 0.00294, 0.00291, 0.00289, 0.00286, 0.00284,
     . 0.00281, 0.00279, 0.00277, 0.00275, 0.00273,
     . 0.00272, 0.00272, 0.00271, 0.00270, 0.00270,
     . 0.00270, 0.00269, 0.00269, 0.00268, 0.00267,
     . 0.00266, 0.00265, 0.00264, 0.00263, 0.00263,
     . 0.00261, 0.00260, 0.00260, 0.00259, 0.00258,
     . 0.00257, 0.00257, 0.00257, 0.00257, 0.00257,
     . 0.00257, 0.00256, 0.00255, 0.00253, 0.00251,
     . 0.00250, 0.00248, 0.00246, 0.00244, 0.00243,
     . 0.00241, 0.00239, 0.00237, 0.00235, 0.00233,
     . 0.00230, 0.00227, 0.00224, 0.00221, 0.00217,
     . 0.00213, 0.00208, 0.00204, 0.00200, 0.00195,
     . 0.00190, 0.00186, 0.00182, 0.00177, 0.00173,
     . 0.00169, 0.00164, 0.00160, 0.00155, 0.00149,
     . 0.00143, 0.00137, 0.00131, 0.00124, 0.00118,
     . 0.00111, 0.00105, 0.00099, 0.00094, 0.00089,
     . 0.00084, 0.00080, 0.00076, 0.00072, 0.00069,
     . 0.00066, 0.00063, 0.00060, 0.00057, 0.00054,
     . 0.00051, 0.00048, 0.00045, 0.00042, 0.00039,
     . 0.00036, 0.00034, 0.00031, 0.00028, 0.00025,
     . 0.00023, 0.00020, 0.00017, 0.00015, 0.00013,
     . 0.00011, 0.00009, 0.00007, 0.00005, 0.00003,
     . 0.00000/
 
 
      xiu = xi
      xo  = xi
      if (xi.lt.0001.or.xi.gt.4096) return
 
c     if (xi.gt.2048) xiu = xi-2048                                   ! JAY WHY WAS THIS HERE?!
      pctphase = (xiu-int(xiu/68.266666)*68.266666)/68.266666*100.00
 
      r = 1 + 5*pctphase
      i = int(r)
      f = r-i
 
      corru = (1-f)*corr(i) + (f)*corr(i+1)
 
      xo = xi + corru*0.68266
 
      return
      end
 
 
c----------------------------------------------------
c
c the following routines will supply the table values
c
c
      real*8 function tab1xx_fn(i,j,g)
      implicit none
      integer i,j,g
      integer*2 wwtabx1(12,33,65)
      common /wwtabx1_/wwtabx1
 
      tab1xx_fn = wwtabx1(g,j,i)/1000.0
      return
      end
 
      real*8 function tab1yy_fn(i,j,g)
      implicit none
      integer i,j,g
      integer*2 wwtaby1(12,33,65)
      common /wwtaby1_/wwtaby1
 
      tab1yy_fn = wwtaby1(g,j,i)/1000.0
      if (g.eq.8.and.j.eq.1) tab1yy_fn = tab1yy_fn+0.01
 
      return
      end
 
      real*8 function tab2xx_fn(i,j,g)
      implicit none
      integer i,j,g
      integer*2 wwtabx2(12,33,65)
      common /wwtabx2_/wwtabx2
 
      tab2xx_fn = wwtabx2(g,j,i)/1000.0
      return
      end
 
      real*8 function tab2yy_fn(i,j,g)
      implicit none
      integer i,j,g
      integer*2 wwtaby2(12,33,65)
      common /wwtaby2_/wwtaby2
 
      tab2yy_fn = wwtaby2(g,j,i)/1000.0
      return
      end
 
 
 
      block data xx1array
      integer*2 wwtabx1(12,33,65)
      common /wwtabx1_/wwtabx1
      data wwtabx1/
     c-249,-139,  86, 313,  40, 159, 354,  86, 392, 272, 349, 251,
     c-247,-136,  84, 317,  46, 166, 361,  91, 399, 215, 361, 260,
     c-244,-134,  83, 325,  53, 171, 368,  97, 406, 197, 367, 268,
     c-239,-127,  90, 336,  65, 181, 374, 104, 411, 224, 370, 274,
     c-236,-123,  88, 341,  73, 180, 382, 110, 417, 286, 372, 279,
     c-235,-118,  89, 351,  83, 188, 388, 117, 423, 335, 378, 285,
     c-231,-110,  99, 369,  96, 200, 395, 128, 430, 366, 385, 292,
     c-221,-100, 107, 381, 112, 203, 402, 137, 438, 391, 392, 300,
     c-210, -90, 111, 388, 121, 211, 407, 144, 446, 406, 399, 309,
     c-199, -83, 118, 397, 133, 217, 415, 151, 455, 392, 409, 319,
     c-189, -76, 125, 404, 146, 233, 423, 157, 462, 375, 415, 327,
     c-184, -71, 132, 407, 156, 235, 429, 165, 470, 375, 420, 333,
     c-183, -67, 141, 407, 162, 234, 436, 170, 477, 389, 423, 337,
     c-177, -63, 155, 413, 174, 249, 442, 173, 483, 407, 426, 341,
     c-164, -59, 164, 419, 177, 249, 447, 177, 486, 423, 428, 345,
     c-155, -56, 169, 421, 176, 255, 451, 179, 489, 444, 430, 348,
     c-152, -53, 171, 417, 172, 252, 449, 180, 489, 467, 431, 347,
     c-147, -49, 174, 419, 172, 260, 450, 179, 488, 500, 432, 346,
     c-149, -44, 167, 423, 172, 269, 450, 182, 488, 498, 431, 343,
     c-151, -38, 162, 428, 178, 266, 451, 186, 490, 473, 431, 342,
     c-147, -29, 166, 434, 184, 272, 458, 195, 496, 444, 437, 346,
     c-137, -16, 179, 442, 193, 282, 469, 212, 506, 438, 447, 355,
     c-121,   1, 198, 457, 211, 281, 486, 232, 521, 430, 457, 370,
     c -96,  21, 218, 480, 237, 310, 506, 255, 543, 444, 473, 388,
     c -64,  44, 235, 506, 257, 334, 531, 279, 568, 488, 493, 410,
     c -31,  68, 252, 527, 275, 351, 555, 301, 592, 575, 517, 433,
     c  -2,  89, 273, 549, 293, 376, 576, 327, 613, 628, 539, 454,
     c  26, 109, 298, 566, 309, 396, 598, 341, 629, 666, 554, 471,
     c  46, 127, 315, 573, 317, 419, 610, 354, 643, 695, 562, 482,
     c  57, 141, 318, 573, 318, 426, 616, 353, 651, 738, 564, 487,
     c  58, 148, 313, 564, 306, 425, 614, 352, 658, 732, 564, 490,
     c  73, 161, 318, 557, 308, 424, 614, 343, 664, 681, 567, 490,
     c  87, 175, 323, 548, 307, 414, 613, 335, 671, 608, 574, 490,
     c-202, -90, 127, 369,  89, 193, 393, 117, 431, 414, 396, 298,
     c-198, -88, 125, 373,  94, 199, 398, 120, 436, 341, 407, 305,
     c-196, -85, 124, 378,  99, 213, 403, 124, 440, 309, 413, 310,
     c-192, -80, 124, 384, 105, 217, 408, 130, 444, 312, 414, 313,
     c-193, -76, 118, 384, 108, 218, 411, 134, 447, 349, 413, 315,
     c-194, -72, 115, 390, 114, 222, 416, 140, 451, 377, 415, 317,
     c-193, -66, 124, 404, 125, 227, 420, 147, 455, 389, 419, 321,
     c-185, -59, 132, 413, 136, 236, 425, 151, 462, 398, 421, 326,
     c-178, -53, 134, 415, 144, 237, 431, 156, 468, 401, 426, 333,
     c-171, -48, 139, 423, 153, 238, 437, 163, 474, 379, 431, 340,
     c-162, -45, 144, 429, 161, 246, 443, 169, 481, 358, 436, 347,
     c-159, -42, 149, 431, 165, 245, 448, 174, 487, 358, 439, 350,
     c-160, -40, 155, 429, 171, 241, 451, 179, 493, 377, 441, 353,
     c-155, -38, 167, 435, 180, 258, 456, 183, 497, 400, 444, 356,
     c-145, -36, 175, 440, 185, 264, 462, 186, 500, 421, 445, 359,
     c-137, -34, 178, 438, 184, 267, 463, 189, 500, 448, 445, 360,
     c-136, -33, 179, 434, 181, 264, 463, 187, 500, 472, 446, 358,
     c-132, -30, 180, 433, 179, 264, 461, 185, 497, 497, 445, 355,
     c-134, -26, 175, 434, 178, 269, 460, 183, 495, 484, 443, 351,
     c-136, -22, 171, 437, 183, 267, 461, 186, 496, 449, 443, 349,
     c-134, -15, 174, 441, 187, 269, 465, 191, 500, 407, 447, 350,
     c-125,  -4, 186, 450, 195, 282, 476, 205, 509, 390, 455, 357,
     c-112,   9, 204, 462, 212, 292, 490, 223, 523, 380, 464, 370,
     c -87,  27, 220, 483, 236, 312, 509, 244, 541, 390, 476, 386,
     c -60,  45, 232, 503, 251, 335, 530, 267, 564, 435, 496, 405,
     c -32,  65, 247, 523, 267, 344, 552, 290, 587, 514, 518, 426,
     c  -6,  82, 266, 542, 283, 362, 573, 312, 606, 558, 538, 444,
     c  19,  98, 286, 556, 297, 379, 591, 329, 620, 578, 553, 458,
     c  37, 113, 302, 561, 303, 388, 605, 342, 630, 588, 560, 465,
     c  46, 125, 304, 561, 304, 403, 609, 344, 638, 612, 562, 468,
     c  46, 129, 299, 553, 291, 401, 606, 341, 643, 597, 562, 469,
     c  60, 143, 303, 549, 294, 399, 605, 334, 649, 554, 565, 468,
     c  77, 158, 310, 539, 293, 407, 603, 327, 653, 487, 571, 466,
     c-154, -42, 168, 425, 136, 236, 438, 154, 469, 513, 441, 343,
     c-151, -39, 166, 428, 140, 243, 440, 156, 472, 426, 451, 347,
     c-148, -37, 165, 431, 146, 248, 442, 158, 475, 379, 456, 350,
     c-147, -32, 159, 432, 146, 247, 443, 159, 476, 364, 454, 349,
     c-148, -30, 149, 428, 145, 251, 446, 161, 478, 385, 452, 348,
     c-151, -28, 143, 430, 148, 251, 447, 161, 479, 401, 452, 347,
     c-154, -24, 148, 438, 154, 256, 449, 166, 481, 403, 452, 348,
     c-151, -19, 156, 445, 161, 257, 451, 168, 485, 406, 451, 351,
     c-146, -15, 157, 444, 165, 258, 457, 173, 489, 402, 453, 355,
     c-142, -14, 160, 449, 172, 259, 460, 181, 495, 378, 455, 360,
     c-135, -12, 164, 454, 175, 269, 465, 185, 498, 353, 458, 365,
     c-134, -12, 165, 455, 178, 265, 467, 189, 503, 351, 458, 366,
     c-137, -13, 169, 452, 180, 260, 470, 192, 508, 371, 458, 368,
     c-135, -13, 178, 454, 187, 269, 472, 194, 511, 397, 460, 369,
     c-125, -12, 185, 457, 190, 277, 476, 197, 512, 417, 461, 371,
     c-120, -13, 187, 455, 191, 277, 476, 197, 512, 446, 461, 370,
     c-120, -13, 187, 449, 188, 274, 476, 196, 510, 469, 461, 368,
     c-116, -12, 185, 446, 186, 273, 474, 193, 507, 487, 459, 364,
     c-120,  -9, 183, 445, 184, 275, 470, 189, 504, 469, 456, 360,
     c-123,  -7, 180, 445, 187, 269, 471, 190, 503, 431, 454, 356,
     c-122,  -1, 183, 449, 189, 279, 475, 193, 505, 384, 457, 356,
     c-113,   6, 193, 456, 198, 286, 483, 205, 512, 366, 463, 361,
     c-102,  18, 210, 468, 213, 294, 497, 222, 524, 359, 471, 372,
     c -79,  31, 221, 485, 232, 315, 514, 242, 542, 370, 482, 386,
     c -57,  47, 229, 501, 246, 334, 532, 262, 563, 413, 499, 403,
     c -32,  63, 242, 518, 260, 342, 552, 284, 582, 484, 519, 420,
     c -10,  76, 259, 535, 273, 363, 570, 304, 598, 518, 538, 436,
     c  11,  88, 275, 545, 285, 373, 586, 321, 611, 520, 551, 447,
     c  28, 100, 288, 551, 291, 381, 597, 329, 619, 512, 558, 452,
     c  36, 109, 291, 552, 292, 385, 600, 333, 624, 521, 558, 453,
     c  36, 112, 285, 545, 279, 382, 597, 325, 628, 504, 558, 452,
     c  50, 125, 291, 540, 278, 388, 595, 321, 632, 468, 562, 451,
     c  65, 139, 295, 533, 275, 386, 593, 313, 636, 408, 567, 447,
     c-102,  13, 220, 481, 184, 276, 489, 204, 507, 561, 484, 385,
     c-102,  14, 213, 479, 186, 284, 489, 202, 509, 461, 493, 387,
     c-102,  15, 207, 479, 189, 288, 490, 201, 509, 401, 497, 387,
     c-103,  19, 194, 479, 183, 284, 486, 197, 509, 372, 494, 384,
     c-105,  21, 179, 477, 178, 283, 484, 194, 508, 385, 490, 380,
     c-107,  22, 170, 473, 177, 277, 484, 192, 505, 397, 487, 377,
     c-112,  23, 175, 474, 181, 275, 483, 191, 505, 403, 485, 375,
     c-114,  24, 182, 479, 186, 281, 484, 194, 508, 415, 482, 375,
     c-113,  24, 184, 479, 189, 278, 485, 197, 511, 417, 480, 377,
     c-109,  24, 186, 480, 192, 275, 488, 202, 514, 392, 481, 380,
     c-105,  22, 187, 480, 193, 278, 490, 204, 518, 364, 480, 381,
     c-104,  20, 185, 479, 193, 273, 489, 203, 521, 359, 479, 380,
     c-110,  17, 185, 473, 193, 266, 489, 206, 524, 375, 478, 380,
     c-112,  15, 191, 474, 196, 282, 490, 208, 526, 400, 478, 380,
     c-103,  14, 196, 477, 199, 291, 492, 211, 526, 419, 476, 381,
     c -98,  12, 196, 477, 198, 293, 494, 211, 523, 444, 475, 380,
     c-100,  10, 195, 470, 195, 285, 492, 207, 521, 459, 473, 378,
     c-103,  10, 191, 461, 192, 282, 488, 203, 517, 472, 471, 374,
     c-106,  11, 188, 458, 190, 279, 486, 199, 512, 452, 467, 369,
     c-106,  12, 185, 457, 189, 275, 484, 198, 510, 416, 465, 365,
     c-105,  16, 190, 460, 191, 284, 487, 198, 511, 376, 468, 365,
     c -99,  22, 198, 463, 198, 278, 495, 205, 518, 367, 473, 369,
     c -87,  31, 212, 472, 211, 288, 508, 218, 528, 368, 479, 378,
     c -67,  42, 220, 484, 226, 302, 522, 235, 543, 389, 489, 389,
     c -48,  53, 228, 499, 239, 319, 538, 253, 561, 434, 504, 403,
     c -31,  63, 239, 513, 251, 330, 554, 271, 578, 497, 522, 419,
     c -18,  71, 255, 528, 264, 353, 567, 289, 591, 513, 537, 432,
     c  -3,  78, 265, 537, 269, 357, 579, 303, 600, 490, 548, 440,
     c  12,  85, 272, 540, 273, 361, 586, 310, 605, 459, 553, 442,
     c  22,  92, 272, 541, 276, 364, 588, 312, 609, 458, 553, 441,
     c  19,  93, 263, 534, 266, 354, 584, 306, 611, 444, 553, 439,
     c  32, 105, 273, 531, 262, 364, 582, 302, 615, 423, 556, 437,
     c  45, 117, 280, 526, 258, 365, 581, 297, 618, 391, 562, 434,
     c -54,  69, 258, 521, 223, 308, 535, 239, 544, 578, 524, 423,
     c -55,  69, 250, 518, 223, 312, 536, 238, 544, 472, 532, 423,
     c -57,  69, 241, 517, 221, 316, 533, 234, 544, 402, 534, 422,
     c -59,  72, 226, 515, 217, 316, 528, 228, 540, 363, 530, 416,
     c -64,  72, 210, 508, 208, 308, 522, 220, 536, 367, 524, 410,
     c -66,  71, 200, 502, 205, 301, 516, 217, 532, 378, 519, 405,
     c -73,  69, 202, 500, 206, 296, 514, 215, 530, 393, 516, 401,
     c -76,  67, 209, 503, 210, 295, 512, 216, 530, 421, 511, 399,
     c -79,  64, 213, 504, 211, 295, 511, 216, 532, 439, 507, 398,
     c -80,  59, 211, 502, 209, 294, 511, 216, 535, 416, 506, 398,
     c -80,  55, 208, 501, 208, 292, 509, 215, 537, 380, 504, 397,
     c -80,  50, 204, 499, 206, 290, 507, 215, 537, 364, 501, 393,
     c -86,  46, 203, 494, 205, 281, 505, 217, 538, 374, 498, 391,
     c -90,  42, 206, 493, 203, 290, 504, 218, 538, 394, 495, 389,
     c -86,  40, 208, 495, 204, 296, 503, 217, 537, 410, 491, 388,
     c -84,  35, 203, 490, 202, 290, 505, 218, 534, 425, 489, 386,
     c -89,  32, 202, 484, 198, 288, 502, 214, 530, 432, 485, 384,
     c -94,  29, 199, 476, 193, 279, 499, 211, 525, 445, 482, 380,
     c -95,  28, 192, 470, 191, 274, 497, 207, 521, 428, 477, 376,
     c -94,  28, 189, 468, 192, 279, 497, 208, 518, 402, 475, 373,
     c -92,  31, 194, 470, 192, 288, 497, 206, 518, 377, 477, 372,
     c -88,  36, 204, 474, 196, 286, 503, 211, 523, 385, 482, 375,
     c -75,  45, 215, 480, 211, 293, 515, 220, 532, 397, 488, 382,
     c -58,  53, 224, 491, 225, 305, 528, 237, 544, 431, 496, 391,
     c -44,  61, 233, 505, 235, 320, 541, 252, 559, 479, 507, 403,
     c -34,  67, 243, 516, 246, 331, 554, 265, 574, 532, 522, 416,
     c -24,  71, 253, 526, 255, 340, 563, 278, 584, 523, 534, 427,
     c -12,  73, 259, 531, 257, 339, 571, 290, 590, 484, 542, 433,
     c   0,  77, 263, 534, 260, 338, 576, 297, 594, 435, 547, 433,
     c  11,  79, 264, 532, 261, 339, 578, 298, 595, 422, 547, 432,
     c  12,  78, 259, 524, 253, 336, 573, 294, 597, 414, 547, 428,
     c  24,  88, 268, 522, 251, 344, 573, 292, 598, 408, 551, 426,
     c  34,  98, 277, 517, 244, 348, 571, 288, 601, 407, 557, 424,
     c  -6, 127, 297, 553, 254, 342, 570, 269, 576, 601, 556, 452,
     c  -8, 124, 286, 549, 251, 342, 569, 266, 576, 496, 564, 451,
     c -10, 121, 277, 547, 249, 340, 565, 262, 573, 423, 565, 449,
     c -18, 121, 262, 541, 243, 335, 556, 253, 568, 374, 559, 443,
     c -25, 119, 246, 529, 233, 323, 548, 243, 562, 366, 551, 435,
     c -32, 114, 235, 520, 228, 306, 539, 238, 555, 375, 545, 428,
     c -43, 110, 236, 517, 229, 304, 534, 233, 551, 404, 540, 423,
     c -48, 105, 237, 518, 229, 309, 534, 233, 550, 451, 535, 419,
     c -52,  98, 237, 519, 227, 309, 531, 230, 550, 484, 532, 417,
     c -56,  89, 232, 517, 226, 308, 528, 228, 550, 461, 528, 414,
     c -61,  81, 227, 515, 223, 305, 523, 223, 550, 413, 525, 410,
     c -66,  74, 221, 513, 218, 300, 519, 220, 549, 380, 520, 403,
     c -71,  68, 220, 509, 212, 292, 514, 219, 548, 375, 515, 399,
     c -76,  62, 222, 506, 210, 293, 511, 219, 546, 386, 510, 395,
     c -76,  57, 217, 505, 206, 294, 509, 216, 543, 398, 505, 392,
     c -77,  50, 209, 499, 201, 289, 509, 216, 539, 399, 499, 389,
     c -82,  44, 207, 492, 197, 286, 506, 212, 536, 397, 495, 387,
     c -86,  40, 203, 485, 194, 279, 505, 210, 531, 404, 490, 383,
     c -90,  35, 194, 477, 190, 275, 502, 208, 526, 397, 485, 379,
     c -88,  34, 191, 475, 191, 276, 502, 208, 523, 377, 481, 376,
     c -85,  37, 198, 476, 192, 281, 502, 206, 523, 370, 483, 375,
     c -81,  40, 206, 478, 195, 287, 507, 210, 528, 385, 489, 377,
     c -71,  45, 214, 483, 206, 294, 516, 218, 534, 409, 493, 382,
     c -57,  53, 226, 495, 220, 305, 529, 231, 545, 451, 499, 389,
     c -42,  59, 239, 507, 232, 320, 540, 243, 556, 500, 508, 399,
     c -33,  63, 245, 514, 241, 332, 550, 254, 567, 540, 521, 409,
     c -26,  64, 247, 520, 246, 336, 557, 263, 576, 521, 531, 418,
     c -15,  65, 249, 524, 248, 337, 564, 273, 581, 469, 537, 423,
     c  -1,  67, 253, 525, 250, 332, 569, 282, 584, 414, 540, 423,
     c  10,  69, 257, 522, 249, 329, 570, 285, 586, 400, 542, 420,
     c  11,  65, 258, 515, 240, 323, 568, 285, 586, 399, 543, 416,
     c  20,  74, 266, 511, 241, 335, 566, 280, 588, 411, 547, 414,
     c  28,  82, 273, 505, 236, 327, 562, 275, 589, 435, 552, 412,
     c  24, 167, 320, 570, 273, 363, 591, 284, 595, 611, 577, 467,
     c  20, 161, 310, 567, 267, 352, 590, 282, 594, 519, 582, 466,
     c  15, 157, 301, 562, 263, 349, 584, 278, 591, 452, 582, 464,
     c   9, 152, 292, 556, 258, 346, 576, 268, 584, 395, 575, 457,
     c   0, 145, 275, 546, 248, 334, 564, 257, 576, 380, 566, 450,
     c  -8, 137, 262, 537, 242, 326, 556, 250, 568, 390, 560, 443,
     c -23, 129, 261, 532, 241, 319, 550, 245, 563, 429, 556, 436,
     c -29, 122, 260, 530, 241, 318, 548, 244, 560, 493, 552, 431,
     c -32, 112, 252, 527, 237, 315, 545, 239, 559, 537, 547, 428,
     c -35, 103, 244, 527, 234, 315, 538, 234, 558, 508, 545, 423,
     c -45,  93, 238, 523, 232, 310, 533, 226, 557, 448, 541, 417,
     c -54,  84, 234, 519, 227, 307, 526, 221, 553, 397, 534, 409,
     c -61,  77, 231, 515, 218, 300, 520, 215, 550, 376, 527, 402,
     c -66,  70, 228, 509, 212, 296, 515, 211, 547, 379, 520, 397,
     c -68,  64, 220, 507, 207, 295, 511, 209, 544, 393, 513, 393,
     c -68,  56, 214, 506, 202, 293, 508, 208, 540, 390, 506, 388,
     c -71,  46, 211, 499, 197, 293, 506, 209, 535, 375, 501, 385,
     c -78,  38, 203, 489, 193, 284, 504, 209, 532, 376, 496, 381,
     c -81,  32, 196, 484, 190, 279, 502, 208, 528, 371, 490, 377,
     c -80,  29, 196, 482, 190, 280, 501, 207, 526, 361, 486, 374,
     c -79,  28, 198, 478, 188, 285, 501, 207, 526, 355, 486, 373,
     c -78,  29, 203, 477, 188, 284, 504, 207, 529, 365, 490, 375,
     c -72,  33, 212, 483, 197, 289, 511, 214, 535, 391, 495, 378,
     c -59,  38, 225, 494, 210, 301, 522, 226, 542, 433, 499, 383,
     c -44,  45, 235, 501, 221, 312, 533, 235, 552, 478, 507, 391,
     c -33,  50, 241, 505, 231, 317, 542, 246, 561, 506, 518, 401,
     c -26,  52, 241, 512, 238, 326, 548, 253, 569, 488, 526, 409,
     c -15,  54, 240, 517, 239, 327, 556, 264, 574, 440, 531, 413,
     c   2,  57, 242, 518, 241, 319, 562, 272, 576, 392, 534, 413,
     c  12,  59, 246, 515, 241, 314, 565, 276, 578, 388, 537, 410,
     c   6,  55, 247, 511, 231, 311, 561, 278, 579, 401, 539, 405,
     c  12,  61, 254, 504, 230, 314, 559, 275, 580, 426, 543, 403,
     c  17,  68, 261, 497, 230, 321, 555, 270, 579, 465, 547, 401,
     c  36, 183, 322, 572, 276, 374, 592, 282, 600, 590, 581, 466,
     c  29, 174, 312, 567, 271, 358, 592, 282, 599, 514, 583, 465,
     c  23, 166, 304, 561, 264, 351, 588, 279, 595, 459, 583, 464,
     c  16, 158, 296, 555, 259, 345, 578, 271, 588, 410, 575, 459,
     c   8, 146, 283, 549, 251, 338, 568, 260, 580, 396, 567, 453,
     c  -1, 134, 271, 544, 246, 330, 561, 252, 571, 407, 561, 446,
     c -13, 125, 268, 539, 244, 320, 556, 249, 566, 447, 558, 440,
     c -19, 118, 264, 536, 244, 324, 552, 248, 563, 516, 556, 435,
     c -19, 109, 256, 532, 240, 317, 550, 245, 561, 562, 553, 430,
     c -23,  99, 245, 529, 234, 318, 543, 236, 559, 533, 550, 424,
     c -35,  91, 238, 523, 233, 309, 537, 229, 557, 464, 545, 417,
     c -46,  84, 236, 518, 229, 307, 530, 222, 553, 406, 539, 409,
     c -56,  77, 231, 512, 218, 297, 522, 213, 549, 378, 531, 401,
     c -61,  71, 227, 506, 210, 290, 515, 206, 545, 383, 523, 395,
     c -63,  63, 219, 504, 205, 284, 511, 203, 540, 396, 515, 390,
     c -61,  53, 214, 504, 200, 283, 506, 199, 536, 390, 509, 385,
     c -64,  42, 209, 498, 194, 281, 504, 199, 533, 365, 502, 381,
     c -69,  32, 202, 493, 191, 280, 500, 197, 530, 359, 497, 376,
     c -71,  22, 198, 491, 189, 277, 499, 200, 526, 355, 491, 372,
     c -73,  15, 195, 487, 186, 274, 497, 200, 524, 347, 487, 369,
     c -76,  13, 197, 479, 182, 277, 497, 203, 525, 339, 487, 368,
     c -77,  13, 199, 477, 183, 275, 499, 201, 528, 346, 490, 369,
     c -72,  16, 208, 482, 189, 286, 504, 206, 531, 369, 493, 371,
     c -59,  22, 220, 488, 198, 293, 513, 214, 538, 411, 497, 376,
     c -45,  29, 229, 495, 210, 298, 523, 225, 545, 446, 504, 383,
     c -33,  35, 237, 499, 218, 307, 535, 235, 553, 460, 513, 392,
     c -24,  39, 239, 504, 226, 313, 542, 244, 560, 442, 520, 400,
     c -12,  44, 235, 511, 228, 318, 549, 254, 565, 411, 524, 405,
     c   2,  50, 235, 517, 231, 325, 555, 261, 569, 380, 527, 404,
     c   7,  53, 239, 520, 233, 321, 557, 266, 571, 386, 530, 401,
     c   0,  49, 235, 509, 224, 314, 553, 266, 571, 412, 534, 396,
     c   2,  54, 239, 503, 224, 320, 549, 262, 571, 445, 537, 394,
     c   7,  60, 244, 495, 224, 310, 545, 255, 570, 492, 540, 392,
     c  24, 166, 303, 554, 258, 359, 576, 263, 592, 543, 567, 449,
     c  20, 157, 296, 553, 256, 342, 576, 264, 591, 492, 569, 450,
     c  17, 148, 289, 548, 253, 336, 574, 263, 589, 455, 568, 450,
     c  10, 137, 281, 544, 250, 329, 567, 254, 582, 426, 562, 447,
     c   0, 123, 269, 537, 241, 321, 559, 250, 574, 421, 555, 443,
     c  -7, 112, 261, 532, 234, 315, 553, 245, 568, 428, 550, 439,
     c -14, 104, 258, 531, 235, 308, 550, 243, 563, 452, 548, 434,
     c -18,  98, 257, 529, 236, 321, 548, 239, 559, 510, 548, 429,
     c -19,  92, 252, 527, 233, 313, 543, 238, 557, 546, 546, 424,
     c -20,  87, 239, 521, 227, 306, 539, 230, 556, 512, 543, 418,
     c -32,  81, 229, 515, 223, 301, 533, 222, 553, 441, 540, 411,
     c -45,  75, 227, 512, 219, 299, 526, 214, 548, 393, 535, 403,
     c -51,  70, 228, 510, 213, 295, 519, 206, 543, 373, 528, 395,
     c -58,  65, 228, 504, 206, 289, 513, 199, 539, 381, 520, 390,
     c -61,  58, 221, 501, 200, 283, 509, 195, 536, 401, 513, 385,
     c -60,  50, 213, 498, 196, 281, 504, 192, 532, 398, 506, 380,
     c -62,  38, 209, 496, 190, 275, 502, 191, 529, 366, 501, 376,
     c -68,  25, 204, 495, 186, 276, 497, 189, 526, 347, 497, 371,
     c -69,  15, 198, 494, 186, 271, 495, 191, 524, 345, 491, 366,
     c -70,   7, 194, 489, 183, 264, 494, 191, 523, 340, 486, 363,
     c -74,   2, 195, 482, 177, 271, 493, 196, 523, 331, 486, 361,
     c -75,   2, 198, 481, 179, 275, 493, 195, 524, 334, 487, 361,
     c -69,   5, 202, 483, 181, 283, 498, 200, 528, 359, 490, 363,
     c -57,  11, 210, 483, 186, 288, 505, 207, 533, 401, 494, 368,
     c -44,  19, 222, 488, 196, 290, 515, 219, 539, 425, 500, 374,
     c -33,  25, 234, 494, 207, 297, 527, 227, 546, 426, 507, 383,
     c -23,  30, 238, 498, 210, 306, 536, 235, 553, 407, 513, 391,
     c -11,  37, 234, 505, 215, 309, 542, 241, 558, 389, 516, 395,
     c  -3,  45, 234, 515, 221, 316, 547, 247, 561, 373, 520, 395,
     c   0,  49, 236, 519, 226, 313, 549, 252, 563, 391, 524, 392,
     c  -6,  47, 229, 508, 214, 299, 544, 251, 563, 428, 528, 388,
     c  -4,  50, 230, 502, 214, 298, 540, 243, 563, 466, 531, 385,
     c   0,  55, 233, 496, 216, 300, 535, 239, 560, 514, 534, 383,
     c  -6, 125, 273, 523, 224, 326, 544, 229, 575, 486, 541, 422,
     c  -9, 116, 268, 521, 226, 314, 544, 229, 575, 465, 544, 425,
     c -12, 107, 262, 520, 227, 309, 542, 230, 572, 451, 543, 425,
     c -14,  97, 256, 518, 225, 304, 540, 227, 568, 442, 540, 425,
     c -19,  85, 247, 514, 219, 297, 536, 227, 562, 444, 534, 424,
     c -22,  77, 241, 513, 216, 296, 534, 225, 556, 437, 532, 422,
     c -28,  72, 240, 514, 219, 286, 532, 226, 552, 439, 531, 419,
     c -31,  71, 243, 518, 222, 302, 531, 223, 551, 470, 531, 414,
     c -31,  70, 239, 512, 220, 292, 529, 223, 549, 490, 530, 411,
     c -31,  68, 227, 507, 215, 283, 526, 217, 547, 451, 529, 405,
     c -43,  65, 219, 505, 210, 286, 521, 210, 545, 396, 527, 399,
     c -51,  62, 221, 505, 206, 289, 515, 203, 541, 369, 523, 393,
     c -54,  58, 228, 503, 203, 286, 510, 195, 537, 366, 518, 387,
     c -57,  55, 229, 499, 200, 283, 504, 191, 534, 386, 512, 383,
     c -63,  51, 224, 497, 195, 280, 502, 187, 531, 413, 507, 379,
     c -64,  45, 219, 495, 192, 273, 500, 185, 529, 413, 503, 376,
     c -64,  37, 217, 494, 188, 273, 498, 184, 528, 375, 500, 373,
     c -68,  26, 208, 494, 184, 273, 494, 182, 527, 349, 495, 368,
     c -72,  16, 198, 493, 181, 269, 493, 181, 524, 342, 491, 363,
     c -71,   8, 195, 490, 180, 264, 492, 182, 522, 337, 487, 359,
     c -70,   4, 196, 486, 178, 274, 491, 187, 523, 325, 485, 356,
     c -71,   3, 196, 483, 176, 274, 491, 189, 524, 323, 487, 355,
     c -66,   4, 193, 481, 175, 273, 494, 194, 526, 353, 489, 356,
     c -58,   9, 198, 482, 177, 281, 501, 198, 530, 391, 494, 360,
     c -45,  15, 213, 486, 187, 280, 510, 208, 534, 406, 499, 366,
     c -34,  21, 228, 488, 196, 281, 521, 216, 540, 394, 505, 375,
     c -27,  26, 232, 491, 198, 291, 529, 223, 546, 376, 510, 382,
     c -17,  33, 231, 498, 205, 294, 536, 228, 551, 360, 513, 386,
     c -10,  43, 234, 505, 214, 299, 541, 233, 555, 358, 516, 387,
     c  -7,  50, 236, 511, 218, 304, 542, 236, 556, 382, 521, 383,
     c -13,  47, 229, 504, 209, 296, 537, 233, 556, 421, 524, 379,
     c  -9,  51, 230, 499, 208, 294, 534, 227, 554, 459, 527, 377,
     c  -7,  54, 230, 493, 209, 293, 529, 225, 551, 503, 530, 375,
     c -49,  75, 237, 488, 186, 284, 502, 190, 548, 405, 511, 388,
     c -49,  68, 234, 486, 190, 277, 506, 191, 549, 411, 513, 392,
     c -50,  61, 230, 487, 192, 274, 506, 193, 549, 420, 514, 395,
     c -47,  54, 228, 489, 194, 275, 506, 192, 546, 433, 513, 398,
     c -48,  47, 221, 491, 194, 269, 504, 195, 543, 440, 512, 399,
     c -47,  44, 218, 495, 195, 271, 505, 196, 540, 416, 511, 399,
     c -48,  45, 220, 501, 201, 267, 506, 199, 538, 396, 512, 397,
     c -48,  48, 224, 505, 206, 276, 508, 198, 537, 406, 512, 394,
     c -49,  50, 222, 499, 204, 270, 507, 198, 537, 416, 511, 392,
     c -53,  52, 213, 494, 199, 264, 505, 194, 537, 382, 511, 387,
     c -60,  50, 207, 493, 196, 267, 503, 190, 535, 353, 510, 384,
     c -63,  48, 213, 492, 193, 266, 499, 183, 532, 355, 507, 380,
     c -61,  46, 221, 489, 192, 266, 496, 180, 529, 371, 505, 377,
     c -61,  45, 224, 487, 192, 266, 496, 178, 528, 395, 502, 375,
     c -65,  44, 225, 489, 191, 261, 497, 178, 529, 421, 501, 374,
     c -63,  44, 227, 493, 191, 264, 498, 180, 529, 423, 499, 373,
     c -61,  41, 225, 496, 189, 268, 498, 181, 529, 383, 498, 371,
     c -62,  35, 215, 494, 186, 263, 498, 178, 530, 352, 497, 368,
     c -65,  29, 207, 496, 186, 263, 497, 178, 529, 340, 494, 363,
     c -67,  22, 204, 495, 184, 262, 494, 177, 527, 335, 491, 358,
     c -67,  18, 203, 491, 181, 265, 493, 179, 525, 318, 489, 353,
     c -67,  15, 199, 487, 176, 263, 492, 183, 525, 311, 489, 352,
     c -62,  15, 194, 485, 174, 265, 495, 187, 527, 338, 493, 352,
     c -57,  19, 198, 488, 176, 270, 500, 192, 530, 378, 497, 356,
     c -47,  24, 209, 490, 184, 268, 507, 199, 534, 385, 502, 361,
     c -39,  29, 223, 491, 193, 276, 517, 207, 539, 365, 508, 368,
     c -32,  34, 232, 491, 195, 280, 525, 212, 544, 344, 512, 375,
     c -21,  43, 234, 492, 198, 281, 531, 218, 548, 333, 515, 379,
     c -12,  52, 238, 497, 206, 286, 537, 224, 550, 328, 517, 380,
     c -11,  57, 240, 503, 213, 288, 538, 224, 551, 351, 522, 377,
     c -19,  53, 237, 499, 205, 282, 534, 222, 550, 385, 524, 374,
     c -15,  54, 237, 494, 202, 278, 531, 219, 548, 417, 526, 371,
     c -10,  56, 239, 490, 202, 279, 525, 221, 544, 452, 528, 369,
     c -85,  35, 202, 456, 153, 246, 464, 152, 517, 299, 477, 353,
     c -84,  31, 203, 457, 157, 241, 468, 155, 520, 323, 481, 358,
     c -81,  28, 202, 459, 162, 241, 471, 158, 521, 350, 483, 362,
     c -76,  26, 203, 464, 169, 246, 474, 161, 521, 382, 486, 368,
     c -73,  25, 200, 469, 170, 240, 476, 165, 521, 396, 488, 371,
     c -70,  26, 199, 474, 172, 246, 479, 169, 520, 368, 490, 373,
     c -68,  31, 204, 483, 180, 248, 483, 171, 521, 338, 492, 373,
     c -66,  37, 207, 488, 185, 256, 485, 172, 523, 342, 492, 372,
     c -67,  42, 205, 485, 185, 256, 487, 173, 523, 354, 492, 371,
     c -70,  45, 199, 482, 184, 250, 487, 173, 523, 338, 493, 369,
     c -76,  46, 195, 477, 182, 251, 485, 170, 523, 334, 493, 367,
     c -77,  43, 198, 474, 179, 251, 484, 165, 523, 361, 494, 366,
     c -72,  42, 208, 474, 179, 250, 485, 165, 523, 384, 494, 366,
     c -68,  44, 216, 477, 182, 255, 488, 168, 524, 396, 494, 367,
     c -64,  49, 222, 484, 188, 261, 494, 174, 527, 407, 495, 369,
     c -57,  52, 228, 494, 193, 269, 499, 179, 530, 403, 499, 371,
     c -52,  54, 231, 499, 193, 276, 502, 181, 534, 364, 501, 372,
     c -51,  52, 227, 500, 195, 274, 504, 181, 536, 334, 502, 371,
     c -54,  48, 221, 502, 194, 273, 502, 180, 536, 328, 500, 365,
     c -58,  43, 220, 499, 191, 272, 499, 179, 533, 328, 498, 360,
     c -60,  38, 217, 495, 186, 272, 498, 176, 532, 314, 496, 354,
     c -60,  36, 212, 494, 182, 276, 496, 179, 530, 309, 495, 352,
     c -57,  37, 208, 491, 177, 277, 498, 182, 531, 336, 498, 351,
     c -51,  40, 208, 492, 178, 281, 502, 187, 534, 374, 503, 354,
     c -42,  46, 215, 498, 185, 284, 508, 192, 537, 376, 508, 358,
     c -37,  52, 228, 502, 191, 291, 515, 200, 541, 351, 512, 365,
     c -32,  58, 238, 498, 193, 285, 522, 205, 545, 327, 516, 370,
     c -19,  65, 240, 497, 197, 285, 530, 211, 548, 314, 518, 374,
     c -11,  70, 247, 500, 201, 288, 535, 214, 549, 305, 520, 375,
     c -13,  72, 252, 501, 205, 284, 535, 215, 548, 316, 521, 373,
     c -19,  64, 248, 497, 199, 278, 533, 214, 548, 340, 524, 371,
     c -15,  65, 249, 496, 200, 273, 530, 212, 544, 366, 525, 368,
     c -11,  66, 251, 495, 198, 268, 525, 214, 540, 394, 524, 366,
     c-112,   4, 164, 426, 120, 216, 433, 116, 485, 203, 443, 318,
     c-107,   5, 170, 431, 125, 216, 437, 124, 489, 241, 449, 325,
     c-102,   5, 174, 435, 132, 222, 443, 131, 492, 277, 454, 330,
     c -96,  10, 182, 441, 142, 225, 449, 138, 494, 322, 459, 337,
     c -93,  13, 183, 446, 143, 222, 456, 140, 497, 346, 463, 342,
     c -88,  17, 184, 451, 145, 225, 461, 146, 501, 325, 467, 346,
     c -83,  23, 188, 458, 152, 229, 467, 149, 504, 295, 469, 348,
     c -78,  31, 192, 465, 159, 237, 471, 152, 506, 301, 472, 349,
     c -76,  37, 193, 469, 164, 243, 473, 152, 508, 318, 473, 350,
     c -79,  40, 187, 466, 164, 240, 475, 153, 511, 312, 475, 349,
     c -85,  42, 185, 460, 164, 240, 476, 152, 512, 327, 479, 351,
     c -84,  44, 189, 460, 164, 237, 475, 151, 513, 369, 482, 352,
     c -78,  46, 200, 464, 168, 240, 479, 156, 515, 386, 485, 355,
     c -72,  51, 210, 472, 176, 248, 486, 162, 519, 376, 488, 360,
     c -63,  58, 219, 482, 185, 256, 495, 172, 526, 370, 493, 365,
     c -52,  64, 226, 490, 191, 261, 503, 179, 533, 358, 499, 370,
     c -44,  70, 237, 500, 196, 275, 509, 184, 539, 325, 505, 373,
     c -43,  72, 241, 505, 200, 283, 511, 184, 543, 300, 509, 373,
     c -44,  70, 233, 504, 199, 278, 511, 182, 543, 306, 508, 369,
     c -48,  64, 232, 501, 195, 283, 506, 178, 541, 319, 505, 363,
     c -50,  60, 235, 498, 190, 276, 504, 177, 538, 319, 504, 357,
     c -52,  58, 231, 499, 185, 271, 503, 179, 536, 320, 502, 353,
     c -50,  59, 223, 498, 179, 271, 504, 180, 537, 351, 504, 352,
     c -42,  65, 222, 498, 180, 270, 508, 184, 539, 385, 509, 353,
     c -34,  72, 228, 503, 186, 275, 513, 191, 542, 385, 513, 357,
     c -31,  78, 237, 507, 190, 291, 518, 198, 546, 356, 516, 362,
     c -28,  84, 244, 506, 191, 289, 525, 203, 549, 330, 520, 367,
     c -18,  88, 247, 505, 194, 291, 529, 206, 551, 311, 521, 370,
     c -12,  91, 256, 507, 199, 301, 533, 210, 551, 297, 522, 371,
     c -14,  87, 257, 502, 199, 288, 533, 209, 550, 298, 522, 369,
     c -19,  78, 251, 497, 192, 280, 532, 208, 548, 312, 522, 367,
     c -16,  76, 251, 499, 193, 276, 528, 206, 545, 329, 521, 364,
     c -12,  76, 253, 501, 193, 274, 525, 211, 541, 351, 521, 362,
     c-132, -24, 128, 395,  89, 183, 409,  89, 456, 144, 412, 284,
     c-127, -21, 137, 400,  96, 184, 414,  96, 462, 190, 419, 292,
     c-121, -16, 145, 407, 103, 188, 421, 106, 466, 231, 426, 298,
     c-114,  -8, 158, 416, 110, 198, 430, 113, 471, 277, 433, 306,
     c-108,   0, 165, 424, 116, 201, 439, 119, 477, 304, 439, 313,
     c-102,   4, 165, 428, 119, 202, 447, 125, 481, 286, 444, 318,
     c -94,  10, 170, 436, 125, 210, 453, 129, 485, 259, 448, 322,
     c -87,  16, 175, 446, 133, 218, 459, 131, 490, 261, 451, 324,
     c -86,  22, 177, 450, 138, 225, 463, 134, 493, 280, 455, 327,
     c -87,  28, 175, 450, 141, 225, 466, 135, 496, 277, 459, 329,
     c -90,  33, 180, 451, 147, 233, 467, 136, 500, 302, 465, 333,
     c -86,  39, 188, 455, 152, 233, 472, 141, 504, 349, 470, 338,
     c -78,  46, 198, 462, 161, 232, 478, 147, 509, 365, 476, 344,
     c -70,  54, 206, 470, 172, 244, 485, 156, 516, 344, 483, 351,
     c -63,  63, 214, 479, 181, 249, 496, 169, 524, 329, 491, 359,
     c -48,  73, 227, 490, 191, 261, 507, 180, 533, 319, 500, 366,
     c -39,  80, 239, 500, 199, 273, 514, 188, 542, 296, 508, 372,
     c -35,  84, 242, 506, 202, 277, 518, 188, 547, 283, 512, 373,
     c -36,  83, 237, 504, 200, 272, 517, 185, 548, 300, 513, 370,
     c -37,  78, 236, 502, 194, 281, 513, 181, 545, 322, 511, 364,
     c -40,  73, 241, 499, 190, 275, 510, 178, 542, 332, 507, 358,
     c -42,  71, 240, 501, 187, 270, 509, 180, 540, 343, 506, 354,
     c -39,  74, 232, 500, 182, 270, 513, 183, 541, 376, 508, 352,
     c -33,  79, 230, 504, 181, 269, 517, 188, 544, 399, 513, 353,
     c -26,  87, 238, 510, 187, 271, 522, 193, 548, 395, 516, 356,
     c -23,  94, 243, 511, 190, 282, 527, 199, 550, 365, 521, 361,
     c -20,  99, 247, 510, 189, 284, 529, 202, 553, 338, 524, 365,
     c -12, 102, 253, 511, 190, 291, 531, 205, 554, 312, 526, 367,
     c -10, 101, 259, 511, 194, 299, 531, 204, 553, 297, 524, 367,
     c -13,  96, 254, 503, 193, 283, 532, 202, 551, 295, 522, 365,
     c -17,  85, 245, 495, 189, 270, 529, 201, 549, 300, 519, 363,
     c -13,  83, 245, 499, 191, 269, 527, 201, 545, 311, 518, 360,
     c  -9,  82, 247, 500, 189, 265, 526, 204, 541, 326, 517, 358,
     c-154, -56, 102, 363,  56, 145, 386,  60, 432, 125, 384, 251,
     c-149, -49, 112, 370,  63, 152, 393,  69, 438, 169, 392, 260,
     c-143, -42, 123, 377,  71, 160, 401,  76, 445, 208, 401, 267,
     c-133, -30, 139, 392,  79, 174, 412,  87, 451, 250, 409, 276,
     c-126, -23, 144, 399,  86, 175, 422,  94, 458, 270, 417, 284,
     c-119, -17, 147, 407,  93, 174, 428, 102, 464, 248, 423, 291,
     c-111, -13, 150, 416, 100, 184, 437, 104, 469, 225, 428, 295,
     c-104,  -8, 154, 428, 109, 202, 443, 110, 473, 227, 432, 299,
     c-104,  -1, 157, 434, 114, 212, 448, 112, 477, 240, 437, 304,
     c-103,   6, 161, 436, 120, 217, 453, 118, 483, 242, 444, 309,
     c -98,  16, 172, 442, 130, 230, 458, 122, 489, 271, 452, 316,
     c -88,  26, 182, 452, 139, 241, 465, 130, 494, 317, 460, 324,
     c -78,  37, 191, 459, 149, 241, 473, 141, 502, 336, 468, 332,
     c -69,  47, 197, 466, 161, 249, 484, 151, 510, 315, 477, 342,
     c -60,  56, 207, 475, 173, 249, 495, 163, 521, 299, 487, 351,
     c -45,  66, 221, 487, 185, 257, 509, 175, 531, 296, 497, 360,
     c -34,  76, 232, 496, 195, 266, 518, 185, 539, 283, 505, 366,
     c -31,  81, 233, 500, 197, 267, 522, 190, 544, 275, 511, 368,
     c -30,  80, 230, 499, 195, 263, 520, 185, 545, 293, 512, 365,
     c -31,  75, 231, 496, 187, 267, 515, 179, 543, 317, 510, 359,
     c -34,  70, 233, 494, 181, 267, 513, 175, 541, 333, 507, 355,
     c -37,  69, 232, 495, 178, 266, 512, 178, 539, 351, 505, 351,
     c -33,  72, 229, 496, 179, 263, 518, 183, 542, 381, 508, 349,
     c -27,  79, 229, 503, 181, 268, 524, 190, 545, 402, 512, 350,
     c -19,  87, 236, 512, 186, 274, 531, 195, 550, 390, 518, 354,
     c -14,  94, 241, 515, 189, 278, 534, 200, 553, 362, 523, 358,
     c  -9,  99, 248, 514, 188, 279, 536, 201, 555, 335, 527, 362,
     c  -5, 102, 256, 515, 189, 282, 535, 203, 555, 317, 527, 363,
     c  -5, 101, 258, 513, 188, 286, 534, 204, 553, 301, 524, 363,
     c  -9,  94, 251, 503, 187, 280, 532, 200, 551, 300, 520, 360,
     c -13,  84, 241, 498, 184, 268, 530, 198, 547, 301, 515, 358,
     c  -8,  81, 241, 500, 185, 269, 528, 195, 544, 308, 512, 354,
     c  -4,  79, 242, 500, 184, 262, 526, 199, 539, 320, 511, 353,
     c-181, -86,  82, 335,  22, 112, 366,  32, 412, 117, 360, 220,
     c-174, -78,  95, 346,  30, 121, 373,  39, 420, 157, 369, 230,
     c-166, -68, 108, 356,  38, 131, 381,  47, 427, 192, 378, 238,
     c-155, -56, 122, 370,  50, 148, 393,  61, 435, 222, 388, 248,
     c-148, -47, 126, 378,  59, 153, 401,  69, 442, 235, 397, 256,
     c-141, -42, 129, 386,  68, 152, 410,  78, 448, 216, 403, 264,
     c-134, -38, 130, 397,  78, 167, 417,  80, 453, 199, 409, 270,
     c-129, -33, 131, 407,  85, 178, 423,  88, 458, 202, 416, 275,
     c-125, -26, 137, 415,  92, 188, 429,  90, 463, 214, 422, 281,
     c-119, -15, 149, 425, 104, 200, 435,  95, 469, 216, 430, 288,
     c-108,  -4, 163, 435, 116, 214, 443, 104, 477, 245, 441, 297,
     c -93,   7, 172, 446, 127, 227, 453, 116, 485, 285, 450, 307,
     c -80,  19, 180, 456, 139, 234, 464, 129, 494, 300, 460, 318,
     c -73,  28, 184, 462, 148, 239, 475, 138, 504, 285, 470, 328,
     c -61,  37, 193, 469, 160, 239, 487, 151, 513, 279, 480, 339,
     c -48,  49, 208, 482, 172, 249, 499, 163, 522, 281, 490, 348,
     c -40,  58, 220, 489, 182, 254, 510, 174, 529, 273, 498, 354,
     c -37,  64, 223, 491, 186, 254, 515, 180, 534, 266, 503, 357,
     c -32,  64, 220, 490, 181, 249, 514, 178, 534, 283, 504, 354,
     c -32,  60, 222, 487, 173, 249, 510, 169, 534, 302, 502, 349,
     c -36,  55, 224, 484, 168, 248, 508, 164, 534, 318, 500, 346,
     c -40,  53, 222, 486, 166, 248, 509, 166, 534, 339, 499, 343,
     c -36,  57, 222, 490, 169, 252, 515, 174, 538, 370, 502, 343,
     c -29,  65, 223, 500, 176, 261, 525, 183, 544, 384, 509, 345,
     c -18,  75, 229, 512, 182, 267, 533, 192, 550, 369, 517, 350,
     c  -8,  84, 238, 518, 187, 273, 537, 198, 552, 344, 523, 354,
     c  -3,  89, 246, 520, 189, 278, 539, 200, 554, 324, 527, 358,
     c  -5,  90, 251, 518, 188, 275, 537, 201, 554, 312, 526, 360,
     c  -6,  88, 254, 514, 183, 281, 532, 198, 550, 304, 521, 357,
     c  -6,  82, 249, 503, 179, 269, 528, 196, 546, 303, 513, 353,
     c -11,  73, 241, 498, 178, 262, 526, 192, 543, 305, 508, 350,
     c  -8,  71, 241, 499, 180, 263, 524, 187, 537, 309, 505, 346,
     c  -5,  69, 239, 498, 180, 258, 522, 189, 532, 318, 502, 344,
     c-202,-112,  63, 315,  -8,  80, 346,   6, 393, 120, 339, 193,
     c-193,-101,  76, 328,   0,  92, 352,  14, 402, 155, 350, 203,
     c-183, -92,  87, 339,   9, 100, 362,  24, 411, 182, 360, 212,
     c-174, -78, 105, 354,  25, 118, 373,  37, 419, 202, 370, 222,
     c-168, -69, 110, 361,  37, 127, 382,  47, 427, 208, 378, 231,
     c-159, -63, 113, 370,  47, 130, 389,  53, 434, 194, 386, 239,
     c-154, -59, 114, 379,  57, 141, 395,  58, 439, 182, 393, 245,
     c-153, -54, 115, 386,  64, 151, 401,  64, 443, 185, 399, 251,
     c-146, -45, 124, 397,  72, 159, 408,  67, 448, 194, 408, 258,
     c-136, -36, 138, 411,  85, 179, 415,  75, 456, 197, 417, 266,
     c-122, -25, 155, 423, 100, 196, 425,  84, 464, 220, 429, 278,
     c-104, -14, 163, 432, 113, 213, 435,  96, 474, 251, 439, 289,
     c -91,  -4, 168, 445, 123, 224, 448, 109, 484, 267, 450, 301,
     c -81,   4, 172, 453, 130, 229, 460, 117, 493, 261, 460, 312,
     c -72,  12, 178, 460, 140, 225, 471, 128, 502, 267, 470, 322,
     c -61,  22, 189, 468, 152, 231, 484, 140, 508, 273, 479, 330,
     c -55,  33, 204, 476, 162, 237, 492, 152, 513, 272, 485, 336,
     c -51,  38, 212, 480, 166, 237, 496, 156, 517, 263, 488, 338,
     c -45,  39, 210, 478, 163, 237, 496, 157, 519, 271, 489, 336,
     c -41,  35, 212, 476, 155, 237, 495, 151, 519, 285, 488, 334,
     c -45,  32, 217, 472, 152, 237, 493, 149, 521, 303, 488, 333,
     c -46,  32, 218, 477, 154, 239, 498, 149, 525, 324, 492, 333,
     c -43,  36, 217, 487, 160, 246, 506, 158, 533, 354, 497, 335,
     c -34,  45, 221, 497, 169, 253, 517, 167, 540, 364, 506, 339,
     c -21,  55, 229, 509, 177, 263, 527, 178, 547, 350, 514, 344,
     c -13,  64, 234, 514, 181, 265, 533, 186, 551, 326, 521, 348,
     c  -9,  68, 240, 515, 181, 269, 535, 190, 552, 311, 525, 351,
     c  -9,  69, 245, 514, 182, 268, 533, 191, 549, 303, 523, 352,
     c -13,  67, 250, 509, 178, 267, 527, 186, 544, 299, 517, 349,
     c -16,  63, 247, 497, 172, 258, 522, 183, 539, 298, 507, 343,
     c -15,  55, 240, 491, 167, 247, 518, 179, 533, 295, 501, 338,
     c -12,  54, 238, 490, 167, 251, 515, 174, 529, 299, 496, 335,
     c -11,  52, 234, 486, 168, 242, 511, 173, 524, 309, 495, 332,
     c-218,-123,  50, 301, -36,  54, 327, -14, 375, 123, 323, 170,
     c-209,-114,  60, 315, -26,  65, 334,  -4, 385, 151, 334, 181,
     c-199,-105,  70, 327, -13,  72, 344,   4, 394, 171, 344, 190,
     c-188, -89,  89, 342,   5,  94, 355,  18, 403, 183, 353, 201,
     c-180, -79,  96, 351,  18, 108, 365,  27, 411, 186, 362, 209,
     c-171, -74,  98, 357,  26, 113, 371,  35, 418, 174, 370, 217,
     c-167, -70,  99, 364,  35, 122, 378,  39, 423, 166, 378, 223,
     c-167, -64, 104, 373,  45, 133, 384,  46, 428, 168, 384, 229,
     c-164, -58, 113, 385,  53, 144, 389,  50, 434, 175, 392, 237,
     c-153, -51, 128, 395,  64, 154, 397,  56, 441, 177, 403, 246,
     c-138, -43, 145, 405,  80, 174, 406,  64, 451, 194, 416, 258,
     c-120, -33, 156, 419,  94, 194, 418,  76, 462, 221, 426, 270,
     c-106, -25, 161, 430, 103, 202, 430,  87, 472, 238, 436, 282,
     c -95, -19, 162, 438, 110, 209, 440,  95, 480, 243, 447, 292,
     c -88, -13, 166, 444, 121, 205, 452, 106, 486, 257, 457, 301,
     c -81,  -3, 175, 453, 131, 210, 461, 116, 491, 272, 464, 308,
     c -76,   4, 187, 458, 138, 217, 469, 126, 495, 275, 470, 313,
     c -71,   9, 195, 461, 141, 216, 473, 129, 498, 269, 472, 316,
     c -63,  10, 194, 460, 140, 216, 474, 130, 499, 272, 473, 315,
     c -56,   9, 198, 459, 136, 213, 474, 127, 502, 281, 475, 315,
     c -55,   9, 205, 460, 136, 219, 479, 129, 508, 297, 478, 317,
     c -52,  12, 211, 470, 142, 225, 486, 131, 515, 322, 483, 321,
     c -47,  17, 215, 481, 152, 235, 497, 142, 525, 351, 493, 326,
     c -35,  27, 224, 493, 162, 248, 509, 153, 536, 356, 504, 331,
     c -25,  38, 235, 505, 171, 257, 520, 167, 544, 335, 514, 337,
     c -19,  46, 239, 510, 176, 265, 528, 176, 547, 311, 521, 341,
     c -13,  49, 241, 508, 174, 261, 530, 181, 547, 296, 523, 343,
     c -14,  49, 245, 506, 173, 261, 526, 179, 544, 289, 519, 343,
     c -18,  47, 246, 499, 169, 256, 520, 175, 537, 281, 510, 337,
     c -21,  43, 241, 489, 163, 246, 512, 171, 529, 276, 501, 330,
     c -19,  38, 231, 479, 155, 238, 507, 165, 523, 269, 493, 323,
     c -17,  38, 227, 475, 152, 235, 502, 161, 517, 273, 489, 319,
     c -14,  36, 221, 471, 150, 230, 501, 160, 512, 286, 487, 316,
     c-229,-115,  43, 292, -58,  32, 309, -37, 357, 106, 309, 152,
     c-221,-107,  53, 306, -44,  41, 318, -25, 367, 127, 319, 163,
     c-211, -97,  64, 320, -31,  48, 327, -15, 378, 141, 329, 172,
     c-197, -84,  78, 334, -11,  72, 341,  -1, 387, 150, 338, 183,
     c-187, -74,  85, 341,   0,  86, 350,   6, 396, 152, 347, 191,
     c-180, -69,  88, 347,   6,  95, 357,  14, 403, 148, 355, 199,
     c-176, -67,  90, 352,  14, 105, 363,  20, 409, 147, 362, 205,
     c-175, -64,  94, 363,  24, 116, 368,  28, 414, 150, 369, 211,
     c-174, -61, 101, 372,  31, 123, 375,  34, 420, 156, 378, 219,
     c-164, -56, 113, 380,  41, 130, 384,  42, 429, 161, 389, 228,
     c-152, -51, 130, 389,  55, 149, 393,  51, 439, 177, 401, 240,
     c-136, -46, 143, 403,  70, 165, 405,  60, 449, 198, 412, 252,
     c-121, -40, 151, 414,  80, 175, 415,  67, 459, 214, 422, 263,
     c-111, -35, 152, 421,  90, 184, 425,  73, 466, 224, 433, 272,
     c-104, -29, 156, 429, 102, 184, 433,  80, 471, 238, 441, 280,
     c -97, -23, 163, 437, 110, 193, 441,  90, 474, 256, 449, 286,
     c -94, -17, 173, 442, 116, 201, 445,  97, 476, 259, 453, 290,
     c -91, -14, 176, 441, 118, 195, 448, 100, 478, 251, 457, 292,
     c -83, -13, 175, 440, 117, 192, 451, 103, 481, 251, 459, 293,
     c -72, -10, 180, 442, 118, 196, 455, 105, 486, 259, 464, 296,
     c -65,  -4, 191, 449, 124, 207, 464, 113, 494, 275, 470, 302,
     c -57,   3, 201, 460, 133, 215, 476, 122, 506, 304, 479, 310,
     c -45,  13, 212, 473, 146, 230, 491, 134, 520, 331, 492, 318,
     c -32,  23, 227, 488, 160, 240, 504, 145, 532, 336, 504, 325,
     c -23,  33, 239, 500, 168, 254, 517, 159, 541, 315, 515, 332,
     c -16,  40, 245, 508, 169, 260, 525, 167, 545, 291, 522, 335,
     c -13,  41, 246, 506, 169, 256, 526, 172, 544, 274, 522, 336,
     c -17,  38, 244, 499, 164, 252, 522, 169, 538, 266, 516, 333,
     c -20,  35, 241, 491, 159, 247, 514, 163, 529, 256, 505, 325,
     c -22,  32, 233, 479, 150, 238, 506, 158, 520, 245, 495, 316,
     c -23,  28, 221, 471, 141, 229, 498, 150, 511, 237, 486, 308,
     c -23,  27, 215, 463, 137, 223, 494, 147, 505, 243, 482, 304,
     c -22,  27, 208, 458, 137, 214, 493, 147, 500, 259, 481, 300,
     c-238, -95,  33, 284, -75,  13, 292, -52, 340,  64, 293, 136,
     c-227, -88,  45, 298, -60,  26, 304, -41, 351,  78, 305, 147,
     c-216, -80,  56, 314, -45,  36, 314, -30, 361,  88, 314, 156,
     c-203, -68,  70, 328, -27,  57, 328, -16, 371,  96, 324, 167,
     c-195, -62,  77, 333, -18,  66, 338,  -8, 381, 105, 332, 176,
     c-188, -59,  83, 339, -12,  73, 346,   0, 389, 111, 340, 184,
     c-184, -59,  86, 344,  -4,  84, 352,   4, 396, 118, 347, 190,
     c-182, -58,  89, 351,   4,  94, 359,  13, 402, 124, 354, 196,
     c-177, -56,  95, 358,  14, 104, 367,  21, 410, 135, 364, 204,
     c-169, -55, 105, 367,  24, 109, 375,  32, 419, 145, 375, 213,
     c-158, -52, 118, 376,  35, 126, 385,  39, 430, 164, 387, 224,
     c-144, -48, 131, 388,  50, 144, 396,  49, 440, 182, 399, 236,
     c-131, -43, 142, 401,  65, 157, 406,  55, 449, 194, 409, 246,
     c-120, -39, 146, 410,  76, 170, 413,  62, 455, 200, 419, 254,
     c-111, -35, 148, 418,  84, 171, 419,  64, 458, 210, 427, 261,
     c-104, -30, 154, 425,  91, 180, 424,  70, 459, 221, 433, 265,
     c-106, -27, 158, 424,  95, 184, 427,  71, 460, 220, 439, 268,
     c-104, -25, 158, 423,  96, 177, 428,  74, 462, 207, 443, 271,
     c -96, -23, 158, 424,  97, 179, 433,  77, 465, 203, 447, 274,
     c -84, -15, 166, 430, 101, 182, 442,  88, 473, 210, 454, 280,
     c -73,  -2, 180, 439, 113, 191, 455, 100, 486, 230, 464, 291,
     c -57,  11, 197, 454, 130, 204, 472, 113, 501, 260, 476, 302,
     c -38,  24, 213, 471, 144, 222, 490, 128, 517, 290, 490, 313,
     c -24,  36, 229, 486, 156, 234, 504, 141, 532, 297, 505, 322,
     c -14,  45, 242, 500, 168, 252, 517, 156, 541, 280, 517, 329,
     c  -9,  48, 249, 507, 170, 257, 525, 163, 543, 258, 521, 331,
     c  -7,  46, 248, 506, 164, 255, 526, 165, 540, 242, 519, 330,
     c -13,  40, 243, 499, 159, 254, 519, 162, 534, 234, 513, 325,
     c -18,  35, 236, 487, 153, 242, 510, 155, 522, 226, 501, 315,
     c -23,  29, 227, 474, 142, 234, 501, 149, 511, 212, 488, 303,
     c -27,  25, 215, 462, 130, 220, 493, 142, 502, 207, 480, 295,
     c -27,  24, 208, 456, 128, 215, 489, 138, 495, 215, 476, 289,
     c -28,  23, 200, 449, 124, 208, 488, 137, 490, 239, 474, 286,
     c-241, -81,  23, 274, -83,  -8, 279, -70, 326,  30, 280, 120,
     c-231, -76,  33, 287, -70,   6, 290, -61, 336,  37, 290, 131,
     c-219, -69,  43, 301, -58,  18, 302, -50, 347,  44, 300, 141,
     c-209, -61,  60, 317, -41,  41, 317, -36, 357,  55, 309, 152,
     c-201, -56,  70, 326, -32,  51, 329, -24, 368,  67, 319, 161,
     c-194, -55,  79, 331, -27,  58, 337, -15, 378,  79, 327, 170,
     c-188, -56,  86, 336, -16,  69, 344,  -8, 386,  89, 334, 178,
     c-184, -55,  90, 342,  -7,  77, 352,   3, 394,  96, 342, 184,
     c-176, -53,  96, 352,   2,  92, 362,  12, 403, 107, 352, 192,
     c-166, -51, 104, 359,  13,  97, 371,  22, 413, 123, 364, 201,
     c-157, -49, 114, 367,  25, 108, 382,  30, 423, 147, 376, 212,
     c-146, -45, 124, 377,  38, 122, 393,  39, 433, 166, 386, 223,
     c-134, -41, 133, 390,  53, 134, 402,  44, 441, 175, 396, 232,
     c-121, -37, 139, 401,  64, 149, 408,  49, 446, 176, 406, 239,
     c-114, -34, 140, 406,  69, 161, 412,  50, 448, 180, 415, 245,
     c-110, -30, 143, 410,  72, 164, 413,  50, 449, 185, 421, 248,
     c-110, -28, 146, 410,  74, 169, 415,  51, 449, 181, 427, 251,
     c-107, -25, 146, 411,  77, 165, 416,  54, 451, 164, 432, 255,
     c -98, -19, 150, 417,  82, 165, 421,  61, 456, 155, 439, 261,
     c -87,  -8, 163, 426,  93, 174, 434,  76, 467, 162, 447, 269,
     c -73,   8, 181, 437, 107, 183, 452,  92, 481, 185, 459, 283,
     c -54,  26, 202, 454, 126, 203, 471, 110, 499, 214, 475, 297,
     c -34,  42, 221, 473, 143, 227, 489, 127, 517, 243, 491, 310,
     c -16,  54, 237, 490, 158, 242, 505, 142, 532, 255, 506, 320,
     c  -7,  61, 247, 501, 167, 258, 517, 154, 541, 248, 516, 327,
     c  -3,  61, 249, 506, 168, 258, 522, 159, 543, 234, 521, 329,
     c  -2,  55, 247, 504, 160, 256, 522, 157, 538, 222, 518, 326,
     c  -5,  45, 239, 496, 154, 249, 516, 152, 529, 215, 509, 318,
     c -14,  35, 228, 481, 144, 229, 504, 144, 516, 206, 498, 306,
     c -26,  28, 218, 465, 132, 220, 494, 139, 505, 193, 484, 293,
     c -30,  22, 208, 454, 120, 210, 486, 128, 494, 187, 476, 283,
     c -30,  22, 202, 447, 117, 201, 483, 125, 487, 200, 471, 277,
     c -31,  22, 195, 440, 112, 201, 482, 122, 483, 231, 471, 275,
     c-243, -82,  14, 264, -88, -15, 267, -83, 315,  19, 270, 105,
     c-235, -78,  23, 274, -80,  -4, 278, -77, 326,  21, 280, 115,
     c-224, -74,  32, 285, -70,   2, 291, -67, 336,  26, 290, 125,
     c-213, -68,  50, 302, -54,  24, 307, -54, 347,  38, 299, 137,
     c-204, -64,  62, 314, -43,  36, 319, -40, 358,  50, 309, 148,
     c-196, -64,  73, 321, -36,  41, 329, -30, 369,  60, 318, 158,
     c-191, -63,  84, 330, -23,  57, 338, -21, 379,  65, 327, 166,
     c-182, -60,  93, 341, -11,  72, 348, -10, 388,  68, 335, 174,
     c-174, -55,  99, 350,  -1,  86, 358,   2, 399,  77, 345, 183,
     c-162, -51, 105, 357,   9,  93, 370,  14, 409,  99, 358, 193,
     c-154, -46, 113, 364,  19, 101, 380,  24, 420, 128, 369, 204,
     c-146, -42, 120, 374,  29, 118, 390,  34, 430, 153, 379, 214,
     c-133, -36, 128, 386,  41, 132, 398,  41, 438, 161, 388, 222,
     c-122, -31, 133, 393,  51, 143, 404,  44, 443, 159, 397, 229,
     c-117, -29, 135, 398,  53, 146, 406,  45, 444, 159, 405, 234,
     c-115, -26, 140, 402,  56, 149, 407,  44, 444, 162, 412, 237,
     c-112, -23, 145, 402,  59, 152, 409,  44, 445, 156, 417, 240,
     c-107, -20, 147, 405,  64, 154, 411,  48, 448, 142, 424, 245,
     c -98, -13, 151, 414,  73, 162, 419,  54, 454, 133, 433, 252,
     c -85,   0, 167, 425,  86, 176, 434,  69, 466, 140, 444, 263,
     c -68,  18, 188, 438, 103, 185, 452,  87, 483, 159, 458, 278,
     c -46,  39, 208, 458, 120, 205, 473, 107, 501, 187, 473, 295,
     c -28,  55, 227, 476, 139, 227, 491, 125, 519, 214, 491, 308,
     c -11,  67, 243, 492, 156, 243, 507, 141, 534, 229, 505, 319,
     c  -3,  70, 249, 500, 164, 257, 515, 150, 541, 230, 515, 325,
     c   0,  67, 248, 505, 164, 255, 518, 153, 542, 224, 518, 326,
     c  -1,  56, 242, 500, 159, 248, 515, 148, 536, 215, 515, 321,
     c  -4,  44, 230, 491, 147, 238, 508, 144, 525, 207, 506, 311,
     c -12,  34, 216, 475, 133, 216, 497, 132, 513, 195, 494, 299,
     c -25,  24, 204, 460, 121, 209, 486, 125, 500, 180, 482, 285,
     c -32,  19, 197, 447, 112, 193, 479, 114, 490, 175, 473, 275,
     c -33,  18, 196, 442, 108, 188, 475, 111, 482, 190, 469, 269,
     c -37,  17, 193, 435, 104, 183, 476, 109, 478, 227, 469, 266,
     c-250, -91,   6, 253, -88, -26, 258, -99, 311,  20, 266,  92,
     c-241, -89,  17, 262, -80, -16, 268, -96, 320,  21, 275, 101,
     c-231, -86,  28, 273, -71,  -7, 279, -83, 330,  24, 284, 111,
     c-217, -80,  42, 288, -59,   6, 296, -70, 341,  34, 294, 124,
     c-207, -77,  54, 301, -49,  22, 310, -53, 353,  44, 305, 135,
     c-199, -77,  67, 311, -39,  28, 321, -44, 364,  49, 314, 147,
     c-191, -75,  80, 324, -27,  44, 330, -34, 375,  48, 324, 157,
     c-180, -68,  92, 337, -14,  62, 340, -23, 386,  47, 334, 167,
     c-170, -61, 100, 349,  -2,  79, 352,  -9, 397,  55, 345, 178,
     c-158, -53, 106, 358,   8,  91, 365,   5, 409,  82, 356, 188,
     c-150, -44, 114, 367,  16,  98, 376,  16, 420, 116, 368, 199,
     c-141, -36, 121, 377,  25, 114, 388,  27, 430, 144, 378, 209,
     c-131, -29, 128, 387,  34, 125, 397,  34, 438, 153, 387, 218,
     c-123, -24, 133, 390,  40, 130, 403,  39, 443, 150, 395, 224,
     c-120, -20, 139, 394,  44, 137, 407,  40, 446, 149, 402, 230,
     c-119, -17, 145, 398,  46, 142, 409,  39, 447, 151, 408, 233,
     c-116, -14, 152, 402,  53, 151, 410,  42, 448, 149, 415, 237,
     c-108,  -9, 155, 406,  61, 154, 415,  46, 452, 138, 422, 243,
     c -96,  -2, 158, 412,  69, 159, 424,  52, 460, 132, 432, 251,
     c -79,  10, 172, 425,  83, 174, 438,  66, 472, 138, 444, 264,
     c -59,  28, 193, 442, 103, 187, 456,  87, 489, 150, 459, 279,
     c -38,  48, 215, 463, 122, 204, 476, 108, 507, 173, 475, 296,
     c -18,  63, 233, 481, 139, 223, 495, 126, 525, 195, 490, 309,
     c  -5,  72, 246, 492, 155, 233, 505, 140, 537, 213, 504, 319,
     c   0,  74, 250, 500, 164, 244, 513, 147, 543, 221, 512, 324,
     c   2,  68, 244, 502, 164, 247, 514, 146, 542, 223, 514, 323,
     c   2,  57, 236, 499, 157, 241, 509, 140, 535, 212, 511, 317,
     c  -3,  44, 221, 488, 142, 234, 500, 135, 524, 200, 503, 307,
     c -14,  32, 203, 472, 126, 212, 490, 124, 510, 184, 491, 294,
     c -28,  23, 191, 458, 113, 202, 479, 115, 498, 167, 479, 281,
     c -34,  19, 191, 448, 103, 193, 472, 105, 487, 160, 471, 271,
     c -37,  18, 192, 444, 101, 186, 469, 103, 481, 177, 468, 265,
     c -39,  17, 192, 439, 101, 182, 472,  98, 477, 216, 469, 262,
     c-254,-103,  -3, 241, -92, -37, 251,-111, 311,  25, 267,  83,
     c-244,-101,   6, 252, -85, -27, 261,-106, 320,  23, 276,  92,
     c-233, -97,  18, 263, -74, -19, 272, -94, 329,  27, 285, 102,
     c-219, -93,  34, 280, -63,  -2, 287, -82, 340,  34, 294, 114,
     c-208, -90,  49, 293, -52,  13, 300, -67, 351,  41, 305, 126,
     c-200, -88,  64, 304, -41,  21, 312, -56, 362,  42, 316, 139,
     c-192, -84,  77, 317, -29,  38, 323, -44, 374,  37, 327, 151,
     c-178, -75,  92, 333, -15,  56, 335, -34, 385,  36, 337, 162,
     c-164, -64, 102, 349,  -3,  71, 347, -19, 398,  48, 350, 174,
     c-153, -51, 110, 362,   7,  92, 361,  -4, 411,  79, 362, 186,
     c-145, -40, 118, 372,  14,  96, 375,  11, 423, 116, 374, 198,
     c-134, -28, 128, 382,  24, 112, 388,  25, 434, 144, 384, 209,
     c-124, -19, 136, 390,  31, 122, 398,  34, 443, 151, 391, 218,
     c-115, -12, 142, 394,  37, 124, 407,  42, 449, 146, 400, 225,
     c-113,  -6, 148, 397,  42, 133, 411,  45, 453, 143, 407, 231,
     c-113,  -2, 156, 401,  49, 138, 414,  47, 455, 147, 413, 236,
     c-110,   0, 162, 406,  57, 148, 417,  49, 457, 151, 420, 242,
     c-100,   6, 167, 410,  65, 157, 422,  55, 461, 144, 427, 248,
     c -87,  13, 170, 418,  75, 162, 433,  60, 470, 141, 437, 257,
     c -69,  24, 182, 432,  89, 176, 447,  74, 483, 144, 449, 270,
     c -47,  39, 201, 449, 109, 194, 465,  91, 498, 151, 463, 286,
     c -25,  57, 222, 470, 129, 209, 484, 112, 515, 165, 478, 301,
     c  -8,  70, 238, 486, 144, 226, 499, 128, 529, 186, 491, 313,
     c   2,  76, 249, 497, 157, 233, 508, 139, 540, 205, 502, 321,
     c   5,  76, 251, 502, 164, 239, 511, 143, 544, 216, 508, 324,
     c   3,  69, 240, 500, 163, 237, 510, 142, 541, 218, 508, 322,
     c   2,  58, 227, 495, 152, 231, 505, 134, 533, 206, 505, 315,
     c  -2,  48, 214, 485, 140, 225, 496, 126, 522, 190, 497, 304,
     c -13,  38, 198, 472, 124, 207, 486, 114, 509, 173, 487, 291,
     c -26,  31, 187, 461, 111, 202, 476, 106, 497, 154, 476, 278,
     c -32,  25, 190, 451, 101, 195, 470,  97, 487, 147, 470, 269,
     c -34,  24, 190, 448,  98, 186, 467,  96, 480, 163, 466, 263,
     c -36,  22, 190, 445,  98, 185, 468,  92, 477, 201, 468, 260,
     c-247,-113,  -7, 241, -95, -32, 253,-118, 317,  29, 277,  82,
     c-238,-110,   1, 252, -86, -26, 263,-109, 324,  28, 285,  90,
     c-230,-108,  10, 261, -77, -20, 273, -96, 332,  32, 293,  99,
     c-214,-102,  29, 278, -63,  -5, 288, -83, 342,  39, 302, 111,
     c-202, -98,  46, 291, -52,  12, 299, -69, 353,  43, 312, 122,
     c-194, -95,  61, 300, -42,  17, 310, -62, 365,  41, 323, 135,
     c-185, -88,  77, 314, -28,  32, 320, -48, 376,  35, 334, 148,
     c-172, -77,  91, 330, -16,  51, 332, -37, 389,  35, 346, 160,
     c-157, -61, 101, 346,  -5,  65, 347, -22, 401,  49, 358, 174,
     c-145, -45, 111, 361,   8,  83, 363,  -6, 415,  81, 372, 187,
     c-135, -29, 123, 377,  19,  96, 378,   7, 427, 118, 383, 200,
     c-124, -15, 134, 391,  27, 119, 392,  23, 439, 143, 393, 212,
     c-111,  -4, 142, 397,  33, 130, 404,  33, 448, 146, 402, 222,
     c-100,   4, 150, 401,  42, 134, 413,  44, 456, 141, 410, 231,
     c -95,  11, 157, 406,  51, 139, 420,  50, 462, 141, 417, 238,
     c -97,  16, 163, 411,  60, 144, 425,  53, 467, 150, 424, 244,
     c -93,  22, 171, 414,  65, 148, 430,  56, 471, 160, 430, 251,
     c -82,  28, 178, 422,  73, 164, 437,  62, 477, 159, 438, 259,
     c -71,  33, 182, 431,  86, 174, 446,  72, 485, 157, 448, 268,
     c -54,  42, 194, 446, 105, 188, 459,  85, 497, 156, 459, 280,
     c -35,  54, 212, 461, 121, 206, 476, 101, 509, 157, 472, 294,
     c -15,  68, 228, 479, 135, 219, 491, 118, 522, 166, 484, 307,
     c  -1,  77, 241, 494, 149, 228, 503, 128, 535, 184, 495, 317,
     c   7,  82, 252, 503, 159, 238, 508, 137, 541, 202, 502, 322,
     c   8,  81, 251, 504, 158, 238, 510, 136, 543, 215, 505, 324,
     c   2,  74, 238, 499, 155, 233, 507, 134, 540, 216, 505, 320,
     c   0,  66, 225, 492, 146, 226, 500, 128, 531, 202, 500, 312,
     c  -3,  59, 213, 483, 133, 215, 493, 121, 520, 186, 492, 300,
     c -12,  51, 200, 472, 118, 202, 484, 111, 507, 172, 482, 287,
     c -21,  43, 191, 460, 108, 196, 476, 103, 496, 157, 473, 275,
     c -25,  38, 190, 453, 102, 189, 470,  95, 487, 150, 467, 266,
     c -27,  36, 191, 450,  99, 186, 467,  96, 481, 164, 465, 261,
     c -28,  33, 192, 447,  97, 181, 469,  93, 479, 196, 467, 258,
     c-232,-116,  -1, 252, -93, -23, 266,-106, 326,  30, 293,  87,
     c-223,-113,   7, 264, -81, -21, 272, -98, 333,  32, 300,  94,
     c-214,-110,  16, 272, -70, -13, 283, -87, 340,  35, 307, 103,
     c-202,-104,  31, 285, -59,   0, 294, -78, 348,  41, 314, 113,
     c-190, -97,  45, 296, -48,  14, 304, -66, 357,  42, 323, 123,
     c-182, -91,  60, 304, -37,  23, 314, -58, 368,  38, 332, 135,
     c-172, -82,  76, 316, -25,  31, 324, -45, 380,  31, 344, 147,
     c-159, -69,  89, 332, -14,  48, 336, -36, 393,  33, 357, 160,
     c-146, -53, 100, 348,  -2,  66, 352, -20, 407,  50, 370, 175,
     c-133, -34, 113, 367,  13,  88, 369,  -3, 420,  81, 383, 189,
     c-122, -17, 126, 386,  28, 100, 386,  10, 433, 115, 396, 204,
     c-112,  -1, 138, 400,  37, 119, 399,  27, 444, 135, 406, 216,
     c -97,  11, 147, 407,  44, 131, 412,  38, 454, 138, 415, 227,
     c -83,  22, 157, 412,  55, 140, 423,  50, 465, 135, 423, 238,
     c -75,  30, 163, 419,  65, 154, 433,  59, 473, 140, 431, 247,
     c -73,  38, 169, 426,  72, 164, 440,  64, 480, 156, 438, 255,
     c -69,  44, 179, 432,  78, 172, 448,  70, 487, 171, 445, 263,
     c -58,  50, 188, 441,  87, 184, 454,  76, 493, 177, 453, 271,
     c -47,  56, 195, 452, 100, 194, 464,  83, 501, 176, 463, 281,
     c -35,  63, 207, 462, 117, 202, 476,  93, 511, 171, 474, 291,
     c -22,  70, 219, 473, 129, 212, 488, 106, 521, 167, 484, 303,
     c  -6,  79, 232, 488, 140, 223, 500, 119, 531, 171, 494, 313,
     c   3,  86, 243, 501, 149, 230, 507, 127, 539, 184, 500, 319,
     c   8,  88, 251, 506, 152, 236, 509, 133, 543, 200, 505, 323,
     c   6,  87, 248, 502, 149, 231, 508, 130, 542, 207, 506, 322,
     c   0,  83, 238, 494, 143, 225, 503, 128, 537, 202, 503, 317,
     c  -5,  78, 227, 487, 136, 220, 498, 121, 529, 186, 497, 307,
     c  -7,  72, 217, 477, 124, 208, 491, 114, 518, 176, 489, 295,
     c -12,  65, 207, 467, 110, 196, 482, 106, 506, 168, 479, 282,
     c -18,  58, 198, 456,  99, 189, 473,  98, 495, 160, 471, 270,
     c -21,  51, 194, 449,  94, 183, 469,  90, 487, 158, 465, 262,
     c -23,  48, 194, 446,  92, 180, 467,  90, 481, 169, 464, 257,
     c -25,  46, 195, 444,  91, 177, 468,  87, 479, 193, 467, 256,
     c-214,-105,  17, 281, -79,  -2, 284, -92, 340,  26, 313,  97,
     c-207,-102,  24, 287, -69,  -2, 290, -85, 344,  30, 320, 103,
     c-199,-100,  31, 295, -58,   3, 298, -76, 350,  34, 325, 111,
     c-188, -93,  40, 301, -49,  14, 307, -65, 357,  39, 331, 119,
     c-178, -86,  50, 309, -42,  21, 315, -55, 365,  38, 336, 128,
     c-169, -78,  63, 315, -33,  31, 324, -49, 375,  32, 345, 139,
     c-158, -68,  77, 324, -20,  34, 334, -38, 387,  24, 355, 150,
     c-145, -56,  91, 339,  -8,  50, 346, -30, 400,  27, 368, 163,
     c-132, -40, 106, 358,   6,  74, 361, -15, 413,  46, 382, 178,
     c-120, -24, 119, 378,  22,  94, 378,   1, 427,  78, 396, 192,
     c-110,  -6, 132, 394,  37, 107, 394,  15, 439, 106, 409, 207,
     c -98,   9, 145, 408,  48, 123, 410,  31, 450, 125, 419, 220,
     c -82,  24, 155, 417,  59, 137, 423,  42, 462, 129, 428, 233,
     c -66,  37, 164, 425,  71, 146, 436,  56, 473, 130, 437, 245,
     c -57,  48, 171, 432,  79, 165, 447,  66, 483, 140, 445, 256,
     c -51,  57, 178, 441,  85, 179, 457,  75, 493, 163, 453, 265,
     c -44,  65, 189, 451,  92, 187, 465,  84, 501, 184, 461, 274,
     c -31,  71, 200, 461, 101, 199, 474,  90, 509, 193, 469, 283,
     c -21,  77, 209, 469, 113, 208, 483,  98, 517, 191, 479, 292,
     c -15,  82, 219, 478, 126, 212, 492, 105, 525, 185, 488, 299,
     c  -7,  87, 228, 485, 138, 223, 500, 112, 532, 176, 497, 309,
     c   0,  93, 236, 495, 145, 229, 505, 121, 539, 172, 504, 316,
     c   6,  96, 241, 504, 148, 234, 510, 127, 544, 178, 508, 319,
     c   9,  97, 246, 505, 149, 237, 511, 130, 544, 187, 509, 320,
     c   9,  95, 244, 499, 146, 231, 508, 126, 542, 184, 507, 317,
     c   3,  93, 235, 493, 138, 222, 504, 122, 535, 171, 503, 311,
     c  -2,  89, 227, 485, 130, 215, 497, 115, 527, 156, 496, 301,
     c  -6,  83, 220, 474, 121, 201, 488, 109, 516, 150, 488, 289,
     c -10,  75, 210, 464, 106, 192, 480, 100, 504, 153, 478, 276,
     c -15,  66, 201, 458,  93, 189, 470,  90, 494, 154, 469, 265,
     c -17,  60, 198, 450,  87, 174, 466,  82, 485, 155, 465, 258,
     c -21,  56, 196, 447,  85, 168, 464,  84, 481, 163, 465, 254,
     c -24,  53, 195, 447,  84, 165, 465,  84, 480, 177, 467, 253,
     c-195, -80,  42, 314, -61,  26, 308, -72, 355,  13, 335, 110,
     c-188, -78,  47, 319, -52,  25, 312, -66, 360,  22, 341, 116,
     c-183, -77,  51, 323, -46,  28, 317, -59, 364,  27, 346, 122,
     c-174, -71,  56, 322, -37,  31, 323, -50, 368,  30, 349, 129,
     c-165, -64,  62, 322, -32,  30, 329, -43, 375,  26, 353, 136,
     c-158, -59,  72, 327, -25,  42, 336, -36, 384,  23, 359, 146,
     c-148, -51,  85, 336, -13,  47, 344, -28, 395,  19, 368, 156,
     c-134, -41,  98, 348,   0,  63, 357, -20, 407,  25, 380, 168,
     c-122, -31, 112, 365,  12,  84, 372,  -9, 420,  44, 393, 182,
     c-111, -19, 124, 382,  24, 101, 386,   2, 432,  72, 407, 196,
     c-100,  -2, 138, 398,  38, 116, 403,  16, 445,  96, 420, 210,
     c -88,  14, 151, 411,  53, 125, 418,  32, 455, 109, 430, 224,
     c -72,  31, 162, 421,  65, 138, 433,  46, 467, 114, 440, 238,
     c -54,  46, 173, 432,  77, 153, 446,  58, 479, 119, 449, 251,
     c -43,  58, 181, 443,  87, 168, 458,  70, 493, 131, 459, 263,
     c -37,  67, 188, 452,  95, 183, 469,  80, 504, 159, 468, 273,
     c -28,  76, 198, 461, 101, 193, 478,  88, 514, 186, 476, 283,
     c -12,  85, 210, 472, 111, 205, 487,  97, 522, 199, 485, 291,
     c  -5,  91, 219, 480, 122, 211, 495, 106, 529, 198, 494, 298,
     c  -1,  95, 227, 486, 133, 220, 502, 110, 536, 191, 502, 304,
     c   4,  99, 235, 494, 142, 230, 507, 116, 540, 178, 508, 311,
     c   8, 102, 237, 500, 147, 232, 511, 123, 545, 170, 511, 315,
     c  10, 102, 234, 502, 148, 229, 514, 129, 546, 170, 513, 316,
     c  15, 102, 237, 504, 149, 230, 513, 129, 545, 173, 512, 315,
     c  19, 101, 239, 501, 145, 228, 510, 126, 539, 160, 509, 311,
     c  11,  98, 229, 494, 135, 224, 503, 119, 532, 140, 503, 304,
     c   1,  92, 221, 483, 126, 210, 496, 111, 523, 126, 496, 294,
     c  -3,  84, 216, 471, 114, 194, 486, 101, 512, 127, 487, 282,
     c  -7,  74, 208, 463,  99, 185, 475,  92, 502, 134, 478, 270,
     c -13,  63, 199, 457,  87, 179, 467,  84, 492, 139, 469, 260,
     c -16,  58, 199, 452,  84, 169, 462,  80, 485, 142, 465, 254,
     c -18,  56, 198, 451,  84, 166, 461,  79, 480, 147, 465, 251,
     c -21,  53, 197, 449,  83, 160, 462,  78, 479, 154, 469, 250,
     c-173, -50,  68, 346, -43,  48, 330, -64, 374,  -4, 358, 125,
     c-167, -50,  70, 349, -37,  45, 335, -60, 376,   8, 363, 130,
     c-163, -49,  72, 349, -32,  45, 339, -53, 379,  14, 367, 135,
     c-156, -46,  74, 344, -26,  51, 343, -44, 383,  15, 370, 141,
     c-152, -42,  77, 339, -23,  46, 347, -38, 388,   9, 372, 146,
     c-144, -39,  85, 341, -17,  58, 351, -29, 394,   7, 376, 154,
     c-134, -34,  95, 348,  -5,  66, 360, -22, 403,   6, 383, 163,
     c-126, -30, 104, 354,   2,  74, 371, -12, 415,  12, 392, 174,
     c-114, -24, 116, 366,  12,  92, 383,  -6, 427,  27, 404, 186,
     c-105, -15, 128, 381,  22, 105, 395,   4, 438,  50, 418, 199,
     c -92,  -1, 142, 397,  35, 117, 409,  15, 449,  66, 430, 213,
     c -81,  15, 155, 411,  50, 130, 424,  31, 460,  77, 440, 226,
     c -66,  33, 167, 423,  63, 142, 439,  44, 472,  83, 449, 240,
     c -48,  49, 181, 436,  77, 156, 453,  59, 485,  92, 459, 254,
     c -35,  61, 190, 451,  90, 175, 465,  70, 499, 108, 469, 267,
     c -29,  71, 196, 461, 101, 190, 474,  79, 512, 141, 479, 277,
     c -22,  78, 204, 468, 107, 201, 483,  90, 522, 174, 487, 287,
     c  -8,  86, 215, 477, 115, 210, 493,  97, 530, 194, 496, 295,
     c   0,  93, 224, 485, 125, 216, 499, 107, 537, 196, 504, 300,
     c   4,  97, 230, 489, 135, 219, 504, 111, 542, 189, 510, 305,
     c   9, 100, 236, 495, 139, 226, 508, 116, 545, 177, 514, 309,
     c  12, 101, 233, 499, 141, 228, 510, 116, 546, 164, 515, 310,
     c  14, 101, 228, 497, 143, 224, 511, 120, 545, 158, 515, 309,
     c  18,  99, 228, 498, 142, 221, 510, 118, 542, 156, 512, 306,
     c  20,  96, 228, 496, 135, 219, 506, 117, 536, 139, 508, 302,
     c  13,  91, 221, 489, 126, 215, 498, 110, 528, 119, 502, 295,
     c   2,  84, 214, 479, 116, 202, 489, 101, 519, 110, 495, 286,
     c  -4,  74, 209, 471, 104, 193, 479,  88, 509, 116, 486, 275,
     c  -8,  63, 202, 461,  92, 183, 470,  81, 499, 125, 477, 265,
     c -12,  53, 194, 452,  83, 174, 463,  75, 491, 130, 470, 256,
     c -15,  49, 195, 450,  80, 168, 459,  73, 484, 130, 466, 250,
     c -16,  47, 197, 447,  80, 164, 458,  74, 481, 133, 467, 248,
     c -17,  46, 199, 447,  80, 164, 459,  75, 481, 135, 471, 249,
     c-154, -25,  89, 368, -27,  62, 353, -51, 392, -13, 379, 140,
     c-149, -24,  90, 368, -21,  60, 356, -46, 395,   1, 385, 144,
     c-143, -24,  92, 367, -15,  60, 359, -41, 398,   9, 388, 148,
     c-138, -22,  93, 364, -11,  70, 362, -32, 399,   5, 390, 153,
     c-135, -22,  93, 359, -11,  64, 365, -28, 402,  -2, 390, 157,
     c-129, -21,  98, 356,  -8,  70, 370, -21, 407,  -6, 392, 163,
     c-122, -19, 105, 358,  -1,  77, 376, -16, 414,  -8, 397, 171,
     c-116, -18, 112, 361,   4,  82, 385,  -8, 423,  -5, 404, 179,
     c-107, -14, 123, 370,  13,  96, 393,  -3, 433,   3, 415, 190,
     c -95,  -8, 136, 384,  23, 106, 404,   5, 443,  20, 426, 201,
     c -85,   3, 147, 399,  33, 118, 415,  13, 453,  31, 438, 214,
     c -74,  19, 161, 413,  47, 131, 427,  28, 463,  39, 448, 227,
     c -60,  35, 173, 428,  62, 146, 441,  43, 474,  46, 457, 241,
     c -44,  50, 187, 444,  76, 160, 455,  58, 488,  58, 466, 254,
     c -29,  61, 195, 457,  90, 177, 467,  70, 503,  77, 476, 267,
     c -23,  68, 200, 466, 100, 189, 476,  77, 515, 112, 485, 278,
     c -19,  75, 207, 472, 109, 200, 485,  83, 526, 150, 494, 287,
     c -10,  81, 216, 477, 115, 213, 491,  91, 533, 175, 502, 294,
     c   1,  88, 221, 484, 121, 218, 498, 100, 539, 181, 508, 298,
     c   6,  92, 227, 490, 126, 223, 503, 104, 542, 177, 512, 301,
     c   9,  93, 230, 492, 128, 224, 504, 106, 544, 164, 514, 304,
     c  13,  94, 229, 493, 129, 222, 505, 107, 543, 149, 513, 303,
     c  13,  92, 226, 494, 129, 221, 503, 109, 541, 140, 511, 300,
     c  12,  88, 225, 492, 127, 217, 502, 105, 535, 135, 508, 296,
     c   8,  81, 223, 486, 122, 209, 495, 100, 529, 117, 504, 291,
     c   4,  75, 217, 479, 112, 204, 488,  92, 521, 100, 498, 285,
     c  -6,  67, 210, 473, 102, 191, 479,  84, 512, 100, 492, 277,
     c -14,  57, 203, 466,  97, 183, 472,  77, 504, 113, 485, 268,
     c -15,  48, 197, 456,  89, 177, 465,  72, 496, 121, 476, 258,
     c -16,  39, 190, 445,  79, 167, 458,  68, 489, 124, 470, 251,
     c -17,  38, 192, 442,  75, 163, 456,  66, 485, 122, 467, 247,
     c -17,  38, 195, 442,  76, 161, 456,  68, 482, 122, 469, 246,
     c -16,  37, 198, 442,  77, 162, 459,  70, 483, 122, 474, 248,
     c-137,  -6, 107, 381, -15,  77, 373, -44, 411,  -9, 396, 154,
     c-133,  -6, 108, 381, -10,  77, 375, -42, 413,   8, 402, 158,
     c-128,  -6, 108, 380,  -6,  75, 379, -36, 415,  15, 406, 161,
     c-120,  -3, 112, 381,   0,  88, 381, -27, 416,   9, 406, 165,
     c-118,  -2, 110, 376,  -1,  84, 384, -23, 417,   0, 407, 168,
     c-117,  -2, 112, 370,  -2,  86, 386, -20, 420,  -7, 407, 173,
     c-112,  -2, 116, 365,   1,  86, 391, -17, 425, -12, 410, 179,
     c-106,  -1, 124, 368,   8,  92, 397,  -8, 432, -14, 416, 185,
     c -97,  -1, 136, 378,  17, 105, 403,  -2, 439, -10, 424, 194,
     c -86,   1, 146, 389,  26, 108, 411,   5, 447,   3, 434, 204,
     c -77,  10, 157, 402,  35, 122, 419,  13, 456,  10, 445, 215,
     c -66,  23, 168, 416,  47, 134, 430,  27, 466,  16, 453, 227,
     c -53,  37, 180, 431,  63, 148, 443,  39, 478,  23, 462, 240,
     c -38,  49, 191, 446,  75, 165, 454,  53, 491,  35, 471, 252,
     c -23,  58, 199, 458,  88, 177, 465,  65, 504,  50, 481, 264,
     c -17,  65, 204, 466,  98, 185, 475,  75, 515,  81, 489, 274,
     c -14,  70, 209, 472, 107, 196, 482,  81, 525, 120, 497, 282,
     c  -5,  76, 214, 476, 111, 198, 490,  88, 532, 147, 503, 288,
     c   3,  82, 219, 481, 113, 205, 496,  95, 535, 158, 507, 292,
     c   7,  85, 222, 484, 115, 209, 499,  97, 537, 158, 509, 294,
     c   9,  86, 225, 485, 116, 212, 498,  97, 538, 147, 509, 295,
     c   9,  84, 225, 484, 114, 210, 496,  94, 536, 131, 507, 293,
     c   6,  80, 224, 484, 112, 209, 494,  94, 532, 118, 504, 289,
     c   0,  74, 223, 482, 114, 204, 490,  89, 527, 106, 501, 284,
     c  -2,  66, 220, 474, 109, 192, 484,  83, 520,  90, 496, 279,
     c  -4,  58, 214, 470,  99, 191, 478,  75, 513,  82, 492, 274,
     c -11,  50, 206, 467,  92, 184, 471,  70, 506,  89, 487, 267,
     c -19,  42, 199, 459,  92, 177, 465,  65, 499, 105, 481, 259,
     c -18,  34, 193, 452,  87, 172, 460,  62, 493, 115, 475, 251,
     c -16,  29, 190, 446,  82, 170, 455,  60, 489, 118, 470, 246,
     c -15,  28, 194, 442,  80, 162, 454,  58, 487, 114, 469, 243,
     c -14,  29, 198, 443,  81, 167, 455,  63, 486, 114, 470, 244,
     c -12,  30, 201, 444,  83, 167, 457,  68, 487, 114, 475, 247,
     c-118,   2, 123, 388,  -2,  87, 387, -35, 424,   0, 408, 168,
     c-114,   3, 124, 390,  -1,  89, 390, -31, 427,  17, 414, 171,
     c-110,   5, 126, 391,   0,  89, 392, -28, 429,  24, 418, 173,
     c-102,   9, 131, 391,   7,  96, 396, -20, 429,  18, 419, 176,
     c-102,  11, 128, 386,   5,  96, 398, -20, 430,   7, 419, 178,
     c-104,  12, 126, 381,   4,  93, 399, -16, 432,  -2, 420, 182,
     c-103,  11, 129, 375,   7,  96, 403, -17, 435,  -6, 422, 187,
     c -96,  10, 137, 376,  12, 100, 406, -10, 440,  -8, 425, 192,
     c -87,   9, 148, 384,  19, 109, 411,  -6, 445,  -5, 432, 199,
     c -78,  11, 156, 394,  28, 112, 415,   1, 453,   5, 441, 207,
     c -68,  16, 165, 405,  37, 123, 423,  10, 460,  14, 450, 216,
     c -60,  24, 172, 417,  46, 135, 432,  22, 469,  19, 459, 226,
     c -48,  35, 181, 428,  58, 144, 441,  35, 480,  24, 467, 237,
     c -33,  45, 191, 441,  70, 160, 451,  48, 491,  30, 475, 248,
     c -20,  53, 199, 453,  81, 171, 460,  60, 503,  36, 482, 257,
     c -13,  59, 203, 461,  93, 177, 469,  68, 513,  56, 490, 265,
     c -12,  64, 207, 467, 101, 190, 476,  75, 520,  89, 495, 272,
     c  -5,  69, 211, 472, 105, 193, 485,  79, 525, 114, 500, 277,
     c   3,  74, 214, 476, 106, 195, 490,  82, 528, 127, 502, 279,
     c   6,  77, 216, 475, 106, 197, 492,  85, 529, 130, 503, 281,
     c   6,  78, 219, 477, 106, 201, 492,  84, 528, 123, 501, 282,
     c   6,  76, 220, 477, 103, 201, 489,  83, 525, 107, 498, 279,
     c   2,  72, 220, 474, 102, 197, 485,  80, 522,  95, 496, 275,
     c  -4,  65, 220, 468, 100, 189, 479,  74, 516,  83, 492, 271,
     c  -5,  57, 217, 466,  97, 181, 475,  69, 509,  69, 488, 267,
     c  -6,  48, 212, 464,  91, 181, 471,  63, 504,  66, 485, 262,
     c  -9,  40, 204, 460,  88, 175, 465,  59, 499,  78, 481, 256,
     c -16,  32, 196, 454,  83, 171, 460,  54, 495,  96, 477, 250,
     c -17,  26, 192, 451,  82, 169, 456,  54, 491, 105, 471, 244,
     c -15,  21, 190, 447,  81, 165, 452,  52, 490, 108, 469, 240,
     c -12,  23, 195, 449,  84, 164, 452,  53, 490, 106, 468, 239,
     c  -9,  24, 199, 451,  88, 168, 454,  57, 490, 108, 471, 241,
     c  -5,  26, 204, 453,  92, 171, 460,  66, 491, 108, 476, 245,
     c -99,   4, 135, 385,   6,  89, 399, -24, 434,  -3, 417, 181,
     c -96,   6, 136, 389,   6,  97, 400, -23, 437,  14, 423, 183,
     c -93,   9, 139, 391,   6, 100, 403, -23, 438,  20, 427, 185,
     c -87,  16, 144, 395,  10, 109, 406, -19, 439,  15, 429, 186,
     c -89,  18, 141, 392,   9, 106, 406, -19, 439,   4, 428, 188,
     c -90,  19, 140, 389,  12, 102, 408, -17, 441,  -2, 429, 191,
     c -90,  18, 143, 388,  15, 100, 409, -17, 443,  -5, 430, 194,
     c -86,  16, 149, 388,  17, 101, 412, -11, 446,  -6, 433, 198,
     c -77,  16, 157, 393,  22, 109, 416,  -4, 452,   2, 439, 204,
     c -66,  15, 164, 401,  30, 118, 420,   3, 457,  17, 447, 210,
     c -58,  18, 170, 411,  37, 128, 426,  10, 465,  29, 455, 217,
     c -52,  24, 175, 419,  44, 137, 433,  20, 473,  34, 463, 225,
     c -43,  32, 181, 426,  55, 142, 440,  30, 482,  36, 470, 233,
     c -30,  41, 191, 438,  67, 155, 448,  39, 491,  34, 476, 241,
     c -18,  48, 197, 448,  74, 164, 454,  48, 500,  30, 481, 248,
     c -17,  52, 199, 454,  82, 170, 461,  54, 506,  38, 485, 253,
     c -18,  57, 202, 460,  89, 177, 467,  60, 511,  61, 489, 257,
     c -13,  60, 204, 465,  93, 181, 473,  63, 514,  82, 491, 261,
     c  -6,  63, 206, 468,  93, 180, 476,  66, 515,  95, 491, 262,
     c  -4,  65, 205, 466,  93, 183, 478,  69, 515, 100, 491, 263,
     c  -3,  67, 208, 468,  92, 185, 480,  70, 515,  97, 490, 264,
     c  -1,  67, 210, 466,  90, 187, 477,  67, 512,  87, 487, 263,
     c  -3,  64, 212, 463,  89, 181, 473,  64, 508,  77, 484, 260,
     c  -9,  59, 213, 458,  85, 174, 469,  60, 505,  65, 482, 257,
     c -10,  53, 213, 456,  84, 170, 465,  58, 500,  54, 480, 253,
     c  -6,  45, 209, 455,  83, 170, 463,  54, 495,  53, 477, 249,
     c  -7,  38, 203, 453,  80, 166, 459,  52, 493,  65, 475, 246,
     c -13,  31, 196, 451,  77, 166, 455,  45, 493,  82, 473, 241,
     c -15,  25, 194, 448,  77, 163, 451,  45, 492,  92, 469, 237,
     c -13,  21, 190, 446,  77, 160, 450,  44, 492,  98, 467, 235,
     c -10,  24, 194, 451,  83, 167, 451,  49, 493, 101, 468, 236,
     c  -6,  27, 198, 456,  89, 168, 454,  52, 495, 105, 472, 239,
     c  -1,  30, 201, 462,  95, 173, 461,  61, 498, 107, 478, 244,
     c -83,   7, 145, 379,  11, 100, 404, -14, 440, -13, 424, 193,
     c -81,  10, 146, 383,  10, 105, 407, -12, 442,   3, 430, 195,
     c -80,  14, 147, 385,  10, 104, 410, -14, 444,   8, 435, 196,
     c -76,  21, 154, 394,  15, 115, 412, -10, 445,   4, 437, 197,
     c -76,  24, 153, 396,  17, 113, 414, -14, 446,  -5, 438, 197,
     c -78,  24, 151, 395,  19, 110, 416, -14, 448, -10, 438, 199,
     c -77,  23, 154, 399,  20, 113, 416, -14, 450, -10, 439, 201,
     c -73,  22, 158, 402,  22, 116, 418,  -9, 452,  -6, 441, 204,
     c -65,  20, 163, 404,  27, 119, 422,  -3, 456,   5, 445, 208,
     c -58,  20, 166, 410,  33, 124, 425,   1, 462,  25, 452, 212,
     c -52,  20, 170, 416,  37, 130, 429,   9, 467,  39, 460, 218,
     c -47,  24, 174, 422,  42, 136, 433,  14, 474,  45, 465, 223,
     c -40,  30, 180, 428,  51, 144, 438,  24, 481,  45, 470, 229,
     c -31,  36, 186, 434,  59, 149, 443,  31, 487,  36, 473, 233,
     c -24,  42, 191, 439,  63, 153, 447,  37, 492,  21, 476, 236,
     c -24,  46, 192, 445,  67, 158, 449,  40, 495,  21, 476, 238,
     c -26,  47, 191, 449,  70, 161, 452,  40, 496,  35, 476, 239,
     c -25,  48, 191, 449,  73, 159, 455,  43, 497,  51, 475, 240,
     c -21,  49, 190, 450,  72, 159, 457,  41, 498,  61, 475, 240,
     c -18,  51, 189, 452,  72, 157, 459,  44, 498,  66, 475, 242,
     c -17,  53, 190, 452,  72, 162, 460,  46, 497,  66, 475, 244,
     c -12,  53, 193, 452,  71, 166, 461,  48, 496,  61, 474, 244,
     c -10,  54, 197, 450,  69, 161, 458,  46, 495,  54, 473, 243,
     c -15,  51, 201, 448,  70, 155, 456,  46, 492,  46, 473, 241,
     c -15,  49, 206, 447,  72, 153, 455,  45, 491,  37, 471, 240,
     c  -9,  45, 208, 448,  73, 156, 454,  45, 490,  38, 470, 237,
     c  -6,  40, 203, 448,  73, 153, 452,  43, 490,  49, 470, 235,
     c -10,  34, 197, 447,  72, 160, 451,  41, 490,  65, 469, 234,
     c -12,  30, 193, 445,  71, 157, 449,  41, 492,  78, 468, 232,
     c -11,  29, 189, 444,  71, 156, 449,  41, 494,  91, 467, 231,
     c  -7,  32, 193, 452,  82, 166, 452,  48, 496, 100, 469, 234,
     c  -2,  36, 195, 459,  88, 171, 457,  51, 499, 105, 473, 238,
     c   1,  39, 197, 468,  96, 175, 464,  63, 503, 109, 480, 244,
     c -72,  15, 154, 372,  15, 107, 413,  -7, 444, -21, 433, 206,
     c -71,  20, 156, 377,  15, 111, 415,  -5, 447, -10, 439, 207,
     c -69,  23, 157, 381,  16, 111, 418,  -6, 448,  -5, 444, 207,
     c -65,  29, 165, 391,  21, 118, 421,  -6, 450, -10, 446, 207,
     c -65,  30, 165, 397,  23, 122, 422,  -9, 451, -17, 447, 206,
     c -67,  29, 162, 401,  21, 119, 423,  -9, 453, -20, 448, 207,
     c -66,  29, 162, 405,  22, 120, 423, -10, 454, -17, 448, 208,
     c -61,  30, 166, 411,  24, 126, 424,  -8, 456,  -9, 449, 209,
     c -58,  28, 167, 412,  26, 127, 425,  -3, 460,   3, 452, 211,
     c -53,  27, 167, 415,  30, 131, 429,   0, 464,  24, 457, 214,
     c -49,  27, 172, 419,  35, 130, 431,   6, 470,  39, 462, 218,
     c -43,  27, 175, 424,  39, 138, 435,   9, 475,  43, 466, 221,
     c -40,  30, 178, 426,  43, 141, 438,  16, 477,  40, 468, 223,
     c -35,  35, 181, 427,  48, 140, 439,  21, 480,  25, 468, 224,
     c -33,  39, 182, 428,  48, 141, 438,  20, 480,   5, 466, 223,
     c -34,  40, 181, 431,  48, 146, 437,  19, 479,   0, 464, 220,
     c -40,  38, 175, 429,  46, 142, 435,  14, 477,   9, 459, 218,
     c -39,  35, 171, 425,  46, 138, 433,  15, 475,  17, 457, 217,
     c -36,  34, 169, 426,  45, 135, 434,  17, 475,  21, 456, 216,
     c -35,  34, 168, 428,  45, 134, 435,  21, 476,  25, 457, 218,
     c -32,  36, 169, 431,  46, 139, 438,  22, 477,  29, 459, 220,
     c -27,  38, 172, 433,  49, 143, 439,  27, 479,  29, 460, 223,
     c -21,  39, 178, 436,  51, 144, 441,  30, 479,  28, 462, 224,
     c -22,  40, 186, 437,  55, 139, 442,  33, 481,  23, 462, 226,
     c -20,  40, 194, 439,  59, 142, 446,  34, 481,  19, 464, 227,
     c -11,  40, 198, 443,  64, 147, 448,  35, 483,  24, 465, 227,
     c  -6,  38, 198, 442,  66, 146, 448,  37, 485,  35, 466, 227,
     c  -9,  36, 194, 441,  66, 151, 448,  38, 489,  48, 467, 227,
     c  -6,  37, 190, 441,  65, 149, 450,  39, 492,  66, 467, 228,
     c  -4,  38, 188, 443,  70, 150, 452,  41, 494,  83, 469, 229,
     c   0,  44, 192, 451,  84, 159, 458,  48, 498,  95, 471, 233,
     c   5,  47, 195, 461,  91, 161, 464,  54, 503, 102, 477, 239,
     c   9,  52, 198, 470,  99, 172, 471,  64, 506, 107, 484, 246,
     c -58,  26, 166, 372,  22, 119, 423,  -5, 449, -21, 445, 217,
     c -57,  30, 168, 379,  23, 120, 426,  -4, 451, -16, 450, 217,
     c -56,  33, 170, 384,  24, 121, 429,  -1, 454, -14, 454, 217,
     c -51,  39, 177, 394,  27, 128, 432,  -2, 455, -18, 456, 217,
     c -50,  38, 176, 401,  24, 128, 433,  -4, 456, -25, 456, 215,
     c -52,  37, 173, 407,  21, 130, 433,  -6, 458, -27, 456, 214,
     c -52,  37, 171, 413,  21, 126, 433,  -6, 459, -23, 456, 213,
     c -49,  39, 171, 417,  21, 130, 432,  -5, 460, -15, 456, 213,
     c -49,  37, 171, 415,  21, 131, 432,  -4, 462,  -3, 458, 214,
     c -47,  34, 171, 416,  25, 131, 434,  -2, 466,  13, 460, 215,
     c -44,  32, 175, 419,  30, 134, 434,   2, 469,  25, 464, 216,
     c -41,  31, 177, 419,  34, 136, 436,   4, 472,  28, 466, 216,
     c -42,  32, 177, 418,  36, 136, 437,   8, 473,  23, 464, 215,
     c -42,  34, 176, 418,  36, 133, 435,   7, 470,   8, 461, 213,
     c -44,  35, 173, 416,  32, 128, 431,   4, 466, -10, 454, 208,
     c -50,  32, 164, 410,  25, 120, 424,   0, 460, -16, 447, 201,
     c -57,  28, 155, 405,  23, 112, 417,  -6, 454,  -8, 441, 196,
     c -56,  24, 150, 403,  20, 109, 413,  -9, 452,  -7, 437, 191,
     c -55,  20, 148, 403,  18, 109, 411, -10, 451, -12, 435, 190,
     c -54,  19, 147, 405,  18, 107, 412,  -6, 453, -14, 437, 192,
     c -52,  20, 146, 411,  23, 113, 417,  -1, 456, -10, 442, 196,
     c -43,  21, 152, 419,  29, 123, 421,   7, 460,  -4, 445, 202,
     c -36,  22, 159, 422,  35, 123, 427,  11, 464,   0, 449, 206,
     c -32,  26, 167, 424,  40, 122, 432,  17, 468,   1, 453, 210,
     c -26,  31, 176, 431,  45, 132, 440,  22, 473,   3, 456, 214,
     c -16,  34, 184, 437,  53, 139, 444,  26, 477,  12, 459, 216,
     c  -8,  36, 185, 437,  58, 138, 447,  31, 482,  23, 463, 219,
     c  -8,  38, 186, 437,  60, 146, 448,  34, 486,  35, 466, 222,
     c  -3,  42, 190, 443,  65, 151, 452,  38, 490,  52, 468, 224,
     c   4,  46, 189, 446,  73, 158, 458,  41, 494,  71, 471, 228,
     c  10,  53, 193, 453,  86, 166, 465,  48, 498,  82, 476, 233,
     c  14,  58, 197, 462,  94, 166, 473,  57, 504,  90, 482, 240,
     c  20,  63, 200, 472, 101, 176, 482,  65, 510,  95, 490, 247,
     c -41,  34, 179, 382,  29, 131, 438,   0, 456, -17, 459, 227,
     c -41,  37, 180, 388,  29, 135, 440,  -1, 459, -19, 464, 227,
     c -41,  41, 180, 393,  29, 132, 443,   0, 459, -22, 467, 226,
     c -36,  46, 186, 406,  31, 140, 445,   0, 459, -25, 467, 225,
     c -37,  46, 185, 412,  27, 137, 445,  -2, 460, -32, 466, 222,
     c -38,  45, 180, 417,  22, 136, 444,  -4, 461, -32, 465, 220,
     c -37,  46, 177, 424,  24, 139, 442,  -4, 461, -28, 464, 218,
     c -37,  47, 176, 425,  24, 139, 441,  -4, 461, -23, 463, 216,
     c -38,  45, 176, 420,  23, 135, 439,  -5, 462, -14, 462, 215,
     c -38,  42, 177, 419,  26, 132, 437,  -4, 465,  -2, 464, 214,
     c -36,  37, 179, 420,  30, 130, 437,  -1, 468,   5, 465, 213,
     c -38,  33, 177, 415,  31, 130, 436,  -1, 467,   7, 462, 211,
     c -42,  32, 174, 413,  30, 127, 432,  -4, 465,   2, 457, 205,
     c -45,  31, 169, 411,  27, 123, 428,  -9, 459,  -6, 450, 200,
     c -54,  27, 158, 402,  15, 113, 419, -15, 451, -16, 441, 192,
     c -66,  22, 143, 392,   4,  96, 407, -24, 441, -14, 430, 182,
     c -73,  15, 132, 384,  -2,  85, 398, -33, 433,  -7, 422, 173,
     c -73,  10, 126, 381,  -7,  79, 392, -36, 428, -12, 416, 167,
     c -74,   7, 125, 383,  -8,  80, 390, -37, 428, -25, 416, 165,
     c -74,   6, 125, 387,  -5,  84, 393, -29, 431, -31, 419, 168,
     c -68,   6, 126, 394,   1,  93, 399, -25, 436, -30, 425, 173,
     c -58,   6, 133, 403,  11, 103, 407, -15, 443, -24, 431, 181,
     c -49,   9, 143, 410,  22, 106, 414,  -7, 449, -15, 438, 187,
     c -42,  13, 151, 416,  29, 110, 424,   2, 457, -10, 444, 194,
     c -35,  21, 161, 425,  37, 119, 433,  13, 463,  -5, 448, 201,
     c -23,  27, 168, 432,  46, 124, 439,  18, 470,   1, 454, 206,
     c -12,  32, 173, 436,  53, 132, 443,  24, 476,  10, 459, 211,
     c  -9,  36, 177, 437,  58, 141, 446,  28, 482,  21, 464, 216,
     c  -3,  43, 185, 444,  67, 143, 451,  33, 488,  36, 469, 220,
     c   8,  51, 189, 450,  77, 154, 460,  40, 493,  53, 474, 225,
     c  17,  58, 196, 457,  86, 162, 471,  46, 499,  62, 480, 232,
     c  26,  63, 201, 466,  95, 162, 480,  59, 505,  70, 486, 239,
     c  33,  70, 207, 477, 103, 177, 489,  66, 512,  74, 494, 248,
     c -27,  40, 186, 401,  30, 141, 452,  -1, 465, -11, 474, 236,
     c -27,  44, 186, 406,  30, 143, 455,  -3, 466, -19, 477, 236,
     c -28,  47, 186, 410,  29, 144, 456,   0, 466, -25, 480, 234,
     c -25,  53, 190, 421,  31, 148, 457,  -1, 466, -29, 478, 232,
     c -27,  53, 189, 425,  29, 146, 454,  -3, 465, -32, 476, 228,
     c -27,  53, 184, 429,  24, 144, 452,  -3, 464, -31, 473, 225,
     c -26,  54, 180, 432,  23, 142, 450,  -2, 462, -28, 471, 221,
     c -30,  54, 178, 430,  25, 140, 447,   0, 463, -26, 468, 217,
     c -34,  52, 178, 423,  23, 134, 444,  -1, 462, -24, 466, 215,
     c -35,  47, 178, 420,  25, 129, 442,   0, 463, -18, 466, 212,
     c -33,  42, 177, 416,  28, 126, 438,  -3, 464, -13, 464, 209,
     c -37,  35, 173, 410,  25, 123, 432,  -7, 462, -13, 459, 203,
     c -45,  29, 166, 406,  19, 114, 425, -15, 457, -13, 450, 195,
     c -54,  23, 156, 400,  10, 106, 415, -24, 448, -16, 439, 186,
     c -66,  16, 138, 389,  -2,  91, 404, -36, 436, -15, 426, 175,
     c -79,   7, 121, 377, -14,  73, 391, -47, 423,  -7, 414, 163,
     c -87,   0, 109, 366, -25,  63, 380, -58, 414,  -2, 404, 153,
     c -89,  -6, 103, 360, -32,  56, 373, -59, 409, -10, 399, 145,
     c -90,  -7, 103, 365, -31,  57, 373, -59, 408, -26, 400, 143,
     c -88,  -7, 105, 373, -25,  67, 377, -52, 412, -35, 405, 146,
     c -81,  -6, 109, 379, -16,  75, 384, -44, 419, -33, 412, 153,
     c -70,  -5, 117, 386,  -6,  84, 394, -35, 427, -25, 420, 162,
     c -60,  -2, 128, 396,   6,  93, 405, -25, 436, -17, 428, 170,
     c -52,   4, 140, 407,  18, 101, 416, -13, 446, -11, 435, 179,
     c -45,  11, 151, 417,  30, 110, 424,  -1, 456,  -9, 442, 187,
     c -32,  19, 156, 426,  39, 119, 431,   4, 464,  -7, 448, 195,
     c -22,  26, 161, 430,  45, 124, 435,  10, 472,  -5, 456, 201,
     c -13,  33, 169, 436,  54, 129, 442,  17, 479,   1, 462, 208,
     c  -5,  43, 175, 444,  64, 134, 448,  26, 485,  13, 468, 214,
     c   4,  51, 181, 451,  71, 143, 458,  35, 493,  27, 476, 221,
     c  18,  60, 191, 461,  81, 151, 472,  44, 500,  36, 483, 229,
     c  29,  67, 199, 471,  90, 155, 482,  55, 508,  44, 491, 238,
     c  39,  72, 208, 479,  97, 167, 492,  64, 516,  49, 499, 247,
     c -13,  49, 194, 427,  34, 149, 463,   1, 474,  -2, 486, 242,
     c -16,  50, 192, 429,  32, 152, 465,   0, 474, -17, 489, 242,
     c -17,  52, 191, 431,  31, 148, 464,   0, 474, -25, 489, 239,
     c -18,  59, 193, 436,  31, 149, 462,  -1, 472, -29, 486, 236,
     c -19,  61, 192, 439,  28, 152, 460,  -4, 469, -28, 482, 231,
     c -20,  60, 187, 439,  22, 149, 456,  -5, 467, -25, 478, 226,
     c -22,  60, 183, 434,  22, 140, 453,  -4, 465, -24, 474, 221,
     c -27,  60, 180, 429,  23, 135, 449,  -5, 462, -25, 471, 216,
     c -33,  57, 180, 424,  22, 129, 444,  -7, 461, -28, 468, 212,
     c -36,  52, 177, 417,  20, 121, 441,  -7, 461, -25, 465, 208,
     c -37,  47, 173, 411,  20, 117, 434, -14, 459, -22, 462, 202,
     c -43,  39, 165, 403,  15, 112, 426, -23, 455, -21, 455, 193,
     c -53,  30, 156, 397,   5, 103, 415, -33, 447, -21, 443, 183,
     c -65,  19, 143, 391,  -6,  89, 403, -44, 436, -21, 429, 172,
     c -78,   7, 125, 380, -18,  72, 389, -56, 422, -20, 414, 159,
     c -91,  -5, 106, 363, -32,  53, 376, -69, 409, -12, 401, 145,
     c-102, -15,  92, 349, -44,  39, 364, -79, 398, -11, 392, 134,
     c-105, -20,  87, 346, -50,  38, 357, -81, 393, -23, 387, 126,
     c-104, -22,  90, 351, -49,  44, 358, -77, 393, -39, 387, 124,
     c-100, -21,  94, 357, -42,  50, 364, -71, 397, -42, 393, 128,
     c -92, -17, 100, 364, -32,  62, 373, -62, 405, -35, 402, 135,
     c -81, -15, 107, 372, -21,  71, 382, -55, 415, -23, 411, 146,
     c -71, -11, 119, 384, -10,  80, 394, -42, 427, -13, 419, 156,
     c -63,  -3, 133, 398,   2,  92, 404, -29, 438,  -6, 428, 166,
     c -52,   5, 143, 411,  16, 100, 414, -15, 449,  -6, 436, 174,
     c -40,  14, 145, 421,  26, 110, 422,  -8, 458, -11, 443, 183,
     c -30,  22, 149, 425,  34, 114, 427,   0, 467, -16, 451, 191,
     c -23,  30, 158, 431,  43, 120, 433,   7, 475, -15, 460, 200,
     c -11,  40, 165, 441,  54, 130, 442,  18, 484,  -8, 467, 208,
     c   1,  50, 171, 449,  62, 138, 455,  28, 493,   1, 476, 216,
     c  16,  58, 181, 461,  73, 146, 471,  38, 502,   8, 485, 225,
     c  28,  66, 192, 471,  83, 152, 482,  51, 511,  16, 494, 235,
     c  41,  74, 203, 480,  93, 164, 492,  60, 520,  23, 502, 245,
     c   0,  57, 202, 455,  39, 167, 472,   2, 482,  -3, 494, 245,
     c  -3,  58, 198, 453,  37, 165, 472,   0, 481, -20, 497, 244,
     c  -5,  60, 194, 452,  35, 161, 471,   1, 479, -29, 495, 241,
     c  -9,  64, 194, 451,  31, 160, 467,  -1, 476, -31, 491, 237,
     c -13,  65, 192, 448,  26, 157, 463,  -3, 471, -25, 486, 230,
     c -16,  64, 189, 442,  21, 150, 458,  -3, 467, -20, 481, 224,
     c -18,  64, 185, 435,  21, 140, 453,  -5, 464, -19, 476, 217,
     c -22,  63, 181, 428,  22, 132, 448,  -5, 461, -21, 471, 211,
     c -29,  61, 178, 420,  20, 123, 442, -11, 459, -25, 467, 206,
     c -36,  59, 171, 413,  15, 116, 436, -15, 457, -25, 464, 200,
     c -41,  54, 165, 406,  11, 113, 428, -26, 454, -22, 458, 193,
     c -49,  46, 157, 397,   3, 105, 416, -37, 448, -21, 449, 183,
     c -62,  34, 145, 388,  -9,  92, 404, -49, 438, -27, 435, 171,
     c -72,  22, 134, 383, -19,  76, 390, -61, 425, -32, 420, 158,
     c -83,   7, 119, 372, -31,  62, 376, -74, 411, -37, 405, 144,
     c -98,  -7, 101, 354, -44,  42, 362, -86, 397, -40, 391, 130,
     c-110, -21,  86, 340, -54,  29, 350, -94, 387, -46, 382, 119,
     c-115, -29,  82, 337, -60,  28, 345, -97, 382, -56, 378, 111,
     c-114, -31,  88, 342, -57,  34, 347, -93, 381, -65, 380, 110,
     c-109, -30,  91, 346, -52,  37, 353, -87, 386, -58, 386, 113,
     c-100, -27,  94, 354, -44,  48, 363, -78, 396, -38, 394, 121,
     c -89, -23, 103, 366, -34,  64, 374, -69, 407, -17, 403, 132,
     c -77, -16, 115, 378, -24,  74, 385, -58, 419,  -3, 414, 143,
     c -67,  -8, 128, 389,  -9,  84, 395, -45, 432,   4, 422, 153,
     c -53,   2, 136, 404,   3,  92, 406, -31, 443,   0, 430, 163,
     c -40,  12, 140, 416,  15, 104, 414, -20, 453,  -8, 438, 173,
     c -31,  21, 144, 423,  26, 108, 422, -11, 462, -18, 447, 182,
     c -23,  30, 154, 428,  37, 116, 430,  -3, 473, -21, 456, 191,
     c -11,  40, 164, 438,  48, 126, 441,   7, 483, -21, 466, 201,
     c   3,  50, 172, 451,  61, 138, 455,  20, 494, -14, 476, 210,
     c  20,  58, 183, 463,  75, 147, 470,  33, 505,  -9, 487, 221,
     c  32,  66, 194, 475,  85, 154, 482,  46, 515,  -2, 495, 231,
     c  46,  75, 207, 486,  97, 168, 494,  56, 525,   7, 504, 242,
     c  10,  68, 208, 474,  40, 175, 476,   8, 486, -20, 501, 244,
     c   6,  68, 202, 469,  38, 174, 475,   5, 485, -37, 502, 243,
     c   1,  68, 197, 465,  35, 166, 473,   3, 482, -45, 501, 239,
     c  -3,  71, 195, 459,  31, 162, 468,   1, 477, -41, 496, 234,
     c -10,  70, 192, 451,  26, 157, 462,  -1, 472, -31, 489, 226,
     c -14,  69, 187, 441,  21, 145, 456,  -3, 467, -22, 482, 219,
     c -17,  68, 181, 429,  21, 132, 449,  -7, 462, -18, 476, 211,
     c -21,  68, 174, 421,  21, 123, 442, -13, 458, -21, 470, 203,
     c -27,  68, 168, 412,  17, 115, 435, -22, 454, -23, 464, 197,
     c -34,  67, 159, 405,  10, 109, 428, -32, 452, -23, 460, 190,
     c -41,  64, 152, 400,   1, 109, 419, -42, 446, -20, 454, 182,
     c -53,  55, 143, 391,  -9, 101, 406, -55, 439, -23, 444, 171,
     c -66,  43, 134, 380, -20,  83, 393, -67, 428, -38, 429, 159,
     c -76,  29, 124, 373, -31,  67, 378, -79, 414, -54, 413, 145,
     c -89,  13, 113, 361, -45,  51, 365, -89, 400, -68, 397, 132,
     c-104,  -4,  97, 347, -55,  35, 351, -99, 388, -78, 385, 117,
     c-112, -19,  87, 334, -61,  21, 341,-105, 377, -91, 376, 107,
     c-117, -31,  83, 330, -68,  16, 337,-110, 372,-100, 373,  99,
     c-120, -36,  85, 334, -68,  25, 337,-108, 373, -95, 375,  98,
     c-116, -36,  85, 338, -63,  26, 343,-100, 379, -70, 381, 102,
     c-104, -31,  88, 347, -54,  34, 354, -90, 388, -39, 389, 110,
     c -93, -24,  97, 359, -44,  51, 365, -79, 400, -12, 399, 121,
     c -83, -18, 107, 372, -32,  66, 376, -66, 413,   6, 409, 131,
     c -68,  -7, 122, 383, -16,  74, 387, -54, 426,  16, 418, 142,
     c -53,   3, 133, 395,  -1,  81, 399, -40, 438,  10, 427, 152,
     c -38,  15, 140, 408,  10,  95, 409, -28, 449,  -2, 436, 163,
     c -27,  25, 147, 419,  21, 104, 420, -16, 459, -14, 445, 173,
     c -15,  35, 158, 429,  35, 116, 430,  -5, 471, -17, 455, 183,
     c  -5,  45, 169, 440,  48, 130, 442,   3, 483, -22, 465, 194,
     c   9,  54, 179, 453,  60, 141, 456,  18, 496, -21, 477, 205,
     c  24,  62, 191, 468,  75, 152, 472,  30, 507, -19, 488, 216,
     c  39,  72, 205, 481,  87, 164, 484,  43, 518, -12, 498, 227,
     c  53,  80, 218, 494, 100, 175, 495,  54, 528,   0, 507, 237,
     c  13,  78, 211, 476,  38, 174, 477,  10, 489, -42, 506, 240,
     c   9,  77, 206, 470,  36, 168, 476,   6, 487, -55, 506, 239,
     c   3,  75, 199, 465,  34, 156, 473,   3, 483, -61, 504, 234,
     c  -1,  76, 194, 456,  31, 149, 467,   1, 477, -55, 498, 228,
     c  -8,  76, 188, 446,  26, 143, 458,  -4, 470, -39, 489, 219,
     c -13,  74, 181, 433,  19, 135, 451, -12, 463, -26, 481, 210,
     c -19,  73, 171, 420,  16, 124, 443, -19, 458, -23, 473, 201,
     c -26,  74, 162, 411,  14, 114, 433, -26, 452, -27, 466, 192,
     c -30,  74, 155, 402,   7, 106, 425, -35, 448, -31, 459, 185,
     c -35,  74, 146, 397,   0,  99, 415, -46, 443, -26, 454, 177,
     c -42,  71, 139, 391,  -9,  98, 407, -57, 437, -21, 448, 169,
     c -57,  62, 131, 382, -22,  90, 394, -67, 428, -29, 437, 158,
     c -70,  48, 122, 372, -34,  72, 381, -79, 417, -54, 422, 145,
     c -81,  33, 113, 363, -44,  55, 369, -89, 403, -79, 406, 132,
     c -93,  16, 105, 351, -53,  41, 357, -96, 391,-100, 391, 119,
     c-107,  -2,  93, 338, -64,  26, 345,-106, 379,-118, 379, 106,
     c-114, -18,  85, 329, -71,  16, 335,-113, 370,-137, 372,  95,
     c-120, -31,  81, 325, -76,  13, 329,-118, 365,-141, 369,  88,
     c-121, -37,  78, 326, -76,  20, 329,-118, 366,-126, 371,  87,
     c-117, -35,  78, 332, -71,  23, 335,-111, 372, -90, 376,  91,
     c-107, -28,  79, 341, -62,  30, 344,-102, 382, -52, 384,  99,
     c -95, -20,  87, 355, -50,  45, 356, -89, 395, -20, 394, 111,
     c -86, -13, 100, 367, -36,  58, 367, -78, 408,   2, 404, 122,
     c -71,  -2, 117, 381, -19,  70, 381, -63, 421,  14, 415, 133,
     c -56,   8, 129, 390,  -3,  75, 392, -51, 433,   8, 426, 143,
     c -40,  21, 139, 402,   8,  88, 406, -36, 444,  -4, 434, 154,
     c -28,  33, 148, 414,  18,  97, 419, -24, 456, -10, 444, 165,
     c -14,  44, 161, 428,  33, 115, 431, -13, 468, -10, 455, 176,
     c   0,  54, 175, 443,  49, 132, 447,  -3, 483, -17, 466, 189,
     c  12,  64, 185, 455,  58, 140, 460,  11, 496, -20, 477, 200,
     c  25,  72, 196, 470,  71, 153, 476,  26, 509, -22, 490, 212,
     c  38,  82, 210, 483,  84, 165, 489,  40, 520, -16, 501, 224,
     c  53,  93, 224, 498,  98, 179, 498,  50, 530,  -3, 510, 233,
     c  11,  85, 212, 466,  35, 163, 474,   0, 489, -50, 507, 232,
     c   6,  82, 205, 459,  33, 155, 472,  -1, 485, -61, 508, 230,
     c   2,  80, 197, 454,  33, 141, 469,  -4, 481, -64, 504, 225,
     c   0,  79, 190, 446,  29, 135, 463,  -9, 474, -57, 497, 218,
     c  -5,  78, 184, 437,  22, 129, 453, -14, 466, -43, 488, 207,
     c -14,  76, 173, 422,  14, 119, 443, -26, 458, -34, 478, 197,
     c -24,  76, 162, 410,   8, 111, 433, -37, 451, -35, 469, 186,
     c -32,  75, 151, 400,   2, 102, 422, -49, 444, -43, 459, 176,
     c -38,  75, 141, 393,  -6,  96, 412, -60, 437, -49, 451, 167,
     c -45,  74, 133, 387, -17,  87, 403, -68, 431, -41, 445, 160,
     c -53,  68, 127, 381, -27,  81, 393, -75, 425, -33, 438, 152,
     c -63,  58, 121, 375, -36,  74, 382, -83, 417, -42, 427, 142,
     c -74,  43, 112, 365, -47,  59, 372, -92, 406, -70, 413, 131,
     c -84,  27, 103, 353, -54,  43, 360, -98, 393, -99, 398, 119,
     c -96,  10,  96, 339, -64,  30, 349,-104, 381,-124, 385, 107,
     c-109,  -5,  87, 327, -76,  15, 338,-115, 372,-146, 375,  95,
     c-120, -20,  81, 321, -83,   9, 328,-123, 364,-167, 368,  86,
     c-122, -30,  74, 320, -83,   8, 322,-125, 360,-171, 366,  79,
     c-122, -34,  70, 319, -87,   9, 321,-128, 362,-153, 368,  79,
     c-119, -30,  70, 326, -81,  12, 326,-122, 368,-116, 372,  83,
     c-109, -21,  72, 339, -70,  22, 335,-114, 378, -77, 379,  91,
     c -98, -13,  78, 355, -57,  40, 346, -99, 390, -47, 388, 101,
     c -87,  -5,  92, 366, -44,  55, 360, -87, 403, -25, 400, 113,
     c -75,   2, 113, 378, -26,  64, 371, -72, 417, -10, 411, 125,
     c -58,  12, 127, 389, -10,  73, 388, -60, 430, -13, 422, 135,
     c -43,  23, 137, 401,   1,  87, 402, -46, 442, -16, 433, 147,
     c -32,  36, 146, 411,  14,  96, 418, -33, 454, -11, 444, 159,
     c -17,  49, 160, 424,  28, 110, 432, -19, 467,  -2, 454, 171,
     c   3,  61, 175, 441,  42, 128, 448,  -7, 481,  -6, 467, 185,
     c  16,  72, 187, 455,  54, 139, 462,   8, 496, -14, 479, 197,
     c  27,  82, 198, 469,  67, 148, 477,  22, 508, -19, 492, 209,
     c  38,  94, 212, 483,  83, 161, 489,  35, 520, -15, 502, 220,
     c  51, 106, 225, 497,  97, 173, 498,  44, 530,  -4, 512, 231,
     c   8,  88, 208, 450,  31, 154, 468, -11, 486, -45, 504, 220,
     c   4,  84, 200, 445,  31, 147, 466, -11, 483, -55, 503, 217,
     c   0,  79, 190, 439,  28, 130, 463, -14, 476, -59, 500, 211,
     c   0,  78, 185, 434,  25, 124, 455, -19, 469, -54, 492, 203,
     c  -4,  75, 177, 424,  15, 115, 445, -31, 459, -45, 482, 192,
     c -16,  72, 165, 410,   5, 104, 432, -43, 450, -42, 471, 180,
     c -29,  70, 152, 398,  -2,  94, 421, -58, 441, -51, 461, 169,
     c -40,  68, 140, 390, -12,  85, 408, -71, 432, -64, 450, 158,
     c -52,  66, 129, 379, -25,  76, 396, -81, 424, -73, 441, 148,
     c -62,  62, 119, 371, -37,  65, 387, -87, 418, -66, 433, 141,
     c -70,  55, 113, 368, -47,  59, 378, -93, 411, -59, 427, 133,
     c -75,  42, 106, 364, -53,  54, 368, -98, 402, -66, 417, 124,
     c -82,  26,  99, 352, -59,  40, 359,-103, 393, -93, 404, 115,
     c -90,   9,  92, 341, -66,  26, 350,-108, 383,-120, 391, 105,
     c-101,  -6,  86, 330, -77,  16, 340,-115, 374,-142, 380,  95,
     c-112, -19,  79, 319, -87,   6, 330,-125, 366,-159, 372,  85,
     c-124, -29,  71, 314, -91,  -1, 321,-133, 359,-179, 366,  76,
     c-126, -35,  65, 315, -94,   0, 316,-136, 357,-182, 364,  72,
     c-125, -34,  61, 318, -95,   4, 316,-139, 358,-164, 365,  72,
     c-120, -27,  62, 323, -89,   5, 320,-133, 364,-129, 369,  76,
     c-110, -17,  66, 336, -74,  16, 329,-123, 374,-101, 375,  83,
     c -97,  -8,  73, 353, -62,  36, 341,-109, 386, -80, 383,  93,
     c -84,  -2,  89, 366, -49,  51, 353, -96, 401, -66, 393, 105,
     c -71,   2, 107, 375, -32,  57, 367, -83, 414, -52, 406, 116,
     c -54,   9, 122, 385, -17,  68, 383, -70, 427, -53, 418, 128,
     c -42,  19, 133, 398,  -3,  81, 400, -55, 439, -46, 430, 141,
     c -29,  32, 144, 413,  11,  95, 416, -42, 451, -24, 442, 153,
     c -12,  46, 157, 425,  25, 106, 431, -27, 465,   0, 453, 166,
     c   4,  61, 171, 436,  37, 117, 447, -15, 480,   0, 465, 180,
     c  16,  74, 185, 454,  52, 135, 461,   3, 494,  -7, 479, 193,
     c  28,  87, 199, 471,  67, 144, 476,  20, 507, -15, 491, 206,
     c  42, 102, 213, 487,  85, 159, 489,  32, 518, -14, 503, 217,
     c  55, 115, 227, 503, 101, 170, 497,  40, 529,  -8, 513, 228,
     c   3,  83, 203, 437,  24, 144, 457, -29, 481, -34, 497, 205,
     c  -2,  77, 194, 432,  22, 134, 455, -30, 476, -44, 495, 202,
     c  -7,  71, 183, 425,  18, 118, 451, -33, 469, -51, 490, 195,
     c  -8,  69, 176, 420,  14, 110, 443, -40, 460, -53, 482, 185,
     c -13,  64, 165, 409,   3, 101, 432, -51, 450, -52, 471, 173,
     c -23,  58, 152, 398,  -7,  91, 418, -63, 438, -56, 459, 161,
     c -37,  54, 138, 387, -17,  78, 405, -76, 428, -73, 449, 149,
     c -55,  51, 126, 376, -30,  68, 393, -91, 418, -95, 437, 138,
     c -68,  46, 115, 365, -43,  56, 380,-100, 409,-109, 428, 128,
     c -77,  40, 107, 359, -53,  48, 370,-106, 401,-107, 421, 120,
     c -84,  31,  98, 354, -63,  40, 361,-112, 395,-100, 415, 112,
     c -92,  16,  87, 346, -73,  29, 354,-116, 388,-106, 406, 104,
     c -97,   0,  81, 337, -76,  22, 346,-120, 381,-126, 394,  97,
     c-101, -17,  77, 329, -79,   8, 337,-124, 373,-143, 384,  89,
     c-110, -33,  72, 320, -91,   1, 328,-130, 366,-154, 375,  81,
     c-120, -43,  65, 313, -98,  -1, 320,-137, 360,-162, 368,  74,
     c-126, -47,  58, 310,-102,  -8, 315,-145, 356,-174, 364,  67,
     c-127, -46,  56, 313,-103,  -4, 312,-145, 355,-171, 362,  64,
     c-126, -42,  55, 315,-103,  -3, 312,-146, 356,-150, 363,  65,
     c-121, -32,  57, 321, -94,  -1, 317,-138, 362,-116, 366,  70,
     c-111, -21,  61, 333, -79,   9, 326,-129, 373,-100, 371,  77,
     c-100, -12,  71, 347, -66,  29, 338,-114, 385, -97, 379,  86,
     c -84,  -8,  85, 362, -52,  45, 351,-102, 399, -94, 388,  98,
     c -67,  -4, 100, 372, -34,  54, 366, -88, 413, -88, 401, 109,
     c -53,   1, 115, 382, -19,  63, 381, -77, 426, -91, 413, 122,
     c -42,  10, 126, 393,  -8,  74, 396, -61, 438, -81, 426, 134,
     c -25,  22, 139, 409,   6,  87, 411, -49, 450, -48, 438, 147,
     c  -8,  37, 155, 423,  21, 100, 426, -34, 464, -15, 452, 161,
     c   4,  54, 170, 438,  36, 113, 440, -21, 478,  -9, 465, 176,
     c  15,  71, 184, 454,  50, 127, 455,  -4, 492, -16, 478, 190,
     c  28,  86, 199, 474,  68, 139, 471,  14, 506, -23, 491, 203,
     c  43, 102, 211, 489,  84, 151, 484,  26, 518, -25, 503, 214,
     c  58, 118, 225, 506, 101, 164, 494,  32, 528, -24, 514, 225,
     c  -2,  67, 197, 423,   8, 133, 443, -46, 472, -26, 486, 189,
     c  -9,  59, 187, 419,   5, 125, 439, -48, 465, -40, 484, 184,
     c -17,  52, 175, 412,   0, 111, 433, -55, 458, -51, 477, 176,
     c -21,  46, 163, 404,  -7,  99, 425, -63, 447, -64, 468, 165,
     c -29,  39, 150, 394, -17,  87, 413, -73, 436, -73, 457, 153,
     c -38,  31, 136, 384, -27,  74, 401, -86, 424, -83, 445, 140,
     c -53,  24, 121, 372, -41,  60, 387, -99, 413,-105, 434, 128,
     c -70,  19, 110, 362, -52,  45, 375,-110, 401,-133, 423, 116,
     c -81,  14, 103, 355, -62,  37, 365,-118, 391,-154, 412, 106,
     c -87,   9,  96, 348, -70,  36, 355,-126, 383,-152, 405,  98,
     c -95,  -1,  83, 336, -80,  19, 347,-133, 377,-144, 399,  90,
     c-106, -14,  73, 328, -88,  10, 338,-136, 372,-140, 392,  84,
     c-113, -30,  68, 324, -94,   5, 330,-136, 367,-147, 383,  77,
     c-116, -46,  64, 320, -94,  -4, 323,-141, 362,-151, 374,  71,
     c-119, -59,  59, 313,-100,  -9, 317,-145, 358,-153, 368,  65,
     c-125, -64,  53, 309,-106,  -7, 313,-152, 355,-153, 364,  61,
     c-124, -64,  49, 313,-108,  -9, 312,-154, 352,-158, 360,  56,
     c-123, -60,  48, 316,-106,  -5, 311,-151, 352,-151, 360,  56,
     c-119, -52,  51, 318,-103,  -4, 313,-151, 355,-129, 362,  58,
     c-114, -42,  54, 322, -97,  -4, 317,-143, 362,-101, 365,  63,
     c-110, -32,  58, 332, -83,   3, 327,-134, 372, -96, 369,  71,
     c-101, -24,  63, 346, -70,  23, 338,-119, 385,-106, 376,  80,
     c -84, -18,  76, 357, -55,  38, 351,-106, 399,-114, 386,  92,
     c -67, -15,  90, 369, -39,  48, 365, -93, 412,-114, 396, 103,
     c -56,  -9, 104, 382, -23,  60, 379, -80, 425,-121, 410, 116,
     c -42,   0, 118, 393, -10,  71, 392, -69, 437,-110, 423, 129,
     c -27,  12, 134, 403,   2,  81, 406, -57, 449, -72, 437, 142,
     c -12,  28, 153, 420,  19,  96, 420, -45, 463, -34, 450, 156,
     c   2,  47, 172, 441,  36, 113, 434, -28, 477, -27, 463, 172,
     c  15,  67, 189, 458,  51, 127, 451, -11, 493, -32, 478, 186,
     c  27,  84, 201, 475,  65, 137, 467,   9, 506, -39, 492, 200,
     c  42, 101, 213, 489,  82, 148, 480,  22, 517, -43, 503, 212,
     c  56, 119, 227, 505, 100, 159, 491,  31, 527, -47, 514, 222,
     c -12,  46, 183, 410,  -7, 118, 429, -66, 459, -34, 477, 171,
     c -21,  36, 173, 406, -13, 108, 425, -71, 451, -53, 471, 166,
     c -30,  26, 161, 400, -19,  94, 418, -77, 442, -71, 464, 157,
     c -40,  17, 148, 390, -28,  81, 406, -88, 432, -92, 454, 145,
     c -49,   5, 132, 380, -39,  69, 393, -99, 419,-109, 442, 132,
     c -61,  -5, 117, 369, -52,  52, 382,-111, 406,-125, 430, 119,
     c -75, -14, 104, 360, -65,  40, 370,-118, 394,-149, 419, 106,
     c -87, -20,  95, 349, -75,  26, 358,-128, 383,-176, 407,  94,
     c -96, -23,  90, 341, -83,  17, 348,-136, 373,-195, 396,  84,
     c-101, -27,  83, 331, -91,  13, 340,-144, 365,-192, 388,  76,
     c-108, -34,  70, 322,-100,   3, 331,-149, 360,-176, 383,  68,
     c-116, -44,  60, 314,-107, -10, 325,-155, 357,-160, 377,  63,
     c-125, -56,  56, 310,-110, -15, 320,-156, 353,-153, 370,  58,
     c-127, -67,  52, 310,-108, -19, 314,-159, 352,-149, 365,  54,
     c-127, -75,  47, 309,-111, -19, 309,-163, 349,-147, 360,  50,
     c-127, -78,  44, 307,-114, -13, 307,-165, 347,-147, 356,  47,
     c-124, -73,  45, 314,-109, -15, 308,-162, 347,-148, 355,  45,
     c-118, -68,  44, 320,-104,  -7, 311,-157, 348,-142, 357,  46,
     c-113, -60,  48, 322,-103,  -6, 315,-155, 353,-126, 359,  50,
     c-112, -52,  52, 324, -99,  -5, 318,-149, 361,-103, 363,  57,
     c-108, -44,  57, 334, -86,   6, 326,-140, 372,-105, 369,  65,
     c -99, -36,  60, 345, -75,  20, 338,-126, 385,-123, 376,  75,
     c -85, -30,  72, 354, -60,  31, 351,-113, 399,-135, 384,  87,
     c -72, -24,  87, 365, -43,  42, 364, -99, 412,-132, 396,  98,
     c -57, -17, 100, 381, -27,  54, 377, -86, 424,-137, 409, 111,
     c -41,  -6, 116, 392, -13,  65, 389, -76, 436,-124, 423, 124,
     c -27,   7, 133, 402,   1,  74, 401, -63, 448, -84, 437, 138,
     c -14,  25, 152, 418,  16,  87, 415, -50, 463, -44, 451, 152,
     c   1,  47, 171, 440,  34, 108, 430, -32, 479, -35, 464, 168,
     c  18,  68, 192, 460,  54, 122, 447, -14, 494, -37, 479, 184,
     c  34,  88, 206, 476,  67, 134, 466,   5, 508, -41, 492, 198,
     c  50, 106, 219, 491,  84, 146, 481,  20, 519, -46, 505, 210,
     c  65, 122, 233, 505, 101, 157, 493,  32, 528, -54, 516, 220,
     c -21,  26, 168, 403, -22,  99, 419, -84, 443, -60, 467, 155,
     c -33,  13, 156, 395, -30,  86, 412, -86, 434, -86, 460, 149,
     c -45,   1, 143, 387, -39,  68, 403, -94, 425,-110, 451, 139,
     c -57, -11, 132, 379, -47,  59, 389,-109, 413,-136, 440, 126,
     c -68, -24, 117, 367, -60,  46, 377,-119, 401,-157, 426, 113,
     c -81, -38, 101, 355, -73,  29, 366,-130, 389,-168, 413,  99,
     c -94, -50,  91, 347, -84,  20, 353,-140, 377,-184, 401,  86,
     c-106, -56,  82, 334, -96,   4, 343,-150, 365,-203, 389,  74,
     c-114, -59,  74, 319,-107, -11, 333,-156, 355,-215, 379,  63,
     c-117, -60,  68, 311,-112, -18, 326,-160, 348,-205, 372,  56,
     c-120, -62,  59, 308,-118, -20, 321,-166, 344,-184, 368,  49,
     c-126, -66,  49, 303,-121, -29, 316,-169, 342,-162, 363,  44,
     c-133, -72,  45, 298,-122, -33, 310,-171, 341,-148, 358,  40,
     c-134, -79,  45, 301,-121, -31, 306,-176, 340,-144, 355,  37,
     c-132, -84,  41, 305,-124, -28, 300,-179, 339,-145, 352,  34,
     c-132, -84,  37, 303,-125, -28, 298,-180, 339,-146, 349,  33,
     c-131, -79,  39, 306,-119, -30, 300,-177, 340,-147, 349,  32,
     c-126, -72,  44, 314,-113, -20, 304,-171, 344,-146, 351,  36,
     c-119, -65,  49, 319,-107, -15, 310,-164, 351,-135, 355,  43,
     c-116, -58,  55, 325,-100,  -8, 317,-154, 361,-118, 361,  51,
     c-112, -50,  61, 334, -90,   3, 325,-143, 373,-128, 368,  61,
     c-103, -43,  69, 341, -79,  12, 335,-131, 385,-147, 377,  72,
     c -89, -35,  84, 351, -61,  25, 348,-117, 398,-154, 386,  84,
     c -73, -25,  99, 366, -43,  38, 362,-103, 411,-143, 397,  96,
     c -56, -13, 111, 379, -26,  49, 375, -89, 424,-144, 410, 109,
     c -40,   0, 124, 390, -12,  61, 387, -79, 436,-125, 424, 123,
     c -25,  16, 139, 405,   2,  75, 400, -67, 450, -83, 438, 136,
     c -13,  34, 153, 422,  15,  88, 413, -54, 464, -45, 452, 151,
     c   1,  56, 170, 444,  37, 109, 430, -35, 480, -34, 467, 166,
     c  24,  78, 191, 464,  57, 125, 450, -17, 497, -35, 482, 183,
     c  43,  97, 207, 478,  69, 135, 469,   2, 510, -36, 496, 197,
     c  59, 114, 219, 493,  84, 151, 485,  15, 521, -42, 509, 209,
     c  76, 131, 233, 506, 100, 159, 497,  28, 530, -50, 521, 219,
     c -31,   6, 157, 397, -34,  81, 407, -98, 428, -97, 458, 138,
     c -44,  -6, 145, 388, -43,  70, 399,-102, 419,-128, 451, 132,
     c -59, -21, 131, 378, -54,  48, 390,-113, 408,-155, 440, 122,
     c -73, -36, 118, 366, -65,  42, 376,-126, 397,-183, 427, 109,
     c -84, -50, 105, 354, -76,  28, 363,-138, 383,-200, 413,  95,
     c -96, -66,  90, 343, -88,  13, 350,-148, 371,-203, 399,  81,
     c-110, -79,  80, 332,-101,   0, 338,-157, 359,-205, 386,  67,
     c-124, -87,  70, 315,-115, -18, 327,-168, 348,-212, 374,  55,
     c-128, -88,  62, 304,-123, -34, 318,-173, 340,-218, 364,  45,
     c-128, -86,  58, 300,-126, -37, 312,-176, 334,-206, 358,  38,
     c-131, -85,  51, 298,-131, -41, 309,-180, 332,-184, 355,  32,
     c-136, -84,  41, 293,-135, -43, 306,-184, 330,-162, 353,  28,
     c-138, -84,  39, 293,-134, -43, 302,-188, 331,-151, 350,  25,
     c-138, -86,  41, 296,-133, -38, 299,-191, 330,-151, 347,  23,
     c-137, -87,  40, 296,-135, -36, 293,-195, 331,-154, 345,  21,
     c-140, -85,  35, 292,-141, -42, 290,-196, 331,-154, 343,  21,
     c-144, -80,  36, 294,-140, -41, 290,-193, 334,-154, 342,  22,
     c-144, -72,  45, 300,-130, -36, 294,-186, 340,-151, 346,  28,
     c-134, -63,  58, 311,-115, -25, 302,-172, 349,-140, 352,  37,
     c-122, -54,  70, 323,-102, -12, 312,-158, 361,-127, 361,  48,
     c-115, -46,  80, 333, -91,   0, 322,-147, 374,-138, 370,  59,
     c-106, -36,  93, 341, -77,  11, 335,-136, 387,-155, 380,  72,
     c -89, -24, 108, 351, -57,  20, 348,-123, 401,-153, 391,  85,
     c -67, -10, 122, 367, -38,  35, 362,-110, 413,-141, 402,  97,
     c -52,   5, 131, 385, -22,  52, 374, -95, 425,-137, 415, 110,
     c -36,  21, 138, 397, -10,  64, 388, -81, 438,-119, 430, 124,
     c -20,  37, 148, 409,   2,  78, 400, -67, 452, -81, 444, 138,
     c  -9,  54, 159, 427,  18,  92, 417, -54, 467, -51, 457, 152,
     c   5,  73, 172, 452,  37, 118, 435, -36, 484, -44, 471, 167,
     c  29,  94, 192, 471,  58, 131, 455, -18, 500, -44, 487, 183,
     c  49, 110, 207, 482,  73, 138, 473,  -1, 514, -46, 501, 197,
     c  63, 125, 219, 493,  84, 148, 489,   9, 523, -50, 515, 209,
     c  78, 140, 231, 503,  98, 155, 501,  20, 531, -58, 527, 220,
     c -41,  -8, 148, 388, -44,  62, 395,-116, 415,-116, 451, 122,
     c -56, -24, 136, 379, -55,  49, 387,-121, 406,-150, 443, 116,
     c -71, -39, 123, 369, -65,  30, 376,-131, 396,-180, 433, 106,
     c -85, -53, 109, 354, -80,  18, 362,-143, 383,-206, 419,  92,
     c -98, -69,  95, 340, -91,   4, 349,-153, 370,-220, 403,  78,
     c-109, -85,  83, 328,-102,  -7, 337,-164, 358,-214, 386,  63,
     c-123, -99,  71, 315,-118, -20, 323,-177, 346,-204, 373,  50,
     c-135,-108,  59, 299,-130, -38, 311,-185, 337,-203, 362,  38,
     c-137,-109,  54, 293,-138, -47, 305,-192, 329,-209, 353,  28,
     c-137,-106,  52, 292,-142, -50, 300,-195, 324,-202, 348,  22,
     c-140,-100,  45, 291,-146, -51, 298,-198, 323,-188, 347,  18,
     c-142, -94,  39, 289,-145, -48, 296,-198, 324,-176, 347,  16,
     c-138, -88,  39, 291,-142, -46, 296,-198, 326,-171, 345,  15,
     c-135, -83,  43, 294,-141, -38, 294,-199, 326,-174, 343,  15,
     c-137, -79,  41, 291,-145, -41, 291,-198, 327,-179, 341,  14,
     c-145, -76,  38, 285,-152, -50, 286,-202, 328,-176, 339,  14,
     c-150, -70,  42, 286,-149, -50, 285,-200, 333,-171, 340,  17,
     c-146, -62,  57, 295,-136, -41, 292,-188, 341,-167, 346,  25,
     c-133, -51,  77, 310,-117, -24, 302,-171, 351,-159, 353,  36,
     c-118, -42,  93, 322,-104, -11, 314,-156, 365,-147, 364,  48,
     c-104, -31, 111, 338, -85,   4, 326,-144, 380,-155, 376,  62,
     c -95, -20, 124, 349, -68,  14, 339,-135, 393,-169, 388,  75,
     c -77,  -4, 136, 358, -51,  21, 354,-123, 405,-164, 399,  89,
     c -56,  13, 144, 374, -35,  37, 368,-109, 418,-148, 412, 101,
     c -38,  31, 152, 395, -20,  56, 382, -92, 430,-141, 425, 115,
     c -19,  48, 157, 409,  -9,  69, 397, -78, 442,-124, 437, 128,
     c  -6,  62, 163, 420,   5,  81, 411, -64, 456, -92, 450, 141,
     c   2,  77, 172, 437,  23,  95, 428, -53, 472, -69, 464, 154,
     c  17,  94, 183, 460,  42, 118, 444, -36, 488, -66, 477, 168,
     c  38, 109, 197, 473,  61, 130, 463, -18, 503, -71, 492, 184,
     c  54, 122, 208, 482,  75, 138, 481,  -5, 517, -74, 507, 197,
     c  67, 134, 220, 493,  87, 148, 492,   6, 527, -76, 521, 209,
     c  80, 146, 231, 503,  98, 157, 505,  15, 534, -78, 534, 220,
     c -54, -18, 136, 376, -57,  43, 382,-134, 407,-113, 446, 106,
     c -68, -34, 123, 364, -68,  26, 374,-139, 399,-147, 437,  99,
     c -82, -48, 113, 356, -80,  12, 364,-147, 388,-176, 426,  90,
     c -96, -63, 101, 341, -93,  -4, 350,-160, 374,-201, 413,  77,
     c-109, -78,  87, 326,-106, -17, 336,-171, 361,-213, 395,  62,
     c-121, -93,  74, 315,-119, -26, 324,-180, 348,-205, 378,  48,
     c-134,-109,  60, 303,-132, -37, 312,-192, 337,-191, 364,  34,
     c-139,-117,  50, 292,-142, -51, 299,-200, 328,-191, 354,  23,
     c-142,-120,  45, 286,-149, -56, 292,-208, 321,-200, 347,  14,
     c-144,-116,  43, 286,-154, -55, 289,-209, 319,-207, 344,  10,
     c-147,-107,  38, 290,-155, -54, 287,-211, 320,-205, 345,   8,
     c-144, -96,  36, 289,-154, -50, 288,-208, 323,-206, 345,   9,
     c-135, -83,  42, 294,-147, -45, 291,-205, 326,-208, 344,  10,
     c-128, -73,  46, 296,-144, -39, 294,-201, 328,-212, 344,  11,
     c-132, -66,  45, 294,-146, -43, 294,-197, 330,-213, 344,  12,
     c-138, -60,  46, 290,-146, -50, 293,-196, 333,-209, 343,  15,
     c-138, -53,  55, 295,-138, -44, 294,-191, 338,-203, 344,  19,
     c-130, -45,  72, 306,-124, -35, 301,-179, 347,-201, 351,  28,
     c-116, -37,  95, 319,-111, -19, 314,-163, 360,-191, 362,  41,
     c -97, -27, 116, 333, -92,  -5, 327,-149, 374,-179, 373,  54,
     c -82, -17, 134, 349, -74,  12, 340,-135, 388,-186, 386,  68,
     c -71,  -4, 146, 361, -60,  23, 353,-127, 401,-195, 399,  82,
     c -57,  10, 153, 367, -48,  24, 367,-115, 414,-186, 411,  95,
     c -38,  30, 164, 384, -33,  43, 381,-102, 425,-172, 423, 108,
     c -17,  50, 171, 404, -18,  60, 397, -86, 437,-170, 435, 120,
     c   0,  65, 174, 418,  -7,  72, 412, -72, 449,-151, 447, 132,
     c  10,  79, 181, 433,  10,  86, 426, -59, 463,-117, 458, 144,
     c  17,  91, 187, 448,  29, 100, 441, -47, 478, -95, 470, 156,
     c  30, 103, 193, 461,  46, 117, 456, -31, 493, -93, 483, 169,
     c  49, 114, 201, 473,  62, 129, 472, -17, 507, -95, 497, 183,
     c  61, 124, 210, 485,  77, 142, 487,  -5, 519, -98, 512, 196,
     c  74, 134, 221, 495,  88, 151, 500,   5, 528, -99, 524, 207,
     c  85, 143, 231, 503,  97, 159, 508,  15, 535, -97, 536, 217,
     c -63, -21, 125, 366, -72,  30, 372,-144, 403,-105, 437,  90,
     c -77, -35, 114, 356, -83,  15, 363,-151, 394,-135, 430,  84,
     c -89, -50, 103, 345, -95,   0, 354,-159, 383,-161, 420,  75,
     c-104, -65,  94, 332,-106, -14, 341,-172, 370,-186, 405,  62,
     c-116, -80,  82, 322,-118, -24, 327,-183, 356,-200, 388,  47,
     c-126, -95,  67, 314,-131, -33, 314,-194, 342,-196, 372,  33,
     c-135,-109,  53, 299,-143, -45, 301,-206, 332,-181, 359,  20,
     c-141,-119,  43, 289,-152, -57, 289,-212, 324,-182, 349,  10,
     c-143,-122,  37, 285,-158, -57, 283,-218, 319,-200, 343,   3,
     c-146,-116,  35, 287,-159, -55, 280,-218, 318,-215, 343,   1,
     c-149,-106,  33, 288,-160, -57, 283,-216, 321,-223, 346,   1,
     c-145, -92,  35, 291,-154, -53, 286,-209, 326,-227, 349,   5,
     c-132, -76,  43, 297,-146, -46, 291,-201, 331,-227, 349,   9,
     c-119, -62,  52, 302,-142, -37, 298,-194, 337,-225, 350,  13,
     c-117, -53,  56, 305,-135, -32, 303,-185, 341,-221, 351,  17,
     c-120, -46,  58, 308,-126, -31, 306,-181, 345,-215, 353,  21,
     c-118, -42,  65, 313,-118, -22, 312,-173, 352,-215, 356,  28,
     c-108, -36,  81, 322,-107, -16, 321,-163, 360,-220, 364,  38,
     c -92, -29, 101, 336, -91,   0, 331,-151, 373,-213, 375,  51,
     c -72, -22, 120, 350, -74,  14, 344,-138, 386,-202, 387,  64,
     c -58, -13, 135, 364, -61,  27, 356,-127, 400,-209, 399,  77,
     c -50,  -1, 146, 373, -50,  37, 368,-117, 413,-215, 411,  90,
     c -37,  16, 158, 384, -36,  38, 380,-105, 424,-209, 423, 102,
     c -17,  35, 170, 399, -22,  54, 396, -93, 436,-206, 434, 114,
     c   1,  55, 178, 417,  -8,  66, 411, -79, 446,-207, 445, 125,
     c  12,  70, 184, 431,   2,  80, 424, -67, 457,-185, 456, 136,
     c  19,  81, 189, 442,  15,  88, 437, -55, 470,-148, 465, 146,
     c  25,  90, 192, 452,  32,  98, 450, -45, 483,-120, 474, 156,
     c  37,  98, 195, 463,  48, 112, 464, -31, 497,-113, 485, 167,
     c  55, 107, 203, 475,  64, 123, 478, -20, 509,-113, 499, 180,
     c  65, 112, 208, 485,  76, 135, 492,  -9, 520,-115, 512, 191,
     c  75, 120, 217, 492,  85, 141, 502,   1, 529,-114, 524, 202,
     c  85, 128, 227, 500,  94, 149, 510,  11, 534,-112, 536, 211,
     c -68, -18, 117, 358, -82,  25, 363,-157, 399,-132, 429,  75,
     c -80, -33, 106, 350, -93,   5, 355,-163, 391,-152, 423,  69,
     c -92, -47,  97, 341,-104, -10, 345,-171, 381,-174, 414,  61,
     c-106, -61,  87, 329,-116, -22, 333,-184, 367,-199, 400,  48,
     c-119, -78,  76, 319,-129, -34, 319,-195, 353,-216, 384,  34,
     c-130, -94,  62, 310,-142, -41, 304,-207, 340,-217, 366,  20,
     c-138,-109,  48, 295,-154, -53, 292,-216, 330,-202, 354,   8,
     c-143,-118,  39, 286,-161, -62, 282,-222, 323,-197, 346,   0,
     c-143,-118,  34, 288,-162, -55, 276,-225, 319,-212, 342,  -5,
     c-147,-113,  33, 289,-163, -50, 277,-223, 320,-226, 344,  -6,
     c-148,-100,  34, 290,-161, -55, 280,-216, 325,-230, 350,  -1,
     c-141, -85,  39, 294,-151, -49, 288,-205, 333,-227, 355,   5,
     c-124, -67,  49, 305,-140, -38, 297,-194, 342,-216, 358,  13,
     c-108, -52,  62, 315,-131, -25, 308,-182, 350,-201, 361,  20,
     c-101, -42,  71, 322,-121, -18, 316,-173, 357,-189, 365,  27,
     c-100, -39,  70, 326,-109, -16, 322,-164, 363,-184, 368,  33,
     c -96, -38,  73, 332,-100,  -5, 330,-159, 370,-192, 373,  41,
     c -89, -36,  81, 338, -90,  -1, 339,-152, 379,-206, 380,  52,
     c -74, -33,  95, 350, -76,  12, 349,-143, 391,-206, 390,  62,
     c -55, -28, 108, 364, -63,  27, 360,-131, 403,-199, 400,  74,
     c -42, -19, 118, 377, -51,  35, 370,-121, 415,-205, 411,  87,
     c -35,  -7, 126, 385, -40,  41, 381,-111, 426,-215, 423,  98,
     c -25,  11, 140, 398, -26,  45, 391,-101, 436,-218, 432, 108,
     c  -6,  31, 156, 415, -10,  62, 406, -90, 446,-230, 442, 119,
     c   3,  49, 165, 430,   0,  72, 419, -76, 455,-240, 451, 128,
     c  12,  62, 173, 440,  10,  83, 431, -65, 465,-218, 460, 137,
     c  20,  70, 180, 448,  22,  89, 442, -55, 476,-176, 468, 145,
     c  25,  75, 183, 454,  35,  96, 452, -48, 487,-145, 476, 152,
     c  33,  81, 186, 463,  49, 106, 464, -38, 498,-132, 486, 161,
     c  47,  88, 195, 473,  63, 118, 477, -26, 509,-129, 498, 171,
     c  62,  94, 204, 482,  75, 128, 489, -16, 517,-134, 510, 182,
     c  70, 100, 212, 489,  82, 132, 498,  -7, 525,-131, 521, 192,
     c  77, 107, 219, 495,  88, 140, 503,  -1, 531,-124, 532, 201,
     c -72, -13, 107, 352, -90,  15, 353,-163, 395,-163, 421,  62,
     c -82, -26,  96, 346,-100,   1, 348,-167, 388,-167, 418,  57,
     c -91, -37,  87, 339,-110, -11, 340,-176, 379,-182, 410,  50,
     c-103, -52,  76, 326,-124, -20, 327,-188, 367,-211, 398,  38,
     c-120, -69,  63, 314,-138, -35, 312,-198, 352,-238, 380,  24,
     c-134, -89,  50, 302,-151, -51, 298,-211, 340,-242, 364,  11,
     c-140,-103,  42, 291,-160, -59, 286,-220, 331,-225, 352,   0,
     c-142,-110,  39, 285,-167, -64, 277,-228, 324,-220, 344,  -7,
     c-145,-111,  38, 288,-167, -56, 274,-228, 323,-228, 341, -10,
     c-146,-104,  41, 293,-163, -49, 276,-225, 326,-233, 345,  -8,
     c-145, -91,  45, 295,-157, -52, 283,-213, 334,-231, 353,   0,
     c-130, -73,  54, 303,-144, -43, 294,-201, 344,-224, 360,   9,
     c-108, -54,  68, 319,-128, -24, 309,-187, 356,-202, 367,  20,
     c -92, -39,  82, 331,-113, -11, 321,-174, 367,-176, 373,  32,
     c -86, -30,  89, 340,-103,  -1, 331,-162, 376,-158, 380,  42,
     c -82, -28,  85, 344, -94,   1, 340,-154, 384,-156, 387,  50,
     c -75, -30,  81, 349, -85,   8, 347,-147, 391,-171, 392,  59,
     c -67, -32,  82, 355, -75,  12, 355,-141, 399,-192, 399,  68,
     c -58, -32,  86, 362, -64,  19, 365,-135, 409,-194, 407,  76,
     c -42, -28,  93, 374, -50,  32, 373,-125, 420,-188, 415,  85,
     c -33, -21, 100, 387, -39,  41, 381,-117, 430,-194, 422,  94,
     c -30,  -8, 105, 397, -31,  48, 389,-109, 438,-207, 430, 103,
     c -20,   7, 114, 407, -20,  50, 399, -98, 447,-221, 439, 111,
     c  -7,  26, 127, 423,  -5,  61, 409, -89, 454,-249, 446, 119,
     c   0,  40, 138, 435,   5,  71, 422, -77, 461,-271, 454, 126,
     c   8,  48, 144, 442,   9,  77, 431, -70, 469,-250, 462, 132,
     c  18,  52, 153, 450,  20,  85, 439, -63, 477,-206, 468, 138,
     c  23,  55, 164, 456,  36,  94, 447, -60, 486,-175, 475, 145,
     c  27,  60, 172, 461,  47, 100, 456, -51, 495,-159, 484, 152,
     c  37,  67, 179, 468,  54, 108, 468, -41, 504,-152, 496, 160,
     c  49,  75, 189, 478,  63, 119, 479, -34, 512,-159, 505, 169,
     c  57,  82, 197, 483,  68, 121, 487, -26, 518,-153, 515, 178,
     c  65,  89, 204, 489,  72, 126, 493, -21, 524,-144, 524, 186,
     c -76,  -7,  94, 348,-101,   5, 344,-171, 391,-176, 413,  52,
     c -82, -16,  83, 343,-109,  -6, 342,-172, 386,-165, 412,  48,
     c -88, -26,  73, 336,-118, -15, 334,-179, 379,-172, 407,  42,
     c -96, -38,  61, 326,-131, -26, 322,-190, 367,-207, 395,  30,
     c-113, -56,  49, 313,-144, -35, 307,-202, 355,-238, 380,  18,
     c-130, -75,  39, 299,-156, -52, 294,-214, 344,-253, 364,   6,
     c-138, -90,  33, 289,-165, -61, 283,-221, 335,-243, 352,  -3,
     c-141, -97,  38, 286,-167, -61, 277,-229, 331,-239, 343,  -9,
     c-142, -98,  44, 290,-166, -53, 276,-228, 330,-242, 341, -11,
     c-140, -90,  50, 297,-161, -46, 281,-224, 334,-246, 347,  -6,
     c-134, -78,  58, 302,-149, -47, 290,-210, 344,-241, 356,   3,
     c-116, -60,  72, 314,-130, -35, 305,-198, 358,-233, 367,  16,
     c -92, -40,  89, 333,-112, -15, 321,-179, 372,-208, 376,  31,
     c -78, -23, 104, 347, -95,   1, 337,-165, 385,-177, 386,  45,
     c -72, -13, 109, 355, -82,  13, 349,-150, 397,-156, 396,  57,
     c -64,  -9, 104, 360, -73,  19, 359,-142, 405,-154, 404,  67,
     c -53, -11,  95, 366, -66,  25, 366,-137, 413,-172, 410,  75,
     c -45, -13,  90, 372, -58,  26, 374,-130, 419,-194, 417,  81,
     c -40, -14,  87, 378, -49,  34, 380,-127, 426,-191, 422,  87,
     c -30, -11,  90, 389, -35,  44, 387,-119, 434,-178, 426,  92,
     c -24,  -6,  90, 398, -28,  48, 393,-113, 441,-180, 431,  97,
     c -23,   2,  90, 406, -24,  52, 396,-109, 448,-196, 436, 103,
     c -21,  14,  94, 411, -18,  50, 402,-100, 454,-217, 441, 108,
     c -12,  28, 104, 422,  -5,  58, 411, -94, 459,-258, 447, 113,
     c  -3,  37, 109, 432,   1,  63, 421, -85, 462,-291, 454, 117,
     c   6,  40, 116, 436,   4,  68, 427, -80, 468,-276, 459, 122,
     c  13,  39, 129, 442,  14,  74, 432, -76, 474,-237, 466, 128,
     c  19,  40, 144, 451,  29,  85, 438, -73, 481,-210, 473, 134,
     c  23,  45, 153, 454,  34,  88, 446, -68, 489,-196, 482, 140,
     c  28,  55, 159, 460,  39,  91, 456, -59, 495,-186, 492, 147,
     c  36,  67, 171, 472,  47, 102, 466, -49, 502,-191, 501, 154,
     c  43,  74, 179, 476,  52, 105, 474, -43, 508,-180, 509, 162,
     c  49,  81, 186, 482,  55, 109, 480, -37, 513,-165, 516, 169,
     c -89,  -7,  79, 346,-117,  -1, 334,-176, 387,-178, 405,  41,
     c -92, -13,  69, 340,-123, -13, 333,-177, 384,-152, 407,  38,
     c -94, -19,  61, 335,-130, -17, 328,-184, 378,-151, 403,  34,
     c -95, -25,  51, 329,-136, -24, 317,-193, 369,-184, 394,  24,
     c-107, -41,  39, 316,-146, -33, 305,-205, 359,-224, 380,  14,
     c-123, -59,  27, 302,-157, -49, 294,-212, 350,-248, 364,   4,
     c-130, -73,  26, 294,-163, -57, 285,-220, 343,-247, 351,  -3,
     c-133, -80,  35, 294,-163, -56, 281,-226, 339,-252, 343,  -8,
     c-135, -82,  42, 295,-162, -50, 283,-225, 339,-260, 343,  -7,
     c-131, -75,  49, 300,-155, -47, 288,-219, 346,-266, 349,  -1,
     c-118, -62,  62, 309,-141, -42, 301,-205, 357,-265, 360,  10,
     c-101, -45,  79, 325,-117, -26, 318,-192, 372,-258, 372,  25,
     c -82, -24,  97, 342, -96,  -7, 336,-171, 388,-233, 384,  42,
     c -68,  -5, 113, 356, -79,   8, 353,-156, 403,-197, 396,  58,
     c -58,   7, 122, 369, -64,  20, 368,-141, 415,-173, 409,  71,
     c -48,  13, 118, 375, -53,  26, 377,-131, 425,-172, 418,  81,
     c -33,  14, 110, 382, -48,  32, 384,-125, 431,-190, 425,  88,
     c -26,  14, 105, 389, -41,  38, 390,-120, 436,-211, 429,  91,
     c -23,  14, 101, 397, -31,  48, 394,-116, 441,-202, 433,  94,
     c -18,  15,  97, 405, -23,  52, 397,-113, 446,-181, 434,  95,
     c -16,  18,  91, 409, -21,  54, 399,-110, 450,-173, 435,  96,
     c -17,  23,  89, 412, -20,  56, 401,-107, 453,-185, 437,  98,
     c -21,  30,  92, 415, -18,  53, 403,-100, 454,-211, 440, 100,
     c -16,  38,  96, 421, -10,  58, 407, -98, 456,-259, 443, 103,
     c -10,  42,  96, 425,  -5,  53, 412, -93, 459,-291, 448, 105,
     c   1,  42, 105, 428,   0,  56, 416, -93, 462,-282, 454, 110,
     c  10,  39, 118, 433,   9,  64, 421, -92, 466,-252, 459, 115,
     c  14,  38, 128, 441,  16,  69, 426, -91, 472,-235, 467, 121,
     c  18,  44, 137, 446,  20,  75, 436, -85, 478,-218, 477, 128,
     c  23,  57, 146, 454,  23,  78, 446, -78, 485,-207, 487, 134,
     c  32,  70, 155, 466,  32,  89, 457, -68, 490,-203, 495, 140,
     c  37,  77, 162, 469,  35,  93, 466, -57, 495,-186, 501, 147,
     c  44,  84, 168, 475,  39,  96, 469, -50, 499,-161, 506, 151,
     c-104, -15,  68, 339,-131,  -8, 322,-193, 381,-204, 394,  29,
     c-104, -16,  61, 336,-134, -13, 323,-193, 380,-164, 399,  28,
     c-105, -16,  54, 334,-136, -17, 321,-196, 377,-154, 398,  25,
     c-102, -16,  48, 330,-141, -18, 314,-200, 372,-180, 391,  19,
     c-109, -24,  35, 318,-147, -28, 303,-208, 365,-218, 378,  11,
     c-119, -38,  23, 308,-152, -45, 294,-216, 357,-247, 365,   3,
     c-120, -50,  23, 304,-155, -49, 290,-221, 352,-255, 353,  -2,
     c-121, -57,  30, 302,-157, -50, 289,-221, 349,-267, 345,  -4,
     c-123, -60,  34, 303,-153, -46, 294,-219, 352,-284, 345,  -1,
     c-118, -56,  41, 307,-145, -42, 301,-211, 359,-295, 353,   5,
     c-104, -44,  55, 318,-131, -34, 314,-198, 372,-298, 365,  18,
     c -86, -26,  74, 336,-108, -15, 329,-183, 386,-293, 379,  35,
     c -69,  -6,  93, 353, -86,   2, 348,-164, 403,-265, 392,  52,
     c -55,  14, 110, 366, -67,  15, 367,-146, 419,-225, 406,  69,
     c -45,  28, 122, 379, -53,  27, 384,-131, 432,-200, 419,  82,
     c -30,  37, 126, 392, -38,  38, 395,-120, 440,-199, 429,  91,
     c -14,  41, 125, 400, -31,  40, 400,-114, 446,-221, 435,  96,
     c  -9,  41, 123, 405, -25,  44, 403,-111, 449,-241, 439,  97,
     c -11,  42, 121, 410, -20,  53, 404,-111, 452,-230, 440,  96,
     c -11,  42, 112, 411, -18,  51, 405,-112, 453,-200, 439,  93,
     c -13,  42, 103, 413, -19,  54, 404,-113, 454,-183, 437,  90,
     c -19,  42,  98, 412, -20,  53, 401,-116, 452,-190, 435,  89,
     c -23,  43, 102, 415, -17,  51, 400,-115, 451,-213, 435,  89,
     c -23,  47, 105, 419, -13,  55, 399,-115, 449,-256, 437,  89,
     c -21,  47, 104, 420, -12,  48, 401,-115, 449,-282, 441,  91,
     c -12,  46, 108, 419,  -9,  47, 403,-114, 451,-273, 446,  94,
     c   1,  43, 117, 423,  -1,  52, 409,-111, 455,-253, 451, 100,
     c   7,  43, 125, 431,   5,  57, 416,-104, 460,-247, 459, 107,
     c   9,  51, 132, 440,   7,  65, 426, -98, 468,-233, 469, 115,
     c  17,  62, 137, 447,   5,  70, 437, -90, 473,-219, 480, 121,
     c  32,  77, 147, 459,  17,  80, 449, -80, 478,-215, 487, 127,
     c  34,  82, 150, 463,  19,  81, 456, -69, 482,-189, 492, 132,
     c  38,  87, 153, 471,  25,  85, 461, -55, 485,-146, 495, 136,
     c-120, -28,  55, 327,-148, -20, 310,-208, 372,-190, 379,  15,
     c-118, -23,  52, 328,-145, -25, 313,-207, 374,-141, 387,  16,
     c-116, -19,  49, 330,-143, -30, 312,-206, 374,-125, 390,  16,
     c-110, -11,  48, 328,-141, -29, 310,-208, 372,-146, 385,  12,
     c-113, -11,  40, 319,-145, -37, 304,-214, 369,-187, 376,   8,
     c-113, -17,  31, 314,-147, -41, 300,-216, 365,-222, 366,   4,
     c-108, -26,  29, 311,-149, -42, 298,-217, 362,-242, 356,   1,
     c-108, -34,  31, 308,-149, -45, 300,-214, 361,-270, 349,   2,
     c-108, -38,  31, 309,-144, -42, 306,-210, 364,-298, 351,   6,
     c-103, -35,  37, 317,-133, -36, 316,-200, 372,-316, 359,  14,
     c -91, -26,  51, 330,-118, -26, 328,-188, 385,-324, 373,  27,
     c -70,  -9,  69, 347, -98,  -9, 343,-174, 402,-323, 387,  44,
     c -54,   9,  85, 364, -77,   8, 361,-157, 419,-294, 401,  60,
     c -42,  28, 105, 378, -58,  25, 381,-140, 434,-250, 414,  76,
     c -32,  42, 119, 392, -41,  34, 395,-125, 445,-229, 426,  89,
     c -15,  52, 128, 406, -24,  47, 407,-114, 453,-238, 435,  96,
     c  -3,  56, 133, 414, -18,  50, 411,-109, 457,-266, 441, 100,
     c  -3,  58, 136, 417, -17,  47, 411,-108, 459,-289, 443,  97,
     c -10,  58, 133, 417, -17,  51, 408,-110, 457,-281, 442,  93,
     c -13,  57, 123, 413, -20,  40, 405,-114, 456,-246, 439,  88,
     c -18,  54, 113, 409, -26,  37, 400,-118, 453,-219, 436,  82,
     c -27,  48, 108, 405, -30,  36, 395,-124, 448,-215, 433,  77,
     c -34,  45, 112, 407, -26,  39, 388,-130, 443,-227, 431,  75,
     c -38,  44, 117, 408, -23,  39, 387,-134, 439,-252, 431,  73,
     c -38,  44, 116, 410, -23,  38, 387,-136, 438,-264, 433,  74,
     c -29,  41, 117, 409, -23,  37, 391,-136, 438,-250, 438,  78,
     c -15,  41, 124, 413, -17,  40, 397,-133, 443,-239, 444,  85,
     c  -6,  44, 132, 422,  -9,  47, 406,-122, 450,-247, 452,  93,
     c   1,  50, 137, 430,  -8,  51, 418,-114, 457,-246, 463, 102,
     c  13,  59, 138, 437, -10,  55, 429,-103, 463,-234, 472, 109,
     c  24,  70, 145, 450,   0,  63, 439, -94, 468,-227, 479, 115,
     c  28,  74, 145, 457,   3,  63, 447, -81, 472,-194, 483, 118,
     c  29,  76, 147, 462,   8,  68, 450, -69, 474,-141, 483, 121,
     c-133, -46,  35, 311,-162, -39, 297,-227, 360,-174, 360,  -1,
     c-128, -37,  38, 318,-153, -41, 303,-223, 365,-121, 370,   1,
     c-123, -29,  40, 321,-148, -42, 306,-219, 368,-102, 375,   4,
     c-115, -13,  47, 326,-142, -33, 307,-216, 370,-122, 376,   4,
     c-109,  -7,  50, 323,-143, -37, 306,-215, 370,-162, 371,   4,
     c-104,  -7,  45, 321,-145, -40, 306,-215, 370,-205, 365,   4,
     c -96, -12,  39, 317,-145, -37, 307,-214, 370,-239, 359,   5,
     c -94, -17,  38, 316,-140, -48, 312,-208, 371,-273, 355,   7,
     c -93, -21,  39, 318,-133, -39, 319,-201, 376,-304, 360,  14,
     c -88, -18,  44, 328,-122, -30, 331,-191, 386,-322, 369,  23,
     c -76, -11,  55, 342,-105, -14, 341,-179, 399,-326, 383,  36,
     c -59,   2,  69, 357, -86,   0, 357,-165, 415,-321, 396,  50,
     c -44,  18,  85, 373, -68,  19, 373,-151, 432,-289, 409,  66,
     c -34,  34, 105, 390, -48,  32, 390,-136, 446,-244, 421,  80,
     c -24,  46, 121, 404, -29,  41, 403,-123, 456,-229, 431,  91,
     c -11,  54, 128, 416, -15,  50, 412,-114, 462,-254, 440,  97,
     c  -4,  56, 135, 422, -10,  49, 414,-113, 464,-297, 443,  96,
     c -10,  56, 139, 423, -13,  46, 411,-115, 462,-332, 444,  93,
     c -20,  56, 134, 419, -19,  45, 403,-122, 458,-332, 442,  86,
     c -26,  54, 124, 412, -25,  35, 398,-129, 453,-303, 438,  78,
     c -31,  48, 115, 402, -34,  28, 390,-134, 446,-269, 434,  70,
     c -35,  40, 110, 396, -38,  25, 384,-144, 438,-252, 430,  64,
     c -46,  34, 113, 396, -40,  22, 376,-154, 432,-247, 429,  60,
     c -53,  31, 117, 395, -39,  20, 374,-157, 426,-252, 428,  57,
     c -51,  30, 117, 394, -38,  16, 374,-157, 425,-244, 430,  58,
     c -41,  30, 120, 395, -37,  14, 377,-155, 427,-227, 434,  63,
     c -29,  33, 127, 403, -33,  24, 387,-148, 433,-230, 440,  71,
     c -17,  38, 137, 414, -25,  33, 397,-134, 441,-253, 448,  80,
     c  -5,  44, 144, 422, -22,  35, 410,-124, 449,-264, 458,  89,
     c   4,  50, 143, 427, -21,  39, 419,-114, 456,-264, 467,  97,
     c  14,  56, 143, 439, -13,  44, 429,-103, 460,-259, 473, 102,
     c  14,  55, 142, 445, -11,  43, 433, -92, 462,-221, 476, 105,
     c  15,  55, 142, 453,  -6,  49, 436, -82, 462,-158, 475, 107,
     c-150, -67,  11, 291,-175, -61, 282,-249, 342,-195, 337, -21,
     c-142, -55,  18, 302,-161, -59, 291,-239, 349,-143, 350, -15,
     c-133, -43,  26, 312,-149, -61, 299,-231, 357,-123, 359, -10,
     c-120, -25,  42, 321,-141, -44, 305,-223, 362,-144, 364,  -5,
     c-109, -14,  52, 323,-139, -45, 308,-218, 368,-186, 366,   0,
     c-100, -10,  53, 323,-139, -43, 310,-215, 372,-228, 365,   3,
     c -91, -10,  53, 323,-136, -34, 313,-209, 375,-262, 363,   8,
     c -84, -12,  55, 326,-128, -41, 322,-204, 380,-291, 363,  13,
     c -82, -12,  58, 331,-120, -33, 331,-196, 387,-312, 369,  21,
     c -77, -10,  60, 339,-108, -22, 342,-187, 398,-315, 382,  31,
     c -64,  -2,  70, 355, -91,  -5, 354,-175, 412,-310, 394,  44,
     c -50,   8,  82, 372, -71,  11, 368,-162, 428,-294, 407,  57,
     c -38,  21,  95, 387, -54,  28, 382,-149, 443,-258, 419,  71,
     c -27,  33, 111, 401, -37,  36, 397,-135, 457,-215, 429,  83,
     c -20,  42, 123, 415, -22,  45, 408,-126, 465,-215, 437,  91,
     c -13,  45, 131, 424, -14,  52, 412,-119, 468,-257, 441,  93,
     c -11,  43, 132, 425, -12,  47, 411,-120, 467,-314, 444,  91,
     c -21,  39, 132, 421, -18,  38, 404,-125, 461,-358, 442,  84,
     c -33,  36, 126, 416, -30,  38, 396,-134, 453,-374, 437,  76,
     c -40,  33, 118, 405, -37,  26, 387,-144, 444,-353, 432,  66,
     c -43,  27, 109, 394, -42,  17, 378,-150, 435,-320, 428,  57,
     c -50,  18, 105, 388, -50,  14, 369,-162, 426,-297, 425,  49,
     c -57,  12, 108, 385, -59,   7, 364,-170, 418,-278, 424,  45,
     c -64,   9, 106, 381, -59,   0, 362,-176, 413,-264, 424,  42,
     c -60,  11, 107, 380, -56,  -3, 365,-174, 412,-237, 427,  44,
     c -46,  16, 114, 386, -53,   0, 370,-170, 416,-218, 431,  49,
     c -33,  24, 123, 395, -48,  10, 380,-162, 424,-231, 437,  58,
     c -24,  32, 133, 407, -39,  22, 391,-150, 434,-270, 446,  68,
     c -11,  40, 142, 416, -31,  24, 404,-138, 444,-288, 454,  77,
     c  -4,  42, 142, 420, -31,  28, 412,-126, 450,-292, 461,  84,
     c   1,  46, 139, 430, -26,  30, 419,-117, 454,-288, 466,  88,
     c  -1,  39, 135, 433, -28,  26, 422,-109, 454,-253, 468,  91,
     c  -3,  34, 133, 438, -26,  34, 419,-105, 452,-194, 467,  91,
     c-165, -87,  -9, 268,-187, -86, 263,-280, 322,-271, 313, -41,
     c-154, -73,   1, 284,-170, -81, 275,-264, 332,-224, 329, -33,
     c-143, -58,  12, 299,-154, -79, 288,-250, 342,-210, 342, -24,
     c-127, -39,  33, 313,-142, -60, 300,-234, 352,-230, 352, -15,
     c-113, -26,  45, 318,-136, -54, 306,-226, 363,-269, 361,  -6,
     c-101, -17,  56, 323,-130, -44, 311,-219, 373,-300, 365,   2,
     c -91, -12,  64, 329,-124, -34, 317,-214, 381,-318, 369,  11,
     c -85, -11,  70, 336,-117, -33, 328,-205, 388,-323, 374,  18,
     c -78, -10,  78, 346,-105, -24, 339,-193, 398,-318, 382,  28,
     c -68,  -6,  84, 358, -90, -12, 351,-183, 411,-300, 394,  39,
     c -55,   1,  93, 373, -76,   4, 366,-170, 425,-279, 407,  52,
     c -43,  11, 101, 391, -57,  21, 377,-157, 440,-257, 419,  64,
     c -31,  21, 109, 405, -40,  39, 390,-145, 455,-223, 428,  75,
     c -23,  29, 118, 415, -29,  44, 399,-134, 466,-190, 436,  84,
     c -19,  34, 128, 426, -22,  47, 405,-126, 471,-206, 442,  88,
     c -14,  33, 135, 431, -18,  54, 408,-124, 471,-256, 444,  89,
     c -15,  28, 133, 427, -19,  48, 403,-128, 466,-312, 444,  83,
     c -26,  20, 128, 419, -29,  38, 396,-138, 457,-356, 439,  75,
     c -39,  14, 121, 409, -40,  30, 385,-149, 445,-377, 432,  65,
     c -46,  10, 113, 397, -48,  17, 378,-161, 433,-364, 426,  53,
     c -53,   4, 105, 386, -53,   2, 368,-170, 422,-340, 421,  43,
     c -63,  -2,  99, 378, -62,  -1, 360,-185, 412,-323, 419,  35,
     c -70,  -8,  96, 371, -71, -12, 354,-191, 404,-310, 420,  31,
     c -73,  -8,  92, 369, -75, -19, 353,-196, 401,-288, 420,  28,
     c -68,  -4,  94, 374, -71, -15, 356,-193, 403,-254, 423,  30,
     c -54,   5,  99, 381, -70, -11, 364,-184, 408,-238, 427,  37,
     c -40,  16, 107, 388, -66,  -3, 375,-170, 418,-261, 434,  46,
     c -29,  28, 120, 399, -55,   9, 387,-156, 429,-304, 440,  56,
     c -21,  36, 131, 410, -47,  17, 401,-143, 438,-323, 448,  64,
     c -14,  37, 136, 416, -48,  22, 408,-133, 444,-327, 453,  70,
     c -13,  37, 140, 423, -45,  20, 412,-126, 446,-327, 458,  73,
     c -21,  27, 133, 421, -51,  13, 413,-120, 445,-296, 457,  75,
     c -27,  17, 128, 422, -54,  15, 408,-119, 441,-245, 455,  74,
     c-184,-104, -19, 246,-209,-120, 241,-302, 302,-332, 291, -61,
     c-168, -89,  -5, 268,-187,-105, 258,-285, 315,-292, 309, -49,
     c-152, -73,  10, 290,-164, -94, 275,-266, 328,-280, 326, -38,
     c-130, -51,  31, 306,-145, -73, 293,-249, 344,-309, 343, -24,
     c-117, -37,  44, 316,-134, -64, 304,-234, 359,-343, 357, -11,
     c-102, -24,  59, 327,-123, -49, 314,-225, 373,-360, 368,   1,
     c -91, -15,  71, 337,-114, -39, 325,-214, 386,-358, 376,  12,
     c -83, -10,  84, 348,-102, -33, 336,-203, 397,-339, 384,  23,
     c -72,  -6,  99, 364, -87, -15, 349,-190, 410,-310, 395,  34,
     c -59,  -1, 108, 379, -71,   0, 363,-178, 423,-270, 408,  46,
     c -45,   5, 116, 393, -57,  17, 377,-166, 438,-246, 419,  58,
     c -32,  14, 120, 407, -42,  31, 388,-152, 451,-228, 428,  69,
     c -24,  21, 121, 421, -30,  45, 398,-143, 464,-206, 436,  78,
     c -20,  26, 124, 429, -24,  48, 404,-134, 473,-190, 441,  84,
     c -18,  30, 134, 435, -20,  50, 405,-129, 475,-218, 444,  86,
     c -14,  28, 139, 434, -18,  48, 404,-129, 472,-267, 445,  84,
     c -16,  21, 136, 426, -23,  40, 399,-135, 463,-312, 442,  76,
     c -27,  13, 131, 416, -35,  31, 389,-148, 451,-336, 437,  66,
     c -40,   6, 120, 403, -47,  20, 377,-161, 437,-347, 429,  55,
     c -49,   1, 109, 389, -56,   4, 368,-174, 423,-340, 421,  42,
     c -58,  -3,  99, 377, -65,  -7, 359,-184, 410,-327, 417,  32,
     c -72, -11,  90, 367, -76, -17, 351,-200, 400,-325, 415,  23,
     c -81, -16,  84, 360, -86, -30, 343,-207, 394,-325, 416,  18,
     c -84, -15,  80, 362, -89, -33, 342,-210, 391,-313, 418,  16,
     c -79,  -9,  82, 369, -88, -26, 349,-202, 395,-286, 421,  18,
     c -66,   1,  87, 375, -85, -19, 356,-193, 402,-281, 425,  25,
     c -48,  13,  96, 382, -82, -13, 369,-179, 413,-311, 431,  35,
     c -34,  25, 108, 392, -73,  -1, 384,-166, 423,-352, 436,  44,
     c -24,  32, 121, 404, -66,   8, 395,-154, 431,-366, 440,  51,
     c -21,  31, 133, 408, -65,  10, 403,-144, 436,-368, 445,  55,
     c -21,  29, 140, 412, -62,  11, 406,-142, 435,-365, 446,  57,
     c -32,  16, 131, 410, -68,   2, 405,-137, 432,-342, 446,  57,
     c -45,   2, 121, 406, -77,  -4, 397,-141, 426,-303, 444,  55,
     c-202,-113, -26, 229,-228,-139, 225,-328, 284,-371, 271, -80,
     c-183, -98,  -9, 256,-202,-118, 245,-308, 300,-334, 294, -66,
     c-164, -83,   7, 283,-175,-106, 264,-284, 318,-327, 315, -51,
     c-133, -58,  32, 307,-149, -78, 288,-264, 337,-361, 336, -33,
     c-113, -40,  49, 324,-130, -63, 306,-245, 357,-392, 356, -17,
     c -98, -23,  65, 340,-113, -41, 320,-231, 375,-400, 373,   0,
     c -84,  -9,  81, 353, -97, -31, 334,-216, 391,-387, 384,  13,
     c -71,   0,  98, 366, -85, -21, 347,-202, 406,-348, 395,  25,
     c -57,   7, 114, 385, -66,   0, 361,-185, 420,-302, 407,  37,
     c -41,  13, 127, 400, -49,  13, 376,-169, 433,-259, 418,  50,
     c -28,  21, 132, 412, -35,  28, 388,-156, 447,-235, 428,  61,
     c -20,  27, 133, 423, -28,  41, 398,-146, 460,-227, 436,  72,
     c -14,  33, 131, 434, -22,  49, 404,-136, 471,-221, 441,  79,
     c -10,  38, 133, 440, -17,  54, 406,-131, 477,-219, 445,  83,
     c -11,  41, 139, 442, -14,  54, 406,-130, 477,-251, 446,  83,
     c -12,  40, 144, 438, -14,  51, 404,-134, 471,-296, 445,  79,
     c -15,  33, 143, 429, -19,  41, 397,-143, 461,-322, 443,  71,
     c -26,  25, 137, 417, -30,  24, 386,-157, 446,-325, 435,  60,
     c -38,  18, 123, 405, -47,  17, 375,-172, 429,-323, 426,  47,
     c -46,  13, 108, 390, -59,  -1, 364,-185, 414,-317, 419,  34,
     c -57,   7,  94, 377, -68, -14, 355,-200, 401,-312, 414,  23,
     c -69,   0,  86, 367, -79, -22, 346,-215, 392,-322, 414,  14,
     c -79,  -4,  80, 366, -93, -27, 337,-221, 386,-336, 414,   8,
     c -83,  -5,  78, 366, -94, -31, 336,-224, 386,-341, 417,   6,
     c -79,   0,  81, 370, -94, -28, 341,-216, 389,-324, 419,   9,
     c -66,   7,  87, 376, -95, -23, 350,-208, 397,-330, 423,  16,
     c -47,  18,  97, 386, -91, -12, 362,-192, 407,-369, 428,  25,
     c -31,  29, 111, 398, -79,   1, 376,-179, 417,-408, 432,  33,
     c -19,  35, 127, 409, -73,  12, 389,-167, 424,-414, 434,  38,
     c -17,  35, 138, 412, -71,  13, 394,-160, 425,-408, 436,  41,
     c -26,  26, 136, 408, -74,   6, 395,-155, 423,-406, 438,  41,
     c -41,  12, 127, 405, -80,  -5, 391,-152, 417,-387, 436,  40,
     c -54,   0, 118, 401, -87,  -8, 383,-156, 408,-358, 432,  36,
     c-205,-111, -25, 222,-242,-143, 211,-343, 270,-382, 255, -98,
     c-186, -96,  -8, 251,-212,-122, 235,-320, 289,-349, 282, -81,
     c-166, -80,   8, 278,-187,-106, 258,-293, 310,-346, 307, -62,
     c-134, -57,  34, 306,-155, -77, 286,-268, 332,-382, 333, -42,
     c-110, -37,  54, 330,-129, -56, 307,-247, 354,-415, 357, -23,
     c -94, -18,  72, 351,-109, -33, 325,-229, 376,-424, 375,  -4,
     c -79,  -2,  88, 365, -90, -23, 340,-210, 394,-412, 389,  12,
     c -65,   8, 107, 377, -74, -12, 357,-195, 411,-378, 401,  26,
     c -48,  17, 124, 395, -56,  10, 372,-179, 426,-340, 414,  39,
     c -31,  25, 138, 412, -38,  24, 385,-165, 441,-305, 426,  52,
     c -19,  33, 142, 422, -28,  37, 398,-151, 453,-294, 436,  63,
     c -11,  40, 141, 434, -22,  51, 404,-142, 465,-299, 441,  73,
     c  -6,  45, 138, 442, -20,  57, 409,-134, 474,-301, 446,  79,
     c  -4,  50, 138, 443, -18,  59, 410,-132, 479,-299, 449,  82,
     c  -5,  53, 143, 442, -17,  57, 410,-136, 477,-325, 449,  81,
     c  -8,  50, 146, 438, -20,  53, 405,-143, 470,-358, 448,  76,
     c -14,  44, 144, 429, -23,  43, 396,-151, 458,-369, 444,  66,
     c -25,  34, 137, 415, -37,  24, 386,-165, 443,-358, 436,  55,
     c -39,  26, 120, 402, -57,  11, 373,-179, 426,-346, 426,  42,
     c -49,  20, 102, 390, -69,  -6, 362,-193, 409,-334, 418,  27,
     c -60,  12,  87, 373, -80, -25, 352,-208, 397,-329, 413,  17,
     c -74,   2,  76, 364, -93, -36, 341,-220, 388,-342, 412,   8,
     c -84,  -4,  69, 364,-105, -38, 334,-228, 382,-363, 414,   1,
     c -91,  -8,  67, 362,-108, -43, 331,-230, 382,-373, 415,   0,
     c -88,  -6,  68, 365,-108, -43, 335,-222, 387,-365, 417,   2,
     c -77,  -1,  73, 372,-109, -42, 343,-214, 394,-376, 421,   7,
     c -61,   6,  83, 380,-108, -32, 355,-200, 404,-416, 425,  16,
     c -47,  14,  96, 389, -99, -18, 366,-190, 412,-455, 427,  24,
     c -37,  20, 110, 400, -94,  -5, 377,-180, 416,-460, 427,  28,
     c -37,  17, 118, 400, -94,  -6, 381,-175, 415,-452, 428,  29,
     c -49,  10, 115, 395, -96, -14, 380,-173, 410,-447, 427,  29,
     c -63,  -4, 105, 390,-103, -25, 375,-170, 402,-430, 425,  26,
     c -77, -18,  96, 384,-111, -34, 366,-171, 392,-403, 421,  21,
     c-207,-109, -26, 212,-258,-158, 203,-360, 256,-367, 243,-116,
     c-188, -94,  -9, 243,-227,-132, 230,-334, 279,-339, 274, -95,
     c-169, -79,   7, 271,-197,-117, 256,-304, 304,-341, 304, -73,
     c-133, -55,  36, 307,-159, -84, 286,-272, 329,-375, 332, -50,
     c-109, -34,  57, 335,-128, -57, 308,-250, 354,-415, 357, -29,
     c -91, -14,  78, 360,-105, -32, 328,-229, 377,-435, 378,  -7,
     c -74,   3,  95, 376, -84, -20, 347,-209, 397,-434, 393,  10,
     c -58,  17, 117, 392, -64,  -4, 364,-192, 414,-419, 405,  25,
     c -41,  27, 134, 409, -46,  19, 380,-177, 431,-406, 418,  39,
     c -23,  37, 148, 423, -28,  33, 394,-160, 444,-395, 431,  53,
     c -10,  45, 152, 433, -20,  44, 405,-148, 457,-407, 439,  63,
     c  -1,  52, 149, 444, -20,  58, 413,-139, 466,-429, 446,  72,
     c   1,  57, 143, 449, -21,  59, 417,-131, 474,-436, 451,  78,
     c   2,  61, 144, 447, -20,  60, 417,-133, 477,-427, 454,  80,
     c  -1,  63, 146, 442, -21,  57, 415,-139, 476,-442, 454,  78,
     c  -5,  60, 147, 437, -23,  48, 411,-150, 468,-456, 452,  72,
     c -12,  54, 146, 430, -27,  34, 402,-159, 455,-448, 447,  63,
     c -25,  44, 137, 414, -44,  12, 389,-173, 440,-421, 439,  52,
     c -41,  34, 116, 401, -66,   1, 376,-189, 423,-400, 427,  37,
     c -52,  26,  95, 388, -81, -14, 364,-203, 408,-379, 418,  24,
     c -64,  16,  78, 371, -93, -28, 351,-221, 396,-368, 413,  13,
     c -78,   6,  66, 363,-106, -39, 340,-231, 387,-380, 412,   4,
     c -91,  -4,  58, 363,-117, -43, 330,-238, 383,-401, 413,  -2,
     c -98, -10,  55, 361,-119, -52, 327,-240, 382,-411, 414,  -4,
     c -97, -12,  56, 361,-120, -60, 330,-235, 386,-407, 415,  -4,
     c -89, -10,  60, 368,-121, -54, 335,-230, 392,-421, 417,   1,
     c -76,  -5,  68, 375,-121, -45, 346,-218, 400,-462, 419,   9,
     c -63,   0,  79, 382,-116, -38, 355,-206, 406,-501, 421,  16,
     c -54,   4,  94, 392,-112, -25, 364,-199, 408,-506, 420,  20,
     c -58,   0, 100, 391,-114, -27, 364,-192, 405,-496, 419,  20,
     c -73,  -7,  92, 382,-120, -37, 364,-188, 397,-487, 418,  19,
     c -87, -21,  83, 376,-128, -47, 357,-187, 387,-473, 415,  14,
     c-100, -35,  75, 371,-134, -56, 347,-187, 374,-447, 409,   7/
      end
 
 
      block data yy1array
      integer*2 wwtaby1(12,33,65)
      common /wwtaby1_/wwtaby1
      data wwtaby1/
     c 608, 227, 555, 764, 591,  52, 284, -36, 452, 815, 335,  66,
     c 598, 213, 546, 750, 576,  49, 270, -51, 443, 806, 339,  53,
     c 587, 199, 535, 732, 557,  41, 258, -67, 436, 793, 339,  42,
     c 576, 183, 518, 715, 537,  33, 247, -80, 427, 776, 334,  32,
     c 562, 177, 505, 703, 522,  14, 238, -93, 415, 754, 327,  19,
     c 552, 178, 494, 687, 504,   0, 225,-109, 401, 724, 317,   6,
     c 542, 175, 477, 667, 481, -23, 208,-126, 384, 689, 305, -11,
     c 525, 168, 464, 649, 466, -42, 190,-149, 367, 657, 289, -28,
     c 509, 158, 449, 635, 448, -53, 172,-169, 352, 637, 275, -47,
     c 500, 144, 433, 621, 430, -72, 157,-188, 340, 627, 267, -63,
     c 488, 127, 416, 606, 412, -92, 144,-203, 332, 617, 258, -76,
     c 474, 113, 404, 599, 403, -96, 135,-217, 326, 604, 245, -87,
     c 464, 105, 400, 598, 396,-105, 125,-229, 320, 592, 232, -95,
     c 457,  99, 397, 591, 382,-124, 115,-243, 315, 576, 221,-103,
     c 453,  97, 391, 582, 370,-138, 107,-253, 308, 555, 209,-111,
     c 445,  95, 380, 577, 364,-145, 100,-263, 302, 523, 196,-118,
     c 439,  89, 370, 579, 361,-147,  95,-271, 296, 482, 189,-124,
     c 435,  83, 366, 576, 356,-151,  91,-284, 292, 447, 191,-129,
     c 429,  81, 366, 566, 348,-167,  87,-293, 289, 441, 193,-132,
     c 428,  82, 365, 563, 340,-169,  81,-301, 283, 449, 193,-135,
     c 427,  81, 358, 558, 329,-182,  73,-312, 277, 454, 191,-141,
     c 425,  80, 356, 549, 318,-192,  63,-328, 266, 444, 184,-151,
     c 414,  79, 355, 536, 300,-202,  50,-347, 252, 447, 175,-165,
     c 395,  72, 345, 518, 276,-223,  35,-369, 234, 443, 159,-183,
     c 367,  56, 324, 496, 254,-244,  15,-392, 213, 409, 140,-207,
     c 336,  31, 303, 474, 232,-262,  -9,-419, 191, 343, 119,-232,
     c 306,   0, 274, 450, 200,-293, -34,-452, 170, 259,  99,-257,
     c 278, -34, 238, 422, 164,-329, -60,-481, 150, 171,  77,-280,
     c 254, -64, 199, 400, 135,-353, -78,-500, 133, 117,  61,-298,
     c 239, -82, 180, 392, 119,-364, -86,-515, 123, 106,  53,-308,
     c 234, -93, 186, 392, 114,-360, -84,-517, 118, 105,  53,-312,
     c 236, -94, 189, 397, 110,-358, -80,-513, 117, 101,  51,-313,
     c 237, -96, 193, 404, 109,-351, -73,-500, 121,  88,  49,-309,
     c 551, 172, 497, 697, 528,  -2, 235, -78, 400, 759, 281,  15,
     c 542, 159, 488, 683, 513,  -5, 224, -91, 396, 753, 285,   5,
     c 531, 144, 477, 668, 496, -10, 215,-105, 390, 743, 286,  -3,
     c 523, 131, 466, 656, 481, -16, 204,-119, 384, 731, 284, -10,
     c 515, 129, 461, 650, 470, -33, 197,-129, 377, 713, 278, -19,
     c 509, 133, 452, 639, 456, -44, 187,-142, 368, 689, 271, -31,
     c 503, 134, 442, 625, 440, -57, 175,-158, 354, 659, 262, -44,
     c 489, 131, 430, 612, 429, -82, 159,-174, 341, 633, 250, -60,
     c 476, 123, 418, 603, 416, -92, 145,-193, 330, 619, 241, -75,
     c 469, 111, 404, 591, 402,-101, 131,-208, 321, 612, 236, -87,
     c 461,  96, 391, 580, 387,-118, 123,-221, 314, 605, 231, -98,
     c 451,  86, 380, 575, 380,-121, 115,-232, 309, 593, 223,-107,
     c 442,  80, 376, 575, 374,-130, 107,-242, 305, 580, 212,-114,
     c 439,  77, 376, 570, 362,-148,  99,-258, 299, 564, 204,-120,
     c 436,  78, 374, 563, 352,-157,  91,-269, 293, 544, 195,-127,
     c 430,  80, 365, 559, 347,-165,  87,-278, 288, 512, 184,-133,
     c 425,  77, 358, 560, 344,-166,  83,-285, 284, 475, 179,-138,
     c 423,  72, 358, 558, 340,-164,  82,-292, 280, 446, 182,-140,
     c 421,  72, 361, 553, 335,-176,  79,-299, 279, 448, 188,-141,
     c 420,  74, 359, 552, 330,-178,  75,-306, 277, 464, 190,-142,
     c 422,  75, 352, 550, 324,-188,  69,-315, 272, 471, 189,-146,
     c 421,  74, 349, 544, 316,-196,  59,-328, 263, 458, 185,-154,
     c 410,  73, 345, 531, 298,-205,  47,-346, 251, 448, 176,-167,
     c 392,  68, 336, 516, 277,-231,  32,-367, 235, 425, 161,-183,
     c 368,  54, 318, 497, 256,-245,  14,-389, 215, 383, 142,-206,
     c 341,  32, 300, 474, 235,-264,  -6,-416, 193, 314, 122,-229,
     c 315,   3, 276, 453, 206,-291, -29,-447, 172, 239, 101,-253,
     c 291, -26, 248, 430, 174,-317, -52,-475, 153, 172,  81,-273,
     c 271, -52, 214, 411, 148,-346, -68,-494, 136, 147,  63,-289,
     c 259, -67, 198, 403, 135,-356, -75,-508, 126, 161,  57,-296,
     c 256, -76, 201, 403, 131,-356, -71,-508, 121, 186,  58,-299,
     c 256, -78, 205, 408, 126,-349, -67,-504, 122, 191,  57,-297,
     c 258, -80, 209, 416, 126,-352, -59,-495, 125, 186,  57,-292,
     c 495, 118, 440, 626, 463, -56, 180,-131, 348, 716, 226, -36,
     c 484, 104, 431, 616, 450, -61, 172,-142, 345, 712, 233, -44,
     c 473,  89, 420, 604, 435, -69, 165,-153, 343, 705, 236, -50,
     c 471,  80, 415, 596, 424, -73, 157,-164, 342, 697, 234, -55,
     c 468,  82, 415, 595, 418, -83, 153,-173, 338, 682, 230, -62,
     c 465,  89, 412, 592, 409, -87, 147,-181, 332, 661, 227, -70,
     c 463,  93, 404, 582, 397, -97, 139,-192, 323, 635, 221, -81,
     c 454,  93, 397, 576, 393,-115, 127,-206, 313, 612, 213, -92,
     c 443,  88, 386, 568, 382,-121, 115,-220, 304, 600, 207,-104,
     c 439,  77, 374, 561, 371,-131, 105,-235, 298, 595, 206,-114,
     c 434,  66, 365, 553, 361,-145,  98,-247, 293, 589, 204,-122,
     c 427,  58, 356, 552, 359,-144,  94,-256, 290, 577, 199,-128,
     c 421,  54, 352, 551, 352,-150,  88,-265, 286, 564, 192,-133,
     c 420,  55, 355, 549, 342,-164,  82,-276, 282, 546, 188,-138,
     c 418,  59, 356, 544, 334,-173,  77,-284, 277, 527, 181,-143,
     c 415,  64, 349, 540, 328,-178,  74,-291, 272, 497, 172,-148,
     c 412,  64, 346, 541, 326,-181,  73,-295, 270, 464, 168,-151,
     c 412,  62, 349, 541, 325,-180,  73,-303, 269, 439, 173,-152,
     c 412,  63, 355, 539, 321,-189,  72,-308, 269, 448, 179,-152,
     c 413,  67, 352, 543, 319,-188,  69,-313, 269, 466, 183,-152,
     c 417,  68, 345, 543, 316,-192,  63,-321, 266, 474, 183,-154,
     c 418,  68, 341, 539, 311,-198,  55,-332, 259, 457, 181,-160,
     c 406,  68, 338, 528, 298,-206,  44,-349, 250, 437, 172,-170,
     c 388,  64, 328, 515, 279,-229,  29,-367, 235, 403, 160,-186,
     c 370,  52, 314, 498, 259,-242,  14,-389, 216, 359, 141,-205,
     c 346,  32, 297, 477, 237,-268,  -4,-414, 196, 294, 122,-228,
     c 325,   8, 279, 458, 211,-290, -24,-442, 175, 226, 102,-249,
     c 303, -19, 258, 437, 183,-317, -43,-467, 157, 177,  84,-267,
     c 288, -40, 229, 420, 162,-336, -57,-483, 142, 175,  68,-280,
     c 279, -52, 216, 413, 153,-344, -63,-495, 132, 204,  63,-286,
     c 275, -61, 217, 414, 147,-349, -57,-495, 127, 245,  65,-287,
     c 277, -62, 221, 420, 146,-342, -52,-490, 128, 257,  65,-284,
     c 279, -63, 225, 428, 145,-340, -45,-484, 132, 261,  67,-278,
     c 423,  57, 372, 553, 392,-122, 116,-200, 294, 687, 174, -94,
     c 418,  47, 366, 550, 384,-118, 109,-208, 295, 687, 180, -99,
     c 413,  35, 359, 541, 373,-127, 105,-218, 294, 683, 184,-103,
     c 415,  29, 362, 541, 371,-127, 101,-226, 295, 677, 184,-105,
     c 421,  34, 371, 544, 371,-137, 103,-230, 295, 665, 183,-108,
     c 422,  45, 373, 544, 367,-137, 102,-232, 294, 646, 182,-113,
     c 419,  53, 369, 541, 359,-141,  97,-238, 289, 620, 179,-119,
     c 416,  57, 363, 539, 357,-151,  89,-245, 282, 595, 173,-128,
     c 412,  53, 356, 535, 351,-158,  79,-257, 277, 581, 171,-136,
     c 411,  46, 348, 532, 345,-163,  73,-266, 272, 575, 173,-143,
     c 407,  36, 343, 526, 338,-174,  70,-274, 269, 567, 176,-148,
     c 403,  31, 338, 525, 336,-178,  69,-278, 267, 553, 174,-151,
     c 402,  32, 337, 527, 331,-178,  68,-286, 265, 539, 172,-153,
     c 409,  37, 340, 529, 324,-188,  66,-293, 263, 521, 170,-156,
     c 408,  44, 339, 524, 318,-199,  64,-298, 259, 502, 165,-160,
     c 404,  51, 336, 518, 311,-206,  62,-306, 255, 474, 159,-163,
     c 400,  54, 336, 520, 310,-205,  61,-310, 254, 444, 157,-166,
     c 404,  54, 341, 523, 309,-197,  62,-314, 255, 426, 162,-166,
     c 408,  56, 345, 524, 311,-203,  62,-314, 257, 438, 168,-165,
     c 411,  61, 346, 529, 312,-200,  62,-319, 259, 458, 172,-163,
     c 414,  63, 342, 536, 312,-201,  57,-323, 259, 464, 174,-164,
     c 414,  64, 333, 536, 311,-202,  51,-330, 255, 440, 171,-169,
     c 402,  64, 322, 526, 299,-208,  39,-344, 247, 412, 165,-177,
     c 386,  59, 313, 513, 277,-231,  28,-364, 234, 376, 153,-191,
     c 370,  48, 305, 497, 256,-245,  13,-387, 217, 331, 136,-208,
     c 353,  32, 292, 479, 234,-271,  -2,-409, 198, 276, 119,-229,
     c 338,  12, 281, 461, 214,-290, -17,-433, 180, 226, 103,-247,
     c 323,  -9, 263, 445, 192,-312, -32,-456, 163, 193,  87,-263,
     c 309, -25, 242, 429, 175,-329, -42,-472, 150, 200,  75,-274,
     c 302, -33, 236, 424, 164,-338, -46,-479, 141, 240,  71,-278,
     c 300, -38, 238, 425, 159,-342, -42,-478, 138, 284,  74,-277,
     c 305, -38, 239, 431, 157,-335, -34,-473, 138, 301,  76,-274,
     c 307, -38, 241, 437, 159,-335, -27,-463, 142, 303,  78,-266,
     c 363,   9, 329, 504, 345,-163,  58,-259, 241, 663, 123,-150,
     c 362,   1, 325, 502, 339,-159,  52,-263, 243, 665, 130,-154,
     c 362,  -6, 320, 498, 332,-164,  50,-269, 245, 663, 134,-156,
     c 369,  -9, 323, 501, 330,-166,  53,-271, 249, 659, 137,-156,
     c 376,  -2, 333, 505, 330,-170,  56,-269, 253, 649, 137,-155,
     c 382,  10, 340, 508, 332,-168,  60,-269, 255, 629, 140,-155,
     c 383,  19, 339, 510, 326,-167,  58,-271, 254, 603, 139,-158,
     c 383,  23, 334, 508, 324,-177,  54,-277, 250, 576, 136,-164,
     c 384,  22, 328, 505, 322,-186,  48,-285, 247, 558, 136,-168,
     c 384,  16, 325, 504, 319,-189,  45,-292, 245, 549, 140,-172,
     c 380,   9, 323, 500, 313,-199,  44,-297, 243, 541, 146,-174,
     c 379,   8, 323, 500, 311,-203,  46,-300, 243, 528, 149,-174,
     c 385,  12, 324, 505, 310,-198,  49,-304, 244, 512, 150,-174,
     c 393,  20, 326, 509, 306,-200,  49,-306, 243, 497, 152,-174,
     c 397,  30, 325, 505, 303,-208,  50,-311, 242, 477, 152,-175,
     c 393,  39, 324, 505, 298,-212,  49,-315, 240, 452, 148,-178,
     c 390,  43, 326, 508, 296,-212,  49,-322, 240, 426, 146,-180,
     c 393,  45, 331, 509, 296,-211,  50,-326, 241, 408, 152,-178,
     c 398,  48, 337, 512, 298,-211,  51,-327, 245, 419, 158,-177,
     c 404,  53, 340, 518, 299,-212,  52,-329, 249, 439, 161,-174,
     c 409,  56, 334, 524, 301,-209,  50,-332, 252, 435, 162,-174,
     c 409,  57, 321, 525, 299,-210,  44,-338, 250, 403, 160,-178,
     c 400,  57, 310, 519, 288,-221,  37,-346, 244, 371, 155,-185,
     c 385,  51, 303, 505, 267,-236,  26,-366, 233, 340, 144,-196,
     c 368,  38, 296, 492, 247,-246,  13,-384, 217, 306, 131,-212,
     c 356,  24, 290, 479, 229,-270,   0,-407, 201, 269, 116,-229,
     c 346,   9, 280, 464, 214,-291, -12,-427, 185, 236, 104,-246,
     c 332,  -7, 264, 448, 196,-309, -24,-445, 170, 212,  92,-260,
     c 319, -17, 250, 436, 185,-321, -31,-459, 159, 226,  83,-269,
     c 316, -21, 249, 433, 176,-329, -33,-465, 151, 270,  81,-271,
     c 319, -21, 252, 435, 169,-333, -28,-467, 149, 310,  84,-269,
     c 324, -20, 252, 439, 169,-329, -22,-462, 150, 321,  87,-264,
     c 327, -19, 251, 442, 172,-336, -13,-453, 153, 311,  90,-257,
     c 318, -30, 294, 463, 306,-206,  15,-305, 196, 635,  80,-200,
     c 321, -35, 290, 462, 299,-202,  12,-305, 198, 638,  86,-203,
     c 323, -40, 285, 458, 291,-207,  11,-308, 203, 637,  91,-203,
     c 333, -39, 285, 464, 291,-208,  16,-309, 208, 634,  94,-200,
     c 341, -31, 294, 470, 294,-210,  23,-305, 214, 626,  98,-196,
     c 347, -19, 305, 474, 298,-208,  29,-302, 219, 608, 102,-193,
     c 351, -12, 309, 478, 297,-204,  29,-300, 221, 582, 103,-192,
     c 353, -10, 306, 480, 297,-207,  25,-306, 221, 550, 102,-195,
     c 355, -10, 300, 481, 296,-209,  21,-312, 220, 530, 104,-197,
     c 354, -14, 297, 480, 293,-217,  20,-315, 220, 519, 112,-199,
     c 355, -15, 298, 477, 290,-222,  21,-318, 220, 510, 119,-198,
     c 359, -13, 301, 479, 291,-221,  26,-319, 223, 495, 126,-196,
     c 367,  -6, 305, 488, 293,-211,  31,-319, 225, 487, 131,-192,
     c 374,   3, 305, 493, 292,-208,  36,-321, 227, 477, 137,-190,
     c 382,  15, 307, 493, 292,-211,  40,-324, 228, 458, 140,-189,
     c 382,  25, 313, 495, 291,-216,  40,-329, 229, 435, 139,-190,
     c 378,  31, 319, 498, 289,-218,  40,-334, 230, 416, 141,-190,
     c 380,  34, 324, 501, 286,-218,  40,-337, 233, 405, 146,-189,
     c 388,  38, 331, 504, 287,-213,  42,-337, 237, 416, 152,-187,
     c 398,  43, 332, 508, 286,-216,  45,-336, 242, 429, 154,-184,
     c 403,  48, 324, 512, 286,-214,  46,-337, 245, 417, 153,-183,
     c 404,  50, 314, 514, 286,-216,  43,-342, 245, 380, 152,-185,
     c 398,  48, 306, 511, 278,-230,  35,-351, 241, 344, 146,-191,
     c 386,  40, 298, 498, 261,-245,  24,-367, 231, 318, 138,-200,
     c 370,  28, 292, 487, 244,-253,  13,-386, 218, 296, 128,-215,
     c 357,  16, 291, 477, 229,-271,   0,-406, 203, 273, 116,-230,
     c 349,   4, 283, 466, 213,-285,  -9,-423, 189, 249, 107,-245,
     c 339,  -6, 268, 452, 200,-304, -19,-438, 177, 233,  96,-257,
     c 325, -14, 256, 444, 191,-310, -26,-453, 167, 243,  90,-264,
     c 322, -14, 259, 446, 185,-313, -26,-459, 161, 277,  89,-265,
     c 331,  -9, 266, 446, 181,-319, -21,-460, 159, 307,  92,-262,
     c 334,  -7, 266, 448, 181,-319, -15,-453, 160, 311,  95,-257,
     c 339,  -4, 266, 450, 183,-327,  -6,-445, 163, 297, 100,-249,
     c 286, -63, 262, 427, 272,-250, -16,-334, 162, 609,  48,-235,
     c 291, -65, 257, 426, 265,-244, -18,-336, 166, 611,  54,-237,
     c 294, -68, 252, 424, 258,-243, -18,-338, 170, 611,  58,-236,
     c 308, -65, 245, 432, 261,-242, -12,-338, 178, 610,  64,-232,
     c 315, -56, 257, 439, 269,-239,  -4,-333, 187, 603,  68,-227,
     c 321, -46, 275, 445, 274,-239,   2,-328, 194, 588,  73,-221,
     c 326, -41, 283, 451, 276,-233,   4,-326, 197, 565,  77,-219,
     c 329, -40, 281, 456, 276,-233,   2,-329, 199, 534,  78,-220,
     c 329, -41, 278, 460, 276,-233,   0,-332, 200, 508,  81,-221,
     c 331, -40, 276, 462, 273,-236,   0,-334, 201, 492,  90,-220,
     c 335, -38, 278, 462, 270,-240,   3,-334, 204, 482, 100,-217,
     c 345, -31, 283, 467, 273,-237,  10,-335, 208, 468, 108,-213,
     c 354, -20, 287, 474, 278,-231,  17,-334, 213, 468, 116,-207,
     c 363,  -8, 289, 483, 282,-225,  26,-330, 217, 463, 124,-202,
     c 369,   3, 295, 484, 283,-228,  31,-331, 221, 447, 130,-200,
     c 371,  13, 305, 486, 285,-231,  32,-333, 223, 425, 134,-197,
     c 370,  20, 313, 490, 284,-231,  34,-338, 225, 416, 138,-197,
     c 372,  25, 320, 495, 283,-225,  34,-342, 228, 405, 143,-195,
     c 382,  30, 326, 499, 283,-214,  36,-343, 232, 413, 148,-193,
     c 392,  37, 325, 502, 283,-217,  40,-341, 237, 422, 149,-190,
     c 401,  42, 320, 506, 283,-215,  42,-342, 241, 405, 147,-189,
     c 402,  44, 313, 508, 283,-223,  41,-346, 241, 361, 146,-191,
     c 396,  41, 305, 504, 278,-237,  34,-355, 239, 330, 141,-195,
     c 387,  33, 299, 498, 265,-245,  25,-368, 232, 314, 135,-203,
     c 374,  22, 295, 487, 251,-250,  12,-385, 220, 297, 127,-215,
     c 359,  11, 289, 477, 232,-266,   1,-404, 206, 278, 118,-229,
     c 352,   1, 281, 467, 213,-282,  -7,-417, 194, 253, 109,-243,
     c 344,  -7, 269, 458, 200,-293, -15,-431, 182, 229, 102,-254,
     c 333, -12, 262, 452, 195,-306, -21,-446, 173, 228,  97,-260,
     c 328,  -8, 265, 452, 187,-308, -23,-454, 169, 243,  96,-260,
     c 339,  -1, 273, 453, 185,-310, -17,-458, 167, 254,  98,-256,
     c 342,   3, 276, 455, 187,-314, -12,-453, 167, 249, 102,-251,
     c 347,   8, 280, 457, 188,-319,  -4,-450, 171, 230, 106,-243,
     c 264, -86, 236, 407, 250,-278, -37,-357, 142, 589,  31,-256,
     c 269, -88, 228, 406, 244,-273, -40,-358, 146, 590,  35,-257,
     c 274, -88, 222, 405, 240,-267, -37,-359, 152, 589,  40,-256,
     c 287, -83, 219, 411, 244,-262, -32,-358, 160, 587,  45,-251,
     c 297, -75, 232, 419, 252,-260, -23,-352, 169, 582,  51,-245,
     c 302, -68, 252, 427, 258,-258, -15,-345, 177, 573,  57,-239,
     c 305, -65, 262, 432, 260,-252, -13,-345, 182, 552,  61,-237,
     c 308, -63, 266, 439, 260,-250, -12,-348, 185, 523,  64,-235,
     c 309, -62, 265, 447, 262,-248, -14,-350, 186, 496,  68,-236,
     c 314, -59, 265, 451, 260,-251, -13,-351, 189, 479,  78,-234,
     c 325, -53, 267, 454, 257,-253,  -8,-349, 193, 463,  88,-231,
     c 336, -41, 273, 459, 261,-246,   0,-345, 199, 452,  98,-224,
     c 350, -28, 280, 469, 269,-239,  11,-340, 208, 457, 106,-216,
     c 361, -15, 284, 478, 275,-232,  20,-336, 214, 458, 117,-210,
     c 366,  -4, 290, 480, 278,-225,  28,-337, 219, 444, 124,-204,
     c 368,   5, 298, 483, 281,-224,  31,-335, 222, 428, 130,-202,
     c 370,  12, 309, 488, 282,-227,  32,-338, 224, 426, 135,-200,
     c 373,  19, 319, 491, 281,-224,  34,-342, 227, 425, 142,-197,
     c 381,  26, 322, 494, 283,-219,  37,-342, 232, 427, 147,-194,
     c 391,  34, 322, 500, 285,-222,  39,-340, 236, 421, 147,-192,
     c 401,  40, 321, 506, 286,-215,  42,-342, 239, 393, 146,-191,
     c 402,  42, 314, 502, 286,-221,  40,-348, 240, 352, 144,-194,
     c 399,  39, 307, 501, 282,-236,  35,-356, 238, 324, 141,-197,
     c 389,  31, 302, 498, 271,-246,  28,-367, 232, 308, 136,-205,
     c 377,  20, 297, 491, 256,-247,  16,-383, 222, 293, 130,-215,
     c 366,  10, 285, 479, 235,-265,   4,-400, 210, 270, 122,-228,
     c 360,   1, 272, 472, 219,-277,  -4,-413, 197, 243, 115,-240,
     c 352,  -5, 265, 464, 208,-289, -11,-425, 187, 215, 108,-250,
     c 342,  -8, 267, 458, 200,-302, -16,-439, 178, 202, 103,-255,
     c 340,  -2, 274, 453, 191,-310, -17,-447, 174, 194, 102,-255,
     c 349,   7, 282, 456, 187,-312, -12,-449, 172, 186, 103,-253,
     c 353,  13, 287, 459, 192,-310,  -6,-446, 173, 176, 106,-247,
     c 356,  19, 291, 463, 196,-311,   0,-442, 177, 159, 111,-239,
     c 258, -97, 223, 405, 246,-288, -46,-364, 135, 568,  28,-261,
     c 261, -97, 217, 402, 240,-284, -49,-366, 139, 568,  31,-262,
     c 263, -98, 211, 399, 236,-277, -48,-369, 145, 565,  34,-261,
     c 274, -93, 209, 406, 236,-271, -42,-367, 153, 562,  39,-257,
     c 284, -86, 223, 417, 244,-265, -33,-362, 161, 555,  45,-252,
     c 291, -82, 239, 424, 252,-265, -27,-355, 169, 548,  51,-248,
     c 296, -79, 253, 429, 256,-261, -23,-351, 173, 533,  55,-245,
     c 299, -77, 257, 434, 254,-256, -22,-353, 176, 509,  59,-244,
     c 304, -73, 259, 442, 255,-254, -22,-356, 179, 488,  64,-244,
     c 308, -68, 262, 447, 252,-256, -19,-357, 182, 474,  74,-242,
     c 317, -57, 267, 450, 252,-255, -12,-355, 189, 459,  85,-237,
     c 333, -43, 275, 457, 257,-248,  -2,-348, 197, 446,  94,-229,
     c 348, -29, 282, 467, 266,-241,   8,-342, 206, 452, 103,-220,
     c 360, -17, 286, 475, 272,-233,  19,-335, 214, 457, 113,-211,
     c 366,  -8, 291, 479, 275,-232,  26,-333, 220, 446, 121,-206,
     c 370,   0, 300, 484, 279,-228,  30,-331, 223, 437, 127,-203,
     c 373,   6, 309, 488, 281,-229,  33,-333, 226, 446, 134,-200,
     c 376,  13, 314, 490, 280,-225,  36,-335, 228, 450, 141,-197,
     c 385,  23, 320, 496, 284,-214,  37,-335, 232, 445, 147,-195,
     c 394,  32, 323, 500, 285,-219,  41,-337, 235, 428, 147,-193,
     c 401,  39, 322, 502, 284,-219,  41,-340, 239, 389, 146,-192,
     c 402,  42, 319, 500, 283,-225,  40,-345, 240, 344, 144,-193,
     c 398,  39, 315, 499, 281,-239,  37,-352, 238, 318, 142,-197,
     c 390,  32, 312, 498, 274,-242,  31,-361, 233, 303, 138,-203,
     c 381,  23, 301, 494, 260,-246,  21,-376, 224, 286, 133,-213,
     c 374,  14, 282, 485, 241,-261,  11,-394, 214, 263, 127,-225,
     c 371,   6, 270, 478, 228,-271,   2,-405, 201, 236, 119,-236,
     c 362,   0, 262, 469, 217,-290,  -5,-416, 191, 215, 113,-247,
     c 350,  -1, 264, 459, 204,-306, -11,-428, 184, 203, 109,-252,
     c 348,   5, 275, 455, 196,-312, -11,-438, 179, 184, 106,-253,
     c 355,  16, 288, 458, 195,-308,  -6,-439, 177, 159, 107,-250,
     c 358,  23, 293, 460, 200,-310,   0,-439, 178, 144, 110,-246,
     c 361,  30, 299, 465, 208,-314,   4,-437, 182, 131, 116,-238,
     c 268, -91, 229, 418, 256,-276, -42,-359, 141, 552,  37,-253,
     c 268, -93, 223, 415, 251,-274, -45,-361, 145, 552,  39,-255,
     c 269, -94, 218, 411, 246,-264, -44,-364, 149, 549,  41,-254,
     c 274, -91, 217, 419, 247,-258, -38,-364, 157, 541,  44,-251,
     c 283, -87, 225, 426, 252,-254, -32,-361, 164, 534,  48,-249,
     c 288, -86, 237, 429, 255,-257, -27,-357, 170, 532,  54,-246,
     c 293, -83, 250, 432, 256,-257, -25,-355, 173, 523,  59,-245,
     c 299, -78, 255, 437, 255,-249, -25,-356, 175, 508,  63,-245,
     c 306, -73, 260, 442, 254,-254, -22,-357, 178, 497,  69,-245,
     c 312, -65, 265, 446, 250,-261, -18,-357, 182, 494,  77,-242,
     c 320, -54, 270, 449, 249,-260, -10,-355, 191, 474,  88,-236,
     c 334, -39, 278, 459, 257,-254,   0,-348, 200, 450,  96,-227,
     c 348, -25, 283, 469, 267,-245,  12,-340, 210, 453, 105,-219,
     c 358, -15, 288, 478, 273,-234,  21,-335, 217, 454, 113,-210,
     c 367, -10, 294, 481, 277,-231,  27,-333, 222, 442, 120,-205,
     c 374,  -6, 302, 484, 278,-225,  31,-331, 225, 438, 127,-202,
     c 375,  -2, 305, 486, 279,-225,  34,-333, 227, 460, 133,-200,
     c 377,   4, 311, 489, 282,-222,  36,-334, 230, 473, 140,-198,
     c 385,  15, 318, 495, 283,-214,  37,-334, 232, 467, 146,-196,
     c 395,  27, 322, 497, 281,-222,  41,-335, 235, 434, 148,-194,
     c 403,  37, 322, 500, 283,-218,  41,-340, 237, 389, 147,-194,
     c 402,  42, 323, 500, 284,-220,  41,-348, 238, 345, 146,-194,
     c 397,  41, 324, 499, 281,-229,  39,-353, 237, 320, 143,-197,
     c 392,  35, 319, 496, 274,-237,  36,-360, 233, 302, 139,-202,
     c 386,  27, 306, 497, 264,-241,  28,-372, 226, 282, 135,-211,
     c 380,  19, 289, 491, 251,-258,  19,-385, 216, 263, 129,-221,
     c 378,  12, 274, 484, 238,-272,   9,-397, 205, 248, 122,-233,
     c 373,   7, 263, 473, 222,-290,   1,-410, 195, 251, 115,-244,
     c 361,   8, 264, 463, 209,-308,  -4,-421, 188, 247, 111,-250,
     c 355,  15, 273, 458, 198,-311,  -4,-428, 183, 222, 108,-251,
     c 362,  26, 286, 460, 201,-309,   2,-428, 181, 186, 108,-250,
     c 364,  33, 293, 462, 205,-313,   5,-429, 182, 167, 111,-246,
     c 364,  39, 300, 465, 210,-313,   9,-432, 187, 162, 118,-238,
     c 293, -78, 248, 441, 277,-261, -22,-338, 158, 556,  57,-235,
     c 291, -79, 242, 437, 273,-257, -26,-340, 162, 557,  57,-237,
     c 288, -81, 236, 432, 268,-245, -27,-344, 165, 552,  57,-239,
     c 289, -81, 233, 436, 268,-245, -25,-348, 170, 543,  60,-238,
     c 292, -79, 238, 441, 269,-238, -22,-347, 175, 533,  61,-237,
     c 294, -79, 243, 440, 264,-245, -20,-346, 178, 533,  64,-237,
     c 298, -76, 251, 440, 259,-257, -19,-348, 179, 528,  67,-237,
     c 305, -70, 257, 442, 258,-252, -18,-348, 181, 521,  71,-239,
     c 312, -63, 265, 445, 257,-258, -16,-351, 184, 520,  77,-240,
     c 321, -56, 271, 450, 253,-257, -11,-351, 190, 524,  86,-237,
     c 331, -44, 276, 456, 255,-253,  -3,-348, 198, 501,  95,-231,
     c 342, -30, 284, 468, 263,-245,  10,-342, 207, 469, 104,-222,
     c 352, -18, 291, 479, 272,-229,  20,-334, 217, 459, 110,-213,
     c 363, -11, 294, 486, 275,-221,  28,-332, 223, 457, 117,-207,
     c 371,  -8, 299, 486, 278,-222,  32,-328, 226, 443, 122,-202,
     c 375,  -9, 302, 486, 277,-220,  34,-331, 228, 440, 127,-202,
     c 375,  -9, 303, 486, 277,-225,  32,-331, 227, 464, 132,-202,
     c 376,  -4, 306, 487, 277,-222,  36,-334, 229, 478, 139,-200,
     c 383,   6, 310, 490, 278,-222,  36,-333, 230, 466, 143,-199,
     c 393,  19, 312, 492, 278,-230,  38,-335, 232, 429, 145,-197,
     c 401,  32, 317, 496, 279,-223,  39,-337, 234, 383, 146,-197,
     c 402,  38, 320, 496, 281,-219,  40,-341, 235, 340, 144,-197,
     c 400,  39, 323, 495, 279,-229,  40,-347, 234, 320, 142,-198,
     c 396,  36, 321, 493, 274,-230,  38,-355, 231, 302, 139,-203,
     c 391,  30, 313, 492, 268,-242,  33,-367, 225, 283, 136,-209,
     c 385,  22, 296, 491, 256,-261,  26,-379, 216, 265, 131,-220,
     c 384,  16, 277, 487, 241,-274,  16,-394, 206, 267, 124,-231,
     c 380,  14, 269, 478, 225,-289,   7,-408, 197, 292, 116,-242,
     c 369,  17, 269, 469, 214,-300,   2,-418, 191, 296, 112,-249,
     c 362,  22, 272, 464, 204,-301,   1,-422, 187, 259, 110,-251,
     c 369,  32, 285, 464, 203,-298,   6,-425, 185, 214, 108,-251,
     c 371,  38, 293, 468, 207,-296,   9,-424, 187, 195, 111,-246,
     c 372,  43, 299, 470, 209,-302,  14,-427, 191, 197, 119,-240,
     c 323, -62, 273, 469, 305,-236,   4,-308, 184, 578,  82,-212,
     c 318, -65, 266, 461, 299,-237,   0,-315, 185, 580,  81,-214,
     c 313, -68, 259, 453, 292,-228,  -2,-321, 187, 575,  81,-216,
     c 309, -68, 255, 454, 288,-231,  -4,-327, 190, 563,  80,-217,
     c 310, -67, 254, 458, 286,-227,  -4,-330, 193, 551,  79,-220,
     c 309, -66, 255, 457, 279,-232,  -4,-330, 192, 548,  79,-222,
     c 311, -61, 257, 453, 270,-246,  -6,-335, 192, 538,  82,-225,
     c 316, -53, 264, 451, 266,-244,  -5,-338, 193, 529,  84,-228,
     c 322, -47, 274, 452, 266,-250,  -4,-342, 196, 534,  89,-228,
     c 334, -39, 284, 460, 267,-245,   2,-341, 201, 545,  98,-226,
     c 346, -30, 290, 471, 269,-234,  13,-335, 210, 523, 107,-221,
     c 352, -19, 297, 481, 276,-227,  22,-329, 218, 487, 114,-213,
     c 361, -10, 304, 490, 281,-213,  31,-324, 225, 473, 118,-206,
     c 368,  -6, 306, 494, 281,-208,  36,-324, 229, 475, 121,-201,
     c 374,  -5, 306, 493, 279,-218,  35,-324, 229, 464, 124,-201,
     c 374,  -9, 305, 487, 275,-222,  34,-330, 228, 458, 126,-203,
     c 375, -14, 302, 484, 273,-227,  31,-332, 227, 473, 129,-205,
     c 374, -13, 296, 482, 269,-226,  31,-337, 226, 483, 133,-206,
     c 380,  -2, 296, 484, 269,-226,  32,-337, 226, 461, 138,-205,
     c 389,  12, 298, 487, 272,-231,  34,-339, 227, 418, 139,-204,
     c 398,  26, 305, 492, 273,-227,  37,-340, 229, 370, 141,-202,
     c 404,  33, 309, 490, 271,-231,  39,-344, 231, 338, 140,-202,
     c 404,  35, 315, 490, 272,-236,  38,-349, 231, 320, 139,-203,
     c 399,  34, 318, 491, 271,-233,  39,-356, 228, 301, 136,-206,
     c 393,  29, 313, 488, 264,-247,  37,-366, 223, 281, 134,-212,
     c 389,  21, 295, 484, 252,-264,  30,-379, 214, 267, 129,-221,
     c 387,  16, 279, 483, 239,-275,  21,-393, 205, 282, 123,-232,
     c 380,  16, 272, 479, 226,-284,  11,-408, 198, 317, 117,-242,
     c 370,  19, 270, 471, 216,-294,   7,-418, 193, 320, 113,-249,
     c 368,  23, 269, 466, 207,-297,   7,-420, 190, 272, 110,-252,
     c 376,  31, 281, 466, 203,-293,  10,-421, 190, 217, 109,-253,
     c 377,  35, 289, 470, 206,-299,  13,-420, 191, 199, 113,-249,
     c 378,  40, 296, 472, 207,-300,  15,-423, 195, 207, 120,-243,
     c 351, -43, 306, 499, 334,-203,  33,-276, 212, 608, 113,-184,
     c 344, -47, 296, 488, 323,-208,  28,-286, 212, 612, 110,-187,
     c 338, -49, 286, 480, 315,-205,  23,-295, 213, 606, 107,-191,
     c 333, -50, 278, 478, 306,-212,  20,-307, 213, 592, 104,-195,
     c 331, -49, 274, 480, 303,-211,  17,-311, 213, 574, 101,-199,
     c 330, -47, 270, 477, 296,-219,  14,-313, 211, 564,  99,-204,
     c 331, -42, 272, 472, 287,-230,  13,-319, 210, 546,  99,-208,
     c 334, -32, 279, 470, 282,-225,  12,-322, 209, 532, 102,-211,
     c 340, -26, 289, 468, 284,-231,  13,-327, 211, 535, 107,-213,
     c 349, -20, 299, 474, 286,-225,  19,-325, 216, 548, 114,-212,
     c 358, -13, 308, 484, 288,-215,  28,-322, 223, 530, 122,-207,
     c 366,  -6, 315, 494, 292,-209,  38,-316, 230, 495, 127,-201,
     c 372,  -1, 320, 499, 294,-201,  42,-313, 234, 486, 128,-198,
     c 377,   0, 320, 501, 291,-203,  43,-317, 235, 495, 128,-197,
     c 379,  -1, 317, 497, 284,-209,  40,-322, 232, 491, 127,-200,
     c 376,  -8, 311, 488, 275,-221,  36,-330, 228, 484, 126,-205,
     c 375, -16, 301, 481, 268,-232,  31,-336, 225, 489, 125,-211,
     c 371, -19, 289, 478, 263,-230,  27,-342, 222, 484, 127,-214,
     c 373,  -9, 285, 479, 261,-235,  25,-343, 221, 453, 131,-215,
     c 379,   4, 285, 479, 262,-237,  27,-345, 221, 406, 133,-214,
     c 389,  18, 292, 480, 262,-236,  30,-344, 224, 362, 135,-211,
     c 395,  27, 299, 480, 259,-238,  32,-347, 225, 335, 135,-209,
     c 397,  31, 308, 483, 262,-236,  33,-352, 225, 318, 136,-210,
     c 395,  31, 314, 484, 264,-243,  34,-360, 223, 300, 133,-212,
     c 389,  26, 307, 479, 256,-260,  32,-369, 218, 277, 130,-217,
     c 386,  19, 292, 475, 242,-273,  27,-382, 210, 264, 126,-225,
     c 384,  14, 281, 473, 233,-285,  19,-395, 202, 285, 121,-233,
     c 378,  13, 272, 471, 223,-291,  12,-407, 197, 319, 116,-243,
     c 370,  15, 265, 465, 214,-300,   8,-415, 194, 314, 112,-250,
     c 370,  18, 263, 463, 207,-304,   8,-418, 192, 252, 110,-253,
     c 378,  24, 274, 465, 204,-299,  11,-419, 193, 195, 110,-255,
     c 379,  28, 283, 464, 203,-302,  14,-417, 194, 180, 114,-252,
     c 381,  32, 291, 466, 201,-300,  17,-417, 198, 196, 121,-247,
     c 375, -18, 341, 527, 359,-177,  61,-249, 242, 638, 143,-155,
     c 369, -21, 330, 517, 349,-180,  55,-258, 241, 642, 140,-159,
     c 363, -26, 318, 507, 339,-176,  50,-270, 240, 636, 136,-164,
     c 356, -27, 306, 505, 330,-185,  44,-279, 238, 621, 131,-169,
     c 356, -27, 296, 501, 324,-192,  42,-287, 235, 601, 126,-176,
     c 356, -25, 291, 497, 316,-197,  39,-290, 232, 589, 121,-182,
     c 355, -18, 293, 494, 308,-207,  35,-297, 229, 566, 120,-188,
     c 355,  -9, 298, 491, 304,-208,  34,-301, 228, 548, 122,-193,
     c 358,  -2, 305, 486, 303,-211,  35,-305, 229, 550, 126,-196,
     c 365,   1, 313, 489, 302,-208,  39,-305, 233, 562, 133,-196,
     c 371,   6, 320, 496, 304,-202,  44,-303, 237, 541, 138,-193,
     c 379,   8, 327, 502, 305,-199,  50,-301, 241, 505, 141,-190,
     c 383,   7, 333, 505, 304,-197,  51,-303, 244, 495, 139,-189,
     c 384,   5, 332, 504, 297,-203,  50,-310, 241, 506, 136,-192,
     c 382,   1, 327, 498, 288,-210,  43,-320, 236, 506, 132,-198,
     c 378,  -8, 314, 489, 277,-221,  35,-333, 229, 498, 128,-208,
     c 374, -18, 301, 479, 267,-236,  27,-342, 223, 494, 124,-217,
     c 367, -23, 289, 474, 259,-235,  21,-349, 219, 476, 123,-222,
     c 365, -15, 283, 473, 255,-242,  18,-352, 216, 438, 125,-224,
     c 368,  -2, 282, 472, 254,-244,  18,-353, 217, 389, 128,-224,
     c 375,  11, 287, 472, 254,-242,  21,-352, 218, 351, 130,-221,
     c 381,  22, 295, 474, 254,-244,  23,-357, 220, 329, 132,-218,
     c 386,  27, 305, 478, 255,-240,  25,-363, 220, 315, 132,-217,
     c 385,  27, 306, 477, 254,-249,  26,-369, 217, 295, 129,-220,
     c 381,  23, 299, 472, 250,-261,  25,-378, 213, 271, 125,-224,
     c 380,  16, 290, 468, 238,-274,  19,-389, 206, 256, 120,-230,
     c 380,  10, 279, 469, 229,-283,  14,-401, 199, 275, 116,-238,
     c 375,   9, 267, 464, 221,-295,   8,-409, 195, 302, 111,-247,
     c 369,   9, 257, 458, 214,-308,   7,-414, 193, 287, 109,-252,
     c 370,  10, 256, 459, 207,-306,   9,-416, 194, 220, 108,-256,
     c 380,  17, 268, 466, 206,-293,  12,-418, 194, 174, 109,-258,
     c 381,  19, 275, 465, 202,-291,  12,-417, 196, 166, 113,-255,
     c 383,  22, 283, 465, 200,-289,  13,-417, 199, 187, 120,-250,
     c 401,  12, 375, 557, 387,-138,  87,-223, 272, 665, 174,-125,
     c 395,   7, 360, 546, 377,-144,  81,-230, 269, 669, 169,-132,
     c 388,   1, 345, 536, 365,-147,  76,-243, 267, 662, 165,-137,
     c 382,  -1, 330, 530, 354,-160,  70,-255, 263, 646, 158,-144,
     c 378,  -3, 320, 524, 345,-167,  66,-265, 259, 626, 151,-151,
     c 378,  -3, 315, 519, 337,-176,  63,-271, 254, 610, 146,-160,
     c 380,   3, 317, 516, 331,-179,  61,-278, 249, 590, 144,-167,
     c 377,  14, 323, 510, 327,-185,  58,-284, 247, 573, 145,-171,
     c 375,  20, 327, 503, 321,-191,  56,-288, 248, 573, 147,-175,
     c 379,  24, 329, 505, 318,-190,  58,-290, 249, 580, 151,-177,
     c 386,  25, 332, 509, 317,-187,  60,-289, 251, 555, 155,-176,
     c 390,  22, 337, 511, 316,-192,  61,-290, 253, 517, 155,-177,
     c 392,  16, 345, 510, 314,-196,  60,-294, 252, 502, 150,-180,
     c 391,   9, 342, 509, 304,-198,  55,-304, 247, 511, 144,-186,
     c 387,   3, 332, 502, 293,-206,  47,-316, 240, 512, 137,-196,
     c 381,  -6, 317, 491, 279,-218,  37,-332, 231, 505, 130,-209,
     c 373, -18, 304, 481, 266,-230,  25,-346, 223, 494, 125,-220,
     c 362, -23, 290, 473, 253,-236,  15,-357, 217, 471, 123,-227,
     c 359, -18, 284, 472, 248,-240,  11,-360, 212, 426, 122,-231,
     c 361,  -6, 285, 470, 248,-240,  13,-360, 213, 379, 125,-230,
     c 366,   8, 292, 470, 251,-241,  15,-357, 215, 345, 128,-228,
     c 374,  18, 297, 472, 248,-243,  17,-361, 217, 326, 130,-226,
     c 379,  25, 302, 476, 250,-240,  18,-367, 216, 310, 129,-225,
     c 378,  26, 301, 474, 250,-252,  18,-374, 214, 288, 125,-227,
     c 375,  21, 298, 467, 246,-261,  16,-384, 209, 262, 119,-230,
     c 374,  13, 287, 462, 235,-274,  11,-395, 202, 241, 113,-237,
     c 374,   7, 274, 463, 227,-280,   6,-410, 196, 257, 108,-244,
     c 368,   4, 264, 459, 219,-288,   1,-417, 193, 272, 104,-251,
     c 363,   2, 253, 454, 213,-301,   3,-421, 192, 253, 102,-256,
     c 366,   3, 250, 457, 206,-305,   5,-422, 194, 191, 102,-259,
     c 377,   8, 262, 464, 205,-296,   8,-421, 194, 162, 105,-259,
     c 379,  10, 267, 464, 203,-294,   9,-421, 196, 162, 110,-258,
     c 383,  12, 273, 465, 203,-292,  11,-418, 199, 190, 116,-254,
     c 425,  43, 402, 582, 415,-107, 112,-197, 300, 689, 203, -98,
     c 418,  38, 386, 571, 405,-113, 105,-203, 297, 690, 197,-103,
     c 413,  30, 369, 560, 390,-121, 101,-217, 292, 683, 191,-110,
     c 405,  25, 350, 553, 379,-135,  95,-228, 287, 666, 184,-119,
     c 402,  20, 340, 547, 371,-143,  90,-239, 281, 646, 176,-127,
     c 403,  19, 338, 543, 363,-151,  88,-246, 274, 629, 170,-137,
     c 404,  25, 344, 538, 356,-152,  84,-255, 269, 611, 167,-144,
     c 399,  35, 347, 530, 348,-163,  80,-263, 265, 595, 167,-150,
     c 396,  42, 349, 524, 342,-169,  78,-269, 264, 593, 169,-155,
     c 400,  46, 348, 524, 339,-170,  76,-273, 265, 594, 172,-158,
     c 402,  44, 346, 524, 335,-169,  74,-277, 265, 570, 172,-161,
     c 402,  35, 348, 522, 328,-178,  73,-281, 264, 530, 169,-164,
     c 402,  24, 354, 518, 321,-189,  69,-290, 261, 512, 161,-170,
     c 400,  14, 350, 514, 313,-195,  62,-299, 255, 518, 152,-179,
     c 394,   8, 339, 509, 299,-202,  53,-311, 246, 522, 143,-192,
     c 384,  -2, 324, 494, 281,-212,  41,-329, 236, 515, 135,-205,
     c 375, -14, 308, 482, 266,-228,  29,-346, 227, 499, 129,-219,
     c 365, -19, 293, 474, 253,-235,  16,-358, 219, 471, 126,-228,
     c 360, -15, 288, 473, 246,-237,  12,-362, 214, 425, 125,-232,
     c 360,  -4, 289, 473, 247,-240,  11,-362, 213, 378, 126,-233,
     c 365,   6, 294, 473, 249,-240,  15,-359, 215, 344, 129,-231,
     c 371,  16, 297, 472, 246,-241,  15,-364, 217, 325, 130,-230,
     c 377,  24, 301, 474, 248,-239,  15,-367, 217, 304, 129,-229,
     c 377,  25, 301, 472, 247,-253,  14,-378, 212, 279, 124,-232,
     c 371,  20, 296, 463, 241,-263,  10,-389, 206, 251, 116,-237,
     c 367,  10, 283, 454, 230,-280,   4,-402, 200, 231, 108,-244,
     c 365,   4, 272, 453, 221,-284,  -2,-415, 194, 240, 101,-251,
     c 357,   0, 265, 455, 216,-289,  -5,-422, 191, 245,  97,-257,
     c 354,  -4, 256, 452, 211,-302,  -3,-428, 192, 229,  96,-260,
     c 362,  -3, 250, 455, 207,-308,   0,-427, 193, 184,  98,-262,
     c 372,   1, 258, 460, 205,-300,   3,-427, 195, 173, 102,-261,
     c 376,   3, 260, 461, 204,-295,   5,-426, 197, 182, 107,-260,
     c 380,   6, 264, 463, 204,-293,   4,-424, 199, 213, 113,-256,
     c 448,  74, 425, 603, 441, -84, 136,-176, 327, 706, 228, -71,
     c 443,  66, 407, 593, 428, -92, 130,-181, 322, 705, 221, -79,
     c 436,  58, 390, 582, 416,-100, 124,-194, 316, 699, 215, -87,
     c 430,  50, 371, 575, 405,-111, 119,-206, 309, 682, 207, -95,
     c 426,  42, 359, 569, 395,-119, 114,-216, 301, 663, 198,-105,
     c 427,  39, 360, 563, 384,-127, 110,-225, 293, 644, 192,-114,
     c 427,  45, 365, 556, 376,-130, 108,-233, 286, 626, 189,-122,
     c 423,  55, 369, 550, 369,-141, 103,-241, 282, 612, 189,-130,
     c 420,  64, 372, 546, 365,-145,  97,-250, 280, 607, 189,-135,
     c 420,  65, 368, 542, 358,-149,  93,-257, 279, 604, 190,-140,
     c 419,  60, 361, 538, 350,-155,  89,-263, 278, 580, 188,-146,
     c 415,  48, 359, 533, 339,-171,  84,-267, 275, 543, 183,-151,
     c 415,  34, 363, 528, 331,-182,  79,-277, 272, 522, 172,-159,
     c 411,  23, 358, 521, 320,-195,  72,-289, 264, 522, 161,-170,
     c 401,  15, 347, 514, 305,-203,  64,-301, 254, 524, 153,-183,
     c 391,   6, 332, 502, 288,-211,  50,-319, 244, 513, 145,-198,
     c 383,  -3, 318, 489, 274,-227,  35,-337, 235, 495, 138,-212,
     c 373, -10, 301, 480, 260,-235,  23,-351, 227, 464, 134,-222,
     c 363,  -7, 292, 478, 251,-239,  18,-357, 221, 419, 132,-228,
     c 361,   0, 291, 481, 251,-239,  17,-359, 219, 375, 133,-229,
     c 366,   8, 295, 480, 251,-239,  18,-358, 222, 345, 134,-228,
     c 374,  18, 298, 477, 250,-238,  20,-361, 223, 323, 135,-228,
     c 376,  26, 300, 475, 248,-236,  20,-363, 221, 298, 133,-231,
     c 375,  26, 300, 471, 245,-247,  16,-375, 215, 271, 125,-236,
     c 370,  18, 290, 460, 235,-266,   8,-388, 206, 242, 114,-243,
     c 362,   8, 280, 450, 222,-282,  -2,-406, 198, 225, 105,-251,
     c 355,   1, 274, 446, 214,-288,  -8,-421, 193, 235,  98,-258,
     c 350,  -4, 269, 446, 210,-291, -10,-427, 190, 233,  93,-261,
     c 351,  -7, 263, 448, 209,-295,  -8,-431, 192, 217,  93,-264,
     c 359,  -7, 258, 453, 208,-301,  -4,-430, 194, 187,  97,-263,
     c 369,  -1, 261, 459, 206,-298,   0,-429, 196, 198, 102,-261,
     c 374,   1, 262, 462, 206,-293,   2,-426, 198, 212, 107,-258,
     c 378,   4, 263, 463, 206,-295,   2,-425, 201, 243, 113,-256,
     c 475, 100, 444, 627, 465, -60, 160,-151, 352, 716, 248, -49,
     c 467,  91, 427, 616, 451, -71, 153,-159, 345, 715, 242, -57,
     c 461,  83, 410, 604, 439, -81, 147,-171, 339, 709, 234, -65,
     c 452,  73, 390, 595, 427, -89, 140,-182, 330, 695, 226, -75,
     c 449,  64, 378, 588, 415, -97, 136,-194, 321, 678, 218, -85,
     c 448,  58, 375, 579, 403,-110, 132,-203, 311, 659, 212, -95,
     c 447,  64, 382, 574, 394,-113, 128,-214, 303, 641, 209,-102,
     c 444,  76, 389, 569, 389,-123, 122,-224, 297, 626, 209,-110,
     c 442,  83, 390, 564, 383,-125, 115,-234, 295, 621, 208,-116,
     c 440,  83, 386, 559, 374,-125, 110,-240, 293, 614, 207,-123,
     c 435,  75, 379, 554, 363,-130, 105,-247, 292, 590, 204,-129,
     c 430,  59, 373, 546, 352,-146, 100,-255, 288, 553, 196,-137,
     c 427,  43, 371, 539, 343,-163,  93,-264, 282, 528, 185,-147,
     c 421,  32, 365, 530, 329,-181,  85,-276, 274, 520, 173,-158,
     c 413,  26, 353, 521, 314,-195,  76,-291, 265, 513, 164,-172,
     c 404,  17, 340, 511, 299,-205,  62,-307, 256, 497, 156,-187,
     c 397,   9, 329, 501, 284,-214,  48,-325, 246, 476, 151,-200,
     c 387,   4, 315, 493, 270,-221,  37,-340, 238, 443, 147,-210,
     c 375,   5, 305, 489, 263,-225,  29,-348, 232, 404, 143,-216,
     c 370,   9, 303, 489, 261,-227,  28,-352, 231, 367, 142,-219,
     c 373,  15, 303, 488, 259,-232,  28,-353, 231, 341, 142,-221,
     c 379,  22, 302, 484, 257,-230,  30,-357, 231, 319, 142,-223,
     c 381,  28, 301, 480, 252,-231,  27,-360, 226, 294, 138,-228,
     c 377,  26, 297, 471, 243,-243,  20,-371, 218, 267, 128,-237,
     c 369,  17, 287, 458, 232,-263,   8,-385, 208, 246, 115,-247,
     c 362,   7, 279, 449, 220,-278,  -3,-405, 198, 239, 104,-255,
     c 355,   0, 275, 444, 210,-286, -12,-419, 192, 250,  97,-261,
     c 352,  -5, 273, 442, 209,-290, -12,-424, 190, 240,  92,-265,
     c 353,  -8, 268, 445, 208,-290,  -8,-428, 193, 220,  92,-264,
     c 362,  -6, 265, 453, 208,-294,  -2,-427, 196, 198,  98,-262,
     c 373,   1, 266, 463, 210,-294,   3,-427, 199, 208, 104,-258,
     c 377,   5, 266, 467, 211,-293,   5,-424, 202, 222, 110,-255,
     c 382,   9, 264, 470, 212,-292,   6,-422, 205, 251, 117,-252,
     c 496, 121, 459, 650, 485, -40, 180,-127, 373, 728, 268, -30,
     c 488, 111, 443, 637, 472, -51, 173,-137, 366, 728, 260, -39,
     c 481, 102, 425, 624, 458, -59, 167,-149, 358, 722, 253, -48,
     c 471,  92, 407, 613, 446, -70, 159,-163, 348, 709, 244, -57,
     c 463,  81, 392, 602, 432, -85, 153,-174, 337, 694, 236, -68,
     c 461,  76, 391, 595, 421, -92, 149,-186, 326, 673, 230, -77,
     c 463,  81, 397, 590, 413, -97, 146,-198, 318, 652, 227, -85,
     c 460,  92, 405, 584, 406,-105, 139,-209, 313, 637, 226, -92,
     c 459,  99, 409, 579, 398,-107, 131,-217, 310, 630, 225,-100,
     c 459,  97, 406, 575, 391,-108, 126,-228, 308, 621, 224,-107,
     c 453,  86, 398, 571, 379,-113, 120,-235, 305, 598, 219,-115,
     c 444,  68, 388, 560, 365,-135, 113,-243, 300, 562, 211,-123,
     c 439,  51, 381, 549, 354,-154, 107,-252, 293, 535, 198,-133,
     c 433,  41, 370, 539, 341,-174, 100,-265, 285, 519, 186,-146,
     c 426,  36, 358, 530, 325,-186,  89,-278, 276, 506, 177,-159,
     c 420,  31, 349, 521, 312,-194,  76,-294, 268, 485, 170,-173,
     c 413,  24, 339, 513, 297,-199,  62,-309, 260, 461, 165,-186,
     c 402,  21, 328, 507, 283,-202,  52,-322, 253, 428, 160,-196,
     c 391,  21, 322, 504, 278,-210,  47,-331, 247, 393, 157,-202,
     c 386,  23, 320, 503, 275,-214,  44,-338, 245, 363, 153,-206,
     c 386,  27, 316, 501, 270,-214,  43,-339, 244, 340, 152,-210,
     c 389,  30, 310, 496, 266,-217,  42,-347, 241, 318, 149,-216,
     c 390,  32, 306, 488, 258,-225,  37,-352, 233, 294, 143,-224,
     c 386,  27, 298, 477, 246,-234,  28,-366, 221, 269, 131,-237,
     c 375,  15, 288, 460, 229,-260,  13,-385, 209, 260, 116,-248,
     c 367,   4, 280, 448, 215,-280,   0,-401, 198, 267, 104,-259,
     c 362,  -1, 274, 441, 208,-288,  -9,-415, 191, 281,  96,-265,
     c 358,  -3, 275, 440, 207,-291,  -9,-422, 191, 263,  92,-267,
     c 360,  -5, 274, 444, 209,-291,  -4,-426, 194, 238,  93,-264,
     c 370,   0, 271, 454, 210,-293,   2,-424, 199, 208, 100,-258,
     c 378,   9, 269, 466, 213,-293,  10,-419, 204, 207, 107,-254,
     c 384,  14, 268, 471, 213,-292,  14,-414, 209, 220, 115,-249,
     c 393,  20, 267, 478, 218,-295,  19,-409, 211, 244, 122,-246,
     c 515, 137, 476, 668, 503, -21, 198,-110, 391, 743, 286, -12,
     c 505, 127, 459, 654, 490, -33, 190,-120, 383, 744, 279, -21,
     c 496, 117, 442, 641, 478, -39, 182,-136, 374, 740, 271, -31,
     c 484, 107, 421, 629, 463, -53, 174,-151, 363, 729, 262, -42,
     c 476,  96, 409, 618, 449, -63, 169,-163, 351, 711, 254, -52,
     c 473,  90, 408, 609, 439, -73, 164,-171, 340, 686, 248, -62,
     c 475,  95, 414, 604, 431, -78, 159,-182, 331, 662, 245, -70,
     c 475, 103, 423, 599, 420, -87, 154,-192, 327, 644, 243, -77,
     c 476, 108, 428, 594, 411, -91, 146,-203, 324, 635, 241, -84,
     c 476, 105, 427, 589, 405, -96, 140,-213, 322, 626, 239, -92,
     c 469,  93, 416, 583, 394,-111, 133,-223, 317, 606, 233,-101,
     c 458,  75, 402, 573, 381,-124, 126,-236, 310, 573, 225,-111,
     c 451,  59, 391, 560, 368,-143, 118,-247, 303, 548, 212,-122,
     c 447,  51, 376, 548, 355,-161, 110,-258, 294, 530, 200,-134,
     c 440,  47, 365, 539, 339,-171, 101,-270, 286, 516, 191,-147,
     c 434,  44, 357, 531, 325,-182,  90,-281, 280, 493, 184,-160,
     c 428,  41, 352, 526, 311,-188,  77,-292, 275, 466, 179,-172,
     c 418,  38, 344, 522, 300,-198,  69,-305, 269, 436, 174,-181,
     c 408,  39, 342, 520, 295,-203,  64,-312, 264, 403, 170,-188,
     c 403,  41, 338, 519, 292,-204,  62,-319, 260, 371, 165,-193,
     c 401,  40, 330, 515, 285,-202,  58,-326, 256, 345, 161,-200,
     c 400,  37, 318, 506, 274,-206,  53,-336, 250, 323, 156,-209,
     c 398,  35, 309, 495, 262,-219,  45,-346, 238, 295, 146,-222,
     c 389,  27, 301, 481, 247,-231,  33,-362, 224, 277, 133,-236,
     c 377,  13, 290, 464, 229,-255,  17,-380, 208, 280, 117,-251,
     c 367,   2, 279, 448, 214,-277,   2,-397, 196, 305, 104,-263,
     c 362,  -2, 275, 441, 206,-289,  -5,-409, 189, 321,  96,-269,
     c 361,  -2, 275, 438, 207,-294,  -6,-414, 190, 305,  92,-269,
     c 366,  -1, 274, 445, 209,-292,  -1,-419, 195, 278,  95,-263,
     c 378,   6, 273, 457, 214,-288,   7,-418, 202, 248, 102,-255,
     c 390,  18, 274, 469, 216,-290,  18,-410, 210, 237, 111,-249,
     c 400,  26, 276, 477, 221,-285,  26,-404, 216, 242, 119,-243,
     c 409,  33, 276, 486, 225,-280,  32,-396, 221, 258, 127,-238,
     c 531, 149, 491, 680, 517,  -8, 211, -97, 406, 764, 302,   3,
     c 521, 140, 474, 667, 506, -17, 205,-106, 398, 766, 295,  -5,
     c 511, 130, 457, 655, 494, -20, 199,-120, 388, 761, 287, -15,
     c 498, 120, 437, 643, 480, -33, 190,-137, 376, 750, 279, -26,
     c 487, 107, 422, 631, 464, -46, 183,-148, 364, 732, 270, -39,
     c 483, 100, 422, 621, 452, -55, 177,-159, 353, 703, 263, -48,
     c 483, 102, 427, 614, 441, -63, 172,-169, 345, 673, 260, -57,
     c 486, 110, 435, 611, 432, -69, 166,-181, 340, 652, 257, -65,
     c 488, 112, 440, 606, 424, -73, 158,-193, 337, 642, 255, -73,
     c 487, 109, 439, 599, 416, -82, 150,-206, 333, 632, 252, -81,
     c 479,  97, 429, 593, 407, -91, 143,-218, 329, 613, 247, -90,
     c 469,  79, 414, 585, 396,-102, 134,-230, 320, 584, 237,-101,
     c 460,  64, 398, 571, 381,-124, 125,-244, 311, 561, 225,-113,
     c 456,  59, 384, 557, 364,-141, 117,-252, 303, 545, 213,-124,
     c 453,  59, 374, 550, 350,-157, 108,-261, 296, 532, 204,-137,
     c 448,  57, 368, 543, 337,-168,  99,-271, 291, 512, 197,-149,
     c 441,  55, 365, 540, 325,-173,  90,-282, 288, 488, 193,-159,
     c 432,  53, 361, 536, 316,-178,  84,-292, 285, 458, 188,-168,
     c 421,  56, 359, 534, 307,-186,  79,-298, 280, 424, 183,-174,
     c 414,  56, 351, 530, 301,-192,  76,-308, 274, 392, 178,-182,
     c 411,  51, 340, 523, 293,-191,  70,-315, 267, 364, 171,-191,
     c 407,  44, 324, 513, 279,-199,  61,-331, 258, 337, 162,-204,
     c 398,  36, 309, 496, 263,-216,  48,-344, 242, 308, 150,-221,
     c 386,  25, 298, 481, 246,-227,  33,-362, 223, 293, 133,-238,
     c 372,   9, 287, 461, 228,-253,  16,-383, 206, 299, 115,-255,
     c 361,  -1, 276, 448, 211,-272,   1,-399, 193, 327, 102,-268,
     c 356,  -5, 271, 437, 204,-284,  -6,-410, 186, 351,  93,-273,
     c 359,  -3, 271, 436, 208,-289,  -7,-415, 188, 338,  91,-271,
     c 365,   0, 268, 444, 211,-286,   0,-416, 195, 310,  95,-264,
     c 381,  11, 269, 457, 215,-281,  11,-413, 206, 287, 103,-254,
     c 402,  27, 277, 472, 222,-279,  23,-401, 215, 274, 113,-244,
     c 412,  35, 279, 483, 228,-273,  35,-394, 222, 274, 122,-238,
     c 421,  44, 282, 492, 232,-269,  42,-384, 228, 281, 130,-233,
     c 548, 161, 504, 693, 531,   6, 230, -84, 421, 784, 316,  19,
     c 538, 150, 488, 681, 521,   0, 223, -92, 412, 785, 308,   9,
     c 526, 139, 470, 669, 509,  -6, 216,-105, 401, 780, 301,  -1,
     c 512, 127, 451, 657, 493, -19, 207,-120, 389, 766, 292, -13,
     c 502, 113, 437, 643, 477, -30, 199,-135, 376, 745, 283, -25,
     c 495, 104, 432, 630, 462, -38, 191,-147, 365, 714, 276, -37,
     c 494, 107, 436, 623, 451, -45, 184,-156, 357, 683, 272, -47,
     c 495, 112, 442, 618, 442, -52, 177,-169, 352, 661, 268, -56,
     c 496, 114, 447, 611, 435, -60, 166,-184, 348, 649, 265, -63,
     c 492, 109, 444, 604, 427, -74, 156,-200, 344, 639, 262, -73,
     c 481,  96, 434, 598, 416, -84, 147,-212, 337, 619, 256, -83,
     c 473,  80, 420, 589, 405, -98, 138,-227, 327, 591, 247, -94,
     c 463,  67, 405, 577, 387,-115, 128,-242, 317, 569, 235,-106,
     c 460,  65, 393, 566, 369,-133, 119,-251, 308, 556, 223,-118,
     c 457,  66, 383, 558, 355,-151, 111,-259, 303, 544, 214,-130,
     c 456,  67, 378, 552, 345,-157, 103,-262, 300, 528, 207,-140,
     c 451,  66, 375, 551, 336,-162,  97,-272, 298, 509, 203,-150,
     c 442,  66, 374, 547, 327,-168,  92,-279, 297, 486, 200,-158,
     c 434,  67, 373, 542, 319,-179,  89,-287, 292, 460, 194,-165,
     c 425,  66, 364, 534, 308,-187,  84,-299, 286, 433, 188,-174,
     c 418,  59, 350, 526, 297,-191,  76,-313, 276, 406, 178,-186,
     c 408,  47, 331, 515, 281,-202,  62,-330, 261, 376, 166,-202,
     c 395,  34, 312, 498, 263,-218,  46,-347, 241, 346, 149,-221,
     c 381,  19, 295, 478, 243,-240,  28,-365, 220, 328, 129,-243,
     c 365,   2, 282, 458, 224,-268,  10,-387, 200, 328, 109,-261,
     c 355, -10, 270, 443, 207,-283,  -4,-405, 187, 348,  96,-274,
     c 351, -12, 265, 436, 201,-289, -12,-412, 182, 367,  89,-278,
     c 355,  -9, 263, 434, 204,-292, -11,-416, 185, 355,  88,-275,
     c 366,   0, 263, 441, 209,-288,  -2,-414, 193, 326,  93,-266,
     c 384,  15, 266, 453, 215,-286,  10,-409, 205, 307, 102,-255,
     c 406,  34, 276, 472, 225,-277,  28,-400, 216, 294, 113,-244,
     c 417,  43, 280, 485, 232,-273,  39,-390, 225, 291, 121,-237,
     c 427,  53, 285, 496, 238,-266,  47,-381, 232, 294, 130,-230,
     c 559, 169, 515, 706, 546,  17, 245, -71, 435, 790, 326,  31,
     c 548, 157, 499, 695, 534,  12, 241, -81, 426, 788, 319,  21,
     c 537, 146, 484, 685, 521,   8, 233, -90, 414, 781, 311,  11,
     c 525, 132, 466, 673, 505,  -3, 223,-106, 402, 764, 304,  -1,
     c 514, 115, 450, 655, 486, -12, 212,-120, 388, 744, 295, -15,
     c 505, 105, 443, 641, 471, -25, 202,-134, 377, 715, 287, -28,
     c 502, 108, 445, 632, 460, -35, 193,-146, 367, 686, 282, -38,
     c 502, 112, 448, 624, 448, -45, 183,-160, 362, 664, 278, -48,
     c 501, 114, 450, 615, 441, -55, 173,-177, 358, 653, 271, -58,
     c 496, 109, 446, 607, 435, -70, 162,-195, 351, 642, 267, -67,
     c 484,  95, 434, 600, 421, -83, 151,-209, 342, 622, 262, -78,
     c 474,  80, 420, 592, 408, -90, 142,-225, 331, 593, 252, -91,
     c 464,  69, 407, 579, 389,-109, 131,-242, 319, 570, 240,-103,
     c 461,  67, 397, 571, 372,-124, 121,-253, 310, 557, 229,-115,
     c 459,  70, 390, 563, 359,-136, 113,-260, 305, 547, 220,-126,
     c 459,  72, 384, 557, 352,-143, 107,-264, 303, 532, 213,-136,
     c 457,  71, 381, 556, 342,-156, 101,-269, 304, 521, 210,-146,
     c 450,  71, 380, 550, 332,-161,  96,-278, 303, 509, 207,-153,
     c 442,  71, 380, 544, 323,-177,  94,-285, 298, 493, 202,-161,
     c 432,  70, 373, 538, 314,-182,  88,-296, 290, 475, 193,-171,
     c 418,  61, 357, 527, 296,-189,  78,-312, 277, 453, 182,-185,
     c 403,  44, 333, 510, 275,-210,  60,-333, 258, 424, 165,-205,
     c 388,  27, 309, 494, 257,-221,  39,-356, 234, 390, 145,-227,
     c 371,   8, 285, 473, 236,-247,  18,-378, 211, 364, 122,-250,
     c 356, -11, 270, 451, 216,-271,   0,-399, 192, 353, 102,-269,
     c 347, -24, 260, 438, 200,-286, -15,-413, 179, 357,  88,-282,
     c 344, -24, 255, 430, 195,-297, -21,-421, 175, 365,  83,-286,
     c 350, -17, 252, 429, 198,-296, -17,-422, 179, 355,  83,-281,
     c 366,  -2, 258, 434, 205,-294,  -8,-421, 189, 332,  89,-271,
     c 384,  17, 264, 449, 213,-292,   9,-413, 202, 311,  99,-258,
     c 401,  37, 275, 471, 227,-275,  28,-402, 213, 299, 110,-247,
     c 414,  47, 282, 484, 234,-270,  39,-394, 223, 297, 119,-238,
     c 427,  57, 288, 497, 242,-266,  48,-386, 231, 301, 127,-232,
     c 569, 173, 527, 717, 556,  37, 257, -54, 446, 775, 333,  39,
     c 558, 160, 512, 707, 544,  30, 253, -68, 435, 769, 326,  31,
     c 546, 147, 496, 696, 529,  22, 243, -81, 423, 760, 319,  19,
     c 534, 131, 479, 684, 512,   8, 232, -99, 410, 743, 311,   7,
     c 523, 115, 464, 666, 493,  -5, 221,-114, 396, 725, 302,  -7,
     c 513, 106, 456, 650, 478, -21, 210,-127, 384, 704, 295, -21,
     c 508, 108, 453, 640, 465, -34, 199,-139, 375, 683, 289, -33,
     c 507, 115, 453, 629, 453, -42, 189,-152, 368, 666, 282, -44,
     c 506, 117, 453, 619, 444, -52, 177,-169, 362, 655, 275, -55,
     c 498, 111, 444, 610, 434, -64, 166,-186, 354, 644, 269, -65,
     c 489,  97, 430, 602, 423, -75, 156,-204, 344, 624, 264, -76,
     c 476,  79, 415, 590, 406, -88, 145,-223, 332, 595, 254, -89,
     c 467,  68, 404, 579, 388,-104, 133,-241, 319, 570, 244,-102,
     c 461,  67, 397, 570, 373,-119, 122,-255, 309, 555, 232,-114,
     c 458,  69, 390, 562, 361,-134, 112,-264, 303, 542, 223,-126,
     c 457,  72, 384, 556, 354,-147, 106,-267, 301, 529, 216,-137,
     c 455,  72, 382, 554, 346,-154, 101,-272, 302, 519, 212,-145,
     c 451,  70, 382, 549, 334,-161,  97,-278, 302, 515, 208,-153,
     c 442,  69, 381, 545, 322,-175,  92,-285, 298, 508, 203,-162,
     c 429,  68, 373, 538, 311,-182,  85,-297, 288, 496, 192,-174,
     c 412,  57, 356, 525, 295,-194,  73,-312, 271, 476, 178,-191,
     c 394,  37, 327, 504, 269,-216,  51,-339, 249, 448, 158,-212,
     c 375,  15, 294, 481, 243,-235,  27,-368, 223, 408, 135,-237,
     c 356,  -7, 267, 461, 224,-261,   3,-391, 198, 376, 112,-262,
     c 341, -28, 252, 442, 205,-282, -15,-413, 180, 353,  91,-280,
     c 332, -40, 243, 426, 190,-298, -27,-425, 169, 341,  79,-292,
     c 331, -38, 238, 422, 185,-311, -30,-430, 167, 345,  75,-295,
     c 340, -25, 238, 424, 189,-304, -25,-429, 172, 345,  79,-289,
     c 355,  -5, 245, 430, 197,-302, -14,-425, 183, 329,  85,-277,
     c 376,  17, 259, 445, 212,-298,   4,-416, 196, 308,  96,-263,
     c 394,  36, 272, 467, 224,-282,  22,-406, 208, 303, 106,-252,
     c 406,  47, 282, 478, 232,-277,  34,-395, 218, 302, 115,-242,
     c 420,  58, 292, 489, 240,-272,  41,-392, 227, 308, 123,-235,
     c 573, 168, 532, 724, 561,  47, 262, -47, 450, 761, 334,  42,
     c 562, 154, 518, 712, 546,  36, 257, -64, 439, 750, 329,  34,
     c 551, 140, 504, 702, 530,  25, 249, -79, 428, 738, 321,  24,
     c 538, 124, 486, 685, 514,  11, 236, -97, 415, 721, 314,  10,
     c 524, 110, 470, 668, 495,   0, 222,-112, 401, 710, 306,  -3,
     c 514, 103, 461, 656, 480,  -9, 210,-125, 387, 698, 298, -17,
     c 508, 109, 458, 646, 467, -21, 200,-138, 377, 684, 291, -30,
     c 506, 118, 457, 634, 456, -36, 191,-152, 371, 671, 283, -41,
     c 503, 122, 453, 623, 444, -50, 180,-167, 363, 662, 275, -52,
     c 498, 115, 442, 613, 433, -61, 169,-185, 355, 648, 269, -64,
     c 488,  98, 425, 600, 419, -77, 157,-202, 343, 628, 262, -77,
     c 479,  78, 409, 585, 403, -94, 146,-222, 329, 598, 254, -90,
     c 469,  67, 400, 574, 386,-106, 134,-241, 315, 569, 243,-103,
     c 461,  65, 394, 564, 372,-122, 121,-257, 303, 547, 231,-117,
     c 457,  68, 388, 556, 362,-136, 110,-268, 297, 529, 221,-130,
     c 454,  68, 380, 551, 352,-148, 102,-273, 294, 513, 213,-140,
     c 451,  68, 376, 547, 342,-157,  96,-278, 295, 503, 208,-151,
     c 446,  63, 374, 542, 330,-171,  91,-286, 295, 497, 204,-160,
     c 437,  61, 372, 538, 316,-185,  85,-293, 290, 492, 196,-170,
     c 422,  57, 363, 531, 302,-186,  78,-308, 277, 482, 185,-183,
     c 404,  45, 344, 516, 285,-204,  63,-325, 259, 463, 168,-202,
     c 383,  24, 313, 492, 259,-230,  39,-353, 234, 429, 146,-225,
     c 363,   0, 278, 466, 231,-252,  13,-380, 207, 388, 123,-251,
     c 346, -23, 251, 447, 213,-278,  -7,-403, 184, 351,  99,-274,
     c 330, -43, 237, 430, 196,-297, -25,-424, 167, 310,  80,-293,
     c 319, -53, 228, 417, 182,-307, -36,-435, 160, 286,  69,-303,
     c 320, -47, 225, 415, 178,-314, -37,-439, 159, 287,  68,-304,
     c 332, -29, 227, 421, 186,-308, -29,-438, 167, 294,  74,-297,
     c 347,  -6, 235, 428, 194,-308, -16,-433, 178, 279,  82,-284,
     c 368,  17, 252, 441, 207,-305,   0,-424, 191, 261,  94,-270,
     c 388,  34, 270, 460, 219,-295,  18,-413, 202, 257, 104,-258,
     c 402,  44, 281, 470, 226,-285,  29,-405, 212, 257, 113,-248,
     c 414,  54, 292, 479, 233,-281,  34,-404, 221, 269, 120,-241,
     c 572, 157, 531, 722, 560,  45, 261, -52, 449, 756, 331,  40,
     c 561, 144, 516, 710, 543,  35, 255, -66, 438, 742, 325,  31,
     c 549, 130, 502, 698, 527,  25, 246, -81, 426, 728, 318,  21,
     c 535, 114, 485, 680, 509,   9, 232, -99, 413, 714, 312,  10,
     c 524, 103, 470, 666, 495,  -4, 221,-115, 399, 705, 304,  -4,
     c 513, 100, 464, 658, 483,  -7, 209,-128, 387, 697, 297, -17,
     c 506, 109, 461, 649, 469, -22, 200,-140, 377, 689, 290, -30,
     c 502, 120, 457, 637, 456, -36, 190,-154, 370, 678, 281, -42,
     c 499, 126, 451, 626, 444, -47, 181,-167, 363, 665, 271, -54,
     c 492, 118, 439, 615, 432, -60, 169,-185, 352, 651, 264, -65,
     c 483,  98, 421, 597, 414, -77, 157,-204, 339, 631, 258, -78,
     c 475,  77, 405, 579, 397, -96, 143,-223, 324, 599, 249, -93,
     c 467,  64, 395, 565, 379,-114, 130,-247, 308, 569, 238,-108,
     c 458,  61, 389, 555, 365,-132, 117,-261, 295, 541, 225,-123,
     c 453,  62, 384, 547, 355,-143, 105,-275, 288, 516, 214,-136,
     c 447,  61, 373, 541, 343,-160,  95,-283, 285, 497, 204,-149,
     c 440,  57, 362, 533, 330,-169,  88,-289, 283, 481, 198,-161,
     c 433,  50, 358, 526, 316,-187,  79,-298, 282, 469, 192,-172,
     c 424,  43, 355, 522, 303,-199,  71,-308, 275, 461, 183,-184,
     c 411,  37, 344, 516, 289,-201,  63,-324, 262, 448, 171,-199,
     c 394,  26, 325, 498, 270,-220,  47,-343, 243, 428, 152,-218,
     c 374,   6, 296, 474, 245,-247,  24,-369, 219, 397, 130,-242,
     c 355, -14, 264, 453, 220,-265,   0,-394, 193, 360, 107,-266,
     c 338, -35, 239, 437, 202,-286, -20,-415, 170, 318,  85,-289,
     c 326, -54, 226, 420, 188,-303, -34,-430, 156, 276,  68,-305,
     c 317, -59, 221, 413, 177,-307, -40,-439, 152, 243,  61,-313,
     c 317, -49, 219, 415, 175,-312, -38,-442, 154, 231,  62,-312,
     c 329, -28, 221, 420, 182,-307, -31,-441, 163, 233,  70,-304,
     c 347,  -4, 232, 428, 190,-307, -16,-433, 174, 222,  80,-290,
     c 366,  16, 251, 441, 201,-310,  -2,-422, 187, 197,  92,-276,
     c 384,  31, 270, 458, 215,-297,  14,-414, 198, 186, 103,-263,
     c 398,  40, 282, 467, 224,-292,  23,-408, 207, 189, 111,-254,
     c 411,  48, 293, 475, 230,-289,  28,-407, 215, 205, 118,-246,
     c 562, 144, 522, 711, 552,  36, 253, -65, 443, 755, 323,  31,
     c 552, 131, 509, 700, 534,  27, 247, -76, 432, 738, 317,  23,
     c 541, 117, 495, 686, 516,  20, 239, -88, 420, 724, 312,  15,
     c 529, 104, 480, 670, 501,   4, 226,-105, 407, 710, 306,   3,
     c 520,  96, 469, 660, 490,  -7, 215,-119, 394, 703, 300,  -8,
     c 510,  96, 463, 653, 478,  -8, 205,-135, 383, 696, 293, -22,
     c 504, 106, 461, 647, 465, -17, 197,-145, 374, 687, 286, -34,
     c 499, 119, 456, 636, 452, -31, 188,-158, 367, 675, 277, -45,
     c 495, 125, 448, 628, 441, -43, 181,-169, 360, 661, 267, -57,
     c 488, 119, 435, 615, 429, -58, 170,-187, 348, 644, 258, -70,
     c 477,  98, 416, 594, 410, -75, 153,-208, 334, 624, 251, -83,
     c 466,  75, 399, 571, 389,-101, 137,-233, 318, 595, 241, -99,
     c 458,  61, 388, 554, 371,-122, 123,-256, 301, 563, 230,-115,
     c 450,  55, 381, 544, 357,-139, 109,-273, 286, 531, 217,-131,
     c 440,  51, 371, 535, 343,-153,  95,-287, 276, 502, 204,-147,
     c 432,  48, 358, 527, 329,-172,  82,-297, 271, 477, 192,-162,
     c 423,  40, 346, 518, 314,-181,  73,-305, 269, 454, 182,-176,
     c 413,  29, 338, 507, 299,-203,  62,-318, 264, 436, 175,-189,
     c 405,  19, 333, 501, 285,-214,  52,-328, 256, 420, 166,-202,
     c 392,  11, 321, 491, 270,-224,  42,-346, 243, 406, 151,-218,
     c 378,   2, 304, 476, 253,-244,  28,-364, 224, 389, 134,-236,
     c 361, -12, 279, 457, 228,-263,   7,-385, 201, 371, 113,-259,
     c 343, -29, 252, 440, 206,-281, -13,-407, 178, 345,  91,-282,
     c 327, -46, 228, 425, 188,-302, -30,-426, 159, 313,  72,-302,
     c 317, -60, 218, 415, 178,-313, -41,-440, 148, 272,  59,-315,
     c 314, -61, 219, 411, 173,-314, -43,-444, 147, 233,  54,-320,
     c 317, -48, 219, 413, 172,-317, -38,-445, 151, 208,  58,-317,
     c 328, -25, 223, 419, 180,-308, -28,-441, 161, 196,  67,-307,
     c 349,  -3, 236, 427, 188,-305, -14,-435, 173, 174,  79,-295,
     c 369,  15, 256, 442, 200,-305,   0,-425, 185, 143,  91,-280,
     c 383,  27, 274, 457, 215,-294,  13,-419, 196, 127, 102,-268,
     c 397,  35, 285, 463, 223,-294,  20,-412, 204, 130, 110,-259,
     c 410,  42, 296, 469, 231,-285,  24,-410, 211, 151, 115,-251,
     c 554, 130, 514, 698, 542,  16, 241, -76, 432, 756, 311,  20,
     c 544, 118, 499, 684, 523,  12, 235, -86, 422, 736, 307,  12,
     c 532, 107, 486, 669, 507,  10, 226, -96, 411, 721, 302,   4,
     c 521,  94, 473, 655, 491,  -2, 215,-115, 399, 711, 298,  -5,
     c 514,  88, 463, 647, 481, -11, 207,-128, 387, 705, 292, -17,
     c 508,  90, 460, 644, 469, -12, 199,-142, 377, 696, 287, -29,
     c 502,  99, 458, 639, 457, -21, 192,-153, 369, 685, 281, -39,
     c 497, 112, 453, 633, 446, -31, 186,-164, 363, 670, 270, -50,
     c 491, 120, 443, 625, 436, -42, 178,-175, 355, 651, 259, -62,
     c 482, 114, 428, 613, 421, -56, 166,-189, 343, 631, 250, -75,
     c 469,  93, 407, 586, 399, -81, 149,-213, 328, 611, 241, -90,
     c 455,  70, 389, 559, 378,-110, 130,-241, 310, 584, 232,-107,
     c 447,  55, 378, 543, 362,-131, 113,-266, 292, 550, 219,-124,
     c 438,  46, 369, 532, 348,-147,  98,-282, 276, 515, 205,-142,
     c 427,  39, 355, 521, 330,-166,  82,-297, 264, 482, 190,-160,
     c 415,  31, 341, 513, 312,-182,  67,-311, 257, 452, 176,-176,
     c 404,  23, 331, 504, 299,-191,  53,-323, 252, 418, 165,-193,
     c 392,   7, 322, 492, 283,-213,  41,-339, 245, 389, 155,-208,
     c 381,  -6, 312, 478, 265,-233,  30,-351, 237, 371, 145,-222,
     c 370, -14, 299, 469, 249,-249,  19,-367, 223, 360, 130,-238,
     c 358, -20, 284, 455, 233,-266,   6,-382, 205, 354, 114,-256,
     c 342, -31, 262, 440, 213,-280,  -9,-403, 185, 350,  96,-275,
     c 326, -43, 236, 426, 190,-294, -27,-421, 165, 343,  78,-296,
     c 313, -54, 216, 416, 176,-311, -41,-435, 151, 330,  62,-312,
     c 307, -62, 211, 409, 172,-317, -48,-447, 144, 302,  52,-322,
     c 307, -61, 214, 408, 169,-317, -47,-449, 145, 261,  50,-324,
     c 314, -45, 219, 412, 171,-315, -40,-446, 152, 227,  56,-320,
     c 328, -23, 226, 420, 180,-305, -28,-439, 162, 206,  66,-310,
     c 347,  -3, 243, 429, 190,-301, -15,-433, 174, 173,  79,-297,
     c 367,  13, 262, 442, 202,-303,  -3,-426, 185, 130,  90,-284,
     c 382,  23, 276, 452, 214,-298,   9,-421, 196, 115, 101,-272,
     c 393,  30, 284, 457, 221,-296,  15,-415, 202, 119, 107,-263,
     c 404,  37, 293, 460, 228,-291,  20,-413, 208, 144, 111,-255,
     c 540, 110, 499, 687, 528,   4, 227, -84, 419, 758, 297,   6,
     c 532, 101, 487, 669, 510,   1, 221, -95, 407, 738, 293,   0,
     c 522,  91, 476, 650, 493,  -1, 212,-104, 396, 722, 289,  -8,
     c 513,  82, 462, 637, 479, -16, 203,-123, 386, 715, 285, -16,
     c 505,  78, 455, 630, 468, -29, 196,-137, 376, 708, 281, -26,
     c 500,  79, 452, 628, 457, -30, 189,-150, 368, 696, 277, -37,
     c 495,  88, 451, 629, 446, -36, 184,-163, 362, 681, 272, -47,
     c 489, 100, 444, 624, 435, -43, 179,-175, 356, 662, 263, -57,
     c 483, 108, 433, 617, 425, -47, 172,-184, 349, 639, 251, -69,
     c 474, 104, 418, 604, 411, -63, 160,-197, 336, 616, 239, -83,
     c 460,  86, 399, 578, 390, -90, 143,-223, 319, 595, 231, -98,
     c 446,  64, 379, 549, 369,-117, 123,-249, 301, 569, 220,-114,
     c 438,  48, 366, 531, 353,-140, 106,-275, 282, 533, 207,-134,
     c 425,  35, 353, 518, 337,-157,  88,-296, 265, 494, 192,-153,
     c 412,  24, 338, 508, 318,-176,  70,-315, 253, 458, 176,-172,
     c 402,  14, 326, 499, 299,-190,  52,-331, 244, 420, 159,-192,
     c 391,   4, 318, 489, 284,-204,  37,-344, 235, 375, 146,-211,
     c 376, -12, 307, 475, 266,-227,  23,-361, 227, 341, 135,-228,
     c 363, -26, 296, 462, 250,-246,   9,-374, 217, 326, 123,-243,
     c 353, -35, 283, 451, 234,-266,   0,-388, 203, 324, 111,-258,
     c 341, -39, 266, 439, 219,-279, -11,-402, 187, 328,  96,-274,
     c 324, -46, 243, 425, 197,-291, -24,-416, 171, 338,  81,-291,
     c 311, -54, 223, 416, 179,-304, -38,-431, 155, 349,  67,-307,
     c 303, -60, 210, 409, 168,-313, -48,-442, 145, 355,  56,-319,
     c 301, -64, 208, 406, 167,-322, -52,-451, 141, 338,  48,-326,
     c 305, -60, 212, 407, 167,-321, -49,-451, 144, 303,  49,-326,
     c 314, -44, 221, 414, 172,-319, -41,-448, 153, 265,  56,-321,
     c 331, -24, 233, 423, 182,-308, -29,-440, 163, 237,  66,-311,
     c 350,  -6, 248, 431, 192,-302, -17,-436, 174, 194,  78,-298,
     c 367,   8, 262, 439, 201,-300,  -6,-427, 185, 152,  89,-287,
     c 380,  18, 273, 446, 211,-298,   4,-424, 194, 133,  98,-276,
     c 390,  26, 279, 453, 218,-296,  12,-418, 200, 137, 104,-268,
     c 401,  32, 285, 454, 224,-292,  16,-415, 204, 167, 106,-261,
     c 524,  83, 480, 675, 513, -15, 213,-100, 400, 758, 279,  -9,
     c 518,  77, 470, 653, 497, -13, 205,-108, 389, 738, 277, -15,
     c 510,  70, 460, 633, 480,  -9, 196,-119, 379, 722, 273, -21,
     c 501,  65, 448, 617, 466, -26, 188,-134, 371, 715, 271, -29,
     c 494,  63, 442, 609, 455, -41, 184,-148, 362, 707, 268, -38,
     c 489,  66, 442, 611, 445, -40, 179,-161, 355, 692, 267, -47,
     c 483,  73, 439, 615, 434, -46, 176,-175, 351, 673, 262, -56,
     c 478,  85, 433, 614, 422, -48, 171,-187, 346, 652, 254, -65,
     c 474,  94, 423, 608, 412, -57, 164,-197, 339, 627, 241, -77,
     c 467,  93, 408, 594, 400, -74, 153,-209, 326, 603, 229, -91,
     c 453,  79, 389, 569, 381,-100, 135,-233, 310, 580, 219,-106,
     c 441,  60, 371, 542, 362,-127, 117,-256, 292, 554, 207,-124,
     c 430,  42, 354, 520, 345,-147,  99,-281, 273, 517, 194,-143,
     c 416,  25, 338, 505, 328,-162,  79,-305, 255, 476, 179,-163,
     c 400,  10, 321, 492, 306,-186,  59,-326, 241, 437, 161,-185,
     c 388,  -1, 310, 482, 285,-202,  39,-345, 230, 399, 143,-207,
     c 376, -13, 301, 471, 266,-223,  21,-360, 220, 349, 127,-228,
     c 362, -29, 291, 457, 250,-250,   5,-378, 210, 311, 115,-246,
     c 347, -44, 278, 444, 236,-271,  -7,-394, 198, 301, 103,-262,
     c 336, -52, 265, 434, 220,-289, -18,-406, 186, 308,  93,-276,
     c 328, -54, 248, 425, 205,-295, -25,-415, 174, 319,  81,-289,
     c 316, -56, 230, 417, 187,-303, -36,-425, 161, 334,  71,-303,
     c 305, -59, 215, 410, 172,-308, -46,-438, 149, 352,  61,-314,
     c 300, -63, 205, 406, 166,-313, -53,-444, 142, 362,  53,-323,
     c 302, -64, 206, 405, 165,-323, -53,-450, 141, 366,  48,-327,
     c 308, -58, 214, 409, 169,-319, -49,-449, 145, 342,  49,-326,
     c 319, -45, 224, 416, 174,-313, -41,-444, 154, 304,  56,-320,
     c 335, -27, 236, 425, 182,-303, -31,-439, 163, 266,  67,-311,
     c 352, -11, 249, 430, 187,-298, -20,-436, 173, 225,  77,-301,
     c 365,   1, 260, 436, 197,-298, -10,-431, 182, 180,  86,-290,
     c 375,  12, 268, 442, 208,-301,   1,-428, 189, 153,  93,-281,
     c 385,  20, 273, 449, 214,-295,   6,-423, 195, 162,  97,-274,
     c 393,  27, 276, 452, 218,-296,  10,-425, 198, 198,  99,-268,
     c 505,  53, 459, 655, 497, -41, 197,-117, 381, 746, 261, -24,
     c 500,  51, 451, 630, 483, -33, 188,-123, 370, 727, 258, -30,
     c 494,  48, 441, 608, 467, -35, 180,-134, 360, 713, 257, -37,
     c 488,  47, 432, 590, 450, -50, 172,-148, 352, 704, 255, -43,
     c 481,  47, 428, 586, 440, -60, 169,-163, 346, 695, 253, -51,
     c 474,  49, 428, 590, 430, -60, 168,-175, 341, 678, 253, -58,
     c 469,  57, 427, 596, 418, -62, 165,-186, 336, 659, 252, -66,
     c 466,  68, 420, 601, 408, -60, 161,-197, 333, 638, 244, -75,
     c 464,  79, 411, 599, 400, -64, 154,-206, 326, 614, 231, -87,
     c 459,  80, 399, 587, 388, -80, 141,-219, 315, 589, 219,-100,
     c 450,  71, 383, 564, 373,-102, 127,-239, 299, 566, 208,-115,
     c 437,  54, 363, 536, 357,-132, 110,-262, 281, 542, 196,-133,
     c 426,  35, 345, 514, 340,-152,  92,-286, 263, 506, 182,-152,
     c 410,  15, 325, 496, 320,-171,  72,-311, 246, 466, 166,-173,
     c 391,  -4, 306, 481, 296,-197,  50,-336, 231, 433, 147,-196,
     c 375, -17, 294, 468, 272,-221,  28,-357, 219, 394, 129,-218,
     c 363, -29, 286, 457, 253,-238,   8,-375, 207, 338, 113,-241,
     c 348, -43, 276, 443, 236,-266,  -8,-392, 195, 297,  99,-260,
     c 334, -57, 264, 430, 221,-288, -22,-407, 184, 295,  88,-275,
     c 321, -64, 248, 420, 206,-306, -32,-422, 173, 307,  78,-289,
     c 316, -64, 235, 414, 195,-306, -37,-428, 163, 314,  70,-300,
     c 308, -64, 221, 409, 180,-311, -43,-433, 154, 323,  63,-311,
     c 302, -64, 212, 405, 169,-310, -50,-439, 146, 338,  57,-319,
     c 299, -65, 204, 404, 166,-310, -53,-443, 141, 350,  52,-325,
     c 302, -64, 205, 407, 168,-316, -53,-448, 142, 354,  49,-327,
     c 309, -57, 213, 412, 172,-313, -48,-448, 148, 337,  51,-325,
     c 322, -45, 224, 418, 175,-306, -40,-445, 155, 300,  58,-319,
     c 334, -31, 233, 423, 179,-307, -33,-442, 164, 259,  67,-312,
     c 347, -16, 245, 427, 185,-305, -26,-441, 172, 217,  74,-303,
     c 358,  -3, 256, 432, 196,-302, -16,-436, 179, 178,  82,-294,
     c 368,   8, 262, 438, 206,-306,  -5,-433, 184, 157,  87,-287,
     c 375,  15, 264, 443, 208,-301,  -1,-427, 188, 168,  89,-281,
     c 382,  23, 265, 446, 210,-304,   2,-434, 190, 201,  90,-277,
     c 489,  29, 439, 630, 481, -63, 182,-133, 360, 728, 242, -42,
     c 486,  29, 432, 605, 466, -57, 173,-139, 349, 711, 241, -47,
     c 480,  28, 424, 581, 450, -55, 164,-147, 340, 698, 239, -52,
     c 475,  30, 417, 563, 433, -72, 158,-159, 334, 689, 238, -58,
     c 467,  31, 414, 562, 422, -78, 155,-175, 328, 680, 237, -64,
     c 462,  32, 415, 567, 415, -77, 156,-188, 324, 664, 237, -71,
     c 456,  38, 412, 578, 403, -77, 155,-199, 321, 645, 238, -78,
     c 453,  50, 405, 587, 396, -74, 148,-208, 318, 626, 232, -87,
     c 453,  61, 397, 587, 388, -78, 142,-218, 312, 604, 221, -98,
     c 451,  65, 387, 576, 378, -91, 130,-230, 301, 580, 208,-111,
     c 443,  60, 374, 556, 367,-115, 118,-248, 286, 559, 198,-126,
     c 432,  46, 356, 530, 355,-138, 101,-270, 269, 538, 185,-142,
     c 418,  26, 335, 507, 335,-160,  83,-292, 253, 509, 170,-162,
     c 401,   4, 314, 489, 312,-180,  61,-319, 237, 473, 154,-183,
     c 379, -16, 295, 472, 286,-203,  39,-346, 223, 440, 136,-205,
     c 363, -30, 283, 460, 263,-228,  16,-367, 209, 397, 117,-228,
     c 351, -41, 275, 449, 242,-248,  -2,-384, 197, 334, 101,-250,
     c 338, -53, 266, 436, 224,-272, -19,-402, 185, 290,  88,-270,
     c 323, -66, 251, 418, 208,-299, -32,-415, 175, 286,  77,-285,
     c 315, -71, 239, 410, 197,-308, -40,-428, 165, 296,  68,-296,
     c 309, -69, 231, 409, 189,-305, -45,-435, 157, 295,  63,-307,
     c 303, -67, 222, 406, 179,-308, -49,-439, 150, 288,  58,-314,
     c 300, -66, 215, 407, 171,-312, -52,-443, 146, 287,  55,-320,
     c 300, -65, 209, 410, 172,-308, -53,-444, 144, 291,  53,-324,
     c 304, -63, 209, 413, 176,-315, -50,-448, 145, 294,  52,-324,
     c 308, -56, 213, 417, 176,-314, -47,-447, 151, 280,  54,-322,
     c 319, -46, 222, 421, 176,-311, -40,-446, 158, 251,  60,-317,
     c 333, -33, 233, 424, 181,-309, -35,-443, 167, 224,  67,-311,
     c 343, -19, 243, 427, 188,-313, -29,-441, 172, 198,  72,-305,
     c 352,  -6, 251, 429, 196,-308, -20,-441, 177, 171,  77,-298,
     c 362,   5, 254, 434, 204,-314, -13,-439, 180, 169,  80,-293,
     c 367,  12, 253, 436, 205,-312, -10,-439, 182, 178,  82,-288,
     c 371,  19, 251, 438, 203,-310,  -8,-444, 183, 207,  82,-285,
     c 474,  13, 425, 608, 463, -83, 164,-144, 341, 715, 226, -58,
     c 471,  13, 418, 584, 447, -78, 157,-150, 332, 699, 225, -63,
     c 466,  13, 410, 559, 429, -77, 149,-159, 323, 686, 223, -68,
     c 463,  16, 404, 543, 414, -90, 144,-175, 317, 678, 222, -73,
     c 456,  16, 401, 538, 404, -99, 142,-191, 313, 669, 221, -78,
     c 448,  16, 399, 547, 397, -96, 141,-203, 309, 653, 222, -85,
     c 443,  20, 395, 562, 389, -88, 140,-214, 307, 635, 223, -90,
     c 442,  30, 390, 572, 381, -86, 135,-224, 303, 618, 217, -99,
     c 443,  42, 383, 572, 374, -94, 129,-231, 298, 597, 208,-110,
     c 441,  48, 374, 564, 365,-106, 117,-243, 286, 574, 197,-123,
     c 433,  46, 360, 546, 357,-127, 106,-257, 272, 558, 187,-138,
     c 422,  35, 343, 522, 347,-146,  89,-277, 258, 542, 174,-154,
     c 408,  15, 323, 498, 327,-172,  71,-300, 243, 519, 159,-173,
     c 391,  -6, 305, 481, 303,-191,  50,-326, 229, 487, 144,-193,
     c 370, -26, 288, 467, 280,-211,  29,-353, 216, 456, 126,-214,
     c 353, -40, 277, 454, 258,-235,   9,-375, 205, 411, 109,-236,
     c 341, -47, 269, 446, 239,-251,  -8,-393, 192, 342,  94,-257,
     c 330, -57, 259, 431, 219,-277, -22,-408, 181, 296,  82,-274,
     c 320, -66, 249, 418, 205,-300, -34,-418, 171, 293,  72,-288,
     c 314, -69, 241, 410, 195,-310, -42,-430, 162, 305,  66,-299,
     c 310, -66, 235, 411, 189,-308, -47,-434, 156, 293,  61,-308,
     c 306, -64, 231, 411, 184,-309, -49,-440, 151, 272,  59,-314,
     c 303, -63, 226, 413, 180,-311, -51,-440, 148, 250,  58,-318,
     c 303, -63, 222, 419, 180,-305, -51,-440, 148, 236,  56,-320,
     c 306, -60, 217, 421, 182,-310, -48,-442, 149, 227,  55,-321,
     c 312, -55, 217, 424, 181,-306, -45,-444, 156, 218,  57,-320,
     c 321, -47, 223, 427, 180,-306, -40,-444, 162, 198,  63,-317,
     c 333, -35, 233, 427, 184,-304, -35,-445, 169, 183,  67,-311,
     c 343, -22, 242, 426, 189,-309, -30,-443, 173, 170,  71,-307,
     c 352,  -8, 248, 428, 197,-309, -24,-441, 175, 164,  73,-302,
     c 358,   2, 245, 428, 201,-318, -18,-444, 176, 169,  74,-298,
     c 361,   9, 243, 428, 200,-320, -17,-443, 177, 175,  74,-296,
     c 366,  15, 239, 430, 198,-319, -16,-448, 177, 193,  74,-295,
     c 460,   6, 414, 593, 448, -94, 147,-162, 326, 712, 211, -75,
     c 457,   5, 406, 569, 430, -89, 141,-166, 316, 698, 210, -80,
     c 452,   4, 398, 546, 414, -87, 135,-176, 308, 685, 209, -84,
     c 448,   5, 389, 529, 401,-103, 130,-190, 303, 675, 207, -89,
     c 441,   2, 385, 525, 390,-109, 128,-205, 299, 665, 206, -93,
     c 435,   0, 385, 536, 382,-107, 126,-219, 296, 649, 206, -99,
     c 428,   2, 380, 548, 373,-103, 123,-230, 293, 631, 207,-105,
     c 427,  11, 373, 557, 365,-103, 119,-238, 290, 613, 204,-114,
     c 429,  23, 366, 556, 356,-111, 113,-245, 283, 592, 194,-124,
     c 429,  30, 359, 550, 351,-120, 103,-257, 274, 572, 185,-137,
     c 421,  29, 346, 532, 344,-136,  91,-270, 261, 558, 175,-151,
     c 409,  20, 329, 509, 333,-158,  76,-290, 248, 547, 164,-168,
     c 397,   4, 312, 488, 316,-183,  57,-313, 235, 530, 149,-185,
     c 379, -17, 295, 472, 293,-201,  37,-340, 224, 502, 134,-204,
     c 361, -34, 282, 460, 273,-219,  20,-365, 212, 471, 118,-223,
     c 347, -43, 276, 451, 254,-236,   4,-383, 202, 429, 103,-240,
     c 338, -48, 268, 444, 238,-253,  -8,-398, 191, 365,  90,-258,
     c 328, -54, 260, 434, 223,-273, -20,-409, 182, 320,  81,-273,
     c 321, -59, 252, 425, 213,-295, -28,-416, 173, 321,  74,-286,
     c 319, -60, 248, 420, 206,-302, -36,-423, 166, 337,  68,-295,
     c 319, -57, 246, 420, 199,-300, -40,-429, 161, 330,  65,-302,
     c 316, -54, 245, 422, 195,-301, -44,-435, 157, 297,  65,-308,
     c 314, -55, 243, 425, 192,-298, -46,-437, 154, 254,  65,-312,
     c 312, -57, 235, 425, 190,-298, -46,-440, 154, 218,  63,-315,
     c 312, -57, 228, 427, 188,-303, -43,-440, 157, 202,  61,-317,
     c 316, -55, 224, 430, 186,-301, -41,-442, 161, 189,  62,-318,
     c 325, -48, 227, 430, 185,-302, -38,-442, 168, 172,  65,-316,
     c 332, -38, 234, 429, 188,-301, -36,-442, 172, 158,  67,-312,
     c 342, -25, 243, 427, 191,-305, -32,-441, 174, 151,  68,-308,
     c 350, -11, 247, 425, 198,-311, -27,-442, 174, 149,  67,-306,
     c 355,   0, 242, 424, 200,-319, -22,-448, 173, 147,  67,-303,
     c 357,   4, 238, 422, 195,-326, -21,-451, 172, 148,  66,-303,
     c 358,   8, 234, 421, 190,-326, -24,-456, 172, 151,  65,-303,
     c 444,   2, 402, 580, 429,-102, 129,-177, 312, 715, 198, -91,
     c 441,   0, 393, 558, 416, -96, 124,-185, 302, 701, 198, -96,
     c 435,  -4, 384, 535, 402, -95, 120,-196, 294, 688, 197,-100,
     c 432,  -7, 374, 520, 392,-112, 116,-209, 290, 674, 194,-104,
     c 425, -11, 367, 518, 379,-118, 114,-223, 286, 663, 192,-109,
     c 418, -14, 366, 529, 370,-114, 111,-237, 283, 645, 191,-114,
     c 413, -14, 362, 539, 360,-115, 108,-247, 281, 627, 191,-121,
     c 412,  -5, 356, 544, 351,-118, 103,-254, 277, 608, 188,-129,
     c 414,   5, 349, 545, 343,-122,  95,-259, 271, 588, 181,-140,
     c 415,  11, 343, 537, 337,-137,  88,-268, 261, 569, 173,-152,
     c 409,  11, 330, 517, 331,-156,  78,-283, 249, 558, 164,-166,
     c 398,   5, 316, 494, 322,-171,  63,-301, 237, 551, 152,-181,
     c 384,  -7, 301, 476, 305,-194,  44,-323, 227, 537, 138,-198,
     c 368, -25, 286, 462, 282,-211,  26,-347, 218, 515, 124,-214,
     c 356, -39, 278, 453, 264,-222,  13,-366, 211, 488, 110,-229,
     c 348, -43, 273, 449, 253,-237,   2,-382, 203, 447,  99,-244,
     c 340, -45, 267, 445, 241,-248,  -5,-392, 196, 387,  91,-257,
     c 333, -47, 262, 440, 230,-266, -13,-401, 188, 342,  84,-268,
     c 328, -49, 259, 436, 225,-284, -20,-407, 181, 343,  80,-278,
     c 329, -48, 257, 433, 219,-290, -24,-412, 177, 357,  77,-286,
     c 331, -44, 259, 433, 214,-286, -30,-415, 172, 350,  75,-292,
     c 329, -41, 259, 434, 208,-292, -33,-422, 168, 317,  77,-298,
     c 323, -44, 254, 433, 202,-293, -35,-425, 165, 274,  76,-303,
     c 321, -50, 245, 432, 199,-294, -36,-431, 164, 233,  73,-308,
     c 320, -53, 236, 432, 194,-297, -37,-434, 166, 209,  70,-312,
     c 320, -54, 228, 434, 191,-294, -37,-440, 169, 192,  67,-314,
     c 325, -49, 227, 435, 192,-296, -37,-441, 174, 180,  68,-314,
     c 331, -40, 232, 433, 195,-294, -35,-442, 176, 160,  68,-312,
     c 338, -27, 239, 429, 198,-301, -33,-443, 175, 146,  66,-309,
     c 345, -13, 242, 427, 202,-307, -32,-446, 173, 137,  64,-309,
     c 350,  -4, 240, 425, 198,-319, -28,-451, 170, 134,  61,-309,
     c 348,  -1, 234, 421, 189,-332, -29,-457, 168, 126,  60,-310,
     c 347,   1, 230, 416, 180,-339, -32,-464, 167, 110,  58,-312,
     c 430,   0, 386, 569, 409,-113, 114,-195, 299, 713, 188,-108,
     c 425,  -5, 378, 549, 399,-113, 109,-201, 291, 699, 187,-112,
     c 420, -12, 368, 528, 388,-111, 106,-213, 283, 684, 186,-116,
     c 415, -20, 358, 516, 379,-127, 102,-224, 279, 668, 183,-120,
     c 408, -25, 349, 514, 368,-130, 100,-239, 275, 654, 180,-125,
     c 402, -29, 346, 521, 356,-126,  95,-255, 271, 637, 178,-130,
     c 398, -29, 342, 530, 345,-125,  92,-261, 268, 618, 177,-136,
     c 399, -20, 339, 536, 339,-129,  87,-266, 264, 600, 173,-145,
     c 402, -10, 334, 533, 334,-136,  82,-270, 258, 583, 167,-155,
     c 402,  -5, 328, 523, 330,-151,  74,-280, 249, 569, 159,-167,
     c 397,  -5, 315, 502, 323,-171,  65,-294, 238, 559, 151,-181,
     c 386,  -8, 303, 484, 314,-180,  49,-312, 228, 555, 140,-195,
     c 374, -17, 289, 465, 296,-202,  34,-335, 220, 543, 127,-210,
     c 363, -29, 280, 453, 275,-213,  20,-356, 214, 522, 115,-223,
     c 356, -38, 273, 449, 260,-225,  10,-374, 210, 497, 105,-235,
     c 353, -40, 271, 450, 253,-232,   4,-383, 206, 463,  98,-245,
     c 349, -39, 268, 450, 246,-243,   0,-387, 203, 409,  95,-253,
     c 343, -39, 267, 448, 240,-259,  -4,-392, 198, 365,  94,-260,
     c 340, -39, 267, 449, 237,-269,  -7,-394, 195, 347,  92,-266,
     c 343, -36, 271, 448, 234,-274, -11,-400, 190, 345,  91,-272,
     c 345, -31, 271, 446, 230,-274, -15,-400, 186, 330,  91,-278,
     c 342, -29, 269, 443, 221,-279, -18,-405, 183, 299,  91,-284,
     c 335, -33, 263, 443, 213,-278, -20,-412, 180, 261,  90,-291,
     c 331, -42, 253, 441, 209,-280, -25,-419, 177, 229,  85,-297,
     c 328, -49, 241, 437, 204,-283, -28,-427, 177, 215,  78,-304,
     c 327, -52, 233, 437, 199,-285, -32,-434, 178, 208,  73,-308,
     c 328, -49, 228, 440, 200,-289, -33,-440, 180, 200,  72,-310,
     c 332, -41, 229, 437, 203,-291, -35,-442, 179, 188,  70,-310,
     c 335, -29, 231, 430, 202,-300, -35,-446, 176, 184,  66,-310,
     c 340, -16, 234, 426, 201,-308, -34,-451, 171, 186,  61,-310,
     c 341,  -9, 231, 423, 196,-320, -34,-457, 167, 186,  59,-313,
     c 337,  -9, 227, 418, 184,-332, -36,-466, 164, 172,  56,-315,
     c 332,  -8, 221, 410, 172,-345, -40,-475, 162, 143,  53,-320,
     c 416,  -4, 371, 558, 393,-126,  99,-207, 287, 707, 177,-123,
     c 411, -13, 361, 540, 383,-123,  96,-218, 278, 692, 177,-128,
     c 405, -22, 353, 523, 373,-121,  94,-228, 272, 675, 175,-132,
     c 400, -33, 342, 512, 364,-137,  90,-242, 267, 658, 171,-137,
     c 394, -39, 334, 510, 354,-142,  87,-256, 263, 642, 167,-141,
     c 389, -42, 329, 516, 343,-140,  82,-270, 260, 623, 164,-146,
     c 388, -40, 325, 524, 333,-137,  78,-274, 256, 605, 161,-153,
     c 390, -33, 323, 528, 329,-139,  73,-277, 252, 588, 158,-161,
     c 390, -26, 319, 522, 326,-148,  68,-281, 246, 574, 152,-171,
     c 390, -21, 313, 508, 323,-165,  61,-292, 237, 565, 146,-182,
     c 386, -19, 304, 491, 317,-180,  52,-303, 229, 559, 139,-194,
     c 377, -19, 292, 474, 305,-189,  39,-322, 221, 553, 128,-208,
     c 365, -23, 281, 457, 288,-207,  24,-342, 215, 539, 118,-219,
     c 358, -30, 274, 449, 270,-214,  15,-360, 211, 520, 109,-230,
     c 355, -35, 270, 448, 257,-227,   9,-371, 210, 500, 104,-238,
     c 358, -34, 270, 454, 255,-233,   8,-379, 211, 478, 101,-243,
     c 359, -30, 272, 458, 254,-243,   8,-379, 211, 439, 102,-247,
     c 355, -29, 274, 460, 253,-257,   7,-380, 211, 401, 105,-250,
     c 356, -28, 281, 462, 252,-261,   5,-377, 209, 370, 107,-253,
     c 360, -24, 287, 465, 251,-262,   2,-380, 206, 347, 109,-257,
     c 360, -20, 283, 462, 247,-260,   1,-384, 202, 315, 109,-263,
     c 356, -19, 278, 459, 239,-260,  -2,-388, 198, 282, 108,-269,
     c 348, -24, 271, 457, 230,-263,  -7,-396, 194, 247, 104,-277,
     c 342, -33, 261, 455, 221,-262, -15,-407, 191, 227,  96,-285,
     c 338, -43, 251, 449, 213,-266, -21,-418, 188, 220,  87,-294,
     c 338, -47, 243, 446, 208,-274, -25,-427, 187, 217,  80,-301,
     c 338, -46, 236, 444, 208,-282, -27,-432, 185, 207,  76,-305,
     c 337, -39, 231, 436, 208,-292, -32,-438, 181, 199,  72,-308,
     c 339, -30, 230, 426, 203,-312, -35,-445, 176, 211,  66,-310,
     c 340, -20, 230, 421, 198,-320, -36,-453, 170, 231,  61,-312,
     c 335, -16, 224, 417, 191,-333, -38,-462, 165, 243,  56,-317,
     c 326, -18, 218, 409, 179,-348, -42,-473, 160, 229,  52,-321,
     c 318, -20, 210, 400, 165,-358, -47,-484, 157, 192,  48,-327,
     c 400, -13, 353, 545, 382,-138,  83,-225, 273, 702, 167,-138,
     c 395, -23, 344, 531, 371,-135,  82,-235, 266, 686, 166,-142,
     c 390, -34, 334, 517, 360,-137,  80,-246, 261, 669, 163,-147,
     c 386, -45, 327, 509, 352,-146,  76,-261, 255, 650, 159,-152,
     c 381, -51, 319, 507, 341,-155,  72,-273, 251, 631, 155,-157,
     c 376, -52, 313, 512, 329,-152,  66,-285, 248, 611, 151,-163,
     c 375, -51, 309, 516, 321,-150,  64,-287, 245, 591, 146,-168,
     c 377, -45, 308, 516, 319,-154,  59,-289, 240, 576, 142,-176,
     c 377, -41, 305, 506, 319,-164,  54,-291, 235, 566, 138,-186,
     c 377, -37, 300, 493, 313,-181,  47,-302, 228, 560, 133,-197,
     c 374, -34, 291, 476, 305,-196,  40,-312, 220, 555, 128,-207,
     c 367, -30, 284, 462, 293,-203,  29,-332, 213, 546, 120,-217,
     c 359, -27, 277, 453, 280,-214,  19,-350, 210, 529, 111,-227,
     c 354, -28, 271, 449, 267,-220,  11,-363, 210, 510, 105,-234,
     c 356, -29, 272, 453, 260,-227,  10,-370, 212, 496, 104,-237,
     c 363, -23, 277, 464, 261,-224,  14,-372, 216, 488, 106,-239,
     c 367, -18, 283, 473, 266,-233,  19,-370, 219, 472, 111,-238,
     c 370, -15, 293, 478, 271,-239,  21,-365, 223, 449, 118,-237,
     c 373, -13, 302, 480, 273,-238,  20,-365, 223, 419, 123,-239,
     c 377, -10, 306, 483, 271,-241,  19,-363, 222, 387, 125,-241,
     c 377,  -7, 302, 484, 267,-233,  18,-366, 219, 352, 125,-246,
     c 368, -10, 293, 479, 258,-236,  13,-371, 214, 315, 123,-254,
     c 360, -15, 283, 475, 248,-246,   5,-382, 209, 282, 117,-263,
     c 352, -25, 270, 468, 236,-250,  -5,-394, 204, 262, 107,-274,
     c 347, -36, 262, 462, 223,-254, -13,-409, 198, 254,  95,-285,
     c 346, -41, 258, 457, 218,-263, -19,-418, 194, 235,  86,-294,
     c 344, -41, 250, 448, 217,-279, -22,-426, 189, 210,  79,-300,
     c 342, -36, 242, 437, 213,-291, -28,-435, 182, 196,  74,-304,
     c 345, -29, 237, 429, 205,-308, -31,-446, 176, 213,  66,-309,
     c 342, -23, 233, 421, 199,-320, -36,-458, 168, 244,  60,-314,
     c 329, -23, 222, 412, 189,-335, -40,-469, 161, 269,  54,-321,
     c 318, -27, 215, 405, 176,-351, -44,-479, 156, 254,  49,-327,
     c 307, -31, 206, 399, 164,-362, -51,-490, 152, 213,  44,-334,
     c 386, -20, 334, 535, 377,-144,  70,-239, 262, 695, 156,-152,
     c 382, -31, 327, 522, 364,-146,  70,-247, 255, 680, 155,-157,
     c 377, -42, 321, 511, 351,-146,  67,-259, 249, 663, 152,-161,
     c 374, -53, 314, 506, 341,-158,  64,-274, 245, 643, 148,-167,
     c 369, -60, 307, 504, 329,-163,  58,-285, 241, 623, 142,-172,
     c 365, -61, 299, 506, 319,-163,  53,-292, 237, 602, 137,-178,
     c 363, -61, 292, 505, 313,-167,  49,-296, 234, 582, 133,-184,
     c 363, -58, 290, 500, 311,-175,  44,-297, 230, 567, 128,-191,
     c 364, -55, 291, 490, 311,-180,  40,-304, 226, 558, 125,-200,
     c 363, -52, 288, 476, 306,-199,  34,-315, 220, 556, 121,-209,
     c 362, -47, 279, 461, 295,-210,  26,-326, 213, 552, 118,-218,
     c 360, -38, 276, 452, 284,-214,  21,-342, 209, 539, 112,-226,
     c 357, -30, 275, 451, 275,-218,  14,-353, 207, 519, 106,-232,
     c 355, -26, 273, 452, 267,-220,  11,-363, 210, 500, 104,-235,
     c 358, -23, 274, 460, 266,-224,  14,-367, 216, 489, 106,-236,
     c 367, -14, 283, 474, 271,-222,  22,-363, 222, 487, 113,-234,
     c 376,  -5, 297, 487, 279,-222,  29,-356, 230, 487, 122,-230,
     c 384,   0, 309, 492, 288,-226,  35,-350, 235, 481, 130,-226,
     c 390,   0, 319, 496, 293,-225,  37,-347, 238, 461, 137,-225,
     c 393,   2, 322, 501, 291,-228,  37,-347, 237, 433, 140,-227,
     c 391,   2, 317, 503, 284,-218,  34,-351, 235, 398, 140,-232,
     c 383,   0, 305, 498, 275,-222,  29,-358, 230, 366, 138,-241,
     c 372,  -7, 293, 490, 261,-234,  18,-372, 223, 339, 130,-251,
     c 363, -16, 282, 480, 248,-242,   6,-386, 215, 324, 118,-264,
     c 357, -25, 277, 471, 235,-248,  -5,-401, 207, 308, 103,-276,
     c 352, -32, 272, 461, 228,-262, -14,-412, 200, 274,  92,-287,
     c 351, -34, 265, 452, 224,-279, -18,-421, 192, 237,  85,-294,
     c 351, -31, 254, 442, 221,-288, -24,-431, 184, 211,  77,-301,
     c 349, -27, 244, 430, 209,-305, -29,-444, 175, 217,  69,-308,
     c 343, -24, 234, 419, 198,-318, -37,-460, 166, 245,  61,-316,
     c 330, -27, 225, 414, 189,-327, -40,-473, 158, 269,  53,-323,
     c 318, -33, 216, 409, 178,-339, -46,-482, 152, 255,  47,-332,
     c 304, -40, 205, 405, 165,-351, -55,-493, 147, 217,  40,-341,
     c 374, -28, 321, 525, 370,-155,  58,-250, 251, 685, 146,-164,
     c 370, -38, 316, 515, 356,-153,  57,-258, 245, 670, 145,-169,
     c 366, -48, 310, 505, 342,-157,  56,-271, 240, 653, 142,-175,
     c 362, -59, 304, 501, 329,-165,  50,-283, 236, 636, 136,-180,
     c 356, -66, 295, 497, 317,-174,  46,-294, 232, 617, 130,-186,
     c 355, -68, 286, 497, 310,-177,  41,-299, 229, 598, 124,-192,
     c 354, -68, 279, 494, 306,-182,  38,-304, 225, 579, 120,-198,
     c 354, -67, 277, 488, 306,-188,  35,-308, 223, 564, 116,-205,
     c 354, -65, 279, 477, 307,-191,  30,-315, 218, 555, 113,-213,
     c 353, -61, 278, 464, 301,-207,  23,-325, 214, 554, 112,-220,
     c 356, -53, 274, 455, 292,-215,  19,-339, 210, 552, 110,-227,
     c 359, -41, 274, 452, 282,-218,  15,-347, 207, 536, 107,-232,
     c 358, -30, 275, 454, 275,-222,  12,-355, 207, 511, 105,-234,
     c 358, -24, 273, 457, 270,-226,  12,-359, 212, 490, 106,-235,
     c 363, -18, 275, 467, 270,-224,  17,-358, 220, 479, 112,-233,
     c 374,  -7, 288, 482, 279,-220,  29,-352, 229, 479, 120,-228,
     c 386,   4, 304, 495, 290,-217,  39,-342, 239, 486, 131,-221,
     c 397,  10, 318, 503, 300,-211,  46,-338, 247, 490, 142,-215,
     c 405,  11, 327, 509, 305,-212,  50,-333, 252, 480, 150,-213,
     c 407,  12, 332, 515, 304,-212,  51,-334, 253, 459, 153,-213,
     c 404,  10, 323, 515, 297,-203,  49,-336, 250, 432, 153,-219,
     c 394,   5, 311, 511, 286,-209,  41,-345, 244, 405, 149,-229,
     c 385,   0, 301, 503, 274,-227,  29,-358, 235, 384, 139,-242,
     c 375,  -7, 294, 493, 260,-236,  15,-374, 225, 372, 126,-255,
     c 365, -16, 286, 478, 246,-251,   2,-389, 215, 358, 111,-269,
     c 360, -23, 281, 465, 238,-270,  -6,-402, 205, 327,  98,-281,
     c 358, -26, 273, 457, 234,-277, -14,-417, 195, 286,  89,-289,
     c 355, -26, 259, 447, 226,-286, -21,-431, 185, 255,  80,-298,
     c 351, -26, 243, 432, 211,-303, -27,-445, 174, 255,  71,-307,
     c 344, -26, 230, 420, 197,-320, -34,-460, 164, 271,  61,-317,
     c 332, -30, 223, 419, 187,-327, -41,-473, 155, 277,  52,-326,
     c 316, -40, 210, 413, 173,-342, -49,-484, 149, 256,  44,-336,
     c 301, -49, 199, 411, 159,-357, -58,-496, 142, 220,  37,-346,
     c 363, -34, 311, 517, 362,-160,  49,-258, 241, 674, 138,-174,
     c 361, -43, 306, 508, 351,-161,  50,-265, 237, 659, 136,-180,
     c 356, -53, 301, 498, 335,-167,  47,-275, 233, 646, 132,-186,
     c 353, -63, 295, 492, 323,-173,  42,-289, 228, 631, 127,-192,
     c 350, -70, 286, 490, 311,-180,  38,-298, 224, 614, 120,-198,
     c 349, -72, 277, 487, 303,-183,  33,-301, 221, 599, 115,-203,
     c 350, -72, 271, 483, 302,-191,  31,-308, 220, 581, 110,-208,
     c 350, -70, 270, 477, 306,-196,  27,-311, 217, 566, 107,-215,
     c 348, -67, 272, 468, 305,-204,  23,-321, 214, 556, 106,-221,
     c 349, -62, 274, 460, 299,-214,  19,-332, 212, 556, 106,-228,
     c 353, -53, 275, 456, 290,-217,  15,-344, 208, 553, 107,-232,
     c 360, -39, 278, 458, 283,-217,  14,-351, 207, 534, 106,-235,
     c 363, -27, 277, 462, 278,-219,  14,-354, 209, 505, 106,-235,
     c 364, -22, 275, 466, 276,-220,  16,-355, 216, 483, 110,-233,
     c 371, -16, 281, 475, 277,-217,  23,-350, 226, 471, 118,-227,
     c 382,  -5, 294, 489, 287,-211,  34,-342, 238, 469, 129,-220,
     c 395,   8, 313, 503, 297,-203,  47,-330, 249, 477, 141,-212,
     c 407,  14, 324, 512, 306,-197,  57,-326, 258, 488, 153,-205,
     c 415,  17, 331, 519, 315,-197,  63,-320, 264, 485, 161,-202,
     c 416,  17, 334, 525, 314,-196,  64,-320, 266, 470, 165,-202,
     c 413,  15, 328, 530, 308,-190,  60,-326, 263, 451, 163,-209,
     c 406,   9, 317, 524, 294,-199,  50,-334, 256, 429, 157,-220,
     c 398,   4, 308, 512, 284,-219,  38,-349, 246, 409, 146,-233,
     c 387,  -1, 300, 501, 270,-230,  22,-365, 234, 397, 131,-248,
     c 377,  -8, 292, 488, 255,-245,   9,-380, 222, 386, 116,-262,
     c 370, -15, 287, 473, 245,-264,   0,-395, 210, 358, 102,-274,
     c 366, -20, 273, 461, 239,-276,  -8,-409, 199, 323,  92,-285,
     c 359, -24, 255, 448, 229,-288, -18,-426, 188, 295,  82,-295,
     c 353, -27, 239, 433, 213,-300, -24,-443, 176, 282,  72,-306,
     c 344, -29, 227, 422, 199,-318, -33,-457, 164, 267,  60,-318,
     c 329, -35, 217, 416, 185,-333, -40,-473, 154, 246,  50,-329,
     c 312, -48, 203, 409, 170,-347, -50,-487, 146, 216,  41,-341,
     c 297, -59, 190, 404, 155,-365, -60,-502, 140, 181,  34,-351,
     c 357, -41, 300, 507, 354,-172,  45,-267, 235, 664, 130,-183,
     c 353, -49, 295, 498, 341,-175,  44,-274, 230, 651, 128,-190,
     c 351, -56, 293, 488, 329,-180,  41,-283, 226, 639, 124,-196,
     c 347, -66, 287, 482, 317,-186,  35,-293, 222, 626, 118,-202,
     c 345, -73, 279, 478, 307,-188,  31,-302, 219, 613, 111,-207,
     c 346, -73, 269, 474, 300,-193,  27,-307, 216, 600, 106,-213,
     c 349, -71, 263, 471, 301,-199,  26,-314, 216, 584, 104,-217,
     c 349, -68, 263, 469, 303,-202,  24,-316, 214, 569, 102,-222,
     c 347, -65, 269, 464, 302,-207,  21,-325, 214, 559, 103,-227,
     c 348, -59, 274, 460, 297,-212,  18,-333, 212, 558, 104,-231,
     c 353, -50, 276, 457, 288,-217,  15,-344, 209, 556, 106,-234,
     c 362, -37, 279, 462, 283,-217,  16,-347, 209, 537, 107,-235,
     c 367, -26, 280, 468, 280,-216,  17,-349, 212, 506, 109,-233,
     c 371, -20, 281, 476, 281,-216,  21,-346, 221, 482, 115,-228,
     c 379, -15, 288, 483, 286,-213,  29,-339, 232, 468, 125,-222,
     c 393,  -4, 303, 494, 296,-209,  42,-328, 245, 463, 137,-213,
     c 407,   9, 323, 510, 305,-198,  57,-322, 257, 470, 151,-204,
     c 416,  17, 334, 522, 317,-189,  67,-316, 268, 482, 163,-196,
     c 423,  21, 339, 531, 322,-186,  75,-307, 275, 483, 172,-192,
     c 423,  22, 339, 536, 322,-183,  76,-307, 277, 475, 175,-193,
     c 421,  18, 336, 539, 316,-179,  70,-313, 274, 464, 172,-199,
     c 415,  12, 326, 532, 304,-192,  60,-326, 267, 448, 163,-211,
     c 408,   7, 315, 518, 291,-213,  45,-341, 255, 429, 151,-227,
     c 398,   3, 305, 506, 277,-222,  31,-357, 241, 416, 135,-241,
     c 387,  -2, 297, 495, 263,-239,  17,-370, 228, 401, 118,-257,
     c 379, -10, 287, 481, 252,-254,   6,-386, 215, 377, 105,-269,
     c 372, -17, 273, 464, 243,-270,  -3,-404, 203, 345,  94,-280,
     c 362, -24, 253, 448, 230,-288, -14,-426, 191, 314,  84,-293,
     c 353, -29, 239, 434, 217,-299, -21,-443, 179, 278,  72,-305,
     c 340, -34, 230, 423, 203,-318, -32,-460, 166, 232,  60,-319,
     c 325, -42, 219, 415, 188,-338, -41,-477, 155, 176,  48,-333,
     c 309, -56, 204, 407, 171,-352, -51,-493, 146, 135,  39,-345,
     c 294, -69, 189, 400, 155,-370, -62,-503, 138,  97,  31,-356,
     c 354, -48, 292, 502, 348,-178,  41,-268, 230, 649, 124,-191,
     c 351, -54, 290, 492, 335,-177,  39,-278, 225, 639, 122,-197,
     c 347, -61, 285, 479, 323,-186,  36,-285, 221, 629, 118,-204,
     c 341, -69, 281, 472, 312,-193,  29,-297, 217, 617, 112,-209,
     c 340, -72, 273, 468, 304,-198,  25,-305, 215, 605, 106,-215,
     c 344, -70, 265, 464, 300,-204,  23,-309, 214, 594, 102,-219,
     c 348, -65, 261, 464, 300,-206,  23,-312, 214, 580, 101,-221,
     c 352, -61, 263, 466, 302,-208,  23,-316, 215, 565, 102,-225,
     c 352, -58, 270, 465, 304,-207,  22,-325, 215, 553, 103,-228,
     c 353, -52, 277, 463, 299,-209,  20,-331, 214, 554, 106,-230,
     c 358, -45, 279, 461, 290,-214,  18,-338, 213, 553, 108,-232,
     c 365, -35, 281, 466, 286,-218,  19,-339, 213, 538, 110,-232,
     c 371, -25, 285, 476, 287,-215,  22,-341, 217, 508, 113,-228,
     c 376, -20, 287, 483, 289,-214,  30,-335, 226, 486, 121,-223,
     c 385, -14, 295, 491, 295,-212,  38,-327, 239, 473, 132,-216,
     c 402,  -2, 314, 505, 307,-203,  52,-317, 252, 465, 145,-207,
     c 418,  11, 333, 520, 318,-191,  66,-310, 266, 466, 160,-198,
     c 426,  21, 340, 531, 326,-182,  79,-303, 276, 475, 172,-190,
     c 431,  26, 344, 542, 332,-172,  86,-295, 283, 474, 182,-185,
     c 434,  28, 345, 549, 332,-165,  87,-295, 286, 468, 184,-186,
     c 430,  23, 341, 546, 324,-169,  80,-304, 283, 459, 179,-192,
     c 422,  15, 332, 535, 313,-181,  67,-317, 275, 449, 169,-205,
     c 415,  10, 323, 522, 297,-202,  53,-332, 263, 433, 155,-220,
     c 406,   6, 312, 510, 284,-215,  38,-349, 249, 422, 137,-237,
     c 392,   0, 300, 496, 270,-238,  26,-364, 234, 407, 120,-252,
     c 383,  -6, 288, 481, 256,-252,  13,-381, 221, 388, 106,-265,
     c 377, -15, 271, 465, 244,-266,   3,-401, 208, 363,  95,-276,
     c 366, -24, 257, 452, 232,-282,  -9,-426, 196, 335,  85,-289,
     c 351, -32, 245, 437, 218,-298, -19,-445, 182, 284,  73,-305,
     c 337, -39, 237, 426, 204,-317, -30,-464, 169, 215,  60,-320,
     c 326, -48, 223, 419, 191,-336, -41,-480, 156, 135,  49,-335,
     c 310, -63, 205, 410, 172,-351, -53,-494, 146,  86,  39,-348,
     c 293, -78, 188, 401, 152,-372, -64,-507, 136,  45,  30,-361,
     c 354, -53, 291, 502, 346,-177,  41,-272, 230, 634, 120,-195,
     c 349, -57, 286, 490, 334,-176,  37,-279, 225, 625, 117,-202,
     c 345, -63, 283, 478, 323,-181,  32,-290, 221, 616, 115,-207,
     c 340, -68, 278, 468, 311,-196,  25,-301, 217, 606, 110,-214,
     c 337, -68, 270, 460, 303,-201,  20,-310, 214, 594, 104,-218,
     c 342, -62, 265, 461, 301,-205,  21,-315, 214, 584, 102,-221,
     c 351, -55, 265, 465, 303,-207,  22,-319, 217, 572, 102,-223,
     c 358, -50, 268, 470, 307,-203,  25,-318, 219, 558, 104,-223,
     c 359, -46, 276, 472, 307,-203,  24,-322, 220, 547, 107,-225,
     c 361, -44, 282, 472, 303,-207,  24,-327, 221, 547, 110,-226,
     c 365, -39, 288, 473, 297,-211,  23,-329, 220, 549, 113,-226,
     c 372, -30, 292, 479, 296,-211,  25,-330, 221, 535, 117,-225,
     c 377, -23, 294, 485, 297,-212,  30,-327, 225, 509, 121,-222,
     c 383, -19, 296, 492, 300,-207,  39,-324, 233, 490, 129,-216,
     c 394, -11, 307, 501, 307,-204,  50,-316, 246, 478, 142,-209,
     c 413,   3, 327, 517, 321,-196,  63,-306, 260, 467, 155,-200,
     c 429,  18, 343, 531, 330,-182,  76,-301, 272, 464, 169,-191,
     c 438,  27, 346, 542, 335,-173,  88,-294, 283, 467, 182,-184,
     c 442,  32, 345, 553, 340,-162,  94,-289, 290, 463, 190,-180,
     c 446,  34, 346, 559, 341,-155,  95,-290, 294, 456, 191,-180,
     c 440,  28, 343, 555, 334,-164,  87,-299, 292, 448, 187,-187,
     c 430,  19, 338, 543, 321,-179,  74,-310, 283, 436, 175,-199,
     c 421,  11, 329, 529, 307,-198,  59,-325, 270, 421, 159,-216,
     c 410,   6, 319, 515, 292,-210,  45,-343, 255, 410, 139,-233,
     c 397,   1, 307, 500, 277,-230,  33,-359, 239, 397, 121,-249,
     c 386,  -4, 291, 483, 261,-249,  21,-379, 227, 385, 106,-262,
     c 378, -12, 274, 467, 247,-264,   8,-399, 213, 375,  94,-274,
     c 368, -21, 261, 457, 234,-276,  -4,-424, 200, 361,  84,-287,
     c 354, -31, 254, 445, 218,-293, -16,-443, 186, 318,  73,-304,
     c 339, -41, 244, 432, 202,-309, -29,-462, 171, 249,  61,-320,
     c 324, -51, 225, 423, 186,-331, -41,-478, 158, 172,  48,-337,
     c 307, -66, 205, 413, 168,-351, -54,-493, 145, 119,  37,-351,
     c 290, -82, 184, 402, 149,-371, -66,-505, 135,  74,  29,-365,
     c 355, -52, 290, 502, 347,-178,  41,-269, 231, 623, 117,-198,
     c 352, -55, 286, 490, 336,-177,  36,-277, 227, 615, 116,-203,
     c 348, -58, 281, 479, 325,-183,  32,-291, 223, 607, 114,-209,
     c 341, -61, 276, 468, 314,-199,  24,-304, 220, 597, 110,-214,
     c 339, -58, 271, 465, 308,-204,  21,-310, 218, 587, 106,-218,
     c 344, -49, 268, 467, 307,-206,  21,-315, 218, 579, 105,-220,
     c 354, -40, 269, 471, 309,-204,  24,-314, 221, 568, 108,-220,
     c 363, -34, 273, 477, 312,-199,  28,-315, 225, 555, 111,-219,
     c 368, -33, 281, 482, 309,-196,  30,-316, 228, 544, 114,-218,
     c 371, -33, 290, 486, 307,-196,  30,-319, 229, 543, 118,-218,
     c 375, -31, 299, 488, 305,-199,  31,-321, 229, 544, 122,-218,
     c 380, -27, 303, 491, 305,-204,  34,-320, 230, 533, 125,-216,
     c 383, -22, 304, 495, 306,-209,  39,-318, 234, 511, 130,-213,
     c 390, -18, 308, 502, 312,-204,  47,-314, 243, 495, 139,-207,
     c 403,  -6, 319, 513, 322,-197,  59,-305, 255, 485, 152,-201,
     c 422,   9, 336, 528, 336,-193,  73,-301, 268, 476, 165,-193,
     c 439,  25, 350, 541, 342,-177,  83,-293, 279, 471, 177,-185,
     c 446,  33, 351, 550, 342,-166,  92,-287, 289, 471, 189,-179,
     c 453,  39, 345, 561, 346,-155,  99,-283, 297, 466, 196,-176,
     c 455,  40, 344, 567, 349,-148, 100,-285, 300, 458, 197,-177,
     c 451,  33, 345, 566, 344,-151,  93,-291, 297, 448, 191,-183,
     c 438,  20, 342, 551, 329,-169,  80,-303, 289, 432, 179,-196,
     c 426,   8, 335, 534, 314,-192,  66,-321, 275, 410, 161,-212,
     c 413,   3, 327, 520, 300,-206,  52,-339, 260, 392, 141,-230,
     c 401,   1, 316, 505, 285,-223,  39,-356, 244, 374, 120,-246,
     c 389,  -2, 299, 487, 268,-244,  26,-376, 231, 364, 105,-259,
     c 382,  -7, 281, 472, 252,-261,  14,-396, 218, 366,  94,-272,
     c 371, -16, 267, 460, 235,-272,   0,-418, 204, 369,  83,-286,
     c 360, -27, 260, 452, 221,-287, -12,-439, 189, 344,  72,-302,
     c 345, -40, 248, 438, 204,-308, -27,-458, 174, 293,  59,-321,
     c 328, -50, 227, 424, 187,-331, -41,-477, 157, 232,  46,-338,
     c 309, -66, 202, 411, 167,-356, -55,-492, 144, 179,  34,-354,
     c 290, -84, 176, 400, 147,-379, -69,-507, 132, 133,  25,-370,
     c 360, -50, 289, 500, 350,-177,  46,-269, 235, 618, 118,-198,
     c 357, -51, 285, 490, 339,-178,  40,-275, 231, 611, 117,-203,
     c 355, -52, 281, 481, 329,-179,  36,-288, 228, 603, 115,-207,
     c 350, -52, 276, 474, 319,-195,  30,-298, 224, 594, 114,-211,
     c 348, -45, 273, 475, 315,-195,  28,-305, 223, 585, 113,-214,
     c 352, -34, 273, 478, 317,-196,  29,-309, 225, 579, 113,-214,
     c 361, -24, 274, 479, 318,-196,  32,-309, 228, 570, 118,-212,
     c 371, -19, 280, 486, 318,-190,  34,-308, 233, 557, 122,-210,
     c 379, -19, 290, 493, 317,-185,  36,-306, 237, 547, 125,-209,
     c 384, -22, 301, 498, 316,-184,  39,-308, 239, 546, 129,-207,
     c 387, -24, 311, 500, 316,-193,  42,-304, 240, 545, 133,-206,
     c 390, -23, 317, 507, 321,-191,  46,-305, 242, 535, 136,-205,
     c 393, -21, 318, 508, 322,-197,  49,-302, 246, 518, 141,-201,
     c 399, -15, 320, 512, 326,-196,  56,-302, 255, 506, 150,-197,
     c 413,   0, 329, 524, 336,-188,  68,-296, 267, 499, 162,-191,
     c 431,  19, 344, 541, 349,-182,  81,-291, 277, 491, 174,-185,
     c 445,  34, 353, 549, 350,-171,  90,-287, 287, 487, 185,-179,
     c 450,  42, 353, 555, 346,-164,  96,-287, 297, 486, 193,-174,
     c 453,  46, 346, 563, 347,-154, 100,-282, 303, 480, 199,-172,
     c 458,  46, 345, 573, 351,-143, 103,-281, 304, 472, 199,-174,
     c 456,  36, 348, 569, 349,-148,  98,-286, 301, 460, 192,-181,
     c 444,  19, 346, 555, 334,-163,  84,-301, 293, 438, 181,-193,
     c 428,   4, 340, 537, 318,-183,  69,-318, 280, 407, 163,-210,
     c 415,  -3, 333, 520, 303,-202,  55,-338, 264, 380, 143,-227,
     c 403,  -2, 322, 504, 290,-221,  42,-356, 249, 353, 123,-243,
     c 391,  -1, 306, 488, 272,-241,  28,-375, 235, 341, 106,-257,
     c 384,  -2, 288, 475, 257,-260,  17,-394, 220, 347,  95,-270,
     c 374,  -9, 275, 465, 242,-271,   2,-411, 206, 358,  84,-284,
     c 362, -22, 265, 456, 228,-291,  -9,-434, 190, 345,  73,-301,
     c 347, -37, 248, 441, 209,-312, -26,-455, 173, 311,  58,-321,
     c 332, -49, 222, 426, 190,-336, -42,-476, 156, 267,  44,-340,
     c 312, -66, 194, 411, 168,-362, -57,-494, 141, 218,  31,-357,
     c 293, -84, 166, 396, 146,-384, -73,-509, 128, 168,  21,-373,
     c 366, -46, 294, 505, 352,-175,  49,-264, 240, 617, 120,-196,
     c 365, -45, 289, 497, 343,-175,  44,-271, 235, 610, 120,-201,
     c 363, -44, 285, 488, 334,-175,  41,-282, 232, 604, 120,-204,
     c 360, -43, 281, 484, 324,-187,  37,-290, 231, 594, 120,-207,
     c 359, -34, 279, 487, 322,-184,  36,-296, 231, 587, 121,-207,
     c 362, -20, 279, 489, 325,-183,  38,-297, 232, 583, 124,-206,
     c 371,  -9, 282, 489, 325,-185,  40,-297, 237, 575, 130,-204,
     c 385,  -3, 292, 495, 327,-180,  44,-297, 243, 563, 134,-200,
     c 394,  -3, 304, 502, 328,-179,  47,-293, 247, 553, 138,-197,
     c 398,  -9, 315, 506, 330,-179,  50,-292, 252, 550, 142,-194,
     c 403, -14, 326, 513, 333,-184,  55,-287, 254, 549, 145,-193,
     c 410, -16, 334, 522, 340,-180,  60,-287, 256, 542, 150,-191,
     c 412, -17, 334, 525, 341,-179,  63,-287, 261, 529, 156,-188,
     c 416,  -9, 332, 527, 342,-181,  69,-291, 269, 521, 164,-184,
     c 428,   9, 338, 538, 348,-172,  82,-286, 280, 516, 173,-179,
     c 446,  32, 352, 557, 359,-165,  94,-280, 289, 510, 183,-175,
     c 456,  47, 360, 562, 357,-159,  99,-280, 298, 506, 190,-171,
     c 454,  52, 355, 558, 347,-159, 100,-283, 304, 504, 195,-168,
     c 452,  54, 349, 564, 346,-151, 103,-283, 309, 495, 199,-168,
     c 456,  52, 351, 573, 354,-141, 105,-278, 309, 487, 197,-171,
     c 455,  39, 353, 570, 353,-149, 100,-281, 305, 469, 192,-179,
     c 445,  18, 351, 555, 341,-169,  86,-297, 297, 443, 182,-191,
     c 430,   0, 344, 537, 324,-185,  70,-317, 284, 408, 166,-206,
     c 416,  -9, 332, 517, 307,-207,  54,-339, 267, 377, 146,-224,
     c 403,  -5, 322, 503, 293,-225,  41,-358, 252, 344, 127,-240,
     c 392,   1, 309, 491, 277,-240,  29,-375, 237, 330, 110,-254,
     c 384,   4, 295, 482, 264,-257,  16,-393, 223, 338,  98,-267,
     c 373,   0, 281, 472, 250,-274,   4,-411, 206, 353,  86,-283,
     c 361, -14, 271, 463, 232,-295, -10,-433, 188, 344,  73,-300,
     c 343, -34, 247, 444, 210,-319, -28,-455, 169, 318,  58,-321,
     c 329, -47, 216, 427, 191,-342, -44,-481, 152, 282,  42,-341,
     c 308, -66, 185, 410, 168,-368, -62,-498, 135, 239,  29,-360,
     c 287, -84, 154, 392, 146,-391, -78,-519, 121, 191,  17,-377,
     c 370, -44, 302, 515, 357,-171,  50,-268, 245, 622, 124,-193,
     c 368, -42, 297, 506, 349,-174,  46,-270, 240, 613, 125,-196,
     c 368, -39, 292, 498, 341,-173,  44,-279, 238, 605, 125,-199,
     c 368, -34, 289, 494, 334,-180,  43,-282, 237, 598, 127,-199,
     c 369, -24, 288, 496, 331,-179,  44,-286, 238, 593, 130,-199,
     c 374,  -8, 290, 499, 334,-176,  47,-288, 241, 590, 135,-197,
     c 385,   5, 296, 500, 334,-177,  51,-289, 247, 584, 141,-193,
     c 398,  15, 306, 505, 337,-172,  54,-286, 253, 572, 147,-189,
     c 405,  14, 319, 511, 338,-172,  59,-282, 260, 562, 151,-184,
     c 411,   7, 331, 517, 345,-170,  63,-279, 265, 557, 156,-181,
     c 420,   0, 341, 526, 352,-173,  70,-270, 268, 557, 161,-179,
     c 427,  -6, 348, 535, 357,-167,  74,-270, 272, 551, 165,-176,
     c 430,  -7, 348, 540, 356,-168,  77,-270, 278, 541, 171,-173,
     c 435,   0, 346, 543, 357,-165,  84,-273, 285, 534, 178,-169,
     c 451,  24, 352, 556, 364,-152,  98,-266, 294, 530, 187,-165,
     c 468,  49, 366, 573, 372,-146, 110,-259, 302, 525, 192,-162,
     c 474,  64, 373, 576, 368,-142, 114,-267, 308, 522, 196,-161,
     c 466,  64, 364, 566, 354,-150, 109,-274, 313, 517, 198,-162,
     c 460,  62, 358, 569, 353,-147, 109,-275, 316, 506, 198,-164,
     c 457,  56, 358, 575, 358,-139, 108,-270, 314, 494, 196,-168,
     c 455,  41, 359, 571, 358,-147, 103,-274, 309, 472, 192,-176,
     c 446,  16, 354, 555, 348,-166,  90,-292, 300, 441, 183,-187,
     c 432,  -3, 343, 538, 331,-184,  73,-314, 287, 408, 169,-203,
     c 418,  -9, 330, 520, 310,-205,  57,-338, 270, 379, 150,-220,
     c 405,  -3, 321, 507, 297,-224,  42,-360, 255, 345, 131,-237,
     c 394,   6, 311, 497, 285,-236,  29,-378, 239, 331, 115,-252,
     c 383,  13, 299, 490, 270,-255,  15,-395, 223, 341, 101,-266,
     c 372,   8, 286, 481, 251,-273,   2,-414, 205, 353,  89,-282,
     c 357,  -8, 272, 465, 233,-299, -13,-436, 185, 343,  74,-301,
     c 341, -29, 246, 444, 209,-322, -31,-457, 165, 319,  56,-322,
     c 326, -45, 211, 427, 187,-344, -49,-484, 146, 288,  39,-344,
     c 303, -65, 177, 406, 164,-371, -65,-508, 129, 246,  25,-364,
     c 282, -84, 144, 388, 142,-392, -83,-532, 113, 198,  13,-381,
     c 370, -43, 306, 518, 360,-168,  51,-265, 251, 630, 128,-188,
     c 372, -38, 303, 512, 354,-169,  49,-267, 247, 621, 130,-191,
     c 371, -34, 300, 505, 348,-167,  48,-274, 245, 612, 133,-192,
     c 372, -27, 299, 502, 343,-173,  49,-277, 244, 606, 136,-192,
     c 376, -14, 300, 504, 341,-175,  52,-279, 247, 601, 140,-189,
     c 384,   2, 302, 506, 342,-173,  56,-279, 251, 598, 145,-186,
     c 397,  22, 310, 511, 344,-167,  61,-277, 257, 592, 152,-182,
     c 409,  34, 323, 516, 346,-162,  67,-272, 265, 582, 159,-176,
     c 416,  37, 338, 525, 349,-163,  71,-266, 273, 573, 165,-171,
     c 425,  29, 347, 532, 357,-161,  77,-261, 279, 568, 172,-167,
     c 435,  18, 355, 539, 365,-162,  83,-258, 284, 567, 177,-164,
     c 441,   8, 357, 547, 366,-162,  87,-258, 288, 562, 181,-162,
     c 445,   5, 356, 553, 365,-156,  92,-259, 294, 554, 186,-158,
     c 454,  16, 359, 560, 368,-153, 100,-260, 302, 547, 193,-155,
     c 473,  41, 369, 573, 378,-142, 114,-252, 309, 541, 199,-153,
     c 489,  67, 384, 587, 387,-131, 126,-242, 315, 536, 203,-151,
     c 493,  79, 386, 587, 382,-130, 127,-247, 320, 532, 204,-152,
     c 484,  77, 379, 578, 371,-135, 123,-256, 323, 523, 204,-153,
     c 472,  70, 370, 576, 365,-136, 117,-263, 324, 512, 201,-158,
     c 467,  59, 367, 578, 368,-135, 115,-259, 321, 498, 197,-164,
     c 463,  42, 364, 573, 367,-144, 110,-269, 314, 475, 193,-172,
     c 454,  19, 356, 558, 357,-162,  96,-288, 303, 445, 185,-184,
     c 439,   0, 345, 540, 338,-182,  79,-310, 288, 416, 172,-200,
     c 425,  -3, 334, 524, 319,-202,  62,-334, 273, 387, 153,-218,
     c 411,   4, 324, 512, 304,-220,  46,-358, 256, 354, 134,-236,
     c 398,  14, 312, 502, 290,-233,  31,-375, 240, 338, 118,-252,
     c 385,  20, 300, 492, 274,-255,  17,-394, 223, 342, 103,-267,
     c 372,  13, 287, 482, 253,-280,   1,-414, 203, 344,  89,-283,
     c 357,  -5, 267, 466, 231,-302, -15,-439, 182, 327,  73,-304,
     c 340, -28, 241, 442, 206,-328, -34,-463, 160, 298,  54,-326,
     c 324, -44, 206, 423, 185,-352, -53,-493, 140, 268,  37,-349,
     c 300, -65, 173, 400, 161,-380, -71,-518, 122, 226,  22,-370,
     c 278, -86, 140, 380, 139,-403, -89,-544, 106, 179,   9,-387,
     c 378, -40, 311, 523, 365,-167,  56,-260, 257, 639, 133,-184,
     c 378, -35, 312, 517, 359,-164,  54,-262, 253, 629, 137,-185,
     c 380, -29, 310, 510, 355,-164,  55,-269, 252, 620, 140,-186,
     c 382, -21, 312, 511, 354,-167,  58,-271, 253, 614, 143,-183,
     c 388,  -6, 312, 514, 353,-171,  62,-268, 256, 608, 148,-181,
     c 400,  14, 315, 516, 353,-169,  68,-267, 260, 606, 155,-177,
     c 412,  36, 324, 520, 355,-168,  72,-265, 268, 599, 164,-172,
     c 424,  54, 342, 531, 363,-153,  79,-258, 277, 592, 171,-166,
     c 434,  61, 358, 540, 367,-149,  86,-254, 286, 584, 180,-160,
     c 444,  54, 366, 544, 373,-147,  90,-248, 293, 579, 187,-155,
     c 452,  41, 366, 552, 378,-144,  98,-246, 300, 577, 192,-151,
     c 457,  27, 365, 561, 380,-143, 101,-244, 304, 572, 197,-148,
     c 460,  22, 363, 566, 376,-141, 105,-247, 309, 564, 201,-146,
     c 468,  33, 368, 573, 378,-138, 111,-247, 315, 554, 205,-144,
     c 485,  58, 383, 586, 388,-128, 125,-241, 321, 545, 209,-143,
     c 500,  83, 397, 597, 398,-120, 136,-234, 326, 538, 212,-142,
     c 501,  92, 398, 595, 392,-120, 136,-237, 329, 530, 212,-144,
     c 491,  87, 389, 585, 381,-127, 131,-242, 331, 517, 209,-147,
     c 481,  76, 380, 583, 377,-129, 126,-248, 330, 504, 204,-152,
     c 476,  61, 372, 580, 375,-134, 123,-252, 324, 490, 199,-160,
     c 471,  43, 367, 571, 372,-149, 115,-265, 316, 467, 194,-170,
     c 461,  21, 357, 556, 358,-165,  99,-284, 304, 442, 185,-183,
     c 446,   5, 348, 542, 343,-182,  83,-306, 288, 418, 171,-199,
     c 431,   4, 338, 527, 325,-199,  66,-331, 272, 392, 154,-218,
     c 416,  11, 325, 514, 306,-219,  51,-354, 255, 359, 135,-236,
     c 401,  20, 311, 504, 291,-234,  32,-372, 239, 341, 118,-254,
     c 386,  21, 295, 495, 275,-254,  18,-394, 220, 338, 102,-270,
     c 372,  12, 280, 482, 253,-282,   0,-417, 200, 329,  87,-288,
     c 357,  -7, 260, 465, 230,-305, -16,-442, 178, 301,  69,-309,
     c 337, -31, 234, 441, 203,-330, -36,-470, 156, 264,  50,-332,
     c 320, -47, 204, 419, 182,-357, -56,-500, 134, 227,  32,-356,
     c 296, -70, 172, 398, 159,-383, -75,-527, 116, 190,  18,-375,
     c 273, -91, 140, 378, 137,-409, -94,-551,  99, 149,   6,-394,
     c 386, -37, 319, 531, 371,-161,  62,-245, 263, 646, 140,-179,
     c 390, -30, 322, 525, 368,-155,  64,-251, 259, 636, 142,-180,
     c 392, -24, 323, 519, 363,-152,  65,-255, 258, 627, 146,-179,
     c 396, -14, 324, 523, 364,-159,  68,-258, 260, 619, 151,-177,
     c 403,   1, 323, 525, 364,-162,  72,-256, 264, 614, 157,-174,
     c 413,  23, 327, 525, 364,-161,  78,-254, 270, 610, 164,-170,
     c 427,  47, 337, 530, 365,-158,  84,-250, 278, 606, 174,-164,
     c 442,  71, 359, 543, 375,-142,  93,-244, 288, 599, 185,-157,
     c 453,  81, 376, 553, 381,-135, 100,-239, 299, 593, 194,-150,
     c 464,  76, 383, 557, 387,-134, 107,-235, 307, 589, 202,-145,
     c 472,  63, 379, 565, 391,-130, 112,-232, 313, 584, 208,-141,
     c 478,  48, 375, 575, 391,-127, 114,-230, 317, 579, 210,-138,
     c 477,  40, 373, 579, 386,-129, 116,-233, 321, 570, 212,-138,
     c 480,  50, 379, 583, 384,-128, 120,-235, 323, 558, 213,-136,
     c 492,  73, 394, 590, 389,-124, 129,-234, 328, 546, 215,-136,
     c 502,  93, 409, 599, 396,-118, 137,-229, 331, 535, 215,-137,
     c 502,  99, 409, 598, 395,-115, 139,-232, 333, 519, 214,-139,
     c 492,  90, 396, 589, 385,-127, 133,-235, 334, 501, 210,-144,
     c 485,  76, 386, 586, 380,-130, 128,-242, 331, 486, 205,-150,
     c 481,  59, 378, 582, 377,-134, 122,-253, 324, 472, 198,-159,
     c 477,  40, 369, 570, 370,-154, 113,-269, 314, 450, 191,-171,
     c 466,  21, 357, 553, 357,-167,  98,-289, 301, 431, 181,-185,
     c 450,  10, 347, 541, 342,-182,  81,-313, 284, 412, 168,-202,
     c 435,   9, 334, 529, 322,-198,  64,-335, 268, 386, 151,-221,
     c 419,  15, 320, 515, 304,-220,  48,-358, 250, 352, 133,-240,
     c 402,  19, 301, 504, 287,-238,  32,-377, 234, 335, 114,-258,
     c 384,  16, 280, 494, 270,-261,  14,-399, 215, 332,  99,-276,
     c 368,   4, 264, 478, 249,-285,  -1,-421, 195, 319,  82,-295,
     c 350, -16, 249, 458, 226,-307, -21,-446, 173, 284,  63,-315,
     c 330, -39, 227, 436, 200,-329, -41,-477, 150, 245,  44,-339,
     c 313, -53, 203, 417, 180,-357, -61,-508, 128, 206,  29,-362,
     c 289, -76, 171, 396, 157,-387, -80,-534, 110, 172,  15,-382,
     c 265, -97, 139, 378, 135,-414, -99,-556,  93, 137,   1,-400,
     c 395, -31, 330, 539, 381,-151,  71,-239, 269, 650, 144,-173,
     c 398, -25, 333, 533, 376,-146,  72,-242, 265, 639, 149,-174,
     c 401, -19, 334, 530, 372,-145,  73,-246, 265, 629, 153,-174,
     c 408,  -9, 334, 533, 373,-149,  78,-247, 267, 623, 159,-171,
     c 416,   7, 333, 533, 371,-154,  82,-245, 271, 617, 165,-167,
     c 426,  30, 337, 534, 372,-153,  85,-243, 279, 614, 174,-162,
     c 438,  58, 349, 543, 378,-147,  94,-239, 288, 610, 184,-156,
     c 453,  83, 370, 554, 385,-133, 103,-230, 299, 604, 196,-149,
     c 468,  97, 389, 564, 391,-126, 112,-225, 310, 598, 207,-142,
     c 482,  96, 394, 574, 400,-119, 119,-221, 318, 594, 216,-137,
     c 490,  82, 391, 582, 402,-111, 122,-218, 323, 589, 219,-133,
     c 493,  66, 387, 589, 399,-113, 125,-217, 326, 584, 218,-132,
     c 491,  58, 387, 592, 396,-113, 124,-223, 327, 576, 216,-133,
     c 490,  63, 389, 590, 391,-121, 126,-229, 327, 563, 214,-134,
     c 496,  81, 401, 590, 391,-128, 129,-232, 328, 551, 212,-136,
     c 500,  95, 415, 595, 395,-123, 133,-232, 330, 536, 211,-139,
     c 495,  95, 414, 595, 395,-119, 133,-233, 331, 514, 209,-142,
     c 487,  84, 399, 588, 387,-126, 128,-240, 330, 488, 206,-146,
     c 480,  67, 385, 583, 380,-127, 121,-248, 326, 469, 199,-154,
     c 477,  49, 377, 577, 374,-138, 115,-263, 318, 455, 191,-164,
     c 471,  31, 366, 564, 366,-160, 103,-279, 306, 434, 183,-177,
     c 460,  16, 352, 547, 352,-173,  90,-301, 292, 415, 174,-192,
     c 445,   8, 334, 534, 332,-194,  73,-324, 277, 398, 160,-210,
     c 427,   9, 319, 523, 313,-208,  55,-345, 259, 367, 143,-229,
     c 410,  13, 302, 509, 293,-231,  39,-366, 243, 328, 125,-248,
     c 394,  13, 283, 496, 276,-252,  22,-389, 226, 315, 107,-267,
     c 376,   6, 261, 483, 257,-273,   6,-408, 207, 320,  91,-284,
     c 360,  -7, 247, 468, 238,-296, -10,-433, 188, 310,  74,-303,
     c 343, -27, 238, 450, 218,-319, -28,-457, 166, 278,  56,-323,
     c 325, -48, 222, 429, 196,-345, -48,-490, 143, 239,  39,-345,
     c 307, -60, 200, 412, 175,-367, -67,-519, 122, 204,  24,-367,
     c 283, -81, 168, 391, 150,-396, -87,-541, 104, 174,  10,-386,
     c 259,-102, 136, 370, 125,-424,-106,-562,  88, 148,  -2,-403,
     c 401, -25, 336, 541, 387,-150,  76,-233, 274, 651, 150,-170,
     c 406, -20, 339, 536, 381,-147,  79,-238, 269, 639, 153,-170,
     c 409, -15, 341, 534, 376,-144,  81,-240, 268, 630, 158,-170,
     c 417,  -7, 344, 538, 376,-146,  84,-239, 271, 624, 165,-166,
     c 426,  10, 343, 540, 376,-150,  88,-238, 277, 620, 173,-161,
     c 437,  36, 347, 541, 379,-147,  92,-236, 285, 617, 182,-156,
     c 450,  65, 359, 552, 387,-139, 101,-231, 296, 612, 194,-149,
     c 465,  94, 380, 566, 397,-122, 110,-220, 307, 607, 207,-142,
     c 481, 111, 396, 575, 401,-114, 120,-214, 318, 600, 219,-135,
     c 494, 112, 402, 586, 406,-107, 125,-210, 326, 596, 226,-129,
     c 499,  97, 397, 594, 407,-102, 129,-209, 330, 591, 226,-127,
     c 498,  79, 394, 596, 405,-105, 129,-214, 330, 587, 221,-128,
     c 493,  68, 391, 595, 400,-108, 125,-223, 328, 583, 215,-133,
     c 490,  70, 392, 590, 395,-123, 124,-230, 326, 573, 208,-138,
     c 490,  79, 400, 585, 390,-132, 124,-238, 323, 561, 204,-143,
     c 491,  85, 409, 584, 390,-134, 125,-241, 323, 545, 201,-148,
     c 484,  81, 405, 584, 390,-133, 121,-246, 321, 518, 198,-152,
     c 473,  66, 388, 577, 382,-139, 116,-253, 319, 488, 194,-156,
     c 468,  48, 375, 571, 372,-142, 108,-264, 314, 465, 188,-164,
     c 466,  31, 366, 564, 365,-151, 101,-280, 305, 450, 179,-175,
     c 458,  18, 354, 551, 355,-173,  88,-295, 293, 428, 172,-189,
     c 444,   7, 337, 536, 339,-190,  76,-315, 279, 407, 163,-204,
     c 429,   4, 319, 521, 320,-214,  60,-336, 264, 382, 150,-222,
     c 412,   5, 300, 508, 301,-229,  44,-355, 248, 337, 134,-241,
     c 395,   7, 280, 496, 282,-246,  26,-377, 233, 289, 116,-260,
     c 380,   3, 262, 484, 264,-261,  11,-402, 216, 279,  98,-278,
     c 365,  -5, 246, 469, 248,-284,  -4,-420, 198, 294,  82,-295,
     c 350, -20, 237, 457, 232,-306, -21,-446, 181, 293,  67,-312,
     c 335, -39, 229, 442, 215,-328, -36,-470, 160, 268,  52,-330,
     c 318, -56, 215, 422, 193,-350, -54,-499, 139, 234,  37,-351,
     c 302, -65, 195, 406, 174,-373, -72,-527, 118, 200,  23,-370,
     c 278, -86, 164, 385, 146,-405, -91,-549, 101, 181,  10,-388,
     c 256,-105, 133, 366, 120,-429,-110,-569,  85, 169,  -1,-405,
     c 409, -19, 345, 545, 393,-143,  80,-231, 276, 650, 154,-166,
     c 411, -17, 346, 539, 384,-142,  81,-234, 271, 637, 157,-168,
     c 414, -14, 348, 534, 377,-143,  82,-238, 270, 628, 162,-166,
     c 422,  -7, 350, 539, 375,-145,  84,-237, 273, 623, 169,-163,
     c 434,  10, 351, 544, 379,-145,  90,-235, 280, 620, 178,-158,
     c 449,  38, 360, 550, 385,-135,  96,-227, 290, 618, 188,-151,
     c 464,  71, 372, 560, 393,-129, 105,-221, 301, 613, 201,-143,
     c 478, 103, 387, 573, 404,-116, 115,-214, 313, 607, 214,-136,
     c 491, 122, 399, 582, 408,-110, 124,-207, 325, 599, 225,-129,
     c 502, 122, 405, 589, 408,-109, 130,-204, 331, 593, 230,-125,
     c 503, 108, 401, 595, 408,-109, 131,-208, 333, 586, 229,-124,
     c 497,  87, 394, 594, 406,-113, 127,-217, 331, 583, 221,-128,
     c 488,  71, 386, 588, 396,-121, 121,-228, 325, 578, 210,-136,
     c 481,  66, 382, 579, 389,-137, 117,-239, 320, 569, 200,-146,
     c 478,  68, 387, 572, 382,-145, 112,-248, 315, 557, 191,-153,
     c 475,  67, 387, 568, 380,-149, 111,-255, 309, 541, 185,-161,
     c 468,  57, 382, 564, 375,-153, 106,-264, 305, 514, 182,-168,
     c 458,  40, 367, 558, 368,-160,  99,-272, 303, 482, 178,-174,
     c 455,  23, 355, 553, 358,-162,  91,-284, 297, 461, 171,-181,
     c 451,   9, 346, 545, 348,-175,  83,-298, 288, 447, 163,-192,
     c 445,   3, 337, 533, 339,-194,  72,-312, 277, 427, 156,-205,
     c 432,   0, 322, 521, 325,-213,  61,-328, 264, 402, 148,-220,
     c 416,   0, 305, 511, 307,-233,  47,-347, 251, 367, 138,-237,
     c 399,   2, 284, 496, 290,-248,  32,-367, 237, 308, 123,-254,
     c 383,   1, 265, 485, 275,-263,  16,-387, 222, 250, 107,-272,
     c 369,  -5, 251, 475, 260,-276,   2,-410, 206, 242,  91,-289,
     c 354, -18, 239, 462, 243,-293, -12,-430, 191, 264,  77,-304,
     c 341, -32, 232, 450, 229,-310, -26,-455, 174, 274,  65,-319,
     c 330, -47, 227, 438, 213,-328, -39,-480, 156, 256,  52,-336,
     c 317, -60, 214, 418, 192,-349, -55,-503, 137, 228,  40,-353,
     c 302, -67, 191, 404, 172,-375, -73,-530, 118, 198,  27,-371,
     c 280, -86, 160, 386, 144,-404, -90,-548, 101, 189,  16,-388,
     c 258,-106, 129, 369, 118,-426,-108,-569,  85, 195,   4,-403,
     c 410, -13, 353, 546, 397,-138,  81,-227, 278, 649, 156,-164,
     c 412, -13, 355, 541, 387,-138,  81,-233, 272, 635, 160,-166,
     c 416, -14, 355, 534, 378,-147,  83,-237, 271, 626, 165,-166,
     c 423, -11, 355, 537, 372,-150,  85,-236, 274, 621, 172,-161,
     c 438,   7, 357, 545, 378,-144,  92,-232, 280, 619, 180,-155,
     c 457,  38, 367, 554, 387,-136,  98,-225, 291, 616, 191,-149,
     c 472,  76, 379, 567, 396,-122, 110,-218, 302, 611, 202,-141,
     c 485, 109, 392, 578, 406,-112, 119,-210, 316, 605, 215,-132,
     c 498, 128, 402, 586, 410,-109, 128,-204, 326, 597, 225,-126,
     c 504, 128, 406, 590, 410,-108, 132,-204, 332, 588, 230,-123,
     c 503, 112, 403, 590, 406,-114, 132,-209, 331, 577, 226,-124,
     c 495,  89, 393, 586, 400,-121, 126,-219, 327, 571, 215,-132,
     c 484,  70, 381, 578, 390,-130, 117,-235, 319, 564, 201,-143,
     c 472,  58, 369, 566, 378,-147, 108,-250, 309, 552, 188,-156,
     c 465,  52, 363, 556, 368,-164,  99,-263, 300, 538, 177,-169,
     c 458,  43, 361, 549, 360,-168,  93,-274, 291, 522, 167,-180,
     c 450,  28, 355, 544, 354,-175,  87,-283, 286, 497, 162,-188,
     c 444,  10, 342, 537, 347,-181,  80,-293, 280, 469, 156,-195,
     c 438,  -4, 331, 530, 336,-190,  71,-306, 274, 455, 151,-203,
     c 434, -12, 328, 524, 329,-199,  63,-319, 267, 447, 143,-212,
     c 431, -11, 323, 517, 322,-212,  56,-332, 258, 429, 137,-224,
     c 423,  -5, 312, 508, 310,-228,  47,-345, 249, 403, 132,-237,
     c 408,  -1, 294, 499, 292,-246,  35,-361, 237, 362, 125,-251,
     c 393,   1, 278, 490, 280,-255,  24,-379, 225, 291, 114,-266,
     c 377,  -3, 264, 478, 268,-270,  11,-398, 212, 229, 101,-281,
     c 366, -13, 251, 468, 257,-283,  -1,-416, 199, 221,  88,-297,
     c 352, -26, 238, 458, 242,-294, -14,-434, 186, 249,  77,-310,
     c 340, -38, 231, 446, 225,-315, -25,-456, 171, 261,  69,-322,
     c 334, -47, 228, 437, 210,-331, -37,-479, 154, 247,  60,-337,
     c 326, -56, 215, 422, 191,-348, -51,-501, 138, 222,  51,-352,
     c 315, -61, 193, 408, 170,-373, -66,-524, 121, 199,  41,-368,
     c 293, -79, 161, 393, 143,-401, -83,-542, 104, 203,  30,-383,
     c 271, -99, 129, 377, 116,-421,-102,-563,  89, 229,  18,-399,
     c 414,  -6, 361, 550, 398,-134,  84,-224, 280, 651, 159,-161,
     c 416,  -9, 360, 543, 388,-135,  81,-231, 272, 637, 162,-165,
     c 418, -12, 361, 536, 379,-145,  82,-234, 269, 626, 165,-165,
     c 424, -14, 358, 536, 375,-151,  83,-234, 272, 621, 171,-162,
     c 441,   2, 359, 546, 380,-146,  89,-233, 279, 617, 179,-156,
     c 457,  35, 366, 556, 388,-139,  98,-225, 289, 612, 189,-150,
     c 471,  74, 377, 566, 396,-121, 109,-217, 302, 606, 200,-141,
     c 486, 109, 390, 578, 406,-112, 119,-208, 314, 600, 211,-133,
     c 498, 128, 400, 587, 410,-109, 128,-204, 324, 593, 220,-127,
     c 504, 127, 406, 589, 411,-109, 133,-205, 328, 581, 223,-125,
     c 501, 110, 402, 586, 404,-120, 131,-208, 326, 568, 218,-128,
     c 493,  87, 394, 577, 395,-130, 123,-223, 318, 558, 205,-138,
     c 481,  66, 377, 569, 385,-139, 110,-240, 308, 548, 189,-153,
     c 465,  48, 354, 556, 369,-156,  97,-260, 296, 532, 174,-170,
     c 453,  34, 338, 540, 353,-175,  85,-276, 282, 515, 161,-187,
     c 443,  18, 333, 531, 341,-184,  75,-294, 271, 498, 149,-201,
     c 432,   0, 324, 524, 333,-193,  65,-307, 262, 475, 140,-211,
     c 422, -18, 311, 515, 322,-204,  57,-317, 256, 453, 135,-218,
     c 417, -30, 303, 509, 316,-215,  49,-330, 250, 445, 128,-226,
     c 417, -34, 304, 505, 312,-223,  45,-340, 245, 442, 121,-233,
     c 415, -25, 306, 503, 307,-230,  41,-347, 240, 430, 118,-242,
     c 409, -12, 299, 497, 293,-243,  37,-357, 234, 404, 116,-251,
     c 401,  -2, 286, 489, 279,-258,  31,-368, 226, 364, 112,-262,
     c 392,   0, 277, 481, 272,-264,  21,-384, 217, 294, 105,-274,
     c 378,  -6, 268, 474, 263,-276,  10,-401, 205, 235,  96,-286,
     c 367, -19, 256, 466, 254,-286,   1,-419, 195, 229,  88,-298,
     c 356, -32, 246, 455, 243,-299,  -9,-436, 183, 256,  81,-310,
     c 345, -39, 240, 442, 224,-321, -19,-456, 170, 263,  76,-321,
     c 342, -40, 234, 437, 209,-330, -29,-473, 156, 251,  71,-333,
     c 340, -43, 222, 427, 191,-343, -40,-492, 141, 228,  64,-347,
     c 332, -48, 202, 416, 169,-365, -54,-513, 126, 206,  56,-361,
     c 309, -67, 170, 401, 143,-392, -70,-528, 110, 224,  46,-376,
     c 284, -88, 138, 384, 114,-414, -86,-548,  95, 274,  35,-389,
     c 426,   3, 364, 553, 400,-131,  86,-222, 285, 656, 163,-158,
     c 424,  -3, 361, 544, 389,-133,  83,-229, 275, 642, 165,-162,
     c 424,  -9, 357, 536, 379,-146,  83,-235, 269, 631, 168,-165,
     c 430, -14, 355, 536, 375,-153,  82,-237, 270, 623, 172,-163,
     c 442,  -3, 355, 542, 378,-149,  88,-237, 276, 616, 176,-157,
     c 456,  28, 364, 552, 385,-143,  97,-229, 285, 607, 183,-152,
     c 469,  67, 376, 561, 394,-128, 106,-221, 298, 599, 193,-144,
     c 485, 103, 389, 572, 404,-117, 116,-211, 309, 594, 203,-137,
     c 498, 121, 397, 580, 408,-116, 125,-208, 318, 587, 209,-133,
     c 502, 120, 403, 584, 407,-114, 129,-210, 322, 572, 211,-132,
     c 498, 104, 401, 579, 402,-126, 126,-215, 318, 557, 207,-137,
     c 488,  80, 388, 566, 391,-141, 118,-230, 307, 545, 194,-148,
     c 474,  58, 364, 555, 377,-155, 103,-248, 294, 534, 177,-166,
     c 456,  36, 336, 540, 359,-171,  85,-273, 279, 517, 160,-187,
     c 438,  15, 316, 524, 339,-188,  69,-296, 263, 495, 145,-206,
     c 426,  -5, 304, 510, 322,-203,  55,-316, 250, 476, 131,-223,
     c 413, -25, 293, 501, 310,-216,  44,-329, 239, 454, 120,-235,
     c 401, -43, 280, 494, 300,-228,  35,-343, 232, 435, 114,-243,
     c 398, -53, 275, 488, 295,-240,  30,-351, 228, 428, 108,-248,
     c 400, -52, 279, 486, 292,-249,  28,-358, 226, 431, 103,-254,
     c 400, -38, 284, 487, 290,-251,  28,-360, 224, 423, 103,-259,
     c 398, -17, 283, 487, 281,-255,  28,-366, 221, 400, 104,-263,
     c 396,  -1, 278, 485, 272,-262,  26,-374, 217, 364, 104,-270,
     c 393,   1, 277, 480, 267,-267,  21,-385, 210, 305, 100,-278,
     c 385,  -7, 275, 475, 263,-279,  14,-398, 201, 258,  96,-287,
     c 377, -22, 268, 470, 257,-289,   6,-417, 192, 254,  90,-295,
     c 368, -35, 259, 460, 246,-298,   0,-433, 182, 271,  87,-305,
     c 358, -36, 252, 449, 229,-318,  -9,-449, 171, 264,  84,-315,
     c 356, -30, 247, 442, 213,-326, -19,-463, 159, 244,  80,-326,
     c 356, -28, 234, 434, 192,-337, -28,-478, 145, 209,  74,-339,
     c 349, -33, 217, 425, 171,-358, -40,-496, 131, 188,  66,-353,
     c 324, -54, 186, 410, 144,-381, -54,-515, 116, 217,  57,-366,
     c 299, -75, 155, 396, 116,-404, -72,-535, 102, 288,  46,-380,
     c 442,  19, 365, 558, 405,-127,  92,-216, 292, 656, 171,-151,
     c 438,  10, 359, 547, 393,-132,  89,-225, 280, 643, 171,-157,
     c 433,   0, 351, 535, 380,-148,  85,-231, 273, 632, 171,-162,
     c 435, -10, 347, 532, 372,-156,  81,-239, 271, 621, 172,-162,
     c 441,  -4, 343, 537, 373,-155,  85,-238, 274, 610, 173,-160,
     c 451,  19, 353, 543, 379,-152,  92,-235, 282, 597, 177,-156,
     c 467,  57, 373, 554, 387,-133, 102,-227, 292, 588, 183,-151,
     c 483,  90, 390, 565, 397,-126, 110,-220, 303, 583, 191,-145,
     c 495, 107, 396, 571, 399,-126, 117,-216, 311, 576, 196,-142,
     c 498, 105, 398, 571, 397,-128, 121,-218, 312, 559, 197,-143,
     c 493,  90, 394, 566, 392,-138, 119,-226, 306, 541, 191,-149,
     c 478,  69, 374, 553, 379,-155, 110,-243, 294, 532, 178,-163,
     c 461,  45, 343, 537, 361,-175,  92,-263, 279, 522, 161,-182,
     c 442,  21, 317, 521, 342,-192,  73,-289, 262, 503, 143,-204,
     c 427,  -3, 297, 505, 322,-210,  53,-314, 245, 477, 127,-225,
     c 410, -27, 280, 487, 301,-228,  37,-335, 229, 454, 112,-244,
     c 395, -48, 266, 476, 286,-246,  25,-349, 218, 433, 101,-257,
     c 385, -64, 257, 471, 278,-252,  18,-361, 212, 413,  95,-265,
     c 385, -71, 255, 470, 275,-259,  14,-369, 211, 406,  92,-268,
     c 390, -66, 262, 470, 275,-266,  14,-372, 211, 411,  91,-271,
     c 392, -47, 269, 473, 276,-265,  17,-369, 211, 411,  95,-271,
     c 395, -22, 274, 480, 274,-264,  23,-372, 212, 394, 100,-272,
     c 398,  -1, 279, 484, 271,-265,  25,-376, 211, 368, 103,-274,
     c 399,   3, 282, 481, 269,-268,  23,-384, 206, 326, 102,-278,
     c 395,  -5, 285, 478, 264,-279,  20,-397, 200, 294, 101,-283,
     c 392, -22, 285, 475, 262,-287,  14,-411, 192, 286,  97,-290,
     c 383, -35, 274, 468, 251,-297,   8,-426, 183, 286,  95,-298,
     c 374, -32, 261, 458, 234,-316,   0,-442, 174, 261,  91,-308,
     c 372, -21, 258, 452, 215,-327,  -7,-457, 162, 227,  85,-319,
     c 371, -16, 247, 441, 194,-342, -18,-470, 150, 179,  78,-332,
     c 361, -21, 231, 430, 173,-356, -31,-487, 137, 155,  69,-345,
     c 335, -42, 201, 414, 147,-379, -44,-505, 123, 189,  60,-358,
     c 311, -63, 172, 400, 120,-400, -59,-523, 109, 272,  50,-372,
     c 461,  38, 375, 566, 415,-118, 103,-208, 303, 650, 180,-140,
     c 454,  27, 365, 552, 400,-127,  97,-217, 287, 640, 178,-151,
     c 446,  15, 356, 538, 384,-138,  91,-228, 277, 629, 175,-157,
     c 439,   0, 342, 530, 372,-157,  83,-237, 272, 616, 172,-161,
     c 440,  -2, 335, 533, 369,-161,  84,-239, 272, 601, 169,-163,
     c 444,  14, 344, 539, 374,-159,  87,-239, 277, 586, 169,-163,
     c 457,  44, 364, 547, 379,-150,  94,-232, 285, 577, 174,-160,
     c 473,  73, 382, 555, 387,-141, 101,-229, 293, 572, 178,-157,
     c 485,  88, 388, 559, 388,-138, 106,-228, 298, 565, 181,-156,
     c 486,  85, 385, 556, 385,-142, 108,-231, 297, 549, 180,-158,
     c 477,  70, 373, 547, 378,-155, 104,-244, 289, 534, 173,-167,
     c 461,  51, 352, 535, 362,-171,  93,-260, 277, 529, 159,-181,
     c 443,  29, 321, 519, 342,-190,  76,-280, 260, 522, 142,-201,
     c 426,   3, 294, 501, 321,-208,  55,-305, 241, 502, 124,-224,
     c 414, -22, 275, 483, 301,-230,  35,-332, 224, 473, 108,-246,
     c 399, -47, 262, 467, 280,-248,  20,-353, 209, 444,  91,-264,
     c 382, -67, 249, 458, 267,-262,   8,-367, 200, 420,  81,-277,
     c 374, -79, 243, 456, 261,-268,   2,-378, 195, 392,  76,-284,
     c 375, -82, 245, 457, 262,-273,   0,-384, 196, 383,  78,-285,
     c 382, -75, 256, 458, 264,-277,   4,-382, 199, 390,  81,-283,
     c 388, -53, 266, 465, 267,-277,  12,-379, 203, 397,  90,-280,
     c 395, -24, 277, 475, 271,-271,  21,-377, 205, 388, 102,-276,
     c 403,   0, 284, 481, 273,-267,  26,-378, 207, 376, 110,-275,
     c 408,   6, 294, 481, 273,-269,  27,-384, 204, 352, 111,-275,
     c 406,  -2, 298, 481, 267,-278,  26,-394, 200, 335, 111,-277,
     c 402, -21, 296, 479, 262,-285,  22,-407, 194, 328, 110,-283,
     c 394, -33, 284, 472, 252,-300,  15,-421, 186, 306, 106,-290,
     c 385, -30, 269, 462, 233,-318,   7,-437, 177, 263,  99,-300,
     c 380, -15, 263, 457, 214,-332,  -2,-448, 166, 223,  91,-313,
     c 376,  -8, 254, 447, 195,-342, -11,-464, 154, 168,  82,-326,
     c 370, -11, 244, 437, 174,-356, -24,-480, 141, 132,  72,-339,
     c 345, -31, 217, 420, 149,-382, -38,-496, 128, 169,  62,-352,
     c 320, -51, 191, 405, 125,-401, -51,-515, 115, 259,  54,-365,
     c 485,  56, 391, 581, 431,-105, 118,-193, 316, 646, 188,-130,
     c 474,  43, 379, 563, 410,-115, 108,-206, 297, 639, 185,-143,
     c 462,  30, 366, 545, 391,-133,  99,-218, 283, 627, 180,-154,
     c 449,  12, 349, 533, 375,-155,  87,-233, 273, 613, 174,-162,
     c 442,   1, 336, 532, 368,-161,  83,-239, 269, 595, 166,-166,
     c 441,   9, 338, 535, 368,-166,  83,-244, 270, 579, 161,-170,
     c 449,  31, 353, 541, 371,-159,  86,-241, 275, 568, 162,-171,
     c 462,  54, 367, 543, 375,-153,  90,-241, 279, 565, 164,-171,
     c 473,  67, 370, 544, 375,-153,  92,-244, 281, 557, 163,-173,
     c 469,  62, 363, 537, 370,-160,  91,-252, 277, 542, 160,-179,
     c 456,  45, 345, 526, 361,-175,  84,-267, 268, 531, 152,-189,
     c 440,  27, 324, 512, 343,-196,  73,-285, 254, 530, 138,-204,
     c 423,   7, 301, 500, 323,-214,  56,-305, 237, 526, 120,-224,
     c 407, -18, 277, 483, 301,-231,  35,-328, 219, 506, 102,-247,
     c 395, -44, 257, 465, 280,-252,  15,-351, 201, 471,  86,-268,
     c 385, -67, 244, 449, 260,-271,   0,-371, 188, 436,  71,-285,
     c 372, -83, 234, 445, 250,-278,  -7,-385, 181, 404,  60,-296,
     c 362, -90, 232, 445, 247,-280, -12,-396, 180, 371,  59,-299,
     c 364, -89, 237, 446, 250,-285,  -9,-396, 184, 358,  64,-298,
     c 374, -79, 252, 451, 254,-285,  -2,-393, 190, 367,  72,-292,
     c 384, -56, 269, 460, 260,-282,   8,-386, 197, 379,  87,-285,
     c 394, -23, 282, 472, 268,-275,  19,-379, 202, 378, 104,-278,
     c 408,   2, 294, 480, 275,-267,  27,-379, 205, 376, 117,-272,
     c 418,  10, 306, 483, 275,-268,  31,-382, 205, 369, 122,-269,
     c 414,   1, 310, 484, 269,-276,  31,-393, 202, 367, 122,-270,
     c 409, -16, 302, 484, 264,-283,  26,-404, 197, 355, 121,-275,
     c 402, -29, 288, 479, 253,-298,  20,-415, 190, 318, 117,-284,
     c 392, -26, 273, 470, 233,-315,  11,-431, 182, 271, 108,-295,
     c 382, -12, 263, 462, 214,-332,   1,-445, 170, 233,  98,-308,
     c 381,  -3, 260, 455, 196,-342,  -9,-461, 157, 183,  86,-321,
     c 377,  -3, 256, 449, 178,-346, -21,-475, 145, 147,  76,-334,
     c 354, -22, 230, 432, 155,-369, -32,-490, 133, 175,  68,-347,
     c 330, -40, 206, 420, 134,-381, -44,-504, 120, 258,  61,-360,
     c 506,  68, 407, 593, 447, -96, 132,-179, 329, 647, 194,-118,
     c 491,  54, 391, 571, 421,-110, 119,-193, 306, 642, 189,-136,
     c 475,  39, 375, 550, 396,-130, 106,-211, 288, 631, 181,-150,
     c 460,  20, 358, 536, 376,-152,  88,-231, 275, 614, 171,-163,
     c 446,   4, 339, 529, 366,-165,  80,-241, 265, 594, 159,-172,
     c 440,   3, 334, 527, 362,-173,  76,-248, 261, 576, 151,-180,
     c 444,  17, 342, 530, 361,-173,  76,-252, 261, 564, 148,-184,
     c 452,  33, 349, 529, 362,-172,  75,-254, 262, 558, 148,-188,
     c 455,  40, 346, 522, 358,-178,  73,-264, 260, 546, 144,-193,
     c 449,  33, 334, 511, 350,-191,  70,-276, 254, 532, 139,-203,
     c 434,  17, 317, 501, 340,-204,  60,-292, 243, 523, 129,-215,
     c 415,   0, 297, 492, 322,-224,  48,-310, 229, 525, 114,-231,
     c 398, -19, 280, 477, 300,-243,  29,-329, 211, 521,  96,-251,
     c 385, -42, 265, 460, 280,-260,  11,-352, 193, 499,  79,-271,
     c 376, -67, 248, 445, 261,-279,  -5,-372, 177, 459,  64,-290,
     c 367, -87, 228, 433, 242,-295, -18,-390, 167, 422,  50,-304,
     c 358, -97, 218, 429, 235,-302, -23,-402, 163, 390,  43,-313,
     c 352, -97, 220, 434, 236,-296, -24,-406, 165, 362,  46,-313,
     c 355, -91, 232, 437, 240,-295, -18,-404, 173, 349,  55,-307,
     c 367, -79, 251, 445, 247,-290,  -7,-398, 182, 361,  68,-298,
     c 381, -52, 274, 460, 258,-282,   6,-389, 191, 375,  86,-288,
     c 398, -17, 290, 473, 271,-274,  20,-381, 200, 377, 106,-277,
     c 416,   8, 302, 484, 279,-264,  31,-378, 204, 374, 121,-270,
     c 427,  17, 314, 490, 280,-264,  37,-380, 207, 373, 128,-266,
     c 427,   8, 318, 490, 272,-271,  38,-389, 205, 374, 130,-265,
     c 421,  -7, 308, 489, 265,-279,  33,-398, 201, 354, 130,-270,
     c 411, -20, 288, 486, 253,-292,  27,-411, 195, 307, 126,-280,
     c 398, -20, 274, 478, 231,-308,  15,-425, 186, 258, 118,-292,
     c 390,  -9, 267, 469, 212,-326,   3,-441, 174, 227, 106,-306,
     c 389,  -2, 264, 459, 193,-341,  -6,-459, 161, 176,  93,-320,
     c 388,   1, 259, 456, 182,-343, -17,-470, 148, 140,  83,-333,
     c 366, -15, 234, 445, 162,-364, -26,-483, 136, 161,  76,-345,
     c 344, -31, 209, 434, 142,-378, -37,-493, 125, 229,  71,-357,
     c 514,  76, 413, 606, 462, -85, 142,-168, 340, 651, 195,-108,
     c 497,  61, 395, 580, 430,-102, 127,-188, 314, 646, 188,-129,
     c 478,  46, 376, 555, 399,-127, 110,-207, 292, 634, 178,-149,
     c 463,  26, 358, 536, 375,-153,  87,-232, 274, 616, 166,-166,
     c 448,   4, 338, 524, 362,-172,  74,-249, 260, 595, 151,-180,
     c 438,  -4, 328, 518, 354,-185,  65,-261, 250, 576, 139,-190,
     c 434,   0, 329, 515, 348,-191,  59,-268, 246, 561, 134,-200,
     c 437,   8, 332, 512, 345,-193,  57,-275, 242, 552, 130,-207,
     c 436,  10, 323, 502, 338,-201,  53,-287, 236, 536, 124,-216,
     c 428,   1, 307, 489, 329,-214,  45,-301, 227, 519, 115,-228,
     c 410, -14, 288, 480, 316,-231,  33,-319, 215, 509, 103,-243,
     c 390, -29, 270, 468, 297,-252,  20,-337, 200, 509,  86,-260,
     c 376, -46, 259, 454, 277,-268,   3,-356, 184, 502,  68,-278,
     c 367, -67, 249, 438, 258,-286, -11,-375, 167, 476,  53,-297,
     c 362, -89, 235, 424, 241,-306, -23,-392, 153, 434,  41,-314,
     c 357,-103, 216, 414, 228,-319, -32,-405, 145, 402,  32,-324,
     c 352,-108, 205, 415, 220,-322, -34,-417, 144, 381,  31,-328,
     c 351,-102, 212, 422, 223,-314, -30,-415, 150, 366,  40,-325,
     c 357, -90, 231, 431, 231,-307, -19,-411, 161, 363,  54,-315,
     c 369, -73, 255, 444, 242,-295,  -6,-399, 173, 380,  69,-303,
     c 385, -45, 279, 461, 256,-282,   9,-388, 186, 395,  89,-290,
     c 404,  -9, 297, 476, 271,-272,  25,-380, 196, 390, 108,-278,
     c 422,  17, 311, 487, 281,-264,  36,-374, 203, 381, 124,-270,
     c 435,  24, 320, 493, 282,-261,  42,-376, 207, 373, 131,-265,
     c 438,  16, 322, 494, 273,-270,  43,-382, 207, 367, 135,-264,
     c 431,   1, 312, 492, 262,-281,  38,-390, 204, 334, 136,-269,
     c 417, -10, 294, 488, 248,-293,  30,-403, 197, 279, 133,-280,
     c 403, -14, 280, 479, 226,-313,  18,-418, 188, 236, 126,-293,
     c 396,  -8, 273, 471, 206,-328,   7,-436, 176, 216, 114,-306,
     c 397,  -3, 268, 463, 190,-340,  -2,-452, 163, 174, 102,-321,
     c 397,   2, 260, 462, 181,-342, -12,-467, 150, 135,  92,-333,
     c 378, -12, 234, 454, 165,-357, -20,-475, 139, 145,  86,-345,
     c 357, -26, 209, 447, 146,-373, -29,-483, 128, 194,  85,-356,
     c 517,  80, 412, 617, 473, -77, 149,-160, 351, 659, 195, -98,
     c 496,  63, 392, 586, 435, -98, 131,-181, 321, 654, 187,-124,
     c 475,  47, 372, 556, 399,-131, 111,-208, 295, 640, 175,-148,
     c 457,  25, 353, 533, 370,-160,  82,-236, 271, 621, 160,-168,
     c 439,   0, 332, 514, 353,-182,  63,-259, 253, 597, 143,-186,
     c 424, -16, 319, 503, 341,-201,  50,-274, 239, 575, 128,-202,
     c 416, -21, 315, 496, 333,-208,  42,-289, 230, 559, 121,-214,
     c 413, -21, 310, 488, 325,-218,  34,-300, 223, 545, 114,-225,
     c 411, -23, 298, 478, 313,-228,  27,-314, 214, 524, 105,-238,
     c 400, -34, 280, 466, 299,-243,  16,-331, 202, 503,  92,-253,
     c 382, -48, 257, 454, 286,-264,   4,-348, 189, 492,  78,-270,
     c 365, -60, 239, 442, 268,-283,  -8,-366, 174, 489,  61,-286,
     c 355, -72, 232, 431, 251,-296, -20,-383, 158, 477,  44,-304,
     c 350, -89, 231, 420, 237,-308, -33,-398, 142, 447,  31,-321,
     c 349,-105, 220, 407, 224,-325, -42,-412, 130, 404,  22,-334,
     c 351,-115, 205, 400, 212,-337, -46,-421, 123, 379,  17,-341,
     c 353,-114, 197, 405, 208,-337, -41,-427, 125, 372,  22,-342,
     c 358,-103, 208, 415, 215,-324, -33,-422, 136, 374,  36,-335,
     c 367, -86, 231, 429, 228,-311, -19,-415, 150, 380,  55,-323,
     c 381, -65, 260, 446, 243,-298,  -3,-404, 165, 400,  72,-307,
     c 397, -34, 285, 466, 258,-284,  14,-393, 179, 414,  91,-293,
     c 414,   0, 299, 477, 270,-278,  28,-383, 192, 402, 110,-281,
     c 430,  25, 312, 489, 276,-268,  40,-377, 202, 383, 123,-272,
     c 443,  31, 324, 497, 278,-263,  44,-377, 206, 364, 130,-267,
     c 447,  23, 327, 500, 273,-265,  44,-382, 207, 345, 136,-266,
     c 439,  10, 316, 495, 261,-278,  40,-391, 204, 308, 138,-271,
     c 423,  -1, 304, 491, 243,-288,  30,-403, 197, 252, 137,-281,
     c 411,  -5, 295, 484, 224,-309,  19,-418, 187, 221, 130,-295,
     c 405,  -3, 289, 477, 209,-322,   8,-436, 175, 216, 119,-309,
     c 403,   0, 280, 470, 193,-333,  -2,-452, 163, 188, 108,-322,
     c 402,   1, 264, 464, 180,-339,  -9,-468, 150, 146,  99,-334,
     c 388,  -9, 240, 464, 170,-350, -16,-469, 139, 151,  95,-345,
     c 373, -19, 216, 462, 160,-360, -22,-473, 130, 186,  95,-354,
     c 523,  88, 418, 629, 486, -72, 157,-156, 360, 676, 197, -86,
     c 503,  71, 396, 596, 445, -97, 137,-178, 325, 669, 185,-117,
     c 483,  55, 377, 565, 408,-127, 112,-209, 295, 653, 171,-145,
     c 462,  29, 354, 537, 375,-160,  80,-239, 269, 630, 155,-171,
     c 441,   0, 330, 512, 350,-186,  57,-264, 246, 602, 135,-193,
     c 421, -22, 313, 494, 333,-210,  40,-285, 229, 574, 118,-213,
     c 406, -34, 304, 481, 322,-224,  27,-304, 217, 553, 108,-228,
     c 399, -39, 295, 471, 307,-237,  17,-321, 206, 534, 100,-242,
     c 392, -47, 279, 458, 292,-250,   5,-338, 196, 507,  88,-257,
     c 380, -60, 257, 445, 277,-272,  -5,-355, 183, 479,  74,-275,
     c 360, -75, 232, 432, 262,-292, -19,-374, 169, 462,  61,-291,
     c 342, -87, 215, 420, 244,-308, -32,-389, 152, 453,  43,-309,
     c 333, -97, 210, 411, 228,-319, -44,-406, 137, 436,  27,-326,
     c 329,-112, 210, 401, 216,-332, -53,-417, 122, 403,  15,-341,
     c 333,-124, 203, 391, 207,-346, -57,-432, 110, 362,   9,-352,
     c 337,-131, 191, 385, 197,-358, -58,-437, 106, 340,   8,-356,
     c 343,-127, 185, 392, 193,-356, -52,-439, 110, 344,  15,-354,
     c 351,-113, 197, 407, 203,-345, -40,-432, 122, 353,  32,-344,
     c 365, -93, 223, 425, 218,-331, -23,-424, 138, 368,  52,-330,
     c 379, -70, 253, 443, 233,-313,  -6,-413, 156, 391,  69,-313,
     c 393, -39, 277, 461, 245,-298,  11,-400, 172, 402,  89,-298,
     c 407,  -4, 290, 473, 255,-289,  25,-391, 186, 385, 107,-284,
     c 426,  21, 305, 486, 263,-278,  37,-383, 198, 358, 121,-275,
     c 440,  26, 315, 496, 266,-270,  41,-380, 203, 332, 127,-270,
     c 443,  19, 319, 498, 264,-275,  40,-384, 205, 310, 133,-268,
     c 435,   5, 311, 494, 253,-286,  34,-394, 202, 275, 136,-273,
     c 421,  -6, 301, 488, 237,-295,  25,-406, 194, 225, 135,-283,
     c 410, -11, 293, 480, 217,-319,  15,-421, 184, 207, 129,-296,
     c 402,  -9, 287, 474, 202,-332,   5,-437, 172, 215, 119,-309,
     c 399,  -8, 276, 471, 191,-342,  -4,-452, 160, 199, 108,-322,
     c 405,  -3, 262, 475, 186,-349,  -9,-466, 149, 162,  99,-333,
     c 391, -13, 239, 471, 176,-357, -14,-464, 138, 166,  96,-342,
     c 375, -25, 214, 472, 168,-371, -18,-466, 129, 201,  97,-351,
     c 531,  95, 422, 642, 496, -63, 167,-147, 367, 700, 198, -75,
     c 510,  78, 402, 608, 455, -88, 142,-170, 328, 690, 185,-110,
     c 490,  62, 382, 575, 416,-123, 114,-207, 294, 672, 169,-143,
     c 465,  34, 355, 541, 377,-159,  79,-241, 264, 643, 150,-173,
     c 440,   0, 328, 509, 348,-191,  52,-269, 239, 609, 127,-199,
     c 415, -29, 306, 485, 327,-218,  31,-292, 219, 575, 108,-222,
     c 397, -46, 294, 468, 309,-237,  15,-314, 205, 546,  97,-240,
     c 385, -58, 281, 454, 291,-253,   0,-334, 193, 519,  86,-258,
     c 375, -71, 260, 438, 271,-268, -13,-355, 181, 484,  74,-275,
     c 358, -87, 235, 423, 253,-295, -27,-375, 166, 448,  61,-293,
     c 337,-103, 207, 410, 236,-315, -42,-396, 151, 422,  46,-311,
     c 318,-114, 189, 398, 220,-332, -54,-408, 136, 405,  30,-328,
     c 309,-123, 188, 389, 205,-341, -64,-425, 119, 382,  14,-343,
     c 309,-133, 192, 382, 197,-352, -70,-436, 105, 344,   5,-356,
     c 315,-144, 187, 374, 190,-369, -73,-450,  94, 303,   0,-365,
     c 325,-147, 179, 371, 182,-377, -71,-452,  91, 288,   1,-367,
     c 333,-140, 174, 380, 179,-378, -62,-453,  96, 299,   9,-364,
     c 346,-122, 188, 400, 193,-362, -48,-442, 109, 315,  27,-353,
     c 361,-100, 216, 421, 210,-345, -30,-434, 127, 336,  47,-337,
     c 378, -75, 246, 440, 223,-326, -13,-423, 146, 360,  64,-320,
     c 390, -43, 268, 457, 232,-310,   4,-411, 165, 371,  83,-303,
     c 402,  -7, 283, 471, 240,-297,  18,-399, 180, 350, 101,-288,
     c 421,  16, 297, 483, 247,-287,  29,-392, 192, 314, 115,-278,
     c 436,  21, 308, 495, 253,-278,  33,-389, 198, 282, 122,-272,
     c 439,  14, 311, 497, 253,-280,  31,-392, 200, 260, 126,-270,
     c 432,   0, 306, 492, 247,-293,  25,-401, 197, 231, 130,-275,
     c 420, -11, 298, 484, 233,-305,  17,-414, 189, 192, 129,-284,
     c 407, -17, 291, 478, 212,-327,   7,-426, 179, 193, 122,-296,
     c 398, -16, 284, 474, 198,-345,  -1,-442, 168, 219, 112,-309,
     c 396, -16, 273, 472, 189,-353,  -8,-456, 156, 216, 101,-321,
     c 407,  -9, 260, 482, 187,-351, -12,-465, 145, 191,  94,-331,
     c 392, -19, 236, 481, 182,-360, -16,-462, 135, 195,  92,-340,
     c 378, -30, 212, 484, 176,-371, -18,-458, 127, 230,  94,-348/
      end
 
 
      block data xx2array
      integer*2 wwtabx2(12,33,65)
      common /wwtabx2_/wwtabx2
      data wwtabx2/
     c -75,  65, 194, 431, 254, 267, 505, 196, 539, 390, 454, 379,
     c -80,  64, 189, 438, 244, 274, 506, 199, 541, 388, 465, 384,
     c -86,  63, 182, 443, 237, 269, 509, 208, 545, 394, 475, 390,
     c -83,  72, 181, 454, 237, 279, 513, 220, 549, 413, 480, 398,
     c -76,  79, 190, 461, 242, 295, 519, 237, 556, 429, 489, 408,
     c -63,  86, 205, 470, 252, 308, 528, 250, 563, 437, 499, 418,
     c -54,  89, 221, 480, 258, 323, 532, 260, 570, 448, 507, 427,
     c -48,  87, 229, 484, 256, 328, 536, 261, 574, 463, 510, 433,
     c -51,  78, 228, 491, 253, 327, 537, 263, 575, 463, 511, 435,
     c -60,  63, 226, 493, 250, 338, 533, 261, 573, 443, 508, 434,
     c -73,  43, 225, 485, 245, 345, 525, 258, 568, 427, 504, 432,
     c -88,  20, 220, 478, 237, 352, 517, 251, 563, 423, 496, 429,
     c-101,   0, 216, 478, 229, 363, 509, 246, 557, 427, 489, 427,
     c-107, -17, 210, 478, 224, 368, 502, 241, 551, 440, 482, 426,
     c-111, -26, 201, 471, 217, 356, 499, 238, 545, 461, 477, 423,
     c-119, -24, 197, 467, 220, 346, 498, 230, 540, 464, 473, 420,
     c-117, -13, 198, 471, 215, 335, 497, 228, 533, 447, 471, 415,
     c-113,  -3, 200, 473, 208, 323, 494, 219, 526, 427, 469, 410,
     c-117,   0, 196, 470, 203, 304, 489, 214, 519, 412, 468, 403,
     c-129,  -3, 192, 460, 199, 283, 481, 200, 508, 394, 463, 396,
     c-142, -13, 186, 446, 189, 276, 471, 192, 500, 372, 456, 388,
     c-156, -24, 176, 431, 178, 260, 460, 181, 491, 362, 449, 381,
     c-166, -32, 162, 426, 171, 253, 450, 173, 485, 361, 444, 374,
     c-171, -39, 154, 422, 165, 258, 445, 168, 483, 355, 441, 370,
     c-171, -42, 151, 422, 163, 252, 444, 167, 482, 345, 443, 366,
     c-168, -43, 151, 428, 169, 249, 448, 169, 485, 348, 447, 365,
     c-162, -43, 153, 434, 178, 251, 452, 174, 489, 360, 453, 368,
     c-156, -42, 160, 440, 184, 250, 458, 178, 494, 368, 457, 372,
     c-152, -42, 165, 444, 186, 257, 460, 186, 499, 357, 461, 376,
     c-153, -45, 166, 447, 184, 256, 461, 184, 502, 342, 463, 378,
     c-160, -51, 165, 443, 178, 258, 457, 184, 505, 336, 463, 379,
     c-163, -52, 168, 442, 173, 256, 453, 178, 505, 340, 461, 378,
     c-166, -52, 170, 441, 168, 256, 449, 177, 504, 348, 457, 374,
     c -60,  70, 208, 447, 261, 282, 515, 211, 554, 370, 471, 398,
     c -65,  69, 202, 453, 251, 280, 515, 213, 555, 362, 480, 400,
     c -70,  67, 195, 458, 243, 288, 516, 216, 556, 363, 490, 404,
     c -70,  73, 194, 466, 241, 294, 518, 227, 559, 371, 497, 409,
     c -65,  78, 200, 471, 244, 306, 524, 238, 564, 384, 506, 417,
     c -56,  81, 210, 477, 249, 318, 530, 250, 570, 392, 515, 424,
     c -49,  83, 225, 486, 254, 327, 534, 259, 575, 411, 521, 431,
     c -44,  81, 230, 491, 253, 335, 538, 262, 577, 438, 523, 436,
     c -47,  74, 228, 497, 250, 340, 538, 264, 577, 450, 521, 437,
     c -54,  63, 227, 498, 247, 346, 535, 263, 573, 439, 517, 435,
     c -65,  46, 226, 490, 243, 354, 529, 258, 568, 429, 512, 432,
     c -77,  28, 225, 484, 236, 365, 522, 252, 562, 423, 505, 429,
     c -88,   9, 221, 485, 228, 378, 514, 247, 556, 422, 498, 426,
     c -95,  -5, 216, 483, 220, 373, 508, 241, 550, 429, 491, 423,
     c-100, -14, 208, 475, 215, 362, 503, 235, 545, 445, 485, 419,
     c-109, -14, 201, 469, 214, 335, 499, 227, 538, 442, 480, 415,
     c-111,  -7, 199, 469, 207, 319, 495, 220, 532, 422, 476, 408,
     c-109,   0, 195, 468, 199, 311, 491, 212, 524, 401, 473, 402,
     c-113,   2, 190, 464, 195, 295, 485, 203, 516, 386, 470, 394,
     c-126,  -3, 183, 454, 190, 283, 475, 194, 506, 369, 465, 387,
     c-139, -12, 177, 440, 180, 277, 464, 184, 496, 351, 458, 379,
     c-152, -22, 168, 427, 169, 256, 454, 173, 488, 347, 451, 373,
     c-159, -29, 157, 423, 162, 258, 446, 168, 483, 352, 447, 367,
     c-164, -35, 151, 421, 158, 267, 440, 163, 480, 351, 445, 363,
     c-164, -38, 148, 422, 157, 256, 441, 164, 480, 346, 448, 360,
     c-161, -39, 148, 428, 162, 253, 445, 167, 484, 352, 453, 361,
     c-155, -38, 151, 436, 171, 258, 450, 172, 488, 370, 459, 365,
     c-149, -36, 159, 445, 178, 253, 457, 178, 494, 384, 465, 371,
     c-144, -34, 165, 451, 183, 256, 461, 185, 499, 380, 469, 375,
     c-142, -35, 169, 457, 185, 263, 464, 183, 504, 372, 472, 378,
     c-149, -39, 170, 454, 182, 259, 459, 184, 507, 372, 474, 381,
     c-152, -39, 172, 453, 178, 263, 457, 180, 507, 377, 472, 380,
     c-155, -39, 174, 452, 173, 261, 454, 178, 507, 386, 468, 376,
     c -45,  75, 221, 460, 268, 295, 527, 225, 566, 369, 482, 412,
     c -49,  73, 215, 468, 257, 294, 523, 224, 565, 356, 490, 412,
     c -55,  72, 209, 473, 248, 299, 522, 225, 564, 352, 497, 413,
     c -57,  74, 206, 479, 244, 307, 523, 232, 566, 353, 505, 416,
     c -55,  75, 208, 480, 244, 312, 526, 240, 569, 362, 513, 421,
     c -51,  76, 215, 483, 245, 322, 530, 250, 573, 367, 521, 426,
     c -45,  77, 227, 490, 250, 331, 536, 257, 575, 388, 526, 432,
     c -41,  76, 231, 495, 251, 338, 538, 261, 576, 418, 527, 435,
     c -44,  70, 227, 500, 245, 352, 538, 262, 575, 436, 526, 435,
     c -47,  62, 228, 502, 244, 364, 537, 260, 571, 429, 522, 434,
     c -56,  49, 228, 495, 241, 367, 532, 255, 565, 421, 517, 430,
     c -66,  36, 229, 489, 235, 369, 526, 251, 560, 412, 512, 427,
     c -76,  21, 227, 491, 228, 379, 518, 244, 554, 408, 506, 424,
     c -83,   7, 223, 489, 219, 367, 512, 238, 548, 409, 499, 420,
     c -91,  -2, 214, 479, 210, 345, 506, 231, 543, 421, 492, 415,
     c -99,  -5, 206, 472, 207, 328, 500, 222, 537, 416, 486, 410,
     c-104,   0, 199, 467, 199, 311, 494, 211, 529, 398, 480, 402,
     c-106,   3, 190, 464, 190, 308, 488, 203, 522, 378, 476, 395,
     c-111,   4, 183, 457, 186, 291, 480, 195, 513, 367, 473, 388,
     c-124,  -1, 174, 448, 182, 273, 468, 186, 503, 353, 467, 379,
     c-135, -10, 170, 435, 171, 271, 458, 177, 493, 339, 461, 373,
     c-147, -20, 161, 424, 159, 253, 449, 167, 485, 337, 454, 366,
     c-153, -26, 152, 421, 153, 253, 441, 162, 479, 346, 449, 360,
     c-156, -31, 148, 420, 150, 262, 438, 157, 478, 347, 450, 358,
     c-156, -33, 146, 421, 150, 252, 439, 157, 479, 343, 453, 356,
     c-155, -34, 146, 428, 154, 249, 442, 159, 482, 351, 458, 358,
     c-149, -32, 149, 440, 164, 252, 448, 166, 487, 372, 465, 362,
     c-143, -30, 157, 449, 172, 252, 457, 173, 494, 391, 471, 369,
     c-136, -27, 166, 457, 179, 260, 463, 182, 500, 392, 476, 375,
     c-131, -24, 172, 466, 186, 268, 467, 185, 505, 388, 480, 379,
     c-136, -26, 175, 464, 186, 266, 464, 184, 508, 392, 482, 381,
     c-140, -27, 177, 463, 181, 275, 463, 182, 510, 398, 482, 381,
     c-143, -27, 179, 464, 176, 275, 461, 180, 509, 409, 480, 378,
     c -26,  89, 242, 481, 270, 310, 539, 238, 577, 397, 484, 422,
     c -33,  84, 233, 484, 259, 311, 534, 236, 574, 379, 491, 418,
     c -41,  79, 224, 487, 251, 313, 530, 236, 571, 369, 497, 417,
     c -44,  76, 221, 492, 249, 322, 527, 239, 570, 368, 501, 418,
     c -48,  74, 217, 489, 244, 322, 528, 241, 571, 371, 508, 419,
     c -46,  72, 222, 490, 242, 331, 529, 246, 571, 369, 516, 423,
     c -44,  70, 230, 495, 246, 339, 533, 250, 573, 380, 520, 426,
     c -44,  68, 232, 499, 246, 353, 534, 257, 572, 406, 522, 429,
     c -44,  65, 227, 499, 241, 366, 535, 259, 570, 421, 522, 429,
     c -45,  61, 228, 501, 236, 374, 534, 257, 566, 416, 522, 429,
     c -49,  54, 231, 499, 234, 379, 532, 253, 561, 406, 520, 427,
     c -56,  46, 233, 494, 231, 378, 528, 249, 556, 395, 518, 425,
     c -62,  35, 233, 494, 224, 366, 524, 243, 551, 381, 512, 423,
     c -72,  22, 228, 492, 216, 353, 518, 236, 546, 375, 506, 418,
     c -82,  10, 222, 483, 206, 337, 509, 225, 541, 382, 498, 413,
     c -92,   5, 211, 474, 199, 317, 501, 216, 534, 380, 491, 405,
     c -99,   5, 200, 466, 190, 305, 492, 201, 527, 370, 484, 396,
     c-105,   7, 184, 456, 180, 297, 482, 192, 518, 362, 480, 388,
     c-113,   5, 172, 448, 175, 278, 471, 182, 509, 357, 475, 381,
     c-126,   0, 164, 438, 170, 265, 461, 176, 499, 348, 469, 373,
     c-138,  -8, 159, 431, 161, 259, 452, 166, 489, 336, 463, 366,
     c-143, -16, 152, 423, 150, 246, 444, 159, 482, 338, 458, 360,
     c-145, -23, 148, 421, 145, 251, 440, 155, 478, 344, 455, 356,
     c-148, -27, 148, 423, 142, 261, 438, 153, 475, 344, 456, 354,
     c-149, -29, 147, 425, 144, 247, 438, 152, 477, 338, 458, 354,
     c-148, -30, 146, 432, 149, 241, 440, 155, 481, 347, 463, 356,
     c-145, -29, 149, 445, 156, 241, 445, 162, 487, 366, 470, 361,
     c-139, -25, 158, 455, 167, 242, 454, 171, 493, 386, 477, 368,
     c-128, -17, 165, 466, 175, 258, 464, 180, 500, 392, 482, 374,
     c-123, -12, 172, 475, 182, 269, 469, 184, 506, 394, 486, 379,
     c-124, -10, 176, 477, 182, 274, 470, 183, 510, 396, 490, 382,
     c-124,  -8, 181, 479, 180, 290, 469, 180, 510, 403, 491, 382,
     c-125,  -6, 186, 481, 178, 290, 466, 178, 510, 411, 490, 380,
     c -12, 108, 258, 498, 266, 320, 548, 252, 584, 412, 488, 426,
     c -21,  99, 247, 496, 257, 318, 541, 245, 579, 393, 491, 420,
     c -30,  91, 238, 496, 248, 318, 535, 241, 574, 382, 494, 416,
     c -38,  85, 227, 491, 240, 318, 528, 238, 572, 378, 496, 415,
     c -44,  79, 223, 490, 234, 317, 527, 238, 569, 377, 500, 414,
     c -45,  75, 226, 493, 234, 331, 526, 240, 568, 367, 504, 416,
     c -46,  71, 228, 497, 234, 338, 528, 241, 567, 364, 509, 417,
     c -48,  68, 226, 496, 230, 344, 530, 248, 564, 381, 511, 419,
     c -49,  65, 227, 495, 226, 359, 531, 251, 563, 394, 514, 422,
     c -46,  63, 230, 499, 226, 368, 532, 249, 559, 393, 517, 422,
     c -45,  60, 234, 502, 224, 377, 532, 245, 555, 386, 520, 422,
     c -50,  56, 237, 499, 221, 366, 529, 241, 552, 375, 519, 422,
     c -55,  50, 238, 497, 216, 354, 525, 236, 549, 359, 517, 420,
     c -62,  39, 237, 494, 212, 338, 519, 227, 544, 349, 511, 416,
     c -72,  27, 232, 485, 202, 323, 511, 216, 538, 351, 503, 409,
     c -87,  18, 220, 476, 192, 310, 499, 204, 531, 352, 495, 400,
     c -96,  16, 205, 464, 179, 297, 488, 193, 523, 351, 487, 390,
     c-102,  16, 190, 454, 171, 290, 476, 182, 514, 352, 482, 381,
     c-113,  14, 177, 445, 166, 275, 466, 176, 505, 352, 476, 374,
     c-125,  10, 166, 438, 160, 265, 458, 170, 495, 344, 471, 367,
     c-133,   3, 159, 434, 154, 258, 449, 162, 486, 332, 465, 360,
     c-136,  -6, 154, 432, 145, 255, 443, 155, 479, 333, 461, 355,
     c-135, -14, 152, 433, 141, 260, 440, 153, 475, 336, 459, 351,
     c-137, -19, 152, 435, 138, 256, 439, 149, 474, 333, 459, 351,
     c-138, -21, 151, 437, 140, 240, 440, 147, 476, 327, 462, 352,
     c-140, -21, 149, 444, 146, 240, 442, 149, 480, 334, 467, 354,
     c-137, -17, 151, 454, 151, 232, 448, 153, 486, 354, 472, 359,
     c-130, -10, 157, 461, 159, 233, 455, 162, 493, 374, 478, 367,
     c-119,   0, 164, 472, 171, 249, 465, 172, 500, 383, 485, 373,
     c-112,  11, 172, 483, 181, 262, 473, 180, 506, 388, 491, 378,
     c-111,  14, 176, 485, 181, 270, 474, 182, 509, 393, 496, 381,
     c-109,  18, 182, 487, 179, 285, 475, 179, 511, 398, 498, 382,
     c-107,  22, 187, 490, 177, 294, 475, 176, 511, 405, 497, 382,
     c  -4, 123, 266, 512, 257, 329, 551, 258, 587, 408, 495, 427,
     c -14, 111, 255, 507, 248, 319, 542, 245, 581, 391, 496, 418,
     c -26,  98, 245, 498, 237, 318, 534, 239, 575, 379, 496, 413,
     c -38,  89, 232, 490, 227, 314, 524, 231, 569, 373, 492, 409,
     c -43,  83, 226, 490, 221, 317, 520, 230, 565, 367, 493, 406,
     c -43,  77, 228, 496, 222, 334, 519, 232, 560, 347, 494, 405,
     c -46,  72, 226, 497, 219, 338, 520, 230, 557, 335, 497, 407,
     c -49,  68, 224, 492, 211, 337, 523, 234, 555, 344, 500, 409,
     c -52,  65, 225, 492, 209, 342, 525, 236, 553, 359, 505, 411,
     c -49,  65, 231, 496, 213, 350, 525, 239, 550, 366, 511, 413,
     c -46,  64, 236, 498, 211, 353, 527, 235, 549, 371, 517, 415,
     c -50,  63, 239, 498, 208, 344, 526, 234, 547, 367, 518, 417,
     c -55,  58, 240, 495, 206, 327, 523, 229, 544, 352, 517, 416,
     c -60,  49, 240, 489, 202, 312, 518, 220, 540, 341, 511, 411,
     c -68,  38, 237, 481, 195, 306, 509, 212, 534, 340, 504, 404,
     c -82,  31, 227, 474, 185, 302, 499, 201, 528, 341, 495, 394,
     c -90,  28, 214, 466, 173, 290, 487, 190, 519, 346, 489, 384,
     c -96,  29, 201, 457, 163, 286, 475, 178, 510, 356, 482, 376,
     c-106,  28, 188, 451, 160, 273, 466, 171, 499, 357, 477, 368,
     c-118,  25, 176, 445, 153, 264, 458, 165, 490, 348, 472, 361,
     c-123,  19, 168, 444, 147, 259, 451, 157, 482, 336, 466, 355,
     c-126,   9, 161, 442, 140, 256, 446, 151, 476, 335, 462, 351,
     c-127,  -1, 156, 443, 137, 256, 444, 150, 473, 334, 460, 348,
     c-129,  -9, 154, 442, 134, 249, 442, 147, 473, 330, 460, 348,
     c-130, -10, 155, 444, 136, 233, 444, 148, 475, 326, 462, 350,
     c-131,  -7, 155, 452, 142, 233, 447, 151, 480, 331, 466, 353,
     c-127,   0, 160, 458, 148, 233, 452, 155, 486, 347, 471, 359,
     c-119,  11, 166, 465, 157, 233, 459, 162, 492, 364, 478, 365,
     c-111,  26, 172, 474, 169, 252, 467, 171, 499, 372, 484, 370,
     c-104,  38, 179, 483, 181, 267, 476, 178, 504, 377, 492, 376,
     c-102,  43, 183, 483, 180, 275, 479, 182, 508, 384, 496, 380,
     c-101,  48, 188, 485, 179, 283, 480, 178, 509, 388, 499, 382,
     c -98,  53, 193, 486, 178, 284, 481, 178, 510, 392, 499, 382,
     c  -4, 134, 267, 516, 247, 327, 550, 259, 585, 399, 504, 424,
     c -19, 118, 254, 505, 236, 316, 539, 244, 577, 385, 502, 414,
     c -32, 101, 241, 495, 225, 315, 528, 231, 570, 375, 499, 406,
     c -44,  88, 230, 486, 215, 309, 516, 223, 562, 368, 493, 400,
     c -48,  79, 227, 484, 209, 309, 511, 220, 555, 357, 488, 395,
     c -49,  73, 228, 487, 204, 317, 509, 219, 550, 331, 487, 393,
     c -52,  68, 226, 490, 201, 317, 509, 217, 546, 309, 487, 393,
     c -55,  64, 224, 486, 195, 313, 512, 219, 544, 311, 490, 395,
     c -54,  63, 225, 485, 194, 306, 515, 222, 543, 327, 496, 399,
     c -52,  64, 230, 487, 196, 308, 518, 224, 542, 343, 503, 402,
     c -50,  65, 234, 488, 196, 305, 520, 221, 542, 356, 508, 406,
     c -51,  66, 236, 490, 196, 294, 522, 220, 543, 358, 511, 408,
     c -54,  64, 235, 487, 194, 290, 520, 216, 541, 347, 511, 408,
     c -57,  57, 234, 481, 190, 282, 516, 210, 537, 337, 507, 404,
     c -65,  47, 231, 475, 184, 281, 508, 203, 531, 332, 501, 398,
     c -77,  40, 224, 473, 179, 280, 499, 196, 524, 335, 494, 389,
     c -86,  38, 214, 469, 170, 279, 488, 185, 516, 348, 487, 380,
     c -90,  41, 204, 463, 161, 271, 479, 178, 507, 367, 483, 372,
     c -97,  44, 196, 458, 156, 259, 471, 169, 498, 373, 478, 365,
     c-109,  43, 185, 454, 148, 256, 463, 163, 489, 365, 472, 358,
     c-115,  37, 174, 451, 139, 250, 458, 158, 481, 354, 467, 352,
     c-118,  26, 163, 447, 134, 245, 453, 150, 476, 349, 462, 348,
     c-121,  14, 157, 446, 132, 240, 449, 145, 473, 344, 458, 345,
     c-122,   7, 158, 446, 132, 234, 448, 142, 474, 339, 458, 346,
     c-121,   8, 161, 449, 135, 222, 449, 144, 477, 336, 459, 348,
     c-118,  13, 166, 454, 140, 228, 453, 147, 481, 339, 463, 352,
     c-115,  23, 174, 460, 147, 229, 458, 151, 487, 349, 468, 356,
     c-109,  37, 181, 467, 157, 239, 463, 156, 493, 357, 475, 361,
     c-103,  52, 187, 475, 170, 253, 470, 163, 498, 358, 482, 367,
     c -96,  65, 192, 480, 178, 265, 479, 170, 503, 360, 490, 373,
     c -97,  69, 193, 480, 177, 268, 483, 176, 507, 365, 495, 378,
     c -94,  74, 199, 482, 179, 268, 485, 177, 509, 369, 498, 381,
     c -91,  80, 205, 486, 181, 271, 488, 178, 510, 372, 499, 382,
     c -10, 141, 260, 513, 241, 319, 546, 251, 578, 393, 508, 417,
     c -25, 122, 245, 499, 226, 311, 532, 234, 569, 381, 504, 406,
     c -39, 103, 231, 487, 213, 303, 521, 219, 561, 372, 500, 397,
     c -54,  84, 219, 475, 199, 291, 508, 208, 553, 365, 491, 389,
     c -60,  73, 218, 469, 191, 289, 500, 203, 544, 351, 483, 382,
     c -61,  66, 222, 470, 186, 290, 497, 202, 537, 321, 480, 379,
     c -64,  61, 221, 476, 181, 291, 497, 201, 532, 294, 480, 379,
     c -66,  60, 220, 475, 177, 287, 499, 203, 531, 291, 481, 381,
     c -59,  63, 223, 475, 179, 275, 505, 206, 531, 304, 488, 385,
     c -54,  68, 228, 478, 184, 267, 510, 207, 534, 322, 496, 390,
     c -53,  72, 232, 482, 186, 262, 513, 207, 535, 340, 500, 395,
     c -53,  75, 230, 483, 185, 259, 517, 206, 537, 347, 503, 398,
     c -53,  73, 227, 480, 183, 251, 516, 204, 536, 339, 502, 398,
     c -54,  68, 225, 478, 182, 252, 513, 202, 532, 330, 498, 396,
     c -61,  59, 223, 473, 176, 248, 507, 197, 528, 324, 495, 391,
     c -71,  54, 217, 474, 173, 249, 500, 192, 523, 327, 491, 384,
     c -77,  53, 211, 474, 168, 257, 493, 186, 515, 346, 486, 377,
     c -81,  56, 204, 468, 160, 251, 486, 176, 507, 371, 483, 370,
     c -89,  58, 198, 461, 151, 245, 478, 168, 498, 379, 479, 363,
     c -99,  59, 188, 457, 142, 245, 471, 161, 490, 373, 472, 357,
     c-104,  56, 176, 453, 136, 235, 465, 154, 483, 360, 467, 351,
     c-108,  46, 164, 448, 132, 221, 460, 147, 479, 351, 462, 346,
     c-113,  36, 159, 444, 130, 213, 456, 141, 477, 342, 457, 344,
     c-114,  30, 161, 445, 131, 208, 454, 141, 478, 337, 455, 344,
     c-111,  32, 165, 446, 134, 207, 455, 145, 481, 334, 455, 346,
     c-107,  39, 173, 451, 140, 219, 457, 149, 484, 336, 458, 349,
     c-104,  49, 182, 457, 145, 227, 460, 152, 489, 341, 463, 353,
     c-100,  62, 191, 465, 155, 244, 468, 156, 494, 341, 470, 358,
     c -96,  74, 197, 472, 165, 255, 473, 163, 499, 338, 479, 363,
     c -91,  84, 201, 477, 173, 266, 480, 169, 503, 338, 485, 370,
     c -94,  87, 201, 476, 172, 267, 484, 175, 508, 343, 491, 375,
     c -90,  92, 206, 482, 178, 262, 488, 178, 511, 347, 494, 379,
     c -87,  97, 210, 488, 183, 267, 491, 183, 511, 349, 495, 381,
     c -16, 145, 252, 511, 239, 320, 538, 236, 569, 370, 508, 409,
     c -29, 125, 239, 497, 222, 312, 525, 221, 560, 360, 504, 397,
     c -44, 104, 225, 482, 204, 301, 512, 206, 550, 351, 498, 386,
     c -59,  82, 210, 464, 185, 282, 499, 193, 540, 346, 488, 377,
     c -65,  68, 208, 457, 174, 277, 490, 185, 531, 334, 479, 370,
     c -70,  59, 210, 457, 165, 271, 486, 183, 523, 309, 475, 365,
     c -74,  55, 211, 461, 159, 271, 486, 183, 518, 287, 473, 364,
     c -71,  58, 214, 465, 158, 259, 489, 185, 518, 284, 474, 366,
     c -65,  65, 220, 466, 163, 252, 495, 189, 519, 296, 479, 371,
     c -57,  73, 225, 470, 172, 241, 502, 188, 522, 315, 487, 376,
     c -54,  80, 229, 477, 176, 238, 507, 191, 526, 332, 490, 382,
     c -53,  86, 227, 480, 177, 237, 510, 192, 528, 339, 492, 385,
     c -54,  88, 223, 478, 176, 223, 510, 191, 529, 335, 492, 386,
     c -55,  84, 216, 473, 171, 224, 508, 191, 527, 328, 491, 385,
     c -61,  77, 212, 472, 168, 219, 503, 188, 524, 318, 489, 382,
     c -68,  70, 207, 473, 163, 226, 500, 185, 520, 317, 488, 377,
     c -72,  66, 201, 471, 158, 224, 494, 182, 515, 332, 485, 372,
     c -76,  67, 196, 467, 149, 217, 489, 174, 508, 355, 482, 366,
     c -84,  70, 193, 461, 143, 212, 481, 164, 501, 361, 478, 360,
     c -91,  72, 185, 456, 135, 206, 475, 154, 494, 353, 473, 354,
     c -96,  71, 174, 450, 129, 196, 470, 149, 489, 341, 467, 348,
     c -99,  65, 164, 444, 127, 195, 466, 142, 484, 330, 461, 344,
     c-104,  58, 162, 441, 128, 192, 461, 139, 482, 322, 457, 342,
     c-105,  54, 164, 439, 129, 195, 459, 139, 483, 319, 453, 341,
     c-102,  56, 169, 442, 135, 204, 460, 143, 485, 320, 452, 343,
     c -98,  61, 177, 447, 141, 219, 462, 144, 488, 323, 454, 346,
     c -97,  68, 186, 452, 145, 233, 465, 150, 491, 326, 458, 349,
     c -95,  77, 196, 458, 152, 245, 468, 156, 495, 323, 465, 354,
     c -92,  84, 202, 466, 160, 259, 474, 159, 500, 318, 473, 359,
     c -91,  89, 205, 474, 169, 272, 478, 163, 505, 320, 479, 366,
     c -92,  90, 204, 474, 171, 272, 483, 171, 509, 328, 485, 372,
     c -89,  95, 208, 481, 179, 260, 487, 174, 512, 334, 488, 376,
     c -85, 100, 212, 489, 188, 264, 490, 180, 514, 336, 488, 379,
     c -23, 135, 242, 509, 233, 314, 531, 224, 559, 346, 506, 398,
     c -37, 115, 228, 492, 209, 307, 517, 205, 548, 336, 502, 385,
     c -52,  95, 214, 475, 188, 291, 504, 193, 538, 329, 495, 374,
     c -62,  73, 202, 462, 169, 275, 492, 180, 527, 326, 483, 364,
     c -68,  58, 200, 454, 157, 266, 482, 173, 516, 319, 474, 356,
     c -76,  48, 200, 449, 146, 250, 479, 167, 507, 300, 468, 350,
     c -80,  45, 202, 450, 140, 239, 477, 164, 502, 286, 466, 349,
     c -76,  50, 207, 453, 139, 226, 481, 165, 502, 287, 466, 351,
     c -68,  60, 217, 455, 145, 222, 487, 167, 504, 297, 470, 355,
     c -62,  71, 222, 460, 154, 222, 494, 171, 509, 312, 475, 361,
     c -60,  81, 223, 464, 159, 218, 499, 174, 513, 326, 479, 366,
     c -58,  89, 221, 469, 162, 217, 501, 178, 517, 329, 480, 369,
     c -58,  93, 216, 468, 164, 212, 501, 180, 518, 327, 482, 371,
     c -58,  93, 206, 468, 159, 209, 500, 179, 518, 323, 483, 371,
     c -63,  88, 198, 466, 156, 205, 495, 177, 517, 310, 484, 370,
     c -68,  81, 192, 466, 152, 210, 495, 174, 516, 304, 483, 367,
     c -69,  77, 190, 466, 147, 206, 491, 170, 513, 313, 483, 363,
     c -72,  74, 187, 462, 142, 196, 486, 164, 508, 329, 480, 358,
     c -79,  76, 186, 458, 140, 192, 480, 155, 502, 330, 477, 353,
     c -87,  78, 181, 453, 134, 179, 474, 149, 497, 324, 473, 347,
     c -91,  80, 174, 449, 129, 174, 470, 145, 492, 316, 467, 342,
     c -95,  79, 168, 442, 128, 174, 467, 140, 489, 311, 461, 339,
     c -98,  75, 167, 436, 128, 173, 463, 140, 487, 308, 456, 338,
     c -99,  72, 170, 436, 130, 190, 461, 140, 486, 311, 450, 337,
     c -97,  73, 176, 439, 134, 202, 462, 144, 487, 313, 448, 339,
     c -93,  75, 181, 441, 140, 218, 463, 143, 488, 314, 449, 341,
     c -90,  77, 191, 446, 145, 230, 465, 148, 490, 313, 452, 344,
     c -91,  78, 199, 453, 151, 241, 467, 152, 494, 307, 457, 349,
     c -92,  79, 204, 461, 156, 252, 471, 153, 500, 301, 463, 354,
     c -92,  80, 206, 467, 162, 256, 473, 155, 504, 306, 471, 361,
     c -91,  78, 204, 469, 168, 258, 476, 161, 509, 320, 475, 367,
     c -88,  82, 207, 476, 176, 251, 481, 165, 513, 326, 479, 372,
     c -84,  86, 210, 482, 184, 258, 484, 172, 514, 328, 479, 375,
     c -31, 107, 231, 501, 216, 286, 522, 206, 547, 324, 500, 384,
     c -44,  89, 217, 484, 192, 285, 507, 192, 538, 316, 495, 372,
     c -58,  71, 202, 468, 168, 267, 495, 179, 527, 311, 487, 360,
     c -69,  52, 191, 457, 151, 266, 482, 167, 514, 310, 476, 350,
     c -74,  40, 192, 452, 140, 255, 473, 159, 503, 304, 466, 342,
     c -82,  32, 191, 443, 129, 229, 468, 150, 492, 292, 460, 336,
     c -86,  30, 190, 440, 122, 221, 467, 145, 487, 286, 457, 334,
     c -85,  34, 197, 440, 122, 209, 470, 145, 487, 287, 457, 336,
     c -77,  44, 207, 443, 130, 209, 476, 148, 490, 292, 459, 340,
     c -72,  56, 214, 446, 135, 213, 482, 151, 495, 298, 463, 344,
     c -70,  66, 214, 449, 138, 211, 486, 156, 501, 302, 467, 350,
     c -69,  76, 209, 455, 144, 206, 489, 161, 504, 301, 469, 352,
     c -67,  82, 203, 460, 147, 204, 489, 165, 507, 301, 473, 354,
     c -66,  85, 195, 461, 142, 197, 488, 165, 508, 300, 476, 355,
     c -68,  84, 185, 462, 140, 192, 486, 161, 509, 286, 478, 355,
     c -71,  79, 178, 462, 138, 199, 485, 160, 509, 278, 478, 353,
     c -70,  74, 177, 462, 136, 197, 483, 156, 508, 284, 478, 351,
     c -72,  72, 177, 458, 135, 189, 479, 151, 505, 295, 475, 347,
     c -81,  73, 174, 451, 132, 183, 474, 144, 501, 296, 472, 343,
     c -88,  77, 174, 448, 130, 173, 469, 142, 497, 297, 468, 338,
     c -91,  82, 173, 446, 128, 172, 466, 138, 493, 301, 463, 335,
     c -92,  84, 172, 441, 128, 177, 464, 134, 490, 305, 457, 332,
     c -96,  83, 174, 435, 127, 180, 463, 133, 487, 311, 450, 332,
     c -99,  81, 177, 436, 129, 197, 459, 133, 487, 317, 445, 331,
     c -98,  78, 180, 438, 132, 207, 458, 136, 486, 316, 442, 332,
     c -94,  76, 183, 438, 135, 213, 459, 136, 487, 308, 440, 335,
     c -90,  74, 190, 441, 141, 222, 460, 139, 489, 301, 442, 337,
     c -91,  70, 196, 447, 145, 227, 461, 142, 493, 288, 448, 341,
     c -97,  66, 197, 453, 146, 240, 461, 144, 497, 280, 454, 346,
     c -98,  63, 197, 457, 150, 243, 464, 145, 503, 287, 460, 353,
     c -95,  60, 194, 461, 157, 244, 467, 151, 508, 304, 466, 359,
     c -92,  64, 197, 468, 166, 244, 470, 155, 511, 312, 469, 364,
     c -87,  68, 201, 474, 172, 248, 475, 161, 513, 314, 470, 367,
     c -43,  68, 216, 492, 196, 276, 513, 188, 538, 290, 493, 371,
     c -56,  54, 202, 476, 172, 266, 498, 174, 529, 288, 487, 358,
     c -67,  39, 190, 461, 149, 251, 485, 161, 518, 287, 479, 347,
     c -78,  28, 179, 450, 131, 255, 470, 147, 505, 287, 468, 338,
     c -84,  21, 177, 443, 123, 239, 462, 138, 491, 282, 458, 329,
     c -93,  16, 175, 434, 113, 211, 457, 130, 481, 275, 453, 323,
     c -97,  13, 175, 428, 108, 202, 455, 125, 475, 273, 449, 320,
     c -95,  16, 181, 428, 109, 194, 458, 124, 475, 272, 447, 322,
     c -88,  24, 191, 429, 115, 195, 462, 128, 479, 270, 449, 325,
     c -84,  33, 197, 432, 118, 204, 466, 134, 484, 270, 452, 329,
     c -82,  44, 200, 440, 121, 209, 471, 137, 489, 269, 455, 334,
     c -81,  51, 196, 445, 125, 204, 471, 146, 494, 265, 460, 336,
     c -77,  59, 191, 452, 128, 201, 472, 149, 497, 269, 465, 337,
     c -75,  64, 184, 455, 125, 195, 474, 149, 497, 273, 468, 338,
     c -75,  66, 178, 458, 124, 194, 474, 148, 500, 261, 470, 339,
     c -74,  63, 173, 458, 125, 201, 473, 147, 501, 253, 470, 338,
     c -72,  59, 172, 457, 126, 195, 473, 141, 501, 253, 468, 337,
     c -76,  56, 170, 450, 124, 186, 469, 139, 499, 256, 466, 333,
     c -85,  57, 167, 441, 121, 183, 465, 132, 495, 257, 463, 331,
     c -91,  62, 169, 439, 121, 171, 460, 130, 492, 266, 458, 327,
     c -92,  68, 171, 438, 122, 177, 458, 129, 488, 280, 454, 325,
     c -92,  73, 175, 436, 123, 183, 456, 128, 487, 294, 449, 324,
     c -98,  74, 177, 431, 121, 188, 454, 128, 484, 312, 443, 324,
     c-104,  71, 177, 433, 121, 202, 451, 128, 482, 321, 438, 323,
     c-105,  68, 177, 435, 125, 205, 449, 128, 481, 313, 433, 324,
     c-102,  65, 177, 435, 129, 211, 449, 127, 482, 291, 432, 326,
     c -98,  61, 178, 437, 133, 213, 451, 127, 484, 275, 433, 328,
     c -99,  55, 181, 441, 134, 215, 451, 128, 488, 258, 437, 331,
     c-104,  48, 180, 445, 135, 227, 450, 129, 494, 249, 443, 335,
     c-106,  44, 179, 447, 139, 232, 452, 131, 499, 256, 449, 341,
     c-106,  40, 175, 449, 145, 228, 453, 136, 505, 276, 456, 346,
     c-100,  45, 178, 457, 153, 234, 459, 141, 508, 285, 459, 351,
     c -94,  50, 182, 463, 159, 236, 464, 146, 509, 286, 460, 354,
     c -58,  38, 205, 483, 176, 260, 502, 169, 530, 240, 489, 361,
     c -68,  27, 192, 468, 155, 250, 488, 157, 521, 246, 481, 347,
     c -77,  17, 181, 454, 136, 235, 475, 143, 509, 250, 472, 336,
     c -87,  10, 171, 441, 118, 231, 460, 131, 497, 255, 461, 327,
     c -93,   8, 165, 435, 110, 215, 452, 122, 484, 252, 452, 318,
     c-103,   6, 162, 426, 103, 199, 445, 112, 472, 248, 446, 313,
     c-107,   3, 160, 420, 100, 190, 444, 108, 467, 247, 442, 310,
     c-104,   2, 165, 418, 101, 184, 445, 105, 466, 243, 438, 310,
     c -99,   6, 173, 420, 104, 190, 450, 110, 469, 239, 441, 313,
     c -94,  13, 182, 425, 108, 201, 453, 115, 475, 242, 444, 318,
     c -91,  19, 185, 433, 110, 207, 455, 120, 481, 243, 448, 320,
     c -92,  26, 182, 439, 111, 203, 455, 125, 485, 242, 453, 322,
     c -88,  33, 178, 443, 110, 203, 456, 128, 488, 253, 457, 322,
     c -85,  39, 175, 447, 108, 197, 460, 129, 489, 258, 460, 323,
     c -85,  41, 172, 448, 108, 194, 460, 129, 490, 243, 461, 323,
     c -82,  40, 171, 450, 112, 206, 461, 128, 491, 228, 461, 323,
     c -79,  35, 170, 448, 114, 200, 460, 125, 492, 226, 457, 322,
     c -83,  31, 165, 440, 111, 196, 457, 122, 490, 222, 454, 319,
     c -93,  30, 161, 430, 108, 191, 453, 118, 487, 218, 450, 317,
     c -98,  33, 163, 429, 110, 181, 449, 115, 484, 230, 447, 315,
     c -99,  38, 166, 426, 109, 182, 447, 116, 482, 254, 443, 314,
     c -99,  45, 169, 428, 112, 184, 446, 118, 479, 280, 439, 313,
     c-103,  47, 171, 426, 114, 194, 444, 117, 477, 307, 435, 314,
     c-110,  45, 169, 427, 114, 204, 439, 116, 476, 319, 429, 313,
     c-116,  41, 165, 429, 115, 202, 437, 113, 475, 304, 426, 314,
     c-116,  38, 160, 430, 117, 210, 435, 112, 476, 273, 423, 315,
     c-112,  34, 159, 431, 119, 205, 436, 113, 478, 248, 424, 316,
     c-110,  29, 161, 434, 122, 203, 437, 116, 482, 227, 427, 318,
     c-113,  24, 161, 438, 125, 217, 437, 117, 487, 218, 431, 321,
     c-116,  20, 159, 439, 128, 220, 437, 118, 494, 229, 438, 326,
     c-115,  20, 156, 442, 131, 220, 441, 124, 498, 251, 444, 330,
     c-109,  25, 162, 449, 140, 227, 447, 129, 501, 259, 446, 334,
     c-101,  32, 168, 456, 145, 232, 453, 134, 503, 259, 447, 337,
     c -64,  25, 201, 478, 162, 242, 497, 156, 525, 199, 486, 352,
     c -74,  17, 189, 463, 141, 236, 482, 142, 514, 217, 476, 339,
     c -83,  10, 179, 450, 124, 221, 468, 128, 503, 227, 467, 328,
     c -90,   7, 169, 439, 109, 218, 454, 116, 490, 234, 456, 318,
     c -95,   7, 163, 432, 101, 206, 446, 107, 478, 229, 447, 310,
     c-104,   5, 156, 424,  97, 197, 440, 100, 467, 221, 441, 304,
     c-109,   0, 149, 417,  94, 190, 437,  95, 462, 213, 435, 302,
     c-107,  -4, 150, 413,  93, 185, 437,  95, 462, 202, 434, 302,
     c-104,  -4, 157, 417,  94, 191, 440, 102, 465, 197, 436, 304,
     c-101,   0, 165, 424,  97, 200, 442, 105, 470, 207, 440, 308,
     c-101,   3, 167, 429,  96, 202, 443, 107, 475, 216, 443, 310,
     c -99,   6, 167, 432,  94, 200, 443, 107, 479, 220, 448, 311,
     c -98,   9, 166, 435,  94, 197, 443, 111, 481, 229, 451, 310,
     c -95,  12, 164, 436,  92, 193, 445, 111, 482, 231, 453, 310,
     c -93,  14, 165, 437,  95, 191, 448, 111, 482, 212, 452, 310,
     c -90,  12, 166, 437, 101, 195, 450, 112, 482, 198, 450, 310,
     c -89,   8, 166, 436, 105, 195, 449, 111, 481, 194, 446, 308,
     c -94,   1, 161, 430, 102, 193, 446, 110, 480, 191, 441, 307,
     c-103,  -1, 156, 423, 101, 194, 442, 106, 476, 188, 438, 305,
     c-109,   0, 158, 421, 101, 186, 437, 105, 474, 205, 436, 303,
     c-111,   4, 159, 420, 101, 188, 436, 106, 472, 234, 434, 303,
     c-110,   9, 158, 420, 103, 187, 435, 104, 472, 266, 431, 302,
     c-114,  12, 156, 419, 105, 191, 432, 105, 470, 297, 428, 303,
     c-118,  12, 152, 421, 106, 193, 427, 101, 469, 312, 423, 302,
     c-126,   8, 145, 421, 104, 189, 424,  95, 468, 294, 419, 302,
     c-128,   5, 139, 424, 103, 194, 423,  92, 468, 257, 416, 302,
     c-126,   1, 137, 425, 104, 186, 423,  94, 470, 227, 415, 302,
     c-125,  -1, 139, 428, 107, 188, 423,  97, 474, 207, 417, 302,
     c-126,  -5, 140, 429, 110, 201, 423,  99, 479, 200, 420, 304,
     c-126,  -5, 142, 429, 114, 203, 425, 101, 484, 216, 426, 308,
     c-124,  -4, 143, 431, 119, 208, 429, 109, 490, 240, 430, 311,
     c-116,   2, 151, 439, 126, 219, 435, 115, 493, 248, 433, 315,
     c-109,   9, 158, 447, 131, 225, 442, 120, 494, 244, 434, 318,
     c -58,  33, 206, 476, 148, 247, 494, 154, 519, 188, 484, 343,
     c -69,  26, 195, 461, 131, 235, 479, 139, 508, 218, 473, 331,
     c -79,  20, 185, 448, 115, 218, 466, 125, 498, 235, 463, 320,
     c -87,  16, 172, 436, 100, 212, 452, 110, 486, 239, 454, 311,
     c -92,  17, 162, 428,  94, 196, 443, 103, 473, 228, 445, 302,
     c -98,  13, 153, 422,  90, 189, 438,  95, 464, 211, 439, 297,
     c-103,   7, 145, 418,  88, 189, 435,  90, 459, 188, 434, 295,
     c-105,   1, 142, 414,  86, 182, 434,  90, 460, 163, 434, 296,
     c-104,   0, 147, 416,  85, 188, 436,  94, 463, 156, 437, 298,
     c-103,   0, 152, 421,  85, 193, 438,  98, 468, 172, 440, 301,
     c-103,   1, 156, 427,  84, 192, 437,  99, 472, 187, 443, 302,
     c-103,   1, 159, 429,  85, 193, 436,  98, 474, 193, 445, 302,
     c-103,   0, 159, 429,  84, 188, 436,  97, 475, 196, 448, 299,
     c-103,  -3, 158, 428,  81, 184, 436,  97, 475, 191, 449, 298,
     c-102,  -4, 158, 427,  86, 181, 438,  95, 473, 171, 447, 297,
     c -99,  -8, 160, 426,  93, 189, 440,  95, 472, 161, 442, 297,
     c-100, -15, 161, 425,  96, 189, 438,  94, 471, 165, 438, 296,
     c-105, -22, 158, 421,  94, 188, 436,  94, 469, 168, 432, 295,
     c-114, -27, 154, 418,  92, 195, 431,  94, 467, 169, 429, 294,
     c-120, -27, 153, 418,  92, 187, 428,  92, 466, 189, 428, 293,
     c-121, -23, 152, 417,  93, 187, 426,  93, 465, 215, 427, 292,
     c-120, -16, 148, 418,  94, 187, 426,  91, 464, 243, 426, 292,
     c-122, -12, 144, 416,  96, 182, 423,  89, 463, 275, 423, 292,
     c-127, -13, 137, 417,  97, 185, 417,  85, 462, 290, 420, 290,
     c-133, -17, 130, 416,  95, 180, 414,  81, 462, 274, 415, 289,
     c-138, -21, 123, 414,  92, 181, 412,  79, 462, 239, 411, 288,
     c-139, -25, 122, 417,  91, 177, 412,  79, 463, 212, 409, 287,
     c-138, -29, 124, 418,  93, 177, 412,  82, 465, 194, 411, 286,
     c-138, -32, 125, 418,  95, 187, 412,  82, 469, 193, 413, 287,
     c-138, -31, 129, 416,  98, 185, 414,  84, 475, 212, 416, 290,
     c-134, -27, 137, 419, 102, 194, 419,  90, 479, 238, 420, 294,
     c-126, -20, 145, 426, 108, 203, 425,  99, 482, 244, 422, 297,
     c-120, -12, 154, 435, 113, 209, 432, 107, 484, 237, 423, 300,
     c -53,  50, 213, 475, 140, 250, 490, 147, 514, 197, 489, 338,
     c -63,  43, 201, 459, 124, 233, 477, 133, 503, 237, 477, 326,
     c -74,  37, 190, 446, 109, 217, 465, 117, 492, 259, 466, 315,
     c -83,  34, 177, 435,  94, 206, 451, 104, 481, 262, 456, 305,
     c -87,  32, 166, 426,  88, 192, 442, 101, 471, 248, 450, 297,
     c -93,  28, 156, 418,  83, 185, 437,  99, 463, 222, 443, 291,
     c-100,  20, 148, 414,  80, 186, 433,  94, 460, 186, 440, 289,
     c-104,  14, 146, 414,  76, 182, 430,  93, 461, 152, 440, 289,
     c-104,  12, 147, 415,  75, 188, 429,  92, 464, 141, 442, 291,
     c-102,  13, 151, 418,  75, 184, 433,  94, 467, 160, 443, 293,
     c-102,  15, 157, 424,  80, 185, 433,  92, 470, 179, 444, 294,
     c-102,  11, 161, 424,  82, 187, 433,  91, 472, 184, 445, 293,
     c-104,   5, 161, 423,  79, 178, 431,  87, 472, 180, 447, 291,
     c-105,   0, 158, 420,  75, 176, 432,  86, 470, 168, 446, 288,
     c-106,  -7, 156, 418,  78, 171, 432,  83, 468, 149, 443, 287,
     c-106, -16, 157, 417,  83, 178, 431,  84, 465, 145, 438, 287,
     c-109, -26, 156, 414,  83, 174, 429,  80, 463, 156, 431, 286,
     c-116, -37, 154, 411,  81, 171, 426,  80, 461, 166, 427, 285,
     c-120, -43, 150, 411,  81, 185, 423,  81, 460, 167, 424, 284,
     c-124, -44, 149, 413,  82, 182, 420,  79, 458, 179, 423, 283,
     c-125, -40, 147, 414,  83, 183, 419,  80, 458, 194, 424, 283,
     c-125, -33, 143, 416,  86, 187, 417,  78, 458, 209, 424, 282,
     c-125, -28, 139, 415,  88, 185, 415,  74, 457, 232, 422, 282,
     c-131, -28, 132, 414,  89, 185, 410,  72, 456, 244, 419, 279,
     c-138, -32, 124, 411,  86, 181, 405,  68, 454, 233, 414, 277,
     c-143, -38, 117, 406,  85, 177, 403,  64, 454, 206, 410, 274,
     c-144, -42, 116, 407,  85, 170, 405,  65, 454, 188, 407, 272,
     c-146, -46, 117, 407,  83, 167, 404,  66, 455, 177, 407, 271,
     c-146, -50, 119, 403,  81, 168, 402,  68, 459, 182, 408, 271,
     c-145, -51, 122, 401,  83, 165, 405,  69, 463, 205, 410, 274,
     c-144, -48, 130, 406,  85, 176, 409,  74, 467, 233, 413, 277,
     c-137, -40, 139, 412,  90, 183, 415,  80, 470, 238, 415, 279,
     c-130, -32, 149, 419,  95, 190, 421,  87, 472, 228, 416, 282,
     c -51,  66, 218, 467, 129, 231, 486, 142, 510, 206, 494, 334,
     c -63,  59, 207, 455, 116, 214, 474, 126, 499, 252, 482, 322,
     c -75,  52, 195, 442, 103, 203, 462, 112, 489, 277, 470, 311,
     c -85,  46, 180, 429,  89, 192, 448,  99, 478, 280, 461, 301,
     c -88,  44, 174, 420,  83, 183, 439,  98, 468, 266, 455, 293,
     c -93,  39, 164, 411,  77, 180, 433,  93, 462, 239, 449, 285,
     c-101,  33, 157, 407,  72, 177, 428,  90, 461, 201, 445, 282,
     c-106,  28, 156, 409,  68, 172, 425,  88, 461, 165, 445, 282,
     c-104,  28, 158, 412,  67, 175, 425,  85, 464, 155, 446, 283,
     c-101,  30, 160, 415,  71, 173, 429,  84, 467, 178, 445, 285,
     c-101,  30, 163, 418,  76, 176, 430,  82, 468, 200, 443, 285,
     c-102,  27, 166, 417,  77, 179, 431,  82, 468, 203, 444, 284,
     c-102,  20, 167, 414,  75, 170, 430,  79, 467, 195, 445, 283,
     c-103,  11, 162, 412,  71, 172, 429,  76, 465, 180, 443, 281,
     c-106,   2, 159, 412,  73, 166, 429,  75, 462, 158, 441, 280,
     c-109,  -8, 156, 412,  74, 169, 426,  73, 458, 154, 435, 278,
     c-114, -23, 154, 408,  73, 163, 423,  73, 457, 168, 428, 277,
     c-119, -35, 151, 405,  71, 160, 419,  70, 454, 175, 423, 277,
     c-123, -45, 145, 405,  72, 174, 417,  70, 453, 170, 420, 275,
     c-126, -48, 142, 406,  75, 174, 413,  68, 453, 173, 420, 274,
     c-127, -45, 142, 408,  76, 174, 413,  68, 453, 177, 421, 273,
     c-127, -40, 140, 411,  79, 184, 410,  65, 453, 180, 421, 273,
     c-127, -35, 137, 412,  81, 180, 407,  63, 453, 188, 420, 271,
     c-135, -37, 129, 407,  79, 173, 402,  62, 451, 194, 416, 267,
     c-141, -41, 122, 402,  77, 167, 398,  60, 449, 186, 412, 264,
     c-144, -45, 117, 400,  73, 159, 397,  57, 447, 170, 408, 260,
     c-146, -49, 116, 397,  72, 160, 396,  56, 446, 160, 406, 257,
     c-148, -53, 116, 395,  70, 153, 397,  56, 446, 157, 404, 255,
     c-149, -56, 118, 392,  68, 151, 396,  58, 448, 168, 404, 255,
     c-149, -57, 120, 391,  67, 152, 397,  58, 452, 192, 405, 258,
     c-150, -57, 125, 394,  67, 158, 400,  60, 455, 218, 406, 261,
     c-143, -49, 135, 398,  71, 160, 406,  65, 458, 223, 408, 263,
     c-136, -42, 145, 405,  76, 166, 413,  72, 460, 214, 408, 265,
     c -52,  76, 223, 463, 123, 225, 483, 131, 506, 201, 496, 330,
     c -65,  66, 210, 451, 110, 213, 472, 117, 495, 249, 483, 318,
     c -77,  58, 198, 438,  97, 199, 461, 102, 484, 274, 472, 307,
     c -88,  52, 185, 426,  85, 188, 446,  91, 474, 276, 463, 296,
     c -91,  48, 179, 418,  79, 178, 437,  86, 467, 266, 455, 287,
     c -95,  44, 172, 412,  73, 178, 430,  84, 461, 241, 450, 279,
     c-103,  39, 166, 406,  67, 174, 424,  79, 460, 206, 445, 275,
     c-109,  36, 166, 404,  61, 162, 420,  79, 461, 174, 443, 273,
     c-109,  37, 166, 407,  60, 166, 421,  76, 463, 171, 443, 273,
     c-106,  38, 165, 414,  66, 170, 424,  75, 463, 195, 441, 274,
     c-103,  38, 167, 416,  70, 171, 427,  71, 464, 218, 438, 275,
     c-103,  34, 169, 414,  69, 171, 427,  69, 463, 222, 438, 275,
     c-101,  29, 167, 410,  68, 164, 428,  68, 462, 208, 438, 274,
     c-101,  23, 163, 409,  67, 164, 427,  67, 460, 188, 438, 273,
     c-104,  16, 161, 412,  70, 166, 426,  70, 457, 167, 436, 272,
     c-109,   5, 158, 411,  70, 167, 422,  69, 454, 160, 431, 271,
     c-113,  -7, 154, 407,  68, 159, 419,  68, 451, 167, 426, 270,
     c-119, -21, 148, 402,  65, 156, 415,  64, 449, 172, 421, 270,
     c-124, -32, 140, 400,  65, 161, 411,  64, 449, 167, 419, 268,
     c-126, -36, 137, 403,  68, 166, 408,  59, 448, 169, 419, 266,
     c-128, -37, 136, 404,  69, 166, 407,  57, 450, 169, 419, 264,
     c-129, -35, 135, 404,  68, 171, 403,  52, 451, 165, 418, 263,
     c-133, -35, 130, 401,  67, 163, 398,  48, 449, 164, 416, 260,
     c-140, -37, 123, 397,  67, 159, 392,  45, 447, 163, 412, 255,
     c-147, -42, 116, 392,  63, 153, 388,  41, 443, 154, 408, 251,
     c-152, -46, 110, 387,  55, 138, 384,  40, 441, 142, 405, 246,
     c-153, -47, 110, 383,  51, 137, 385,  40, 438, 135, 402, 242,
     c-154, -47, 113, 382,  51, 133, 385,  41, 437, 137, 400, 240,
     c-155, -46, 116, 382,  50, 136, 385,  45, 439, 149, 399, 240,
     c-157, -47, 119, 383,  50, 138, 387,  47, 441, 172, 400, 243,
     c-159, -48, 122, 382,  48, 140, 391,  50, 444, 195, 400, 246,
     c-153, -41, 131, 387,  51, 140, 396,  55, 446, 199, 401, 247,
     c-149, -35, 139, 391,  55, 141, 401,  61, 447, 189, 401, 249,
     c -52,  82, 224, 461, 119, 213, 481, 124, 502, 193, 494, 325,
     c -65,  72, 212, 449, 105, 202, 469, 110, 491, 235, 482, 314,
     c -77,  62, 198, 437,  91, 188, 459,  94, 481, 258, 471, 302,
     c -88,  53, 184, 426,  81, 182, 446,  80, 473, 259, 461, 291,
     c -93,  48, 175, 418,  75, 175, 436,  72, 465, 248, 453, 281,
     c -98,  43, 170, 413,  68, 171, 428,  66, 461, 226, 446, 272,
     c-105,  40, 166, 409,  63, 170, 421,  64, 460, 195, 439, 267,
     c-112,  38, 163, 402,  54, 159, 417,  63, 461, 172, 436, 264,
     c-113,  38, 163, 403,  53, 163, 416,  62, 461, 172, 435, 263,
     c-110,  37, 164, 408,  56, 166, 419,  62, 460, 196, 433, 264,
     c-106,  36, 166, 413,  60, 173, 421,  61, 458, 216, 430, 265,
     c-106,  33, 164, 409,  60, 167, 422,  59, 458, 220, 429, 265,
     c-105,  30, 161, 405,  60, 163, 424,  59, 456, 203, 431, 265,
     c-104,  29, 158, 405,  64, 161, 425,  60, 455, 178, 432, 265,
     c-104,  26, 157, 410,  68, 162, 425,  63, 452, 155, 431, 265,
     c-108,  21, 157, 411,  69, 162, 421,  61, 450, 146, 429, 266,
     c-114,  10, 151, 405,  64, 150, 416,  59, 448, 150, 426, 265,
     c-118,  -2, 144, 400,  61, 149, 412,  58, 446, 154, 422, 265,
     c-122, -12, 138, 400,  60, 153, 408,  55, 446, 151, 419, 263,
     c-126, -18, 134, 402,  62, 162, 404,  52, 447, 154, 418, 259,
     c-130, -22, 132, 401,  61, 162, 401,  46, 448, 156, 416, 256,
     c-134, -25, 130, 396,  58, 162, 395,  43, 448, 154, 413, 254,
     c-139, -26, 125, 392,  57, 154, 388,  39, 446, 149, 409, 249,
     c-148, -30, 116, 387,  52, 146, 382,  33, 442, 144, 406, 244,
     c-156, -34, 108, 380,  45, 137, 377,  30, 439, 135, 401, 238,
     c-159, -35, 105, 376,  38, 132, 373,  28, 435, 123, 398, 233,
     c-160, -33, 107, 373,  33, 129, 372,  27, 432, 119, 395, 229,
     c-163, -30, 110, 374,  31, 120, 372,  29, 431, 121, 393, 227,
     c-163, -28, 113, 375,  31, 118, 372,  29, 430, 131, 392, 226,
     c-165, -26, 117, 377,  32, 119, 374,  33, 432, 148, 391, 228,
     c-168, -28, 120, 379,  30, 120, 377,  36, 433, 165, 392, 231,
     c-165, -23, 126, 381,  33, 120, 381,  40, 435, 167, 391, 231,
     c-160, -17, 134, 384,  39, 120, 385,  43, 435, 157, 391, 232,
     c -52,  88, 224, 456, 112, 209, 480, 120, 499, 172, 491, 321,
     c -63,  77, 209, 446, 100, 198, 470, 107, 487, 206, 480, 309,
     c -75,  66, 196, 436,  89, 185, 460,  91, 478, 225, 469, 298,
     c -87,  55, 182, 427,  79, 178, 447,  75, 472, 224, 460, 287,
     c -92,  46, 171, 419,  70, 167, 435,  65, 465, 215, 450, 276,
     c -99,  41, 165, 412,  63, 162, 426,  58, 462, 197, 442, 267,
     c-108,  35, 161, 409,  58, 161, 419,  53, 459, 175, 434, 260,
     c-115,  31, 158, 402,  51, 155, 415,  47, 458, 161, 430, 257,
     c-116,  29, 158, 400,  48, 153, 412,  47, 457, 165, 428, 255,
     c-113,  27, 159, 402,  50, 156, 414,  49, 455, 186, 426, 255,
     c-111,  26, 159, 404,  51, 162, 416,  50, 454, 203, 424, 257,
     c-109,  25, 157, 404,  53, 159, 418,  49, 453, 204, 423, 257,
     c-110,  26, 154, 400,  55, 157, 420,  50, 453, 184, 424, 258,
     c-110,  29, 152, 399,  60, 154, 422,  55, 453, 156, 426, 259,
     c-109,  30, 151, 404,  66, 156, 423,  58, 451, 133, 427, 261,
     c-109,  28, 151, 405,  66, 159, 421,  55, 449, 124, 426, 262,
     c-113,  21, 147, 400,  60, 150, 415,  51, 447, 126, 425, 261,
     c-116,  12, 141, 396,  56, 148, 412,  48, 446, 129, 422, 261,
     c-121,   3, 134, 397,  55, 149, 406,  43, 446, 128, 420, 258,
     c-128,  -4, 130, 397,  54, 154, 401,  39, 446, 132, 415, 253,
     c-135,  -8, 129, 394,  52, 153, 395,  34, 447, 135, 411, 248,
     c-140, -12, 127, 390,  49, 150, 389,  29, 446, 137, 407, 244,
     c-146, -15, 121, 385,  45, 144, 382,  26, 443, 133, 402, 239,
     c-155, -17, 114, 378,  37, 134, 375,  22, 439, 131, 397, 234,
     c-163, -20, 107, 374,  28, 127, 370,  19, 434, 122, 392, 227,
     c-165, -20, 105, 371,  22, 119, 366,  19, 430, 112, 389, 221,
     c-166, -17, 107, 370,  17, 114, 363,  16, 427, 108, 386, 217,
     c-168, -13, 109, 370,  15, 110, 360,  17, 424, 109, 383, 214,
     c-171,  -9, 111, 369,  13, 106, 358,  14, 423, 117, 381, 214,
     c-173,  -8, 112, 372,  12, 100, 359,  17, 422, 128, 379, 214,
     c-177,  -9, 113, 373,  12, 100, 361,  20, 423, 139, 379, 216,
     c-175,  -5, 118, 375,  17, 100, 363,  21, 422, 138, 377, 215,
     c-173,  -1, 123, 377,  22, 100, 367,  24, 422, 130, 375, 214,
     c -50,  92, 226, 454, 106, 203, 478, 114, 496, 144, 489, 315,
     c -61,  80, 212, 446,  96, 199, 470, 100, 486, 170, 480, 304,
     c -72,  68, 198, 437,  89, 186, 459,  84, 478, 183, 470, 294,
     c -83,  55, 181, 427,  76, 172, 445,  68, 471, 182, 459, 283,
     c -90,  45, 169, 423,  68, 168, 435,  57, 466, 176, 448, 272,
     c-100,  35, 161, 416,  60, 161, 424,  45, 461, 164, 438, 263,
     c-109,  27, 153, 409,  54, 157, 417,  37, 459, 152, 430, 256,
     c-116,  21, 151, 402,  48, 152, 412,  32, 457, 145, 427, 252,
     c-117,  17, 150, 399,  47, 147, 409,  30, 455, 150, 426, 250,
     c-115,  14, 150, 401,  48, 151, 410,  34, 452, 166, 424, 250,
     c-113,  12, 150, 401,  47, 150, 411,  41, 451, 179, 421, 251,
     c-113,  13, 148, 399,  45, 145, 414,  40, 451, 176, 420, 252,
     c-113,  16, 149, 398,  49, 151, 416,  44, 451, 156, 421, 254,
     c-114,  21, 151, 400,  56, 150, 418,  48, 451, 132, 422, 256,
     c-109,  26, 153, 405,  62, 155, 421,  51, 451, 113, 424, 258,
     c-107,  27, 151, 405,  61, 156, 420,  52, 451, 106, 424, 259,
     c-109,  25, 147, 401,  57, 149, 417,  47, 449, 109, 424, 259,
     c-110,  20, 143, 397,  54, 147, 412,  43, 447, 112, 422, 258,
     c-116,  14, 135, 396,  53, 147, 404,  37, 447, 111, 418, 254,
     c-126,   9, 129, 394,  50, 145, 399,  33, 448, 114, 414, 248,
     c-137,   5, 127, 392,  45, 149, 392,  29, 447, 119, 408, 243,
     c-143,   2, 124, 387,  42, 142, 386,  24, 445, 126, 401, 237,
     c-149,   0, 117, 380,  35, 132, 380,  23, 441, 127, 396, 231,
     c-157,  -1, 111, 373,  26, 122, 374,  18, 436, 130, 389, 225,
     c-165,  -2, 107, 370,  17, 110, 369,  15, 431, 122, 385, 218,
     c-168,  -4, 107, 370,  10, 109, 363,  12, 427, 114, 382, 212,
     c-170,  -3, 106, 368,   4, 103, 359,  10, 423, 107, 379, 207,
     c-172,   0, 105, 365,   2,  97, 353,   5, 419, 106, 374, 203,
     c-175,   1, 104, 365,   0,  91, 348,   0, 415, 109, 370, 202,
     c-179,   2, 103, 366,  -1,  85, 346,   0, 413, 115, 367, 200,
     c-185,   1, 100, 363,  -3,  81, 346,   2, 411, 120, 364, 200,
     c-185,   4, 102, 365,   0,  77, 347,   0, 410, 117, 362, 197,
     c-183,   8, 106, 366,   5,  77, 349,   1, 409, 109, 359, 195,
     c -51,  91, 223, 456, 102, 204, 477, 106, 496, 127, 488, 309,
     c -61,  78, 210, 447,  94, 196, 467,  90, 487, 144, 481, 299,
     c -70,  66, 197, 439,  88, 187, 457,  78, 480, 152, 472, 289,
     c -80,  51, 180, 431,  76, 170, 443,  65, 474, 149, 460, 279,
     c -87,  39, 167, 427,  69, 170, 435,  53, 468, 146, 450, 269,
     c -97,  29, 159, 422,  63, 165, 426,  42, 463, 138, 439, 261,
     c-106,  18, 149, 416,  56, 157, 419,  34, 459, 131, 432, 254,
     c-113,  10, 143, 409,  49, 152, 413,  29, 456, 127, 430, 250,
     c-114,   5, 142, 405,  49, 147, 410,  28, 453, 131, 430, 248,
     c-112,   2, 143, 406,  50, 152, 411,  31, 451, 140, 428, 247,
     c-112,   1, 143, 404,  49, 155, 411,  33, 450, 148, 425, 249,
     c-114,   1, 141, 401,  45, 149, 412,  35, 450, 145, 423, 249,
     c-114,   6, 146, 401,  48, 153, 413,  38, 452, 129, 421, 251,
     c-112,  12, 153, 406,  56, 155, 415,  41, 452, 111, 421, 254,
     c-109,  17, 156, 409,  59, 157, 418,  45, 452,  99, 421, 256,
     c-104,  21, 153, 408,  58, 158, 419,  45, 451,  96, 423, 257,
     c-104,  23, 149, 403,  55, 145, 415,  42, 450, 103, 424, 257,
     c-108,  23, 143, 399,  51, 143, 410,  39, 450, 106, 422, 256,
     c-114,  22, 135, 398,  48, 149, 404,  34, 450, 105, 419, 252,
     c-125,  20, 129, 395,  45, 146, 399,  27, 448, 106, 414, 246,
     c-136,  19, 125, 391,  40, 145, 393,  26, 448, 112, 407, 239,
     c-142,  19, 119, 384,  33, 137, 386,  22, 444, 120, 400, 232,
     c-147,  17, 112, 376,  25, 121, 382,  18, 439, 127, 393, 225,
     c-154,  16, 109, 371,  19, 115, 376,  16, 434, 133, 388, 220,
     c-161,  13, 107, 368,  12, 111, 370,   8, 428, 128, 384, 212,
     c-167,  10, 105, 367,   4, 105, 363,   7, 423, 119, 379, 206,
     c-172,   7, 101, 363,  -2,  95, 357,  -1, 419, 109, 374, 200,
     c-176,   5,  98, 360,  -5,  89, 348,  -6, 413, 103, 369, 195,
     c-179,   4,  96, 357,  -8,  77, 341, -13, 407, 101, 363, 191,
     c-183,   4,  92, 354, -11,  71, 337, -17, 403, 103, 357, 187,
     c-192,   1,  87, 347, -15,  67, 333, -15, 400, 103, 353, 184,
     c-192,   3,  86, 348, -11,  63, 333, -20, 397,  98, 350, 180,
     c-193,   5,  87, 349,  -8,  64, 332, -18, 394,  88, 347, 177,
     c -53,  83, 213, 462, 102, 208, 475,  94, 498, 130, 488, 306,
     c -61,  71, 203, 453,  95, 199, 466,  80, 490, 139, 482, 296,
     c -69,  59, 192, 444,  87, 190, 455,  71, 483, 142, 474, 287,
     c -78,  44, 178, 437,  79, 177, 444,  58, 477, 138, 463, 278,
     c -82,  33, 166, 430,  70, 170, 437,  47, 472, 133, 452, 269,
     c -89,  22, 157, 427,  63, 165, 430,  39, 466, 126, 444, 261,
     c -97,  13, 150, 424,  59, 163, 424,  32, 461, 121, 438, 256,
     c-103,   5, 142, 416,  52, 158, 419,  30, 458, 117, 436, 251,
     c-106,   0, 140, 411,  49, 150, 415,  28, 455, 116, 436, 249,
     c-106,  -1, 141, 409,  52, 155, 415,  31, 452, 118, 435, 249,
     c-108,  -2, 139, 407,  52, 154, 415,  33, 451, 121, 432, 249,
     c-109,   0, 139, 406,  50, 152, 416,  34, 453, 120, 429, 249,
     c-112,   1, 144, 404,  49, 153, 413,  37, 454, 108, 425, 251,
     c-111,   5, 152, 407,  53, 155, 415,  37, 453,  96, 424, 253,
     c-106,  10, 156, 411,  57, 158, 416,  39, 453,  90, 424, 255,
     c-102,  14, 153, 410,  55, 155, 415,  39, 453,  92, 424, 256,
     c-103,  18, 149, 405,  52, 147, 413,  37, 452, 100, 426, 257,
     c-106,  22, 146, 404,  52, 145, 408,  34, 451, 102, 424, 254,
     c-112,  25, 140, 402,  47, 151, 404,  31, 450,  98, 421, 250,
     c-122,  28, 133, 398,  43, 146, 400,  28, 449,  95, 416, 243,
     c-130,  29, 127, 391,  38, 141, 395,  26, 447,  98, 410, 236,
     c-136,  29, 121, 385,  32, 135, 391,  23, 442, 106, 403, 229,
     c-139,  29, 113, 377,  23, 115, 386,  17, 438, 114, 396, 222,
     c-145,  28, 108, 371,  18, 110, 381,  15, 431, 122, 391, 217,
     c-152,  23, 106, 370,  11, 104, 374,   6, 426, 120, 386, 209,
     c-163,  17, 104, 366,   4,  92, 365,   0, 421, 112, 381, 203,
     c-171,  10,  99, 360,  -1,  85, 355, -10, 415, 101, 375, 196,
     c-177,   3,  93, 354,  -6,  72, 345, -19, 408,  93, 367, 189,
     c-181,  -1,  89, 350, -10,  64, 336, -27, 400,  90, 359, 183,
     c-185,  -5,  84, 343, -14,  61, 328, -33, 393,  91, 351, 175,
     c-194, -10,  76, 335, -19,  54, 322, -36, 388,  89, 345, 170,
     c-195, -10,  72, 331, -18,  48, 318, -39, 384,  82, 340, 164,
     c-196,  -9,  70, 330, -17,  47, 316, -39, 381,  69, 337, 160,
     c -52,  75, 201, 464,  99, 201, 476,  87, 502, 136, 490, 305,
     c -60,  64, 193, 455,  91, 193, 467,  75, 496, 140, 485, 296,
     c -69,  52, 184, 447,  82, 186, 457,  63, 489, 140, 478, 287,
     c -76,  39, 174, 438,  76, 176, 446,  55, 483, 134, 469, 279,
     c -76,  29, 166, 433,  69, 170, 440,  49, 477, 126, 459, 270,
     c -82,  21, 158, 428,  59, 164, 435,  46, 471, 120, 452, 264,
     c -90,  13, 152, 424,  54, 162, 430,  39, 466, 115, 446, 259,
     c -95,   8, 147, 420,  52, 157, 424,  36, 461, 111, 445, 254,
     c -97,   5, 144, 416,  49, 151, 422,  34, 458, 108, 445, 252,
     c -98,   4, 145, 411,  49, 152, 422,  35, 456, 109, 444, 251,
     c-101,   5, 144, 409,  52, 154, 422,  34, 455, 110, 441, 251,
     c-102,   5, 142, 411,  53, 156, 421,  35, 456, 105, 436, 252,
     c-106,   6, 146, 408,  51, 152, 418,  38, 457,  95, 433, 252,
     c-106,   8, 153, 409,  52, 152, 416,  36, 457,  86, 430, 253,
     c-103,   9, 155, 412,  53, 153, 415,  36, 456,  82, 429, 254,
     c-100,  12, 153, 412,  55, 150, 414,  33, 455,  86, 429, 255,
     c-103,  15, 150, 408,  51, 144, 413,  33, 453,  94, 429, 255,
     c-106,  20, 148, 407,  50, 143, 409,  31, 453,  94, 428, 252,
     c-109,  24, 144, 403,  46, 148, 406,  29, 452,  86, 426, 248,
     c-117,  27, 137, 396,  40, 139, 402,  28, 450,  79, 420, 241,
     c-126,  29, 131, 389,  32, 129, 398,  23, 447,  76, 414, 234,
     c-130,  30, 126, 386,  26, 124, 394,  21, 442,  82, 409, 227,
     c-132,  32, 118, 380,  20, 107, 389,  14, 437,  88, 403, 220,
     c-138,  29, 114, 374,  13, 103, 384,  12, 431,  96, 397, 215,
     c-148,  24, 110, 370,   7, 100, 376,   2, 425,  97, 392, 207,
     c-158,  16, 105, 366,   2,  83, 366,  -6, 419,  92, 387, 200,
     c-169,   6,  97, 359,  -2,  77, 353, -17, 412,  84, 379, 192,
     c-178,  -4,  87, 349,  -8,  63, 340, -29, 403,  78, 368, 183,
     c-184, -14,  80, 339, -13,  55, 330, -39, 392,  76, 357, 174,
     c-189, -21,  73, 331, -18,  50, 319, -48, 384,  80, 348, 164,
     c-198, -31,  61, 319, -25,  39, 311, -56, 377,  78, 338, 156,
     c-200, -33,  56, 314, -27,  32, 306, -62, 371,  69, 332, 149,
     c-202, -35,  51, 310, -28,  26, 300, -65, 367,  54, 327, 143,
     c -49,  70, 195, 461,  96, 202, 479,  89, 508, 142, 495, 305,
     c -57,  59, 187, 453,  86, 193, 470,  78, 501, 144, 490, 297,
     c -65,  49, 181, 447,  79, 186, 461,  65, 495, 141, 484, 289,
     c -70,  39, 176, 440,  72, 179, 451,  57, 490, 132, 476, 281,
     c -74,  33, 171, 434,  65, 172, 445,  52, 484, 122, 467, 275,
     c -78,  28, 166, 432,  59, 167, 441,  49, 477, 116, 461, 268,
     c -85,  25, 160, 427,  56, 163, 438,  43, 471, 112, 456, 263,
     c -88,  22, 154, 422,  51, 158, 433,  37, 466, 109, 455, 259,
     c -90,  21, 154, 419,  52, 158, 431,  35, 463, 106, 454, 257,
     c -90,  22, 155, 418,  53, 158, 431,  36, 460, 106, 452, 255,
     c -90,  22, 152, 415,  54, 158, 429,  38, 459, 103, 449, 254,
     c -91,  22, 150, 413,  53, 155, 427,  36, 460,  97, 444, 254,
     c -94,  20, 153, 413,  53, 153, 423,  38, 460,  86, 441, 253,
     c -95,  19, 158, 414,  54, 152, 420,  37, 459,  77, 438, 253,
     c -94,  18, 158, 414,  53, 149, 418,  36, 457,  76, 436, 253,
     c -94,  18, 155, 414,  53, 145, 417,  33, 456,  83, 435, 253,
     c -98,  20, 153, 411,  52, 141, 415,  32, 454,  90, 434, 252,
     c-101,  22, 148, 409,  49, 140, 413,  32, 454,  88, 434, 249,
     c-105,  26, 145, 402,  45, 140, 410,  28, 452,  77, 430, 245,
     c-112,  28, 140, 396,  37, 136, 405,  26, 450,  66, 426, 239,
     c-120,  29, 137, 391,  30, 125, 401,  21, 446,  63, 421, 232,
     c-126,  28, 131, 387,  23, 118, 396,  19, 442,  67, 416, 225,
     c-129,  27, 126, 385,  17, 106, 391,  14, 437,  72, 411, 219,
     c-133,  25, 124, 381,  10, 102, 384,   7, 431,  77, 405, 213,
     c-142,  18, 119, 375,   6,  99, 376,  -3, 426,  80, 399, 205,
     c-153,   9, 111, 367,   1,  85, 364, -16, 419,  75, 393, 197,
     c-165,  -1,  97, 356,  -5,  73, 352, -29, 410,  67, 383, 188,
     c-177, -14,  84, 342, -13,  56, 338, -40, 400,  62, 371, 176,
     c-186, -25,  73, 330, -18,  47, 325, -50, 388,  64, 358, 165,
     c-194, -37,  60, 316, -25,  37, 313, -59, 376,  69, 347, 153,
     c-205, -50,  44, 299, -36,  21, 302, -69, 368,  70, 336, 143,
     c-210, -56,  37, 294, -41,  19, 293, -75, 362,  60, 329, 136,
     c-214, -61,  29, 289, -46,   8, 288, -79, 358,  41, 323, 129,
     c -42,  72, 198, 464,  98, 202, 482,  89, 512, 147, 500, 307,
     c -48,  63, 193, 458,  90, 194, 476,  79, 507, 148, 494, 298,
     c -54,  54, 187, 453,  83, 188, 467,  67, 501, 144, 488, 290,
     c -61,  45, 182, 446,  75, 185, 458,  59, 495, 133, 482, 283,
     c -66,  42, 179, 439,  68, 176, 452,  54, 490, 121, 475, 277,
     c -71,  41, 173, 436,  64, 171, 448,  52, 483, 113, 469, 271,
     c -75,  39, 167, 434,  61, 169, 444,  47, 477, 109, 464, 267,
     c -77,  39, 163, 430,  60, 159, 441,  42, 471, 107, 462, 264,
     c -79,  39, 163, 424,  58, 158, 438,  41, 467, 104, 461, 260,
     c -79,  39, 163, 422,  59, 156, 437,  39, 465, 102, 458, 258,
     c -80,  39, 160, 419,  57, 159, 435,  39, 463,  99, 453, 256,
     c -83,  37, 155, 414,  53, 154, 431,  36, 462,  91, 449, 255,
     c -82,  36, 156, 413,  52, 149, 428,  38, 461,  81, 446, 253,
     c -84,  34, 159, 415,  53, 149, 425,  35, 460,  75, 443, 252,
     c -86,  32, 160, 416,  53, 145, 423,  33, 458,  80, 441, 251,
     c -87,  30, 158, 416,  51, 141, 419,  30, 455,  93, 440, 249,
     c -92,  28, 154, 414,  49, 141, 417,  31, 454, 102, 439, 248,
     c -95,  29, 147, 411,  47, 141, 416,  29, 452,  97, 437, 245,
     c-100,  28, 143, 404,  41, 136, 413,  28, 451,  80, 435, 241,
     c-107,  27, 142, 399,  34, 131, 407,  25, 449,  66, 431, 235,
     c-117,  24, 138, 395,  27, 119, 402,  20, 446,  60, 426, 229,
     c-124,  22, 134, 391,  21, 110, 395,  16, 442,  61, 422, 222,
     c-128,  20, 129, 387,  14, 105, 389,   8, 437,  65, 416, 216,
     c-132,  16, 129, 383,  11, 103, 382,   0, 432,  69, 411, 211,
     c-138,  11, 126, 378,   9,  99, 373, -10, 426,  70, 405, 202,
     c-146,   3, 116, 368,   2,  86, 363, -20, 419,  64, 397, 194,
     c-159,  -8,  98, 351,  -7,  70, 349, -34, 410,  56, 386, 183,
     c-173, -21,  84, 337, -15,  52, 336, -46, 398,  51, 374, 170,
     c-185, -35,  69, 324, -21,  44, 321, -57, 384,  56, 361, 158,
     c-196, -49,  51, 308, -32,  29, 310, -68, 373,  62, 347, 144,
     c-210, -65,  33, 291, -46,  12, 296, -77, 363,  62, 336, 133,
     c-216, -72,  24, 286, -54,   7, 288, -83, 356,  52, 328, 125,
     c-221, -79,  15, 280, -62,  -6, 282, -87, 351,  33, 322, 117,
     c -33,  75, 209, 470, 102, 205, 484,  82, 516, 149, 503, 306,
     c -38,  68, 204, 465,  96, 200, 479,  77, 511, 152, 497, 298,
     c -45,  60, 198, 460,  88, 196, 472,  69, 505, 148, 491, 291,
     c -52,  52, 193, 453,  83, 190, 463,  62, 500, 135, 486, 285,
     c -56,  51, 188, 446,  74, 180, 457,  54, 494, 120, 481, 279,
     c -60,  50, 180, 442,  67, 174, 453,  52, 488, 112, 475, 273,
     c -63,  51, 178, 443,  68, 171, 448,  45, 481, 107, 471, 269,
     c -66,  50, 174, 438,  66, 164, 445,  43, 476, 105, 468, 266,
     c -69,  49, 171, 429,  62, 158, 441,  41, 472, 101, 465, 262,
     c -71,  48, 170, 425,  59, 153, 439,  39, 468,  98, 462, 259,
     c -73,  46, 167, 424,  57, 157, 436,  37, 466,  94, 456, 257,
     c -77,  44, 161, 419,  55, 155, 432,  33, 464,  86, 453, 255,
     c -79,  41, 156, 413,  50, 147, 429,  32, 463,  78, 449, 252,
     c -81,  40, 157, 414,  49, 148, 425,  29, 461,  75, 447, 250,
     c -83,  38, 159, 416,  50, 144, 422,  29, 458,  87, 445, 247,
     c -86,  35, 157, 416,  49, 142, 420,  27, 454, 107, 443, 245,
     c -90,  33, 154, 414,  46, 139, 419,  25, 452, 118, 442, 243,
     c -91,  29, 148, 413,  44, 140, 418,  27, 450, 111, 440, 239,
     c -97,  25, 145, 409,  39, 136, 413,  23, 448,  90, 437, 235,
     c-106,  20, 143, 404,  32, 130, 408,  21, 446,  71, 434, 230,
     c-116,  15, 140, 398,  26, 117, 401,  16, 443,  62, 430, 224,
     c-123,  12, 137, 395,  20, 110, 394,   9, 440,  60, 426, 219,
     c-128,   9, 133, 390,  15, 107, 387,   0, 436,  63, 420, 213,
     c-132,   6, 130, 385,  11, 102, 378,  -7, 431,  64, 415, 207,
     c-136,   3, 126, 377,   9,  98, 370, -18, 426,  63, 407, 198,
     c-142,  -2, 117, 366,   3,  86, 360, -26, 418,  55, 399, 189,
     c-154, -12, 101, 350,  -5,  70, 346, -38, 409,  45, 388, 178,
     c-169, -25,  83, 333, -15,  53, 332, -48, 398,  41, 375, 165,
     c-184, -39,  67, 320, -26,  40, 319, -59, 385,  47, 362, 151,
     c-199, -53,  49, 309, -37,  26, 308, -68, 372,  55, 348, 137,
     c-214, -70,  31, 297, -52,  10, 295, -79, 362,  55, 337, 125,
     c-219, -78,  21, 293, -59,   2, 288, -87, 355,  45, 328, 117,
     c-225, -85,  11, 289, -66,  -8, 282, -92, 350,  24, 322, 109,
     c -30,  75, 219, 473, 103, 206, 485,  77, 518, 148, 504, 303,
     c -36,  69, 215, 467,  96, 198, 481,  72, 513, 152, 498, 297,
     c -41,  64, 209, 463,  88, 196, 474,  63, 508, 148, 493, 290,
     c -49,  57, 203, 457,  84, 191, 466,  57, 502, 135, 488, 284,
     c -53,  55, 195, 452,  76, 181, 459,  48, 498, 119, 485, 278,
     c -55,  55, 186, 448,  68, 177, 454,  45, 491, 111, 481, 273,
     c -58,  55, 185, 445,  68, 166, 449,  40, 485, 105, 477, 270,
     c -61,  54, 180, 440,  66, 161, 444,  38, 480, 102, 472, 266,
     c -66,  51, 177, 435,  63, 154, 440,  33, 476,  97, 469, 263,
     c -70,  47, 176, 431,  58, 152, 435,  31, 473,  93, 465, 259,
     c -73,  43, 174, 428,  58, 156, 431,  27, 469,  88, 460, 256,
     c -76,  40, 167, 424,  55, 153, 428,  25, 467,  80, 455, 253,
     c -78,  39, 161, 419,  51, 151, 426,  23, 464,  72, 453, 251,
     c -81,  37, 160, 417,  47, 145, 422,  24, 461,  70, 451, 246,
     c -84,  36, 162, 417,  47, 142, 419,  22, 457,  86, 448, 243,
     c -88,  35, 161, 418,  46, 142, 416,  19, 453, 110, 446, 241,
     c -92,  31, 157, 412,  41, 136, 415,  18, 450, 124, 444, 237,
     c -94,  24, 152, 409,  39, 132, 413,  20, 447, 115, 442, 234,
     c -98,  18, 150, 408,  39, 128, 410,  16, 446,  93, 439, 230,
     c-106,  11, 147, 403,  32, 126, 404,  12, 444,  72, 434, 225,
     c-116,   5, 144, 398,  23, 114, 398,   5, 442,  60, 431, 220,
     c-125,   1, 139, 396,  19, 107, 391,   0, 439,  58, 428, 214,
     c-131,   0, 134, 390,  14, 109, 383,  -9, 434,  56, 422, 209,
     c-133,   0, 130, 384,   8, 100, 376, -16, 430,  57, 415, 203,
     c-137,   0, 123, 374,   4,  94, 368, -23, 425,  53, 408, 194,
     c-145,  -5, 115, 363,   0,  87, 357, -30, 419,  45, 400, 185,
     c-157, -13, 100, 349,  -8,  72, 345, -41, 410,  35, 389, 174,
     c-169, -24,  84, 335, -19,  58, 333, -50, 400,  33, 376, 160,
     c-184, -35,  69, 325, -30,  49, 321, -61, 387,  40, 363, 147,
     c-199, -47,  51, 318, -39,  36, 308, -71, 376,  49, 351, 132,
     c-212, -60,  33, 312, -51,  26, 299, -82, 365,  49, 340, 121,
     c-218, -67,  24, 312, -57,  15, 292, -88, 358,  39, 332, 112,
     c-225, -75,  13, 309, -64,   6, 289, -91, 353,  21, 326, 105,
     c -33,  69, 220, 473,  98, 198, 485,  71, 520, 139, 504, 300,
     c -38,  65, 214, 468,  92, 193, 481,  66, 516, 141, 499, 294,
     c -43,  61, 209, 463,  85, 190, 475,  57, 511, 137, 495, 288,
     c -48,  57, 205, 460,  79, 187, 468,  51, 506, 127, 491, 282,
     c -53,  57, 198, 455,  74, 180, 461,  43, 501, 113, 488, 277,
     c -56,  56, 190, 450,  70, 175, 453,  39, 495, 106, 486, 273,
     c -59,  56, 185, 445,  68, 165, 448,  34, 489, 102, 481, 269,
     c -63,  55, 181, 441,  65, 160, 443,  30, 484,  98, 477, 265,
     c -68,  50, 180, 437,  60, 153, 438,  25, 480,  92, 473, 262,
     c -71,  45, 182, 437,  59, 153, 433,  22, 476,  86, 469, 258,
     c -74,  40, 180, 433,  57, 152, 428,  18, 473,  80, 464, 254,
     c -77,  36, 175, 427,  54, 147, 425,  18, 469,  74, 460, 251,
     c -79,  34, 169, 423,  50, 146, 422,  15, 466,  65, 458, 248,
     c -79,  34, 165, 421,  46, 142, 419,  13, 463,  62, 455, 243,
     c -84,  33, 165, 418,  44, 137, 415,   9, 458,  76, 453, 239,
     c -90,  31, 166, 414,  40, 135, 412,   9, 453, 100, 450, 236,
     c -94,  27, 161, 409,  34, 126, 412,   7, 449, 113, 446, 232,
     c -98,  21, 152, 405,  33, 124, 409,   8, 447, 104, 444, 229,
     c-101,  14, 151, 403,  34, 119, 406,   4, 444,  84, 440, 225,
     c-108,   5, 150, 401,  31, 119, 401,   2, 442,  65, 436, 221,
     c-117,  -1, 146, 397,  24, 111, 395,  -2, 440,  54, 432, 216,
     c-125,  -4, 139, 392,  16, 102, 388,  -9, 436,  52, 428, 211,
     c-129,  -3, 135, 390,  13, 104, 382, -15, 433,  50, 423, 205,
     c-132,  -1, 130, 383,   8,  99, 377, -21, 428,  49, 416, 200,
     c-138,   0, 124, 372,   4,  91, 368, -25, 424,  43, 409, 192,
     c-145,   0, 116, 362,  -2,  85, 359, -34, 417,  36, 400, 183,
     c-157,  -6, 103, 349, -11,  70, 349, -41, 410,  27, 389, 171,
     c-168, -15,  90, 343, -20,  63, 337, -50, 402,  26, 379, 158,
     c-182, -25,  76, 334, -32,  53, 326, -62, 391,  33, 367, 145,
     c-194, -32,  59, 330, -40,  43, 316, -73, 380,  43, 356, 131,
     c-205, -44,  41, 326, -50,  33, 307, -86, 371,  44, 347, 120,
     c-213, -50,  33, 327, -56,  17, 300, -90, 364,  34, 340, 112,
     c-219, -56,  23, 328, -62,  17, 297, -96, 359,  16, 334, 104,
     c -35,  64, 213, 473,  92, 199, 484,  69, 523, 117, 504, 297,
     c -37,  63, 210, 469,  88, 192, 481,  61, 517, 117, 499, 292,
     c -41,  61, 205, 465,  82, 185, 475,  53, 513, 114, 496, 286,
     c -45,  59, 204, 464,  79, 184, 469,  49, 509, 107, 493, 280,
     c -49,  58, 199, 458,  74, 177, 463,  40, 504,  97, 491, 275,
     c -53,  58, 192, 452,  70, 171, 455,  34, 499,  95, 490, 271,
     c -57,  57, 187, 449,  67, 166, 450,  29, 494,  94, 485, 266,
     c -62,  56, 184, 443,  64, 161, 444,  25, 489,  90, 481, 263,
     c -66,  52, 183, 438,  59, 153, 439,  19, 484,  82, 477, 259,
     c -69,  46, 185, 437,  56, 150, 433,  17, 479,  75, 472, 255,
     c -74,  38, 185, 436,  53, 151, 429,  13, 475,  70, 467, 252,
     c -78,  35, 180, 430,  49, 143, 425,  13, 471,  65, 464, 248,
     c -78,  33, 173, 425,  46, 141, 421,  12, 467,  56, 462, 244,
     c -80,  31, 167, 421,  43, 138, 418,  11, 463,  53, 458, 238,
     c -84,  30, 165, 417,  40, 136, 414,   6, 458,  64, 455, 234,
     c -91,  29, 165, 413,  33, 131, 410,   4, 452,  85, 452, 231,
     c -95,  24, 160, 408,  27, 125, 408,   1, 449,  96, 449, 227,
     c-100,  16, 152, 403,  27, 119, 405,   1, 445,  87, 445, 224,
     c-104,   8, 150, 400,  27, 116, 402,  -1, 443,  69, 441, 221,
     c-111,   0, 150, 400,  25, 121, 398,  -5, 441,  55, 436, 217,
     c-118,  -5, 146, 398,  20, 115, 393,  -9, 439,  48, 432, 212,
     c-122,  -7, 140, 394,  16, 106, 388, -13, 436,  47, 428, 207,
     c-125,  -5, 137, 391,  13, 102, 385, -14, 431,  46, 423, 202,
     c-127,   0, 133, 385,  11,  98, 381, -21, 425,  43, 417, 197,
     c-132,   3, 127, 373,   5,  90, 373, -25, 421,  38, 409, 190,
     c-140,   2, 118, 363,  -1,  85, 366, -31, 416,  33, 400, 181,
     c-151,  -1, 106, 355, -11,  75, 357, -41, 410,  26, 391, 170,
     c-163, -10,  97, 348, -21,  64, 347, -48, 403,  24, 381, 158,
     c-174, -16,  86, 344, -31,  59, 336, -62, 393,  33, 372, 145,
     c-184, -23,  70, 340, -43,  45, 326, -72, 384,  41, 362, 131,
     c-195, -30,  55, 339, -52,  37, 316, -86, 375,  39, 354, 121,
     c-201, -36,  48, 341, -57,  25, 312, -91, 368,  29, 346, 113,
     c-207, -41,  39, 341, -62,  25, 310, -95, 364,  11, 341, 106,
     c -33,  65, 208, 476,  87, 194, 484,  62, 522,  93, 504, 293,
     c -36,  64, 205, 472,  84, 189, 480,  55, 518,  91, 500, 288,
     c -37,  64, 202, 469,  80, 184, 475,  48, 515,  87, 497, 283,
     c -39,  64, 204, 467,  80, 184, 470,  44, 510,  82, 495, 277,
     c -40,  65, 202, 463,  76, 178, 464,  37, 506,  80, 494, 272,
     c -45,  64, 196, 455,  70, 171, 459,  33, 502,  83, 491, 268,
     c -51,  63, 193, 450,  65, 167, 454,  28, 497,  85, 488, 264,
     c -57,  61, 192, 448,  63, 165, 449,  24, 492,  81, 483, 260,
     c -60,  57, 189, 443,  57, 155, 443,  20, 487,  71, 480, 256,
     c -64,  51, 189, 439,  52, 147, 437,  16, 481,  62, 475, 252,
     c -69,  44, 189, 436,  47, 145, 432,  12, 476,  57, 470, 248,
     c -75,  40, 183, 433,  44, 140, 429,  12, 470,  53, 467, 243,
     c -78,  38, 176, 427,  41, 140, 424,  10, 466,  45, 464, 238,
     c -78,  36, 170, 421,  36, 136, 420,   6, 462,  41, 461, 233,
     c -82,  33, 164, 416,  31, 133, 416,   0, 457,  50, 457, 229,
     c -87,  29, 162, 411,  27, 130, 411,  -2, 452,  66, 453, 225,
     c -90,  23, 159, 408,  23, 124, 408,  -4, 447,  75, 449, 222,
     c -93,  15, 155, 404,  21, 120, 404,  -5, 445,  68, 445, 219,
     c-100,   4, 151, 401,  20, 120, 401,  -8, 442,  54, 440, 216,
     c-109,  -3, 150, 400,  19, 120, 396, -11, 440,  44, 436, 212,
     c-115,  -9, 147, 397,  15, 114, 393, -13, 438,  39, 432, 208,
     c-117, -10, 143, 396,  14, 106, 391, -17, 434,  39, 428, 204,
     c-118,  -6, 139, 394,  15, 103, 388, -18, 429,  39, 423, 199,
     c-120,  -1, 134, 387,  11,  98, 384, -23, 424,  37, 418, 194,
     c-124,   2, 128, 378,   6,  89, 379, -25, 419,  32, 410, 188,
     c-131,   2, 119, 370,   0,  87, 372, -30, 414,  27, 402, 179,
     c-141,  -1, 109, 363,  -7,  80, 365, -38, 409,  21, 393, 169,
     c-152,  -9, 101, 355, -18,  68, 355, -44, 403,  19, 384, 157,
     c-162, -17,  94, 349, -30,  63, 345, -60, 395,  24, 375, 145,
     c-172, -23,  82, 346, -41,  53, 334, -72, 385,  28, 367, 133,
     c-182, -28,  70, 345, -49,  46, 327, -86, 378,  24, 358, 123,
     c-188, -32,  64, 347, -52,  33, 323, -93, 372,  12, 352, 115,
     c-194, -36,  56, 347, -56,  32, 321, -99, 368,  -8, 348, 109,
     c -30,  73, 210, 476,  83, 186, 482,  57, 522,  85, 504, 288,
     c -32,  73, 208, 472,  79, 187, 479,  50, 518,  78, 499, 284,
     c -33,  73, 205, 469,  77, 181, 475,  44, 515,  74, 497, 279,
     c -33,  74, 208, 470,  78, 186, 470,  39, 511,  72, 495, 273,
     c -35,  74, 205, 467,  74, 181, 468,  35, 508,  75, 495, 269,
     c -42,  72, 203, 461,  68, 173, 462,  31, 504,  81, 493, 265,
     c -47,  70, 204, 456,  64, 173, 459,  29, 499,  83, 489, 262,
     c -52,  68, 199, 452,  62, 167, 454,  26, 494,  78, 485, 257,
     c -58,  63, 194, 445,  54, 155, 448,  20, 489,  65, 481, 253,
     c -60,  57, 194, 439,  48, 151, 441,  13, 482,  52, 477, 248,
     c -65,  52, 192, 434,  42, 143, 436,   9, 475,  46, 472, 243,
     c -72,  50, 184, 431,  39, 140, 430,   7, 469,  41, 468, 238,
     c -75,  47, 177, 426,  35, 136, 426,   5, 464,  34, 465, 232,
     c -78,  43, 169, 418,  29, 125, 422,   2, 460,  29, 462, 227,
     c -82,  39, 163, 413,  25, 122, 416,   0, 455,  35, 458, 223,
     c -84,  35, 161, 411,  24, 121, 412,  -4, 450,  48, 453, 219,
     c -83,  29, 161, 407,  20, 114, 409,  -4, 447,  55, 448, 216,
     c -85,  19, 158, 401,  16, 111, 405,  -7, 444,  52, 444, 214,
     c -92,  10, 154, 400,  16, 112, 401, -11, 442,  40, 440, 211,
     c-100,   1, 152, 398,  14, 109, 397, -15, 440,  34, 434, 208,
     c-105,  -4, 149, 397,  13, 113, 393, -18, 438,  29, 431, 204,
     c-109,  -7, 145, 399,  13, 108, 390, -20, 435,  27, 427, 200,
     c-111,  -6, 139, 396,  14, 104, 389, -19, 429,  27, 424, 196,
     c-114,  -3, 133, 388,  11,  99, 384, -23, 422,  26, 418, 191,
     c-118,  -2, 126, 380,   5,  89, 380, -27, 417,  22, 412, 186,
     c-125,  -2, 116, 375,   0,  85, 374, -34, 413,  16, 405, 177,
     c-134,  -7, 107, 366,  -8,  77, 367, -41, 408,   9, 396, 168,
     c-143, -16, 101, 359, -17,  65, 358, -47, 402,   6, 387, 156,
     c-153, -25,  98, 351, -29,  60, 349, -62, 394,   6, 378, 146,
     c-163, -32,  89, 345, -38,  51, 339, -73, 387,   7, 369, 134,
     c-171, -38,  80, 342, -43,  44, 332, -83, 379,  -1, 362, 125,
     c-177, -42,  75, 343, -45,  35, 328, -88, 373, -17, 356, 119,
     c-184, -46,  68, 344, -49,  31, 328, -93, 369, -42, 352, 113,
     c -32,  84, 212, 474,  76, 171, 483,  53, 519,  92, 503, 282,
     c -33,  82, 209, 471,  74, 174, 479,  46, 515,  83, 500, 277,
     c -31,  82, 209, 468,  71, 175, 476,  41, 512,  78, 498, 273,
     c -32,  82, 210, 469,  71, 181, 471,  37, 509,  78, 496, 268,
     c -36,  81, 210, 468,  69, 180, 468,  32, 507,  81, 496, 265,
     c -41,  77, 210, 464,  66, 173, 464,  27, 504,  88, 494, 261,
     c -45,  74, 211, 459,  63, 171, 459,  27, 500,  88, 490, 258,
     c -50,  69, 206, 454,  59, 163, 454,  23, 494,  80, 484, 253,
     c -53,  65, 202, 443,  53, 149, 448,  16, 488,  63, 480, 249,
     c -55,  61, 199, 435,  45, 142, 442,  10, 480,  47, 476, 245,
     c -62,  57, 193, 430,  37, 136, 436,   4, 473,  38, 473, 239,
     c -69,  55, 185, 425,  33, 130, 431,   1, 466,  31, 469, 232,
     c -73,  52, 175, 419,  27, 123, 426,  -2, 461,  25, 466, 226,
     c -77,  48, 166, 413,  21, 117, 420,  -8, 457,  19, 462, 221,
     c -83,  43, 159, 410,  19, 115, 416, -12, 453,  21, 458, 216,
     c -84,  39, 159, 410,  18, 117, 413, -13, 449,  31, 453, 213,
     c -82,  33, 159, 405,  15, 111, 409, -14, 445,  38, 448, 210,
     c -82,  25, 157, 400,  11, 107, 405, -15, 443,  36, 444, 208,
     c -87,  16, 154, 399,  11, 109, 401, -20, 441,  29, 438, 205,
     c -94,   7, 151, 396,   8, 105, 397, -20, 439,  24, 434, 203,
     c -99,   0, 148, 395,   9, 106, 394, -20, 438,  18, 430, 199,
     c-101,  -3, 142, 395,  11, 104, 391, -22, 434,  12, 427, 196,
     c-105,  -5, 135, 394,  10,  99, 388, -26, 429,  10, 423, 192,
     c-109,  -4, 130, 387,   6,  94, 384, -31, 423,  12, 419, 188,
     c-113,  -3, 124, 380,   2,  84, 380, -35, 418,   9, 414, 183,
     c-120,  -5, 114, 374,  -4,  82, 373, -41, 412,   2, 406, 174,
     c-129, -11, 105, 368, -13,  77, 366, -48, 407,  -3, 398, 165,
     c-138, -21, 100, 361, -19,  68, 357, -55, 401, -10, 389, 155,
     c-147, -33,  97, 352, -29,  63, 347, -66, 395, -13, 380, 146,
     c-158, -46,  89, 341, -37,  51, 339, -75, 386, -15, 371, 136,
     c-166, -53,  82, 337, -41,  45, 334, -85, 379, -27, 363, 128,
     c-172, -58,  78, 336, -44,  37, 330, -89, 374, -47, 358, 123,
     c-178, -64,  74, 336, -46,  29, 329, -93, 370, -77, 354, 119,
     c -32,  92, 210, 469,  67, 164, 482,  46, 515, 102, 501, 275,
     c -31,  90, 208, 467,  65, 172, 478,  39, 511,  93, 500, 270,
     c -30,  88, 207, 467,  64, 175, 475,  36, 509,  88, 498, 267,
     c -34,  85, 208, 467,  63, 180, 470,  31, 506,  88, 496, 263,
     c -38,  81, 210, 465,  61, 178, 467,  28, 504,  88, 495, 260,
     c -40,  78, 213, 462,  59, 169, 462,  22, 502,  93, 493, 257,
     c -44,  72, 215, 459,  59, 168, 459,  20, 498,  91, 489, 254,
     c -48,  67, 214, 453,  56, 160, 452,  15, 493,  82, 484, 250,
     c -51,  62, 209, 441,  51, 145, 446,   9, 487,  63, 480, 245,
     c -55,  58, 205, 434,  43, 141, 440,   4, 479,  45, 476, 240,
     c -62,  54, 195, 429,  35, 133, 434,  -2, 470,  35, 473, 233,
     c -69,  51, 184, 422,  29, 127, 428,  -7, 463,  27, 468, 226,
     c -72,  46, 173, 415,  24, 119, 422, -14, 457,  18, 465, 220,
     c -77,  40, 161, 410,  16, 113, 418, -16, 453,   9, 459, 214,
     c -84,  34, 153, 409,  11, 113, 413, -21, 450,   7, 455, 209,
     c -86,  30, 152, 407,  10, 111, 411, -22, 446,  10, 451, 206,
     c -85,  27, 154, 404,   7, 107, 407, -23, 443,  14, 447, 203,
     c -85,  22, 154, 400,   5, 104, 403, -23, 440,  14, 441, 201,
     c -88,  16, 150, 398,   2, 102, 399, -28, 439,  12, 437, 198,
     c -93,   9, 149, 396,   2, 102, 395, -25, 438,   9, 434, 196,
     c -96,   2, 144, 394,   4, 102, 393, -28, 437,   4, 430, 194,
     c -96,  -1, 138, 393,   6,  98, 392, -27, 435,  -3, 427, 191,
     c -99,  -4, 132, 392,   4,  97, 390, -31, 430,  -4, 424, 189,
     c-105,  -5, 127, 387,   0,  92, 384, -36, 424,   0, 420, 184,
     c-112,  -4, 122, 380,  -3,  82, 379, -42, 419,  -1, 414, 179,
     c-117,  -5, 113, 376, -11,  79, 374, -49, 414,  -6, 407, 171,
     c-125, -10, 105, 371, -17,  75, 367, -54, 409, -13, 399, 163,
     c-136, -22,  98, 360, -23,  70, 358, -62, 403, -23, 391, 154,
     c-145, -39,  92, 347, -31,  63, 349, -73, 395, -29, 381, 146,
     c-155, -55,  83, 335, -39,  54, 339, -81, 387, -34, 372, 138,
     c-163, -66,  78, 327, -45,  49, 334, -84, 379, -49, 363, 132,
     c-169, -72,  74, 324, -45,  41, 329, -85, 375, -68, 359, 127,
     c-175, -79,  69, 322, -46,  34, 328, -87, 372, -97, 357, 123,
     c -34,  93, 207, 463,  56, 157, 479,  37, 512, 107, 500, 268,
     c -34,  88, 206, 463,  56, 166, 475,  32, 507,  98, 498, 265,
     c -34,  85, 205, 464,  57, 168, 473,  29, 505,  93, 497, 261,
     c -38,  80, 206, 462,  56, 171, 467,  25, 503,  91, 495, 259,
     c -42,  77, 206, 460,  54, 171, 463,  21, 502,  90, 494, 256,
     c -44,  73, 209, 457,  52, 162, 459,  16, 499,  90, 493, 252,
     c -45,  70, 214, 455,  54, 160, 456,  12, 496,  87, 489, 249,
     c -47,  64, 213, 449,  52, 151, 450,   6, 492,  79, 484, 246,
     c -53,  58, 207, 441,  46, 145, 444,   0, 485,  63, 480, 241,
     c -60,  53, 203, 435,  39, 142, 436,  -3, 478,  47, 476, 235,
     c -66,  49, 193, 428,  32, 134, 432, -10, 469,  37, 472, 228,
     c -71,  42, 179, 422,  26, 128, 424, -16, 461,  31, 468, 220,
     c -74,  35, 169, 415,  21, 118, 419, -21, 455,  21, 462, 214,
     c -78,  28, 159, 410,  14, 110, 413, -26, 451,  11, 457, 208,
     c -83,  22, 151, 408,   7, 111, 409, -29, 447,   3, 452, 203,
     c -85,  19, 148, 406,   5, 108, 407, -33, 443,  -2, 448, 199,
     c -86,  17, 150, 401,   2, 104, 404, -34, 440,  -4, 445, 196,
     c -88,  14, 150, 395,  -1,  94, 400, -36, 438,  -6, 440, 194,
     c -91,  11, 146, 393,  -4,  92, 398, -41, 435,  -6, 437, 191,
     c -93,   6, 144, 392,  -5,  93, 396, -41, 435,  -7, 434, 190,
     c -95,   1, 140, 390,  -3,  93, 395, -37, 435, -11, 430, 188,
     c -94,  -3, 136, 391,  -1,  96, 395, -35, 434, -21, 428, 186,
     c -96,  -6, 132, 390,  -1,  94, 393, -37, 430, -22, 424, 185,
     c-100,  -5, 128, 388,  -4,  89, 391, -43, 427, -15, 420, 180,
     c-107,  -4, 125, 384,  -8,  87, 385, -46, 423, -12, 415, 176,
     c-111,  -3, 118, 383, -13,  90, 380, -52, 418, -16, 409, 169,
     c-118,  -8, 109, 376, -17,  86, 374, -58, 412, -24, 401, 162,
     c-130, -21, 101, 363, -24,  79, 364, -68, 406, -34, 392, 154,
     c-141, -39,  92, 347, -31,  68, 353, -79, 398, -44, 383, 148,
     c-148, -58,  82, 331, -38,  58, 345, -86, 389, -46, 375, 141,
     c-154, -69,  79, 320, -42,  54, 339, -87, 382, -58, 367, 137,
     c-159, -78,  74, 317, -44,  45, 336, -87, 377, -76, 364, 133,
     c-164, -86,  69, 314, -46,  40, 334, -87, 375,-104, 362, 130,
     c -31,  88, 207, 461,  51, 161, 474,  29, 509, 102, 499, 262,
     c -33,  83, 206, 460,  51, 161, 472,  24, 506,  96, 497, 259,
     c -34,  78, 205, 460,  52, 164, 467,  17, 503,  91, 495, 257,
     c -40,  73, 204, 459,  53, 161, 461,  16, 501,  89, 494, 254,
     c -45,  72, 204, 458,  54, 159, 459,  13, 499,  85, 493, 251,
     c -46,  70, 207, 455,  51, 156, 457,   9, 498,  82, 491, 248,
     c -44,  68, 210, 452,  49, 153, 453,   7, 494,  79, 489, 245,
     c -45,  64, 207, 448,  47, 149, 448,   2, 490,  73, 486, 241,
     c -53,  59, 201, 441,  42, 144, 443,  -2, 484,  63, 482, 236,
     c -62,  52, 195, 435,  35, 138, 436,  -9, 477,  51, 478, 231,
     c -68,  45, 187, 430,  30, 132, 429, -13, 468,  45, 473, 224,
     c -73,  36, 173, 423,  23, 128, 424, -21, 461,  41, 469, 217,
     c -76,  26, 164, 416,  16, 115, 418, -26, 454,  34, 463, 209,
     c -79,  17, 157, 409,  10, 109, 413, -32, 449,  25, 457, 204,
     c -81,  12, 152, 408,   9, 111, 409, -35, 445,  14, 452, 199,
     c -85,   9, 150, 405,   7, 107, 406, -39, 440,   2, 448, 194,
     c -87,   9, 151, 400,   0, 104, 403, -41, 437,  -7, 443, 191,
     c -90,   8, 149, 394,  -3,  95, 399, -45, 434, -13, 440, 188,
     c -91,   8, 145, 392,  -5,  94, 398, -47, 432, -15, 436, 186,
     c -92,   4, 142, 388,  -6,  90, 398, -48, 432, -14, 433, 184,
     c -92,   0, 141, 388,  -6,  91, 399, -45, 432, -19, 430, 183,
     c -90,  -4, 137, 391,  -5,  98, 400, -42, 434, -30, 427, 182,
     c -92,  -5, 135, 391,  -5,  97, 400, -41, 431, -31, 424, 181,
     c -97,  -4, 132, 388,  -5,  92, 398, -42, 429, -22, 420, 178,
     c-102,  -1, 131, 388,  -7,  93, 395, -47, 426, -14, 416, 174,
     c-105,   0, 125, 388, -12,  97, 390, -54, 423, -16, 409, 168,
     c-110,  -4, 119, 380, -18,  94, 384, -61, 418, -25, 402, 162,
     c-120, -18, 108, 368, -22,  87, 375, -71, 411, -36, 395, 156,
     c-131, -37,  99, 353, -29,  76, 365, -80, 403, -45, 388, 152,
     c-138, -56,  89, 334, -36,  65, 357, -86, 394, -46, 380, 147,
     c-140, -65,  87, 322, -38,  62, 351, -84, 386, -51, 375, 144,
     c-145, -74,  82, 316, -42,  52, 347, -84, 383, -66, 372, 142,
     c-150, -83,  75, 310, -45,  47, 346, -80, 382, -91, 372, 139,
     c -29,  88, 205, 462,  51, 159, 472,  22, 508,  95, 500, 256,
     c -31,  81, 204, 460,  51, 158, 467,  17, 505,  90, 498, 254,
     c -33,  75, 202, 459,  53, 155, 463,  13, 503,  86, 495, 251,
     c -41,  70, 201, 458,  52, 153, 458,   8, 500,  82, 494, 249,
     c -48,  71, 201, 457,  52, 154, 457,   3, 498,  78, 493, 246,
     c -46,  72, 203, 456,  50, 154, 455,   1, 496,  73, 492, 243,
     c -43,  72, 205, 455,  48, 152, 452,   0, 493,  70, 491, 240,
     c -44,  67, 201, 451,  44, 148, 448,  -1, 489,  67, 488, 236,
     c -50,  61, 193, 442,  41, 142, 442,  -5, 484,  60, 484, 232,
     c -59,  53, 185, 435,  33, 135, 436, -12, 478,  52, 480, 226,
     c -67,  45, 177, 432,  27, 130, 431, -16, 470,  47, 476, 220,
     c -71,  34, 169, 426,  19, 126, 426, -24, 462,  43, 470, 213,
     c -74,  23, 159, 416,  11, 109, 420, -30, 456,  41, 465, 206,
     c -78,  12, 154, 411,   8, 106, 416, -35, 450,  38, 459, 200,
     c -82,   5, 153, 410,   8, 107, 412, -38, 445,  29, 453, 195,
     c -86,   3, 154, 407,   7, 100, 407, -45, 439,  15, 448, 190,
     c -90,   2, 151, 398,   0,  94, 402, -47, 434,   1, 444, 186,
     c -92,   3, 146, 393,  -3,  88, 400, -51, 432,  -7, 440, 184,
     c -91,   4, 143, 393,  -4,  89, 400, -53, 429, -13, 436, 181,
     c -89,   4, 143, 393,  -4,  96, 401, -54, 429, -11, 432, 180,
     c -88,   1, 142, 391,  -5,  96, 403, -50, 430, -16, 429, 179,
     c -87,  -3, 139, 391,  -5,  99, 404, -46, 431, -32, 426, 178,
     c -87,  -4, 139, 394,  -6, 103, 406, -44, 431, -35, 423, 178,
     c -92,  -2, 137, 394,  -5, 102, 405, -45, 430, -22, 421, 176,
     c -94,   0, 136, 394,  -4, 101, 402, -48, 429,  -8, 417, 174,
     c -96,   1, 132, 393,  -9, 103, 399, -56, 426,  -9, 412, 169,
     c-102,  -3, 127, 388, -15, 103, 395, -62, 422, -16, 406, 165,
     c-109, -15, 121, 379, -19, 100, 386, -72, 416, -26, 400, 162,
     c-116, -31, 113, 364, -25,  87, 378, -79, 410, -30, 396, 159,
     c-124, -46, 104, 347, -34,  77, 371, -83, 401, -25, 390, 155,
     c-125, -53, 101, 336, -36,  75, 366, -83, 395, -23, 387, 153,
     c-130, -61,  96, 329, -38,  64, 364, -82, 391, -34, 384, 152,
     c-134, -69,  90, 323, -42,  62, 363, -79, 391, -54, 385, 150,
     c -27,  94, 199, 465,  50, 154, 471,  18, 508,  87, 504, 251,
     c -29,  88, 198, 463,  49, 155, 466,  11, 505,  83, 499, 248,
     c -32,  81, 196, 462,  51, 152, 459,   6, 502,  80, 496, 246,
     c -43,  75, 193, 456,  48, 148, 456,   0, 500,  77, 494, 243,
     c -47,  75, 193, 456,  47, 147, 454,  -4, 497,  73, 494, 241,
     c -47,  76, 194, 455,  45, 151, 453,  -2, 496,  67, 493, 239,
     c -47,  75, 193, 454,  43, 149, 451,  -3, 492,  63, 492, 235,
     c -46,  71, 189, 450,  40, 146, 447,  -6, 488,  59, 488, 232,
     c -49,  65, 183, 445,  37, 145, 442, -10, 484,  53, 484, 227,
     c -57,  57, 175, 438,  32, 137, 437, -15, 477,  48, 480, 222,
     c -65,  47, 167, 432,  23, 128, 433, -20, 470,  41, 476, 215,
     c -68,  37, 162, 425,  15, 122, 428, -27, 464,  37, 471, 209,
     c -71,  24, 156, 416,   7, 109, 423, -31, 458,  37, 466, 202,
     c -76,  13, 153, 411,   4, 105, 419, -35, 451,  39, 459, 196,
     c -81,   4, 151, 408,   4, 101, 414, -43, 445,  32, 453, 191,
     c -87,   0, 151, 403,   0,  94, 408, -49, 439,  18, 449, 186,
     c -92,  -1, 147, 395,  -5,  85, 402, -55, 434,   2, 444, 182,
     c -94,   0, 143, 391,  -8,  81, 401, -59, 430,  -7, 439, 180,
     c -91,   2, 141, 394,  -8,  87, 401, -60, 427, -10, 435, 177,
     c -87,   3, 140, 396,  -6,  92, 404, -58, 427, -10, 432, 176,
     c -85,   1, 141, 394,  -5,  94, 406, -56, 427, -12, 429, 175,
     c -84,  -3, 140, 391,  -6,  96, 407, -54, 429, -27, 426, 175,
     c -84,  -5, 141, 397,  -7, 101, 408, -51, 429, -33, 424, 175,
     c -87,  -4, 140, 399,  -6, 102, 408, -50, 429, -20, 422, 174,
     c -88,  -1, 140, 398,  -6, 102, 407, -50, 430,   0, 420, 173,
     c -90,  -1, 138, 398,  -8, 103, 403, -56, 430,   3, 417, 170,
     c -94,  -5, 138, 397, -11, 108, 401, -62, 427,  -3, 413, 168,
     c -98, -14, 137, 390, -15, 103, 396, -70, 423, -11, 410, 167,
     c-101, -25, 131, 378, -21,  96, 391, -77, 417, -11, 407, 166,
     c-107, -36, 123, 366, -28,  95, 385, -80, 410,  -1, 404, 164,
     c-107, -36, 123, 360, -29,  95, 382, -80, 406,   4, 402, 164,
     c-113, -44, 117, 352, -33,  83, 379, -80, 404,   0, 402, 163,
     c-117, -51, 109, 348, -34,  79, 379, -77, 405, -15, 403, 162,
     c -26, 102, 199, 473,  46, 156, 472,  15, 509,  78, 509, 244,
     c -30,  93, 196, 467,  44, 152, 466,   7, 505,  75, 503, 242,
     c -33,  86, 194, 463,  43, 146, 459,   0, 502,  73, 499, 239,
     c -42,  78, 187, 454,  38, 137, 455,  -5, 500,  72, 495, 236,
     c -47,  76, 186, 454,  37, 138, 452,  -8, 497,  67, 493, 234,
     c -50,  74, 187, 454,  37, 139, 451, -10, 494,  62, 492, 232,
     c -47,  72, 185, 453,  36, 143, 449, -11, 491,  57, 490, 229,
     c -47,  67, 178, 447,  35, 137, 445, -14, 487,  54, 487, 225,
     c -52,  60, 170, 442,  31, 136, 440, -18, 483,  48, 483, 221,
     c -59,  55, 165, 438,  29, 129, 436, -21, 477,  41, 479, 216,
     c -64,  49, 159, 431,  21, 118, 432, -25, 471,  33, 474, 210,
     c -68,  40, 156, 423,  12, 112, 427, -31, 465,  28, 471, 204,
     c -70,  30, 153, 415,   5, 104, 423, -34, 460,  29, 465, 197,
     c -73,  19, 154, 412,   2, 102, 419, -38, 454,  30, 459, 192,
     c -79,   9, 151, 406,   0,  98, 412, -45, 447,  26, 453, 187,
     c -87,   2, 146, 398,  -6,  89, 407, -52, 440,  12, 449, 183,
     c -93,   0, 141, 391, -13,  80, 401, -60, 434,  -2, 444, 179,
     c -94,   1, 140, 392, -15,  81, 400, -63, 430, -13, 439, 178,
     c -92,   4, 140, 396, -13,  87, 401, -65, 425, -16, 435, 176,
     c -89,   4, 139, 394, -11,  87, 403, -64, 424, -13, 431, 174,
     c -86,   1, 141, 393, -10,  88, 404, -64, 424, -13, 428, 173,
     c -84,  -2, 142, 391, -10,  88, 404, -61, 424, -27, 426, 172,
     c -83,  -6, 143, 394, -10,  94, 405, -60, 425, -36, 426, 172,
     c -84,  -8, 142, 396,  -8,  96, 406, -56, 427, -22, 425, 172,
     c -86,  -7, 142, 397, -10,  95, 406, -54, 429,   0, 425, 172,
     c -85,  -6, 144, 401,  -9,  98, 406, -55, 430,   4, 424, 171,
     c -86,  -8, 149, 404,  -7, 103, 406, -59, 429,  -1, 422, 171,
     c -88, -14, 151, 400, -11, 101, 402, -65, 427,  -9, 420, 172,
     c -90, -22, 148, 393, -17,  97, 399, -71, 424,  -6, 419, 172,
     c -92, -28, 144, 388, -23, 100, 396, -73, 421,   6, 418, 173,
     c -88, -23, 146, 385, -21, 103, 395, -73, 418,  16, 419, 173,
     c -93, -28, 139, 381, -23,  96, 395, -69, 417,  12, 420, 174,
     c -96, -33, 132, 380, -23,  92, 396, -67, 418,   0, 422, 173,
     c -24, 102, 204, 476,  39, 149, 469,  10, 508,  67, 511, 238,
     c -28,  94, 198, 468,  38, 148, 464,   0, 504,  64, 505, 234,
     c -31,  87, 195, 463,  36, 141, 459,  -4, 501,  62, 499, 231,
     c -38,  77, 189, 454,  33, 134, 453, -12, 497,  63, 495, 228,
     c -46,  70, 186, 453,  32, 137, 449, -14, 495,  61, 491, 225,
     c -49,  64, 186, 452,  31, 135, 446, -17, 491,  57, 490, 223,
     c -46,  59, 182, 450,  29, 135, 444, -18, 488,  52, 487, 221,
     c -48,  54, 175, 446,  27, 129, 440, -21, 483,  48, 483, 218,
     c -55,  50, 167, 441,  24, 125, 435, -26, 479,  44, 479, 214,
     c -63,  47, 160, 435,  21, 120, 430, -29, 474,  36, 476, 209,
     c -67,  45, 157, 430,  19, 110, 427, -35, 470,  27, 472, 203,
     c -70,  41, 156, 424,  10, 111, 423, -37, 465,  23, 469, 197,
     c -70,  35, 155, 415,   2, 103, 420, -42, 461,  23, 464, 191,
     c -72,  27, 155, 412,   0, 100, 416, -45, 455,  25, 459, 186,
     c -78,  18, 153, 407,  -3,  92, 412, -52, 448,  16, 454, 182,
     c -86,  10, 149, 399, -10,  82, 407, -55, 442,   1, 449, 179,
     c -90,   6, 146, 395, -14,  77, 402, -61, 436, -11, 444, 177,
     c -93,   5, 144, 395, -17,  78, 399, -65, 430, -18, 439, 175,
     c -92,   5, 144, 396, -16,  80, 400, -70, 425, -21, 434, 173,
     c -90,   5, 144, 393, -14,  82, 400, -72, 421, -18, 431, 171,
     c -87,   2, 145, 390, -13,  81, 400, -73, 420, -18, 428, 170,
     c -83,  -1, 147, 390, -12,  88, 401, -72, 421, -29, 427, 169,
     c -82,  -6, 146, 389, -13,  91, 401, -69, 422, -38, 426, 169,
     c -81,  -8, 143, 390, -12,  90, 404, -65, 424, -29, 427, 169,
     c -82,  -8, 145, 396, -13,  92, 405, -61, 427,  -8, 429, 170,
     c -80,  -8, 148, 404, -11,  97, 407, -59, 429,  -2, 429, 170,
     c -80,  -8, 154, 408,  -9, 100, 407, -59, 430, -11, 429, 172,
     c -80, -11, 158, 408,  -9, 102, 406, -60, 430, -19, 430, 174,
     c -80, -15, 159, 409, -12, 104, 404, -64, 430, -15, 432, 177,
     c -79, -16, 157, 408, -16, 114, 404, -64, 428,  -3, 432, 179,
     c -73, -10, 159, 410, -11, 120, 405, -63, 428,   7, 434, 181,
     c -75, -13, 154, 410, -11, 116, 408, -58, 430,   4, 436, 183,
     c -77, -16, 147, 413, -11, 113, 412, -57, 432,  -7, 439, 183,
     c -29,  94, 198, 469,  33, 141, 463,   1, 506,  56, 512, 231,
     c -32,  86, 194, 464,  34, 139, 458,  -9, 502,  47, 503, 226,
     c -37,  78, 189, 458,  33, 134, 454, -15, 499,  46, 496, 223,
     c -42,  68, 185, 450,  30, 129, 447, -23, 495,  52, 491, 219,
     c -49,  60, 183, 449,  28, 130, 442, -28, 491,  56, 487, 217,
     c -53,  52, 180, 446,  25, 126, 438, -31, 487,  53, 484, 214,
     c -52,  45, 177, 443,  22, 125, 436, -31, 482,  48, 482, 213,
     c -55,  40, 172, 440,  20, 115, 433, -30, 478,  44, 479, 209,
     c -62,  37, 164, 437,  17, 113, 429, -37, 474,  39, 474, 205,
     c -68,  36, 157, 432,  13, 105, 425, -41, 470,  32, 471, 200,
     c -73,  37, 153, 427,  11, 102, 422, -45, 466,  24, 467, 195,
     c -74,  38, 154, 421,   6,  99, 419, -46, 462,  21, 464, 190,
     c -72,  35, 154, 416,   0,  96, 417, -51, 459,  20, 460, 184,
     c -73,  30, 155, 412,  -6,  94, 415, -55, 455,  18, 456, 180,
     c -78,  24, 156, 410,  -9,  91, 410, -59, 449,   5, 452, 176,
     c -84,  17, 156, 404, -13,  82, 408, -60, 443, -12, 448, 174,
     c -88,  12, 154, 397, -15,  75, 403, -66, 437, -24, 443, 172,
     c -91,   9, 152, 395, -17,  73, 400, -70, 431, -26, 439, 171,
     c -90,   9, 151, 395, -19,  75, 399, -73, 425, -29, 435, 170,
     c -89,   7, 149, 392, -19,  75, 397, -77, 421, -26, 433, 167,
     c -86,   5, 149, 388, -17,  72, 395, -78, 418, -27, 430, 166,
     c -81,   1, 148, 385, -18,  76, 395, -79, 418, -38, 429, 165,
     c -78,  -1, 148, 386, -17,  82, 398, -75, 419, -48, 428, 166,
     c -77,  -3, 146, 389, -16,  83, 400, -70, 422, -41, 430, 166,
     c -77,  -3, 145, 392, -15,  89, 404, -66, 424, -22, 433, 168,
     c -75,  -1, 149, 400, -13,  95, 406, -61, 427, -17, 436, 170,
     c -74,   1, 153, 408, -11, 101, 408, -60, 429, -24, 438, 171,
     c -73,   3, 158, 412, -10, 106, 409, -59, 431, -31, 440, 175,
     c -70,   3, 159, 415,  -8, 107, 407, -59, 433, -27, 443, 179,
     c -70,   3, 156, 416, -11, 113, 408, -58, 435, -17, 446, 182,
     c -63,  11, 160, 424,  -4, 123, 414, -54, 436, -10, 447, 186,
     c -63,   9, 156, 427,  -4, 121, 420, -48, 439, -16, 451, 189,
     c -63,   7, 152, 433,  -1, 121, 424, -45, 442, -29, 457, 189,
     c -37,  80, 181, 464,  28, 135, 453, -15, 503,  38, 510, 223,
     c -40,  73, 178, 459,  29, 130, 449, -21, 500,  23, 499, 219,
     c -42,  67, 176, 456,  31, 125, 444, -28, 495,  19, 491, 214,
     c -50,  58, 172, 450,  27, 122, 438, -36, 491,  33, 485, 210,
     c -57,  48, 169, 445,  21, 118, 432, -41, 487,  47, 482, 207,
     c -61,  40, 167, 439,  16, 115, 428, -43, 481,  51, 479, 204,
     c -59,  36, 167, 439,  14, 113, 427, -43, 477,  47, 478, 202,
     c -61,  34, 166, 437,  12, 108, 423, -42, 471,  42, 473, 199,
     c -66,  32, 161, 433,   8, 106, 421, -47, 468,  34, 468, 195,
     c -71,  31, 154, 429,   3,  99, 418, -51, 464,  29, 464, 191,
     c -73,  33, 150, 424,   1,  97, 417, -54, 462,  21, 461, 186,
     c -74,  35, 150, 421,   0,  94, 415, -55, 459,  17, 458, 181,
     c -73,  35, 153, 416,  -7,  88, 414, -60, 457,  16, 456, 177,
     c -74,  32, 156, 413, -13,  92, 413, -59, 452,   8, 451, 172,
     c -78,  27, 157, 408, -18,  84, 410, -65, 448, -13, 447, 169,
     c -86,  21, 156, 402, -21,  76, 407, -66, 442, -32, 445, 167,
     c -89,  15, 154, 394, -23,  70, 405, -72, 437, -41, 442, 166,
     c -91,  11, 153, 390, -25,  67, 401, -77, 430, -38, 438, 165,
     c -90,  11, 151, 390, -26,  69, 397, -81, 425, -37, 437, 164,
     c -90,  11, 146, 388, -28,  68, 393, -88, 420, -37, 436, 162,
     c -86,  11, 144, 385, -25,  64, 390, -90, 417, -39, 434, 161,
     c -81,   9, 143, 382, -24,  68, 391, -92, 417, -50, 432, 160,
     c -74,   7, 144, 385, -22,  77, 394, -86, 418, -60, 432, 161,
     c -74,   5, 141, 387, -20,  82, 397, -81, 421, -57, 434, 162,
     c -73,   6, 141, 389, -18,  90, 401, -76, 424, -39, 438, 165,
     c -71,  11, 141, 394, -16,  93, 404, -68, 427, -32, 442, 168,
     c -70,  17, 144, 402, -14, 100, 407, -63, 429, -35, 446, 169,
     c -65,  23, 151, 409, -10, 106, 408, -61, 431, -39, 449, 174,
     c -63,  26, 153, 412,  -7, 105, 409, -59, 435, -35, 453, 179,
     c -61,  29, 152, 417,  -6, 109, 412, -53, 438, -30, 456, 183,
     c -52,  37, 159, 429,   2, 123, 421, -49, 442, -31, 460, 188,
     c -52,  36, 156, 433,   5, 123, 427, -41, 446, -38, 465, 192,
     c -52,  34, 154, 439,   7, 124, 434, -38, 451, -53, 472, 194,
     c -45,  71, 163, 461,  18, 127, 443, -32, 499,  20, 507, 214,
     c -47,  65, 162, 458,  20, 124, 439, -35, 495,  -4, 495, 210,
     c -51,  59, 160, 454,  22, 119, 434, -42, 491,  -9, 485, 205,
     c -56,  51, 157, 450,  17, 116, 428, -49, 486,  11, 479, 201,
     c -63,  42, 155, 444,  12, 109, 423, -55, 481,  37, 478, 197,
     c -66,  37, 156, 439,   8, 105, 419, -55, 476,  50, 477, 193,
     c -64,  34, 159, 436,   7, 104, 420, -54, 470,  50, 476, 191,
     c -65,  33, 160, 436,   4, 106, 417, -55, 466,  42, 471, 187,
     c -68,  33, 159, 431,   0, 104, 415, -58, 462,  32, 466, 184,
     c -71,  33, 153, 427,  -4,  98, 412, -62, 459,  23, 461, 179,
     c -74,  33, 148, 421,  -6,  94, 412, -64, 456,  20, 457, 176,
     c -76,  34, 147, 416, -10,  90, 412, -64, 454,  18, 454, 171,
     c -76,  32, 150, 412, -16,  85, 412, -69, 451,  15, 450, 167,
     c -75,  30, 155, 410, -21,  88, 411, -70, 448,  -2, 447, 163,
     c -79,  26, 157, 405, -26,  81, 410, -73, 444, -31, 443, 161,
     c -86,  20, 153, 396, -32,  69, 407, -76, 440, -52, 441, 159,
     c -89,  15, 151, 390, -32,  63, 404, -80, 434, -57, 439, 158,
     c -89,  12, 149, 387, -33,  61, 399, -83, 429, -50, 438, 157,
     c -89,  12, 145, 388, -34,  65, 396, -86, 424, -45, 438, 156,
     c -90,  14, 137, 385, -35,  63, 389, -90, 420, -44, 437, 154,
     c -86,  17, 136, 385, -32,  63, 386, -96, 417, -48, 436, 153,
     c -81,  17, 136, 385, -29,  71, 386, -97, 417, -60, 434, 153,
     c -75,  16, 137, 386, -25,  77, 390, -94, 418, -73, 435, 155,
     c -74,  15, 135, 387, -23,  81, 392, -90, 421, -72, 436, 157,
     c -74,  16, 134, 385, -21,  87, 396, -84, 423, -58, 440, 160,
     c -71,  22, 133, 388, -21,  88, 399, -77, 425, -49, 444, 163,
     c -65,  30, 135, 393, -18,  92, 403, -69, 427, -48, 448, 165,
     c -60,  38, 141, 401, -14,  97, 406, -64, 429, -50, 452, 170,
     c -56,  43, 144, 406, -12, 101, 410, -62, 434, -47, 458, 176,
     c -53,  46, 145, 412,  -9, 106, 415, -55, 440, -46, 462, 182,
     c -41,  55, 156, 424,   2, 119, 425, -49, 444, -52, 468, 187,
     c -41,  53, 156, 430,   7, 119, 433, -40, 450, -62, 473, 192,
     c -39,  52, 155, 436,  14, 119, 441, -36, 455, -79, 481, 195,
     c -49,  74, 153, 457,   8, 121, 434, -46, 493,   5, 505, 204,
     c -51,  70, 153, 453,  10, 116, 432, -49, 489, -26, 491, 200,
     c -54,  65, 151, 450,  11, 109, 428, -54, 485, -33, 481, 196,
     c -57,  58, 150, 446,   7, 106, 420, -59, 480,  -9, 476, 191,
     c -64,  49, 150, 443,   3, 102, 416, -66, 475,  23, 475, 187,
     c -69,  42, 153, 438,   1, 100, 413, -67, 469,  46, 475, 183,
     c -71,  41, 155, 434,   0, 101, 414, -66, 465,  51, 474, 180,
     c -72,  41, 159, 433,  -5, 101, 411, -67, 460,  43, 471, 176,
     c -73,  40, 158, 428, -10,  97, 409, -69, 457,  28, 465, 172,
     c -74,  40, 153, 422, -15,  90, 406, -72, 453,  19, 460, 168,
     c -78,  39, 149, 418, -18,  87, 406, -75, 451,  18, 455, 164,
     c -81,  36, 147, 412, -21,  82, 407, -76, 448,  22, 452, 160,
     c -80,  33, 148, 406, -25,  76, 406, -78, 446,  18, 448, 157,
     c -78,  29, 150, 403, -30,  79, 407, -83, 442,  -3, 444, 153,
     c -81,  24, 151, 400, -35,  77, 405, -84, 439, -41, 440, 150,
     c -87,  20, 147, 392, -40,  67, 403, -88, 435, -66, 438, 149,
     c -88,  16, 144, 387, -41,  63, 399, -88, 431, -68, 436, 148,
     c -88,  13, 140, 386, -40,  61, 395, -90, 426, -57, 437, 147,
     c -92,  13, 132, 385, -41,  60, 390, -96, 422, -49, 437, 147,
     c -91,  17, 125, 384, -40,  57, 385, -99, 417, -47, 437, 145,
     c -87,  21, 125, 385, -38,  59, 383,-103, 416, -53, 436, 144,
     c -82,  22, 126, 389, -34,  67, 384,-104, 416, -65, 434, 146,
     c -78,  21, 128, 389, -28,  73, 384,-104, 418, -79, 433, 147,
     c -76,  18, 127, 386, -26,  76, 387,-100, 419, -86, 434, 149,
     c -75,  20, 128, 384, -25,  80, 389, -95, 421, -79, 437, 153,
     c -68,  27, 128, 385, -24,  85, 395, -89, 422, -69, 441, 156,
     c -61,  36, 129, 387, -23,  84, 399, -79, 423, -67, 446, 158,
     c -55,  44, 132, 392, -19,  86, 403, -72, 427, -65, 451, 164,
     c -50,  50, 136, 398, -14,  95, 409, -66, 432, -61, 457, 171,
     c -45,  53, 139, 404, -12,  97, 417, -58, 438, -62, 463, 177,
     c -34,  62, 152, 417,   1, 116, 427, -50, 445, -69, 470, 185,
     c -31,  62, 155, 425,   9, 118, 436, -40, 451, -81, 478, 190,
     c -28,  63, 159, 434,  18, 120, 444, -36, 457,-100, 487, 194,
     c -52,  82, 156, 454,   1, 113, 431, -51, 485,   0, 501, 195,
     c -54,  77, 155, 451,   1, 109, 428, -56, 480, -39, 488, 190,
     c -55,  74, 154, 447,   2, 103, 424, -63, 476, -51, 478, 186,
     c -57,  68, 152, 442,   0,  97, 418, -70, 472, -27, 473, 181,
     c -64,  59, 152, 435,  -6,  91, 414, -77, 467,   8, 472, 177,
     c -70,  52, 153, 430, -10,  87, 411, -79, 464,  37, 472, 172,
     c -75,  47, 154, 425, -14,  87, 411, -79, 459,  46, 471, 169,
     c -78,  46, 155, 421, -18,  87, 409, -80, 456,  36, 468, 165,
     c -80,  44, 154, 417, -24,  86, 406, -81, 453,  16, 463, 161,
     c -80,  42, 151, 414, -29,  86, 402, -83, 449,   2, 457, 157,
     c -83,  40, 147, 412, -32,  81, 401, -86, 445,   9, 452, 153,
     c -86,  36, 141, 407, -32,  78, 400, -89, 443,  21, 448, 149,
     c -86,  30, 140, 400, -36,  69, 398, -92, 439,  22, 444, 146,
     c -85,  25, 139, 396, -42,  69, 399, -97, 436,  -6, 441, 143,
     c -86,  22, 137, 394, -44,  65, 397, -97, 433, -48, 437, 140,
     c -89,  19, 134, 389, -47,  63, 395, -99, 430, -76, 435, 139,
     c -91,  16, 130, 382, -49,  59, 391, -98, 426, -79, 435, 137,
     c -92,  15, 125, 380, -48,  54, 388, -99, 422, -69, 435, 136,
     c -93,  15, 118, 382, -48,  55, 383,-100, 417, -58, 436, 136,
     c -92,  17, 112, 382, -47,  53, 381,-103, 414, -51, 436, 135,
     c -89,  19, 110, 384, -47,  53, 379,-108, 413, -55, 434, 134,
     c -84,  19, 114, 387, -42,  60, 378,-110, 413, -66, 432, 136,
     c -80,  16, 117, 389, -38,  66, 378,-110, 414, -82, 429, 138,
     c -78,  13, 118, 387, -34,  68, 380,-108, 416, -95, 429, 140,
     c -75,  13, 122, 386, -32,  71, 381,-107, 416, -98, 432, 143,
     c -67,  19, 125, 384, -30,  77, 385,-102, 417, -92, 436, 147,
     c -61,  28, 126, 384, -28,  78, 392, -94, 418, -86, 441, 150,
     c -54,  38, 128, 387, -24,  78, 398, -86, 422, -80, 446, 156,
     c -48,  45, 130, 392, -19,  87, 404, -80, 428, -74, 453, 164,
     c -42,  51, 136, 397, -13,  92, 414, -73, 437, -73, 461, 172,
     c -30,  61, 152, 412,   1, 110, 424, -61, 444, -79, 470, 180,
     c -26,  63, 160, 422,  10, 115, 435, -50, 452, -91, 479, 186,
     c -21,  65, 166, 432,  21, 117, 445, -41, 459,-109, 490, 191,
     c -54,  80, 165, 450,  -5, 102, 430, -59, 475,  -2, 496, 183,
     c -56,  77, 163, 447,  -6,  96, 427, -64, 471, -46, 483, 179,
     c -55,  75, 161, 444,  -5,  91, 425, -71, 468, -60, 474, 175,
     c -56,  71, 158, 438,  -8,  88, 419, -77, 464, -42, 468, 170,
     c -62,  63, 153, 427, -14,  79, 413, -83, 460,  -8, 466, 166,
     c -69,  54, 151, 419, -22,  72, 412, -88, 456,  20, 465, 163,
     c -73,  48, 151, 416, -25,  75, 409, -88, 453,  30, 463, 158,
     c -77,  43, 150, 414, -27,  72, 407, -89, 451,  13, 460, 154,
     c -81,  37, 146, 409, -32,  71, 403, -90, 447, -18, 456, 149,
     c -83,  33, 143, 406, -38,  72, 398, -92, 443, -32, 452, 145,
     c -85,  31, 139, 405, -40,  69, 394, -95, 440, -20, 447, 141,
     c -88,  25, 131, 400, -43,  65, 391, -98, 435,   0, 443, 136,
     c -92,  20, 125, 394, -48,  59, 388,-103, 432,   8, 440, 134,
     c -92,  15, 121, 389, -53,  58, 387,-106, 429, -18, 436, 131,
     c -92,  13, 117, 388, -52,  55, 386,-107, 426, -61, 433, 127,
     c -94,  12, 116, 386, -55,  52, 384,-110, 423, -91, 431, 127,
     c -96,  12, 113, 380, -58,  48, 381,-112, 420, -96, 432, 125,
     c -98,  10, 107, 376, -58,  42, 378,-115, 416, -91, 432, 123,
     c -97,  10, 102, 378, -56,  44, 376,-115, 413, -78, 433, 123,
     c -96,   8,  97, 378, -59,  39, 374,-115, 409, -65, 432, 123,
     c -92,   8,  96, 378, -56,  36, 372,-117, 407, -64, 429, 122,
     c -88,   5,  99, 380, -53,  40, 371,-120, 407, -72, 426, 124,
     c -86,   1, 103, 381, -52,  42, 370,-122, 408, -89, 424, 126,
     c -85,  -3, 106, 381, -47,  51, 369,-123, 408,-109, 424, 128,
     c -83,  -4, 112, 381, -43,  55, 372,-122, 409,-120, 427, 132,
     c -76,   0, 119, 381, -42,  58, 376,-118, 409,-118, 429, 135,
     c -69,   9, 121, 383, -38,  66, 381,-114, 411,-109, 434, 139,
     c -62,  19, 123, 387, -33,  70, 387,-106, 415, -98, 440, 146,
     c -55,  29, 126, 391, -26,  79, 394, -98, 424, -88, 449, 154,
     c -47,  37, 135, 396, -18,  87, 404, -89, 433, -84, 458, 163,
     c -32,  51, 155, 412,  -2, 111, 417, -77, 442, -89, 468, 172,
     c -25,  54, 164, 423,   8, 117, 428, -61, 450,-101, 478, 178,
     c -19,  58, 173, 435,  21, 122, 439, -51, 458,-119, 489, 184,
     c -59,  68, 168, 443, -16,  86, 428, -67, 467,   4, 488, 173,
     c -60,  65, 163, 440, -15,  80, 425, -71, 462, -39, 476, 167,
     c -60,  64, 160, 437, -17,  77, 422, -80, 458, -57, 467, 163,
     c -59,  62, 154, 430, -20,  73, 417, -86, 455, -47, 461, 159,
     c -62,  56, 148, 421, -26,  65, 410, -92, 452, -19, 458, 155,
     c -66,  49, 146, 413, -31,  62, 407, -97, 450,   9, 455, 151,
     c -72,  40, 142, 408, -33,  63, 405,-100, 446,  13, 453, 146,
     c -79,  31, 138, 404, -37,  60, 402,-102, 443, -12, 450, 141,
     c -85,  23, 132, 400, -41,  58, 395,-103, 440, -46, 447, 137,
     c -89,  17, 127, 397, -45,  54, 390,-105, 436, -62, 443, 132,
     c -92,  13, 123, 397, -49,  51, 384,-110, 431, -50, 440, 128,
     c -97,   9, 116, 392, -55,  46, 378,-114, 428, -21, 436, 123,
     c -99,   3, 108, 386, -61,  42, 373,-120, 424,  -7, 432, 120,
     c -99,   0, 101, 382, -63,  42, 371,-122, 421, -30, 429, 117,
     c -99,  -2,  98, 382, -64,  41, 371,-123, 419, -70, 426, 115,
     c-100,  -2,  99, 380, -67,  41, 369,-126, 416,-100, 425, 113,
     c-100,  -2,  99, 376, -68,  40, 368,-126, 413,-111, 425, 111,
     c-101,  -3,  97, 374, -66,  36, 366,-125, 411,-114, 426, 109,
     c-101,  -4,  94, 373, -65,  33, 365,-123, 407,-105, 426, 109,
     c -99,  -6,  91, 372, -66,  28, 364,-125, 404, -91, 425, 108,
     c -98,  -9,  90, 370, -67,  26, 362,-127, 402, -83, 422, 108,
     c -95, -12,  94, 373, -63,  27, 361,-131, 401, -84, 419, 110,
     c -95, -17,  97, 374, -62,  29, 360,-132, 400,-101, 417, 112,
     c -94, -23, 100, 373, -59,  32, 360,-134, 401,-128, 418, 114,
     c -92, -25, 107, 373, -57,  35, 362,-131, 401,-146, 420, 118,
     c -90, -22, 112, 377, -57,  42, 366,-132, 401,-145, 423, 122,
     c -83, -13, 115, 381, -51,  51, 369,-128, 404,-133, 427, 125,
     c -76,  -4, 114, 384, -46,  52, 376,-124, 409,-118, 434, 132,
     c -67,   5, 119, 388, -40,  62, 384,-115, 417,-102, 442, 141,
     c -58,  14, 129, 395, -33,  78, 394,-106, 427, -97, 453, 151,
     c -40,  30, 153, 410, -14, 104, 408, -92, 437,-102, 464, 161,
     c -32,  36, 162, 420,  -2, 112, 419, -77, 447,-114, 476, 168,
     c -23,  41, 173, 431,  11, 118, 431, -65, 456,-134, 488, 174,
     c -66,  52, 161, 434, -29,  73, 419, -87, 457,  19, 479, 161,
     c -67,  52, 157, 431, -28,  70, 418, -92, 453, -23, 468, 155,
     c -66,  51, 153, 428, -30,  67, 414, -96, 450, -43, 459, 151,
     c -66,  50, 145, 419, -35,  59, 408,-101, 447, -40, 453, 147,
     c -65,  48, 140, 412, -37,  53, 402,-105, 444, -21, 450, 143,
     c -68,  42, 137, 406, -38,  52, 397,-111, 441,  -1, 446, 140,
     c -76,  34, 130, 399, -41,  44, 392,-113, 439,   5, 443, 134,
     c -87,  22, 124, 392, -47,  41, 388,-118, 435, -14, 441, 129,
     c -96,  11, 117, 389, -53,  40, 382,-120, 431, -46, 438, 124,
     c -99,   3, 114, 388, -58,  40, 376,-123, 427, -64, 434, 119,
     c-103,  -1, 110, 385, -65,  36, 369,-128, 422, -49, 429, 114,
     c-108,  -7, 103, 382, -69,  33, 362,-130, 418, -20, 426, 110,
     c-108, -11,  95, 380, -71,  34, 358,-134, 415,  -1, 422, 107,
     c-108, -17,  88, 376, -74,  32, 355,-137, 412, -19, 419, 104,
     c-109, -20,  85, 375, -75,  30, 353,-140, 411, -60, 417, 101,
     c-111, -21,  88, 373, -78,  27, 354,-143, 409, -90, 416,  99,
     c-110, -22,  91, 369, -79,  27, 354,-143, 408,-109, 417,  97,
     c-111, -22,  91, 368, -78,  26, 354,-143, 405,-130, 418,  95,
     c-111, -25,  89, 364, -78,  21, 353,-141, 403,-141, 418,  94,
     c-110, -27,  90, 362, -80,  20, 352,-143, 399,-125, 417,  94,
     c-107, -28,  93, 363, -79,  18, 351,-143, 397,-111, 415,  94,
     c-107, -31,  95, 365, -76,  19, 351,-145, 396,-104, 412,  95,
     c-106, -35,  97, 364, -73,  18, 352,-144, 395,-118, 411,  98,
     c-104, -39, 101, 364, -73,  16, 354,-145, 395,-147, 412, 100,
     c-100, -41, 107, 367, -71,  25, 357,-145, 395,-170, 414, 104,
     c -97, -38, 111, 371, -67,  32, 358,-144, 395,-169, 417, 108,
     c -95, -32, 108, 374, -64,  37, 361,-141, 396,-153, 421, 111,
     c -88, -22, 107, 377, -60,  42, 365,-139, 402,-131, 427, 119,
     c -79, -13, 111, 380, -57,  47, 374,-132, 411,-110, 436, 127,
     c -67,  -2, 124, 388, -48,  61, 386,-120, 422,-103, 447, 138,
     c -46,  13, 147, 405, -27,  85, 401,-105, 432,-111, 460, 148,
     c -38,  19, 155, 414, -15,  94, 413, -90, 442,-127, 472, 156,
     c -28,  26, 166, 426,   0, 101, 425, -81, 451,-149, 485, 163,
     c -68,  45, 155, 427, -35,  65, 411, -98, 449,  27, 470, 149,
     c -69,  44, 150, 424, -37,  60, 408,-104, 445, -16, 459, 144,
     c -71,  43, 144, 420, -39,  56, 403,-108, 441, -41, 451, 139,
     c -71,  43, 138, 412, -45,  52, 396,-114, 438, -45, 445, 135,
     c -70,  45, 133, 406, -47,  47, 390,-120, 437, -35, 441, 131,
     c -71,  45, 131, 402, -47,  48, 384,-125, 434, -19, 438, 128,
     c -78,  37, 127, 394, -49,  41, 379,-128, 430,  -1, 434, 122,
     c -89,  25, 119, 384, -56,  33, 376,-133, 426,  -5, 432, 117,
     c -98,  12, 112, 380, -64,  30, 370,-138, 422, -25, 428, 112,
     c-104,   0, 108, 377, -71,  28, 363,-142, 417, -40, 424, 107,
     c-109,  -8, 104, 373, -77,  24, 356,-144, 412, -26, 418, 102,
     c-113, -15,  99, 372, -79,  21, 348,-146, 409,  -2, 413,  98,
     c-114, -20,  94, 374, -78,  25, 344,-150, 405,  17, 410,  94,
     c-116, -26,  87, 374, -80,  24, 340,-152, 404,  -2, 408,  91,
     c-119, -32,  81, 370, -84,  21, 340,-155, 403, -41, 406,  89,
     c-122, -37,  81, 364, -89,  14, 340,-158, 402, -76, 406,  87,
     c-122, -40,  87, 362, -90,  13, 341,-159, 401,-108, 407,  85,
     c-122, -43,  87, 359, -91,  13, 341,-158, 400,-149, 408,  82,
     c-121, -44,  88, 355, -92,   7, 342,-156, 398,-175, 410,  81,
     c-119, -44,  90, 352, -94,   7, 342,-157, 397,-167, 410,  81,
     c-116, -44,  96, 353, -91,   6, 343,-157, 395,-145, 409,  80,
     c-115, -44, 100, 357, -87,  10, 344,-156, 394,-127, 407,  82,
     c-113, -45, 103, 358, -83,  11, 346,-154, 393,-135, 407,  84,
     c-110, -49, 105, 358, -84,   9, 349,-153, 391,-166, 408,  87,
     c-106, -50, 108, 363, -82,  18, 352,-150, 391,-191, 411,  91,
     c-101, -47, 112, 368, -75,  24, 354,-151, 391,-187, 413,  95,
     c -98, -40, 107, 371, -70,  28, 357,-149, 392,-167, 416,  99,
     c -94, -31, 104, 373, -69,  31, 361,-147, 397,-141, 422, 106,
     c -86, -20, 109, 379, -64,  35, 369,-140, 405,-117, 431, 115,
     c -72, -10, 123, 388, -54,  48, 381,-129, 416,-110, 442, 125,
     c -54,   4, 142, 404, -34,  72, 396,-115, 427,-124, 456, 136,
     c -42,  11, 151, 412, -21,  74, 409, -98, 437,-140, 467, 144,
     c -31,  17, 160, 424,  -7,  85, 420, -89, 447,-162, 480, 152,
     c -72,  50, 143, 419, -41,  60, 404,-112, 443,  20, 462, 139,
     c -74,  49, 138, 414, -45,  52, 400,-118, 438, -26, 453, 134,
     c -77,  48, 132, 409, -47,  46, 395,-120, 435, -55, 445, 128,
     c -80,  49, 127, 404, -54,  45, 387,-127, 432, -67, 439, 124,
     c -78,  54, 126, 401, -54,  41, 381,-131, 429, -66, 434, 121,
     c -78,  56, 125, 397, -54,  40, 375,-136, 426, -45, 431, 116,
     c -80,  53, 124, 390, -58,  34, 372,-139, 422, -15, 427, 111,
     c -86,  41, 119, 381, -63,  31, 368,-145, 418,  -1, 425, 106,
     c -95,  25, 110, 373, -73,  23, 360,-149, 414, -10, 421, 101,
     c-102,   9, 104, 368, -81,  18, 353,-152, 408, -15, 415,  96,
     c-107,  -3, 102, 364, -86,  15, 348,-154, 403,  -8, 408,  90,
     c-113, -11,  99, 361, -87,   9, 340,-155, 399,  11, 403,  87,
     c-118, -19,  95, 364, -87,  11, 334,-157, 396,  22, 399,  83,
     c-121, -26,  88, 364, -90,  11, 331,-158, 394,   5, 396,  80,
     c-123, -36,  80, 360, -94,   7, 331,-163, 394, -36, 396,  79,
     c-128, -45,  79, 354,-100,   0, 331,-165, 393, -80, 396,  77,
     c-129, -52,  84, 355,-101,   6, 331,-169, 394,-128, 399,  74,
     c-125, -55,  86, 353,-101,   8, 332,-172, 394,-180, 400,  72,
     c-123, -57,  87, 351,-103,   6, 332,-171, 395,-217, 404,  70,
     c-120, -56,  92, 348,-105,   7, 334,-172, 394,-214, 405,  69,
     c-116, -53,  98, 349,-104,   6, 337,-169, 394,-183, 405,  69,
     c-117, -52, 102, 352,-100,   9, 339,-167, 394,-155, 404,  70,
     c-116, -53, 105, 352, -98,  10, 342,-164, 393,-159, 406,  73,
     c-112, -54, 105, 352, -95,   5, 347,-163, 392,-187, 408,  76,
     c-107, -55, 106, 358, -91,  13, 349,-159, 390,-210, 410,  79,
     c-104, -51, 108, 364, -85,  18, 352,-159, 390,-202, 412,  83,
     c-102, -43, 104, 367, -80,  20, 353,-157, 390,-181, 414,  87,
     c -97, -33, 103, 371, -74,  26, 357,-153, 394,-153, 419,  95,
     c -89, -24, 109, 378, -68,  31, 364,-147, 402,-129, 427, 104,
     c -77, -15, 122, 388, -57,  42, 376,-139, 413,-127, 439, 114,
     c -59,   0, 139, 403, -39,  62, 391,-123, 423,-147, 451, 125,
     c -48,   6, 146, 414, -27,  67, 402,-109, 433,-164, 463, 133,
     c -37,  13, 155, 425, -13,  75, 414,-100, 443,-183, 476, 141,
     c -73,  63, 134, 415, -51,  49, 401,-114, 436,   0, 456, 131,
     c -76,  60, 129, 409, -53,  44, 395,-121, 432, -56, 448, 125,
     c -81,  57, 123, 402, -57,  36, 388,-126, 428, -92, 441, 120,
     c -86,  57, 117, 395, -63,  31, 381,-133, 425,-106, 435, 115,
     c -86,  63, 117, 397, -65,  32, 374,-139, 422,-101, 430, 110,
     c -83,  69, 120, 396, -62,  33, 369,-143, 419, -72, 425, 106,
     c -81,  67, 120, 387, -66,  27, 366,-147, 416, -33, 422, 102,
     c -86,  56, 114, 377, -74,  20, 360,-151, 411,  -6, 419,  96,
     c -95,  38, 103, 368, -83,  18, 356,-157, 406,   1, 413,  91,
     c-101,  20,  97, 361, -89,  12, 347,-160, 400,  -2, 406,  86,
     c-107,   6,  94, 355, -94,   5, 342,-162, 395,  -4, 400,  81,
     c-115,  -3,  95, 352, -97,   0, 334,-165, 391,  12, 394,  77,
     c-123, -10,  92, 352, -99,  -2, 329,-168, 387,  21, 390,  73,
     c-125, -18,  87, 352,-102,  -4, 325,-169, 385,   0, 388,  71,
     c-128, -30,  80, 348,-107,  -9, 326,-172, 385, -53, 388,  69,
     c-131, -41,  79, 347,-109,  -9, 326,-174, 385,-110, 389,  68,
     c-131, -49,  82, 348,-110,  -3, 327,-176, 386,-164, 392,  66,
     c-127, -54,  84, 349,-109,  -1, 328,-177, 388,-218, 396,  64,
     c-124, -55,  86, 348,-110,   0, 328,-179, 391,-259, 400,  63,
     c-118, -54,  93, 348,-112,   3, 330,-178, 393,-253, 404,  61,
     c-115, -52,  99, 346,-114,   0, 333,-175, 394,-213, 405,  61,
     c-117, -52, 103, 347,-111,   5, 336,-172, 394,-176, 405,  61,
     c-117, -53, 105, 350,-107,   7, 340,-169, 394,-173, 406,  63,
     c-114, -56, 102, 349,-106,  -1, 343,-167, 393,-198, 409,  65,
     c-110, -56, 102, 352,-101,   6, 346,-163, 392,-211, 410,  68,
     c-108, -52, 100, 356, -95,   5, 348,-163, 391,-197, 411,  72,
     c-105, -44,  97, 360, -88,   9, 349,-163, 391,-174, 414,  76,
     c -99, -35,  99, 364, -80,  18, 353,-159, 395,-151, 418,  84,
     c -91, -26, 106, 372, -73,  21, 360,-152, 402,-130, 425,  93,
     c -83, -18, 116, 382, -64,  32, 370,-143, 412,-131, 435, 103,
     c -65,  -5, 130, 397, -48,  52, 384,-131, 422,-156, 448, 115,
     c -54,   1, 137, 409, -34,  58, 397,-116, 432,-171, 459, 123,
     c -44,   8, 145, 422, -21,  65, 408,-107, 441,-183, 470, 130,
     c -72,  73, 131, 415, -57,  43, 397,-124, 429, -20, 452, 122,
     c -76,  68, 124, 408, -60,  37, 389,-131, 423, -83, 445, 116,
     c -81,  63, 117, 400, -65,  29, 382,-136, 420,-123, 438, 110,
     c -87,  60, 110, 395, -71,  25, 374,-142, 416,-136, 431, 105,
     c -88,  62, 108, 395, -74,  22, 367,-148, 414,-130, 425, 100,
     c -88,  63, 109, 391, -73,  22, 362,-152, 412,-102, 421,  95,
     c -86,  61, 110, 383, -77,  18, 358,-159, 408, -56, 417,  91,
     c -92,  49, 103, 373, -85,  11, 353,-164, 404, -23, 413,  86,
     c-101,  32,  95, 365, -91,  11, 347,-169, 399,  -8, 407,  82,
     c-108,  13,  88, 357, -98,   4, 341,-173, 393, -13, 399,  76,
     c-113,   1,  86, 351,-104,  -3, 336,-177, 387, -10, 390,  72,
     c-120,  -4,  88, 347,-106,  -8, 330,-179, 382,   2, 386,  68,
     c-126,  -9,  89, 346,-108, -14, 324,-182, 378,  18, 383,  64,
     c-128, -14,  86, 345,-112, -17, 321,-184, 375, -13, 382,  61,
     c-130, -22,  80, 343,-115, -18, 320,-184, 375, -87, 383,  61,
     c-132, -31,  80, 345,-115, -15, 321,-181, 376,-155, 385,  60,
     c-132, -39,  81, 344,-115, -10, 323,-181, 379,-203, 388,  59,
     c-131, -43,  79, 346,-116, -10, 325,-181, 382,-248, 392,  58,
     c-126, -42,  81, 347,-118,  -4, 327,-183, 386,-283, 399,  57,
     c-119, -40,  89, 347,-119,  -4, 330,-181, 388,-264, 405,  57,
     c-117, -40,  97, 345,-120,  -4, 333,-180, 391,-217, 407,  55,
     c-117, -42,  98, 345,-117,   0, 335,-178, 393,-172, 407,  55,
     c-117, -47,  95, 345,-115,  -1, 338,-177, 393,-167, 407,  56,
     c-115, -51,  94, 347,-113,  -4, 340,-175, 393,-181, 408,  57,
     c-114, -52,  91, 348,-111,   0, 343,-172, 392,-184, 409,  59,
     c-111, -48,  90, 351,-105,  -1, 344,-171, 391,-161, 410,  62,
     c-107, -41,  89, 354, -97,   0, 345,-170, 392,-140, 412,  66,
     c-100, -33,  91, 360, -90,   6, 348,-167, 396,-123, 417,  74,
     c -93, -26,  97, 366, -83,   5, 356,-159, 403,-113, 423,  83,
     c -83, -20, 106, 376, -73,  14, 365,-149, 413,-121, 432,  93,
     c -65,  -7, 121, 393, -54,  36, 380,-137, 422,-147, 443, 105,
     c -56,  -1, 128, 405, -42,  43, 391,-124, 431,-158, 452, 112,
     c -45,   5, 136, 416, -29,  52, 402,-116, 440,-161, 463, 119,
     c -71,  79, 131, 417, -63,  32, 390,-128, 420, -32, 448, 114,
     c -76,  71, 123, 410, -67,  29, 382,-137, 415, -92, 442, 107,
     c -81,  63, 115, 402, -71,  22, 374,-145, 411,-129, 433, 101,
     c -88,  54, 106, 397, -76,  18, 366,-153, 408,-142, 426,  94,
     c -91,  48, 102, 395, -78,  15, 358,-159, 406,-143, 420,  88,
     c -94,  43,  99, 389, -82,   9, 351,-164, 403,-121, 415,  83,
     c -95,  36,  97, 378, -88,   4, 347,-171, 400, -78, 410,  80,
     c-102,  24,  92, 370, -93,  -1, 340,-177, 396, -53, 406,  75,
     c-112,   7,  85, 363, -97,   0, 334,-185, 391, -44, 400,  71,
     c-118,  -8,  80, 356,-103,  -2, 330,-190, 385, -42, 391,  66,
     c-124, -18,  77, 347,-109, -12, 325,-194, 379, -26, 383,  62,
     c-128, -21,  81, 343,-113, -16, 321,-196, 374, -12, 378,  58,
     c-132, -19,  85, 344,-115, -17, 316,-196, 369,  -2, 377,  54,
     c-131, -20,  83, 344,-117, -19, 313,-196, 367, -42, 377,  52,
     c-131, -23,  80, 342,-118, -22, 313,-194, 366,-127, 378,  51,
     c-133, -28,  77, 342,-117, -22, 316,-191, 367,-206, 381,  52,
     c-131, -31,  77, 346,-116, -15, 321,-188, 370,-244, 385,  52,
     c-128, -30,  76, 347,-118, -15, 323,-186, 373,-262, 391,  53,
     c-123, -27,  76, 347,-121, -12, 327,-186, 379,-264, 399,  53,
     c-119, -24,  81, 345,-124, -12, 330,-184, 383,-231, 405,  53,
     c-117, -25,  87, 347,-123,  -6, 331,-182, 387,-174, 408,  52,
     c-117, -29,  90, 345,-120,  -2, 333,-182, 390,-129, 407,  51,
     c-118, -36,  85, 344,-120,  -5, 335,-182, 390,-127, 407,  51,
     c-119, -41,  81, 346,-119,  -6, 336,-182, 390,-145, 407,  51,
     c-118, -44,  79, 350,-115,  -3, 337,-179, 391,-144, 408,  52,
     c-115, -42,  80, 354,-111,   0, 337,-179, 391,-123, 409,  54,
     c-108, -37,  81, 357,-104,   2, 339,-175, 392,-111, 411,  57,
     c-103, -32,  83, 362, -97,   5, 343,-170, 397,-106, 416,  65,
     c -96, -28,  86, 367, -91,   7, 350,-162, 405,-108, 421,  74,
     c -84, -21,  97, 376, -78,  14, 360,-153, 413,-121, 429,  84,
     c -69, -10, 111, 390, -60,  32, 374,-142, 422,-144, 438,  94,
     c -60,  -3, 117, 400, -49,  37, 384,-129, 429,-149, 446, 101,
     c -51,   3, 124, 412, -36,  43, 395,-121, 438,-144, 455, 107,
     c -76,  76, 126, 415, -68,  20, 381,-140, 413, -17, 445, 107,
     c -81,  67, 117, 407, -73,  15, 373,-153, 407, -62, 438,  99,
     c -86,  58, 109, 401, -76,  10, 365,-160, 403, -89, 430,  92,
     c -93,  44,  99, 397, -79,   8, 356,-167, 400,-104, 422,  84,
     c-100,  30,  92, 392, -85,   4, 348,-174, 398,-108, 415,  78,
     c-102,  18,  85, 383, -91,  -4, 341,-178, 396, -91, 410,  72,
     c-107,   8,  81, 375, -97,  -8, 335,-183, 393, -72, 404,  69,
     c-115,  -4,  76, 368,-100, -10, 329,-192, 390, -64, 400,  65,
     c-126, -19,  70, 362,-105, -11, 324,-201, 385, -68, 393,  60,
     c-133, -34,  64, 352,-108, -14, 320,-209, 379, -53, 385,  56,
     c-136, -41,  64, 345,-113, -22, 316,-212, 373, -29, 377,  53,
     c-139, -40,  69, 341,-119, -25, 313,-213, 367,  -8, 372,  48,
     c-139, -36,  72, 340,-122, -28, 311,-213, 363, -13, 371,  44,
     c-136, -32,  71, 339,-122, -29, 308,-210, 359, -63, 371,  42,
     c-134, -30,  68, 337,-121, -31, 309,-207, 359,-161, 373,  41,
     c-134, -29,  67, 338,-119, -30, 312,-200, 359,-246, 375,  42,
     c-131, -26,  70, 343,-120, -24, 316,-195, 363,-272, 382,  44,
     c-126, -21,  72, 347,-121, -20, 320,-192, 367,-254, 389,  46,
     c-120, -14,  72, 348,-124, -16, 325,-189, 371,-229, 397,  48,
     c-117,  -9,  75, 349,-126, -13, 327,-186, 377,-177, 406,  49,
     c-115, -10,  79, 351,-124,  -6, 330,-184, 381,-112, 409,  49,
     c-117, -15,  79, 349,-121,  -5, 330,-184, 385, -74, 408,  48,
     c-119, -22,  77, 347,-121,  -9, 331,-188, 386, -85, 407,  48,
     c-119, -30,  72, 347,-121, -10, 332,-188, 388,-112, 408,  48,
     c-120, -35,  69, 350,-118,  -6, 332,-187, 389,-120, 408,  48,
     c-118, -38,  70, 354,-114,  -3, 334,-185, 390,-112, 409,  49,
     c-112, -36,  72, 358,-109,   0, 337,-182, 393,-116, 412,  51,
     c-105, -33,  78, 363,-103,   4, 340,-175, 398,-125, 417,  58,
     c -99, -29,  83, 368, -94,   7, 347,-168, 406,-135, 421,  66,
     c -90, -24,  90, 375, -84,  12, 356,-161, 414,-152, 426,  75,
     c -76, -12, 103, 387, -67,  24, 366,-150, 421,-172, 434,  84,
     c -68,  -5, 108, 397, -56,  27, 377,-137, 428,-171, 442,  89,
     c -60,   0, 113, 408, -44,  28, 388,-129, 435,-157, 449,  94,
     c -76,  67, 123, 417, -72,  16, 374,-151, 407, -13, 443,  99,
     c -81,  56, 113, 407, -76,   7, 367,-165, 402, -39, 436,  91,
     c -86,  47, 105, 402, -79,   4, 358,-174, 399, -54, 429,  84,
     c -94,  31,  93, 394, -83,  -2, 348,-182, 396, -54, 422,  76,
     c-103,  15,  84, 388, -91,  -9, 339,-185, 394, -53, 415,  69,
     c-107,   2,  78, 380, -97, -15, 334,-189, 391, -43, 408,  63,
     c-107,  -6,  74, 374,-102, -17, 327,-193, 389, -44, 402,  59,
     c-114, -15,  70, 370,-105, -17, 322,-198, 385, -60, 398,  55,
     c-127, -29,  61, 362,-109, -21, 318,-207, 380, -78, 390,  51,
     c-136, -42,  54, 351,-112, -28, 316,-216, 375, -59, 382,  47,
     c-139, -50,  53, 342,-118, -35, 313,-219, 369, -28, 374,  43,
     c-140, -51,  58, 341,-122, -33, 310,-221, 364,  -4, 369,  39,
     c-140, -47,  58, 337,-127, -34, 309,-221, 359, -16, 368,  35,
     c-137, -41,  56, 332,-129, -37, 307,-220, 357, -73, 368,  33,
     c-137, -35,  53, 329,-128, -41, 306,-216, 356,-181, 369,  32,
     c-135, -28,  56, 332,-124, -38, 307,-210, 356,-268, 372,  34,
     c-132, -22,  59, 335,-125, -33, 312,-207, 358,-283, 377,  36,
     c-128, -14,  62, 338,-127, -28, 315,-203, 361,-248, 387,  40,
     c-123,  -7,  66, 344,-126, -24, 320,-197, 367,-200, 396,  42,
     c-117,  -2,  71, 351,-123, -14, 323,-192, 372,-134, 406,  45,
     c-117,  -2,  71, 353,-124,  -9, 326,-188, 377, -71, 411,  46,
     c-118,  -6,  70, 352,-123, -11, 328,-187, 382, -43, 410,  46,
     c-117, -13,  70, 354,-119,  -5, 330,-189, 385, -69, 409,  46,
     c-117, -22,  67, 354,-119, -10, 331,-190, 387,-108, 409,  46,
     c-119, -29,  64, 354,-119, -11, 332,-187, 389,-129, 410,  46,
     c-117, -33,  65, 354,-116,  -5, 332,-187, 391,-132, 412,  47,
     c-111, -34,  70, 360,-111,   0, 335,-183, 395,-145, 415,  48,
     c-103, -32,  79, 365,-104,   2, 339,-178, 400,-163, 419,  54,
     c -99, -28,  85, 370, -96,  12, 345,-172, 408,-178, 422,  60,
     c -95, -23,  89, 374, -88,  15, 351,-165, 414,-191, 426,  67,
     c -80,  -9, 100, 386, -74,  23, 361,-155, 419,-198, 432,  74,
     c -75,  -4, 103, 396, -66,  26, 370,-144, 425,-193, 437,  78,
     c -69,   0, 107, 406, -56,  22, 378,-137, 431,-179, 443,  81,
     c -78,  52, 117, 418, -76,  12, 371,-163, 406, -32, 446,  94,
     c -83,  43, 108, 409, -79,   0, 363,-175, 402, -24, 439,  85,
     c -88,  35, 100, 402, -83,   0, 355,-184, 397, -18, 433,  78,
     c -96,  22,  88, 394, -87,  -7, 345,-188, 394,  -9, 427,  71,
     c-103,   9,  80, 386, -95, -14, 338,-193, 392, -11, 420,  64,
     c-106,   0,  77, 380,-103, -18, 331,-194, 391,  -5, 413,  58,
     c-104,  -3,  75, 375,-106, -24, 328,-199, 387, -20, 406,  53,
     c-106,  -6,  70, 372,-110, -27, 323,-204, 384, -66, 399,  48,
     c-116, -14,  60, 363,-114, -31, 319,-210, 379,-104, 392,  44,
     c-125, -27,  51, 351,-119, -39, 317,-217, 374, -88, 383,  40,
     c-129, -38,  50, 345,-122, -41, 316,-218, 369, -54, 375,  36,
     c-134, -46,  52, 341,-126, -38, 314,-224, 364, -40, 371,  32,
     c-134, -46,  51, 337,-129, -38, 312,-225, 360, -55, 369,  29,
     c-132, -40,  47, 332,-135, -40, 309,-225, 357,-111, 370,  26,
     c-131, -33,  46, 328,-136, -45, 307,-223, 356,-210, 369,  26,
     c-133, -24,  50, 329,-131, -43, 308,-220, 355,-288, 370,  27,
     c-133, -18,  53, 330,-130, -39, 309,-215, 357,-292, 375,  29,
     c-128, -14,  55, 331,-131, -38, 312,-212, 360,-245, 384,  34,
     c-124, -11,  58, 339,-127, -32, 315,-204, 363,-184, 396,  37,
     c-119,  -9,  64, 349,-121, -20, 320,-198, 368,-115, 406,  41,
     c-116,  -8,  64, 354,-119, -15, 324,-194, 374, -60, 411,  43,
     c-113,  -8,  63, 355,-117, -19, 328,-191, 379, -45, 411,  45,
     c-110, -10,  62, 359,-116, -12, 330,-191, 383, -86, 411,  46,
     c-109, -13,  63, 362,-115, -12, 332,-189, 387,-133, 412,  46,
     c-109, -19,  62, 362,-115, -13, 335,-186, 389,-163, 413,  47,
     c-108, -24,  63, 360,-114,  -8, 335,-187, 393,-175, 414,  47,
     c-102, -25,  69, 365,-110,  -1, 338,-182, 397,-195, 417,  48,
     c -98, -24,  76, 371,-105,   5, 340,-179, 402,-209, 419,  52,
     c -94, -20,  85, 376, -97,  15, 344,-174, 407,-221, 421,  55,
     c -88, -13,  90, 380, -91,  20, 349,-168, 412,-230, 424,  60,
     c -78,  -3,  96, 388, -82,  27, 356,-161, 417,-228, 428,  65,
     c -76,   0,  98, 396, -76,  27, 362,-149, 422,-223, 433,  67,
     c -71,   5, 102, 407, -69,  24, 369,-144, 426,-212, 438,  69,
     c -78,  44, 117, 423, -80,  11, 373,-159, 409, -80, 450,  91,
     c -81,  38, 112, 416, -82,   3, 365,-169, 404, -41, 444,  84,
     c -86,  32, 104, 408, -86,   1, 358,-182, 400, -16, 438,  76,
     c -93,  24,  93, 400, -88,  -5, 349,-188, 397,  -2, 434,  69,
     c -98,  17,  86, 393, -93, -10, 343,-194, 394,   0, 428,  62,
     c -99,  13,  83, 385,-103, -12, 337,-195, 391,   0, 419,  56,
     c -96,  14,  82, 382,-107, -17, 331,-199, 388, -21, 411,  50,
     c -98,  16,  78, 379,-111, -17, 327,-202, 384, -87, 403,  44,
     c-105,  12,  68, 370,-116, -25, 324,-206, 380,-143, 395,  40,
     c-110,   2,  59, 360,-120, -31, 321,-211, 375,-139, 387,  35,
     c-117, -11,  54, 351,-123, -39, 321,-214, 371,-105, 381,  32,
     c-123, -24,  54, 348,-127, -38, 318,-220, 368, -98, 376,  28,
     c-124, -32,  53, 342,-131, -40, 317,-223, 364,-120, 376,  26,
     c-122, -30,  50, 338,-133, -41, 314,-227, 362,-158, 376,  23,
     c-124, -24,  49, 333,-135, -44, 312,-226, 360,-227, 373,  23,
     c-129, -19,  51, 334,-134, -43, 311,-227, 359,-288, 373,  23,
     c-129, -18,  52, 333,-130, -38, 310,-225, 359,-290, 377,  25,
     c-126, -22,  53, 333,-128, -35, 313,-220, 360,-231, 385,  29,
     c-125, -27,  53, 336,-124, -34, 315,-214, 364,-159, 395,  33,
     c-122, -29,  56, 347,-116, -24, 320,-207, 368, -91, 404,  37,
     c-116, -26,  56, 355,-113, -19, 324,-204, 372, -48, 410,  41,
     c-109, -18,  56, 359,-110, -19, 328,-196, 377, -53, 410,  43,
     c-104,  -9,  59, 362,-110, -14, 331,-192, 382,-108, 410,  45,
     c -99,  -3,  64, 368,-110,  -9, 335,-189, 386,-167, 412,  46,
     c -95,  -2,  64, 371,-110,  -6, 338,-185, 390,-207, 414,  47,
     c -95,  -5,  65, 369,-110,  -3, 340,-184, 393,-227, 416,  48,
     c -96,  -7,  70, 371,-108,  -2, 341,-182, 396,-246, 418,  48,
     c -93,  -7,  75, 374,-105,   4, 341,-179, 400,-260, 419,  49,
     c -87,  -3,  81, 378,-100,  15, 344,-178, 405,-265, 420,  51,
     c -83,   0,  84, 378, -97,  18, 346,-174, 409,-259, 421,  53,
     c -77,   6,  89, 384, -91,  23, 350,-169, 412,-252, 424,  55,
     c -76,   7,  89, 390, -87,  21, 354,-163, 415,-246, 428,  56,
     c -75,   8,  89, 397, -83,  19, 359,-157, 419,-242, 432,  56,
     c -69,  43, 128, 425, -82,   8, 377,-160, 412,-120, 452,  90,
     c -72,  41, 123, 417, -84,   1, 372,-169, 408, -60, 447,  84,
     c -76,  39, 116, 410, -86,  -1, 366,-179, 404, -24, 442,  76,
     c -81,  36, 106, 407, -89,  -3, 359,-187, 400, -13, 438,  69,
     c -87,  31,  99, 400, -92,  -6, 351,-194, 397,  -3, 434,  63,
     c -87,  27,  93, 392, -98, -10, 346,-198, 394,   7, 425,  56,
     c -89,  27,  88, 387,-104, -14, 340,-203, 389, -28, 415,  49,
     c -91,  31,  84, 384,-111, -13, 334,-204, 386,-102, 406,  43,
     c -98,  32,  77, 377,-117, -20, 329,-206, 382,-166, 399,  38,
     c-104,  25,  67, 369,-119, -28, 326,-209, 379,-165, 392,  33,
     c-108,  11,  61, 362,-121, -35, 324,-209, 376,-153, 387,  30,
     c-114,  -5,  61, 357,-125, -35, 321,-214, 372,-149, 384,  27,
     c-116, -16,  60, 352,-128, -38, 319,-219, 370,-164, 386,  25,
     c-115, -20,  56, 346,-128, -39, 318,-224, 367,-177, 385,  23,
     c-117, -17,  54, 342,-129, -42, 318,-224, 365,-222, 383,  23,
     c-119, -14,  56, 341,-128, -41, 317,-226, 364,-262, 380,  23,
     c-118, -17,  56, 341,-124, -33, 316,-227, 363,-264, 382,  24,
     c-119, -29,  53, 339,-121, -35, 317,-225, 364,-210, 388,  27,
     c-121, -43,  51, 339,-118, -34, 319,-220, 366,-135, 396,  31,
     c-118, -49,  51, 347,-114, -26, 325,-211, 369, -68, 405,  35,
     c-115, -44,  50, 357,-110, -18, 327,-207, 373, -37, 410,  38,
     c-109, -29,  51, 361,-108, -17, 330,-201, 377, -56, 409,  41,
     c-100,  -8,  59, 365,-107, -11, 335,-195, 381,-123, 408,  44,
     c -93,   8,  66, 369,-106,  -5, 338,-193, 385,-194, 410,  45,
     c -88,  16,  69, 371,-108,  -1, 342,-188, 388,-239, 413,  46,
     c -90,  17,  69, 370,-109,   1, 342,-185, 392,-262, 415,  47,
     c -91,  15,  72, 371,-108,  -3, 344,-183, 395,-280, 417,  46,
     c -88,  13,  75, 372,-106,   1, 343,-182, 398,-289, 417,  46,
     c -84,  12,  78, 371,-104,   2, 342,-182, 400,-283, 417,  47,
     c -84,  11,  79, 370,-105,   4, 342,-182, 402,-272, 416,  46,
     c -81,  13,  82, 373,-102,  12, 343,-179, 405,-260, 418,  46,
     c -82,   9,  80, 376,-100,   6, 344,-176, 406,-257, 419,  45,
     c -82,   7,  80, 380, -97,   3, 348,-172, 409,-260, 422,  44,
     c -60,  41, 141, 428, -80,   7, 384,-157, 415,-156, 453,  90,
     c -60,  42, 137, 422, -81,   0, 380,-165, 411, -84, 449,  84,
     c -61,  43, 132, 418, -82,   1, 374,-175, 407, -41, 444,  78,
     c -62,  44, 122, 414, -84,  -2, 368,-183, 404, -29, 443,  71,
     c -67,  39, 111, 406, -89,  -6, 363,-192, 399, -23, 439,  64,
     c -72,  33, 103, 399, -93, -13, 356,-197, 395, -10, 431,  57,
     c -80,  29,  93, 391,-101, -19, 349,-202, 391, -42, 421,  49,
     c -87,  28,  85, 384,-109, -23, 342,-207, 388,-117, 412,  43,
     c -96,  30,  79, 378,-115, -26, 334,-207, 384,-186, 404,  37,
     c-101,  28,  72, 373,-119, -25, 329,-213, 382,-190, 396,  32,
     c-103,  18,  68, 370,-120, -29, 326,-212, 379,-188, 394,  29,
     c-106,   3,  68, 365,-121, -33, 323,-215, 378,-190, 392,  27,
     c-110, -10,  66, 358,-123, -38, 322,-218, 376,-195, 394,  26,
     c-109, -15,  61, 356,-125, -39, 323,-223, 374,-182, 395,  25,
     c-107, -13,  59, 354,-124, -39, 322,-222, 372,-207, 392,  25,
     c-108, -11,  60, 352,-122, -39, 323,-223, 370,-234, 389,  24,
     c-107, -17,  59, 350,-121, -33, 323,-223, 369,-237, 389,  25,
     c-109, -32,  53, 346,-120, -37, 323,-223, 369,-190, 392,  27,
     c-112, -48,  50, 345,-118, -32, 325,-219, 371,-125, 399,  30,
     c-114, -57,  49, 350,-113, -30, 327,-212, 373, -62, 406,  33,
     c-112, -51,  47, 355,-112, -27, 330,-211, 374, -39, 409,  36,
     c-108, -31,  49, 356,-110, -28, 331,-206, 376, -68, 407,  39,
     c-102,  -4,  58, 360,-107, -26, 336,-203, 380,-142, 405,  41,
     c -93,  19,  69, 367,-104, -15, 338,-198, 383,-213, 407,  42,
     c -87,  32,  75, 367,-106, -11, 341,-195, 386,-257, 410,  43,
     c -86,  35,  76, 366,-107, -11, 342,-192, 387,-278, 410,  43,
     c -89,  31,  75, 367,-108, -15, 341,-190, 389,-290, 411,  42,
     c -89,  26,  76, 369,-109, -12, 340,-190, 391,-287, 411,  41,
     c -88,  20,  77, 364,-110, -15, 338,-193, 392,-271, 409,  40,
     c -88,  15,  77, 360,-113, -14, 336,-194, 393,-254, 407,  37,
     c -87,  11,  79, 363,-113,  -6, 334,-194, 394,-238, 406,  36,
     c -90,   5,  75, 363,-113, -13, 333,-195, 395,-242, 407,  33,
     c -93,   0,  74, 364,-113, -15, 333,-194, 396,-256, 408,  30,
     c -63,  30, 141, 424, -83,   3, 384,-167, 416,-149, 457,  90,
     c -61,  35, 137, 421, -83,   0, 381,-171, 413, -73, 452,  85,
     c -59,  40, 133, 420, -83,   0, 379,-176, 410, -31, 450,  79,
     c -55,  43, 123, 416, -83,  -6, 375,-183, 407, -28, 449,  73,
     c -55,  41, 113, 411, -86, -10, 371,-191, 403, -31, 446,  65,
     c -63,  32, 104, 403, -92, -17, 365,-197, 398, -23, 438,  58,
     c -76,  23,  95, 395, -98, -24, 358,-205, 393, -55, 428,  50,
     c -87,  20,  85, 385,-106, -28, 350,-209, 389,-133, 417,  43,
     c -94,  21,  76, 377,-114, -34, 341,-211, 387,-194, 408,  37,
     c -95,  23,  74, 375,-116, -31, 335,-216, 385,-202, 402,  32,
     c -98,  18,  70, 376,-117, -30, 328,-216, 383,-210, 398,  29,
     c-102,   5,  69, 370,-118, -33, 326,-216, 382,-223, 399,  27,
     c-105,  -7,  66, 366,-120, -38, 325,-218, 381,-217, 401,  28,
     c-104, -15,  62, 365,-122, -40, 325,-219, 379,-194, 402,  27,
     c-102, -14,  63, 365,-121, -37, 326,-217, 377,-196, 400,  27,
     c-102, -12,  63, 364,-119, -38, 328,-219, 376,-213, 396,  27,
     c -99, -15,  62, 363,-119, -34, 328,-221, 375,-211, 395,  27,
     c -98, -24,  58, 359,-118, -34, 328,-222, 376,-169, 397,  28,
     c-101, -37,  55, 358,-115, -31, 330,-220, 376,-113, 402,  29,
     c-104, -44,  54, 359,-113, -31, 330,-214, 376, -76, 406,  32,
     c-105, -39,  52, 359,-112, -30, 332,-215, 377, -63, 407,  34,
     c-105, -22,  53, 357,-110, -30, 333,-210, 377, -98, 404,  35,
     c-104,   0,  59, 356,-110, -30, 334,-208, 378,-179, 400,  36,
     c -96,  21,  69, 361,-108, -20, 337,-205, 378,-252, 402,  36,
     c -88,  34,  75, 360,-105, -17, 337,-203, 380,-281, 403,  36,
     c -90,  35,  75, 359,-108, -19, 338,-201, 381,-284, 403,  35,
     c -95,  29,  72, 360,-110, -26, 337,-203, 380,-284, 403,  33,
     c -96,  21,  69, 359,-115, -22, 333,-202, 380,-273, 401,  31,
     c -96,  15,  71, 357,-118, -23, 330,-207, 380,-246, 397,  28,
     c -98,   6,  72, 351,-123, -22, 326,-207, 379,-218, 392,  24,
     c -99,   0,  72, 352,-123, -16, 323,-210, 379,-211, 390,  20,
     c-106,  -8,  68, 349,-123, -29, 318,-215, 378,-216, 388,  16,
     c-111, -16,  65, 346,-126, -34, 315,-216, 378,-236, 388,  12,
     c -65,  21, 131, 421, -90,  -7, 384,-171, 416,-111, 461,  90,
     c -63,  27, 126, 420, -88, -11, 382,-175, 413, -42, 457,  84,
     c -61,  34, 123, 419, -85,  -8, 381,-180, 411, -11, 455,  79,
     c -53,  41, 115, 419, -86, -13, 380,-185, 408, -24, 456,  73,
     c -51,  41, 110, 416, -87, -13, 376,-193, 405, -37, 454,  67,
     c -59,  34, 104, 411, -93, -13, 372,-200, 400, -43, 447,  60,
     c -70,  26,  98, 403, -98, -18, 366,-209, 396, -73, 436,  54,
     c -80,  20,  89, 394,-103, -25, 356,-213, 393,-133, 425,  46,
     c -85,  20,  82, 387,-111, -30, 349,-217, 389,-174, 416,  39,
     c -87,  23,  79, 384,-112, -27, 341,-221, 387,-181, 409,  34,
     c -91,  21,  76, 383,-112, -26, 334,-220, 385,-186, 405,  30,
     c -95,  12,  71, 379,-116, -29, 331,-219, 385,-200, 404,  29,
     c -96,   0,  67, 377,-116, -33, 330,-218, 384,-201, 407,  30,
     c -97,  -9,  64, 377,-115, -33, 330,-216, 383,-177, 409,  30,
     c -98, -11,  64, 377,-115, -31, 330,-214, 382,-167, 406,  30,
     c -96,  -9,  65, 376,-116, -33, 329,-214, 382,-177, 402,  29,
     c -90,  -6,  64, 376,-113, -32, 330,-215, 381,-177, 402,  28,
     c -91,  -8,  63, 373,-112, -30, 329,-215, 381,-140, 402,  29,
     c -93, -11,  64, 371,-111, -29, 330,-216, 381,-108, 404,  29,
     c -95, -15,  63, 370,-110, -31, 332,-215, 380, -98, 407,  29,
     c -96, -13,  61, 368,-109, -29, 332,-218, 378,-103, 407,  30,
     c-101,  -7,  59, 362,-111, -34, 332,-216, 376,-143, 402,  29,
     c-103,   3,  60, 356,-112, -37, 332,-216, 375,-223, 396,  29,
     c -98,  13,  66, 356,-111, -32, 331,-216, 373,-286, 395,  27,
     c -93,  16,  69, 355,-111, -28, 332,-216, 371,-297, 394,  25,
     c -99,  14,  65, 351,-112, -29, 330,-217, 370,-283, 392,  22,
     c-107,   7,  57, 345,-120, -39, 327,-222, 368,-269, 390,  18,
     c-108,   0,  54, 343,-128, -39, 324,-224, 365,-246, 386,  14,
     c-110,  -5,  56, 340,-130, -42, 319,-229, 362,-213, 379,  10,
     c-117, -12,  59, 335,-133, -42, 312,-232, 359,-180, 371,   3,
     c-121, -19,  57, 332,-135, -40, 306,-237, 358,-177, 366,  -2,
     c-130, -29,  53, 327,-140, -52, 299,-240, 357,-186, 362,  -7,
     c-138, -39,  47, 319,-144, -59, 293,-243, 356,-207, 361, -11,
     c -63,  19, 117, 422, -95,  -7, 383,-180, 413, -85, 462,  86,
     c -60,  27, 115, 422, -91,  -8, 384,-181, 412, -26, 460,  81,
     c -57,  34, 112, 421, -88,  -9, 385,-183, 411,  -6, 460,  77,
     c -51,  42, 106, 420, -91, -13, 384,-186, 410, -41, 462,  73,
     c -48,  47, 109, 419, -90, -13, 381,-191, 407, -77, 461,  68,
     c -54,  45, 107, 417, -93, -17, 376,-198, 404, -88, 455,  62,
     c -63,  38, 103, 410, -99, -18, 371,-204, 399,-118, 444,  56,
     c -71,  33,  98, 402,-104, -23, 362,-210, 396,-163, 434,  48,
     c -76,  31,  95, 397,-106, -26, 354,-215, 393,-172, 425,  41,
     c -79,  32,  91, 394,-109, -24, 349,-220, 390,-154, 417,  35,
     c -83,  31,  85, 389,-111, -25, 343,-220, 388,-162, 412,  31,
     c -86,  23,  79, 384,-113, -30, 339,-221, 387,-186, 411,  30,
     c -86,  12,  73, 384,-113, -30, 336,-219, 387,-188, 414,  30,
     c -88,   0,  67, 384,-113, -31, 336,-215, 386,-175, 414,  31,
     c -89,  -4,  65, 384,-112, -30, 335,-212, 385,-162, 413,  30,
     c -89,  -3,  64, 381,-113, -36, 334,-212, 386,-163, 409,  29,
     c -86,   3,  63, 381,-112, -35, 332,-212, 386,-156, 408,  27,
     c -85,  11,  64, 378,-113, -32, 332,-214, 386,-132, 407,  27,
     c -86,  18,  70, 377,-112, -31, 333,-215, 385,-118, 408,  25,
     c -86,  20,  71, 375,-110, -33, 332,-217, 383,-134, 410,  25,
     c -89,  16,  68, 372,-110, -35, 331,-220, 380,-148, 408,  23,
     c -97,  10,  63, 365,-115, -40, 328,-221, 375,-184, 401,  21,
     c-102,   4,  61, 357,-118, -47, 325,-223, 371,-253, 394,  18,
     c-102,  -2,  60, 353,-120, -44, 321,-226, 366,-291, 390,  14,
     c-103,  -9,  57, 348,-123, -45, 319,-228, 362,-277, 387,  10,
     c-110, -17,  50, 342,-125, -47, 315,-233, 358,-252, 381,   5,
     c-118, -23,  40, 334,-133, -57, 310,-241, 353,-228, 375,  -1,
     c-122, -28,  33, 326,-142, -62, 303,-245, 348,-201, 367,  -7,
     c-128, -31,  36, 321,-148, -66, 296,-253, 344,-164, 356, -13,
     c-137, -35,  36, 317,-150, -66, 289,-256, 339,-144, 345, -21,
     c-146, -42,  35, 310,-155, -72, 280,-264, 334,-145, 337, -29,
     c-155, -51,  27, 301,-162, -86, 272,-268, 332,-153, 332, -35,
     c-165, -61,  20, 292,-167, -96, 266,-275, 330,-174, 329, -40,
     c -55,  28, 108, 422,-100, -11, 383,-183, 409, -80, 462,  79,
     c -52,  35, 108, 423, -96,  -9, 386,-185, 410, -33, 461,  76,
     c -48,  43, 109, 423, -92, -11, 387,-188, 409, -26, 462,  73,
     c -45,  52, 108, 422, -90, -11, 387,-187, 409, -74, 465,  71,
     c -43,  59, 115, 421, -89, -12, 386,-191, 409,-127, 467,  68,
     c -48,  60, 117, 419, -91, -13, 380,-197, 408,-154, 462,  63,
     c -55,  58, 116, 414, -95, -16, 374,-203, 404,-179, 452,  58,
     c -61,  53, 110, 408,-101, -23, 367,-209, 401,-199, 442,  51,
     c -65,  50, 108, 404,-103, -27, 360,-214, 397,-187, 432,  43,
     c -69,  49, 105, 402,-106, -22, 356,-220, 393,-157, 425,  37,
     c -73,  47,  99, 396,-108, -25, 350,-223, 390,-161, 420,  32,
     c -76,  41,  90, 391,-110, -29, 346,-223, 390,-191, 418,  30,
     c -76,  31,  81, 390,-112, -28, 344,-221, 389,-204, 418,  30,
     c -77,  20,  73, 390,-113, -30, 342,-219, 389,-193, 419,  31,
     c -77,  12,  70, 390,-110, -30, 340,-216, 389,-182, 417,  29,
     c -79,  12,  65, 388,-111, -34, 339,-214, 390,-182, 414,  27,
     c -80,  20,  63, 385,-114, -36, 337,-213, 390,-163, 411,  26,
     c -78,  33,  65, 382,-115, -33, 336,-215, 389,-135, 408,  23,
     c -78,  45,  72, 382,-114, -32, 334,-219, 389,-137, 408,  20,
     c -81,  49,  73, 378,-114, -33, 331,-222, 385,-163, 409,  18,
     c -86,  43,  71, 375,-116, -35, 327,-227, 379,-173, 405,  15,
     c -96,  27,  64, 366,-120, -44, 322,-232, 373,-200, 396,  11,
     c-103,   7,  60, 357,-123, -50, 315,-239, 366,-253, 389,   6,
     c-109, -13,  53, 350,-129, -55, 308,-246, 360,-276, 383,   0,
     c-113, -29,  48, 343,-133, -55, 302,-252, 352,-243, 377,  -6,
     c-121, -40,  38, 337,-138, -61, 294,-258, 346,-207, 368, -13,
     c-128, -48,  26, 326,-147, -68, 287,-267, 339,-189, 358, -22,
     c-136, -50,  18, 315,-156, -77, 279,-274, 332,-171, 347, -31,
     c-145, -50,  17, 307,-162, -84, 271,-284, 324,-142, 333, -39,
     c-154, -53,  11, 302,-169, -82, 262,-293, 317,-126, 318, -48,
     c-165, -61,   3, 291,-179, -95, 250,-301, 312,-134, 308, -57,
     c-173, -69,  -3, 280,-186,-111, 243,-310, 308,-145, 301, -64,
     c-182, -77, -11, 271,-193,-119, 236,-316, 304,-166, 296, -70,
     c -52,  34, 102, 420,-109, -17, 382,-184, 404, -52, 457,  72,
     c -48,  42, 102, 420,-105, -16, 385,-188, 406, -17, 458,  72,
     c -44,  49, 103, 422, -99, -16, 388,-189, 408, -23, 460,  70,
     c -41,  59, 107, 424, -94, -11, 389,-190, 410, -82, 465,  69,
     c -39,  67, 116, 424, -90, -13, 387,-191, 411,-143, 468,  67,
     c -44,  71, 121, 423, -91, -13, 383,-196, 410,-175, 465,  64,
     c -52,  69, 121, 419, -94, -13, 377,-200, 408,-203, 455,  59,
     c -54,  67, 116, 415,-100, -17, 370,-208, 405,-225, 445,  52,
     c -58,  63, 115, 411,-103, -22, 365,-213, 401,-210, 435,  44,
     c -62,  62, 113, 410,-106, -18, 360,-222, 397,-177, 428,  38,
     c -66,  61, 106, 405,-108, -21, 355,-224, 393,-183, 423,  33,
     c -70,  55,  96, 398,-112, -27, 351,-227, 392,-215, 421,  31,
     c -71,  45,  84, 395,-114, -25, 349,-226, 392,-226, 421,  30,
     c -71,  34,  75, 395,-115, -27, 345,-225, 391,-216, 422,  29,
     c -74,  25,  69, 394,-112, -29, 344,-222, 391,-204, 419,  27,
     c -78,  24,  61, 390,-114, -36, 342,-221, 391,-197, 415,  25,
     c -79,  32,  59, 387,-118, -40, 339,-220, 391,-173, 411,  22,
     c -81,  45,  60, 385,-120, -38, 337,-222, 391,-141, 407,  18,
     c -82,  57,  65, 384,-121, -40, 334,-224, 389,-137, 405,  14,
     c -85,  59,  66, 379,-122, -42, 328,-229, 385,-158, 403,  10,
     c -95,  49,  62, 371,-126, -49, 321,-237, 378,-168, 399,   5,
     c-106,  27,  54, 360,-132, -60, 311,-246, 370,-190, 388,   0,
     c-117,  -1,  45, 347,-140, -74, 303,-255, 361,-233, 378,  -7,
     c-124, -28,  38, 339,-147, -81, 293,-263, 352,-249, 371, -16,
     c-131, -51,  30, 330,-152, -81, 284,-272, 344,-213, 362, -24,
     c-140, -66,  18, 320,-160, -88, 274,-281, 334,-173, 351, -33,
     c-149, -74,   2, 307,-171, -91, 264,-292, 326,-157, 339, -44,
     c-160, -77,  -8, 295,-183,-101, 255,-300, 316,-147, 326, -54,
     c-171, -77, -13, 283,-191,-113, 246,-312, 307,-126, 310, -63,
     c-183, -79, -21, 275,-199,-114, 236,-320, 300,-115, 295, -74,
     c-192, -84, -31, 262,-208,-128, 226,-328, 292,-129, 283, -84,
     c-200, -93, -38, 252,-218,-141, 217,-337, 287,-142, 274, -91,
     c-210,-101, -46, 243,-225,-149, 210,-343, 282,-164, 268, -98,
     c -48,  41,  97, 418,-118, -21, 378,-189, 399, -12, 449,  65,
     c -45,  48,  98, 417,-112, -17, 384,-190, 403,   8, 451,  66,
     c -41,  56,  97, 419,-107, -18, 387,-195, 405,  -9, 455,  66,
     c -38,  66, 104, 425, -99,  -9, 388,-195, 409, -72, 462,  67,
     c -35,  76, 118, 428, -91, -11, 387,-196, 411,-139, 466,  66,
     c -39,  81, 127, 429, -87, -12, 384,-199, 412,-175, 463,  64,
     c -46,  82, 127, 426, -91, -12, 378,-202, 411,-209, 455,  59,
     c -47,  80, 123, 423, -98, -16, 373,-210, 408,-248, 444,  53,
     c -50,  78, 123, 419,-101, -21, 367,-214, 404,-240, 436,  44,
     c -55,  77, 122, 418,-107, -18, 364,-221, 400,-212, 430,  37,
     c -58,  74, 113, 414,-111, -18, 359,-223, 396,-224, 425,  32,
     c -64,  68, 102, 408,-113, -26, 355,-228, 395,-258, 422,  30,
     c -66,  60,  88, 403,-115, -26, 351,-227, 393,-263, 423,  28,
     c -66,  47,  77, 401,-116, -26, 350,-231, 393,-257, 423,  28,
     c -69,  38,  68, 399,-113, -28, 347,-229, 393,-239, 418,  25,
     c -75,  36,  59, 392,-116, -35, 345,-229, 393,-222, 412,  21,
     c -78,  43,  54, 388,-122, -39, 341,-229, 393,-187, 406,  18,
     c -81,  57,  55, 388,-125, -35, 337,-231, 391,-142, 401,  13,
     c -86,  67,  57, 384,-129, -43, 332,-234, 389,-121, 397,   7,
     c -92,  69,  57, 379,-131, -44, 323,-241, 383,-134, 395,   1,
     c-102,  55,  52, 371,-136, -54, 313,-251, 376,-138, 389,  -5,
     c-116,  27,  42, 354,-144, -70, 301,-261, 366,-156, 377, -14,
     c-130,  -8,  32, 338,-153, -84, 288,-272, 356,-198, 364, -23,
     c-139, -44,  22, 328,-162, -96, 276,-283, 346,-212, 354, -34,
     c-148, -72,  11, 317,-171, -96, 263,-294, 335,-178, 343, -44,
     c-159, -92,  -2, 303,-182,-108, 252,-304, 324,-139, 329, -55,
     c-171,-102, -20, 287,-195,-116, 241,-314, 314,-130, 316, -67,
     c-185,-104, -35, 274,-210,-127, 231,-324, 303,-131, 303, -77,
     c-197,-104, -44, 260,-218,-143, 221,-331, 293,-121, 287, -87,
     c-210,-103, -54, 249,-227,-145, 212,-343, 283,-116, 273, -99,
     c-219,-108, -66, 235,-238,-158, 203,-348, 275,-136, 260,-109,
     c-229,-116, -74, 224,-248,-178, 194,-361, 267,-150, 250,-117,
     c-237,-124, -81, 215,-254,-188, 187,-367, 261,-175, 242,-125/
      end
 
 
      block data yy2array
      integer*2 wwtaby2(12,33,65)
      common /wwtaby2_/wwtaby2
      data wwtaby2/
     c 325,   7, 339, 473, 534, -67,  71,-131, 304, 925, 121,  -6,
     c 331,   5, 347, 482, 533, -60,  78,-115, 308, 913, 123,  -2,
     c 338,   3, 354, 490, 531, -60,  86,-101, 310, 919, 125,  -1,
     c 345,   3, 364, 503, 516, -56,  96, -93, 309, 952, 130,  -2,
     c 351,   5, 367, 515, 509, -49, 103, -93, 307, 986, 134,  -6,
     c 354,   4, 355, 520, 503, -48, 102, -97, 305,1017, 137, -10,
     c 356,   0, 340, 520, 492, -53, 100, -97, 303,1049, 140, -15,
     c 354,  -3, 333, 515, 482, -54,  96, -98, 302,1074, 145, -18,
     c 355,   0, 340, 520, 479, -51,  97, -96, 305,1055, 150, -19,
     c 367,   7, 352, 531, 478, -30, 105, -95, 308,1000, 152, -20,
     c 378,  17, 355, 538, 476, -20, 117, -91, 313, 956, 158, -18,
     c 389,  31, 358, 547, 478,  -3, 128, -86, 316, 934, 164, -16,
     c 400,  49, 369, 557, 478,   3, 135, -76, 320, 922, 171, -14,
     c 414,  68, 391, 566, 480,   1, 142, -75, 323, 935, 175, -13,
     c 428,  77, 415, 573, 477,   0, 149, -76, 325, 965, 178, -11,
     c 433,  62, 432, 574, 473, -20, 152, -82, 325, 962, 182,  -7,
     c 429,  32, 434, 570, 467, -35, 156, -88, 328, 924, 188,  -3,
     c 429,   8, 426, 571, 466, -57, 157, -89, 331, 890, 195,   0,
     c 440,   4, 419, 583, 471, -55, 162, -90, 336, 869, 203,   3,
     c 453,  18, 414, 594, 475, -46, 166, -87, 341, 847, 210,   5,
     c 463,  39, 414, 602, 475, -37, 170, -86, 346, 825, 216,   5,
     c 466,  53, 419, 603, 471, -35, 173, -84, 351, 821, 221,   7,
     c 469,  61, 430, 602, 468, -49, 175, -85, 355, 823, 228,   8,
     c 472,  69, 443, 602, 467, -53, 178, -88, 358, 820, 236,   7,
     c 475,  84, 456, 606, 472, -52, 181, -91, 357, 815, 241,   5,
     c 478,  95, 454, 605, 469, -46, 181, -99, 355, 822, 241,  -2,
     c 479,  93, 439, 596, 455, -58, 177,-105, 349, 835, 234, -14,
     c 469,  76, 419, 586, 437, -78, 168,-118, 340, 834, 225, -30,
     c 456,  58, 409, 583, 428, -87, 154,-136, 331, 808, 214, -44,
     c 448,  48, 402, 580, 423, -97, 141,-147, 323, 765, 205, -58,
     c 438,  49, 392, 572, 415,-114, 133,-165, 318, 727, 201, -69,
     c 436,  58, 393, 572, 411, -99, 129,-175, 315, 699, 201, -74,
     c 434,  67, 395, 568, 404, -88, 130,-185, 315, 678, 206, -76,
     c 317,  -2, 332, 472, 524, -67,  68,-130, 298, 885, 126, -13,
     c 324,  -3, 339, 481, 523, -62,  74,-117, 301, 862, 127,  -9,
     c 330,  -5, 347, 488, 517, -59,  82,-103, 303, 858, 130,  -8,
     c 338,  -5, 356, 496, 503, -60,  91, -96, 303, 875, 134, -10,
     c 343,  -4, 358, 506, 497, -51,  96, -95, 301, 903, 138, -13,
     c 348,  -5, 348, 510, 490, -53,  95, -98, 298, 933, 139, -18,
     c 350, -10, 334, 510, 481, -57,  92,-101, 295, 979, 140, -23,
     c 348, -14, 329, 507, 471, -62,  87,-102, 294,1027, 143, -26,
     c 346, -13, 336, 510, 468, -59,  87,-105, 295,1033, 145, -27,
     c 355,  -7, 346, 521, 468, -38,  93,-105, 299,1000, 148, -27,
     c 366,   0, 348, 527, 466, -29, 105,-100, 302, 971, 154, -26,
     c 377,  12, 350, 536, 465, -16, 116, -94, 306, 953, 160, -24,
     c 388,  31, 359, 543, 463, -15, 125, -90, 310, 942, 166, -22,
     c 403,  55, 382, 554, 465, -14, 133, -89, 314, 947, 171, -20,
     c 417,  67, 406, 563, 464, -16, 138, -89, 317, 970, 175, -17,
     c 424,  56, 423, 566, 462, -29, 143, -95, 319, 961, 179, -13,
     c 421,  29, 424, 562, 457, -48, 147, -95, 322, 920, 185,  -8,
     c 424,   6, 418, 566, 458, -66, 152, -97, 327, 882, 192,  -4,
     c 435,   1, 411, 576, 463, -62, 155, -95, 332, 862, 198,  -1,
     c 448,  15, 407, 587, 470, -51, 160, -93, 337, 839, 205,   1,
     c 458,  34, 410, 595, 473, -42, 165, -92, 343, 819, 210,   2,
     c 462,  48, 415, 599, 471, -37, 170, -90, 349, 815, 215,   3,
     c 466,  55, 426, 598, 468, -49, 173, -90, 353, 817, 223,   5,
     c 468,  64, 438, 600, 466, -54, 178, -90, 356, 814, 231,   4,
     c 472,  79, 450, 606, 470, -55, 180, -92, 356, 807, 236,   0,
     c 474,  88, 445, 606, 468, -53, 178,-102, 352, 811, 235,  -7,
     c 473,  84, 429, 597, 456, -63, 172,-111, 347, 824, 228, -20,
     c 460,  67, 410, 585, 438, -87, 159,-126, 337, 827, 217, -35,
     c 445,  47, 398, 577, 425, -94, 144,-145, 326, 804, 204, -51,
     c 433,  38, 390, 570, 414,-118, 129,-160, 316, 765, 194, -67,
     c 423,  38, 381, 558, 401,-137, 119,-176, 309, 733, 188, -79,
     c 422,  48, 382, 556, 395,-119, 115,-185, 306, 708, 187, -86,
     c 420,  58, 384, 552, 387,-100, 114,-192, 304, 690, 191, -88,
     c 310, -11, 325, 469, 513, -70,  64,-127, 291, 889, 124, -20,
     c 316, -13, 332, 478, 509, -60,  70,-118, 295, 855, 126, -16,
     c 322, -14, 339, 485, 505, -58,  76,-107, 297, 842, 129, -15,
     c 330, -15, 345, 491, 490, -55,  86,-102, 296, 845, 134, -16,
     c 335, -14, 349, 496, 482, -55,  90,-101, 294, 865, 136, -19,
     c 341, -16, 339, 499, 476, -59,  90,-104, 291, 889, 137, -25,
     c 344, -21, 328, 500, 467, -62,  85,-107, 287, 937, 137, -29,
     c 341, -25, 325, 497, 459, -67,  81,-111, 286, 993, 140, -32,
     c 338, -26, 332, 501, 458, -56,  79,-114, 286,1010, 142, -34,
     c 343, -23, 339, 509, 455, -38,  84,-112, 289, 988, 145, -34,
     c 355, -16, 341, 518, 453, -30,  96,-108, 293, 970, 148, -33,
     c 365,  -4, 343, 526, 453, -23, 106,-106, 296, 952, 155, -32,
     c 376,  15, 350, 531, 451, -25, 115,-103, 301, 940, 162, -29,
     c 392,  41, 370, 541, 450, -33, 123,-101, 306, 941, 166, -28,
     c 407,  57, 398, 553, 451, -36, 130,-103, 310, 961, 170, -24,
     c 414,  50, 415, 556, 448, -44, 135,-104, 312, 952, 175, -20,
     c 414,  26, 416, 555, 446, -54, 139,-104, 317, 912, 181, -14,
     c 419,   5, 411, 561, 450, -65, 144,-103, 322, 874, 187, -10,
     c 430,   0, 405, 571, 458, -64, 149, -98, 328, 858, 195,  -6,
     c 444,  10, 402, 582, 465, -57, 156, -96, 333, 836, 201,  -4,
     c 452,  28, 404, 590, 468, -50, 161, -94, 340, 817, 206,  -3,
     c 459,  42, 412, 593, 469, -47, 166, -93, 345, 813, 212,   0,
     c 462,  50, 421, 593, 466, -55, 171, -93, 350, 816, 219,   0,
     c 465,  59, 434, 600, 466, -59, 175, -94, 354, 811, 228,   0,
     c 468,  72, 444, 606, 469, -56, 177, -98, 353, 802, 233,  -4,
     c 470,  81, 437, 605, 467, -59, 174,-106, 350, 802, 231, -13,
     c 464,  75, 419, 596, 454, -76, 165,-118, 342, 814, 222, -27,
     c 450,  56, 399, 582, 435, -97, 151,-134, 331, 817, 209, -44,
     c 432,  36, 386, 572, 419,-109, 133,-157, 320, 796, 195, -61,
     c 420,  27, 379, 561, 405,-121, 118,-174, 309, 762, 183, -76,
     c 410,  28, 368, 546, 388,-143, 108,-191, 301, 733, 176, -90,
     c 408,  38, 371, 541, 380,-127, 103,-198, 294, 711, 174, -97,
     c 406,  47, 372, 536, 370,-113, 103,-205, 291, 697, 178,-101,
     c 308, -18, 320, 467, 503, -66,  61,-124, 284, 947, 116, -27,
     c 314, -21, 326, 475, 499, -62,  67,-117, 289, 910, 119, -22,
     c 320, -24, 332, 483, 492, -61,  73,-107, 290, 888, 121, -21,
     c 325, -27, 337, 486, 479, -65,  82,-103, 290, 880, 126, -21,
     c 331, -26, 337, 489, 467, -66,  85,-103, 287, 886, 130, -26,
     c 339, -26, 333, 492, 463, -63,  85,-106, 284, 892, 131, -30,
     c 340, -30, 324, 494, 456, -66,  79,-111, 281, 923, 133, -35,
     c 335, -35, 323, 493, 450, -60,  75,-115, 277, 968, 137, -39,
     c 330, -38, 329, 496, 445, -46,  73,-120, 277, 987, 140, -41,
     c 332, -38, 332, 505, 442, -30,  78,-119, 279, 969, 140, -41,
     c 340, -34, 333, 511, 441, -25,  86,-117, 282, 953, 143, -41,
     c 351, -24, 334, 517, 439, -25,  97,-115, 287, 934, 148, -39,
     c 362,  -3, 344, 523, 438, -39, 104,-113, 292, 914, 153, -36,
     c 381,  25, 363, 530, 439, -52, 112,-112, 297, 908, 159, -35,
     c 397,  47, 386, 539, 440, -66, 119,-114, 302, 924, 163, -33,
     c 406,  47, 404, 545, 439, -67, 126,-116, 306, 922, 170, -27,
     c 411,  28, 409, 551, 443, -67, 132,-114, 312, 895, 176, -22,
     c 417,   7, 405, 556, 448, -76, 136,-109, 318, 871, 184, -18,
     c 428,   0, 399, 565, 453, -72, 143,-104, 323, 859, 192, -14,
     c 440,   6, 397, 573, 460, -71, 150,-102, 330, 841, 198, -12,
     c 449,  22, 403, 585, 465, -63, 157,-100, 336, 821, 203, -10,
     c 453,  36, 409, 592, 465, -55, 162, -99, 342, 820, 211,  -8,
     c 456,  44, 420, 595, 465, -54, 168, -96, 347, 822, 219,  -6,
     c 461,  55, 432, 601, 468, -58, 172, -97, 351, 815, 228,  -8,
     c 466,  68, 438, 606, 468, -56, 173,-102, 351, 802, 231, -13,
     c 465,  72, 427, 603, 463, -62, 168,-111, 346, 797, 228, -22,
     c 458,  64, 408, 593, 452, -84, 158,-126, 338, 801, 217, -36,
     c 439,  44, 390, 576, 431,-101, 141,-145, 326, 801, 201, -53,
     c 420,  25, 375, 562, 409,-118, 123,-168, 312, 782, 185, -70,
     c 404,  17, 365, 548, 391,-134, 106,-187, 300, 752, 172, -88,
     c 394,  18, 358, 532, 374,-151,  95,-201, 290, 725, 164,-101,
     c 393,  28, 360, 526, 364,-143,  90,-212, 283, 706, 161,-110,
     c 392,  38, 362, 520, 353,-136,  90,-217, 278, 694, 163,-114,
     c 304, -26, 320, 464, 487, -61,  58,-124, 277, 981, 109, -32,
     c 309, -29, 324, 473, 484, -61,  64,-115, 281, 946, 111, -28,
     c 316, -32, 330, 481, 480, -58,  71,-109, 283, 923, 114, -26,
     c 320, -36, 332, 483, 471, -56,  79,-105, 283, 910, 118, -26,
     c 329, -35, 332, 486, 460, -55,  82,-106, 281, 905, 123, -29,
     c 336, -34, 329, 489, 454, -55,  81,-108, 277, 898, 126, -33,
     c 336, -37, 324, 491, 450, -59,  78,-110, 273, 902, 130, -38,
     c 331, -41, 323, 491, 443, -55,  73,-114, 270, 931, 135, -42,
     c 327, -45, 328, 494, 437, -42,  73,-119, 269, 948, 137, -44,
     c 329, -45, 332, 499, 435, -37,  76,-122, 270, 938, 137, -46,
     c 336, -43, 332, 507, 432, -37,  84,-123, 273, 923, 137, -46,
     c 346, -33, 336, 514, 432, -42,  92,-122, 277, 904, 141, -45,
     c 357, -13, 343, 518, 430, -62,  97,-121, 282, 882, 145, -44,
     c 371,  14, 358, 522, 428, -70, 103,-121, 288, 877, 148, -43,
     c 388,  39, 378, 530, 432, -81, 109,-123, 294, 892, 154, -41,
     c 398,  44, 392, 537, 434, -76, 115,-122, 300, 895, 161, -37,
     c 406,  31, 396, 544, 438, -77, 123,-119, 305, 883, 170, -32,
     c 412,  11, 393, 549, 443, -81, 130,-114, 312, 873, 180, -27,
     c 423,   0, 392, 559, 451, -75, 137,-109, 318, 860, 187, -23,
     c 432,   2, 393, 569, 456, -75, 142,-102, 324, 839, 195, -20,
     c 440,  14, 401, 581, 461, -63, 150,-100, 331, 820, 202, -18,
     c 446,  27, 409, 592, 462, -56, 158, -99, 338, 820, 209, -16,
     c 452,  39, 418, 598, 463, -50, 165,-100, 344, 824, 218, -15,
     c 457,  50, 427, 602, 464, -59, 168,-103, 348, 819, 227, -16,
     c 460,  58, 426, 599, 462, -64, 167,-109, 346, 805, 229, -21,
     c 458,  61, 414, 596, 455, -73, 160,-118, 341, 794, 224, -31,
     c 450,  52, 397, 586, 444, -95, 149,-135, 332, 792, 210, -46,
     c 432,  34, 380, 569, 426,-110, 132,-154, 319, 788, 194, -63,
     c 413,  18, 367, 555, 405,-128, 115,-177, 305, 769, 175, -81,
     c 398,  12, 360, 542, 386,-141,  99,-195, 291, 742, 161, -97,
     c 385,  14, 355, 526, 367,-156,  88,-212, 280, 718, 153,-112,
     c 384,  23, 358, 518, 355,-150,  81,-220, 271, 700, 149,-121,
     c 381,  30, 359, 509, 341,-147,  79,-228, 266, 690, 149,-126,
     c 297, -34, 316, 460, 473, -63,  52,-126, 272, 995, 107, -36,
     c 305, -36, 322, 470, 473, -61,  62,-115, 276, 964, 108, -32,
     c 312, -38, 326, 478, 473, -54,  69,-108, 279, 942, 112, -29,
     c 317, -42, 328, 482, 466, -57,  77,-104, 279, 926, 115, -29,
     c 324, -41, 330, 485, 460, -54,  80,-104, 277, 909, 120, -30,
     c 333, -40, 327, 490, 455, -48,  82,-105, 274, 887, 125, -34,
     c 335, -41, 324, 493, 447, -38,  79,-106, 270, 872, 130, -37,
     c 331, -44, 324, 492, 437, -40,  76,-109, 267, 885, 135, -41,
     c 328, -48, 329, 493, 432, -38,  75,-116, 264, 900, 138, -44,
     c 332, -49, 335, 499, 433, -32,  79,-122, 264, 908, 136, -47,
     c 340, -46, 338, 505, 430, -40,  85,-125, 267, 905, 134, -48,
     c 346, -38, 338, 509, 426, -52,  90,-126, 271, 892, 134, -50,
     c 353, -20, 344, 511, 423, -69,  94,-127, 276, 869, 137, -50,
     c 365,   4, 355, 516, 424, -80,  98,-129, 282, 865, 140, -50,
     c 381,  29, 370, 523, 426, -88, 104,-129, 288, 876, 146, -48,
     c 392,  39, 379, 532, 429, -87, 110,-129, 293, 880, 154, -44,
     c 398,  31, 379, 538, 431, -84, 116,-124, 299, 879, 164, -39,
     c 404,  14, 378, 544, 438, -88, 124,-118, 306, 880, 174, -34,
     c 414,   1, 380, 557, 446, -85, 130,-115, 313, 864, 184, -30,
     c 424,  -1, 384, 569, 449, -77, 138,-109, 320, 841, 192, -27,
     c 432,   5, 393, 581, 454, -72, 144,-109, 327, 825, 201, -25,
     c 439,  17, 403, 591, 459, -64, 154,-106, 333, 826, 209, -22,
     c 446,  28, 411, 596, 459, -59, 160,-108, 340, 831, 217, -22,
     c 451,  39, 413, 596, 454, -70, 163,-111, 342, 830, 225, -24,
     c 454,  48, 412, 593, 454, -78, 160,-118, 341, 819, 227, -31,
     c 450,  48, 402, 587, 448, -93, 151,-127, 334, 805, 220, -41,
     c 441,  41, 384, 578, 435,-105, 140,-141, 325, 796, 205, -56,
     c 424,  28, 368, 561, 418,-115, 127,-161, 311, 786, 187, -73,
     c 407,  17, 361, 549, 401,-122, 111,-179, 296, 764, 169, -89,
     c 394,  11, 359, 538, 386,-135,  96,-196, 282, 736, 154,-106,
     c 383,  11, 356, 521, 366,-149,  86,-215, 270, 711, 143,-120,
     c 381,  18, 358, 511, 353,-151,  79,-226, 262, 694, 138,-130,
     c 379,  25, 360, 502, 339,-151,  75,-236, 255, 686, 138,-136,
     c 294, -43, 314, 456, 464, -79,  49,-130, 268,1004, 106, -40,
     c 304, -44, 320, 465, 467, -71,  61,-117, 275, 983, 109, -35,
     c 311, -46, 324, 474, 470, -64,  70,-110, 277, 969, 111, -33,
     c 319, -48, 328, 480, 465, -60,  78,-103, 278, 950, 115, -30,
     c 325, -45, 331, 488, 463, -49,  82,-101, 276, 930, 120, -30,
     c 332, -43, 328, 492, 457, -41,  83,-101, 274, 901, 126, -32,
     c 336, -44, 324, 494, 445, -35,  82,-101, 270, 868, 131, -35,
     c 335, -47, 326, 493, 436, -38,  81,-106, 266, 864, 137, -38,
     c 334, -49, 332, 498, 433, -34,  80,-113, 264, 877, 140, -41,
     c 339, -50, 337, 504, 432, -32,  84,-120, 264, 893, 136, -46,
     c 345, -48, 341, 506, 428, -51,  88,-124, 265, 895, 132, -49,
     c 349, -40, 342, 506, 422, -64,  90,-127, 268, 886, 130, -51,
     c 353, -25, 346, 510, 418, -76,  93,-131, 272, 865, 132, -52,
     c 363,  -2, 353, 512, 418, -84,  97,-135, 278, 858, 134, -54,
     c 376,  20, 361, 516, 420, -95,  99,-134, 283, 862, 141, -54,
     c 387,  33, 367, 525, 420, -93, 104,-133, 289, 872, 148, -49,
     c 393,  32, 366, 534, 423, -91, 111,-127, 294, 883, 159, -44,
     c 400,  18, 367, 546, 432, -88, 118,-122, 301, 896, 170, -40,
     c 410,   3, 371, 558, 440, -84, 125,-116, 307, 885, 180, -36,
     c 419,  -5, 376, 569, 443, -78, 133,-115, 313, 865, 190, -33,
     c 426,  -5, 384, 577, 445, -78, 140,-115, 320, 851, 198, -31,
     c 434,   3, 394, 588, 450, -70, 147,-114, 327, 852, 205, -30,
     c 439,  15, 401, 590, 450, -75, 154,-116, 333, 851, 212, -29,
     c 445,  28, 404, 588, 448, -89, 156,-119, 335, 848, 218, -32,
     c 447,  36, 403, 587, 447, -94, 150,-124, 332, 838, 219, -39,
     c 442,  39, 393, 582, 441,-100, 143,-134, 326, 819, 212, -50,
     c 433,  36, 378, 570, 431,-111, 133,-148, 315, 803, 198, -64,
     c 417,  28, 364, 555, 415,-114, 121,-165, 302, 788, 182, -80,
     c 403,  20, 358, 545, 399,-117, 109,-180, 288, 763, 163, -97,
     c 393,  14, 358, 533, 383,-130,  96,-198, 275, 732, 148,-113,
     c 381,  10, 353, 515, 363,-146,  84,-215, 263, 705, 138,-127,
     c 379,  13, 357, 506, 351,-148,  77,-230, 255, 689, 133,-136,
     c 377,  17, 359, 495, 337,-153,  71,-237, 250, 682, 130,-142,
     c 293, -56, 313, 458, 461, -79,  48,-127, 268,1007, 106, -43,
     c 304, -55, 320, 467, 465, -71,  62,-114, 274, 996, 110, -38,
     c 314, -54, 327, 476, 467, -58,  72,-104, 277, 987, 113, -34,
     c 322, -52, 330, 485, 467, -49,  83, -99, 279, 977, 116, -30,
     c 328, -47, 331, 493, 463, -41,  87, -98, 278, 963, 122, -29,
     c 337, -43, 331, 497, 458, -32,  90, -95, 275, 935, 128, -28,
     c 342, -44, 328, 499, 446, -28,  89, -97, 272, 896, 135, -31,
     c 342, -45, 329, 499, 438, -34,  90,-103, 269, 882, 141, -34,
     c 344, -46, 335, 502, 435, -38,  90,-109, 266, 885, 142, -38,
     c 347, -46, 337, 504, 431, -45,  91,-118, 266, 897, 138, -42,
     c 349, -45, 341, 505, 426, -61,  92,-125, 267, 900, 131, -47,
     c 352, -38, 345, 506, 421, -74,  93,-130, 269, 892, 129, -50,
     c 355, -25, 349, 509, 418, -78,  93,-134, 272, 870, 129, -54,
     c 360,  -7, 351, 509, 416, -84,  95,-136, 276, 859, 132, -56,
     c 373,  13, 356, 514, 416, -90,  96,-136, 281, 858, 137, -56,
     c 383,  30, 358, 522, 415, -89, 100,-135, 285, 868, 146, -54,
     c 392,  34, 359, 535, 421, -87, 107,-129, 291, 887, 156, -50,
     c 399,  24, 361, 547, 428, -86, 114,-126, 296, 907, 166, -46,
     c 407,   7, 367, 558, 432, -82, 122,-120, 303, 903, 177, -42,
     c 415,  -7, 371, 566, 435, -77, 128,-122, 309, 889, 186, -39,
     c 424, -13, 377, 574, 440, -77, 136,-125, 316, 876, 194, -39,
     c 430,  -9, 387, 581, 443, -74, 143,-124, 321, 869, 200, -37,
     c 434,   2, 393, 582, 441, -84, 146,-124, 326, 861, 204, -38,
     c 439,  15, 397, 581, 441,-103, 148,-127, 327, 853, 208, -42,
     c 440,  27, 398, 580, 442,-106, 142,-134, 324, 840, 208, -49,
     c 433,  32, 387, 571, 435,-112, 134,-146, 316, 818, 202, -59,
     c 421,  33, 373, 560, 425,-121, 124,-158, 307, 799, 191, -74,
     c 409,  30, 362, 549, 412,-118, 115,-171, 295, 782, 175, -88,
     c 398,  24, 358, 539, 398,-118, 106,-183, 281, 757, 160,-103,
     c 389,  15, 354, 526, 379,-135,  95,-201, 270, 725, 146,-118,
     c 378,   7, 351, 510, 358,-152,  83,-220, 260, 697, 135,-131,
     c 376,   8, 354, 500, 347,-152,  75,-236, 253, 681, 128,-141,
     c 373,   8, 356, 489, 337,-155,  67,-243, 246, 674, 126,-147,
     c 296, -70, 318, 465, 465, -66,  53,-120, 271, 959, 109, -43,
     c 307, -67, 325, 473, 467, -59,  66,-106, 277, 956, 113, -37,
     c 318, -62, 332, 484, 468, -45,  77, -98, 281, 956, 118, -32,
     c 326, -57, 335, 493, 468, -38,  88, -93, 282, 961, 122, -29,
     c 335, -48, 337, 500, 465, -30,  94, -88, 281, 965, 127, -25,
     c 345, -41, 337, 505, 460, -24,  97, -87, 279, 959, 133, -24,
     c 350, -38, 336, 507, 452, -24,  99, -88, 277, 931, 139, -25,
     c 350, -37, 336, 506, 443, -32,  99, -97, 273, 917, 144, -28,
     c 351, -38, 336, 507, 438, -42,  99,-104, 271, 917, 146, -32,
     c 351, -40, 335, 504, 434, -52,  97,-112, 270, 924, 140, -38,
     c 353, -40, 340, 505, 428, -63,  96,-122, 270, 923, 132, -43,
     c 354, -35, 347, 506, 423, -75,  96,-127, 271, 911, 128, -48,
     c 356, -24, 354, 510, 421, -74,  95,-133, 274, 891, 129, -52,
     c 361,  -9, 355, 512, 419, -76,  94,-134, 277, 878, 132, -56,
     c 373,  10, 357, 518, 418, -83,  96,-136, 280, 867, 137, -57,
     c 382,  27, 354, 524, 415, -83,  99,-135, 285, 868, 145, -56,
     c 390,  36, 355, 534, 419, -82, 105,-131, 290, 884, 154, -54,
     c 397,  29, 358, 545, 424, -84, 111,-129, 295, 899, 164, -50,
     c 403,  11, 363, 553, 428, -81, 117,-125, 300, 894, 175, -47,
     c 411,  -6, 364, 561, 431, -80, 123,-126, 306, 883, 183, -46,
     c 416, -21, 369, 567, 435, -86, 128,-129, 311, 878, 188, -46,
     c 421, -22, 378, 571, 438, -89, 133,-131, 315, 867, 191, -46,
     c 426, -11, 388, 573, 438, -99, 137,-129, 318, 850, 194, -47,
     c 431,   5, 394, 575, 437,-108, 137,-133, 319, 839, 197, -52,
     c 430,  18, 392, 570, 435,-113, 131,-139, 314, 827, 197, -59,
     c 420,  27, 383, 561, 430,-116, 124,-151, 308, 805, 193, -69,
     c 411,  32, 370, 554, 420,-115, 116,-164, 299, 786, 183, -81,
     c 400,  31, 358, 543, 407,-116, 108,-179, 288, 772, 171, -94,
     c 392,  25, 351, 531, 393,-120, 101,-190, 277, 751, 157,-108,
     c 382,  15, 349, 520, 376,-134,  90,-205, 268, 722, 144,-121,
     c 373,   4, 346, 506, 357,-158,  79,-223, 259, 695, 133,-133,
     c 370,   1, 349, 497, 345,-157,  70,-236, 252, 680, 127,-142,
     c 369,   0, 352, 486, 334,-159,  62,-243, 246, 672, 123,-149,
     c 299, -80, 324, 472, 472, -53,  58,-115, 276, 922, 114, -39,
     c 311, -75, 331, 482, 469, -53,  71,-102, 283, 920, 121, -33,
     c 322, -70, 336, 491, 469, -37,  82, -94, 286, 925, 127, -29,
     c 333, -62, 342, 502, 468, -27,  93, -88, 287, 947, 132, -23,
     c 342, -49, 347, 509, 467, -26,  99, -84, 287, 964, 137, -18,
     c 352, -37, 348, 514, 465, -20, 104, -83, 286, 975, 143, -17,
     c 355, -29, 348, 518, 459, -30, 107, -85, 283, 966, 147, -18,
     c 356, -26, 346, 516, 452, -41, 107, -94, 280, 955, 151, -22,
     c 354, -26, 340, 510, 447, -51, 104,-104, 278, 947, 151, -26,
     c 355, -29, 333, 507, 441, -58, 103,-114, 275, 948, 144, -33,
     c 356, -32, 337, 506, 433, -66, 100,-124, 274, 941, 137, -39,
     c 356, -29, 346, 508, 427, -74,  96,-128, 274, 925, 133, -44,
     c 357, -20, 354, 513, 424, -75,  96,-132, 276, 906, 133, -50,
     c 364,  -7, 359, 518, 422, -73,  96,-132, 278, 892, 136, -54,
     c 374,   7, 360, 524, 421, -75,  97,-134, 282, 874, 140, -58,
     c 382,  25, 354, 530, 416, -71, 100,-135, 287, 864, 147, -58,
     c 387,  35, 351, 536, 417, -71, 104,-135, 291, 871, 156, -56,
     c 394,  33, 356, 543, 423, -77, 108,-135, 295, 879, 165, -54,
     c 400,  16, 360, 549, 427, -78, 113,-132, 301, 871, 172, -52,
     c 404,  -6, 357, 555, 426, -83, 118,-135, 306, 868, 178, -51,
     c 406, -25, 359, 556, 428, -94, 122,-136, 310, 876, 182, -52,
     c 410, -31, 370, 561, 433, -97, 125,-140, 312, 867, 184, -53,
     c 416, -21, 383, 566, 435,-106, 127,-141, 312, 850, 186, -56,
     c 421,  -4, 390, 567, 432,-109, 127,-144, 310, 838, 188, -60,
     c 420,  11, 389, 563, 427,-113, 124,-149, 306, 822, 189, -67,
     c 412,  20, 379, 554, 420,-114, 117,-159, 299, 796, 185, -76,
     c 404,  26, 367, 549, 414,-108, 111,-172, 293, 775, 179, -88,
     c 395,  26, 352, 538, 401,-108, 103,-186, 284, 763, 168, -99,
     c 387,  20, 344, 525, 387,-119,  96,-195, 274, 747, 157,-111,
     c 380,  10, 340, 515, 373,-135,  88,-209, 266, 723, 146,-123,
     c 371,  -1, 339, 504, 356,-158,  77,-229, 259, 699, 136,-133,
     c 369,  -4, 341, 496, 344,-155,  68,-240, 253, 684, 130,-142,
     c 366,  -8, 344, 487, 332,-156,  60,-249, 246, 676, 126,-150,
     c 301, -86, 328, 477, 475, -52,  66,-108, 281, 908, 121, -33,
     c 314, -80, 335, 488, 471, -52,  77, -96, 287, 913, 131, -27,
     c 326, -73, 342, 498, 469, -37,  86, -90, 290, 925, 138, -21,
     c 338, -63, 348, 508, 466, -24,  97, -81, 293, 951, 143, -15,
     c 347, -48, 355, 514, 466, -27, 104, -77, 293, 979, 149, -11,
     c 355, -32, 362, 521, 465, -19, 110, -78, 292,1000, 153,  -9,
     c 357, -21, 362, 524, 460, -41, 111, -83, 290, 998, 156, -10,
     c 356, -15, 357, 522, 456, -46, 112, -91, 287, 982, 157, -14,
     c 356, -15, 347, 518, 453, -51, 110,-101, 284, 962, 156, -20,
     c 357, -20, 334, 513, 446, -61, 107,-111, 282, 948, 151, -27,
     c 358, -23, 334, 512, 437, -63, 103,-119, 281, 926, 143, -33,
     c 361, -20, 346, 515, 431, -71, 100,-124, 280, 905, 141, -39,
     c 363, -12, 356, 523, 429, -70,  98,-126, 281, 888, 142, -46,
     c 367,  -3, 360, 527, 424, -79,  98,-129, 283, 875, 144, -51,
     c 374,   8, 359, 529, 421, -79, 100,-133, 286, 855, 148, -56,
     c 381,  23, 354, 534, 415, -81, 100,-136, 289, 844, 153, -58,
     c 386,  35, 352, 537, 417, -78, 103,-139, 295, 846, 160, -57,
     c 391,  34, 356, 542, 424, -76, 107,-140, 299, 850, 165, -56,
     c 398,  21, 360, 547, 430, -75, 111,-140, 303, 849, 170, -55,
     c 400,  -2, 356, 549, 427, -83, 113,-141, 307, 862, 173, -56,
     c 401, -25, 354, 549, 426, -95, 114,-144, 308, 881, 174, -57,
     c 404, -36, 367, 554, 431, -95, 117,-145, 308, 881, 175, -59,
     c 409, -29, 381, 558, 433, -99, 118,-146, 306, 870, 176, -62,
     c 410, -12, 387, 558, 427,-103, 119,-150, 304, 857, 179, -67,
     c 411,   3, 387, 555, 421,-104, 117,-155, 299, 834, 181, -73,
     c 407,  14, 379, 551, 415,-102, 111,-164, 294, 799, 180, -82,
     c 399,  18, 364, 545, 406, -97, 107,-174, 288, 772, 175, -91,
     c 392,  19, 351, 537, 400,-102,  99,-185, 281, 758, 168,-101,
     c 385,  14, 341, 525, 388,-114,  94,-198, 274, 743, 158,-112,
     c 379,   6, 338, 515, 377,-133,  86,-209, 267, 724, 149,-122,
     c 371,  -4, 335, 504, 359,-159,  76,-228, 260, 705, 141,-132,
     c 368, -10, 338, 497, 347,-154,  69,-239, 254, 690, 135,-140,
     c 364, -14, 341, 489, 336,-156,  60,-246, 248, 680, 132,-147,
     c 307, -87, 334, 485, 475, -45,  76,-101, 286, 901, 130, -25,
     c 320, -78, 342, 498, 472, -41,  85, -91, 290, 909, 140, -19,
     c 332, -68, 350, 510, 470, -29,  94, -81, 293, 925, 149, -13,
     c 344, -57, 356, 516, 466, -21, 104, -76, 295, 959, 155,  -8,
     c 353, -42, 365, 521, 464, -27, 112, -74, 296, 989, 160,  -3,
     c 361, -26, 372, 527, 463, -25, 118, -75, 296,1012, 162,  -2,
     c 363, -12, 375, 532, 462, -35, 120, -81, 295,1011, 162,  -3,
     c 362,  -5, 370, 529, 459, -47, 120, -88, 292, 990, 162,  -8,
     c 362,  -4, 356, 524, 457, -51, 116, -97, 291, 954, 161, -15,
     c 365,  -9, 340, 523, 452, -52, 112,-106, 288, 925, 156, -22,
     c 367, -12, 336, 524, 443, -59, 107,-115, 287, 893, 152, -29,
     c 371,  -9, 346, 526, 435, -67, 105,-119, 287, 867, 150, -36,
     c 374,  -1, 357, 534, 433, -69, 104,-121, 286, 852, 152, -42,
     c 374,   4, 358, 535, 427, -78, 103,-124, 288, 845, 154, -49,
     c 375,  12, 355, 533, 421, -82, 102,-131, 290, 828, 156, -55,
     c 378,  23, 353, 534, 415, -82, 102,-136, 294, 818, 157, -57,
     c 382,  35, 353, 537, 418, -79, 103,-139, 298, 819, 161, -57,
     c 390,  38, 358, 542, 427, -76, 106,-140, 303, 821, 165, -57,
     c 396,  26, 360, 546, 432, -74, 109,-140, 307, 822, 167, -58,
     c 399,   2, 358, 548, 430, -80, 112,-144, 309, 845, 168, -59,
     c 399, -22, 359, 547, 429, -93, 113,-145, 309, 873, 167, -60,
     c 400, -36, 367, 550, 432, -97, 114,-150, 307, 881, 167, -63,
     c 402, -32, 378, 554, 430,-101, 114,-150, 303, 880, 169, -66,
     c 404, -16, 386, 554, 425,-100, 114,-155, 299, 870, 172, -70,
     c 406,   0, 385, 550, 417, -99, 111,-160, 295, 844, 176, -76,
     c 402,   7, 377, 546, 412, -99, 108,-167, 291, 801, 176, -83,
     c 395,  11, 364, 543, 405, -95, 103,-177, 288, 767, 173, -92,
     c 388,  11, 348, 534, 399,-103,  97,-187, 284, 750, 167,-101,
     c 385,   8, 341, 525, 393,-114,  93,-198, 277, 737, 162,-110,
     c 379,   2, 340, 516, 383,-127,  87,-207, 271, 722, 155,-119,
     c 371,  -6, 338, 506, 366,-155,  78,-225, 265, 705, 149,-127,
     c 369, -10, 340, 499, 355,-150,  71,-235, 258, 692, 145,-135,
     c 365, -16, 342, 489, 342,-154,  62,-244, 252, 681, 142,-142,
     c 319, -79, 342, 498, 478, -35,  88, -88, 288, 866, 138, -16,
     c 329, -69, 349, 508, 476, -31,  95, -77, 293, 877, 151, -11,
     c 342, -58, 358, 519, 475, -22, 104, -68, 295, 896, 159,  -5,
     c 353, -46, 365, 527, 470, -18, 112, -63, 297, 936, 165,  -1,
     c 363, -30, 375, 530, 470, -26, 121, -62, 298, 965, 169,   2,
     c 369, -16, 382, 534, 469, -35, 127, -68, 299, 988, 169,   2,
     c 372,  -4, 384, 538, 469, -39, 129, -72, 297, 992, 167,   0,
     c 371,   2, 378, 535, 466, -45, 125, -82, 297, 968, 165,  -5,
     c 371,   3, 363, 530, 461, -50, 121, -89, 295, 929, 164, -11,
     c 375,   0, 345, 530, 455, -56, 116, -98, 295, 900, 163, -19,
     c 378,   0, 339, 534, 448, -60, 113,-105, 294, 874, 161, -26,
     c 380,   4, 346, 539, 441, -66, 111,-108, 294, 848, 162, -32,
     c 385,  11, 355, 545, 438, -70, 111,-113, 294, 834, 163, -39,
     c 385,  15, 356, 544, 433, -75, 109,-116, 294, 828, 163, -46,
     c 381,  17, 353, 538, 426, -82, 107,-128, 295, 812, 161, -52,
     c 378,  25, 351, 536, 421, -87, 104,-135, 297, 800, 161, -55,
     c 381,  35, 355, 537, 424, -83, 105,-141, 302, 799, 163, -57,
     c 388,  40, 362, 541, 430, -79, 107,-140, 306, 797, 164, -57,
     c 396,  32, 366, 544, 436, -77, 111,-138, 310, 795, 164, -57,
     c 399,  10, 366, 550, 437, -76, 114,-139, 313, 816, 162, -58,
     c 401, -15, 365, 551, 435, -82, 115,-140, 311, 845, 160, -61,
     c 401, -33, 371, 550, 432, -87, 115,-145, 306, 859, 161, -63,
     c 403, -30, 379, 553, 431, -89, 114,-147, 301, 866, 163, -66,
     c 404, -16, 382, 552, 424, -93, 113,-154, 298, 864, 167, -71,
     c 406,  -1, 382, 549, 417, -98, 110,-160, 294, 842, 172, -76,
     c 401,   5, 374, 546, 411,-101, 108,-168, 293, 799, 174, -83,
     c 392,   7, 361, 542, 405,-100, 103,-181, 291, 762, 172, -90,
     c 389,   8, 348, 534, 400,-113,  99,-187, 288, 744, 169, -97,
     c 386,   6, 341, 525, 395,-125,  95,-197, 283, 734, 165,-106,
     c 382,   3, 344, 520, 388,-129,  89,-203, 277, 722, 161,-113,
     c 376,  -4, 343, 511, 373,-146,  81,-218, 271, 709, 158,-121,
     c 372,  -8, 345, 503, 361,-142,  75,-229, 265, 696, 155,-127,
     c 368, -12, 346, 493, 349,-148,  65,-239, 259, 683, 154,-134,
     c 331, -68, 350, 509, 481, -44,  97, -73, 291, 831, 145,  -7,
     c 342, -57, 356, 516, 479, -39, 104, -65, 294, 853, 158,  -4,
     c 354, -46, 364, 523, 475, -32, 113, -58, 296, 874, 166,   0,
     c 364, -31, 373, 533, 476, -22, 121, -58, 298, 905, 170,   4,
     c 371, -18, 382, 536, 476, -26, 128, -60, 298, 922, 173,   5,
     c 376,  -8, 388, 537, 475, -29, 132, -66, 299, 933, 171,   5,
     c 377,  -1, 386, 540, 475, -31, 133, -71, 300, 933, 167,   2,
     c 377,   5, 380, 541, 472, -37, 129, -80, 300, 909, 165,  -3,
     c 376,   7, 364, 537, 463, -47, 124, -87, 300, 878, 167, -10,
     c 379,   6, 349, 534, 455, -51, 118, -93, 300, 867, 169, -18,
     c 382,   8, 344, 539, 449, -55, 117, -97, 301, 861, 169, -24,
     c 385,  14, 347, 547, 445, -57, 117,-101, 301, 846, 171, -31,
     c 389,  20, 353, 552, 443, -63, 116,-108, 301, 832, 173, -37,
     c 391,  22, 354, 550, 439, -69, 114,-116, 300, 825, 170, -44,
     c 387,  23, 355, 544, 436, -81, 112,-125, 299, 807, 165, -49,
     c 384,  27, 357, 542, 432, -84, 109,-131, 301, 796, 161, -52,
     c 385,  36, 361, 541, 431, -82, 108,-134, 304, 795, 160, -53,
     c 393,  42, 370, 542, 436, -79, 111,-133, 310, 794, 162, -54,
     c 400,  36, 375, 548, 439, -77, 116,-131, 313, 792, 162, -55,
     c 403,  16, 374, 552, 439, -73, 119,-132, 315, 808, 161, -57,
     c 403,  -9, 371, 553, 436, -79, 117,-135, 313, 828, 159, -59,
     c 405, -26, 372, 553, 433, -83, 118,-140, 308, 838, 159, -62,
     c 407, -26, 377, 555, 431, -80, 117,-145, 303, 847, 161, -64,
     c 409, -14, 379, 554, 427, -83, 116,-151, 298, 850, 166, -68,
     c 408,  -1, 378, 550, 419, -87, 114,-156, 297, 831, 171, -74,
     c 404,   4, 374, 551, 417, -93, 111,-163, 296, 792, 172, -80,
     c 396,   5, 362, 548, 410, -97, 108,-172, 296, 760, 172, -86,
     c 391,   6, 349, 538, 403,-113, 103,-182, 295, 743, 171, -93,
     c 392,   8, 346, 531, 396,-119, 102,-189, 290, 735, 171, -99,
     c 390,   7, 347, 526, 390,-126,  96,-197, 285, 728, 170,-106,
     c 384,   2, 349, 518, 377,-142,  88,-208, 279, 718, 168,-112,
     c 379,  -1, 349, 509, 366,-141,  80,-221, 272, 706, 168,-119,
     c 375,  -5, 350, 501, 354,-146,  72,-230, 265, 691, 167,-126,
     c 335, -58, 351, 514, 481, -47, 103, -64, 294, 828, 150,   0,
     c 345, -46, 359, 521, 481, -37, 109, -58, 295, 861, 161,   2,
     c 355, -33, 366, 527, 478, -31, 115, -57, 297, 883, 169,   4,
     c 365, -19, 374, 532, 477, -25, 123, -58, 298, 899, 171,   7,
     c 370, -11, 380, 535, 478, -23, 129, -61, 299, 894, 171,   7,
     c 372,  -7, 382, 537, 478, -27, 132, -66, 301, 889, 168,   5,
     c 372,  -3, 380, 539, 474, -27, 133, -72, 302, 879, 164,   2,
     c 375,   1, 375, 541, 471, -36, 129, -79, 303, 854, 165,  -3,
     c 377,   7, 363, 539, 462, -44, 124, -84, 305, 835, 169, -10,
     c 380,   9, 354, 539, 454, -50, 119, -91, 306, 849, 171, -17,
     c 382,  14, 351, 542, 450, -55, 117, -95, 307, 863, 175, -24,
     c 388,  20, 352, 547, 447, -59, 119,-100, 307, 861, 177, -29,
     c 392,  24, 355, 553, 446, -60, 121,-106, 306, 847, 177, -35,
     c 394,  26, 357, 553, 446, -63, 119,-113, 304, 831, 172, -41,
     c 391,  25, 359, 549, 444, -71, 116,-123, 303, 809, 164, -47,
     c 390,  29, 364, 546, 440, -75, 114,-128, 303, 801, 158, -49,
     c 395,  36, 371, 546, 439, -73, 116,-132, 307, 806, 158, -50,
     c 401,  44, 378, 548, 442, -72, 119,-128, 311, 811, 160, -51,
     c 407,  40, 384, 554, 442, -71, 121,-125, 316, 813, 162, -52,
     c 409,  21, 382, 555, 439, -67, 124,-125, 318, 824, 162, -53,
     c 409,  -1, 378, 555, 435, -74, 123,-129, 316, 832, 162, -56,
     c 408, -19, 375, 555, 434, -76, 121,-137, 311, 831, 162, -58,
     c 410, -21, 376, 559, 432, -72, 119,-140, 305, 836, 163, -62,
     c 410, -11, 376, 556, 429, -79, 118,-146, 302, 837, 167, -66,
     c 409,  -1, 375, 553, 425, -83, 117,-151, 301, 819, 170, -71,
     c 407,   4, 374, 556, 423, -88, 116,-158, 302, 786, 173, -77,
     c 401,   6, 366, 553, 418, -90, 113,-167, 303, 758, 173, -82,
     c 398,   9, 356, 544, 411,-102, 112,-175, 302, 743, 174, -87,
     c 400,  14, 354, 538, 403,-110, 109,-182, 298, 738, 176, -93,
     c 402,  16, 358, 535, 396,-111, 105,-188, 293, 736, 177, -99,
     c 396,  12, 357, 526, 381,-126,  97,-199, 287, 729, 178,-105,
     c 389,   8, 357, 517, 371,-127,  90,-214, 281, 717, 178,-111,
     c 384,   5, 357, 510, 361,-133,  81,-225, 274, 700, 178,-117,
     c 339, -44, 355, 525, 483, -39, 105, -57, 296, 881, 154,   6,
     c 348, -32, 363, 530, 483, -29, 112, -55, 298, 917, 165,   7,
     c 357, -20, 371, 535, 482, -24, 116, -55, 299, 935, 171,   8,
     c 364,  -8, 376, 536, 479, -24, 125, -59, 300, 937, 171,   8,
     c 367,  -4, 378, 535, 478, -26, 128, -65, 302, 916, 168,   8,
     c 368,  -7, 377, 537, 478, -30, 131, -69, 304, 894, 164,   5,
     c 369,  -8, 372, 540, 474, -34, 131, -77, 305, 875, 161,   1,
     c 374,  -1, 368, 542, 469, -39, 130, -82, 308, 854, 163,  -4,
     c 379,   6, 363, 542, 462, -41, 125, -85, 310, 845, 167, -10,
     c 382,  12, 360, 545, 456, -49, 120, -90, 312, 876, 172, -17,
     c 386,  17, 358, 546, 452, -50, 118, -95, 313, 912, 175, -23,
     c 390,  21, 359, 547, 448, -62, 120, -99, 312, 916, 178, -28,
     c 395,  23, 359, 551, 448, -64, 123,-106, 310, 889, 178, -34,
     c 396,  23, 359, 552, 449, -66, 121,-113, 307, 858, 171, -39,
     c 394,  24, 362, 550, 449, -71, 120,-119, 304, 832, 161, -43,
     c 394,  27, 368, 547, 446, -74, 120,-122, 304, 822, 155, -45,
     c 399,  34, 374, 548, 446, -70, 121,-123, 307, 830, 155, -46,
     c 405,  42, 383, 553, 446, -68, 124,-120, 313, 839, 160, -47,
     c 411,  40, 390, 558, 446, -66, 127,-118, 317, 844, 165, -48,
     c 412,  25, 388, 560, 442, -62, 127,-121, 319, 847, 167, -50,
     c 411,   5, 383, 558, 438, -68, 125,-126, 318, 842, 167, -53,
     c 409,  -9, 377, 559, 436, -69, 122,-134, 314, 827, 166, -57,
     c 408, -14, 376, 561, 435, -69, 120,-141, 310, 823, 167, -59,
     c 408,  -9, 374, 560, 433, -71, 119,-148, 307, 819, 170, -64,
     c 408,   0, 374, 558, 430, -78, 119,-152, 308, 802, 173, -69,
     c 405,   4, 376, 559, 429, -81, 118,-156, 309, 776, 174, -74,
     c 403,   8, 371, 556, 425, -84, 118,-163, 311, 755, 176, -78,
     c 403,  13, 364, 548, 417, -96, 117,-169, 310, 743, 178, -83,
     c 408,  20, 366, 545, 412,-103, 115,-174, 307, 741, 182, -87,
     c 410,  25, 371, 545, 406,-103, 112,-179, 302, 743, 185, -93,
     c 402,  23, 370, 534, 391,-117, 105,-190, 296, 741, 187, -98,
     c 396,  19, 368, 526, 382,-118,  97,-203, 290, 729, 188,-104,
     c 389,  16, 366, 518, 373,-125,  90,-213, 283, 711, 188,-111,
     c 345, -31, 361, 533, 488, -42, 109, -54, 300, 935, 161,  12,
     c 353, -19, 369, 536, 486, -29, 113, -54, 300, 972, 170,  11,
     c 361,  -8, 375, 540, 485, -28, 120, -55, 301, 987, 173,   9,
     c 366,   1, 382, 540, 483, -23, 124, -57, 302, 978, 171,   8,
     c 367,   1, 381, 540, 482, -22, 128, -62, 304, 946, 167,   6,
     c 367,  -6, 377, 540, 480, -25, 131, -69, 307, 916, 162,   5,
     c 372,  -9, 370, 541, 475, -30, 132, -75, 310, 900, 160,   1,
     c 378,  -2, 365, 546, 470, -34, 131, -79, 313, 886, 162,  -3,
     c 383,   8, 363, 549, 464, -35, 127, -82, 316, 890, 168, -10,
     c 388,  15, 364, 550, 458, -41, 122, -88, 317, 938, 173, -17,
     c 392,  19, 363, 549, 455, -44, 122, -95, 317, 987, 175, -23,
     c 393,  19, 362, 549, 453, -51, 122,-102, 316, 990, 177, -29,
     c 396,  18, 362, 552, 454, -57, 123,-109, 312, 949, 176, -33,
     c 396,  16, 358, 550, 452, -61, 122,-114, 308, 900, 170, -39,
     c 395,  16, 361, 547, 452, -71, 122,-118, 305, 857, 160, -41,
     c 396,  20, 366, 548, 453, -70, 121,-119, 305, 836, 153, -42,
     c 399,  26, 373, 550, 453, -68, 124,-121, 308, 839, 155, -42,
     c 406,  36, 383, 555, 453, -64, 127,-118, 313, 849, 162, -43,
     c 412,  37, 390, 559, 451, -61, 130,-117, 319, 853, 168, -46,
     c 413,  28, 391, 560, 449, -60, 127,-118, 322, 852, 171, -48,
     c 410,  12, 385, 560, 443, -68, 123,-126, 321, 839, 172, -51,
     c 409,   0, 378, 561, 442, -69, 121,-134, 318, 819, 172, -55,
     c 407,  -7, 374, 563, 440, -69, 120,-140, 314, 804, 172, -59,
     c 406,  -5, 373, 563, 438, -73, 120,-145, 313, 797, 174, -63,
     c 406,   0, 374, 561, 435, -75, 119,-151, 313, 783, 176, -68,
     c 406,   6, 377, 562, 435, -77, 120,-153, 316, 765, 178, -72,
     c 406,  12, 376, 559, 429, -82, 121,-160, 317, 750, 179, -75,
     c 409,  19, 374, 554, 424, -89, 121,-165, 317, 742, 183, -77,
     c 415,  28, 379, 554, 420, -93, 121,-171, 314, 744, 187, -81,
     c 415,  33, 383, 551, 414, -98, 117,-175, 309, 750, 191, -85,
     c 407,  31, 380, 543, 401,-112, 111,-185, 304, 753, 193, -91,
     c 401,  28, 379, 533, 391,-111, 104,-194, 299, 742, 195, -96,
     c 395,  24, 377, 525, 384,-120,  97,-204, 292, 722, 195,-103,
     c 348, -21, 364, 537, 492, -33, 111, -51, 301, 961, 170,  16,
     c 357, -11, 372, 539, 489, -20, 117, -52, 301, 998, 176,  13,
     c 366,  -1, 379, 541, 485, -21, 122, -51, 303,1011, 178,  11,
     c 370,   6, 387, 542, 485, -18, 127, -55, 305, 993, 174,   9,
     c 370,   4, 387, 543, 484, -17, 129, -58, 308, 958, 168,   6,
     c 370,  -3, 380, 542, 480, -24, 132, -64, 312, 926, 163,   3,
     c 375,  -7, 371, 544, 476, -28, 132, -72, 316, 908, 162,   1,
     c 384,  -1, 367, 550, 470, -28, 132, -77, 319, 899, 166,  -2,
     c 388,   9, 365, 554, 464, -30, 129, -82, 321, 913, 172,  -9,
     c 391,  18, 365, 553, 459, -41, 126, -87, 322, 968, 175, -16,
     c 394,  20, 364, 552, 457, -42, 124, -94, 320,1022, 177, -24,
     c 395,  17, 363, 553, 457, -46, 125,-101, 317,1025, 177, -29,
     c 395,  12, 362, 553, 457, -57, 124,-107, 313, 977, 175, -34,
     c 394,   8, 358, 550, 455, -65, 122,-111, 308, 917, 169, -38,
     c 392,   7, 357, 546, 453, -74, 120,-115, 305, 861, 159, -41,
     c 394,  10, 361, 547, 454, -72, 121,-118, 304, 831, 154, -42,
     c 399,  16, 369, 552, 456, -68, 124,-117, 308, 828, 157, -41,
     c 405,  25, 380, 558, 456, -64, 128,-116, 314, 836, 164, -42,
     c 410,  30, 388, 561, 454, -58, 126,-115, 319, 841, 171, -44,
     c 414,  26, 389, 562, 451, -58, 126,-121, 323, 843, 175, -46,
     c 412,  16, 384, 563, 448, -61, 122,-128, 323, 831, 176, -51,
     c 409,   5, 378, 564, 447, -65, 119,-133, 321, 810, 175, -56,
     c 405,  -1, 373, 565, 445, -67, 118,-141, 320, 793, 175, -59,
     c 404,  -2, 373, 565, 442, -66, 119,-145, 318, 785, 177, -63,
     c 406,   3, 376, 564, 439, -75, 121,-149, 320, 771, 180, -66,
     c 409,  10, 381, 565, 439, -75, 123,-150, 321, 761, 182, -69,
     c 411,  18, 384, 564, 435, -78, 125,-153, 324, 752, 184, -70,
     c 416,  26, 384, 561, 428, -89, 127,-157, 324, 745, 188, -72,
     c 419,  34, 388, 561, 423, -89, 127,-165, 321, 747, 193, -74,
     c 418,  39, 393, 558, 418, -94, 123,-169, 317, 757, 197, -78,
     c 412,  38, 392, 549, 407,-105, 118,-178, 312, 761, 200, -83,
     c 407,  34, 390, 540, 398,-106, 111,-186, 307, 752, 202, -88,
     c 402,  31, 388, 532, 392,-114, 105,-193, 302, 733, 202, -94,
     c 347, -17, 362, 538, 494, -27, 115, -46, 300, 960, 177,  19,
     c 355,  -8, 370, 538, 490, -22, 119, -50, 301, 993, 181,  15,
     c 363,   0, 378, 539, 486, -19, 122, -50, 303,1005, 181,  12,
     c 370,   8, 385, 541, 483, -14, 128, -52, 306, 994, 177,   8,
     c 372,   7, 387, 544, 485, -13, 130, -55, 310, 960, 171,   6,
     c 374,   0, 382, 545, 481, -22, 133, -61, 314, 929, 167,   3,
     c 380,  -5, 374, 550, 475, -26, 136, -67, 318, 909, 167,   0,
     c 388,   0, 368, 556, 470, -28, 134, -73, 323, 901, 171,  -3,
     c 391,  10, 365, 558, 466, -35, 133, -82, 324, 913, 175,  -9,
     c 393,  17, 366, 558, 462, -43, 130, -90, 323, 965, 178, -17,
     c 394,  18, 366, 556, 462, -44, 128, -97, 322,1015, 178, -23,
     c 396,  14, 365, 553, 462, -45, 127,-102, 318,1019, 179, -28,
     c 396,   8, 360, 553, 461, -58, 126,-109, 314, 973, 176, -34,
     c 394,   4, 356, 551, 459, -62, 122,-112, 307, 909, 170, -39,
     c 392,   3, 354, 548, 458, -69, 120,-115, 304, 851, 162, -41,
     c 393,   2, 355, 546, 456, -74, 120,-115, 305, 815, 157, -41,
     c 398,   7, 366, 554, 456, -64, 123,-114, 308, 809, 159, -40,
     c 402,  16, 378, 560, 456, -60, 125,-115, 313, 819, 166, -41,
     c 409,  23, 388, 565, 456, -54, 125,-118, 320, 825, 172, -42,
     c 412,  24, 390, 567, 454, -58, 122,-126, 324, 830, 177, -46,
     c 411,  19, 385, 568, 453, -61, 120,-131, 326, 827, 179, -50,
     c 407,  10, 377, 566, 451, -65, 119,-136, 325, 812, 179, -55,
     c 404,   2, 372, 567, 450, -71, 120,-139, 324, 795, 179, -60,
     c 404,   1, 374, 569, 446, -69, 121,-143, 324, 786, 182, -63,
     c 408,   7, 381, 569, 444, -72, 124,-143, 325, 776, 184, -64,
     c 412,  16, 388, 569, 442, -75, 128,-144, 327, 764, 187, -66,
     c 418,  28, 393, 566, 438, -81, 133,-145, 328, 755, 190, -66,
     c 422,  36, 394, 566, 430, -88, 135,-149, 328, 746, 194, -66,
     c 426,  43, 399, 567, 426, -90, 137,-153, 326, 746, 199, -67,
     c 424,  45, 402, 565, 422, -93, 134,-160, 323, 755, 202, -70,
     c 420,  44, 402, 557, 413,-103, 127,-170, 320, 761, 205, -75,
     c 416,  41, 400, 550, 405,-102, 122,-179, 315, 753, 208, -80,
     c 412,  37, 398, 542, 398,-106, 116,-186, 310, 734, 209, -84,
     c 345, -18, 358, 537, 495, -24, 117, -43, 299, 936, 179,  20,
     c 353,  -9, 366, 537, 488, -21, 120, -50, 300, 966, 181,  16,
     c 360,  -1, 372, 534, 483, -23, 122, -51, 302, 984, 180,  11,
     c 367,   6, 377, 538, 479, -16, 127, -52, 305, 985, 176,   8,
     c 371,   6, 382, 543, 483, -12, 130, -54, 310, 968, 171,   5,
     c 376,   0, 385, 549, 482, -17, 133, -58, 315, 941, 169,   2,
     c 383,  -4, 378, 555, 476, -20, 135, -63, 320, 922, 169,   0,
     c 388,   0, 369, 561, 471, -28, 136, -71, 323, 915, 174,  -3,
     c 391,   9, 366, 563, 468, -34, 135, -82, 326, 918, 179,  -9,
     c 393,  16, 368, 563, 466, -41, 132, -91, 324, 955, 180, -17,
     c 395,  18, 368, 559, 466, -42, 131, -95, 321, 997, 180, -23,
     c 397,  15, 365, 555, 466, -42, 130, -98, 318, 998, 179, -29,
     c 397,  10, 359, 553, 464, -58, 127,-104, 313, 950, 177, -34,
     c 395,   6, 352, 550, 463, -55, 123,-110, 308, 889, 171, -39,
     c 393,   2, 349, 550, 462, -65, 119,-111, 305, 837, 164, -41,
     c 394,   0, 352, 551, 460, -67, 119,-114, 305, 802, 160, -42,
     c 396,   1, 360, 555, 456, -61, 121,-112, 309, 797, 162, -41,
     c 400,   7, 374, 561, 456, -60, 123,-116, 315, 809, 167, -41,
     c 407,  16, 389, 568, 459, -50, 123,-118, 321, 816, 174, -42,
     c 410,  20, 391, 569, 456, -58, 121,-126, 325, 825, 178, -45,
     c 408,  19, 383, 568, 454, -62, 118,-132, 328, 826, 180, -50,
     c 405,  14, 376, 567, 453, -63, 118,-135, 328, 818, 181, -54,
     c 403,   8, 373, 567, 452, -69, 119,-137, 328, 803, 183, -58,
     c 403,   6, 376, 570, 448, -67, 122,-138, 328, 794, 186, -60,
     c 408,  13, 384, 570, 444, -70, 128,-138, 330, 782, 189, -62,
     c 416,  26, 395, 571, 443, -74, 132,-139, 331, 769, 192, -62,
     c 420,  38, 399, 569, 439, -81, 137,-140, 333, 755, 195, -61,
     c 427,  47, 401, 571, 435, -86, 141,-143, 333, 742, 199, -61,
     c 431,  52, 406, 572, 431, -87, 142,-144, 331, 739, 205, -61,
     c 431,  54, 410, 572, 428, -89, 141,-150, 329, 747, 208, -64,
     c 428,  52, 409, 566, 419, -92, 135,-161, 325, 754, 211, -67,
     c 425,  48, 407, 560, 411, -89, 131,-171, 322, 746, 213, -71,
     c 421,  44, 404, 554, 403, -97, 126,-178, 319, 728, 215, -75,
     c 346, -18, 354, 535, 496, -24, 120, -44, 298, 870, 176,  20,
     c 352, -12, 358, 533, 488, -21, 121, -52, 299, 909, 175,  15,
     c 360,  -5, 363, 531, 481, -21, 123, -54, 301, 940, 174,  11,
     c 366,   1, 369, 534, 479, -15, 125, -56, 305, 964, 171,   8,
     c 369,   1, 378, 542, 483, -13, 128, -57, 310, 962, 168,   4,
     c 374,  -3, 383, 549, 483, -24, 132, -57, 316, 944, 167,   0,
     c 382,  -6, 379, 557, 478, -23, 134, -65, 319, 928, 170,  -2,
     c 387,  -2, 370, 564, 471, -29, 134, -74, 323, 917, 175,  -5,
     c 391,   6, 369, 568, 470, -34, 134, -85, 324, 911, 180, -11,
     c 394,  15, 369, 564, 469, -39, 133, -92, 323, 935, 180, -18,
     c 397,  18, 366, 561, 468, -42, 132, -97, 321, 967, 180, -25,
     c 399,  17, 364, 556, 467, -45, 131,-100, 317, 963, 180, -29,
     c 397,  13, 357, 550, 468, -61, 127,-105, 313, 915, 177, -35,
     c 394,   9, 347, 547, 465, -60, 123,-108, 309, 859, 173, -38,
     c 393,   5, 343, 549, 463, -65, 118,-113, 306, 811, 167, -41,
     c 393,   0, 348, 550, 461, -68, 118,-116, 307, 782, 163, -42,
     c 395,  -1, 359, 555, 459, -60, 118,-117, 310, 784, 162, -41,
     c 399,   2, 373, 562, 460, -59, 119,-119, 317, 802, 167, -42,
     c 404,  11, 387, 566, 460, -51, 119,-120, 323, 810, 172, -43,
     c 408,  19, 390, 567, 458, -58, 119,-128, 328, 820, 178, -46,
     c 408,  22, 385, 567, 455, -60, 119,-131, 330, 828, 181, -49,
     c 407,  19, 377, 567, 453, -61, 120,-135, 331, 829, 184, -54,
     c 406,  14, 375, 567, 451, -68, 123,-133, 331, 819, 186, -57,
     c 407,  13, 381, 569, 446, -69, 128,-133, 332, 813, 190, -57,
     c 413,  21, 390, 573, 443, -69, 133,-132, 333, 801, 193, -58,
     c 418,  35, 400, 576, 440, -71, 137,-133, 335, 782, 197, -58,
     c 424,  50, 405, 576, 438, -79, 141,-136, 336, 760, 200, -57,
     c 430,  59, 410, 577, 438, -83, 144,-137, 336, 741, 204, -56,
     c 434,  62, 414, 579, 438, -84, 148,-140, 334, 735, 208, -56,
     c 435,  61, 416, 577, 435, -87, 146,-147, 333, 741, 211, -58,
     c 435,  59, 414, 573, 426, -92, 142,-158, 331, 747, 214, -61,
     c 433,  55, 412, 568, 417, -91, 139,-166, 328, 739, 218, -63,
     c 432,  51, 412, 565, 409, -88, 135,-170, 326, 722, 221, -65,
     c 352, -16, 355, 534, 498, -14, 121, -45, 297, 784, 170,  19,
     c 357, -12, 356, 532, 489, -18, 122, -51, 299, 835, 168,  15,
     c 363,  -7, 359, 531, 482, -18, 125, -56, 302, 880, 166,  11,
     c 365,  -3, 361, 534, 479, -18, 125, -58, 306, 929, 165,   6,
     c 367,  -3, 371, 542, 482, -19, 126, -60, 311, 946, 164,   3,
     c 369,  -8, 377, 545, 479, -29, 130, -61, 315, 936, 164,  -1,
     c 377, -10, 376, 553, 476, -27, 130, -70, 318, 915, 167,  -5,
     c 385,  -5, 370, 563, 472, -31, 131, -78, 321, 892, 172,  -9,
     c 390,   2, 365, 564, 470, -33, 132, -84, 322, 878, 177, -14,
     c 394,  11, 363, 561, 467, -40, 132, -89, 320, 895, 179, -20,
     c 398,  17, 365, 558, 468, -44, 131, -93, 318, 926, 178, -26,
     c 399,  18, 365, 554, 469, -46, 131, -98, 315, 920, 177, -29,
     c 397,  17, 358, 548, 469, -61, 127,-103, 312, 874, 176, -34,
     c 393,  14, 346, 547, 464, -57, 123,-106, 309, 825, 173, -39,
     c 392,   8, 341, 546, 462, -65, 118,-111, 308, 786, 167, -41,
     c 392,   2, 344, 548, 459, -65, 116,-118, 308, 769, 162, -42,
     c 392,  -2, 356, 554, 456, -57, 115,-122, 313, 781, 162, -43,
     c 395,   0, 371, 561, 459, -57, 115,-123, 318, 807, 165, -45,
     c 402,   9, 382, 563, 458, -53, 117,-125, 324, 819, 170, -46,
     c 406,  19, 388, 564, 454, -60, 118,-126, 328, 830, 175, -48,
     c 409,  25, 385, 568, 454, -63, 120,-128, 331, 842, 179, -51,
     c 411,  24, 382, 569, 453, -60, 123,-126, 333, 847, 183, -54,
     c 411,  21, 382, 569, 450, -69, 126,-127, 334, 844, 188, -56,
     c 414,  19, 386, 573, 445, -73, 132,-126, 334, 842, 193, -57,
     c 417,  27, 395, 577, 440, -70, 136,-126, 336, 830, 197, -57,
     c 420,  42, 403, 579, 437, -74, 140,-130, 337, 804, 199, -56,
     c 426,  57, 410, 581, 438, -77, 144,-134, 339, 774, 203, -55,
     c 431,  66, 414, 582, 440, -84, 145,-138, 338, 749, 207, -55,
     c 434,  68, 418, 582, 441, -89, 147,-141, 337, 738, 210, -54,
     c 438,  68, 421, 579, 440, -89, 148,-145, 335, 739, 215, -54,
     c 440,  65, 422, 577, 433, -89, 147,-154, 335, 743, 219, -54,
     c 440,  61, 420, 573, 424, -85, 145,-160, 335, 736, 222, -55,
     c 440,  57, 419, 569, 416, -85, 144,-162, 333, 719, 227, -56,
     c 359, -14, 359, 536, 500, -10, 123, -44, 298, 715, 167,  18,
     c 363, -11, 359, 534, 491, -10, 124, -51, 300, 766, 164,  14,
     c 366,  -8, 358, 535, 485, -14, 124, -58, 304, 817, 161,   9,
     c 366,  -6, 357, 539, 480, -15, 126, -62, 308, 893, 159,   5,
     c 364,  -9, 363, 544, 481, -23, 127, -63, 312, 929, 159,   0,
     c 365, -14, 370, 546, 477, -34, 126, -65, 315, 917, 160,  -4,
     c 374, -15, 371, 550, 472, -32, 127, -75, 317, 892, 163,  -8,
     c 383, -10, 368, 557, 469, -40, 127, -82, 318, 859, 169, -12,
     c 387,  -2, 362, 557, 466, -41, 128, -88, 319, 841, 174, -17,
     c 390,   6, 359, 553, 464, -48, 128, -93, 317, 863, 175, -23,
     c 395,  14, 364, 552, 467, -46, 128, -96, 316, 902, 175, -27,
     c 397,  18, 367, 550, 471, -51, 127,-100, 314, 904, 175, -31,
     c 394,  19, 361, 547, 470, -60, 124,-104, 312, 862, 174, -34,
     c 391,  16, 349, 545, 468, -56, 122,-108, 309, 817, 171, -38,
     c 390,  12, 344, 546, 466, -68, 117,-111, 308, 783, 167, -41,
     c 389,   5, 345, 550, 462, -61, 113,-117, 310, 772, 163, -44,
     c 389,   2, 354, 554, 460, -56, 109,-122, 313, 791, 161, -45,
     c 391,   3, 365, 558, 459, -60, 110,-126, 319, 820, 164, -47,
     c 397,  12, 378, 561, 458, -53, 112,-128, 324, 833, 167, -49,
     c 403,  23, 384, 563, 455, -58, 117,-127, 329, 837, 173, -52,
     c 407,  29, 384, 564, 452, -63, 120,-127, 333, 847, 178, -54,
     c 410,  28, 382, 567, 451, -63, 124,-125, 334, 854, 183, -56,
     c 412,  25, 386, 571, 450, -70, 128,-123, 335, 853, 189, -56,
     c 414,  24, 391, 574, 444, -78, 132,-124, 336, 855, 195, -57,
     c 417,  30, 397, 576, 437, -78, 136,-125, 336, 844, 198, -57,
     c 420,  43, 403, 578, 433, -78, 139,-132, 339, 815, 202, -56,
     c 425,  58, 409, 581, 437, -84, 139,-137, 339, 780, 204, -56,
     c 432,  68, 415, 583, 441, -83, 142,-141, 339, 751, 208, -55,
     c 436,  70, 420, 581, 442, -89, 144,-142, 338, 736, 212, -53,
     c 440,  71, 424, 578, 440, -87, 146,-145, 338, 735, 217, -51,
     c 445,  70, 425, 575, 436, -87, 149,-149, 339, 737, 222, -50,
     c 447,  67, 425, 576, 432, -83, 152,-153, 339, 730, 227, -49,
     c 449,  64, 424, 574, 425, -84, 154,-153, 341, 715, 233, -49,
     c 361, -15, 363, 535, 497, -19, 121, -47, 298, 655, 167,  15,
     c 363, -13, 361, 534, 490, -17, 121, -55, 303, 722, 163,  10,
     c 365, -12, 359, 534, 483, -18, 122, -58, 306, 783, 161,   6,
     c 362, -11, 356, 542, 480, -15, 123, -63, 310, 857, 159,   2,
     c 359, -15, 357, 547, 479, -21, 124, -67, 313, 900, 158,  -2,
     c 362, -19, 364, 549, 476, -32, 123, -73, 315, 897, 158,  -9,
     c 371, -20, 370, 552, 469, -30, 123, -77, 315, 866, 161, -13,
     c 378, -14, 365, 554, 468, -37, 123, -85, 316, 823, 166, -17,
     c 381,  -6, 359, 552, 466, -42, 122, -90, 315, 811, 169, -22,
     c 385,   1, 356, 548, 465, -49, 123, -97, 314, 854, 170, -27,
     c 388,  10, 362, 549, 467, -50, 122, -99, 313, 907, 169, -30,
     c 393,  16, 367, 549, 471, -54, 123,-103, 312, 914, 169, -32,
     c 393,  19, 364, 548, 470, -60, 121,-107, 311, 874, 169, -35,
     c 390,  18, 355, 547, 470, -59, 118,-110, 309, 830, 168, -38,
     c 389,  14, 350, 550, 468, -64, 114,-116, 309, 798, 166, -42,
     c 389,   9, 350, 554, 465, -57, 110,-119, 309, 789, 162, -45,
     c 387,   5, 353, 554, 462, -56, 107,-125, 313, 806, 161, -48,
     c 388,   8, 362, 555, 461, -59, 106,-129, 318, 832, 163, -51,
     c 393,  17, 373, 559, 458, -58, 110,-132, 323, 839, 166, -55,
     c 398,  27, 380, 561, 452, -60, 114,-130, 329, 834, 170, -56,
     c 402,  33, 380, 561, 447, -68, 120,-127, 332, 832, 176, -59,
     c 405,  32, 381, 564, 446, -70, 123,-123, 334, 835, 182, -59,
     c 407,  28, 386, 569, 446, -77, 126,-124, 336, 837, 188, -60,
     c 409,  25, 392, 572, 440, -81, 129,-128, 335, 842, 195, -60,
     c 410,  28, 394, 571, 431, -81, 130,-132, 337, 834, 199, -60,
     c 414,  39, 398, 572, 428, -84, 131,-140, 337, 807, 201, -60,
     c 422,  54, 405, 576, 434, -85, 132,-145, 337, 771, 204, -59,
     c 431,  64, 412, 577, 440, -84, 135,-147, 338, 744, 207, -59,
     c 439,  70, 419, 579, 442, -89, 140,-145, 338, 729, 212, -56,
     c 446,  73, 422, 575, 440, -86, 147,-143, 339, 728, 219, -52,
     c 453,  74, 427, 575, 439, -81, 154,-144, 342, 730, 225, -48,
     c 456,  73, 428, 578, 439, -78, 160,-142, 345, 724, 231, -45,
     c 458,  70, 429, 580, 436, -72, 166,-143, 348, 713, 238, -42,
     c 357, -18, 365, 533, 497, -13, 117, -54, 299, 666, 170,  10,
     c 356, -17, 362, 533, 490, -15, 119, -60, 303, 737, 167,   6,
     c 357, -16, 358, 534, 484, -15, 120, -62, 307, 795, 163,   2,
     c 355, -17, 355, 541, 478, -19, 120, -66, 311, 861, 161,  -2,
     c 354, -20, 358, 547, 477, -21, 120, -71, 312, 890, 159,  -7,
     c 357, -24, 362, 548, 471, -30, 119, -76, 313, 878, 159, -14,
     c 365, -22, 366, 551, 467, -30, 118, -84, 314, 832, 161, -20,
     c 372, -17, 363, 552, 464, -34, 118, -89, 312, 780, 163, -24,
     c 378,  -9, 356, 548, 466, -42, 118, -94, 312, 771, 165, -28,
     c 381,   0, 354, 545, 466, -48, 118,-101, 311, 834, 163, -32,
     c 386,   8, 360, 546, 467, -52, 118,-103, 310, 907, 162, -34,
     c 390,  15, 365, 549, 468, -55, 117,-105, 310, 927, 161, -35,
     c 391,  18, 365, 549, 469, -62, 118,-107, 309, 898, 162, -37,
     c 389,  17, 358, 551, 469, -65, 115,-110, 309, 857, 162, -40,
     c 389,  14, 351, 551, 467, -70, 111,-118, 309, 829, 161, -45,
     c 388,   9, 348, 552, 463, -62, 108,-119, 310, 819, 159, -49,
     c 385,   9, 351, 552, 461, -62, 103,-125, 313, 830, 159, -53,
     c 382,  12, 357, 551, 457, -65, 103,-128, 318, 845, 160, -57,
     c 386,  21, 367, 554, 452, -60, 107,-130, 323, 845, 163, -60,
     c 391,  32, 375, 557, 447, -66, 112,-130, 328, 825, 169, -62,
     c 395,  37, 377, 558, 442, -73, 115,-128, 332, 811, 174, -63,
     c 398,  36, 381, 563, 441, -77, 118,-128, 334, 807, 180, -65,
     c 399,  29, 386, 568, 438, -83, 120,-130, 334, 813, 186, -63,
     c 401,  24, 391, 568, 432, -85, 123,-136, 335, 822, 192, -63,
     c 403,  24, 392, 566, 426, -89, 121,-143, 334, 821, 195, -64,
     c 407,  33, 394, 565, 425, -91, 122,-151, 335, 799, 198, -65,
     c 416,  47, 399, 566, 430, -92, 123,-154, 335, 767, 199, -65,
     c 429,  59, 409, 569, 438, -89, 129,-150, 335, 741, 204, -63,
     c 439,  66, 416, 571, 440, -96, 135,-147, 337, 727, 210, -59,
     c 448,  73, 422, 572, 441, -85, 145,-141, 341, 725, 218, -53,
     c 459,  79, 431, 578, 445, -75, 159,-137, 345, 728, 227, -47,
     c 464,  78, 434, 586, 448, -71, 168,-131, 350, 724, 236, -42,
     c 469,  77, 437, 593, 451, -61, 179,-128, 355, 717, 244, -37,
     c 350, -24, 369, 532, 500, -22, 112, -62, 299, 745, 172,   4,
     c 351, -22, 365, 534, 492, -19, 115, -62, 303, 812, 169,   1,
     c 351, -21, 360, 533, 484, -21, 115, -64, 306, 861, 165,  -3,
     c 349, -22, 356, 537, 476, -24, 116, -69, 309, 902, 161,  -7,
     c 349, -25, 356, 542, 472, -25, 116, -75, 310, 906, 159, -14,
     c 353, -26, 359, 545, 466, -33, 114, -81, 311, 875, 158, -19,
     c 361, -23, 360, 545, 462, -38, 114, -87, 310, 804, 159, -25,
     c 369, -18, 357, 545, 462, -45, 113, -92, 309, 733, 160, -30,
     c 376, -11, 352, 545, 464, -49, 115, -97, 308, 725, 161, -34,
     c 378,  -2, 351, 543, 466, -51, 114,-102, 308, 805, 157, -37,
     c 385,   7, 357, 544, 467, -56, 114,-106, 307, 898, 154, -38,
     c 389,  13, 365, 548, 469, -57, 114,-109, 307, 939, 153, -38,
     c 387,  16, 366, 552, 468, -61, 112,-111, 307, 928, 155, -40,
     c 385,  15, 360, 553, 467, -61, 111,-115, 306, 904, 156, -43,
     c 386,  12, 351, 550, 464, -68, 106,-121, 307, 883, 156, -47,
     c 384,   8, 344, 548, 460, -67, 104,-125, 310, 874, 154, -52,
     c 380,   9, 345, 546, 455, -69, 101,-129, 313, 877, 155, -57,
     c 378,  15, 351, 547, 452, -69, 102,-132, 317, 879, 158, -61,
     c 380,  25, 362, 550, 448, -68, 104,-133, 322, 861, 162, -64,
     c 386,  35, 370, 553, 442, -72, 109,-133, 326, 826, 166, -67,
     c 390,  39, 378, 558, 439, -72, 113,-130, 330, 795, 171, -68,
     c 394,  36, 383, 565, 436, -79, 116,-132, 332, 782, 177, -68,
     c 397,  29, 388, 571, 434, -81, 117,-135, 333, 791, 182, -68,
     c 398,  21, 390, 569, 429, -82, 115,-143, 332, 806, 187, -69,
     c 398,  20, 387, 563, 425, -91, 114,-155, 332, 810, 190, -70,
     c 400,  27, 386, 557, 424, -94, 112,-160, 331, 794, 191, -71,
     c 412,  42, 393, 558, 430, -94, 116,-161, 330, 768, 194, -71,
     c 424,  54, 400, 561, 434, -92, 122,-155, 331, 742, 199, -69,
     c 437,  63, 409, 564, 437, -93, 133,-149, 335, 726, 207, -63,
     c 449,  71, 419, 568, 440, -92, 145,-141, 341, 721, 218, -56,
     c 463,  79, 434, 584, 451, -72, 162,-134, 348, 725, 229, -46,
     c 470,  79, 439, 596, 457, -66, 175,-127, 355, 724, 239, -39,
     c 477,  79, 445, 608, 466, -49, 187,-122, 361, 721, 248, -33,
     c 343, -31, 369, 532, 500, -31, 108, -63, 297, 851, 168,   0,
     c 345, -28, 364, 532, 491, -28, 111, -66, 301, 908, 164,  -5,
     c 346, -25, 360, 533, 482, -27, 112, -68, 304, 945, 161,  -9,
     c 345, -24, 354, 534, 472, -27, 112, -74, 306, 966, 158, -13,
     c 346, -25, 351, 538, 467, -28, 112, -79, 306, 947, 157, -19,
     c 352, -25, 352, 541, 463, -33, 111, -84, 305, 887, 156, -26,
     c 359, -23, 351, 539, 460, -36, 111, -91, 305, 791, 156, -31,
     c 367, -18, 347, 538, 460, -46, 110, -96, 305, 705, 157, -36,
     c 374, -12, 345, 538, 461, -51, 111,-100, 304, 695, 156, -39,
     c 378,  -4, 346, 538, 464, -52, 112,-106, 304, 779, 153, -42,
     c 382,   4, 354, 540, 466, -57, 111,-109, 303, 883, 149, -42,
     c 384,  10, 362, 544, 468, -58, 109,-113, 303, 941, 147, -42,
     c 381,  14, 364, 549, 467, -63, 106,-114, 304, 947, 149, -43,
     c 377,  12, 358, 551, 466, -63, 104,-119, 305, 939, 151, -46,
     c 379,   8, 350, 548, 463, -69, 103,-123, 307, 928, 152, -50,
     c 381,   5, 342, 546, 458, -69, 101,-127, 309, 921, 152, -55,
     c 378,   8, 340, 544, 452, -70, 100,-129, 314, 915, 154, -59,
     c 376,  15, 345, 544, 448, -70, 101,-133, 318, 904, 157, -64,
     c 378,  25, 358, 546, 446, -73, 104,-132, 322, 870, 162, -67,
     c 383,  35, 369, 552, 441, -74, 108,-133, 326, 817, 166, -69,
     c 386,  39, 376, 557, 436, -76, 109,-133, 329, 771, 171, -70,
     c 393,  36, 383, 564, 434, -86, 113,-135, 331, 753, 175, -72,
     c 396,  27, 389, 569, 433, -86, 113,-143, 330, 764, 179, -71,
     c 396,  20, 390, 568, 428, -85, 110,-152, 330, 781, 183, -72,
     c 396,  17, 384, 558, 423, -96, 108,-163, 328, 789, 184, -74,
     c 400,  24, 380, 550, 424,-104, 108,-165, 327, 781, 186, -76,
     c 407,  38, 383, 550, 429,-103, 111,-164, 326, 760, 188, -78,
     c 419,  50, 392, 555, 432, -96, 119,-155, 328, 736, 195, -75,
     c 433,  59, 403, 562, 436, -97, 129,-151, 333, 716, 205, -68,
     c 447,  67, 416, 571, 443, -87, 144,-142, 341, 709, 218, -58,
     c 464,  76, 431, 590, 456, -69, 162,-133, 350, 712, 231, -47,
     c 472,  76, 439, 604, 465, -59, 178,-124, 359, 712, 242, -38,
     c 481,  78, 448, 621, 477, -35, 192,-116, 367, 713, 250, -30,
     c 334, -38, 361, 528, 492, -31, 106, -69, 296, 923, 160,  -4,
     c 335, -34, 357, 527, 484, -24, 106, -72, 298, 986, 157,  -8,
     c 337, -30, 352, 529, 475, -28, 108, -73, 300,1019, 155, -12,
     c 338, -26, 346, 532, 468, -27, 107, -78, 300,1013, 154, -18,
     c 343, -25, 343, 535, 463, -32, 108, -81, 300, 972, 153, -23,
     c 352, -24, 343, 537, 463, -44, 108, -87, 299, 901, 152, -30,
     c 359, -22, 343, 536, 462, -45, 105, -95, 299, 793, 152, -37,
     c 364, -20, 339, 535, 460, -54, 105,-102, 299, 694, 152, -41,
     c 371, -16, 336, 533, 460, -58, 107,-105, 300, 676, 152, -45,
     c 377,  -7, 340, 535, 463, -57, 108,-108, 301, 754, 148, -46,
     c 378,   0, 349, 536, 465, -58, 107,-112, 301, 850, 145, -46,
     c 378,   7, 355, 538, 465, -63, 104,-117, 301, 906, 143, -46,
     c 374,  10, 356, 542, 463, -65, 101,-120, 302, 923, 146, -46,
     c 371,   9, 352, 544, 464, -59, 100,-122, 304, 927, 149, -49,
     c 374,   5, 346, 543, 463, -65,  99,-125, 306, 928, 151, -53,
     c 378,   1, 342, 546, 457, -65, 100,-128, 310, 928, 151, -57,
     c 379,   5, 343, 547, 452, -67, 100,-130, 315, 919, 153, -60,
     c 378,  14, 349, 546, 449, -71, 103,-133, 319, 902, 158, -64,
     c 378,  24, 359, 547, 445, -78, 104,-132, 323, 861, 163, -67,
     c 381,  34, 368, 552, 440, -80, 108,-132, 327, 798, 167, -70,
     c 385,  38, 377, 558, 434, -80, 108,-134, 328, 743, 171, -71,
     c 390,  35, 383, 562, 432, -94, 109,-139, 329, 721, 174, -73,
     c 393,  28, 388, 564, 430, -92, 108,-145, 329, 735, 176, -74,
     c 395,  20, 387, 560, 426, -94, 105,-155, 326, 754, 178, -77,
     c 396,  17, 380, 550, 422,-107, 103,-166, 324, 766, 179, -80,
     c 398,  24, 374, 542, 423,-113, 104,-166, 321, 762, 180, -83,
     c 404,  37, 376, 543, 425,-114, 108,-164, 320, 747, 184, -83,
     c 415,  49, 385, 551, 429,-106, 115,-156, 323, 723, 191, -81,
     c 428,  57, 396, 563, 435, -99, 128,-149, 330, 702, 203, -73,
     c 445,  65, 410, 578, 444, -91, 144,-141, 341, 694, 218, -61,
     c 463,  73, 428, 598, 458, -71, 164,-132, 352, 697, 233, -48,
     c 472,  73, 438, 611, 468, -58, 180,-120, 362, 698, 245, -38,
     c 482,  73, 447, 624, 479, -34, 196,-113, 371, 700, 254, -28,
     c 322, -45, 353, 520, 483, -34, 100, -73, 295, 964, 152,  -4,
     c 324, -40, 348, 520, 477, -32, 101, -76, 297,1017, 151,  -9,
     c 327, -35, 342, 523, 469, -36, 101, -80, 297,1036, 149, -15,
     c 330, -29, 337, 529, 463, -32, 100, -86, 296,1026, 148, -20,
     c 339, -25, 336, 533, 462, -36, 102, -87, 295, 974, 148, -28,
     c 348, -22, 338, 535, 461, -45, 101, -92, 294, 890, 147, -34,
     c 354, -22, 337, 533, 460, -49, 100,-100, 294, 778, 147, -40,
     c 362, -22, 334, 531, 458, -57, 101,-106, 295, 680, 147, -46,
     c 368, -20, 334, 531, 459, -58, 102,-109, 297, 658, 145, -49,
     c 372, -13, 338, 533, 462, -61, 102,-109, 298, 724, 143, -50,
     c 376,  -4, 343, 534, 463, -61, 102,-116, 299, 802, 139, -51,
     c 374,   2, 346, 532, 461, -68, 100,-120, 299, 849, 139, -50,
     c 369,   8, 347, 533, 459, -71,  96,-121, 300, 867, 143, -51,
     c 367,   9, 348, 538, 461, -56,  96,-125, 302, 877, 147, -52,
     c 371,   4, 346, 541, 462, -56,  98,-124, 306, 887, 148, -55,
     c 377,   1, 346, 546, 459, -57, 100,-127, 310, 897, 150, -58,
     c 379,   3, 349, 548, 455, -59, 102,-129, 317, 895, 154, -60,
     c 379,  10, 355, 550, 450, -66, 105,-131, 321, 882, 159, -63,
     c 378,  20, 362, 551, 444, -76, 105,-131, 325, 846, 164, -68,
     c 378,  30, 369, 554, 436, -80, 105,-134, 326, 785, 167, -70,
     c 381,  36, 376, 557, 431, -84, 106,-137, 327, 728, 170, -73,
     c 386,  36, 382, 561, 429, -89, 106,-143, 327, 708, 171, -75,
     c 389,  30, 386, 560, 426, -93, 103,-152, 325, 722, 173, -78,
     c 391,  24, 383, 551, 422,-100,  99,-163, 322, 738, 173, -80,
     c 394,  21, 376, 542, 421,-113,  98,-169, 319, 749, 172, -85,
     c 397,  24, 370, 536, 421,-120,  99,-169, 316, 749, 174, -88,
     c 402,  35, 371, 539, 423,-121, 104,-165, 316, 739, 179, -90,
     c 411,  48, 379, 551, 426,-111, 112,-159, 320, 718, 188, -86,
     c 423,  58, 389, 566, 433,-103, 126,-151, 329, 697, 202, -77,
     c 441,  67, 404, 582, 442, -91, 143,-140, 342, 690, 220, -64,
     c 462,  73, 424, 604, 459, -70, 165,-131, 354, 691, 236, -50,
     c 472,  72, 435, 616, 468, -50, 182,-121, 366, 693, 248, -38,
     c 482,  69, 445, 626, 478, -25, 197,-111, 375, 696, 256, -27,
     c 315, -47, 351, 517, 480, -28,  95, -81, 295, 948, 146,  -4,
     c 317, -42, 345, 517, 475, -34,  95, -83, 296, 998, 145, -10,
     c 318, -37, 339, 520, 467, -41,  94, -85, 295,1014, 145, -16,
     c 322, -30, 332, 524, 459, -42,  93, -90, 293, 995, 145, -22,
     c 332, -24, 332, 530, 458, -48,  93, -95, 291, 934, 145, -31,
     c 341, -23, 332, 531, 456, -54,  94, -99, 289, 845, 142, -39,
     c 348, -23, 329, 527, 453, -58,  92,-105, 290, 736, 140, -46,
     c 356, -26, 329, 524, 451, -65,  93,-111, 292, 651, 138, -52,
     c 362, -25, 332, 524, 455, -64,  96,-115, 295, 645, 138, -55,
     c 366, -19, 336, 528, 459, -62,  99,-115, 297, 711, 136, -55,
     c 371,  -9, 339, 531, 461, -61,  97,-118, 298, 778, 135, -55,
     c 374,   0, 340, 530, 458, -67,  96,-121, 298, 812, 136, -55,
     c 370,   7, 342, 530, 458, -71,  92,-122, 299, 825, 139, -54,
     c 368,   9, 345, 534, 458, -63,  95,-123, 301, 836, 144, -56,
     c 371,   6, 345, 540, 460, -61,  98,-124, 304, 848, 148, -58,
     c 374,   0, 344, 544, 459, -65, 101,-128, 311, 864, 151, -61,
     c 376,   0, 349, 548, 454, -70, 103,-129, 317, 872, 154, -63,
     c 375,   6, 358, 552, 450, -69, 104,-129, 321, 867, 160, -66,
     c 375,  16, 365, 553, 445, -76, 104,-130, 325, 839, 164, -69,
     c 374,  25, 368, 554, 433, -86, 103,-134, 326, 786, 166, -73,
     c 376,  32, 374, 557, 426, -89, 102,-140, 324, 734, 168, -76,
     c 381,  36, 381, 561, 425, -95, 101,-146, 323, 715, 169, -80,
     c 384,  34, 381, 556, 424,-101,  97,-158, 321, 725, 167, -83,
     c 386,  28, 376, 543, 420,-113,  93,-169, 317, 734, 167, -86,
     c 389,  23, 368, 535, 418,-127,  93,-173, 314, 738, 166, -91,
     c 393,  25, 362, 532, 418,-128,  94,-174, 311, 740, 168, -94,
     c 398,  34, 364, 539, 421,-125,  99,-171, 311, 734, 175, -95,
     c 407,  48, 373, 554, 423,-116, 108,-162, 317, 719, 185, -91,
     c 420,  61, 385, 571, 430,-101, 124,-151, 327, 702, 201, -81,
     c 438,  70, 400, 590, 441, -88, 143,-142, 342, 697, 221, -67,
     c 460,  74, 421, 612, 457, -66, 165,-131, 357, 700, 238, -51,
     c 472,  70, 433, 622, 466, -45, 182,-123, 368, 701, 250, -38,
     c 483,  66, 443, 632, 476, -19, 199,-112, 378, 704, 258, -26,
     c 314, -45, 353, 516, 480, -26,  93, -80, 296, 926, 143,  -5,
     c 317, -40, 347, 517, 474, -31,  93, -83, 295, 970, 144, -11,
     c 317, -36, 341, 519, 467, -40,  90, -87, 293, 981, 143, -18,
     c 317, -30, 331, 523, 459, -45,  86, -94, 290, 958, 142, -27,
     c 326, -26, 326, 529, 456, -51,  86,-100, 287, 890, 141, -35,
     c 335, -24, 325, 528, 452, -57,  86,-108, 285, 799, 136, -45,
     c 342, -25, 323, 522, 448, -63,  85,-114, 285, 697, 131, -53,
     c 348, -29, 325, 517, 445, -69,  86,-117, 288, 634, 130, -58,
     c 355, -30, 331, 518, 449, -67,  90,-120, 292, 652, 131, -60,
     c 361, -24, 336, 525, 455, -62,  94,-119, 296, 729, 131, -60,
     c 366, -14, 340, 528, 460, -64,  93,-120, 297, 789, 131, -60,
     c 368,  -4, 340, 529, 460, -67,  90,-121, 298, 813, 133, -58,
     c 370,   6, 340, 531, 457, -69,  89,-124, 297, 814, 138, -58,
     c 369,  11, 343, 535, 457, -64,  92,-124, 299, 819, 143, -59,
     c 368,   6, 344, 539, 458, -58,  97,-124, 303, 827, 147, -61,
     c 368,  -1, 342, 540, 454, -69, 100,-129, 309, 840, 150, -64,
     c 368,  -5, 345, 544, 451, -77, 101,-129, 316, 851, 154, -66,
     c 369,  -1, 354, 548, 450, -77, 101,-132, 321, 856, 159, -69,
     c 368,   6, 360, 551, 441, -83,  99,-133, 323, 840, 163, -73,
     c 369,  17, 365, 553, 430, -89,  99,-138, 323, 796, 165, -77,
     c 372,  28, 370, 556, 421, -93,  98,-147, 321, 753, 165, -82,
     c 376,  35, 375, 556, 419,-100,  95,-155, 319, 736, 165, -85,
     c 380,  36, 374, 549, 418,-108,  91,-168, 315, 739, 163, -88,
     c 381,  32, 367, 537, 415,-120,  89,-176, 312, 735, 162, -92,
     c 384,  26, 360, 529, 413,-131,  88,-180, 308, 730, 160, -96,
     c 388,  24, 356, 527, 414,-131,  89,-177, 307, 732, 163,-100,
     c 395,  31, 357, 537, 416,-129,  95,-174, 309, 733, 170,-101,
     c 403,  46, 368, 555, 420,-121, 106,-168, 315, 723, 183, -96,
     c 417,  63, 383, 579, 428,-102, 121,-158, 327, 712, 200, -86,
     c 436,  74, 400, 604, 442, -86, 142,-148, 342, 710, 220, -71,
     c 457,  73, 417, 622, 456, -67, 164,-139, 358, 714, 238, -55,
     c 469,  68, 428, 629, 465, -44, 181,-130, 371, 717, 249, -42,
     c 480,  61, 438, 636, 472, -19, 197,-119, 380, 719, 257, -29,
     c 319, -39, 356, 518, 479, -19,  97, -78, 297, 920, 146,  -6,
     c 318, -37, 348, 519, 471, -31,  94, -83, 296, 959, 147, -13,
     c 318, -35, 340, 520, 465, -37,  91, -87, 293, 966, 145, -21,
     c 315, -32, 329, 523, 458, -45,  84, -97, 289, 937, 143, -30,
     c 321, -28, 320, 526, 455, -51,  81,-103, 285, 867, 139, -42,
     c 331, -26, 317, 525, 451, -54,  79,-114, 281, 777, 131, -51,
     c 338, -28, 319, 519, 447, -60,  77,-119, 282, 690, 125, -59,
     c 343, -31, 325, 513, 445, -67,  80,-122, 285, 645, 123, -64,
     c 349, -32, 333, 514, 446, -68,  85,-124, 289, 677, 124, -66,
     c 354, -27, 338, 519, 453, -66,  88,-124, 292, 757, 127, -66,
     c 360, -16, 340, 525, 460, -66,  88,-125, 295, 810, 129, -64,
     c 363,  -3, 339, 529, 462, -67,  85,-125, 296, 820, 132, -61,
     c 366,   7, 339, 532, 459, -65,  83,-129, 297, 811, 137, -61,
     c 366,  11, 341, 537, 458, -65,  86,-130, 298, 810, 142, -63,
     c 364,   6, 341, 539, 456, -61,  92,-130, 301, 811, 146, -65,
     c 361,  -6, 340, 537, 453, -71,  94,-135, 308, 820, 149, -67,
     c 360, -14, 340, 538, 447, -80,  94,-138, 314, 833, 152, -71,
     c 360, -12, 347, 542, 444, -79,  93,-137, 318, 843, 157, -74,
     c 360,  -4, 354, 546, 436, -86,  93,-137, 321, 836, 160, -78,
     c 361,   7, 358, 549, 425, -94,  93,-141, 320, 804, 162, -83,
     c 366,  21, 363, 554, 416, -96,  92,-150, 316, 770, 162, -87,
     c 373,  33, 366, 552, 415,-106,  91,-159, 313, 754, 161, -91,
     c 376,  38, 364, 542, 413,-115,  87,-171, 311, 748, 158, -95,
     c 377,  35, 359, 531, 411,-129,  85,-177, 307, 732, 156, -99,
     c 381,  29, 354, 524, 411,-140,  85,-179, 305, 719, 155,-103,
     c 385,  24, 350, 522, 410,-142,  86,-177, 304, 719, 158,-106,
     c 389,  29, 354, 532, 411,-140,  92,-175, 307, 723, 166,-107,
     c 399,  45, 366, 554, 417,-129, 105,-168, 314, 721, 179,-103,
     c 414,  64, 383, 584, 429,-103, 120,-162, 327, 717, 197, -91,
     c 433,  74, 397, 610, 441, -84, 141,-154, 343, 719, 218, -77,
     c 454,  72, 413, 628, 456, -68, 163,-145, 359, 725, 235, -61,
     c 464,  64, 423, 632, 463, -40, 179,-135, 371, 729, 247, -46,
     c 475,  56, 430, 637, 469, -15, 194,-125, 381, 733, 255, -33,
     c 321, -30, 359, 520, 476, -24,  99, -75, 298, 916, 151,  -7,
     c 320, -30, 350, 519, 469, -38,  97, -80, 296, 940, 150, -15,
     c 318, -31, 340, 520, 463, -40,  92, -85, 294, 942, 148, -23,
     c 315, -32, 327, 520, 455, -47,  85, -99, 289, 921, 144, -34,
     c 320, -31, 317, 521, 452, -56,  78,-104, 283, 868, 137, -46,
     c 330, -30, 313, 521, 450, -60,  76,-116, 279, 798, 128, -57,
     c 336, -31, 314, 515, 445, -67,  73,-123, 279, 732, 121, -66,
     c 340, -34, 323, 509, 443, -71,  76,-128, 280, 704, 117, -70,
     c 343, -34, 334, 509, 447, -72,  79,-130, 284, 738, 120, -72,
     c 348, -27, 341, 516, 453, -70,  83,-130, 290, 803, 123, -70,
     c 353, -15, 338, 523, 456, -71,  82,-129, 293, 839, 128, -67,
     c 358,  -2, 334, 528, 458, -75,  81,-131, 295, 830, 132, -65,
     c 362,   9, 337, 534, 459, -65,  79,-132, 296, 813, 136, -64,
     c 366,  14, 340, 539, 459, -68,  83,-132, 296, 808, 141, -65,
     c 363,   5, 340, 537, 455, -65,  87,-133, 300, 807, 144, -68,
     c 358, -10, 337, 533, 449, -73,  88,-138, 305, 814, 145, -72,
     c 354, -22, 337, 531, 443, -82,  86,-141, 312, 828, 149, -75,
     c 353, -23, 343, 534, 438, -84,  86,-141, 317, 842, 153, -78,
     c 355, -15, 349, 539, 431, -95,  87,-141, 318, 838, 157, -83,
     c 356,  -2, 353, 546, 421,-101,  88,-147, 317, 811, 158, -87,
     c 361,  15, 356, 551, 414,-106,  88,-155, 313, 784, 158, -92,
     c 366,  31, 358, 547, 412,-114,  86,-164, 309, 770, 156, -96,
     c 372,  39, 358, 537, 411,-122,  83,-172, 305, 757, 154,-100,
     c 375,  39, 354, 527, 410,-129,  82,-178, 303, 729, 152,-104,
     c 378,  31, 349, 520, 408,-141,  83,-182, 301, 708, 150,-109,
     c 380,  24, 348, 518, 407,-144,  84,-180, 301, 706, 154,-112,
     c 385,  26, 352, 529, 406,-144,  90,-177, 306, 714, 162,-113,
     c 396,  42, 366, 555, 414,-130, 103,-171, 314, 716, 175,-108,
     c 412,  61, 383, 584, 427,-107, 119,-165, 327, 718, 194, -98,
     c 429,  71, 396, 609, 440, -85, 138,-158, 342, 725, 214, -82,
     c 448,  66, 407, 624, 454, -71, 158,-149, 357, 733, 231, -67,
     c 458,  58, 413, 629, 459, -45, 174,-140, 370, 738, 242, -53,
     c 469,  50, 420, 634, 466, -19, 188,-131, 379, 742, 250, -39,
     c 321, -25, 359, 518, 478, -18, 100, -74, 299, 894, 155,  -8,
     c 320, -26, 350, 518, 471, -27,  97, -81, 297, 904, 154, -16,
     c 318, -28, 341, 518, 464, -32,  93, -87, 294, 904, 150, -25,
     c 315, -33, 326, 516, 454, -43,  84,-100, 289, 895, 144, -37,
     c 320, -35, 313, 515, 448, -54,  78,-107, 283, 873, 135, -49,
     c 328, -35, 310, 514, 443, -58,  73,-118, 278, 836, 125, -61,
     c 334, -35, 314, 511, 443, -64,  71,-125, 275, 796, 117, -69,
     c 335, -35, 322, 505, 440, -72,  71,-129, 277, 776, 115, -74,
     c 340, -34, 333, 505, 444, -73,  75,-133, 280, 801, 117, -75,
     c 345, -28, 337, 511, 449, -72,  78,-132, 285, 845, 122, -74,
     c 349, -15, 330, 517, 451, -75,  79,-133, 290, 856, 127, -71,
     c 354,   0, 327, 525, 453, -70,  77,-135, 292, 835, 131, -67,
     c 361,  10, 329, 534, 456, -64,  78,-133, 294, 820, 135, -67,
     c 365,  12, 336, 538, 456, -66,  82,-133, 295, 821, 139, -69,
     c 363,   3, 338, 536, 452, -64,  85,-135, 297, 825, 141, -72,
     c 355, -15, 336, 531, 447, -72,  83,-143, 304, 837, 142, -76,
     c 351, -28, 335, 527, 439, -80,  81,-146, 310, 852, 145, -79,
     c 350, -29, 340, 528, 434, -87,  80,-148, 315, 862, 149, -83,
     c 350, -22, 347, 537, 428, -96,  82,-146, 316, 853, 152, -86,
     c 352,  -8, 351, 545, 420,-102,  84,-150, 314, 825, 155, -91,
     c 356,   9, 351, 548, 414,-109,  85,-157, 309, 798, 155, -96,
     c 362,  28, 352, 543, 411,-116,  83,-167, 305, 782, 153,-101,
     c 368,  40, 352, 534, 411,-121,  80,-176, 301, 763, 150,-106,
     c 372,  40, 348, 522, 408,-127,  79,-182, 299, 728, 148,-111,
     c 373,  32, 344, 515, 406,-138,  79,-183, 299, 702, 147,-115,
     c 375,  22, 343, 516, 403,-146,  81,-185, 300, 698, 150,-119,
     c 380,  22, 350, 529, 403,-140,  86,-181, 304, 706, 159,-119,
     c 392,  33, 364, 552, 409,-131, 100,-174, 313, 714, 171,-115,
     c 407,  50, 383, 581, 423,-111, 116,-168, 325, 721, 188,-104,
     c 424,  58, 393, 603, 436, -93, 135,-161, 340, 730, 207, -89,
     c 443,  56, 402, 616, 448, -77, 154,-155, 353, 739, 224, -73,
     c 454,  49, 408, 622, 455, -51, 169,-146, 365, 744, 236, -59,
     c 465,  42, 412, 626, 460, -25, 183,-138, 374, 749, 242, -47,
     c 320, -25, 357, 515, 480, -21,  98, -79, 298, 885, 157,  -8,
     c 318, -27, 349, 516, 473, -28,  94, -83, 297, 875, 154, -16,
     c 318, -29, 341, 517, 466, -33,  90, -90, 293, 872, 150, -27,
     c 314, -34, 327, 515, 454, -43,  82,-100, 289, 883, 142, -39,
     c 317, -39, 312, 511, 444, -53,  74,-112, 282, 890, 133, -52,
     c 325, -42, 310, 510, 438, -64,  69,-121, 275, 885, 124, -64,
     c 330, -40, 315, 506, 437, -72,  67,-129, 272, 860, 117, -72,
     c 332, -39, 321, 501, 437, -77,  69,-132, 271, 840, 114, -76,
     c 336, -36, 327, 501, 441, -83,  73,-135, 275, 843, 118, -78,
     c 343, -29, 326, 508, 445, -83,  75,-137, 280, 862, 123, -77,
     c 348, -16, 319, 513, 447, -80,  75,-139, 285, 854, 128, -73,
     c 353,  -1, 315, 522, 451, -78,  76,-138, 289, 832, 132, -71,
     c 361,   7, 320, 531, 454, -70,  77,-134, 291, 822, 135, -70,
     c 365,   8, 328, 536, 454, -69,  80,-135, 292, 829, 138, -72,
     c 360,  -2, 333, 533, 449, -70,  82,-137, 296, 840, 138, -76,
     c 352, -19, 334, 528, 444, -75,  81,-142, 301, 857, 139, -80,
     c 350, -31, 334, 526, 438, -80,  78,-145, 308, 873, 140, -84,
     c 348, -32, 340, 528, 431, -87,  78,-145, 313, 880, 144, -86,
     c 349, -25, 346, 535, 425, -98,  79,-146, 314, 866, 148, -89,
     c 349, -13, 349, 544, 420,-104,  81,-151, 311, 835, 150, -94,
     c 351,   5, 347, 547, 415,-110,  81,-157, 306, 807, 150,-100,
     c 357,  25, 348, 540, 411,-112,  79,-169, 301, 791, 149,-105,
     c 364,  38, 348, 529, 409,-120,  75,-178, 297, 773, 147,-110,
     c 369,  39, 344, 517, 405,-129,  74,-187, 295, 738, 144,-116,
     c 370,  32, 341, 510, 400,-136,  75,-191, 295, 712, 143,-121,
     c 370,  20, 339, 510, 398,-147,  76,-193, 297, 703, 146,-125,
     c 376,  14, 345, 525, 399,-146,  82,-186, 302, 710, 153,-126,
     c 384,  21, 360, 547, 405,-135,  94,-181, 310, 717, 165,-121,
     c 399,  33, 376, 572, 417,-116, 110,-175, 320, 726, 182,-111,
     c 419,  41, 388, 594, 431, -95, 130,-169, 333, 733, 200, -95,
     c 436,  42, 396, 606, 442, -81, 148,-162, 346, 741, 215, -80,
     c 447,  38, 401, 610, 446, -55, 162,-153, 357, 746, 226, -66,
     c 457,  35, 405, 615, 451, -34, 174,-145, 367, 749, 234, -54,
     c 314, -35, 350, 509, 478, -26,  96, -82, 295, 870, 155,  -8,
     c 314, -34, 344, 512, 469, -34,  91, -84, 294, 843, 150, -18,
     c 315, -33, 338, 515, 461, -38,  86, -90, 291, 838, 144, -28,
     c 312, -36, 329, 515, 453, -46,  79,-103, 286, 862, 137, -41,
     c 313, -43, 315, 510, 444, -58,  71,-115, 280, 894, 129, -54,
     c 321, -46, 311, 506, 437, -72,  66,-128, 274, 906, 122, -66,
     c 326, -46, 315, 502, 435, -76,  63,-134, 268, 888, 115, -75,
     c 328, -43, 320, 498, 437, -83,  65,-135, 267, 861, 114, -79,
     c 333, -40, 322, 498, 441, -85,  68,-137, 269, 845, 118, -81,
     c 341, -34, 317, 505, 444, -88,  72,-141, 273, 841, 123, -80,
     c 347, -20, 311, 511, 446, -83,  71,-143, 280, 828, 127, -76,
     c 352,  -6, 308, 519, 450, -76,  73,-142, 283, 813, 132, -75,
     c 359,   1, 312, 526, 454, -73,  74,-138, 286, 808, 134, -75,
     c 363,   0, 323, 531, 453, -68,  77,-137, 289, 816, 136, -77,
     c 358,  -8, 329, 529, 447, -70,  78,-141, 293, 825, 134, -80,
     c 351, -22, 334, 527, 441, -78,  78,-145, 299, 846, 134, -84,
     c 348, -31, 337, 524, 436, -80,  76,-148, 306, 863, 135, -87,
     c 349, -31, 340, 526, 429, -92,  77,-148, 311, 868, 138, -91,
     c 347, -27, 344, 531, 423,-102,  78,-150, 312, 851, 142, -93,
     c 346, -18, 345, 537, 416,-111,  81,-150, 309, 823, 145, -97,
     c 347,  -2, 343, 541, 412,-114,  80,-156, 303, 797, 145,-103,
     c 353,  19, 343, 535, 409,-118,  76,-171, 297, 785, 144,-109,
     c 359,  35, 342, 523, 405,-128,  71,-185, 293, 772, 141,-115,
     c 363,  39, 339, 512, 399,-137,  68,-196, 290, 744, 139,-122,
     c 364,  31, 335, 504, 393,-142,  69,-199, 291, 718, 138,-128,
     c 365,  16, 333, 504, 391,-150,  70,-197, 293, 707, 140,-132,
     c 368,   5, 339, 516, 393,-144,  75,-194, 297, 709, 148,-132,
     c 377,   4, 351, 535, 400,-138,  86,-188, 304, 715, 158,-128,
     c 392,  13, 368, 558, 413,-124, 103,-183, 313, 723, 173,-117,
     c 410,  22, 379, 578, 426,-108, 121,-174, 325, 729, 190,-102,
     c 429,  29, 388, 593, 437, -91, 140,-167, 336, 734, 205, -87,
     c 439,  30, 394, 602, 442, -66, 155,-159, 347, 737, 217, -75,
     c 448,  29, 398, 608, 446, -44, 165,-151, 356, 738, 224, -63,
     c 307, -52, 342, 508, 478, -24,  92, -83, 291, 819, 146, -10,
     c 309, -47, 339, 512, 468, -30,  90, -84, 290, 774, 141, -20,
     c 309, -43, 335, 512, 457, -38,  84, -91, 288, 763, 135, -30,
     c 310, -40, 328, 514, 450, -48,  76,-107, 285, 804, 129, -43,
     c 313, -43, 318, 511, 445, -59,  69,-120, 279, 864, 123, -56,
     c 318, -47, 314, 506, 440, -71,  64,-127, 273, 889, 117, -68,
     c 322, -48, 315, 501, 437, -74,  60,-132, 267, 877, 112, -76,
     c 324, -46, 317, 496, 436, -80,  60,-137, 265, 851, 111, -81,
     c 329, -43, 317, 496, 441, -84,  64,-142, 266, 829, 114, -83,
     c 337, -37, 311, 501, 443, -88,  68,-145, 269, 822, 119, -82,
     c 342, -26, 303, 506, 442, -89,  68,-147, 274, 813, 123, -81,
     c 347, -14, 303, 513, 445, -82,  68,-147, 279, 811, 126, -79,
     c 356,  -8, 310, 520, 451, -86,  70,-146, 282, 801, 129, -80,
     c 357,  -9, 319, 524, 450, -81,  71,-145, 285, 795, 131, -83,
     c 353, -16, 324, 523, 441, -80,  73,-148, 289, 795, 130, -86,
     c 348, -24, 332, 523, 437, -83,  73,-150, 296, 813, 129, -90,
     c 348, -30, 337, 522, 432, -81,  75,-150, 303, 828, 129, -93,
     c 348, -31, 339, 522, 427, -90,  76,-150, 307, 830, 133, -95,
     c 345, -30, 340, 524, 420,-102,  76,-150, 308, 816, 136, -97,
     c 342, -24, 338, 529, 413,-109,  77,-154, 305, 794, 138,-102,
     c 342, -10, 334, 530, 407,-116,  76,-161, 299, 774, 138,-107,
     c 346,  11, 335, 527, 405,-122,  72,-174, 293, 767, 136,-113,
     c 350,  30, 336, 519, 398,-133,  67,-188, 288, 762, 134,-120,
     c 354,  37, 333, 507, 391,-143,  62,-201, 285, 743, 133,-127,
     c 358,  31, 330, 500, 387,-147,  62,-207, 285, 720, 131,-133,
     c 360,  13, 328, 499, 384,-151,  63,-206, 286, 706, 134,-137,
     c 362,  -4, 330, 505, 384,-151,  68,-203, 289, 706, 139,-139,
     c 370, -11, 341, 522, 393,-143,  78,-196, 295, 709, 149,-134,
     c 383,  -6, 356, 542, 407,-135,  93,-189, 304, 716, 163,-124,
     c 400,   3, 369, 561, 418,-119, 112,-180, 315, 721, 179,-109,
     c 420,  17, 380, 579, 431,-100, 131,-173, 326, 726, 195, -95,
     c 430,  22, 386, 589, 437, -79, 143,-165, 336, 726, 207, -83,
     c 441,  27, 392, 600, 444, -56, 153,-160, 346, 724, 215, -72,
     c 306, -68, 337, 508, 479, -34,  90, -83, 286, 788, 139, -12,
     c 309, -59, 337, 510, 469, -41,  87, -85, 287, 737, 132, -22,
     c 311, -50, 335, 512, 458, -43,  83, -91, 286, 723, 128, -34,
     c 310, -42, 330, 511, 448, -55,  76,-105, 283, 761, 123, -46,
     c 312, -42, 320, 508, 444, -62,  68,-119, 277, 826, 119, -59,
     c 317, -46, 314, 504, 442, -70,  62,-129, 272, 850, 115, -71,
     c 320, -48, 314, 500, 438, -74,  59,-134, 267, 832, 111, -78,
     c 321, -48, 313, 495, 435, -81,  59,-141, 264, 800, 109, -83,
     c 325, -47, 309, 493, 438, -89,  62,-145, 264, 785, 112, -86,
     c 331, -42, 305, 498, 438, -95,  64,-148, 267, 788, 114, -86,
     c 336, -33, 301, 503, 437, -93,  65,-150, 271, 799, 118, -84,
     c 341, -24, 301, 507, 438, -93,  64,-151, 275, 807, 121, -84,
     c 349, -19, 310, 512, 443, -93,  64,-152, 277, 798, 124, -84,
     c 351, -18, 318, 517, 443, -84,  65,-152, 280, 779, 126, -88,
     c 348, -22, 324, 518, 437, -85,  67,-155, 285, 766, 124, -91,
     c 346, -26, 332, 520, 433, -84,  69,-155, 291, 779, 123, -95,
     c 347, -28, 336, 518, 429, -85,  72,-156, 298, 795, 124, -97,
     c 345, -29, 337, 518, 424, -93,  74,-155, 304, 794, 126, -99,
     c 341, -31, 335, 521, 416,-101,  74,-157, 305, 785, 129,-103,
     c 337, -30, 331, 522, 408,-113,  74,-160, 302, 773, 132,-106,
     c 337, -18, 327, 523, 403,-123,  72,-168, 295, 759, 131,-113,
     c 340,   4, 326, 522, 399,-128,  69,-179, 289, 753, 130,-119,
     c 345,  26, 329, 517, 394,-137,  64,-192, 284, 753, 127,-125,
     c 351,  38, 331, 508, 389,-144,  59,-205, 281, 742, 126,-132,
     c 354,  30, 326, 498, 383,-151,  57,-213, 280, 721, 125,-139,
     c 355,   8, 321, 494, 377,-154,  59,-215, 280, 704, 126,-143,
     c 355, -15, 323, 496, 377,-158,  62,-213, 282, 697, 132,-143,
     c 363, -27, 332, 508, 385,-150,  71,-208, 287, 700, 142,-139,
     c 376, -24, 347, 526, 398,-142,  84,-198, 295, 706, 155,-129,
     c 391, -11, 358, 542, 408,-127, 101,-188, 304, 712, 171,-116,
     c 412,   7, 372, 562, 420,-108, 117,-180, 315, 716, 186,-103,
     c 422,  16, 377, 574, 427, -89, 132,-174, 325, 714, 196, -92,
     c 433,  23, 383, 586, 435, -70, 141,-168, 334, 707, 205, -82,
     c 304, -80, 336, 503, 478, -36,  86, -83, 285, 850, 136, -15,
     c 307, -68, 336, 506, 467, -43,  85, -87, 285, 794, 130, -26,
     c 311, -56, 337, 509, 458, -47,  83, -94, 284, 773, 125, -36,
     c 311, -44, 334, 508, 448, -55,  77,-108, 281, 796, 122, -49,
     c 313, -42, 323, 505, 445, -65,  70,-119, 277, 836, 120, -61,
     c 318, -45, 313, 502, 443, -71,  64,-129, 273, 827, 117, -73,
     c 321, -49, 310, 500, 439, -74,  59,-136, 268, 784, 113, -81,
     c 322, -50, 307, 495, 435, -85,  58,-142, 265, 744, 111, -85,
     c 324, -49, 303, 494, 434, -88,  59,-146, 264, 733, 111, -88,
     c 330, -44, 301, 499, 434, -91,  63,-149, 265, 748, 113, -88,
     c 333, -37, 300, 502, 432, -93,  63,-152, 268, 779, 114, -88,
     c 338, -31, 303, 504, 434, -90,  62,-154, 271, 801, 117, -87,
     c 346, -29, 310, 508, 439, -95,  61,-156, 274, 791, 120, -89,
     c 349, -28, 316, 513, 439, -87,  61,-156, 276, 755, 121, -93,
     c 346, -27, 323, 515, 435, -86,  64,-159, 280, 732, 119, -96,
     c 344, -27, 329, 516, 431, -88,  66,-159, 287, 737, 118, -99,
     c 344, -27, 334, 516, 428, -89,  69,-159, 293, 750, 118,-103,
     c 343, -29, 335, 518, 422, -93,  72,-161, 298, 751, 122,-105,
     c 338, -33, 333, 518, 414,-101,  72,-161, 300, 754, 124,-107,
     c 334, -34, 327, 517, 405,-117,  71,-165, 299, 754, 126,-112,
     c 336, -23, 325, 519, 400,-128,  71,-170, 294, 750, 125,-117,
     c 340,  -1, 324, 519, 397,-135,  67,-178, 288, 751, 123,-123,
     c 346,  24, 328, 517, 393,-141,  62,-191, 282, 755, 121,-130,
     c 350,  36, 330, 509, 386,-146,  58,-203, 279, 749, 120,-137,
     c 353,  29, 327, 500, 380,-151,  55,-214, 277, 728, 119,-143,
     c 352,   4, 321, 492, 374,-156,  55,-221, 275, 706, 121,-146,
     c 349, -24, 320, 491, 371,-160,  57,-222, 276, 695, 126,-147,
     c 354, -40, 328, 499, 377,-153,  65,-216, 279, 694, 135,-143,
     c 367, -39, 338, 509, 386,-149,  75,-206, 286, 699, 148,-135,
     c 382, -24, 349, 525, 392,-137,  91,-197, 295, 702, 163,-123,
     c 402,  -1, 363, 546, 405,-116, 106,-189, 305, 704, 177,-111,
     c 412,   9, 367, 558, 415,-102, 118,-181, 314, 701, 189,-101,
     c 422,  19, 372, 571, 425, -83, 128,-175, 323, 692, 197, -92,
     c 297, -88, 332, 499, 475, -41,  82, -88, 284, 955, 135, -20,
     c 301, -75, 333, 501, 464, -43,  81, -93, 284, 908, 131, -28,
     c 305, -62, 334, 504, 455, -45,  79, -98, 283, 882, 128, -38,
     c 311, -47, 336, 507, 451, -53,  77,-107, 280, 873, 124, -50,
     c 316, -43, 323, 506, 450, -59,  70,-118, 277, 875, 122, -63,
     c 320, -47, 311, 503, 446, -65,  65,-126, 272, 826, 120, -73,
     c 322, -51, 304, 501, 441, -73,  59,-136, 269, 749, 116, -81,
     c 324, -53, 301, 498, 435, -82,  57,-143, 266, 698, 112, -85,
     c 328, -50, 299, 497, 434, -86,  59,-149, 265, 692, 112, -88,
     c 331, -44, 298, 499, 432, -93,  63,-152, 265, 716, 111, -90,
     c 334, -38, 302, 501, 432, -96,  63,-153, 267, 761, 112, -90,
     c 338, -35, 307, 505, 435, -93,  60,-156, 270, 794, 115, -91,
     c 343, -34, 313, 508, 440, -95,  59,-158, 270, 784, 117, -92,
     c 345, -35, 315, 512, 439, -91,  58,-158, 272, 742, 117, -96,
     c 343, -34, 318, 513, 433, -90,  61,-159, 276, 715, 115,-100,
     c 343, -30, 326, 514, 430, -92,  65,-161, 281, 718, 113,-103,
     c 344, -27, 332, 514, 426, -93,  68,-164, 288, 729, 114,-105,
     c 342, -29, 334, 514, 419, -96,  71,-165, 294, 729, 117,-108,
     c 341, -33, 333, 515, 413,-105,  73,-164, 297, 737, 122,-111,
     c 338, -35, 328, 515, 404,-110,  73,-165, 297, 748, 124,-115,
     c 339, -27, 324, 516, 399,-128,  71,-169, 292, 750, 123,-121,
     c 342,  -5, 322, 516, 395,-137,  67,-178, 287, 753, 120,-128,
     c 347,  20, 328, 517, 391,-138,  62,-191, 283, 759, 117,-133,
     c 351,  35, 331, 512, 385,-142,  57,-205, 279, 755, 116,-140,
     c 353,  26, 328, 502, 376,-152,  54,-217, 276, 734, 115,-147,
     c 349,   0, 323, 494, 373,-157,  53,-226, 274, 709, 116,-150,
     c 347, -31, 322, 493, 371,-161,  55,-226, 273, 695, 121,-150,
     c 350, -50, 326, 497, 373,-158,  61,-223, 275, 691, 131,-147,
     c 360, -48, 335, 503, 377,-157,  69,-215, 280, 692, 143,-139,
     c 375, -31, 342, 515, 383,-147,  81,-207, 287, 694, 158,-129,
     c 394,  -8, 352, 535, 396,-126,  96,-198, 296, 693, 171,-120,
     c 404,   2, 354, 547, 405,-114, 107,-190, 304, 688, 181,-111,
     c 414,  15, 357, 560, 417, -97, 119,-182, 314, 677, 189,-103,
     c 292, -91, 330, 500, 479, -39,  78, -89, 283,1007, 135, -21,
     c 297, -78, 332, 501, 468, -46,  79, -95, 283, 973, 132, -29,
     c 301, -66, 333, 503, 460, -46,  78,-102, 282, 946, 130, -39,
     c 307, -52, 333, 505, 454, -47,  76,-109, 278, 918, 127, -50,
     c 316, -49, 322, 507, 450, -52,  71,-117, 275, 892, 125, -62,
     c 320, -51, 309, 506, 450, -61,  64,-124, 272, 816, 122, -73,
     c 320, -55, 298, 504, 444, -74,  57,-134, 268, 730, 117, -80,
     c 324, -54, 296, 499, 437, -87,  56,-141, 267, 681, 114, -85,
     c 330, -48, 298, 497, 435, -93,  59,-147, 266, 680, 113, -88,
     c 333, -39, 301, 498, 433, -96,  64,-150, 266, 714, 111, -90,
     c 336, -33, 307, 499, 434, -94,  64,-153, 267, 762, 110, -90,
     c 340, -32, 314, 504, 437, -88,  62,-155, 269, 798, 111, -92,
     c 341, -35, 316, 507, 439, -92,  59,-156, 270, 785, 112, -95,
     c 341, -39, 317, 512, 437, -88,  58,-160, 271, 753, 111, -98,
     c 341, -38, 318, 514, 433, -89,  60,-160, 272, 737, 109,-101,
     c 342, -34, 325, 513, 428, -93,  62,-163, 278, 744, 109,-104,
     c 342, -31, 332, 510, 422, -97,  65,-167, 283, 750, 110,-107,
     c 344, -31, 333, 511, 418, -99,  69,-169, 289, 745, 115,-110,
     c 344, -34, 334, 512, 411,-101,  72,-167, 293, 750, 119,-112,
     c 345, -35, 330, 513, 406,-110,  74,-166, 294, 757, 122,-117,
     c 345, -28, 324, 513, 400,-123,  71,-169, 292, 757, 121,-123,
     c 345,  -9, 319, 515, 394,-132,  67,-178, 288, 753, 119,-130,
     c 346,  16, 321, 514, 387,-135,  61,-191, 284, 756, 117,-136,
     c 348,  32, 325, 512, 380,-139,  56,-204, 281, 753, 116,-143,
     c 351,  26, 328, 506, 376,-147,  52,-217, 277, 734, 114,-148,
     c 347,  -1, 325, 499, 372,-154,  52,-225, 274, 710, 116,-150,
     c 344, -33, 325, 496, 372,-160,  53,-229, 272, 697, 121,-151,
     c 347, -53, 328, 499, 373,-156,  58,-225, 272, 693, 129,-148,
     c 358, -53, 333, 505, 376,-155,  65,-218, 277, 693, 140,-142,
     c 372, -36, 336, 513, 378,-150,  76,-212, 283, 692, 153,-134,
     c 389, -14, 341, 528, 388,-128,  88,-204, 290, 690, 166,-125,
     c 397,  -2, 341, 538, 397,-118,  99,-197, 299, 684, 175,-118,
     c 407,   9, 342, 549, 407,-103, 110,-190, 307, 673, 182,-111,
     c 292, -90, 328, 500, 480, -28,  77, -88, 284, 999, 132, -23,
     c 296, -79, 329, 502, 472, -43,  79, -95, 282, 988, 132, -31,
     c 300, -68, 332, 502, 463, -42,  78,-101, 280, 967, 130, -39,
     c 306, -59, 331, 503, 452, -49,  76,-108, 277, 926, 127, -50,
     c 314, -55, 322, 504, 449, -55,  72,-113, 273, 880, 126, -60,
     c 318, -55, 309, 506, 450, -62,  66,-120, 270, 799, 124, -70,
     c 320, -56, 302, 506, 447, -76,  59,-132, 269, 716, 121, -77,
     c 324, -53, 300, 500, 442, -88,  58,-141, 268, 670, 120, -82,
     c 330, -43, 301, 496, 437, -94,  61,-147, 269, 684, 117, -86,
     c 337, -31, 307, 498, 437, -94,  66,-149, 269, 722, 115, -89,
     c 339, -25, 314, 498, 437, -94,  68,-149, 270, 768, 112, -91,
     c 342, -27, 322, 500, 437, -89,  66,-153, 271, 796, 111, -91,
     c 340, -33, 321, 505, 436, -98,  63,-155, 270, 790, 111, -94,
     c 340, -39, 321, 511, 434, -96,  59,-160, 269, 774, 109, -98,
     c 339, -41, 321, 513, 433, -97,  60,-162, 271, 779, 107,-102,
     c 338, -39, 325, 510, 426,-101,  60,-166, 274, 796, 106,-105,
     c 339, -34, 330, 509, 420, -98,  63,-171, 279, 800, 109,-107,
     c 343, -32, 334, 509, 416, -99,  67,-174, 285, 786, 113,-109,
     c 348, -32, 336, 513, 414,-101,  70,-173, 290, 778, 119,-113,
     c 348, -32, 331, 514, 408,-107,  72,-170, 292, 774, 122,-117,
     c 347, -28, 322, 513, 401,-120,  70,-172, 290, 764, 122,-124,
     c 344, -11, 314, 513, 394,-131,  66,-178, 287, 748, 121,-131,
     c 343,  13, 315, 513, 388,-135,  60,-191, 285, 746, 118,-137,
     c 347,  31, 320, 512, 379,-139,  56,-204, 282, 745, 117,-143,
     c 350,  26, 325, 509, 377,-147,  53,-214, 278, 731, 116,-148,
     c 347,   0, 327, 504, 374,-149,  53,-222, 276, 711, 117,-150,
     c 344, -32, 329, 498, 371,-154,  54,-226, 273, 700, 121,-150,
     c 348, -53, 331, 501, 373,-151,  58,-227, 273, 698, 130,-148,
     c 359, -53, 333, 508, 377,-147,  63,-220, 275, 696, 139,-143,
     c 370, -39, 331, 513, 377,-146,  71,-217, 281, 694, 151,-136,
     c 385, -18, 332, 523, 382,-130,  83,-211, 287, 690, 160,-130,
     c 393,  -7, 330, 531, 389,-123,  94,-207, 294, 683, 169,-124,
     c 401,   4, 329, 540, 398,-114, 107,-198, 303, 673, 177,-118,
     c 294, -84, 327, 502, 483, -28,  77, -84, 287, 957, 129, -25,
     c 298, -76, 328, 502, 472, -40,  80, -92, 284, 970, 131, -31,
     c 301, -68, 330, 502, 461, -41,  80,-100, 281, 960, 130, -39,
     c 308, -61, 331, 500, 451, -51,  78,-108, 277, 919, 129, -49,
     c 316, -57, 323, 502, 448, -60,  74,-114, 272, 863, 128, -59,
     c 320, -55, 314, 508, 450, -61,  68,-118, 270, 777, 127, -68,
     c 323, -52, 310, 509, 450, -69,  62,-130, 270, 700, 127, -75,
     c 326, -47, 307, 504, 446, -79,  60,-138, 271, 664, 126, -80,
     c 333, -35, 305, 500, 443, -88,  65,-146, 272, 680, 125, -85,
     c 342, -22, 312, 502, 442, -88,  71,-146, 273, 716, 121, -87,
     c 345, -17, 323, 500, 440, -91,  72,-146, 274, 758, 117, -88,
     c 345, -20, 328, 500, 438, -93,  70,-150, 273, 772, 115, -90,
     c 342, -28, 329, 505, 436, -98,  65,-154, 272, 761, 112, -92,
     c 341, -37, 328, 509, 433, -98,  63,-157, 271, 756, 108, -96,
     c 341, -41, 327, 509, 431,-102,  62,-161, 271, 786, 106,-100,
     c 340, -40, 329, 510, 426,-102,  61,-168, 274, 814, 107,-102,
     c 340, -35, 333, 510, 421, -98,  64,-172, 277, 818, 109,-104,
     c 343, -31, 335, 511, 417,-101,  65,-175, 282, 801, 114,-108,
     c 350, -29, 336, 513, 416,-101,  69,-175, 287, 785, 119,-111,
     c 351, -28, 331, 515, 412,-104,  71,-174, 289, 773, 122,-117,
     c 349, -25, 322, 512, 405,-115,  69,-174, 289, 756, 123,-123,
     c 348, -12, 312, 511, 398,-127,  66,-179, 288, 740, 122,-130,
     c 348,  11, 312, 512, 390,-134,  62,-188, 285, 736, 122,-137,
     c 350,  30, 317, 512, 383,-140,  58,-199, 283, 738, 122,-143,
     c 353,  28, 324, 511, 379,-143,  56,-208, 280, 730, 120,-147,
     c 352,   6, 330, 508, 378,-143,  57,-217, 278, 714, 121,-148,
     c 348, -26, 333, 505, 376,-146,  57,-224, 275, 707, 124,-149,
     c 349, -50, 334, 506, 375,-143,  59,-224, 275, 705, 131,-147,
     c 359, -52, 332, 511, 378,-143,  65,-220, 277, 701, 138,-143,
     c 369, -40, 327, 515, 379,-145,  72,-217, 282, 696, 148,-138,
     c 383, -22, 328, 524, 383,-130,  82,-213, 286, 690, 157,-132,
     c 389, -11, 325, 530, 388,-122,  91,-210, 293, 684, 165,-128,
     c 395,  -2, 321, 537, 393,-117, 103,-201, 300, 676, 171,-124,
     c 298, -80, 329, 504, 488, -32,  78, -85, 291, 903, 128, -26,
     c 300, -74, 329, 501, 475, -45,  82, -91, 287, 942, 130, -32,
     c 302, -68, 329, 502, 462, -46,  81, -98, 283, 945, 130, -40,
     c 308, -64, 332, 501, 451, -54,  78,-106, 278, 906, 130, -48,
     c 317, -58, 328, 504, 450, -58,  76,-111, 273, 846, 130, -58,
     c 325, -51, 321, 510, 452, -62,  70,-117, 271, 766, 129, -67,
     c 326, -46, 315, 511, 451, -68,  66,-128, 271, 691, 129, -73,
     c 333, -38, 312, 508, 450, -74,  64,-137, 275, 653, 130, -78,
     c 339, -24, 311, 508, 448, -81,  69,-141, 278, 675, 128, -81,
     c 343, -13, 317, 507, 445, -83,  73,-144, 279, 716, 126, -83,
     c 348, -10, 326, 506, 444, -84,  77,-147, 279, 742, 121, -85,
     c 351, -16, 336, 507, 441, -87,  76,-149, 278, 734, 118, -86,
     c 348, -25, 337, 510, 438, -94,  73,-151, 276, 718, 114, -89,
     c 346, -34, 334, 510, 435, -98,  69,-154, 273, 722, 111, -93,
     c 347, -41, 332, 511, 432,-102,  67,-159, 274, 762, 109, -97,
     c 348, -40, 334, 512, 429,-103,  66,-165, 275, 801, 109,-100,
     c 346, -33, 336, 514, 424, -94,  65,-169, 278, 809, 112,-102,
     c 350, -26, 337, 515, 422, -98,  67,-173, 282, 792, 116,-105,
     c 355, -22, 336, 518, 420, -99,  69,-173, 286, 774, 121,-110,
     c 357, -20, 332, 518, 417,-100,  70,-174, 289, 761, 124,-115,
     c 356, -20, 323, 513, 409,-115,  70,-175, 288, 746, 125,-122,
     c 354, -10, 313, 510, 399,-123,  67,-178, 288, 731, 126,-130,
     c 353,   9, 312, 509, 391,-129,  63,-183, 287, 730, 125,-135,
     c 357,  31, 318, 511, 386,-134,  62,-192, 284, 737, 125,-141,
     c 360,  32, 325, 511, 382,-138,  62,-200, 282, 734, 124,-145,
     c 359,  11, 331, 510, 380,-137,  61,-210, 280, 722, 125,-147,
     c 355, -20, 336, 509, 377,-140,  63,-216, 279, 714, 127,-147,
     c 354, -45, 335, 511, 374,-138,  64,-220, 278, 710, 134,-146,
     c 360, -51, 332, 514, 377,-138,  65,-217, 280, 703, 139,-142,
     c 369, -43, 326, 519, 381,-138,  71,-218, 283, 695, 147,-139,
     c 381, -26, 326, 526, 387,-127,  80,-216, 288, 687, 153,-135,
     c 386, -18, 322, 530, 388,-119,  89,-213, 293, 682, 160,-132,
     c 393,  -9, 320, 538, 393,-113, 100,-206, 300, 678, 167,-128,
     c 302, -76, 331, 506, 493, -24,  78, -88, 297, 859, 128, -25,
     c 301, -73, 331, 505, 479, -35,  80, -93, 293, 918, 133, -31,
     c 301, -70, 332, 504, 467, -39,  82, -97, 288, 935, 134, -38,
     c 306, -65, 332, 503, 456, -50,  79,-105, 281, 905, 133, -46,
     c 316, -59, 331, 508, 452, -53,  78,-107, 276, 847, 132, -55,
     c 324, -50, 326, 514, 453, -59,  74,-112, 273, 773, 131, -64,
     c 330, -39, 321, 514, 454, -65,  71,-121, 276, 706, 131, -70,
     c 339, -28, 318, 513, 454, -69,  69,-129, 279, 671, 131, -74,
     c 343, -16, 319, 513, 452, -74,  72,-135, 283, 685, 130, -77,
     c 347,  -7, 321, 511, 450, -79,  78,-141, 286, 724, 127, -79,
     c 350,  -6, 331, 510, 447, -81,  82,-143, 286, 739, 125, -80,
     c 355, -13, 341, 512, 445, -82,  82,-146, 283, 714, 122, -81,
     c 355, -21, 345, 514, 443, -87,  80,-148, 281, 679, 119, -84,
     c 353, -32, 342, 515, 440, -93,  77,-150, 278, 691, 116, -88,
     c 354, -38, 339, 514, 437, -98,  71,-153, 277, 740, 114, -93,
     c 355, -38, 339, 515, 433,-102,  68,-159, 278, 781, 115, -96,
     c 355, -31, 336, 517, 427, -94,  68,-163, 280, 791, 116, -98,
     c 355, -23, 334, 518, 425, -99,  68,-168, 283, 781, 120,-103,
     c 360, -17, 333, 520, 424, -98,  71,-170, 287, 765, 124,-107,
     c 362, -15, 330, 519, 419,-100,  72,-175, 290, 752, 126,-113,
     c 361, -15, 324, 514, 409,-109,  70,-177, 290, 740, 127,-120,
     c 360,  -9, 318, 510, 401,-120,  68,-181, 290, 729, 129,-127,
     c 360,   9, 317, 509, 393,-126,  66,-183, 288, 730, 130,-133,
     c 363,  30, 321, 510, 388,-132,  65,-188, 286, 740, 131,-138,
     c 366,  35, 328, 510, 386,-135,  65,-194, 285, 740, 130,-141,
     c 366,  18, 335, 512, 383,-133,  67,-203, 283, 728, 131,-143,
     c 360, -12, 338, 513, 378,-136,  67,-212, 282, 718, 134,-144,
     c 358, -39, 336, 514, 376,-136,  69,-215, 282, 712, 138,-143,
     c 363, -50, 331, 518, 379,-134,  69,-215, 284, 702, 142,-141,
     c 371, -45, 327, 520, 381,-134,  73,-217, 286, 691, 147,-139,
     c 380, -31, 328, 526, 386,-124,  81,-217, 290, 683, 153,-137,
     c 383, -24, 325, 530, 387,-115,  87,-213, 295, 680, 158,-134,
     c 388, -15, 323, 536, 392,-111,  96,-210, 301, 680, 164,-132,
     c 305, -68, 330, 507, 495, -23,  81, -89, 304, 849, 134, -24,
     c 304, -67, 332, 506, 481, -27,  83, -94, 299, 921, 137, -29,
     c 303, -66, 332, 505, 470, -34,  83, -96, 294, 948, 140, -36,
     c 305, -65, 335, 504, 458, -45,  82,-105, 286, 926, 139, -43,
     c 312, -61, 335, 509, 455, -49,  82,-106, 280, 876, 138, -52,
     c 322, -49, 331, 516, 455, -52,  78,-110, 278, 817, 136, -61,
     c 333, -36, 327, 519, 457, -58,  74,-116, 280, 761, 134, -66,
     c 343, -21, 324, 518, 457, -62,  72,-124, 285, 729, 134, -70,
     c 350,  -8, 324, 518, 458, -68,  76,-132, 290, 744, 134, -72,
     c 355,   0, 328, 517, 456, -71,  83,-136, 293, 776, 132, -73,
     c 358,   0, 338, 515, 454, -76,  88,-138, 293, 782, 130, -74,
     c 359,  -8, 347, 516, 451, -80,  89,-141, 291, 746, 128, -75,
     c 359, -19, 350, 517, 447, -83,  88,-144, 287, 698, 126, -79,
     c 360, -28, 349, 517, 444, -90,  82,-147, 284, 701, 124, -84,
     c 361, -34, 346, 517, 442, -92,  77,-151, 283, 745, 122, -89,
     c 363, -33, 340, 517, 439, -96,  71,-155, 282, 784, 122, -92,
     c 362, -27, 333, 520, 433, -92,  69,-160, 284, 790, 123, -95,
     c 362, -19, 330, 521, 430, -96,  70,-164, 287, 784, 125, -98,
     c 364, -13, 329, 523, 429, -95,  73,-169, 290, 770, 128,-103,
     c 366, -11, 327, 524, 423, -93,  73,-174, 293, 756, 131,-109,
     c 366, -12, 324, 519, 414,-104,  71,-176, 292, 747, 132,-116,
     c 365,  -7, 323, 516, 406,-112,  69,-181, 292, 739, 133,-123,
     c 365,   8, 325, 516, 398,-117,  69,-183, 291, 740, 135,-128,
     c 367,  31, 328, 515, 393,-124,  68,-187, 289, 750, 137,-133,
     c 372,  41, 333, 516, 392,-131,  70,-191, 288, 748, 137,-137,
     c 372,  27, 338, 515, 387,-133,  72,-198, 286, 733, 138,-138,
     c 368,  -1, 342, 517, 382,-136,  75,-202, 286, 719, 141,-139,
     c 366, -29, 339, 520, 380,-132,  74,-208, 286, 710, 144,-139,
     c 369, -45, 336, 522, 384,-129,  76,-210, 287, 698, 147,-137,
     c 376, -44, 334, 522, 385,-130,  78,-214, 290, 685, 150,-136,
     c 383, -32, 336, 526, 388,-122,  84,-215, 293, 678, 154,-135,
     c 387, -24, 335, 528, 390,-112,  90,-211, 298, 677, 159,-133,
     c 390, -18, 333, 531, 391,-107,  97,-209, 303, 682, 164,-131,
     c 314, -57, 335, 510, 495, -24,  88, -83, 311, 854, 141, -20,
     c 314, -57, 338, 509, 484, -27,  90, -88, 306, 928, 145, -26,
     c 311, -58, 338, 507, 471, -33,  89, -90, 300, 959, 146, -32,
     c 310, -60, 342, 506, 464, -40,  87, -97, 293, 943, 145, -39,
     c 313, -59, 342, 510, 460, -42,  87,-100, 287, 905, 143, -48,
     c 322, -51, 338, 517, 457, -51,  82,-104, 284, 859, 141, -56,
     c 334, -36, 334, 521, 459, -56,  78,-111, 286, 817, 139, -62,
     c 348, -18, 330, 521, 459, -58,  77,-120, 291, 794, 139, -64,
     c 355,  -2, 328, 522, 461, -63,  82,-124, 297, 805, 138, -66,
     c 360,   6, 332, 523, 464, -63,  87,-128, 300, 829, 137, -67,
     c 365,   5, 342, 523, 463, -65,  94,-130, 300, 832, 138, -68,
     c 367,  -3, 350, 523, 460, -72,  97,-133, 298, 790, 138, -69,
     c 369, -14, 357, 522, 456, -75,  96,-134, 293, 735, 136, -73,
     c 369, -23, 358, 521, 451, -83,  90,-138, 290, 728, 133, -79,
     c 370, -28, 354, 520, 448, -88,  82,-142, 288, 762, 130, -84,
     c 369, -28, 346, 520, 445, -92,  75,-149, 287, 792, 129, -87,
     c 370, -23, 337, 523, 439, -91,  74,-154, 288, 799, 129, -90,
     c 370, -16, 330, 525, 435, -98,  75,-158, 290, 796, 130, -94,
     c 368, -11, 327, 527, 433, -92,  75,-163, 293, 784, 133, -98,
     c 370,  -8, 327, 529, 430, -90,  75,-170, 295, 771, 135,-104,
     c 371,  -8, 328, 526, 422, -99,  73,-174, 296, 760, 136,-110,
     c 372,  -4, 330, 523, 414,-105,  73,-177, 294, 751, 138,-117,
     c 371,  10, 334, 523, 406,-109,  73,-182, 293, 750, 141,-123,
     c 374,  33, 338, 522, 401,-115,  73,-186, 292, 758, 143,-127,
     c 377,  45, 340, 520, 398,-123,  75,-190, 292, 754, 143,-130,
     c 379,  36, 344, 521, 396,-125,  80,-194, 292, 735, 146,-131,
     c 378,  10, 347, 524, 392,-130,  83,-197, 292, 717, 150,-133,
     c 377, -18, 346, 527, 389,-126,  85,-201, 292, 707, 153,-133,
     c 381, -35, 343, 529, 393,-123,  84,-204, 293, 692, 155,-133,
     c 386, -38, 343, 527, 394,-124,  86,-207, 294, 677, 157,-133,
     c 393, -26, 347, 529, 395,-119,  90,-209, 297, 672, 160,-132,
     c 395, -19, 347, 531, 395,-112,  94,-208, 300, 674, 163,-131,
     c 398, -13, 347, 533, 396,-107, 101,-207, 306, 683, 169,-130,
     c 328, -45, 343, 516, 500, -20,  98, -75, 317, 852, 148, -17,
     c 326, -45, 346, 513, 490, -18,  99, -80, 312, 922, 151, -22,
     c 325, -46, 348, 512, 479, -23,  98, -86, 306, 951, 152, -28,
     c 322, -51, 350, 509, 472, -32,  94, -92, 299, 937, 151, -36,
     c 320, -56, 349, 513, 466, -35,  91, -95, 292, 903, 148, -45,
     c 325, -51, 346, 518, 463, -43,  87,-100, 290, 875, 145, -51,
     c 338, -37, 342, 524, 463, -46,  84,-107, 291, 845, 143, -56,
     c 352, -16, 336, 527, 464, -55,  84,-111, 296, 827, 142, -59,
     c 362,   2, 334, 532, 468, -56,  88,-115, 301, 833, 143, -61,
     c 370,  14, 338, 532, 473, -57,  93,-120, 305, 855, 144, -61,
     c 374,  13, 345, 533, 472, -57,  99,-123, 305, 856, 145, -62,
     c 378,   3, 353, 531, 467, -62, 103,-126, 304, 822, 145, -65,
     c 379,  -9, 359, 528, 458, -68, 104,-128, 300, 767, 143, -69,
     c 379, -18, 365, 524, 455, -78,  96,-132, 296, 748, 139, -75,
     c 379, -22, 363, 525, 453, -83,  89,-136, 293, 769, 137, -80,
     c 380, -19, 357, 526, 451, -85,  84,-143, 291, 795, 135, -83,
     c 380, -14, 346, 528, 447, -90,  81,-149, 292, 801, 134, -85,
     c 377,  -9, 338, 529, 441, -94,  81,-152, 294, 802, 135, -88,
     c 376,  -5, 334, 533, 439, -86,  81,-157, 297, 796, 140, -91,
     c 379,  -3, 334, 535, 437, -86,  83,-162, 299, 785, 142, -97,
     c 380,  -3, 334, 532, 431, -94,  81,-167, 298, 772, 142,-104,
     c 381,   0, 338, 530, 422,-100,  80,-171, 297, 757, 144,-110,
     c 382,  12, 345, 528, 414,-105,  79,-176, 296, 753, 146,-115,
     c 382,  34, 348, 525, 406,-109,  79,-182, 296, 758, 148,-119,
     c 384,  50, 347, 524, 404,-117,  82,-186, 296, 753, 151,-123,
     c 386,  45, 349, 526, 403,-113,  86,-187, 296, 732, 154,-124,
     c 388,  22, 352, 531, 402,-117,  92,-189, 297, 713, 158,-125,
     c 388,  -6, 350, 534, 399,-115,  93,-193, 297, 700, 162,-126,
     c 392, -26, 351, 536, 401,-113,  93,-195, 297, 682, 163,-127,
     c 396, -28, 354, 534, 401,-115,  92,-199, 298, 667, 165,-126,
     c 401, -17, 357, 535, 400,-113,  96,-202, 300, 663, 167,-126,
     c 404, -10, 358, 538, 399,-110, 101,-201, 304, 667, 171,-126,
     c 407,  -4, 358, 540, 401,-106, 108,-199, 308, 678, 176,-125,
     c 335, -39, 351, 522, 508, -19, 108, -64, 321, 845, 153, -12,
     c 333, -39, 353, 519, 496, -19, 106, -70, 316, 909, 155, -17,
     c 334, -38, 356, 516, 488, -23, 105, -76, 310, 937, 155, -24,
     c 330, -43, 358, 512, 479, -29,  99, -86, 303, 921, 154, -31,
     c 327, -49, 356, 516, 474, -32,  96, -91, 298, 894, 151, -40,
     c 330, -48, 352, 521, 469, -36,  92, -95, 295, 873, 146, -47,
     c 342, -37, 347, 528, 468, -42,  90,-100, 296, 841, 145, -51,
     c 354, -17, 341, 533, 469, -48,  89,-104, 300, 821, 146, -53,
     c 367,   4, 341, 539, 473, -51,  93,-108, 306, 813, 148, -54,
     c 377,  17, 345, 541, 477, -50,  97,-110, 310, 829, 151, -55,
     c 382,  17, 350, 540, 476, -51, 104,-114, 311, 832, 152, -57,
     c 385,   6, 355, 537, 470, -56, 107,-119, 310, 814, 152, -59,
     c 387,  -6, 363, 533, 462, -62, 108,-125, 306, 761, 150, -65,
     c 386, -16, 368, 529, 457, -72, 103,-129, 302, 737, 147, -71,
     c 386, -17, 368, 528, 456, -78,  98,-132, 298, 752, 143, -76,
     c 389, -13, 365, 529, 456, -79,  92,-136, 297, 779, 141, -79,
     c 388,  -7, 358, 532, 451, -83,  89,-141, 296, 790, 140, -81,
     c 387,  -2, 349, 532, 446, -90,  91,-142, 297, 800, 142, -82,
     c 386,   1, 346, 536, 444, -84,  91,-148, 299, 802, 145, -85,
     c 390,   3, 346, 539, 443, -83,  91,-155, 300, 792, 147, -89,
     c 393,   2, 343, 535, 436, -93,  90,-160, 300, 777, 148, -96,
     c 394,   3, 346, 533, 428,-100,  89,-165, 299, 758, 149,-103,
     c 394,  14, 352, 532, 419,-102,  87,-172, 298, 750, 152,-109,
     c 393,  35, 353, 530, 412,-104,  87,-177, 297, 756, 154,-112,
     c 392,  53, 352, 527, 407,-109,  91,-182, 299, 752, 157,-115,
     c 394,  52, 353, 529, 406,-104,  94,-184, 301, 732, 162,-117,
     c 394,  31, 353, 534, 406,-105,  99,-185, 302, 715, 168,-119,
     c 398,   3, 355, 539, 407,-101, 101,-188, 302, 702, 171,-119,
     c 402, -16, 357, 541, 409,-102, 101,-190, 301, 684, 173,-119,
     c 406, -21, 361, 539, 406,-112, 100,-193, 302, 668, 175,-120,
     c 411,  -8, 364, 541, 406,-114, 104,-194, 304, 666, 176,-120,
     c 413,  -2, 366, 545, 406,-106, 108,-193, 307, 670, 180,-120,
     c 416,   3, 367, 548, 406,-100, 116,-191, 312, 681, 186,-119,
     c 332, -41, 354, 522, 508, -27, 110, -65, 327, 848, 157,  -7,
     c 334, -38, 357, 520, 497, -25, 110, -70, 322, 906, 157, -14,
     c 334, -34, 361, 517, 489, -26, 107, -75, 316, 930, 156, -20,
     c 333, -33, 363, 518, 484, -26, 100, -84, 310, 916, 154, -28,
     c 332, -39, 360, 517, 478, -29,  98, -90, 304, 893, 152, -35,
     c 336, -42, 357, 522, 474, -34,  94, -96, 300, 871, 149, -41,
     c 346, -34, 352, 531, 473, -36,  93, -98, 302, 834, 148, -45,
     c 359, -17, 348, 539, 474, -44,  94,-101, 305, 796, 151, -47,
     c 370,   3, 349, 545, 476, -45,  97,-102, 310, 772, 154, -48,
     c 379,  17, 353, 548, 479, -47, 100,-104, 314, 782, 156, -50,
     c 385,  18, 356, 549, 480, -43, 105,-108, 316, 790, 157, -52,
     c 388,   8, 360, 545, 476, -49, 110,-114, 316, 785, 157, -55,
     c 390,  -6, 366, 539, 469, -56, 111,-121, 313, 741, 156, -60,
     c 392, -15, 370, 536, 463, -63, 109,-126, 310, 719, 153, -66,
     c 394, -16, 373, 537, 462, -68, 105,-129, 305, 729, 151, -71,
     c 396,  -9, 371, 536, 463, -71, 100,-133, 302, 763, 148, -74,
     c 397,  -2, 365, 536, 456, -81,  98,-136, 302, 780, 146, -77,
     c 395,   4, 359, 537, 450, -84,  97,-138, 302, 800, 147, -77,
     c 397,   9, 358, 540, 448, -77,  99,-143, 303, 811, 152, -79,
     c 401,  10, 357, 542, 448, -77, 100,-149, 303, 806, 154, -84,
     c 404,   8, 354, 540, 442, -82,  99,-155, 302, 788, 154, -90,
     c 405,   8, 355, 538, 433, -90,  97,-158, 300, 766, 155, -96,
     c 403,  15, 356, 536, 422, -94,  95,-166, 298, 755, 156,-101,
     c 400,  35, 356, 535, 416, -98,  94,-173, 299, 760, 159,-105,
     c 400,  57, 353, 534, 412,-102,  97,-175, 301, 756, 163,-109,
     c 401,  60, 353, 535, 410,-100, 102,-178, 303, 738, 169,-111,
     c 403,  41, 356, 539, 409, -97, 105,-181, 305, 722, 174,-112,
     c 405,  10, 358, 544, 411,-101, 107,-184, 305, 712, 177,-113,
     c 410, -11, 361, 545, 413,-104, 106,-186, 305, 696, 179,-114,
     c 414, -16, 365, 543, 410,-111, 106,-188, 305, 683, 182,-113,
     c 420,  -5, 371, 547, 410,-112, 109,-189, 308, 681, 185,-114,
     c 422,   0, 372, 549, 410,-104, 115,-187, 311, 685, 189,-113,
     c 425,   8, 373, 553, 411, -97, 123,-186, 316, 694, 193,-114,
     c 329, -45, 358, 520, 506, -21, 110, -61, 333, 862, 159,  -5,
     c 332, -37, 362, 519, 498, -17, 109, -65, 329, 915, 158, -11,
     c 334, -29, 366, 519, 492, -15, 106, -74, 324, 938, 157, -18,
     c 337, -22, 369, 518, 488, -20, 101, -83, 317, 925, 155, -25,
     c 339, -25, 365, 517, 483, -25,  98, -88, 311, 897, 153, -32,
     c 344, -30, 363, 521, 479, -30,  96, -93, 308, 864, 151, -38,
     c 354, -29, 359, 530, 478, -31,  98, -94, 307, 813, 152, -40,
     c 364, -18, 355, 539, 477, -37,  99, -97, 311, 765, 157, -42,
     c 372,  -1, 355, 546, 476, -35, 100, -98, 316, 729, 160, -43,
     c 381,  12, 359, 551, 482, -38, 102,-101, 320, 725, 162, -45,
     c 387,  15, 363, 555, 485, -34, 107,-103, 323, 735, 162, -48,
     c 388,   7, 367, 552, 483, -39, 110,-109, 323, 747, 163, -51,
     c 390,  -6, 370, 546, 476, -50, 113,-119, 321, 718, 162, -55,
     c 393, -17, 373, 545, 471, -55, 113,-122, 318, 700, 161, -61,
     c 399, -17, 376, 546, 469, -60, 110,-123, 313, 713, 159, -67,
     c 403, -11, 375, 545, 467, -65, 107,-129, 310, 755, 155, -70,
     c 402,  -2, 369, 542, 460, -75, 102,-133, 308, 781, 153, -72,
     c 402,   7, 366, 542, 453, -77, 104,-136, 307, 806, 154, -73,
     c 402,  14, 366, 543, 451, -80, 104,-140, 307, 823, 157, -76,
     c 405,  16, 367, 544, 450, -75, 105,-146, 306, 821, 159, -80,
     c 410,  14, 365, 543, 446, -80, 105,-152, 305, 800, 158, -86,
     c 409,  10, 361, 541, 438, -90, 102,-156, 302, 774, 158, -92,
     c 407,  16, 360, 540, 429, -93, 100,-159, 301, 761, 160, -97,
     c 406,  37, 359, 543, 422, -96, 100,-166, 300, 764, 162,-100,
     c 407,  61, 357, 542, 417, -97, 102,-173, 302, 755, 166,-103,
     c 409,  67, 355, 541, 415, -97, 106,-177, 305, 733, 171,-106,
     c 413,  49, 359, 544, 415, -93, 109,-178, 307, 720, 175,-108,
     c 416,  17, 363, 547, 415, -97, 111,-181, 307, 717, 180,-110,
     c 419,  -8, 367, 548, 416,-100, 111,-182, 308, 704, 183,-109,
     c 423, -14, 369, 548, 415,-106, 112,-184, 309, 694, 186,-110,
     c 428,  -4, 375, 551, 416,-108, 115,-184, 311, 694, 189,-110,
     c 430,   3, 377, 555, 417, -97, 120,-181, 315, 697, 194,-110,
     c 434,  10, 379, 557, 417, -92, 128,-180, 320, 701, 199,-109,
     c 331, -48, 358, 520, 506,  -8, 109, -59, 342, 875, 162,  -4,
     c 333, -37, 363, 520, 500,  -7, 108, -65, 337, 929, 160, -11,
     c 337, -25, 368, 521, 496,  -7, 106, -73, 332, 952, 158, -18,
     c 342, -12, 371, 521, 493, -11, 102, -80, 325, 933, 156, -24,
     c 346, -12, 367, 520, 488, -23,  99, -86, 319, 902, 154, -30,
     c 352, -19, 364, 524, 487, -29,  99, -89, 314, 865, 153, -34,
     c 361, -23, 360, 530, 483, -31, 102, -92, 314, 809, 157, -36,
     c 367, -20, 355, 538, 479, -35, 102, -92, 316, 756, 163, -37,
     c 377,  -8, 357, 545, 477, -29, 104, -94, 320, 710, 166, -38,
     c 385,   5, 363, 552, 483, -32, 105, -95, 325, 697, 166, -41,
     c 392,  13, 370, 557, 487, -30, 109, -99, 329, 704, 166, -43,
     c 392,   8, 371, 555, 486, -36, 114,-103, 331, 722, 167, -47,
     c 393,  -5, 377, 552, 480, -45, 119,-110, 330, 704, 168, -50,
     c 400, -16, 381, 551, 478, -46, 121,-116, 327, 698, 167, -56,
     c 406, -19, 383, 554, 475, -48, 119,-118, 323, 722, 165, -61,
     c 407, -13, 380, 552, 470, -54, 113,-125, 319, 767, 162, -66,
     c 406,  -2, 373, 547, 463, -65, 109,-129, 317, 793, 159, -69,
     c 407,  11, 371, 545, 457, -72, 106,-134, 315, 814, 159, -72,
     c 409,  21, 375, 545, 456, -73, 109,-136, 314, 829, 163, -75,
     c 410,  21, 376, 546, 453, -72, 110,-141, 311, 824, 164, -80,
     c 411,  16, 372, 546, 448, -72, 108,-147, 309, 799, 163, -85,
     c 409,   9, 367, 544, 441, -85, 106,-151, 306, 770, 162, -89,
     c 407,  13, 363, 544, 434, -89, 105,-156, 303, 755, 162, -93,
     c 408,  35, 360, 545, 428, -94, 105,-164, 303, 751, 164, -98,
     c 411,  64, 358, 544, 424, -97, 104,-170, 304, 734, 167,-100,
     c 418,  74, 360, 545, 423, -97, 108,-175, 306, 705, 172,-103,
     c 421,  55, 365, 547, 421, -91, 111,-178, 308, 695, 176,-105,
     c 422,  21, 369, 550, 420, -97, 114,-180, 310, 698, 179,-107,
     c 424,  -5, 372, 551, 420,-102, 113,-179, 311, 696, 183,-107,
     c 426, -14, 373, 550, 420,-101, 115,-179, 312, 691, 188,-108,
     c 431,  -2, 378, 553, 420,-101, 119,-181, 315, 693, 193,-106,
     c 435,   5, 380, 556, 422, -89, 124,-178, 319, 693, 197,-107,
     c 439,  13, 383, 560, 424, -83, 133,-176, 325, 690, 203,-106,
     c 330, -52, 355, 518, 505,  -5, 106, -56, 349, 886, 165,  -5,
     c 335, -38, 360, 520, 501,  -1, 106, -62, 345, 942, 163, -12,
     c 339, -24, 366, 523, 499,  -1, 105, -69, 340, 964, 161, -17,
     c 345,  -7, 370, 528, 499,  -1, 101, -77, 333, 937, 159, -23,
     c 351,  -6, 366, 528, 495, -11, 101, -83, 325, 911, 157, -27,
     c 358, -13, 364, 530, 492, -18, 102, -87, 320, 883, 158, -30,
     c 364, -23, 361, 535, 488, -21, 106, -88, 317, 833, 163, -32,
     c 374, -23, 359, 540, 485, -26, 108, -85, 320, 788, 169, -32,
     c 384, -14, 360, 546, 482, -26, 110, -87, 324, 749, 172, -34,
     c 393,   2, 369, 552, 486, -27, 110, -88, 329, 727, 171, -36,
     c 399,  15, 377, 557, 487, -28, 113, -91, 334, 715, 169, -38,
     c 403,  15, 382, 559, 488, -31, 120, -97, 338, 731, 170, -41,
     c 404,   2, 388, 559, 486, -41, 126,-101, 338, 726, 172, -46,
     c 409, -12, 392, 560, 485, -38, 129,-106, 336, 732, 173, -51,
     c 412, -18, 391, 560, 481, -40, 126,-109, 332, 758, 172, -57,
     c 412, -14, 385, 557, 473, -46, 120,-120, 328, 802, 168, -62,
     c 411,   0, 380, 552, 467, -56, 115,-127, 325, 820, 166, -66,
     c 413,  17, 381, 550, 462, -62, 112,-134, 322, 824, 166, -70,
     c 416,  28, 383, 549, 458, -65, 113,-137, 320, 821, 169, -75,
     c 418,  27, 384, 548, 455, -66, 113,-141, 318, 807, 170, -80,
     c 416,  17, 379, 549, 450, -67, 112,-147, 315, 777, 168, -86,
     c 412,   5, 370, 547, 444, -79, 109,-151, 310, 747, 166, -90,
     c 408,   7, 361, 545, 436, -88, 107,-156, 308, 734, 166, -93,
     c 410,  34, 357, 547, 432, -92, 108,-162, 306, 723, 166, -95,
     c 417,  67, 358, 547, 431, -97, 108,-170, 306, 699, 169, -98,
     c 425,  80, 362, 549, 430, -95, 110,-174, 308, 669, 172,-102,
     c 425,  60, 366, 548, 424, -95, 112,-175, 310, 665, 175,-104,
     c 425,  23, 370, 550, 424, -97, 114,-176, 311, 677, 178,-106,
     c 427,  -6, 375, 553, 424, -98, 116,-179, 313, 686, 183,-105,
     c 431, -13, 377, 554, 423, -99, 119,-178, 315, 687, 189,-105,
     c 436,   0, 380, 556, 424, -96, 122,-179, 318, 690, 196,-104,
     c 440,  11, 383, 559, 425, -84, 128,-176, 324, 687, 202,-103,
     c 446,  22, 388, 563, 427, -77, 137,-174, 330, 678, 207,-102,
     c 330, -56, 350, 516, 506,   3, 104, -57, 351, 884, 166,  -6,
     c 335, -42, 356, 520, 502,   1, 105, -61, 348, 929, 164, -11,
     c 340, -27, 363, 526, 499,   2, 104, -65, 344, 945, 163, -17,
     c 346, -11, 369, 533, 501,   4, 102, -71, 337, 922, 162, -21,
     c 352,  -7, 367, 533, 499,  -6, 103, -78, 330, 899, 160, -25,
     c 361, -14, 366, 536, 498, -12, 106, -84, 324, 882, 161, -27,
     c 370, -24, 365, 538, 493, -17, 110, -85, 321, 857, 167, -28,
     c 379, -29, 366, 543, 490, -22, 115, -81, 322, 828, 174, -29,
     c 390, -20, 370, 550, 487, -21, 117, -81, 326, 793, 176, -30,
     c 401,   0, 378, 556, 489, -21, 119, -82, 333, 764, 174, -31,
     c 408,  20, 386, 560, 490, -22, 122, -83, 338, 744, 173, -34,
     c 414,  26, 396, 564, 493, -23, 126, -85, 343, 751, 174, -36,
     c 416,  14, 402, 567, 493, -29, 133, -91, 345, 756, 176, -40,
     c 417,  -4, 402, 566, 489, -33, 136, -95, 343, 773, 178, -45,
     c 417, -15, 398, 565, 482, -36, 134,-101, 339, 805, 178, -51,
     c 417, -10, 392, 562, 475, -44, 128,-111, 335, 845, 175, -57,
     c 417,   7, 388, 560, 469, -50, 122,-120, 332, 850, 172, -62,
     c 422,  27, 388, 555, 463, -59, 120,-127, 330, 832, 172, -68,
     c 425,  38, 391, 551, 458, -62, 119,-132, 327, 809, 177, -74,
     c 425,  32, 391, 548, 457, -66, 118,-138, 323, 781, 177, -81,
     c 419,  14, 382, 547, 453, -70, 114,-141, 319, 747, 175, -87,
     c 414,  -1, 369, 546, 446, -79, 112,-149, 315, 721, 172, -90,
     c 410,   1, 356, 544, 437, -88, 110,-155, 310, 709, 169, -93,
     c 413,  30, 352, 547, 436, -91, 110,-162, 308, 695, 170, -96,
     c 420,  67, 356, 549, 435, -94, 110,-167, 308, 669, 171, -98,
     c 430,  81, 361, 552, 433, -92, 113,-172, 309, 644, 174,-101,
     c 430,  60, 365, 550, 428, -95, 113,-175, 311, 648, 175,-104,
     c 426,  20, 370, 551, 426, -95, 116,-176, 313, 671, 178,-105,
     c 429,  -9, 373, 554, 426,-100, 116,-177, 313, 687, 184,-105,
     c 435, -14, 375, 557, 426, -97, 121,-178, 316, 692, 191,-104,
     c 443,   5, 382, 561, 427, -92, 126,-175, 321, 695, 199,-103,
     c 449,  18, 386, 564, 427, -81, 131,-174, 326, 688, 205,-101,
     c 455,  31, 391, 567, 428, -73, 140,-172, 333, 674, 212,-100,
     c 328, -63, 346, 513, 505,   4, 102, -59, 351, 865, 166,  -8,
     c 334, -49, 353, 519, 501,   4, 103, -60, 349, 900, 165, -12,
     c 340, -35, 359, 526, 499,   0, 105, -63, 346, 908, 163, -16,
     c 349, -19, 368, 529, 499,  -2, 104, -68, 340, 877, 161, -19,
     c 357, -12, 368, 530, 499, -12, 106, -75, 333, 856, 160, -22,
     c 366, -17, 369, 533, 498, -19, 110, -81, 328, 853, 162, -24,
     c 376, -28, 370, 536, 496, -21, 116, -81, 324, 848, 168, -25,
     c 384, -34, 373, 539, 492, -26, 121, -80, 324, 840, 175, -25,
     c 394, -25, 377, 546, 489, -24, 124, -79, 328, 821, 179, -26,
     c 404,  -1, 383, 553, 490, -21, 125, -79, 334, 789, 178, -28,
     c 416,  26, 397, 563, 494, -17, 129, -80, 341, 762, 176, -30,
     c 423,  37, 408, 567, 497, -19, 133, -80, 347, 767, 178, -33,
     c 426,  27, 410, 570, 497, -27, 138, -86, 350, 778, 181, -37,
     c 424,   6, 409, 569, 491, -31, 141, -89, 348, 797, 184, -42,
     c 422,  -7, 404, 567, 483, -35, 138, -96, 345, 834, 185, -48,
     c 421,  -3, 396, 567, 475, -43, 133,-106, 340, 870, 182, -53,
     c 425,  16, 391, 564, 469, -47, 129,-113, 337, 871, 179, -59,
     c 431,  38, 395, 561, 465, -50, 127,-123, 334, 836, 180, -66,
     c 434,  47, 397, 557, 460, -55, 125,-127, 331, 792, 183, -74,
     c 430,  36, 395, 552, 457, -61, 122,-136, 327, 752, 183, -81,
     c 422,  10, 383, 549, 453, -67, 119,-143, 323, 719, 181, -88,
     c 414, -10, 366, 544, 445, -81, 115,-152, 316, 697, 177, -93,
     c 413,  -6, 355, 544, 439, -89, 111,-156, 312, 688, 174, -95,
     c 416,  25, 351, 546, 436, -93, 111,-161, 309, 676, 172, -97,
     c 425,  64, 354, 549, 434, -94, 112,-167, 308, 655, 173,-100,
     c 433,  79, 359, 551, 433, -94, 114,-171, 308, 640, 173,-103,
     c 433,  56, 365, 551, 429, -95, 114,-171, 310, 652, 172,-106,
     c 430,  14, 369, 550, 426,-101, 117,-175, 311, 679, 174,-107,
     c 430, -15, 370, 551, 425,-102, 118,-178, 313, 696, 181,-106,
     c 439, -14, 374, 556, 427, -98, 123,-178, 317, 699, 190,-104,
     c 451,   9, 383, 563, 430, -87, 128,-176, 321, 696, 199,-102,
     c 459,  26, 390, 568, 432, -77, 135,-174, 327, 686, 207,-100,
     c 467,  43, 396, 573, 434, -68, 143,-172, 335, 669, 213, -97,
     c 325, -68, 342, 508, 503,  -1,  99, -59, 347, 828, 161, -12,
     c 333, -55, 348, 515, 501,   1, 102, -62, 347, 854, 162, -14,
     c 341, -42, 355, 522, 498,   0, 103, -62, 345, 853, 162, -16,
     c 350, -27, 363, 525, 500,  -5, 104, -65, 340, 812, 160, -19,
     c 364, -16, 367, 526, 500, -13, 108, -72, 335, 794, 159, -22,
     c 372, -16, 371, 530, 501, -16, 114, -78, 330, 796, 160, -23,
     c 379, -26, 373, 534, 500, -19, 120, -80, 326, 815, 165, -24,
     c 384, -36, 373, 538, 494, -22, 126, -80, 325, 828, 175, -25,
     c 392, -31, 377, 544, 489, -24, 127, -79, 329, 831, 179, -26,
     c 403,  -6, 387, 549, 490, -21, 129, -79, 335, 803, 181, -27,
     c 416,  26, 403, 561, 495, -14, 131, -77, 342, 777, 180, -29,
     c 423,  43, 415, 566, 496, -15, 134, -78, 348, 773, 181, -31,
     c 428,  37, 417, 569, 495, -21, 139, -79, 351, 785, 185, -36,
     c 427,  16, 411, 568, 491, -29, 140, -82, 350, 804, 188, -41,
     c 424,   1, 405, 569, 485, -32, 139, -91, 346, 841, 188, -46,
     c 423,   4, 397, 567, 475, -39, 135,-100, 342, 873, 186, -51,
     c 431,  24, 394, 568, 471, -38, 133,-106, 339, 870, 183, -56,
     c 442,  46, 399, 567, 468, -42, 131,-113, 336, 823, 183, -65,
     c 441,  52, 401, 561, 462, -53, 129,-122, 333, 762, 187, -73,
     c 434,  35, 394, 554, 456, -59, 124,-133, 328, 709, 188, -83,
     c 423,   5, 380, 549, 452, -70, 119,-139, 323, 678, 185, -91,
     c 415, -18, 365, 544, 445, -81, 115,-149, 317, 663, 179, -95,
     c 413, -14, 352, 542, 436, -91, 110,-155, 311, 662, 175, -98,
     c 419,  17, 347, 542, 430, -96, 110,-161, 307, 660, 172,-102,
     c 427,  57, 353, 545, 432, -95, 110,-167, 307, 654, 171,-105,
     c 434,  71, 360, 548, 430, -92, 112,-171, 307, 652, 170,-108,
     c 433,  48, 365, 548, 427, -94, 112,-174, 308, 671, 167,-111,
     c 428,   6, 367, 547, 426,-101, 114,-177, 310, 695, 168,-111,
     c 429, -21, 367, 549, 425,-105, 115,-178, 311, 705, 176,-110,
     c 438, -16, 371, 554, 427,-102, 120,-178, 315, 701, 187,-107,
     c 454,  12, 383, 562, 431, -90, 127,-174, 319, 693, 197,-103,
     c 466,  33, 391, 569, 436, -81, 136,-173, 327, 681, 206,-100,
     c 476,  54, 400, 577, 441, -69, 147,-170, 336, 664, 212, -97,
     c 323, -72, 336, 504, 500,  -5,  98, -64, 343, 824, 155, -18,
     c 333, -61, 343, 511, 498,  -5, 100, -64, 342, 832, 156, -18,
     c 341, -49, 348, 517, 498,  -6, 103, -65, 341, 820, 157, -19,
     c 354, -33, 357, 520, 500, -10, 104, -66, 338, 775, 156, -20,
     c 369, -16, 366, 524, 502, -13, 107, -72, 335, 750, 155, -23,
     c 378, -12, 371, 531, 504, -13, 115, -75, 330, 750, 156, -25,
     c 382, -20, 372, 535, 502, -17, 121, -80, 328, 782, 163, -26,
     c 386, -33, 374, 540, 497, -19, 127, -81, 326, 818, 171, -27,
     c 391, -33, 379, 544, 491, -24, 128, -82, 329, 840, 179, -27,
     c 400, -12, 388, 548, 491, -25, 130, -83, 334, 820, 181, -28,
     c 411,  19, 405, 557, 493, -17, 130, -83, 341, 795, 180, -29,
     c 423,  40, 419, 566, 496, -11, 134, -84, 347, 787, 180, -33,
     c 429,  39, 422, 570, 496, -15, 138, -84, 350, 794, 182, -37,
     c 429,  23, 417, 569, 492, -23, 139, -88, 349, 803, 185, -41,
     c 425,   8, 408, 568, 484, -31, 138, -94, 346, 827, 187, -46,
     c 423,   8, 398, 568, 477, -40, 133,-101, 342, 856, 185, -51,
     c 434,  25, 396, 569, 471, -41, 133,-107, 338, 850, 184, -57,
     c 443,  43, 402, 569, 468, -43, 131,-116, 334, 796, 184, -64,
     c 441,  47, 399, 562, 459, -55, 129,-124, 331, 722, 187, -74,
     c 431,  30, 389, 553, 452, -62, 123,-136, 327, 661, 187, -84,
     c 421,   0, 374, 547, 444, -75, 117,-144, 321, 631, 182, -94,
     c 416, -21, 359, 542, 438, -85, 113,-154, 314, 629, 175,-100,
     c 416, -16, 348, 539, 431, -94, 109,-161, 309, 642, 170,-104,
     c 419,  14, 348, 538, 425, -98, 106,-168, 306, 655, 166,-107,
     c 426,  51, 354, 540, 425, -96, 107,-173, 303, 666, 165,-111,
     c 431,  62, 359, 541, 424, -99, 108,-177, 303, 678, 161,-116,
     c 429,  36, 362, 539, 420,-102, 108,-179, 303, 697, 157,-118,
     c 424,  -3, 362, 540, 420,-106, 109,-183, 305, 711, 157,-119,
     c 426, -26, 363, 547, 422,-107, 109,-183, 307, 709, 166,-116,
     c 437, -17, 368, 552, 423,-104, 117,-180, 311, 698, 179,-110,
     c 455,  16, 380, 561, 431, -93, 124,-177, 318, 687, 192,-106,
     c 466,  38, 389, 569, 436, -83, 136,-173, 326, 674, 200,-101,
     c 479,  61, 398, 577, 443, -73, 149,-168, 335, 657, 208, -97,
     c 320, -74, 333, 504, 496, -10,  94, -71, 337, 826, 147, -23,
     c 329, -64, 338, 509, 496,  -7,  95, -71, 337, 823, 151, -23,
     c 339, -54, 342, 513, 494,  -6,  98, -71, 336, 802, 152, -22,
     c 353, -37, 350, 516, 497, -10, 100, -69, 335, 753, 152, -24,
     c 368, -18, 360, 523, 501, -10, 105, -71, 332, 714, 151, -26,
     c 381,  -6, 369, 533, 505,  -7, 111, -74, 330, 711, 152, -28,
     c 385, -13, 374, 536, 500, -15, 118, -79, 327, 754, 158, -30,
     c 384, -28, 376, 537, 494, -18, 124, -81, 326, 807, 169, -30,
     c 389, -35, 377, 539, 490, -24, 126, -84, 329, 833, 176, -30,
     c 394, -21, 385, 543, 488, -23, 127, -85, 334, 819, 180, -29,
     c 405,   6, 402, 551, 489, -19, 127, -84, 340, 804, 180, -32,
     c 418,  28, 417, 559, 493, -16, 133, -84, 344, 792, 179, -35,
     c 428,  34, 421, 564, 495, -19, 137, -85, 346, 785, 179, -40,
     c 429,  23, 414, 563, 488, -30, 137, -90, 345, 782, 181, -45,
     c 424,  10, 405, 562, 480, -39, 134, -95, 341, 801, 183, -50,
     c 424,   8, 398, 562, 474, -47, 130,-100, 337, 824, 183, -54,
     c 432,  18, 395, 562, 468, -47, 130,-108, 334, 823, 182, -59,
     c 437,  30, 396, 562, 462, -49, 127,-118, 330, 773, 184, -67,
     c 432,  32, 392, 558, 454, -60, 122,-130, 327, 699, 185, -76,
     c 421,  18, 380, 549, 446, -68, 115,-141, 322, 635, 183, -88,
     c 412,  -3, 365, 542, 437, -84, 111,-150, 317, 610, 177, -98,
     c 413, -16, 354, 540, 430, -91, 107,-157, 311, 621, 168,-105,
     c 415,  -8, 346, 535, 423, -99, 104,-166, 306, 645, 162,-110,
     c 418,  19, 346, 534, 419,-103, 102,-172, 302, 669, 159,-115,
     c 422,  47, 352, 533, 416,-105, 102,-178, 301, 692, 157,-119,
     c 428,  51, 358, 532, 415,-106, 102,-184, 299, 707, 154,-123,
     c 426,  24, 360, 532, 415,-107, 100,-187, 298, 717, 150,-127,
     c 420, -13, 361, 536, 414,-109, 100,-190, 298, 718, 150,-127,
     c 422, -32, 358, 542, 415,-108, 102,-189, 301, 704, 159,-123,
     c 433, -18, 362, 548, 418,-107, 111,-187, 308, 687, 172,-117,
     c 452,  16, 375, 559, 428, -95, 121,-180, 315, 676, 186,-110,
     c 466,  40, 386, 570, 437, -84, 135,-173, 325, 665, 196,-104,
     c 480,  65, 396, 582, 447, -74, 151,-164, 336, 652, 204, -98,
     c 316, -74, 330, 499, 491, -17,  88, -77, 331, 843, 141, -31,
     c 325, -66, 333, 503, 489, -15,  90, -76, 330, 830, 144, -28,
     c 335, -58, 337, 508, 489, -13,  92, -77, 329, 802, 147, -27,
     c 347, -43, 341, 510, 491, -18,  94, -76, 329, 747, 147, -29,
     c 365, -22, 352, 518, 496, -13,  99, -79, 329, 705, 146, -32,
     c 376,  -9, 362, 524, 497, -11, 106, -80, 328, 695, 146, -34,
     c 380, -12, 369, 528, 494, -18, 113, -82, 327, 737, 154, -36,
     c 383, -25, 373, 531, 492, -21, 120, -82, 327, 798, 166, -35,
     c 386, -34, 374, 531, 488, -29, 121, -84, 329, 832, 175, -33,
     c 391, -27, 380, 535, 485, -29, 124, -89, 332, 823, 180, -32,
     c 400,  -8, 395, 543, 485, -25, 125, -89, 336, 814, 181, -35,
     c 415,  11, 409, 550, 487, -24, 129, -94, 339, 805, 179, -39,
     c 427,  22, 414, 552, 489, -29, 133, -95, 340, 789, 178, -44,
     c 430,  20, 409, 553, 483, -35, 133, -99, 337, 773, 180, -51,
     c 429,  10, 402, 555, 477, -42, 131,-103, 333, 783, 182, -56,
     c 426,   3, 393, 551, 471, -53, 128,-109, 329, 798, 182, -60,
     c 426,   3, 387, 550, 464, -57, 124,-117, 325, 805, 182, -66,
     c 427,   7, 385, 551, 457, -59, 120,-127, 322, 768, 181, -72,
     c 421,   9, 380, 550, 449, -69, 115,-135, 319, 699, 180, -82,
     c 412,   5, 371, 543, 442, -76, 108,-148, 316, 642, 176, -93,
     c 408,  -2, 359, 539, 434, -87, 104,-156, 311, 627, 168,-104,
     c 409,  -3, 349, 535, 424, -96, 103,-163, 306, 642, 159,-112,
     c 415,   9, 346, 534, 414,-100, 102,-170, 302, 672, 154,-117,
     c 416,  30, 348, 529, 409,-106,  99,-177, 300, 698, 153,-122,
     c 420,  47, 351, 524, 407,-109,  98,-184, 297, 720, 154,-127,
     c 423,  40, 356, 523, 408,-113,  96,-191, 294, 729, 151,-132,
     c 424,   9, 360, 525, 409,-110,  95,-193, 292, 727, 146,-135,
     c 419, -26, 356, 530, 409,-113,  94,-198, 293, 710, 146,-136,
     c 419, -39, 350, 533, 409,-117,  95,-196, 297, 686, 156,-131,
     c 429, -23, 355, 542, 413,-114, 104,-192, 304, 665, 170,-122,
     c 450,  14, 372, 560, 427,-100, 116,-183, 314, 654, 184,-114,
     c 466,  38, 383, 573, 439, -86, 134,-172, 325, 646, 194,-107,
     c 482,  63, 395, 589, 452, -72, 155,-159, 337, 639, 204, -99,
     c 317, -70, 328, 494, 495, -23,  84, -81, 328, 824, 135, -37,
     c 327, -63, 330, 497, 490, -22,  86, -80, 325, 808, 139, -34,
     c 335, -56, 330, 502, 488, -20,  88, -81, 324, 782, 141, -35,
     c 347, -45, 332, 505, 487, -23,  91, -80, 324, 727, 140, -36,
     c 361, -30, 340, 511, 488, -19,  95, -84, 324, 688, 138, -39,
     c 369, -18, 351, 514, 489, -16, 102, -83, 324, 673, 139, -42,
     c 374, -18, 361, 518, 488, -24, 109, -85, 324, 724, 148, -43,
     c 381, -25, 368, 523, 487, -26, 115, -84, 325, 788, 161, -42,
     c 383, -33, 370, 526, 483, -33, 117, -86, 327, 823, 174, -39,
     c 386, -32, 376, 529, 482, -36, 117, -92, 329, 819, 180, -39,
     c 395, -22, 389, 536, 481, -30, 119, -95, 330, 829, 182, -40,
     c 407,  -6, 402, 541, 480, -31, 123, -99, 332, 828, 180, -45,
     c 421,   7, 406, 543, 479, -38, 126,-100, 330, 809, 179, -52,
     c 427,  11, 402, 543, 476, -42, 127,-106, 327, 785, 179, -60,
     c 425,   6, 395, 546, 471, -50, 124,-111, 322, 786, 179, -67,
     c 418,  -3, 385, 542, 463, -62, 117,-118, 317, 791, 179, -71,
     c 419, -12, 378, 541, 458, -61, 114,-125, 314, 794, 177, -76,
     c 416, -16, 373, 542, 451, -68, 109,-135, 311, 761, 175, -83,
     c 408, -15, 367, 539, 442, -77, 103,-143, 309, 700, 172, -91,
     c 404,  -9, 361, 534, 433, -81,  99,-154, 305, 649, 166,-102,
     c 405,   0, 351, 532, 425, -94,  97,-160, 302, 641, 157,-112,
     c 408,  12, 346, 530, 416, -98,  97,-165, 299, 661, 149,-119,
     c 413,  30, 345, 526, 406,-106,  98,-172, 297, 694, 147,-125,
     c 418,  46, 349, 522, 400,-112,  96,-179, 294, 720, 150,-131,
     c 420,  50, 349, 517, 398,-121,  93,-188, 291, 734, 152,-135,
     c 422,  31, 353, 517, 397,-122,  91,-194, 288, 732, 151,-140,
     c 419,  -6, 354, 518, 398,-120,  88,-199, 287, 720, 147,-144,
     c 415, -42, 350, 523, 403,-121,  87,-202, 287, 693, 149,-143,
     c 418, -49, 344, 529, 406,-121,  88,-203, 293, 664, 157,-138,
     c 430, -28, 349, 538, 411,-117,  97,-200, 302, 642, 172,-128,
     c 453,   8, 368, 558, 426,-101, 116,-186, 314, 637, 186,-118,
     c 469,  32, 380, 574, 439, -84, 135,-171, 326, 632, 199,-108,
     c 486,  57, 394, 591, 453, -71, 158,-156, 341, 627, 210, -98,
     c 321, -61, 327, 492, 495, -27,  82, -84, 323, 789, 129, -45,
     c 329, -56, 326, 495, 490, -21,  83, -85, 321, 766, 134, -43,
     c 337, -51, 326, 500, 487, -22,  86, -86, 318, 744, 135, -43,
     c 348, -46, 322, 501, 483, -27,  88, -89, 317, 710, 131, -46,
     c 358, -38, 325, 501, 479, -27,  92, -91, 318, 680, 127, -49,
     c 365, -31, 337, 504, 479, -25,  98, -89, 318, 672, 127, -51,
     c 371, -28, 348, 507, 481, -27, 103, -90, 319, 712, 137, -52,
     c 376, -29, 356, 513, 478, -31, 107, -89, 319, 771, 152, -52,
     c 381, -31, 365, 520, 477, -30, 110, -91, 321, 789, 165, -49,
     c 383, -33, 372, 524, 475, -35, 110, -95, 321, 781, 174, -47,
     c 387, -33, 382, 528, 472, -36, 111, -99, 321, 798, 176, -49,
     c 397, -25, 394, 533, 468, -40, 114,-107, 321, 813, 175, -55,
     c 411, -12, 400, 533, 467, -49, 116,-111, 319, 799, 170, -61,
     c 415,  -2, 395, 532, 463, -55, 116,-118, 314, 778, 169, -70,
     c 413,  -2, 386, 531, 457, -67, 111,-125, 309, 774, 169, -78,
     c 407, -12, 376, 530, 451, -72, 106,-134, 303, 775, 168, -83,
     c 405, -26, 366, 529, 444, -72, 101,-141, 299, 773, 166, -89,
     c 404, -35, 361, 529, 437, -75,  97,-147, 296, 739, 162, -95,
     c 398, -34, 353, 524, 428, -87,  94,-156, 294, 681, 158,-104,
     c 395, -22, 348, 522, 421, -91,  89,-166, 292, 637, 152,-112,
     c 397,  -3, 342, 518, 412,-100,  89,-169, 289, 634, 144,-121,
     c 405,  22, 340, 518, 407,-108,  90,-172, 288, 663, 139,-129,
     c 411,  43, 341, 514, 399,-114,  91,-179, 287, 697, 141,-134,
     c 414,  55, 345, 513, 393,-116,  90,-186, 286, 721, 147,-139,
     c 417,  50, 347, 510, 391,-124,  89,-194, 284, 727, 150,-143,
     c 417,  22, 347, 510, 390,-128,  85,-197, 283, 721, 151,-148,
     c 413, -21, 347, 512, 391,-127,  83,-203, 282, 702, 148,-151,
     c 408, -54, 343, 519, 397,-128,  81,-207, 284, 674, 149,-150,
     c 414, -58, 338, 525, 401,-129,  83,-210, 290, 646, 159,-143,
     c 430, -33, 343, 533, 408,-124,  95,-205, 301, 631, 175,-132,
     c 456,   3, 365, 555, 426,-104, 113,-189, 315, 629, 189,-119,
     c 474,  29, 380, 574, 440, -87, 135,-168, 330, 626, 204,-107,
     c 491,  53, 395, 591, 454, -73, 163,-150, 345, 625, 216, -95,
     c 319, -54, 321, 488, 488, -32,  78, -87, 321, 741, 125, -52,
     c 326, -50, 322, 492, 484, -27,  80, -91, 316, 724, 129, -51,
     c 332, -47, 320, 494, 481, -27,  82, -91, 313, 712, 127, -52,
     c 342, -44, 316, 494, 476, -32,  82, -96, 311, 701, 119, -55,
     c 350, -44, 315, 492, 469, -34,  84, -99, 310, 698, 111, -59,
     c 355, -43, 323, 494, 470, -34,  89, -99, 311, 707, 111, -62,
     c 360, -41, 335, 497, 470, -39,  92, -99, 311, 745, 122, -64,
     c 368, -35, 347, 505, 470, -40,  95, -99, 312, 777, 136, -62,
     c 375, -32, 355, 511, 469, -41,  97,-100, 313, 765, 151, -59,
     c 377, -35, 363, 517, 467, -48,  97,-104, 313, 743, 160, -58,
     c 377, -44, 373, 519, 461, -48,  98,-108, 312, 760, 163, -60,
     c 385, -45, 382, 520, 457, -55, 101,-115, 311, 779, 160, -65,
     c 396, -35, 385, 517, 454, -64, 102,-123, 307, 770, 155, -73,
     c 400, -22, 381, 516, 449, -72, 101,-131, 302, 757, 153, -83,
     c 399, -15, 372, 516, 445, -85,  99,-139, 294, 755, 152, -91,
     c 396, -19, 363, 515, 438, -89,  92,-146, 288, 754, 152, -98,
     c 395, -31, 355, 514, 430, -90,  88,-153, 284, 745, 151,-103,
     c 395, -41, 349, 513, 424, -96,  84,-160, 281, 710, 150,-110,
     c 392, -45, 342, 512, 416,-100,  83,-167, 279, 655, 146,-117,
     c 388, -35, 334, 509, 409,-107,  81,-175, 278, 619, 140,-125,
     c 389, -12, 329, 505, 402,-114,  81,-181, 276, 625, 134,-132,
     c 398,  16, 331, 504, 399,-120,  81,-184, 275, 659, 131,-137,
     c 405,  40, 334, 503, 392,-124,  82,-190, 276, 689, 136,-143,
     c 409,  53, 338, 504, 387,-123,  82,-195, 276, 707, 144,-147,
     c 410,  44, 338, 502, 384,-133,  82,-202, 275, 707, 149,-151,
     c 411,  13, 340, 505, 384,-133,  80,-205, 275, 698, 149,-154,
     c 406, -31, 340, 506, 385,-135,  78,-210, 276, 679, 146,-157,
     c 404, -61, 340, 517, 394,-132,  77,-210, 279, 654, 148,-155,
     c 413, -59, 338, 522, 400,-133,  81,-210, 288, 632, 158,-146,
     c 435, -31, 348, 534, 409,-123,  94,-203, 302, 625, 175,-133,
     c 463,   6, 373, 557, 428, -99, 116,-187, 318, 628, 192,-118,
     c 482,  30, 389, 577, 446, -80, 140,-167, 333, 628, 208,-104,
     c 499,  53, 403, 597, 464, -69, 168,-148, 350, 629, 223, -90,
     c 312, -48, 319, 483, 479, -37,  71, -96, 319, 720, 124, -58,
     c 318, -46, 317, 484, 475, -36,  74,-100, 313, 706, 126, -57,
     c 323, -44, 315, 485, 472, -33,  75,-104, 309, 705, 123, -60,
     c 333, -43, 311, 484, 468, -38,  74,-109, 305, 722, 110, -65,
     c 339, -48, 313, 484, 463, -38,  74,-114, 304, 751,  99, -69,
     c 341, -51, 319, 484, 461, -41,  75,-116, 304, 772,  97, -73,
     c 346, -50, 330, 486, 462, -49,  77,-116, 303, 798, 108, -74,
     c 355, -43, 340, 493, 461, -50,  79,-115, 303, 808, 123, -73,
     c 363, -38, 344, 500, 460, -53,  82,-116, 304, 773, 137, -72,
     c 366, -43, 351, 507, 457, -59,  82,-118, 303, 732, 146, -70,
     c 367, -57, 361, 508, 452, -61,  82,-121, 301, 734, 149, -73,
     c 374, -64, 369, 506, 448, -67,  85,-127, 300, 753, 146, -77,
     c 382, -59, 368, 503, 444, -78,  87,-137, 296, 751, 140, -85,
     c 389, -42, 365, 504, 439, -85,  88,-143, 289, 744, 137, -95,
     c 388, -29, 359, 504, 434, -94,  84,-151, 283, 741, 137,-105,
     c 389, -25, 350, 501, 427, -99,  80,-160, 275, 738, 138,-112,
     c 390, -31, 345, 500, 420, -99,  77,-166, 270, 724, 140,-118,
     c 391, -41, 343, 503, 415,-101,  76,-173, 267, 685, 138,-124,
     c 387, -48, 333, 500, 408,-113,  74,-178, 266, 637, 135,-131,
     c 382, -45, 322, 495, 398,-120,  72,-186, 265, 615, 130,-136,
     c 381, -29, 316, 490, 392,-129,  71,-191, 263, 629, 125,-142,
     c 387,  -3, 319, 489, 387,-135,  71,-193, 264, 663, 125,-147,
     c 395,  20, 324, 489, 380,-134,  73,-197, 264, 690, 131,-151,
     c 400,  34, 330, 492, 376,-133,  73,-201, 266, 697, 140,-154,
     c 401,  29, 328, 491, 377,-142,  75,-207, 267, 688, 144,-157,
     c 403,   1, 330, 495, 376,-141,  74,-211, 269, 674, 144,-160,
     c 402, -38, 335, 499, 378,-142,  74,-214, 271, 658, 141,-161,
     c 406, -61, 341, 511, 389,-137,  75,-214, 276, 635, 144,-158,
     c 418, -54, 344, 520, 400,-133,  83,-208, 287, 618, 155,-148,
     c 444, -23, 359, 535, 412,-121,  98,-200, 303, 615, 174,-133,
     c 473,  13, 384, 560, 433, -95, 121,-180, 320, 621, 193,-116,
     c 492,  35, 398, 581, 451, -78, 146,-157, 337, 623, 212,-100,
     c 509,  56, 411, 602, 471, -63, 176,-140, 356, 624, 229, -83,
     c 309, -46, 317, 479, 471, -37,  67,-102, 318, 687, 132, -60,
     c 314, -44, 315, 480, 472, -44,  68,-105, 311, 691, 130, -62,
     c 320, -43, 313, 480, 469, -37,  69,-112, 305, 709, 124, -65,
     c 327, -44, 308, 476, 462, -45,  65,-118, 301, 741, 110, -70,
     c 330, -51, 308, 474, 455, -47,  64,-123, 299, 783,  96, -77,
     c 331, -57, 314, 475, 452, -52,  63,-127, 297, 810,  93, -82,
     c 334, -58, 322, 476, 451, -60,  63,-129, 296, 840, 103, -84,
     c 344, -52, 329, 480, 451, -62,  66,-131, 296, 849, 117, -84,
     c 351, -49, 332, 485, 447, -67,  68,-131, 295, 804, 131, -83,
     c 353, -56, 336, 492, 444, -72,  68,-134, 295, 750, 138, -83,
     c 354, -73, 346, 494, 439, -73,  67,-137, 293, 746, 139, -85,
     c 360, -83, 352, 491, 434, -81,  70,-142, 292, 756, 135, -91,
     c 368, -78, 351, 489, 430, -93,  72,-148, 287, 748, 130, -99,
     c 373, -62, 348, 488, 424,-101,  75,-155, 282, 740, 127,-109,
     c 375, -45, 343, 488, 420,-109,  74,-162, 273, 739, 126,-119,
     c 378, -35, 337, 486, 413,-111,  69,-168, 266, 734, 129,-126,
     c 380, -37, 335, 486, 407,-109,  66,-175, 261, 718, 130,-132,
     c 382, -45, 333, 488, 403,-113,  66,-180, 258, 680, 129,-138,
     c 381, -53, 324, 486, 395,-124,  67,-187, 256, 634, 127,-143,
     c 377, -52, 314, 482, 388,-132,  65,-195, 254, 616, 123,-149,
     c 376, -39, 308, 477, 381,-138,  64,-203, 254, 635, 118,-153,
     c 383, -16, 313, 478, 377,-145,  64,-205, 253, 669, 116,-157,
     c 391,   7, 319, 480, 375,-139,  66,-209, 255, 692, 123,-160,
     c 398,  24, 327, 487, 376,-137,  68,-210, 257, 693, 131,-162,
     c 398,  22, 325, 485, 375,-145,  71,-212, 259, 678, 135,-164,
     c 402,  -1, 329, 491, 376,-142,  72,-217, 262, 659, 134,-165,
     c 404, -37, 337, 497, 378,-142,  73,-218, 266, 642, 133,-166,
     c 410, -57, 346, 510, 388,-137,  76,-214, 274, 619, 137,-162,
     c 425, -47, 352, 520, 399,-130,  84,-206, 287, 603, 151,-149,
     c 453, -15, 371, 538, 417,-114, 100,-194, 304, 601, 173,-132,
     c 483,  20, 395, 564, 439, -88, 126,-175, 323, 609, 195,-113,
     c 501,  42, 408, 585, 457, -72, 153,-155, 341, 612, 216, -94,
     c 519,  64, 421, 608, 478, -59, 182,-137, 360, 614, 236, -76,
     c 306, -45, 314, 475, 467, -41,  63,-110, 318, 659, 146, -60,
     c 311, -43, 313, 476, 467, -41,  63,-115, 310, 683, 141, -62,
     c 316, -42, 309, 476, 466, -38,  61,-121, 303, 720, 131, -67,
     c 320, -44, 305, 470, 458, -46,  57,-128, 298, 761, 115, -74,
     c 321, -54, 305, 466, 447, -52,  53,-137, 294, 814, 101, -82,
     c 321, -62, 309, 464, 442, -59,  51,-141, 291, 846,  97, -89,
     c 322, -66, 314, 464, 440, -74,  51,-145, 288, 887, 104, -93,
     c 332, -62, 319, 466, 438, -80,  53,-145, 287, 907, 118, -94,
     c 339, -60, 319, 471, 435, -87,  53,-147, 286, 859, 128, -95,
     c 341, -70, 324, 477, 430, -89,  53,-147, 286, 794, 135, -95,
     c 342, -88, 330, 479, 426, -91,  52,-150, 285, 785, 134, -99,
     c 348,-100, 337, 477, 422, -93,  55,-154, 284, 783, 129,-104,
     c 354, -98, 336, 474, 416,-104,  59,-158, 282, 760, 123,-112,
     c 360, -80, 332, 473, 410,-108,  62,-163, 276, 751, 119,-122,
     c 364, -59, 328, 473, 405,-117,  61,-169, 268, 752, 120,-132,
     c 366, -46, 324, 470, 399,-123,  60,-176, 260, 740, 121,-140,
     c 371, -44, 323, 471, 395,-126,  59,-183, 254, 722, 124,-146,
     c 374, -50, 323, 473, 390,-129,  60,-185, 250, 683, 123,-151,
     c 373, -57, 315, 471, 382,-143,  59,-193, 248, 641, 120,-157,
     c 371, -60, 307, 467, 376,-147,  57,-200, 247, 626, 115,-160,
     c 371, -50, 301, 463, 370,-153,  57,-206, 244, 650, 109,-164,
     c 378, -29, 306, 466, 367,-156,  57,-209, 245, 683, 107,-166,
     c 388,  -4, 314, 472, 367,-151,  60,-211, 246, 702, 112,-168,
     c 393,  12, 323, 481, 371,-145,  63,-213, 248, 695, 119,-170,
     c 397,  13, 320, 482, 372,-153,  69,-215, 253, 672, 122,-172,
     c 402,  -4, 328, 489, 374,-145,  71,-217, 258, 646, 121,-172,
     c 406, -35, 339, 497, 377,-142,  74,-218, 263, 626, 122,-171,
     c 416, -52, 353, 512, 389,-132,  79,-216, 272, 603, 128,-164,
     c 433, -40, 361, 521, 404,-125,  88,-205, 286, 586, 146,-150,
     c 462,  -7, 381, 538, 422,-110, 107,-193, 304, 584, 170,-131,
     c 491,  27, 404, 566, 445, -82, 132,-170, 325, 594, 196,-110,
     c 510,  49, 418, 589, 463, -64, 158,-151, 345, 597, 220, -89,
     c 528,  70, 431, 611, 482, -50, 188,-133, 365, 600, 242, -68/
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc_zpa.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c---------------------------------------------------------------------------
c
c wfc_zpa.f --- routine to correct photometry for the fact that
c               the flat-fields were designed to preserve surface
c               brightness, not flux.  This is a pretty sizeable
c               correction... from 0.127 in the upper left corner,
c               to -0.085 in the lower right corner.
c
c---------------------------------------------------------------------------
c
c On the off chance that it might be useful, I will reproduce here the table
c that samples the following correction:
c
c
c 4096   0.127  0.118  0.109  0.100  0.092  0.084  0.077  0.070  0.063  0.057  0.050  0.045  0.039  0.034  0.029  0.024
c 3840   0.118  0.108  0.100  0.091  0.083  0.075  0.068  0.061  0.054  0.048  0.042  0.036  0.030  0.025  0.020  0.015
c 3584   0.109  0.099  0.091  0.082  0.074  0.067  0.059  0.052  0.046  0.039  0.033  0.027  0.022  0.017  0.012  0.007
c 3328   0.100  0.091  0.082  0.074  0.066  0.058  0.051  0.044  0.038  0.031  0.025  0.019  0.014  0.009  0.004 -0.001
c 3072   0.092  0.083  0.075  0.066  0.058  0.051  0.043  0.037  0.030  0.024  0.017  0.012  0.006  0.001 -0.004 -0.009
c 2816   0.085  0.076  0.067  0.059  0.051  0.043  0.036  0.029  0.023  0.016  0.010  0.004 -0.001 -0.007 -0.012 -0.016
c 2560   0.077  0.068  0.060  0.052  0.044  0.036  0.029  0.022  0.015  0.009  0.003 -0.003 -0.009 -0.014 -0.019 -0.024
c 2304   0.070  0.062  0.053  0.045  0.037  0.029  0.022  0.015  0.008  0.002 -0.004 -0.010 -0.016 -0.021 -0.026 -0.031
c 2048   0.066  0.057  0.048  0.039  0.031  0.024  0.016  0.010  0.003 -0.003 -0.010 -0.015 -0.021 -0.026 -0.031 -0.036
c
c 2048   0.066  0.057  0.048  0.039  0.031  0.024  0.016  0.009  0.003 -0.004 -0.010 -0.015 -0.021 -0.026 -0.031 -0.036
c 1792   0.059  0.050  0.041  0.033  0.025  0.017  0.010  0.003 -0.004 -0.010 -0.016 -0.022 -0.027 -0.033 -0.038 -0.042
c 1536   0.053  0.044  0.035  0.027  0.019  0.011  0.004 -0.003 -0.010 -0.016 -0.022 -0.028 -0.034 -0.039 -0.044 -0.049
c 1280   0.047  0.038  0.029  0.021  0.013  0.005 -0.002 -0.009 -0.016 -0.022 -0.028 -0.034 -0.039 -0.045 -0.050 -0.054
c 1024   0.041  0.032  0.023  0.015  0.007 -0.001 -0.008 -0.015 -0.021 -0.028 -0.034 -0.040 -0.045 -0.050 -0.055 -0.060
c 0768   0.036  0.027  0.018  0.010  0.002 -0.006 -0.013 -0.020 -0.027 -0.033 -0.039 -0.045 -0.050 -0.056 -0.061 -0.065
c 0512   0.031  0.022  0.013  0.005 -0.003 -0.011 -0.018 -0.025 -0.032 -0.038 -0.044 -0.050 -0.055 -0.061 -0.066 -0.071
c 0256   0.026  0.017  0.008  0.000 -0.008 -0.016 -0.023 -0.030 -0.037 -0.043 -0.049 -0.055 -0.060 -0.066 -0.071 -0.075
c 0000   0.021  0.012  0.004 -0.005 -0.013 -0.020 -0.028 -0.035 -0.041 -0.048 -0.054 -0.059 -0.065 -0.070 -0.075 -0.080
c
c
c AVG: 0.0000
c
c----------------------------------------------------------------------------------------
c
c this is the photometric correction for the ACS/WFC camera
c
c this corrects an observed magnitude as measured by aperture or
c psf-fitting photometry for the fact that the area subtended by
c each pixel varies because of distortion and the flat fields have
c been constructed to conserve surfact brightness and not flux.
c
c this correction should be ADDED to a magnitude to correct
c it for the pixel area
c
c   mcorr = mraw + wfc_zpa()
c
c
      real function wfc_zpa(x,y,k)
      implicit none
 
      real*8 x, y
      integer k
 
      integer i, j
      real*8 pixarea_wfc
      real*8 pa
 
      if (k.eq.0) then
         i = x
         j = y
         endif
      if (k.eq.1) then
         i = x
         j = y+2048
         endif
      if (k.eq.2) then
         i = x
         j = y
         endif
 
      pa = pixarea_wfc(i,j)
      wfc_zpa = -2.5*log10(pa)  ! I have found experimentally
                                 ! that this is the right sign to
                                 ! use
 
      wfc_zpa = wfc_zpa - 0.03018
 
      return
      end
 
 
 
 
c---------------------------------------------
c
c routine to determine the area on the sky for a given pixel,
c using just the polynomials
c
      real*8 function pixarea_wfc(i,j)
      implicit none
 
      integer i,j
 
      real fx, fy
 
      real dxdx, dxdy
      real dydx, dydy
      real dxdx0,dxdy0
      real dydx0,dydy0
 
 
c
c in LINUX you need to do this to make sure
c that the variables stay in memory
c
      real poly1x(15), poly1y(15) ! TOP CHIP WFC1
      real poly2x(15), poly2y(15) ! BOT CHIP WFC2
      common /polya/poly1x,poly1y,poly2x,poly2y
      data poly1x /
     .      4.222858,-25.810972,  7.522745, 35.110044,-15.458679,
     .      2.224611, -3.997423, -0.461412, -1.137435,  0.069899,
     .      0.365157,  0.297704,  0.451025, -0.059556,  0.164580/
      data poly1y /
     .   2090.829009,166.636444,-22.581991, -9.224829, 11.854841,
     .     -9.812475,  0.450533, -1.922356, -0.151181, -0.408813,
     .     -0.294261, -0.302678, -0.414122,  0.101310, -0.188003/
      data poly2x /
     .     -0.013903,  0.115885, -0.014278, 35.845661,-10.955353,
     .      2.264019, -4.018862, -0.189312, -1.135375,  0.008529,
     .      0.419362,  0.099082,  0.167527, -0.036017, -0.000001/
      data poly2y /
     .      0.023567,141.245503, 11.904442, -4.966731, 12.417648,
     .     -7.488638,  0.463892, -2.239110, -0.249694, -0.464881,
     .     -0.258344, -0.022357, -0.105517, -0.050072, -0.031641/
 
      if (j.le.2048) then
         fx = (i-2048.0)/2048.0
         fy = (j-1024.0)/1024.0
         dxdx = 1*(poly2x(02)+2048)
     .        + 2*poly2x(04)*fx
     .        + 1*poly2x(05)*fy
     .        + 3*poly2x(07)*fx*fx
     .        + 2*poly2x(08)*fx*fy
     .        + 1*poly2x(09)*fy*fy
     .        + 4*poly2x(11)*fx*fx*fx
     .        + 3*poly2x(12)*fx*fx*fy
     .        + 2*poly2x(13)*fx*fy*fy
     .        + 1*poly2x(14)*fy*fy*fy
         dydx = 1*poly2y(02)
     .        + 2*poly2y(04)*fx
     .        + 1*poly2y(05)*fy
     .        + 3*poly2y(07)*fx*fx
     .        + 2*poly2y(08)*fx*fy
     .        + 1*poly2y(09)*fy*fy
     .        + 4*poly2y(11)*fx*fx*fx
     .        + 3*poly2y(12)*fx*fx*fy
     .        + 2*poly2y(13)*fx*fy*fy
     .        + 1*poly2y(14)*fy*fy*fy
         dxdy = 1*poly2x(03)
     .        + 2*poly2x(06)*fy
     .        + 1*poly2x(05)*fx
     .        + 3*poly2x(10)*fy*fy
     .        + 2*poly2x(09)*fx*fy
     .        + 1*poly2x(08)*fx*fx
     .        + 4*poly2x(15)*fy*fy*fy
     .        + 3*poly2x(14)*fx*fy*fy
     .        + 2*poly2x(13)*fx*fx*fy
     .        + 1*poly2x(12)*fx*fx*fx
         dydy = 1*(poly2y(03)+1024)
     .        + 2*poly2y(06)*fy
     .        + 1*poly2y(05)*fx
     .        + 3*poly2y(10)*fy*fy
     .        + 2*poly2y(09)*fx*fy
     .        + 1*poly2y(08)*fx*fx
     .        + 4*poly2y(15)*fy*fy*fy
     .        + 3*poly2y(14)*fx*fy*fy
     .        + 2*poly2y(13)*fx*fx*fy
     .        + 1*poly2y(12)*fx*fx*fx
         endif
 
 
 
      if (j.gt.2048) then
         fx = (i-2048.0)/2048.0
         fy = (j-3072.0)/1024.0
         dxdx = 1*(poly1x(02)+2048)
     .        + 2*poly1x(04)*fx
     .        + 1*poly1x(05)*fy
     .        + 3*poly1x(07)*fx*fx
     .        + 2*poly1x(08)*fx*fy
     .        + 1*poly1x(09)*fy*fy
     .        + 4*poly1x(11)*fx*fx*fx
     .        + 3*poly1x(12)*fx*fx*fy
     .        + 2*poly1x(13)*fx*fy*fy
     .        + 1*poly1x(14)*fy*fy*fy
         dydx = 1*poly1y(02)
     .        + 2*poly1y(04)*fx
     .        + 1*poly1y(05)*fy
     .        + 3*poly1y(07)*fx*fx
     .        + 2*poly1y(08)*fx*fy
     .        + 1*poly1y(09)*fy*fy
     .        + 4*poly1y(11)*fx*fx*fx
     .        + 3*poly1y(12)*fx*fx*fy
     .        + 2*poly1y(13)*fx*fy*fy
     .        + 1*poly1y(14)*fy*fy*fy
         dxdy = 1*poly1x(03)
     .        + 2*poly1x(06)*fy
     .        + 1*poly1x(05)*fx
     .        + 3*poly1x(10)*fy*fy
     .        + 2*poly1x(09)*fx*fy
     .        + 1*poly1x(08)*fx*fx
     .        + 4*poly1x(15)*fy*fy*fy
     .        + 3*poly1x(14)*fx*fy*fy
     .        + 2*poly1x(13)*fx*fx*fy
     .        + 1*poly1x(12)*fx*fx*fx
         dydy = 1*(poly1y(03)+1024)
     .        + 2*poly1y(06)*fy
     .        + 1*poly1y(05)*fx
     .        + 3*poly1y(10)*fy*fy
     .        + 2*poly1y(09)*fx*fy
     .        + 1*poly1y(08)*fx*fx
     .        + 4*poly1y(15)*fy*fy*fy
     .        + 3*poly1y(14)*fx*fy*fy
     .        + 2*poly1y(13)*fx*fx*fy
     .        + 1*poly1y(12)*fx*fx*fx
         endif
 
      dxdx0 = poly2x(02)+2048
      dydx0 = poly2y(02)
      dxdy0 = poly2x(03)
      dydy0 = poly2y(03)+1024
 
      pixarea_wfc = (dxdx *dydy  - dxdy *dydx )/
     .              (dxdx0*dydy0 - dxdy0*dydx0)
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfpc2gcJJ.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c---------------------------------------------------------------------
c
c Jay Anderson
c Berkeley Jan 2001
c
c These are the distortion coefficients I derived based on the
c inner Omega Cen calibration field, about 80 V observations of 100s.
c
c I modeled the distortion using LEGENDRE polynomials such that:
c
c xtrue = xobs + DX(x,y)
c ytrue = yobs + DY(x,y)
c
c   fx = (x-425)/375
c   fy = (y-425)/375
c
c   DX(x,y) = 0.000 +
c             A_x *(fx)          + A_y *(fy)    + ...
c             A_xx*(3*fx*fx-1)/2 + A_xy*(fx*fy) +  A_yy*(3*fy*fy-1)/2 + ...
c
c   DY(x,y) = 0.000 +
c             B_x *(fx)          + B_y *(fy)    + ...
c
c
c We subject this to the constraint that the A_x and A_y coefficients be
c 0.00 (the A coeffs apply to x the B to y).  This constraint means
c that the final y axis is directed along the standard y-coordinate
c with the overall scale set to be that along the x-direction at the
c center of the chip.  The B_x and B_y coeffs are not necessarily zero
c to the extent that the x,y scales may differ (possibly because of
c 34th-row issues) or there may be some skew (non-orthogonality of the
c axes; there is an appreciable amount in PC1).
c
c I assumed the center of the disortion to be at (425,425) in each
c chip and modeled it over the region (100:775,100:775).  Below
c x,y values of 100 the fit becomes poor.  I will quantify this
c later when I write this up.  The polynomials are normalized to
c apply over the region (50:800,50:800):  fx = (x-425)/375,
c fy=(y-425)/375 are the scaled coords for the polynomial.
c
c I have found that these coeffs are good globally to better than
c 0.015 in the PC and to better than 0.01 in the WF chips.
c
c Note that while I dervived the correction with Legendre polynomials
c (because of their orthogonality), I later re-tooled the expression
c to use the regular set of polynomials, so that things would be
c easier to examine.
c
c---------------------------------------------------------------------
 
c---------------------------------------------------------------------
c
c This routine takes in an (xin,yin) position as measured on a chip
c then returns the distortion-corrected positoin (xout,yout); if the
c input chip is 0, no correction is performed.  k=1 corresponds to
c pc1, k=2 to wf2, etc.
c
      subroutine wfpc2gcK(xin,yin,xout,yout,k)
      implicit none
      real    xin,  yin
      real    xout, yout
      integer k
      real x_wfpc2gcK
      real y_wfpc2gcK
 
      real xinh, yinh
 
      xinh = xin ! doing it this way allows the calling
      yinh = yin !    routine to use the same var for xin/xout
 
      xout = x_wfpc2gcK(xinh,yinh,k)
      yout = y_wfpc2gcK(xinh,yinh,k)
 
      !if (xinh.lt.100) xout = xout + (100-xinh)/50*0.100
      !if (yinh.lt.100) yout = yout + (100-yinh)/50*0.225
 
      return
      end
 
c--------------------------------------------------------
 
      real function x_wfpc2gcK(xin,yin,k)
      implicit none
      real xin,  yin
      integer k
      real x, y, d
 
      real pwfpc2gc(2,4,10)
      data pwfpc2gc /                                           ! ORDER
     .  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, ! const
     .  0.000, 0.418, 0.000, 0.051, 0.000,-0.028, 0.000, 0.070, ! x
     .  0.000,-0.016, 0.000,-0.015, 0.000,-0.036, 0.000, 0.059, ! y
     . -0.525,-0.280,-0.624,-0.038,-0.349,-0.027,-0.489,-0.050, ! xx
     . -0.268,-0.292,-0.411,-0.568,-0.353,-0.423,-0.391,-0.485, ! xy
     . -0.249,-0.470,-0.092,-0.444, 0.009,-0.373,-0.066,-0.406, ! yy
     . -1.902,-0.011,-1.762, 0.003,-1.791, 0.004,-1.821,-0.015, ! xxx
     .  0.024,-1.907, 0.016,-1.832, 0.006,-1.848, 0.022,-1.890, ! xxy
     . -1.890, 0.022,-1.825, 0.011,-1.841, 0.006,-1.875, 0.022, ! xyy
     . -0.004,-1.923, 0.010,-1.730, 0.021,-1.788,-0.006,-1.821/ ! yyy
c
c        APC1  BPC1    AWF2   BWF2   AWF3   BWF3   AWF4   BWF4
c
 
      x_wfpc2gcK = xin
      if (k.lt.1.or.k.gt.4) return
      if (xin.lt.000) return
      if (yin.lt.000) return
      if (xin.gt.800) return
      if (yin.gt.800) return
 
      x = (xin-425.0)/375.0
      y = (yin-425.0)/375.0
 
c
c     for x use the A coeffs...
c
      d = pwfpc2gc(1,k,01)*1.0 +
     .    pwfpc2gc(1,k,02)*x  +
     .    pwfpc2gc(1,k,03)*y  +
     .    pwfpc2gc(1,k,04)*x**2 +
     .    pwfpc2gc(1,k,05)*x*y  +
     .    pwfpc2gc(1,k,06)*y**2 +
     .    pwfpc2gc(1,k,07)*x**3   +
     .    pwfpc2gc(1,k,08)*x**2*y +
     .    pwfpc2gc(1,k,09)*y**2*x +
     .    pwfpc2gc(1,k,10)*y**3
 
      x_wfpc2gcK = xin + d
 
      return
      end
 
c--------------------------------------------------------
 
      real function y_wfpc2gcK(xin,yin,k)
      implicit none
      real xin,  yin
      integer k
      real x, y, d
 
      real pwfpc2gc(2,4,10)
      data pwfpc2gc /                                           ! ORDER
     .  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, ! const
     .  0.000, 0.418, 0.000, 0.051, 0.000,-0.028, 0.000, 0.070, ! x
     .  0.000,-0.016, 0.000,-0.015, 0.000,-0.036, 0.000, 0.059, ! y
     . -0.525,-0.280,-0.624,-0.038,-0.349,-0.027,-0.489,-0.050, ! xx
     . -0.268,-0.292,-0.411,-0.568,-0.353,-0.423,-0.391,-0.485, ! xy
     . -0.249,-0.470,-0.092,-0.444, 0.009,-0.373,-0.066,-0.406, ! yy
     . -1.902,-0.011,-1.762, 0.003,-1.791, 0.004,-1.821,-0.015, ! xxx
     .  0.024,-1.907, 0.016,-1.832, 0.006,-1.848, 0.022,-1.890, ! xxy
     . -1.890, 0.022,-1.825, 0.011,-1.841, 0.006,-1.875, 0.022, ! xyy
     . -0.004,-1.923, 0.010,-1.730, 0.021,-1.788,-0.006,-1.821/ ! yyy
c
c         APC1  BPC1   AWF2   BWF2   AWF3   BWF3   AWF4   BWF4
c
 
      y_wfpc2gck = yin
      if (k.lt.1.or.k.gt.4) return
      if (xin.lt.000) return
      if (yin.lt.000) return
      if (xin.gt.800) return
      if (yin.gt.800) return
 
      x = (xin-425.0)/375.0
      y = (yin-425.0)/375.0
 
c
c     for y use the B coeffs...
c
      d = pwfpc2gc(2,k,01)*1.0  +
     .    pwfpc2gc(2,k,02)*x    +
     .    pwfpc2gc(2,k,03)*y    +
     .    pwfpc2gc(2,k,04)*x**2 +
     .    pwfpc2gc(2,k,05)*x*y  +
     .    pwfpc2gc(2,k,06)*y**2 +
     .    pwfpc2gc(2,k,07)*x**3   +
     .    pwfpc2gc(2,k,08)*x**2*y +
     .    pwfpc2gc(2,k,09)*y**2*x +
     .    pwfpc2gc(2,k,10)*y**3
 
      y_wfpc2gck = yin + d
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc3u_gc.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------------
c
c this file contains three subroutines:
c
c   1) subroutine wfc3uv_gc(xr,yr,chip,filter,xc,yc)
c
c   3) subroutine wfc3uv_gc_meta_k(xr,yr,chip,filter,xc,yc)
c
c   2) subroutine wfc3uv_gc_meta(xr,yr,filter,xc,yc)
c
c--------------------------------------------------------------
 
 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     This subroutine corrects UVIS individual-chip raw
C     positions
C
C     USAGE:
C     (xr,yr): raw sigle-chip positions
C     chip:    chip ID (1-2, as in Bellini & Bedin 2009,
C              i.e. UVIS1=chip2, UVIS2=chip1)
C     filter:  0 -> F225W
C              1 -> F275W
C              2 -> F336W
C              3 -> F390W
C              4 -> F438W
C              5 -> F555W
C              6 -> F606W
C              7 -> F775W
C              8 -> F814W
C              9 -> F850L
C     (xc,yc): corrected single-chip positions
C
C     NOTE: if (LOOKUP .eq. .false.) the lookup_table
C     correction will be skipped.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 
      subroutine wfc3uv_gc(xr,yr,chip,filter,xc,yc)
      implicit none
 
      integer i,chip,filter,j,jj
 
      real*8 xr, yr, xt, yt, xc, yc
      real*8 x_cen, y_cen
      real*8 x_tab(38), y_tab(18), y1_tab(18), y2_tab(18)
      integer filteru
 
      real a(9), b(9)
 
      integer zx     ! zone number along x
      real    xr_zx  ! the start of each x-zone
      real    rzx    ! the location within an x-zone
 
      integer nx, ny ! table indices in x,y
      real    rx, ry ! rough mapping into tables ; not exact
      real    fx, fy ! the fractional offset between table entries
 
      real dxp, dyp
      real dxt, dyt
      character*1 char
      character*3 lab
 
C---> LOOKUP: if true -> perform lookup-table correction
C             if false -> jump to polynomial correction
      logical LOOKUP
 
      data x_tab/0000.00,
     .      23.50,  192.25,  304.75,  417.25,  529.75,  698.50,
     .     698.50,  867.25,  979.75, 1092.25, 1204.75, 1373.50,
     .    1373.50, 1542.25, 1654.75, 1767.25, 1879.75, 2048.50,
     .    2048.50, 2217.25, 2329.75, 2442.25, 2554.75, 2723.50,
     .    2723.50, 2892.25, 3004.75, 3117.25, 3229.75, 3398.50,
     .    3398.50, 3567.25, 3679.75, 3792.25, 3904.75, 4073.50,
     .    4096.00/
 
      data y1_tab/0000, 170.8125, 284.6875, 398.5625, 512.4375,
     .     626.3125, 740.1875, 911,
     .     911,1082,  1196,  1310,  1424,  1538,  1652,  1766,
     .     1880,  2051/
 
      data y2_tab/0000,  171, 285,  399,  513,  627,  741,
     .     855,  969,  1140,
     .     1140, 1310.8125, 1424.6875, 1538.5625, 1652.4375,
     .     1766.3125, 1880.1875, 2051/
 
C----------------------------------------------------------------------
C
C Polynomial coefficients; one line for each coord/filter
C
C
      real apoly(9,2,10)
      data apoly /
     .0.0, 0.0, 12.1203,-6.2786, 0.0638, 0.1759,-0.0568, 0.0037, 0.0347,
     .0.0, 0.0, 12.0209,-6.0574, 0.0012, 0.1487, 0.0219, 0.0610, 0.0325,
     .0.0, 0.0, 12.1023,-6.2844, 0.0608, 0.1783,-0.0559, 0.0048, 0.0333,
     .0.0, 0.0, 12.0155,-6.0395, 0.0012, 0.1436, 0.0258, 0.0508, 0.0324,
     .0.0, 0.0, 12.0912,-6.1882, 0.0653,-0.0623,-0.0965, 0.0164, 0.0330,
     .0.0, 0.0, 11.9937,-6.1352, 0.0042,-0.1514, 0.0740, 0.0398, 0.0326,
     .0.0, 0.0, 12.0575,-6.1989, 0.0669, 0.0417,-0.0828, 0.0160, 0.0502,
     .0.0, 0.0, 11.9586,-6.1143,-0.0066, 0.0016, 0.0700, 0.0742, 0.0547,
     .0.0, 0.0, 12.0355,-6.2339, 0.0632, 0.1161,-0.0506, 0.0311, 0.0408,
     .0.0, 0.0, 11.9735,-6.0685, 0.0021, 0.0612, 0.0431, 0.0732, 0.0563,
     .0.0, 0.0, 12.1457,-6.2259, 0.0621, 0.3040,-0.0430, 0.0225, 0.0338,
     .0.0, 0.0, 12.0384,-6.0369,-0.0048, 0.2288,-0.0145, 0.0538, 0.0541,
     .0.0, 0.0, 12.0439,-6.2225, 0.0654, 0.1827,-0.0544, 0.0333, 0.0232,
     .0.0, 0.0, 11.9592,-6.0686, 0.0009, 0.0963, 0.0371, 0.0759, 0.0359,
     .0.0, 0.0, 12.0443,-6.2037, 0.0623, 0.2732,-0.0516, 0.0585, 0.0746,
     .0.0, 0.0, 12.0220,-6.0396, 0.0046, 0.1394, 0.1234, 0.0205, 0.0324,
     .0.0, 0.0, 12.0251,-6.2193, 0.0653, 0.1919,-0.0539, 0.0473, 0.0375,
     .0.0, 0.0, 12.0577,-6.0836, 0.0027, 0.0638, 0.0910, 0.0730, 0.0273,
     .0.0, 0.0, 12.0511,-6.2362, 0.0578, 0.2917,-0.0457, 0.0421, 0.0576,
     .0.0, 0.0, 11.9808,-5.9852,-0.0017, 0.1943, 0.0244, 0.0661, 0.0388/
 
      real bpoly(9,2,10)
      data bpoly /
     .129.2297, 1.9351,.5906,5.5526,-3.2274,.0291,0.0327,-0.0412,-.0230,
     .140.2701,-4.2153,.7732,5.4956,-3.0580,.1557,-.0093,-0.0264,0.0277,
     .129.2700, 1.9251,.5809,5.5472,-3.2410,.0333,0.0538,-0.0408,-.0118,
     .140.2850,-4.2207,.7807,5.4933,-3.0483,.1633,0.0072,-0.0253,0.0198,
     .129.4380, 1.7865,.6762,5.5652,-3.1553,.0038,0.0343,-0.0615,0.0163,
     .140.3147,-4.3218,.6715,5.4763,-3.1515,.1893,-.0271, 0.0050,0.0140,
     .129.3641, 1.8663,.6637,5.5509,-3.1606,.0137,0.0260,-0.0513,-.0139,
     .140.2162,-4.2584,.7200,5.4724,-3.1158,.1772,-.0166, 0.0014,0.0223,
     .129.3780, 1.8968,.6111,5.5392,-3.1606,.0303,0.0543,-0.0328,-.0219,
     .140.2763,-4.2583,.7713,5.4920,-3.0793,.1672,0.0269,-0.0219,0.0233,
     .129.3566, 1.9305,.5794,5.5224,-3.2361,.0322,0.0474,-0.0101,0.0053,
     .140.2924,-4.1853,.7695,5.4644,-3.0337,.1187,0.0147,-0.0192,0.0178,
     .129.3845, 1.8679,.6216,5.5261,-3.2111,.0259,0.0804,-0.0336,0.0093,
     .140.2800,-4.2506,.7619,5.4616,-3.0626,.1555,0.0086,-0.0196,0.0493,
     .129.3217, 1.9458,.5925,5.5377,-3.1707,.0017,0.0416, 0.0059,-.0007,
     .140.1670,-4.2114,.7804,5.5297,-2.9862,.2284,0.0016, 0.0373,-.0099,
     .129.3650, 1.8970,.6181,5.5162,-3.1900,.0373,0.0716,-0.0474,-.0039,
     .140.1682,-4.2747,.7646,5.5080,-3.0895,.2008,0.0225, 0.0417,0.0535,
     .129.3177, 1.9401,.5467,5.5222,-3.2432,.0243,0.0650,-0.0497,0.0007,
     .140.2988,-4.2084,.8176,5.5099,-2.9918,.1504,0.0267,-0.0299,0.0396/
 
C----------------------------------------------------------------------
C
C   These are the lookup-table entries with the filter as the
C   fastest-moving element, then x then y ;
C
      integer*2 dx1(10,38,18)
      integer*2 dy1(10,38,18)
      integer*2 dx2(10,38,18)
      integer*2 dy2(10,38,18)
 
      data dx1 /
     .-085,-076,-165,-094,-062,-030,-081,-051,-118,-055, ! dx1(1:10, 1, 1)
     .-021,-027,-147,-111,-038,-030,-061,-035,-104,-043, ! dx1(1:10, 2, 1)
     .-038,-041,-104,-070,-025,-025,-038,-009,-077,-002, ! dx1(1:10, 3, 1)
     .-011,-024,-086,-066,-045,-028,-045,-005,-070,-037, ! dx1(1:10, 4, 1)
     .-064,-044,-072,-045,-047,-046,-042,-013,-062,-026, ! dx1(1:10, 5, 1)
     .-031,-021,-032,-018,-021,-022,-021,-020,-030, 001, ! dx1(1:10, 6, 1)
     .-006,-004,-007,-005,-013,-038,-011,-023, 002,-016, ! dx1(1:10, 7, 1)
     .-056,-067,-061,-046,-061,-082,-061,-070,-041,-065, ! dx1(1:10, 8, 1)
     .-031,-018, 003,-002,-026,-030,-027,-047,-008,-012, ! dx1(1:10, 9, 1)
     .-041,-032,-001,-008,-029,-040,-032,-038,-019,-021, ! dx1(1:10,10, 1)
     .-002,-008, 010,-002,-025,-038,-031,-014,-011,-004, ! dx1(1:10,11, 1)
     .-009, 001, 026, 032,-010,-017,-013, 002, 009, 005, ! dx1(1:10,12, 1)
     .-009,-003, 018, 012,-008,-008,-008, 002, 024, 011, ! dx1(1:10,13, 1)
     . 022, 012, 032, 035, 006,-001,-002, 015, 036, 014, ! dx1(1:10,14, 1)
     . 014, 017, 032, 033, 024, 022, 016, 023, 052, 042, ! dx1(1:10,15, 1)
     . 008, 024, 027, 034, 022, 021, 023, 020, 053, 021, ! dx1(1:10,16, 1)
     . 030, 026, 036, 046, 037, 029, 034, 033, 053, 040, ! dx1(1:10,17, 1)
     . 041, 037, 044, 053, 053, 052, 037, 039, 053, 055, ! dx1(1:10,18, 1)
     . 047, 052, 047, 060, 056, 053, 052, 044, 038, 054, ! dx1(1:10,19, 1)
     . 020, 022, 027, 035, 035, 024, 023, 021, 020, 035, ! dx1(1:10,20, 1)
     . 045, 046, 017, 035, 048, 054, 033, 039, 017, 053, ! dx1(1:10,21, 1)
     . 005, 031, 015, 031, 034, 029, 016, 044, 004, 038, ! dx1(1:10,22, 1)
     . 029, 021, 016, 028, 036, 036, 023, 058, 002, 043, ! dx1(1:10,23, 1)
     . 021, 018, 000, 011, 025, 025, 017, 068, 003, 042, ! dx1(1:10,24, 1)
     . 000, 018,-003, 015, 020, 018, 008, 053, 012, 031, ! dx1(1:10,25, 1)
     . 000, 007,-031,-003, 003,-009,-018, 037,-021, 003, ! dx1(1:10,26, 1)
     .-008,-001,-037,-020,-013,-027,-020, 029,-015, 012, ! dx1(1:10,27, 1)
     . 005,-008,-022,-017,-006,-030,-018, 016,-020, 017, ! dx1(1:10,28, 1)
     .-001,-013,-029,-023,-011,-017,-028, 004,-025, 025, ! dx1(1:10,29, 1)
     .-011,-015,-017,-017,-013,-009,-022, 001,-031, 022, ! dx1(1:10,30, 1)
     .-007,-012,-010,-013,-002, 031,-020,-011,-014, 003, ! dx1(1:10,31, 1)
     .-007,-015,-031,-017,-012, 033,-024,-022,-020, 017, ! dx1(1:10,32, 1)
     . 015, 011, 012, 011, 008, 050,-015, 010, 014, 009, ! dx1(1:10,33, 1)
     . 007, 002, 019, 009, 002, 033,-021, 010, 024, 020, ! dx1(1:10,34, 1)
     . 004, 019, 036, 033, 018, 036,-025, 022, 034, 014, ! dx1(1:10,35, 1)
     . 006, 004, 058, 037, 007, 001,-032, 025, 023,-006, ! dx1(1:10,36, 1)
     . 013, 002, 094, 059, 013,-087,-034, 022,-013,-012, ! dx1(1:10,37, 1)
     . 060, 032, 121, 079, 030,-073,-010, 037, 014, 014, ! dx1(1:10,38, 1)
     .-044,-030,-120,-077,-016,-016,-035,-027,-067,-023, ! dx1(1:10, 1, 2)
     .-057,-040,-119,-083,-025,-015,-042,-022,-062,-015, ! dx1(1:10, 2, 2)
     .-041,-019,-064,-057,-020, 000,-027,-002,-050,-032, ! dx1(1:10, 3, 2)
     .-039,-034,-061,-050,-032,-025,-028,-012,-050,-027, ! dx1(1:10, 4, 2)
     .-031,-017,-040,-036,-020,-024,-026,-010,-036,-019, ! dx1(1:10, 5, 2)
     .-002,-006,-008,-007,-018,-026,-003,-013,-012,-011, ! dx1(1:10, 6, 2)
     .-023, 000, 013, 004, 000,-010, 006,-020, 004,-003, ! dx1(1:10, 7, 2)
     .-053,-027,-029,-033,-049,-052,-041,-066,-038,-046, ! dx1(1:10, 8, 2)
     .-025,-023, 001,-005,-028,-039,-023,-040,-014,-031, ! dx1(1:10, 9, 2)
     .-012,-016, 007,-007,-029,-031,-026,-038,-014,-026, ! dx1(1:10,10, 2)
     .-014,-008, 015,-001,-020,-034,-020,-025,-013,-031, ! dx1(1:10,11, 2)
     .-007,-005, 017, 000,-018,-022,-018,-018,-006,-003, ! dx1(1:10,12, 2)
     .-015,-001, 011, 002,-010,-021,-010,-021, 007,-020, ! dx1(1:10,13, 2)
     . 002, 016, 025, 016, 000,-005, 001,-008, 015, 000, ! dx1(1:10,14, 2)
     . 002, 012, 023, 023, 010, 003, 009,-007, 033, 000, ! dx1(1:10,15, 2)
     . 002, 010, 023, 023, 016, 009, 013,-001, 036, 016, ! dx1(1:10,16, 2)
     . 006, 016, 016, 033, 028, 023, 019, 002, 037, 019, ! dx1(1:10,17, 2)
     . 012, 022, 030, 036, 041, 031, 038, 011, 033, 030, ! dx1(1:10,18, 2)
     . 023, 019, 014, 024, 044, 040, 028, 019, 026, 025, ! dx1(1:10,19, 2)
     . 013, 000,-003, 009, 022, 027, 017, 001, 002, 004, ! dx1(1:10,20, 2)
     . 007, 011, 005, 018, 025, 026, 021, 014, 003, 023, ! dx1(1:10,21, 2)
     . 024, 022, 004, 026, 042, 036, 032, 026, 007, 024, ! dx1(1:10,22, 2)
     . 012, 033,-004, 022, 024, 016, 012, 035, 000, 022, ! dx1(1:10,23, 2)
     . 024, 034, 011, 010, 025, 021, 024, 046, 009, 023, ! dx1(1:10,24, 2)
     . 011, 002,-008, 003, 007,-006, 004, 031, 000, 018, ! dx1(1:10,25, 2)
     .-027,-018,-023,-020,-011,-017,-011, 015,-019,-003, ! dx1(1:10,26, 2)
     .-005,-016,-030,-027,-020,-026,-013, 006,-020, 002, ! dx1(1:10,27, 2)
     .-022,-012,-046,-038,-019,-039,-019,-009,-027,-006, ! dx1(1:10,28, 2)
     .-011,-009,-036,-035,-021,-036,-018,-013,-038,-003, ! dx1(1:10,29, 2)
     .-011,-011,-035,-031,-010,-008,-018,-015,-027, 002, ! dx1(1:10,30, 2)
     .-023,-018,-027,-028,-018, 033,-021,-025,-009, 001, ! dx1(1:10,31, 2)
     .-024,-029,-026,-031,-021, 032,-029,-037,-025,-003, ! dx1(1:10,32, 2)
     . 003,-003,-007,-015,-005, 041,-020,-014, 011, 010, ! dx1(1:10,33, 2)
     .-007, 001, 006, 005,-001, 038,-016,-006, 028, 000, ! dx1(1:10,34, 2)
     .-001,-003, 029, 019, 004, 018,-020, 001, 029,-004, ! dx1(1:10,35, 2)
     . 011, 000, 035, 027, 005, 002,-022, 002, 018,-007, ! dx1(1:10,36, 2)
     .-016, 000, 078, 039, 009,-088,-030, 004, 003,-020, ! dx1(1:10,37, 2)
     . 014, 031, 110, 079, 035,-072,-013, 033, 014,-014, ! dx1(1:10,38, 2)
     .-044,-046,-124,-066,-019,-019,-034,-028,-042,-044, ! dx1(1:10, 1, 3)
     .-023,-006,-082,-069,-010, 002,-030,-014,-045,-029, ! dx1(1:10, 2, 3)
     .-024,-028,-065,-043,-011,-011,-017, 000,-034,-013, ! dx1(1:10, 3, 3)
     .-022,-015,-039,-037,-019,-017,-022,-013,-033,-020, ! dx1(1:10, 4, 3)
     .-011,-010,-021,-022,-018,-019,-013,-017,-027,-022, ! dx1(1:10, 5, 3)
     .-002, 005, 000, 000,-005,-012, 002,-017, 000,-009, ! dx1(1:10, 6, 3)
     .-006,-002, 020, 003,-003,-021, 005,-022,-003,-022, ! dx1(1:10, 7, 3)
     .-013,-040,-024,-031,-038,-050,-030,-061,-043,-059, ! dx1(1:10, 8, 3)
     .-032,-013, 014,-006,-020,-035,-015,-034,-011,-029, ! dx1(1:10, 9, 3)
     .-035,-024, 010,-009,-024,-033,-024,-031,-015,-029, ! dx1(1:10,10, 3)
     .-015,-007, 017, 002,-023,-028,-016,-024,-008,-019, ! dx1(1:10,11, 3)
     .-023,-009, 021, 001,-020,-021,-011,-020,-009,-020, ! dx1(1:10,12, 3)
     .-010,-004,-002,-013,-023,-026,-020,-039,-012,-014, ! dx1(1:10,13, 3)
     . 006, 003, 014, 008,-003,-003,-001,-021, 007,-005, ! dx1(1:10,14, 3)
     . 006, 010, 020, 010, 011, 004, 011,-016, 021, 001, ! dx1(1:10,15, 3)
     .-004, 003, 014, 015, 014, 005, 016,-009, 026, 000, ! dx1(1:10,16, 3)
     . 004, 008, 016, 020, 026, 016, 022,-006, 028, 009, ! dx1(1:10,17, 3)
     . 006, 004, 006, 016, 027, 018, 023, 001, 023, 005, ! dx1(1:10,18, 3)
     . 001, 020, 010, 012, 026, 026, 027, 009, 010, 020, ! dx1(1:10,19, 3)
     .-013, 004,-013, 000, 017, 018, 013,-007,-001, 012, ! dx1(1:10,20, 3)
     . 012, 000, 000, 011, 023, 023, 013, 006, 006, 001, ! dx1(1:10,21, 3)
     . 008, 015,-008, 012, 020, 017, 017, 008, 001, 014, ! dx1(1:10,22, 3)
     . 018, 012,-001, 013, 026, 022, 012, 018, 002, 015, ! dx1(1:10,23, 3)
     . 013, 022,-004, 006, 022, 013, 012, 025,-001, 012, ! dx1(1:10,24, 3)
     . 012, 009, 004,-003, 000,-002, 007, 019,-002, 011, ! dx1(1:10,25, 3)
     .-009, 000,-020,-016,-007,-020,-015, 002,-013, 003, ! dx1(1:10,26, 3)
     .-006,-020,-029,-030,-012,-033,-010,-008,-025,-005, ! dx1(1:10,27, 3)
     .-013,-014,-043,-029,-026,-042,-020,-015,-032,-004, ! dx1(1:10,28, 3)
     .-011,-011,-038,-035,-016,-031,-022,-020,-040, 002, ! dx1(1:10,29, 3)
     . 004,-018,-031,-028,-013,-003,-006,-010,-020, 010, ! dx1(1:10,30, 3)
     .-007,-016,-025,-022,-007, 044,-021,-024,-010, 001, ! dx1(1:10,31, 3)
     .-014,-017,-039,-025,-011, 038,-028,-024,-015, 003, ! dx1(1:10,32, 3)
     .-005,-014,-003,-015,-002, 052,-014,-013, 011, 001, ! dx1(1:10,33, 3)
     . 003,-001, 000, 000,-004, 031,-015,-010, 027, 000, ! dx1(1:10,34, 3)
     . 001, 004, 014, 003, 000, 025,-013,-002, 031,-006, ! dx1(1:10,35, 3)
     .-002, 000, 037, 027, 009, 002,-017,-002, 025,-007, ! dx1(1:10,36, 3)
     . 029, 017, 068, 040, 007,-076,-014, 002, 006,-025, ! dx1(1:10,37, 3)
     . 031, 018, 105, 061, 036,-079, 004, 017, 012, 001, ! dx1(1:10,38, 3)
     .-025,-023,-075,-057,-005, 000,-023,-012,-043, 007, ! dx1(1:10, 1, 4)
     .-031,-007,-072,-037, 004, 001,-011,-009,-027, 000, ! dx1(1:10, 2, 4)
     .-007,-001,-033,-033,-006,-007,-020,-009,-024,-014, ! dx1(1:10, 3, 4)
     .-004,-001,-018,-018,-005,-007,-004,-003,-017,-007, ! dx1(1:10, 4, 4)
     .-014, 000,-010,-001,-005,-013,-003,-018,-007,-012, ! dx1(1:10, 5, 4)
     . 003, 016, 012, 004, 010,-012, 008,-010, 001,-012, ! dx1(1:10, 6, 4)
     .-013, 007, 017,-001, 000,-010, 007,-023, 000,-020, ! dx1(1:10, 7, 4)
     .-052,-021,-010,-017,-033,-045,-023,-053,-025,-039, ! dx1(1:10, 8, 4)
     .-016,-010, 001,-010,-025,-031,-016,-036,-017,-033, ! dx1(1:10, 9, 4)
     .-019, 000, 021, 000,-018,-016,-009,-018,-008,-023, ! dx1(1:10,10, 4)
     .-023,-007, 008,-007,-024,-025,-017,-024,-017,-025, ! dx1(1:10,11, 4)
     . 006, 010, 022, 010,-007,-008, 001,-014, 001,-015, ! dx1(1:10,12, 4)
     .-044,-018,-006,-016,-030,-030,-023,-046,-022,-033, ! dx1(1:10,13, 4)
     .-004, 001, 016, 003,-012,-006, 000,-022, 001,-012, ! dx1(1:10,14, 4)
     . 000, 013, 013, 015, 016, 007, 014,-017, 017,-003, ! dx1(1:10,15, 4)
     . 006,-008,-002, 011, 004, 000, 007,-026, 017,-005, ! dx1(1:10,16, 4)
     .-008, 012, 005, 013, 017, 004, 016,-011, 027,-006, ! dx1(1:10,17, 4)
     .-009, 000, 007, 010, 026, 018, 024, 007, 023, 008, ! dx1(1:10,18, 4)
     .-018, 000, 002, 006, 026, 016, 021, 007, 010,-004, ! dx1(1:10,19, 4)
     .-004,-004,-008, 000, 018, 008, 012,-004,-011,-012, ! dx1(1:10,20, 4)
     . 001, 011, 000, 011, 021, 017, 015, 002, 009, 015, ! dx1(1:10,21, 4)
     . 002, 013,-005, 005, 018, 016, 008,-002, 000, 001, ! dx1(1:10,22, 4)
     . 014, 017,-007, 003, 015, 011, 014, 000, 002, 004, ! dx1(1:10,23, 4)
     . 016, 013, 009, 009, 014, 012, 012, 009, 002, 012, ! dx1(1:10,24, 4)
     . 012, 009,-016,-008,-003,-004, 000, 001,-001, 001, ! dx1(1:10,25, 4)
     .-002,-001,-019,-015,-017,-016,-011,-024,-022,-008, ! dx1(1:10,26, 4)
     .-006,-011,-029,-026,-016,-036,-015,-009,-021, 002, ! dx1(1:10,27, 4)
     .-011,-012,-040,-034,-027,-041,-019,-022,-039,-008, ! dx1(1:10,28, 4)
     . 001,-016,-042,-032,-022,-026,-019,-021,-028,-003, ! dx1(1:10,29, 4)
     .-005, 005,-029,-026, 002, 005,-007,-002,-017, 004, ! dx1(1:10,30, 4)
     .-002,-029,-034,-045,-027, 030,-019,-019,-014,-011, ! dx1(1:10,31, 4)
     .-009,-024,-034,-040,-021, 035,-026,-015,-018,-005, ! dx1(1:10,32, 4)
     .-007,-011,-012,-021,-007, 045,-013,-004, 012,-002, ! dx1(1:10,33, 4)
     . 004,-013,-002,-016,-009, 035,-016,-004, 021,-006, ! dx1(1:10,34, 4)
     . 005,-006, 011, 006,-002, 020,-019,-006, 024,-008, ! dx1(1:10,35, 4)
     .-005, 009, 023, 020, 004, 014,-007,-006, 024,-007, ! dx1(1:10,36, 4)
     . 010,-001, 064, 021, 004,-087,-024,-024, 000,-007, ! dx1(1:10,37, 4)
     . 055, 034, 090, 052, 028,-067, 005, 006, 030, 002, ! dx1(1:10,38, 4)
     .-025, 000,-056,-040, 018,-021,-020,-006,-009,-008, ! dx1(1:10, 1, 5)
     .-027, 003,-047,-017, 016, 007,-004,-003,-013, 002, ! dx1(1:10, 2, 5)
     .-006, 005,-009,-003, 010, 005, 000,-006,-009, 000, ! dx1(1:10, 3, 5)
     . 009, 012,-006, 005, 004, 005, 000,-006,-005, 004, ! dx1(1:10, 4, 5)
     . 001, 019, 006,-001,-003,-010, 000,-016,-007,-014, ! dx1(1:10, 5, 5)
     . 024, 027, 028, 019, 012, 001, 019,-012, 011,-002, ! dx1(1:10, 6, 5)
     . 008, 024, 031, 030, 009, 001, 018,-006, 014, 001, ! dx1(1:10, 7, 5)
     .-028,-014,-009,-017,-035,-042,-024,-058,-035,-054, ! dx1(1:10, 8, 5)
     .-017,-002, 017, 004,-009,-020, 003,-016,-002,-019, ! dx1(1:10, 9, 5)
     .-004,-004, 013,-004,-020,-022,-012,-015,-014,-021, ! dx1(1:10,10, 5)
     .-005,-004, 015, 000,-021,-022,-008,-018,-014,-022, ! dx1(1:10,11, 5)
     .-003, 003, 024, 002,-013,-001, 000,-015,-003,-010, ! dx1(1:10,12, 5)
     .-018,-016, 000,-012,-020,-023,-012,-038,-024,-018, ! dx1(1:10,13, 5)
     .-002, 018, 020, 011, 000, 006, 012,-020, 003,-001, ! dx1(1:10,14, 5)
     . 013, 003, 011, 007, 007, 003, 010,-014, 014,-004, ! dx1(1:10,15, 5)
     .-005, 009,-003, 002, 007,-003, 007,-018, 019,-020, ! dx1(1:10,16, 5)
     .-011,-013,-006, 002, 010, 007, 015,-004, 017,-001, ! dx1(1:10,17, 5)
     .-009,-004, 000, 005, 027, 014, 018, 015, 023,-002, ! dx1(1:10,18, 5)
     . 012, 004,-004, 003, 016, 015, 019, 014, 014,-003, ! dx1(1:10,19, 5)
     .-016,-010,-008,-008, 009, 009, 004,-006, 003, 003, ! dx1(1:10,20, 5)
     . 001, 008,-002, 002, 015, 012, 016, 000, 005,-001, ! dx1(1:10,21, 5)
     .-005, 006,-004, 007, 012, 010, 008,-001, 001, 005, ! dx1(1:10,22, 5)
     . 005, 015, 000,-002, 013, 009, 009,-010, 005, 009, ! dx1(1:10,23, 5)
     . 009, 012, 002, 006, 007, 006, 010,-007, 004, 007, ! dx1(1:10,24, 5)
     .-004, 000,-006, 000,-004,-005,-003,-010,-009, 003, ! dx1(1:10,25, 5)
     .-021,-016,-027,-029,-029,-031,-020,-031,-018,-015, ! dx1(1:10,26, 5)
     .-008,-005,-018,-015,-014,-030,-010,-018,-021,-007, ! dx1(1:10,27, 5)
     .-008,-011,-033,-032,-022,-040,-017,-015,-035,-002, ! dx1(1:10,28, 5)
     .-016,-009,-031,-024,-018,-020,-012,-004,-026, 004, ! dx1(1:10,29, 5)
     . 003,-004,-024,-016,-002, 008, 003, 005,-017, 011, ! dx1(1:10,30, 5)
     .-012,-006,-032,-028,-008, 038,-026,-002,-013,-006, ! dx1(1:10,31, 5)
     .-017,-014,-035,-035,-016, 041,-012,-002,-018,-003, ! dx1(1:10,32, 5)
     . 013, 001,-005,-026,-002, 051,-008, 009, 016, 002, ! dx1(1:10,33, 5)
     . 006,-007,-016,-020,-010, 040,-015,-002, 006,-008, ! dx1(1:10,34, 5)
     . 000, 002, 007,-007,-008, 021,-012,-007, 020,-010, ! dx1(1:10,35, 5)
     . 019, 008, 028, 004, 001, 006,-007,-007, 020,-005, ! dx1(1:10,36, 5)
     .-003,-005, 044, 016, 000,-088,-011,-019,-003,-018, ! dx1(1:10,37, 5)
     . 010, 026, 075, 062, 020,-077, 027, 014, 027, 011, ! dx1(1:10,38, 5)
     .-011,-029,-052,-018,-011,-006,-018, 008,-016, 000, ! dx1(1:10, 1, 6)
     .-008, 006,-029,-002, 017, 015, 002, 014,-004, 005, ! dx1(1:10, 2, 6)
     . 021, 021, 006, 010, 019, 014, 004, 002, 006, 016, ! dx1(1:10, 3, 6)
     . 004, 018, 022, 007, 016, 002, 003,-004, 002, 008, ! dx1(1:10, 4, 6)
     . 008, 013, 012, 015, 002, 000, 005,-022, 006,-009, ! dx1(1:10, 5, 6)
     . 006, 026, 031, 021, 015, 003, 015,-007, 010, 005, ! dx1(1:10, 6, 6)
     . 033, 042, 042, 027, 014, 009, 023,-001, 013,-004, ! dx1(1:10, 7, 6)
     .-016, 003,-001,-001,-020,-024,-008,-038,-018,-023, ! dx1(1:10, 8, 6)
     .-007, 002, 015, 003,-008,-012, 000,-012,-008,-023, ! dx1(1:10, 9, 6)
     .-012,-012, 003,-005,-017,-013,-001,-009,-011,-024, ! dx1(1:10,10, 6)
     .-005, 005, 013, 000,-012,-008, 001,-011,-001,-014, ! dx1(1:10,11, 6)
     . 002,-006, 011,-001,-017,-005, 000,-019,-009,-014, ! dx1(1:10,12, 6)
     .-012,-002,-002,-010,-017,-014,-008,-036,-009,-026, ! dx1(1:10,13, 6)
     .-007, 001, 016, 007,-006, 002, 007,-024, 001,-012, ! dx1(1:10,14, 6)
     . 001, 016, 008, 006, 004, 005, 011,-013, 008,-003, ! dx1(1:10,15, 6)
     .-005,-007,-009,-002,-002, 000, 005,-002, 017,-018, ! dx1(1:10,16, 6)
     .-005,-001,-006, 001, 014, 004, 012, 012, 021,-002, ! dx1(1:10,17, 6)
     .-011,-007,-004,-005, 005, 003, 011, 019, 014,-004, ! dx1(1:10,18, 6)
     . 008, 022, 014, 014, 030, 022, 020, 028, 025, 007, ! dx1(1:10,19, 6)
     . 000, 004,-003, 003, 021, 016, 017, 016, 009,-006, ! dx1(1:10,20, 6)
     . 002, 011, 004, 013, 025, 017, 015, 004, 014, 015, ! dx1(1:10,21, 6)
     . 000, 011,-002, 003, 015, 014, 013,-009, 002, 000, ! dx1(1:10,22, 6)
     . 009, 007,-001, 011, 011, 009, 014,-017, 004, 013, ! dx1(1:10,23, 6)
     . 005, 012, 000, 009, 011, 005, 010,-014, 009, 008, ! dx1(1:10,24, 6)
     . 002, 004,-007,-016,-011,-025,-006,-021,-005,-003, ! dx1(1:10,25, 6)
     .-007,-004,-021,-014,-020,-026,-016,-035,-018,-002, ! dx1(1:10,26, 6)
     .-005,-015,-016,-015,-018,-030,-010,-012,-014, 001, ! dx1(1:10,27, 6)
     .-005,-007,-020,-018,-005,-032,-012,-001,-019,-003, ! dx1(1:10,28, 6)
     . 005,-006,-028,-020,-013,-020,-009, 001,-014, 001, ! dx1(1:10,29, 6)
     . 007,-003,-023,-021,-001, 016,-006, 016,-010, 004, ! dx1(1:10,30, 6)
     .-005,-014,-029,-028,-012, 041,-008, 008,-013,-007, ! dx1(1:10,31, 6)
     . 013,-022,-021,-028,-012, 043,-010, 017,-007, 000, ! dx1(1:10,32, 6)
     .-002, 003,-015,-024, 000, 057,-006, 027, 005, 004, ! dx1(1:10,33, 6)
     . 000,-019,-011,-035,-015, 036,-017,-002, 001,-015, ! dx1(1:10,34, 6)
     . 008,-006, 000,-019,-005, 022,-016,-009, 009, 001, ! dx1(1:10,35, 6)
     . 018, 001, 022, 013, 006, 013,-001,-003, 017,-007, ! dx1(1:10,36, 6)
     . 013, 003, 036, 011, 000,-075,-010,-018,-009,-007, ! dx1(1:10,37, 6)
     . 033, 035, 071, 051, 028,-066, 024, 002, 004, 022, ! dx1(1:10,38, 6)
     .-011, 021,-028, 003, 017, 009, 006, 029,-002,-006, ! dx1(1:10, 1, 7)
     . 016, 017,-021, 009, 030, 018, 009, 036, 005, 008, ! dx1(1:10, 2, 7)
     . 020, 026, 029, 024, 032, 027, 016, 017, 018, 020, ! dx1(1:10, 3, 7)
     . 032, 033, 030, 032, 024, 021, 020, 001, 021, 021, ! dx1(1:10, 4, 7)
     . 007, 015, 030, 018, 010, 009, 012,-014, 012, 003, ! dx1(1:10, 5, 7)
     . 026, 043, 042, 030, 026, 017, 026, 000, 023, 010, ! dx1(1:10, 6, 7)
     . 028, 027, 039, 036, 022, 010, 030, 007, 022, 008, ! dx1(1:10, 7, 7)
     .-008,-005,-003,-008,-020,-023,-013,-029,-019,-026, ! dx1(1:10, 8, 7)
     .-005, 004, 002, 000,-009,-012, 004,-012,-007,-021, ! dx1(1:10, 9, 7)
     .-015, 003, 002,-003,-013,-015,-001,-006,-009,-013, ! dx1(1:10,10, 7)
     . 004,-003, 001, 000,-017,-006, 000,-018,-011,-018, ! dx1(1:10,11, 7)
     . 005, 009, 014,-002,-006, 001, 007,-018, 000,-009, ! dx1(1:10,12, 7)
     .-021,-019,-016,-015,-029,-012,-012,-036,-026,-028, ! dx1(1:10,13, 7)
     . 025, 018, 008, 012,-002, 007, 011,-017, 002,-004, ! dx1(1:10,14, 7)
     . 000,-002, 000, 002, 001, 005, 008,-011, 007,-001, ! dx1(1:10,15, 7)
     .-007, 003,-011,-005,-003,-002, 003, 000, 012,-012, ! dx1(1:10,16, 7)
     .-002,-007,-003, 000, 011, 007, 010, 020, 019,-011, ! dx1(1:10,17, 7)
     .-002, 007, 001, 008, 024, 014, 021, 034, 028, 003, ! dx1(1:10,18, 7)
     . 003,-003, 002, 003, 017, 013, 009, 035, 015, 006, ! dx1(1:10,19, 7)
     . 000,-009,-004, 006, 011, 008, 008, 023, 012, 008, ! dx1(1:10,20, 7)
     . 011, 006, 009, 013, 023, 015, 015, 009, 010, 010, ! dx1(1:10,21, 7)
     .-005, 001, 000, 008, 014, 009, 012,-013, 009, 011, ! dx1(1:10,22, 7)
     . 008, 008, 003, 011, 009, 008, 010,-017, 007, 002, ! dx1(1:10,23, 7)
     . 006, 006, 008, 010, 008, 002, 017,-016, 014, 009, ! dx1(1:10,24, 7)
     . 006,-001,-003, 007,-001,-006, 002,-014, 012, 014, ! dx1(1:10,25, 7)
     .-013,-010,-019,-015,-009,-021,-005,-023, 000, 000, ! dx1(1:10,26, 7)
     .-010,-009,-012,-008,-012,-026,-004,-005,-005, 000, ! dx1(1:10,27, 7)
     . 001,-011,-014,-012,-007,-023,-006, 007,-007, 008, ! dx1(1:10,28, 7)
     .-004,-010,-018,-014,-007,-014,-005, 011,-012, 003, ! dx1(1:10,29, 7)
     .-009,-010,-012,-017, 000, 017,-004, 029,-004, 006, ! dx1(1:10,30, 7)
     . 000,-015,-030,-014,-005, 041,-006, 027,-006, 001, ! dx1(1:10,31, 7)
     .-016,-027,-024,-031,-004, 044,-012, 033,-004,-004, ! dx1(1:10,32, 7)
     .-001,-011,-029,-023,-005, 043,-013, 025,-007,-002, ! dx1(1:10,33, 7)
     .-004,-014,-012,-024,-006, 035,-006, 012, 001, 000, ! dx1(1:10,34, 7)
     . 026, 000,-005,-006,-003, 031,-008,-005, 002,-006, ! dx1(1:10,35, 7)
     . 006, 009, 021, 003, 004, 011, 000, 000, 007, 002, ! dx1(1:10,36, 7)
     .-007,-015, 030, 016, 000,-080,-004,-020,-010,-013, ! dx1(1:10,37, 7)
     . 042, 033, 065, 040, 022,-066, 016, 003, 012, 008, ! dx1(1:10,38, 7)
     . 005, 002,-008, 012, 043, 012,-010, 048, 008,-004, ! dx1(1:10, 1, 8)
     . 016, 010, 011, 031, 032, 016, 017, 040, 018, 032, ! dx1(1:10, 2, 8)
     . 038, 057, 049, 055, 055, 046, 037, 045, 041, 050, ! dx1(1:10, 3, 8)
     . 009, 026, 048, 032, 028, 025, 023, 011, 025, 027, ! dx1(1:10, 4, 8)
     . 035, 039, 048, 039, 030, 024, 019, 007, 025, 016, ! dx1(1:10, 5, 8)
     . 044, 043, 058, 047, 033, 022, 034, 015, 029, 032, ! dx1(1:10, 6, 8)
     . 018, 033, 044, 037, 028, 031, 041, 028, 030, 030, ! dx1(1:10, 7, 8)
     .-012,-002, 004, 000,-005,-012,-005,-009,-009,-019, ! dx1(1:10, 8, 8)
     .-003, 000, 002, 004,-007,-004, 005, 001, 002,-006, ! dx1(1:10, 9, 8)
     . 001,-006,-004,-003,-014, 001,-002,-011,-003,-016, ! dx1(1:10,10, 8)
     . 012, 008, 004,-001,-011,-002, 006,-024, 002,-005, ! dx1(1:10,11, 8)
     .-001, 006, 007, 008,-011, 009, 010,-025, 000, 004, ! dx1(1:10,12, 8)
     . 028, 004, 000,-008,-019,-005,-003,-030,-005,-014, ! dx1(1:10,13, 8)
     . 004, 004, 004, 008,-006, 014, 013,-012, 005, 006, ! dx1(1:10,14, 8)
     . 014, 016, 001, 003, 001, 005, 010,-005, 011, 003, ! dx1(1:10,15, 8)
     . 004, 004,-007,-005, 000,-002, 002, 003, 008,-008, ! dx1(1:10,16, 8)
     . 017, 014,-003, 009, 010,-002, 011, 025, 015, 011, ! dx1(1:10,17, 8)
     . 010, 003, 012, 012, 022, 012, 019, 052, 026, 006, ! dx1(1:10,18, 8)
     .-021,-003, 000, 012, 018, 010, 015, 030, 007, 006, ! dx1(1:10,19, 8)
     .-010, 001,-004, 004, 011,-002, 007, 023, 004,-006, ! dx1(1:10,20, 8)
     .-002,-003, 002, 003, 009, 004, 009, 004, 008, 003, ! dx1(1:10,21, 8)
     .-003,-007, 000, 005, 011, 007, 008, 000, 003, 010, ! dx1(1:10,22, 8)
     . 014, 002, 005, 021, 014, 009, 016,-008, 014, 016, ! dx1(1:10,23, 8)
     . 006,-008, 001, 016, 005, 008, 010,-006, 017, 015, ! dx1(1:10,24, 8)
     . 004, 000, 002, 011, 002,-021, 016,-002, 015, 011, ! dx1(1:10,25, 8)
     . 013,-003, 003, 020,-004,-011, 008,-002, 017, 016, ! dx1(1:10,26, 8)
     .-017,-035,-016,-015,-011,-028,-005, 002,-001, 000, ! dx1(1:10,27, 8)
     .-020,-022,-015,-013,-008,-030,-007, 002,-008, 000, ! dx1(1:10,28, 8)
     . 001,-012,-010,-017,-007,-015,-007, 021, 002, 007, ! dx1(1:10,29, 8)
     . 007, 004,-004,-009, 013, 017, 002, 044, 005, 015, ! dx1(1:10,30, 8)
     .-011,-012,-021,-027, 001, 044,-015, 038,-004, 003, ! dx1(1:10,31, 8)
     .-002,-016,-028,-019,-004, 039,-023, 030, 000,-003, ! dx1(1:10,32, 8)
     . 007,-002,-011,-017, 005, 066, 002, 040,-001, 014, ! dx1(1:10,33, 8)
     . 002,-006,-017,-012,-004, 037,-004, 018,-011, 001, ! dx1(1:10,34, 8)
     . 011,-008, 003,-013,-003, 031, 000, 011,-012, 003, ! dx1(1:10,35, 8)
     . 026, 008, 015, 016, 007, 024, 009, 005,-006, 009, ! dx1(1:10,36, 8)
     . 015, 020, 038, 011, 005,-075, 004,-012,-011, 007, ! dx1(1:10,37, 8)
     . 040, 017, 051, 040, 012,-057, 020, 002,-001, 026, ! dx1(1:10,38, 8)
     .-031,-047,-009, 008, 018,-009,-005, 030, 022, 001, ! dx1(1:10, 1, 9)
     .-006,-010,-045,-015,-010,-028,-027, 004,-029,-033, ! dx1(1:10, 2, 9)
     . 010, 000, 016, 013, 009, 002,-004,-008, 000, 003, ! dx1(1:10, 3, 9)
     . 000, 000, 004, 012, 002,-005,-011,-017,-010,-010, ! dx1(1:10, 4, 9)
     .-022,-003, 006,-001,-015,-012,-017,-041,-016,-014, ! dx1(1:10, 5, 9)
     . 011, 007, 027, 010,-002,-008, 000,-019,-002,-006, ! dx1(1:10, 6, 9)
     .-018, 009, 011, 014, 010,-003, 009,-004, 002,-006, ! dx1(1:10, 7, 9)
     .-018, 000,-004,-010,-014,-024,-009,-018,-019,-033, ! dx1(1:10, 8, 9)
     . 000,-006,-001,-003,-013,-012, 000,-006,-004,-009, ! dx1(1:10, 9, 9)
     .-006,-003,-005,-013,-018,-005,-001,-009,-003,-018, ! dx1(1:10,10, 9)
     . 006, 008, 000,-001,-015,-008, 004,-028,-007,-008, ! dx1(1:10,11, 9)
     . 022, 010, 012, 006,-008, 012, 012,-025, 011,-001, ! dx1(1:10,12, 9)
     .-005, 006,-007,-015,-017,-015,-003,-036,-016,-014, ! dx1(1:10,13, 9)
     .-011,-002,-015,-011,-025,-013,-014,-035,-018,-014, ! dx1(1:10,14, 9)
     .-012,-018,-020,-021,-026,-013,-015,-028,-017,-027, ! dx1(1:10,15, 9)
     .-013,-017,-026,-019,-017,-018,-015,-012,-010,-022, ! dx1(1:10,16, 9)
     .-001,-006,-013,-008, 000,-013,-004, 012,-002,-005, ! dx1(1:10,17, 9)
     .-008,-008,-006, 001, 008,-002, 004, 031, 004,-001, ! dx1(1:10,18, 9)
     .-023,-023,-018,-012, 000,-004, 000, 021, 000, 000, ! dx1(1:10,19, 9)
     .-012,-017,-023,-011,-006,-010,-006, 004,-013,-013, ! dx1(1:10,20, 9)
     .-022,-013,-004,-009, 000,-010,-001,-002,-002,-005, ! dx1(1:10,21, 9)
     .-012,-009,-006, 010, 005,-003, 006,-009, 003,-001, ! dx1(1:10,22, 9)
     .-007,-011, 000, 009, 004, 000, 003,-013, 005, 011, ! dx1(1:10,23, 9)
     .-011,-013,-004, 011, 003, 001, 014,-013, 008, 005, ! dx1(1:10,24, 9)
     . 008,-021,-003, 002,-009,-018, 003,-002, 009, 003, ! dx1(1:10,25, 9)
     .-060,-045,-050,-032,-050,-059,-037,-039,-024,-042, ! dx1(1:10,26, 9)
     .-021,-051,-035,-030,-035,-047,-029,-026,-025,-015, ! dx1(1:10,27, 9)
     .-052,-048,-046,-039,-033,-058,-029,-016,-030,-039, ! dx1(1:10,28, 9)
     .-017,-041,-033,-033,-028,-034,-030, 001,-030,-021, ! dx1(1:10,29, 9)
     .-021,-026,-026,-033,-015,-008,-028, 019,-017,-008, ! dx1(1:10,30, 9)
     .-027,-031,-038,-047,-018, 028,-029, 019,-022,-029, ! dx1(1:10,31, 9)
     . 000,-030,-038,-024,-005, 040,-013, 031,-007,-002, ! dx1(1:10,32, 9)
     . 010, 008,-004,-015, 015, 063, 002, 041, 002, 015, ! dx1(1:10,33, 9)
     . 006,-006,-003, 002, 013, 048, 001, 031, 000, 014, ! dx1(1:10,34, 9)
     . 018, 001, 007, 009, 003, 041, 006, 016,-007, 003, ! dx1(1:10,35, 9)
     . 032, 017, 034, 022, 021, 038, 020, 010, 007, 021, ! dx1(1:10,36, 9)
     . 004, 023, 061, 030, 024,-063, 020, 003,-001, 010, ! dx1(1:10,37, 9)
     . 027,-028, 009,-001,-020,-122,-022,-032,-041,-011, ! dx1(1:10,38, 9)
     . 004,-009,-014, 012, 009, 003,-002, 029,-009, 010, ! dx1(1:10, 1,10)
     .-022,-014,-012, 009, 010, 000,-006, 025,-005, 000, ! dx1(1:10, 2,10)
     .-021, 000, 010, 018, 013, 005,-006, 002,-004,-001, ! dx1(1:10, 3,10)
     . 010, 018, 018, 024, 011, 008, 000, 006, 005, 005, ! dx1(1:10, 4,10)
     .-013,-013, 012, 014, 000,-005,-008,-005,-007,-001, ! dx1(1:10, 5,10)
     . 000, 017, 024, 019, 018, 012, 013, 004, 012, 011, ! dx1(1:10, 6,10)
     . 027, 025, 034, 021, 017, 012, 026, 024, 027, 014, ! dx1(1:10, 7,10)
     .-001, 003, 006, 001, 001, 003, 002, 003, 009, 000, ! dx1(1:10, 8,10)
     . 009, 016, 004, 001,-001, 007, 010,-004, 011, 005, ! dx1(1:10, 9,10)
     . 015, 008, 001, 007,-005, 009, 007,-014, 008, 003, ! dx1(1:10,10,10)
     . 020, 022, 005, 006,-005, 011, 005,-021, 006, 002, ! dx1(1:10,11,10)
     . 023, 026, 013, 007,-001, 007, 011,-030, 010, 002, ! dx1(1:10,12,10)
     . 017, 006,-003, 002,-012, 003, 002,-033, 009,-006, ! dx1(1:10,13,10)
     . 008, 002,-013,-010,-021,-012,-005,-039,-007,-009, ! dx1(1:10,14,10)
     . 000,-004,-010,-007,-012,-006,-006,-021,-003,-003, ! dx1(1:10,15,10)
     . 000,-010,-014,-009,-010,-016,-008,-013,-010,-011, ! dx1(1:10,16,10)
     .-006,-008,-011, 001, 000,-006, 000, 012,-004,-002, ! dx1(1:10,17,10)
     . 002,-004,-006, 000, 002,-010,-002, 022,-007,-004, ! dx1(1:10,18,10)
     .-003,-006,-002, 008, 014, 000, 009, 019,-002, 002, ! dx1(1:10,19,10)
     .-020,-018,-011,-010,-003,-021,-013, 005,-007,-009, ! dx1(1:10,20,10)
     .-003,-005,-001, 007, 007, 006, 006, 003,-004, 003, ! dx1(1:10,21,10)
     .-007,-004, 009, 004, 004,-003, 008, 000, 002, 002, ! dx1(1:10,22,10)
     .-010,-015, 000, 006, 000,-004, 010,-002, 001, 004, ! dx1(1:10,23,10)
     . 001,-003, 015, 015, 000,-007, 014, 008, 013, 007, ! dx1(1:10,24,10)
     .-004,-008, 009, 011, 013,-010, 022, 022, 025, 018, ! dx1(1:10,25,10)
     .-044,-058,-040,-028,-041,-058,-032,-028,-028,-036, ! dx1(1:10,26,10)
     .-036,-051,-033,-025,-035,-053,-026,-006,-020,-027, ! dx1(1:10,27,10)
     .-025,-051,-033,-028,-029,-049,-026, 003,-021,-018, ! dx1(1:10,28,10)
     .-039,-043,-029,-024,-023,-030,-024, 008,-006,-017, ! dx1(1:10,29,10)
     .-022,-021,-018,-018,-010, 002,-019, 021, 004,-011, ! dx1(1:10,30,10)
     .-024,-037,-030,-032,-013, 014,-028, 008,-014,-013, ! dx1(1:10,31,10)
     . 003, 004,-002,-014, 017, 057,-005, 034, 018, 009, ! dx1(1:10,32,10)
     . 023, 019,-003, 000, 020, 056, 008, 044, 009, 008, ! dx1(1:10,33,10)
     . 011, 006, 001,-010, 012, 043, 000, 027,-007, 005, ! dx1(1:10,34,10)
     . 008, 024, 013, 006, 017, 034, 011, 022,-001, 013, ! dx1(1:10,35,10)
     . 036, 021, 032, 019, 023, 029, 023, 020, 000, 021, ! dx1(1:10,36,10)
     . 021, 024, 053, 031, 013,-057, 016, 007,-013, 008, ! dx1(1:10,37,10)
     .-029,-010, 014,-011,-018,-102,-017,-036,-056,-033, ! dx1(1:10,38,10)
     .-052,-004, 002, 021, 019, 004,-015, 035,-003, 002, ! dx1(1:10, 1,11)
     .-031,-022,-012, 000, 000,-003,-014, 020,-017,-011, ! dx1(1:10, 2,11)
     .-004, 000, 008, 012, 011, 013,-007, 009, 003, 006, ! dx1(1:10, 3,11)
     .-013, 002, 017, 019, 018, 014,-001, 012, 006, 009, ! dx1(1:10, 4,11)
     .-003, 010, 007, 002, 004, 000,-004, 010, 001,-001, ! dx1(1:10, 5,11)
     . 021, 012, 029, 025, 018, 016, 017, 025, 013, 023, ! dx1(1:10, 6,11)
     . 018, 031, 027, 021, 023, 025, 031, 036, 033, 024, ! dx1(1:10, 7,11)
     . 012, 003, 012, 006, 003, 007, 011, 015, 011, 005, ! dx1(1:10, 8,11)
     . 008, 009,-001, 000, 000, 010, 009,-004, 014, 000, ! dx1(1:10, 9,11)
     . 019, 017, 000, 000, 001, 014, 010,-015, 017, 008, ! dx1(1:10,10,11)
     . 022, 027, 000, 001,-006, 007, 003,-027, 009, 000, ! dx1(1:10,11,11)
     . 031, 022, 007, 010,-001, 015, 010,-028, 019, 012, ! dx1(1:10,12,11)
     . 006, 027, 006, 008, 002, 005, 010,-023, 011, 006, ! dx1(1:10,13,11)
     . 030, 008,-006,-001,-007,-003,-006,-035, 003, 000, ! dx1(1:10,14,11)
     . 007,-006,-006,-001,-007,-004,-003,-026,-003,-005, ! dx1(1:10,15,11)
     . 012,-005,-002,-007, 001,-007,-004,-005, 000, 007, ! dx1(1:10,16,11)
     . 003,-002,-007,-001, 000,-005, 000, 008,-011, 004, ! dx1(1:10,17,11)
     . 001,-002, 000, 003, 013,-004, 007, 022, 001, 006, ! dx1(1:10,18,11)
     .-008,-008,-002, 002, 007,-006, 000, 015,-008, 009, ! dx1(1:10,19,11)
     .-025,-010,-008,-009, 001,-011, 003, 005,-013,-011, ! dx1(1:10,20,11)
     . 001, 000, 004, 010, 007,-004, 009, 006, 000, 004, ! dx1(1:10,21,11)
     .-002,-006, 007, 010, 009, 001, 018, 006, 002, 007, ! dx1(1:10,22,11)
     .-009, 001, 015, 012, 004,-003, 018, 011, 010, 012, ! dx1(1:10,23,11)
     .-005, 005, 015, 015, 011,-008, 028, 016, 018, 010, ! dx1(1:10,24,11)
     . 006,-002, 026, 019, 005,-001, 021, 040, 015, 010, ! dx1(1:10,25,11)
     .-048,-039,-027,-027,-036,-052,-022,-004,-023,-041, ! dx1(1:10,26,11)
     .-041,-054,-027,-020,-032,-055,-023, 001,-022,-026, ! dx1(1:10,27,11)
     .-043,-048,-031,-023,-026,-055,-024, 002,-014,-030, ! dx1(1:10,28,11)
     .-018,-032,-017,-018,-015,-026,-021, 014,-001,-014, ! dx1(1:10,29,11)
     .-014,-031,-011,-015,-005, 001,-012, 017, 008,-010, ! dx1(1:10,30,11)
     .-019,-016,-024,-027,-006, 030,-026, 006, 000,-005, ! dx1(1:10,31,11)
     .-019,-003,-001,-008, 015, 049,-005, 030, 023, 003, ! dx1(1:10,32,11)
     . 020, 019, 005, 003, 030, 063, 016, 038, 016, 023, ! dx1(1:10,33,11)
     . 022, 018, 005, 005, 024, 048, 011, 034, 006, 014, ! dx1(1:10,34,11)
     . 021, 007, 012, 011, 020, 028, 011, 029, 002, 017, ! dx1(1:10,35,11)
     . 028, 026, 037, 022, 023, 026, 022, 026, 000, 015, ! dx1(1:10,36,11)
     . 037, 038, 047, 023, 011,-059, 013, 000,-021, 008, ! dx1(1:10,37,11)
     .-025,-027, 020,-011,-026,-115,-024,-032,-055,-027, ! dx1(1:10,38,11)
     .-014,-029,-011, 005, 000,-007,-008, 038,-007, 000, ! dx1(1:10, 1,12)
     .-005,-030,-008, 003, 002, 000,-016, 026,-011,-003, ! dx1(1:10, 2,12)
     .-013, 001, 008, 020, 010, 012, 000, 016, 002, 005, ! dx1(1:10, 3,12)
     . 005, 012, 022, 027, 015, 022, 006, 037, 014, 016, ! dx1(1:10, 4,12)
     . 002, 001, 009, 016, 008, 010, 000, 028,-009, 014, ! dx1(1:10, 5,12)
     . 033, 029, 028, 028, 023, 021, 019, 034, 025, 015, ! dx1(1:10, 6,12)
     . 013, 010, 009, 009, 022, 018, 019, 028, 024, 024, ! dx1(1:10, 7,12)
     . 016, 011, 001, 007, 010, 007, 013, 024, 007, 014, ! dx1(1:10, 8,12)
     . 010, 019, 008, 002, 000, 012, 009, 002, 015, 019, ! dx1(1:10, 9,12)
     . 011, 020, 000, 002,-001, 012, 009,-017, 010, 010, ! dx1(1:10,10,12)
     . 018, 015,-012,-008,-011, 003,-004,-040, 001, 000, ! dx1(1:10,11,12)
     . 009, 012,-005, 002,-006, 005, 005,-030, 019, 002, ! dx1(1:10,12,12)
     . 026, 012, 000, 008,-003, 001,-002,-033, 013, 010, ! dx1(1:10,13,12)
     . 004, 003,-003,-001,-008,-009,-008,-038, 003,-005, ! dx1(1:10,14,12)
     . 011, 000,-010, 000,-003,-004,-007,-027, 003, 008, ! dx1(1:10,15,12)
     . 006, 003,-001, 000, 003,-001,-003,-008,-008,-001, ! dx1(1:10,16,12)
     . 005,-010,-007, 000, 005,-005,-003, 004,-010, 011, ! dx1(1:10,17,12)
     . 005,-002,-002, 004, 007,-002, 001, 013,-004, 008, ! dx1(1:10,18,12)
     . 000, 004, 009, 011, 017,-001, 007, 012,-004, 008, ! dx1(1:10,19,12)
     . 001,-002,-005, 005, 003,-010, 000, 005,-018, 004, ! dx1(1:10,20,12)
     . 003,-003, 008, 013, 012, 003, 017, 010, 000, 008, ! dx1(1:10,21,12)
     . 000, 010, 012, 013, 005,-005, 015, 011, 000, 001, ! dx1(1:10,22,12)
     . 004, 002, 025, 021, 015, 003, 028, 018, 005, 014, ! dx1(1:10,23,12)
     . 010, 009, 025, 024, 011, 002, 030, 033, 013, 017, ! dx1(1:10,24,12)
     . 020, 000, 035, 023, 011,-005, 026, 048, 018, 012, ! dx1(1:10,25,12)
     .-032,-045,-014,-016,-036,-046,-019, 005,-022,-030, ! dx1(1:10,26,12)
     .-029,-047,-014,-010,-026,-044,-014, 016,-010,-019, ! dx1(1:10,27,12)
     .-025,-043,-012,-009,-017,-038,-018, 013,-009,-018, ! dx1(1:10,28,12)
     .-019,-033,-021,-006,-017,-022,-014, 010,-001,-012, ! dx1(1:10,29,12)
     .-011,-022,-006,-004, 000, 003,-013, 009, 016,-010, ! dx1(1:10,30,12)
     .-021,-026,-023,-024,-008, 024,-025,-002, 000,-013, ! dx1(1:10,31,12)
     . 012,-005, 000, 000, 015, 055,-002, 019, 024, 018, ! dx1(1:10,32,12)
     . 012, 019, 008, 011, 032, 053, 010, 035, 020, 017, ! dx1(1:10,33,12)
     . 041, 025, 010, 006, 029, 044, 013, 027, 013, 020, ! dx1(1:10,34,12)
     . 013, 028, 015, 009, 021, 027, 010, 027, 000, 015, ! dx1(1:10,35,12)
     . 035, 031, 030, 015, 018, 017, 015, 027,-002, 022, ! dx1(1:10,36,12)
     . 009, 022, 031, 012, 001,-068, 004, 002,-033,-003, ! dx1(1:10,37,12)
     .-012,-005,-009,-018,-042,-117,-033,-039,-066,-024, ! dx1(1:10,38,12)
     .-053,-031, 000, 003, 000, 003,-012, 036,-018,-007, ! dx1(1:10, 1,13)
     .-068,-028,-002, 011,-001,-002,-014, 030,-004,-017, ! dx1(1:10, 2,13)
     .-005,-019, 008, 017, 008, 008,-007, 027, 001, 018, ! dx1(1:10, 3,13)
     . 011, 024, 023, 034, 025, 022, 013, 045, 010, 022, ! dx1(1:10, 4,13)
     . 000, 001, 015, 015, 013, 016, 001, 036, 004, 007, ! dx1(1:10, 5,13)
     . 016, 030, 019, 022, 030, 032, 021, 049, 021, 032, ! dx1(1:10, 6,13)
     . 023, 031, 013, 017, 018, 020, 022, 035, 019, 016, ! dx1(1:10, 7,13)
     .-005,-001,-009,-004,-005, 000,-003, 007, 000, 001, ! dx1(1:10, 8,13)
     . 027, 024,-002, 001, 005, 015, 015, 007, 013, 011, ! dx1(1:10, 9,13)
     . 022, 026, 000, 003,-001, 017, 009,-013, 015, 012, ! dx1(1:10,10,13)
     . 012, 021,-014, 002,-009, 006,-004,-030, 007, 011, ! dx1(1:10,11,13)
     . 023, 006,-008,-002,-008, 010,-002,-037, 014, 013, ! dx1(1:10,12,13)
     . 002, 014,-002, 005,-003, 003,-002,-032, 008, 008, ! dx1(1:10,13,13)
     . 030, 001,-010, 001,-010, 004,-012,-038, 008, 010, ! dx1(1:10,14,13)
     . 020, 009,-001, 004, 005,-001,-003,-021, 009, 009, ! dx1(1:10,15,13)
     . 010, 000,-009,-002,-005,-012,-013,-014,-005, 011, ! dx1(1:10,16,13)
     . 016, 002,-005, 005, 006,-010,-007, 000,-009, 007, ! dx1(1:10,17,13)
     .-001,-006, 000, 008, 012,-007, 003, 010,-005, 016, ! dx1(1:10,18,13)
     .-012, 004, 004, 008, 015,-002, 004, 013,-006, 012, ! dx1(1:10,19,13)
     .-001,-008,-005, 003, 004,-013,-004, 001,-020, 005, ! dx1(1:10,20,13)
     . 007, 017, 023, 023, 018, 002, 022, 023, 007, 017, ! dx1(1:10,21,13)
     .-002, 005, 018, 010, 011,-001, 027, 012,-001, 009, ! dx1(1:10,22,13)
     . 004, 007, 026, 017, 009, 001, 026, 027, 011, 008, ! dx1(1:10,23,13)
     . 009, 011, 038, 022, 017, 006, 040, 041, 018, 011, ! dx1(1:10,24,13)
     . 000, 004, 024, 020, 004,-002, 025, 053, 017, 000, ! dx1(1:10,25,13)
     .-024,-029,-009,-019,-035,-047,-018, 012,-024,-030, ! dx1(1:10,26,13)
     .-035,-029,-004,-002,-014,-038,-006, 018,-012,-019, ! dx1(1:10,27,13)
     .-023,-034,-015,-009,-022,-040,-014, 010,-008,-019, ! dx1(1:10,28,13)
     .-008,-028,-006, 003,-013,-025,-017, 003, 001,-011, ! dx1(1:10,29,13)
     .-006,-015,-009,-001, 001, 003,-009, 008, 014,-005, ! dx1(1:10,30,13)
     .-018,-017,-016,-024,-006, 022,-024,-017, 004,-005, ! dx1(1:10,31,13)
     . 022, 015, 011, 009, 028, 053, 002, 019, 039, 014, ! dx1(1:10,32,13)
     . 018, 024, 015, 009, 030, 057, 011, 027, 030, 025, ! dx1(1:10,33,13)
     . 027, 021, 011, 006, 024, 042, 011, 024, 016, 012, ! dx1(1:10,34,13)
     . 021, 024, 005, 007, 024, 025, 009, 018, 001, 008, ! dx1(1:10,35,13)
     . 033, 033, 021, 011, 016, 011, 018, 023,-002, 018, ! dx1(1:10,36,13)
     . 019, 029, 033, 018,-003,-075, 000, 007,-034,-008, ! dx1(1:10,37,13)
     .-038,-020,-012,-029,-035,-127,-037,-033,-076,-032, ! dx1(1:10,38,13)
     .-037,-044,-009, 003,-012,-013,-022, 026,-010,-011, ! dx1(1:10, 1,14)
     .-049,-043,-005, 013,-003,-003,-013, 030,-008,-013, ! dx1(1:10, 2,14)
     .-021,-002, 022, 024, 009, 015, 005, 038, 012, 007, ! dx1(1:10, 3,14)
     . 012, 006, 021, 040, 024, 028, 015, 050, 015, 020, ! dx1(1:10, 4,14)
     . 011, 025, 021, 029, 027, 022, 017, 051, 008, 024, ! dx1(1:10, 5,14)
     . 015, 038, 029, 036, 033, 034, 028, 063, 026, 026, ! dx1(1:10, 6,14)
     . 013, 023, 010, 016, 020, 025, 024, 038, 017, 028, ! dx1(1:10, 7,14)
     .-001, 018, 001, 002, 003, 011, 011, 024, 004, 010, ! dx1(1:10, 8,14)
     . 008, 017,-011,-003,-003, 008, 007,-003, 004, 016, ! dx1(1:10, 9,14)
     . 010, 013,-009,-007,-004, 018, 002,-010, 010, 015, ! dx1(1:10,10,14)
     . 027, 016,-006, 003,-003, 017, 002,-024, 013, 022, ! dx1(1:10,11,14)
     . 012, 013,-013,-006,-015, 007,-011,-039, 008, 005, ! dx1(1:10,12,14)
     . 021,-003,-010, 007,-001, 004,-007,-035, 018, 020, ! dx1(1:10,13,14)
     .-005, 005,-010, 004,-006, 005,-007,-037, 012, 010, ! dx1(1:10,14,14)
     . 021, 001,-011, 003,-001,-007,-015,-022, 009, 007, ! dx1(1:10,15,14)
     . 012, 002,-010,-001, 009,-002,-007,-002,-004, 007, ! dx1(1:10,16,14)
     .-001, 001,-008, 003, 005,-013,-016,-004,-012, 011, ! dx1(1:10,17,14)
     . 015, 001, 001, 003, 012,-008, 001, 005,-012, 009, ! dx1(1:10,18,14)
     . 002, 007, 006, 011, 007,-002, 006, 014,-002, 014, ! dx1(1:10,19,14)
     . 009, 007, 009, 011, 016, 002, 010, 013,-003, 015, ! dx1(1:10,20,14)
     . 005, 008, 018, 014, 013,-001, 022, 023, 000, 007, ! dx1(1:10,21,14)
     . 015, 007, 025, 018, 013, 003, 023, 024, 014, 016, ! dx1(1:10,22,14)
     . 016, 025, 047, 029, 021, 014, 047, 035, 018, 017, ! dx1(1:10,23,14)
     . 011, 020, 045, 024, 015, 010, 040, 045, 022, 018, ! dx1(1:10,24,14)
     .-013,-011, 013, 004,-018,-021, 005, 035,-008,-004, ! dx1(1:10,25,14)
     .-054,-042,-015,-021,-044,-049,-017, 003,-040,-042, ! dx1(1:10,26,14)
     .-021,-026,-001,-004,-028,-040,-013, 019,-016,-018, ! dx1(1:10,27,14)
     .-030,-025,-010,-008,-024,-041,-013, 005,-013,-023, ! dx1(1:10,28,14)
     .-024,-039,-018,-009,-020,-029,-020,-008,-008,-022, ! dx1(1:10,29,14)
     .-012,-015,-002,-001,-005, 004,-010,-004, 011,-006, ! dx1(1:10,30,14)
     .-018,-022,-013,-017, 007, 022,-013,-018, 006,-005, ! dx1(1:10,31,14)
     .-001,-003, 009, 009, 022, 046, 004, 000, 029, 020, ! dx1(1:10,32,14)
     . 017, 029, 008, 002, 032, 051, 006, 009, 022, 015, ! dx1(1:10,33,14)
     . 011, 020, 001,-005, 014, 034, 002, 010, 015, 015, ! dx1(1:10,34,14)
     . 016, 032, 008, 002, 017, 021, 007, 008, 005, 014, ! dx1(1:10,35,14)
     . 029, 033, 014, 010, 006, 003, 004, 017,-004, 005, ! dx1(1:10,36,14)
     . 025, 021, 020, 000,-010,-073,-003,-016,-039,-012, ! dx1(1:10,37,14)
     .-003, 011,-007,-027,-065,-132,-048,-060,-079,-074, ! dx1(1:10,38,14)
     .-068,-054,-013,-006,-017,-003,-018, 040,-008,-002, ! dx1(1:10, 1,15)
     .-051,-048,-009, 000,-016,-019,-026, 025,-012,-025, ! dx1(1:10, 2,15)
     .-022,-024, 015, 026, 007, 008,-003, 037, 008, 014, ! dx1(1:10, 3,15)
     .-008, 004, 025, 026, 027, 021, 013, 049, 015, 014, ! dx1(1:10, 4,15)
     . 013, 013, 022, 032, 022, 029, 016, 054, 022, 027, ! dx1(1:10, 5,15)
     . 020, 026, 023, 025, 033, 032, 028, 057, 021, 032, ! dx1(1:10, 6,15)
     . 034, 027, 012, 022, 019, 034, 031, 055, 022, 033, ! dx1(1:10, 7,15)
     . 007, 009,-002, 007, 007, 016, 016, 028, 009, 030, ! dx1(1:10, 8,15)
     . 016, 029, 000, 000, 009, 017, 010, 014, 011, 018, ! dx1(1:10, 9,15)
     . 000, 017,-013, 000,-003, 022, 006,-007, 012, 020, ! dx1(1:10,10,15)
     .-002, 006,-017,-004,-012, 013,-006,-020, 006, 016, ! dx1(1:10,11,15)
     . 010,-001,-018,-007,-012, 011,-014,-034, 009, 007, ! dx1(1:10,12,15)
     . 005,-002,-022,-010,-016,-001,-024,-046, 001, 007, ! dx1(1:10,13,15)
     . 006,-007,-022,-011,-017,-004,-024,-047, 006, 007, ! dx1(1:10,14,15)
     . 010, 002,-010, 003, 003, 000,-008,-012, 006, 013, ! dx1(1:10,15,15)
     . 006, 001,-006, 008, 007,-009,-010, 000, 000, 016, ! dx1(1:10,16,15)
     . 003,-001,-008, 000, 004,-010,-013, 003,-014, 009, ! dx1(1:10,17,15)
     . 011, 013, 006, 021, 021, 007, 004, 016, 001, 026, ! dx1(1:10,18,15)
     . 013, 011, 008, 011, 021,-003, 012, 011,-008, 005, ! dx1(1:10,19,15)
     . 010, 010, 005, 011, 016,-001, 006, 010,-008, 014, ! dx1(1:10,20,15)
     . 013, 018, 024, 019, 019, 010, 029, 034, 013, 012, ! dx1(1:10,21,15)
     . 015, 021, 037, 018, 022, 005, 036, 035, 015, 013, ! dx1(1:10,22,15)
     . 040, 039, 056, 042, 038, 027, 056, 056, 038, 030, ! dx1(1:10,23,15)
     . 020, 029, 057, 034, 026, 018, 053, 051, 030, 017, ! dx1(1:10,24,15)
     .-028,-022, 002,-008,-027,-032, 000, 014,-020,-018, ! dx1(1:10,25,15)
     .-036,-034,-016,-033,-051,-050,-021,-003,-045,-039, ! dx1(1:10,26,15)
     .-023,-030,-002,-004,-022,-039,-002, 014,-023,-026, ! dx1(1:10,27,15)
     .-023,-043,-010,-013,-032,-045,-021,-003,-020,-024, ! dx1(1:10,28,15)
     .-030,-036,-021,-019,-025,-036,-025,-017,-015,-021, ! dx1(1:10,29,15)
     .-016,-018,-007,-010,-007,-009,-017,-018, 005,-010, ! dx1(1:10,30,15)
     .-019,-031,-021,-027,-006, 014,-027,-044,-002,-026, ! dx1(1:10,31,15)
     . 004, 007, 009, 001, 019, 041,-002,-015, 029, 011, ! dx1(1:10,32,15)
     . 017, 018, 012, 000, 021, 045, 007,-006, 024, 010, ! dx1(1:10,33,15)
     . 010, 016,-002, 001, 015, 033,-007,-006, 013, 003, ! dx1(1:10,34,15)
     . 021, 025,-002,-007, 008, 017, 001, 000, 003,-007, ! dx1(1:10,35,15)
     . 030, 024, 000, 004, 001,-003,-003,-009,-010, 000, ! dx1(1:10,36,15)
     . 002, 022,-007,-020,-043,-096,-028,-037,-062,-039, ! dx1(1:10,37,15)
     .-015,-020,-032,-049,-072,-136,-056,-067,-092,-084, ! dx1(1:10,38,15)
     .-066,-087,-019, 001,-033,-025,-031, 018,-024,-055, ! dx1(1:10, 1,16)
     .-094,-076,-017,-004,-034,-022,-034, 017,-028,-024, ! dx1(1:10, 2,16)
     .-045,-035, 006, 014,-001,-006,-005, 022,-001,-010, ! dx1(1:10, 3,16)
     .-023,-012, 013, 020, 008, 004, 005, 038, 008, 018, ! dx1(1:10, 4,16)
     . 000,-008, 010, 020, 014, 017, 015, 038, 012, 010, ! dx1(1:10, 5,16)
     . 007, 026, 019, 021, 030, 028, 020, 049, 024, 032, ! dx1(1:10, 6,16)
     . 019, 026, 011, 008, 023, 028, 028, 046, 019, 029, ! dx1(1:10, 7,16)
     . 013, 023,-004, 001, 013, 018, 018, 040, 012, 031, ! dx1(1:10, 8,16)
     . 002, 010,-004, 002, 004, 020, 019, 011, 015, 024, ! dx1(1:10, 9,16)
     . 034, 031, 000, 004, 006, 025, 008, 007, 022, 029, ! dx1(1:10,10,16)
     . 006, 010,-010,-001,-001, 028, 000,-013, 012, 020, ! dx1(1:10,11,16)
     . 001,-006,-026,-014,-012, 014,-018,-027, 000, 017, ! dx1(1:10,12,16)
     . 004, 004,-024,-011,-019,-005,-021,-040, 004, 005, ! dx1(1:10,13,16)
     . 012, 002,-031,-008,-013, 006,-017,-035, 005, 007, ! dx1(1:10,14,16)
     . 012,-002,-016,-005, 001,-014,-016,-016,-003, 010, ! dx1(1:10,15,16)
     . 018, 002,-007, 008, 009,-002,-004, 008, 000, 013, ! dx1(1:10,16,16)
     . 007,-003,-007, 008, 008,-010,-011, 007,-009, 019, ! dx1(1:10,17,16)
     . 025, 013, 012, 012, 024, 005, 008, 022, 000, 021, ! dx1(1:10,18,16)
     . 026, 017, 028, 029, 026, 012, 023, 036, 002, 023, ! dx1(1:10,19,16)
     . 018, 013, 014, 020, 022, 005, 014, 026, 000, 018, ! dx1(1:10,20,16)
     . 038, 039, 047, 028, 031, 011, 038, 041, 022, 027, ! dx1(1:10,21,16)
     . 029, 027, 044, 024, 023, 010, 038, 043, 024, 013, ! dx1(1:10,22,16)
     . 026, 042, 063, 034, 034, 022, 060, 050, 043, 029, ! dx1(1:10,23,16)
     . 022, 034, 054, 030, 024, 019, 058, 052, 040, 017, ! dx1(1:10,24,16)
     .-012,-012, 023, 004,-007,-012, 022, 023,-004,-006, ! dx1(1:10,25,16)
     .-024,-032,-001,-011,-022,-028, 006, 006,-022,-032, ! dx1(1:10,26,16)
     .-017,-021, 000,-009,-034,-041,-005, 006,-023,-028, ! dx1(1:10,27,16)
     .-038,-038,-020,-023,-033,-048,-016,-013,-032,-029, ! dx1(1:10,28,16)
     .-030,-048,-026,-025,-040,-046,-029,-032,-025,-036, ! dx1(1:10,29,16)
     .-031,-032,-022,-020,-026,-024,-029,-037,-014,-024, ! dx1(1:10,30,16)
     .-024,-022,-020,-030,-014, 005,-029,-061,-001,-030, ! dx1(1:10,31,16)
     . 015, 005, 010,-005, 021, 036,-001,-026, 025, 002, ! dx1(1:10,32,16)
     . 007, 016,-001,-004, 013, 032,-008,-035, 013,-003, ! dx1(1:10,33,16)
     . 013, 026, 000,-011, 008, 031,-001,-025, 010,-007, ! dx1(1:10,34,16)
     . 023, 026,-005,-002,-001, 018,-007,-022, 001,-002, ! dx1(1:10,35,16)
     .-002, 022,-011,-019,-013,-009,-018,-036,-022,-023, ! dx1(1:10,36,16)
     . 020, 007,-018,-020,-054,-110,-035,-078,-060,-048, ! dx1(1:10,37,16)
     .-070,-029,-054,-075,-085,-161,-067,-116,-103,-063, ! dx1(1:10,38,16)
     .-131,-102,-041,-039,-050,-061,-061, 002,-044,-058, ! dx1(1:10, 1,17)
     .-100,-102,-034,-024,-048,-055,-055,-009,-043,-061, ! dx1(1:10, 2,17)
     .-075,-053,-008,-007,-021,-020,-026, 015,-021,-021, ! dx1(1:10, 3,17)
     .-040,-036, 003, 001,-003,-007,-009, 011,-001,-014, ! dx1(1:10, 4,17)
     .-039,-025,-005,-006,-006,-005,-003, 015, 004, 001, ! dx1(1:10, 5,17)
     .-006,-001, 007, 004, 013, 019, 021, 038, 016, 019, ! dx1(1:10, 6,17)
     . 000, 020, 003, 004, 010, 015, 021, 039, 022, 025, ! dx1(1:10, 7,17)
     .-012, 016, 002,-002, 005, 015, 009, 029, 008, 023, ! dx1(1:10, 8,17)
     . 004, 013,-010,-008, 001, 014, 009, 010, 012, 022, ! dx1(1:10, 9,17)
     . 006, 006,-013,-009, 000, 023, 005, 002, 008, 019, ! dx1(1:10,10,17)
     . 020, 010,-002, 001, 001, 026, 002,-001, 017, 025, ! dx1(1:10,11,17)
     . 013, 004,-011, 000,-007, 020,-006,-013, 007, 023, ! dx1(1:10,12,17)
     . 015,-001,-019,-002,-002, 008,-016,-021, 003, 001, ! dx1(1:10,13,17)
     . 014,-004,-024,-001,-003, 005,-020,-022, 000, 017, ! dx1(1:10,14,17)
     . 020, 000,-010, 003, 003, 001,-010,-004, 000, 013, ! dx1(1:10,15,17)
     . 014, 002,-005, 010, 019, 002,-001, 007, 000, 016, ! dx1(1:10,16,17)
     . 031, 017, 001, 009, 022, 010, 002, 014,-002, 020, ! dx1(1:10,17,17)
     . 034, 018, 019, 026, 030, 013, 017, 035, 005, 024, ! dx1(1:10,18,17)
     . 032, 033, 033, 020, 032, 010, 025, 038, 005, 025, ! dx1(1:10,19,17)
     . 046, 040, 034, 018, 023, 008, 026, 035, 003, 021, ! dx1(1:10,20,17)
     . 024, 037, 044, 027, 031, 019, 036, 044, 019, 022, ! dx1(1:10,21,17)
     . 039, 044, 051, 025, 027, 018, 048, 038, 036, 019, ! dx1(1:10,22,17)
     . 031, 040, 055, 026, 027, 017, 050, 041, 030, 014, ! dx1(1:10,23,17)
     . 016, 024, 049, 023, 015, 012, 051, 042, 031, 010, ! dx1(1:10,24,17)
     . 026, 022, 041, 017, 010, 012, 052, 034, 018, 017, ! dx1(1:10,25,17)
     .-016,-013, 011,-007,-023,-021, 012, 006,-027,-026, ! dx1(1:10,26,17)
     .-020,-032,-012,-017,-034,-037,-003,-005,-030,-029, ! dx1(1:10,27,17)
     .-037,-038,-013,-022,-041,-046,-012,-018,-033,-032, ! dx1(1:10,28,17)
     .-035,-033,-028,-026,-037,-045,-024,-037,-030,-035, ! dx1(1:10,29,17)
     .-031,-042,-026,-038,-032,-037,-033,-053,-023,-033, ! dx1(1:10,30,17)
     .-019,-025,-030,-033,-018, 001,-032,-069,-013,-030, ! dx1(1:10,31,17)
     . 001,-002,-003,-002, 006, 027,-004,-044, 013,-007, ! dx1(1:10,32,17)
     . 005, 028,-005,-013, 007, 033,-010,-045, 011,-006, ! dx1(1:10,33,17)
     . 033, 030,-007,-011, 007, 029,-011,-053, 001,-012, ! dx1(1:10,34,17)
     . 001, 022,-011,-016,-006, 012,-017,-050,-005,-010, ! dx1(1:10,35,17)
     . 028, 019,-015,-017,-019,-009,-023,-065,-020,-019, ! dx1(1:10,36,17)
     .-006, 004,-025,-036,-053,-105,-045,-098,-071,-048, ! dx1(1:10,37,17)
     .-030,-018,-054,-064,-094,-156,-084,-132,-105,-086, ! dx1(1:10,38,17)
     .-161,-152,-066,-087,-086,-099,-097,-046,-088,-098, ! dx1(1:10, 1,18)
     .-168,-146,-074,-069,-090,-095,-093,-037,-080,-095, ! dx1(1:10, 2,18)
     .-119,-113,-042,-049,-056,-071,-059,-042,-052,-074, ! dx1(1:10, 3,18)
     .-094,-086,-043,-042,-052,-062,-047,-031,-033,-049, ! dx1(1:10, 4,18)
     .-083,-062,-024,-034,-030,-035,-031,-029,-012,-036, ! dx1(1:10, 5,18)
     .-066,-041,-025,-031,-025,-026,-019,-009, 000,-020, ! dx1(1:10, 6,18)
     .-034,-012,-016,-032,-003, 001, 001, 009, 006,-003, ! dx1(1:10, 7,18)
     .-029,-026,-027,-027,-016,-011, 001, 004, 003,-005, ! dx1(1:10, 8,18)
     .-022,-011,-029,-035,-020, 002,-012,-005,-004,-003, ! dx1(1:10, 9,18)
     . 006,-009,-019,-018,-017, 014,-012,-008, 001, 012, ! dx1(1:10,10,18)
     . 000, 003,-018,-016,-009, 023,-003,-008, 000, 010, ! dx1(1:10,11,18)
     . 003, 004,-010,-006, 002, 022,-006,-003, 009, 020, ! dx1(1:10,12,18)
     . 014, 014,-009,-007, 003, 014,-005,-013,-004, 011, ! dx1(1:10,13,18)
     . 039, 027, 012, 016, 016, 036, 014, 004, 019, 018, ! dx1(1:10,14,18)
     . 010,-010,-022,-009, 003, 005,-016,-006,-014, 010, ! dx1(1:10,15,18)
     . 028,-002,-008,-002, 004, 001,-010,-007,-015, 008, ! dx1(1:10,16,18)
     . 020, 007, 004, 010, 016, 000, 000, 006,-013, 015, ! dx1(1:10,17,18)
     . 035, 014, 012, 012, 026, 008, 015, 017,-008, 015, ! dx1(1:10,18,18)
     . 041, 033, 041, 024, 025, 027, 025, 041, 000, 022, ! dx1(1:10,19,18)
     . 039, 031, 034, 023, 027, 018, 024, 036, 000, 024, ! dx1(1:10,20,18)
     . 032, 042, 046, 017, 024, 009, 037, 013, 013, 005, ! dx1(1:10,21,18)
     . 020, 038, 042, 007, 015, 005, 039, 012, 017, 004, ! dx1(1:10,22,18)
     . 024, 030, 041, 015, 005, 010, 045, 016, 023, 000, ! dx1(1:10,23,18)
     . 007, 030, 049, 009, 006, 009, 050, 015, 022, 000, ! dx1(1:10,24,18)
     . 007,-002, 029, 017, 003,-006, 038, 014, 008,-011, ! dx1(1:10,25,18)
     .-034,-024,-005,-024,-045,-036, 010,-015,-019,-038, ! dx1(1:10,26,18)
     .-030,-023,-012,-036,-045,-043,-004,-028,-039,-042, ! dx1(1:10,27,18)
     .-028,-025,-020,-036,-046,-042,-011,-045,-039,-052, ! dx1(1:10,28,18)
     .-029,-039,-034,-054,-056,-055,-025,-059,-044,-048, ! dx1(1:10,29,18)
     .-038,-031,-041,-050,-049,-047,-033,-073,-043,-070, ! dx1(1:10,30,18)
     .-050,-039,-040,-065,-047,-022,-049,-096,-043,-070, ! dx1(1:10,31,18)
     .-013,-005,-024,-042,-012,-005,-015,-075,-012,-038, ! dx1(1:10,32,18)
     . 009, 006,-026,-041,-015, 014,-028,-090,-021,-043, ! dx1(1:10,33,18)
     .-017, 009,-035,-046,-021, 006,-027,-094,-019,-044, ! dx1(1:10,34,18)
     . 025, 020,-029,-039,-023, 001,-031,-112,-032,-050, ! dx1(1:10,35,18)
     .-010, 011,-046,-053,-049,-040,-046,-133,-046,-063, ! dx1(1:10,36,18)
     . 010, 027,-042,-070,-075,-114,-064,-182,-093,-080, ! dx1(1:10,37,18)
     .-027,-048,-075,-099,-120,-165,-098,-214,-139,-110/ ! dx1(1:10,38,18)
 
      data dx2 /
     . 047, 016, 082, 134, 070, 021, 073, 051, 010, 008, ! dx2(1:10, 1, 1)
     . 038, 024, 081, 124, 067, 022, 072, 044, 000,-002, ! dx2(1:10, 2, 1)
     . 043, 040, 101, 142, 097, 056, 097, 054, 048, 032, ! dx2(1:10, 3, 1)
     . 089, 048, 093, 120, 083, 053, 096, 042, 062, 041, ! dx2(1:10, 4, 1)
     . 060, 052, 089, 112, 088, 058, 091, 054, 076, 048, ! dx2(1:10, 5, 1)
     . 037, 055, 065, 079, 072, 051, 090, 050, 070, 045, ! dx2(1:10, 6, 1)
     . 099, 079, 083, 101, 088, 076, 106, 079, 102, 076, ! dx2(1:10, 7, 1)
     . 038, 016, 012, 049, 039, 032, 051, 023, 044, 023, ! dx2(1:10, 8, 1)
     . 024, 025, 018, 030, 028, 036, 036, 022, 039, 033, ! dx2(1:10, 9, 1)
     . 024, 008, 002, 027, 018, 034, 026, 005, 035, 026, ! dx2(1:10,10, 1)
     . 024, 017, 011, 024, 027, 040, 025, 005, 037, 031, ! dx2(1:10,11, 1)
     . 031, 005,-007, 016, 021, 032, 010, 000, 033, 026, ! dx2(1:10,12, 1)
     .-004, 008, 000, 024, 018, 026, 008,-001, 027, 038, ! dx2(1:10,13, 1)
     .-018,-039,-053,-020,-028,-021,-040,-049,-021,-024, ! dx2(1:10,14, 1)
     .-029,-047,-059,-028,-025,-021,-043,-046,-022,-008, ! dx2(1:10,15, 1)
     .-027,-054,-054,-032,-026,-038,-044,-045,-040,-027, ! dx2(1:10,16, 1)
     .-013,-034,-052,-019,-020,-041,-047,-038,-038,-023, ! dx2(1:10,17, 1)
     .-016,-040,-037,-021,-014,-028,-037,-027,-047,-015, ! dx2(1:10,18, 1)
     .-001, 002, 000,-006, 011,-009,-009, 000,-006,-005, ! dx2(1:10,19, 1)
     . 011, 008, 001, 006, 014,-004,-008, 002,-010, 009, ! dx2(1:10,20, 1)
     . 032, 034, 033, 025, 032, 018, 025, 015, 020, 017, ! dx2(1:10,21, 1)
     . 028, 050, 044, 044, 036, 029, 040, 031, 038, 028, ! dx2(1:10,22, 1)
     . 033, 046, 054, 048, 045, 043, 055, 036, 050, 041, ! dx2(1:10,23, 1)
     . 055, 060, 075, 066, 060, 055, 076, 058, 060, 051, ! dx2(1:10,24, 1)
     . 025, 036, 050, 048, 036, 032, 057, 057, 040, 037, ! dx2(1:10,25, 1)
     .-001, 011, 021, 023, 018, 018, 030, 039, 017, 020, ! dx2(1:10,26, 1)
     . 003, 003, 014, 017, 005, 015, 025, 031, 002, 010, ! dx2(1:10,27, 1)
     .-008, 002, 004, 006,-002, 000, 005, 022,-003, 004, ! dx2(1:10,28, 1)
     . 001,-005, 002, 010, 000,-002,-001, 011,-014, 008, ! dx2(1:10,29, 1)
     .-008,-019,-006,-008,-007, 000,-021, 007,-017,-004, ! dx2(1:10,30, 1)
     .-007, 007,-016, 004, 005, 026,-025,-003,-010, 003, ! dx2(1:10,31, 1)
     .-015,-017,-015,-013,-005, 007,-039,-009,-018,-009, ! dx2(1:10,32, 1)
     .-001, 020,-013,-014, 011, 044,-026,-009,-013, 006, ! dx2(1:10,33, 1)
     .-014, 019,-006,-014, 006, 049,-032, 000,-016, 007, ! dx2(1:10,34, 1)
     . 024, 034, 006, 010, 019, 053,-018, 006,-009, 025, ! dx2(1:10,35, 1)
     .-014, 036, 017, 007, 007, 041,-012, 016,-006, 033, ! dx2(1:10,36, 1)
     . 064, 056, 055, 038, 019,-001, 005, 025,-022, 067, ! dx2(1:10,37, 1)
     .-013, 024, 024,-015,-017,-051,-027, 012,-029, 009, ! dx2(1:10,38, 1)
     . 007,-009, 063, 093, 047, 013, 051, 039,-016,-013, ! dx2(1:10, 1, 2)
     . 006, 006, 055, 097, 049, 008, 045, 030,-016,-018, ! dx2(1:10, 2, 2)
     . 022, 003, 051, 064, 035, 008, 045, 016, 006, 007, ! dx2(1:10, 3, 2)
     . 014, 014, 044, 070, 044, 011, 051, 015, 023, 006, ! dx2(1:10, 4, 2)
     . 022, 022, 028, 050, 038, 018, 052, 013, 035, 019, ! dx2(1:10, 5, 2)
     . 039, 029, 038, 046, 038, 024, 058, 021, 050, 030, ! dx2(1:10, 6, 2)
     . 038, 044, 040, 036, 048, 043, 066, 049, 068, 042, ! dx2(1:10, 7, 2)
     . 011, 012, 001,-003, 006,-001, 023, 005, 018, 005, ! dx2(1:10, 8, 2)
     . 002, 003,-011, 000, 001, 015, 013, 011, 024, 007, ! dx2(1:10, 9, 2)
     . 010, 010,-009,-001, 004, 026, 012, 012, 023, 015, ! dx2(1:10,10, 2)
     . 000, 004,-017, 002,-004, 021,-006, 013, 021, 017, ! dx2(1:10,11, 2)
     . 009, 001,-008,-005, 001, 019,-004, 010, 019, 014, ! dx2(1:10,12, 2)
     . 015,-004,-026,-007,-005, 004,-018, 011, 010, 008, ! dx2(1:10,13, 2)
     .-033,-033,-052,-045,-038,-021,-053,-023,-023,-016, ! dx2(1:10,14, 2)
     .-025,-056,-055,-046,-038,-043,-053,-036,-038,-035, ! dx2(1:10,15, 2)
     .-029,-040,-056,-039,-035,-044,-052,-040,-047,-030, ! dx2(1:10,16, 2)
     .-015,-046,-042,-035,-025,-036,-038,-034,-043,-020, ! dx2(1:10,17, 2)
     .-002,-013,-021,-017,-015,-037,-023,-021,-029,-014, ! dx2(1:10,18, 2)
     . 015, 001,-006,-001, 000,-024,-009,-013,-015,-001, ! dx2(1:10,19, 2)
     . 022, 007, 007, 010, 007,-017,-001,-007,-007, 001, ! dx2(1:10,20, 2)
     . 031, 028, 031, 030, 022, 007, 031, 005, 020, 021, ! dx2(1:10,21, 2)
     . 040, 035, 048, 036, 033, 027, 045, 016, 035, 030, ! dx2(1:10,22, 2)
     . 023, 035, 056, 043, 035, 025, 056, 032, 043, 035, ! dx2(1:10,23, 2)
     . 027, 038, 056, 045, 041, 035, 064, 042, 048, 036, ! dx2(1:10,24, 2)
     . 038, 043, 073, 055, 044, 049, 072, 064, 060, 055, ! dx2(1:10,25, 2)
     .-004,-003, 020, 009,-001, 006, 026, 015, 013, 003, ! dx2(1:10,26, 2)
     .-010,-006, 016, 012,-004,-003, 019, 027, 013, 001, ! dx2(1:10,27, 2)
     . 003,-011, 013, 007,-014,-008, 006, 020, 001,-003, ! dx2(1:10,28, 2)
     .-012,-013,-005, 001,-013,-010,-006, 020,-002,-005, ! dx2(1:10,29, 2)
     .-015,-016,-008,-001,-013,-015,-015, 015,-004,-012, ! dx2(1:10,30, 2)
     . 007,-007,-019,-010,-008, 011,-028, 002,-007,-013, ! dx2(1:10,31, 2)
     .-022,-013,-026,-020,-010, 005,-035,-002,-014,-011, ! dx2(1:10,32, 2)
     .-013,-009,-021,-015,-004, 021,-034,-007,-014,-009, ! dx2(1:10,33, 2)
     .-010, 006,-011,-011, 001, 036,-028,-013,-011,-001, ! dx2(1:10,34, 2)
     .-006, 004,-013,-015,-007, 029,-027,-018,-013, 002, ! dx2(1:10,35, 2)
     . 017, 015, 012,-003,-001, 027,-013,-022,-015, 027, ! dx2(1:10,36, 2)
     .-012, 029, 027, 002,-014,-026,-012,-034,-029, 026, ! dx2(1:10,37, 2)
     .-006,-010,-002,-012,-041,-062,-036,-062,-065, 015, ! dx2(1:10,38, 2)
     .-001,-015, 028, 058, 022,-017, 004, 020,-053,-021, ! dx2(1:10, 1, 3)
     .-015,-031, 014, 048, 003,-018, 008, 012,-051,-030, ! dx2(1:10, 2, 3)
     .-014,-007, 020, 035, 019,-014, 026, 000,-013,-015, ! dx2(1:10, 3, 3)
     . 014,-009, 016, 026, 005,-006, 022,-005, 007,-005, ! dx2(1:10, 4, 3)
     .-004,-008, 006, 017, 010,-009, 027,-008, 015, 005, ! dx2(1:10, 5, 3)
     . 020, 020, 022, 016, 025, 015, 046, 008, 044, 014, ! dx2(1:10, 6, 3)
     . 052, 033, 024, 016, 034, 023, 040, 029, 048, 031, ! dx2(1:10, 7, 3)
     .-006,-001,-023,-023,-010,-016,-001,-008, 007,-013, ! dx2(1:10, 8, 3)
     . 010, 003,-011,-011, 000, 008, 001, 016, 020, 000, ! dx2(1:10, 9, 3)
     .-001,-001,-024,-025,-014, 006,-015, 009, 004,-003, ! dx2(1:10,10, 3)
     . 002,-003,-029,-018,-016, 009,-018, 014, 004, 000, ! dx2(1:10,11, 3)
     . 007,-004,-023,-023,-001, 010,-018, 018, 009, 009, ! dx2(1:10,12, 3)
     . 009,-010,-024,-022,-017,-008,-029, 007,-005,-008, ! dx2(1:10,13, 3)
     .-055,-064,-075,-057,-059,-052,-075,-030,-049,-043, ! dx2(1:10,14, 3)
     .-009,-024,-043,-039,-035,-033,-049,-020,-036,-025, ! dx2(1:10,15, 3)
     .-018,-033,-040,-043,-034,-045,-051,-033,-051,-024, ! dx2(1:10,16, 3)
     .-007,-031,-040,-027,-031,-044,-039,-033,-040,-020, ! dx2(1:10,17, 3)
     .-007,-019,-020,-011,-010,-036,-021,-022,-028,-009, ! dx2(1:10,18, 3)
     . 024,-001,-002, 006,-009,-026,-005,-024,-014,-006, ! dx2(1:10,19, 3)
     . 030, 009,-001, 013, 000,-010, 002,-014,-005, 004, ! dx2(1:10,20, 3)
     . 012, 023, 030, 024, 019, 005, 031,-005, 015, 021, ! dx2(1:10,21, 3)
     . 032, 032, 044, 037, 022, 019, 048, 011, 030, 025, ! dx2(1:10,22, 3)
     . 031, 036, 052, 042, 034, 029, 058, 022, 042, 036, ! dx2(1:10,23, 3)
     . 032, 047, 062, 046, 037, 037, 067, 038, 045, 038, ! dx2(1:10,24, 3)
     . 039, 044, 067, 046, 036, 042, 074, 055, 058, 037, ! dx2(1:10,25, 3)
     .-005, 004, 021, 006,-010,-006, 022, 009, 010,-003, ! dx2(1:10,26, 3)
     . 001,-006, 017, 009,-008,-001, 019, 029, 019, 000, ! dx2(1:10,27, 3)
     .-015,-004, 009, 004,-011,-006, 013, 031, 011,-005, ! dx2(1:10,28, 3)
     . 007,-017, 000, 007,-020,-021,-009, 019, 008,-010, ! dx2(1:10,29, 3)
     .-019,-017,-012,-001,-015,-022,-017, 020, 006,-011, ! dx2(1:10,30, 3)
     . 000,-020,-017,-014,-016,-002,-030, 005,-009,-020, ! dx2(1:10,31, 3)
     .-011,-022,-021,-017,-018,-011,-038, 002,-013,-020, ! dx2(1:10,32, 3)
     .-001,-003,-011,-015,-004, 027,-032,-005,-006,-009, ! dx2(1:10,33, 3)
     .-004,-007,-019,-021,-010, 019,-039,-021,-021,-010, ! dx2(1:10,34, 3)
     .-007, 011,-012,-014,-004, 035,-028,-028,-014, 005, ! dx2(1:10,35, 3)
     .-017, 010,-007,-014,-011, 016,-021,-036,-015, 010, ! dx2(1:10,36, 3)
     . 003, 012, 011,-009,-019,-036,-019,-056,-035, 018, ! dx2(1:10,37, 3)
     .-038,-034,-014,-037,-057,-077,-053,-090,-072,-015, ! dx2(1:10,38, 3)
     .-038,-018, 016, 030, 007,-006, 008, 020,-038,-019, ! dx2(1:10, 1, 4)
     .-024,-029, 000, 028,-001,-024, 000, 013,-054,-034, ! dx2(1:10, 2, 4)
     .-012,-024, 010, 021, 001,-014, 012,-004,-018,-012, ! dx2(1:10, 3, 4)
     .-022,-021,-002, 005,-004,-018, 017,-024,-011,-013, ! dx2(1:10, 4, 4)
     .-003, 000,-005, 003, 001,-008, 021,-017, 009,-013, ! dx2(1:10, 5, 4)
     . 010, 006, 001, 001, 011,-002, 025,-009, 023, 003, ! dx2(1:10, 6, 4)
     . 008, 028, 019,-007, 015, 012, 028, 016, 040, 017, ! dx2(1:10, 7, 4)
     .-026,-026,-039,-047,-036,-034,-020,-030,-005,-031, ! dx2(1:10, 8, 4)
     . 007, 014,-018,-021,-003, 010,-003, 020, 011,-002, ! dx2(1:10, 9, 4)
     . 000, 000,-021,-027,-012, 000,-020, 018, 005,-004, ! dx2(1:10,10, 4)
     .-005,-004,-033,-039,-019,-007,-034, 011,-010,-017, ! dx2(1:10,11, 4)
     . 011, 000,-020,-024,-012, 005,-026, 028, 000,-003, ! dx2(1:10,12, 4)
     .-011,-010,-029,-030,-016,-011,-034, 014,-010,-013, ! dx2(1:10,13, 4)
     .-030,-051,-060,-070,-055,-051,-072,-021,-049,-046, ! dx2(1:10,14, 4)
     .-022,-036,-039,-047,-039,-041,-047,-022,-040,-035, ! dx2(1:10,15, 4)
     .-020,-034,-042,-035,-041,-045,-048,-028,-051,-037, ! dx2(1:10,16, 4)
     .-009,-017,-030,-021,-029,-041,-036,-027,-038,-014, ! dx2(1:10,17, 4)
     . 010,-008,-016,-004,-014,-024,-011,-021,-022,-008, ! dx2(1:10,18, 4)
     . 003,-005,-001, 000,-007,-026,-006,-032,-015, 001, ! dx2(1:10,19, 4)
     . 005, 000, 000, 005,-003,-026,-001,-032,-006,-001, ! dx2(1:10,20, 4)
     . 025, 017, 029, 021, 014, 007, 031,-013, 005, 019, ! dx2(1:10,21, 4)
     . 036, 028, 040, 023, 019, 013, 043,-007, 023, 023, ! dx2(1:10,22, 4)
     . 016, 022, 039, 022, 017, 018, 050, 000, 020, 016, ! dx2(1:10,23, 4)
     . 026, 040, 064, 039, 029, 032, 069, 021, 040, 040, ! dx2(1:10,24, 4)
     . 027, 032, 050, 035, 018, 025, 051, 040, 045, 024, ! dx2(1:10,25, 4)
     .-007,-003, 018, 001,-015,-008, 016, 005, 008,-008, ! dx2(1:10,26, 4)
     .-008, 000, 017, 009,-010,-005, 021, 025, 024,-008, ! dx2(1:10,27, 4)
     . 000,-012, 007, 005,-020,-016, 000, 025, 016,-014, ! dx2(1:10,28, 4)
     .-020,-025,-003, 000,-021,-023,-005, 026, 009,-020, ! dx2(1:10,29, 4)
     .-013,-016,-010,-010,-023,-031,-022, 020, 009,-024, ! dx2(1:10,30, 4)
     .-012,-020,-019,-017,-014,-010,-028, 020,-004,-018, ! dx2(1:10,31, 4)
     .-016,-020,-025,-029,-023,-009,-035, 007,-014,-028, ! dx2(1:10,32, 4)
     .-012,-002,-017,-007,-003, 009,-033, 000,-005,-011, ! dx2(1:10,33, 4)
     . 000,-009,-023,-019,-010, 021,-038,-016,-018,-008, ! dx2(1:10,34, 4)
     .-002, 008,-013,-012,-007, 023,-031,-025,-015, 000, ! dx2(1:10,35, 4)
     .-022,-001,-018,-019,-016, 021,-024,-047,-023, 007, ! dx2(1:10,36, 4)
     . 021, 033, 029, 003,-006,-021, 004,-058,-011, 030, ! dx2(1:10,37, 4)
     .-024,-011,-011,-031,-044,-074,-045,-106,-054,-012, ! dx2(1:10,38, 4)
     .-006,-011, 010, 028, 009,-041, 000, 023,-055,-020, ! dx2(1:10, 1, 5)
     .-030,-032,-006, 011,-013,-032,-015, 005,-057,-043, ! dx2(1:10, 2, 5)
     .-006,-027, 000, 002,-007,-021, 008,-011,-025,-013, ! dx2(1:10, 3, 5)
     .-030,-019,-004, 000,-006,-010, 010,-023,-008,-011, ! dx2(1:10, 4, 5)
     .-004,-007,-003,-008,-004,-016, 015,-029, 006,-005, ! dx2(1:10, 5, 5)
     . 013, 006, 008,-009, 008, 000, 024,-019, 023, 000, ! dx2(1:10, 6, 5)
     . 015, 011, 002,-011, 013, 009, 015, 009, 034,-001, ! dx2(1:10, 7, 5)
     .-037,-033,-047,-060,-042,-040,-035,-039,-020,-037, ! dx2(1:10, 8, 5)
     .-004, 003,-014,-033,-008,-005,-014, 018, 012,-016, ! dx2(1:10, 9, 5)
     .-007, 002,-027,-035,-013, 004,-025, 018,-002,-013, ! dx2(1:10,10, 5)
     . 000,-008,-038,-041,-029,-005,-043, 011,-016,-016, ! dx2(1:10,11, 5)
     .-002, 001,-020,-033,-012,-003,-033, 033,-008,-013, ! dx2(1:10,12, 5)
     .-001,-022,-022,-039,-025,-020,-039, 023,-015,-010, ! dx2(1:10,13, 5)
     .-048,-047,-066,-073,-058,-052,-073,-013,-055,-051, ! dx2(1:10,14, 5)
     .-029,-034,-037,-044,-049,-046,-058,-023,-046,-036, ! dx2(1:10,15, 5)
     .-017,-034,-040,-035,-043,-047,-046,-029,-047,-034, ! dx2(1:10,16, 5)
     . 003,-020,-025,-021,-034,-034,-032,-030,-039,-026, ! dx2(1:10,17, 5)
     . 000,-008,-015,-008,-015,-025,-012,-024,-020,-007, ! dx2(1:10,18, 5)
     . 026, 000, 004, 010,-003,-012, 012,-035,-011, 010, ! dx2(1:10,19, 5)
     . 021, 004, 008, 006,-006,-011, 008,-037,-011, 010, ! dx2(1:10,20, 5)
     . 029, 016, 025, 016, 006, 002, 028,-027, 006, 017, ! dx2(1:10,21, 5)
     . 024, 015, 026, 018, 009, 006, 038,-025, 001, 017, ! dx2(1:10,22, 5)
     . 023, 027, 038, 025, 010, 011, 044,-017, 014, 023, ! dx2(1:10,23, 5)
     . 023, 028, 050, 033, 018, 018, 051, 003, 024, 019, ! dx2(1:10,24, 5)
     . 042, 045, 055, 043, 024, 032, 060, 039, 038, 027, ! dx2(1:10,25, 5)
     . 012,-009, 019, 008,-021,-006, 018, 001, 000,-011, ! dx2(1:10,26, 5)
     .-008,-005, 016, 009,-009,-007, 011, 022, 018,-012, ! dx2(1:10,27, 5)
     .-011,-019, 002,-002,-027,-021,-002, 022, 015,-017, ! dx2(1:10,28, 5)
     .-034,-029,-016,-016,-028,-034,-018, 020, 013,-029, ! dx2(1:10,29, 5)
     .-009,-018,-008,-002,-017,-021,-017, 034, 019,-017, ! dx2(1:10,30, 5)
     .-012,-022,-024,-017,-021,-023,-028, 018,-002,-026, ! dx2(1:10,31, 5)
     .-008,-020,-038,-015,-021,-026,-039, 013,-007,-028, ! dx2(1:10,32, 5)
     .-009, 001,-013,-015,-006, 019,-025, 007,-005,-011, ! dx2(1:10,33, 5)
     .-011, 008,-019,-013,-003, 014,-029,-009,-014,-001, ! dx2(1:10,34, 5)
     .-018,-010,-016,-008,-010, 026,-026,-026,-023,-004, ! dx2(1:10,35, 5)
     . 010, 006,-001, 000,-001, 028,-008,-035,-003, 019, ! dx2(1:10,36, 5)
     . 009, 019, 023, 009,-003,-013, 001,-062,-015, 032, ! dx2(1:10,37, 5)
     .-048,-029,-003,-024,-042,-054,-020,-093,-042, 006, ! dx2(1:10,38, 5)
     .-005,-001, 006, 034, 008,-009, 006, 036,-037,-009, ! dx2(1:10, 1, 6)
     .-015,-032,-005, 007,-008,-027, 000, 015,-050,-018, ! dx2(1:10, 2, 6)
     .-032,-028,-009,-006,-013,-019,-001,-019,-023,-021, ! dx2(1:10, 3, 6)
     .-013,-016,-007,-012,-011,-021, 005,-029,-012,-008, ! dx2(1:10, 4, 6)
     .-009,-013,-003,-008,-005,-010, 015,-033, 003,-006, ! dx2(1:10, 5, 6)
     . 006, 020, 012,-001, 015, 003, 024,-010, 032, 012, ! dx2(1:10, 6, 6)
     . 008,-002,-011,-022, 000, 004, 001,-002, 018, 000, ! dx2(1:10, 7, 6)
     .-033,-031,-040,-060,-033,-037,-031,-041,-013,-044, ! dx2(1:10, 8, 6)
     .-002, 000,-029,-036,-012,-005,-027, 018, 002,-013, ! dx2(1:10, 9, 6)
     .-001, 002,-025,-037,-014,-008,-032, 017,-008,-014, ! dx2(1:10,10, 6)
     . 001,-007,-041,-053,-028,-016,-043, 018,-017,-028, ! dx2(1:10,11, 6)
     . 003,-003,-018,-036,-007, 001,-029, 038,-007,-015, ! dx2(1:10,12, 6)
     .-004,-011,-019,-023,-021,-012,-035, 028,-019,-005, ! dx2(1:10,13, 6)
     .-025,-056,-056,-059,-061,-049,-070,-009,-056,-052, ! dx2(1:10,14, 6)
     .-014,-026,-039,-035,-039,-041,-050,-015,-047,-029, ! dx2(1:10,15, 6)
     .-025,-036,-032,-034,-038,-041,-041,-028,-045,-031, ! dx2(1:10,16, 6)
     .-014,-024,-028,-022,-031,-037,-031,-033,-035,-012, ! dx2(1:10,17, 6)
     . 000,-012,-015,-012,-022,-021,-008,-032,-022,-003, ! dx2(1:10,18, 6)
     . 017, 002, 004,-002,-006,-018, 006,-045,-016, 001, ! dx2(1:10,19, 6)
     . 028, 004, 000, 008, 000,-011, 013,-039,-008, 007, ! dx2(1:10,20, 6)
     . 004, 017, 025, 018, 006, 004, 029,-040,-003, 013, ! dx2(1:10,21, 6)
     . 022, 012, 028, 022, 006, 001, 036,-033, 000, 014, ! dx2(1:10,22, 6)
     . 025, 028, 029, 027, 008, 013, 041,-024, 005, 018, ! dx2(1:10,23, 6)
     . 024, 035, 049, 038, 017, 019, 056, 001, 020, 018, ! dx2(1:10,24, 6)
     . 026, 022, 051, 039, 015, 022, 046, 024, 035, 015, ! dx2(1:10,25, 6)
     .-017,-007, 010,-003,-025,-017, 004,-010,-001,-017, ! dx2(1:10,26, 6)
     .-002,-012, 014, 004,-014,-014, 009, 021, 016,-018, ! dx2(1:10,27, 6)
     .-003,-016,-004,-005,-020,-015,-005, 025, 022,-022, ! dx2(1:10,28, 6)
     . 000,-024,-013,-010,-026,-030,-018, 028, 018,-023, ! dx2(1:10,29, 6)
     .-008,-008,-007, 002,-012,-029,-010, 037, 023,-014, ! dx2(1:10,30, 6)
     .-012,-017,-022,-013,-018,-032,-030, 029, 000,-020, ! dx2(1:10,31, 6)
     .-003,-022,-037,-019,-023,-031,-034, 016,-004,-035, ! dx2(1:10,32, 6)
     .-008,-010,-016,-008,-002, 007,-026, 020,-005,-011, ! dx2(1:10,33, 6)
     .-003,-010,-026,-018,-005, 016,-029,-003,-017,-012, ! dx2(1:10,34, 6)
     .-004, 006,-014,-004, 000, 031,-020,-010,-007, 005, ! dx2(1:10,35, 6)
     . 006, 019, 014, 011, 011, 038,-002,-021, 000, 031, ! dx2(1:10,36, 6)
     . 014, 017, 040, 028, 011, 005, 021,-052,-004, 044, ! dx2(1:10,37, 6)
     . 003, 000, 015,-009,-018,-049,-021,-096,-036, 011, ! dx2(1:10,38, 6)
     . 007,-005, 011, 026, 014, 000, 010, 042,-018, 010, ! dx2(1:10, 1, 7)
     .-029,-013,-007, 015,-002, 001, 000, 026,-034,-002, ! dx2(1:10, 2, 7)
     .-019,-023,-002,-012,-007,-019, 007,-017,-021,-014, ! dx2(1:10, 3, 7)
     .-025,-022,-008,-012,-014,-018, 003,-037,-004,-010, ! dx2(1:10, 4, 7)
     .-020,-006,-005,-018,-006,-009, 007,-036, 008,-004, ! dx2(1:10, 5, 7)
     . 016, 011, 006,-008, 012, 003, 019,-016, 032, 005, ! dx2(1:10, 6, 7)
     . 016, 018, 010,-006, 021, 011, 015, 017, 036, 007, ! dx2(1:10, 7, 7)
     .-012,-016,-040,-054,-033,-040,-037,-032,-016,-035, ! dx2(1:10, 8, 7)
     .-001, 005,-014,-038, 000,-003,-019, 021, 004,-016, ! dx2(1:10, 9, 7)
     .-002,-002,-018,-049,-011,-001,-027, 029,-001,-024, ! dx2(1:10,10, 7)
     .-010,-002,-028,-045,-019,-010,-042, 025,-015,-025, ! dx2(1:10,11, 7)
     . 009, 004,-013,-030,-012,-005,-028, 038,-008,-011, ! dx2(1:10,12, 7)
     . 008, 001,-013,-010,-012,-004,-029, 033,-014,-009, ! dx2(1:10,13, 7)
     .-029,-041,-054,-051,-054,-046,-066,-008,-053,-049, ! dx2(1:10,14, 7)
     .-027,-033,-030,-033,-040,-036,-043,-010,-044,-027, ! dx2(1:10,15, 7)
     .-012,-036,-034,-042,-035,-037,-029,-026,-037,-027, ! dx2(1:10,16, 7)
     .-016,-019,-023,-028,-030,-027,-023,-031,-038,-012, ! dx2(1:10,17, 7)
     . 001,-006,-003,-013,-015,-018,-001,-037,-016,-005, ! dx2(1:10,18, 7)
     . 017,-009, 000, 004,-011,-017, 008,-052,-017, 005, ! dx2(1:10,19, 7)
     . 011, 007, 008, 010,-005,-006, 022,-047,-013, 009, ! dx2(1:10,20, 7)
     . 029, 017, 023, 029, 009, 000, 033,-044, 000, 021, ! dx2(1:10,21, 7)
     . 014, 024, 026, 023, 007, 010, 039,-043, 000, 016, ! dx2(1:10,22, 7)
     . 036, 028, 036, 035, 013, 013, 044,-025, 009, 023, ! dx2(1:10,23, 7)
     . 030, 029, 050, 035, 017, 025, 046,-003, 019, 024, ! dx2(1:10,24, 7)
     . 018, 025, 041, 034, 016, 019, 037, 022, 029, 014, ! dx2(1:10,25, 7)
     .-010,-006, 009, 005,-013,-009, 008,-006,-002,-011, ! dx2(1:10,26, 7)
     .-002,-018, 011, 002,-015,-009, 000, 017, 017,-014, ! dx2(1:10,27, 7)
     .-004,-019, 000, 001,-013,-012,-008, 026, 024,-015, ! dx2(1:10,28, 7)
     .-006,-010,-009,-001,-017,-029,-016, 033, 023,-029, ! dx2(1:10,29, 7)
     . 000,-016,-016, 000,-007,-021,-012, 041, 029,-016, ! dx2(1:10,30, 7)
     .-025,-021,-026,-011,-014,-036,-028, 027, 003,-023, ! dx2(1:10,31, 7)
     .-008,-019,-033,-022,-018,-038,-034, 024,-007,-026, ! dx2(1:10,32, 7)
     .-009,-016,-024,-009,-005, 003,-018, 029,-002,-011, ! dx2(1:10,33, 7)
     .-006,-007,-016,-004,-001, 022,-022, 009,-003, 000, ! dx2(1:10,34, 7)
     . 012, 007,-002, 011, 009, 040,-009, 007, 004, 014, ! dx2(1:10,35, 7)
     . 031, 017, 013, 020, 019, 054, 017,-008, 013, 036, ! dx2(1:10,36, 7)
     . 022, 026, 050, 038, 018, 015, 031,-041, 007, 054, ! dx2(1:10,37, 7)
     .-020,-014, 011,-007,-020,-034,-010,-090,-030, 022, ! dx2(1:10,38, 7)
     . 023, 006, 008, 030, 015, 024, 019, 026,-015, 009, ! dx2(1:10, 1, 8)
     .-013,-015, 008, 015, 006, 002, 013, 024,-025, 013, ! dx2(1:10, 2, 8)
     .-018,-003, 011, 001,-001, 000, 009,-009, 000, 000, ! dx2(1:10, 3, 8)
     .-030,-011,-001,-016,-007,-016, 007,-037,-004,-009, ! dx2(1:10, 4, 8)
     . 004,-013, 000,-009,-001,-006, 012,-033, 017, 000, ! dx2(1:10, 5, 8)
     . 008, 013, 017,-004, 019, 011, 020,-005, 031, 008, ! dx2(1:10, 6, 8)
     . 026, 038, 011,-002, 026, 016, 024, 019, 044, 011, ! dx2(1:10, 7, 8)
     .-015,-019,-028,-041,-015,-025,-024,-023,-006,-024, ! dx2(1:10, 8, 8)
     . 004, 010,-005,-032, 001,-004,-018, 028, 010,-013, ! dx2(1:10, 9, 8)
     .-013,-001,-020,-030,-014,-004,-025, 037, 000,-014, ! dx2(1:10,10, 8)
     . 002,-008,-020,-032,-017,-011,-036, 037,-011,-021, ! dx2(1:10,11, 8)
     .-008, 013,-014,-016,-006, 000,-030, 041,-009,-010, ! dx2(1:10,12, 8)
     . 000,-010,-013,-025,-018,-015,-025, 027,-015,-014, ! dx2(1:10,13, 8)
     .-035,-031,-038,-049,-038,-033,-056,-003,-046,-035, ! dx2(1:10,14, 8)
     .-005,-025,-029,-041,-031,-030,-031,-010,-037,-023, ! dx2(1:10,15, 8)
     .-021,-023,-022,-039,-029,-029,-031,-024,-036,-022, ! dx2(1:10,16, 8)
     .-025,-020,-021,-027,-028,-026,-015,-038,-033,-006, ! dx2(1:10,17, 8)
     . 007,-012,-002,-006,-011,-010, 003,-040,-015, 005, ! dx2(1:10,18, 8)
     . 002, 003,-004, 016,-014,-007, 017,-057,-021, 009, ! dx2(1:10,19, 8)
     . 009, 004, 003, 020,-006,-009, 018,-058,-017, 010, ! dx2(1:10,20, 8)
     . 035, 025, 026, 029, 007, 009, 038,-044,-002, 022, ! dx2(1:10,21, 8)
     . 024, 021, 031, 032, 010, 013, 041,-040, 001, 023, ! dx2(1:10,22, 8)
     . 034, 027, 037, 026, 014, 017, 042,-030, 009, 020, ! dx2(1:10,23, 8)
     . 030, 029, 042, 035, 018, 025, 046,-003, 018, 032, ! dx2(1:10,24, 8)
     . 041, 034, 057, 046, 025, 035, 046, 024, 033, 016, ! dx2(1:10,25, 8)
     .-007,-016, 010, 001,-019,-003, 001,-015,-006,-014, ! dx2(1:10,26, 8)
     . 000,-009, 006, 009,-004,-004, 004, 023, 018,-005, ! dx2(1:10,27, 8)
     . 000,-012, 000, 004,-010,-005,-007, 028, 023,-015, ! dx2(1:10,28, 8)
     . 002,-013,-015, 002,-006,-013,-011, 034, 025,-015, ! dx2(1:10,29, 8)
     .-003,-006,-005, 010, 000,-020,-011, 045, 025,-009, ! dx2(1:10,30, 8)
     . 007,-014,-033,-008,-008,-023,-025, 037, 005,-009, ! dx2(1:10,31, 8)
     .-020,-031,-037,-021,-019,-039,-031, 031,-007,-030, ! dx2(1:10,32, 8)
     . 015,-003,-013, 003, 007, 008,-013, 043, 011, 006, ! dx2(1:10,33, 8)
     . 008,-001,-015, 000, 004, 023,-006, 027, 008, 003, ! dx2(1:10,34, 8)
     . 023, 012, 012, 022, 017, 051, 010, 022, 016, 028, ! dx2(1:10,35, 8)
     . 026, 028, 029, 033, 027, 061, 025, 010, 020, 046, ! dx2(1:10,36, 8)
     . 032, 030, 067, 049, 036, 024, 035,-031, 020, 054, ! dx2(1:10,37, 8)
     . 015, 000, 031, 010, 004,-019, 006,-056,-017, 034, ! dx2(1:10,38, 8)
     .-008, 006, 010, 014, 016, 023, 022, 036,-018, 017, ! dx2(1:10, 1, 9)
     . 008, 006, 014, 017, 007, 009, 017, 023,-014, 014, ! dx2(1:10, 2, 9)
     .-012,-009, 019, 013, 010, 009, 024,-008, 006, 017, ! dx2(1:10, 3, 9)
     .-009,-016, 001,-004,-001,-003, 014,-025, 013, 001, ! dx2(1:10, 4, 9)
     .-020, 007, 007,-001, 005,-003, 014,-028, 017,-002, ! dx2(1:10, 5, 9)
     . 016, 030, 022, 007, 030, 022, 030, 006, 049, 024, ! dx2(1:10, 6, 9)
     . 029, 018, 017,-002, 029, 021, 013, 034, 039, 016, ! dx2(1:10, 7, 9)
     .-030,-010,-032,-054,-016,-031,-025,-016,-003,-026, ! dx2(1:10, 8, 9)
     . 012, 006,-001,-022, 007, 002,-009, 044, 017, 004, ! dx2(1:10, 9, 9)
     . 003, 001,-006,-026,-003,-001,-020, 051, 005,-012, ! dx2(1:10,10, 9)
     . 000, 009,-010,-019,-008,-001,-026, 046,-004,-012, ! dx2(1:10,11, 9)
     . 017, 006, 000,-012,-002, 008,-018, 050, 000,-003, ! dx2(1:10,12, 9)
     . 006, 018,-006,-017, 000, 008,-007, 034,-006, 000, ! dx2(1:10,13, 9)
     .-028,-040,-045,-062,-044,-043,-053,-010,-050,-052, ! dx2(1:10,14, 9)
     .-022,-010,-016,-036,-021,-018,-026,-006,-030,-006, ! dx2(1:10,15, 9)
     .-012,-021,-024,-030,-026,-022,-017,-028,-036,-016, ! dx2(1:10,16, 9)
     .-013,-020,-007,-016,-016,-015,-005,-037,-027,-002, ! dx2(1:10,17, 9)
     .-004,-001, 004, 007,-006,-001, 010,-038,-019, 017, ! dx2(1:10,18, 9)
     . 013,-011, 000, 013,-004, 000, 023,-057,-019, 009, ! dx2(1:10,19, 9)
     . 010, 000, 004, 016,-001, 000, 022,-057,-017, 009, ! dx2(1:10,20, 9)
     . 023, 014, 023, 023, 010, 012, 033,-049,-005, 021, ! dx2(1:10,21, 9)
     . 022, 019, 030, 023, 011, 018, 040,-043,-001, 018, ! dx2(1:10,22, 9)
     . 016, 025, 036, 034, 020, 022, 043,-027, 009, 027, ! dx2(1:10,23, 9)
     . 036, 039, 052, 043, 026, 029, 049,-003, 022, 027, ! dx2(1:10,24, 9)
     . 037, 030, 047, 053, 033, 034, 045, 031, 030, 034, ! dx2(1:10,25, 9)
     . 005, 000, 010, 014,-009,-007, 002,-011,-003,-011, ! dx2(1:10,26, 9)
     . 009, 005, 015, 019, 007, 009, 004, 026, 017, 003, ! dx2(1:10,27, 9)
     . 008,-006,-003, 010, 000, 000,-007, 032, 021,-012, ! dx2(1:10,28, 9)
     . 007,-008,-009, 009, 000,-017,-014, 039, 024,-012, ! dx2(1:10,29, 9)
     . 000,-006,-016, 002, 003,-016,-015, 043, 026,-014, ! dx2(1:10,30, 9)
     .-024,-019,-022, 004,-002,-030,-020, 042, 012,-012, ! dx2(1:10,31, 9)
     .-010,-015,-037,-008,-007,-039,-030, 037, 002,-014, ! dx2(1:10,32, 9)
     .-005,-002,-015, 003, 011, 010, 000, 050, 016,-001, ! dx2(1:10,33, 9)
     . 000, 005,-008, 003, 006, 023, 002, 037, 017, 015, ! dx2(1:10,34, 9)
     . 021, 008, 003, 023, 015, 049, 014, 029, 019, 024, ! dx2(1:10,35, 9)
     . 027, 039, 041, 037, 035, 064, 036, 013, 030, 047, ! dx2(1:10,36, 9)
     . 032, 041, 078, 054, 046, 044, 056,-023, 025, 065, ! dx2(1:10,37, 9)
     . 015, 024, 054, 019, 015,-009, 030,-063,-015, 032, ! dx2(1:10,38, 9)
     . 028, 021, 020, 041, 029, 038, 033, 026, 005, 029, ! dx2(1:10, 1,10)
     . 004, 012, 008, 032, 019, 032, 017, 014,-015, 011, ! dx2(1:10, 2,10)
     .-007, 008, 028, 013, 024, 021, 029, 000, 018, 027, ! dx2(1:10, 3,10)
     .-002, 022, 017, 011, 014, 019, 026,-012, 021, 014, ! dx2(1:10, 4,10)
     .-003,-001, 006,-001, 009, 009, 014,-011, 030, 005, ! dx2(1:10, 5,10)
     . 019, 014, 019, 010, 028, 021, 024, 012, 044, 021, ! dx2(1:10, 6,10)
     . 008, 031, 028, 010, 041, 026, 036, 057, 058, 022, ! dx2(1:10, 7,10)
     .-012,-030,-023,-033,-016,-019,-026, 000, 000,-021, ! dx2(1:10, 8,10)
     . 004, 004, 006, 000, 011, 004,-005, 061, 025,-006, ! dx2(1:10, 9,10)
     . 000, 005, 008, 010, 008, 011,-007, 068, 018,-008, ! dx2(1:10,10,10)
     . 000,-005, 000,-014, 000, 000,-018, 055, 007, 001, ! dx2(1:10,11,10)
     . 015, 023, 012,-015, 013, 017,-002, 057, 012, 006, ! dx2(1:10,12,10)
     . 004, 011, 011,-012, 009, 009, 001, 044, 002, 017, ! dx2(1:10,13,10)
     .-020,-005,-022,-054,-023,-015,-032, 009,-033,-014, ! dx2(1:10,14,10)
     .-001,-005,-009,-016,-011,-008,-004,-001,-018,-013, ! dx2(1:10,15,10)
     .-023, 001, 002,-006,-002,-002, 000,-017,-019, 000, ! dx2(1:10,16,10)
     .-003,-004,-004, 010,-008, 003, 004,-035,-019,-002, ! dx2(1:10,17,10)
     . 011, 005, 005, 015, 005, 015, 022,-037,-008, 015, ! dx2(1:10,18,10)
     . 017, 010, 021, 011, 005, 014, 026,-051,-012, 020, ! dx2(1:10,19,10)
     . 028, 003, 019, 010, 007, 012, 027,-046,-010, 036, ! dx2(1:10,20,10)
     . 025, 022, 024, 020, 013, 018, 042,-047, 002, 023, ! dx2(1:10,21,10)
     . 028, 015, 033, 035, 018, 022, 040,-038, 007, 029, ! dx2(1:10,22,10)
     . 034, 034, 028, 040, 018, 021, 034,-025, 002, 028, ! dx2(1:10,23,10)
     . 032, 041, 035, 051, 031, 030, 045,-001, 017, 030, ! dx2(1:10,24,10)
     . 031, 052, 059, 057, 047, 045, 042, 029, 031, 037, ! dx2(1:10,25,10)
     .-003, 003, 008, 018, 008, 005, 007,-010,-010,-004, ! dx2(1:10,26,10)
     . 021, 014, 014, 025, 021, 013, 009, 022, 019, 000, ! dx2(1:10,27,10)
     . 015, 007, 003, 015, 013, 002,-002, 025, 018, 000, ! dx2(1:10,28,10)
     . 009, 000,-008, 007, 011, 007,-008, 036, 024,-006, ! dx2(1:10,29,10)
     . 004, 007,-007, 007, 010,-011,-010, 049, 032,-005, ! dx2(1:10,30,10)
     . 023, 000,-024,-002, 009,-009,-004, 057, 030, 004, ! dx2(1:10,31,10)
     .-008,-023,-029,-015,-004,-033,-024, 051, 016,-019, ! dx2(1:10,32,10)
     . 019, 008,-014, 006, 012,-003, 011, 061, 024, 022, ! dx2(1:10,33,10)
     . 010, 009, 004, 014, 021, 021, 019, 049, 022, 015, ! dx2(1:10,34,10)
     . 032, 022, 022, 023, 031, 046, 036, 034, 034, 027, ! dx2(1:10,35,10)
     . 035, 021, 052, 044, 040, 082, 046, 016, 038, 045, ! dx2(1:10,36,10)
     . 069, 074, 106, 079, 073, 066, 075,-014, 044, 071, ! dx2(1:10,37,10)
     . 058, 010, 063, 052, 024, 021, 030,-054,-001, 031, ! dx2(1:10,38,10)
     . 028, 005, 029, 009, 005, 015, 015, 009,-022, 007, ! dx2(1:10, 1,11)
     .-019,-011, 003, 004, 009, 008, 004, 001,-028, 007, ! dx2(1:10, 2,11)
     .-017, 000, 006,-005, 003, 009, 016,-014, 001, 001, ! dx2(1:10, 3,11)
     .-024,-002, 001,-003, 005,-002, 010,-026, 005, 002, ! dx2(1:10, 4,11)
     .-027, 010, 001,-009, 008, 000, 004,-017, 023, 002, ! dx2(1:10, 5,11)
     .-008, 002, 005,-011, 010, 004, 010, 002, 032, 009, ! dx2(1:10, 6,11)
     . 001, 006, 008, 000, 022, 009, 008, 029, 039, 004, ! dx2(1:10, 7,11)
     .-018,-019,-029,-031,-015,-028,-025,-006,-001,-036, ! dx2(1:10, 8,11)
     . 001,-008, 000, 001, 005, 000,-015, 050, 013,-004, ! dx2(1:10, 9,11)
     .-010, 008, 000,-009, 003,-001,-012, 060, 015,-008, ! dx2(1:10,10,11)
     .-008,-005,-008,-023,-006,-002,-020, 053,-002,-005, ! dx2(1:10,11,11)
     . 020, 018, 005,-016, 008, 011,-006, 053, 008, 002, ! dx2(1:10,12,11)
     .-006, 014, 006,-027, 001, 012,-004, 031,-005, 005, ! dx2(1:10,13,11)
     .-028,-014,-023,-050,-025,-025,-027, 007,-034,-021, ! dx2(1:10,14,11)
     .-013,-006,-011,-017,-015,-016,-012,-003,-019,-009, ! dx2(1:10,15,11)
     .-010,-008,-005,-008,-013,-010,-005,-028,-026,-008, ! dx2(1:10,16,11)
     .-004,-010,-006, 000,-010,-006, 001,-037,-026, 003, ! dx2(1:10,17,11)
     .-001, 004, 004, 002,-005, 003, 016,-044,-009, 009, ! dx2(1:10,18,11)
     . 016, 005, 013,-002, 009, 017, 027,-051,-014, 013, ! dx2(1:10,19,11)
     .-007,-018,-013,-020,-016,-011, 004,-078,-031,-011, ! dx2(1:10,20,11)
     .-018,-013,-005,-007,-018,-016, 006,-081,-032,-003, ! dx2(1:10,21,11)
     .-004,-004,-005, 000,-016,-017, 002,-074,-030,-007, ! dx2(1:10,22,11)
     .-017,-006, 000, 010,-013,-006, 006,-053,-025, 004, ! dx2(1:10,23,11)
     .-005, 008, 001, 013, 000,-010, 010,-033,-019,-008, ! dx2(1:10,24,11)
     . 022, 014, 018, 027, 010, 016, 009, 000, 000,-005, ! dx2(1:10,25,11)
     . 000,-006,-003, 005,-007,-011,-007,-023,-021,-021, ! dx2(1:10,26,11)
     .-012,-005,-002, 004, 006,-002,-011, 001,-003,-018, ! dx2(1:10,27,11)
     . 001,-008,-013,-005,-001,-005,-020, 007, 002,-027, ! dx2(1:10,28,11)
     .-008,-019,-029,-007,-013,-018,-028, 021, 004,-024, ! dx2(1:10,29,11)
     . 001,-016,-034,-010, 000,-031,-025, 028, 012,-023, ! dx2(1:10,30,11)
     .-006,-020,-038,-014,-009,-031,-027, 038, 006,-008, ! dx2(1:10,31,11)
     .-028,-049,-076,-050,-041,-060,-057, 008,-020,-047, ! dx2(1:10,32,11)
     .-033,-047,-060,-040,-029,-046,-039, 016,-022,-037, ! dx2(1:10,33,11)
     .-021,-035,-039,-027,-031,-019,-025, 005,-018,-022, ! dx2(1:10,34,11)
     .-029,-019,-021,-014,-013, 007,-009,-005,-011,-018, ! dx2(1:10,35,11)
     . 016,-011, 009, 002,-004, 027, 003,-026,-002, 011, ! dx2(1:10,36,11)
     .-018, 013, 051, 023, 025, 017, 024,-063,-009, 025, ! dx2(1:10,37,11)
     . 046,-001, 056, 018, 023, 023, 021,-044,-011, 012, ! dx2(1:10,38,11)
     . 000, 027,-022, 021, 013, 031, 014, 000,-015, 052, ! dx2(1:10, 1,12)
     .-002,-004,-011, 006,-003, 019, 006,-012,-027, 013, ! dx2(1:10, 2,12)
     .-024,-003, 001, 003, 005, 014, 014,-014,-001, 022, ! dx2(1:10, 3,12)
     .-020,-005, 000,-006, 004, 007,-001,-016, 006, 003, ! dx2(1:10, 4,12)
     .-013,-007,-004,-003, 003, 002, 001,-007, 016, 002, ! dx2(1:10, 5,12)
     .-014, 018, 019, 015, 027, 018, 017, 016, 042, 012, ! dx2(1:10, 6,12)
     . 005, 014, 009, 020, 016, 008, 010, 042, 039, 009, ! dx2(1:10, 7,12)
     .-053,-040,-025,-010,-021,-033,-034, 000,-010,-039, ! dx2(1:10, 8,12)
     .-012,-006, 003,-006, 002,-003,-008, 053, 017,-007, ! dx2(1:10, 9,12)
     .-011,-006, 003,-018, 000, 004,-014, 059, 007,-014, ! dx2(1:10,10,12)
     .-011,-006,-006,-028,-007,-001,-020, 053,-002,-009, ! dx2(1:10,11,12)
     . 003, 016, 016,-011, 013, 011, 002, 057, 007, 008, ! dx2(1:10,12,12)
     . 027, 025, 022, 011, 016, 019, 014, 048, 018, 015, ! dx2(1:10,13,12)
     .-009,-013,-016,-022,-022,-018,-026, 006,-024,-020, ! dx2(1:10,14,12)
     . 014, 021, 017, 012, 010, 011, 019, 016, 000, 008, ! dx2(1:10,15,12)
     .-015, 006, 004,-009,-005, 002, 001,-017,-018, 003, ! dx2(1:10,16,12)
     .-004, 000, 002,-004,-001, 007, 012,-032,-011, 005, ! dx2(1:10,17,12)
     . 006, 005, 013,-007, 005, 019, 021,-040,-014, 013, ! dx2(1:10,18,12)
     . 014, 012, 012, 018, 008, 013, 024,-055,-014, 022, ! dx2(1:10,19,12)
     .-013,-015,-009,-009,-022,-010,-002,-076,-038, 000, ! dx2(1:10,20,12)
     . 002, 000,-002, 005,-009,-007, 006,-073,-030,-003, ! dx2(1:10,21,12)
     .-008,-013,-005, 007,-013,-003, 006,-068,-031,-001, ! dx2(1:10,22,12)
     . 010,-004,-010, 010,-004,-009, 003,-048,-031,-006, ! dx2(1:10,23,12)
     . 000,-001, 000, 021, 005, 005, 003,-020,-019,-003, ! dx2(1:10,24,12)
     . 020, 021, 000, 014, 020, 003, 004,-005,-014, 015, ! dx2(1:10,25,12)
     .-012,-002,-013, 000, 002,-013,-017,-026,-027,-013, ! dx2(1:10,26,12)
     . 025, 005,-010, 011, 014, 006,-012, 000, 000,-003, ! dx2(1:10,27,12)
     . 002,-006,-013,-001, 012, 007,-017, 013, 006,-014, ! dx2(1:10,28,12)
     . 000,-017,-030,-008,-003,-005,-028, 014, 006,-018, ! dx2(1:10,29,12)
     . 004, 000,-012, 005, 008, 001,-009, 042, 030,-004, ! dx2(1:10,30,12)
     .-005,-019,-036,-016,-007,-027,-022, 035, 014,-015, ! dx2(1:10,31,12)
     .-059,-056,-069,-051,-036,-068,-054, 005,-015,-046, ! dx2(1:10,32,12)
     .-022,-029,-048,-026,-026,-043,-023, 023,-009,-019, ! dx2(1:10,33,12)
     .-025,-041,-045,-023,-024,-029,-019, 005,-020,-034, ! dx2(1:10,34,12)
     .-010,-016,-005,-001,-012, 007,-004,-003,-010, 000, ! dx2(1:10,35,12)
     .-003, 001, 023, 010, 006, 042, 020,-020,-006, 002, ! dx2(1:10,36,12)
     . 017, 012, 071, 036, 016, 020, 029,-069,-012, 026, ! dx2(1:10,37,12)
     . 016, 029, 078, 038, 026, 023, 033,-078,-005, 039, ! dx2(1:10,38,12)
     .-019,-006,-018, 015, 003, 033, 001,-023,-042, 005, ! dx2(1:10, 1,13)
     .-005, 000,-024, 001,-003, 013,-004,-031,-043, 010, ! dx2(1:10, 2,13)
     .-026, 006, 002, 003, 009, 020, 012,-015,-002, 019, ! dx2(1:10, 3,13)
     .-015, 000,-008,-005, 000, 009, 000,-025, 000, 003, ! dx2(1:10, 4,13)
     .-025, 005, 002, 008, 008, 011, 000,-006, 018, 006, ! dx2(1:10, 5,13)
     . 004, 019, 016, 034, 027, 023, 021, 026, 042, 014, ! dx2(1:10, 6,13)
     .-001, 014, 032, 035, 031, 013, 010, 046, 040, 012, ! dx2(1:10, 7,13)
     .-045,-027,-014,-010,-017,-024,-026, 011, 000,-027, ! dx2(1:10, 8,13)
     .-021,-010, 003,-004, 009, 010,-002, 050, 018,-004, ! dx2(1:10, 9,13)
     .-019,-014, 000,-017, 000, 000,-012, 063, 008,-010, ! dx2(1:10,10,13)
     .-019,-010,-004,-018, 000, 000,-010, 055, 000,-008, ! dx2(1:10,11,13)
     . 022, 020, 024, 010, 014, 019, 007, 066, 021, 009, ! dx2(1:10,12,13)
     . 017, 038, 026, 029, 020, 019, 021, 050, 015, 026, ! dx2(1:10,13,13)
     .-012,-005, 000,-009,-009,-010,-011, 020,-010,-014, ! dx2(1:10,14,13)
     . 004, 015, 019, 001, 002, 008, 011, 008, 000, 009, ! dx2(1:10,15,13)
     . 001, 016, 010,-016, 000, 000, 016,-014,-011, 005, ! dx2(1:10,16,13)
     . 005, 020, 017,-007, 006, 017, 018,-023,-004, 019, ! dx2(1:10,17,13)
     . 020, 027, 021, 015, 015, 028, 031,-026,-002, 032, ! dx2(1:10,18,13)
     . 019, 005, 014, 027, 013, 021, 023,-049,-011, 015, ! dx2(1:10,19,13)
     .-015,-014,-012,-004,-016,-012,-002,-078,-038,-003, ! dx2(1:10,20,13)
     . 004,-006, 000, 018,-006,-001, 008,-066,-028, 005, ! dx2(1:10,21,13)
     . 002, 004, 000, 009,-005,-005, 000,-062,-027, 000, ! dx2(1:10,22,13)
     . 000, 006,-001, 019, 004, 007, 009,-036,-024,-003, ! dx2(1:10,23,13)
     . 008, 009,-004, 014, 010, 003, 007,-019,-020, 012, ! dx2(1:10,24,13)
     . 018, 019, 007, 026, 034, 022, 003, 006,-001, 000, ! dx2(1:10,25,13)
     . 010, 001,-020, 002, 003,-003,-018,-019,-024,-014, ! dx2(1:10,26,13)
     . 005, 002,-013, 002, 021, 013,-007, 002, 000,-005, ! dx2(1:10,27,13)
     . 012,-004,-013, 001, 014, 015,-016, 018, 014, 000, ! dx2(1:10,28,13)
     .-003,-005,-022,-011, 011, 006,-013, 025, 015,-014, ! dx2(1:10,29,13)
     . 005,-011,-028,-002, 007, 001,-009, 039, 030, 000, ! dx2(1:10,30,13)
     .-008,-003,-028,-014, 000,-020,-013, 042, 022,-010, ! dx2(1:10,31,13)
     .-060,-043,-071,-040,-037,-056,-045, 013,-011,-045, ! dx2(1:10,32,13)
     .-021,-022,-043,-024,-017,-036,-020, 020,-008,-015, ! dx2(1:10,33,13)
     .-026,-024,-026,-021,-023,-036,-018, 013,-016,-017, ! dx2(1:10,34,13)
     .-017,-012,-001,-004,-009, 007, 002,-003,-014,-011, ! dx2(1:10,35,13)
     . 023, 000, 030, 020, 016, 037, 021,-022,-006, 009, ! dx2(1:10,36,13)
     . 020, 039, 091, 034, 034, 030, 038,-070,-007, 032, ! dx2(1:10,37,13)
     . 010, 018, 096, 039, 029, 016, 021,-071,-027,-014, ! dx2(1:10,38,13)
     .-003, 040,-008, 005, 020, 022, 018,-032,-039, 034, ! dx2(1:10, 1,14)
     .-004,-002,-027,-010, 006, 026, 006,-038,-049, 020, ! dx2(1:10, 2,14)
     .-029, 009,-018,-006,-001, 011, 002,-033,-014, 007, ! dx2(1:10, 3,14)
     .-033,-002, 000,-004, 011, 010, 003,-016, 000, 005, ! dx2(1:10, 4,14)
     . 001, 006, 006, 022, 006, 017, 002,-001, 018, 006, ! dx2(1:10, 5,14)
     .-013, 013, 014, 035, 024, 014, 013, 019, 031, 009, ! dx2(1:10, 6,14)
     .-010, 009, 025, 025, 023, 025, 019, 044, 040, 013, ! dx2(1:10, 7,14)
     .-049,-026,-024,-024,-016,-016,-027, 001,-001,-023, ! dx2(1:10, 8,14)
     .-017,-006, 006,-008, 007, 006,-002, 051, 020,-002, ! dx2(1:10, 9,14)
     .-018,-006, 010,-011, 009, 011, 000, 062, 018, 000, ! dx2(1:10,10,14)
     .-007,-006, 008,-006, 000, 006,-005, 057, 010,-004, ! dx2(1:10,11,14)
     .-013, 020, 023, 025, 016, 018, 009, 070, 024, 014, ! dx2(1:10,12,14)
     . 026, 034, 040, 021, 023, 022, 025, 055, 024, 022, ! dx2(1:10,13,14)
     .-017,-004, 009,-002,-013,-007,-004, 026,-005,-011, ! dx2(1:10,14,14)
     . 003, 021, 023,-016, 005, 000, 011, 009,-002, 011, ! dx2(1:10,15,14)
     . 009, 014, 017,-015, 004, 007, 011,-007,-009, 005, ! dx2(1:10,16,14)
     . 009, 012, 023, 008, 006, 017, 016,-022,-002, 018, ! dx2(1:10,17,14)
     . 020, 021, 020, 029, 018, 025, 032,-025, 004, 024, ! dx2(1:10,18,14)
     . 017, 022, 029, 037, 023, 020, 030,-039,-012, 033, ! dx2(1:10,19,14)
     .-021,-012,-006, 010,-007,-009, 000,-064,-034, 007, ! dx2(1:10,20,14)
     . 002, 002, 000, 016, 000, 006, 006,-062,-023, 001, ! dx2(1:10,21,14)
     . 004, 009, 007, 016, 005,-002, 009,-048,-020, 014, ! dx2(1:10,22,14)
     . 007, 005,-003, 014, 010, 003, 007,-034,-023, 002, ! dx2(1:10,23,14)
     . 012, 011, 002, 024, 024, 013, 005,-012,-013, 008, ! dx2(1:10,24,14)
     . 006, 023,-008, 018, 032, 021, 004, 000, 000, 013, ! dx2(1:10,25,14)
     .-003,-008,-022, 005, 018, 000,-011,-016,-018,-003, ! dx2(1:10,26,14)
     . 003, 010,-016, 002, 021, 013,-016, 007, 006,-008, ! dx2(1:10,27,14)
     . 000,-001,-017,-002, 015, 014,-010, 023, 012,-004, ! dx2(1:10,28,14)
     . 011,-003,-029,-012, 008, 007,-014, 026, 023,-005, ! dx2(1:10,29,14)
     .-007,-011,-022,-009, 011, 011,-008, 041, 033,-002, ! dx2(1:10,30,14)
     . 006,-003,-027,-004, 005,-014, 000, 052, 031,-006, ! dx2(1:10,31,14)
     .-019,-051,-063,-043,-035,-049,-043, 010,-010,-051, ! dx2(1:10,32,14)
     .-010,-017,-029,-020,-015,-040,-015, 029,-007,-009, ! dx2(1:10,33,14)
     .-022,-013,-014,-009,-011,-026,-008, 010,-013,-024, ! dx2(1:10,34,14)
     . 003,-002, 007,-001,-005, 005, 003,-005,-018,-005, ! dx2(1:10,35,14)
     . 001, 015, 047, 020, 019, 034, 027,-024,-003, 019, ! dx2(1:10,36,14)
     . 024, 019, 078, 033, 019, 025, 026,-085,-029,-002, ! dx2(1:10,37,14)
     .-001, 016, 091, 027, 031, 013, 035,-095,-022, 033, ! dx2(1:10,38,14)
     . 012, 011,-039,-004, 016, 033, 002,-030,-032, 031, ! dx2(1:10, 1,15)
     .-022, 017,-043,-005, 002, 021, 001,-043,-046, 034, ! dx2(1:10, 2,15)
     .-005, 000,-019,-006, 000, 019, 006,-036,-012, 012, ! dx2(1:10, 3,15)
     .-044,-002,-019, 000,-006, 006,-011,-037,-011,-007, ! dx2(1:10, 4,15)
     .-020,-003, 000, 023, 005, 011, 003,-007, 011, 011, ! dx2(1:10, 5,15)
     .-003, 019, 027, 038, 021, 031, 013, 019, 036, 014, ! dx2(1:10, 6,15)
     .-010, 000, 011, 009, 024, 011, 009, 037, 032, 007, ! dx2(1:10, 7,15)
     .-049,-036,-017,-022,-021,-025,-026,-008,-005,-032, ! dx2(1:10, 8,15)
     .-024,-007, 000,-003, 010, 008,-005, 045, 019, 000, ! dx2(1:10, 9,15)
     .-018, 001, 013, 008, 010, 006, 001, 057, 022, 004, ! dx2(1:10,10,15)
     .-018,-004, 006, 006, 001, 006,-006, 065, 015, 004, ! dx2(1:10,11,15)
     . 009, 019, 033, 027, 016, 022, 024, 075, 030, 013, ! dx2(1:10,12,15)
     . 017, 017, 041, 010, 022, 019, 021, 059, 026, 020, ! dx2(1:10,13,15)
     .-007, 003, 012,-019,-006,-006, 001, 027,-005, 000, ! dx2(1:10,14,15)
     . 006, 018, 031,-013, 007, 001, 012, 017, 001, 005, ! dx2(1:10,15,15)
     . 000, 018, 023, 004, 004, 002, 015,-008,-003, 008, ! dx2(1:10,16,15)
     . 022, 017, 018, 017, 011, 014, 022,-017,-009, 017, ! dx2(1:10,17,15)
     . 019, 029, 029, 040, 019, 022, 029,-021, 004, 034, ! dx2(1:10,18,15)
     . 009, 023, 023, 039, 022, 025, 032,-029,-002, 028, ! dx2(1:10,19,15)
     . 005, 004,-001, 014, 000, 002, 000,-058,-020, 003, ! dx2(1:10,20,15)
     . 001, 009, 005, 004, 002,-008, 007,-052,-025, 009, ! dx2(1:10,21,15)
     . 009, 008, 003, 015, 015, 004, 010,-041,-015, 007, ! dx2(1:10,22,15)
     . 005, 007,-004, 016, 015, 009, 004,-030,-016, 015, ! dx2(1:10,23,15)
     . 009, 007, 000, 021, 022, 013, 008,-011,-006, 011, ! dx2(1:10,24,15)
     . 022, 017,-004, 017, 035, 020, 002, 004, 005, 012, ! dx2(1:10,25,15)
     .-001, 005,-031,-002, 008, 000,-018,-018,-015,-003, ! dx2(1:10,26,15)
     . 008,-006,-021,-005, 017, 019,-015, 010, 008,-004, ! dx2(1:10,27,15)
     . 000,-004,-031,-008, 014, 017,-019, 025, 017, 002, ! dx2(1:10,28,15)
     . 013,-007,-032,-013, 006, 007,-012, 028, 025,-008, ! dx2(1:10,29,15)
     . 006, 012,-014,-010, 016, 019, 003, 055, 044, 005, ! dx2(1:10,30,15)
     .-007,-010,-014,-002, 003,-012, 000, 051, 027, 003, ! dx2(1:10,31,15)
     .-034,-025,-056,-038,-029,-043,-040, 022, 000,-026, ! dx2(1:10,32,15)
     . 000,-017,-019,-014,-017,-038,-014, 028,-008,-019, ! dx2(1:10,33,15)
     .-009,-005,-002,-005,-011,-036, 000, 013,-013,-017, ! dx2(1:10,34,15)
     . 005, 000, 009, 000,-004, 003, 002,-008,-012,-002, ! dx2(1:10,35,15)
     . 003,-003, 046, 017, 012, 028, 015,-037,-018,-002, ! dx2(1:10,36,15)
     . 002, 002, 090, 030, 023, 016, 025,-098,-032, 004, ! dx2(1:10,37,15)
     .-001, 021, 092, 039, 028, 000, 026,-093,-031,-007, ! dx2(1:10,38,15)
     .-005,-003,-066,-026,-008, 035,-014,-066,-062, 013, ! dx2(1:10, 1,16)
     .-025, 007,-067,-048,-004, 013,-013,-071,-060, 020, ! dx2(1:10, 2,16)
     .-014, 013,-031, 006, 004, 022, 011,-036,-017, 016, ! dx2(1:10, 3,16)
     .-012, 002,-018, 008, 001, 013,-006,-046,-012, 007, ! dx2(1:10, 4,16)
     .-034,-016,-017, 009,-012, 000,-008,-034,-005,-005, ! dx2(1:10, 5,16)
     .-023, 015, 012, 016, 023, 019, 013, 005, 031, 006, ! dx2(1:10, 6,16)
     .-021, 006, 024, 017, 020, 018, 012, 030, 025, 006, ! dx2(1:10, 7,16)
     .-071,-040,-032,-031,-023,-028,-041,-017,-016,-042, ! dx2(1:10, 8,16)
     .-017,-002, 014, 000, 007, 009, 001, 041, 023,-001, ! dx2(1:10, 9,16)
     .-025,-005, 009, 012, 006, 003, 000, 054, 020,-009, ! dx2(1:10,10,16)
     .-015, 005, 017, 014, 007, 007, 002, 059, 024, 003, ! dx2(1:10,11,16)
     .-001, 017, 032, 008, 017, 021, 020, 073, 028, 017, ! dx2(1:10,12,16)
     . 007, 046, 055,-001, 022, 018, 030, 061, 032, 023, ! dx2(1:10,13,16)
     .-007, 001, 014,-034,-008,-008,-004, 030, 002,-003, ! dx2(1:10,14,16)
     . 000, 020, 037, 003, 002, 005, 016, 019, 007, 008, ! dx2(1:10,15,16)
     . 007, 014, 030, 014, 007, 002, 014, 005,-001, 010, ! dx2(1:10,16,16)
     .-006, 013, 025, 025, 009, 006, 018,-009, 000, 018, ! dx2(1:10,17,16)
     . 037, 031, 030, 038, 023, 022, 033,-011, 006, 029, ! dx2(1:10,18,16)
     . 013, 024, 024, 033, 025, 019, 027,-025, 000, 030, ! dx2(1:10,19,16)
     . 002,-003, 003, 005, 000,-011, 003,-050,-030, 008, ! dx2(1:10,20,16)
     .-001, 006, 002, 013, 003, 003, 002,-046,-012, 003, ! dx2(1:10,21,16)
     . 004, 016, 005, 015, 013, 006, 011,-034,-015, 011, ! dx2(1:10,22,16)
     . 016, 012,-008, 015, 012, 001,-003,-029,-012,-001, ! dx2(1:10,23,16)
     . 002, 009,-001, 012, 025, 008, 005,-014,-004, 011, ! dx2(1:10,24,16)
     . 017, 016,-010, 015, 025, 031,-001, 011, 009, 009, ! dx2(1:10,25,16)
     .-008,-006,-026,-005, 009, 003,-024,-016,-009,-008, ! dx2(1:10,26,16)
     .-002, 001,-029,-004, 017, 013,-014, 014, 013,-002, ! dx2(1:10,27,16)
     .-016,-003,-030,-015, 013, 019,-014, 032, 026, 000, ! dx2(1:10,28,16)
     . 008,-001,-032,-012, 005, 014,-015, 036, 028,-003, ! dx2(1:10,29,16)
     . 006, 002,-018,-003, 015, 013, 002, 053, 041, 014, ! dx2(1:10,30,16)
     .-004, 004,-010,-007,-001,-009,-007, 054, 029,-005, ! dx2(1:10,31,16)
     .-030,-030,-036,-034,-028,-034,-029, 033,-004,-026, ! dx2(1:10,32,16)
     .-019,-013,-014,-008,-011,-031,-006, 029,-008,-009, ! dx2(1:10,33,16)
     . 014,-009, 000,-014,-011,-036,-008, 006,-024,-016, ! dx2(1:10,34,16)
     .-005,-023, 020, 000,-006,-014,-004,-020,-029,-014, ! dx2(1:10,35,16)
     . 000, 000, 040, 012, 006, 020, 011,-046,-022, 002, ! dx2(1:10,36,16)
     . 014,-003, 097, 017, 011, 011, 010,-108,-043,-034, ! dx2(1:10,37,16)
     .-001, 000, 100, 020, 006, 023, 005,-112,-042,-004, ! dx2(1:10,38,16)
     .-011, 009,-088,-044,-002, 032,-012,-085,-070, 019, ! dx2(1:10, 1,17)
     .-015,-006,-103,-069,-021, 006,-026,-100,-078,-007, ! dx2(1:10, 2,17)
     .-020, 007,-032, 000,-002, 023, 000,-059,-029, 026, ! dx2(1:10, 3,17)
     .-021,-008,-042, 004,-010, 007,-004,-054,-024,-008, ! dx2(1:10, 4,17)
     .-015,-009,-012,-012, 002, 005, 000,-046, 000,-004, ! dx2(1:10, 5,17)
     .-028,-001, 002, 001, 010, 015, 000,-020, 014,-003, ! dx2(1:10, 6,17)
     .-036,-018,-001, 001, 007, 001,-004, 009, 025, 000, ! dx2(1:10, 7,17)
     .-065,-046,-020,-026,-025,-027,-037,-035,-016,-041, ! dx2(1:10, 8,17)
     .-033,-009, 000, 004, 006,-006,-009, 033, 019,-006, ! dx2(1:10, 9,17)
     .-028, 002, 007, 022, 000,-001, 000, 051, 024,-007, ! dx2(1:10,10,17)
     .-024,-002, 017,-006, 004, 000, 003, 058, 022,-005, ! dx2(1:10,11,17)
     .-012, 015, 024,-015, 004, 002, 010, 061, 027, 006, ! dx2(1:10,12,17)
     . 021, 021, 051, 000, 021, 018, 028, 057, 031, 018, ! dx2(1:10,13,17)
     .-025,-007, 020,-025,-017,-019,-008, 025,-004,-017, ! dx2(1:10,14,17)
     .-008, 011, 024, 002,-005,-013, 006, 014, 000, 001, ! dx2(1:10,15,17)
     . 008, 013, 030, 019, 000,-005, 013, 007,-001, 008, ! dx2(1:10,16,17)
     . 019, 030, 036, 028, 015, 007, 024, 001, 009, 027, ! dx2(1:10,17,17)
     . 015, 023, 025, 027, 021, 013, 022,-007, 007, 028, ! dx2(1:10,18,17)
     . 029, 033, 023, 026, 020, 021, 020,-015, 011, 034, ! dx2(1:10,19,17)
     . 001, 006,-003, 002, 000,-009,-006,-042,-013, 011, ! dx2(1:10,20,17)
     . 001, 008, 004, 009, 004,-001, 000,-040,-018, 007, ! dx2(1:10,21,17)
     . 018, 009, 003, 014, 005,-004, 000,-032,-005, 008, ! dx2(1:10,22,17)
     .-017,-011,-002, 001, 006, 004,-012,-026,-012, 006, ! dx2(1:10,23,17)
     .-005, 001,-012, 006, 013, 008,-003,-005, 003, 002, ! dx2(1:10,24,17)
     . 006, 000,-010,-004, 024, 020,-001, 004, 017, 012, ! dx2(1:10,25,17)
     .-027,-022,-039,-019, 000,-004,-029,-014,-011,-016, ! dx2(1:10,26,17)
     . 005,-001,-037,-013, 006, 021,-016, 019, 022, 002, ! dx2(1:10,27,17)
     . 005, 000,-030,-014, 011, 016,-018, 032, 030,-003, ! dx2(1:10,28,17)
     .-005,-001,-024,-010, 003, 019,-013, 043, 038, 002, ! dx2(1:10,29,17)
     . 015, 006,-016,-002, 017, 017, 003, 059, 045, 012, ! dx2(1:10,30,17)
     . 011, 008, 000,-003, 000, 004, 005, 055, 025, 003, ! dx2(1:10,31,17)
     .-022,-025,-042,-031,-031,-035,-030, 025,-009,-033, ! dx2(1:10,32,17)
     . 000, 002, 000,-016,-018,-038,-010, 022,-014,-015, ! dx2(1:10,33,17)
     .-017,-013, 003,-010,-023,-047,-013,-001,-029,-025, ! dx2(1:10,34,17)
     . 007, 000, 025, 000,-007,-016,-005,-027,-027,-014, ! dx2(1:10,35,17)
     .-023,-011, 050,-002,-004, 005,-003,-053,-037,-026, ! dx2(1:10,36,17)
     .-025,-003, 095, 009, 002, 001, 007,-117,-055,-021, ! dx2(1:10,37,17)
     .-001, 003, 093, 009,-008,-018,-001,-123,-059,-015, ! dx2(1:10,38,17)
     .-012,-020,-131,-098,-038, 007,-032,-136,-109,-007, ! dx2(1:10, 1,18)
     .-047,-042,-138,-090,-053,-017,-044,-138,-114, 000, ! dx2(1:10, 2,18)
     . 000, 001,-089,-022,-022, 005,-018,-098,-059,-006, ! dx2(1:10, 3,18)
     .-039,-025,-066,-051,-026,-010,-019,-098,-039,-015, ! dx2(1:10, 4,18)
     .-059,-012,-045,-042,-024,-012,-026,-081,-025,-016, ! dx2(1:10, 5,18)
     .-025, 000,-009,-003, 012, 006, 011,-040, 022, 007, ! dx2(1:10, 6,18)
     .-026, 003, 020, 013, 016, 000, 000,-010, 024, 005, ! dx2(1:10, 7,18)
     .-065,-065,-053,-042,-039,-043,-053,-061,-029,-032, ! dx2(1:10, 8,18)
     .-052,-012,-007, 002,-013,-021,-017, 007, 011,-031, ! dx2(1:10, 9,18)
     .-015,-013, 009,-015,-006,-008,-010, 037, 014,-007, ! dx2(1:10,10,18)
     .-024,-003, 014,-034,-013,-006,-002, 042, 017,-009, ! dx2(1:10,11,18)
     .-003, 004, 026,-008, 000,-003, 004, 045, 015,-007, ! dx2(1:10,12,18)
     .-008, 028, 030, 002,-001,-004, 012, 041, 023, 006, ! dx2(1:10,13,18)
     .-047,-016, 004,-028,-034,-037,-025, 008,-011,-023, ! dx2(1:10,14,18)
     .-023,-018, 017,-003,-017,-035,-007, 015,-008,-016, ! dx2(1:10,15,18)
     .-035,-006, 009,-009,-021,-031,-012, 005,-009,-004, ! dx2(1:10,16,18)
     .-009, 001, 015, 004,-009,-021, 000,-004,-009, 001, ! dx2(1:10,17,18)
     . 035, 014, 026, 019, 005, 000, 011, 010, 006, 015, ! dx2(1:10,18,18)
     . 003, 020, 018, 018, 011, 004, 009,-005, 004, 012, ! dx2(1:10,19,18)
     .-014,-015,-005, 001,-018,-010,-010,-027,-017, 002, ! dx2(1:10,20,18)
     .-009,-011,-011,-002,-010,-016,-020,-036,-015,-013, ! dx2(1:10,21,18)
     .-023,-016, 000,-005,-004, 002,-017,-029,-009, 009, ! dx2(1:10,22,18)
     .-012, 000,-020,-013,-008,-018,-022,-025, 000,-001, ! dx2(1:10,23,18)
     .-021,-013,-017,-021,-005,-003,-024,-020, 003,-002, ! dx2(1:10,24,18)
     .-022, 004,-026,-012,-003, 004,-019, 011, 019,-009, ! dx2(1:10,25,18)
     .-050,-017,-053,-040,-027,-015,-043,-013, 000,-027, ! dx2(1:10,26,18)
     .-014,-013,-025,-031,-009,-002,-025, 017, 021,-018, ! dx2(1:10,27,18)
     .-007, 000,-037,-014,-009, 008,-021, 029, 037,-008, ! dx2(1:10,28,18)
     . 021, 001,-021,-022,-007, 000,-025, 039, 030, 002, ! dx2(1:10,29,18)
     . 019, 005,-004,-012, 002, 005,-010, 052, 049,-009, ! dx2(1:10,30,18)
     .-006, 014,-002,-004,-008,-026,-009, 047, 005, 008, ! dx2(1:10,31,18)
     .-046,-009,-042,-051,-051,-064,-043, 006,-026,-043, ! dx2(1:10,32,18)
     .-021,-019, 002,-029,-018,-042,-016, 011,-024,-024, ! dx2(1:10,33,18)
     .-027,-017, 012,-028,-018,-052,-018,-019,-032,-034, ! dx2(1:10,34,18)
     .-037,-033, 026,-027,-026,-046,-025,-040,-052,-051, ! dx2(1:10,35,18)
     .-017,-012, 055,-018,-023,-021,-017,-091,-063,-035, ! dx2(1:10,36,18)
     .-026,-053, 092,-009,-026,-014,-028,-138,-074,-058, ! dx2(1:10,37,18)
     .-127,-055, 081,-014,-011,-012,-024,-158,-074,-079/ ! dx2(1:10,38,18)
 
      data dy1 /
     .-005,-001,-098,-089,-044, 072,-002,-064,-066, 031, ! dy1(1:10, 1, 1)
     .-021,-004,-106,-078,-064, 049, 000,-093,-050,-019, ! dy1(1:10, 2, 1)
     .-008,-031,-083,-088,-073, 021,-024,-074,-048,-012, ! dy1(1:10, 3, 1)
     .-011,-010,-065,-053,-061, 023,-015,-060,-022,-029, ! dy1(1:10, 4, 1)
     . 002,-021,-052,-044,-054, 025,-010,-037,-001,-013, ! dy1(1:10, 5, 1)
     .-020,-005,-039,-036,-044, 006,-020,-020, 000,-021, ! dy1(1:10, 6, 1)
     . 024,-005,-017, 001,-033, 026, 005, 009, 030,-005, ! dy1(1:10, 7, 1)
     .-005,-028,-037,-025,-047, 009,-016,-011, 003,-031, ! dy1(1:10, 8, 1)
     .-033,-024,-030,-032,-057,-007,-034,-013,-007,-028, ! dy1(1:10, 9, 1)
     . 001,-013,-015,-012,-034, 000,-013, 006, 011,-027, ! dy1(1:10,10, 1)
     .-010,-006,-006,-005,-028,-004,-010, 010, 008,-017, ! dy1(1:10,11, 1)
     . 000,-021, 002,-019,-034,-007,-018, 000, 000,-025, ! dy1(1:10,12, 1)
     . 001,-016, 006,-006,-017, 007,-005, 018, 005,-004, ! dy1(1:10,13, 1)
     .-027,-023, 000,-019,-036,-014,-024,-001,-024,-039, ! dy1(1:10,14, 1)
     .-036,-036,-016,-021,-039,-024,-031,-018,-031,-040, ! dy1(1:10,15, 1)
     .-015,-014,-007,-022,-025,-014,-022,-012,-039,-041, ! dy1(1:10,16, 1)
     .-019,-039,-010,-014,-018,-014,-027,-021,-035,-019, ! dy1(1:10,17, 1)
     .-032,-027,-015,-023,-018,-022,-028,-034,-048,-033, ! dy1(1:10,18, 1)
     .-054,-042,-012,-023,-034,-038,-035,-044,-057,-037, ! dy1(1:10,19, 1)
     .-044,-039,-025,-024,-037,-039,-040,-046,-056,-049, ! dy1(1:10,20, 1)
     .-043,-038,-024,-040,-020,-034,-038,-044,-052,-046, ! dy1(1:10,21, 1)
     .-022,-040,-020,-017,-023,-029,-017,-037,-035,-028, ! dy1(1:10,22, 1)
     .-041,-028,-025,-030,-016,-032,-017,-043,-033,-020, ! dy1(1:10,23, 1)
     .-023,-027,-007,-010, 000,-020,-010,-030,-014,-016, ! dy1(1:10,24, 1)
     .-002, 005, 020, 003, 003,-005, 001,-013,-001,-003, ! dy1(1:10,25, 1)
     .-030,-015,-009,-015,-019,-015,-020,-033,-014,-006, ! dy1(1:10,26, 1)
     .-001,-017, 017,-013,-003,-016,-005,-017,-010,-017, ! dy1(1:10,27, 1)
     .-006, 016, 020, 000, 011, 000, 016,-003, 012, 002, ! dy1(1:10,28, 1)
     . 010, 030, 024, 013, 007,-003, 018,-010, 016, 015, ! dy1(1:10,29, 1)
     . 029, 021, 018, 008, 015, 008, 021,-009, 011, 014, ! dy1(1:10,30, 1)
     . 024, 055, 035, 020, 007, 023, 036,-006, 032, 044, ! dy1(1:10,31, 1)
     . 020, 042,-002,-002, 002, 008, 014,-031, 005, 014, ! dy1(1:10,32, 1)
     . 008, 007, 002,-022,-018,-014, 004,-049, 010, 012, ! dy1(1:10,33, 1)
     . 009, 059, 004,-006,-007, 007, 019,-052, 009, 021, ! dy1(1:10,34, 1)
     . 022, 020,-008,-015,-009, 003, 026,-065, 013, 026, ! dy1(1:10,35, 1)
     . 048, 043,-013,-029, 001, 023, 034,-061, 034, 036, ! dy1(1:10,36, 1)
     . 045, 059,-011,-024,-002, 014, 057,-064, 041, 040, ! dy1(1:10,37, 1)
     . 040, 037,-030,-073,-018, 002, 027,-104, 013, 008, ! dy1(1:10,38, 1)
     . 029, 043,-032,-014,-013, 055, 030,-034,-008, 005, ! dy1(1:10, 1, 2)
     . 035, 013,-043,-039,-009, 053, 024,-038,-019, 011, ! dy1(1:10, 2, 2)
     . 023, 023,-037,-015,-017, 030, 010,-028, 001, 010, ! dy1(1:10, 3, 2)
     . 023, 006,-028,-013,-017, 032, 011,-019, 007, 010, ! dy1(1:10, 4, 2)
     . 026, 025,-007, 000,-007, 026, 008,-018, 015, 012, ! dy1(1:10, 5, 2)
     . 034, 023, 002, 006, 000, 035, 017,-005, 036, 022, ! dy1(1:10, 6, 2)
     . 035, 041, 031, 014, 018, 035, 018, 012, 036, 026, ! dy1(1:10, 7, 2)
     . 010, 018,-006, 001,-016, 010,-012,-014, 009, 000, ! dy1(1:10, 8, 2)
     . 012, 005, 004,-008,-010,-002,-006,-003, 005,-014, ! dy1(1:10, 9, 2)
     . 006, 012, 006, 008,-008, 007,-008, 016, 002,-002, ! dy1(1:10,10, 2)
     . 003, 006, 017, 005, 002, 012, 000, 024, 016, 000, ! dy1(1:10,11, 2)
     . 010, 014, 020, 019, 007, 017, 001, 032, 017, 002, ! dy1(1:10,12, 2)
     . 004, 023, 024, 018, 012, 016, 007, 033, 014, 004, ! dy1(1:10,13, 2)
     .-021,-019,-008,-018,-017,-014,-025, 005,-007,-014, ! dy1(1:10,14, 2)
     .-002,-004, 001,-006,-009, 000,-013, 006,-019,-012, ! dy1(1:10,15, 2)
     .-021,-017,-002,-012,-007,-006,-012, 001,-020,-001, ! dy1(1:10,16, 2)
     . 002,-001, 000,-001,-004,-005,-012, 005,-025,-017, ! dy1(1:10,17, 2)
     .-018,-011,-002,-006,-003,-009,-015, 003,-021,-012, ! dy1(1:10,18, 2)
     .-010,-013,-013,-006, 003,-011,-008, 008,-022,-020, ! dy1(1:10,19, 2)
     .-025,-018,-010,-016, 002,-019,-015, 002,-028,-013, ! dy1(1:10,20, 2)
     .-022,-027,-017,-020,-010,-026,-017, 003,-023,-031, ! dy1(1:10,21, 2)
     .-036,-029,-013,-019,-007,-019,-024, 002,-023,-017, ! dy1(1:10,22, 2)
     .-015,-013,-006,-006, 000,-015,-011, 005,-007,-019, ! dy1(1:10,23, 2)
     .-021,-015,-004,-007, 000,-013,-013,-002,-001,-016, ! dy1(1:10,24, 2)
     .-005,-008, 017, 009, 016,-002, 006, 006, 010, 007, ! dy1(1:10,25, 2)
     .-015,-008,-007,-011,-010,-023,-013,-013,-005,-026, ! dy1(1:10,26, 2)
     .-001, 009, 018, 013, 015,-001, 003,-014, 003, 003, ! dy1(1:10,27, 2)
     . 013, 004, 031, 019, 009, 003, 005,-013, 010, 015, ! dy1(1:10,28, 2)
     . 017, 019, 037, 022, 026, 014, 022,-006, 017, 017, ! dy1(1:10,29, 2)
     . 026, 037, 038, 025, 021, 019, 026,-008, 017, 029, ! dy1(1:10,30, 2)
     . 034, 032, 031, 038, 031, 022, 027,-003, 021, 038, ! dy1(1:10,31, 2)
     . 016, 020, 029, 001, 008, 012, 016,-014, 008, 023, ! dy1(1:10,32, 2)
     . 017, 024, 009, 012, 010, 009, 013,-021,-001, 010, ! dy1(1:10,33, 2)
     . 021, 002, 005, 000, 010, 013, 016,-021, 009, 010, ! dy1(1:10,34, 2)
     . 028, 036, 004, 000, 010, 012, 022,-017, 005, 018, ! dy1(1:10,35, 2)
     . 023, 038, 000,-009, 003, 020, 026,-020, 007, 026, ! dy1(1:10,36, 2)
     . 021, 017,-023,-014,-002, 034, 031,-030, 001, 021, ! dy1(1:10,37, 2)
     .-022,-001,-047,-030,-026, 010,-002,-056,-021, 026, ! dy1(1:10,38, 2)
     . 029, 017,-033,-012,-004, 059, 016,-006, 007, 064, ! dy1(1:10, 1, 3)
     . 005, 029,-036,-027,-008, 042, 016,-013,-005, 010, ! dy1(1:10, 2, 3)
     . 018, 003,-032,-022,-013, 015, 002,-029,-004, 013, ! dy1(1:10, 3, 3)
     . 015, 011,-010,-005, 000, 005, 005,-017, 011, 002, ! dy1(1:10, 4, 3)
     . 034, 016, 000, 005, 005, 022, 014,-005, 023, 017, ! dy1(1:10, 5, 3)
     . 029, 023, 015, 018, 014, 011, 014,-012, 031, 020, ! dy1(1:10, 6, 3)
     . 020, 029, 028, 026, 018, 022, 013, 006, 026, 017, ! dy1(1:10, 7, 3)
     . 029, 010, 004, 000, 000,-004,-008,-016, 009,-009, ! dy1(1:10, 8, 3)
     . 006, 001, 000, 009,-003,-004,-017,-016,-001, 000, ! dy1(1:10, 9, 3)
     . 013, 001, 012, 010, 004, 000,-006, 000, 008, 000, ! dy1(1:10,10, 3)
     . 007, 016, 019, 022, 016, 011, 001, 011, 011, 004, ! dy1(1:10,11, 3)
     . 021, 015, 018, 019, 015, 011, 008, 014, 016, 008, ! dy1(1:10,12, 3)
     . 005, 005, 017, 016, 014, 013, 008, 022, 012, 000, ! dy1(1:10,13, 3)
     .-002,-002,-001,-001,-005,-002,-011, 005,-007,-011, ! dy1(1:10,14, 3)
     .-011,-015,-007,-007,-005,-011,-017,-001,-018,-022, ! dy1(1:10,15, 3)
     .-003,-004, 000, 002, 000,-001,-009, 007,-018,-012, ! dy1(1:10,16, 3)
     .-009,-004,-002, 002, 006, 000, 000, 009,-011,-008, ! dy1(1:10,17, 3)
     .-003, 000,-006,-002, 007, 000,-005, 021,-014, 000, ! dy1(1:10,18, 3)
     .-021,-025,-013,-014,-004,-017,-013, 024,-019,-021, ! dy1(1:10,19, 3)
     .-010,-012,-015,-020,-007,-015,-011, 024,-016,-013, ! dy1(1:10,20, 3)
     .-036,-017,-010,-009,-001,-011,-011, 024,-016,-013, ! dy1(1:10,21, 3)
     .-016,-009,-009,-014,-004,-018,-011, 028,-010,-022, ! dy1(1:10,22, 3)
     .-020,-014, 002,-016,-003,-019,-004, 024, 000,-009, ! dy1(1:10,23, 3)
     .-002, 006, 000, 001, 012,-008,-004, 018, 012,-005, ! dy1(1:10,24, 3)
     .-009,-009, 016, 006, 013, 004, 005, 000, 014, 003, ! dy1(1:10,25, 3)
     .-013,-023, 000,-005,-003,-015,-014,-013, 000,-010, ! dy1(1:10,26, 3)
     .-004, 004, 012, 004, 000,-003,-004,-021, 005, 002, ! dy1(1:10,27, 3)
     . 022, 014, 025, 022, 020, 004, 011,-010, 017, 001, ! dy1(1:10,28, 3)
     . 025, 018, 033, 027, 024, 011, 015,-008, 020, 025, ! dy1(1:10,29, 3)
     . 017, 020, 031, 028, 017, 018, 020,-010, 019, 022, ! dy1(1:10,30, 3)
     . 021, 028, 040, 023, 027, 023, 027, 004, 020, 024, ! dy1(1:10,31, 3)
     . 014, 006, 008, 010, 004, 010, 012,-010, 010, 011, ! dy1(1:10,32, 3)
     . 014, 034, 013, 007, 005, 005, 011,-005, 003, 008, ! dy1(1:10,33, 3)
     . 019, 032, 024, 011, 012, 010, 020, 010, 003, 014, ! dy1(1:10,34, 3)
     . 007, 014,-001,-005,-003, 015, 010, 007,-001, 012, ! dy1(1:10,35, 3)
     . 023, 012,-004,-004, 004, 014, 015, 013,-012, 019, ! dy1(1:10,36, 3)
     . 005, 008,-022,-029,-021, 011, 013,-019,-025, 017, ! dy1(1:10,37, 3)
     . 012,-008,-054,-039,-031,-010,-011,-036,-049,-015, ! dy1(1:10,38, 3)
     . 034, 014,-027,-036,-003, 006, 011,-014, 001,-005, ! dy1(1:10, 1, 4)
     . 009,-004,-038,-038,-007, 007, 000,-027, 004, 011, ! dy1(1:10, 2, 4)
     . 018, 007,-012,-017, 002, 008, 006,-025, 001, 002, ! dy1(1:10, 3, 4)
     . 024, 011, 000,-009,-001, 008, 001,-026, 014, 017, ! dy1(1:10, 4, 4)
     . 028, 031, 017, 017, 019, 012, 014,-011, 025, 022, ! dy1(1:10, 5, 4)
     . 029, 014, 031, 014, 021, 011, 009,-016, 023, 012, ! dy1(1:10, 6, 4)
     . 040, 029, 044, 039, 034, 015, 019,-001, 037, 025, ! dy1(1:10, 7, 4)
     .-011,-004, 009, 007,-004,-013,-005,-034, 000,-009, ! dy1(1:10, 8, 4)
     . 011, 003, 012, 014, 005,-007,-015,-016,-003, 000, ! dy1(1:10, 9, 4)
     . 011,-002, 008, 009, 002,-009,-011,-015, 000,-007, ! dy1(1:10,10, 4)
     . 016, 014, 016, 015, 015, 000,-002, 000, 008, 000, ! dy1(1:10,11, 4)
     . 006, 005, 010, 006, 012, 001, 000,-001,-002, 001, ! dy1(1:10,12, 4)
     . 014, 016, 022, 022, 020, 013, 007, 017, 014, 006, ! dy1(1:10,13, 4)
     . 000, 000,-005,-005, 003,-004,-011,-007,-016,-014, ! dy1(1:10,14, 4)
     .-009,-008, 000,-005, 000,-005,-005,-003,-016,-013, ! dy1(1:10,15, 4)
     .-006,-004,-009,-005, 004,-003, 000, 003,-015,-008, ! dy1(1:10,16, 4)
     . 003, 000,-002, 000, 005,-001,-004, 008,-013,-002, ! dy1(1:10,17, 4)
     . 006,-005,-013,-010, 000, 000,-002, 019,-015,-010, ! dy1(1:10,18, 4)
     . 000,-003,-011,-011, 005,-007,-002, 037,-007,-009, ! dy1(1:10,19, 4)
     .-017,-016,-017,-009,-001,-008,-005, 030,-015,-022, ! dy1(1:10,20, 4)
     . 001,-009,-008,-012,-004,-011,-009, 031, 000,-008, ! dy1(1:10,21, 4)
     . 000,-006,-001,-013, 004,-006,-005, 037, 002,-003, ! dy1(1:10,22, 4)
     .-004,-010,-003,-008, 003,-003,-002, 028, 006,-009, ! dy1(1:10,23, 4)
     . 000, 005, 005,-011, 003,-008, 001, 020, 011,-004, ! dy1(1:10,24, 4)
     .-012, 001, 013, 000, 005,-002, 009, 003, 025, 012, ! dy1(1:10,25, 4)
     .-031,-009,-006,-004,-008,-016,-006,-012, 007, 000, ! dy1(1:10,26, 4)
     . 008,-005, 009, 008, 002,-007,-003,-012, 010,-003, ! dy1(1:10,27, 4)
     . 004, 010, 021, 017, 010, 007, 009,-009, 022, 013, ! dy1(1:10,28, 4)
     . 018, 016, 033, 032, 020, 023, 021, 002, 029, 022, ! dy1(1:10,29, 4)
     . 014, 025, 025, 025, 014, 012, 015, 005, 028, 015, ! dy1(1:10,30, 4)
     . 024, 011, 045, 041, 025, 022, 030, 022, 030, 029, ! dy1(1:10,31, 4)
     .-004, 013, 020, 014, 016, 010, 008, 012, 013, 006, ! dy1(1:10,32, 4)
     . 011, 001, 017, 012, 003, 002, 007, 023, 007, 004, ! dy1(1:10,33, 4)
     . 001, 016, 006, 007, 006, 010, 008, 034,-003, 014, ! dy1(1:10,34, 4)
     . 012, 001, 000, 001, 001, 004, 010, 033,-014, 002, ! dy1(1:10,35, 4)
     . 011,-001,-014,-016,-008, 008, 003, 025,-026, 007, ! dy1(1:10,36, 4)
     .-005, 003,-024,-022,-012, 010, 000, 018,-039, 007, ! dy1(1:10,37, 4)
     .-080,-031,-052,-054,-047,-021,-029, 000,-066, 005, ! dy1(1:10,38, 4)
     . 034, 007,-007,-014, 011, 018, 023,-033, 002,-021, ! dy1(1:10, 1, 5)
     . 002, 015,-027,-024,-004, 000,-001,-034,-006,-010, ! dy1(1:10, 2, 5)
     . 018, 009,-005,-001, 001,-003,-001,-025, 004, 001, ! dy1(1:10, 3, 5)
     . 016, 017, 010, 006, 010,-003, 005,-020, 016, 014, ! dy1(1:10, 4, 5)
     . 041, 021, 031, 023, 026, 005, 009,-016, 026, 007, ! dy1(1:10, 5, 5)
     . 025, 024, 027, 023, 018, 004, 007,-023, 014, 010, ! dy1(1:10, 6, 5)
     . 021, 024, 039, 030, 027, 007, 008,-010, 021, 020, ! dy1(1:10, 7, 5)
     . 013,-002, 014, 008, 000,-024,-020,-037,-005,-004, ! dy1(1:10, 8, 5)
     .-008,-003, 000,-002, 000,-019,-023,-032,-013,-016, ! dy1(1:10, 9, 5)
     . 005, 000, 006, 007, 004,-011,-011,-019,-008,-001, ! dy1(1:10,10, 5)
     .-002, 005, 010, 005, 014,-008, 000,-010, 000, 000, ! dy1(1:10,11, 5)
     .-003,-009,-005, 003, 008,-009,-006,-007,-007,-008, ! dy1(1:10,12, 5)
     . 011, 005, 006, 000, 012, 004, 010,-004,-003, 006, ! dy1(1:10,13, 5)
     . 000,-012,-011,-012, 002,-012,-014,-022,-019,-016, ! dy1(1:10,14, 5)
     .-006,-011,-016,-015,-007,-014,-010,-028,-023,-020, ! dy1(1:10,15, 5)
     .-006,-002,-010,-005, 003,-001, 000,-005,-019,-005, ! dy1(1:10,16, 5)
     . 004,-009,-006,-005, 002, 002, 002, 009,-010,-013, ! dy1(1:10,17, 5)
     .-007,-007,-023,-017,-006,-009,-009, 010,-025,-019, ! dy1(1:10,18, 5)
     . 005,-003,-004,-008,-004, 000, 000, 036,-005, 006, ! dy1(1:10,19, 5)
     . 001, 000,-008,-015,-008, 000,-002, 032,-009,-009, ! dy1(1:10,20, 5)
     .-011,-006,-014, 000, 000,-005,-005, 035,-002,-009, ! dy1(1:10,21, 5)
     . 000, 001,-009,-006,-006,-002,-005, 029,-002,-003, ! dy1(1:10,22, 5)
     . 003, 004, 000,-010,-003,-004, 001, 025, 002,-005, ! dy1(1:10,23, 5)
     .-007,-009,-004,-006,-004,-005,-001, 016, 005, 000, ! dy1(1:10,24, 5)
     . 008, 001, 005, 007, 010,-001, 005, 006, 015, 011, ! dy1(1:10,25, 5)
     .-001,-008,-007,-010,-014,-009,-010,-005, 003,-004, ! dy1(1:10,26, 5)
     .-006,-011, 003,-002,-004,-005,-003,-014, 008, 000, ! dy1(1:10,27, 5)
     . 006, 010, 015, 013, 007, 004, 009, 003, 030, 016, ! dy1(1:10,28, 5)
     . 013, 016, 025, 018, 010, 008, 014, 012, 033, 015, ! dy1(1:10,29, 5)
     . 003,-009, 023, 004, 003, 010, 001, 005, 023, 003, ! dy1(1:10,30, 5)
     .-002, 024, 039, 033, 023, 025, 022, 042, 034, 023, ! dy1(1:10,31, 5)
     . 001, 003, 022, 004,-005, 001, 006, 015, 019, 015, ! dy1(1:10,32, 5)
     .-021,-018, 000, 003,-006,-002,-004, 031, 003,-008, ! dy1(1:10,33, 5)
     . 010,-009, 007, 008,-005,-001, 006, 041,-011, 001, ! dy1(1:10,34, 5)
     .-012,-012, 000,-008,-003, 005, 001, 043,-024, 001, ! dy1(1:10,35, 5)
     .-015,-018,-013,-019,-011,-011,-006, 036,-039, 000, ! dy1(1:10,36, 5)
     .-013, 000,-031,-039,-021, 015, 003, 037,-060, 000, ! dy1(1:10,37, 5)
     .-025,-020,-052,-076,-047,-021,-027, 000,-092,-039, ! dy1(1:10,38, 5)
     . 021, 003,-011,-011, 008,-002,-006,-035,-002, 029, ! dy1(1:10, 1, 6)
     . 018,-002,-009,-010,-006,-010,-003,-037,-006, 010, ! dy1(1:10, 2, 6)
     . 007, 007, 002,-010, 005, 000,-003,-023, 000, 001, ! dy1(1:10, 3, 6)
     . 023, 009, 013, 009, 014,-004, 001,-019, 008, 003, ! dy1(1:10, 4, 6)
     . 018, 018, 032, 015, 019, 007, 007,-011, 018, 006, ! dy1(1:10, 5, 6)
     . 028, 025, 039, 021, 030, 008, 010,-010, 021, 014, ! dy1(1:10, 6, 6)
     . 015, 017, 032, 020, 022, 003, 003,-015, 009, 010, ! dy1(1:10, 7, 6)
     .-012,-007, 006,-006, 001,-014,-020,-036,-012,-006, ! dy1(1:10, 8, 6)
     .-014,-019, 000,-010,-014,-023,-025,-035,-023,-016, ! dy1(1:10, 9, 6)
     .-014,-015, 002,-008,-002,-017,-022,-024,-017,-010, ! dy1(1:10,10, 6)
     .-003,-008, 001,-002, 001,-004,-008,-016,-010, 000, ! dy1(1:10,11, 6)
     .-009,-003,-006,-006, 003,-009,-006,-026,-008, 000, ! dy1(1:10,12, 6)
     . 007, 000, 001,-002, 014, 002, 007,-017,-004,-010, ! dy1(1:10,13, 6)
     .-010,-028,-020,-018,-006,-015,-011,-037,-021,-015, ! dy1(1:10,14, 6)
     .-008,-010,-028,-025,-013,-015,-013,-033,-025,-022, ! dy1(1:10,15, 6)
     .-006,-010,-017,-015,-004,-009,-006,-018,-017,-022, ! dy1(1:10,16, 6)
     .-008,-002,-017,-020,-008, 000,-007,-007,-019,-004, ! dy1(1:10,17, 6)
     . 004, 006,-013,-008, 000, 006, 003, 008,-008, 003, ! dy1(1:10,18, 6)
     .-015,-009,-023,-018,-010,-005,-011, 007,-013,-012, ! dy1(1:10,19, 6)
     .-003,-011,-027,-019,-015,-014,-019, 003,-021,-019, ! dy1(1:10,20, 6)
     . 004,-003,-021,-025,-019,-013,-016, 019,-018,-010, ! dy1(1:10,21, 6)
     .-004, 000,-012,-008,-009,-007,-005, 018,-005,-006, ! dy1(1:10,22, 6)
     . 000, 003,-013,-006,-011,-001,-001, 014,-004, 004, ! dy1(1:10,23, 6)
     . 007, 002, 001, 000,-005,-002, 000, 011, 007, 005, ! dy1(1:10,24, 6)
     . 016, 010, 005, 022,-002, 007, 015, 011, 009, 005, ! dy1(1:10,25, 6)
     . 003,-011,-006,-003,-014,-011,-004,-011, 002,-001, ! dy1(1:10,26, 6)
     . 000,-008,-010, 004,-011,-011, 000,-002, 009, 002, ! dy1(1:10,27, 6)
     .-001,-007, 003, 011,-006,-004, 003, 002, 015, 002, ! dy1(1:10,28, 6)
     .-010,-011, 019, 009,-001, 007, 009, 009, 028, 005, ! dy1(1:10,29, 6)
     . 022, 015, 030, 020, 010, 012, 016, 017, 032, 029, ! dy1(1:10,30, 6)
     . 000, 002, 027, 008, 009, 013, 014, 040, 036, 010, ! dy1(1:10,31, 6)
     .-027,-011, 015, 002, 000,-007, 001, 024, 017,-001, ! dy1(1:10,32, 6)
     .-006,-014, 007, 001,-012,-008,-005, 031, 000,-002, ! dy1(1:10,33, 6)
     .-028,-014, 004, 003,-004, 000, 000, 047,-011,-003, ! dy1(1:10,34, 6)
     . 000,-006, 004, 005,-010, 002, 001, 045,-025, 008, ! dy1(1:10,35, 6)
     .-016,-017,-017,-018,-018,-009,-009, 041,-049,-008, ! dy1(1:10,36, 6)
     .-042,-010,-023,-039,-032,-013,-012, 028,-077,-009, ! dy1(1:10,37, 6)
     .-077,-041,-050,-053,-053,-039,-033, 014,-094,-050, ! dy1(1:10,38, 6)
     . 023, 005,-002,-011,-002, 019, 008,-036, 002,-013, ! dy1(1:10, 1, 7)
     .-006,-004,-015,-018, 000,-003,-009,-043,-012,-006, ! dy1(1:10, 2, 7)
     . 019,-002, 005, 002, 006,-004, 003,-025,-002, 007, ! dy1(1:10, 3, 7)
     . 003, 009, 013, 002, 010,-001, 003,-029, 000, 000, ! dy1(1:10, 4, 7)
     . 029, 013, 025, 014, 018, 008, 004,-015, 005, 014, ! dy1(1:10, 5, 7)
     . 007, 003, 024, 018, 015, 001, 001,-015, 002, 009, ! dy1(1:10, 6, 7)
     . 007, 008, 034, 010, 018, 004, 003,-008, 004, 006, ! dy1(1:10, 7, 7)
     .-008,-014, 003,-007,-008,-020,-024,-033,-023,-009, ! dy1(1:10, 8, 7)
     .-019,-032,-007,-017,-010,-024,-026,-025,-024,-017, ! dy1(1:10, 9, 7)
     .-026,-015,-007,-011,-005,-012,-015,-015,-013,-010, ! dy1(1:10,10, 7)
     .-015,-015,-011,-014,-005,-011,-015,-024,-011,-018, ! dy1(1:10,11, 7)
     . 002,-008,-008,-008, 003,-001,-008,-021,-011,-013, ! dy1(1:10,12, 7)
     . 000, 006,-004,-002, 004, 006, 002,-017, 003, 000, ! dy1(1:10,13, 7)
     .-019,-014,-034,-025,-017,-016,-020,-037,-022,-017, ! dy1(1:10,14, 7)
     .-008,-016,-026,-023,-015,-004,-015,-030,-012,-019, ! dy1(1:10,15, 7)
     .-002, 000,-022,-013,-010, 001,-006,-025,-010,-010, ! dy1(1:10,16, 7)
     . 011, 001,-019,-012,-010, 002,-010,-021,-007,-009, ! dy1(1:10,17, 7)
     .-002,-005,-021,-018,-012,-007,-018,-022,-016,-006, ! dy1(1:10,18, 7)
     . 022, 016,-008,-006, 000, 004,-001,-003,-007,-006, ! dy1(1:10,19, 7)
     .-006, 006,-014,-008,-009, 000,-004,-003,-009, 000, ! dy1(1:10,20, 7)
     . 000, 000,-018,-018,-010,-011,-011,-010,-016,-004, ! dy1(1:10,21, 7)
     .-010, 006,-010,-007,-005,-006,-013, 000,-010, 006, ! dy1(1:10,22, 7)
     . 009, 003,-009,-009,-009,-002,-007, 002,-003, 004, ! dy1(1:10,23, 7)
     . 006, 005,-010,-007,-012,-010,-007,-002,-011, 000, ! dy1(1:10,24, 7)
     . 001, 000, 003, 005,-005, 008, 012, 008, 011, 016, ! dy1(1:10,25, 7)
     .-012,-012,-016,-007,-016,-013,-005,-008,-011,-008, ! dy1(1:10,26, 7)
     . 002,-014, 002, 002,-012,-006, 000, 000, 002, 009, ! dy1(1:10,27, 7)
     .-009,-009,-005,-004,-015,-013, 003, 004, 010,-005, ! dy1(1:10,28, 7)
     . 000, 007, 014, 016, 000, 001, 011, 017, 016, 014, ! dy1(1:10,29, 7)
     . 002,-006, 016, 009,-001, 004, 012, 024, 020, 011, ! dy1(1:10,30, 7)
     . 007, 000, 035, 011, 009, 015, 014, 047, 029, 007, ! dy1(1:10,31, 7)
     .-016,-015, 016,-001,-010,-006,-004, 026, 012, 005, ! dy1(1:10,32, 7)
     .-023,-013, 007,-006,-012,-013,-005, 031,-002,-015, ! dy1(1:10,33, 7)
     . 000,-011, 009, 003,-011,-012,-003, 030,-013,-008, ! dy1(1:10,34, 7)
     .-028, 000,-001,-004,-011,-014,-007, 036,-028,-010, ! dy1(1:10,35, 7)
     .-014,-032,-014,-023,-024,-021,-011, 023,-056,-016, ! dy1(1:10,36, 7)
     .-021, 009,-025,-037,-025,-023,-018, 021,-073,-018, ! dy1(1:10,37, 7)
     .-059,-061,-059,-078,-060,-028,-034,-005,-102,-044, ! dy1(1:10,38, 7)
     . 001, 023,-001, 005, 028, 005, 004,-028,-005, 109, ! dy1(1:10, 1, 8)
     . 011, 021, 001,-008, 001, 005,-006,-025,-010,-006, ! dy1(1:10, 2, 8)
     . 000,-009, 000,-013,-004,-007,-015,-034,-017,-014, ! dy1(1:10, 3, 8)
     . 003,-009, 001, 002, 002,-005,-010,-016,-008,-007, ! dy1(1:10, 4, 8)
     .-001, 004, 009, 009, 009, 003, 003,-002,-005, 009, ! dy1(1:10, 5, 8)
     . 006, 001, 013, 009, 007, 001, 000, 000,-001,-006, ! dy1(1:10, 6, 8)
     . 002, 003, 014, 023, 013, 012, 008, 019, 006, 017, ! dy1(1:10, 7, 8)
     .-017,-026,-013,-005,-004,-009,-011, 000,-014,-015, ! dy1(1:10, 8, 8)
     .-034,-036,-020,-017,-021,-018,-025,-012,-020,-021, ! dy1(1:10, 9, 8)
     . 000,-028,-012,-018,-013,-013,-025,-010,-021,-022, ! dy1(1:10,10, 8)
     .-017,-010,-014,-010,-001,-004,-003, 001,-001,-013, ! dy1(1:10,11, 8)
     .-024,-016,-020,-012,-011,-003,-019,-013,-006,-009, ! dy1(1:10,12, 8)
     . 010,-004,-001, 000, 006, 012, 000,-007, 018,-001, ! dy1(1:10,13, 8)
     .-023,-015,-026,-023,-010,-010,-018,-028, 002,-026, ! dy1(1:10,14, 8)
     .-012,-007,-032,-026,-017,-010,-017,-033,-007,-019, ! dy1(1:10,15, 8)
     .-007,-004,-024,-018,-006, 000,-011,-029, 002,-014, ! dy1(1:10,16, 8)
     .-004,-006,-025,-016,-005, 000,-011,-033,-002,-009, ! dy1(1:10,17, 8)
     . 015, 001,-021,-013,-009, 002,-008,-028,-005,-001, ! dy1(1:10,18, 8)
     . 003, 013,-008,-003, 000,-002,-005,-024,-007, 009, ! dy1(1:10,19, 8)
     . 014, 013,-015,-014,-001,-002,-014,-032,-016, 003, ! dy1(1:10,20, 8)
     . 014, 008,-022,-012,-010,-011,-014,-037,-015,-003, ! dy1(1:10,21, 8)
     . 014, 009,-010,-015,-010,-003,-003,-028,-010,-004, ! dy1(1:10,22, 8)
     . 007, 016,-006,-005,-004,-005,-002,-025,-010, 010, ! dy1(1:10,23, 8)
     . 003, 008,-005,-012,-008,-009,-001,-015,-008, 002, ! dy1(1:10,24, 8)
     . 002, 005, 004, 000,-009,-014,-001,-003,-011,-004, ! dy1(1:10,25, 8)
     .-020,-006,-023,-032,-026,-026,-015,-019,-025,-013, ! dy1(1:10,26, 8)
     .-021,-005,-007,-009,-023,-018,-007,-004,-017,-016, ! dy1(1:10,27, 8)
     .-009,-001, 010, 004,-001,-008, 011, 008,-008,-001, ! dy1(1:10,28, 8)
     .-020,-013, 007, 004,-009,-008, 012, 013, 000,-006, ! dy1(1:10,29, 8)
     .-005,-002, 020, 012, 000, 002, 015, 023, 012,-001, ! dy1(1:10,30, 8)
     .-014,-001, 014, 014, 000,-007, 017, 025, 017, 004, ! dy1(1:10,31, 8)
     .-009,-023,-002,-002,-012,-013,-001, 010, 000,-023, ! dy1(1:10,32, 8)
     .-026,-022, 000,-011,-019,-022,-015,-008,-008,-019, ! dy1(1:10,33, 8)
     .-015,-015,-011,-017,-017,-026,-022,-004,-013,-020, ! dy1(1:10,34, 8)
     .-019,-024,-005,-011,-013,-018,-009, 000,-018,-020, ! dy1(1:10,35, 8)
     .-027,-026,-016,-027,-028,-037,-033,-010,-042,-036, ! dy1(1:10,36, 8)
     .-039,-034,-013,-025,-017,-028,-009,-001,-059,-013, ! dy1(1:10,37, 8)
     .-044,-018,-027,-033,-043,-051,-046,-026,-087,-035, ! dy1(1:10,38, 8)
     . 048, 003, 042, 024, 040, 021, 023,-004, 021, 067, ! dy1(1:10, 1, 9)
     . 023, 008, 012, 000, 009, 007,-010,-014,-003, 012, ! dy1(1:10, 2, 9)
     . 007,-007, 000,-004, 005,-001,-001,-020,-005,-001, ! dy1(1:10, 3, 9)
     . 010, 004, 011, 006, 004, 000,-008,-008,-003,-001, ! dy1(1:10, 4, 9)
     . 026, 009, 025, 021, 022, 018, 014, 014, 010, 024, ! dy1(1:10, 5, 9)
     .-006,-002, 009, 007, 006, 000,-002, 006,-003, 003, ! dy1(1:10, 6, 9)
     . 010, 011, 016, 018, 014, 013, 007, 015,-002,-007, ! dy1(1:10, 7, 9)
     .-009,-016,-003, 007, 004, 004,-004, 012,-006,-013, ! dy1(1:10, 8, 9)
     . 001,-015, 006, 000, 006, 007,-005, 016, 001, 007, ! dy1(1:10, 9, 9)
     .-001,-005, 004, 006, 003, 007, 002, 011, 005, 003, ! dy1(1:10,10, 9)
     . 005, 003, 008, 006, 017, 021, 006, 015, 017, 004, ! dy1(1:10,11, 9)
     . 000, 006, 000, 000, 008, 013, 000, 005, 007, 001, ! dy1(1:10,12, 9)
     . 023, 028, 010, 012, 025, 032, 021, 006, 038, 017, ! dy1(1:10,13, 9)
     . 030, 035, 004, 017, 018, 026, 013, 003, 027, 016, ! dy1(1:10,14, 9)
     . 030, 033, 008, 013, 028, 032, 027, 008, 044, 014, ! dy1(1:10,15, 9)
     . 032, 030, 017, 023, 029, 038, 024, 010, 041, 037, ! dy1(1:10,16, 9)
     . 035, 048, 023, 025, 036, 045, 035, 012, 045, 032, ! dy1(1:10,17, 9)
     . 046, 031, 013, 023, 027, 028, 020, 004, 027, 033, ! dy1(1:10,18, 9)
     . 048, 044, 023, 024, 029, 034, 027, 006, 027, 038, ! dy1(1:10,19, 9)
     . 009, 019,-012,-006, 005, 002,-003,-022, 001, 002, ! dy1(1:10,20, 9)
     . 011, 012,-003, 000, 001, 002, 000,-026,-006, 014, ! dy1(1:10,21, 9)
     . 023, 027, 000, 002, 006, 013, 006,-020, 004, 019, ! dy1(1:10,22, 9)
     . 022, 019, 007, 007, 001, 005, 003,-014,-002, 014, ! dy1(1:10,23, 9)
     . 019, 023, 005,-002, 000, 000, 005,-013, 005, 013, ! dy1(1:10,24, 9)
     . 003, 014, 003, 000, 004, 003, 017, 010, 007, 014, ! dy1(1:10,25, 9)
     . 007, 000, 001,-006,-003,-001, 008,-001, 000, 007, ! dy1(1:10,26, 9)
     .-003,-003, 000,-005,-014,-013,-003, 000,-012,-007, ! dy1(1:10,27, 9)
     . 012, 016, 026, 015, 010, 004, 026, 028, 008, 016, ! dy1(1:10,28, 9)
     . 008, 014, 027, 029, 015, 015, 030, 039, 011, 015, ! dy1(1:10,29, 9)
     . 015, 009, 033, 021, 014, 015, 026, 045, 021, 023, ! dy1(1:10,30, 9)
     . 022, 010, 028, 032, 016, 013, 029, 037, 029, 014, ! dy1(1:10,31, 9)
     . 009, 012, 038, 036, 023, 022, 031, 040, 035, 025, ! dy1(1:10,32, 9)
     . 000, 000, 014, 022, 005, 007, 011, 021, 016,-001, ! dy1(1:10,33, 9)
     .-001, 012, 021, 018, 016, 004, 019, 026, 020, 007, ! dy1(1:10,34, 9)
     . 017, 015, 027, 030, 021, 012, 022, 032, 016, 018, ! dy1(1:10,35, 9)
     .-016, 000, 014, 004, 002,-013, 006, 021,-012, 000, ! dy1(1:10,36, 9)
     .-010, 023, 019, 001, 008, 001, 009, 022,-027, 003, ! dy1(1:10,37, 9)
     .-041,-005,-025,-025,-035,-009,-027, 000,-059,-019, ! dy1(1:10,38, 9)
     . 031, 045, 025, 026, 024, 029, 015, 012, 027, 038, ! dy1(1:10, 1,10)
     .-007, 003, 003, 003, 005, 004,-006,-018, 000, 000, ! dy1(1:10, 2,10)
     . 004, 000, 011, 010, 002, 007,-007,-005, 000, 001, ! dy1(1:10, 3,10)
     .-020,-009, 003, 004,-005, 001,-007,-007,-007,-005, ! dy1(1:10, 4,10)
     .-009, 000, 008, 014, 004, 009, 000, 019, 000, 004, ! dy1(1:10, 5,10)
     .-006,-010, 001, 012, 005, 004,-001, 029,-001,-008, ! dy1(1:10, 6,10)
     .-023,-020,-011, 000,-004, 010,-008, 039,-004, 007, ! dy1(1:10, 7,10)
     .-026,-018,-015, 000,-005, 001,-013, 037,-009,-011, ! dy1(1:10, 8,10)
     .-027,-027,-019,-007,-015,-002,-014, 023,-010,-015, ! dy1(1:10, 9,10)
     .-020,-014,-018,-009,-003, 010,-008, 024,-003,-010, ! dy1(1:10,10,10)
     . 000, 000,-003, 004, 005, 015, 004, 029, 011, 000, ! dy1(1:10,11,10)
     . 000, 003,-007, 004, 010, 017, 004, 028, 015, 005, ! dy1(1:10,12,10)
     . 006, 004,-013, 005, 007, 015, 000, 023, 023, 002, ! dy1(1:10,13,10)
     . 004, 007, 004, 010, 026, 027, 010, 030, 035, 010, ! dy1(1:10,14,10)
     . 023, 019,-001, 010, 017, 024, 010, 023, 034, 024, ! dy1(1:10,15,10)
     . 015, 018, 000, 009, 026, 019, 011, 018, 035, 013, ! dy1(1:10,16,10)
     . 024, 017, 000, 015, 023, 030, 013, 016, 034, 033, ! dy1(1:10,17,10)
     . 028, 022, 007, 018, 025, 031, 012, 002, 031, 028, ! dy1(1:10,18,10)
     . 035, 035, 011, 020, 031, 032, 024, 002, 035, 036, ! dy1(1:10,19,10)
     . 012, 001,-017,-009,-006,-001,-011,-034,-002, 006, ! dy1(1:10,20,10)
     . 011, 009,-018,-007, 002, 001,-006,-031, 004, 010, ! dy1(1:10,21,10)
     . 012, 011,-014,-002,-001, 001,-002,-030, 000, 008, ! dy1(1:10,22,10)
     . 012, 010,-012,-007,-002, 002, 001,-029, 000, 012, ! dy1(1:10,23,10)
     .-003, 004,-006,-006, 000, 000, 004,-023,-004, 009, ! dy1(1:10,24,10)
     . 015, 015, 014,-002, 008, 002, 009,-009,-007, 001, ! dy1(1:10,25,10)
     . 004, 006, 000,-007,-009,-002, 000,-017,-016, 001, ! dy1(1:10,26,10)
     . 004, 014, 015, 001, 008, 003, 019, 013,-007, 006, ! dy1(1:10,27,10)
     . 000, 010, 014, 009, 003, 008, 015, 019,-007, 000, ! dy1(1:10,28,10)
     . 017, 014, 023, 012, 010, 012, 021, 029, 005, 008, ! dy1(1:10,29,10)
     . 013, 007, 017, 017, 006, 006, 019, 021, 008, 003, ! dy1(1:10,30,10)
     .-018,-007, 023, 013, 004, 009, 017, 005, 017,-001, ! dy1(1:10,31,10)
     . 009, 007, 021, 027, 014, 014, 024, 013, 019, 008, ! dy1(1:10,32,10)
     .-009,-003, 021, 015, 007, 000, 014,-012, 014, 005, ! dy1(1:10,33,10)
     . 004, 005, 023, 020, 012, 003, 017,-007, 019, 003, ! dy1(1:10,34,10)
     . 010, 012, 027, 024, 019, 006, 020, 000, 019, 018, ! dy1(1:10,35,10)
     . 000, 007, 012, 008, 011,-008, 004,-005, 008, 000, ! dy1(1:10,36,10)
     . 020, 006, 006, 003, 012,-001, 014, 005,-007, 004, ! dy1(1:10,37,10)
     .-003,-010,-013,-015,-003,-028,-013,-029,-034,-021, ! dy1(1:10,38,10)
     . 054, 025, 037, 021, 033, 039, 030, 027, 032, 032, ! dy1(1:10, 1,11)
     . 001, 009, 011, 011, 009, 014, 001, 000, 021, 010, ! dy1(1:10, 2,11)
     .-002,-011, 007, 008, 001, 004,-007, 001, 002, 011, ! dy1(1:10, 3,11)
     .-013,-014, 006, 003,-004, 002,-012, 007, 001,-001, ! dy1(1:10, 4,11)
     . 000,-007, 008, 005, 001, 007,-001, 024, 003,-003, ! dy1(1:10, 5,11)
     .-026,-013, 004, 004, 000, 006,-002, 032, 003, 000, ! dy1(1:10, 6,11)
     .-008,-014,-007, 000,-008, 001,-009, 031,-001,-018, ! dy1(1:10, 7,11)
     .-029,-034,-024,-008,-024,-005,-018, 019,-008,-017, ! dy1(1:10, 8,11)
     .-013,-016,-013,-005,-005, 001,-008, 036,-006,-009, ! dy1(1:10, 9,11)
     .-024,-016,-017,-004,-007, 000,-005, 031,-001,-011, ! dy1(1:10,10,11)
     .-018, 002,-005,-003, 001, 006,-001, 032, 006, 000, ! dy1(1:10,11,11)
     .-013,-004,-015,-005,-001, 005,-005, 021, 004, 002, ! dy1(1:10,12,11)
     .-019,-012,-019,-008, 000, 006,-002, 021, 009,-012, ! dy1(1:10,13,11)
     .-009, 003,-012, 004, 004, 015, 002, 031, 017, 003, ! dy1(1:10,14,11)
     . 003, 006,-010, 007, 018, 017, 008, 021, 027, 012, ! dy1(1:10,15,11)
     . 006, 008,-007, 009, 012, 018, 008, 016, 029, 019, ! dy1(1:10,16,11)
     . 021, 018, 002, 009, 020, 026, 010, 014, 034, 025, ! dy1(1:10,17,11)
     . 017, 019, 003, 016, 026, 028, 009, 011, 032, 028, ! dy1(1:10,18,11)
     . 027, 018, 003, 024, 028, 033, 015, 002, 035, 036, ! dy1(1:10,19,11)
     . 004, 000,-012,-004, 004, 005,-010,-022, 013, 008, ! dy1(1:10,20,11)
     . 006,-004,-021,-008, 000,-002,-011,-033, 001, 012, ! dy1(1:10,21,11)
     .-006,-006,-019,-009,-003,-005,-011,-035, 000, 000, ! dy1(1:10,22,11)
     . 003,-006,-016,-010,-001,-009,-004,-028,-007, 004, ! dy1(1:10,23,11)
     . 000,-003,-008,-008,-003,-006,-003,-023,-005,-002, ! dy1(1:10,24,11)
     . 012, 003, 004,-002, 000, 000, 006,-007,-001,-002, ! dy1(1:10,25,11)
     . 001, 002,-006,-008,-007,-006, 000,-015,-010, 000, ! dy1(1:10,26,11)
     . 012, 001, 012, 000, 003, 006, 005, 009,-009,-006, ! dy1(1:10,27,11)
     . 009, 008, 013, 002, 007, 007, 013, 015,-003,-002, ! dy1(1:10,28,11)
     . 005, 010, 020, 007, 007, 006, 013, 010, 001, 002, ! dy1(1:10,29,11)
     . 003, 000, 011, 000,-002, 006, 005, 000,-002,-007, ! dy1(1:10,30,11)
     . 007,-005, 008, 013, 010, 008, 014,-007, 001, 004, ! dy1(1:10,31,11)
     . 011,-003, 022, 019, 004, 006, 014,-007, 011,-008, ! dy1(1:10,32,11)
     . 000,-009, 009, 005, 000, 001, 008,-023, 003, 002, ! dy1(1:10,33,11)
     .-011,-003, 018, 005, 003,-005, 007,-025, 011,-006, ! dy1(1:10,34,11)
     . 006,-008, 016, 012, 010, 006, 012,-022, 020, 006, ! dy1(1:10,35,11)
     .-001, 000, 008, 002, 001,-009, 007,-023, 009, 007, ! dy1(1:10,36,11)
     . 004, 004, 005, 006, 011, 003, 010, 004, 014, 001, ! dy1(1:10,37,11)
     .-034,-034,-032,-026,-019,-030,-018,-026,-020,-016, ! dy1(1:10,38,11)
     . 022, 016, 038, 036, 030, 045, 025, 038, 046, 037, ! dy1(1:10, 1,12)
     .-005, 014, 021, 014, 010, 012, 008, 018, 019, 019, ! dy1(1:10, 2,12)
     .-011,-013, 010, 007,-006, 000,-003, 008, 010,-001, ! dy1(1:10, 3,12)
     .-015,-013, 003,-001,-007,-004,-009, 009, 006,-004, ! dy1(1:10, 4,12)
     .-013,-017, 015, 010, 002, 003, 003, 025, 016, 000, ! dy1(1:10, 5,12)
     .-009,-003, 005, 001,-005,-003,-001, 024, 006,-012, ! dy1(1:10, 6,12)
     .-027,-034, 000,-003,-006,-003,-001, 029, 000,-009, ! dy1(1:10, 7,12)
     .-023,-034,-007,-010,-015,-014,-014, 018,-006,-024, ! dy1(1:10, 8,12)
     .-030,-013,-016,-009,-016,-010,-010, 019,-012,-021, ! dy1(1:10, 9,12)
     .-009,-008,-014,-010,-006,-007,-007, 024,-006,-012, ! dy1(1:10,10,12)
     .-011,-006, 001, 002, 001, 001, 007, 030, 001, 004, ! dy1(1:10,11,12)
     .-012,-010,-013,-003, 000, 003, 004, 023, 000,-007, ! dy1(1:10,12,12)
     .-005,-005,-011,-006,-002, 000,-001, 017, 005, 008, ! dy1(1:10,13,12)
     . 007,-003,-007, 004, 008, 007, 009, 027, 011, 005, ! dy1(1:10,14,12)
     . 003, 004,-003, 003, 008, 013, 007, 017, 020, 013, ! dy1(1:10,15,12)
     . 014, 012,-002, 009, 019, 021, 009, 019, 027, 017, ! dy1(1:10,16,12)
     . 017, 013, 002, 018, 024, 019, 012, 017, 037, 027, ! dy1(1:10,17,12)
     . 014, 015, 000, 016, 020, 022, 004, 009, 025, 032, ! dy1(1:10,18,12)
     . 027, 025, 008, 017, 029, 025, 017, 006, 035, 022, ! dy1(1:10,19,12)
     . 002,-001,-020,-008, 001,-002,-015,-022, 008, 011, ! dy1(1:10,20,12)
     .-010,-011,-018,-009,-001,-005,-017,-027,-003,-005, ! dy1(1:10,21,12)
     .-002,-010,-021,-015,-003,-009,-017,-028,-009, 003, ! dy1(1:10,22,12)
     . 006,-007,-016,-005,-002,-010,-011,-023, 000, 000, ! dy1(1:10,23,12)
     .-003,-004,-012,-010,-001,-010,-006,-015,-002, 000, ! dy1(1:10,24,12)
     . 008, 007, 000, 000, 008, 000, 001,-002,-002,-005, ! dy1(1:10,25,12)
     .-004,-010,-010,-010, 000,-007,-004,-008,-003,-003, ! dy1(1:10,26,12)
     . 003, 002, 003,-008,-002, 001, 000, 004,-005,-009, ! dy1(1:10,27,12)
     . 008, 000, 006,-006,-003,-002, 006, 006,-003,-010, ! dy1(1:10,28,12)
     . 001, 000, 014,-003, 001, 004, 007, 005, 000,-003, ! dy1(1:10,29,12)
     .-004, 001, 005,-002, 000, 004, 004,-001,-004,-004, ! dy1(1:10,30,12)
     .-009,-022, 003, 000,-007,-004, 009,-014,-003, 000, ! dy1(1:10,31,12)
     .-001,-006, 008, 009, 005, 007, 021,-010, 001, 011, ! dy1(1:10,32,12)
     . 000,-011, 012,-002,-003,-007, 003,-027, 000,-008, ! dy1(1:10,33,12)
     .-006,-012, 010, 007, 004,-006, 003,-027, 011,-003, ! dy1(1:10,34,12)
     . 004, 000, 017, 006, 007, 002, 012,-025, 013, 005, ! dy1(1:10,35,12)
     . 007,-011, 005, 000, 004, 000, 008,-022, 019,-003, ! dy1(1:10,36,12)
     . 006, 014, 002, 003, 013, 011, 012,-008, 027, 021, ! dy1(1:10,37,12)
     .-015,-009,-026,-012,-015,-010,-009,-021, 005,-012, ! dy1(1:10,38,12)
     . 031, 035, 032, 036, 033, 031, 019, 026, 051, 019, ! dy1(1:10, 1,13)
     .-003,-012, 004, 001, 003, 011, 002, 008, 015, 013, ! dy1(1:10, 2,13)
     .-017,-012, 004,-004,-005,-002,-009, 006, 011,-007, ! dy1(1:10, 3,13)
     .-027,-020,-001,-008,-012,-011,-009, 002, 003,-005, ! dy1(1:10, 4,13)
     .-017,-017, 008, 000,-009,-007, 000, 009, 009,-004, ! dy1(1:10, 5,13)
     .-013,-023, 002, 002,-003,-008,-005, 013, 008,-006, ! dy1(1:10, 6,13)
     .-013,-004, 000,-002,-007,-003, 000, 021,-003,-013, ! dy1(1:10, 7,13)
     .-012,-010,-001,-003,-008,-007,-001, 018,-007,-001, ! dy1(1:10, 8,13)
     .-024,-017,-013, 000,-011,-009,-008, 009,-015,-011, ! dy1(1:10, 9,13)
     .-009,-017,-013,-006,-009,-019,-005, 009,-017,-017, ! dy1(1:10,10,13)
     .-022, 007, 000, 002, 000,-003, 007, 022, 001, 000, ! dy1(1:10,11,13)
     .-012, 001,-001, 005, 004, 000, 003, 021,-002, 003, ! dy1(1:10,12,13)
     .-019,-022,-009,-016,-008, 000,-003, 005,-010,-009, ! dy1(1:10,13,13)
     .-020,-011,-011,-008, 000, 000, 003, 008,-007,-001, ! dy1(1:10,14,13)
     .-004, 005,-004, 002, 004, 011, 003, 012, 007, 008, ! dy1(1:10,15,13)
     . 000, 002, 002, 009, 011, 009, 008, 013, 012, 019, ! dy1(1:10,16,13)
     . 007, 028, 004, 024, 023, 021, 010, 017, 026, 023, ! dy1(1:10,17,13)
     . 012, 007, 000, 016, 018, 013, 006, 012, 016, 017, ! dy1(1:10,18,13)
     . 021, 011, 000, 020, 021, 008, 001, 002, 015, 027, ! dy1(1:10,19,13)
     .-006,-018,-026,-008,-004,-013,-020,-023,-007,-009, ! dy1(1:10,20,13)
     .-013,-004,-024,-007,-004,-017,-017,-021,-010,-005, ! dy1(1:10,21,13)
     . 002,-005,-012,-006,-004,-009,-016,-010,-006, 001, ! dy1(1:10,22,13)
     . 010, 006,-008,-011, 005,-007,-006,-008, 003, 000, ! dy1(1:10,23,13)
     . 013, 004,-002,-001, 006,-003,-002, 001, 006, 000, ! dy1(1:10,24,13)
     . 004,-004, 001,-003, 013, 000, 007, 013, 010,-004, ! dy1(1:10,25,13)
     .-006,-007, 002,-006, 003, 000,-002, 003, 001,-010, ! dy1(1:10,26,13)
     .-004,-019,-013,-010,-009,-010,-007, 003,-007,-012, ! dy1(1:10,27,13)
     .-005,-004,-003,-018,-004,-008,-003, 002,-007,-017, ! dy1(1:10,28,13)
     .-008,-002, 006,-007,-004, 005, 003, 012,-002,-003, ! dy1(1:10,29,13)
     .-025,-012,-010,-016,-016,-012,-002,-006,-011,-019, ! dy1(1:10,30,13)
     .-010,-021,-002,-016,-009,-010,-007,-019,-015,-010, ! dy1(1:10,31,13)
     .-007,-007, 000,-006,-008,-011, 006,-008,-001, 000, ! dy1(1:10,32,13)
     .-018,-022, 004,-008,-003,-008,-004,-021,-006,-016, ! dy1(1:10,33,13)
     .-007,-019, 003,-007,-007,-004, 001,-024, 002, 001, ! dy1(1:10,34,13)
     . 000,-006, 009,-005, 000,-003, 005,-022, 018, 002, ! dy1(1:10,35,13)
     . 004,-007, 002, 002, 002, 000, 005,-013, 021, 003, ! dy1(1:10,36,13)
     .-012, 008,-002,-004, 003, 008, 004,-015, 026, 005, ! dy1(1:10,37,13)
     .-032,-029,-029,-030,-024,-009,-009,-040,-007,-013, ! dy1(1:10,38,13)
     . 022, 019, 012, 022, 021, 038, 031, 042, 038, 047, ! dy1(1:10, 1,14)
     . 002, 009, 002, 003, 007, 000,-001, 009, 012, 012, ! dy1(1:10, 2,14)
     .-018,-008,-013,-007,-007,-003,-006, 002,-002,-001, ! dy1(1:10, 3,14)
     .-023,-020,-005,-013,-016,-013,-009, 000, 000,-004, ! dy1(1:10, 4,14)
     .-030,-005,-005,-009,-007,-007,-010,-002, 000,-013, ! dy1(1:10, 5,14)
     .-013,-013, 001,-005,-014,-008,-003,-004, 000,-012, ! dy1(1:10, 6,14)
     .-018,-016,-006,-007,-006,-016,-003,-009,-011,-012, ! dy1(1:10, 7,14)
     .-012,-010,-005,-001,-012,-015, 000,-004,-012,-017, ! dy1(1:10, 8,14)
     .-021,-016,-001,-004,-010,-015,-005,-005,-011,-020, ! dy1(1:10, 9,14)
     .-006, 006,-006,-005,-008,-017, 000,-007,-012,-008, ! dy1(1:10,10,14)
     .-025,-012, 000,-001,-005,-010, 000, 001,-013,-009, ! dy1(1:10,11,14)
     .-011, 000,-001, 000,-004,-007, 002, 001,-012, 005, ! dy1(1:10,12,14)
     .-021,-021,-010,-011,-005,-005,-013,-006,-018,-009, ! dy1(1:10,13,14)
     .-016,-016,-001,-006,-007,-004,-002,-006,-009, 000, ! dy1(1:10,14,14)
     .-012,-001, 001, 006, 006, 007, 000, 004, 000, 007, ! dy1(1:10,15,14)
     . 001, 011, 000, 011, 016, 009, 008, 016, 006, 011, ! dy1(1:10,16,14)
     . 022, 012, 011, 022, 019, 014, 010, 023, 009, 022, ! dy1(1:10,17,14)
     . 004, 012, 004, 024, 021, 012, 006, 020, 011, 021, ! dy1(1:10,18,14)
     . 021, 026, 008, 022, 025, 012, 013, 023, 015, 021, ! dy1(1:10,19,14)
     .-006,-005,-014,-002,-003,-016,-020,-009,-020,-009, ! dy1(1:10,20,14)
     .-010,-020,-023,-007,-005,-015,-019,-004,-014,-013, ! dy1(1:10,21,14)
     .-004,-009,-013,-009,-003,-016,-018, 000,-011,-014, ! dy1(1:10,22,14)
     . 005, 000, 000, 004, 010, 001,-004, 022, 005,-001, ! dy1(1:10,23,14)
     . 024, 016, 021, 017, 028, 013, 014, 040, 031, 006, ! dy1(1:10,24,14)
     . 021, 018, 013, 011, 016, 011, 011, 028, 019, 009, ! dy1(1:10,25,14)
     . 007,-003, 000, 002, 006,-001, 000, 016, 008,-007, ! dy1(1:10,26,14)
     .-001,-011,-006,-010,-006,-004,-009, 007,-005,-012, ! dy1(1:10,27,14)
     .-004,-015,-002,-009,-010,-007,-002, 008,-009,-016, ! dy1(1:10,28,14)
     .-002,-005, 000,-009,-006,-003, 001, 011,-002,-011, ! dy1(1:10,29,14)
     .-016,-023,-011,-017,-014,-012,-007, 001,-023,-019, ! dy1(1:10,30,14)
     .-016,-017,-010,-020,-019,-015,-006,-007,-018,-012, ! dy1(1:10,31,14)
     .-008,-024,-011,-015,-009,-010, 000, 002,-016,-006, ! dy1(1:10,32,14)
     .-002,-010, 001,-006,-010,-010, 001,-008,-005,-002, ! dy1(1:10,33,14)
     .-001,-008, 003, 000, 000,-001, 008,-011, 000,-007, ! dy1(1:10,34,14)
     .-005,-014, 006, 000,-003, 008, 003,-001, 005, 006, ! dy1(1:10,35,14)
     .-001,-008, 000,-006, 000, 010, 008,-009, 013, 003, ! dy1(1:10,36,14)
     . 020, 014,-005, 007, 005, 015, 006, 006, 017, 025, ! dy1(1:10,37,14)
     .-020, 005,-019,-032,-024, 003,-019,-023, 003,-017, ! dy1(1:10,38,14)
     . 044, 031, 027, 028, 023, 034, 020, 029, 023, 032, ! dy1(1:10, 1,15)
     . 000, 009,-013,-003, 001, 016, 006, 010,-001, 018, ! dy1(1:10, 2,15)
     . 012,-003, 000, 002,-002, 000,-003, 003,-003, 007, ! dy1(1:10, 3,15)
     .-007, 000,-011,-005,-006,-004,-004,-006,-019,-006, ! dy1(1:10, 4,15)
     .-014,-020,-010,-004,-011,-010,-006,-012,-014,-007, ! dy1(1:10, 5,15)
     .-019,-009,-005,-003,-006,-010, 001,-020,-014,-005, ! dy1(1:10, 6,15)
     .-016,-016,-009,-007,-019,-018,-009,-032,-013,-017, ! dy1(1:10, 7,15)
     .-026,-031,-003,-007,-020,-023,-012,-033,-013,-018, ! dy1(1:10, 8,15)
     .-020,-009,-008,-006,-013,-015,-004,-028,-018,-007, ! dy1(1:10, 9,15)
     .-018,-008,-002,-003,-010,-016, 000,-020,-014,-010, ! dy1(1:10,10,15)
     .-005,-011,-002,-001,-003,-010,-002,-016,-006,-001, ! dy1(1:10,11,15)
     .-012,-012, 005,-005,-003,-006,-001,-014,-011,-006, ! dy1(1:10,12,15)
     .-006, 004, 006, 007, 004,-003, 006, 000, 001, 008, ! dy1(1:10,13,15)
     .-014, 004, 004, 008, 005, 000, 003,-002,-006, 007, ! dy1(1:10,14,15)
     . 001, 009, 007, 012, 014, 007, 009, 010, 000, 012, ! dy1(1:10,15,15)
     .-009, 005, 008, 015, 013, 001, 009, 009,-001, 005, ! dy1(1:10,16,15)
     . 006, 006, 010, 022, 025, 021, 018, 024, 012, 022, ! dy1(1:10,17,15)
     . 003, 004, 010, 023, 020, 010, 010, 023, 003, 019, ! dy1(1:10,18,15)
     . 010, 015, 010, 024, 028, 016, 013, 034, 012, 015, ! dy1(1:10,19,15)
     .-016,-011,-009, 002, 001,-009,-008, 011,-013,-008, ! dy1(1:10,20,15)
     .-013,-016,-010,-005,-004,-019,-019, 003,-023,-012, ! dy1(1:10,21,15)
     .-004,-003,-007, 003, 001,-006,-014, 021,-008,-006, ! dy1(1:10,22,15)
     . 001,-001,-001,-002, 003,-006,-011, 025,-005,-005, ! dy1(1:10,23,15)
     . 005, 004,-003, 001,-002,-008,-011, 030, 000,-016, ! dy1(1:10,24,15)
     .-007,-011,-003,-001, 007,-001,-008, 023, 001,-014, ! dy1(1:10,25,15)
     .-006,-008,-004,-009,-007,-005,-007, 020, 005,-011, ! dy1(1:10,26,15)
     . 003,-015,-001,-005,-002,-007,-008, 016,-008,-013, ! dy1(1:10,27,15)
     . 000,-001, 000,-004, 000, 002, 000, 026,-001,-006, ! dy1(1:10,28,15)
     .-008,-002,-003,-009,-006, 002, 003, 022,-013,-011, ! dy1(1:10,29,15)
     . 004,-008,-007,-018,-013,-014,-003, 011,-015, 000, ! dy1(1:10,30,15)
     .-020,-017,-008,-013,-022,-008,-008, 007,-022,-021, ! dy1(1:10,31,15)
     .-011,-015,-002,-009,-010,-008,-003, 013,-012,-009, ! dy1(1:10,32,15)
     . 003,-008, 004, 000,-005,-002, 009, 014,-006, 003, ! dy1(1:10,33,15)
     . 000, 000, 005,-005,-008, 002, 009, 010,-003, 009, ! dy1(1:10,34,15)
     . 015, 006, 012, 008, 001, 012, 014, 009, 010, 009, ! dy1(1:10,35,15)
     . 021, 003, 007, 012, 003, 019, 009, 013, 014, 022, ! dy1(1:10,36,15)
     . 036, 036, 021, 017, 018, 039, 025, 009, 035, 033, ! dy1(1:10,37,15)
     . 015,-005,-021, 005,-001, 021,-008,-022,-005, 030, ! dy1(1:10,38,15)
     . 056, 076, 005, 019, 040, 055, 048, 045, 029, 061, ! dy1(1:10, 1,16)
     . 029, 021,-006, 000, 011, 020, 006, 005, 002, 028, ! dy1(1:10, 2,16)
     .-001, 019,-008, 009, 007, 022, 009,-001,-012, 016, ! dy1(1:10, 3,16)
     . 011, 009,-009, 004, 004, 007, 006,-005,-009, 003, ! dy1(1:10, 4,16)
     .-010, 000,-002,-004,-005,-003,-001,-020,-022, 000, ! dy1(1:10, 5,16)
     .-018,-003,-008, 002,-004,-003,-003,-022,-014,-005, ! dy1(1:10, 6,16)
     . 000,-011,-005,-005,-009,-011, 003,-038,-008,-007, ! dy1(1:10, 7,16)
     .-019,-010,-019,-015,-019,-017,-012,-051,-018,-012, ! dy1(1:10, 8,16)
     .-020,-024,-010,-006,-019,-021,-012,-043,-016,-019, ! dy1(1:10, 9,16)
     .-024,-009,-017,-012,-017,-025,-011,-042,-009,-015, ! dy1(1:10,10,16)
     .-026,-014, 002,-010,-014,-023,-005,-033,-009,-012, ! dy1(1:10,11,16)
     .-014, 000, 001, 002, 000,-013, 001,-019, 000,-001, ! dy1(1:10,12,16)
     .-016, 001, 014, 008, 005,-005, 005, 001, 002,-002, ! dy1(1:10,13,16)
     . 000, 005, 017, 010, 013,-002, 013, 005, 008, 003, ! dy1(1:10,14,16)
     . 000, 014, 014, 022, 021, 006, 011, 015, 004, 013, ! dy1(1:10,15,16)
     .-001, 013, 013, 018, 015, 000, 011, 015, 001, 008, ! dy1(1:10,16,16)
     . 013, 015, 021, 025, 027, 014, 018, 022, 010, 027, ! dy1(1:10,17,16)
     . 011, 003, 011, 023, 024, 017, 015, 021, 006, 010, ! dy1(1:10,18,16)
     . 006, 013, 021, 022, 024, 013, 012, 030, 005, 019, ! dy1(1:10,19,16)
     .-008,-020,-011,-006,-004,-012,-017, 004,-023,-020, ! dy1(1:10,20,16)
     .-022,-016,-011,-005,-007,-016,-016, 011,-024,-016, ! dy1(1:10,21,16)
     .-009,-014, 002,-001,-006,-015,-022, 013,-024,-025, ! dy1(1:10,22,16)
     .-011,-009,-010,-008,-010,-009,-017, 011,-019,-020, ! dy1(1:10,23,16)
     .-025,-029,-013,-017,-019,-029,-034, 001,-023,-029, ! dy1(1:10,24,16)
     .-004,-007,-005,-014,-010,-018,-016, 006,-009,-023, ! dy1(1:10,25,16)
     .-001,-015,-007,-011,-008,-011,-016, 009,-010,-022, ! dy1(1:10,26,16)
     .-011,-006,-001,-010,-006,-006,-007, 011,-006,-017, ! dy1(1:10,27,16)
     .-013,-015,-004,-011,-013,-007,-008, 005,-008,-013, ! dy1(1:10,28,16)
     . 005, 004, 007, 001, 000,-001, 003, 018,-002,-003, ! dy1(1:10,29,16)
     . 000,-004,-002,-005,-009, 001, 007, 019,-003,-008, ! dy1(1:10,30,16)
     . 011,-004, 000,-011,-011,-003, 008, 013,-017, 004, ! dy1(1:10,31,16)
     . 012, 008, 000,-010,-013,-001, 007, 018,-011, 004, ! dy1(1:10,32,16)
     . 008, 002, 004, 002,-006,-001, 012, 022,-001, 005, ! dy1(1:10,33,16)
     . 016, 007, 007, 008,-001, 005, 014, 016, 001, 008, ! dy1(1:10,34,16)
     . 020, 019, 004, 002,-002, 014, 012, 008, 005, 021, ! dy1(1:10,35,16)
     . 039, 022, 015, 024, 012, 023, 023, 016, 023, 022, ! dy1(1:10,36,16)
     . 058, 057, 031, 027, 028, 050, 028, 021, 043, 062, ! dy1(1:10,37,16)
     . 038, 026, 010, 010,-004, 025, 010,-002, 017, 031, ! dy1(1:10,38,16)
     . 086, 066, 041, 050, 056, 087, 049, 048, 033, 060, ! dy1(1:10, 1,17)
     . 028, 041, 001, 023, 026, 045, 018, 020, 001, 041, ! dy1(1:10, 2,17)
     . 024, 032, 007, 013, 017, 034, 018, 012, 001, 028, ! dy1(1:10, 3,17)
     . 018, 025, 007, 012, 020, 025, 011, 001,-004, 029, ! dy1(1:10, 4,17)
     . 014, 023,-002, 017, 012, 015, 014,-007, 001, 020, ! dy1(1:10, 5,17)
     . 000, 003,-005, 000,-004, 000, 001,-027,-003, 003, ! dy1(1:10, 6,17)
     .-018,-006,-009, 000,-008,-008,-005,-038,-004, 000, ! dy1(1:10, 7,17)
     .-026,-022,-022,-008,-015,-022,-011,-045,-009,-012, ! dy1(1:10, 8,17)
     .-021,-007,-010,-011,-012,-020,-007,-043,-001,-004, ! dy1(1:10, 9,17)
     .-017,-017,-010,-005,-010,-015,-013,-037, 000,-007, ! dy1(1:10,10,17)
     .-035,-011,-009,-010,-011,-023,-012,-034, 002,-015, ! dy1(1:10,11,17)
     .-001,-011,-004,-006,-005,-019,-008,-027, 002,-001, ! dy1(1:10,12,17)
     .-028,-006, 003, 001, 001,-012, 000,-004, 006,-002, ! dy1(1:10,13,17)
     .-019, 002, 006, 005, 005,-011, 001, 000, 009,-003, ! dy1(1:10,14,17)
     . 008, 012, 017, 012, 017, 002, 012, 013, 014, 006, ! dy1(1:10,15,17)
     .-006, 007, 015, 016, 018, 006, 009, 015, 008, 005, ! dy1(1:10,16,17)
     . 000, 009, 019, 017, 020, 010, 009, 020, 012, 010, ! dy1(1:10,17,17)
     . 005, 009, 020, 017, 020, 014, 015, 020, 014, 005, ! dy1(1:10,18,17)
     . 012, 008, 020, 020, 024, 014, 014, 032, 010, 007, ! dy1(1:10,19,17)
     .-016,-015,-005,-003,-006,-017,-017, 003,-022,-020, ! dy1(1:10,20,17)
     .-001,-007,-002,-008,-004,-013,-012, 003,-019,-024, ! dy1(1:10,21,17)
     .-007,-008, 000, 004,-002,-007,-010, 003,-017,-016, ! dy1(1:10,22,17)
     .-006,-001, 005,-003,-005,-015,-012, 000,-016,-014, ! dy1(1:10,23,17)
     .-002,-001,-004,-011,-008,-015,-013,-007,-016,-029, ! dy1(1:10,24,17)
     .-011,-003, 001, 003,-007,-015,-014,-006,-013,-010, ! dy1(1:10,25,17)
     .-012,-015,-011,-011,-016,-024,-019,-014,-020,-018, ! dy1(1:10,26,17)
     .-007,-013,-005,-005,-015,-014,-013,-015,-011,-023, ! dy1(1:10,27,17)
     .-005,-007,-003,-015,-010,-004,-007,-015,-009,-014, ! dy1(1:10,28,17)
     . 003, 000, 000,-002,-009, 000, 000,-013,-004,-014, ! dy1(1:10,29,17)
     . 009, 006, 006,-004,-008, 000, 007,-004, 001, 004, ! dy1(1:10,30,17)
     .-001, 006,-007,-002,-018,-009, 003, 002,-013,-006, ! dy1(1:10,31,17)
     . 002,-002, 000, 003,-014,-007, 010, 003,-011,-007, ! dy1(1:10,32,17)
     . 031, 021, 005,-003,-009, 000, 015, 015, 000, 014, ! dy1(1:10,33,17)
     . 033, 025, 004, 005,-008, 011, 014, 022, 000, 013, ! dy1(1:10,34,17)
     . 055, 032, 015, 020, 005, 025, 024, 023, 016, 041, ! dy1(1:10,35,17)
     . 064, 047, 023, 027, 012, 041, 028, 017, 030, 045, ! dy1(1:10,36,17)
     . 083, 071, 037, 035, 034, 067, 042, 027, 051, 080, ! dy1(1:10,37,17)
     . 034, 049, 010, 006, 010, 046, 016,-008, 023, 052, ! dy1(1:10,38,17)
     . 105, 093, 052, 069, 083, 112, 085, 089, 061, 116, ! dy1(1:10, 1,18)
     . 100, 084, 022, 044, 060, 102, 062, 061, 037, 082, ! dy1(1:10, 2,18)
     . 067, 062, 011, 031, 041, 070, 033, 039, 020, 061, ! dy1(1:10, 3,18)
     . 039, 047, 000, 025, 021, 052, 031, 026, 027, 047, ! dy1(1:10, 4,18)
     . 016, 022, 004, 005, 015, 035, 016, 013, 018, 043, ! dy1(1:10, 5,18)
     . 014, 022,-001, 011, 014, 019, 017,-002, 022, 029, ! dy1(1:10, 6,18)
     . 006, 006,-007, 004, 002, 001, 009,-024, 026, 010, ! dy1(1:10, 7,18)
     .-012, 001,-013,-010,-008,-006, 000,-028, 014, 001, ! dy1(1:10, 8,18)
     .-003,-013,-010, 005,-009,-006,-003,-035, 025, 000, ! dy1(1:10, 9,18)
     .-015,-002,-003,-004,-001,-013,-003,-027, 028,-002, ! dy1(1:10,10,18)
     .-010,-006,-010,-001,-003,-016,-004,-021, 018, 005, ! dy1(1:10,11,18)
     .-026,-001,-004, 000, 000,-009,-002,-008, 024,-015, ! dy1(1:10,12,18)
     .-030,-011,-015,-015,-007,-025,-018,-023, 008,-023, ! dy1(1:10,13,18)
     .-047,-016,-021,-016,-012,-026,-017,-018, 005,-024, ! dy1(1:10,14,18)
     .-013, 005, 009, 006, 012, 005, 005, 019, 027,-004, ! dy1(1:10,15,18)
     .-003, 016, 022, 015, 023, 019, 014, 029, 033, 004, ! dy1(1:10,16,18)
     . 010, 015, 023, 018, 019, 015, 013, 031, 026, 002, ! dy1(1:10,17,18)
     . 014, 022, 026, 019, 022, 018, 014, 030, 021, 010, ! dy1(1:10,18,18)
     . 011, 023, 036, 015, 020, 015, 018, 012, 021,-006, ! dy1(1:10,19,18)
     .-016, 000, 000,-015,-011,-016,-013,-018,-006,-032, ! dy1(1:10,20,18)
     .-003, 000, 002, 001,-003,-010,-009,-017,-009,-017, ! dy1(1:10,21,18)
     . 004, 001, 004,-013,-008,-015,-009,-028,-006,-025, ! dy1(1:10,22,18)
     . 000, 000, 000, 000,-007,-009,-009,-038,-016,-021, ! dy1(1:10,23,18)
     . 000, 007, 007, 013,-002,-003, 000,-037,-009,-005, ! dy1(1:10,24,18)
     . 015, 001, 004, 009,-008,-002, 000,-047,-008,-011, ! dy1(1:10,25,18)
     .-020,-008,-009,-004,-018,-011,-013,-062,-022,-026, ! dy1(1:10,26,18)
     . 001,-001,-010,-011,-021,-011,-011,-072,-015,-010, ! dy1(1:10,27,18)
     .-017,-007,-009,-009,-028,-012,-013,-066,-009,-016, ! dy1(1:10,28,18)
     . 018, 011, 004,-008,-017,-003, 001,-062, 003,-001, ! dy1(1:10,29,18)
     . 016, 015, 001, 014,-012, 008, 001,-042, 000, 007, ! dy1(1:10,30,18)
     . 066, 025, 010, 006,-017, 015, 017,-022, 012, 019, ! dy1(1:10,31,18)
     . 038, 037, 006, 008,-016, 010, 011,-011, 015, 027, ! dy1(1:10,32,18)
     . 048, 035, 002, 026,-002, 024, 019, 001, 019, 027, ! dy1(1:10,33,18)
     . 066, 057, 020, 030, 005, 033, 034, 017, 035, 050, ! dy1(1:10,34,18)
     . 066, 065, 020, 035, 007, 040, 029, 029, 041, 062, ! dy1(1:10,35,18)
     . 093, 075, 028, 049, 032, 066, 047, 035, 061, 096, ! dy1(1:10,36,18)
     . 135, 117, 060, 065, 049, 096, 066, 040, 091, 118, ! dy1(1:10,37,18)
     . 118, 085, 032, 044, 027, 075, 046, 016, 065, 100/ ! dy1(1:10,38,18)
 
      data dy2 /
     . 051, 024, 098, 090, 014, 028, 083,-018, 050, 011, ! dy2(1:10, 1, 1)
     . 049, 018, 099, 073, 011, 014, 063,-020, 048, 005, ! dy2(1:10, 2, 1)
     . 019, 000, 068, 044,-018,-013, 032,-066, 009,-030, ! dy2(1:10, 3, 1)
     . 000,-043, 022, 007,-038,-027,-003,-083,-011,-036, ! dy2(1:10, 4, 1)
     .-019,-036, 005, 000,-047,-041,-002,-102,-018,-050, ! dy2(1:10, 5, 1)
     .-012,-042,-012,-012,-058,-050,-010,-109,-033,-048, ! dy2(1:10, 6, 1)
     .-050,-059,-035,-044,-067,-071,-031,-128,-029,-065, ! dy2(1:10, 7, 1)
     .-055,-056,-033,-032,-063,-055,-031,-130,-031,-056, ! dy2(1:10, 8, 1)
     .-029,-054,-031,-030,-061,-054,-034,-118,-032,-057, ! dy2(1:10, 9, 1)
     .-022,-033,-033,-028,-048,-047,-025,-103,-019,-043, ! dy2(1:10,10, 1)
     .-014,-032,-026,-020,-042,-032,-023,-086,-019,-029, ! dy2(1:10,11, 1)
     .-009,-032,-033,-019,-035,-027,-021,-064,-014,-034, ! dy2(1:10,12, 1)
     .-002,-009,-028,-015,-016,-011,-015,-027,-008,-005, ! dy2(1:10,13, 1)
     . 005,-002,-010, 001,-003, 003,-008,-020, 002,-008, ! dy2(1:10,14, 1)
     . 040, 021, 000, 010, 009, 023, 011, 022, 020, 013, ! dy2(1:10,15, 1)
     . 032, 033, 015, 019, 028, 030, 013, 041, 022, 029, ! dy2(1:10,16, 1)
     . 041, 040, 028, 037, 034, 042, 032, 056, 031, 037, ! dy2(1:10,17, 1)
     . 061, 057, 033, 030, 040, 040, 025, 062, 030, 034, ! dy2(1:10,18, 1)
     . 062, 053, 035, 041, 035, 042, 034, 068, 032, 049, ! dy2(1:10,19, 1)
     . 047, 032, 021, 010, 030, 014, 019, 039, 020, 025, ! dy2(1:10,20, 1)
     . 027, 024, 003, 010, 011,-001, 004, 026,-005, 021, ! dy2(1:10,21, 1)
     . 018, 007, 000, 006, 007,-013,-005, 008,-008, 003, ! dy2(1:10,22, 1)
     . 003, 003,-021, 004,-011,-027,-013,-006,-025, 000, ! dy2(1:10,23, 1)
     .-027,-027,-032,-020,-026,-044,-033,-030,-053,-018, ! dy2(1:10,24, 1)
     .-038,-039,-043,-034,-040,-051,-048,-046,-060,-035, ! dy2(1:10,25, 1)
     .-033,-032,-022,-018,-019,-037,-025,-028,-039,-013, ! dy2(1:10,26, 1)
     .-021,-028,-027,-021,-025,-035,-025,-033,-029,-025, ! dy2(1:10,27, 1)
     .-031,-024,-020,-015,-010,-031,-015,-023,-016,-014, ! dy2(1:10,28, 1)
     .-025,-017,-013,-014,-012,-031,-013,-025,-013,-024, ! dy2(1:10,29, 1)
     .-011,-017, 002, 001, 000,-008,-001,-003, 002,-009, ! dy2(1:10,30, 1)
     .-007,-008, 003, 007, 002,-019, 010, 005, 011, 002, ! dy2(1:10,31, 1)
     .-001, 009, 017, 016, 014,-006, 012, 022, 021, 000, ! dy2(1:10,32, 1)
     . 000, 010, 026, 018, 020, 002, 031, 038, 029, 003, ! dy2(1:10,33, 1)
     .-019,-003, 029, 015, 019,-002, 028, 034, 035, 017, ! dy2(1:10,34, 1)
     . 017, 017, 025, 027, 019,-003, 028, 031, 037, 003, ! dy2(1:10,35, 1)
     .-024,-002, 020, 013, 023, 005, 021, 014, 035, 015, ! dy2(1:10,36, 1)
     .-021,-015, 004,-003, 005, 000, 016,-040, 016,-027, ! dy2(1:10,37, 1)
     .-029,-019,-022,-029,-010,-007, 000,-056, 023,-011, ! dy2(1:10,38, 1)
     . 063, 013, 092, 054, 014, 029, 043, 026, 039, 003, ! dy2(1:10, 1, 2)
     . 036, 028, 090, 068, 019, 027, 053, 023, 034, 004, ! dy2(1:10, 2, 2)
     . 026,-002, 042, 034,-007, 007, 017,-006, 007,-010, ! dy2(1:10, 3, 2)
     .-005,-014, 030, 016,-019,-006, 014,-018, 003,-014, ! dy2(1:10, 4, 2)
     . 005,-023, 006,-001,-027,-017, 000,-033,-011,-017, ! dy2(1:10, 5, 2)
     .-022,-025,-015,-019,-041,-024,-010,-054,-019,-028, ! dy2(1:10, 6, 2)
     .-015,-038,-017,-014,-037,-021,-011,-064,-011,-015, ! dy2(1:10, 7, 2)
     .-014,-040,-025,-019,-047,-028,-018,-068,-025,-033, ! dy2(1:10, 8, 2)
     .-025,-042,-031,-034,-040,-025,-026,-068,-018,-028, ! dy2(1:10, 9, 2)
     .-025,-041,-038,-031,-039,-026,-034,-064,-023,-031, ! dy2(1:10,10, 2)
     .-011,-034,-037,-028,-026,-025,-026,-046,-014,-035, ! dy2(1:10,11, 2)
     . 000,-010,-029,-021,-016,-012,-025,-025,-013,-016, ! dy2(1:10,12, 2)
     . 010,-003,-011,-011, 002, 007,-009, 006, 004,-016, ! dy2(1:10,13, 2)
     . 020, 006,-009,-007, 009, 010,-008, 019, 013, 002, ! dy2(1:10,14, 2)
     . 024, 029, 011, 009, 025, 021, 004, 044, 016, 007, ! dy2(1:10,15, 2)
     . 043, 036, 024, 016, 034, 033, 014, 062, 025, 014, ! dy2(1:10,16, 2)
     . 037, 048, 031, 021, 037, 036, 016, 070, 030, 022, ! dy2(1:10,17, 2)
     . 047, 059, 042, 033, 047, 047, 028, 079, 035, 035, ! dy2(1:10,18, 2)
     . 047, 058, 036, 036, 043, 032, 028, 065, 035, 031, ! dy2(1:10,19, 2)
     . 031, 049, 027, 034, 032, 028, 015, 058, 021, 018, ! dy2(1:10,20, 2)
     . 010, 027, 006, 018, 015, 006, 001, 022, 001, 003, ! dy2(1:10,21, 2)
     .-006, 002,-017, 001,-008,-008,-015,-003,-021, 000, ! dy2(1:10,22, 2)
     .-016,-014,-022,-014,-015,-023,-024,-021,-040,-025, ! dy2(1:10,23, 2)
     .-030,-032,-040,-031,-033,-037,-043,-045,-055,-033, ! dy2(1:10,24, 2)
     .-051,-046,-045,-042,-038,-045,-044,-064,-067,-037, ! dy2(1:10,25, 2)
     .-015,-018,-024,-017,-017,-013,-024,-041,-041,-020, ! dy2(1:10,26, 2)
     .-023,-018,-026,-029,-026,-023,-028,-048,-048,-012, ! dy2(1:10,27, 2)
     .-006,-025,-021,-018,-020,-019,-025,-040,-036,-024, ! dy2(1:10,28, 2)
     .-011,-010,-006,-010,-009,-013,-016,-024,-018,-011, ! dy2(1:10,29, 2)
     .-003,-008,-002,-003,-011,-013,-009,-014,-008,-005, ! dy2(1:10,30, 2)
     .-011,-005, 005,-001, 000,-001, 000, 006, 006,-005, ! dy2(1:10,31, 2)
     . 001, 001, 017, 011, 008, 011, 010, 017, 018, 005, ! dy2(1:10,32, 2)
     . 000, 006, 020, 015, 011, 004, 011, 030, 020, 007, ! dy2(1:10,33, 2)
     . 007, 019, 027, 031, 020, 014, 023, 040, 029, 007, ! dy2(1:10,34, 2)
     .-014, 001, 020, 015, 015, 012, 015, 031, 020, 015, ! dy2(1:10,35, 2)
     . 011, 003, 021, 020, 013, 013, 020, 026, 022, 012, ! dy2(1:10,36, 2)
     .-037,-002, 006, 003, 010, 013, 005, 004, 011, 005, ! dy2(1:10,37, 2)
     .-046,-047, 001,-004,-006, 003,-014,-024,-007,-011, ! dy2(1:10,38, 2)
     . 055, 042, 079, 075, 040, 060, 076, 054, 053, 036, ! dy2(1:10, 1, 3)
     . 073, 032, 079, 071, 035, 051, 058, 058, 045, 036, ! dy2(1:10, 2, 3)
     . 017, 009, 043, 028, 003, 017, 028, 031, 012, 011, ! dy2(1:10, 3, 3)
     . 009,-002, 021, 017,-002, 015, 017, 017, 010, 017, ! dy2(1:10, 4, 3)
     . 014, 000, 010, 007,-010, 017, 016, 008, 010, 010, ! dy2(1:10, 5, 3)
     .-003,-025,-006,-004,-025,-005,-002,-017,-007, 000, ! dy2(1:10, 6, 3)
     .-006,-028,-021,-016,-026,-007,-008,-035,-012,-019, ! dy2(1:10, 7, 3)
     .-015,-024,-022,-015,-019,-002,-009,-035,-002,-006, ! dy2(1:10, 8, 3)
     .-006,-039,-029,-025,-031,-018,-025,-047,-017,-022, ! dy2(1:10, 9, 3)
     .-009,-024,-027,-020,-020,-014,-022,-028,-009,-015, ! dy2(1:10,10, 3)
     .-004,-008,-018,-017,-009,-006,-012,-013, 003,-008, ! dy2(1:10,11, 3)
     .-010,-012,-021,-023,-003,-007,-022,-002,-006,-018, ! dy2(1:10,12, 3)
     . 027, 011,-006, 002, 016, 005,-001, 031, 010, 008, ! dy2(1:10,13, 3)
     . 022, 025, 012, 011, 029, 022, 013, 042, 020, 010, ! dy2(1:10,14, 3)
     . 017, 014, 005, 002, 025, 009,-002, 044, 015, 010, ! dy2(1:10,15, 3)
     . 041, 041, 028, 017, 041, 032, 016, 064, 026, 020, ! dy2(1:10,16, 3)
     . 057, 057, 051, 037, 052, 041, 034, 080, 043, 033, ! dy2(1:10,17, 3)
     . 054, 059, 039, 039, 049, 036, 026, 070, 038, 034, ! dy2(1:10,18, 3)
     . 054, 058, 045, 050, 047, 040, 034, 069, 041, 034, ! dy2(1:10,19, 3)
     . 038, 048, 031, 036, 039, 029, 029, 056, 034, 034, ! dy2(1:10,20, 3)
     . 021, 019, 008, 012, 012, 003, 000, 017, 001, 001, ! dy2(1:10,21, 3)
     .-006,-006,-008,-005, 001,-006,-007,-005,-016,-005, ! dy2(1:10,22, 3)
     .-021,-017,-022,-020,-017,-019,-024,-030,-032,-013, ! dy2(1:10,23, 3)
     .-037,-033,-044,-036,-036,-042,-043,-064,-060,-040, ! dy2(1:10,24, 3)
     .-029,-041,-053,-045,-040,-038,-044,-074,-070,-035, ! dy2(1:10,25, 3)
     .-017,-021,-027,-021,-019,-020,-023,-055,-048,-014, ! dy2(1:10,26, 3)
     .-023,-018,-021,-022,-026,-020,-028,-053,-050,-027, ! dy2(1:10,27, 3)
     .-027,-015,-021,-021,-018,-014,-021,-049,-034,-007, ! dy2(1:10,28, 3)
     .-003,-011,-005,-007,-011,-006,-012,-033,-019,-009, ! dy2(1:10,29, 3)
     .-010,-002,-004,-006,-010,-002,-013,-025,-013,-013, ! dy2(1:10,30, 3)
     .-009, 001, 009, 000, 005, 005,-002, 002, 014, 014, ! dy2(1:10,31, 3)
     . 004, 018, 018, 009, 014, 016, 013, 012, 021, 006, ! dy2(1:10,32, 3)
     . 012, 011, 015, 016, 012, 008, 008, 024, 024, 013, ! dy2(1:10,33, 3)
     . 029, 014, 034, 028, 023, 024, 022, 043, 031, 023, ! dy2(1:10,34, 3)
     . 010, 029, 033, 030, 027, 020, 023, 044, 032, 026, ! dy2(1:10,35, 3)
     .-018, 004, 016, 019, 016, 016, 009, 038, 014, 015, ! dy2(1:10,36, 3)
     .-003, 016, 020, 019, 019, 027, 016, 020, 023, 021, ! dy2(1:10,37, 3)
     .-033, 000, 003, 005, 001, 003,-005, 001, 007, 000, ! dy2(1:10,38, 3)
     . 066, 064, 058, 052, 026, 042, 042, 057, 035, 019, ! dy2(1:10, 1, 4)
     . 047, 036, 060, 050, 031, 037, 044, 057, 035, 037, ! dy2(1:10, 2, 4)
     . 008, 006, 024, 022, 001, 018, 024, 039, 010, 017, ! dy2(1:10, 3, 4)
     . 022, 006, 013, 009,-006, 017, 016, 030, 009, 015, ! dy2(1:10, 4, 4)
     .-002, 000, 003,-001,-005, 015, 018, 020, 003, 012, ! dy2(1:10, 5, 4)
     .-001,-008,-007,-005,-010, 006, 002, 003,-001, 008, ! dy2(1:10, 6, 4)
     . 009,-004, 000, 003,-004, 009, 000,-001, 008, 004, ! dy2(1:10, 7, 4)
     . 026,-007, 001, 004,-008, 013, 010,-002, 005,-004, ! dy2(1:10, 8, 4)
     .-021,-025,-032,-023,-024,-015,-028,-023,-015,-015, ! dy2(1:10, 9, 4)
     .-005,-023,-025,-020,-010,-010,-018,-011,-006,-010, ! dy2(1:10,10, 4)
     . 012, 004, 003,-001, 009, 006,-003, 004, 011, 005, ! dy2(1:10,11, 4)
     . 005, 001,-015,-013, 006,-002,-014, 004, 000,-010, ! dy2(1:10,12, 4)
     . 022, 012, 016, 002, 026, 010, 001, 039, 015, 016, ! dy2(1:10,13, 4)
     . 025, 035, 020, 010, 045, 025, 011, 050, 030, 019, ! dy2(1:10,14, 4)
     . 037, 028, 018, 005, 029, 015, 009, 048, 018, 011, ! dy2(1:10,15, 4)
     . 036, 036, 034, 026, 043, 025, 018, 059, 031, 026, ! dy2(1:10,16, 4)
     . 048, 044, 041, 043, 053, 040, 029, 068, 039, 031, ! dy2(1:10,17, 4)
     . 032, 042, 038, 034, 041, 031, 025, 063, 034, 024, ! dy2(1:10,18, 4)
     . 039, 037, 037, 032, 039, 030, 027, 048, 038, 028, ! dy2(1:10,19, 4)
     . 033, 031, 037, 027, 035, 027, 021, 047, 032, 025, ! dy2(1:10,20, 4)
     .-009, 006, 000,-001, 007, 001,-002, 002,-002,-003, ! dy2(1:10,21, 4)
     .-008,-003,-009,-007,-004,-005,-007,-015,-011,-010, ! dy2(1:10,22, 4)
     .-012,-014,-024,-021,-015,-012,-018,-038,-030,-015, ! dy2(1:10,23, 4)
     .-037,-046,-038,-038,-039,-036,-037,-065,-054,-031, ! dy2(1:10,24, 4)
     .-035,-030,-039,-040,-041,-030,-036,-075,-055,-033, ! dy2(1:10,25, 4)
     .-015,-008,-013,-013,-014,-008,-014,-053,-031,-011, ! dy2(1:10,26, 4)
     .-015,-012,-022,-015,-025,-018,-021,-059,-041,-017, ! dy2(1:10,27, 4)
     . 000,-012,-001,-005,-014,-005,-018,-048,-024,-017, ! dy2(1:10,28, 4)
     . 001, 004, 000, 000,-001, 005,-007,-034,-016, 002, ! dy2(1:10,29, 4)
     .-015,-002,-003,-006,-009, 009,-015,-029,-008,-005, ! dy2(1:10,30, 4)
     . 007, 013, 011, 006, 005, 002,-003,-010, 012, 000, ! dy2(1:10,31, 4)
     . 026, 029, 028, 024, 015, 027, 008, 010, 029, 026, ! dy2(1:10,32, 4)
     .-001, 008, 014, 014, 013, 015, 010, 018, 022, 018, ! dy2(1:10,33, 4)
     . 017, 035, 021, 020, 021, 019, 017, 035, 036, 019, ! dy2(1:10,34, 4)
     . 005, 018, 026, 027, 019, 023, 016, 041, 023, 032, ! dy2(1:10,35, 4)
     .-007, 012, 015, 013, 010, 013, 004, 032, 017, 017, ! dy2(1:10,36, 4)
     .-006,-001, 008, 008, 009, 017, 000, 025, 007, 010, ! dy2(1:10,37, 4)
     .-031,-020,-008,-008,-007, 005,-019, 003,-002, 005, ! dy2(1:10,38, 4)
     . 022, 022, 029, 025, 003, 014, 036, 061, 010, 039, ! dy2(1:10, 1, 5)
     . 029, 026, 039, 041, 021, 038, 042, 069, 020, 031, ! dy2(1:10, 2, 5)
     . 025, 010, 009, 009, 000, 019, 016, 048, 003, 025, ! dy2(1:10, 3, 5)
     . 011,-001, 003, 005, 002, 022, 014, 041, 004, 021, ! dy2(1:10, 4, 5)
     . 020, 001, 006,-001,-001, 014, 007, 025, 004, 012, ! dy2(1:10, 5, 5)
     . 017,-012, 004, 002, 000, 015, 011, 019, 006, 016, ! dy2(1:10, 6, 5)
     . 011, 005,-005,-002, 005, 015, 007, 008, 009, 018, ! dy2(1:10, 7, 5)
     . 008, 008, 000, 009, 005, 014, 008, 014, 011, 024, ! dy2(1:10, 8, 5)
     . 009,-016,-013,-010,-007,-001,-009,-006,-005,-001, ! dy2(1:10, 9, 5)
     . 001,-008,-017,-011,-010,-009,-018,-005,-004,-009, ! dy2(1:10,10, 5)
     . 009, 005,-004,-002, 013, 001,-002, 012, 013, 008, ! dy2(1:10,11, 5)
     . 009, 007,-001,-008, 009, 000,-006, 015, 009, 002, ! dy2(1:10,12, 5)
     . 038, 034, 014, 012, 033, 015, 013, 039, 024, 018, ! dy2(1:10,13, 5)
     . 043, 032, 032, 024, 045, 030, 026, 053, 037, 023, ! dy2(1:10,14, 5)
     . 033, 029, 027, 021, 036, 013, 013, 050, 025, 018, ! dy2(1:10,15, 5)
     . 046, 035, 030, 036, 044, 023, 023, 057, 036, 019, ! dy2(1:10,16, 5)
     . 040, 035, 040, 036, 045, 029, 030, 060, 038, 028, ! dy2(1:10,17, 5)
     . 021, 021, 021, 019, 026, 015, 013, 035, 024, 015, ! dy2(1:10,18, 5)
     . 014, 019, 021, 012, 029, 020, 019, 031, 029, 010, ! dy2(1:10,19, 5)
     . 016, 017, 010, 005, 018, 011, 011, 024, 019, 009, ! dy2(1:10,20, 5)
     .-009,-011,-003,-007,-006,-007,-003,-008,-005,-008, ! dy2(1:10,21, 5)
     .-022,-015,-012,-017,-015,-013,-011,-028,-019,-019, ! dy2(1:10,22, 5)
     .-020,-022,-017,-021,-015,-014,-014,-040,-024,-016, ! dy2(1:10,23, 5)
     .-033,-032,-027,-033,-032,-024,-026,-059,-043,-029, ! dy2(1:10,24, 5)
     .-025,-024,-030,-026,-037,-025,-029,-070,-043,-031, ! dy2(1:10,25, 5)
     .-004,-009,-002,-002,-015, 000,-003,-038,-016,-002, ! dy2(1:10,26, 5)
     .-020,-020,-018,-006,-021,-013,-024,-055,-033,-010, ! dy2(1:10,27, 5)
     .-002,-003,-001, 002,-010, 004,-009,-043,-019,-002, ! dy2(1:10,28, 5)
     .-009,-001,-002,-003,-003, 008,-018,-040,-005, 010, ! dy2(1:10,29, 5)
     .-014,-009,-009,-012,-008, 001,-020,-037,-012,-008, ! dy2(1:10,30, 5)
     . 020, 023, 016, 019, 013, 028, 003,-002, 019, 017, ! dy2(1:10,31, 5)
     . 035, 032, 021, 026, 020, 039, 012, 008, 032, 033, ! dy2(1:10,32, 5)
     . 004, 024, 016, 016, 016, 017, 008, 016, 019, 022, ! dy2(1:10,33, 5)
     . 014, 017, 017, 020, 016, 021, 014, 025, 022, 030, ! dy2(1:10,34, 5)
     .-004, 011, 009, 010, 009, 011, 007, 034, 018, 015, ! dy2(1:10,35, 5)
     . 012, 001, 000, 008, 008, 007, 002, 032, 007, 019, ! dy2(1:10,36, 5)
     .-034,-005, 000,-002,-002, 006,-002, 025, 000, 004, ! dy2(1:10,37, 5)
     .-042,-022,-013,-026,-014, 000,-025, 009,-027,-013, ! dy2(1:10,38, 5)
     . 021,-003, 000, 008,-001, 016, 010, 049,-022, 022, ! dy2(1:10, 1, 6)
     . 026, 014, 008, 004,-003, 009, 018, 055,-001, 022, ! dy2(1:10, 2, 6)
     . 019, 000, 008, 003, 001, 020, 008, 043, 003, 019, ! dy2(1:10, 3, 6)
     . 015, 001,-001, 000,-003, 009, 009, 033,-004, 016, ! dy2(1:10, 4, 6)
     . 012, 002, 001, 004, 002, 020, 014, 029, 009, 018, ! dy2(1:10, 5, 6)
     . 006, 000,-007,-009,-009, 004,-004, 012,-006, 010, ! dy2(1:10, 6, 6)
     . 029, 006, 004, 011, 007, 019, 013, 019, 016, 025, ! dy2(1:10, 7, 6)
     . 018, 004, 003, 008, 010, 022, 010, 023, 019, 024, ! dy2(1:10, 8, 6)
     . 001,-008,-013,-007,-001, 000,-008, 005,-002, 005, ! dy2(1:10, 9, 6)
     . 008,-007,-007, 001, 003, 000,-003, 008, 001, 001, ! dy2(1:10,10, 6)
     . 028, 011, 010, 006, 017, 011, 003, 022, 015, 012, ! dy2(1:10,11, 6)
     . 004, 001,-001,-002, 009, 000,-002, 020, 012, 005, ! dy2(1:10,12, 6)
     . 029, 020, 022, 011, 026, 008, 012, 035, 021, 009, ! dy2(1:10,13, 6)
     . 037, 029, 027, 032, 033, 022, 020, 045, 033, 029, ! dy2(1:10,14, 6)
     . 025, 030, 022, 023, 026, 016, 016, 040, 023, 004, ! dy2(1:10,15, 6)
     . 031, 022, 025, 030, 031, 025, 019, 045, 029, 013, ! dy2(1:10,16, 6)
     . 016, 025, 029, 024, 029, 016, 025, 047, 034, 016, ! dy2(1:10,17, 6)
     . 022, 015, 022, 019, 027, 019, 024, 035, 027, 012, ! dy2(1:10,18, 6)
     . 006, 012, 017, 008, 018, 010, 017, 019, 025, 017, ! dy2(1:10,19, 6)
     . 000, 018, 009, 006, 004, 006, 018, 012, 017, 000, ! dy2(1:10,20, 6)
     .-019,-021,-010,-015,-011,-014,-003,-022,-012,-016, ! dy2(1:10,21, 6)
     .-010,-010,-006,-011,-015,-010,-002,-026,-011,-016, ! dy2(1:10,22, 6)
     .-019,-019,-015,-017,-023,-017,-007,-043,-022,-022, ! dy2(1:10,23, 6)
     .-026,-026,-025,-023,-030,-026,-020,-054,-033,-030, ! dy2(1:10,24, 6)
     .-025,-029,-023,-018,-030,-017,-023,-052,-032,-025, ! dy2(1:10,25, 6)
     .-008,-005, 003, 002,-007, 003, 000,-033,-009,-003, ! dy2(1:10,26, 6)
     .-012,-010,-017,-017,-020,-010,-017,-046,-026,-022, ! dy2(1:10,27, 6)
     .-014,-010,-007,-013,-011, 000,-019,-039,-015,-003, ! dy2(1:10,28, 6)
     . 011, 014, 010, 000, 000, 016,-003,-026, 001, 004, ! dy2(1:10,29, 6)
     . 011, 004,-003, 000,-005, 011,-017,-027,-008, 008, ! dy2(1:10,30, 6)
     .-003, 028, 015, 018, 018, 020, 000,-005, 015, 017, ! dy2(1:10,31, 6)
     . 029, 032, 029, 029, 032, 036, 020, 014, 025, 032, ! dy2(1:10,32, 6)
     . 011, 020, 008, 013, 012, 009, 000, 006, 010, 022, ! dy2(1:10,33, 6)
     . 011, 019, 004, 008, 013, 009, 004, 023, 014, 016, ! dy2(1:10,34, 6)
     .-004, 017, 009, 007, 012, 004, 008, 029, 012, 029, ! dy2(1:10,35, 6)
     .-016, 008,-002,-004,-001,-003,-005, 025, 004, 009, ! dy2(1:10,36, 6)
     .-024,-018,-015,-012,-011,-003,-011, 021,-017, 000, ! dy2(1:10,37, 6)
     . 008,-022,-017,-027,-026,-034,-034, 003,-032,-020, ! dy2(1:10,38, 6)
     . 019,-010,-009,-015,-024,-007, 005, 022,-021, 002, ! dy2(1:10, 1, 7)
     .-005,-009,-013,-005,-025,-001,-004, 030,-021, 000, ! dy2(1:10, 2, 7)
     . 013,-003,-004,-010,-004, 012, 008, 023,-009, 016, ! dy2(1:10, 3, 7)
     . 004, 000,-003,-006,-001, 011, 002, 022, 004, 014, ! dy2(1:10, 4, 7)
     . 020, 010, 005, 000, 002, 018, 007, 022, 003, 012, ! dy2(1:10, 5, 7)
     . 001,-009,-012,-006,-006, 007,-004, 009, 000, 005, ! dy2(1:10, 6, 7)
     . 016, 007,-001, 000, 000, 012,-002, 012, 002, 015, ! dy2(1:10, 7, 7)
     . 028, 017, 000, 004, 005, 017, 002, 018, 008, 016, ! dy2(1:10, 8, 7)
     . 002,-016,-012, 004, 000, 003,-006, 007, 001, 005, ! dy2(1:10, 9, 7)
     . 009,-004,-003,-003, 002, 000,-007, 009, 006, 002, ! dy2(1:10,10, 7)
     . 022, 016, 011, 012, 015, 012, 009, 029, 020, 015, ! dy2(1:10,11, 7)
     . 019,-002, 000, 012, 004, 000,-003, 024, 009, 004, ! dy2(1:10,12, 7)
     . 001, 019, 014, 025, 017, 009, 003, 031, 020, 012, ! dy2(1:10,13, 7)
     . 022, 024, 021, 037, 026, 017, 015, 039, 032, 016, ! dy2(1:10,14, 7)
     . 022, 015, 012, 021, 021, 009, 010, 032, 023, 007, ! dy2(1:10,15, 7)
     . 020, 027, 021, 017, 021, 011, 013, 027, 026, 013, ! dy2(1:10,16, 7)
     . 018, 029, 020, 021, 027, 012, 021, 035, 032, 017, ! dy2(1:10,17, 7)
     . 007, 005, 018, 007, 016, 002, 017, 017, 020, 002, ! dy2(1:10,18, 7)
     . 000, 017, 014, 002, 005, 007, 022, 006, 018,-005, ! dy2(1:10,19, 7)
     .-018,-007, 004,-007, 000,-009, 002,-005, 006,-009, ! dy2(1:10,20, 7)
     .-025,-016,-011,-010,-020,-015,-005,-022,-009,-019, ! dy2(1:10,21, 7)
     .-022,-024,-018,-011,-024,-023,-006,-033,-016,-021, ! dy2(1:10,22, 7)
     .-022,-019,-020,-018,-027,-020,-008,-040,-021,-029, ! dy2(1:10,23, 7)
     .-037,-025,-024,-028,-035,-027,-020,-048,-026,-031, ! dy2(1:10,24, 7)
     .-018,-031,-021,-036,-031,-026,-025,-053,-029,-028, ! dy2(1:10,25, 7)
     .-013,-001,-003,-009,-011,-008,-005,-029,-009,-007, ! dy2(1:10,26, 7)
     .-019,-018,-006,-012,-018,-006,-015,-038,-014,-017, ! dy2(1:10,27, 7)
     . 000, 000,-005,-003,-009,-001,-013,-029,-010,-008, ! dy2(1:10,28, 7)
     . 006, 008, 002, 008, 005, 017,-005,-019,-001, 015, ! dy2(1:10,29, 7)
     .-006, 009, 000, 001, 005, 015,-011,-024,-008, 000, ! dy2(1:10,30, 7)
     . 011, 016, 004, 013, 018, 020, 000,-007, 001, 017, ! dy2(1:10,31, 7)
     . 030, 044, 022, 030, 033, 036, 016, 009, 019, 040, ! dy2(1:10,32, 7)
     .-009, 012, 000, 001, 011, 007,-006,-001,-006, 009, ! dy2(1:10,33, 7)
     . 007, 012, 004, 009, 015, 010, 003, 015, 000, 020, ! dy2(1:10,34, 7)
     .-006, 014,-001, 004, 008, 002, 006, 024, 008, 020, ! dy2(1:10,35, 7)
     .-013,-012,-020,-009,-004,-014,-006, 018,-013, 009, ! dy2(1:10,36, 7)
     .-069,-017,-018,-029,-027,-022,-025, 013,-018,-006, ! dy2(1:10,37, 7)
     .-054,-033,-050,-044,-052,-036,-037, 000,-045,-009, ! dy2(1:10,38, 7)
     .-046,-040,-016,-051,-025,-025,-024, 002,-038,-001, ! dy2(1:10, 1, 8)
     . 005,-018,-023,-023,-022,-011,-011, 005,-026,-006, ! dy2(1:10, 2, 8)
     . 005,-013,-011,-012,-017, 002,-005, 004,-020, 006, ! dy2(1:10, 3, 8)
     . 013,-004,-005,-008,-004, 007, 001, 004,-007, 020, ! dy2(1:10, 4, 8)
     . 015, 004,-008,-005,-007, 011, 000, 004,-003, 023, ! dy2(1:10, 5, 8)
     . 012, 000,-006,-004, 003, 004,-005, 000, 000, 010, ! dy2(1:10, 6, 8)
     . 017, 006,-005, 007, 000, 018, 003, 011, 006, 007, ! dy2(1:10, 7, 8)
     . 012, 003,-008, 003,-005, 009,-004, 011, 008, 001, ! dy2(1:10, 8, 8)
     . 000,-005,-011,-005,-002,-002,-008, 003, 000, 005, ! dy2(1:10, 9, 8)
     . 013,-004,-010,-001,-006,-008,-009, 006, 000,-004, ! dy2(1:10,10, 8)
     . 005, 000, 006, 020, 005, 001, 002, 022, 010, 006, ! dy2(1:10,11, 8)
     . 024, 003, 013, 027, 006, 004, 004, 027, 015, 008, ! dy2(1:10,12, 8)
     . 006,-004, 011, 029, 010,-006, 010, 028, 019, 008, ! dy2(1:10,13, 8)
     . 032, 018, 024, 022, 019, 012, 018, 039, 029, 019, ! dy2(1:10,14, 8)
     . 002, 005, 010, 008, 008,-005, 007, 018, 016, 000, ! dy2(1:10,15, 8)
     . 017, 017, 016, 014, 018, 005, 016, 021, 026, 005, ! dy2(1:10,16, 8)
     . 011, 017, 020, 016, 017, 008, 022, 020, 024, 000, ! dy2(1:10,17, 8)
     . 000, 016, 013, 007, 002, 000, 015, 004, 018,-001, ! dy2(1:10,18, 8)
     .-003, 001, 011, 008, 009,-007, 017, 004, 013, 003, ! dy2(1:10,19, 8)
     .-007,-002, 000, 003,-005,-009, 011,-008,-001,-015, ! dy2(1:10,20, 8)
     .-037,-026,-017,-018,-028,-021,-010,-030,-015,-034, ! dy2(1:10,21, 8)
     .-028,-023,-019,-024,-026,-020,-010,-033,-017,-030, ! dy2(1:10,22, 8)
     .-027,-024,-018,-026,-031,-026,-016,-031,-014,-028, ! dy2(1:10,23, 8)
     .-037,-038,-018,-035,-033,-027,-023,-041,-027,-039, ! dy2(1:10,24, 8)
     .-028,-029,-031,-028,-036,-028,-026,-044,-025,-031, ! dy2(1:10,25, 8)
     .-002,-017,-006,-009,-010, 001,-003,-020,-003,-009, ! dy2(1:10,26, 8)
     . 000, 002,-004, 001,-009,-004,-008,-019,-012,-006, ! dy2(1:10,27, 8)
     .-010, 003, 005, 005, 004, 009,-004,-015,-004, 003, ! dy2(1:10,28, 8)
     . 019, 020, 008, 013, 011, 014,-001,-007,-005, 005, ! dy2(1:10,29, 8)
     . 001, 007,-002, 001, 015, 015,-006,-011,-014, 007, ! dy2(1:10,30, 8)
     .-007, 026, 008, 012, 016, 024, 001, 002,-005, 017, ! dy2(1:10,31, 8)
     . 014, 029, 017, 019, 033, 036, 005, 012, 005, 027, ! dy2(1:10,32, 8)
     . 014, 018,-003, 005, 016, 009,-001, 008,-003, 021, ! dy2(1:10,33, 8)
     .-001, 018,-005, 006, 015, 009, 003, 013, 000, 020, ! dy2(1:10,34, 8)
     .-005, 006,-008,-002, 009, 005, 001, 021,-004, 018, ! dy2(1:10,35, 8)
     .-037,-018,-019,-022,-009,-009,-009, 010,-018, 003, ! dy2(1:10,36, 8)
     .-034,-037,-035,-044,-035,-046,-028,-005,-038,-026, ! dy2(1:10,37, 8)
     .-044,-073,-045,-057,-054,-051,-042,-022,-064,-053, ! dy2(1:10,38, 8)
     .-001,-029,-031,-030,-036,-025,-015,-019,-032,-017, ! dy2(1:10, 1, 9)
     .-011,-034,-020,-032,-030,-015,-020,-015,-026,-015, ! dy2(1:10, 2, 9)
     . 000,-017,-027,-033,-022,-010,-016,-023,-030, 007, ! dy2(1:10, 3, 9)
     . 008,-011,-016,-016,-012, 003,-002,-014,-013, 004, ! dy2(1:10, 4, 9)
     . 022, 002,-010,-006,-005, 007, 000,-005,-006, 015, ! dy2(1:10, 5, 9)
     . 003,-007,-017,-009,-014, 003,-014,-015,-011,-002, ! dy2(1:10, 6, 9)
     . 020, 010,-008,-007, 003, 000,-003, 000, 006, 024, ! dy2(1:10, 7, 9)
     . 017, 006,-005,-007, 005, 017,-003, 003, 003, 016, ! dy2(1:10, 8, 9)
     .-005,-015,-016,-008,-019,-009,-018,-004,-009,-007, ! dy2(1:10, 9, 9)
     .-011,-026,-013, 005,-015,-010,-016, 004,-006,-012, ! dy2(1:10,10, 9)
     . 012, 002, 002, 028, 001, 004,-003, 021, 006, 002, ! dy2(1:10,11, 9)
     .-009,-009,-003, 022,-007,-014,-002, 015, 003, 002, ! dy2(1:10,12, 9)
     . 010, 000, 007, 012, 003,-004, 005, 020, 013, 005, ! dy2(1:10,13, 9)
     . 007, 005, 015, 026, 008, 000, 012, 025, 020, 018, ! dy2(1:10,14, 9)
     . 003, 004, 010, 004, 003,-008, 013, 015, 017,-006, ! dy2(1:10,15, 9)
     .-002, 009, 011, 006, 001,-011, 010, 009, 013, 001, ! dy2(1:10,16, 9)
     . 000, 008, 013, 014, 004,-002, 019, 009, 021,-002, ! dy2(1:10,17, 9)
     .-001, 006, 012, 018, 001,-002, 016, 000, 010,-003, ! dy2(1:10,18, 9)
     .-014, 004, 011, 018,-003, 003, 017,-001, 010,-008, ! dy2(1:10,19, 9)
     .-026,-003, 000,-006,-017,-011, 005,-012, 000,-019, ! dy2(1:10,20, 9)
     .-012,-016,-005,-015,-018,-013,-005,-015,-006,-020, ! dy2(1:10,21, 9)
     .-029,-028,-007,-032,-030,-020,-013,-024,-013,-031, ! dy2(1:10,22, 9)
     .-030,-032,-024,-031,-030,-026,-022,-029,-020,-031, ! dy2(1:10,23, 9)
     .-032,-030,-022,-027,-039,-029,-027,-030,-023,-041, ! dy2(1:10,24, 9)
     .-032,-025,-021,-020,-022,-018,-022,-020,-017,-026, ! dy2(1:10,25, 9)
     .-008, 005, 001, 004,-005, 002,-004,-001, 000,-010, ! dy2(1:10,26, 9)
     .-006,-003,-010,-001,-001, 000,-012,-007,-007,-004, ! dy2(1:10,27, 9)
     . 009, 014, 001, 006, 007, 003,-002,-004,-006, 000, ! dy2(1:10,28, 9)
     . 022, 017, 007, 013, 024, 025, 005, 006,-002, 016, ! dy2(1:10,29, 9)
     . 002, 017, 000, 010, 015, 021,-004, 000,-013, 006, ! dy2(1:10,30, 9)
     . 011, 021, 003, 002, 026, 022, 000, 004,-005, 021, ! dy2(1:10,31, 9)
     . 024, 035, 013, 018, 033, 038, 010, 019, 006, 028, ! dy2(1:10,32, 9)
     . 000, 012,-008, 000, 019, 017,-001, 008,-007, 017, ! dy2(1:10,33, 9)
     . 014, 011, 004, 002, 021, 019, 009, 022, 005, 026, ! dy2(1:10,34, 9)
     .-009, 000,-007, 003, 007, 000, 011, 024, 003, 024, ! dy2(1:10,35, 9)
     .-025,-023,-027,-020,-010,-021,-010, 002,-021, 003, ! dy2(1:10,36, 9)
     .-069,-028,-033,-038,-031,-025,-013,-001,-027,-016, ! dy2(1:10,37, 9)
     .-044,-031,-048,-064,-052,-053,-041,-027,-061,-036, ! dy2(1:10,38, 9)
     .-023,-030,-023,-041,-039,-035,-035,-045,-033,-006, ! dy2(1:10, 1,10)
     . 006,-021,-023,-023,-028,-033,-018,-048,-026,-004, ! dy2(1:10, 2,10)
     . 000,-033,-035,-026,-038,-027,-024,-047,-034,-011, ! dy2(1:10, 3,10)
     . 008,-014,-025,-019,-026,-015,-025,-041,-036, 006, ! dy2(1:10, 4,10)
     . 007, 001,-009,-003, 000,-005,-006,-020,-008, 013, ! dy2(1:10, 5,10)
     . 000, 007,-018,-020,-010,-001,-010,-012,-013, 011, ! dy2(1:10, 6,10)
     . 000,-009,-010, 000,-010, 008,-008,-010,-002, 001, ! dy2(1:10, 7,10)
     . 004, 005,-011,-001,-004,-001,-007,-008,-005,-002, ! dy2(1:10, 8,10)
     .-018,-022,-028, 000,-024,-020,-032,-025,-028,-015, ! dy2(1:10, 9,10)
     .-006,-013,-024, 007,-027,-018,-028,-024,-024,-014, ! dy2(1:10,10,10)
     .-015,-025,-016, 007,-019,-019,-010,-008,-009,-009, ! dy2(1:10,11,10)
     .-012,-029,-016,-004,-020,-021,-014,-010,-014,-018, ! dy2(1:10,12,10)
     .-018,-026,-007,-005,-014,-021,-008,-007,-003,-003, ! dy2(1:10,13,10)
     . 003,-010,-002,-007,-007,-014, 002, 001, 003,-005, ! dy2(1:10,14,10)
     .-015,-020, 002, 009,-014,-031,-001,-008,-002,-004, ! dy2(1:10,15,10)
     . 000,-008, 015, 022,-002,-007, 016, 004, 012,-001, ! dy2(1:10,16,10)
     .-006, 008, 022, 038, 002,-009, 021, 008, 011, 003, ! dy2(1:10,17,10)
     . 005, 002, 014, 015,-011, 000, 011, 000, 011,-009, ! dy2(1:10,18,10)
     . 000, 007, 022,-006, 002,-003, 021, 006, 013,-001, ! dy2(1:10,19,10)
     .-015,-011, 013,-021,-011,-012, 005,-009,-004,-023, ! dy2(1:10,20,10)
     .-025,-019,-006,-025,-025,-024,-010,-011,-011,-026, ! dy2(1:10,21,10)
     .-028,-013,-004,-018,-023,-018,-012,-012,-012,-023, ! dy2(1:10,22,10)
     .-007,-009,-002,-009,-027,-018,-008,-007,-007,-032, ! dy2(1:10,23,10)
     .-024,-019,-013,-011,-019,-019,-021,-008,-018,-020, ! dy2(1:10,24,10)
     .-023,-018,-020,-016,-028,-026,-026, 001,-016,-028, ! dy2(1:10,25,10)
     .-001,-009, 002, 004,-002,-005,-002, 020, 004,-004, ! dy2(1:10,26,10)
     . 000,-005,-017,-002,-001,-004,-016, 004,-021,-006, ! dy2(1:10,27,10)
     . 006, 005,-012,-003, 013, 000,-012, 009,-012,-001, ! dy2(1:10,28,10)
     . 017, 015,-002, 007, 019, 002,-008, 010,-008, 007, ! dy2(1:10,29,10)
     . 010, 011,-005, 001, 022, 021,-005, 009,-006, 024, ! dy2(1:10,30,10)
     . 018, 020, 003, 007, 030, 035, 004, 015, 004, 021, ! dy2(1:10,31,10)
     . 044, 023, 017, 016, 046, 054, 025, 027, 025, 039, ! dy2(1:10,32,10)
     . 004, 026,-001, 001, 025, 026, 005, 014, 011, 028, ! dy2(1:10,33,10)
     . 006, 006,-006,-003, 016, 012, 013, 009, 011, 032, ! dy2(1:10,34,10)
     . 000, 009,-007,-006, 009, 011, 008, 009, 001, 008, ! dy2(1:10,35,10)
     .-006,-013,-014,-014,-003,-009, 002, 002,-014, 005, ! dy2(1:10,36,10)
     .-049,-043,-031,-036,-032,-033,-016,-036,-043,-025, ! dy2(1:10,37,10)
     .-033,-085,-067,-053,-052,-044,-026,-057,-054,-045, ! dy2(1:10,38,10)
     .-023,-008, 026, 023, 006, 013,-006,-006, 000, 014, ! dy2(1:10, 1,11)
     . 043, 016, 025, 009, 014, 007, 018,-010, 016, 023, ! dy2(1:10, 2,11)
     . 035, 009, 000, 009, 005, 009, 016,-009, 008, 018, ! dy2(1:10, 3,11)
     . 051, 021, 016, 022, 021, 034, 017, 000, 008, 047, ! dy2(1:10, 4,11)
     . 046, 036, 017, 022, 025, 025, 026, 013, 024, 039, ! dy2(1:10, 5,11)
     . 048, 030, 019, 022, 026, 035, 026, 019, 022, 041, ! dy2(1:10, 6,11)
     . 049, 049, 023, 028, 024, 035, 028, 031, 037, 039, ! dy2(1:10, 7,11)
     . 013, 024, 007, 019, 013, 017, 005, 016, 014, 023, ! dy2(1:10, 8,11)
     . 021,-010,-002, 026,-001, 006,-002,-007,-001, 006, ! dy2(1:10, 9,11)
     .-005, 001,-005, 020,-003, 001,-007,-002,-004, 000, ! dy2(1:10,10,11)
     . 027, 001, 011, 025, 006, 012, 007, 010, 009, 005, ! dy2(1:10,11,11)
     . 003,-006,-001, 016, 000, 003, 006, 006, 004, 008, ! dy2(1:10,12,11)
     . 010, 002, 012, 011, 005,-003, 015, 015, 018, 009, ! dy2(1:10,13,11)
     . 003, 000, 018, 016, 013, 006, 019, 017, 021, 003, ! dy2(1:10,14,11)
     . 019, 007, 025, 036, 010, 001, 026, 013, 024, 011, ! dy2(1:10,15,11)
     . 025, 034, 054, 068, 031, 019, 046, 031, 046, 023, ! dy2(1:10,16,11)
     . 028, 029, 041, 053, 022, 019, 038, 027, 030, 018, ! dy2(1:10,17,11)
     . 010, 020, 032, 030, 011, 011, 026, 017, 030, 008, ! dy2(1:10,18,11)
     . 016, 017, 029,-004, 008, 018, 034, 015, 019, 002, ! dy2(1:10,19,11)
     . 011, 015, 025,-003, 001, 003, 019, 004, 019,-005, ! dy2(1:10,20,11)
     . 021, 010, 025, 011, 002, 012, 015, 011, 016, 000, ! dy2(1:10,21,11)
     . 007, 019, 020, 013, 000, 012, 015, 013, 014, 008, ! dy2(1:10,22,11)
     . 000, 005, 018, 015, 002, 009, 010, 018, 016,-005, ! dy2(1:10,23,11)
     .-004, 010, 020, 012,-001, 007, 004, 021, 011,-002, ! dy2(1:10,24,11)
     .-022,-008,-006, 000, 000,-006,-006, 019,-008,-011, ! dy2(1:10,25,11)
     .-009, 005, 003,-004, 006, 001,-001, 018, 000,-003, ! dy2(1:10,26,11)
     . 000, 005,-012, 003, 003,-001,-016, 015,-009,-002, ! dy2(1:10,27,11)
     . 019, 021, 003, 014, 022, 014, 004, 021, 003, 012, ! dy2(1:10,28,11)
     . 017, 022, 011, 022, 037, 024, 009, 030, 009, 032, ! dy2(1:10,29,11)
     . 033, 021, 003, 011, 035, 038, 005, 019, 003, 026, ! dy2(1:10,30,11)
     . 024, 038, 018, 017, 037, 045, 022, 032, 015, 048, ! dy2(1:10,31,11)
     . 021, 023, 007, 015, 033, 033, 014, 023, 008, 032, ! dy2(1:10,32,11)
     . 001, 006,-007,-004, 024, 035, 007, 010, 010, 021, ! dy2(1:10,33,11)
     .-001, 012,-004,-001, 019, 014, 006, 009, 008, 020, ! dy2(1:10,34,11)
     .-003, 003,-013,-002, 005, 016, 009, 010,-004, 012, ! dy2(1:10,35,11)
     .-015,-036,-023,-031,-011,-017,-013,-014,-015, 002, ! dy2(1:10,36,11)
     .-058,-036,-036,-036,-042,-039,-018,-030,-048,-028, ! dy2(1:10,37,11)
     .-079,-061,-038,-045,-041,-048,-023,-037,-056,-035, ! dy2(1:10,38,11)
     . 004,-006, 011,-003,-008,-004, 014,-006, 005, 006, ! dy2(1:10, 1,12)
     . 016,-013, 000, 003,-011,-025, 008,-012, 006, 012, ! dy2(1:10, 2,12)
     . 045, 000, 008, 003, 000, 005, 010,-018, 007, 022, ! dy2(1:10, 3,12)
     . 020, 022, 007, 004, 011, 003, 015,-008, 018, 022, ! dy2(1:10, 4,12)
     . 047, 025, 012, 006, 020, 019, 018, 003, 017, 029, ! dy2(1:10, 5,12)
     . 032, 025, 019, 015, 016, 019, 013, 004, 015, 028, ! dy2(1:10, 6,12)
     . 056, 033, 020, 043, 029, 028, 025, 018, 025, 030, ! dy2(1:10, 7,12)
     . 036, 011, 003, 029, 006, 014, 008, 003, 007, 019, ! dy2(1:10, 8,12)
     .-011, 004,-008, 006,-009,-002,-010,-014,-011,-003, ! dy2(1:10, 9,12)
     . 000,-011,-006,-003,-006, 000,-006,-016,-009,-001, ! dy2(1:10,10,12)
     .-011,-002,-001, 005, 001, 006, 007,-008,-005, 004, ! dy2(1:10,11,12)
     .-006,-013,-007,-005,-009,-004,-005,-017,-009,-004, ! dy2(1:10,12,12)
     .-020,-015,-004, 013,-007, 001, 005,-004,-002,-005, ! dy2(1:10,13,12)
     .-010,-014, 001, 020, 000,-004, 008,-006, 001, 002, ! dy2(1:10,14,12)
     .-011,-005, 004, 025,-011,-002, 000,-003, 000,-009, ! dy2(1:10,15,12)
     .-006,-013, 005, 004,-012,-005, 006,-003,-003,-011, ! dy2(1:10,16,12)
     . 004, 002, 021, 002,-002, 001, 015, 005, 014, 000, ! dy2(1:10,17,12)
     . 010, 008, 024,-004, 000, 004, 013, 008, 006, 000, ! dy2(1:10,18,12)
     . 000, 002, 023, 015, 003,-001, 011, 009, 016,-005, ! dy2(1:10,19,12)
     .-011, 001, 018, 004,-006, 000, 006, 003, 002,-011, ! dy2(1:10,20,12)
     . 000,-006, 007, 001,-013,-016,-001, 000,-008,-011, ! dy2(1:10,21,12)
     . 006, 004, 012, 008,-004,-006,-001, 006, 001,-004, ! dy2(1:10,22,12)
     .-002, 003, 008, 007,-005,-008,-001, 012,-001,-007, ! dy2(1:10,23,12)
     . 004, 002, 003, 004, 000,-012,-007, 011,-005,-009, ! dy2(1:10,24,12)
     . 014, 011, 008, 003, 015, 006,-002, 029, 000, 006, ! dy2(1:10,25,12)
     . 021, 012, 004, 010, 013, 003,-003, 025, 001,-001, ! dy2(1:10,26,12)
     .-010, 004,-004, 001, 016, 006,-002, 024,-001, 002, ! dy2(1:10,27,12)
     . 010, 014,-005, 000, 024, 011,-004, 024, 003, 010, ! dy2(1:10,28,12)
     . 034, 027, 002, 013, 036, 030, 010, 036, 020, 032, ! dy2(1:10,29,12)
     . 007, 019, 003, 002, 028, 023, 005, 027, 012, 024, ! dy2(1:10,30,12)
     . 029, 026, 002, 015, 042, 044, 024, 031, 030, 034, ! dy2(1:10,31,12)
     . 014, 017,-005, 000, 030, 044, 016, 020, 027, 025, ! dy2(1:10,32,12)
     .-009,-004,-013,-016, 010, 013, 002, 005, 005, 019, ! dy2(1:10,33,12)
     .-006,-003,-012,-007, 012, 020, 016, 010, 014, 023, ! dy2(1:10,34,12)
     .-024,-015,-015,-018, 003, 002, 005,-006, 007, 011, ! dy2(1:10,35,12)
     .-032,-007,-017,-019,-018,-011,-002,-018,-019,-013, ! dy2(1:10,36,12)
     .-068,-050,-029,-041,-030,-026,-013,-049,-035,-021, ! dy2(1:10,37,12)
     .-030,-023,-023,-035,-035,-020,-018,-059,-036,-035, ! dy2(1:10,38,12)
     .-006,-006, 015,-019,-010,-024, 013,-008, 033, 035, ! dy2(1:10, 1,13)
     .-022,-010, 016,-001,-008, 005, 013, 003, 028, 015, ! dy2(1:10, 2,13)
     . 041,-001,-005,-013,-003,-028, 003,-018, 006, 011, ! dy2(1:10, 3,13)
     . 021,-001, 002,-002, 003, 007, 009,-002, 010, 027, ! dy2(1:10, 4,13)
     . 027, 022, 016, 005, 010, 007, 019, 003, 018, 027, ! dy2(1:10, 5,13)
     . 030, 013,-002, 014, 007, 006, 009,-001, 002, 017, ! dy2(1:10, 6,13)
     . 006, 002,-002, 010, 004, 014, 004, 005, 003, 013, ! dy2(1:10, 7,13)
     . 005,-008,-014, 004,-008, 000,-008,-012,-021,-007, ! dy2(1:10, 8,13)
     . 000,-005,-017,-020,-011,-001,-012,-026,-022,-010, ! dy2(1:10, 9,13)
     .-016,-010,-020,-015,-013,-005,-013,-028,-022,-005, ! dy2(1:10,10,13)
     . 007, 009, 000,-002, 002, 006, 004,-017,-008, 005, ! dy2(1:10,11,13)
     .-017,-004,-008, 003,-005, 003,-001,-020,-012,-005, ! dy2(1:10,12,13)
     .-001,-014,-007, 019,-005,-007, 001,-012,-006,-003, ! dy2(1:10,13,13)
     .-012,-007,-002, 013,-009,-001, 008,-012, 000,-006, ! dy2(1:10,14,13)
     .-018,-007, 000, 000,-010,-012,-003,-012,-010,-013, ! dy2(1:10,15,13)
     .-012,-001, 006,-012,-008,-003, 002,-008,-005,-004, ! dy2(1:10,16,13)
     .-003,-005, 006,-015,-010,-009,-002,-006,-003,-018, ! dy2(1:10,17,13)
     .-004,-003, 011, 000,-009,-012,-002,-005,-003,-010, ! dy2(1:10,18,13)
     . 001, 004, 012, 000,-006,-008, 003, 005,-003,-008, ! dy2(1:10,19,13)
     . 003,-002, 009, 004,-012,-018,-006,-004,-008,-015, ! dy2(1:10,20,13)
     .-009,-005, 005, 004,-008,-016,-009, 004,-002,-015, ! dy2(1:10,21,13)
     .-002, 000, 006, 009,-004,-010,-008, 010,-007,-011, ! dy2(1:10,22,13)
     . 004, 010, 005,-002, 001,-009,-009, 009,-008,-006, ! dy2(1:10,23,13)
     .-011, 000, 002,-002, 005,-007,-012, 014,-003,-008, ! dy2(1:10,24,13)
     . 014, 011, 000, 002, 013,-003,-004, 015, 000, 000, ! dy2(1:10,25,13)
     . 011, 015, 002, 000, 016, 001,-001, 018, 005, 002, ! dy2(1:10,26,13)
     . 003, 009,-005, 000, 019, 007,-005, 021, 009, 006, ! dy2(1:10,27,13)
     . 017, 013, 005, 003, 028, 016, 003, 031, 012, 012, ! dy2(1:10,28,13)
     . 016, 018,-002, 010, 037, 024, 009, 035, 018, 020, ! dy2(1:10,29,13)
     . 013, 004,-015,-005, 020, 021, 012, 027, 018, 019, ! dy2(1:10,30,13)
     . 005, 010,-001,-003, 026, 030, 015, 031, 027, 031, ! dy2(1:10,31,13)
     . 015, 010,-015,-004, 027, 025, 014, 025, 022, 031, ! dy2(1:10,32,13)
     .-016,-009,-017,-014, 004, 023, 006, 012, 011, 014, ! dy2(1:10,33,13)
     .-002, 002,-006,-004, 008, 018, 010, 008, 011, 007, ! dy2(1:10,34,13)
     .-017, 005,-003,-008, 004, 007, 011, 001, 006, 008, ! dy2(1:10,35,13)
     . 008,-028,-020,-022,-019,-014,-009,-028,-011,-004, ! dy2(1:10,36,13)
     .-052,-019,-006,-026,-031,-025,-012,-055,-037,-035, ! dy2(1:10,37,13)
     .-067,-067,-023,-044,-042,-019,-034,-055,-047,-033, ! dy2(1:10,38,13)
     . 015, 011, 031,-021, 001, 000, 012, 015, 037,-010, ! dy2(1:10, 1,14)
     . 027,-029, 013,-012,-019,-034, 016, 011, 028, 000, ! dy2(1:10, 2,14)
     . 014, 003, 005, 002,-007,-004, 008, 011, 017, 023, ! dy2(1:10, 3,14)
     . 054, 003,-001,-010, 001,-007, 011, 002, 014, 009, ! dy2(1:10, 4,14)
     . 011, 006, 000, 019, 006, 004, 016, 013, 018, 019, ! dy2(1:10, 5,14)
     . 019, 015, 011, 016, 008, 006, 012, 008, 010, 017, ! dy2(1:10, 6,14)
     . 043, 007,-002, 000, 004, 011, 009, 004, 000, 022, ! dy2(1:10, 7,14)
     . 012,-006,-010,-010,-010, 000,-002,-006,-006, 003, ! dy2(1:10, 8,14)
     .-008,-030,-034,-027,-025,-021,-022,-037,-038,-020, ! dy2(1:10, 9,14)
     . 001,-021,-022,-024,-012,-006,-014,-033,-027,-009, ! dy2(1:10,10,14)
     . 008, 005,-008, 002,-001, 008, 003,-020,-010, 003, ! dy2(1:10,11,14)
     . 002, 000,-010, 010,-005,-002,-002,-021,-012,-004, ! dy2(1:10,12,14)
     .-010, 007,-005, 000,-005, 001, 005,-018,-006,-001, ! dy2(1:10,13,14)
     .-006,-005,-012,-004,-006,-004, 000,-019,-008,-009, ! dy2(1:10,14,14)
     .-006, 001, 000,-020,-006, 000, 003,-011,-010,-008, ! dy2(1:10,15,14)
     .-002, 001, 002,-019,-009,-006, 000,-010,-010,-020, ! dy2(1:10,16,14)
     . 003, 007, 007,-002,-002,-002, 004,-001, 001,-004, ! dy2(1:10,17,14)
     .-005,-003, 004, 000,-010,-012,-004,-006,-007,-013, ! dy2(1:10,18,14)
     . 003, 015, 011, 015,-002,-017,-003, 003,-002,-017, ! dy2(1:10,19,14)
     . 000, 000, 000, 005,-007,-016,-015,-003,-012,-018, ! dy2(1:10,20,14)
     .-015, 000, 000,-002,-009,-028,-013, 000,-018,-022, ! dy2(1:10,21,14)
     . 012, 002, 000,-002,-002,-018,-014, 007,-012,-015, ! dy2(1:10,22,14)
     .-008, 007, 000, 004, 008,-015,-009, 019,-004,-003, ! dy2(1:10,23,14)
     . 002, 010, 005,-002, 006,-010,-010, 018,-001,-012, ! dy2(1:10,24,14)
     . 005, 012, 000, 014, 021, 006,-003, 023, 014, 007, ! dy2(1:10,25,14)
     . 009, 028, 017, 009, 028, 011, 009, 033, 019, 017, ! dy2(1:10,26,14)
     . 005, 003, 003, 007, 021, 009,-002, 023, 017, 012, ! dy2(1:10,27,14)
     . 003, 004,-013,-003, 021, 011, 000, 026, 018, 015, ! dy2(1:10,28,14)
     . 007, 007,-005, 000, 019, 017, 009, 032, 032, 027, ! dy2(1:10,29,14)
     . 000,-002,-018,-005, 016, 015, 001, 021, 024, 026, ! dy2(1:10,30,14)
     . 017, 013,-003, 002, 023, 035, 025, 032, 040, 033, ! dy2(1:10,31,14)
     . 016, 016,-005,-002, 022, 036, 017, 028, 032, 026, ! dy2(1:10,32,14)
     .-010,-008,-010,-010, 002, 018, 007, 007, 019, 014, ! dy2(1:10,33,14)
     .-018,-002,-003,-005, 003, 020, 007, 006, 011, 023, ! dy2(1:10,34,14)
     . 010,-007, 002,-012,-004, 008, 012,-009, 005, 003, ! dy2(1:10,35,14)
     .-049,-019,-012,-012,-017,-012,-003,-032,-016,-007, ! dy2(1:10,36,14)
     .-039,-043,-019,-035,-039,-033,-021,-070,-039,-048, ! dy2(1:10,37,14)
     .-048,-037,-026,-031,-041,-035,-019,-076,-040,-042, ! dy2(1:10,38,14)
     .-021,-035, 013, 018,-030,-021, 018, 035, 024, 015, ! dy2(1:10, 1,15)
     . 022,-030, 003, 003,-022,-032, 003, 031, 027, 010, ! dy2(1:10, 2,15)
     . 000,-023, 007,-003,-010,-026, 003, 028, 019, 003, ! dy2(1:10, 3,15)
     . 039, 022, 011, 029, 011, 001, 021, 039, 028, 035, ! dy2(1:10, 4,15)
     . 024, 004, 010, 013, 000, 002, 019, 024, 014, 019, ! dy2(1:10, 5,15)
     . 017,-012,-013, 000,-008,-011, 000, 002,-005,-004, ! dy2(1:10, 6,15)
     . 026, 007, 003, 002, 002, 009, 010, 013, 007, 016, ! dy2(1:10, 7,15)
     . 003,-016,-017,-014,-012,-010,-007,-008,-012,-003, ! dy2(1:10, 8,15)
     .-026,-022,-034,-037,-018,-014,-018,-029,-032,-017, ! dy2(1:10, 9,15)
     .-020,-023,-030,-018,-022,-019,-019,-031,-023,-019, ! dy2(1:10,10,15)
     . 007,-006,-025, 003,-009, 000,-009,-023,-019, 000, ! dy2(1:10,11,15)
     .-011,-005,-020,-003,-009,-006,-007,-027,-014,-013, ! dy2(1:10,12,15)
     . 008, 004,-004,-011, 000, 004, 003,-011,-008, 005, ! dy2(1:10,13,15)
     . 000, 010,-005,-013,-003, 000, 009,-014,-002,-008, ! dy2(1:10,14,15)
     .-004,-004,-011,-033,-008,-006,-006,-023,-013,-009, ! dy2(1:10,15,15)
     .-004, 008, 004,-001,-004,-001, 000,-012,-009,-006, ! dy2(1:10,16,15)
     . 010, 011, 003, 000, 000,-001, 003,-001,-012,-007, ! dy2(1:10,17,15)
     .-009, 003, 004, 008,-001,-013,-005,-001,-008,-016, ! dy2(1:10,18,15)
     . 007, 005, 002, 006, 004,-008,-002, 006,-007, 004, ! dy2(1:10,19,15)
     .-008,-001,-003, 000,-003,-016,-007,-001,-015,-016, ! dy2(1:10,20,15)
     . 008, 014,-002,-001, 004,-010,-006, 015,-007,-002, ! dy2(1:10,21,15)
     . 023, 018, 006, 000, 015,-005,-005, 023, 000, 006, ! dy2(1:10,22,15)
     . 003, 009, 007,-001, 011,-003,-009, 023, 004,-004, ! dy2(1:10,23,15)
     .-010, 010,-003, 001, 014,-006,-005, 022, 005, 002, ! dy2(1:10,24,15)
     . 011, 009, 010,-002, 022, 008,-001, 027, 022, 007, ! dy2(1:10,25,15)
     . 023, 016, 011, 001, 024, 008, 003, 029, 025, 013, ! dy2(1:10,26,15)
     .-013,-006,-014,-007, 006,-001,-003, 021, 016,-002, ! dy2(1:10,27,15)
     .-006,-006,-007,-007, 015, 011,-001, 023, 026, 009, ! dy2(1:10,28,15)
     . 011, 011,-004, 003, 017, 011, 012, 032, 041, 021, ! dy2(1:10,29,15)
     .-009,-007,-018,-007, 010, 018, 009, 027, 036, 013, ! dy2(1:10,30,15)
     . 011, 017, 001, 007, 018, 025, 020, 028, 039, 024, ! dy2(1:10,31,15)
     . 000, 008,-012,-003, 010, 021, 016, 022, 040, 015, ! dy2(1:10,32,15)
     .-009,-012, 000,-011,-004, 011, 009, 001, 007, 008, ! dy2(1:10,33,15)
     . 006, 012, 008, 006, 007, 022, 019, 001, 021, 003, ! dy2(1:10,34,15)
     .-009, 007, 013, 000, 000, 007, 016,-012, 002, 014, ! dy2(1:10,35,15)
     .-020,-010,-002,-012,-015,-012, 002,-041,-015,-018, ! dy2(1:10,36,15)
     .-057,-067,-012,-023,-035,-037,-017,-082,-040,-033, ! dy2(1:10,37,15)
     .-048,-042, 003,-020,-030,-024,-019,-075,-047,-050, ! dy2(1:10,38,15)
     . 012,-014, 046, 025,-014,-023, 028, 071, 065, 003, ! dy2(1:10, 1,16)
     .-020,-024, 040, 021,-020,-018, 013, 065, 047, 012, ! dy2(1:10, 2,16)
     . 002,-022, 007, 000,-021,-020,-002, 033, 023, 004, ! dy2(1:10, 3,16)
     . 013,-012, 004, 021,-010,-012, 008, 048, 020, 009, ! dy2(1:10, 4,16)
     . 006, 008, 018, 026, 017,-004, 022, 042, 034, 010, ! dy2(1:10, 5,16)
     . 016, 002, 001,-003,-002, 001, 007, 021, 010, 018, ! dy2(1:10, 6,16)
     . 012, 006, 000,-004, 006, 007, 009, 003, 006, 009, ! dy2(1:10, 7,16)
     . 000,-010,-011,-013,-004, 000, 003,-001,-006, 015, ! dy2(1:10, 8,16)
     . 001,-028,-032,-016,-025,-025,-018,-034,-026,-023, ! dy2(1:10, 9,16)
     .-004,-020,-019,-001,-012,-007,-010,-027,-023,-003, ! dy2(1:10,10,16)
     .-005, 008,-007, 007,-005,-003,-001,-021,-010,-013, ! dy2(1:10,11,16)
     . 016, 004,-020,-010,-005,-004,-006,-025,-016, 003, ! dy2(1:10,12,16)
     . 008, 006,-002,-026, 000,-003, 001,-029,-012,-017, ! dy2(1:10,13,16)
     . 004, 010,-004,-024,-002, 002,-001,-026,-019,-006, ! dy2(1:10,14,16)
     .-002,-010,-021,-020,-010,-013,-008,-037,-020,-027, ! dy2(1:10,15,16)
     .-009,-001,-017,-014,-012,-011,-009,-027,-021,-015, ! dy2(1:10,16,16)
     .-001,-004,-006, 000,-008,-019,-010,-019,-019,-021, ! dy2(1:10,17,16)
     .-016, 000,-009, 002,-006,-018,-002,-009,-021,-004, ! dy2(1:10,18,16)
     .-003, 005, 000,-012,-004,-024,-008,-001,-010,-020, ! dy2(1:10,19,16)
     . 001, 011,-005,-014,-003,-015,-010,-001,-013,-012, ! dy2(1:10,20,16)
     . 007, 000,-007,-014, 000,-018,-012, 008,-015,-016, ! dy2(1:10,21,16)
     .-007,-003,-008,-002, 005,-015,-009, 015,-012,-015, ! dy2(1:10,22,16)
     . 003, 006,-003,-004, 009,-011,-011, 016,-005,-006, ! dy2(1:10,23,16)
     . 001,-005,-007,-016, 007,-007,-015, 015,-002,-009, ! dy2(1:10,24,16)
     .-020,-005,-008,-011, 005,-006,-006, 017, 012,-007, ! dy2(1:10,25,16)
     .-010,-003,-007,-009, 009, 000,-008, 021, 011,-004, ! dy2(1:10,26,16)
     .-009,-008,-001,-012, 010, 004, 000, 024, 026, 002, ! dy2(1:10,27,16)
     .-009,-002,-014,-011, 011, 007, 005, 025, 033, 007, ! dy2(1:10,28,16)
     . 004, 000, 001,-005, 012, 022, 014, 028, 043, 024, ! dy2(1:10,29,16)
     .-008,-009,-007,-014, 003, 004, 005, 016, 031, 010, ! dy2(1:10,30,16)
     .-006, 022, 008, 012, 018, 035, 029, 028, 044, 027, ! dy2(1:10,31,16)
     . 000, 008, 013, 006, 015, 029, 023, 027, 043, 025, ! dy2(1:10,32,16)
     .-023, 006, 002, 000, 000, 018, 016,-001, 015, 008, ! dy2(1:10,33,16)
     .-004, 000, 011, 004,-004, 014, 019,-013, 006, 004, ! dy2(1:10,34,16)
     .-020,-017, 010,-001,-004, 002, 015,-034,-009,-015, ! dy2(1:10,35,16)
     .-025,-020, 005,-007,-014,-017, 005,-063,-028,-021, ! dy2(1:10,36,16)
     .-031,-024, 013,-004,-023,-022,-002,-079,-040,-036, ! dy2(1:10,37,16)
     .-048,-047, 001,-016,-035,-025,-015,-098,-040,-035, ! dy2(1:10,38,16)
     . 014,-023, 047, 034,-011,-030, 030, 093, 061, 000, ! dy2(1:10, 1,17)
     . 022,-006, 053, 034,-014,-012, 020, 097, 067,-016, ! dy2(1:10, 2,17)
     . 006,-019, 027, 033,-015,-024, 004, 063, 034,-002, ! dy2(1:10, 3,17)
     .-002,-017, 023, 029,-010,-011, 012, 058, 030,-011, ! dy2(1:10, 4,17)
     . 021, 001, 016, 022,-003, 007, 011, 056, 022, 023, ! dy2(1:10, 5,17)
     . 016,-013, 013, 010, 005, 002, 016, 033, 020, 013, ! dy2(1:10, 6,17)
     . 010, 044, 011, 021, 015, 022, 028, 028, 021, 023, ! dy2(1:10, 7,17)
     . 015,-018,-003, 002,-006,-003, 005, 002, 000,-005, ! dy2(1:10, 8,17)
     .-020,-010,-021,-001,-011,-012,-006,-026,-017,-006, ! dy2(1:10, 9,17)
     . 005,-007,-017,-012,-011,-017,-010,-034,-017,-021, ! dy2(1:10,10,17)
     . 025, 006,-006,-010, 000, 005, 004,-021,-011, 008, ! dy2(1:10,11,17)
     . 012, 002, 000,-019, 002, 000, 002,-028,-007,-010, ! dy2(1:10,12,17)
     . 002, 014,-006,-013, 001, 000, 007,-032,-012, 007, ! dy2(1:10,13,17)
     . 016,-001,-011,-013,-006,-006, 002,-036,-016,-002, ! dy2(1:10,14,17)
     .-014, 002,-008,-009,-004,-009,-006,-041,-024,-012, ! dy2(1:10,15,17)
     .-007,-007,-015,-002,-008,-020,-006,-038,-029,-014, ! dy2(1:10,16,17)
     .-030,-011,-019,-013,-009,-020,-009,-034,-026,-025, ! dy2(1:10,17,17)
     . 005,-003,-007,-009,-001,-014,-006,-021,-019,-014, ! dy2(1:10,18,17)
     . 004, 005,-008,-018, 005,-012,-004,-001,-015,-014, ! dy2(1:10,19,17)
     .-018, 000,-011,-020,-001,-022,-010,-011,-032,-023, ! dy2(1:10,20,17)
     . 004, 000,-014,-012,-001,-021,-012, 001,-021,-009, ! dy2(1:10,21,17)
     .-002, 005,-013,-007, 008,-013,-007, 004,-011,-011, ! dy2(1:10,22,17)
     . 001, 002,-007,-010, 006,-010,-007, 015,-007,-007, ! dy2(1:10,23,17)
     .-009,-002,-004,-010, 007,-001,-005, 017, 004,-005, ! dy2(1:10,24,17)
     . 004, 001,-003,-011, 011, 009,-001, 022, 012, 004, ! dy2(1:10,25,17)
     .-005,-004, 001,-009, 009, 011, 000, 021, 016,-011, ! dy2(1:10,26,17)
     .-009, 000,-011,-014, 006, 011, 000, 020, 019, 003, ! dy2(1:10,27,17)
     .-010,-002, 000,-006, 005, 009, 007, 020, 028,-003, ! dy2(1:10,28,17)
     . 000, 009,-001, 004, 013, 017, 015, 028, 036, 017, ! dy2(1:10,29,17)
     .-005, 009, 003, 000, 000, 021, 016, 027, 035, 013, ! dy2(1:10,30,17)
     . 016, 012, 022, 011, 017, 028, 026, 021, 034, 019, ! dy2(1:10,31,17)
     . 019, 003, 008, 012, 008, 018, 019, 013, 021, 016, ! dy2(1:10,32,17)
     .-014, 000, 007,-006,-016, 008, 006,-032,-002,-012, ! dy2(1:10,33,17)
     .-001, 001, 015,-002,-003, 011, 015,-036,-009, 001, ! dy2(1:10,34,17)
     .-020, 003, 022, 003,-003, 006, 017,-051,-005,-007, ! dy2(1:10,35,17)
     .-036,-013, 019,-005,-012,-009, 005,-079,-031,-020, ! dy2(1:10,36,17)
     .-057,-048, 012,-015,-033,-034,-004,-114,-058,-044, ! dy2(1:10,37,17)
     .-048,-028, 018,-010,-024,-031,-005,-112,-071,-047, ! dy2(1:10,38,17)
     . 034, 010, 126, 063,-001, 007, 028, 147, 094, 015, ! dy2(1:10, 1,18)
     . 000, 012, 131, 111, 012,-017, 043, 147, 094, 005, ! dy2(1:10, 2,18)
     .-003,-012, 067, 080,-002,-028, 019, 108, 062, 003, ! dy2(1:10, 3,18)
     . 025, 008, 072, 054, 008,-002, 023, 091, 053, 005, ! dy2(1:10, 4,18)
     .-007,-008, 042, 031, 010,-007, 020, 067, 034, 010, ! dy2(1:10, 5,18)
     . 004, 007, 030, 005, 000,-013, 008, 041, 014,-009, ! dy2(1:10, 6,18)
     . 043, 000, 026, 043, 022, 017, 028, 023, 021, 012, ! dy2(1:10, 7,18)
     . 007, 008, 019, 034, 008,-003, 016, 019, 012, 009, ! dy2(1:10, 8,18)
     . 026, 003, 009, 004,-002,-004, 001,-019,-003,-017, ! dy2(1:10, 9,18)
     . 003,-001, 009, 002, 001, 001, 010,-025,-004, 003, ! dy2(1:10,10,18)
     . 000, 022, 016,-018, 004,-001, 013,-040,-008, 000, ! dy2(1:10,11,18)
     . 022, 013, 004,-002, 002, 005, 011,-039,-011, 014, ! dy2(1:10,12,18)
     . 043, 038, 023, 022, 016, 016, 018,-040, 000, 012, ! dy2(1:10,13,18)
     . 004, 039, 011, 013, 012, 010, 016,-043,-013, 006, ! dy2(1:10,14,18)
     . 028, 014, 010, 005, 012, 000, 017,-045,-005, 000, ! dy2(1:10,15,18)
     . 020, 028, 010, 003, 019, 005, 014,-033,-011, 010, ! dy2(1:10,16,18)
     . 027, 011, 003,-004, 012, 000, 009,-035,-013, 005, ! dy2(1:10,17,18)
     .-002, 019,-002,-015, 015,-003, 007,-035,-016, 000, ! dy2(1:10,18,18)
     . 004, 003, 011, 011, 008,-008, 007,-013,-017, 006, ! dy2(1:10,19,18)
     . 009,-006,-008,-009,-002,-030,-012,-026,-028,-007, ! dy2(1:10,20,18)
     . 018, 011, 000, 000, 012, 000, 004,-001,-020,-013, ! dy2(1:10,21,18)
     . 004, 007, 006,-013, 005,-003,-008, 001,-021,-001, ! dy2(1:10,22,18)
     . 004, 003,-006,-005, 005, 004,-005, 005,-010, 005, ! dy2(1:10,23,18)
     . 012, 026, 004,-007, 015, 017, 007, 013, 000, 004, ! dy2(1:10,24,18)
     .-006, 014, 000, 000, 004, 019, 006, 015, 013, 002, ! dy2(1:10,25,18)
     . 006, 024, 003,-005, 012, 021, 010, 012, 009, 015, ! dy2(1:10,26,18)
     .-006, 010, 008, 001,-002, 024, 006, 013, 016, 000, ! dy2(1:10,27,18)
     .-010, 005, 005, 000, 007, 024, 013, 017, 017, 011, ! dy2(1:10,28,18)
     . 003, 013, 015,-002, 000, 032, 024, 010, 017,-003, ! dy2(1:10,29,18)
     . 000,-008, 004, 000,-004, 017, 008,-008,-002,-005, ! dy2(1:10,30,18)
     .-003, 038, 036, 028, 000, 024, 032,-008,-001, 017, ! dy2(1:10,31,18)
     . 003, 027, 027, 006,-002, 019, 025,-023,-001,-008, ! dy2(1:10,32,18)
     .-032,-008, 002, 002,-008, 002, 002,-057,-035,-022, ! dy2(1:10,33,18)
     .-032,-006, 023,-001,-010, 000, 013,-077,-024,-023, ! dy2(1:10,34,18)
     .-032,-023, 029, 007,-014, 008, 012,-095,-042,-027, ! dy2(1:10,35,18)
     .-034,-022, 029, 001,-021,-010,-004,-125,-055,-039, ! dy2(1:10,36,18)
     .-057,-041, 041,-010,-034,-004,-013,-156,-083,-062, ! dy2(1:10,37,18)
     .-110,-040, 041,-031,-052, 001,-004,-167,-067,-105/ ! dy2(1:10,38,18)
 
c----------------------------------------------------------------------
 
      LOOKUP = .true.
      if (LOOKUP) then
 
      filteru = filter
      if (filter.eq.12) filteru = 0
 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     POLYNOMIAL COEFFICIENTS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 
         do i = 1, 9
            a(i) = apoly(i,chip,1+filteru)
            b(i) = bpoly(i,chip,1+filteru)
         enddo
 
 
CCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     CORRECTIONS
C
CCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCC
 
 
C
C   Compute where the input point is in terms of the x array
C   indices ; the goal is to just find the one below and the
C   one above; the challenge is that there are zones of 6,
C   and there's a repeat at the end of one and the beginning
C   of the next ;  "nx" is the lower index and "fx" tells you
C   where you are between "nx" and "nx+1"
C
         zx    = int((xr-23.5)/675+100)-100
         xr_zx = 23.5 + zx*675
         rzx   = (xr-xr_zx)/112.5 - 0.5
         if (rzx.lt.0.000) rzx = 0.000
         if (rzx.gt.4.999) rzx = 4.999
 
         rx    = 2 + (zx)*6 + rzx
 
         if (rx.lt. 2) rx =  2.0001
         if (rx.gt.37) rx = 36.9999
         if (zx.eq.-1) rx =  1.0001
         if (zx.eq. 6) rx = 37.9999
 
         nx = int(rx)
         fx = (xr         -x_tab(nx)) /
     .        (x_tab(nx+1)-x_tab(nx))
 
         if (zx.eq.-1) then
            nx =  1
            fx =  0.0001
         endif
         if (zx.eq. 6) then
            nx = 37
            fx =  0.9999
         endif
 
c
c the y-index stuff is a bit easier, but only
c a bit.  Again, "ny" is the lower index and "fy"
c tells you where you are between "ny" and "ny+1"
c
 
         ry = 2 + (yr-171)/114
         if (ry.lt.01.0001) ry = 01.0001
         if (ry.gt.17.9999) ry = 17.9999
 
         if (chip.eq.1) then
            if (yr.le. 911.and.ry.gt. 7.999) ry =  7.999
            if (yr.gt. 911.and.ry.lt. 9.001) ry =  9.001
            ny = int(ry)
            fy = (yr          -y1_tab(ny)) /
     .           (y1_tab(ny+1)-y1_tab(ny))
         endif
 
         if (chip.eq.2) then
            if (yr.le.1140.and.ry.gt. 9.999) ry =  9.999
            if (yr.gt.1140.and.ry.lt.11.001) ry = 11.001
            ny = int(ry)
            fy = (yr          -y2_tab(ny)) /
     .           (y2_tab(ny+1)-y2_tab(ny))
         endif
 
 
         if (chip.eq.1) then
            dxt = (1-fx)*(1-fy)*dx1(01+filteru,nx,  ny  )*0.001
     .          + (1-fx)*( fy )*dx1(01+filteru,nx,  ny+1)*0.001
     .          + ( fx )*(1-fy)*dx1(01+filteru,nx+1,ny  )*0.001
     .          + ( fx )*( fy )*dx1(01+filteru,nx+1,ny+1)*0.001
            dyt = (1-fx)*(1-fy)*dy1(01+filteru,nx  ,ny  )*0.001
     .          + (1-fx)*( fy )*dy1(01+filteru,nx  ,ny+1)*0.001
     .          + ( fx )*(1-fy)*dy1(01+filteru,nx+1,ny  )*0.001
     .          + ( fx )*( fy )*dy1(01+filteru,nx+1,ny+1)*0.001
         endif
 
 
         if (chip.eq.2) then
            dxt = (1-fx)*(1-fy)*dx2(01+filteru,nx  ,ny  )*0.001
     .          + (1-fx)*( fy )*dx2(01+filteru,nx  ,ny+1)*0.001
     .          + ( fx )*(1-fy)*dx2(01+filteru,nx+1,ny  )*0.001
     .          + ( fx )*( fy )*dx2(01+filteru,nx+1,ny+1)*0.001
            dyt = (1-fx)*(1-fy)*dy2(01+filteru,nx  ,ny  )*0.001
     .          + (1-fx)*( fy )*dy2(01+filteru,nx  ,ny+1)*0.001
     .          + ( fx )*(1-fy)*dy2(01+filteru,nx+1,ny  )*0.001
     .          + ( fx )*( fy )*dy2(01+filteru,nx+1,ny+1)*0.001
         endif
 
      else ! (if LOOKUP .eq. .false.)
         dxt = 0
         dyt = 0
      endif
 
C     MEMO
C     filter:
C     0 -> F225W
C     1 -> F275W
C     2 -> F336W
C     3 -> F390W
C     4 -> F438W
C     5 -> F555W
C     6 -> F606W
C     7 -> F775W
C     8 -> F814W
C     9 -> F850L
 
 
CCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     POLYNOMIAL
C
CCCCCCCCCCCCCCCCCCCCCCCCCC
 
 
C----> input xt, yt ----> output xc, yc (polynomial correction)
C
C J I did find it strange that you used (xt,yt) here and not
C   (xr,yr)...
C
 
C normalized positions
 
      x_cen=2048
      y_cen=1025
      xt = xr + dxt
      yt = yr + dyt
      rx=(xt-x_cen)/x_cen
      ry=(yt-y_cen)/y_cen
 
C corrections
 
      dxp = (a(3)*rx*rx)
     .     +(a(4)*rx*ry)
     .     +(a(5)*ry*ry)
     .     +(a(6)*rx*rx*rx)
     .     +(a(7)*rx*rx*ry)
     .     +(a(8)*rx*ry*ry)
     .     +(a(9)*ry*ry*ry)
 
      dyp = (b(1)*rx)
     .     +(b(2)*ry)
     .     +(b(3)*rx*rx)
     .     +(b(4)*rx*ry)
     .     +(b(5)*ry*ry)
     .     +(b(6)*rx*rx*rx)
     .     +(b(7)*rx*rx*ry)
     .     +(b(8)*rx*ry*ry)
     .     +(b(9)*ry*ry*ry)
 
      xc = xr + dxp + dxt
      yc = yr + dyp + dyt
 
      return
      end ! subroutine wfc3uv_gc
 
 
 
 
 
 
 
 
 
 
C--------------------------------------------------------
C
C This is a wrapper that puts single-chip GD corrections into a
C meta coordinate system.
C
C The properties of this system are that
C    1) the bottom chip is in its frame but has y --> y+200 to prevent
C       negative coordinates
C    2) the top chip is transformed using linear transformations
C       into the frame implied by the bottom chip
C
      subroutine wfc3uv_gc_meta_k(xr,yr,chip,filter,xc,yc)
      implicit none
 
      real*8 xr, yr
      integer chip
      integer filter
      real*8 xc, yc
 
      real*8 xru, yru
      real*8 xcu, ycu
      real*8 fx, fy
      real*8 skew1
      real*8 skew2
      real*8 a(9), b(9)
 
      real    rx,  ry
      integer nx,  ny
      real    ddx, ddy
 
      real filt_shift_x(10)
      data filt_shift_x / 0.200,  0.265,  0.440,  0.280, -0.075,
     .                   -0.085,  0.000,  0.260, -0.070,  0.155/
 
      real filt_shift_y(10)
      data filt_shift_y / 0.265,  0.120, -0.315, -0.330, -0.520,
     .                   -0.685,  0.000, -1.480, -0.455, -0.920/
 
      real filt_scl(10)
      data filt_scl / 1.000110, 0.999997, 0.999851, 0.999894, 1.000007,
     .                1.000121, 0.999997, 1.000004, 1.000048, 1.000158/
 
      real skewxx_(10), skewxy_(10), offxxx_(10)
      real skewyx_(10), skewyy_(10), offyyy_(10)
      real*8 xch, ych
 
 
      data offxxx_ /   -2.024,   -2.001,   -2.023,   -2.001,   -2.003,
     .                 -1.996,   -2.020,   -1.975,   -2.048,   -1.969/
 
      data offyyy_ / 2073.362, 2073.354, 2073.383, 2073.411, 2073.402,
     .               2073.434, 2073.410, 2073.409, 2073.463, 2073.389/
 
      data skewxx_ /  -12.152,  -12.123,  -12.068,  -12.098,  -12.097,
     .                -12.063,  -12.035,  -11.995,  -12.038,  -12.027/
 
      data skewxy_ /   -2.355,   -2.318,   -2.384,   -2.391,   -2.368,
     .                 -2.356,   -2.367,   -2.346,   -2.384,   -2.299/
 
      data skewyx_ /    2.306,    2.310,    2.367,    2.397,    2.367,
     .                  2.360,    2.363,    2.339,    2.387,    2.300/
 
      data skewyy_ /  -12.146,  -12.116,  -12.068,  -12.110,  -12.096,
     .                -12.046,  -12.031,  -11.987,  -12.033,  -12.017/
 
 
      if (chip.ne.1.and.chip.ne.2) stop 'invalid chip'
 
      if (chip.eq.1) then
           xru = xr
           yru = yr
           call wfc3uv_gc(xru,yru,1,filter,xcu,ycu)
           xc  = xcu
           yc  = ycu
           endif
 
      if (chip.eq.2) then
           xru = xr
           yru = yr
           call wfc3uv_gc(xru,yru,2,filter,xcu,ycu)
 
           fx  = (xcu-2048.00)/2048.0
           fy  = (ycu-1024.00)/2048.0
 
           xc  = xcu + offxxx_(1+filter)
     .               + skewxx_(1+filter)*fx
     .               + skewxy_(1+filter)*fy
 
           yc  = ycu + offyyy_(1+filter)
     .               + skewyx_(1+filter)*fx
     .               + skewyy_(1+filter)*fy
 
 
         endif
 
      xc = xc + filt_shift_x(1+filter)
      yc = yc + filt_shift_y(1+filter)
 
 
 
c-------------------------------------------------------
c
c include the field expansion
c
      xc = 2048 + (xc-2048)/filt_scl(1+filter)
      yc = 2048 + (yc-2048)/filt_scl(1+filter)
 
 
      yc = yc + 200
 
      return
      end
 
 
 
 
 
 
 
 
c--------------------------------------------------------
c
c This particular wrapper takes a position in the
c    4096x4096 abutted frame and finds the meta-frame
c    position.
c
      subroutine wfc3uv_gc_meta(xr,yr,filter,xc,yc)
      implicit none
      real*8 xr, yr
      integer filter
      real*8 xc, yc
 
      real*8 xru
      real*8 yru
      integer chip
 
      if (yr.lt.2048) then
         xru = xr
         yru = yr
         call wfc3uv_gc_meta_k(xru,yru,1,filter,xc,yc)
         return
         endif
 
      if (yr.gt.2048) then
         xru = xr
         yru = yr-2048
         call wfc3uv_gc_meta_k(xru,yru,2,filter,xc,yc)
         return
         endif
 
      return
      end
 
 
 
 
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GC/wfc3u_cg.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------
c
c this will perform the inverse
c distortion correction...
c
      subroutine wfc3uv_cg_meta(xc,yc,kin,f,xr,yr)
      implicit none
      real*8 xc,yc
      real*8 xr,yr
      integer kin, f
 
      integer k
      real*8 xt,yt
 
      real*8 dx, dy, dd
      integer NIT
      real*8 xr1, yr1
      real*8 xr2, yr2
 
      k = kin
 
      xr1 = xc
      yr1 = yc
      NIT = 0
 1    continue
      NIT = NIT + 1
      call wfc3uv_gc_meta_k(xr1,yr1,1,f,xt,yt)
      dx = xc-xt
      dy = yc-yt
      dd = sqrt(dx**2+dy**2)
      xr1 = xr1 + (xc-xt)*0.5
      yr1 = yr1 + (yc-yt)*0.5
      if (dd.gt.0.001.and.NIT.lt.99) goto 1
 11   continue
 
 
      xr2 = xc
      yr2 = yc
      NIT = 0
 2    continue
      NIT = NIT + 1
      call wfc3uv_gc_meta_k(xr2,yr2,2,f,xt,yt)
      dx = xc-xt
      dy = yc-yt
      dd = sqrt(dx**2+dy**2)
      xr2 = xr2 + (xc-xt)*0.5
      yr2 = yr2 + (yc-yt)*0.5
      if (dd.gt.0.001.and.NIT.lt.99) goto 2
 22   continue
 
 
      if (k.eq.1)  then
         xr = xr1
         yr = yr1
         return
         endif
      if (k.eq.2)  then
         xr = xr2
         yr = yr2
         return
         endif
      if (k.le.0) then
         if (yr2.gt.0001) then
             xr = xr2
             yr = yr2+2048
             if (xr.lt.0000.or.
     .           xr.gt.4096.or.
     .           yr.lt.2048.or.
     .           yr.gt.4096) then
                 xr =  -1.00
                 yr =  -1.00
                 endif
             return
             endif
         if (yr1.lt.2048) then
             xr = xr1
             yr = yr1
             if (xr.lt.0000.or.
     .           xr.gt.4096.or.
     .           yr.lt.0000.or.
     .           yr.gt.2048) then
                 xr =  -1.00
                 yr =  -1.00
                 endif
             return
             endif
         if (yr1.ge.2048.and.yr2.le.0001.and.k.eq.0) then
             xr = -1
             yr = -1
             return
             endif
         if (yr1.ge.2048.and.yr2.le.0001.and.k.eq.-1) then
             xr =  xr2
             yr = 2048
             return
             endif
         xr = -1
         yr = -1
         endif
 
 
 
      return
      end
 
 
 
 
c--------------------------------------------------
c GEN - GENERAL ROUTINES
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/bTOu2.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c-----------------------------------------------------------------------
c
c
      integer*2 function bTOu2(b)
      implicit none
 
      byte b
 
      bTOu2 = b
      if (bTOu2.lt.0) bTOu2 = bTOu2 + 256
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/dclip.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      real*8 function dclip(x,xmin,xmax)
      implicit none
 
      real*8 x
      real xmax
      real xmin
 
      dclip = x
      if (.not.(dclip.ge.xmin)) dclip = xmin
      if (.not.(dclip.le.xmax)) dclip = xmax
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/img2putchar_b1.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine img2putchar_b1(putchar,val,ic,jc,pix,NX,NY)
      implicit none
 
      character putchar
      integer ic,jc
      integer val
      integer NX,NY
      byte pix(NX,NY)
 
      integer i,j,n,nchar
 
      character*27 INFO(39)
      data INFO/
     .     'aA.***.*...*******...**...*',
     .     'bB****.*..******.*..******.',
     .     'cC.*****....*....*.....****',
     .     'dD****.*...**...**...*****.',
     .     'eE******....***..*....*****',
     .     'fF******....***..*....*....',
     .     'gG******....*..***...******',
     .     'hH*...**...*******...**...*',
     .     'iI.***...*....*....*...***.',
     .     'jJ....*....*....**...*.***.',
     .     'kK*...**..*.***..*..*.*...*',
     .     'lL*....*....*....*....*****',
     .     'mM*...***.***.*.**...**...*',
     .     'nN*...***..**.*.**..***...*',
     .     'oO.***.*...**...**...*.***.',
     .     'pP******...*******....*....',
     .     'qQ******...**...**..*.***.*',
     .     'rR******...****..*..*.*...*',
     .     'sS******....*****....******',
     .     'tT*****..*....*....*....*..',
     .     'uU*...**...**...**...******',
     .     'vV*...**...**...*.*.*...*..',
     .     'wW*...**...**.*.***.***...*',
     .     'xX*...*.*.*...*...*.*.*...*',
     .     'yY*...*.*.*...*....*....*..',
     .     'zZ*****...*...*...*...*****',
     .     '00.***.*...**.*.**...*.***.',
     .     '11.**....*....*....*...***.',
     .     '22*****....*******....*****',
     .     '33*****....******....******',
     .     '44...*.*..*.*****...*....*.',
     .     '55******....*****....******',
     .     '66******....******...******',
     .     '77*****....*...*....*....*.',
     .     '88******...*******   ******',
     .     '99******...******.   ******',
     .     '  .........................',
     .     '........................*..',
     .     '--...........***...........'/
 
 
      do N = 1, 39
         if (putchar.eq.INFO(N)(1:1).or.
     .       putchar.eq.INFO(N)(2:2)) then
            do i = -2,2
            do j = -2,2
               nchar = 3 + i+2 + (2-j)*5
               if (INFO(N)(nchar:nchar).eq.'*')
     .            pix(ic+i,jc+j) = val
               enddo
               enddo
            endif
         enddo
 
      return
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/img2putchar_i2.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine img2putchar_i2(putchar,val,ic,jc,pix,NX,NY)
      implicit none
 
      character putchar
      integer ic,jc
      integer val
      integer NX,NY
      integer*2 pix(NX,NY)
 
      integer i,j,n,nchar
 
      character*27 INFO(39)
      data INFO/
     .     'aA.***.*...*******...**...*',
     .     'bB****.*..******.*..******.',
     .     'cC.*****....*....*.....****',
     .     'dD****.*...**...**...*****.',
     .     'eE******....***..*....*****',
     .     'fF******....***..*....*....',
     .     'gG******....*..***...******',
     .     'hH*...**...*******...**...*',
     .     'iI.***...*....*....*...***.',
     .     'jJ....*....*....**...*.***.',
     .     'kK*...**..*.***..*..*.*...*',
     .     'lL*....*....*....*....*****',
     .     'mM*...***.***.*.**...**...*',
     .     'nN*...***..**.*.**..***...*',
     .     'oO.***.*...**...**...*.***.',
     .     'pP******...*******....*....',
     .     'qQ******...**...**..*.***.*',
     .     'rR******...****..*..*.*...*',
     .     'sS******....*****....******',
     .     'tT*****..*....*....*....*..',
     .     'uU*...**...**...**...******',
     .     'vV*...**...**...*.*.*...*..',
     .     'wW*...**...**.*.***.***...*',
     .     'xX*...*.*.*...*...*.*.*...*',
     .     'yY*...*.*.*...*....*....*..',
     .     'zZ*****...*...*...*...*****',
     .     '00.***.*...**.*.**...*.***.',
     .     '11.**....*....*....*...***.',
     .     '22*****....*******....*****',
     .     '33*****....******....******',
     .     '44...*.*..*.*****...*....*.',
     .     '55******....*****....******',
     .     '66******....******...******',
     .     '77*****....*...*....*....*.',
     .     '88******...*******   ******',
     .     '99******...******.   ******',
     .     '  .........................',
     .     '........................*..',
     .     '--...........***...........'/
 
      do N = 1, 39
         if (putchar.eq.INFO(N)(1:1).or.
     .       putchar.eq.INFO(N)(2:2)) then
            do i = -2,2
            do j = -2,2
               nchar = 3 + i+2 + (2-j)*5
               if (INFO(N)(nchar:nchar).eq.'*')
     .            pix(ic+i,jc+j) = val
               enddo
               enddo
            endif
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/img2putstr_b1.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine img2putstr_b1(string,NELEM,val,ic,jc,pix,NX,NY)
      implicit none
      integer   NELEM
 
      character STRING(NELEM)
      integer ic,jc
      integer val
      integer NX,NY
      byte pix(NX,NY)
      integer N
 
      do N = 1, NELEM
         call img2putchar_b1(string(N),val,ic+(N-1)*6,jc,pix,NX,NY)
         enddo
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/img2putstr_i2.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine img2putstr_i2(string,NELEM,val,ic,jc,pix,NX,NY)
      implicit none
      integer   NELEM
 
      character STRING(NELEM)
      integer ic,jc
      integer val
      integer NX,NY
      integer*2 pix(NX,NY)
      integer N
 
      do N = 1, NELEM
         call img2putchar_i2(string(N),val,ic+(N-1)*6,jc,pix,NX,NY)
         enddo
 
      return
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/log_report.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------
c
c this routine will report how much time has been
c spent in the various zones...
c
      subroutine log_report(IT,JT,UREF_T,VREF_T)
 
      implicit none
      integer IT,JT
      integer UREF_T, VREF_T
 
c-----------------------------------
 
      integer syst(25)        ! cumulative by zone
      common /syst_/syst
 
      character*40 zone_string(25)
      common /zone_string_/zone_string
 
      integer zz
      integer tt
      character*40 stringu
      integer i
      character charu
 
c-----------------------------------
 
!$omp critical(log_report)
      open(31,file='LOGK.REPORT',status='unknown')
      tt = 0
      do zz = 1, 25
         tt = tt + syst(zz)
         enddo
 
      write(31,*)
      write(31,'('' IT: '',i3.3,5x,i5.5)') IT,UREF_T
      write(31,'('' JT: '',i3.3,5x,i5.5)') JT,VREF_T
      write(31,*)
 
      print*,'  '
      print*,'****************************************************'
      print*,'**** '
      print*,'**** ZONE REPORT  '
      print*,'**** '
      print*,'****************************************************'
      print*,'  '
      do zz = 1, 25
         stringu = '                                        '
         i = 0
    1    i = i + 1
         charu = zone_string(zz)(i:i)
         stringu(i:i) = charu
         if (zone_string(zz)(i:i).eq.'_') goto 1
         if (zone_string(zz)(i:i).eq.'(') goto 1
         if (zone_string(zz)(i:i).eq.')') goto 1
         if (zone_string(zz)(i:i).ge.'a'.and.
     .       zone_string(zz)(i:i).le.'z') goto 1
         if (zone_string(zz)(i:i).ge.'A'.and.
     .       zone_string(zz)(i:i).le.'Z') goto 1
         if (zone_string(zz)(i:i).eq.'0') goto 1
         if (zone_string(zz)(i:i).ge.'1'.and.
     .       zone_string(zz)(i:i).le.'9') goto 1
         if (i.gt.5) write(31,111) zz,syst(zz),100.*syst(zz)/tt,
     .                             stringu
         if (i.gt.5) write( *,111) zz,syst(zz),100.*syst(zz)/tt,
     .                             stringu
         enddo
      write( *,'(40(''-''))')
      write( *,112) tt/01.0,      'seconds'
      write( *,112) tt/60.0,      'minutes'
      write( *,112) tt/60.0/60.0, 'hours'
      write(31,'(40(''-''))')
      write(31,112) tt/01.0,      'seconds'
      write(31,112) tt/60.0,      'minutes'
      write(31,112) tt/60.0/60.0, 'hours'
  111 format(10x,i2.2,5x,i14,5x,f10.2,5x,40a,1x,i20)
  112 format(10x, 2x ,5x,f14.2,5x,10x,5x,40a,1x,i20)
      print*,'  '
      close(31)
!$omp end critical(log_report)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/log_zone.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------
c
c this routine will keep track of how much time
c the program spends in various zones, 1-25 ;
c
c if z=0 is input, then it resets things
c
      subroutine log_zone(z,STRING)
      implicit none
      integer z
      character*40 STRING
c-----------------------------------
 
      integer syst(25)        ! cumulative by zone
      common /syst_/syst
 
      character*40 zone_string(25)
      common /zone_string_/zone_string
 
      integer i, i0           ! current and previous time
      common /i0/i0
 
      integer zz
      integer*4 mclock        ! holds the number of cycles since start
 
c-----------------------------------
 
c     call itime(timeArray)
c     i = timeArray(1)*60*60 + timeArray(2)*60 + timearray(3)
 
      i = time()
 
      if (z.eq.0) then
         do zz = 1, 25
            syst(zz) = 0
            enddo
         i0 = i
         return
         endif
 
      syst(z) = syst(z) + (i-i0)
      i0 = i
 
      zone_string(z) = STRING
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/noisesig.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------------------------
c
c this function will return random noise in terms of sigma.  The return value
c will be between -2 and 2 and will have a gaussian distribution centered about
c 1 with a sigma of 1  ( exp( (-x**2)/2 ) )
c
 
      real function noise_sig()
      implicit none
 
      real rand
 
      noise_sig = cos(3.1415927*2*rand(0))*sqrt(-2*log(rand(0)))
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/rclip.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      real*4 function rclip(x,xmin,xmax)
      implicit none
 
      real x
      real xmax
      real xmin
 
      rclip = x
      if (.not.(rclip.ge.xmin)) rclip = xmin
      if (.not.(rclip.le.xmax)) rclip = xmax
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/abbrev.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------
c
c this routine will abbreviate a string ; it'll
c keep one letter of each of the early directories
c and will report the entire filename
c
c     /home/jayander/FORTRAN/CODE/abbrev.f
c
c     ----->
c
c                /h/j/F/C/abbrev.f
c
c
      character*80 function abbrev(string)
      implicit none
 
      character*80 string
      integer start
      integer i, j, ii
 
      do i = 01, 80
         abbrev(i:i) = ' '
         enddo
 
      start = -1
      j = 0
      do i = 01, 80
         if (string(i:i).eq.'/') then
            if (start.ne.-1) then
               j = j + 1
               abbrev(j:j) = string(start:start)
               endif
            j = j + 1
            abbrev(j:j) = '/'
            start = -1
            goto 1
            endif
         if (string(i:i).eq.' ') goto 4
         if (start.eq.-1) start = i
    1    continue
         enddo
 
    4 continue
 
      if (start.ne.-1) then
         do ii = start, i-1
            j = j + 1
            abbrev(j:j) = string(ii:ii)
            enddo
         endif
 
      return
      end
 
 
c--------------------------------------------------
c HASH - 2D HASH TABLE STUFF
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/HASH/init_hash.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c---------------------------------------------------
c
c will initialize the hash tables
c
      subroutine init_hash(nash,hash)
      implicit none
 
      integer*2 nash(_HASHDM_,_HASHDM_)
      integer*4 hash(_HASHDM_,_HASHDM_,_HASHMX_)
 
      integer i, j, n
 
      do i = 001, _HASHDM_
      do j = 001, _HASHDM_
         nash(i,j) = 0
         do n = 1, _HASHMX_
            hash(i,j,n) = 0
            enddo
         enddo
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/HASH/push_hash.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------
c
c this will take a list of stars and add it to the
c 2-d hash table
c
      subroutine push_hash(nash,hash,No,Ns,un,vn)
      implicit none
 
      integer*2 nash(_HASHDM_,_HASHDM_)
      integer*4 hash(_HASHDM_,_HASHDM_,_HASHMX_)
 
      integer No
      integer Ns
      real*8  un(_NSTMAX_)
      real*8  vn(_NSTMAX_)
 
      integer N
      integer it, jt
 
      write(*,'(5x,''enter push_hash... '')')
      write(*,'(5x,''         No: '',i6)') No
      write(*,'(5x,''         Ns: '',i6)') Ns
      do N = No+1, Ns
         it = int((un(N)-_HCEN_)/120.0+0.5)+1
         jt = int((vn(N)-_HCEN_)/120.0+0.5)+1
         if (it.lt.1.or.it.gt._HASHDM_.or.
     .       jt.lt.1.or.jt.gt._HASHDM_) then
             print*,'HASH PROB  it.lt.1 or it.gt._HASHDIM  '
             print*,'        or jt.lt.1 or jt.gt._HASHDIM: '
             print*,'--->       it: ',it,un(N)
             print*,'--->       jt: ',jt,vn(N)
             print*,'---> _HASHDM_: ',_HASHDM_
             stop
             endif
         nash(it,jt) = nash(it,jt) + 1
         if (nash(it,jt).gt._HASHMX_) then
             print*,'HASH PROB: nash(it,jt).gt._HASHMX_'
             print*,'--->       nt: ',nash(it,jt),it,jt
             print*,'--->        n: ',N,No,Ns
             print*,'---> _HASHMX_: ',_HASHMX_
             stop
             endif
         hash(it,jt,nash(it,jt)) = N
    1    continue
         enddo
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/HASH/show_hash.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c-------------------------------------------------
c
c a one-liner
c
      subroutine show_hash(nash,FILENAME)
      implicit none
 
      integer*2     nash(_HASHDM_,_HASHDM_)
      character*(*) FILENAME
 
      call writfits_i2(FILENAME,nash,_HASHDM_,_HASHDM_)
 
      end
 
 
 
c--------------------------------------------------
c PSF - PSF-RELATED STUFF
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/get_loc_psf_Ns.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------
c
c
c
      subroutine get_psfloc_Ns(Ns,
     .                         icen_p,jcen_p,
     .                         FFF_N,KKK_N,
     .                         psf_f, psf_n,
     .                         FILEPSF_N)
      implicit none
 
      integer Ns
      integer icen_p(Ns), jcen_p(Ns)
      integer FFF_N(Ns)
      integer KKK_N(Ns)
      real    psf_f(101,101,09,10,_FDIM_)
      real    psf_n(101,101,Ns)
      character*80 FILEPSF_N(Ns)
 
      integer N
      integer iraw, jraw
 
      do N = 1, Ns
         iraw = icen_p(n)
         jraw = jcen_p(n)
         call mk_loc_psf(psf_n(1,1,n),iraw,jraw,
     .                   psf_f(1,1,1,1,FFF_n(N)),
     .                   KKK_N(n),FILEPSF_N(N))
         enddo
 
      if (.false.) then
!omp critical(get_loc_psf)
         open(32,file='LOG.GET_PSFLOC.out',status='unknown')
         do N = 1, Ns
            write(32,
     .          '(''g_ploc_N: '',i3.3,1x,i2,1x,i2,3x,2i6.4,3x,2f9.5)')
     .                 N,FFF_n(N),KKK_n(N),
     .                 icen_p(n),jcen_p(n),
     .                 psf_n(51,51,n),psf_f(51,51,1,1,FFF_n(N))
            enddo
         close(32)
!omp end critical(get_loc_psf)
         endif
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/grabfits_stdpsf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c-----------------------------------------------------------------
c
c this routine will grab one of the PSFs from a
c "KS2 standard PSF" datacube ; it is designed to be fast;
c it won't read the header or anything but will just assume
c that the fits file has one page for the header then
c the data starts on page 2 in real*4 variables
c
      subroutine grabfits_stdpsf(FILE,pix,NX,NY,NXPSFs,NYPSFs)
      implicit none
 
      character*80 FILE
      real*4  pix(*)
      integer NX, NY
      integer NXPSFs
      integer NYPSFs
 
      integer nbyte0
      integer nbyteE
      integer i,ios
 
      integer c1, c2, c3
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer ii
      integer ifirst, i1, i2
      integer np1, np2, npt
 
      integer n, k
 
      byte b(4)
      real*4 r
      equivalence(r,b)
 
      integer q, npu, nbu
      integer NN
      integer npu1
      integer npu2
 
      character*80 FILEU
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
!$omp critical(grabfits_stdpsf)
      open(24,file=FILEU,
     .     status='old',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
      NN = NX + (NY-1)*NXPSFs
 
      npu1 =       1 + (NN-1)*101*101
      npu2 = 101*101 + (NN-1)*101*101
 
      i1 = 2 + 4*npu1/2880
      i2 = 2 + 4*npu2/2880
 
      do i = i1, i2, 1
         nbyte0 = (i-2)*2880+   1
         nbyteE = (i-2)*2880+2880
         np1 = (nbyte0-1)/4 + 1
         np2 = (nbyteE-1)/4 + 1
         read(24,rec=i,iostat=ios) buffc
         do q = 001, 720
            npu = np1+q-1
            nbu = (q-1)*4
            if (.not.(_LINUX_)) then
               b(1) = buffb(nbu+1)
               b(2) = buffb(nbu+2)
               b(3) = buffb(nbu+3)
               b(4) = buffb(nbu+4)
               endif
            if ((_LINUX_)) then
               b(4) = buffb(nbu+1)
               b(3) = buffb(nbu+2)
               b(2) = buffb(nbu+3)
               b(1) = buffb(nbu+4)
               endif
            if (npu.ge.npu1.and.npu.le.npu2) pix(npu-npu1+1) = r
            enddo
         enddo
 
      goto 901
  900 continue
      print*,' '
      print*,'ERROR ACCESSING FITS FILE IN grabfits_pixpsf(): '
      write(*,'('' FILE : '',a80)') FILE
      write(*,'('' FILEu: '',a80)') FILEU
      print*,' '
      stop
  901 close(24)
!$omp end critical(grabfits_stdpsf)
      return
 
      end
 
 
 
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/infofits_stdpsf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
 
 
c-----------------------------------------------------------------
c
c
c
 
      subroutine infofits_stdpsf(FILE,NXPSFs,NYPSFs,ilist,jlist)
      implicit none
 
      character*80 FILE
      integer NXPSFs
      integer NYPSFs
      integer ilist(10)
      integer jlist(10)
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer i, k
      character*80 FILEU
 
      integer NPSFs
 
      integer q, npu, nbu
      character*08 FIELD
      character*20 STREAM
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
!$omp critical(infofits_stdpsf)
      open(25,file=FILEU,
     .     status='old',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
      NXPSFs = 0
      NYPSFs = 0
      do i = 01, 10
         ilist(i) = -999
         jlist(i) = -999
         enddo
 
      read(25,rec=1) buffc
 
      do k = 01, 35
         FIELD  = buffc(01+(k-1)*80:08+(k-1)*80)
         STREAM = buffc(11+(k-1)*80:30+(k-1)*80)
         if (FIELD.eq.'NXPSFs  ') read(STREAM,*) NXPSFs
         if (FIELD.eq.'NYPSFs  ') read(STREAM,*) NYPSFs
         if (FIELD.eq.'IPSFX01 ') read(STREAM,*) ilist(01)
         if (FIELD.eq.'IPSFX02 ') read(STREAM,*) ilist(02)
         if (FIELD.eq.'IPSFX03 ') read(STREAM,*) ilist(03)
         if (FIELD.eq.'IPSFX04 ') read(STREAM,*) ilist(04)
         if (FIELD.eq.'IPSFX05 ') read(STREAM,*) ilist(05)
         if (FIELD.eq.'IPSFX06 ') read(STREAM,*) ilist(06)
         if (FIELD.eq.'IPSFX07 ') read(STREAM,*) ilist(07)
         if (FIELD.eq.'IPSFX08 ') read(STREAM,*) ilist(08)
         if (FIELD.eq.'IPSFX09 ') read(STREAM,*) ilist(09)
         if (FIELD.eq.'IPSFX10 ') read(STREAM,*) ilist(10)
         if (FIELD.eq.'JPSFY01 ') read(STREAM,*) jlist(01)
         if (FIELD.eq.'JPSFY02 ') read(STREAM,*) jlist(02)
         if (FIELD.eq.'JPSFY03 ') read(STREAM,*) jlist(03)
         if (FIELD.eq.'JPSFY04 ') read(STREAM,*) jlist(04)
         if (FIELD.eq.'JPSFY05 ') read(STREAM,*) jlist(05)
         if (FIELD.eq.'JPSFY06 ') read(STREAM,*) jlist(06)
         if (FIELD.eq.'JPSFY07 ') read(STREAM,*) jlist(07)
         if (FIELD.eq.'JPSFY08 ') read(STREAM,*) jlist(08)
         if (FIELD.eq.'JPSFY09 ') read(STREAM,*) jlist(09)
         if (FIELD.eq.'JPSFY10 ') read(STREAM,*) jlist(10)
         enddo
 
      do i = 01, 10
         if (ilist(i).lt.0)
     .       stop 'infofits_stdpsf: HEADER NEEDs TO SPECIFY ALL IPSFs..'
         if (jlist(i).lt.0)
     .       stop 'infofits_stdpsf: HEADER NEEDs TO SPECIFY ALL JPSFs..'
         if (NXPSFs.eq.0) stop 'infofits_stdpsf: HEADER NEEDs TO NXPSFs'
         if (NYPSFs.eq.0) stop 'infofits_stdpsf: HEADER NEEDs TO NXPSFs'
         enddo
 
      goto 901
  900 continue
      print*,' '
      print*,'ERROR ACCESSING FITS FILE IN infofits_stdpsf(): '
      write(*,'('' FILE : '',a80)') FILE
      write(*,'('' FILEU: '',a80)') FILEU
      print*,' '
      stop
  901 close(25)
!$omp end critical(infofits_stdpsf)
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/locpsfij_stdpsf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine locpsfij_stdpsf(iloc,jloc,psfloc,
     .                           FILEU,NXPSFs,NYPSFs,ilist,jlist)
      implicit none
 
      integer iloc
      integer jloc
      real    psfloc(101,101)
 
      character*80 FILEU
      integer NXPSFs
      integer NYPSFs
      integer ilist(10)
      integer jlist(10)
 
c
c-----------------------------------------
c
 
      integer NX,   NY,  NN
      integer ipsf, jpsf
      integer npix
 
      integer i, j, n
      real    psfa(101,101)
      real    psfb(101,101)
      real    psfc(101,101)
      real    psfd(101,101)
      real    fx, fy
 
      integer NXDIM
      integer NYDIM
 
      if (NXPSFs.le.0) then ! need to load in the info
         call infofits_stdpsf(FILEU,NXPSFs,NYPSFs,ilist,jlist)
c        write(*,'(''# '')')
c        write(*,'(''#  NXPSFs: '',i4.2,1x,10i6)')
c    .                  NXPSFs,(ilist(NN),NN=1,NXPSFs)
c        write(*,'(''#  NYPSFs: '',i4.2,1x,10i6)')
c    .                  NYPSFs,(jlist(NN),NN=1,NYPSFs)
         endif
 
c
c let's assume all the info is gold
c
      nx = 1
    1 continue
      if (iloc.gt.ilist(nx+1).and.nx.le.NXPSFs-2) then
         nx = nx + 1
         goto 1
         endif
 
      ny = 1
    2 continue
      if (jloc.gt.jlist(ny+1).and.ny.le.NYPSFs-2) then
         ny = ny + 1
         goto 2
         endif
 
      call grabfits_stdpsf(FILEU,psfa,NX  ,NY  ,NXPSFs,NYPSFs)
      call grabfits_stdpsf(FILEU,psfb,NX  ,NY+1,NXPSFs,NYPSFs)
      call grabfits_stdpsf(FILEU,psfc,NX+1,NY  ,NXPSFs,NYPSFs)
      call grabfits_stdpsf(FILEU,psfd,NX+1,NY+1,NXPSFs,NYPSFs)
 
      fx = 1.00*(iloc       -ilist(NX))/
     .          (ilist(NX+1)-ilist(NX))
      fy = 1.00*(jloc       -jlist(NY))/
     .          (jlist(NY+1)-jlist(NY))
 
 
      do ipsf = 001, 101
      do jpsf = 001, 101
         psfloc(ipsf,jpsf) = (1-fx)*(1-fy)*psfa(ipsf,jpsf)
     .                     + (1-fx)*( fy )*psfb(ipsf,jpsf)
     .                     + ( fx )*(1-fy)*psfc(ipsf,jpsf)
     .                     + ( fx )*( fy )*psfd(ipsf,jpsf)
         enddo
         enddo
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/mk_loc_psf.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------------------------------
c
c
      subroutine mk_loc_psf(psf_loc,ix,iy,psf_slot,KKK,PSFFILE)
      implicit none
 
      integer ix, iy
      real    psf_loc(101,101)
      real    psf_slot(101,101,9,10)
      integer KKK
      integer ipsf, jpsf
      character*80 PSFFILE
 
      integer NXPSFs, NYPSFs
      integer ilist(10)
      integer jlist(10)
      integer nx,ny
 
 
      if (KKK.eq.5) then ! ACS/WFC
         if (PSFFILE(1:4).eq.'NULL') then
              call mk_loc_psfacs(ix,iy,psf_loc,psf_slot)
              return
            else
              NXPSFs = 0
              call locpsfij_stdpsf(ix,iy,psf_loc,
     .                             PSFFILE,
     .                             NXPSFs,NYPSFs,ilist,jlist)
            return
            endif
         endif
 
      if (KKK.eq.7) then ! ACS/HRC (only one PSF...)
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf_loc(ipsf,jpsf) = psf_slot(ipsf,jpsf,1,1)
            enddo
            enddo
         return
         endif
 
      if (KKK.eq.8) then ! WFC3/UV
         if (PSFFILE(1:4).eq.'NULL') then
              call mk_loc_psfwfc3uv(ix,iy,psf_loc,psf_slot)
              return
            else
              NXPSFs = 0
              call locpsfij_stdpsf(ix,iy,psf_loc,
     .                             PSFFILE,
     .                             NXPSFs,NYPSFs,ilist,jlist)
            return
            endif
         endif
 
 
 
      if (KKK.eq.9) then ! WFC3/IR (only one PSF...)
         if (PSFFILE(1:4).eq.'NULL') then
            do ipsf = 001, 101
            do jpsf = 001, 101
               psf_loc(ipsf,jpsf) = psf_slot(ipsf,jpsf,1,1)
               enddo
               enddo
            return
           else
              NXPSFs = 0
              call locpsfij_stdpsf(ix,iy,psf_loc,
     .                             PSFFILE,
     .                             NXPSFs,NYPSFs,ilist,jlist)
           return
           endif
         endif
 
      print*,'mk_loc_psf:  could not fill local psf...'
      print*,'  ---> KKK:  ',KKK
 
      stop
      end
 
 
 
 
c----------------------------------------------------
c
c
      subroutine mk_loc_psfwfc3uv(ix,iy,psfloc,psf09x10)
      implicit none
 
      integer ix, iy
      real psfloc(101,101)
      real psf09x10(101,101,09,10)
 
      real XMIN, XMAX
      real YMIN, YMAX
 
      real    fx, fy
      integer hx, hy
      integer ipsf, jpsf
 
      hx = 1
      if (ix.gt.4096/6*1) hx = 2
      if (ix.gt.4096/6*2) hx = 3
      if (ix.gt.4096/6*3) hx = 4
      if (ix.gt.4096/6*4) hx = 5
      if (ix.gt.4096/6*5) hx = 6
 
      hy = 1
      if (iy.gt.4096/6*1) hy = 2
      if (iy.gt.4096/6*2) hy = 3
      if (iy.gt.4096/6*3) hy = 4
      if (iy.gt.4096/6*4) hy = 6
      if (iy.gt.4096/6*5) hy = 7
 
 
      XMIN = (hx-1)*4096/6
      XMAX = (hx  )*4096/6
      YMIN = (hy-1)*4096/6
      YMAX = (hy  )*4096/6
      if (hy.ge.4) then
         YMIN = (hy-2)*4096/6
         YMAX = (hy-1)*4096/6
         endif
 
      fx = (ix-XMIN)/(XMAX-XMIN)
      fy = (iy-YMIN)/(YMAX-YMIN)
 
      if (fx.lt.0.0) fx = 0.0
      if (fy.lt.0.0) fy = 0.0
      if (fx.gt.1.0) fx = 1.0
      if (fy.gt.1.0) fy = 1.0
 
      do ipsf = 001, 101
      do jpsf = 001, 101
         psfloc(ipsf,jpsf)
     .       = (1-fx)*(1-fy)*psf09x10(ipsf,jpsf,hx  ,hy  )
     .       + (1-fx)*( fy )*psf09x10(ipsf,jpsf,hx  ,hy+1)
     .       + ( fx )*(1-fy)*psf09x10(ipsf,jpsf,hx+1,hy  )
     .       + ( fx )*( fy )*psf09x10(ipsf,jpsf,hx+1,hy+1)
         enddo
         enddo
 
      return
      end
 
 
 
 
 
c---------------------------------------------
c
c
      subroutine mk_loc_psfacs(ix,iy,psfloc,psf09x10)
      implicit none
 
      integer ix, iy
      real psfloc(101,101)
      real psf09x10(101,101,09,10)
 
      integer ixu,iyu
      real    fx, fy
      integer hx, hy
      integer ipsf,jpsf
 
c-----------------------------------------------
c
c this info tells the routine where the fiducial
c PSFs are located
c
      integer ixcl(09)
      integer iycl(10)
      common /ixycl/ixcl,iycl
      data ixcl /0000,0512,1024,1536,2168,2800,3192,3584,4096/
      data iycl /0000,0512,1024,1536,2048,2048,2560,3072,3584,4096/
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
      ixu = ix
      iyu = iy
      if (ixu.lt.0001) ixu = 0001
      if (iyu.lt.0001) iyu = 0001
      if (ixu.gt.4096) ixu = 4096
      if (iyu.gt.4096) iyu = 4096
 
      if (ixu.lt.0001.or.ixu.gt.4096.or.
     .    iyu.lt.0001.or.iyu.gt.4096) then
          do ipsf = 001, 101
          do jpsf = 001, 101
             psfloc(ipsf,jpsf) = 0.
             enddo
             enddo
          return
          endif
 
      hx = 1
      if (ixu.gt.ixcl(2)) hx = 2
      if (ixu.gt.ixcl(3)) hx = 3
      if (ixu.gt.ixcl(4)) hx = 4
      if (ixu.gt.ixcl(5)) hx = 5
      if (ixu.gt.ixcl(6)) hx = 6
      if (ixu.gt.ixcl(7)) hx = 7
      if (ixu.gt.ixcl(8)) hx = 8
 
      hy = 1
      if (iyu.gt.iycl(2)) hy = 2
      if (iyu.gt.iycl(3)) hy = 3
      if (iyu.gt.iycl(4)) hy = 4
      if (iyu.gt.iycl(5)) hy = 5
      if (iyu.gt.iycl(6)) hy = 6
      if (iyu.gt.iycl(7)) hy = 7
      if (iyu.gt.iycl(8)) hy = 8
      if (iyu.gt.iycl(9)) hy = 9
 
      fx = (ixu-ixcl(hx))/1.0/(ixcl(hx+1)-ixcl(hx))
      fy = (iyu-iycl(hy))/1.0/(iycl(hy+1)-iycl(hy))
 
 
c----------------------------------------------------
c
c linearly interpolate the value of the PSF at this
c from the nearest 4
c
      do ipsf = 001, 101
      do jpsf = 001, 101
         psfloc(ipsf,jpsf)
     .   = (1-fx)*(1-fy)*psf09x10(ipsf,jpsf,hx  ,hy  )
     .   + (1-fx)*( fy )*psf09x10(ipsf,jpsf,hx  ,hy+1)
     .   + ( fx )*(1-fy)*psf09x10(ipsf,jpsf,hx+1,hy  )
     .   + ( fx )*( fy )*psf09x10(ipsf,jpsf,hx+1,hy+1)
         enddo
         enddo
 
      if (VERBOSE)
     .write(* ,199) ix,iy,ixu,iyu,psfloc(51,51),
     .              hx,hy,fx,fy,
     .              psf09x10(51,51,hx  ,hy  ),
     .              psf09x10(51,51,hx  ,hy+1),
     .              psf09x10(51,51,hx+1,hy  ),
     .              psf09x10(51,51,hx+1,hy+1)
  199 format('PSFLOC_ACS: ',i4.4,1x,i4.4,
     .       5x,i4.4,1x,i4.4,1x,f8.6,
     .       5x,i2,1x,i2,1x,f8.4,1x,f8.4,1x,
     .       5x,4(f9.6))
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/read_psf3ir.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------
c
c reads in a UVIS PSF ; it is in a slightly
c different format from the ACS PSF in that it
c has 7x4 in each chip rather than 9x5...
c
      subroutine read_psf3ir(FILEPSF,psf)
      implicit none
 
      character*80 FILEPSF
      real psf(101,101,9,10)
 
      real psfarr(101,101)
 
      integer ipsf, jpsf
      integer i, j, jmax
      integer NIM
 
 
      do i = 1, 09
      do j = 1, 10
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf(ipsf,jpsf,i,j) = 0.
            enddo
            enddo
         enddo
         enddo
 
      call readfits_r4(FILEPSF,psfarr,101,101)
 
      do i = 1, 1
      do j = 1, 1
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf(ipsf,jpsf,i,j) = psfarr(ipsf+(i-1)*100,
     .                                  jpsf+(j-1)*100)
            enddo
            enddo
         enddo
         enddo
 
      print*,'             '
      print*,'---> PSF3IR: '
      do j = 10, 1, -1
         write(*,'(10x,i2,1x,9f8.4)') j,(psf(51,51,i,j),i=1,9)
         enddo
      print*,'            '
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/read_psf3uv.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------
c
c reads in a UVIS PSF ; it is in a slightly
c different format from the ACS PSF in that it
c has 7x4 in each chip rather than 9x5...
c
      subroutine read_psf3uv(FILEPSF,psf)
      implicit none
 
      character*80 FILEPSF
      real psf(101,101,9,10)
 
      real psfarr(1401,801)
 
      integer ipsf, jpsf
      integer i, j, jmax
      integer NIM
 
 
      do i = 1, 09
      do j = 1, 10
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf(ipsf,jpsf,i,j) = 0.
            enddo
            enddo
         enddo
         enddo
 
 
      write(*,*)
      write(*,'(10x,''READ_PSF3UV: '',80a)') FILEPSF
      call readfits_r4(FILEPSF,psfarr,1401,801)
 
      do i = 1, 7
      do j = 1, 8
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf(ipsf,jpsf,i,j) = psfarr(ipsf+(i-1)*100,
     .                                  jpsf+(j-1)*100)
            enddo
            enddo
         enddo
         enddo
 
      do j = 10, 1, -1
         write(*,'(10x,i2,1x,9f8.4)') j,(psf(51,51,i,j),i=1,9)
         enddo
      write(*,*)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/read_psfacs.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------
c
c reads in a UVIS PSF ; it is in a slightly
c different format from the ACS PSF in that it
c has 7x4 in each chip rather than 9x5...
c
      subroutine read_psfacs(FILEPSF,psf)
      implicit none
 
      character*80 FILEPSF
      real psf(101,101,9,10)
 
      real psfarr(901,1001)
 
      integer ipsf, jpsf
      integer i, j, jmax
      integer NIM
 
      call readfits_r4(FILEPSF,psfarr,0901,1001)
 
      do i = 01, 09
      do j = 01, 10
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf(ipsf,jpsf,i,j) = psfarr(ipsf+(i-1)*100,
     .                                  jpsf+(j-1)*100)
            enddo
            enddo
         enddo
         enddo
 
c     print*,'            '
c     write(*,'(''---> READ_PSFACS: '',80a)') FILEPSF
c     print*,'            '
c     do j = 10, 1, -1
c        write(*,'(10x,i2,1x,9f8.4)') j,(psf(51,51,i,j),i=1,9)
c        enddo
c     print*,'            '
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/read_psfhrc.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------
c
c reads in a UVIS PSF ; it is in a slightly
c different format from the ACS PSF in that it
c has 7x4 in each chip rather than 9x5...
c
      subroutine read_psfhrc(FILEPSF,psf)
      implicit none
 
      character*80 FILEPSF
      real psf(101,101,9,10)
 
      integer*4 psfarr(1201,1201)
 
      integer ipsf, jpsf
      integer i, j, jmax
      integer NIM
 
      do i = 01, 09
      do j = 01, 10
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf(ipsf,jpsf,i,j) = 0.
            enddo
            enddo
         enddo
         enddo
 
      call readfits_i4(FILEPSF,psfarr,1201,1201)
 
      do i = 01, 09
      do j = 01, 10
         do ipsf = 001, 101
         do jpsf = 001, 101
            psf(ipsf,jpsf,i,j) = psfarr(601+(ipsf-51)*10,
     .                                  601+(jpsf-51)*10)/1.0e6
            enddo
            enddo
         enddo
         enddo
 
      print*,'            '
      print*,'---> PSFHRC: '
      do j = 10, 1, -1
         write(*,'(10x,i2,1x,9f8.4)') j,(psf(51,51,i,j),i=1,9)
         enddo
      print*,'            '
      do j = 56, 46, -1
         write(*,'(10x,i2,1x,11f8.4)') j,(psf(i,j,1,1),i=46,56,1)
         enddo
      print*,'            '
      do j = 71, 31, -4
         write(*,'(10x,i2,1x,21f8.4)') j,(psf(i,j,1,1),i=031,071,4)
         enddo
      print*,'            '
      print*,'            '
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/PSF/rpsf_phot.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c--------------------------------------------
c
c this will evaluate a PSF at a given (dx,dy)
c offset; for the regions within 4 pixels of
c the center, it uses bi-cubic interpolation
c
      real function rpsf_phot(x,y,psf)
      implicit none
      real x, y
      real psf(101,101)
 
 
      real    rx, ry
      integer ix, iy   !     3   4
      real    fx, fy   !    *1*  2
 
      real    dd
 
      real A1, B1, C1, D1, E1, F1, V1
      real A2, B2, C2, D2, E2, F2, V2
      real A3, B3, C3, D3, E3, F3, V3
      real A4, B4, C4, D4, E4, F4, V4
 
 
      rx = 51 + x*4
      ry = 51 + y*4
      ix = int(rx)
      iy = int(ry)
      fx = rx-ix
      fy = ry-iy
 
      dd = sqrt(x**2+y**2)
 
 
      rpsf_phot = 0.
      if (dd.gt.12.0) return
 
      if (dd.gt.4.0) then
         rpsf_phot = (1-fx)*(1-fy)*psf(ix  ,iy  )
     .             + ( fx )*(1-fy)*psf(ix+1,iy  )
     .             + (1-fx)*( fy )*psf(ix  ,iy+1)
     .             + ( fx )*( fy )*psf(ix+1,iy+1)
         return
         endif
 
 
      A1 =  psf(ix  ,iy  )
      B1 = (psf(ix+1,iy  )-psf(ix-1,iy  ))/2
      C1 = (psf(ix  ,iy+1)-psf(ix  ,iy-1))/2
      D1 = (psf(ix+1,iy  )+psf(ix-1,iy  )-2*A1)/2
      F1 = (psf(ix  ,iy+1)+psf(ix  ,iy-1)-2*A1)/2
      E1 = (psf(ix+1,iy+1)-A1)
 
      A2 =  psf(ix+1,iy  )
      B2 = (psf(ix+2,iy  )-psf(ix  ,iy  ))/2
      C2 = (psf(ix+1,iy+1)-psf(ix+1,iy-1))/2
      D2 = (psf(ix+2,iy  )+psf(ix  ,iy  )-2*A2)/2
      F2 = (psf(ix+1,iy+1)+psf(ix+1,iy-1)-2*A2)/2
      E2 =-(psf(ix  ,iy+1)-A2)
 
      A3 =  psf(ix  ,iy+1)
      B3 = (psf(ix+1,iy+1)-psf(ix-1,iy+1))/2
      C3 = (psf(ix  ,iy+2)-psf(ix  ,iy  ))/2
      D3 = (psf(ix+1,iy+1)+psf(ix-1,iy+1)-2*A3)/2
      F3 = (psf(ix  ,iy+2)+psf(ix  ,iy  )-2*A3)/2
      E3 =-(psf(ix+1,iy  )-A3)
 
      A4 =  psf(ix+1,iy+1)
      B4 = (psf(ix+2,iy+1)-psf(ix  ,iy+1))/2
      C4 = (psf(ix+1,iy+2)-psf(ix+1,iy  ))/2
      D4 = (psf(ix+2,iy+1)+psf(ix  ,iy+1)-2*A4)/2
      F4 = (psf(ix+1,iy+2)+psf(ix+1,iy  )-2*A4)/2
      E4 = (psf(ix  ,iy  )-A4)
 
 
      V1 = A1
     .   + B1*( fx )
     .   + C1*( fy )
     .   + D1*( fx )**2
     .   + E1*( fx )*( fy )
     .   + F1*( fy )**2
 
      V2 = A2
     .   + B2*(fx-1)
     .   + C2*( fy )
     .   + D2*(fx-1)**2
     .   + E2*(fx-1)*( fy )
     .   + F2*( fy )**2
 
      V3 = A3
     .   + B3*( fx )
     .   + C3*(fy-1)
     .   + D3*( fx )**2
     .   + E3*( fx )*(fy-1)
     .   + F3*(fy-1)**2
 
      V4 = A4
     .   + B4*(fx-1)
     .   + C4*(fy-1)
     .   + D4*(fx-1)**2
     .   + E4*(fx-1)*(fy-1)
     .   + F4*(fy-1)**2
 
      rpsf_phot = (1-fx)*(1-fy)*V1
     .          + ( fx )*(1-fy)*V2
     .          + (1-fx)*( fy )*V3
     .          + ( fx )*( fy )*V4
 
 
      return
      end
 
 
c--------------------------------------------------
c SETUP - SETUP-RELATED STUFF
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/SETUP/glob_fit6nrDP.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c--------------------------------------------------------------
c
c this routine does a least squares solution (with no
c data rejection or weighting) for the 6-param linear
c fit for:
c
c
c    x2 = A*(x1-x1o) + B*(y1-y1o) + x2o
c    y2 = C*(x1-x1o) + D*(y1-y1o) + y2o
c
c it may look like there are 8 params, but two of the
c offsets are arbitrary and are just set to the centroid
c of the distribution.
c
c
 
      subroutine glob_fit6nrDP(x1,y1,x2,y2,NUSE,
     .                         A,B,C,D,x1o,y1o,x2o,y2o)
      implicit none
 
      integer   NUSE
      real*8 x1(NUSE), y1(NUSE)
      real*8 x2(NUSE), y2(NUSE)
      real*8 A, B, C, D
      real*8 x1o, y1o, x2o, y2o
 
      real*8 sxx, sx, swx, szx
      real*8 syy, sy, swy, szy
      real*8 sw,  sz, sxy
      real*8 dlta
      real*8 dsxx, dsyy, dsxy
      real*8 dswx, dswy, dszx, dszy
 
      integer n
 
      if (NUSE.lt.3) goto 999
 
      x1o = 0
      y1o = 0
      x2o = 0
      y2o = 0
      do n = 1, NUSE
         x1o = x1o + x1(n)
         y1o = y1o + y1(n)
         x2o = x2o + x2(n)
         y2o = y2o + y2(n)
         enddo
 
      x1o = x1o/NUSE
      y1o = y1o/NUSE
      x2o = x2o/NUSE
      y2o = y2o/NUSE
 
      sxx = 0.0
      sx  = 0.0
      syy = 0.0
      sy  = 0.0
      swx = 0.0
      swy = 0.0
      szx = 0.0
      szy = 0.0
      sw  = 0.0
      sz  = 0.0
      sxy = 0.0
      do n = 1, NUSE
         sxy = sxy + (x1(n)-x1o)*(y1(n)-y1o)
         sxx = sxx + (x1(n)-x1o)*(x1(n)-x1o)
         sx  = sx  + (x1(n)-x1o)
         syy = syy + (y1(n)-y1o)*(y1(n)-y1o)
         sy  = sy  + (y1(n)-y1o)
         swx = swx + (x2(n)-x2o)*(x1(n)-x1o)
         swy = swy + (x2(n)-x2o)*(y1(n)-y1o)
         sw  = sw  + (x2(n)-x2o)
         szx = szx + (y2(n)-y2o)*(x1(n)-x1o)
         szy = szy + (y2(n)-y2o)*(y1(n)-y1o)
         sz  = sz  + (y2(n)-y2o)
         enddo
 
 
      dsxx = sx*sx - NUSE*sxx
      dsyy = sy*sy - NUSE*syy
      dsxy = sx*sy - NUSE*sxy
 
      dlta = dsxx*dsyy - dsxy*dsxy
 
      if (dlta.eq.0) goto 999
 
      dswx = sw*sx - NUSE*swx
      dswy = sw*sy - NUSE*swy
      dszx = sz*sx - NUSE*szx
      dszy = sz*sy - NUSE*szy
 
      A =   (dswx*dsyy-dswy*dsxy)/dlta
      B =   (dswy*dsxx-dswx*dsxy)/dlta
      C =   (dszx*dsyy-dszy*dsxy)/dlta
      D =   (dszy*dsxx-dszx*dsxy)/dlta
 
      return
 
 999  continue
      A  = 1
      B  = 0
      C  = 0
      D  = 1
      x1o = 0
      y1o = 0
      x2o = 0
      y2o = 0
      return
      end
 
 
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/SETUP/ks2_setup.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------
c
c will read in info for *all* images
c
      subroutine ks2_setup(INFILENAME,LABEL7,DIRECT,NDIRECT,
     .                     UMIN_KS2,UMAX_KS2,VMIN_KS2,VMAX_KS2,
     .                     Gs,FILENAME_G,SUBDIR_G,NSUBDIR_G,EXP_G,
     .                        FILEPSF_G, FILEGCS_G,
     .                        ucen_cg,vcen_cg,
     .                        icen_cg,jcen_cg,
     .                        xcen_cg,ycen_cg,
     .                        AG_CG,BG_CG,CG_CG,DG_CG,
     .                        GA_CG,GB_CG,GC_CG,GD_CG,
     .                        ZP_CG,SC_CG,
     .                        FFF_G,KKK_G,
     .                        FLT_G,RAP_G,POS_G,FND_G,
     .                        SKY_G,ZPU_G,MSK_G,OTH_G,
     .                        psf_f,psf_mask_f,
     .                     Bs,uref_b,vref_b,zref_bf,
     .                     Fs,EXP_F,SCL_F,CMODE,ONEOFF,ONEOFFX,ONEOFFY,
     .                     NMASTi, umast0, vmast0, zmast0, szmast0,
     .                             xmast0, ymast0, wmast0,
     .                             smast0,ssmast0,
     .                     NARTs, uart0, vart0, zart0)
      implicit none
 
      character*80 INFILENAME
      character*07 LABEL7
      character*80 DIRECT
      integer      NDIRECT
      integer      UMIN_KS2, UMAX_KS2, VMIN_KS2, VMAX_KS2
 
      integer Gs
      character*80 FILENAME_G(Gs)
      character*80 SUBDIR_G(Gs)
      integer      NSUBDIR_G(Gs)
      real         EXP_G(Gs)
      character*80 FILEPSF_G(Gs)
      character*80 FILEGCS_G(Gs)
      real*8  ucen_cg(_CDIM_,Gs), vcen_cg(_CDIM_,Gs)
      integer icen_cg(_CDIM_,Gs), jcen_cg(_CDIM_,Gs)
      real*8  xcen_cg(_CDIM_,Gs), ycen_cg(_CDIM_,Gs)
      real*8  AG_CG(_CDIM_,Gs), BG_CG(_CDIM_,Gs)
      real*8  CG_CG(_CDIM_,Gs), DG_CG(_CDIM_,Gs)
      real*8  GA_CG(_CDIM_,Gs), GB_CG(_CDIM_,Gs)
      real*8  GC_CG(_CDIM_,Gs), GD_CG(_CDIM_,Gs)
      real    ZP_CG(_CDIM_,Gs) ! the zp that applies to each img
      real    SC_CG(_CDIM_,Gs) ! the scaling that applies to each img
      integer FFF_G(Gs)        ! filter number ! order
      integer RAP_G(Gs)        ! aperture to use
      integer KKK_G(Gs)        ! the kind of chip
      integer FLT_G(Gs)        ! the dist-corr filtnum
      character*9 POS_G(Gs)    ! use for positions
      character*9 FND_G(Gs)    ! use for any finding?
      real    SKY_G(Gs)
      real    ZPU_G(Gs)
      real    MSK_G(Gs)
      real    OTH_G(Gs)
      real    psf_f(101,101,09,10,_FDIM_)
      real    psf_mask_f(901,901,_FDIM_)
 
      character*80 FILEPSF
      character*80 FILEBRI
      character*80 FILEPRE
      character*80 FILEART
 
      integer Bs, Bx
      real*8  uref_b(_BDIM_), vref_b(_BDIM_)
      real    zref_bf(_BDIM_,_FDIM_)
 
      integer   Fs
      real      EXP_F(_FDIM_)
      real      SCL_F(_FDIM_)
      character CMODE
      logical   ONEOFF
      integer   ONEOFFX, ONEOFFY
 
      integer NMASTi
      real*8  umast0(_NSTMAX_)
      real*8  vmast0(_NSTMAX_)
      real    zmast0(_NSTMAX_,_FDIM_)
      real   szmast0(_NSTMAX_,_FDIM_)
      real    xmast0(_NSTMAX_)        ! x-position in tile
      real    ymast0(_NSTMAX_)        ! y-position in tile
      integer wmast0(_NSTMAX_)        ! iteration number where found
      real    smast0(_NSTMAX_,_FDIM_) ! sky background
      real   ssmast0(_NSTMAX_,_FDIM_) ! sigma sky background
 
      integer   NARTs                   ! total number of AS tests
      real*8    uart0(_ARTMAX_)         ! master-frame posn for art starsss
      real*8    vart0(_ARTMAX_)
      real*8    zart0(_ARTMAX_,_FDIM_)  ! master-frame flux for art stars
c
c----------------------------------------------------------------------
c
      character*200 STRING
c     character*80 FILEPERT_G(_GDIM_)
      character*80 FILEMATT_G(_GDIM_)
      character*80 FILEMATT
 
      integer KFILT
      integer F, B
 
      integer KKK,KKKu
      integer SLT,SLTu
      integer RAP,RAPu
      character*9 UPOS,UPOSu
      character*9 UFND,UFNDu
      integer G
      character*80 SLIST(99)
 
      character*80 SUBDIR
      integer     NSUBDIR
      integer     STRLEN
      character*80 FILTNAME
      character*80 CHIPNAME
      integer FILTNUM
      integer CHIPNUM
      character*5 FILT5
      character*20 ESTRING
      character*80 FILENAMEU
      character*06 MODEIN
      character*80 FILEPSFu
      character*80 FILEGCSu
      character*80 ABBREV
 
      integer F_SLOT
 
      integer N, Ns
      integer NMAST
      integer i, j
      integer WHICH_FILT
 
      integer Cs_KKK, C
      logical DIAG
      data DIAG/.false./
 
      integer NLINEs
      real x, y
 
      logical DOSKIP
 
      logical LOGNIMFO
      common/LOGNIMFO_/LOGNIMFO
 
      logical LOGFINFO
      common/LOGFINFO_/LOGFINFO
 
      real BLIM_F(_FDIM_)
      real PLIM_F(_FDIM_)
 
      integer NIT
 
 
 
c-------------------------------------------
c
c finding parameters...
c
      integer     HMIN_NIT(10)
      real        SSIG_NIT(10)
 
      integer     QMIN_NIT(10)
      real        QSEL_NIT(10)
      real        QSEP_NIT(10)
 
      integer     DMIN_NIT(10)
      real        DSEP_NIT(10)
 
      integer     PMIN_NIT(10)
      real        PSEP_NIT(10)
 
      real        OPRX_NIT(10)
      real        OPRV_NIT(10)
 
      real        RSIZ_NIT(11)
      character*7 RCOL_NIT(11)
      integer     RWID_NIT(11)
 
      common /HMIN_NIT/HMIN_NIT
      common /SSIG_NIT/SSIG_NIT
 
      common /QMIN_NIT/QMIN_NIT
      common /QSEL_NIT/QSEL_NIT
      common /QSEP_NIT/QSEP_NIT
 
      common /DMIN_NIT/DMIN_NIT
      common /DSEP_NIT/DSEP_NIT
 
      common /PMIN_NIT/PMIN_NIT
      common /PSEP_NIT/PSEP_NIT
 
      common /OPRX_NIT/OPRX_NIT
      common /OPRV_NIT/OPRV_NIT
 
      common /RSIZ_NIT/RSIZ_NIT
      common /RCOL_NIT/RCOL_NIT
      common /RWID_NIT/RWID_NIT
 
      integer NITMINU
      integer NITMAXU
      common /NITMINMAXU_/NITMINU,NITMAXU
 
      integer ITMINU, ITMAXU
      integer JTMINU, JTMAXU
      common /IJTMINMAXU_/ITMINU,ITMAXU,JTMINU,JTMAXU
 
      real    SKYU
      logical ok
      integer Q
 
c
c------------------------------------------
c
      real    MASKFAC
      common /MASKFAC_/MASKFAC
 
      real    OTHRFAC
      common /OTHRFAC_/OTHRFAC
 
      logical SHOW_TILE
      common /SHOW_TILE_/SHOW_TILE
 
      logical SHOW_TILES
      common /SHOW_TILES_/SHOW_TILES
 
      logical MOSAIC_X1
      common /MOSAIC_X1_/MOSAIC_X1
 
      logical MOSAIC_X2
      common /MOSAIC_X2_/MOSAIC_X2
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
 
c
c------------------------------------------
c
      NMASTi = 0
      NARTs  = 0
 
      do NMAST = 1, _NSTMAX_
         umast0(NMAST) = 0.
         vmast0(NMAST) = 0.
         xmast0(NMAST) = 0.
         ymast0(NMAST) = 0.
         wmast0(NMAST) = 0
         do F = 1, _FDIM_
             zmast0(NMAST,F) = 0.
            szmast0(NMAST,F) = 0.
             smast0(NMAST,F) = 0.
            ssmast0(NMAST,F) = 0.
            enddo
         enddo
 
      do F = 1, Fs
         EXP_F(F) = 0.
         SCL_F(F) = 1.0
         enddo
 
      do G = 1, Gs
         FFF_G(G) = 0
         RAP_G(G) = 0
         KKK_G(G) = 0
         FLT_G(G) = 0
         POS_G(G) = '000000000'
         FND_G(G) = '000000000'
         FILENAME_G(G) = 'NULL'
c        FILEPERT_G(G) = 'NULL'
         FILEMATT_G(G) = 'NULL'
         FILEPSF_G(G)  = 'NULL'
         FILEGCS_G(G)  = 'NULL'
         SUBDIR_G(G)   = 'NULL'
         NSUBDIR_G(G)  = 0
         EXP_G(G) = 0.
         SKY_G(G) = 0.0
         ZPU_G(G) = -99   ! flag saying to use the ZP from the MAT file
         MSK_G(G) = MASKFAC
         OTH_G(G) = OTHRFAC
         enddo
 
      F_SLOT = 0
 
      CMODE = ' '
 
      KFILT = 0
      SLT  = 0
      SLTu = 0
      G    = 0
 
      KKK   = 0   ! no default chip
      RAP   = 2   ! default: 5x5
      UPOS  = '111111111'   ! default: do use for finding
      UFND  = '111111111'   ! default: only use for qual peaks
 
      DIRECT = ''
      NDIRECT = 0
 
      SUBDIR = ''
      NSUBDIR = 0
 
      UMIN_KS2 =  0000000
      UMAX_KS2 = _PXDIMX1_
      VMIN_KS2 =  0000000
      VMAX_KS2 = _PXDIMY1_
 
 
      Gs = 0
      Fs = 0
      Bs = 0
      Bx = 0
 
      FILEPSFu = 'NULL'
      FILEGCSu = 'NULL'
 
      write(*,*)
      write(*,'(''***********************************************'')')
      write(*,'(''***** '')')
      write(*,'(''***** READ IN KS2 INPUT FILE...'')')
      write(*,'(''***** '')')
      write(*,'(''***********************************************'')')
      write(*,*)
 
      open(69,file='LOGK.INPUT_FILE',status='unknown')
      DOSKIP = .false.
      write(*,'(''ENTER KS2_SETUP... INFILENAME: '',a80)') INFILENAME
      open(90,file=INFILENAME,status='old')
      read(90,'(a6)') MODEIN
      NLINEs = 1
      write( *,'(''KS2_SETUP LINE'',i3.3,3x,200a)') NLINEs,MODEIN
      write(69,'(''KS2_SETUP LINE'',i3.3,3x,200a)') NLINEs,MODEIN
      CMODE = 'Q'
      if (MODEIN.eq.'MODE=R'.or.
     .    MODEIN.eq.'MODE=D'.or.
     .    MODEIN.eq.'MODE=A'.or.
     .    MODEIN.eq.'MODE=C') then
          CMODE = MODEIN(6:6)
          endif
      if (CMODE.eq.'Q') stop 'must spec MODE=R,D,A, or C... on LINE1'
    1 read(90,'(a200)',end=3) STRING
      G = 0
      NLINEs = NLINEs + 1
      write( *,'(''KS2_SETUP LINE'',i3.3,3x,a200)') NLINEs,STRING
      write(69,'(''KS2_SETUP LINE'',i3.3,3x,a200)') NLINEs,STRING
      if (STRING(1:1).eq.'#') goto 1
      do Q = 200, 2, -1
         if (STRING(Q:Q).eq.'#') STRING = STRING(1:Q-1)
         enddo
      if (DOSKIP.and.STRING(1:4).eq.'PIKS') then
         DOSKIP = .false.
         goto 1
         endif
      if (DOSKIP) goto 1
      if (STRING(1:4).eq.'SKIP') then
         DOSKIP = .true.
         goto 1
         endif
      if (STRING(1:6).eq.'ONEOFF') then
         ONEOFF = .true.
         read(STRING(8:80),*) x,y
         ONEOFFX = int(x+0.5)
         ONEOFFY = int(y+0.5)
         write(*,'(10x,''ONEOFF: '',l1,2i7)') ONEOFF,ONEOFFX,ONEOFFY
         goto 1
         endif
      if (STRING(1:3).eq.'END') goto 3
      call parse(STRING,SLIST,Ns)
 
      if (STRING(1:4).eq.'NIT0') then
         read(STRING(5:5),*) NIT
         if (NIT.eq.0) NIT = 11
         do Q = 2, Ns-1, 2
            ok = .false.
            if (NIT.le.10) then
               if (slist(Q)(1:4).eq.'HMIN') then
                  ok = .true.
                  read(SLIST(Q+1),*) HMIN_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'SSIG') then
                  ok = .true.
                  read(SLIST(Q+1),*) SSIG_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'QMIN') then
                  ok = .true.
                  read(SLIST(Q+1),*) QMIN_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'QSEL') then
                  ok = .true.
                  read(SLIST(Q+1),*) QSEL_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'QSEP') then
                  ok = .true.
                  read(SLIST(Q+1),*) QSEP_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'PMIN') then
                  ok = .true.
                  read(SLIST(Q+1),*) PMIN_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'PSEP') then
                  ok = .true.
                  read(SLIST(Q+1),*) PSEP_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'DMIN') then
                  ok = .true.
                  read(SLIST(Q+1),*) DMIN_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'DSEP') then
                  ok = .true.
                  read(SLIST(Q+1),*) DSEP_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'OPRX') then
                  ok = .true.
                  read(SLIST(Q+1),*) OPRX_NIT(NIT)
                  endif
               if (slist(Q)(1:4).eq.'OPRV') then
                  ok = .true.
                  read(SLIST(Q+1),*) OPRV_NIT(NIT)
                  endif
               endif
            if (slist(Q)(1:4).eq.'RSIZ') then
               ok = .true.
               read(SLIST(Q+1),*) RSIZ_NIT(NIT)
               endif
            if (slist(Q)(1:4).eq.'RWID') then
               ok = .true.
               read(SLIST(Q+1),*) RWID_NIT(NIT)
               endif
            if (slist(Q)(1:4).eq.'RCOL') then
               ok = .true.
               read(SLIST(Q+1),*) RCOL_NIT(NIT)
               if (RCOL_NIT(NIT).ne.'yellow '.and.
     .             RCOL_NIT(NIT).ne.'red    '.and.
     .             RCOL_NIT(NIT).ne.'green  '.and.
     .             RCOL_NIT(NIT).ne.'blue   '.and.
     .             RCOL_NIT(NIT).ne.'cyan   '.and.
     .             RCOL_NIT(NIT).ne.'magenta'.and.
     .             RCOL_NIT(NIT).ne.'white  '.and.
     .             RCOL_NIT(NIT).ne.'black  ') then
                   print*,'LEGIT COLORS FOR RCOL_NIT: '
                   print*,'   yellow, red, green, blue '
                   print*,'   cyan magenta white black '
                   stop
                   endif
               endif
            if (.not.ok) then
               print*,'  '
               print*,'NIT0 SYNTAX ERROR, YOU BOZO!'
               print*,'  '
               print*,'FIELD NOT RECOGNIZED AS NIT SPEC: '
               print*,'FIELD: ',slist(Q)(1:5)
               print*,' LIST: HMIN= SSIG= '
               print*,'       QMIN= QSEL= '
               print*,'       DMIN= DSEL= '
               print*,'       PMIN= '
               print*,'       OPRX= OPRV= '
               print*,'       RCOL= RWID= RSIZ= '
               print*,' '
               print*,'(NIT00 can only do RCOL,RWID,RSIZ...)'
               print*,' '
               stop
               endif
            enddo
         if (.false.) then
            print*,'           '
            print*,'FINDING PARAMS FOR NIT = ',NIT
            print*,'           '
            print*,'    HMIN = ',HMIN_NIT(NIT)
            print*,'    SSIG = ',HMIN_NIT(NIT)
            print*,'           '
            print*,'    QMIN = ',QMIN_NIT(NIT)
            print*,'    QSEL = ',QSEL_NIT(NIT)
            print*,'    QSEP = ',QSEP_NIT(NIT)
            print*,'           '
            print*,'    DMIN = ',DMIN_NIT(NIT)
            print*,'    DSEP = ',DSEP_NIT(NIT)
            print*,'           '
            print*,'    PMIN = ',PMIN_NIT(NIT)
            print*,'    PSEP = ',PSEP_NIT(NIT)
            print*,'           '
            print*,'    RSIZ = ',RSIZ_NIT(NIT)
            print*,'    RWID = ',RWID_NIT(NIT)
            print*,'    RCOL = ',RCOL_NIT(NIT)
            print*,'           '
            endif
         goto 1
         endif
 
      N = 1
      G = 0
      KKKu  = KKK
      RAPu  = RAP
      UPOSu = UPOS
      UFNDu = UFND
    2 continue
      if (N.gt.Ns) goto 1
      if (G.ne.0) then
         if (KKKu.eq.0) then
            print*,'Image has been specified w/o a chip.'
            stop
            endif
         FFF_G(G) = F_SLOT
         if (F_SLOT.gt.Fs) Fs = F_SLOT
         RAP_G(G) = RAPu
         KKK_G(G) = KKKu
         POS_G(G) = UPOSu
         FND_G(G) = UFNDu
         FLT_G(G) = WHICH_FILT(FILT5,KKK_G(G))
         SUBDIR_G(G)  =  SUBDIR
         NSUBDIR_G(G) = NSUBDIR
         MSK_G(G) = MASKFAC
         OTH_G(G) = OTHRFAC
         endif
 
      if (SLIST(N)(1:3).eq.'END') goto 3
      if (SLIST(N)(1:6).eq.'LABEL7') then
         read(SLIST(N+1)(1:7),*) LABEL7
         N = N + 2
         goto 2
         endif
      if (N.eq.1.and.
     .    SLIST(N)(1:1).ge.'0'.and.SLIST(N)(1:1).le.'9') then
         read(SLIST(N),*) G
         if (G.gt.Gs) then
            Gs = G
            if (Gs.gt._GDIM_) then
               print*,'                 '
               print*,'Gs.gt._GDIM_ --- '
               print*,'   Gs  : ',Gs
               print*,' _GDIM_: ',_GDIM_
               print*,'                 '
               stop
               endif
            endif
         if (FILEPSFu(1:4).ne.'NULL') FILEPSF_G(G) = FILEPSFu
         if (FILEGCSu(1:4).ne.'NULL') FILEGCS_G(G) = FILEGCSu
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:9).eq.'LOGNIMFO+') then
         LOGNIMFO = .true.
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:9).eq.'LOGNIMFO-') then
         LOGNIMFO = .false.
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:9).eq.'LOGFINFO+') then
         LOGFINFO = .true.
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:9).eq.'LOGFINFO-') then
         LOGFINFO = .false.
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:7).eq.'VERBOSE') then
         if (SLIST(N)(8:8).eq.'+') VERBOSE = .true.
         if (SLIST(N)(8:8).eq.'-') VERBOSE = .false.
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:9).eq.'MOSAIC_X1') then
         if (SLIST(N)(10:10).eq.'+') MOSAIC_X1 = .true.
         if (SLIST(N)(10:10).eq.'-') MOSAIC_X1 = .false.
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:9).eq.'MOSAIC_X2') then
         if (SLIST(N)(10:10).eq.'+') MOSAIC_X2 = .true.
         if (SLIST(N)(10:10).eq.'-') MOSAIC_X2 = .false.
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:10).eq.'SHOW_TILES') then
         if (SLIST(N)(11:11).eq.'-') SHOW_TILES = .false.
         if (SLIST(N)(11:11).eq.'+') then
            SHOW_TILE  = .true.
            SHOW_TILES = .true.
            endif
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:9).eq.'SHOW_TILE') then
         if (SLIST(N)(10:10).eq.'+') SHOW_TILE = .true.
         if (SLIST(N)(10:10).eq.'-') then
            SHOW_TILE  = .false.
            SHOW_TILES = .false.
            endif
         N = N + 1
         goto 2
         endif
      if (SLIST(N)(1:7).eq.'MASKFAC') then
         read(SLIST(N+1),*) MASKFAC
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:7).eq.'OTHRFAC') then
         read(SLIST(N+1),*) OTHRFAC
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:3).eq.'PIX') then
        !print*,'        G: ',G,Gs,_GDIM_
        !print*,'DIAGNOSTIC-j-> NDIRECT: ',NDIRECT
         read(SLIST(N+1),*) FILENAME_G(G)
        !print*,'DIAGNOSTIC-k-> NDIRECT: ',NDIRECT
         FILENAME_G(G) = SLIST(N+1)
        !print*,'DIAGNOSTIC-l-> NDIRECT: ',NDIRECT
        !print*,'QUERY_HDR...'
        !print*,'        G: ',G
        !print*,'   FILE_G: ',FILENAME_G(G)
        !print*,'  NDIRECT: ',NDIRECT
        !print*,'   DIRECT: ',DIRECT(1:NDIRECT)
        !print*,'NSUBDIR_G: ',NSUBDIR_G(G)
        !print*,'   SUBDIR: ',SUBDIR_G(G)(1:NSUBDIR_G(G))
        !print*,'     FILE: ',FILENAME_G(G)
         FILENAMEU = DIRECT(1:NDIRECT)
     .             //  SUBDIR_G(G)(1:NSUBDIR_G(G))
     .             //  FILENAME_G(G)
        !print*,'    FILEU: ',FILENAMEU
         call query_hdr(FILENAMEU,'EXPTIME ',ESTRING)
        !print*,'  ESTRING: ',ESTRING
         if (EXP_G(G).eq.0) read(ESTRING,*) EXP_G(G)
         N = N + 2
         goto 2
         endif
c     if (SLIST(N)(1:4).eq.'PERT') then
c        read(SLIST(N+1),*) FILEPERT_G(G)
c        N = N + 2
c        goto 2
c        endif
      if (SLIST(N)(1:3).eq.'MAT') then
        !read(SLIST(N+1),*) FILEMATT_G(G)
         FILEMATT_G(G) = SLIST(N+1)
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:3).eq.'SKY') then
         read(SLIST(N+1),*) SKYU
         SKY_G(G) = SKY_G(G) + SKYU
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:3).eq.'ZPU') then
         read(SLIST(N+1),*) ZPU_G(G)
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:4).eq.'EXPT') then
         read(SLIST(N+1),*) EXP_G(G)
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'PSF3UV') then
         FILEPSF = SLIST(N+1)
         call read_psf3uv(FILEPSF,psf_f(1,1,1,1,F_SLOT))
         FILEPSFu = 'NULL'
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'PSF3IR') then
         FILEPSF = SLIST(N+1)
         call read_psf3ir(FILEPSF,psf_f(1,1,1,1,F_SLOT))
         FILEPSFu = 'NULL'
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'PSFHRC') then
         FILEPSF = SLIST(N+1)
         call read_psfhrc(FILEPSF,psf_f(1,1,1,1,F_SLOT))
         FILEPSFu = 'NULL'
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'PSFACS') then
         FILEPSF = SLIST(N+1)
         call read_psfacs(FILEPSF,psf_f(1,1,1,1,F_SLOT))
         FILEPSFu = 'NULL'
         N = N + 2
         goto 2
         endif
      if (G.ne.0.and.SLIST(N)(1:3).eq.'PSF') then
          FILEPSF_G(G) = DIRECT(1:NDIRECT)
     .                   // SUBDIR_G(G)(1:NSUBDIR_G(G))
     .                   // SLIST(N+1)
          N = N + 2
          goto 2
          endif
      if (G.eq.0.and.SLIST(N)(1:6).eq.'PSFSTD') then
          FILEPSFu = SLIST(N+1)
          print*,'G       : ',G
          print*,'FILEPSFu: ',FILEPSFu
          N = N + 2
          goto 2
          endif
      if (SLIST(N)(1:6).eq.'F_SLOT') then
         read(SLIST(N+1),*) F_SLOT
         if (F_SLOT.gt._FDIM_) stop 'F_SLOT.gt._FDIM_'
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'EXPFLT') then
         if (.not.(F_SLOT.ge.1.or.F_SLOT.le._FDIM_)) stop 'ETIME FSLOT'
         read(SLIST(N+1),*) EXP_F(F_SLOT)
         if (.not.(EXP_F(F_SLOT).gt.0)) stop 'ETIME ERROR'
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'SCLFLT') then
         if (.not.(F_SLOT.ge.1.or.F_SLOT.le._FDIM_)) stop 'SCLFLT FSLOT'
         read(SLIST(N+1),*) SCL_F(F_SLOT)
         if (.not.(SCL_F(F_SLOT).gt.0)) stop 'SCALE ERROR'
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'IJTLIM') then
         read(SLIST(N+1),*) ITMINU
         read(SLIST(N+2),*) ITMAXU
         read(SLIST(N+3),*) JTMINU
         read(SLIST(N+4),*) JTMAXU
         N = N + 5
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'NITLIM'.or.
     .    SLIST(N)(1:6).eq.'NITFND') then
         read(SLIST(N+1),*) NITMINU
         read(SLIST(N+2),*) NITMAXU
         N = N + 3
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'NITMIN') then
         read(SLIST(N+1),*) NITMINU
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'NITMAX') then
         read(SLIST(N+1),*) NITMAXU
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:4).eq.'ULIM') then
         read(SLIST(N+1),*) UMIN_KS2
         read(SLIST(N+2),*) UMAX_KS2
         N = N + 3
         goto 2
         endif
      if (SLIST(N)(1:4).eq.'VLIM') then
         read(SLIST(N+1),*) VMIN_KS2
         read(SLIST(N+2),*) VMAX_KS2
         N = N + 3
         goto 2
         endif
      if (SLIST(N)(1:5).eq.'UVLIM') then
         read(SLIST(N+1),*) UMIN_KS2
         read(SLIST(N+2),*) UMAX_KS2
         read(SLIST(N+3),*) VMIN_KS2
         read(SLIST(N+4),*) VMAX_KS2
         N = N + 5
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'FILTER') then
         read(SLIST(N+1),*) FILT5
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'CHIPNA') then
         KKK = 0
         if (SLIST(N+1)(1:6).eq.'ACSWFC') KKK = 5
         if (SLIST(N+1)(1:6).eq.'ACSHRC') KKK = 7
         if (SLIST(N+1)(1:6).eq.'WFC3UV') KKK = 8
         if (SLIST(N+1)(1:6).eq.'WFC3IR') KKK = 9
         if (KKK.eq.0) then
            print*,'BAD CHIP NAME...',SLIST(N+1)(1:6)
            stop
            endif
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:5).eq.'GCSTD') then
         read(SLIST(N+1),*) FILEGCSu
         FILEGCSu = SLIST(N+1)
         if (G.ne.0) FILEGCS_G(G) = SLIST(N+1)
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'DIRECT') then
         DIRECT = SLIST(N+1)
         NDIRECT = STRLEN(SLIST(N+1))
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'SUBDIR') then
         NSUBDIR = STRLEN(SLIST(N+1))
         SUBDIR = SLIST(N+1)(1:NSUBDIR)
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:3).eq.'RAP') then
         read(SLIST(N+1),*) RAPu
         if (G.eq.0) RAP = RAPu
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'USEPOS') then
         read(SLIST(N+1),'(a9)') UPOSu
         do i = 01, 09
            if (UPOSu(i:i).ne.'1'.and.
     .          UPOSu(i:i).ne.'0') then
                print*,'KS2_SETUP ERRROR: '
                print*,'UPOS must be 9x 1s and 0s'
                print*,'UPOS: ',UPOSu
                stop
                endif
             enddo
         if (G.eq.0) UPOS = UPOSu
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'USEFND') then
         read(SLIST(N+1),'(a9)') UFNDu
         do i = 01, 09
            if (UPOSu(i:i).ne.'1'.and.
     .          UPOSu(i:i).ne.'0') then
                print*,'KS2_SETUP ERRROR: '
                print*,'UPOS must be 9x 1s and 0s'
                print*,'UPOS: ',UPOSu
                stop
                endif
             enddo
         if (G.eq.0) UFND = UFNDu
         N = N + 2
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'PREFLX'.or.
     .    SLIST(N)(1:6).eq.'PREMAG') then
         FILEPRE = SLIST(N+1)
         do F = 1, _FDIM_
            read(SLIST(N+1+F),*,end=9992) PLIM_F(F) ! BRITE LIMITING MAG...
            enddo
         open(91,file=FILEPRE,status='old')
         NMASTi = 0
    5    read(91,'(200a)',end=15) STRING
         if (STRING(1:1).eq.'#') goto 5
         NMASTi = NMASTi + 1
         read(STRING,*,end=9991) umast0(NMASTi),  vmast0(NMASTi),
     .                          (zmast0(NMASTi,F),F=1,_FDIM_)
         if (SLIST(N)(1:6).eq.'PREMAG') then
            do F = 1, _FDIM_
               if (zmast0(NMASTi,F).lt.0.)
     .             zmast0(NMASTi,F) = 10**(-zmast0(NMASTi,F)/2.5)
               if (zmast0(NMASTi,F).le.0.) zmast0(NMASTi,F) = 0.001
               enddo
            endif
         j = 0 ! see if any stars qualify...
         do F = 1, _FDIM_
            if (zmast0(NMASTi,F).gt.10**(-PLIM_F(F)/2.5)) j = j + 1
            enddo
         if (j.eq.0) NMASTi = NMASTi - 1
  116    format(1x,f9.3,1x,f9.3,5x,_FDIM_(f8.3,1x),5x,'N',i6.6,
     .                          5x,_FDIM_(f11.1,1x))
         goto 5
   15    close(91)
         close(13)
         write(*,'(10x,''NMASTi: '',i6)') NMASTi
         N = N + 2 + F
         goto 2
         endif
      if (SLIST(N)(1:5).eq.'BRITE') then
         FILEBRI = SLIST(N+1)
         open(91,file=FILEBRI,status='old')
         do F = 1, _FDIM_
            read(SLIST(N+1+F),*,end=9992) BLIM_F(F) ! BRITE LIMITING MAG...
            enddo
         Bs = 0
         Bx = 0
    4    read(91,'(200a)',end=14) STRING
         if (STRING(1:1).eq.'#') goto 4
         Bx = Bx + 1
         Bs = Bs + 1
         if (Bs.gt._BDIM_) Bs = _BDIM_
         read(STRING,*,end=9991) uref_b(Bs),    vref_b(Bs),
     .                          (zref_bf(Bs,F),F=1,_FDIM_)
         j = 0
         do F = 1, _FDIM_
            if (zref_bf(Bs,F).lt.BLIM_F(F)) then
                  zref_bf(Bs,F) = 10**(-zref_bf(Bs,F)/2.5)
                  j = j + 1
               else
                  zref_bf(Bs,F) =  0.001
               endif
            if (zref_bf(Bs,F).le.0.) zref_bf(Bs,F) = 0.001
            enddo
         if (j.eq.0) Bs = Bs - 1
         goto 4
   14    close(91)
         if (Bx.gt._BDIM_) then
            print*,' '
            print*,'THE ROUTINE WANTS TO READ IN '
            print*,'THIS MANY BRITE STARS      Bs: ',Bx
            print*,'THE HARDCODED LIMIT IS _BDIM_: ',_BDIM_
            stop 'Bs.gt._BDIM_'
            endif
         write(*,'(10x,''    Bs: '',i6)') Bs
         N = N + 2 + F
         goto 2
         endif
      if (SLIST(N)(1:8).eq.'ADDBRITE') then
         Bs = Bs + 1
         if (Bs.gt._BDIM_) stop 'Bs.gt._BDIM_'
         read(SLIST(N+1),*) uref_b(Bs)
         read(SLIST(N+2),*) vref_b(Bs)
         do F = 1, _FDIM_
            zref_bf(Bs,F) = 0.00
            enddo
         do F = 1, _FDIM_
            read(SLIST(N+2+F),*,end=132) zref_bf(Bs,F)
            if (zref_bf(Bs,F).lt.0) then
               zref_bf(Bs,F) = 10**(-zref_bf(Bs,F)/2.5)
               endif
            enddo
  132    continue
         write(*,
     .      '(20x,''ADDBRITE: '',i7.7,1x,2f8.2,10(3x,f9.1,1x,f7.3))')
     .        Bs,uref_b(Bs),vref_b(Bs),
     .        (zref_bf(Bs,F),-2.5*log10(max(zref_bf(Bs,F),1.0)),
     .         F=1,_FDIM_)
         N = N + 2 + _FDIM_ + 1
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'ADDART') then
         NARTs = NARTs + 1
         if (NARTs.gt._ARTMAX_) stop 'NARTs.gt._ARTMAX_'
         read(SLIST(N+1),*) uart0(NARTs)
         read(SLIST(N+2),*) vart0(NARTs)
         do F = 1, _FDIM_
            zart0(NARTs,F) = 0.00
            enddo
         do F = 1, _FDIM_
            read(SLIST(N+2+F),*,end=232) zart0(NARTs,F)
            if (zart0(NARTs,F).lt.0) then
               zart0(NARTs,F) = 10**(-zart0(NARTs,F)/2.5)
               endif
            enddo
  232    continue
         write(*,'(''ADDART: '',i7.7,1x,2f8.2,10(3x,f9.1,1x,f7.3))')
     .        NARTs,uref_b(NARTs),vref_b(NARTs),
     .        (zref_bf(NARTs,F),-2.5*log10(max(zref_bf(NARTs,F),1.0)),
     .         F=1,_FDIM_)
         N = N + 2 + _FDIM_ + 1
         goto 2
         endif
      if (SLIST(N)(1:6).eq.'ARTLST') then
         print*,'                           '
         print*,'ARTLST has been deprecated;'
         print*,'                           '
         print*,'Use ARTMAG or ARTFLX instead.'
         print*,'                           '
         stop
         endif
      if (SLIST(N)(1:6).eq.'ARTFLX'.or.
     .    SLIST(N)(1:6).eq.'ARTMAG') then
         FILEART = SLIST(N+1)
         open(91,file=FILEART,status='old')
         NARTs = 0
   56    read(91,'(200a)',end=16) STRING
         if (STRING(1:1).eq.'#') goto 56
         NARTs = NARTs + 1
         if (NARTs.gt._ARTMAX_) stop 'NARTs.gt._ARTMAX_'
         read(STRING,*,end=26) uart0(NARTs),  vart0(NARTs),
     .                        (zart0(NARTs,F),F=1,_FDIM_)
         if (SLIST(N)(1:6).eq.'ARTMAG') then
            do F = 1, _FDIM_
               zart0(NARTs,F) = 10**(-zart0(NARTs,F)/2.5)
               enddo
            endif
   26    continue
         goto 56
   16    close(91)
         print*,'NARTs: ',NARTs
         if (NARTs.eq.0) stop 'something wrong NARTs0'
         N = N + 2
         goto 2
         endif
 
      if (SLIST(N)(1:6).eq.'DRIVXY') then
         FILEART = SLIST(N+1)
         open(91,file=FILEART,status='old')
         NMASTi = 0
    6    read(91,'(200a)',end=46) STRING
         if (STRING(1:1).eq.'#') goto 6
         NARTs = NARTs + 1
         if (NMASTi.gt._NSTMAX_) stop 'NMASTi.gt._NSTMAX_'
         NMASTi = NMASTi + 1
         do F = 1, _FDIM_
            zmast0(NMASTi,F) = 0.00
            enddo
         read(STRING,*) umast0(NMASTi),  vmast0(NMASTi),
     .                 (zmast0(NMASTi,F),F=1,_FDIM_)
         do F = 1, _FDIM_
            if (zmast0(NMASTi,F).lt.-1.00)
     .          zmast0(NMASTi,F) = 10**(-zmast0(NMASTi,F)/2.5)
            enddo
         wmast0(NMASTi) = 1
         goto 6
   46    close(91)
         N = N + 2
         print*,'---> NMASTi: ',NMASTi
         goto 2
         endif
 
      print*,'PARSING ERROR... '
      print*,'    N: ',N,SLIST(N)(1:30)
      print*,'   Ns: ',Ns
      stop
 
    3 continue
      close(60)
 
!$omp critical(info_ks2)
      write(*,*)
      write(*,'(''***********************************************'')')
      write(*,'(''***** '')')
      write(*,'(''***** REPORT ON IMAGE SLOTS ---- Gs :'',i4)') Gs
      write(*,'(''***** '')')
      write(*,'(''***** '')')
      write(*,'(''***********************************************'')')
      write(*,*)
      write(*,43)
      open(33,file='LOGK.INFO_ks2',status='unknown')
      write(33,43)
      do G = 1, Gs
         write(33,44) G,Cs_KKK(KKK_G(G)),
     .                ABBREV(FILENAME_G(G)),
     .                ABBREV( FILEPSF_G(G)),
     .                ABBREV( FILEGCS_G(G)),
     .                ABBREV(FILEMATT_G(G)),
     .                FFF_G(G),RAP_G(G),
     .                POS_G(G),FND_G(G),
     .                KKK_G(G),FLT_G(G),
     .                MSK_G(G),OTH_G(G),
     .                SUBDIR_G(G)(1:NSUBDIR_G(G))
         write( *,44) G,Cs_KKK(KKK_G(G)),
     .                ABBREV(FILENAME_G(G)),
     .                ABBREV( FILEPSF_G(G)),
     .                ABBREV( FILEGCS_G(G)),
     .                ABBREV(FILEMATT_G(G)),
     .                FFF_G(G),RAP_G(G),
     .                POS_G(G),FND_G(G),
     .                KKK_G(G),FLT_G(G),
     .                MSK_G(G),OTH_G(G),
     .                SUBDIR_G(G)(1:NSUBDIR_G(G))
   43    format('#  G.Cs',3x,
     .          'PIX                           ',1x,
     .          'PSF                           ',1x,
     .          'GCS                           ',1x,
     .          'MAT                           ',3x,
     .          'SLT RAP POS...... FND...... KKK.FLT',2x,
     .          '  MSK   OTH   SUBDIR ')
   44    format(i4.4,'.',i1,4x,a30,1x,a30,1x,a30,1x,a30,
     .               2x,2i4,1x,a9,1x,a9,1x,i3,'.',i2.2,
     .               3x,f6.2,1x,f6.2,3x,20a)
         enddo
      close(33)
!$omp end critical(info_ks2)
 
      write(*,*)
      write(*,'(''***********************************************'')')
      write(*,'(''***** '')')
      write(*,'(''***** READ IN THE MAT FILES...'')')
      write(*,'(''***** '')')
      write(*,'(''***********************************************'')')
      write(*,*)
 
      do G = 1, Gs
         if (G.eq.G/10*10) write(*,122)
         FILEMATT = DIRECT(1:NDIRECT) //
     .              SUBDIR_G(G)(1:NSUBDIR_G(G)) //
     .              FILEMATT_G(G)
         do C = 1, Cs_KKK(KKK_G(G))
            ZP_CG(C,G) = ZPU_G(G)
            enddo
         call read_mat(FILEMATT,  KKK_G(G), FLT_G(G), FILEGCS_G(G),
     .                 ucen_cg(1,G), vcen_cg(1,G),
     .                 icen_cg(1,G), jcen_cg(1,G),
     .                 xcen_cg(1,G), ycen_cg(1,G),
     .                   AG_CG(1,G),   BG_CG(1,G),
     .                   CG_CG(1,G),   DG_CG(1,G),
     .                   GA_CG(1,G),   GB_CG(1,G),
     .                   GC_CG(1,G),   GD_CG(1,G),
     .                   ZP_CG(1,G),   SC_CG(1,G))
         do C = 1, Cs_KKK(KKK_G(G))
            write(*,111) G, C,
     .           AG_CG(C,G), BG_CG(C,G), CG_CG(C,G), DG_CG(C,G),
     .           ucen_cg(C,G), vcen_cg(C,G),
     .           icen_CG(C,G), jcen_cg(C,G),
     .           xcen_CG(C,G), ycen_cg(C,G),
     .           ZP_CG(C,G), SC_CG(C,G),
     .           EXP_G(G),EXP_F(FFF_G(G)), SKY_G(G)
  111       format(1x,i4.4,1x,i1,1x,4f10.5,
     .             4x,2f10.3,
     .             4x,2i5,
     .             4x,2f10.3,
     .             4x,f8.4,1x,f8.4,
     .             4x,f8.2,1x,f8.2,1x,
     .             4x,f8.1,1x,f8.1,1x,f8.2)
  122       format(1x,'..G.',1x,'C',1x,
     .             ' ....AG...',' ....BG...',' ....CG...',' ....DG...',
     .             4x,' ...UCEN..',' ...VCEN..',
     .             4x,' ICEN',' JCEN',
     .             4x,' ...XCEN..',' ...YCEN..',
     .             4x,'..ZP_CG.',1x,'..SC_CG.',
     .             4x,'..EXP_G.',1x,'..EXP_F.',1x,'..SKY_G.')
            enddo
         enddo
      write(*,122)
      write(*,*)
!$omp critical(log_trans)
      open(34,file='LOGK.TRANS_ks2',status='unknown')
      write(34,122)
      do G = 1, Gs
         do C = 1, Cs_KKK(KKK_G(G))
            write(34,111) G, C,
     .           AG_CG(C,G), BG_CG(C,G), CG_CG(C,G), DG_CG(C,G),
     .           ucen_cg(C,G), vcen_cg(C,G),
     .           icen_CG(C,G), jcen_cg(C,G),
     .           xcen_CG(C,G), ycen_cg(C,G),
     .           ZP_CG(C,G), SC_CG(C,G),
     .           EXP_G(G),EXP_F(FFF_G(G)), SKY_G(G)
            enddo
         enddo
      write(34,122)
      close(34)
!$omp end critical(log_trans)
 
!$omp critical(log_brites)
      write(*,'(''***** LOG BRITES ---     Bs: '',i5)') Bs
      if (Bs.ge.0) then
         open(35,file='LOGK.BRITE')
         do B = 1, Bs
            write(35,115) uref_b(B), vref_b(B),
     .           (-2.5*log10(max(zref_bf(B,F),1.0)),F=1,_FDIM_),B,
     .           (                     zref_bf(B,F),F=1,_FDIM_)
  115       format(1x,f9.3,1x,f9.3,5x,_FDIM_(f8.3,1x),5x,'B',i6.6,
     .                             5x,_FDIM_(f11.1,1x))
            enddo
         close(35)
         endif
!$omp end critical(log_brites)
 
!$omp critical(log_premag)
      write(*,'(''***** LOG PREMAG --- NMASTi: '',i5)') NMASTi
      if (NMASTi.ge.0) then
         open(36,file='LOGK.PREMAG')
         do NMAST = 1, NMASTi
            write(36,116) umast0(NMAST), vmast0(NMAST),
     .        (-2.5*log10(max(zmast0(NMAST,F),1.0)),F=1,_FDIM_),NMAST,
     .        (zmast0(NMAST,F),F=1,_FDIM_)
              enddo
         close(36)
         endif
!$omp end critical(log_premag)
 
 
 
!$omp critical(log_brite_reg_x1)
      if (_MOSAIC_X1_) then
         open(58,file='LOGK.brite_u1.reg',status='unknown')
         write(58,'(''# Region file format: DS9 version 3.0'')')
         do B = 1, Bs
            write(58,112) 1*uref_b(B), 1*vref_b(B),5.0,'yellow ',4
            enddo
         close(58)
         endif
!$omp end critical(log_brite_reg_x1)
 
!$omp critical(log_brite_reg_x2)
      if (_MOSAIC_X2_) then
         open(59,file='LOGK.brite_u2.reg',status='unknown')
         write(59,'(''# Region file format: DS9 version 3.0'')')
         do B = 1, Bs
            write(59,112) 2*uref_b(B), 2*vref_b(B),5.0,'yellow ',4
  112       format('linear;circle( ',f8.1,',',f8.1,
     .             ',',f6.3,') # color=',a7,' width=',i1)
            enddo
         close(59)
         endif
!$omp end critical(log_brite_reg_x2)
 
      write(*,'(''***** EXIT SETUP ---     Gs: '',i5)') Gs
      do F = 1, Fs
         write(*,'(''      EXPTIMES   ---      F: '',i2,f10.2)')
     .                                               F,EXP_F(F)
         if (.not.EXP_F(F).gt.0) stop
         enddo
      write(*,*)
 
 
      if (Fs.ne._FDIM_) then
         print*,' '
         print*,'STRANGE, I KNOW, BUT THE ROUTINE'
         print*,'DOESN''T SEEM TO WORK WHEN Fs.ne._FDIM_'
         print*,'     Fs  : ',Fs
         print*,'   _FDIM_: ',_FDIM_
         stop
         endif
 
      return
 
 9992 continue
      print*,'NEED to have _FDIM_ columns in PREMAG/BRITE spec'
      print*,' '
      print*,'STRING: ',STRING
      do N = 1, Ns
         print*,'  N: ',N,SLIST(N)(1:40)
         enddo
      stop
 
 9991 continue
      print*,' '
      print*,'NEED to have _FDIM_ columns in PREMAG/BRITE..'
      print*,' '
      print*,'FILE  :  ',SLIST(N+1)(1:60)
      print*,' '
      print*,'Line from PREMAG/BRITE that did not have enough entries: '
      print*,' '
      print*,'STRING:  ',STRING
      print*,' '
      stop
      end
 
 
 
      character*5 function FLT_VS_CHIP(flt,chp)
      implicit none
 
      integer flt
      integer chp
 
      character*5 FLT_VS_CHIPH(12,10)
      common /FLT_VS_CHIP_/FLT_VS_CHIPH
      data   FLT_VS_CHIPH /
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF', ! 01
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF',
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF', ! 02
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF',
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF', ! 03
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF',
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF', ! 04
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF',
     . 'F435W','F475W','F555W','F606W','F814W','F850L', ! 05 WFC (BOT/BOTH)
     . 'F625W','F658N','F775W','F660N','F502N','F550M', !
     . 'F435W','F475W','F555W','F606W','F814W','F850L', ! 06 WFC (TOP)
     . 'F625W','F658N','F775W','F660N','F502N','F550M', !
     . 'F220W','F330W','F435W','F475W','F555W','F606W', ! 07 HRC
     . 'F625W','F775W','F814W','F850L','FFFFF','FFFFF',
     . 'F275W','F336W','F390W','F438W','F555W','F606W', ! 08
     . 'F775W','F814W','F850L','FFFFF','FFFFF','F225W',
     . 'F110W','F160W','FFFFF','FFFFF','FFFFF','FFFFF', ! 09
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF',
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF', ! 10
     . 'FFFFF','FFFFF','FFFFF','FFFFF','FFFFF','FFFFF'/
 
 
      FLT_VS_CHIP = FLT_VS_CHIPH(flt,chp)
 
      return
      end
 
 
 
c------------------------------------------------
c
c will take a filter string and will return
c the filter number
c
      integer function WHICH_FILT(filt5,KKK)
      implicit none
 
      character*5 filt5
      integer     KKK
 
      character*5 FLT_VS_CHIP
      integer     i
 
      if (KKK.lt.1.or.KKK.gt.10) stop 'KKK out of range'
 
      WHICH_FILT = 0
      do I = 1, 12
         if (FILT5.eq.FLT_VS_CHIP(I,KKK)) WHICH_FILT = I
         enddo
 
      return
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/SETUP/null_l.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c------------------------------------------------------------
c
c
c
      subroutine null_l(uu_l, vv_l, u0_l, v0_l, w0_l,
     .                  z0_lf,sz0_lf,
     .                  z1_lf,sz1_lf, q1_lf, o1_lf, f1_lf, g1_lf,
     .                  z2_lf,sz2_lf, q2_lf, o2_lf, f2_lf, g2_lf,
     .                  z3_lf,sz3_lf, f3_lf, g3_lf,
     .                  bar_lf, rms_lf)
      implicit none
 
      real*8  uu_l(1), vv_l(1)
      real    u0_l(1), v0_l(1)
      integer w0_l(1)
      real    z0_lf(_LDIM_,_FDIM_), sz0_lf(_LDIM_,_FDIM_)
      real    z1_lf(_LDIM_,_FDIM_), sz1_lf(_LDIM_,_FDIM_)
      real    q1_lf(_LDIM_,_FDIM_),  o1_lf(_LDIM_,_FDIM_)
      integer*2 f1_lf(_LDIM_,_FDIM_),  g1_lf(_LDIM_,_FDIM_)
      real    z2_lf(_LDIM_,_FDIM_), sz2_lf(_LDIM_,_FDIM_)
      real    q2_lf(_LDIM_,_FDIM_),  o2_lf(_LDIM_,_FDIM_)
      integer*2  f2_lf(_LDIM_,_FDIM_),  g2_lf(_LDIM_,_FDIM_)
      real    z3_lf(_LDIM_,_FDIM_), sz3_lf(_LDIM_,_FDIM_)
      integer*2 f3_lf(_LDIM_,_FDIM_),  g3_lf(_LDIM_,_FDIM_)
      real   bar_lf(_LDIM_,_FDIM_)
      real   rms_lf(_LDIM_,_FDIM_)
 
      integer F
 
      uu_l(1) = 0.
      vv_l(1) = 0.
      u0_l(1) = 0.
      v0_l(1) = 0.
      w0_l(1) = 0
 
      do F = 1, _FDIM_
          z0_lf(1,F) = 0.
         sz0_lf(1,F) = 0.
          z1_lf(1,F) = 0.
         sz1_lf(1,F) = 0.
          q1_lf(1,F) = 0.
          o1_lf(1,F) = 0
          f1_lf(1,F) = 0
          g1_lf(1,F) = 0.
 
          z2_lf(1,F) = 0.
         sz2_lf(1,F) = 0.
          q2_lf(1,F) = 0.
          o2_lf(1,F) = 0
          o2_lf(1,F) = 0
          f2_lf(1,F) = 0
          g2_lf(1,F) = 0
 
          z3_lf(1,F) = 0.
         sz3_lf(1,F) = 0.
          f3_lf(1,F) = 0
          g3_lf(1,F) = 0
         bar_lf(1,F) = 0.
         rms_lf(1,F) = 0.
         enddo
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/SETUP/parse.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------------
c
c
c
      subroutine parse(STRING,SLIST,Ls)
      implicit none
 
      character*200 STRING
      character*80  SLIST(99)
      integer Ls
 
      integer L, LL(99), Le
      integer i
 
      character*80 Q
      logical paropen
 
      Le = 200
      do i = 1, 200
         if (STRING(i:i).eq.'=') STRING(i:i) = ' '
         if (STRING(i:i).eq.'!') Le = i
         enddo
 
      Ls = 0
      paropen = .false.
 
      i = 0
   11 i = i + 1
      if (i.eq.Le) return
      if (STRING(i:i).eq.'"') paropen = .not.paropen
      if (STRING(i:i).eq.' ') goto 11
 
      Ls = 1
      LL(1) = i
   12 continue
      if (STRING(i  :i  ).eq.' '.and.
     .    STRING(i+1:i+1).ne.' '.and.
     .    .not.paropen) then
          Ls = Ls + 1
          LL(Ls) = i
          endif
      i = i + 1
      if (STRING(i:i).eq.'"') paropen = .not.paropen
      if (i.le.Le-2) goto 12
 
      do L = 1, Ls
         read(STRING(LL(L):200),*) SLIST(L)
         enddo
 
      return
      end
 
      integer function STRLEN(Q)
      implicit none
 
      character*(*) Q
      STRLEN = 0
 
   21 if (Q(STRLEN+1:STRLEN+1).eq.' ') return
      STRLEN = STRLEN + 1
      goto 21
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/SETUP/read_mat.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------------
c
c
c
c
      subroutine read_mat(FILEMATT,  KKK, FLT, FILEGCS,
     .                 ucen_c, vcen_c,
     .                 icen_c, jcen_c,
     .                 xcen_c, ycen_c,
     .                 AG_C,BG_C,CG_C,DG_C,
     .                 GA_C,GB_C,GC_C,GD_C,
     .                 ZP_C,SC_C)
      implicit none
 
      character*80 FILEMATT
      integer      KKK
      integer      FLT
      character*80 FILEGCS
 
      real*8  ucen_c(_CDIM_), vcen_c(_CDIM_)
      integer icen_c(_CDIM_), jcen_c(_CDIM_)
      real*8  xcen_c(_CDIM_), ycen_c(_CDIM_)
      real*8  AG_C(_CDIM_), BG_C(_CDIM_), CG_C(_CDIM_), DG_C(_CDIM_)
      real*8  GA_C(_CDIM_), GB_C(_CDIM_), GC_C(_CDIM_), GD_C(_CDIM_)
      real    ZP_C(_CDIM_), SC_C(_CDIM_)
 
      integer ij_cen
 
      integer NMAT, NMATs
      real*8 x1(_NMATMX_), y1(_NMATMX_)
      real*8 x2(_NMATMX_), y2(_NMATMX_)
      real   m1(_NMATMX_), m2(_NMATMX_)
      byte   cc(_NMATMX_)
      integer C, Cs
 
      real*8 x1o, y1o, x2o, y2o
      real*8 AG, BG, CG, DG
      real*8 GA, GB, GC, GD, DLTA
      integer Us, Uu
      real*8 x1u(_NMATMX_), y1u(_NMATMX_)
      real*8 x2u(_NMATMX_), y2u(_NMATMX_)
      real   m1u(_NMATMX_), m2u(_NMATMX_), dmu(_NMATMX_)
      real   mbar, msig
      byte   ccu(_NMATMX_)
      integer Cs_KKK
      character*200 STRING
 
c     print*,'enter read_mat: ',FILEMATT(1:80)
c     print*,'           KKK: ',KKK
c     print*,'           FLT: ',FLT
c     print*,'       FILEGCS: ',FILEGCS(1:80)
 
      do C = 1, _CDIM_
         ucen_c(C) = -9999.
         vcen_c(C) = -9999.
         icen_c(C) = 0.
         jcen_c(C) = 0.
         AG_C(C) = 0.
         BG_C(C) = 0.
         CG_C(C) = 0.
         DG_C(C) = 0.
         GA_C(C) = 0.
         GB_C(C) = 0.
         GC_C(C) = 0.
         GD_C(C) = 0.
         SC_C(C) = 0.
         enddo
 
      Cs = 0
      if (KKK.eq.1) Cs = 4
      if (KKK.eq.5) Cs = 2
      if (KKK.eq.7) Cs = 1
      if (KKK.eq.8) Cs = 2
      if (KKK.eq.9) Cs = 1
 
      if (KKK.eq.0) return
 
      if (Cs.gt._CDIM_) stop 'Cs.gt._CDIM_'
 
!$omp critical(read_mat)
      open(40,file=FILEMATT,status='old')
      NMATs = 0
    1 read(40,'(200a)',end=2) STRING
      if (STRING(1:1).eq.'#') goto 1
      read(STRING,*) x1(NMATs+1), y1(NMATs+1),
     .               x2(NMATs+1), y2(NMATs+1),
     .               m1(NMATs+1), m2(NMATs+1)
      NMATs = NMATs + 1
      if (NMATs+1.gt.(_NMATMX_)) stop 'NMATs.gt._NMATMX_'
      goto 1
    2 close(40)
!$omp end critical(read_mat)
 
      Cs = Cs_KKK(KKK)
 
      do NMAT = 1, NMATs
         cc(NMAT) = 1
         if (KKK.eq.1) then
            if (y2(NMAT).lt.800.and.x2(NMAT).lt.800) cc(NMAT) = 1
            if (y2(NMAT).gt.800.and.x2(NMAT).gt.800) cc(NMAT) = 2
            if (y2(NMAT).gt.800.and.x2(NMAT).gt.800) cc(NMAT) = 3
            if (y2(NMAT).gt.800.and.x2(NMAT).gt.800) cc(NMAT) = 4
            endif
         if (KKK.eq.5.and.y2(NMAT).lt.1915+300*x2(NMAT)/4096) cc(NMAT)=2
         if (KKK.eq.8.and.y2(NMAT).lt.2060) cc(NMAT)=2
         enddo
 
      do C = 1, Cs
         call glob_fit6nrDP(x1u,y1u,x2u,y2u,NMATs,
     .                      AG,BG,CG,DG,x1o,y1o,x2o,y2o)
         Us = 0
         do NMAT = 1, NMATs
            if (cc(NMAT).eq.c) then
               Us = Us + 1
               x1u(Us) = x1(NMAT) + _XOFF_
               y1u(Us) = y1(NMAT) + _YOFF_
               x2u(Us) = x2(NMAT)
               y2u(Us) = y2(NMAT)
               m1u(Us) = m1(NMAT)
               m2u(Us) = m2(NMAT)
               dmu(Us) = m1(NMAT)-m2(NMAT)
               endif
            enddo
         if (Us.gt.10) then
            call glob_fit6nrDP(x1u,y1u,x2u,y2u,Us,
     .                         AG,BG,CG,DG,x1o,y1o,x2o,y2o)
            endif
         DLTA = AG*DG-BG*CG
         GA =  DG/DLTA
         GB = -BG/DLTA
         GC = -CG/DLTA
         GD =  AG/DLTA
         AG_C(C) = AG
         BG_C(C) = BG
         CG_C(C) = CG
         DG_C(C) = DG
         GA_C(C) = GA
         GB_C(C) = GB
         GC_C(C) = GC
         GD_C(C) = GD
         icen_c(C) = ij_cen(1,C,KKK)
         jcen_c(C) = ij_cen(2,C,KKK)
         call gc_cf(icen_c(C)*1.0d0,jcen_c(C)*1.0d0,
     .              xcen_c(C),      ycen_c(C),
     .              KKK,FLT,C,FILEGCS)
         ucen_c(C) = x1o + GA*(xcen_c(C)-x2o) + GB*(ycen_c(C)-y2o)
         vcen_c(C) = y1o + GC*(xcen_c(C)-x2o) + GD*(ycen_c(C)-y2o)
 
 
         call barsig(dmu,Us,mbar,msig,Uu)
         if (ZP_C(C).le.-90) ZP_C(C) = mbar
         SC_C(C) = 10**(-mbar/2.5)
         enddo!C
c     STOP
      return
      end
 
 
 
 
 
      integer function ij_cen(ixy,ik,KKK)
      implicit none
 
      integer ixy
      integer ik
      integer KKK
 
      integer ij_cenh(2,4,10)
      common /ij_cen_/ij_cenh
      data ij_cenh/
     .     0400, 0400, 0400, 0400, 0400, 0400, 0400, 0400, ! 01 WFPC2
     .     0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, ! 02
     .     0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, ! 03
     .     0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, ! 04
     .     2048, 1024, 2048, 3072, 0000, 0000, 0000, 0000, ! 05 WFC
     .     0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, ! 06
     .     0512, 0512, 0000, 0000, 0000, 0000, 0000, 0000, ! 07 HRC
     .     2048, 1024, 2048, 3072, 0000, 0000, 0000, 0000, ! 08 WFC3/UVIS
     .     0512, 0512, 0000, 0000, 0000, 0000, 0000, 0000, ! 09 WFC3/IR
     .     0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000/ ! 10
 
      if (ixy.ne.1.and.ixy.ne.2) stop 'ixy.ne.1or2'
      if ( ik.lt.1.or.ik.gt.4)   stop 'ik.lt.1.or.ik.gt.4'
      if (KKK.lt.1.or.KKK.gt.10) stop 'KKK.lt.1.or.KKK.gt.10'
 
      ij_cen = ij_cenh(ixy,ik,KKK)
 
      return
      end
 
 
c-----------------------------------------------
c
c will tell us how many chips each detector has
c
      integer function Cs_KKK(KKK)
      implicit none
 
      integer KKK
 
      integer Cs_KKKH(10)
      common/Cs_KKK_/Cs_KKKH
      data Cs_KKKH/ 4, 0, 0, 0, 2,
     .              0, 1, 2, 1, 0/
 
      Cs_KKK = Cs_KKKH(KKK)
 
      return
      end
 
 
c--------------------------------------------------
c STAT - STATISTICS ROUTINES
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/barsig.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine barsig(xlist,NTOT,bar,sig,NUSE)
      implicit none
 
      integer NTOT
      real*4 xlist(NTOT)
      real*4 bar
      real*4 sig
      integer NUSE
 
      integer n
      real*8    bsum, ssum
      integer nsum
      integer NIT
 
 
      bar = 0.e0
      sig = 9e9
      do NIT = 1, 30
         bsum = 0.
         ssum = 0.
         nsum = 0.
         do n = 1, NTOT
            if (abs(xlist(n)-bar).le.3.0*sig) then
               bsum = bsum + xlist(n)
               ssum = ssum + abs(xlist(n)-bar)
               nsum = nsum + 1
               endif
            enddo
         if (nsum.gt.0) bar = bsum / nsum
         if (nsum.gt.1) sig = abs(ssum/(nsum-1))
         enddo
      NUSE = nsum
      if (nsum.le.1) sig = 0.999
 
      return
      end
 
 
c
c
c
c
      subroutine barsig_2p0(xlist,NTOT,bar,sig,NUSE)
      implicit none
 
      integer NTOT
      real*4 xlist(NTOT)
      real*4 bar
      real*4 sig
      integer NUSE
 
      integer n
      real*8    bsum, ssum
      integer nsum
      integer NIT
 
 
      bar = 0.e0
      sig = 9e9
      do NIT = 1, 30
         bsum = 0.
         ssum = 0.
         nsum = 0.
         do n = 1, NTOT
            if (abs(xlist(n)-bar).le.2.0*sig) then
               bsum = bsum + xlist(n)
               ssum = ssum + abs(xlist(n)-bar)
               nsum = nsum + 1
               endif
            enddo
         if (nsum.gt.0) bar = bsum / nsum
         if (nsum.gt.1) sig = abs(ssum/(nsum-1))
         enddo
      NUSE = nsum
      if (nsum.le.1) sig = 0.999
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/barsigw.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------
c
c
c
      subroutine barsigw(xlist,wlist,NTOT,bar,sig,NUSE,SIGREJ)
      implicit none
 
      integer NTOT
      real*4 xlist(NTOT)
      real*4 wlist(NTOT)
      real*4 bar
      real*4 sig
      integer NUSE
      real   SIGREJ
 
      integer n
      real*8 bsum, ssum
      real*8 wsum
      integer nsum
      integer NIT
      real   wsumo
 
 
      bar = 0.e0
      sig = 9e9
      wsum = 9e9
      do NIT = 1, 30
         wsumo= wsum
         bsum = 0.
         ssum = 0.
         wsum = 0.
         nsum = 0
         do n = 1, NTOT
            if (abs(xlist(n)-bar).le.SIGREJ*sig) then
               bsum = bsum + wlist(n)*xlist(n)
               ssum = ssum + wlist(n)*abs(xlist(n)-bar)
               wsum = wsum + wlist(n)
               nsum = nsum + 1
               endif
            enddo
         if (wsum.gt.0) then
            bar = bsum / wsum
            sig = abs(ssum/wsum)
            endif
         if (SIGREJ.gt.90.0) goto 1
c        if (wsum.ne.wsumo) goto 1
         enddo
    1 continue
      NUSE = nsum
      if (nsum.le.1) sig = 0.999
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/barsig_1DW_MREJ.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c---------------------------------------------------
c
c MREG means marginal rejection:  one at a time
c
      subroutine barsig_1DW_MREJ(zl,wl,uo,ul,Ls,Lg,SIG_CLIP,
     .                           zbar, zsig)
      implicit none
 
      integer Ls, Lg
      real    zl(Ls)
      real    wl(Ls)
      byte    uo(Ls)
      byte    ul(Ls)
      real    SIG_CLIP
      real    zbar, zsig
 
      integer L, LL
      real    ztot, wtot
      integer utot
      real    wmax
      integer Lmin
      real    wmin
      integer Umax, Lmax
      real    Smax, sigu
 
      integer U, Us, Ua
      real    zu(999)
      real    wu(999)
      integer lu(999)
 
      if (Ls.gt.999) stop 'barsig_1DW_MREJ: Ls.gt.999'
 
c-------------------------
c
c save the initial weights
c
      if (Ls.eq.0) then
         zbar = 0.000
         zsig = 99999
         Lg   = 0
         return
         endif
 
 
c-------------------------
c
c save the initial weights
c
      do L = 1, Ls
         if (wl(L).le.0) uo(L) = 0
         ul(L) = uo(L)
         enddo
 
 
 
c--------------------------------
c
c come here every time something
c gets rejected
c
    1 continue
      if (.false.) then
         print*,' '
         print*,' '
         do L = 1, Ls
            write(*,119) L, uo(L), ul(L), zl(L), wl(L)
 119        format(i2,1x,i1,1x,i1,1x,f9.1,1x,f8.4)
            enddo
         print*,' '
         print*,' '
         read(*,*) L
         endif
 
      wtot = 0.0
      wmin = 9e9
      Lmin = 0
      Us = 0
      do L = 1, Ls
         if (ul(L).eq.1) then
            Us = Us + 1
            lu(Us) = L
            zu(Us) = zl(L)
            wu(Us) = wl(L)
            wtot   = wtot + wl(L)
            if (wu(Us).lt.wmin) then
               Lmin = L
               wmin = wl(L)
               endif
            endif
         enddo
 
      if (Us.eq.0) then
         zbar = 0.000
         zsig = 99999
         Lg   = 0
         return
         endif
 
      if (wmin.lt.0.20*wtot/Us) then ! reject things that have less than
         ul(Lmin) = 0                !     20% of the typical weight ; reject
         uo(Lmin) = 0                !     them a-priori...
 
         goto 1
         endif
 
      if (Us.le.2) goto 2                        ! we now have all we need to do the final calculation
 
 
 
c-----------------------------------------------------
c
c go through the observations one by one and see which
c one may not agree with the others (evaluate the
c sigma of the others without including this one; time
c consuming, but necessary when small-number stats
c are involved)
c
      Umax = 0
      Smax = 0.00
      do U = 1, Us
         ztot = 0.
         wtot = 0.
         do Ua = 1, Us
            if (Ua.ne.U) then
               ztot = ztot + wu(Ua)*zu(Ua)
               wtot = wtot + wu(Ua)
               endif
            enddo
         zbar = ztot/wtot
 
         ztot = 0.
         wtot = 0.
         wmax = 0.
         do Ua = 1, Us
            if (Ua.ne.U) then
               ztot = ztot + wu(Ua)*abs(zu(Ua)-zbar)
               wtot = wtot + wu(Ua)
               if (wu(Ua).gt.wmax) wmax = wu(Ua)
               endif
            enddo
 
         if (wtot.eq.wmax) stop '1MREJ wtot.eq.wmax'  ! this really should never happen
         zsig = ztot/(wtot-wmax)                      ! compute sigma w/o this star...
         if (zsig.lt.0.005*zbar) zsig = 0.005*zbar    ! practical photometric limit; if the
         sigu = abs(zu(U)-zbar)/zsig                  !    accidental agreement is better; ignore
         if (sigu.gt.Smax) then
            Smax = sigu
            Umax = U
            endif
c        write(*,111) U, lu(U), zbar,  zsig, wu(U),
c    .                           zu(U), sigu, Umax, Smax
c111     format(1x,i2,1x,i2,3x,f10.1,1x,f10.1,1x,f8.4,
c    .           5x,f10.1,1x,f8.4,1x,i2,1x,f8.4)
         enddo
 
 
 
      if (Smax.gt.SIG_CLIP) then  ! reject this one and start again
         Lmax = lu(Umax)          ! if we don't need to reject one, move on
         ul(Lmax) = 0
         goto 1
         endif
 
 
c---------------------------------------------
c
c now, we have fully flagged the ul() array...
c let's do the averaging!
c
    2 continue
 
      ztot = 0.
      wtot = 0.
      utot = 0
      do L = 1, Ls
         ztot = ztot + ul(L)*wl(L)*zl(L)
         wtot = wtot + ul(L)*wl(L)
         utot = utot + ul(L)
         enddo
 
      if (wtot.le.0) stop '1MREJ wtot.le.0'  ! this really should never happen
 
      zbar = ztot/wtot
 
      if (utot.eq.1) then
         zsig = 99999
         Lg = 1
         return
         endif
 
      ztot = 0.
      wmax = 0.
      do L = 1, Ls
         ztot = ztot + ul(L)*wl(L)*abs(zl(L)-zbar)
         if (ul(L)*wl(L).gt.wmax) wmax = ul(L)*wl(L)
         enddo
      zsig = ztot/(wtot-wmax)
      Lg   = utot
 
c     write(*,111) Ls, Lg, zbar, zsig, wtot
c     read(*,*) Lmin
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/barsig_3DW_MREJ.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c------------------------------------------------------------
c
c MREG means marginal rejection:  one at a time; this routine
c uses all three observables (x,y,z) to do this.
c
      subroutine barsig_3DW_MREJ(xl,yl,zl,wl,ul,Ls,Lg,SIG_CLIP,
     .                           xbar, ybar, zbar,
     .                           xsig, ysig, zsig)
      implicit none
 
      integer Ls, Lg
      real    xl(Ls)
      real    yl(Ls)
      real    zl(Ls)
      real    wl(Ls)
      integer ul(Ls)
      real    SIG_CLIP
      real    xbar, xsig
      real    ybar, ysig
      real    zbar, zsig
 
      integer L, LL
      real*8  xtot, ytot
      real*8  ztot, wtot
      integer utot
      real    wmax
      integer uo(999)
      integer Lmin
      real    wmin
      integer Umax, Lmax
      real    Smax, sigu, sigx, sigy, sigz
 
      integer U, Us, Ua
      real    xu(999)
      real    yu(999)
      real    zu(999)
      real    wu(999)
      integer lu(999)
 
      if (Ls.gt.999) stop 'barsig_3DW_MREJ: Ls.gt.999'
 
c-------------------------
c
c save the initial weights
c
      if (Ls.eq.0) then
         xbar = 0.000
         xsig = 99999
         ybar = 0.000
         ysig = 99999
         zbar = 0.000
         zsig = 99999
         Lg   = 0
         return
         endif
 
 
c-------------------------
c
c save the initial weights
c
      do L = 1, Ls
         if (wl(L).le.0) ul(L) = 0
         uo(L) = ul(L)
         enddo
 
 
 
c-------------------------------
c
c come here every time something
c gets rejected
c
    1 continue
 
      wmin = 9e9
      wmax = 0.0
      wtot = 0.0
      Lmin = 0
      Us = 0
      do L = 1, Ls
         if (ul(L).eq.1) then
            Us = Us + 1
            lu(Us) = L
            xu(Us) = xl(L)
            yu(Us) = yl(L)
            zu(Us) = zl(L)
            wu(Us) = wl(L)
            wtot   = wtot + wl(L)
            if (wu(Us).gt.wmax) wmax = wu(Us)
            if (wu(Us).lt.wmin) then
               Lmin = L
               wmin = wl(L)
               endif
            endif
         enddo
 
      if (Us.eq.0) then
         xbar = 0.000
         xsig = 99999
         ybar = 0.000
         ysig = 99999
         zbar = 0.000
         zsig = 99999
         Lg   = 0
         return
         endif
 
      if (Us.gt.1.and.wmin.lt.0.20*wtot/Us) then ! reject things that have less than
         ul(Lmin) = 0                            !     20% of the typical weight
         goto 1
         endif
 
      if (Us.le.2) then
         xtot = 0.
         ytot = 0.
         ztot = 0.
         wtot = 0.
         do U = 1, Us
            xtot = xtot + wu(U)*xu(U)
            ytot = ytot + wu(U)*yu(U)
            ztot = ztot + wu(U)*zu(U)
            wtot = wtot + wu(U)
            enddo
         xbar = xtot/wtot
         ybar = ytot/wtot
         zbar = ztot/wtot
 
         xtot = 0.
         ytot = 0.
         ztot = 0.
         do U = 1, Us
            xtot = xtot + wu(U)*abs(xu(U)-xbar)
            ytot = ytot + wu(U)*abs(yu(U)-ybar)
            ztot = ztot + wu(U)*abs(zu(U)-zbar)
            wtot = wtot + wu(U)
            enddo
         if (Us.eq.1) then
            xsig =    9.9
            ysig =    9.9
            zsig = 9999.9
            Lg = 1
            return
            endif
         xsig = xtot/wtot
         ysig = ytot/wtot
         zsig = ztot/wtot
         Lg = Us
         return
         endif
 
 
 
c-----------------------------------------------------
c
c go through the observations one by one and see which
c one may not agree with the others (evaluate the
c sigma of the others without including this one; time
c consuming, but necessary when small-number stats
c are involved)
c
      Umax = 0
      Smax = 0.00
      do U = 1, Us
         xtot = 0.
         ytot = 0.
         ztot = 0.
         wtot = 0.
         do Ua = 1, Us
            if (Ua.ne.U) then
               xtot = xtot + wu(Ua)*xu(Ua)
               ytot = ytot + wu(Ua)*yu(Ua)
               ztot = ztot + wu(Ua)*zu(Ua)
               wtot = wtot + wu(Ua)
               endif
            enddo
         xbar = xtot/wtot
         ybar = ytot/wtot
         zbar = ztot/wtot
 
         xtot = 0.
         ytot = 0.
         ztot = 0.
         wtot = 0.
         wmax = 0.
         do Ua = 1, Us
            if (Ua.ne.U) then
               xtot = xtot + wu(Ua)*abs(xu(Ua)-xbar)
               ytot = ytot + wu(Ua)*abs(yu(Ua)-ybar)
               ztot = ztot + wu(Ua)*abs(zu(Ua)-zbar)
               wtot = wtot + wu(Ua)
               if (wu(Ua).gt.wmax) wmax = wu(Ua)
               endif
            enddo
 
         if (wtot.eq.wmax) stop '3MREJ wtot.eq.wmax'  ! this really should never happen
         xsig = xtot/(wtot-wmax)                      ! compute sigma
         ysig = ytot/(wtot-wmax)
         zsig = ztot/(wtot-wmax)
         if (xsig.lt.0.01) xsig = 0.01               ! practical astrometric limit
         if (ysig.lt.0.01) ysig = 0.01
         if (zsig.lt.0.01*zbar) zsig = 0.01*zbar     ! practical photometric limit
         sigx = abs(xu(U)-xbar)/xsig
         sigy = abs(yu(U)-ybar)/ysig
         sigz = abs(zu(U)-zbar)/zsig
         sigu = sqrt(sigz**2 + sigy**2 + sigz**2)
         if (sigu.gt.Smax) then
            Smax = sigu
            Umax = U
            endif
c         write(*,111) U, lu(U),
c     .                xbar, ybar, zbar,
c     .                xsig, ysig, zsig,
c     .                wu(U),
c     .                xu(U), yu(U), zu(u),
c     .                xu(U)-xbar, yu(U)-ybar, zu(u)-zbar,
c     .                sigx, sigy, sigz, sigu,
c     .                Umax, Smax
c  111    format(3x,i2,1x,i2,
c     .          3x,f8.3,1x,f8.3,1x,f9.1,
c     .          3x,f6.3,1x,f6.3,1x,f7.1,
c     .          3x,f6.4,1x,
c     .          3x,f8.3,1x,f8.3,1x,f9.1,
c     .          3x,f8.3,1x,f8.3,1x,f9.1,
c     .          3x,f8.3,1x,f8.3,1x,f8.3,1x,f8.3,
c     .          3x,i2,1x,f8.3)
         enddo
 
 
 
      if (Smax.gt.SIG_CLIP) then  ! reject this one and start again
         Lmax = lu(Umax)          ! if we don't need to reject one, move on
         ul(Lmax) = 0
         goto 1
         endif
 
 
c---------------------------------------------
c
c now, we have fully flagged the ul() array...
c let's do the averaging!
c
    2 continue
 
      ztot = 0.
      wtot = 0.
      utot = 0
      do L = 1, Ls
         ztot = ztot + ul(L)*wl(L)*zl(L)
         wtot = wtot + ul(L)*wl(L)
         utot = utot + ul(L)
         enddo
 
      if (wtot.le.0) stop '3MREJ wtot.le.0'  ! this really should never happen
 
      zbar = ztot/wtot
 
      if (utot.eq.1) then
         zsig = 99999
         Lg = 1
         return
         endif
 
      ztot = 0.
      wmax = 0.
      do L = 1, Ls
         ztot = ztot + ul(L)*wl(L)*abs(zl(L)-zbar)
         if (ul(L)*wl(L).gt.wmax) wmax = ul(L)*wl(L)
         enddo
      zsig = ztot/(wtot-wmax)
      Lg   = utot
 
c      write(*,111) Ls, Lg,
c     .             xbar, ybar, zbar,
c     .             xsig, ysig, zsig,
c     .             wtot
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/barsig_sns_10.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------------
c
c barsig for small number statistics... N<=10
c
c
      subroutine barsig_sns(xlist,NTOTT,bar,sig,NUSE)
      implicit none
 
      integer NTOTT
      real*4  xlist(10)
      real*4  bar
      real*4  sig
      integer NUSE
 
      integer NTOT
      integer n
      real bar1, sig1
      real bar2, sig2
      real bar3, sig3
      real*8 slist(10)
 
      NTOT = NTOTT
 
      if (NTOT.gt.10) then
         print*,'barsig_sns called with NTOT>10: ',NTOT
         stop
         endif
 
      if (NTOT.eq.0) then
         bar = 0.
         sig = 0.
         NUSE = 0
         return
         endif
 
      do n = 1, NTOT
         slist(n) = xlist(n)
         enddo
 
      NTOT = NTOTT
 777  continue
      call dbubble(slist,NTOT)
 
      if (NTOT.eq.10) then
         bar1 = (slist(1)+slist(2)+slist(3)+slist(4)
     .          +slist(5)+slist(6)+slist(7)+slist(8))/8
         sig1 = (slist(7)-slist(2))/2.5
         bar2 = (slist(2)+slist(3)+slist(4)+slist(5)
     .          +slist(6)+slist(7)+slist(8)+slist(9))/8
         sig2 = (slist(8)-slist(3))/2.5
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig.lt.5) sig = 5.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(10).gt.bar+3*sig) then
            NTOT = 9
            goto 777
            endif
         if (slist(01).lt.bar-3*sig) then
            NTOT = 9
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            slist(4) = slist(5)
            slist(5) = slist(6)
            slist(6) = slist(7)
            slist(7) = slist(8)
            slist(8) = slist(9)
            slist(9) = slist(10)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+slist(4)
     .         +slist(5)+slist(6)+slist(7)+slist(8)
     .         +slist(9)+slist(10))/10
         sig = (abs(slist(01)-bar)
     .         +abs(slist(02)-bar)
     .         +abs(slist(03)-bar)
     .         +abs(slist(04)-bar)
     .         +abs(slist(05)-bar)
     .         +abs(slist(06)-bar)
     .         +abs(slist(07)-bar)
     .         +abs(slist(08)-bar)
     .         +abs(slist(09)-bar)
     .         +abs(slist(10)-bar))/9
         NUSE = 10
         goto 666
         endif
 
      if (NTOT.eq.9) then
         bar1 = (slist(1)+slist(2)+slist(3)+slist(4)
     .          +slist(5)+slist(6)+slist(7))/7
         sig1 = (slist(7)-slist(2))/3.0
         bar2 = (slist(2)+slist(3)+slist(4)+slist(5)
     .          +slist(6)+slist(7)+slist(8))/7
         sig2 = (slist(8)-slist(3))/3.0
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig.lt.5) sig = 5.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(9).gt.bar+3*sig) then
            NTOT = 8
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 8
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            slist(4) = slist(5)
            slist(5) = slist(6)
            slist(6) = slist(7)
            slist(7) = slist(8)
            slist(8) = slist(9)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+slist(4)
     .         +slist(5)+slist(6)+slist(7)+slist(8)+slist(9))/9
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar)
     .         +abs(slist(5)-bar)
     .         +abs(slist(6)-bar)
     .         +abs(slist(7)-bar)
     .         +abs(slist(8)-bar)
     .         +abs(slist(9)-bar))/8
         NUSE = 9
         goto 666
         endif
 
      if (NTOT.eq.8) then
         bar1 = (slist(1)+slist(2)+slist(3)+slist(4)+slist(5))/4
         sig1 = (slist(6)-slist(2))/3.0
         bar2 = (slist(2)+slist(3)+slist(4)+slist(5)+slist(6))/4
         sig2 = (slist(7)-slist(3))/3.0
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig.lt.5) sig = 5.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(8).gt.bar+3*sig) then
            NTOT = 7
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 7
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            slist(4) = slist(5)
            slist(5) = slist(6)
            slist(6) = slist(7)
            slist(7) = slist(8)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+slist(4)
     .         +slist(5)+slist(6)+slist(7)+slist(8))/8
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar)
     .         +abs(slist(5)-bar)
     .         +abs(slist(6)-bar)
     .         +abs(slist(7)-bar)
     .         +abs(slist(8)-bar))/7
         NUSE = 8
         goto 666
         endif
 
      if (NTOT.eq.7) then
         bar1 = (slist(1)+slist(2)+slist(3)+slist(4))/4
         sig1 = (slist(5)-slist(1))/3.0
         bar2 = (slist(2)+slist(3)+slist(4)+slist(5))/4
         sig2 = (slist(6)-slist(2))/3.0
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig.lt.5) sig = 5.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(7).gt.bar+3*sig) then
            NTOT = 6
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 6
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            slist(4) = slist(5)
            slist(5) = slist(6)
            slist(6) = slist(7)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+
     .          slist(4)+slist(5)+slist(6)+slist(7))/7
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar)
     .         +abs(slist(5)-bar)
     .         +abs(slist(6)-bar)
     .         +abs(slist(7)-bar))/6
         NUSE = 7
         goto 666
         endif
 
      if (NTOT.eq.6) then
         bar1 = (slist(1)+slist(2)+slist(3)+slist(4))/4
         sig1 = (slist(4)-slist(1))/2.5
         bar2 = (slist(2)+slist(3)+slist(4)+slist(5))/4
         sig2 = (slist(5)-slist(2))/2.5
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig.lt.4) sig = 4.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(6).gt.bar+3*sig) then
            NTOT = 5
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 5
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            slist(4) = slist(5)
            slist(5) = slist(6)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+
     .          slist(4)+slist(5)+slist(6))/6
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar)
     .         +abs(slist(5)-bar)
     .         +abs(slist(6)-bar))/5
         NUSE = 6
         goto 666
         endif
 
      if (NTOT.eq.5) then
         if (slist(3).gt.35000.and.
     .       slist(2).lt.01000.and.
     .       slist(1).lt.01000) then
               NTOT = 2
               goto 777
               endif
         bar1 = (slist(1)+slist(2)+slist(3)+slist(4))/4
         sig1 = (slist(4)-slist(1))/2
         bar2 = (slist(2)+slist(3)+slist(4)+slist(5))/4
         sig2 = (slist(5)-slist(2))/2
         bar3 = (slist(1)+slist(2)+slist(3))/3
         sig3 = (slist(3)-slist(1))*1.5
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig3.lt.sig1) then
            bar = bar3
            sig = sig3
            endif
         if (sig.lt.4) sig = 4.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(5).gt.bar+3*sig) then
            NTOT = 4
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 4
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            slist(4) = slist(5)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+
     .          slist(4)+slist(5))/5
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar)
     .         +abs(slist(5)-bar))/4
         NUSE = 5
         goto 666
         endif
      if (NTOT.eq.4) then
         if (slist(3).gt.35000.and.
     .       slist(2).lt.01000.and.
     .       slist(1).lt.01000) then
               NTOT = 2
               goto 777
               endif
         bar1 = (slist(1)+slist(2)+slist(3))/3
         sig1 = (slist(3)-slist(1))
         bar2 = (slist(2)+slist(3)+slist(4))/3
         sig2 = (slist(4)-slist(2))
         bar3 = (slist(1)+slist(2))/2
         sig3 = (slist(2)-slist(1))*3
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig3.lt.sig1) then
            bar = bar3
            sig = sig3
            endif
         if (sig.lt.4) sig = 4.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(4).gt.bar+3*sig) then
            NTOT = 3
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 3
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+slist(4))/4
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar))/3
         NUSE = 4
         goto 666
         endif
      if (NTOT.eq.3) then
         bar1 = (slist(1)+slist(2))/2
         sig1 = (slist(2)-slist(1))
         bar2 = (slist(2)+slist(3))/2
         sig2 = (slist(3)-slist(2))
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig.lt.4) sig = 4.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(3).gt.bar+3*sig) then
            NTOT = 2
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 2
            slist(1) = slist(2)
            slist(2) = slist(3)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3))/3
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar))/2
         NUSE = 3
         goto 666
         endif
      if (NTOT.eq.2) then
         bar = slist(1)
         sig = 4
         if (sig.lt.4) sig = 4.0
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(2).gt.bar+5*sig) then
            NUSE = 1
            bar = slist(1)
            sig = 999.9
            goto 666
            endif
         if (abs(slist(2)).lt.20.and.slist(1).lt.-50) then
            NUSE = 1
            bar = slist(2)
            sig = 999.9
            goto 666
            endif
         bar = (slist(1)+slist(2))/2
         sig = (slist(2)-slist(1))/2
         NUSE = 2
         goto 666
         endif
      if (NTOT.eq.1) then
         bar = slist(1)
         sig = 999.9
         NUSE = 1
         goto 666
         endif
 
      print*,' '
      print*,'---> STOP...'
      print*,' '
      print*,'---> SHOULD NOT BE HERE.'
      print*,' '
 
 666  continue
      return
 
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/dbubble.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------
c
c bubble-sorts a real*8 list into ascending order
c
      subroutine dbubble(r1,NTOT)
      implicit none
      integer NTOT
      real*8 r1(NTOT)
      integer n
      real*8 temp
      logical change
 777  continue
      change = .false.
      do n = 1, NTOT-1
         if (r1(n).gt.r1(n+1)) then
            temp = r1(n)
            r1(n) = r1(n+1)
            r1(n+1) = temp
            change = .true.
            endif
         enddo
      if (change) goto 777
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/find_avgs_uvz1.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c-----------------------------------------------------------------
c
c monster 3-d rejecter and averager
c
      subroutine find_avg_uvz1( u1_ln,  v1_ln,
     .                          z1_ln, sz1_ln, s1_ln, ss1_ln,
     .                          q1_ln,  o1_ln, f1_ln, g1_ln, FFF_N,
     .                          Ns, Lo, Ls,
     .                          u1_lf,   v1_lf, su1_lf, sv1_lf,
     .                          z1_lf,  sz1_lf,  s1_lf, ss1_lf,
     .                          q1_lf,   o1_lf,  f1_lf,  g1_lf, Fs)
      implicit none
 
      integer   Ns, Lo, Ls
      real      u1_ln(_LDIM_,Ns)
      real      v1_ln(_LDIM_,Ns)
      real      z1_ln(_LDIM_,Ns), sz1_ln(_LDIM_,Ns)
      real      s1_ln(_LDIM_,Ns), ss1_ln(_LDIM_,Ns)
      real      q1_ln(_LDIM_,Ns),  o1_ln(_LDIM_,Ns)
      integer*2 f1_ln(_LDIM_,Ns)
      integer*2 g1_ln(_LDIM_,Ns)
      integer FFF_n(Ns)
 
      real      u1_lf(_LDIM_,_FDIM_), su1_lf(_LDIM_,_FDIM_)
      real      v1_lf(_LDIM_,_FDIM_), sv1_lf(_LDIM_,_FDIM_)
      real      z1_lf(_LDIM_,_FDIM_), sz1_lf(_LDIM_,_FDIM_)
      real      s1_lf(_LDIM_,_FDIM_), ss1_lf(_LDIM_,_FDIM_)
      real      q1_lf(_LDIM_,_FDIM_),  o1_lf(_LDIM_,_FDIM_)
      integer*2 f1_lf(_LDIM_,_FDIM_),  g1_lf(_LDIM_,_FDIM_)
      integer Fs
 
 
      integer U, Us, Ug
      integer L, F, N
 
 
      real   z2f(_FDIM_), sz2f(_FDIM_)
 
      real ubar, vbar, zbar
      real usig, vsig, zsig
      real qtot, otot, wtot
 
      real*4    , dimension(:), allocatable :: u_u, v_u, z_u, sz_u
      real*4    , dimension(:), allocatable :: w_u, q_u, o_u
      integer*4 , dimension(:), allocatable :: f_u, g_u, n_u
 
      allocate( u_u(Ns))
      allocate( v_u(Ns))
      allocate( z_u(Ns))
      allocate(sz_u(Ns))
      allocate( w_u(Ns))
      allocate( q_u(Ns))
      allocate( o_u(Ns))
      allocate( f_u(Ns))
      allocate( g_u(Ns))
      allocate( n_u(Ns))
 
      do L =  1, Ls
         do F = 1, _FDIM_
            Us = 0
            do N = 1, Ns
               if (FFF_n(N).eq.F.and.
     .             f1_ln(L,N).eq.1) then
                  Us = Us + 1
                  u_u(Us) =  u1_ln(L,N)
                  v_u(Us) =  v1_ln(L,N)
                  z_u(Us) =  z1_ln(L,N)
                 sz_u(Us) = sz1_ln(L,N)
                  q_u(Us) =  q1_ln(L,N)
                  o_u(Us) =  o1_ln(L,N)
                  f_u(Us) =  f1_ln(L,N)
                  g_u(Us) =  f1_ln(L,N)
                  n_u(Us) =  N
                  endif
               enddo
            wtot = 0.
            do U = 1, Us
               w_u(U) = 1/sz_u(U)**2
               wtot = wtot + w_u(U)
               enddo
            do U = 1, Us
               w_u(U) = w_u(U)/wtot
               enddo
            call barsig_3DW_MREJ(u_u,v_u,z_u,w_u,g_u,Us,Ug,7.5,
     .                           ubar, vbar, zbar,
     .                           usig, vsig, zsig)
            u1_lf(L,F)  = ubar
            v1_lf(L,F)  = vbar
            z1_lf(L,F)  = zbar
            su1_lf(L,F) = usig
            sv1_lf(L,F) = vsig
            sz1_lf(L,F) = zsig
            f1_lf(L,F)  = Us
            g1_lf(L,F)  = Ug
            do U = 1, Us
               g1_ln(L,n_u(U)) = g_u(U)  ! report back which were actually used
               enddo
            wtot = 0.
            qtot = 0.
            otot = 0.
            do U = 1, Us
               wtot = wtot + g_u(U)*w_u(U)
               qtot = qtot + g_u(U)*w_u(U)*q_u(U)
               otot = otot + g_u(U)*w_u(U)*o_u(U)
               enddo
            q1_lf(L,F)  = 0.000
            o1_lf(L,F)  = 0.000
            if (wtot.gt.0) then
               q1_lf(L,F)  = max(qtot/wtot,0.)
               o1_lf(L,F)  = otot/wtot
               endif
            enddo!F
         enddo!L
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/find_avgs_z2.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
 
 
c-----------------------------------------------------------------
c
c monster averager...
c
      subroutine find_avg_z2( z2_ln, sz2_ln, s2_ln, ss2_ln,
     .                        q2_ln,  o2_ln, f2_ln, g2_ln, FFF_N,
     .                        Ns, Lo, Ls,
     .                        z2_lf,  sz2_lf,  s2_lf, ss2_lf,
     .                        q2_lf,   o2_lf,  f2_lf,  g2_lf, Fs)
      implicit none
 
      integer   Ns, Lo, Ls
      real      z2_ln(_LDIM_,Ns), sz2_ln(_LDIM_,Ns)
      real      s2_ln(_LDIM_,Ns), ss2_ln(_LDIM_,Ns)
      real      q2_ln(_LDIM_,Ns),  o2_ln(_LDIM_,Ns)
      integer*2 f2_ln(_LDIM_,Ns)
      integer*2 g2_ln(_LDIM_,Ns)
      integer   FFF_n(Ns)
 
      real      z2_lf(_LDIM_,_FDIM_), sz2_lf(_LDIM_,_FDIM_)
      real      s2_lf(_LDIM_,_FDIM_), ss2_lf(_LDIM_,_FDIM_)
      real      q2_lf(_LDIM_,_FDIM_),  o2_lf(_LDIM_,_FDIM_)
      integer*2 f2_lf(_LDIM_,_FDIM_),  g2_lf(_LDIM_,_FDIM_)
      integer Fs
 
 
      integer U, Us, Ug
      integer L, F, N
 
      real   z2f(_FDIM_), sz2f(_FDIM_)
 
      real zbar, zsig
      real qtot, otot, wtot
 
      real*4    , dimension(:), allocatable :: u_u, v_u, z_u, sz_u
      real*4    , dimension(:), allocatable :: w_u, q_u, o_u
      byte      , dimension(:), allocatable :: f_u, g_u
      integer*4 , dimension(:), allocatable :: n_u
 
      allocate( u_u(Ns))
      allocate( v_u(Ns))
      allocate( z_u(Ns))
      allocate(sz_u(Ns))
      allocate( w_u(Ns))
      allocate( q_u(Ns))
      allocate( o_u(Ns))
      allocate( f_u(Ns))
      allocate( g_u(Ns))
      allocate( n_u(Ns))
 
      do L =  1, Ls
         do F = 1, _FDIM_
            Us = 0
            do N = 1, Ns
               if (FFF_n(N).eq.F.and.
     .             f2_ln(L,N).eq.1) then
                  Us = Us + 1
                  z_u(Us) =  z2_ln(L,N)
                 sz_u(Us) = sz2_ln(L,N)
                  q_u(Us) =  q2_ln(L,N)
                  o_u(Us) =  o2_ln(L,N)
                  f_u(Us) =  f2_ln(L,N)
                  n_u(Us) =  N
                  endif
               enddo
            wtot = 0.
            do U = 1, Us
               w_u(U) = 1/sz_u(U)**2
               wtot = wtot + w_u(U)
               enddo
            do U = 1, Us
               w_u(U) = w_u(U)/wtot
               enddo
            call barsig_1DW_MREJ(z_u,w_u,f_u,g_u,Us,Ug,4.0,
     .                           zbar, zsig)
            z2_lf(L,F)  = zbar
            sz2_lf(L,F) = zsig
            f2_lf(L,F)  = 0
            g2_lf(L,F)  = 0
            do U = 1, Us
               g2_ln(L,n_u(U)) = g_u(U)  ! report back which were actually used
               f2_lf(L,F) = f2_lf(L,F) + f_u(U)
               g2_lf(L,F) = g2_lf(L,F) + g_u(U)
               enddo
            wtot = 0.
            qtot = 0.
            otot = 0.
            do U = 1, Us
               wtot = wtot + g_u(U)*w_u(U)
               qtot = qtot + g_u(U)*w_u(U)*q_u(U)
               otot = otot + g_u(U)*w_u(U)*o_u(U)
               enddo
            q2_lf(L,F)  = 0.000
            o2_lf(L,F)  = 0.000
            if (wtot.gt.0) then
               q2_lf(L,F)  = max(qtot/wtot,0.0)
               o2_lf(L,F)  = otot/wtot
               endif
            enddo!F
         enddo!L
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STAT/rbubble.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c--------------------------------------
c
c bubble-sorts a real*4 list into ascending order
c
      subroutine rbubble(r1,NTOT)
      implicit none
      integer NTOT
      real r1(NTOT)
      real temp
      integer n
      logical change
 777  continue
      change = .false.
      do n = 1, NTOT-1
         if (r1(n).gt.r1(n+1)) then
            temp = r1(n)
            r1(n) = r1(n+1)
            r1(n+1) = temp
            change = .true.
            endif
         enddo
      if (change) goto 777
      end
 
 
c--------------------------------------------------
c STDGC - STANDARD DISTORTION SOLUTION STUFF
c--------------------------------------------------
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STDGC/infofits_stdgc.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine infofits_stdgc(FILEI,
     .                          PXDIMX,PXDIMY,
     .                          FILTNAME,IFILT,INSTNAME,
     .                          Ks,i_abcd,j_abcd,x_abcd,y_abcd)
      implicit none
 
      character*80 FILEI
      integer      PXDIMX
      integer      PXDIMY
      character*5  FILTNAME
      integer      IFILT
      character*7  INSTNAME
      integer     Ks
      integer     i_abcd(4,9), j_abcd(4,9)
      real*8      x_abcd(4,9), y_abcd(4,9)
 
 
 
      character*2880 buffc
 
      integer k, q
      integer n
 
      character*08 FIELD
      character*70 STREAM
 
 
!$omp critical(infofits)
      print*,'INFOFITS: ',FILEI
      open(37,file=FILEI,
     .        status='old',
     .        err   =900,
     .        recl  =2880,
     .        form  ='UNFORMATTED',
     .        access='DIRECT')
 
      read(37,rec=1) buffc
 
      do k = 01, 09
      do q = 01, 04
         i_abcd(k,q) = 9999
         j_abcd(k,q) = 9999
         x_abcd(k,q) = 9999.99
         y_abcd(k,q) = 9999.99
         enddo
         enddo
 
      do n = 01, 36
         FIELD  = buffc((n-1)*80+01:(n-1)*80+08)
         STREAM = buffc((n-1)*80+11:(n-1)*80+80)
         if (FIELD.eq.'NAXIS2  ') read(STREAM,*) PXDIMX
         if (FIELD.eq.'NAXIS3  ') read(STREAM,*) PXDIMY
         if (FIELD.eq.'NCHIPS  ') read(STREAM,*) Ks
         if (FIELD.eq.'CHIP1U  ')
     .       read(STREAM,*) i_abcd(3,1),j_abcd(3,1),
     .                      i_abcd(4,1),j_abcd(4,1),
     .                      x_abcd(3,1),y_abcd(3,1),
     .                      x_abcd(4,1),y_abcd(4,1)
         if (FIELD.eq.'CHIP1L  ')
     .       read(STREAM,*) i_abcd(1,1),j_abcd(1,1),
     .                      i_abcd(2,1),j_abcd(2,1),
     .                      x_abcd(1,1),y_abcd(1,1),
     .                      x_abcd(2,1),y_abcd(2,1)
         if (FIELD.eq.'CHIP2U  ')
     .       read(STREAM,*) i_abcd(3,2),j_abcd(3,2),
     .                      i_abcd(4,2),j_abcd(4,2),
     .                      x_abcd(3,2),y_abcd(3,2),
     .                      x_abcd(4,2),y_abcd(4,2)
         if (FIELD.eq.'CHIP2L  ')
     .       read(STREAM,*) i_abcd(1,2),j_abcd(1,2),
     .                      i_abcd(2,2),j_abcd(2,2),
     .                      x_abcd(1,2),y_abcd(1,2),
     .                      x_abcd(2,2),y_abcd(2,2)
         if (FIELD.eq.'FILTNAME') read(STREAM,*) FILTNAME
         if (FIELD.eq.'IFILT   ') read(STREAM,*) IFILT
         if (FIELD.eq.'INSTNAME') read(STREAM,*) INSTNAME
         enddo
 
c      if (.false.) then
c         print*,' '
c         do k = 01, Ks
c            print*,'k=',k
c            do q = 01, 04
c               write(*,'(10x,i1,1x,i4.4,1x,i4.4,1x,2f10.4)')
c     .                  q, i_abcd(q,k), j_abcd(q,k),
c     .                     x_abcd(q,k), y_abcd(q,k)
c               enddo
c            enddo
c         print*,' '
c         endif
 
      goto 901
  900 continue
      stop 'infofits_stdgc'
  901 stop
 
      close(37)
!$omp end critical(infofits)
 
 
      return
 
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STDGC/xcyc2xryr_stdgc.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------
c
c This routine  will extract the inverse distortion solution,
c using the xryr2xcyc_stdgc() routine.  Its implicit assumption
c is that the distortion solution is *largely* in the original
c chip frame.  It iterates using the residuals directly rather
c than converting them into the distorted frame.  It does use
c the info in the common block to delimit the area for each
c chip.  It returns the found chip number in "ko".
c
      subroutine xcyc2xryr_stdgc(xc,yc,xr,yr,FILEI,ki,ko)
      implicit none
 
      real*8 xc, yc
      real*8 xr, yr
      character*80 FILEI
      integer ki ! input :  2 = bottom chip, 1 = top chip
      integer ko ! output:  2 = bottom chip, 1 = top chip
 
c
c-------------------------------------------------------
c
 
      integer     i_abcd(4,9), j_abcd(4,9)
      real*8      x_abcd(4,9), y_abcd(4,9)
      integer     Ks
      integer     PXDIMX
      integer     PXDIMY
      character*5 FILTNAME
      character*7 INSTNAME
      integer     IFILT
      character*80 FILEH
      common /get_stdgc_/ i_abcd,j_abcd,x_abcd,y_abcd,Ks,
     .                    PXDIMX,PXDIMY,
     .                    FILTNAME,INSTNAME,IFILT,
     .                    FILEH
      real*8 xre, yre
      real*8 xce, yce
 
      integer NIT
      real*8  dx, dy
 
c
c-------------------------------------------------------
c
 
      ko = 0
 
      if (ki.eq.0.or.ki.eq.1) then
         xre = xc
         yre = yc
         do NIT = 01, 10
            call xryr2xcyc_stdgc(xre,yre,xce,yce,FILEI,1)
            dx = xc-xce
            dy = yc-yce
            xre = xre + dx
            yre = yre + dy
            enddo
         if (xre.ge.i_abcd(1,1).and.xre.le.i_abcd(2,1).and.
     .       yre.ge.j_abcd(1,1).and.yre.le.j_abcd(3,1)) ko = 1
         if (ki.eq.1.or.ko.eq.1) then
            xr = xre
            yr = yre
            return
            endif
         endif
 
      if (ki.eq.0.or.ki.eq.2) then
         xre = xc
         yre = yc
         do NIT = 01, 10
            call xryr2xcyc_stdgc(xre,yre,xce,yce,FILEI,2)
            dx = xc-xce
            dy = yc-yce
            xre = xre + dx
            yre = yre + dy
            enddo
         if (xre.ge.i_abcd(1,2).and.xre.le.i_abcd(2,2).and.
     .       yre.ge.j_abcd(1,2).and.yre.le.j_abcd(3,2)) ko = 2
         if (ki.eq.2.or.ko.eq.2) then
            xr = xre
            yr = yre
            return
            endif
         endif
 
      ko = 0
      xr = -999.9
      yr = -999.9
      return
 
 900  continue
      print*,'stdfits_gc file error: ',FILEI
      stop 'stop'
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/STDGC/xryr2xcyc_stdgc.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------
c
c this will extract the distortion solution from a 2*4096*4096
c file ; it doesn't actually use the BSCALE/BZERO, it assumes
c them to be 1e-5 and 0.
c
c
      subroutine xryr2xcyc_stdgc(xr,yr,xc,yc,FILEI,k)
      implicit none
 
      real*8 xr, yr
      real*8 xc, yc
      character*80 FILEI
      integer k ! 2 = bottom chip, 1 = top chip
 
c
c-------------------------------------------------------
c
 
 
      character*8 buffc
      byte        buffb(8), b(8)
      integer*4   buffi(2)
      equivalence (buffb,buffc,buffi)
 
      integer NABCD
      real*8  xcn(4)
      real*8  ycn(4)
 
      integer i0,j0,n
      integer i, j
 
 
      integer ni(4)
      common /ni_/ni
      data ni/0,1,0,1/  ! should be faster to read this way
 
      integer nj(4)
      common /nj_/nj
      data nj/0,0,1,1/  ! should be faster to read this way
 
      character*80 FILEH
      integer PXDIMX
      integer PXDIMY
      character*5 FILTNAME
      integer     IFILT
      character*7 INSTNAME
      integer     Ks
      integer     i_abcd(4,9), j_abcd(4,9)
      real*8      x_abcd(4,9), y_abcd(4,9)
      common /get_stdgc_/ i_abcd,j_abcd,x_abcd,y_abcd,Ks,
     .                    PXDIMX,PXDIMY,
     .                    FILTNAME,INSTNAME,IFILT,
     .                    FILEH
      data FILEH/'NULL'/
 
      real fx, fy
      integer iminu, imaxu
      integer jminu, jmaxu
 
c
c------------------------------------------------------
c
 
      print*,'STDGC NEEDS TO BE SAFE FOR OPENMP...'
      print*,'  FILEH: ',FILEH
      print*,'  FILEI: ',FILEI
      print*,'     xr: ',xr,yr
      print*,'     xc: ',xc,yc
      print*,'      k: ',k
      stop
      if (FILEH.ne.FILEI) then
         print*,'first call info...',FILEI
         call infofits_stdgc(FILEI,
     .                       PXDIMX,PXDIMY,
     .                       FILTNAME,IFILT,INSTNAME,
     .                       Ks,i_abcd,j_abcd,x_abcd,y_abcd)
         print*,'FILEI      : ',FILEI(1:30)
         print*,'     PXDIMX: ',PXDIMX
         print*,'     PXDIMY: ',PXDIMY
         print*,'   FILTNAME: ',FILTNAME
         print*,'      IFILT: ',IFILT
         print*,'   INSTNAME: ',INSTNAME
         print*,'         Ks: ',Ks
         open(38,file=FILEI,
     .        status='old',
     .        err   =900,
     .        recl  =8,
     .        form  ='UNFORMATTED',
     .        access='DIRECT')
         FILEH = FILEI
         if (Ks.gt.4) stop 'get_stdgc: Ks.gt.9'
         endif
 
      if (k.eq.0) then
            iminu = 0001
            imaxu = PXDIMX
            jminu = 0001
            jmaxu = PXDIMY
         else
            if (k.gt.Ks) stop 'get_stdgc: K.gt.Ks'
            iminu = i_abcd(1,k)
            imaxu = i_abcd(2,k)
            jminu = j_abcd(1,k)
            jmaxu = j_abcd(3,k)
         endif
 
      i0 = int(xr)
      j0 = int(yr)
      if (i0.lt.iminu) i0 = iminu
      if (i0.ge.imaxu) i0 = imaxu-1
      if (j0.lt.jminu) j0 = jminu
      if (j0.ge.jmaxu) j0 = jmaxu-1
 
      fx = xr-i0
      fy = yr-j0
 
      do NABCD = 1, 4
         i = i0 + ni(NABCD)
         j = j0 + nj(NABCD)
         n = 360 + i + (j-1)*PXDIMX
         read(38,rec=n) buffc
         if (_LINUX_) then
            do i = 01, 08
               b(i) = buffb(i)
               enddo
            buffb(01) = b(04)
            buffb(02) = b(03)
            buffb(03) = b(02)
            buffb(04) = b(01)
            buffb(05) = b(08)
            buffb(06) = b(07)
            buffb(07) = b(06)
            buffb(08) = b(05)
            endif
         xcn(NABCD) = buffi(01)/100000.0
         ycn(NABCD) = buffi(02)/100000.0
         enddo
 
      xc = (1-fx)*(1-fy)*xcn(1)
     .   + ( fx )*(1-fy)*xcn(2)
     .   + (1-fx)*( fy )*xcn(3)
     .   + ( fx )*( fy )*xcn(4)
 
      yc = (1-fx)*(1-fy)*ycn(1)
     .   + ( fx )*(1-fy)*ycn(2)
     .   + (1-fx)*( fy )*ycn(3)
     .   + ( fx )*( fy )*ycn(4)
 
      return
 
 900  continue
      print*,'stdfits_gc file error: ',FILEI
      stop 'stop'
      end
 
 
 
c--------------------------------------------------
c TILE - TILE-SPECIFIC ROUTINES
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/add_art.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------
c
c
      subroutine add_art(Ns,pixv_n,pixe_n,pixu_n,psf_n,
     .                      xartu,yartu,zartu,sartu,
     .                      FFF_N,EXP_F,EXP_N,
     .                      UTAB_N,VTAB_N,XTAB_N,YTAB_N)
      implicit none
 
      integer Ns
      real    pixv_n(_TDIM_,_TDIM_,Ns)
      real    pixe_n(_TDIM_,_TDIM_,Ns)
      byte    pixu_n(_TDIM_,_TDIM_,Ns)
      real    psf_n(101,101,Ns)
      real    xartu, yartu
      real    zartu(_FDIM_)
      real    sartu(_FDIM_)
      integer FFF_N(Ns)
      real    EXP_F(_FDIM_)
      real    EXP_N(Ns)
      real    UTAB_N(_TTAB_,_TTAB_,Ns)    ! tabular-based transformations
      real    VTAB_N(_TTAB_,_TTAB_,Ns)    !
      real    XTAB_N(_TTAB_,_TTAB_,Ns)    !
      real    YTAB_N(_TTAB_,_TTAB_,Ns)    !
 
      integer   N
      integer   i,  j
      real      xt, yt
      real      xt_tuv
      real      yt_tuv
      real      dx, dy, dd
      real      sl(9999,_FDIM_)
      real      fl(9999,_FDIM_)
      real      rpsf_phot, psfu
      integer   Ls(_FDIM_)
      integer   Lu(_FDIM_)
      integer   F
      real      skybar
      real      skysig
      integer   L
      real      flxadd, sigadd, noiadd
      real      noise_sig
 
      logical   VERBOSE
      common   /VERBOSE_/VERBOSE
 
 
      do F = 1, _FDIM_
         Ls(F) = 0
         enddo
 
      do N = 1, Ns
         F  = FFF_N(N)
         xt = xt_tuv(xartu,yartu,XTAB_N(1,1,N),YTAB_N(1,1,N))
         yt = yt_tuv(xartu,yartu,XTAB_N(1,1,N),YTAB_N(1,1,N))
         do i = max(0001,int(xt-12.5)), min(_TDIM_,int(xt+12.5))
         do j = max(0001,int(yt-12.5)), min(_TDIM_,int(yt+12.5))
            if (pixu_n(i,j,N).eq.0) then
               dx = i-xt
               dy = j-yt
               dd = sqrt(dx**2+dy**2)
               psfu = rpsf_phot(dx,dy,psf_n(1,1,N))
               psfu = max(rpsf_phot(dx,dy,psf_n(1,1,N)),0.0)
               if (dd.lt.2.5) then
                  Ls(F) = Ls(F) + 1
                  if (Ls(F).gt.9999) stop 'Ls(F).gt.9999'
                  sl(Ls(F),F) = pixv_n(i,j,N)
                  fl(Ls(F),F) = psfu/pixe_n(i,j,N)**2
                  endif
               flxadd = psfu*zartu(F)
               sigadd = sqrt(EXP_F(F)/EXP_N(N))*sqrt(flxadd)
               noiadd = sigadd*noise_sig()
               if (_NONOISE_) noiadd = 0.00
               pixv_n(i,j,N) = pixv_n(i,j,N) + flxadd + noiadd
               endif
            enddo
            enddo
         enddo
 
      do F = 1, _FDIM_
         call barsigw(sl(1,F),fl(1,F),Ls(F),skybar,skysig,Lu(F),3.0)
         sartu(F) = skybar
         if (VERBOSE) print*,'---> F: ',F,sartu(F),skysig,Ls(F),Lu(F)
         enddo
 
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/find_loc_brite.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------------------
c
c This routine will make a local subset of the bright stars
c for the current tile, centered at (UREF_T,VREF_T).
c
      subroutine find_loc_brite(UREF_T,VREF_T,
     .                          Bs ,uref_b ,vref_b ,zref_bf,
     .                          BBs,uref_bb,vref_bb,zref_bbf)
      implicit none
 
      integer UREF_T, VREF_T
      integer Bs
      real*8  uref_b(_BDIM_)
      real*8  vref_b(_BDIM_)
      real    zref_bf(_BDIM_,_FDIM_)
 
      integer BBs
      real*8  uref_bb(_BDIM_)
      real*8  vref_bb(_BDIM_)
      real    zref_bbf(_BDIM_,_FDIM_)
 
      logical SHOW_TILE
      common /SHOW_TILE_/SHOW_TILE
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
c
c----------------------------------------------------------
c
      integer B, F, BB
 
      if (VERBOSE) write(*,'(''ENTER FIND_LOC_BRITE:  ...'')')
      BBs = 0
      do B = 1, Bs
         if ((uref_b(B)-UREF_T)**2
     .      +(vref_b(B)-VREF_T)**2.le.(_BRITE_DMAX_)**2) then
             BBs = BBs + 1
             if (BBs.gt._BDIM_) stop 'BBs.gt._BDIM_'
             uref_bb(BBs) = uref_b(B)
             vref_bb(BBs) = vref_b(B)
             do F = 1, _FDIM_
                zref_bbf(BBs,F) = zref_bf(B,F)
                enddo
             if ((BBs.le.10.or.BBs.eq.BBs/25*25).and.VERBOSE)
     .       write(*,11) BBs,B,
     .                   uref_bb(BBs), vref_bb(BBs),
     .                   (int(zref_bbf(BBs,F)),
     .                    -2.5*log10(max(zref_bbf(BBs,F),0.)),
     .                        F=1,_FDIM_)
   11        format(2x,i4.4,1x,i5,1x,
     .              5x,f8.1,1x,f8.1,1x,10(i10,1x,f7.3,2x))
             endif
         enddo
 
      if (SHOW_TILE) then
         open(44,file='AUX/SHOW_TILE_LOG.BRITE.000',
     .           status='unknown')
         do BB = 1, BBs
            write(44,144) _TCEN_+2*(uref_bb(BB)-UREF_T),
     .                    _TCEN_+2*(vref_bb(BB)-VREF_T),
     .                    zref_bbf(BB,1),
     .                    BB,
     .                    (int(zref_bbf(BB,F)),F=1,_FDIM_)
  144       format(3x,f8.2,1x,f8.2,1x,f9.1,1x,i5.5,1x,
     .                _FDIM_(i10))
            enddo
         close(44)
 
         open(44,file='AUX/SHOW_TILE_LOG.BRITE.reg',
     .           status='unknown')
         write(44,'(''# Region file format: DS9 version 3.0'')')
         write(44,'(''global color=yellow'')')
         do BB = 1, BBs
            write(44,112) _TCEN_+2*(uref_bb(BB)-UREF_T),
     .                    _TCEN_+2*(vref_bb(BB)-VREF_T),
     .                    2.5,'yellow',4
  112       format('linear;circle( ',f8.1,',',f8.1,
     .             ',',f6.3,') # color=',a7,' width=',i1)
            enddo
         close(44)
         endif
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/find_pixt.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c--------------------------------------------------------------------------
c
c
c
c
      subroutine find_pixt(Ns, pixv_n, pixt_n,
     .                         UTAB_N, VTAB_N, XTAB_N, YTAB_N)
      implicit none
 
      integer   Ns
      real      pixv_n(_TDIM_,_TDIM_,Ns)
      real      pixt_n(_TDIM_,_TDIM_,Ns)
 
      real      UTAB_N(31,31,Ns), VTAB_N(31,31,Ns)
      real      XTAB_N(31,31,Ns), YTAB_N(31,31,Ns)
 
c
c-------------------------------------------------------------------
c
      integer   N
      real*8    u,  v
      real*8    x,  y
      integer   i,  j
      integer   ii, jj
      real      xt_tuv
      real      yt_tuv
 
      print*,'ENTER stack_tile_rej...  Ns: ',Ns
 
      do i = 0001, _TDIM_
      do j = 0001, _TDIM_
         do N = 1, Ns
            pixt_n(i,j,N) = -500
            enddo
         enddo
         enddo
 
      do N = 1, Ns
         do i = 1, _TDIM_
         do j = 1, _TDIM_
            x = xt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
            y = yt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
            ii = x + 0.5
            jj = y + 0.5
            if (ii.ge.0001+1.and.ii.le._TDIM_-1.and.
     .          jj.ge.0001+1.and.jj.le._TDIM_-1) then
                pixt_n(i,j,N) = pixv_n(ii,jj,N)
                endif
            enddo
            enddo
         enddo
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/find_sky.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c---------------------------------------------------
c
c This routine will find an iteratively clipped mean sky
c value from an annulus about a point.  The point is (ixc,iyc).
c It will take the pixels between r=inr and r=ior and will
c analyze them for a robust average.
c
      subroutine find_sky(ixc,iyc,inr,ior,
     .                    pixv, pixu, pixo,
     .                    sbar, ssig, Su)
      implicit none
 
      integer  ixc, iyc
      integer  inr, ior
      real    pixv(_TDIM_,_TDIM_)
      byte    pixu(_TDIM_,_TDIM_)
      real    pixo(_TDIM_,_TDIM_)
      real    sbar, ssig
      integer Su
 
 
      integer i  , j
      integer ixh, iyh
      real    rij
      integer nuse
 
      logical inimage
      integer nsk
      real bar, sig
      real rmode_i2
 
      integer HIFLAG
      common / HIFLAG_ / HIFLAG
 
      integer LOFLAG
      common / LOFLAG_ / LOFLAG
 
      real*4, dimension(:), allocatable :: sklist
 
      allocate (sklist(999))
 
      nsk = 0
      do i = -ior+1, ior-1
      do j = -ior+1, ior-1
         rij = i**2+j**2
         if (rij.ge.ior**2) goto 333
         if (rij.lt.inr**2) goto 333
         ixh = ixc + i
         iyh = iyc + j
         if (ixh.lt. 0001 ) goto 333
         if (iyh.lt. 0001 ) goto 333
         if (ixh.gt._TDIM_) goto 333
         if (iyh.gt._TDIM_) goto 333
         if (pixu(ixh,iyh).ne.0) goto 333
         nsk = nsk + 1
         if (nsk.gt.999) goto 333
         sklist(nsk) = pixv(ixh,iyh)-pixo(ixh,iyh)
 333     continue
         enddo
         enddo
 
      call find_sky_barsig(sklist,nsk,sbar,ssig,Su,2.25)
 
      deallocate(sklist)
      return
      end
 
 
 
 
c-----------------------------------------------------------
c
c
c
      subroutine find_sky_barsig(xlist,NTOT,bar,sig,NUSE,SIGCLIP)
      implicit none
 
      integer NTOT
      real xlist(NTOT)
      real bar
      real sig
      integer NUSE
      real SIGCLIP
 
      integer n
      real*8  bsum, ssum
      integer nsum, nsumo
      integer NIT
 
 
      nsum = 0
      bar = 0.e0
      sig = 9e9
      do NIT = 1, 20
         nsumo = nsum
         bsum = 0.
         ssum = 0.
         nsum = 0.
         do n = 1, NTOT
            if (abs(xlist(n)-bar).le.SIGCLIP*sig) then
               bsum = bsum + xlist(n)
               ssum = ssum + abs(xlist(n)-bar)
               nsum = nsum + 1
               endif
            enddo
         if (nsum.gt.0) bar = bsum / nsum
         if (nsum.gt.1) sig = ssum/(nsum-1)
         if (nsum.lt.0.35*NTOT.and.NIT.ge.3) return
         if (nsum.eq.nsumo.and.NIT.ge.3) goto 1
         enddo
  1   continue
      NUSE = nsum
      if (nsum.le.1) sig = 0.999
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/find_tile.f"
c****                                         
c*********************************************
                                              
*********************************************
 
c--------------------------------------------
c WHYNO CODES
c--------------------------------------------
c 00 - out of the zone
c ----------------------------- qualifies to be searched
c 01 - too close to previous
c 02 - hmin disqualified (not enough of a local maximum)
c 03 - within r=4 of a pixel that is more neg than this is positive (?)
c 04 - potential star is below mask
c 05 - potential star is below other
c 06 - skysig reject
c 07 - FOUND!!!
c
c--------------------------------------------
 
 
c----------------------------------------------------------------------
c
c this particular version will focus on position coincidence
c
      subroutine find_tile(Ls,ul,vl,wfnd_l,yfnd_l,
     .                        ufnd_l,vfnd_l,
     .                        cfnd_l,
     .                        qmin_l,qfnd_l,
     .                        dmin_l,dfnd_l,
     .                        pmin_l,pfnd_l,
     .                     NIT,iumin1,iumax1,ivmin1,ivmax1,
     .                     Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                         FFF_n, FND_n, MSK_n, OTH_n,
     .                         pixv_n, pixd_n, pixf_n,
     .                         pixe_n, pixm_n, pixu_n, psf_n,
     .                         stackp_x1,stackq_x1,stackd_x1,
     .                         stacky_x1,stackc_x1,
     .                     IT)
      implicit none
 
      integer Ls
      real    ul(_LDIM_)
      real    vl(_LDIM_)
      integer wfnd_l(_LDIM_)
      integer yfnd_l(_LDIM_)                       ! why was this found?
      real    ufnd_l(_LDIM_), vfnd_l(_LDIM_)
      integer cfnd_l(_LDIM_)
      integer qmin_l(_LDIM_), qfnd_l(_LDIM_)   ! info on the q-based finding criteria
      integer dmin_l(_LDIM_), dfnd_l(_LDIM_)   ! info on the d-based finding criteria
      integer pmin_l(_LDIM_), pfnd_l(_LDIM_)   ! info on the p-based finding criteria
 
      integer   NIT
      integer   iumin1, iumax1, ivmin1, ivmax1
 
      integer   Ns
 
      real        UTAB_N(_TTAB_,_TTAB_,Ns)
      real        VTAB_N(_TTAB_,_TTAB_,Ns)
      real        XTAB_N(_TTAB_,_TTAB_,Ns)
      real        YTAB_N(_TTAB_,_TTAB_,Ns)
      integer     FFF_N(Ns)
      character*9 FND_N(Ns)
      real        MSK_N(Ns), OTH_N(Ns)
 
      real      pixv_n(_TDIM_,_TDIM_,Ns)
      real      pixd_n(_TDIM_,_TDIM_,Ns)
      real      pixf_n(_TDIM_,_TDIM_,Ns)
      real      pixe_n(_TDIM_,_TDIM_,Ns)
      real      pixm_n(_TDIM_,_TDIM_,Ns)
      byte      pixu_n(_TDIM_,_TDIM_,Ns)
 
      real      psf_n(101,101,Ns)
 
      integer*2 stackp_x1(_TDIM_,_TDIM_)
      integer*2 stackq_x1(_TDIM_,_TDIM_)
      integer*2 stackd_x1(_TDIM_,_TDIM_)
      integer*2 stacky_x1(_TDIM_,_TDIM_)
      integer*2 stackc_x1(_TDIM_,_TDIM_)
      integer   IT
c
c---------------------------------------------------------------------------
c
 
c------------------------------
c
 
      integer nprox
      real    dprox
 
      integer   iumin4, iumax4, ivmin4, ivmax4
 
      byte      bn
 
      integer   findp_uvz
      integer   findp_uv
      real      umsum, vmsum
      integer   nmsum
 
      integer L, LL
      integer Lo ! the initial number of sources
      integer N
      integer i,  j
      integer ii, jj
      integer i1, j1, di,  dj,  dmax
      integer i4, j4, i4u, j4u
      integer iii,jjj
      integer iu, ju
      integer ih, jh
      integer h,  hh
      real    fx, fy
      real    x,  y, dd
      real    u,  v
      integer o
      integer iv
 
      integer M, Ms, Mo, MMs
      real    imbar,  jmbar
 
      real    xt, xt_tuv
      real    yt, yt_tuv
      real*8  uu_tuv
      real*8  vv_tuv
 
 
      real xx, yy
      real F1, F2, F3, F4, FMAX, SMAX
      real FTOT, STOT
      integer add
      logical realmax
      real xr, yr
      real xoptu, yoptu, zoptu, soptu, qoptu, coptu
      logical pk
 
      real ut, ut_txy, ut_ij
      real vt, vt_txy, vt_ij
 
      real utu, uminl, umaxl
      real vtu, vminl, vmaxl
 
      character*80 FITSO
      character*80 FILEO
 
 
      integer ii0, jj0
      real    rclip
c
c------------------------------
c
      integer  HNITU
 
      integer HMIN_NIT(10)
      real    SSIG_NIT(10)
 
      real    QSEP_NIT(10)
      integer QMIN_NIT(10)
      real    QSEL_NIT(10)
 
      real    DSEP_NIT(10)
      integer DMIN_NIT(10)
 
      real    PSEP_NIT(10)
      integer PMIN_NIT(10)
 
      real    OPRX_NIT(10)
      real    OPRV_NIT(10)
c
c------------------------------
c
      common /HMIN_NIT/HMIN_NIT
      common /SSIG_NIT/SSIG_NIT
 
      common /QMIN_NIT/QMIN_NIT
      common /QSEP_NIT/QSEP_NIT
      common /QSEL_NIT/QSEL_NIT
 
      common /DSEP_NIT/DSEP_NIT
      common /DMIN_NIT/DMIN_NIT
 
      common /PMIN_NIT/PMIN_NIT
      common /PSEP_NIT/PSEP_NIT
 
      common /OPRX_NIT/OPRX_NIT
      common /OPRV_NIT/OPRV_NIT
c
c------------------------------
c
      integer qreq_n
      integer preq_n
      integer pminu, pmina, pminb
      integer qminu, qmina, qminb
      integer dminu, dmina, dminb
 
 
      integer YNEW
      integer NNEWs
      real    ubar, vbar
c
c------------------------------
c
 
      real ri, rj
 
      integer whyno
      integer id
 
      logical VERBOSEU
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
      logical SHOW_TILE
      common /SHOW_TILE_/SHOW_TILE
 
      logical SHOW_TILES
      common /SHOW_TILES_/SHOW_TILES
 
      real    MASKFAC
      common /MASKFAC_/MASKFAC
      real    OTHRFAC
      common /OTHRFAC_/OTHRFAC
 
      real skysig, skybar
      byte   b
      real   d
      real   tbar
      integer*4 i2_tot_1201
      integer*4 bsum
      integer iy, ytot
c
c-----------------------------------------------
c
c     logical FIND_DUMP
c     common /FIND_DUMP_/FIND_DUMP
c     data    FIND_DUMP/.false./
c
c-----------------------------------------------
 
      byte      , dimension(:,:),   allocatable :: stacka_x1
      integer*2 , dimension(:,:),   allocatable :: tallyq_x4 ! raw version of stackq
      integer*2 , dimension(:,:),   allocatable :: tallyd_x4 ! raw version of stackd
      integer*2 , dimension(:,:),   allocatable :: tallyp_x4 ! raw version of stackp
      integer*2 , dimension(:,:,:), allocatable :: tallyy_x4 ! raw version of stacky
      integer*2 , dimension(:,:),   allocatable :: stackq_x4 ! convolved version of stackq
      integer*2 , dimension(:,:),   allocatable :: stackd_x4 ! convolved version of stackd
      integer*2 , dimension(:,:),   allocatable :: stackp_x4 ! convolved version of stackp
      integer*2 , dimension(:,:),   allocatable :: stacky_x4 ! convolved version of stackp
      integer*2 , dimension(:,:),   allocatable :: stackz_x4 ! convolved version of stackp
      byte      , dimension(:,:),   allocatable :: pkmapn
      byte      , dimension(:,:),   allocatable :: stack_prev
      real*4    , dimension(:)  ,   allocatable :: utl
      real*4    , dimension(:)  ,   allocatable :: vtl
      integer*4 , dimension(:)  ,   allocatable :: im, jm, qm
      real*4    , dimension(:)  ,   allocatable :: skyl
      integer*2 , dimension(:,:),   allocatable :: covg_x4
      integer*2 , dimension(:,:),   allocatable :: pmin_x4
 
c
c-----------------------------------------------
c
      allocate(stacka_x1(0301,0301))
      allocate(tallyq_x4(1201,1201))    ! raw version of tallyq
      allocate(tallyd_x4(1201,1201))    ! raw version of tallyd
      allocate(tallyp_x4(1201,1201))    ! raw version of tallyp
      allocate(tallyy_x4(1201,1201,7)) ! raw version of tallyy
      allocate(stackq_x4(1201,1201))    ! convolved version of stackq
      allocate(stackd_x4(1201,1201))    ! convolved version of stackd
      allocate(stackp_x4(1201,1201))    ! convolved version of stackp
      allocate(stacky_x4(1201,1201))
      allocate(stackz_x4(1201,1201))
      allocate(pkmapn(_TDIM_,_TDIM_))
      allocate(stack_prev(_TDIM_,_TDIM_))
      allocate(utl(4))
      allocate(vtl(4))
      allocate(im(_LDIM_), jm(_LDIM_), qm(_LDIM_))
      allocate(skyl(16))
      allocate(pmin_x4(1201,1201))
      allocate(covg_x4(1201,1201))
 
      do i = 0001, 1201
      do j = 0001, 1201
         tallyq_x4(i,j) = 0
         tallyd_x4(i,j) = 0
         tallyp_x4(i,j) = 0
         stackq_x4(i,j) = 0
         stackd_x4(i,j) = 0
         stackp_x4(i,j) = 0
         do iy = 1, 07
            tallyy_x4(i,j,iy) = 0
            enddo
         pmin_x4(i,j) = 999
         covg_x4(i,j) =   0
         enddo
         enddo
 
      VERBOSEU = VERBOSE.and.IT.eq.31
      VERBOSEU = .false.
 
      if (_TDIM_.ne.301) stop 'find_tile_NOQ tied to _TDIM_ = 301'
 
      if ((.false.).and.NIT.eq.1) then
         do i1 = iumin1, iumax1
         do j1 = ivmin1, ivmax1
            do N = 1, Ns
               xt  = xt_tuv(i1*1.,j1*1.,XTAB_N(1,1,N),YTAB_N(1,1,N))
               yt  = yt_tuv(i1*1.,j1*1.,XTAB_N(1,1,N),YTAB_N(1,1,N))
               ii0 = int(xt+0.5)
               jj0 = int(yt+0.5)
               if (ii0.ge.001.and.ii0.le._TDIM_.and.
     .             jj0.ge.001.and.jj0.le._TDIM_) then
                      write(44,144) i1,j1,N,ii0,jj0,
     .                              pixv_n(ii0,jj0,N),
     .                              pixd_n(ii0,jj0,N),
     .                              pixf_n(ii0,jj0,N),
     .                              pixe_n(ii0,jj0,N),
     .                              pixm_n(ii0,jj0,N),
     .                              pixu_n(ii0,jj0,N)
  144                 format(1x,i3.3,1x,i3.3,
     .                       3x,i2.2,1x,i4,1x,i4,
     .                       3x,f8.1,1x,f8.1,1x,f8.1,
     .                       3x,f8.1,1x,f8.1,1x,i1)
                   else
                      write(44,144) i1,j1,N,ii0,jj0
                   endif
               enddo
            enddo
            enddo
         close(44)
         stop
         endif
 
      if (VERBOSEU) then
         write(*,'(a6,90f8.1)') 'pixv_n',(tbar(pixv_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixd_n',(tbar(pixd_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixf_n',(tbar(pixf_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixe_n',(tbar(pixe_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixm_n',(tbar(pixm_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90i8.1)') 'pixu_n',(bsum(pixu_n(1,1,N)),N=1,Ns)
         endif
 
      iumin4 = max(601+(iumin1-151)*4,0001)
      iumax4 = min(601+(iumax1-151)*4,1201)
      ivmin4 = max(601+(ivmin1-151)*4,0001)
      ivmax4 = min(601+(ivmax1-151)*4,1201)
 
      HNITU = HMIN_NIT(NIT)
 
      if (VERBOSEU) then
         print*,'                      '
         print*,'  ---> find_tile NIT: ',NIT
         print*,'                HNIT: ',HNITU
         print*,'             MASKFAC: ',MASKFAC
         print*,'             OTHRFAC: ',OTHRFAC
         print*,'           SHOW_TILE: ',SHOW_TILE,SHOW_TILES
         print*,'                  Ls: ',Ls
         print*,'              iumnx1: ',iumin1,iumax1
         print*,'              ivmnx1: ',ivmin1,ivmax1
         print*,'                 ST : ',SHOW_TILE
         print*,'                 STs: ',SHOW_TILES
         print*,'                   Q: ',QMIN_NIT(NIT),QSEP_NIT(NIT),
     .                                   4*QSEP_NIT(NIT)+0.5,
     .                                   QSEL_NIT(NIT)
         print*,'                   D: ',DMIN_NIT(NIT),DSEP_NIT(NIT),
     .                                   4*DSEP_NIT(NIT)+0.5
         print*,'                   P: ',PMIN_NIT(NIT),PSEP_NIT(NIT),
     .                                   4*PSEP_NIT(NIT)+0.5
         print*,'                      '
         endif
 
c*******************************************************************
c*******************************************************************
c*****
c*****  STAGE 0: INITIALIZE ARRAYS
c*****
c*******************************************************************
c*******************************************************************
 
 
 
c
c mark out the places in the field where things have
c already been found ; don't want to find overlapping
c objects ; these are half-pixels in reality, so we're
c only saying things have to be at least 0.5 pix apart,
c give or take
c
      if (VERBOSEU) print*,'stage0: zero things out...',NIT
      do i = 0001, _TDIM_
      do j = 0001, _TDIM_
         stack_prev(i,j) = 0
         enddo
         enddo
      do L = 1, Ls
         ii = int(ul(L)+0.5)
         jj = int(vl(L)+0.5)
         do i = -9, 9
         do j = -9, 9
            if (i+ii.ge.001.and.i+ii.le._TDIM_.and.
     .          j+jj.ge.001.and.j+jj.le._TDIM_) then
                dd = sqrt(1.*(i**2+j**2))/2.0                       ! in real pixels
                if (dd.le.OPRX_NIT(NIT)) stack_prev(i+ii,j+jj) = 1
                if (NIT.le.wfnd_l(L)+1.and.
     .              dd.le.OPRV_NIT(NIT)) stack_prev(i+ii,j+jj) = 1
                endif
            enddo
            enddo
         enddo
 
 
      if (VERBOSEU) print*,'--a-> '
      do i = 0001, _TDIM_
      do j = 0001, _TDIM_
         stackp_x1(i,j) = 0
         stackc_x1(i,j) = 0
         stackq_x1(i,j) = 0
         stackd_x1(i,j) = 0
         stacky_x1(i,j) = 0
         enddo
         enddo
 
      if (VERBOSEU) print*,'--b-> ',iumin4,iumax4,ivmin4,ivmax4
      do i = max(iumin4-8,0001), min(iumax4+8,1201)
      do j = max(ivmin4-8,0001), min(ivmax4+8,1201)
         tallyp_x4(i,j) = 0
         tallyq_x4(i,j) = 0
         tallyd_x4(i,j) = 0
         stackp_x4(i,j) = 0
         stackq_x4(i,j) = 0
         stackd_x4(i,j) = 0
         stacky_x4(i,j) = 0
         do iy = 1, 07
            tallyy_x4(i,j,iy) = 0
            enddo
         enddo
         enddo
      if (VERBOSEU) print*,'--c-> '
 
 
 
c*******************************************************************
c*******************************************************************
c*****
c*****  STAGE 1: GO THRU EACH IMAGE AND IDENTIFY POSSIBLE STARS
c*****
c*******************************************************************
c*******************************************************************
 
      Lo = Ls ! the initial number of sources
 
 
      if (VERBOSEU) print*,'stage1: find peaks in individual images...'
      do N = 1, Ns
 
         if (FND_N(N)(NIT:NIT).eq.'0') goto 9   ! image not to be used for fndg
         do i = iumin4, iumax4
         do j = ivmin4, ivmax4
            stacky_x4(i,j) = 0
            enddo
            enddo
 
         do i = 001+5, _TDIM_-5
         do j = 001+5, _TDIM_-5
 
            i4 = 1
            j4 = 1
            pkmapn(i,j) = 0
 
            xoptu = i
            yoptu = j
            zoptu = 0.00
            soptu = 0.00
            qoptu = 1.00
 
            whyno = 0
            ut = ut_txy(i*1.,j*1.,UTAB_N(1,1,N),VTAB_N(1,1,N))
            if (ut.le. iumin1) goto 3
            if (ut.ge. iumax1) goto 3
 
            vt = vt_txy(i*1.,j*1.,UTAB_N(1,1,N),VTAB_N(1,1,N))
            if (vt.le. ivmin1) goto 3
            if (vt.ge. ivmax1) goto 3
 
            ut_ij = ut
            vt_ij = vt
 
            ii0 = int(ut+0.5)
            jj0 = int(vt+0.5)
            if (ii0.lt.iumin1) goto 3
            if (jj0.lt.ivmin1) goto 3
            if (ii0.gt.iumax1) goto 3
            if (jj0.gt.ivmax1) goto 3
 
            if (pixu_n(i  ,j  ,n).ne.0) goto 3  ! not near bad pixels
            do ii = i-2, i+2
            do jj = j-2, j+2
               if (pixu_n(ii,jj,n).ne.0) goto 3
               enddo
               enddo
 
            i4 = 1 + (ut-1)*4
            j4 = 1 + (vt-1)*4
            if (i4.lt.0001) goto 3
            if (i4.gt.1201) goto 3
            if (j4.lt.0001) goto 3
            if (j4.gt.1201) goto 3
 
            if (i4.le.iumin4) goto 3
            if (j4.le.ivmin4) goto 3
            if (i4.ge.iumax4) goto 3
            if (j4.ge.ivmax4) goto 3
 
            whyno = 1
            pkmapn(i,j) = 1                          ! could contain star
            if (stack_prev(ii0,jj0).ne.0) goto 3
 
            whyno = 2
            do ii = -HNITU, HNITU, 1
            do jj = -HNITU, HNITU, 1
               if (ii**2+jj**2.le.(HNITU+0.5)**2) then
                  if (pixd_n(i+ii,j+jj,n).gt.pixd_n(i,j,n)) goto 3
                  if (pixu_n(i+ii,j+jj,n).ne.0) goto 3
                  endif
               enddo
               enddo
 
            whyno = 3
            do ii = -4, 4, 1
            do jj = -4, 4, 1
               if (ii**2+jj**2.le.(4+0.5)**2) then
                  if (pixd_n(i+ii,j+jj,n).lt.-pixd_n(i,j,n)) goto 3
                  endif
               enddo
               enddo
 
            FMAX = 0.               ! poor man's apphot ; find max in
            SMAX = 0.
            do ii = -1, 1, 2        ! 2x2 pixels, then find local sky
            do jj = -1, 1, 2        ! used for
               FTOT = pixd_n(i   ,j   ,N)
     .              + pixd_n(i+ii,j   ,N)
     .              + pixd_n(i   ,j+jj,N)
     .              + pixd_n(i+ii,j+jj,N)
               STOT = pixd_n(i-  ii,j-  jj,N)
     .              + pixd_n(i     ,j-  jj,N)
     .              + pixd_n(i+  ii,j-  jj,N)
     .              + pixd_n(i+2*ii,j-  jj,N)
     .              + pixd_n(i+2*ii,j     ,N)
     .              + pixd_n(i+2*ii,j+  jj,N)
     .              + pixd_n(i+2*ii,j+2*jj,N)
     .              + pixd_n(i+  ii,j+2*jj,N)
     .              + pixd_n(i     ,j+2*jj,N)
     .              + pixd_n(i-  ii,j+2*jj,N)
     .              + pixd_n(i-  ii,j+  jj,N)
     .              + pixd_n(i-  ii,j     ,N)
               if (FTOT.gt.FMAX) then
                  FMAX = FTOT
                  SMAX = STOT/12.0
                  endif
               enddo
               enddo
 
            FTOT = FMAX
            STOT = SMAX
            FMAX = FTOT-4*STOT
 
            whyno = 4
            if (FMAX.le.MSK_N(N)*pixm_n(i,j,N)) goto 3 ! at least 2x mask
 
            whyno = 5
            if (FMAX.le.OTH_N(N)*pixf_n(i,j,N)) goto 3 ! at least 2x other
 
 
            ut = ut_txy(i*1.0,j*1.0,UTAB_N(1,1,N),VTAB_N(1,1,N))
            vt = vt_txy(i*1.0,j*1.0,UTAB_N(1,1,N),VTAB_N(1,1,N))
 
c
c let's measure a sky/rmssky
c
            whyno = 6
            skyl(01) = pixd_n(i-2,j-2,n)
            skyl(02) = pixd_n(i-2,j-1,n)
            skyl(03) = pixd_n(i-2,j  ,n)
            skyl(04) = pixd_n(i-2,j+1,n)
            skyl(05) = pixd_n(i-2,j+2,n)
            skyl(06) = pixd_n(i-1,j+2,n)
            skyl(07) = pixd_n(i  ,j+2,n)
            skyl(08) = pixd_n(i+1,j+2,n)
            skyl(09) = pixd_n(i+2,j+2,n)
            skyl(10) = pixd_n(i+2,j+1,n)
            skyl(11) = pixd_n(i+2,j  ,n)
            skyl(12) = pixd_n(i+2,j-1,n)
            skyl(13) = pixd_n(i+2,j-2,n)
            skyl(14) = pixd_n(i+1,j-2,n)
            skyl(15) = pixd_n(i  ,j-2,n)
            skyl(16) = pixd_n(i-1,j-2,n)
            call rbubble(skyl,16)
            skysig = (skyl(13)-skyl(04))/2.0
            skybar = (skyl(08)+skyl(09))/2.0
            if (FTOT-4*skybar.lt.SSIG_NIT(NIT)*skysig) goto 3
 
            whyno = 7 ! it was found!!
 
c------------------------------------------
c
c get a sense of how PSF-like the source is
c
            tallyp_x4(i4,j4) = tallyp_x4(i4,j4) + 1
            call find_qopt(i,j,pixd_n(1,1,N),pixe_n(1,1,N),         ! find a refined position
     .                         psf_n(1,1,N),                        !    in the raw frame, using PSF
     .                         xoptu,yoptu,zoptu,soptu,qoptu,coptu)
            ut = ut_txy(xoptu,yoptu,UTAB_N(1,1,N),VTAB_N(1,1,N))    ! transform this raw position into
            vt = vt_txy(xoptu,yoptu,UTAB_N(1,1,N),VTAB_N(1,1,N))    !    the reference frame
            i4u = 1 + (ut-1)*4 + 0.5                                ! map to tallyidual x4 (really x8) supsam frame
            j4u = 1 + (vt-1)*4 + 0.5
            if (i4u.ge.iumin4.and.i4u.le.iumax4.and.
     .          j4u.ge.ivmin4.and.j4u.le.ivmax4) then
                tallyd_x4(i4u,j4u) = tallyd_x4(i4u,j4u) + 1
                if (qoptu.gt.QSEL_NIT(NIT)) then
                   tallyq_x4(i4u,j4u) = tallyq_x4(i4u,j4u) + 1
                   endif
                endif
 
    3       continue
            id = 4*PSEP_NIT(NIT) + 1
            do ii = -id, id
            do jj = -id, id
               if (ii**2+jj**2.le.(id+0.5)**2) then
                  i4u = i4 + ii
                  j4u = j4 + jj
                  if (i4u.ge.iumin4.and.i4u.le.iumax4.and.
     .                j4u.ge.ivmin4.and.j4u.le.ivmax4) then
                      if (stacky_x4(i4u,j4u).lt.whyno)
     .                    stacky_x4(i4u,j4u) =  whyno
                      endif
                  endif
               enddo
               enddo
            enddo
            enddo
 
c----------------------------------------------------------
c
c take stock of how many pixels a star could have been found in
c
         do i1 = iumin1, iumax1 ! go thu ref frame and det the #
         do j1 = ivmin1, ivmax1 !   of imgs avail in the field & # of pks
            xt  = xt_tuv(i1*1.,j1*1.,XTAB_N(1,1,N),YTAB_N(1,1,N))
            yt  = yt_tuv(i1*1.,j1*1.,XTAB_N(1,1,N),YTAB_N(1,1,N))
            ii0 = int(xt+0.5)
            jj0 = int(yt+0.5)
            if (ii0.ge.1.and.ii0.le._TDIM_.and.
     .          jj0.ge.1.and.jj0.le._TDIM_)
     .          stackc_x1(i1,j1) = stackc_x1(i1,j1) + pkmapn(ii0,jj0)
            enddo
            enddo
 
         do i4 = iumin4, iumax4
         do j4 = ivmin4, ivmax4
            if (stacky_x4(i4,j4).ge.1.and.stacky_x4(i4,j4).le.07)
     .         tallyy_x4(i4,j4,stacky_x4(i4,j4)) =
     .         tallyy_x4(i4,j4,stacky_x4(i4,j4)) + 1
            enddo
            enddo
 
    9    continue ! come here if not to use image#N for finding...
         enddo!N
 
 
      if (.false.) then
         do iy = 1, 07
            write(FILEO,'(''tallyy_x4_'',i2.2,''.fits'')') iy
            call writfits_i2_ltv(FILEO,tallyy_x4(1,1,iy),1201,1201,4.)
            enddo
         endif
 
 
c*******************************************************************
c*******************************************************************
c*****
c*****  STAGE 2: ADD UP OBSERVED PEAKS
c*****
c*******************************************************************
c*******************************************************************
 
      if (VERBOSEU) print*,'stage2: down-bin to x1...'
 
c     if (DSEP_NIT(NIT).gt.0.5) stop 'DSEP_NIT.gt.0.5 nonsense'
 
 
c----------------------------------------------------------------------
c
c convolve the super-duper sampled maps with the appropriate flat
c kernel to add up the number of observations within the desired
c radius
c
      id = 4*QSEP_NIT(NIT)+0.5                            ! map the separation into x4x2 pixels = x8 pixels...
      do i4 = max(iumin4-8,0001+5), min(iumax4+8,1201-5)
      do j4 = max(ivmin4-8,0001+5), min(ivmax4+8,1201-5)
         if (tallyq_x4(i4,j4).gt.0) then
            do i = -id, +id
            do j = -id, +id
               if (i**2+j**2.le.(id+0.5)**2) then
                  i4u = i4+i
                  j4u = j4+j
                  if (i4u.ge.iumin4.and.i4u.le.iumax4.and.
     .                j4u.ge.ivmin4.and.j4u.le.ivmax4) then
                      stackq_x4(i4u,j4u) = stackq_x4(i4u,j4u)+
     .                                     tallyq_x4(i4 ,j4 )
                      endif
                  endif
               enddo
               enddo
            endif
         enddo
         enddo
 
      id = 4*DSEP_NIT(NIT)+0.5
      do i4 = max(iumin4-8,0001+5), min(iumax4+8,1201-5)
      do j4 = max(ivmin4-8,0001+5), min(ivmax4+8,1201-5)
         if (tallyd_x4(i4,j4).gt.0) then
            do i = -id, +id
            do j = -id, +id
               if (i**2+j**2.le.(id+0.5)**2) then
                  i4u = i4+i
                  j4u = j4+j
                  if (i4u.ge.iumin4.and.i4u.le.iumax4.and.
     .                j4u.ge.ivmin4.and.j4u.le.ivmax4) then
                      stackd_x4(i4u,j4u) = stackd_x4(i4u,j4u)+
     .                                     tallyd_x4(i4 ,j4 )
                      endif
                  endif
               enddo
               enddo
            endif
         enddo
         enddo
 
      id = 4*PSEP_NIT(NIT)+0.5
      do i4 = max(iumin4-8,0001+5), min(iumax4+8,1201-5)
      do j4 = max(ivmin4-8,0001+5), min(ivmax4+8,1201-5)
         if (tallyp_x4(i4,j4).gt.0) then
            do i = -id, +id
            do j = -id, +id
               if (i**2+j**2.le.(id+0.5)**2) then
                  i4u = i4+i
                  j4u = j4+j
                  if (i4u.ge.iumin4.and.i4u.le.iumax4.and.
     .                j4u.ge.ivmin4.and.j4u.le.ivmax4) then
                      stackp_x4(i4u,j4u) = stackp_x4(i4u,j4u)+
     .                                     tallyp_x4(i4 ,j4 )
                      endif
                  endif
               enddo
               enddo
            endif
         enddo
         enddo
 
c----------------------------------------------------------------------
c
c
c
      do i1 = iumin1, iumax1
      do j1 = ivmin1, ivmax1
         i4 = 1 + (i1-1)*4
         j4 = 1 + (j1-1)*4
         stackp_x1(i1,j1) = stackp_x4(i4,j4)
         stackq_x1(i1,j1) = stackq_x4(i4,j4)
         stackd_x1(i1,j1) = stackd_x4(i4,j4)
         do ii = max(0001,i4-2), min(1201,i4+2)
         do jj = max(0001,j4-2), min(1201,j4+2)
            if (stackp_x1(i1,j1).lt.stackp_x4(ii,jj)) then
                stackp_x1(i1,j1) =  stackp_x4(ii,jj)
                endif
            if (stackq_x1(i1,j1).lt.stackq_x4(ii,jj)) then
                stackq_x1(i1,j1) =  stackq_x4(ii,jj)
                endif
            if (stackd_x1(i1,j1).lt.stackd_x4(ii,jj)) then
                stackd_x1(i1,j1) =  stackd_x4(ii,jj)
                endif
            enddo
            enddo
         enddo
         enddo
 
      if (SHOW_TILES) then
        if (VERBOSEU) then
            print*,'stage2: show_tile fits output...'
            endif
        write(FILEO,997) 'tallyq',4,NIT
        call writfits_i2_ltv(FILEO,tallyq_x4,1201,1201,4.)
        write(FILEO,997) 'tallyd',4,NIT
        call writfits_i2_ltv(FILEO,tallyd_x4,1201,1201,4.)
        write(FILEO,997) 'tallyp',4,NIT
        call writfits_i2_ltv(FILEO,tallyp_x4,1201,1201,4.)
 
        write(FILEO,997) 'stackq',4,NIT
        call writfits_i2_ltv(FILEO,stackq_x4,1201,1201,4.)
        write(FILEO,997) 'stackd',4,NIT
        call writfits_i2_ltv(FILEO,stackd_x4,1201,1201,4.)
        write(FILEO,997) 'stackp',4,NIT
        call writfits_i2_ltv(FILEO,stackp_x4,1201,1201,4.)
 
        write(FILEO,997) 'stackc',1,NIT
        call writfits_i2_ltv(FILEO,stackc_x1,0301,0301,1.)
 
        write(FILEO,997) 'stackq',1,NIT
        call writfits_i2_ltv(FILEO,stackq_x1,0301,0301,1.)
        write(FILEO,997) 'stackd',1,NIT
        call writfits_i2_ltv(FILEO,stackd_x1,0301,0301,1.)
        write(FILEO,997) 'stackp',1,NIT
        call writfits_i2_ltv(FILEO,stackp_x1,0301,0301,1.)
  997   format('AUX/FIND_TILE_',a6,'_x',i1,'_NIT',i1,'.fits')
        endif
 
 
 
c*******************************************************************
c*******************************************************************
c*****
c***** STAGE 3:  ONCE POTENTIAL STARS HAVE BEEN FOUND IN EACH
c*****           IMAGE, COLLATE THEM TOGETHER TO SEE WHETHER WE
c*****           HAVE ENOUGH INDEPENDENT DETECTIONS TO DECLARE
c*****           DISCOVERY
c*****
c*******************************************************************
c*******************************************************************
 
      if (VERBOSEU) print*,'stage3: collate'
 
      do i1 = max(0001,iumin1), min(301,iumax1)
      do j1 = max(0001,ivmin1), min(301,ivmax1)
         stacka_x1(i1,j1) = 0                               ! flag whether this pixel has already been
         enddo                                              !    associated with a star this wave
         enddo
 
      NNEWs = 0
      do i1 = max(0001+3,iumin1), min(0301-3,iumax1)        ! go thru the reference frame and
      do j1 = max(0001+3,ivmin1), min(0301-3,ivmax1)        ! identify pixels
 
         pminu = 999
         if (stacka_x1(i1,j1).ne.0) goto 1333 ! do no more
 
         YNEW = 0
         qminu = max(qreq_n(stackc_x1(i1,j1)),QMIN_NIT(NIT))
         if (YNEW.eq.0.and.stackq_x1(i1,j1).ge.qminu) then  ! this qualifies as a find based
            pk = .true.                                     ! on lg number of quality peaks
            do di = -3, 3
            do dj = -3, 3
               if (di**2+dj**2.le.3.5**2.and.
     .             stackq_x1(i1+di,j1+dj).gt.stackq_x1(i1,j1))pk=.false.
               enddo
               enddo
            if (pk) then
               i4 = 1 + (i1-1)*4
               j4 = 1 + (j1-1)*4
               id = 4*QSEP_NIT(NIT)+0.5
               call find_ubarvbar(ubar,vbar,
     .                            i1,j1,
     .                            i4,j4,id,
     .                            stackq_x1,
     .                            tallyq_x4,
     .                            stackq_x4,'q')
               YNEW = 1
               endif
            endif
 
         dminu = 99
         if (stackc_x1(i1,j1).eq.2) dminu = 2
         if (stackc_x1(i1,j1).eq.3) dminu = 2
         if (stackc_x1(i1,j1).eq.4) dminu = 3
         if (stackc_x1(i1,j1).eq.5) dminu = 3
         if (stackc_x1(i1,j1).eq.6) dminu = 3
         if (stackc_x1(i1,j1).ge.7) dminu = 1+stackc_x1(i1,j1)/2
         dminu = max(dminu,DMIN_NIT(NIT))
         if (YNEW.eq.0.and.stackd_x1(i1,j1).ge.dminu) then  ! qualifies based on close peaks
            pk = .true.
            do di = -3, 3
            do dj = -3, 3
               if (di**2+dj**2.le.3.5**2.and.
     .             stackd_x1(i1+di,j1+dj).gt.stackd_x1(i1,j1))pk=.false.
               enddo
               enddo
            if (pk) then
               i4 = 1 + (i1-1)*4
               j4 = 1 + (j1-1)*4
               id = 4*DSEP_NIT(NIT)+0.5
               call find_ubarvbar(ubar,vbar,
     .                            i1,j1,
     .                            i4,j4,id,
     .                            stackd_x1,
     .                            tallyd_x4,
     .                            stackd_x4,'d')
               YNEW = 2
               endif
            endif
 
         pminu = max(preq_n(stackc_x1(i1,j1)),PMIN_NIT(NIT))
         if (YNEW.eq.0.and.stackp_x1(i1,j1).ge.pminu) then  ! this qualifies as a find based
            pk = .true.                                     !    on large number of peaks
            do di = -3, 3
            do dj = -3, 3
               if (di**2+dj**2.le.3.5**2.and.
     .             stackp_x1(i1+di,j1+dj).gt.stackp_x1(i1,j1))pk=.false.
               enddo
               enddo
            if (pk) then
               i4 = 1 + (i1-1)*4
               j4 = 1 + (j1-1)*4
               id = 4*PSEP_NIT(NIT)+0.5
               call find_ubarvbar(ubar,vbar,
     .                            i1,j1,
     .                            i4,j4,id,
     .                            stackp_x1,
     .                            tallyp_x4,
     .                            stackp_x4,'p')
               YNEW = 3
               endif
            endif
 
         if (YNEW.gt.0) then
            NNEWs = NNEWs + 1
            Ls = Ls + 1
            if (Ls.gt._LDIM_) stop 'Ls.gt._LDIM_'
            ul(Ls) = ubar
            vl(Ls) = vbar
            wfnd_l(Ls) = NIT
            yfnd_l(Ls) = YNEW
            qmin_l(Ls) = qminu
            dmin_l(Ls) = dminu
            pmin_l(Ls) = pminu
            cfnd_l(Ls) = stackc_x1(i1,j1)
            qfnd_l(Ls) = stackq_x1(i1,j1)
            dfnd_l(Ls) = stackd_x1(i1,j1)
            pfnd_l(Ls) = stackp_x1(i1,j1)
            ufnd_l(Ls) = ubar
            vfnd_l(Ls) = vbar
            if (SHOW_TILE.and.VERBOSEU) then
               write( *,131) i1,j1,i4,j4,NNEWs,
     .                       stacka_x1(i1,j1),
     .                       stackc_x1(i1,j1),
     .                       stackq_x1(i1,j1),qminu,
     .                       stackd_x1(i1,j1),dminu,
     .                       stackp_x1(i1,j1),pminu,
     .                       ufnd_l(Ls),vfnd_l(Ls),Ls
               endif
  131       format(3x,i3.3,1x,i3.3,1x,i4.4,1x,i4.4,
     .             1x,'NNEW',i3.3,
     .             4x,'ALRDY',i1,4x,
     .             4x,'C',i3.3,
     .             4x,'Q',i3.3,'/',i3.3,
     .             4x,'D',i3.3,'/',i3.3,
     .             4x,'P',i3.3,'/',i3.3,
     .             5x,f8.2,1x,f8.2,1x,i3,1x,'L',i3)
            dmax = max(3.5,OPRX_NIT(NIT),OPRV_NIT(NIT))
            do di = -5, 5
            do dj = -5, 5
               if (i1+di.ge.0001.and.i1+di.le.301.and.
     .             j1+dj.ge.0001.and.j1+dj.le.301.and.
     .             di**2+dj**2.le.dmax**2) stacka_x1(i1+di,j1+dj) = YNEW ! already found this time
               enddo
               enddo
            endif
 1333    continue
         enddo
         enddo
      close(31)
 
      if (VERBOSEU) then
         print*,'       '
         print*,' Lo/Ls: ',Lo,Ls
         print*,' NEWs: '
         endif
 
      if (VERBOSEU) then
         print*,' Lo/Ls: ',Lo,Ls
         print*,'       '
         print*,'     ---> found.....        Ls: ',Ls
         print*,'                                '
         do L = Lo+1,Ls
            write(*,119) L,ul(L),vl(L),
     .                   wfnd_l(L),yfnd_l(L),
     .                   qfnd_l(L),qmin_l(L),
     .                   dfnd_l(L),dmin_l(L),
     .                   pfnd_l(L),pmin_l(L)
  119       format(1x,'L',i3.3,1x,f8.2,1x,f8.2,
     .                    1x,'W',i1,1x,'Y',i1,
     .                    3x,'Q',i3.3,'>=',i3.3,
     .                    3x,'D',i3.3,'>=',i3.3,
     .                    3x,'P',i3.3,'>=',i3.3)
            enddo
         endif
 
      if (VERBOSEU) print*,'call rest_stat...',NIT
      if (.false.) ! need to get working for parallel!
     .    call rest_stat(stacka_x1,stackc_x1,
     .                             stackq_x1,
     .                             stackd_x1,
     .                             stackp_x1,NIT)
 
      if (VERBOSEU) print*,'return find_tile...'
 
 
      if (VERBOSEU.and.(.false.)) then
         do j = 301, 001, -1
           !write(*,'(i3.3,1x,301i1)') j,(stackc_x1(i,j),i=151-100,151+100)
            enddo
         write(*,'(a6,90f8.1)') 'pixv_n',(tbar(pixv_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixd_n',(tbar(pixd_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixf_n',(tbar(pixf_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixe_n',(tbar(pixe_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90f8.1)') 'pixm_n',(tbar(pixm_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90i8.1)') 'pixu_n',(bsum(pixu_n(1,1,N)),N=1,Ns)
         write(*,'(a6,90i15)' ) 'talq_4',(i2_tot_1201(tallyq_x4))
         write(*,'(a6,90i15)' ) 'tald_4',(i2_tot_1201(tallyd_x4))
         write(*,'(a6,90i15)' ) 'talp_4',(i2_tot_1201(tallyp_x4))
         write(*,'(a6,90i15)' ) 'stkq_4',(i2_tot_1201(stackq_x4))
         write(*,'(a6,90i15)' ) 'stkd_4',(i2_tot_1201(stackd_x4))
         write(*,'(a6,90i15)' ) 'stkp_4',(i2_tot_1201(stackp_x4))
         stop
         endif
 
      do i4 = 0001, 1201
      do j4 = 0001, 1201
         i1 = 1 + (i4-1)/4. + 0.5
         j1 = 1 + (j4-1)/4. + 0.5
         covg_x4(i4,j4) = stackc_x1(i1,j1)
         pmin_x4(i4,j4) = max(preq_n(stackc_x1(i1,j1)),PMIN_NIT(NIT))
         ytot = 0
         do iy = 07, 01, -1
            ytot = ytot + tallyy_x4(i4,j4,iy)
            if (ytot.ge.pmin_x4(i4,j4)) goto 1
            enddo
    1    continue
         stacky_x4(i4,j4) = iy
         ytot = 0
         do iy = 1, 07
            ytot = ytot + tallyy_x4(i4,j4,iy)
            enddo
         stackz_x4(i4,j4) = ytot
c        write(89,189) i4, j4,covg_x4(i4,j4),pmin_x4(i4,j4),
c    .                        stackz_x4(i4,j4),
c    .                        stacky_x4(i4,j4),
c    .                        (tallyy_x4(i4,j4,iy),iy=1,7)
c 189    format(1x,i4.4,1x,i4.4,1x,i3,1x,i3,
c    .          1x,i3,1x,i3,5x,7i3)
         enddo
         enddo
c     close(89)
 
 
      do i = 001, 301
      do j = 001, 301
         i4 = 1 + (i-1)*4
         j4 = 1 + (j-1)*4
         stacky_x1(i,j) = stacky_x4(i4,j4)
         enddo
         enddo
 
      if (.false.) then
         call writfits_i2_ltv('covg_x4.fits',covg_x4,1201,1201,4.)
         call writfits_i2_ltv('pmin_x4.fits',covg_x4,1201,1201,4.)
         call writfits_i2_ltv('stacky_x4.fits',stacky_x4,1201,1201,4.)
         call writfits_i2_ltv('stackz_x4.fits',stackz_x4,1201,1201,4.)
         call writfits_i2_ltv('stacky_x1.fits',stacky_x1,0301,0301,1.)
         call writfits_i2_ltv('stackp_x1.fits',stackp_x1,0301,0301,1.)
         endif
 
 
      deallocate(stacka_x1, tallyq_x4, tallyd_x4, tallyp_x4)
      deallocate(           stackq_x4, stackd_x4, stackp_x4)
      deallocate(pkmapn)
      deallocate(stack_prev)
      deallocate(utl,vtl)
      deallocate(im, jm, qm, skyl)
      deallocate(tallyy_x4)
      deallocate(stacky_x4)
      deallocate(pmin_x4)
      deallocate(covg_x4)
 
      return
      end
 
 
 
      real function tbar(a)
      implicit none
      real a(_TDIM_,_TDIM_)
      integer i,j
      real*8 tsum
      tsum = 0.
      do i = 1, _TDIM_
      do j = 1, _TDIM_
         tsum = tsum+a(i,j)
         enddo
         enddo
      tbar = tsum/_TDIM_/_TDIM_
      return
      end
 
      integer*4 function bsum(a)
      implicit none
      byte a(_TDIM_,_TDIM_)
      integer i,j
      bsum = 0.
      do i = 1, _TDIM_
      do j = 1, _TDIM_
         bsum = bsum+a(i,j)
         enddo
         enddo
      return
      end
 
      integer*4 function i2_tot_1201(a)
      implicit none
      integer*2 a(1201,1201)
      integer i,j
      integer*4 tsum
      tsum = 0.
      do i = 1, 1201
      do j = 1, 1201
         tsum = tsum+a(i,j)
         enddo
         enddo
      i2_tot_1201 = tsum
 
      return
      end
 
 
c------------------------------------------------
c
c
c
      subroutine cosort_rrr(r1,r2,r3,Ns)
      implicit none
 
      real r1(99), r2(99), r3(99)
      integer Ns
 
      real h1, h2, h3
      integer N, NN
 
      do N  = 1, Ns
      do NN = 1, Ns-1
         if (r1(NN).gt.r1(NN+1)) then
            h1 = r1(NN)
            h2 = r2(NN)
            h3 = r3(NN)
            r1(NN) = r1(NN+1)
            r2(NN) = r2(NN+1)
            r3(NN) = r3(NN+1)
            r1(NN+1) = h1
            r2(NN+1) = h2
            r3(NN+1) = h3
            endif
         enddo
         enddo
 
      return
      end
 
 
 
c------------------------------------------------
c
c
c
      subroutine find_qoptX(i,j,pix,psf,
     .                      xoptu,yoptu,zoptu,soptu,qoptu)
      implicit none
 
      integer i, j
      real pix(_TDIM_,_TDIM_)
      real psf(101,101)
      real xoptu, yoptu
      real zoptu, soptu
      real qoptu
 
      integer ii, jj
      integer iu, ju
      integer Ns
      real xl(99)
      real yl(99)
      real s,z,q
      real x,y
      real dx,dy
      real rpsf_phot
 
      xoptu = 0.0
      yoptu = 0.0
      qoptu = 0.0
      zoptu = 0.0
      soptu = 0.0
 
      if (i.lt.001+003.or.i.ge._TDIM_-003.and.
     .    j.lt.001+003.or.j.ge._TDIM_-003) return
 
      xoptu = i + (pix(i+1,j)-pix(i-1,j))/
     .            (pix(i,j)-min(pix(i+1,j),pix(i-1,j)))
      yoptu = j + (pix(i,j+1)-pix(i,j-1))/
     .            (pix(i,j)-min(pix(i,j+1),pix(i,j-1)))
 
      Ns = 0
      do ii = -2, 2
      do jj = -2, 2
         Ns = Ns + 1
         xl(Ns) = rpsf_phot(i+ii-xoptu,j+jj-yoptu,psf)
         yl(Ns) = pix(i+ii,j+jj)
         enddo
         enddo
      call linfit(xl,yl,Ns,soptu,zoptu,qoptu)
 
      return
      end
 
 
c------------------------------------------------
c
c
c
      subroutine find_qopt(i,j,pixv,pixe,psf,
     .                     xoptu,yoptu,zoptu,soptu,qoptu,coptu)
      implicit none
 
      integer i, j
      real pixv(_TDIM_,_TDIM_)
      real pixe(_TDIM_,_TDIM_)
      real psf(101,101)
      real xoptu, yoptu
      real zoptu, soptu
      real qoptu
      real coptu
 
      integer ii, jj
      integer iu, ju
      integer L, Ls
      real xl(99)
      real yl(99)
      real wl(99)
      real el(99)
      real s,z,q
      real x,y
      real dx,dy
 
      xoptu = 0.0
      yoptu = 0.0
      qoptu = 0.0
      zoptu = 0.0
      soptu = 0.0
 
      if (i.lt.001+003.or.i.ge._TDIM_-003.and.
     .    j.lt.001+003.or.j.ge._TDIM_-003) return
 
 
      do ii = -2, 2
      do jj = -2, 2
         Ls = 0
         do iu = -2, 2
         do ju = -2, 2
            Ls = Ls + 1
            dx = 0.25*ii
            dy = 0.25*jj
            x  = i - dx
            y  = j - dy
            xl(Ls) = psf(51+4*iu+ii,51+4*ju+jj)
            yl(Ls) = pixv(i+iu,j+ju)
            el(Ls) = pixe(i+iu,j+ju)
            wl(Ls) = psf(51+4*iu+ii,51+4*ju+jj)
            wl(Ls) = 1.00
            enddo
            enddo
         call linfitw(xl,yl,wl,Ls,s,z,q)
         if (q.gt.qoptu) then
            xoptu = x
            yoptu = y
            qoptu = q
            soptu = s
            zoptu = z
            coptu = 0.
            do L = 1, Ls
               coptu = coptu + ((yl(L)-zoptu*xl(L)-soptu)/el(L))**2
               enddo
            coptu = sqrt(coptu/(Ls-2))
            if (.not.(coptu.lt.9.99)) coptu = 9.99
            endif
         enddo
         enddo
 
      return
      end
 
 
 
 
 
 
      SUBROUTINE LINFITW(X,Y,W,NPTS,A,B,R)
      implicit none
 
      INTEGER NPTS
      REAL X(NPTS), Y(NPTS), W(NPTS)
      real a, b, r
 
      REAL SUM, SUMX, SUMY, SUMX2, SUMXY, SUMY2
      REAL DELTA
      integer i
      real    xi
      real    yi
 
   11 SUM = 0
      SUMX = 0
      SUMY = 0
      SUMX2 = 0
      SUMXY = 0
      SUMY2 = 0
   21 DO 59  I = 1, NPTS
           XI = X(I)
           YI = Y(I)
           SUM   = SUM   + W(I)
           SUMX  = SUMX  + W(I)*XI
           SUMY  = SUMY  + W(I)*YI
           SUMX2 = SUMX2 + W(I)*XI*XI
           SUMXY = SUMXY + W(I)*XI*YI
           SUMY2 = SUMY2 + W(I)*YI*YI
   59 CONTINUE
 
   51 DELTA = SUM*SUMX2 - SUMX*SUMX
      A = (SUMX2*SUMY - SUMX*SUMXY) / DELTA
   53 B = (SUMXY*SUM  - SUMX*SUMY ) / DELTA
      R = 0.00
   71 IF (DELTA*(SUM*SUMY2 - SUMY*SUMY).GE.0) THEN
          R = (SUM*SUMXY - SUMX*SUMY) /
     .        SQRT(DELTA*(SUM*SUMY2 - SUMY*SUMY))
          ENDIF
 
 
      RETURN
      END
 
 
 
      SUBROUTINE LINFIT(X,Y,NPTS,A,B,R)
      implicit none
 
      INTEGER NPTS
      REAL X(1), Y(1)
      real a, b, r
 
      REAL SUM, SUMX, SUMY, SUMX2, SUMXY, SUMY2
      REAL DELTA
      integer i
      real    xi
      real    yi
 
   11 SUM = 0
      SUMX = 0
      SUMY = 0
      SUMX2 = 0
      SUMXY = 0
      SUMY2 = 0
   21 DO 59  I = 1, NPTS
           XI = X(I)
           YI = Y(I)
           SUM   = SUM   + 1
           SUMX  = SUMX  + XI
           SUMY  = SUMY  + YI
           SUMX2 = SUMX2 + XI*XI
           SUMXY = SUMXY + XI*YI
           SUMY2 = SUMY2 + YI*YI
   59 CONTINUE
 
   51 DELTA = SUM*SUMX2 - SUMX*SUMX
      A = (SUMX2*SUMY - SUMX*SUMXY) / DELTA
   53 B = (SUMXY*SUM  - SUMX*SUMY ) / DELTA
      R = 0.00
   71 IF (DELTA*(SUM*SUMY2 - SUMY*SUMY).GE.0) THEN
          R = (SUM*SUMXY - SUMX*SUMY) /
     .        SQRT(DELTA*(SUM*SUMY2 - SUMY*SUMY))
          ENDIF
 
 
      RETURN
      END
 
 
 
c------------------------------------------
c
c the goal of this routine is to take a list of
c peaks found associated with a master-frame pixel
c and see which of them could correspond to the
c same star.  I will first sort the stars and
c find the closest Pz stars that have within a
c factor of two of the same flux.  I will then
c find how many lie within 0.75 pixels of each
c other.  THIS is the number of detections.
c
      integer function findp_uvz(up,vp,zp,Ps,ubar,vbar,zbar)
      implicit none
 
      integer Ps
      real up(Ps), vp(Ps), zp(Ps)
      real ubar, vbar, zbar
 
      integer P, Puv
      integer Pa, Pb
      integer P1, P2
      integer N, N1, N2
      real utot, vtot, ztot
 
      ubar = 0.
      vbar = 0.
      zbar = 0.
      findp_uvz = 0
 
      if (Ps.eq.0) return
 
      if (Ps.eq.1) then
         ubar = up(1)
         vbar = vp(1)
         zbar = zp(1)
         findp_uvz = 1
         return
         endif
 
 
      call cosort_rrr(zp,up,vp,Ps)
 
c
c find the star that has the lgst number within
c a factor of two.
c
      P1 = 1
      P2 = 1
      do Pa =  1, Ps
         if (zp(Pa).gt.0) then
            do Pb = Pa, Ps
               if (zp(Pb).lt.zp(Pa)*2) then
                  if (Pb-Pa.gt.P2-P1) then
                     P1 = Pa
                     P2 = Pb
                     endif
                  endif
               enddo
            endif
         enddo
 
      findp_uvz = 0
      do Pa = P1, P2
         Puv  = 0
         utot = 0.
         vtot = 0.
         ztot = 0.
         do Pb = P1, P2
            if ((up(Pb)-up(Pa))**2
     .         +(vp(Pb)-vp(Pa))**2.lt.1.50**2) then
               Puv  = Puv + 1
               utot = utot + up(Pb)
               vtot = vtot + vp(Pb)
               ztot = ztot + zp(Pb)
               endif
            enddo
         if (Puv.gt.findp_uvz) then
            findp_uvz = Puv
            ubar = utot/Puv
            vbar = vtot/Puv
            zbar = ztot/Puv
            endif
         enddo
 
      return
      end
 
 
 
 
 
 
c------------------------------------------
c
c the goal of this routine is to take a list of
c peaks found associated with a master-frame pixel
c and see which of them could correspond to the
c same star.  I will then find how many lie within
c 0.60 true pixels of each other.  THIS is the number
c of detections.
c
      integer function findp_uv(up,vp,Ps,ubar,vbar)
      implicit none
 
      integer Ps
      real up(Ps), vp(Ps)
      real ubar, vbar
 
      integer P, Puv
      integer Pa, Pb
      integer P1, P2
      integer N, N1, N2
      real utot, vtot, ztot
 
      ubar = 0.
      vbar = 0.
      findp_uv = 0
 
      if (Ps.eq.0) return
 
      if (Ps.eq.1) then
         ubar = up(1)
         vbar = vp(1)
         findp_uv = 1
         return
         endif
 
 
      findp_uv = 0
      do Pa = 1, Ps
         Puv  = 0
         utot = 0.
         vtot = 0.
         ztot = 0.
         do Pb = 1, Ps
            if ((up(Pb)-up(Pa))**2
     .         +(vp(Pb)-vp(Pa))**2.lt.sqrt(1.25)**2) then
               Puv  = Puv + 1
               utot = utot + up(Pb)
               vtot = vtot + vp(Pb)
               endif
            enddo
         if (Puv.gt.findp_uv) then
            findp_uv = Puv
            ubar = utot/Puv
            vbar = vtot/Puv
            endif
         enddo
 
      return
      end
 
 
 
 
 
 
c------------------------------------------------
c
c we have a list of sources ; we want to figure
c out how many are close enough to each other to be
c considered detections...
c
      subroutine findd_uv(Ps,up,vp,Pu,dmax,ubar,vbar)
      implicit none
 
      integer Ps
      real up(Ps), vp(Ps)
      integer Pu
      real dmax
      real ubar, vbar
 
      logical*1 uu(999)
 
      integer Pt
      real    ut, vt
 
      integer P
      real    dd
      integer pmax
 
      if (Ps.gt.999) stop 'findd_uv:  Ps.gt.999'
      if (Ps.lt.Pu) then
         ubar = 0.00
         vbar = 0.00
         dmax = 9.99
         return
         endif
 
      do P = 1, Ps
         uu(P) = .true.
         enddo
 
    1 continue
      Pt = 0
      ut = 0.
      vt = 0.
      do P = 1, Ps
         if (uu(P)) then
            Pt = Pt + 1
            ut = ut + up(P)
            vt = vt + vp(P)
            endif
         enddo
      ubar = ut/Pt
      vbar = vt/Pt
 
      pmax = 0
      dmax = 0
      do P = 1, Ps
         if (uu(P)) then
            dd = sqrt((up(P)-ubar)**2+(vp(P)-vbar)**2)
            if (dd.gt.dmax) then
               pmax = P
               dmax = dd
               endif
            endif
         enddo
 
      if (pmax.eq.0) return
 
      if (Pt.gt.Pu) then  ! whittle down to only Pu...
         uu(pmax) = .false.
         goto 1
         endif
 
      return
      end
 
 
 
 
 
c----------------------------------------------------
c
c
c
      real function dmin_nn(nencl,nposs)
      implicit none
 
      integer nposs
      integer nencl
 
      real darrayu(250,250)
 
      real darray(10,10)
      common /darray_/darray
      data darray /
     . -1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,
     . -1.00, 0.40, 0.30,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,
     . -1.00,-1.00, 0.60, 0.50, 0.40,-1.00,-1.00,-1.00,-1.00,-1.00,
     . -1.00,-1.00,-1.00, 0.65, 0.60, 0.50, 0.40,-1.00,-1.00,-1.00,
     . -1.00,-1.00,-1.00,-1.00, 0.75, 0.65, 0.55, 0.40,-1.00,-1.00,
     . -1.00,-1.00,-1.00,-1.00,-1.00, 0.75, 0.65, 0.55, 0.45, 0.40,
     . -1.00,-1.00,-1.00,-1.00,-1.00,-1.00, 0.75, 0.65, 0.55, 0.45,
     . -1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00, 0.75, 0.65, 0.55,
     . -1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00, 0.75, 0.65,
     . -1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00,-1.00, 0.75/
 
      logical first
      common /dmin_nn_/first
      data first / .true. /
      integer i, j
      integer n1,n2
 
      if (first) then
         do i = 001, 250
         do j = 001, 250
            darrayu(i,j) = -1.00
            enddo
            enddo
         do i = 001, 010
         do j = 001, 010
            darrayu(i,j) = darray(i,j)
            enddo
            enddo
         do i = 011, 250 ! nposs
            n1 = ((i/10.)**0.666)*06
            n2 = ((i/10.)**0.666)*10
            write(*,'(i3.3,1x,i3,1x,i3)') i,n1,n2
            do j = 001, 250
               if (j.ge.n1.and.j.le.n2)
     .            darrayu(i,j) = 0.4 + 0.35*( j-n1)/
     .                                      (n2-n1)
               enddo
            enddo
         first = .false.
         do i = 001, 250
         do j = 001, 250
            write(81,181) i,j,darrayu(i,j)
  181       format(i3.3,1x,i3.3,1x,f8.4)
            enddo
            enddo
         stop
         endif
 
      dmin_nn = -1.00
      if (nposs.lt.002) return
      if (nposs.gt.250) stop 'dmin_nn:  nposs.gt.250'
      dmin_nn = darrayu(i,j)
 
      return
      end
 
c----------------------------------------------------
c
c
c
      integer function pkmapp_min(pkmapn,NIT)
      implicit none
 
      byte    pkmapn
      integer NIT
 
      pkmapp_min = 99
      if (pkmapn.eq.02) pkmapp_min = 2
      if (pkmapn.eq.03) pkmapp_min = 3
      if (pkmapn.eq.04) pkmapp_min = 3
      if (pkmapn.eq.05) pkmapp_min = 4
      if (pkmapn.eq.06) pkmapp_min = 4
      if (pkmapn.eq.07) pkmapp_min = 5
      if (pkmapn.eq.08) pkmapp_min = 5
      if (pkmapn.eq.09) pkmapp_min = 6
      if (pkmapn.eq.10) pkmapp_min = 6
      if (pkmapn.eq.11) pkmapp_min = 6
      if (pkmapn.eq.12) pkmapp_min = 7
      if (pkmapn.eq.13) pkmapp_min = 7
      if (pkmapn.eq.14) pkmapp_min = 7
      if (pkmapn.eq.15) pkmapp_min = 8
      if (pkmapn.eq.16) pkmapp_min = 8
      if (pkmapn.gt.16) pkmapp_min = pkmapn/2
 
      return
      end
 
 
 
 
 
 
c---------------------------------------------------
c
c
c
      integer function qreq_n(ntot)
      implicit none
 
      integer*2 ntot
 
      logical first
      common /qreq_a_/first
      data first/.true./
      integer n
 
      integer qrequ(150)
      common /qreq_n_/qrequ
 
      if (first) then
         do n = 1, 150
            qrequ(n) = n*0.60
            if (n.le.010) qrequ(n) =  6
            if (n.le.009) qrequ(n) =  5
            if (n.le.008) qrequ(n) =  4
            if (n.le.007) qrequ(n) =  4
            if (n.le.006) qrequ(n) =  3
            if (n.le.005) qrequ(n) =  3
            if (n.le.004) qrequ(n) =  2
            if (n.le.003) qrequ(n) =  2
            if (n.le.002) qrequ(n) =  1
            if (n.le.001) qrequ(n) =  1
            enddo
         first = .false.
         endif
 
      qreq_n = 99
      if (ntot.gt.150) then
         qreq_n = ntot*0.6
         return
         endif
      if (ntot.lt.001) return
 
      qreq_n = qrequ(ntot)
 
      return
      end
 
 
 
c---------------------------------------------------
c
c
c
      integer function preq_n(ntot)
      implicit none
 
      integer*2 ntot
 
      logical first
      common /preq_a_/first
      data first/.true./
      integer n
 
      integer prequ(999)
      common /reqn_n_/prequ
 
      if (first) then
         do n = 1, 999
            prequ(n) = n*130/600.+1
            if (n.le.600) prequ(n) = 130
            if (n.le.595) prequ(n) = 129
            if (n.le.590) prequ(n) = 128
            if (n.le.585) prequ(n) = 127
            if (n.le.580) prequ(n) = 126
            if (n.le.575) prequ(n) = 125
            if (n.le.570) prequ(n) = 124
            if (n.le.565) prequ(n) = 123
            if (n.le.560) prequ(n) = 122
            if (n.le.555) prequ(n) = 121
            if (n.le.550) prequ(n) = 120
            if (n.le.545) prequ(n) = 119
            if (n.le.540) prequ(n) = 118
            if (n.le.535) prequ(n) = 117
            if (n.le.530) prequ(n) = 116
            if (n.le.525) prequ(n) = 115
            if (n.le.520) prequ(n) = 114
            if (n.le.515) prequ(n) = 113
            if (n.le.510) prequ(n) = 112
            if (n.le.505) prequ(n) = 111
            if (n.le.500) prequ(n) = 110
            if (n.le.495) prequ(n) = 109
            if (n.le.490) prequ(n) = 108
            if (n.le.485) prequ(n) = 107
            if (n.le.480) prequ(n) = 106
            if (n.le.475) prequ(n) = 105
            if (n.le.470) prequ(n) = 104
            if (n.le.465) prequ(n) = 103
            if (n.le.460) prequ(n) = 102
            if (n.le.455) prequ(n) = 101
            if (n.le.450) prequ(n) = 100
            if (n.le.445) prequ(n) = 099
            if (n.le.440) prequ(n) = 098
            if (n.le.435) prequ(n) = 097
            if (n.le.430) prequ(n) = 096
            if (n.le.425) prequ(n) = 095
            if (n.le.420) prequ(n) = 094
            if (n.le.415) prequ(n) = 093
            if (n.le.410) prequ(n) = 092
            if (n.le.405) prequ(n) = 091
            if (n.le.400) prequ(n) = 090
            if (n.le.395) prequ(n) = 089
            if (n.le.390) prequ(n) = 088
            if (n.le.385) prequ(n) = 087
            if (n.le.380) prequ(n) = 086
            if (n.le.375) prequ(n) = 085
            if (n.le.370) prequ(n) = 084
            if (n.le.365) prequ(n) = 083
            if (n.le.360) prequ(n) = 082
            if (n.le.355) prequ(n) = 081
            if (n.le.350) prequ(n) = 080
            if (n.le.345) prequ(n) = 079
            if (n.le.340) prequ(n) = 078
            if (n.le.335) prequ(n) = 077
            if (n.le.330) prequ(n) = 076
            if (n.le.325) prequ(n) = 075
            if (n.le.320) prequ(n) = 074
            if (n.le.315) prequ(n) = 073
            if (n.le.310) prequ(n) = 072
            if (n.le.305) prequ(n) = 071
            if (n.le.300) prequ(n) = 070
            if (n.le.295) prequ(n) = 069
            if (n.le.290) prequ(n) = 068
            if (n.le.285) prequ(n) = 067
            if (n.le.280) prequ(n) = 066
            if (n.le.275) prequ(n) = 065
            if (n.le.270) prequ(n) = 064
            if (n.le.265) prequ(n) = 063
            if (n.le.260) prequ(n) = 062
            if (n.le.255) prequ(n) = 061
            if (n.le.250) prequ(n) = 060
            if (n.le.245) prequ(n) = 059
            if (n.le.240) prequ(n) = 058
            if (n.le.235) prequ(n) = 057
            if (n.le.230) prequ(n) = 056
            if (n.le.225) prequ(n) = 055
            if (n.le.220) prequ(n) = 054
            if (n.le.215) prequ(n) = 053
            if (n.le.210) prequ(n) = 052
            if (n.le.205) prequ(n) = 051
            if (n.le.200) prequ(n) = 050
            if (n.le.190) prequ(n) = 049
            if (n.le.185) prequ(n) = 048
            if (n.le.180) prequ(n) = 047
            if (n.le.175) prequ(n) = 046
            if (n.le.170) prequ(n) = 045
            if (n.le.165) prequ(n) = 044
            if (n.le.160) prequ(n) = 043
            if (n.le.155) prequ(n) = 042
            if (n.le.150) prequ(n) = 041
            if (n.le.145) prequ(n) = 040
            if (n.le.140) prequ(n) = 039
            if (n.le.135) prequ(n) = 038
            if (n.le.130) prequ(n) = 037
            if (n.le.120) prequ(n) = 036
            if (n.le.115) prequ(n) = 035
            if (n.le.110) prequ(n) = 034
            if (n.le.105) prequ(n) = 033
            if (n.le.100) prequ(n) = 032
            if (n.le.095) prequ(n) = 031
            if (n.le.090) prequ(n) = 030
            if (n.le.085) prequ(n) = 029
            if (n.le.080) prequ(n) = 028
            if (n.le.075) prequ(n) = 027
            if (n.le.070) prequ(n) = 026
            if (n.le.065) prequ(n) = 025
            if (n.le.060) prequ(n) = 024
            if (n.le.055) prequ(n) = 023
            if (n.le.050) prequ(n) = 022
            if (n.le.046) prequ(n) = 021
            if (n.le.043) prequ(n) = 020
            if (n.le.040) prequ(n) = 019
            if (n.le.036) prequ(n) = 018
            if (n.le.033) prequ(n) = 017
            if (n.le.030) prequ(n) = 016
            if (n.le.026) prequ(n) = 015
            if (n.le.023) prequ(n) = 014
            if (n.le.020) prequ(n) = 013
            if (n.le.018) prequ(n) = 012
            if (n.le.016) prequ(n) = 011
            if (n.le.014) prequ(n) = 010
            if (n.le.012) prequ(n) = 009
            if (n.le.010) prequ(n) = 008
            if (n.le.009) prequ(n) = 007
            if (n.le.008) prequ(n) = 006
            if (n.le.006) prequ(n) = 005
            if (n.le.005) prequ(n) = 004
            if (n.le.004) prequ(n) = 003
            enddo
         first = .false.
         endif
 
      preq_n = 99
      if (ntot.gt.999) then
         preq_n = ntot*33/150
         return
         endif
      if (ntot.lt.001) return
 
      preq_n = prequ(ntot)
 
      return
      end
 
 
c-------------------------------------------------
c
c this routine will find a centroid estimate for
c the position of the source based on all the
c independent observations
c
      subroutine find_ubarvbar(ubar,vbar,
     .                         i1,j1,i4,j4,id,
     .                         stack_x1,
     .                         tally_x4,
     .                         stack_x4,qdp)
      implicit none
 
      real      ubar, vbar
 
      integer   i1, j1
      integer   i4, j4, id
      integer*2 stack_x1(0301,0301)
      integer*2 tally_x4(1201,1201) ! raw stackp observations
      integer*2 stack_x4(1201,1201) ! convolved stackp
      character qdp
 
      integer ii,jj
      integer i4u, i4uu
      integer j4u, j4uu
 
      integer ntot
      real*8  xtot, ytot
 
      ntot = 0
      xtot = 0
      ytot = 0
      if (stack_x1(i1,j1).le.0) goto 1
      do i4u = max(0001,i4-4), min(1201,i4+4)
      do j4u = max(0001,j4-4), min(1201,j4+4)
         if (stack_x4(i4u,j4u).ge.stack_x1(i1,j1)) then
            do ii = -id, id
            do jj = -id, id
               if (ii**2+jj**2.le.(id+0.5)**2) then
                  i4uu = i4u + ii
                  j4uu = j4u + jj
                  if (i4uu.ge.0001.and.i4uu.le.1201.and.
     .                j4uu.ge.0001.and.j4uu.le.1201) then
                      if (tally_x4(i4uu,j4uu).gt.0) then
                         ntot = ntot + tally_x4(i4uu,j4uu)
                         xtot = xtot + tally_x4(i4uu,j4uu)*i4uu
                         ytot = ytot + tally_x4(i4uu,j4uu)*j4uu
                         endif
                      endif
                  endif
               enddo
               enddo
            endif
         enddo
         enddo
    1 continue
      if (ntot.eq.0) then
          print*,'---> qdp ',qdp
          print*,'---> i1: ',i1,j1,stack_x1(i1,j1)
          print*,'---> i4: ',i4,j4,stack_x4(i4,j4),tally_x4(i4,j4)
          call writfits_i2('BOMB_stack_x1.fits',stack_x1,0301,0301)
          call writfits_i2('BOMB_stack_x4.fits',stack_x4,1201,1201)
          call writfits_i2('BOMB_tally_x4.fits',tally_x4,1201,1201)
          print*,' '
          print*,' '
          stop 'find_tile:  ntot.eq.0'
          endif
      ubar = 1 + (xtot/ntot-1)*0.25
      vbar = 1 + (ytot/ntot-1)*0.25
      return
      end
 
 
 
 
 
c----------------------------------------------------------------
c
c output some statistics about peaks found and not found
c
c
c
      subroutine rest_stat(stacka_x1,stackc_x1,
     .                               stackq_x1,
     .                               stackd_x1,
     .                               stackp_x1,NIT)
      implicit none
 
      byte      stacka_x1(301,301)
      integer*2 stackc_x1(301,301)
      integer*2 stackq_x1(301,301)
      integer*2 stackd_x1(301,301)
      integer*2 stackp_x1(301,301)
      integer NIT
 
      integer*2 , dimension(:,:), allocatable :: stackp_cp
 
      integer i,j
      integer ih,jh
      integer*4 hist(9,3,3,25,25) ! NIT, Q1D2P3, FND1NOT2, C, QDP
      common/rest_stat1_/hist
      integer ii,jj
 
      logical first
      common/rest_stat2_/first
      data    first/.true./
 
      integer NITMAX
      common/rest_stat3_/NITMAX
      data    NITMAX/0/
 
      integer Q1D2P3
      integer A1N2F3
      integer NITu
 
      logical VERBOSE
      common /VERBOSE/VERBOSE
 
      allocate(stackp_cp(301,301))
 
      if (first) then
         do NITu   = 1, 9
         do Q1D2P3 = 1, 3
         do A1N2F3 = 1, 3
            do ih = 1, 25
            do jh = 1, 25
               hist(NITu,Q1D2P3,A1N2F3,ih,jh) = 0
               enddo
               enddo
            enddo
            enddo
            enddo
         first = .false.
         if (VERBOSE) write(*,'(''INIT rest_stat HISTOGRAM...'')')
         endif
 
      if (NIT.gt.NITMAX) NITMAX = NIT
 
      do Q1D2P3 = 1, 3
 
         do i = 001, 301
         do j = 001, 301
            if (Q1D2P3.eq.1) stackp_cp(i,j) = stackq_x1(i,j)
            if (Q1D2P3.eq.2) stackp_cp(i,j) = stackd_x1(i,j)
            if (Q1D2P3.eq.3) stackp_cp(i,j) = stackp_x1(i,j)
            enddo
            enddo
 
         do i = 051, 251
         do j = 051, 251
            do ii = -5, 5
            do jj = -5, 5
               if (ii**2+jj**2.le.5.5**2) then
                  if (stackp_cp(i,j).lt.stackp_cp(i+ii,j+j)) goto 1
                  endif
               enddo
               enddo
            ih = stackc_x1(i,j)
            jh = stackp_x1(i,j)
            if (ih.ge.1.and.ih.le.25.and.
     .          jh.ge.1.and.jh.le.25) then
                hist(NIT,Q1D2P3,1,ih,jh) = hist(NIT,Q1D2P3,1,ih,jh) + 1
                if (stacka_x1(i,j).eq.0)
     .             hist(NIT,Q1D2P3,2,ih,jh) = hist(NIT,Q1D2P3,2,ih,jh)+1
                if (stacka_x1(i,j).ne.0)
     .             hist(NIT,Q1D2P3,3,ih,jh) = hist(NIT,Q1D2P3,3,ih,jh)+1
                endif
            stackp_cp(i,j) = stackp_cp(i,j)+1
    1       continue
            enddo
            enddo
         enddo
 
      if (NIT.eq.NITMAX) then
         open(46,file='LOGK.PEAKSTAT',status='unknown')
         do NITu   = 1, NITMAX
         do Q1D2P3 = 1, 3
         do A1N2F3 = 1, 3
            write(46,119) NITu,'QDP'(Q1D2P3:Q1D2P3),
     .                         'ANF'(A1N2F3:A1N2F3)
            write(46,119) NITu,'QDP'(Q1D2P3:Q1D2P3),
     .                         'ANF'(A1N2F3:A1N2F3),
     .                         0,(jh,jh=1,25)
            do ih = 25, 01, -1
               write(46,119)
     .              NITu,'QDP'(Q1D2P3:Q1D2P3),
     .                  'ANF'(A1N2F3:A1N2F3),
     .              ih,(hist(NITu,Q1D2P3,A1N2F3,ih,jh),jh=1,25)
  119          format('NIT',i1,a1,a1,1x,'C',i2.2,
     .                      1x,10(1x,i9),10(1x,i8),5(1x,i7))
  118          format('   ',1x,1x,1x,1x,1x, 2x,
     .                      1x,10(1x,i9),10(1x,i8),5(1x,i7))
               enddo
            write(46,119) NITu,'QDP'(Q1D2P3:Q1D2P3),
     .                         'ANF'(A1N2F3:A1N2F3)
            enddo
            enddo
            enddo
         close(46)
         endif
 
      deallocate(stackp_cp)
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/histo_sky.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------------------------
c
c
c
c
      subroutine histo_sky(Ns, FFF_N,
     .                         UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                         pixv_n, pixe_n, pixm_n, pixu_n,
     .                         GGG_N,sky_stat)
      implicit none
 
      integer   Ns
      integer   FFF_N(Ns)
 
      real      UTAB_N(31,31,Ns), VTAB_N(31,31,Ns)
      real      XTAB_N(31,31,Ns), YTAB_N(31,31,Ns)
 
      real      pixv_n(_TDIM_,_TDIM_,Ns)
      real      pixe_n(_TDIM_,_TDIM_,Ns)
      real      pixm_n(_TDIM_,_TDIM_,Ns)
      byte      pixu_n(_TDIM_,_TDIM_,Ns)
 
      integer   GGG_N(Ns)
      integer   sky_stat(201,_GDIM_,_GDIM_)
 
c
c-------------------------------------------------------------------
c
      integer   N, F, NN
      real*8    u,  v
      real*8    x,  y
      integer   i,  j
      integer   ii, jj
      real      xt_tuv
      real      yt_tuv
 
      character*80 FILENAME
 
      integer   L, Ls, Lu, LL
      real      pl(9999)
      integer   nl(9999)
 
      integer   Us, Uu
      real      pu(9999)
      real      pbar, psig
 
      real   pixr(301,301)
      byte   pixu(301,301)
      integer h
 
      print*,'ENTER stack_tile_rej...  Ns: ',Ns
 
      do F = 1, _FDIM_
         print*,'----> F: ',F
         do i = 1+30, _TDIM_-30, 2
         do j = 1+30, _TDIM_-30, 2
            Lu = 0
            Ls = 0
            do N = 1, Ns
               if (FFF_N(N).eq.F) then
                  x = xt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
                  y = yt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
                  ii = int(x+0.5)
                  jj = int(y+0.5)
                  if (ii.ge.0001.and.ii.le._TDIM_.and.
     .                jj.ge.0001.and.ii.le._TDIM_) then
                      if (pixu_n(ii,jj,N).le.0) then
                         Ls = Ls + 1
                         if (Ls.gt.9999) stop 'Ls.gt.9999'
                         pl(Ls) = pixv_n(ii,jj,N)
                         nl(Ls) = N
                         endif
                      endif
                  endif
               enddo
            if (Ls.ge.2) then
               do L  = 1, Ls
               do LL = 1, Ls
                  if (L.ne.LL) then
                     h = 101 + (pl(L)-pl(LL)) + 0.5
                     if (h.ge.001.and.h.le.201)
     .                   sky_stat(H,GGG_N(nl(L)),GGG_N(nl(LL))) =
     .                   sky_stat(H,GGG_N(nl(L)),GGG_N(nl(LL))) + 1
                     endif
                  enddo
                  enddo
               endif
            enddo
            enddo
         enddo!F
 
      print*,'EXIT  histo_sky...'
 
      return
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/hold_pixv.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------------
c
c save a version of the pixel value array
c
         subroutine hold_pixv(Ns,pixv_n,pixh_n)
         implicit none
 
         integer Ns
         real*4 pixv_n(_TDIM_,_TDIM_,Ns)
         real*4 pixh_n(_TDIM_,_TDIM_,Ns)
 
         integer i, j, N
 
         do N = 1, Ns
            do i = 001, _TDIM_
            do j = 001, _TDIM_
               pixh_n(i,j,N) = pixv_n(i,j,N)
               enddo
               enddo
            enddo
 
         return
         end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/imin_KKK_C.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------
c
c
      integer function imin_KKK_C(KKK,C)
      implicit none
 
      integer KKK
      integer C
 
      integer imin_KKK_C_H(4,10)
      common/imin_KKK_C_H_/imin_KKK_C_H
      data imin_KKK_C_H/
     .     0000,0000,0000,0000,   ! KKK=1 PC
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     0001,0001,0000,0000,   ! KKK=5 ACS/WFC
     .     0000,0000,0000,0000,
     .     0001,0000,0000,0000,   ! KKK=7 ACS/HRC
     .     0001,0001,0000,0000,   ! KKK=8 WFC3/UVIS
     .     0001,0000,0000,0000,   ! KKK=9 WFC3/IR
     .     0000,0000,0000,0000/
 
      if (C  .lt.1.or.c  .gt.04) stop 'imin_KKK_C: c out of bounds'
      if (KKK.lt.1.or.KKK.gt.10) stop 'imin_KKK_C: c out of bounds'
 
      imin_KKK_C = imin_KKK_C_H(C,KKK)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/imax_KKK_C.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------
c
c
      integer function imax_KKK_C(KKK,C)
      implicit none
 
      integer KKK
      integer C
 
      integer imax_KKK_C_H(4,10)
      common/imax_KKK_C_H_/imax_KKK_C_H
      data imax_KKK_C_H/
     .     0000,0000,0000,0000,  ! KKK=1 PC
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     4096,4096,0000,0000,  ! KKK=5 ACS/WFC
     .     0000,0000,0000,0000,
     .     1024,0000,0000,0000,  ! KKK=7 ACS/HRC
     .     4096,4096,0000,0000,  ! KKK=8 WFC3/UVIS
     .     1014,0000,0000,0000,  ! KKK=9 WFC3/IR
     .     0000,0000,0000,0000/
 
      if (C  .lt.1.or.c  .gt.04) stop 'imax_KKK_C: c out of bounds'
      if (KKK.lt.1.or.KKK.gt.10) stop 'imax_KKK_C: c out of bounds'
 
      imax_KKK_C = imax_KKK_C_H(C,KKK)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/init_pixsub.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------
c
c initialize the arrays that'll do the pixel subtraction
c
      subroutine init_pixsub(Ns,pixv_n,pixd_n,pixs_n)
      implicit none
 
      integer Ns
      real pixv_n(_TDIM_,_TDIM_,Ns)
      real pixd_n(_TDIM_,_TDIM_,Ns)
      real pixs_n(_TDIM_,_TDIM_,Ns)
 
      integer N, i, j
 
      do N = 1, Ns
         do i = 001, _TDIM_
         do j = 001, _TDIM_
            pixd_n(i,j,N) = pixv_n(i,j,N)
            pixs_n(i,j,N) = 0.
            enddo
            enddo
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/init_stacks.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------
c
c initialize the stacks for a new tile run
c
      subroutine init_stacks(Fs,stackv_tf, stackd_tf,stacks_tf,
     .                                     stackp_tf,stackn_tf)
      implicit none
 
      integer   Fs
      real*4    stackv_tf(_TDIM_,_TDIM_,_FDIM_)
      real*4    stackd_tf(_TDIM_,_TDIM_,_FDIM_)
      real*4    stacks_tf(_TDIM_,_TDIM_,_FDIM_)
      integer*2 stackp_tf(_TDIM_,_TDIM_,_FDIM_)
      integer*2 stackn_tf(_TDIM_,_TDIM_,_FDIM_)
 
      integer i, j, F
 
      do i = 001, _TDIM_
      do j = 001, _TDIM_
         do F = 1, Fs
            stackv_tf(i,j,F) = 0.00
            stackd_tf(i,j,F) = 0.00
            stacks_tf(i,j,F) = 0.00
            stackp_tf(i,j,F) = 0.00
            stackn_tf(i,j,F) = 0.00
            enddo
         enddo
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/init_stacku.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
cccccccccccccccccccccccccccccccccccccccccc
c
c demark where we will and won't be prime
c
      subroutine init_stacku(stacktu)
      implicit none
 
      byte stacktu(_TDIM_,_TDIM_)
 
      integer i, j
 
      do i = 0001, _TDIM_
      do j = 0001, _TDIM_
         stacktu(i,j) = 0
         if (i.gt.0001+15.and.i.lt._TDIM_-15.and.
     .       j.gt.0001+15.and.j.lt._TDIM_-15)
     .       stacktu(i,j) = 1
         enddo
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/init_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c------------------------------------------------------------------
c
c this routine will read in all the information for the current
c tile... images, error arrays, filter info, etc.
c
      subroutine init_tile_a(IT,JT,UREF_T,VREF_T,DIRECT,NDIRECT,
     .                       Gs,FILENAME_G,SUBDIR_G,NSUBDIR_G,
     .                          FILEPSF_G, FILEGCS_G,
     .                          ucen_cg,vcen_cg,icen_cg,jcen_cg,
     .                                          xcen_cg,ycen_cg,
     .                          AG_CG,BG_CG,CG_CG,DG_CG,
     .                          GA_CG,GB_CG,GC_CG,GD_CG,
     .                          FFF_G,RAP_G,SC_CG,KKK_G,FLT_G,ZP_CG,
     .                                MSK_G,OTH_G,
     .                          POS_G,FND_G,SKY_G,EXP_G,EXP_F,
     .                       Ns,GGG_N,KKK_N,FFF_N,RAP_N,SCL_N,SKY_N,
     .                          CCC_N,FLT_N,ZPU_N,
     .                          POS_N,FND_N,EXP_N,MSK_N,OTH_N,
     .                          UCEN_N,VCEN_N,ICEN_N,JCEN_N,
     .                                        XCEN_N,YCEN_N,
     .                          UTIL_N, VTIL_N, ITIL_N, JTIL_N,
     .                                          XTIL_N, YTIL_N,
     .                          UTAB_N, VTAB_N,
     .                          XTAB_N, YTAB_N,
     .                          AG_N,BG_N,CG_N,DG_N,
     .                          GA_N,GB_N,GC_N,GD_N,
     .                          FILEPSF_N, FILEGCS_N, FILEPIX_N)
      implicit none
 
      integer      IT, JT
      integer      UREF_T, VREF_T
      character*80 DIRECT
      integer      NDIRECT
      integer      Gs
      character*80 FILENAME_G(Gs)
      character*80 SUBDIR_G(Gs)
      integer      NSUBDIR_G(Gs)
      character*80 FILEPSF_G(Gs)
      character*80 FILEGCS_G(Gs)
 
      real*8  ucen_cg(_CDIM_,Gs), vcen_cg(_CDIM_,Gs)
      integer icen_cg(_CDIM_,Gs), jcen_cg(_CDIM_,Gs)
      real*8  xcen_cg(_CDIM_,Gs), ycen_cg(_CDIM_,Gs)
      real*8  AG_CG(_CDIM_,Gs), BG_CG(_CDIM_,Gs)
      real*8  CG_CG(_CDIM_,Gs), DG_CG(_CDIM_,Gs)
      real*8  GA_CG(_CDIM_,Gs), GB_CG(_CDIM_,Gs)
      real*8  GC_CG(_CDIM_,Gs), GD_CG(_CDIM_,Gs)
 
      integer FFF_G(Gs)
      integer RAP_G(Gs)
      real    SC_CG(_CDIM_,Gs)
      integer KKK_G(Gs)
      integer FLT_G(Gs)
      real    ZP_CG(_CDIM_,Gs)
      character*9 POS_G(Gs)
      character*9 FND_G(Gs)
      real    MSK_G(Gs)
      real    OTH_G(Gs)
      real    SKY_G(Gs)
      real    EXP_G(Gs)
      real    EXP_F(_FDIM_)
      integer Ns
      integer GGG_N(_NDIM_)
      integer KKK_N(_NDIM_)
      integer FFF_N(_NDIM_)
      integer RAP_N(_NDIM_)
      real    SCL_N(_NDIM_)
      real    SKY_N(_NDIM_)
      integer CCC_N(_NDIM_)
      integer FLT_N(_NDIM_)
      real    ZPU_N(_NDIM_)
      real    MSK_N(_NDIM_)
      real    OTH_N(_NDIM_)
      character*9 POS_N(_NDIM_)
      character*9 FND_N(_NDIM_)
      real    EXP_N(_NDIM_)
 
      real*8  UCEN_N(_NDIM_), VCEN_N(_NDIM_)
      integer ICEN_N(_NDIM_), JCEN_N(_NDIM_)
      real*8  XCEN_N(_NDIM_), YCEN_N(_NDIM_)
 
      real*8  UTIL_N(_NDIM_), VTIL_N(_NDIM_)
      integer ITIL_N(_NDIM_), JTIL_N(_NDIM_)
      real*8  XTIL_N(_NDIM_), YTIL_N(_NDIM_)
 
      real    UTAB_N(31,31,_NDIM_), VTAB_N(31,31,_NDIM_)
      real    XTAB_N(31,31,_NDIM_), YTAB_N(31,31,_NDIM_)
      real*8  AG_N(_NDIM_), BG_N(_NDIM_), CG_N(_NDIM_), DG_N(_NDIM_)
      real*8  GA_N(_NDIM_), GB_N(_NDIM_), GC_N(_NDIM_), GD_N(_NDIM_)
 
      character*80 FILEPSF_N(_NDIM_)
      character*80 FILEGCS_N(_NDIM_)
      character*80 FILEPIX_N(_NDIM_)
c
c-----------------------------------------------------
c
      real    sbar_t(_NDIM_)
      real    ssig_t(_NDIM_)
      integer sknu_t(_NDIM_)
 
      integer Cs_KKK
      real*8              urefu, vrefu, urefuu, vrefuu
      real*8  xcor, ycor, xcoru, ycoru, xcoruu, ycoruu
      real*8  xraw, yraw, xrawu, yrawu, xrawuu, yrawuu
      integer iraw, jraw, irawu, jrawu, irawuu, jrawuu
 
      integer G, C
      integer i, j
      integer i1, i2, j1, j2
      integer imin_KKK_C, iminu
      integer imax_KKK_C, imaxu
      integer jmin_KKK_C, jminu
      integer jmax_KKK_C, jmaxu
 
      integer N
      real*8 xsum, ysum, fsum
 
      real FLXRAT
      real dsky, ssky
      integer NSKY
 
      integer BB
      real*8  uref_bb(_BDIM_), vref_bb(_BDIM_)
      real    zref_bbf(_BDIM_,_FDIM_)
      integer F
 
      real ut, ut_txy
      real vt, vt_txy
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
c
c-----------------------------------------------------
c
      Ns = 0
      do G = 1, Gs
      do C = 1, Cs_KKK(KKK_G(G))
         xcor = xcen_cg(C,G)
     .        + AG_CG(C,G)*(UREF_T-ucen_cg(c,g))
     .        + BG_CG(C,G)*(VREF_T-vcen_cg(c,g))
         ycor = ycen_cg(C,G)
     .        + CG_CG(C,G)*(UREF_T-ucen_cg(c,g))
     .        + DG_CG(C,G)*(VREF_T-vcen_cg(c,g))
         call cg_cf(xcor,ycor,xraw,yraw,
     .              KKK_G(g),FLT_G(g),C,FILEGCS_G(G))
 
         iraw = int(xraw+0.5)  ! this is the pixel that is closest to
         jraw = int(yraw+0.5)  ! the center of the reference-frame tile
 
         xrawu = iraw
         yrawu = jraw
         call gc_cf(xrawu,yrawu,xcoru,ycoru,
     .              KKK_G(g),FLT_G(g),C,FILEGCS_G(G))
         urefu = ucen_cg(c,g)
     .         + GA_CG(C,G)*(xcoru-xcen_cg(C,G))
     .         + GB_CG(C,G)*(ycoru-ycen_cg(C,G))
         vrefu = vcen_cg(c,g)
     .         + GC_CG(C,G)*(xcoru-xcen_cg(C,G))
     .         + GD_CG(C,G)*(ycoru-ycen_cg(C,G))
 
         i1 = iraw - (_TDIM_-1)/2
         i2 = iraw + (_TDIM_-1)/2
         j1 = jraw - (_TDIM_-1)/2
         j2 = jraw + (_TDIM_-1)/2
 
         iminu = imin_KKK_C(KKK_G(G),C)
         imaxu = imax_KKK_C(KKK_G(G),C)
         jminu = jmin_KKK_C(KKK_G(G),C)
         jmaxu = jmax_KKK_C(KKK_G(G),C)
 
         if (i1.lt.imaxu.and.i2.gt.iminu.and.
     .       j1.lt.jmaxu.and.j2.gt.jminu) then
             Ns = Ns + 1
             if (Ns.gt._NDIM_) then
                print*,'                 '
                print*,'Ns.gt._NDIM_ --- '
                print*,' Ns   : ',Ns
                print*,'_NDIM_: ',_NDIM_
                print*,'                 '
                stop
                endif
             GGG_N(Ns)  = G
             KKK_N(Ns)  = KKK_G(G)
             FFF_N(Ns)  = FFF_G(G)
             RAP_N(Ns) = RAP_G(G)
             SCL_N(Ns) = SC_CG(C,G)
             SKY_N(Ns) = SKY_G(G)
             CCC_N(Ns)  = C
             FLT_N(Ns) = FLT_G(G)
             ZPU_N(Ns) = ZP_CG(C,G)
             MSK_N(Ns) = MSK_G(G)
             OTH_N(Ns) = OTH_G(G)
             POS_N(Ns) = POS_G(G)
             FND_N(Ns) = FND_G(G)
             EXP_N(Ns) = EXP_G(G)
             AG_N(Ns)  = AG_CG(C,G)
             BG_N(Ns)  = BG_CG(C,G)
             CG_N(Ns)  = CG_CG(C,G)
             DG_N(Ns)  = DG_CG(C,G)
             GA_N(Ns)  = GA_CG(C,G)
             GB_N(Ns)  = GB_CG(C,G)
             GC_N(Ns)  = GC_CG(C,G)
             GD_N(Ns)  = GD_CG(C,G)
 
             ITIL_N(Ns) = iraw
             JTIL_N(Ns) = jraw
             XTIL_N(Ns) = xcoru
             YTIL_N(Ns) = ycoru
             UTIL_N(Ns) = urefu
             VTIL_N(Ns) = vrefu
 
             UCEN_N(Ns) = ucen_cg(C,G)
             VCEN_N(Ns) = vcen_cg(C,G)
             ICEN_N(Ns) = icen_cg(C,G)
             JCEN_N(Ns) = jcen_cg(C,G)
             XCEN_N(Ns) = xcen_cg(C,G)
             YCEN_N(Ns) = ycen_cg(C,G)
 
             FILEPSF_N(Ns) = FILEPSF_G(G)
             FILEGCS_N(Ns) = FILEGCS_G(G)
             FILEPIX_N(Ns) = DIRECT(1:NDIRECT)
     .                       //  SUBDIR_G(G)(1:NSUBDIR_G(G))
     .                       //  FILENAME_G(G)
 
             call trans_tile(UREF_T,    VREF_T,                   ! the center of the ref-frame tile
     .                       ITIL_N(Ns),JTIL_N(Ns),               ! the center of the local tile
     .                       XTIL_N(Ns),YTIL_N(Ns),               ! the dist-cor position of the loc-tile center
     .                       UTIL_N(Ns),VTIL_N(Ns),               ! the ref-frame position of the loc-tile center
     .                       GA_N(Ns),GB_N(Ns),GC_N(Ns),GD_N(Ns), ! from gc-loc to ref
     .                       KKK_N(Ns), CCC_N(Ns), FLT_N(Ns),     ! background info for the distortion correction
     .                       FILEGCS_N(Ns),
     .                       UTAB_N(1,1,Ns),VTAB_N(1,1,Ns),       ! tabulated transformation from loc1_t ---> ref2_t
     .                       XTAB_N(1,1,Ns),YTAB_N(1,1,Ns))       ! tabulated transformation from ref2_t ---> loc1_t
             endif
          enddo ! C
          enddo ! G
      if (VERBOSE) print*,'EXIT init_tile1...  Ns: ',Ns
      return ! init_tile_a
      end
 
 
c------------------------------------------------------------------
c
c this routine will read in all the information for the current
c tile... images, error arrays, filter info, etc.
c
      subroutine init_tile_b(IT,JT,UREF_T,VREF_T,
     .                       Ns,GGG_N,KKK_N,FFF_N,RAP_N,SCL_N,SKY_N,
     .                          CCC_N,FLT_N,ZPU_N,
     .                          POS_N,FND_N,EXP_N,MSK_N,OTH_N,
     .                          UCEN_N, VCEN_N, ICEN_N, JCEN_N,
     .                                          XCEN_N, YCEN_N,
     .                          UTIL_N, VTIL_N, ITIL_N, JTIL_N,
     .                                          XTIL_N, YTIL_N,
     .                          UTAB_N, VTAB_N,
     .                          XTAB_N, YTAB_N,
     .                          AG_N,BG_N,CG_N,DG_N,
     .                          GA_N,GB_N,GC_N,GD_N,
     .                          pixv_n, pixe_n, pixm_n, pixu_n,
     .                          FILEPSF_N, FILEGCS_N, FILEPIX_N,
     .                       Bs,BBs,uref_b,vref_b,zref_bf)
      implicit none
 
      integer     IT, JT
      integer     UREF_T, VREF_T
      integer     Ns
      integer     GGG_N(Ns)
      integer     KKK_N(Ns)
      integer     FFF_N(Ns)
      integer     RAP_N(Ns)
      real        SCL_N(Ns)
      real        SKY_N(Ns)
      integer     CCC_N(Ns)
      integer     FLT_N(Ns)
      real        ZPU_N(Ns)
      character*9 POS_N(Ns)
      character*9 FND_N(Ns)
      real        EXP_N(Ns)
      real        MSK_N(Ns)
      real        OTH_N(Ns)
 
      real*8  UCEN_N(Ns), VCEN_N(Ns)
      integer ICEN_N(Ns), JCEN_N(Ns)
      real*8  XCEN_N(Ns), YCEN_N(Ns)
 
      integer ITIL_N(Ns), JTIL_N(Ns)
      real*8  XTIL_N(Ns), YTIL_N(Ns)
      real*8  UTIL_N(Ns), VTIL_N(Ns)
 
      real    UTAB_N(31,31,Ns), VTAB_N(31,31,Ns)
      real    XTAB_N(31,31,Ns), YTAB_N(31,31,Ns)
      real*8  AG_N(Ns), BG_N(Ns), CG_N(Ns), DG_N(Ns)
      real*8  GA_N(Ns), GB_N(Ns), GC_N(Ns), GD_N(Ns)
 
      real*4 pixv_n(_TDIM_,_TDIM_,Ns)
      real*4 pixe_n(_TDIM_,_TDIM_,Ns)
      real*4 pixm_n(_TDIM_,_TDIM_,Ns)
      byte   pixu_n(_TDIM_,_TDIM_,Ns)
 
      character*80 FILEPSF_N(Ns)
      character*80 FILEGCS_N(Ns)
      character*80 FILEPIX_N(Ns)
      integer Bs, BBs
      real*8  uref_b(_BDIM_), vref_b(_BDIM_)
      real    zref_bf(_BDIM_,_FDIM_)
 
c
c-----------------------------------------------------
c
      real    sbar_t(_NDIM_)
      real    ssig_t(_NDIM_)
      integer sknu_t(_NDIM_)
 
      integer Cs_KKK
      real*8              urefu, vrefu, urefuu, vrefuu
      real*8  xcor, ycor, xcoru, ycoru, xcoruu, ycoruu
      real*8  xraw, yraw, xrawu, yrawu, xrawuu, yrawuu
      integer iraw, jraw, irawu, jrawu, irawuu, jrawuu
 
      integer G, C
      integer i, j
      integer i1, i2, j1, j2
      integer imin_KKK_C
      integer imax_KKK_C
      integer jmin_KKK_C
      integer jmax_KKK_C
 
      integer N
      real*8 xsum, ysum, fsum
 
      real FLXRAT
      real dsky, ssky
      integer NSKY
 
      integer BB
      real*8  uref_bb(_BDIM_), vref_bb(_BDIM_)
      real    zref_bbf(_BDIM_,_FDIM_)
      integer F
 
      real ut, ut_txy
      real vt, vt_txy
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
c
c-----------------------------------------------------
c
      if (VERBOSE)
     .   print*,'ENTER init_tile_b... Ns: ',Ns
 
      if (VERBOSE) print*,'init_tile_b... read in Ns: ',Ns
      do N = 1, Ns
         call read_tile(FILEPIX_N(N),KKK_N(N),CCC_N(N),
     .                  ITIL_N(N),JTIL_N(N),
     .                  pixv_n(1,1,N),
     .                  pixe_n(1,1,N),
     .                  pixu_n(1,1,N),SKY_N(N))
         if (VERBOSE)
     .   write(*,111) IT,JT,UREF_T, VREF_T, N, GGG_N(N),CCC_N(N),
     .                UTIL_N(N), VTIL_N(N),
     .                XTIL_N(N), YTIL_N(N),
     .                ITIL_N(N), JTIL_N(N),
     .                ITIL_N(N)-(_TDIM_-1)/2, ITIL_N(N)+(_TDIM_-1)/2,
     .                JTIL_N(N)-(_TDIM_-1)/2, JTIL_N(N)+(_TDIM_-1)/2,
     .                UCEN_N(N), VCEN_N(N),
     .                ICEN_N(N), JCEN_N(N),
     .                FFF_N(N),
     .                pixv_n(_TCEN_,_TCEN_,N),
     .                pixu_n(_TCEN_,_TCEN_,N),
     .                SKY_N(N),
     .                FILEPSF_N(N)(1:20),
     .                FILEGCS_N(N)(1:20),
     .                FILEPIX_N(N)(1:80)
  111    format(i3.3,1x,i3.3,5x,i4.4,1x,i4.4,5x,
     .          'N',i3.3,1x,'G',i3.3,1x,'C',i1,
     .                   1x,2f7.1,
     .                   1x,2f7.1,
     .                   1x,i5.4,1x,i5.4,
     .                   1x,'[',i5.4,':',i5.4,
     .                      ',',i5.4,':',i5.4,']',
     .                   1x,2f7.1,
     .                   1x,2i5,1x,i1,
     .                   1x,f10.1,
     .                   1x,i1,f8.2,
     .                   1x,a20,
     .                   1x,a20,
     .                   1x,a80)
         FLXRAT = 10**(ZPU_N(N)/2.5)
         do i = 0001, _TDIM_
         do j = 0001, _TDIM_
            irawu = ITIL_N(N) + (i-_TCEN_)
            jrawu = JTIL_N(N) + (j-_TCEN_)
            pixv_n(i,j,N) = pixv_n(i,j,N)/FLXRAT
            pixe_n(i,j,N) = pixe_n(i,j,N)/FLXRAT
            if (irawu.lt.imin_KKK_C(KKK_N(N),CCC_N(N)).or.
     .          irawu.gt.imax_KKK_C(KKK_N(N),CCC_N(N)).or.
     .          jrawu.lt.jmin_KKK_C(KKK_N(N),CCC_N(N)).or.
     .          jrawu.gt.jmax_KKK_C(KKK_N(N),CCC_N(N))) then
                pixv_n(i,j,N) =  -500
                pixe_n(i,j,N) = 99999
                pixu_n(i,j,N) =     3
                endif
            ut = ut_txy(i*1.,j*1.,UTAB_N(1,1,N),VTAB_N(1,1,N)) ! u-location in master tile
            vt = vt_txy(i*1.,j*1.,UTAB_N(1,1,N),VTAB_N(1,1,N)) ! v-location in master tile
            if (ut.lt.0001-5.or.ut.gt._TDIM_+5.or.             ! if we're way off the tile, then null out
     .          vt.lt.0001-5.or.vt.gt._TDIM_+5) then
                pixv_n(i,j,N) =  -500
                pixe_n(i,j,N) = 99999
                pixu_n(i,j,N) =     3
                endif
            pixm_n(i,j,N) = 0. ! start with a mask
            enddo
            enddo
         if (VERBOSE)
     .   write(*,111) IT,JT,UREF_T, VREF_T, N, GGG_N(N),CCC_N(N),
     .                UTIL_N(N), VTIL_N(N),
     .                XTIL_N(N), YTIL_N(N),
     .                ITIL_N(N), JTIL_N(N),
     .                ITIL_N(N)-(_TDIM_-1)/2, ITIL_N(N)+(_TDIM_-1)/2,
     .                JTIL_N(N)-(_TDIM_-1)/2, JTIL_N(N)+(_TDIM_-1)/2,
     .                UCEN_N(N), VCEN_N(N),
     .                ICEN_N(N), JCEN_N(N),
     .                FFF_N(N),
     .                pixv_n(_TCEN_,_TCEN_,N),
     .                pixu_n(_TCEN_,_TCEN_,N),
     .                SKY_N(N),
     .                FILEPSF_N(N)(1:20),
     .                FILEGCS_N(N)(1:20),
     .                FILEPIX_N(N)(1:80)
         enddo!N
 
      if (VERBOSE) print*,'      init_tile --- C   Ns: ',Ns,Bs
      call find_loc_brite(UREF_T,VREF_T,
     .                    Bs ,uref_b ,vref_b ,zref_bf,
     .                    BBs,uref_bb,vref_bb,zref_bbf)
 
      if (VERBOSE) then
         print*,'                           '
         print*,'INIT_TILE:  MASK_TILE...   '
         print*,'                   UREF_T: ',UREF_T
         print*,'                   VREF_T: ',VREF_T
         print*,'                   _TDIM_: ',_TDIM_
         print*,'                           '
         print*,'       CALL MASK...   Bs: ',Bs,BBs
         print*,'                           '
         print*,'                           '
         endif
      do N = 1, Ns
         if (VERBOSE) then
            if (N.lt.0010.or.N.eq.N/25*25) print*,'----> N',N,' / ',Ns
            endif
         call mask_tile(pixm_n(1,1,N),
c        call mask_tile_dummy(pixm_n(1,1,N),
     .                  KKK_N(N),CCC_N(N),FFF_N(N),FLT_N(N),
     .                  UREF_T,VREF_T,
     .                  UTIL_N(N),VTIL_N(N),ITIL_N(N),JTIL_N(N),
     .                                      XTIL_N(N),YTIL_N(N),
     .                  UTAB_N(1,1,N),VTAB_N(1,1,N),
     .                  XTAB_N(1,1,N),YTAB_N(1,1,N),
     .                  BBs,uref_bb,vref_bb,zref_bbf)
         enddo
 
 
!$omp critical(init_showmos)
      if (_SHOW_MOS_) then
         if (VERBOSE) print*,'INIT_TILE:  OUTPUT TILE_MOSAICs...'
         call show_mosaic_b1_b1('TILE_pixu',pixu_n,GGG_n,CCC_n,FFF_n,Ns)
         call show_mosaic_r4_j2('TILE_pixv',pixv_n,GGG_n,CCC_n,FFF_n,Ns)
         call show_mosaic_r4_j2('TILE_pixe',pixe_n,GGG_n,CCC_n,FFF_n,Ns)
         call show_mosaic_r4_j2('TILE_pixm',pixm_n,GGG_n,CCC_n,FFF_n,Ns)
         endif
!$omp end critical(init_showmos)
 
      if (VERBOSE) print*,'RETURN FROM init_tile...'
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/jmin_KKK_C.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------
c
c
      integer function jmin_KKK_C(KKK,C)
      implicit none
 
      integer KKK
      integer C
 
      integer jmin_KKK_C_H(4,10)
      common/jmin_KKK_C_H_/jmin_KKK_C_H
      data jmin_KKK_C_H/
     .     0000,0000,0000,0000,  ! KKK=1 PC
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     2049,0001,0000,0000,  ! KKK=5 ACS/WFC
     .     0000,0000,0000,0000,
     .     0001,0000,0000,0000,  ! KKK=7 ACS/HRC
     .     2049,0001,0000,0000,  ! KKK=8 WFC3/UVIS
     .     0001,0000,0000,0000,  ! KKK=9 WFC3/IR
     .     0000,0000,0000,0000/
 
      if (C  .lt.1.or.c  .gt.04) stop 'jmin_KKK_C: c out of bounds'
      if (KKK.lt.1.or.KKK.gt.10) stop 'jmin_KKK_C: c out of bounds'
 
      jmin_KKK_C = jmin_KKK_C_H(C,KKK)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/jmax_KKK_C.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------
c
c
      integer function jmax_KKK_C(KKK,C)
      implicit none
 
      integer KKK
      integer C
 
      integer jmax_KKK_C_H(4,10)
      common/jmax_KKK_C_/jmax_KKK_C_H
      data jmax_KKK_C_H/
     .     0000,0000,0000,0000,  ! KKK=1 PC
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     0000,0000,0000,0000,
     .     4096,2048,0000,0000,  ! KKK=5 ACS/WFC
     .     0000,0000,0000,0000,
     .     1024,0000,0000,0000,  ! KKK=7 ACS/HRC
     .     4096,2048,0000,0000,  ! KKK=8 WFC3/UVIS
     .     1014,0000,0000,0000,  ! KKK=9 WFC3/IR
     .     0000,0000,0000,0000/
 
      if (C  .lt.1.or.c  .gt.04) stop 'jmax_KKK_C: c out of bounds'
      if (KKK.lt.1.or.KKK.gt.10) stop 'jmax_KKK_C: c out of bounds'
 
      jmax_KKK_C = jmax_KKK_C_H(C,KKK)
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/mask_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c------------------------------------------------------------------
c
c there are three parameters for this model:
c
c    0) distance mapping --- dgen(NRAD)
c    1) radial   profile --- pgen(C,NRAD)
c    2) spike    profile --- sgen(C,NRAD)
c    3) spike    width   --- wgen(C,NRAD)
c
c
      subroutine mask_tile(pixm,
     .                     KKK,CCC,FFF,FLT,
     .                     UREF,VREF,
     .                     ULOC,VLOC,ILOC,JLOC,
     .                               XLOC,YLOC,
     .                     UTAB,VTAB,
     .                     XTAB,YTAB,
     .                     BBs,uref_bb,vref_bb,zref_bbf)
      implicit none
 
      real    pixm(_TDIM_,_TDIM_)
      integer KKK
      integer CCC
      integer FFF
      integer FLT
      integer UREF, VREF
      real*8  ULOC, VLOC
      integer ILOC, JLOC
      real*8  XLOC, YLOC
      real    UTAB(_TTAB_,_TTAB_), VTAB(_TTAB_,_TTAB_)
      real    XTAB(_TTAB_,_TTAB_), YTAB(_TTAB_,_TTAB_)
      integer BBs
      real*8  uref_bb(_BDIM_)
      real*8  vref_bb(_BDIM_)
      real    zref_bbf(_BDIM_,_FDIM_)
c
c----------------------------------------------------------
c
      integer BB
 
      integer dgen(23)
      common /dgen_/dgen
 
      real rgen(10,23) ! profile for radial part
      common /rgen_/rgen
 
      real sgen(10,23) ! profile for spike
      common /sgen_/sgen
 
      integer wgen(10,23) ! spike width
      common /wgen_/wgen
 
      real ANGLE_XC(4,10) ! x angle at the 4 corners   !  3  4
      common /angle_xc_/angle_xc                       !  1  2
      data angle_xc/
     .  000.00, 000.00, 000.00, 000.00, !  1
     .  000.00, 000.00, 000.00, 000.00, !  2
     .  000.00, 000.00, 000.00, 000.00, !  3
     .  000.00, 000.00, 000.00, 000.00, !  4
     .   -1.40,  -1.30,  -4.00,  -2.30, !  5
     .  000.00, 000.00, 000.00, 000.00, !  6
     .   -6.00,  -6.00,  -6.00,  -6.00, !  7
     .   43.02,  43.29,  43.03,  43.11, !  8
     .  048.10, 048.10, 048.10, 048.10, !  9
     .  000.00, 000.00, 000.00, 000.00/ ! 10
 
      real ANGLE_YC(4,10) ! y angle at the 4 corners
      common /angle_yc_/angle_yc
      data angle_yc/
     .  090.00, 090.00, 090.00, 090.00, !  1
     .  090.00, 090.00, 090.00, 090.00, !  2
     .  090.00, 090.00, 090.00, 090.00, !  3
     .  090.00, 090.00, 090.00, 090.00, !  4
     .  092.40, 091.50, 093.80, 091.60, !  5
     .  090.00, 090.00, 090.00, 090.00, !  6
     .  090.00, 090.00, 090.00, 090.00, !  7
     .  -46.21, -46.78, -46.84, -47.39, !  8
     .  -48.10, -48.10, -48.10, -48.10, !  9
     .  090.00, 090.00, 090.00, 090.00/ ! 10
 
      integer ANGLE_EC(10) ! extent ... where are the corners?
      common /angle_ec_/angle_ec
      data angle_ec/
     .   800,  800,  800,  800, 4096,
     .  4096, 1024, 4096, 4096, 1014/
 
      integer F
      real fx, fy, fr
      real angle_x, angle_y
      real cosx, sinx
      real cosy, siny
      real mu, zu, zr
      integer i, iu, ic, ii
      integer j, ju, jc, jj
      integer NR
      integer ir, di, q
      real    rr, rru
      real    fxl(4), fyl(4)
      character*80 FILENAME
      real    dxa, dya
      real    dxb, dyb
      integer IRs
      real*8  xcor, ycor
      real*8  xraw, yraw
      integer iraw, jraw
      real*8  xcor0,ycor0
 
      real*4    , dimension(:), allocatable :: rprofi
      real*4    , dimension(:), allocatable :: sprofi
      real*4    , dimension(:), allocatable :: wprofi
 
      real*4    , dimension(:,:), allocatable ::  mask0
      real*4    , dimension(:,:), allocatable ::  mask1
      real*4    , dimension(:,:), allocatable ::  mask2
      real*4    , dimension(:,:), allocatable ::  mask3
 
      integer*4 , dimension(:), allocatable :: ia1, ib1
      integer*4 , dimension(:), allocatable :: ia2, ib2
      integer*4 , dimension(:), allocatable :: ia3, ib3
 
      integer ja1, jb1, ja2, jb2, ja3, jb3
 
      real xx, yy
      real    z, zmax
      integer FMAX
 
      real    rprof_ik
      real    sprof_ik
      integer wprof_ik
      integer ib, jb
      logical same
      real    xr_uv, yr_uv
 
      real*4 , dimension(:,:), allocatable ::  pixm_max
      real*4 , dimension(:,:), allocatable ::  pixm_sum
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
c
c-------------------------------------------------------------
c
 
      allocate(rprofi(1001))
      allocate(sprofi(1001))
      allocate(wprofi(1001))
 
      allocate(mask0(2001,2001))
      allocate(mask1(2001,2001))
      allocate(mask2(2001,2001))
      allocate(mask3(2001,2001))
 
      allocate(ia1(2001))
      allocate(ib1(2001))
      allocate(ia2(2001))
      allocate(ib2(2001))
      allocate(ia3(2001))
      allocate(ib3(2001))
 
      allocate(pixm_max(_TDIM_,_TDIM_))
      allocate(pixm_sum(_TDIM_,_TDIM_))
 
      if (VERBOSE.and.(.false.)) then
         print*,'                 '
         print*,'ENTER MASK_TILE: ',UREF,VREF
         print*,'            KKK: ',KKK
         print*,'            CCC: ',CCC
         print*,'            FFF: ',FFF
         print*,'            FLT: ',FLT
         print*,'            BBs: ',BBs
         print*,'                 '
         endif
 
c     if (VERBOSE) print*,'----> a: '
      fx = 0.5
      fy = 0.5
      if (KKK.eq.5) then ! ACS/WFC
         fx = ILOC/4096.0
         fy = JLOC/4096.0
         endif
      if (KKK.eq.7) then ! ACS/WFC
         fx = ILOC/1024.0
         fy = JLOC/1024.0
         endif
      if (KKK.eq.8) then ! ACS/WFC
         fx = ILOC/4096.0
         fy = JLOC/4096.0
         endif
      if (KKK.eq.8) then ! ACS/WFC
         fx = ILOC/4096.0
         fy = JLOC/4096.0
         endif
      if (fx.lt.0.00) fx = 0.0
      if (fy.lt.0.00) fy = 0.0
      if (fx.gt.1.00) fx = 1.0
      if (fy.gt.1.00) fy = 1.0
 
 
c     if (VERBOSE) print*,'----> b: '
      ANGLE_X = (1-fx)*(1-fy)*ANGLE_XC(1,KKK)
     .        + ( fx )*(1-fy)*ANGLE_XC(2,KKK)
     .        + (1-fx)*( fy )*ANGLE_XC(3,KKK)
     .        + ( fx )*( fy )*ANGLE_XC(4,KKK)
      ANGLE_Y = (1-fx)*(1-fy)*ANGLE_YC(1,KKK)
     .        + ( fx )*(1-fy)*ANGLE_YC(2,KKK)
     .        + (1-fx)*( fy )*ANGLE_YC(3,KKK)
     .        + ( fx )*( fy )*ANGLE_YC(4,KKK)
      cosx = cos(ANGLE_X*3.14159/180)
      sinx = sin(ANGLE_X*3.14159/180)
      cosy = cos(ANGLE_Y*3.14159/180)
      siny = sin(ANGLE_Y*3.14159/180)
      ja1 = 2001
      ja2 = 2001
      ja3 = 2001
      jb1 = 0001
      jb2 = 0001
      jb3 = 0001
      do j = 0001, 2001
         ia1(j) = 2001
         ib1(j) = 0001
         ia2(j) = 2001
         ib2(j) = 0001
         ia3(j) = 2001
         ib3(j) = 0001
         do i = 0001, 2001
            mask0(i,j) = 0.00
            mask1(i,j) = 0.00
            mask2(i,j) = 0.00
            mask3(i,j) = 0.00
            ir = 1 + sqrt((i-1001.)**2+(j-1001.)**2)
            if (ir.le.1001) then
               mask1(i,j) = mask1(i,j) + rprof_ik(ir,KKK)
               dya = (i-1001)*sinx - (j-1001)*cosx
               if (abs(dya).lt.wprof_ik(ir,KKK)) then
                  mask2(i,j) = mask2(i,j) + sprof_ik(ir,KKK)
                  endif
               dyb = (i-1001)*siny - (j-1001)*cosy
               if (abs(dyb).lt.wprof_ik(ir,KKK)) then
                  mask3(i,j) = mask3(i,j) + sprof_ik(ir,KKK)
                  endif
               endif
            mask0(i,j) = mask1(i,j) + mask2(i,j) + mask3(i,j)
            enddo
         ia1(j) = 2001
         ia2(j) = 2001
         ia3(j) = 2001
         ib1(j) = 0001
         ib2(j) = 0001
         ib3(j) = 0001
         do i = 0001, 2001
            if (mask1(i,j).gt.0) ib1(j) = i
            if (mask2(i,j).gt.0) ib2(j) = i
            if (mask3(i,j).gt.0) ib3(j) = i
            enddo
         do i = 2001, 0001, -1
            if (mask1(i,j).gt.0) ia1(j) = i
            if (mask2(i,j).gt.0) ia2(j) = i
            if (mask3(i,j).gt.0) ia3(j) = i
            enddo
         if (ia1(j).ne.2001) then
            ja1 = min(j,ja1)
            jb1 = max(j,jb1)
            endif
         if (ia2(j).ne.2001) then
            ja2 = min(j,ja2)
            jb2 = max(j,jb2)
            endif
         if (ia3(j).ne.2001) then
            ja3 = min(j,ja3)
            jb3 = max(j,jb3)
            endif
         enddo
 
c     call writfits_r4('mask0.fits',mask0,2001,2001)
c     call writfits_r4('mask1.fits',mask1,2001,2001)
c     call writfits_r4('mask2.fits',mask2,2001,2001)
c     call writfits_r4('mask3.fits',mask3,2001,2001)
 
c     if (VERBOSE) print*,'----> c: '
      do i = 001, _TDIM_
      do j = 001, _TDIM_
         pixm_max(i,j) = 0.
         pixm_sum(i,j) = 0.
         enddo
         enddo
 
c     if (VERBOSE) print*,'----> d: ',BBs
      do BB = 1, BBs
         zu = zref_bbf(BB,FFF)
 
         xraw = xr_uv(uref_bb(BB),vref_bb(BB),
     .                xtab,ytab,ILOC,JLOC,UREF,VREF)
         yraw = yr_uv(uref_bb(BB),vref_bb(BB),
     .                xtab,ytab,ILOC,JLOC,UREF,VREF)
 
         iraw = int(xraw+0.5)
         jraw = int(yraw+0.5)
         iu = iraw - ILOC + _TCEN_
         ju = jraw - JLOC + _TCEN_
 
         if (VERBOSE.and.(.false.)) then
            write(*,119) BB,xraw,yraw,
     .                      uref_bb(BB), vref_bb(BB),
     .                      zref_bbf(BB,FFF), zu
  119       format(10x,i4,5x,f10.2,1x,f10.2,
     .                    5x,f10.2,1x,f10.2,1x,2f12.1)
            endif
 
         if (iu+1000.le. 0001 ) goto 333
         if (ju+1000.le. 0001 ) goto 333
         if (iu-1000.ge._TDIM_) goto 333
         if (ju-1000.ge._TDIM_) goto 333
 
         do j = ja2, jb2
            jj = ju + (j-1001)
            if (jj.ge.001.and.jj.le._TDIM_) then
               do i = ia2(j), ib2(j)
                  ii = iu + (i-1001)
                  if (ii.ge.001.and.ii.le._TDIM_) then
                     pixm_sum(ii,jj)= pixm_sum(ii,jj)+(zu*mask2(i,j))**2
                     pixm_max(ii,jj)= max(pixm_max(ii,jj),zu*mask2(i,j))
                     endif
                  enddo
               endif
            enddo
 
         do j = ja3, jb3
            jj = ju + (j-1001)
            if (jj.ge.001.and.jj.le._TDIM_) then
               do i = ia3(j), ib3(j)
                  ii = iu + (i-1001)
                  if (ii.ge.001.and.ii.le._TDIM_) then
                     pixm_sum(ii,jj)= pixm_sum(ii,jj)+(zu*mask3(i,j))**2
                     pixm_max(ii,jj)= max(pixm_max(ii,jj),zu*mask3(i,j))
                     endif
                  enddo
               endif
            enddo
 
c        if (iu+iref_bb(BB).lt. 0001 ) goto 333
c        if (iu-iref_bb(BB).gt._TDIM_) goto 333
c        if (ju+jref_bb(BB).lt. 0001 ) goto 333
c        if (ju-jref_bb(BB).gt._TDIM_) goto 333
 
         do j = ja1, jb1
            jj = ju + (j-1001)
            if (jj.ge.001.and.jj.le._TDIM_) then
               do i = ia1(j), ib1(j)
                  ii = iu + (i-1001)
                  if (ii.ge.001.and.ii.le._TDIM_) then
                     pixm_sum(ii,jj)= pixm_sum(ii,jj)+(zu*mask1(i,j))**2
                     pixm_max(ii,jj)= max(pixm_max(ii,jj),zu*mask1(i,j))
                     endif
                  enddo
               endif
            enddo
 
  333    continue
         enddo!BB
 
c     if (VERBOSE) print*,'----> e: '
 
      do i = 0001, _TDIM_
      do j = 0001, _TDIM_
        !if (pixm(i,j).gt.30000) pixm(i,j) = 30000
        !pixm(i,j) = min(pixm_sum(i,j),2*pixm_max(i,j))
         pixm(i,j) = sqrt(pixm_sum(i,j))
         enddo
         enddo
 
c     if (VERBOSE) print*,'----> f: '
c     call writfits_r4('pixm.fits',pixm,_TDIM_,_TDIM_)
 
      deallocate(rprofi)
      deallocate(sprofi)
      deallocate(wprofi)
 
      deallocate(mask0)
      deallocate(mask1)
      deallocate(mask2)
      deallocate(mask3)
 
      deallocate(ia1)
      deallocate(ib2)
      deallocate(ia3)
      deallocate(ib1)
      deallocate(ia2)
      deallocate(ib3)
 
      deallocate(pixm_max)
      deallocate(pixm_sum)
 
      return
      end
 
 
 
c------------------------------------
c
      subroutine swap(a,b)
      real a,b
      real c
      c = a
      a = b
      b = c
      return
      end
 
      subroutine swdp(a,b)
      real*8 a,b
      real*8 c
      c = a
      a = b
      b = c
      return
      end
 
 
 
c------------------------------------------------------
c
c this will act like a simple array
c
      real function rprof_ik(ir,k)
      implicit none
 
      integer ir, k
      real rprof_arr(1001,10)
      common /rprof_arr_/rprof_arr
 
      integer dgen(23)
      common /dgen_/dgen
 
      real rgen(10,23)
      common /rgen_/rgen
 
      logical first_rprof
      common /first_rprof_/ first_rprof
      data first_rprof/.true./
 
      integer i, ii, iiu
      integer kk
      real    ff
 
      if (first_rprof) then
         do i = 0001, 1001
            iiu = 0
            do ii = 1, 22
               if (i.ge.dgen(ii)) iiu = ii
               enddo
            if (iiu.eq.00) stop 'screech iiu.eq.00'
            if (iiu.ge.23) stop 'screech iiu.ge.23'
            ff = (i-dgen(iiu))*1.0/(dgen(iiu+1)-dgen(iiu))
            do kk = 01, 10
               rprof_arr(i,kk) = rgen(kk,iiu)
     .                         + ff*(rgen(kk,iiu+1)-rgen(kk,iiu))
               enddo
            enddo
         first_rprof = .false.
         endif
 
      rprof_ik = 0.
      if (ir.lt.0001.or.ir.gt.1001) return
      rprof_ik = rprof_arr(ir,k)
 
      return
      end
 
 
 
c------------------------------------------------------
c
c this will act like a simple array ; the spike profile
c
      real function sprof_ik(ir,k)
      implicit none
 
      integer ir, k
      real sprof_arr(1001,10)
      common /sprof_arr_/sprof_arr
 
      integer dgen(23)
      common /dgen_/dgen
 
      real sgen(10,23)
      common /sgen_/sgen
 
      logical first_sprof
      common /first_sprof_/ first_sprof
      data first_sprof/.true./
 
      integer i, ii, iiu
      integer kk
      real    ff
 
      if (first_sprof) then
         do i = 0001, 1001
            iiu = 0
            do ii = 1, 22
               if (i.ge.dgen(ii)) iiu = ii
               enddo
            if (iiu.eq.00) stop 'screech iiu.eq.00'
            if (iiu.ge.23) stop 'screech iiu.ge.23'
            ff = (i-dgen(iiu))*1.0/(dgen(iiu+1)-dgen(iiu))
            do kk = 01, 10
               sprof_arr(i,kk) = sgen(kk,iiu)
     .                         + ff*(sgen(kk,iiu+1)-sgen(kk,iiu))
               enddo
            enddo
         first_sprof = .false.
         endif
 
      sprof_ik = 0.
      if (ir.lt.0001.or.ir.gt.1001) return
      sprof_ik = sprof_arr(ir,k)
 
      return
      end
 
 
 
c------------------------------------------------------
c
c this will act like a simple array ; the spike-width profile
c
      integer function wprof_ik(ir,k)
      implicit none
 
      integer ir, k
      integer wprof_arr(1001,10)
      common /wprof_arr_/wprof_arr
 
      integer dgen(23)
      common /dgen_/dgen
 
      integer wgen(10,23)
      common /wgen_/wgen
 
      logical first_wprof
      common /first_wprof_/ first_wprof
      data first_wprof/.true./
 
      integer i, ii, iiu
      integer kk
      real    ff
 
      if (first_wprof) then
         do i = 0001, 1001
            iiu = 0
            do ii = 1, 22
               if (i.ge.dgen(ii)) iiu = ii
               enddo
            if (iiu.eq.00) stop 'screech iiu.eq.00'
            if (iiu.ge.23) stop 'screech iiu.ge.23'
            ff = (i-dgen(iiu))*1.0/(dgen(iiu+1)-dgen(iiu))
            do kk = 01, 10
               wprof_arr(i,kk) = wgen(kk,iiu)
     .                         + ff*(wgen(kk,iiu+1)-wgen(kk,iiu)) + 0.5
               enddo
            enddo
         first_wprof = .false.
         endif
 
      wprof_ik = 0.
      if (ir.lt.0001.or.ir.gt.1001) return
      wprof_ik = wprof_arr(ir,k)
 
      return
      end
 
 
 
c-------------------------------------------------
c this regulates the radial parametrization
c
      block data bd_dgen
      integer dgen(23)
      common /dgen_/dgen
      data dgen/
     . 0000, 0005, 0010, 0015, 0020, 0030, 0040, 0050, 0060, 0075,
     . 0100, 0125, 0150, 0200, 0250, 0300, 0400, 0500, 0600, 0700,
     . 0800, 0900, 1000/
      end
 
 
c-------------------------------------------------
c this regulates the radial profile
c
      block data bd_rgen
      real rgen(10,23) ! profile for radial part
      common /rgen_/rgen
      data rgen/
c       PC1  WF2   WF3   WF4   WFCb  WFCt  HRC   WFC3 WFC3IR
c       1     2     3     4     5     6     7     8     9   10
     . 0e-00,0e-00,0e-00,0e-00,8e-04,0e-00,6e-03,1e-03,7e-04,0e-00, ! 000 --- 01
     . 0e-00,0e-00,0e-00,0e-00,4e-04,0e-00,3e-03,1e-03,5e-04,0e-00, ! 005 --- 02
     . 0e-00,0e-00,0e-00,0e-00,2e-04,0e-00,2e-03,5e-04,7e-05,0e-00, ! 010 --- 03
     . 0e-00,0e-00,0e-00,0e-00,4e-05,0e-00,6e-04,2e-04,3e-05,0e-00, ! 015 --- 04
     . 0e-00,0e-00,0e-00,0e-00,1e-05,0e-00,3e-04,1e-05,1e-05,0e-00, ! 020 --- 05
     . 0e-00,0e-00,0e-00,0e-00,5e-06,0e-00,4e-05,6e-06,4e-06,0e-00, ! 030 --- 06
     . 0e-00,0e-00,0e-00,0e-00,2e-06,0e-00,8e-06,5e-06,2e-06,0e-00, ! 040 --- 07
     . 0e-00,0e-00,0e-00,0e-00,1e-06,0e-00,1e-06,4e-06,1e-06,0e-00, ! 050 --- 08
     . 0e-00,0e-00,0e-00,0e-00,8e-07,0e-00,0e-00,2e-06,6e-07,0e-00, ! 060 --- 09
     . 0e-00,0e-00,0e-00,0e-00,3e-07,0e-00,0e-00,8e-07,2e-08,0e-00, ! 075 --- 10
     . 0e-00,0e-00,0e-00,0e-00,1e-07,0e-00,0e-00,2e-07,1e-08,0e-00, ! 100 --- 11
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,1e-07,0e-00,0e-00, ! 125 --- 12
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,6e-08,0e-00,0e-00, ! 150 --- 13
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,3e-08,0e-00,0e-00, ! 200 --- 14
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,1e-08,0e-00,0e-00, ! 250 --- 15
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00, ! 300 --- 16
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00, ! 400 --- 17
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00, ! 500 --- 18
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00, ! 600 --- 19
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00, ! 700 --- 20
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00, ! 800 --- 21
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00, ! 900 --- 22
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00/ !1000 --- 23
      end
 
 
c-------------------------------------------------
c this regulates the spike profile
c
      block data bd_sgen
      real sgen(10,23) ! profile for spike
      common /sgen_/sgen
      data sgen/
c       1     2     3     4     5     6     7     8     9   10
     . 0e-00,0e-00,0e-00,0e-00,0e-05,0e-00,0e-03,0e-04,0e-04,0e-00, ! 000 --- 01
     . 0e-00,0e-00,0e-00,0e-00,4e-05,0e-00,2e-04,4e-05,2e-04,0e-00, ! 005 --- 02
     . 0e-00,0e-00,0e-00,0e-00,8e-05,0e-00,3e-04,7e-05,6e-04,0e-00, ! 010 --- 03
     . 0e-00,0e-00,0e-00,0e-00,5e-05,0e-00,1e-04,7e-05,4e-04,0e-00, ! 015 --- 04
     . 0e-00,0e-00,0e-00,0e-00,3e-05,0e-00,5e-05,5e-05,2e-04,0e-00, ! 020 --- 05
     . 0e-00,0e-00,0e-00,0e-00,2e-05,0e-00,4e-05,4e-05,6e-05,0e-00, ! 030 --- 06
     . 0e-00,0e-00,0e-00,0e-00,1e-05,0e-00,3e-05,3e-05,3e-05,0e-00, ! 040 --- 07
     . 0e-00,0e-00,0e-00,0e-00,1e-05,0e-00,2e-05,2e-05,1e-05,0e-00, ! 050 --- 08
     . 0e-00,0e-00,0e-00,0e-00,8e-06,0e-00,1e-05,1e-05,8e-06,0e-00, ! 060 --- 09
     . 0e-00,0e-00,0e-00,0e-00,4e-06,0e-00,5e-06,8e-06,6e-06,0e-00, ! 075 --- 10
     . 0e-00,0e-00,0e-00,0e-00,2e-06,0e-00,0e-00,6e-06,5e-06,0e-00, ! 100 --- 11
     . 0e-00,0e-00,0e-00,0e-00,1e-06,0e-00,0e-00,4e-06,3e-06,0e-00, ! 125 --- 12
     . 0e-00,0e-00,0e-00,0e-00,3e-07,0e-00,0e-00,2e-06,2e-06,0e-00, ! 150 --- 13
     . 0e-00,0e-00,0e-00,0e-00,2e-07,0e-00,0e-00,1e-06,1e-06,0e-00, ! 200 --- 14
     . 0e-00,0e-00,0e-00,0e-00,1e-07,0e-00,0e-00,6e-07,6e-07,0e-00, ! 250 --- 15
     . 0e-00,0e-00,0e-00,0e-00,4e-08,0e-00,0e-00,3e-07,4e-07,0e-00, ! 300 --- 16
     . 0e-00,0e-00,0e-00,0e-00,1e-08,0e-00,0e-00,1e-07,2e-07,0e-00, ! 400 --- 17
     . 0e-00,0e-00,0e-00,0e-00,4e-09,0e-00,0e-00,5e-08,1e-07,0e-00, ! 500 --- 18
     . 0e-00,0e-00,0e-00,0e-00,1e-09,0e-00,0e-00,3e-08,5e-08,0e-00, ! 600 --- 19
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,3e-08,4e-08,0e-00, ! 700 --- 20
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,3e-08,3e-08,0e-00, ! 800 --- 21
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,2e-08,2e-08,0e-00, ! 900 --- 22
     . 0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,0e-00,1e-08,1e-08,0e-00/ !1000 --- 23
 
 
 
 
      end
 
 
c-------------------------------------------------
c this regulates the spike width
c
      block data bd_wgen
      integer wgen(10,23) ! spike width
      common /wgen_/wgen
      data wgen/
c
c       1  2  3  4  5  6  7  8  9 10
c
     .  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, ! 000 --- 01
     .  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, ! 005 --- 02
     .  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, ! 010 --- 03
     .  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, ! 015 --- 04
     .  5, 5, 5, 5, 4, 5, 5, 4, 5, 5, ! 020 --- 05
     .  5, 5, 5, 5, 4, 5, 5, 4, 5, 5, ! 030 --- 06
     .  5, 5, 5, 5, 3, 5, 5, 3, 5, 5, ! 040 --- 07
     .  5, 5, 5, 5, 3, 5, 5, 3, 5, 5, ! 050 --- 08
     .  5, 5, 5, 5, 3, 5, 5, 3, 5, 5, ! 060 --- 09
     .  5, 5, 5, 5, 3, 5, 5, 3, 5, 5, ! 075 --- 10
     .  5, 5, 5, 5, 3, 5, 5, 3, 5, 5, ! 100 --- 11
     .  5, 5, 5, 5, 3, 5, 5, 3, 5, 5, ! 125 --- 12
     .  5, 5, 5, 5, 3, 5, 5, 3, 5, 5, ! 150 --- 13
     .  5, 5, 5, 5, 3, 5, 5, 3, 6, 5, ! 200 --- 14
     .  5, 5, 5, 5, 3, 5, 5, 3, 6, 5, ! 250 --- 15
     .  5, 5, 5, 5, 3, 5, 5, 3, 8, 5, ! 300 --- 16
     .  5, 5, 5, 5, 4, 5, 5, 2,10, 5, ! 400 --- 17
     .  5, 5, 5, 5, 4, 5, 5, 2,11, 5, ! 500 --- 18
     .  5, 5, 5, 5, 4, 5, 5, 2,12, 5, ! 600 --- 19
     .  5, 5, 5, 5, 5, 5, 5, 2,13, 5, ! 700 --- 20
     .  5, 5, 5, 5, 5, 5, 5, 2,14, 5, ! 800 --- 21
     .  5, 5, 5, 5, 5, 5, 5, 2,15, 5, ! 900 --- 22
     .  5, 5, 5, 5, 5, 5, 5, 2,15, 5/ !1000 --- 23
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth0_barsigw.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine barsigw_meth0(pl,wl,Ls,Lu,bar,sig)
      implicit none
 
      real pl(1), wl(1)
      integer Ls
      integer Lu
      real bar, sig
 
      real ptot, wtot
 
      integer L
      byte    ul(1000)
      logical again
      integer utot
 
      if (Ls.le.10) then
         bar = 0.
         sig = 9999.
         Lu = 0
         return
         endif
 
      utot = 0
      do L = 1, Ls
         ul(L) = 1
         utot = utot + ul(L)
         enddo
 
 
      bar = 0.00
      sig = 9e9
    1 continue
 
      ptot = 0.
      wtot = 0.
      utot = 0
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*pl(L)
         wtot = wtot + ul(L)*wl(L)
         utot = utot + ul(L)
         enddo
      bar = ptot/wtot
 
      ptot = 0.
      wtot = 0.
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*abs(pl(L)-bar)
         wtot = wtot + ul(L)*wl(L)
         enddo
      sig = ptot/wtot
 
      again = .false.
      do L = 1, Ls
         if (ul(L).eq.1.and.abs(pl(L)-bar).gt.2.5*sig) then
            ul(L) = 0
            again = .true.
            endif
         enddo
 
      if (again) goto 1
 
      Lu = utot
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth0_xyz_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c
c look up "NOTE TO SELF"
c
c
c QQQ inefficient for AS tests... it will
c     simulate the entire image...
c
 
 
c--------------------------------------------------------------------------
c
c this takes in the list of current stars in the tile
c and finds (1) a flux with fixed positions, and
c           (2) positions at fixed fluxes
c
c it modifies the inputs given to it
c
      subroutine meth0_xyz_tile(Lo, Ls,
     .                           u0_l,  v0_l,   z0_lf,
     .                          su0_l, sv0_l,  sz0_lf,
     .                           f0_lf, g0_lf,   w_l,
     .                           u0_ln, v0_ln,  z0_ln,
     .                          sz0_ln,gp0_ln, gz0_ln,
     .                           Ns,UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                           pixv_n, pixe_n, pixm_n, pixu_n,
     .                           psf_n,
     .                           FFF_n, POS_N, FND_N, RAP_N, NIT)
      implicit none
 
      integer     Lo                                           ! the first one to act on
      integer     Ls                                           ! the last one to act on
      real        u0_l(_LDIM_),  v0_l(_LDIM_)                  ! the list of (x,y,z) in the ref frame
      real       su0_l(_LDIM_), sv0_l(_LDIM_)                  ! the associated errors
      real       z0_lf(_LDIM_,_FDIM_), sz0_lf(_LDIM_,_FDIM_)
      integer*2  g0_lf(_LDIM_,_FDIM_)
      integer*2  f0_lf(_LDIM_,_FDIM_)
      integer      w_l(_LDIM_)                                 ! which finding pass?  "0" means given, no chg
      real       u0_ln(_LDIM_,_NDIM_),  v0_ln(_LDIM_,_NDIM_)
      real       z0_ln(_LDIM_,_NDIM_), sz0_ln(_LDIM_,_NDIM_)
      integer*2 gz0_ln(_LDIM_,_NDIM_)
      integer*2 gp0_ln(_LDIM_,_NDIM_)
 
      integer Ns                                                ! number of images to use
 
      real      UTAB_N(_TTAB_,_TTAB_,_NDIM_)                    ! table based trans for frames 1-->N
      real      VTAB_N(_TTAB_,_TTAB_,_NDIM_)
      real      XTAB_N(_TTAB_,_TTAB_,_NDIM_)
      real      YTAB_N(_TTAB_,_TTAB_,_NDIM_)
 
      real      pixv_n(_TDIM_,_TDIM_,_NDIM_)                    ! pixel value info for image 1-->N
      real      pixe_n(_TDIM_,_TDIM_,_NDIM_)                    ! error arrays
      real      pixm_n(_TDIM_,_TDIM_,_NDIM_)                    ! mask arrays
      byte      pixu_n(_TDIM_,_TDIM_,_NDIM_)                    ! use arrays
      real      pixd_n(_TDIM_,_TDIM_,_NDIM_)
 
      real      psf_n(101,101,_NDIM_)                           ! psf
      integer   FFF_N(_NDIM_)                                   ! which filter?
 
      character*9 POS_N(_NDIM_)                                 ! used in positioning?
      character*9 FND_N(_NDIM_)                                 ! used in finding?
      integer     RAP_N(_NDIM_)
      integer     NIT
c
c-------------------------------------------------------
c
      integer   L, LL
      integer   i, j
      real      dx, dy, rpsf_phot, rpsf_photu
 
      real*4   , dimension(:,:), allocatable ::    tempp
      real*4   , dimension(:,:), allocatable ::    tempw
      real*4   , dimension(:,:), allocatable ::    tempe
 
      integer*4, dimension(:,:), allocatable ::    ga_ln
      integer*4, dimension(:,:), allocatable ::    gb_ln
 
      real*4   , dimension(:,:), allocatable ::    x0_ln,  y0_ln  ! this is what came in, transformed into the
      integer*4, dimension(:,:), allocatable ::    i0_ln,  j0_ln  !    individual frames
      real*4   , dimension(:,:), allocatable ::    zi_ln
 
      real*4   , dimension(:,:), allocatable ::    xa_ln,  ya_ln  ! results for approach "a" ; finding positions only
      real*4   , dimension(:,:), allocatable ::    za_ln, sza_ln
      real*4   , dimension(:,:), allocatable ::    ua_ln,  va_ln
      real*4   , dimension(:,:), allocatable ::    sa_ln, ssa_ln
 
      real*4   , dimension(:,:), allocatable ::    zb_ln, szb_ln  ! results for approach "b" ; finding fluxes only
 
      real*4   , dimension(:)  , allocatable ::    ua_l, sua_l    ! these are what we'd like to output
      real*4   , dimension(:)  , allocatable ::    va_l, sva_l    ! but some error/limit checking will be
      real*4   , dimension(:,:), allocatable ::    zb_lf
      real*4   , dimension(:,:), allocatable ::   szb_lf
      real*4   , dimension(:,:), allocatable ::    za_lf
      real*4   , dimension(:,:), allocatable ::   sza_lf
      real*4   , dimension(:,:), allocatable ::   pixmod
      real*4   , dimension(:)  , allocatable ::  xprox_p, yprox_p
      integer*4, dimension(:)  , allocatable ::  f0_l
      integer*4, dimension(:)  , allocatable ::  g0_l
 
      integer*4, dimension(:,:), allocatable ::  gz_ln
      integer*4, dimension(:,:), allocatable ::  fz_ln
      integer*4, dimension(:,:), allocatable ::  gp_ln
      integer*4, dimension(:,:), allocatable ::  fp_ln
 
      real    d
      integer w
      real fmax
 
      integer NSAT
 
      integer F
      integer N
      real xt_tuv, yt_tuv
      real ut_txy, vt_txy
 
      real    ssig
      integer Su
      real    oth, wtt
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
 
      integer Ps
 
      logical DO_POS
 
 
      logical METH0_DIAG
      common  /METH0_DIAG_/METH0_DIAG
      data     METH0_DIAG/.false./
 
 
 
      allocate(tempp(_TDIM_,_TDIM_))
      allocate(tempw(_TDIM_,_TDIM_))
      allocate(tempe(_TDIM_,_TDIM_))
 
      allocate(ga_ln(_LDIM_,Ns))
      allocate(gb_ln(_LDIM_,Ns))
 
      allocate(x0_ln(_LDIM_,Ns),  y0_ln(_LDIM_,Ns))     ! this is what came in, transformed into the
      allocate(i0_ln(_LDIM_,Ns),  j0_ln(_LDIM_,Ns))     !    individual frames
      allocate(zi_ln(_LDIM_,Ns))
 
      allocate(xa_ln(_LDIM_,Ns),  ya_ln(_LDIM_,Ns))     ! results for approach "a" ; finding positions only
      allocate(za_ln(_LDIM_,Ns), sza_ln(_LDIM_,Ns))
      allocate(ua_ln(_LDIM_,Ns),  va_ln(_LDIM_,Ns))
      allocate(sa_ln(_LDIM_,Ns), ssa_ln(_LDIM_,Ns))
 
      allocate(zb_ln(_LDIM_,Ns), szb_ln(_LDIM_,Ns))     ! results for approach "b" ; finding fluxes only
 
      allocate(   ua_l(_LDIM_), sua_l(_LDIM_))  ! these are what we'd like to output
      allocate(   va_l(_LDIM_), sva_l(_LDIM_))  ! but some error/limit checking will be
      allocate(   zb_lf(_LDIM_,_FDIM_))         ! needed
      allocate(  szb_lf(_LDIM_,_FDIM_))
      allocate(   za_lf(_LDIM_,_FDIM_))         ! needed
      allocate(  sza_lf(_LDIM_,_FDIM_))
      allocate(  pixmod(_TDIM_,_TDIM_))
      allocate( xprox_p(99), yprox_p(99))
      allocate( f0_l(_LDIM_))
      allocate( g0_l(_LDIM_))
 
      allocate( gz_ln(_LDIM_,Ns))
      allocate( fz_ln(_LDIM_,Ns))
      allocate( gp_ln(_LDIM_,Ns))
      allocate( fp_ln(_LDIM_,Ns))
 
 
c----------------------------------------------------------
c
c transform the current star positions into the local frame
c
      do N = 1, Ns
         do L = 1, Ls
            x0_ln(L,N) = xt_tuv(u0_l(L),v0_l(L),xtab_n(1,1,N),
     .                                          ytab_n(1,1,N))
            y0_ln(L,N) = yt_tuv(u0_l(L),v0_l(L),xtab_n(1,1,N),
     .                                          ytab_n(1,1,N))
            zi_ln(L,N) = max(z0_lf(L,FFF_n(N)),0.)
            i0_ln(L,N) = int(x0_ln(L,n)+0.5)
            j0_ln(L,N) = int(y0_ln(L,n)+0.5)
 
            xa_ln(L,N) =      0.
            ya_ln(L,N) =      0.
            za_ln(L,N) =      0.
           sza_ln(L,N) = 999999.
 
            gb_ln(L,N) =      9
            zb_ln(L,N) =      0.
           szb_ln(L,N) = 999999.
 
            gz_ln(L,N) =      9
            gp_ln(L,N) =      9
            enddo
         enddo
 
 
 
 
c------------------------------------------------
c
c now, measure positions, using subtraction of
c stars by means of fluxes from above
c
      if (VERBOSE) print*,'     ---> new_positns... 1--->N: ',N,
     .                                             '    Ls: ',Ls
      do N = 1, Ns
         do i = 001, _TDIM_
         do j = 001, _TDIM_
            pixmod(i,j) = 0.
            enddo
            enddo
         do L = 1, Ls
            do i = max(i0_ln(L,N)-12,0001), min(i0_ln(L,N)+12,_TDIM_)
            do j = max(j0_ln(L,N)-12,0001), min(j0_ln(L,N)+12,_TDIM_)
               dx = x0_ln(L,N)-i
               dy = y0_ln(L,N)-j
               pixmod(i,j) = pixmod(i,j)
     .                     + zi_ln(L,N)*rpsf_phot(dx,dy,psf_n(1,1,N))!  Jay, use zb, maybe?!
               enddo
               enddo
            enddo
         do L = 1, Ls
             u0_ln(L,N) =     0.0
             v0_ln(L,N) =     0.0
             z0_ln(L,N) =     0.0
            sz0_ln(L,N) = 99999.0
            gz0_ln(L,N) =     0
            gp0_ln(L,N) =     0
            w = max(w_l(L),1)
c           DO_POS =  NIT.lt.99.and.POS_N(N)(w:w).eq.'1'
            DO_POS =  POS_N(N)(w:w).eq.'1'
            if (w_l(L).eq.6)  DO_POS = .false.
            if (w_l(L).eq.7)  DO_POS = .false.
            if (i0_ln(L,N).lt. 0001 +005) goto 4
            if (j0_ln(L,N).lt. 0001 +005) goto 4
            if (i0_ln(L,N).gt._TDIM_-005) goto 4
            if (j0_ln(L,N).gt._TDIM_-005) goto 4
            do i = i0_ln(L,N)-3, i0_ln(L,N)+3
            do j = j0_ln(L,N)-3, j0_ln(L,N)+3
               if (pixu_n(i,j,N).ne.0) goto 4
                enddo
                enddo
            Ps = 0                                                ! find all the nearby neighbors
            xprox_p(1) = 0.00                                     !    within 2.5 pixels, so that we
            yprox_p(1) = 0.00                                     !    can make sure that stars
            do LL = 1, Ls                                         !    will never overlap
               if (L.ne.LL) then
                  d = sqrt((x0_ln(L,N)-x0_ln(LL,N))**2
     .                    +(y0_ln(L,N)-y0_ln(LL,N))**2)
                  if (d.lt.2.5) then
                     Ps = Ps + 1
                     if (Ps.gt.99) stop 'Ps.gt.99'
                     xprox_p(Ps) = x0_ln(LL,N)
                     yprox_p(Ps) = y0_ln(LL,N)
                     endif
                  endif
               enddo
            call find_sky(i0_ln(L,N),j0_ln(L,N),8,12,             ! find sky for each object
     .                    pixv_n(1,1,N), pixu_n(1,1,N), pixmod,   ! Jay, shouldn't you use the subtracted?
     .                    sa_ln(L,N), ssa_ln(L,N), Su)
            do i = i0_ln(L,N)-3, i0_ln(L,N)+3                     ! construct local images
            do j = j0_ln(L,N)-3, j0_ln(L,N)+3
               oth = 0
               wtt = 0
               do LL = 1, Ls
                  if (LL.ne.L) then
                     rpsf_photu = rpsf_phot(i-x0_ln(LL,N),
     .                                      j-y0_ln(LL,N),
     .                                      psf_n(1,1,N))
                     wtt = wtt + rpsf_photu
                     oth = oth + zi_ln(LL,N)*rpsf_photu
                     endif
                  enddo
               rpsf_photu = rpsf_phot(i-x0_ln(L,N),
     .                                j-y0_ln(L,N),
     .                                psf_n(1,1,N))
               wtt = rpsf_photu/(rpsf_photu+wtt)
               tempe(i,j) = sqrt(pixe_n(i,j,N)**2 + pixm_n(i,j,N)**2)
               tempp(i,j) = pixv_n(i,j,N) - oth
               tempw(i,j) = wtt
               tempw(i,j) = 1.00                             ! Jay, you were over-weighting things
               tempw(i,j) = rpsf_photu                       ! Jay, you were over-weighting things
               enddo
               enddo
            call cap_tempw(tempw,i0_ln(L,N),j0_ln(L,N))      ! find the 4th largest wt, and set all
            xa_ln(L,N) = x0_ln(L,N)                          !   grtr ones to that
            ya_ln(L,N) = y0_ln(L,N)
            call quik_xyz(xa_ln(L,N), ya_ln(L,N),            ! fit position and flux
     .                    za_ln(L,N),sza_ln(L,N),
     .                    gp_ln(L,N), gz_ln(L,N),
     .                    tempp,tempe,tempw,psf_n(1,1,n),
     .                    i0_ln(L,N),j0_ln(L,N),sa_ln(L,N),RAP_N(N),
     .                    xprox_p, yprox_p,Ps, DO_POS)
            ua_ln(L,N) = ut_txy(xa_ln(L,N),ya_ln(L,N),
     .                          utab_N(1,1,N),vtab_N(1,1,N))
            va_ln(L,N) = vt_txy(xa_ln(L,N),ya_ln(L,N),
     .                          utab_N(1,1,N),vtab_N(1,1,N))
            if (METH0_DIAG)
     .      write(94,194) NIT,L,N,FFF_N(N),
     .                    ua_ln(L,N),va_ln(L,N),
     .                    za_ln(L,N),
     .                    gp_ln(L,N),gz_ln(L,N),
     .                    x0_ln(L,N),y0_ln(L,N),
     .                    xa_ln(L,N),ya_ln(L,N),
     .                    xprox_P(1),yprox_P(1),Ps,
     .                    DO_POS
            if (DO_POS) then
                 u0_ln(L,N) = ua_ln(L,N)
                 v0_ln(L,N) = va_ln(L,N)
                gp0_ln(L,N) = gp_ln(L,N)
                endif
            gz0_ln(L,N) =  gz_ln(L,N)
             z0_ln(L,N) =  za_ln(L,N)
            sz0_ln(L,N) = sza_ln(L,N)
  194       format(1x,i2.2,1x,'L',i3.3,1x,'N',i3.3,1x,'F',i1,1x,
     .                f8.2,1x,f8.2,1x,f10.1,2i3,1x,
     .                2f9.2,5x,2f9.2,5x,2f9.2,1x,i1,1x,l1)
    4       continue
            enddo!L
         enddo!N
 
      if (VERBOSE) print*,'     ---> find_avg_xy_f... 1--->N: ',N,
     .                                               '    Ls: ',Ls
      call find_avg_xy(ua_ln, va_ln, za_ln, sza_ln, gp_ln, Ns, 1, Ls,
     .                 ua_l, sua_l,  va_l,  sva_l,  f0_l, g0_l)
      call find_avg_z_f(za_ln,sza_ln,gz_ln,
     .                  Ns, 1,Ls,FFF_n,
     .                  za_lf,sza_lf,f0_lf,g0_lf)
 
      do L =  1, Ls
         if (g0_l(L).ge.1) then
             u0_l(L) =  ua_l(L)
             v0_l(L) =  va_l(L)
            su0_l(L) = sua_l(L)
            sv0_l(L) = sva_l(L)
            endif
         do F = 1, _FDIM_
            if (g0_lf(L,F).ge.1) then
                z0_lf(L,F) =  za_lf(L,F)
               sz0_lf(L,F) = sza_lf(L,F)
               endif
         if (METH0_DIAG)
     .       write(94,194) NIT,L,N,F,
     .                     ua_l(L), va_l(L), za_lf(L,F),
     .                     g0_l(L), g0_lf(L,F),
     .                    sua_l(L),sva_l(L),sza_lf(L,F)
            enddo
  193    format(5x,i4,1x,'L',i3.3,1x,'F',i1,1x,
     .          3(5x,2f8.2,1x,f10.1),
     .          1x,i2.2,'/',i2.2,3x,i2.2,'/',i2.2)
         if (METH0_DIAG) then
            do F = 1, _FDIM_
               write(93,193) NIT,L,F,
     .                   u0_l(L), v0_l(L), z0_lf(L,F),
     .                   ua_l(L), va_l(L), za_lf(L,F),
     .                  sua_l(L),sva_l(L),sza_lf(L,F),
     .                   g0_l(L),   f0_l(L),
     .                   g0_lf(L,F),f0_lf(L,F)
               enddo
            endif
         enddo
 
      if (METH0_DIAG) then
         close(93)
         close(94)
         endif
 
      deallocate(tempp)
      deallocate(tempw)
      deallocate(tempe)
 
      deallocate(ga_ln)
      deallocate(gb_ln)
 
      deallocate(x0_ln,  y0_ln)     ! this is what came in, transformed into the
      deallocate(i0_ln,  j0_ln)     !    individual frames
      deallocate(zi_ln)
 
      deallocate(xa_ln,  ya_ln)     ! results for approach "a" ; finding positions only
      deallocate(za_ln, sza_ln)
      deallocate(ua_ln,  va_ln)
      deallocate(sa_ln, ssa_ln)
 
      deallocate(zb_ln, szb_ln)     ! results for approach "b" ; finding fluxes only
 
      deallocate(   ua_l, sua_l)  ! these are what we'd like to output
      deallocate(   va_l, sva_l)  ! but some error/limit checking will be
      deallocate(   zb_lf)         ! needed
      deallocate(  szb_lf)
      deallocate(   za_lf)         ! needed
      deallocate(  sza_lf)
      deallocate(  pixmod)
      deallocate( xprox_p, yprox_p)
      deallocate( f0_l)
      deallocate( g0_l)
 
      deallocate( gz_ln)
      deallocate( fz_ln)
      deallocate( gp_ln)
      deallocate( fp_ln)
 
      return ! meth0
      end
 
 
 
c---------------------------------------------
c
c
c
      subroutine cap_tempw(tempw,ic,jc)      ! find the 4th largest wt, and set all
      implicit none
 
      real tempw(_TDIM_,_TDIM_)
      integer ic, jc
      integer i,j
 
      integer Ls
      real    wl(9)
      real    fbar
 
      fbar = 0.
      do i = ic-1, ic+1
      do j = jc-1, jc+1
         fbar = fbar + tempw(i,j)
         enddo
         enddo
      do i = ic-1, ic+1
      do j = jc-1, jc+1
         tempw(i,j) = fbar
         enddo
         enddo
      do i = ic-3, ic+3
      do j = jc-3, jc+3
         if (tempw(i,j).gt.fbar) tempw(i,j) = fbar
         enddo
         enddo
 
      return
      end
 
 
 
 
c---------------------------------------------
c
c this routine will fit a quick position for
c each star
c
      subroutine quik_xyz(x,y,
     .                    z1,sz1,gp,gz,
     .                    parr,earr,warr,
     .                    psf,ic0,jc0,s,RAP,
     .                    xprox_p, yprox_p,Ps, DO_POS)
      implicit none
 
      real x, y
      real z1, sz1
      integer gp, gz
      real parr(_TDIM_,_TDIM_)
      real earr(_TDIM_,_TDIM_)
      real warr(_TDIM_,_TDIM_)
      real psf(101,101)
      integer ic0, jc0
      real s
      integer RAP
      real    xprox_p(99), yprox_p(99)
      integer P, Ps
      logical DO_POS
 
      real farr(_TDIM_,_TDIM_)
      real rpsf_phot, rpsf_photu
      real qtot, qmin
      real xu,  yu, zu
      real xmin, ymin, zmin, emin
      real ptot, ftot, etot
      integer i, j
      real DD
      real wtot
      real x0, y0
      integer ic, jc
      real skuse
 
      integer NIT
      real xc, yc
      integer ii,jj
 
      logical DO_POSu
 
 
      x0  = x
      y0  = y
      z1  =      0.00
      sz1 =  99999.00
      gp  = 0
      gz  = 0
 
      ic = int(x0+0.5)
      jc = int(y0+0.5)
 
c------------------------------------------
c
c if we're going to solve for a position, then
c insist on their being a local maximum
c
c
      DO_POSu = DO_POS
      if (DO_POS) then
 
         do i = int(x0), int(x0+1.0)           ! find the max pixel within
         do j = int(y0), int(y0+1.0)           !    the fitting radius
            if (parr(i,j).gt.parr(ic,jc)) then
               ic = i
               jc = j
               endif
            enddo
            enddo
 
         if (parr(ic,jc).lt.parr(ic+1,jc  ).or.  ! if this pixel is not a local maximum,
     .       parr(ic,jc).lt.parr(ic-1,jc  ).or.  !    then don't measure it
     .       parr(ic,jc).lt.parr(ic  ,jc+1).or.
     .       parr(ic,jc).lt.parr(ic  ,jc-1).or.
     .       parr(ic,jc).lt.parr(ic+1,jc+1).or.
     .       parr(ic,jc).lt.parr(ic-1,jc+1).or.
     .       parr(ic,jc).lt.parr(ic+1,jc-1).or.
     .       parr(ic,jc).lt.parr(ic-1,jc-1).or.
     .       parr(ic,jc).lt.parr(ic-2,jc-1).or.
     .       parr(ic,jc).lt.parr(ic-2,jc  ).or.
     .       parr(ic,jc).lt.parr(ic-2,jc+1).or.
     .       parr(ic,jc).lt.parr(ic+2,jc-1).or.
     .       parr(ic,jc).lt.parr(ic+2,jc  ).or.
     .       parr(ic,jc).lt.parr(ic+2,jc+1).or.
     .       parr(ic,jc).lt.parr(ic-1,jc-2).or.
     .       parr(ic,jc).lt.parr(ic  ,jc-2).or.
     .       parr(ic,jc).lt.parr(ic+1,jc-2).or.
     .       parr(ic,jc).lt.parr(ic-1,jc+2).or.
     .       parr(ic,jc).lt.parr(ic  ,jc+2).or.
     .       parr(ic,jc).lt.parr(ic+1,jc+2)) DO_POSu = .false.
         endif
 
 
      wtot = 0.
      do i = ic-RAP, ic+RAP
      do j = jc-RAP, jc+RAP
         wtot = wtot + warr(i,j)
         enddo
         enddo
 
      do i = ic-RAP, ic+RAP                    ! normalize the weights
      do j = jc-RAP, jc+RAP
         warr(i,j) = warr(i,j)/wtot
         enddo
         enddo
 
      xc = x                          ! start with the original position
      yc = y
      if (DO_POSu) then
         xc = ic
         yc = jc
         endif
      do NIT = 1, 9                   ! by trial, find the best position
         if (NIT.eq.1) DD = 0.40
         if (NIT.eq.2) DD = 0.25
         if (NIT.eq.3) DD = 0.15
         if (NIT.eq.4) DD = 0.10
         if (NIT.eq.5) DD = 0.06
         if (NIT.eq.6) DD = 0.04
         if (NIT.eq.7) DD = 0.03
         if (NIT.eq.8) DD = 0.02
         if (NIT.eq.9) DD = 0.01
         if (.not.DO_POSu) DD = 0.00
 
         qmin = 9e19
         xmin = x0
         ymin = y0
         xmin = 0.
         ymin = 0.
         zmin = 0.
         emin = 0.
         do ii = -1, 1                ! evaluate the central position and
         do jj = -1, 1                ! eight surrounding positions
            xu = xc + DD*ii
            yu = yc + DD*jj
            if (Ps.gt.0) then
               do P = 1, Ps
                  if (sqrt((xu-xprox_p(P))**2
     .                    +(yu-yprox_p(P))**2).lt.0.80) goto 332
                  enddo
               endif
            ftot = 0.
            ptot = 0.
            etot = 0.
            do i = ic-RAP, ic+RAP
            do j = jc-RAP, jc+RAP
               farr(i,j) = rpsf_phot(i-xu,j-yu,psf)
               ptot = ptot + warr(i,j)*(parr(i,j)-s)
               ftot = ftot + warr(i,j)* farr(i,j)
               etot = etot + warr(i,j)* earr(i,j)**2
               enddo
               enddo
            zu = ptot/ftot
            qtot = 0.
            do i = ic-RAP, ic+RAP
            do j = jc-RAP, jc+RAP
               qtot = qtot + warr(i,j)*abs(parr(i,j)-s-zu*farr(i,j))
               enddo
               enddo
            if (qtot.lt.qmin) then
               qmin = qtot
               xmin = xu
               ymin = yu
               zmin = zu
               emin = sqrt(etot)
               gz   = 1
               if (DO_POSu) gp = 1
               endif
  332       continue
            enddo
            enddo
         xc = xmin
         yc = ymin
         if (.not.DO_POSu) goto 333  ! only do the central position...
         enddo
  333 continue
 
      x   = xmin
      y   = ymin
      z1  = zmin
      sz1 = emin
 
c     if (zmin.lt.0) then
c        x  = ic
c        y  = jc
c        skuse = (parr(ic-1,jc-2)
c    .           +parr(ic+0,jc-2)
c    .           +parr(ic+1,jc-2)
c    .           +parr(ic-1,jc+2)
c    .           +parr(ic+0,jc+2)
c    .           +parr(ic+1,jc+2)
c    .           +parr(ic-2,jc  )
c    .           +parr(ic+2,jc  )
c    .           +parr(ic-2,jc-1)
c    .           +parr(ic+2,jc-1)
c    .           +parr(ic-2,jc+1)
c    .           +parr(ic+2,jc+1))/12
c        z1 = (parr(ic,jc)-skuse)/psf(51,51)
c        if (z1.lt.0) z1 = 0.0
c       sz1 = z1
c        endif
 
      return
      end
 
 
 
 
 
c-----------------------------------------------------------------
c
c
      subroutine find_avg_xy(x_ln,y_ln,z_ln,sz_ln,g_ln,Ns,Lo,Ls,
     .                       xbar_l, xsig_l,
     .                       ybar_l, ysig_l,f0_l, g0_l)
      implicit none
 
      real     x_ln(_LDIM_,_NDIM_)
      real     y_ln(_LDIM_,_NDIM_)
      real     z_ln(_LDIM_,_NDIM_)
      real    sz_ln(_LDIM_,_NDIM_)
      integer  g_ln(_LDIM_,_NDIM_)
      integer  Ns, Lo, Ls
      real     xbar_l(_LDIM_),  xsig_l(_LDIM_)
      real     ybar_l(_LDIM_),  ysig_l(_LDIM_)
      integer  f0_l(_LDIM_), g0_l(_LDIM_)
 
      integer U, Us, Ug
      real    x_u(_NDIM_)
      real    y_u(_NDIM_)
      real    w_u(_NDIM_)
      integer u_u(_NDIM_)
 
      real xbar, xsig
      real ybar, ysig
      integer L
      integer N
      real wtot, Wo, Wf
 
      do L =  Lo, Ls
         Us = 0
         do N = 1, Ns
            if (g_ln(L,N).eq.1.and.z_ln(L,N).gt.0) then
               Us = Us + 1
               x_u(Us) = x_ln(L,N)
               y_u(Us) = y_ln(L,N)
               u_u(Us) = 1
               w_u(Us) = 0.01*z_ln(L,N)/sz_ln(L,N)
               w_u(Us) = 1.0
               if (w_u(Us).gt.1.00) w_u(Us) = 1.0
               endif
            enddo
         wtot = 0.
         do U = 1, Us
            wtot = wtot + w_u(U)
            enddo
         do U = 1, Us
            w_u(U) = w_u(U)/wtot
            enddo
         call barsig_2DW_REJJ(x_u,y_u,w_u,u_u,Us,Ug,
     .                        xbar,xsig,ybar,ysig,3.5)
         xbar_l(L) = xbar
         ybar_l(L) = ybar
         xsig_l(L) = xsig
         ysig_l(L) = ysig
         f0_l(L)   = Us
         g0_l(L)   = Ug
         enddo!L
 
      return
      end
 
 
 
c---------------------------------------------------
c
c this will measure averages and dispersions for
c a weighted list of (z) ; it will allow for excluding
c one of the points...
c
      subroutine barsig_3DWX(xl,yl,zl,wl,Ls,Lu,Lx,
     .                       xbar, ybar, zbar,
     .                       xsig, ysig, zsig)
      implicit none
 
      real xl(_NDIM_)
      real yl(_NDIM_)
      real zl(_NDIM_)
      real wl(_NDIM_)
      integer Ls, Lu, Lx
      real xbar, ybar, zbar
      real xsig, ysig, zsig
 
      real xtot, ytot, ztot, wtot
      real wmax
      integer L
 
      xtot = 0.
      ytot = 0.
      ztot = 0.
      wtot = 0.
      wmax = 0.
      do L = 1, Ls
         if (L.ne.Lx) then
            xtot = xtot + wl(L)*xl(L)
            ytot = ytot + wl(L)*yl(L)
            ztot = ztot + wl(L)*zl(L)
            wtot = wtot + wl(L)
            if (wl(L).gt.wmax) wmax = wl(L)
            endif
         enddo
      if (wtot.le.0) then
         xbar = 0.000
         ybar = 0.000
         zbar = 0.000
         xsig = 9.999
         ysig = 9.999
         zsig = 99999
         Lu = 0
         return
         endif
      xbar = xtot/wtot
      ybar = ytot/wtot
      zbar = ztot/wtot
 
      xtot = 0.
      ytot = 0.
      ztot = 0.
      Lu   = 0
      do L = 1, Ls
         if (L.ne.Lx) then
            xtot = xtot + wl(L)*abs(xl(L)-xbar)
            ytot = ytot + wl(L)*abs(yl(L)-ybar)
            ztot = ztot + wl(L)*abs(zl(L)-zbar)
            if (wl(L).gt.0.0) Lu = Lu + 1
            endif
         enddo
      if (wtot.le.wmax) then
         xsig = 9.999
         ysig = 9.999
         zsig = 99999
         return
         endif
      xsig = xtot/(wtot-wmax)
      ysig = ytot/(wtot-wmax)
      zsig = ztot/(wtot-wmax)
 
      return
      end
 
 
c---------------------------------------------------
c
c this will measure averages and dispersions for
c a weighted list of (x,y) ; it will allow for excluding
c one of the points at a time...
c
      subroutine barsig_2DWX(xl,yl,wl,Ls,Lu,Lx,
     .                       xbar, ybar,
     .                       xsig, ysig)
      implicit none
 
      real xl(_NDIM_)
      real yl(_NDIM_)
      real wl(_NDIM_)
      integer Ls, Lu, Lx
      real xbar, ybar
      real xsig, ysig
 
      real xtot, ytot, wtot
      real wmax
      integer L
 
      xtot = 0.
      ytot = 0.
      wtot = 0.
      wmax = 0.
      do L = 1, Ls
         if (L.ne.Lx) then
            xtot = xtot + wl(L)*xl(L)
            ytot = ytot + wl(L)*yl(L)
            wtot = wtot + wl(L)
            if (wl(L).gt.wmax) wmax = wl(L)
            endif
         enddo
      if (wtot.le.0) then
         xbar = 0.000
         ybar = 0.000
         xsig = 9.999
         ysig = 9.999
         Lu = 0
         return
         endif
      xbar = xtot/wtot
      ybar = ytot/wtot
 
      xtot = 0.
      ytot = 0.
      Lu   = 0
      do L = 1, Ls
         if (L.ne.Lx) then
            xtot = xtot + wl(L)*abs(xl(L)-xbar)
            ytot = ytot + wl(L)*abs(yl(L)-ybar)
            if (wl(L).gt.0.0) Lu = Lu + 1
            endif
         enddo
      if (wtot.le.wmax) then
         xsig = 9.999
         ysig = 9.999
         return
         endif
      xsig = xtot/(wtot-wmax)
      ysig = ytot/(wtot-wmax)
 
      return
      end
 
 
c---------------------------------------------------
c
c this will measure averages and dispersions for
c a weighted list of (z) ; it will allow for excluding
c one of the points...
c
      subroutine barsig_1DWX(zl,wl,Ls,Lu,Lx,
     .                       zbar, zsig)
      implicit none
 
      real zl(_NDIM_)
      real wl(_NDIM_)
      integer Ls, Lu, Lx
      real zbar, zsig
 
      real wu(_NDIM_)
      real ztot, wtot
      real wmax
      integer L
 
      ztot = 0.
      wtot = 0.
      wmax = 0.
      Lu = 0
      do L = 1, Ls
         if (L.ne.Lx) then
            ztot = ztot + wl(L)*zl(L)
            wtot = wtot + wl(L)
            if (wl(L).gt.0) Lu = Lu + 1
            if (wl(L).gt.wmax) wmax = wl(L)
            endif
         enddo
      if (wtot.lt.0) then
         zbar = 0.000
         zsig = 99999
         Lu = 0
         return
         endif
      zbar = ztot/wtot
 
      ztot = 0.
      do L = 1, Ls
         if (L.ne.Lx) then
            ztot = ztot + wl(L)*abs(zl(L)-zbar)
            endif
         enddo
      if (wtot.le.wmax) then
         zsig = 99999
         Lu = 1
         return
         endif
      zsig = ztot/(wtot-wmax)
 
      return
      end
 
 
 
 
c----------------------------------------------------------
c
c this routine will take several sets of triplets with
c given weights and will determine the average and
c dispersions, rejecting everything outside of SIGREG.
c
      subroutine barsig_3DW_REJ(xl,yl,zl,wl,wu,Ls,Lu,Wo,Wf,
     .                          xbar, ybar, zbar,
     .                          xsig, ysig, zsig,SIGREJ)
      implicit none
 
      real xl(_NDIM_)
      real yl(_NDIM_)
      real zl(_NDIM_)
      real wl(_NDIM_)
      real wu(_NDIM_)
      integer Ls, Lu
      real Wo, Wf
 
      real xbar, ybar, zbar
      real xsig, ysig, zsig
      real SIGREJ
 
      integer L
      real wmax, wbar
      real sumw, sumww
      real du(_NDIM_)
      integer Lmax
      real    dmax
      real sigratx
      real sigraty
      real sigratz
      real sigratd
 
 
c----------------------------------------------
c
c first, determine the wbar, and
c remove anything that has less than 10% of
c the typical weight
c
      sumw  = 0.
      sumww = 0.
      do L = 1, Ls
         wu(L) = max(wl(L),0.0)
         sumw  = sumw  + wu(L)
         sumww = sumww + wu(L)*wu(L)
         enddo
      if (sumw.le.0) then
         Lu = 0
         Wo = 0.
         Wf = 0.
         xbar = 0.000
         ybar = 0.000
         zbar = 0.000
         xsig = 9.999
         ysig = 9.999
         zsig = 99999
         endif
      wbar = sumww/sumw
      Wo = sumw
 
      sumw = 0.
      wmax = 0
      do L = 1, Ls
         if (wu(L).lt.wbar*0.10) wu(L) = 0.00
         sumw = sumw + wu(L)
         if (wu(L).gt.wmax) wmax = wu(L)
         enddo
 
c----------------------------------------------
c
c second, determine whether any of the enries
c with non-zero weight need to be rejected; go
c through one by one, evaluate sigma/etc without
c them...
c
    1 continue
      dmax = 0
      Lmax = 0
      do L = 1, Ls
         call barsig_3DWX(xl,yl,zl,wu,Ls,Lu,L,
     .                    xbar, ybar, zbar,
     .                    xsig, ysig, zsig)
         sigratx = (xl(L)-xbar)/xsig
         sigraty = (yl(L)-ybar)/ysig
         sigratz = (zl(L)-zbar)/zsig
         sigratd = sqrt(sigratx**2+sigraty**2+sigratz**2)
         if (wu(L).gt.0.and.sigratd.gt.dmax) then
            dmax = sigratd
            Lmax = L
            endif
         enddo
 
      if (dmax.gt.SIGREJ.and.Lmax.ne.0) then
         wu(Lmax) = 0.00
         goto 1
         endif
 
      call barsig_3DWX(xl,yl,zl,wu,Ls,Lu,0,
     .                 xbar, ybar, zbar,
     .                 xsig, ysig, zsig)
 
      Wo = 0.
      Wf = 0.
      do L = 1, Ls
         Wo = Wo + wl(L)
         Wf = Wf + wu(L)
         enddo
 
      return
      end
 
 
c----------------------------------------------------------
c
c this routine will take several sets of triplets with
c given weights and will determine the average and
c dispersions, rejecting everything outside of SIGREG.
c
      subroutine barsig_2DW_REJ(xl,yl,wl,wu,Ls,Lu,Wo,Wf,
     .                          xbar, ybar,
     .                          xsig, ysig, SIGREJ)
      implicit none
 
      real xl(_NDIM_)
      real yl(_NDIM_)
      real wl(_NDIM_)
      real wu(_NDIM_)
      integer Ls, Lu
      real Wo, Wf
 
      real xbar, ybar
      real xsig, ysig
      real SIGREJ
 
      integer L
      real wmax, wbar
      real sumw, sumww
      real du(_NDIM_)
      integer Lmax
      real    dmax
      real sigratx
      real sigraty
      real sigratd
 
 
c----------------------------------------------
c
c first, determine the wbar, and
c remove anything that has less than 10% of
c the typical weight
c
      sumw  = 0.
      sumww = 0.
      do L = 1, Ls
         wu(L) = max(wl(L),0.0)
         sumw  = sumw  + wu(L)
         sumww = sumww + wu(L)*wu(L)
         enddo
      if (sumw.le.0) then
         Lu = 0
         Wo = 0.
         Wf = 0.
         xbar = 0.000
         ybar = 0.000
         xsig = 9.999
         ysig = 9.999
         endif
      wbar = sumww/sumw
      Wo = sumw
 
      sumw = 0.
      wmax = 0
      do L = 1, Ls
         if (wu(L).lt.wbar*0.10) wu(L) = 0.00
         sumw = sumw + wu(L)
         if (wu(L).gt.wmax) wmax = wu(L)
         enddo
 
c----------------------------------------------
c
c second, determine whether any of the enries
c with non-zero weight need to be rejected; go
c through one by one, evaluate sigma/etc without
c them...
c
    1 continue
      dmax = 0
      Lmax = 0
      do L = 1, Ls
         call barsig_2DWX(xl,yl,wu,Ls,Lu,L,
     .                    xbar, ybar,
     .                    xsig, ysig)
         sigratx = (xl(L)-xbar)/xsig
         sigraty = (yl(L)-ybar)/ysig
         sigratd = sqrt(sigratx**2+sigraty**2)
         if (wu(L).gt.0.and.sigratd.gt.dmax) then
            dmax = sigratd
            Lmax = L
            endif
         enddo
 
      if (dmax.gt.SIGREJ.and.Lmax.ne.0) then
         wu(Lmax) = 0.00
         goto 1
         endif
 
      call barsig_2DWX(xl,yl,wu,Ls,Lu,0,
     .                 xbar, ybar,
     .                 xsig, ysig)
 
      Wo = 0.
      Wf = 0.
      do L = 1, Ls
         Wo = Wo + wl(L)
         Wf = Wf + wu(L)
         enddo
 
      return
      end
 
 
 
 
 
c----------------------------------------------------------
c
c this routine will take several sets of triplets with
c given weights and will determine the average and
c dispersions, rejecting everything outside of SIGREG.
c
      subroutine barsig_1DW_REJ(zl,wl,wu,Ls,Lu,Wo,Wf,
     .                          zbar, zsig,SIGREJ)
      implicit none
 
      real zl(_NDIM_)
      real wl(_NDIM_)
      real wu(_NDIM_)
      integer Ls, Lu
      real Wo, Wf
 
      real zbar, zsig
      real SIGREJ
 
      integer L
      real xbarl, ybarl, zbarl
      real xsigl, ysigl, zsigl
      real wmax, wbar
      real sumw, sumww
      real du(_NDIM_)
      integer Lmax
      real    dmax
      real sigratx
      real sigraty
      real sigratz
      real sigratd
 
 
c----------------------------------------------
c
c first, determine the wbar, and
c remove anything that has less than 10% of
c the typical weight
c
      sumw  = 0.
      sumww = 0.
      do L = 1, Ls
         wu(L) = max(wl(L),0.0)
         sumw  = sumw  + wu(L)
         sumww = sumww + wu(L)*wu(L)
         enddo
      if (sumw.le.0) then
         Lu = 0
         Wo = 0.
         Wf = 0.
         zbar = 0.000
         zsig = 99999
         endif
      wbar = sumww/sumw
      Wo = sumw
 
      sumw = 0.
      wmax = 0
      do L = 1, Ls
         if (wu(L).lt.wbar*0.10) wu(L) = 0.00
         sumw = sumw + wu(L)
         if (wu(L).gt.wmax) wmax = wu(L)
         enddo
 
c----------------------------------------------
c
c second, determine whether any of the enries
c with non-zero weight need to be rejected; go
c through one by one, evaluate sigma/etc without
c them...
c
    1 continue
      dmax = 0
      Lmax = 0
      do L = 1, Ls
         call barsig_1DWX(zl,wu,Ls,Lu,L,
     .                    zbarl, zsigl)
         sigratz = (zl(L)-zbarl)/zsigl
         sigratd = sigratz
         if (wu(L).gt.0.and.sigratd.gt.dmax) then
            dmax = sigratd
            Lmax = L
            endif
         enddo
 
      if (dmax.gt.SIGREJ.and.Lmax.ne.0) then
         wu(Lmax) = 0.00
         goto 1
         endif
 
      call barsig_1DWX(zl,wu,Ls,Lu,0,zbar, zsig)
 
      Wo = 0.
      Wf = 0.
      do L = 1, Ls
         Wo = Wo + wl(L)
         Wf = Wf + wu(L)
         enddo
 
      return
      end
 
 
 
c-----------------------------------------------
c
c
c
      subroutine simult_lsqz(xl,yl,zl,szl,gl,Lo,Ls,
     .                       pixv,pixe,pixu,psf)
      implicit none
 
      real    xl(_LDIM_)
      real    yl(_LDIM_)
      real    zl(_LDIM_), szl(_LDIM_)
      integer gl(_LDIM_)
      integer Lo,Ls
      real    pixv(_TDIM_,_TDIM_)
      real    pixe(_TDIM_,_TDIM_)
      byte    pixu(_TDIM_,_TDIM_)
      real    psf(101,101)
 
      integer L, Lu, LL
      integer imin, imax
      integer jmin, jmax
 
      real    ps(99999)
      real    ws(99999)
      integer Ss, Su
      real    sbar, ssig
      integer i, j
 
      integer N, Ns, NN
      real    xn(999), yn(999)
      logical flag(_TDIM_,_TDIM_)
 
      integer Q, Qs
      real    pixq(9999)
      real    psfq(9999,99)
      real    rpsf_phot, dx, dy
 
      real*8  normal(99,99)
      real*8  lamron(99,99)
      real*8  vector(99)
      real*8  coeffs(99)
 
      real*8  ptot
      real    z0(_LDIM_)
      real    pixs_v(_TDIM_,_TDIM_)
      real    pixs_e(_TDIM_,_TDIM_)
      real    pval
      real    dd
 
      do L = 1, Ls
         z0(L) = zl(L) ! we do come in with the old value
         enddo
 
      do L = Lo, Ls
          zl(L)  = 0.
         szl(L)  = 999999.9
          gl(L)  = 1
         enddo
 
      imin = _TDIM_
      jmin = _TDIM_
      imax =  0001
      jmax =  0001
      do L = 1, Ls
         if (xl(L).lt.imin) imin = xl(L)
         if (xl(L).gt.imax) imax = xl(L)
         if (yl(L).lt.jmin) jmin = yl(L)
         if (yl(L).gt.jmax) jmax = yl(L)
         enddo
 
      Ss = 0
c     do i = max(imin-12,001), min(imax+12,_TDIM_)
c     do j = max(jmin-12,001), min(jmax+12,_TDIM_)
      do i = 0001, _TDIM_
      do j = 0001, _TDIM_
         if (pixu(i,j).eq.0) then
            Ss = Ss + 1
            ps(Ss) = pixv(i,j)
            endif
         enddo
         enddo
 
      if (Ss.lt.49) return
 
      call find_sky_barsig(ps,Ss,sbar,ssig,Su,2.5) ! use the average sky over whole usable tile...
 
      do i = 001, _TDIM_
      do j = 001, _TDIM_
         pixs_v(i,j) = pixv(i,j)
         pixs_e(i,j) = pixe(i,j)**2
         enddo
         enddo
      do L = 1, Ls
         do i = max(int(xl(L)-13),0001), min(int(xl(L)+13),_TDIM_)
         do j = max(int(yl(L)-13),0001), min(int(yl(L)+13),_TDIM_)
            pval = z0(L)*rpsf_phot(i-xl(L),j-yl(L),psf)
            pixs_v(i,j) = pixs_v(i,j) - pval
            pixs_e(i,j) = pixs_e(i,j) + (0.1*pval)**2
            enddo
            enddo
         enddo
 
 
      do L = Lo, Ls
         xn(1)  = xl(L)
         yn(1)  = yl(L)
         zl(L)  = 0.000
         szl(L) = 99999.9
         gl(L)  = 2
         do i = int(xn(1)+0.5)-3, int(xn(1)+0.5)+3
         do j = int(yn(1)+0.5)-3, int(yn(1)+0.5)+3
            if (i.le.0001.or.i.ge._TDIM_.or.
     .          j.le.0001.or.j.ge._TDIM_) goto 333
            if (pixu(i,j).ne.0) goto 333
            enddo
            enddo
         Ns = 1
         do LL = 1, Ls
            if (L.ne.LL) then
               if ((xl(L)-xl(LL))**2
     .            +(yl(L)-yl(LL))**2.lt.12.5**2) then
                  do i = max(int(xl(LL)-1.5),0001),
     .                   min(int(xl(LL)+2.5),_TDIM_) ! NOTE TO SELF
                  do j = max(int(yl(LL)-1.5),0001),
     .                   min(int(yl(LL)+2.5),_TDIM_)
                     if (pixu(i,j).ne.0) goto 222
                     enddo
                     enddo
                  Ns = Ns + 1
                  if (Ns.gt.999) stop 'SIMULT_LSQZ PROB: Ns'
                  xn(Ns) = xl(LL)
                  yn(Ns) = yl(LL)
  222             continue
                  endif
               endif
            enddo!LL
         if (Ns.gt.99) Ns = 99
         do i = max(int(xn(1)-15+0.5), 0001 ),
     .          min(int(xn(1)+15+0.5),_TDIM_)
         do j = max(int(yn(1)-15+0.5), 0001 ),
     .          min(int(yn(1)+15+0.5),_TDIM_)
            flag(i,j) = .false.
            enddo
            enddo
         do N = 1, Ns
            do i = max(int(xn(N)-3+0.5), 0001 ),
     .             min(int(xn(N)+3+0.5),_TDIM_)
            do j = max(int(yn(N)-3+0.5), 0001 ),
     .             min(int(yn(N)+3+0.5),_TDIM_)
               if ((i-xn(N))**2+(j-yn(N))**2.lt.2.25**2)
     .              flag(i,j) = .true.
               enddo
               enddo
            enddo
         Qs = 0
         do i = max(int(xn(1)-15+0.5), 0001 ),
     .          min(int(xn(1)+15+0.5),_TDIM_)
         do j = max(int(yn(1)-15+0.5), 0001 ),
     .          min(int(yn(1)+15+0.5),_TDIM_)
            if (flag(i,j).and.pixu(i,j).eq.0) then
               Qs = Qs + 1
               pixq(Qs) = pixv(i,j)-sbar
               do N = 1, Ns
                  dx = i-xn(N)
                  dy = j-yn(N)
                  psfq(Qs,N) = rpsf_phot(dx,dy,psf)
                  enddo
               endif
            enddo
            enddo
         do  N = 1, Ns
         do NN = 1, Ns
            normal(N,NN) = 0.0d0
            do Q = 1, Qs
               normal(N,NN) = normal(N,NN) + psfq(Q,N)*psfq(Q,NN)
               enddo
            enddo
            enddo
         call dinvertNxN(normal,lamron,Ns,99)
         do N = 1, Ns
            vector(N) = 0.0d0
            do Q = 1, Qs
               vector(N) = vector(N) + psfq(Q,N)*pixq(Q)
               enddo
            enddo
         do N = 1, Ns
            coeffs(N) = 0.0d0
            do NN = 1, Ns
               coeffs(N) = coeffs(N) + vector(NN)*lamron(N,NN)
               enddo
            enddo
          zl(L)  = coeffs(1)
         ptot = 0.
         do i = int(xn(1)+0.5)-1, int(xn(1)+0.5)+1
         do j = int(yn(1)+0.5)-1, int(yn(1)+0.5)+1
            ptot =  ptot + pixe(i,j)**2
            enddo
            enddo
         szl(L) = sqrt(ptot)
          gl(L) = 0
  333    continue
         enddo!  L : Lo ---> Ls
 
      return
      end
 
 
c
c *****************************************************
c **                                                 **
c ** dnvertNxN -- subroutine                         **
c **                                                 **
c ** perform simple row operations on a to convert   **
c ** it into the identity matrix; perform the exact  **
c ** same operations on b                            **
c **                                                 **
c *****************************************************
c
 
      subroutine dinvertNxN(a,b,N,NDIM)
      implicit none
 
      integer NDIM        ! the dimensions of them both
      real*8 a(NDIM,NDIM) ! the input matrix; this will NOT be destroyed
      real*8 b(NDIM,NDIM) ! the output matrix;
      integer N           ! the dimensions of them both
 
      integer NMAX         ! change this before compiling to increase
      parameter (NMAX=103) ! the max no of dimensions
      real*8 c(NMAX,NMAX)   ! the copy of a that IS destroyed
 
      integer i,j
      real*8 h
      integer ii, jj
 
 
      if (N.gt.NMAX) then
         print*,' '
         print*,'routine: invertNxN '
         print*,' '
         print*,'   must bomb because N was input:',N
         print*,'   which  is  greater  than NMAX:',NMAX
         print*,' '
         print*,' '
         stop
         endif
 
 
c
c set C = A,
c and B = I (the identity matrix)
c
c
      do i = 1, N
      do j = 1, N
         c(i,j) = a(i,j)
         b(i,j) = 0.0
         enddo
         enddo
      do i = 1, N
         b(i,i) = 1.0
         enddo
 
 
c
c stage  I: reduce the lower left half of C to
c           zeros, and the diagonal to ones
c
      do j = 1, N
         h = c(j,j)
         do i = 1, N
            c(i,j) = c(i,j)/h
            b(i,j) = b(i,j)/h
            enddo
         do jj = j+1, N
            h = c(j,jj)
            do i = 1, N
               c(i,jj) = c(i,jj) - h*c(i,j)
               b(i,jj) = b(i,jj) - h*b(i,j)
               enddo
            enddo
         enddo
 
 
c
c stage II: reduce the upper right half of C to
c           zeros
c
      do j = 1, N-1
         do jj = j+1,N
            h = c(jj,j)
            do ii = 1, N
               c(ii,j) = c(ii,j) - h*c(ii,jj)
               b(ii,j) = b(ii,j) - h*b(ii,jj)
               enddo
            enddo
         enddo
 
c
c now C is the identity matrix...
c and B is the inverse of A...
c and A is still A...
c
      return
      end
 
 
 
c-----------------------------------------------------------------
c
c monster averager...
c
      subroutine find_avg_z_f(zb_ln,szb_ln,gb_ln,
     .                        Ns,Lo,Ls,FFF_n,
     .                        zbarb_lf,zsigb_lf,fb_lf,gb_lf)
      implicit none
 
      real    zb_ln(_LDIM_,_NDIM_), szb_ln(_LDIM_,_NDIM_)
      integer gb_ln(_LDIM_,_NDIM_)
      integer Ns, Lo, Ls
      integer FFF_n(_NDIM_)
      real zbarb_lf(_LDIM_,_FDIM_), zsigb_lf(_LDIM_,_FDIM_)
      integer*2 fb_lf(_LDIM_,_FDIM_)
      integer*2 gb_lf(_LDIM_,_FDIM_)
 
      integer nb_f(_FDIM_), nb_g(_FDIM_)
      real    wb_f(_FDIM_), wb_g(_FDIM_)
      integer U, Us, Ug
      integer L, F, N
      real wtot, Wo, Wf
 
      real    z_u(_NDIM_)
      real   sz_u(_NDIM_)
      real    w_u(_NDIM_)
      real   ww_u(_NDIM_)
 
      real   zb_f(_FDIM_), szb_f(_FDIM_)
 
 
      do L =  Lo, Ls
         do F = 1, _FDIM_
            Us = 0
            do N = 1, Ns
               if (FFF_n(N).eq.F.and.gb_ln(L,N).eq.1) then
                  Us = Us + 1
                  z_u(Us) =  zb_ln(L,N)
                 sz_u(Us) = szb_ln(L,N)
                  endif
               enddo
            wtot = 0.
            do U = 1, Us
               w_u(U) = 1/sz_u(U)**2
               wtot = wtot + w_u(U)
               enddo
            do U = 1, Us
               w_u(U) = w_u(U)/wtot
               enddo
            call barsig_1DW_REJ(z_u,w_u,ww_u,Us,Ug,Wo,Wf,
     .                          zb_f(F),szb_f(F),3.5)
            nb_f(F) = Us
            nb_g(F) = Ug
            wb_f(F) = Wo
            wb_g(F) = Wf
            if (.not.(zb_f(F).gt.-9e9)) then
               nb_f(F) = 0
               nb_g(F) = 0
               zb_f(F) =      0.000
               szb_f(F)= 999999.000
               endif
            zbarb_lf(L,F) =  zb_f(F)
            zsigb_lf(L,F) = szb_f(F)
            fb_lf(L,F) = nb_f(F)
            gb_lf(L,F) = nb_g(F)
            enddo
         enddo! L: Lo ---> Ls
 
      return
      end
 
 
 
 
c----------------------------------------------------------
c
c
c
      subroutine barsig_2DW_REJJ(xl,yl,wl,ul,Ls,Lu,
     .                           xbar,xsig,ybar,ysig,SIG_CLIP)
      implicit none
 
      integer Ls
      real    xl(Ls), yl(Ls)
      real    wl(Ls)
      integer ul(Ls)
      integer Lu
      real    xbar, xsig
      real    ybar, ysig
      real    SIG_CLIP
 
      integer L, LL, LLu
      real    wtot
      real    xbaru, ybaru, dsigu
      real    xtot, ytot, dtot
      real    dsig
      real    dmax
      integer lmax
      integer ntot
 
    1 continue
      wtot = 0.
      ntot = 0.
      do L = 1, Ls
         wtot = wtot + ul(L)*wl(L)
         if (wl(L).gt.0) ntot = ntot + ul(L)
         enddo
 
      if (ntot.eq.0.or.wtot.le.0) then
         xbar = 0.
         ybar = 0.
         xsig = 9.99
         ysig = 9.99
         Lu = 0
         return
         endif
 
      if (ntot.le.2) goto 2
 
      dmax = SIG_CLIP
      lmax = 0
      do L = 1, Ls
         xtot = 0.
         ytot = 0.
         wtot = 0.
         do LL = 1, Ls
            if (L.ne.LL) then
               xtot = xtot + ul(LL)*wl(LL)*xl(LL)
               ytot = ytot + ul(LL)*wl(LL)*yl(LL)
               wtot = wtot + ul(LL)*wl(LL)
               endif
            enddo
         xbaru = 0.
         ybaru = 0.
         dsigu = 0.
         dsig  = 0.
         if (wtot.gt.0) then
            xbaru = xtot/wtot
            ybaru = ytot/wtot
            dtot = 0.
            do LL = 1, Ls
               if (L.ne.LL) then
                  dtot = dtot + ul(LL)*wl(LL)*sqrt((xl(LL)-xbaru)**2+
     .                                             (yl(LL)-ybaru)**2)
                  endif
               enddo
            dsigu = dtot/wtot
            dsig = sqrt((xl(L)-xbaru)**2+(yl(L)-ybaru)**2)
            if (dsig/dsigu.gt.dmax.and.ul(L).eq.1) then
               dmax = dsig/dsigu
               lmax = L
               endif
            endif
c        write(*,111) xl(L),yl(L),wl(L)*ul(L)/wtot,
c    .                ul(L),wl(L),
c    .                xl(L)-xbar, yl(L)-ybar,
c    .                dsig,dsigu,dsig/dsigu
c 111    format(1x,f8.2,1x,f8.2,1x,f8.5,1x,i1,1x,f8.5,
c    .          5x,f8.2,1x,f8.2,1x,f8.2,1x,f8.2,1x,f8.4)
         enddo
 
      if (lmax.ne.0) then
        !print*,'----> REJECT: ',lmax,dmax
         ul(lmax) = 0
         goto 1
         endif
 
    2 continue
      xtot = 0.
      ytot = 0.
      wtot = 0.
      Lu = 0
      do L = 1, Ls
         xtot = xtot + ul(L)*wl(L)*xl(L)
         ytot = ytot + ul(L)*wl(L)*yl(L)
         wtot = wtot + ul(L)*wl(L)
         Lu   = Lu   + ul(L)
         enddo
      xbar = xtot/wtot
      ybar = ytot/wtot
      xtot = 0.
      ytot = 0.
      wtot = 0.
      do L = 1, Ls
         xtot = xtot + ul(L)*wl(L)*abs(xl(L)-xbar)
         ytot = ytot + ul(L)*wl(L)*abs(yl(L)-ybar)
         wtot = wtot + ul(L)*wl(L)
         enddo
      xsig = xtot/wtot
      ysig = ytot/wtot
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth1_barsigw.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine meth1_barsigw(pl,wl,Ls,Lu,bar,sig)
      implicit none
 
      integer Ls
      real pl(Ls), wl(Ls)
      integer Lu
      real bar, sig
 
      real ptot, wtot
 
      integer L
      byte   ul(1000)
      logical again
      integer utot
 
      if (Ls.le.10) then
         bar = 0.
         sig = 9999.
         Lu = 0
         return
         endif
 
      utot = 0
      do L = 1, Ls
         ul(L) = 1
         utot = utot + ul(L)
         enddo
 
 
      bar = 0.00
      sig = 9e9
    1 continue
 
      ptot = 0.
      wtot = 0.
      utot = 0
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*pl(L)
         wtot = wtot + ul(L)*wl(L)
         utot = utot + ul(L)
         enddo
      if (wtot.le.0) return
      bar = ptot/wtot
 
      ptot = 0.
      wtot = 0.
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*abs(pl(L)-bar)
         wtot = wtot + ul(L)*wl(L)
         enddo
      sig = ptot/wtot
 
      again = .false.
      do L = 1, Ls
         if (ul(L).eq.1.and.abs(pl(L)-bar).gt.3.0*sig) then
            ul(L) = 0
            again = .true.
            endif
         enddo
 
      if (again) goto 1
 
      Lu = utot
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth1_xyz_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
c----------------------------------------------------------------
c
c this will determine both positions and fluxes for each star (L)
c in each exposure (N):  (x,y,z;u,v)
c
c
      subroutine meth1_xyz_tile(Ls, u0_l, v0_l, z0_lf,
     .                          Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                              u1_ln,  v1_ln, x1_ln, y1_ln,
     .                              z1_ln, sz1_ln, s1_ln, ss1_ln,
     .                              q1_ln,  o1_ln, f1_ln,
     .                              pixv_n, pixe_n, pixm_n, pixu_n,
     .                              psf_n,  RAP_N,FFF_N)
 
      implicit none
 
      integer Ls
      real    u0_l(_LDIM_), v0_l(_LDIM_), z0_lf(_LDIM_,_FDIM_)
 
      integer Ns
 
      real      UTAB_N(_TTAB_,_TTAB_,Ns)
      real      VTAB_N(_TTAB_,_TTAB_,Ns)
      real      XTAB_N(_TTAB_,_TTAB_,Ns)
      real      YTAB_N(_TTAB_,_TTAB_,Ns)
 
      real       u1_ln(_LDIM_,Ns)    ! the transformed position in the ref frame
      real       v1_ln(_LDIM_,Ns)    !
      real       x1_ln(_LDIM_,Ns)    ! the transformed position in the loc frame
      real       y1_ln(_LDIM_,Ns)    !
      real       z1_ln(_LDIM_,Ns)    ! the solved-for flux in this frame
      real      sz1_ln(_LDIM_,Ns)    ! the error in the solved-for flux
      real       s1_ln(_LDIM_,Ns)    ! the solved-for sky value
      real      ss1_ln(_LDIM_,Ns)    ! the rms of the solved-for sky value
      integer   ns1_ln(_LDIM_,Ns)    !
      real       q1_ln(_LDIM_,Ns)
      real       o1_ln(_LDIM_,Ns)
      integer*2  f1_ln(_LDIM_,Ns)
 
      real      pixv_n(_TDIM_,_TDIM_,Ns)
      real      pixe_n(_TDIM_,_TDIM_,Ns)
      real      pixm_n(_TDIM_,_TDIM_,Ns)
      byte      pixu_n(_TDIM_,_TDIM_,Ns)
 
      real      psf_n(101,101,Ns)
      integer   RAP_N(Ns)
      integer   FFF_N(Ns)
c
c-------------------------------------------------------
c
 
      integer   L, LL
      integer   i, j
      real      dx, dy, rpsf_phot, rpsf_photu
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
      integer N, F
      real xt_tuv, yt_tuv
      real ut_txy, vt_txy
 
      real    ssig
      integer Su
      real    oth, wtt
 
      integer ic, jc
      real    z
 
      integer i1, i2
      integer j1, j2
 
 
      real*4, dimension(:,:), allocatable :: x0_ln
      real*4, dimension(:,:), allocatable :: y0_ln
      real*4, dimension(:,:), allocatable :: tempv ! pixel value
      real*4, dimension(:,:), allocatable :: temps ! model
      real*4, dimension(:,:), allocatable :: tempe ! error
      real*4, dimension(:,:), allocatable :: tempm ! mask
      real*4, dimension(:,:), allocatable :: tempd ! difference
      byte  , dimension(:,:), allocatable :: tempu ! use?
      real*4, dimension(:,:), allocatable :: tempo ! others
      real*4, dimension(:,:), allocatable :: pixmod
c
c-------------------------------------------------------
c
      allocate(x0_ln(_LDIM_,Ns))
      allocate(y0_ln(_LDIM_,Ns))
      allocate(tempv(_TDIM_,_TDIM_))
      allocate(temps(_TDIM_,_TDIM_))
      allocate(tempe(_TDIM_,_TDIM_))
      allocate(tempm(_TDIM_,_TDIM_))
      allocate(tempd(_TDIM_,_TDIM_))
      allocate(tempu(_TDIM_,_TDIM_))
      allocate(tempo(_TDIM_,_TDIM_))
      allocate(pixmod(_TDIM_,_TDIM_))
 
      if (VERBOSE) print*,'ENTERED meth1_xyz_tile...',Ns,Ls
 
c
c go through the images one by one
c
      if (VERBOSE) print*,'Go thru images one by one...'
      do N = 1, Ns
         if (VERBOSE) print*,'N = ',N
         F = FFF_N(N)
 
 
c
c load up a local array so that I won't have to
c destroy the real array
c
         if (VERBOSE) print*,'-----> a '
         do i = 0001, _TDIM_
         do j = 0001, _TDIM_
            tempv(i,j) = pixv_n(i,j,N) ! the observed value
            temps(i,j) = 0.            ! will be the model value
            tempm(i,j) = pixm_n(i,j,N) ! the mask value
            tempe(i,j) = pixe_n(i,j,N) ! the error value
            tempd(i,j) = 0.            ! the difference:  obs-mod
            tempu(i,j) = pixu_n(i,j,N)
            enddo
            enddo
 
 
c
c find where each star is within this exposure  ;
c make a model image that makes use of the best
c current positions and fluxes for each star
c
         if (VERBOSE) print*,'-----> b '
         do L = 1, Ls
            x0_ln(L,N) = xt_tuv(u0_l(L),v0_l(L),xtab_n(1,1,N),
     .                                          ytab_n(1,1,N))
            y0_ln(L,N) = yt_tuv(u0_l(L),v0_l(L),xtab_n(1,1,N),
     .                                          ytab_n(1,1,N))
            do i = max( 0001 ,int(x0_ln(L,N)-13)),
     .             min(_TDIM_,int(x0_ln(L,N)+13))
            do j = max( 0001 ,int(y0_ln(L,N)-13)),
     .             min(_TDIM_,int(y0_ln(L,N)+13))
               dx = i-x0_ln(L,N)
               dy = j-y0_ln(L,N)
               z = z0_lf(L,F)
               if (.not.(z.gt.0)) z = 0.
               temps(i,j) = temps(i,j) + z*rpsf_phot(dx,dy,psf_n(1,1,N))
               enddo
               enddo
            enddo ! L
 
 
c
c make the subtracted image...
c
         if (VERBOSE) print*,'-----> c '
         do i = 0001, _TDIM_
         do j = 0001, _TDIM_
            tempd(i,j) = tempv(i,j) - temps(i,j)
            enddo
            enddo
 
         if (.false.) then
            call writfits_r4('tempv.fits',tempv,301,301)
            call writfits_r4('tempd.fits',tempd,301,301)
            call writfits_r4('temps.fits',temps,301,301)
            call writfits_r4('tempe.fits',tempe,301,301)
            call writfits_r4('tempm.fits',tempm,301,301)
            call writfits_b1('tempu.fits',tempu,301,301)
            endif
c
c make the subtracted image...
c
         if (VERBOSE) print*,'-----> d '
         do L = 1, Ls
            ic = int(x0_ln(L,N)+0.5)
            jc = int(y0_ln(L,N)+0.5)
            if (VERBOSE) print*,'----------> 1) L ',L
            call meth1_find_sky(s1_ln(L,N),ss1_ln(L,N),ns1_ln(L,N),
     .                          x0_ln(L,N),y0_ln(L,N),
     .                          2*RAP_n(n), 4*RAP_n(N),
     .                          tempd, tempu, temps, tempe, tempm)
             u1_ln(L,N) = 0.00
             v1_ln(L,N) = 0.00
             x1_ln(L,N) = 0.00
             y1_ln(L,N) = 0.00
             z1_ln(L,N) = 0.00
            sz1_ln(L,N) = 99999.9
             f1_ln(L,N) = 0
 
            if (VERBOSE) print*,'----------> 2) L ',L
            i1 = ic - RAP_N(N) - 1
            i2 = ic + RAP_N(N) + 1
            j1 = jc - RAP_N(N) - 1
            j2 = jc + RAP_N(N) + 1
 
            if (VERBOSE) print*,'----------> 3) L ',L
            if (i1.lt. 0001 ) goto 1      ! bail if thie star goes off the tile...
            if (i1.gt._TDIM_) goto 1
            if (j1.lt. 0001 ) goto 1
            if (j1.gt._TDIM_) goto 1
            if (VERBOSE) print*,'----------> 3) L ',L,N
            if (ns1_ln(L,N).le.10) goto 1
 
            if (VERBOSE) print*,'----------> 4) L ',L
            do i = i1, i2                 ! now, make the "other" image; consists
            do j = j1, j2                 ! of a model image with all the neighbor stars
               tempo(i,j) = 0.
               do LL = 1, Ls
                  if (L.ne.LL) then
                     dx = i-x0_ln(LL,N)
                     dy = j-y0_ln(LL,N)
                     z = z0_lf(LL,F)
                     if (z.gt.0)       ! don't subtract negs... or NaN's...
     .               tempo(i,j) =
     .               tempo(i,j) + z*rpsf_phot(dx,dy,psf_n(1,1,N))
                     endif
                  enddo
               enddo
               enddo
            if (VERBOSE) print*,'----------> 5) L ',L
            call meth1_find_xyz(x1_ln(L,N), y1_ln(L,N),              ! ouptut x,y,
     .                          z1_ln(L,N),sz1_ln(L,N),              !            z,sz
     .                          q1_ln(L,N), o1_ln(L,N), f1_ln(L,N),  !            q,o,f
     .                          ic,jc,                               ! input position
     .                          s1_ln(L,N),ss1_ln(L,N), RAP_n(N),    ! input sky ; apsize
     .                          tempv, tempu, tempo, tempe, tempm,   ! input arrays
     .                          psf_n(1,1,N))                        ! input psf
            if (VERBOSE) print*,'----------> 6) L ',L
            u1_ln(L,N) = 0.
            v1_ln(L,N) = 0.
            if (x1_ln(L,N).gt.001.and.x1_ln(L,N).lt._TDIM_.and.
     .          y1_ln(L,N).gt.001.and.y1_ln(L,N).lt._TDIM_) then
                u1_ln(L,N) = ut_txy(x1_ln(L,N),y1_ln(L,N),utab_n(1,1,N),
     .                                                    vtab_n(1,1,N))
                v1_ln(L,N) = vt_txy(x1_ln(L,N),y1_ln(L,N),utab_n(1,1,N),
     .                                                    vtab_n(1,1,N))
                endif
    1       continue
            if (.false.) then
               write(68,115) N,L,FFF_N(N),
     .                       s1_ln(L,N),ss1_ln(L,N),ns1_ln(L,N),
     .                       x0_ln(L,N),y0_ln(L,N),z0_lf(L,F),
     .                       x1_ln(L,N),y1_ln(L,N),z1_ln(L,N),
     .                                            sz1_ln(L,N),
     .                       o1_ln(L,N),q1_ln(L,N),f1_ln(L,N),
     .                       u1_ln(L,N),v1_ln(L,N)
  115          format(1x,i2.2,1x,i3.3,1x,i1,
     .                3x,f6.1,1x,f6.1,1x,i3,
     .                3x,f8.2,1x,f8.2,1x,f10.1,
     .                3x,f8.2,1x,f8.2,1x,f10.1,1x,f10.1,
     .                3x,f10.1,3x,f8.6,1x,i1,
     .                3x,f8.3,1x,f8.3)
               endif
            if (VERBOSE) print*,'----------> 7) L ',L
            enddo! L
         if (VERBOSE) print*,'-----> e '
         enddo ! N
 
      deallocate(x0_ln)
      deallocate(y0_ln)
      deallocate(tempv)
      deallocate(temps)
      deallocate(tempe)
      deallocate(tempm)
      deallocate(tempd)
      deallocate(tempu)
      deallocate(tempo)
      deallocate(pixmod)
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth1_find_sky.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------
c
c
c
      subroutine meth1_find_sky(s1,ss1,ns1,
     .                          x0,y0,rinr,rotr,
     .                          tempd, tempu, temps, tempe, tempm)
      implicit none
 
      real    s1, ss1
      integer ns1
      real    x0, y0
      integer rinr, rotr
 
 
      real     Wt
      integer  i,  j
      integer ic, jc
      integer ii, jj
      integer Lp, L, Ls, Lu
      real bar, sig
      real*4 tempd(_TDIM_,_TDIM_)
      byte   tempu(_TDIM_,_TDIM_)
      real*4 temps(_TDIM_,_TDIM_)
      real*4 tempe(_TDIM_,_TDIM_)
      real*4 tempm(_TDIM_,_TDIM_)
 
      real*4, dimension(:)  , allocatable :: pl
      real*4, dimension(:)  , allocatable :: el
      real*4, dimension(:)  , allocatable :: wl
 
      allocate(pl(1000))
      allocate(el(1000))
      allocate(wl(1000))
 
      ic = int(x0+0.5)
      jc = int(y0+0.5)
 
      Lp = 0
      Ls = 0
      Wt = 0.0
      do i = -rotr, +rotr
      do j = -rotr, +rotr
         if (i**2+j**2.lt.(rinr-0.5)**2) goto 1
         if (i**2+j**2.gt.(rotr+0.5)**2) goto 1
         Lp = Lp + 1
         ii = ic + i
         jj = jc + j
         if (ii.le. 0001 ) goto 1
         if (ii.ge._TDIM_) goto 1
         if (jj.le. 0001 ) goto 1
         if (jj.ge._TDIM_) goto 1
         if (tempu(ii,jj).ne.0) goto 1
         Ls = Ls + 1
         if (Ls.gt.1000) stop 'find_sky_meth2:  Ls.gt.1000'
         pl(Ls) = tempd(ii,jj)
         el(Ls) = sqrt(tempe(ii,jj)**2
     .                +temps(ii,jj)**2
     .                +tempm(ii,jj)**2)
         wl(Ls) = 1.00/el(Ls)**2
         Wt = Wt + wl(Ls)
    1    continue
         enddo
         enddo
 
      if (Ls.lt.10) then
         s1  = 0.00
         ss1 = 0.00
         ns1 = 0
         goto 9
         endif
 
      do L = 1, Ls
         wl(L) = wl(L)/Wt*Ls
         enddo
 
      call meth1_barsigw(pl,wl,Ls,Lu,bar,sig)
      s1  = bar
      ss1 = sig
      ns1 = Lu
 
      if (.not.(s1.gt.-99999)) then
         s1  =      0.00
         ss1 = 999999.9
         ns1 = 0
         if (.false.) then
            print*,'--->  ic: ',ic
            print*,'--->  jc: ',jc
            print*,'--->  Lp: ',Lp
            print*,'--->  Ls: ',Ls
            print*,'--->  Lu: ',Lu
            print*,'---> bar: ',bar
            print*,'---> sig: ',sig
            do L = 1, Ls
               write(*,*) L,pl(L),wl(L)
               enddo
            stop 's1 = NaN'
            endif
         endif
 
    9 continue
      deallocate(pl)
      deallocate(el)
      deallocate(wl)
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth1_find_xyz.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------------------------------------
c
c find the best values of (x,y,z) given the pixel of the observation,
c and the PSF...
c
      subroutine meth1_find_xyz(x1, y1,  z1, sz1, q1, o1, f1,       ! output
     .                          ic0,jc0, s1, ss1, RAP,              ! input params
     .                          tempv, tempu, tempo, tempe, tempm, ! input images
     .                          psf)                               ! input PSF
      implicit none
 
      real    x1,  y1
      real    z1, sz1, q1, o1
      integer*2 f1
      integer ic0, jc0
      real    s1, ss1
      integer RAP
      real    tempv(_TDIM_,_TDIM_)
      byte    tempu(_TDIM_,_TDIM_)
      real    tempo(_TDIM_,_TDIM_)
      real    tempe(_TDIM_,_TDIM_)
      real    tempm(_TDIM_,_TDIM_)
      real    psf(101,101)
 
      real    rpsf_phot
      integer ic, jc
      integer i,  j
      integer ii, jj
      real    xu, yu, zu
      real    ptot, wtot, etot, otot, ftot
      real    pptot,pftot,fftot
 
      real*4, dimension(:,:), allocatable :: tempd
      real*4, dimension(:,:), allocatable :: tempw
      real*4, dimension(:,:), allocatable :: tempf
      real*4, dimension(:,:), allocatable :: temps
 
      real    sig1, sig2, sig3, sig4, sigu
      real    xc, yc
      real    xmin, ymin, zmin, emin
      real*8  qu, qmin
 
      integer NIT
      real    DD
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
      allocate (tempd(_TDIM_,_TDIM_))
      allocate (tempw(_TDIM_,_TDIM_))
      allocate (tempf(_TDIM_,_TDIM_))
      allocate (temps(_TDIM_,_TDIM_))
 
      if (VERBOSE) print*,'enter meth1_find_xyz...',ic0,jc0
 
c---------------------------------------
c
c if we have to bail early, set the output
c to "nothing found"
c
      x1  = 0.
      y1  = 0.
      z1  = 0.
      sz1 = 9999.
      q1  = 0.
      o1  = 0.
      f1  = 0
 
c-----------------------------------------
c
c find the maximum pixel close to the throw-in
c point
c
      do i = ic0-RAP-1, ic0+RAP+1
      do j = jc0-RAP-1, jc0+RAP+1
         tempd(i,j) = tempv(i,j) - tempo(i,j) - s1
         enddo
         enddo
 
      ic = ic0
      jc = jc0
      do i = ic0-1, ic0+1
      do j = jc0-1, jc0+1
         if (tempd(i,j).gt.tempd(ic,jc)) then
            ic = i
            jc = j
            endif
         enddo
         enddo
 
 
c--------------------------------------
c
c if this pixel is not a local maximum,
c greater than any pixel within the aperture,c
c then bail; don't measure anything
c
      do i = ic-RAP, ic+RAP
      do j = jc-RAP, jc+RAP
         if (tempd(i,j).gt.tempd(ic,jc)) return
         if (tempu(i,j).ne.0) return
         enddo
         enddo
 
 
c---------------------------------------
c
c make normalized pixel-by-pixel weights,
c for the pixels that matter
c
      wtot = 0.
      do i = ic-RAP, ic+RAP
      do j = jc-RAP, jc+RAP
         sig1 = tempe(i,j)
         sig2 = tempo(i,j)
         sig3 = tempm(i,j)
         sig4 = ss1
         sigu = sqrt(sig1**2 + sig2**2 + sig3**2 + sig4**2)
         temps(i,j) = sigu
         tempw(i,j) = 1/sigu**2
         wtot = wtot + tempw(i,j)
         enddo
         enddo
 
      do i = ic-RAP, ic+RAP
      do j = jc-RAP, jc+RAP
         tempw(i,j) = tempw(i,j)/wtot
         enddo
         enddo
 
 
c--------------------------------------------
c
c by trial, find the best position, to within
c 0.01 pixel ; start with the brightest pixel
c as guess
c
      xmin = ic
      ymin = jc
      zmin = 0.
      emin = 0.
      qmin = -1.0
 
      do NIT = 1, 6
         if (VERBOSE) print*,'      meth1_find_xyz... NIT: ',NIT,ic,jc
         if (NIT.eq.1) DD = 0.200
         if (NIT.eq.2) DD = 0.100
         if (NIT.eq.3) DD = 0.050
         if (NIT.eq.4) DD = 0.020
         if (NIT.eq.5) DD = 0.010
         if (NIT.eq.6) DD = 0.005
         xc = xmin
         yc = ymin
c        if (VERBOSE) print*,'      meth1_find_xyz...   a: ',ic,jc
         do ii = -3, 3
         do jj = -3, 3
c        if (VERBOSE) print*,'      meth1_find_xyz...   b: ',ic,jc,ii,jj
            xu = xc + ii*DD
            yu = yc + jj*DD
            ftot = 0.
            ptot = 0.
            etot = 0.
c        if (VERBOSE) print*,'      meth1_find_xyz...   c: ',ic,jc,RAP,
c    .                                                       xu,yu
            do i = ic-RAP, ic+RAP
            do j = jc-RAP, jc+RAP
               tempf(i,j) = rpsf_phot(i-xu,j-yu,psf)
               ptot = ptot + tempd(i,j)
               ftot = ftot + tempf(i,j)
               etot = etot + temps(i,j)**2
               enddo
               enddo
            zu = ptot/ftot
            qu = 0.
c        if (VERBOSE) print*,'      meth1_find_xyz...   d: ',ic,jc,RAP
            do i = ic-RAP, ic+RAP
            do j = jc-RAP, jc+RAP
               qu = qu + tempw(i,j)*(tempd(i,j)-zu*tempf(i,j))**2
               enddo
               enddo
c        if (VERBOSE) print*,'      meth1_find_xyz...   e: ',ic,jc,RAP
            if (qu.lt.qmin.or.qmin.lt.0) then
               qmin = qu
               xmin = xu
               ymin = yu
               zmin = zu
               emin = sqrt(etot)
               endif
            enddo
            enddo
c        if (VERBOSE) print*,'      meth1_find_xyz...   f: ',ic,jc
         enddo ! NIT
 
      x1  = xmin
      y1  = ymin
      z1  = zmin
      sz1 = emin
      f1  = 1
 
      otot = 0.
      ftot = 0.
      ptot = 0.
      fftot = 0.
      pftot = 0.
      pptot = 0.
      do i = ic-RAP, ic+RAP
      do j = jc-RAP, jc+RAP
         tempf(i,j) = rpsf_phot(i-xmin,j-ymin,psf)
         pptot = pptot + tempd(i,j)*tempd(i,j)
         pftot = pftot + tempd(i,j)*tempf(i,j)
         fftot = fftot + tempf(i,j)*tempf(i,j)
         ftot  = ftot  + tempf(i,j)
         ptot  = ptot  + tempd(i,j)
         otot  = otot  + tempo(i,j)
         enddo
         enddo
 
      o1  = otot/ftot
      q1  = pftot/sqrt(pptot)/sqrt(fftot)
 
      if (sz1.eq.0) then
         do i = ic-RAP, ic+RAP
         do j = jc-RAP, jc+RAP
            write(*,999) i,j,i-ic,j-jc,
     .                   tempd(i,j), tempe(i,j),
     .                   tempo(i,j), tempm(i,j),
     .                   tempf(i,j), tempw(i,j)
  999       format(3x,i3.3,1x,i3.3,1x,i2,1x,i2,1x,
     .             3x,f10.1,1x,f10.1,
     .             3x, f8.1,1x, f8.1,
     .             3x, f8.6,1x, f8.6)
            enddo
            enddo
         print*,'sz1: ',sz1
         stop
         endif
 
      if (VERBOSE) print*,' EXIT meth1_find_xyz...'
 
      deallocate (tempd)
      deallocate (tempw)
      deallocate (tempf)
      deallocate (temps)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth2_barsigw.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
      subroutine barsigw_meth2(pl,wl,Ls,Lu,bar,sig)
      implicit none
 
      integer Ls
      real pl(ls), wl(ls)
      integer Lu
      real bar, sig
 
      real ptot, wtot
 
      integer L
      byte   ul(1000)
      logical again
      integer utot
 
      if (Ls.le.10) then
         bar = 0.
         sig = 9999.
         Lu = 0
         return
         endif
 
      utot = 0
      do L = 1, Ls
         ul(L) = 1
         utot = utot + ul(L)
         enddo
 
 
      bar = 0.00
      sig = 9e9
    1 continue
 
      ptot = 0.
      wtot = 0.
      utot = 0
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*pl(L)
         wtot = wtot + ul(L)*wl(L)
         utot = utot + ul(L)
         enddo
      bar = ptot/wtot
 
      ptot = 0.
      wtot = 0.
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*abs(pl(L)-bar)
         wtot = wtot + ul(L)*wl(L)
         enddo
      sig = ptot/wtot
 
      again = .false.
      do L = 1, Ls
         if (ul(L).eq.1.and.abs(pl(L)-bar).gt.3.0*sig) then
            ul(L) = 0
            again = .true.
            endif
         enddo
 
      if (again) goto 1
 
      Lu = utot
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth2_xyz_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------------
c
c the goal of this routine is to do simple "aperture" photometry,
c with a fixed position and with pixel weighting such that neighbors
c are down-weighted ; the sky will be determined by between 2*RAP
c and 3*RAP; neighbors and the target star will be subtracted from
c the pixels before sky (or the star) is measured
c
      subroutine meth2_xyz_tile(
     .                  Ls, u_l, v_l, z_lf,                      ! the "starting" fluxes for everything...
     .                  Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                      x2_ln, y2_ln, z2_ln, sz2_ln,
     .                                    s2_ln, ss2_ln,
     .                                    q2_ln,  o2_ln, f2_ln,  ! the fluxes/sky/qual measured with method2 (only appho
     .                      pixv_n, pixe_n, pixm_n, pixu_n, psf_n,
     .                      RAP_N, FFF_N,M2M3)
      implicit none
 
      integer   Ls
      real      u_l(_LDIM_),  v_l(_LDIM_)
      real      z_lf(_LDIM_,_FDIM_)
 
 
      integer Ns
 
      real      UTAB_N(_TTAB_,_TTAB_,Ns)
      real      VTAB_N(_TTAB_,_TTAB_,Ns)
      real      XTAB_N(_TTAB_,_TTAB_,Ns)
      real      YTAB_N(_TTAB_,_TTAB_,Ns)
 
      real       x2_ln(_LDIM_,Ns)    ! the transformed position in this frame
      real       y2_ln(_LDIM_,Ns)    !
      real       z2_ln(_LDIM_,Ns)    ! the solved-for flux in this frame
      real      sz2_ln(_LDIM_,Ns)    ! the error in the solved-for flux
      real       s2_ln(_LDIM_,Ns)    ! the solved-for sky value
      real      ss2_ln(_LDIM_,Ns)    ! the rms of the solved-for sky value
      integer   ns2_ln(_LDIM_,Ns)    !
      real       q2_ln(_LDIM_,Ns)
      real       o2_ln(_LDIM_,Ns)
      integer*2  f2_ln(_LDIM_,Ns)
 
      real      pixv_n(_TDIM_,_TDIM_,Ns)
      real      pixe_n(_TDIM_,_TDIM_,Ns)
      real      pixm_n(_TDIM_,_TDIM_,Ns)
      byte      pixu_n(_TDIM_,_TDIM_,Ns)
      real      psf_n(101,101,Ns)
      integer   RAP_N(Ns)
      integer   FFF_N(Ns)
      integer   M2M3
c
c-------------------------------------------------------
c
      integer   L, LL
      integer   i, j
      real      dx, dy, rpsf_phot, rpsf_photu
 
      real*4, dimension(:,:), allocatable :: tempv ! pixel value
      real*4, dimension(:,:), allocatable :: temps ! model
      real*4, dimension(:,:), allocatable :: tempe ! error
      real*4, dimension(:,:), allocatable :: tempm ! mask
      real*4, dimension(:,:), allocatable :: tempd ! difference
      byte  , dimension(:,:), allocatable :: tempu ! use?
      real*4, dimension(:,:), allocatable :: tempo ! others
 
      integer N, F
      real xt_tuv, yt_tuv
      real ut_txy, vt_txy
      real pixmod(_TDIM_,_TDIM_)
 
      real    ssig
      integer Su
      real    oth, wtt
 
      integer ic, jc
      real    zlfu
 
      allocate(tempv(_TDIM_,_TDIM_)) ! pixel value
      allocate(temps(_TDIM_,_TDIM_)) ! model
      allocate(tempe(_TDIM_,_TDIM_)) ! error
      allocate(tempm(_TDIM_,_TDIM_)) ! mask
      allocate(tempd(_TDIM_,_TDIM_)) ! difference
      allocate(tempu(_TDIM_,_TDIM_)) ! use?
      allocate(tempo(_TDIM_,_TDIM_)) ! others
 
      if (M2M3.ne.2.and.M2M3.ne.3) stop 'M2M3 must be 2 or 3'
 
c---------------------------------
c
c go through the images one by one
c
      do N = 1, Ns
         F = FFF_N(N)
 
         do i = 0001, _TDIM_
         do j = 0001, _TDIM_
            tempv(i,j) = pixv_n(i,j,N) ! the observed value
            temps(i,j) = 0.            ! will be the model value
            tempm(i,j) = pixm_n(i,j,N) ! the mask value
            tempe(i,j) = pixe_n(i,j,N) ! the error value
            tempd(i,j) = 0.            ! the difference:  obs-mod
            tempu(i,j) = pixu_n(i,j,N)
            enddo
            enddo
 
 
c---------------------------------------------
c
c find where the stars are within the exposure
c add them to the model image
c
         do L = 1, Ls
            x2_ln(L,N) = xt_tuv(u_l(L),v_l(L),xtab_n(1,1,N),
     .                                        ytab_n(1,1,N))
            y2_ln(L,N) = yt_tuv(u_l(L),v_l(L),xtab_n(1,1,N),
     .                                        ytab_n(1,1,N))
            do i = max( 0001 ,int(x2_ln(L,N)-15)),
     .             min(_TDIM_,int(x2_ln(L,N)+15))
            do j = max( 0001 ,int(y2_ln(L,N)-15)),
     .             min(_TDIM_,int(y2_ln(L,N)+15))
               dx = i-x2_ln(L,N)
               dy = j-y2_ln(L,N)
               zlfu = z_lf(L,F)
               if (.not.(zlfu.gt.0)) zlfu = 0.
               temps(i,j) =
     .         temps(i,j) + zlfu*rpsf_phot(dx,dy,psf_n(1,1,N))
               enddo
               enddo
            enddo
 
         do i = 0001, _TDIM_
         do j = 0001, _TDIM_
            tempd(i,j) = tempv(i,j) - temps(i,j)
            enddo
            enddo
 
         do L = 1, Ls
            ic = int(x2_ln(L,N)+0.5)
            jc = int(y2_ln(L,N)+0.5)
            if (M2M3.eq.2) then
               call find_sky_meth2(s2_ln(L,N),ss2_ln(L,N),ns2_ln(L,N),
     .                             x2_ln(L,N),y2_ln(L,N),
     .                             2*RAP_n(n), 4*RAP_n(N),
     .                             tempd, tempu, temps, tempe, tempm)
               endif
            if (M2M3.eq.3) then
               call find_sky_meth2(s2_ln(L,N),ss2_ln(L,N),ns2_ln(L,N),
     .                             x2_ln(L,N),y2_ln(L,N),2,4,
     .                             tempd, tempu, temps, tempe, tempm)
               endif
             z2_ln(L,N) = 0
            sz2_ln(L,N) = 99999.9
             f2_ln(L,N) = 0
            ssig = ss2_ln(L,N)
            if (.not.(ssig.gt.0)) ssig = 999.9
            if (ic.ge.0001+RAP_N(N).and.ic.le._TDIM_-RAP_N(N).and.
     .          jc.ge.0001+RAP_N(N).and.jc.le._TDIM_-RAP_N(N).and.
     .          ns2_ln(L,N).ge.10) then
                do i = ic-RAP_N(N), ic+RAP_N(N)
                do j = jc-RAP_N(N), jc+RAP_N(N)
                   tempo(i,j) = 0.
                   do LL = 1, Ls
                      if (L.ne.LL) then
                         dx = i-x2_ln(LL,N)
                         dy = j-y2_ln(LL,N)
                         zlfu = z_lf(LL,F)
                         if (.not.(zlfu.gt.0)) zlfu = 0.
                         tempo(i,j) =
     .                   tempo(i,j) + zlfu*rpsf_phot(dx,dy,
     .                                               psf_n(1,1,N))
                         endif
                      enddo
                   enddo
                   enddo
                if (M2M3.eq.2)
     .          call find_zwt_meth2(z2_ln(L,N),sz2_ln(L,N),
     .                              q2_ln(L,N), o2_ln(L,N), f2_ln(L,N),
     .                              x2_ln(L,N),y2_ln(L,N),
     .                              s2_ln(L,N),RAP_n(N),ssig,
     .                              tempv, tempu, tempo,
     .                              tempe, tempm, temps,
     .                              psf_n(1,1,N))
                if (M2M3.eq.3)
     .          call find_zwt_meth2(z2_ln(L,N),sz2_ln(L,N),
     .                              q2_ln(L,N), o2_ln(L,N), f2_ln(L,N),
     .                              x2_ln(L,N),y2_ln(L,N),
     .                              s2_ln(L,N),0,ssig,
     .                              tempv, tempu, tempo,
     .                              tempe, tempm, temps,
     .                              psf_n(1,1,N))
                endif
c           write( *,115) N,L,FFF_N(N),
c    .                    s2_ln(L,N),ss2_ln(L,N),ns2_ln(L,N),
c    .                    z_lf(L,F),
c    .                    z2_ln(L,N),sz2_ln(L,N),
c    .                    o2_ln(L,N),q2_ln(L,N),f2_ln(L,N)
c           write(69,115) N,L,FFF_N(N),
c    .                    s2_ln(L,N),ss2_ln(L,N),ns2_ln(L,N),
c    .                    z_lf(L,F),
c    .                    z2_ln(L,N),sz2_ln(L,N),
c    .                    o2_ln(L,N),q2_ln(L,N),f2_ln(L,N)
c 115       format(1x,i2.2,1x,i3.3,1x,i1,
c    .             3x,f8.2,1x,f8.2,1x,i4,
c    .             5x,f10.1,
c    .             5x,f10.1,1x,f10.1,1x,f10.1,3x,f8.6,1x,i1)
            enddo
         enddo ! N
 
      deallocate(tempv) ! pixel value
      deallocate(temps) ! model
      deallocate(tempe) ! error
      deallocate(tempm) ! mask
      deallocate(tempd) ! difference
      deallocate(tempu) ! use?
      deallocate(tempo) ! others
 
      return
      end
 
 
c*********************************************
 
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth2_find_zwt.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine find_zwt_meth2(z2,sz2,q2,o2,f2,
     .                          x2,y2,s2,RAP,skysig,
     .                          tempv, tempu, tempo,
     .                          tempe, tempm, temps,
     .                          psfu)
      implicit none
 
      real    z2, sz2, q2, o2
      integer*2 f2
      real    x2, y2, s2
      integer RAP
      real    skysig
      real    tempv(_TDIM_,_TDIM_)
      byte    tempu(_TDIM_,_TDIM_)
      real    tempo(_TDIM_,_TDIM_)
      real    tempe(_TDIM_,_TDIM_)
      real    tempm(_TDIM_,_TDIM_)
      real    temps(_TDIM_,_TDIM_)
      real    psfu(101,101)
 
      real    rpsf_phot
      real    dx, dy
      integer ic, jc
      integer i,  j
      real    rpixu, rpsfu, zhatu, wgtu
      real    sigp2, sigz2
      real    ptot, wtot, etot, ftot
      real    otot
      real    pptot,pftot,fftot
 
      integer RAPu
 
      ic = int(x2+0.5)
      jc = int(y2+0.5)
 
      RAPu = RAP
      if (RAP.eq.0) RAPu = 1
 
      ptot = 0.
      wtot = 0.
      etot = 0.
      otot = 0.
      pptot = 0.
      fftot = 0.
      pftot = 0.
      ftot  = 0.
      do i = ic-RAPu, ic+RAPu
      do j = jc-RAPu, jc+RAPu
         if (tempu(i,j).ne.0) goto 1
         dx = i-x2
         dy = j-y2
         if (RAP.ne.0.or.sqrt(dx**2+dy**2).lt.0.75) then
            rpsfu = rpsf_phot(dx,dy,psfu)
            rpixu = tempv(i,j) - tempo(i,j) - s2
            zhatu = rpixu / rpsfu
c
c let's try to get the error weighting right this time!
c
c           sigp2 = tempe(i,j)**2 + tempm(i,j)**2 + tempo(i,j)**2
c           if (RAP.eq.0) sigp2 = skysig**2 + tempm(i,j)**2
c    .                          + tempo(i,j)**2
c
c there was a bias when I used the pixel value itself for weighting;
c stars found a little brighter than avg were downweighted and stars
c found a little fainter than avg were upweighted; here, I use the z0
c flux measurement for the target star (and the neighbors) to estimate
c the flux in each pixel from stars; we already have an estimate
c of the error in each pixel from the sky from the sky sigma...
c
            sigp2 = skysig**2 + temps(i,j) + tempm(i,j)**2
c
c --------- sigz2 = sigp2/rpsfu**2   ! ERROR fixed 2014/04/30 by Jay ; thanks Stefano!
c                                    ! CHECK meth1
            sigz2 = sigp2/rpsfu
            wgtu  = 1/sigz2**2
            ptot  = ptot  + wgtu*zhatu
            wtot  = wtot  + wgtu
            etot  = etot  + wgtu*sigz2
            otot  = otot  + wgtu*tempo(i,j)
            ftot  = ftot  + wgtu*rpsfu
            pftot = pftot + rpixu*rpsfu
            fftot = fftot + rpsfu*rpsfu
            pptot = pptot + rpixu*rpixu
            endif
         enddo
         enddo
      if (wtot.le.0) goto 1
 
       z2 = ptot/wtot
c
c --- sz2 = sqrt(etot/wtot)  ! ERROR fixed 2014/04/30 by Jay ; thanks Stefano!
c
      sz2 = sqrt(1.0/wtot)
       q2 = pftot/sqrt(pptot*fftot)
       o2 = otot/ftot
       f2 = 1
      return
 
    1 continue
      f2 = 0
      z2 = 0.
      sz2 = 9999
      q2 = 0.00
      o2 = 0.00
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/meth2_find_sky.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------
c
c
c
      subroutine find_sky_meth2(s2,ss2,ns2,
     .                          x2,y2,rinr,rotr,
     .                          tempd, tempu, temps, tempe, tempm)
      implicit none
 
      real    s2, ss2
      integer ns2
      real    x2, y2
      integer rinr, rotr
      real*4 tempd(_TDIM_,_TDIM_)
      byte   tempu(_TDIM_,_TDIM_)
      real*4 temps(_TDIM_,_TDIM_)
      real*4 tempe(_TDIM_,_TDIM_)
      real*4 tempm(_TDIM_,_TDIM_)
 
      integer  i,  j
      integer ic, jc
      integer ii, jj
      integer Lp, L, Ls, Lu
      real Wt
      real bar, sig
 
      real*4, dimension(:), allocatable :: pl
      real*4, dimension(:), allocatable :: el
      real*4, dimension(:), allocatable :: wl
 
      allocate(pl(1000))
      allocate(el(1000))
      allocate(wl(1000))
 
 
      ic = int(x2+0.5)
      jc = int(y2+0.5)
 
      Lp = 0
      Ls = 0
      Wt = 0.0
      do i = -rotr, +rotr
      do j = -rotr, +rotr
         if (i**2+j**2.lt.(rinr-0.5)**2) goto 1
         if (i**2+j**2.gt.(rotr+0.5)**2) goto 1
         Lp = Lp + 1
         ii = ic + i
         jj = jc + j
         if (ii.le. 0001 ) goto 1
         if (ii.ge._TDIM_) goto 1
         if (jj.le. 0001 ) goto 1
         if (jj.ge._TDIM_) goto 1
         if (tempu(ii,jj).ne.0) goto 1
         Ls = Ls + 1
         if (Ls.gt.1000) stop 'find_sky_meth2:  Ls.gt.1000'
         pl(Ls) = tempd(ii,jj)
         el(Ls) = sqrt(tempe(ii,jj)**2
     .                +temps(ii,jj)**2
     .                +tempm(ii,jj)**2)
         wl(Ls) = 1.00/el(Ls)**2
         Wt = Wt + wl(Ls)
    1    continue
         enddo
         enddo
 
      if (Ls.lt.10) then
         s2  = 0.00
         ss2 = 0.00
         ns2 = 0
         goto 9
         endif
 
      do L = 1, Ls
         wl(L) = wl(L)/Wt*Ls
         enddo
 
      call barsigw_meth2(pl,wl,Ls,Lu,bar,sig)
      s2  = bar
      ss2 = sig
      ns2 = Lu
 
    9 deallocate(pl)
      deallocate(el)
      deallocate(wl)
 
      return
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/mod_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------------------------
c
c
c
c
      subroutine mod_tile(ul,vl,zl,Ls,
     .                    UTAB_TXY,VTAB_TXY,
     .                    XTAB_TUV,YTAB_TUV,
     .                    PSF,
     .                    pixf)
 
      implicit none
 
      real    ul(9999)
      real    vl(9999)
      real    zl(9999)
      integer Ls
      real    UTAB_TXY(31,31), VTAB_TXY(31,31)
      real    XTAB_TUV(31,31), YTAB_TUV(31,31)
      real    PSF(101,101)
      real    pixf(_TDIM_,_TDIM_)  ! output ; the model image
c
c-------------------------------------------------
c
      real   xt_tuv, xt
      real   yt_tuv, yt
      integer  i,  j
      integer ii, jj
      real    dx, dy, z
      real    rpsf_phot
      integer L
 
      do i = 001, _TDIM_
      do j = 001, _TDIM_
         pixf(i,j) = 0.
         enddo
         enddo
 
      do L = 1, Ls
         xt = xt_tuv(ul(L),vl(L),xtab_tuv,ytab_tuv)
         yt = yt_tuv(ul(L),vl(L),xtab_tuv,ytab_tuv)
         z  = max(zl(L),0.0)
         do ii = max(int(xt-12.5+0.5), 0001 ),
     .           min(int(xt+12.5+0.5),_TDIM_)
         do jj = max(int(yt-12.5+0.5), 0001 ),
     .           min(int(yt+12.5+0.5),_TDIM_)
            dx = ii-xt
            dy = jj-yt
            pixf(ii,jj) = pixf(ii,jj) + z*rpsf_phot(dx,dy,PSF)
            enddo
            enddo
         enddo!L
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/read_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c---------------------------------------------------
c
c this will read in a tile from a particular image
c
      subroutine read_tile(FILENAME,KKK,CCC,ic,jc,
     .                     pixv,pixe,pixu,sky)
      implicit none
 
      character*80 FILENAME
      integer KKK, CCC
      integer ic, jc
      real      pixv(_TDIM_,_TDIM_)
      real      pixe(_TDIM_,_TDIM_)
      byte      pixu(_TDIM_,_TDIM_)
      real      sky
 
      integer i, j
      real pixee
      real f00, f01, f10, f11, fx, fy, fff, ffz
      real wfc3uv_zpa
      real wfc3ir_zpa
      real wfc_zpa
      integer   ii, ilo, ihi
      integer   jj, jlo, jhi
      integer*4 pixhrc(1024,1024)
 
      if (KKK.eq.1) then
         print*,'cannot read in wfpc2 yet...'
         stop
         endif
 
      if (KKK.eq.7) then ! HRC
         call readfits_i4(FILENAME,pixhrc,1024,1024)
         do i = 1, _TDIM_
         do j = 1, _TDIM_
            pixu(i,j) = 1
            pixv(i,j) = -999
            pixe(i,j) =  999
            ii = ic + (i-_TCEN_)
            jj = jc + (j-_TCEN_)
            if (ii.ge.0001.and.ii.le.1024.and.
     .          jj.ge.0001.and.jj.le.1024) then
                pixv(i,j) = pixhrc(ii,jj)
                pixe(i,j) = sqrt(16.00 + max(pixhrc(i,j),0))
                pixu(i,j) = 0
                if (pixv(i,j).gt.119000) then
                   pixu(i,j) = 2
                   pixe(i,j) = 999999.0
                   pixv(i,j) = 120000.0
                   endif
                endif
            enddo
            enddo
         endif
 
      if (KKK.eq.5.or.KKK.eq.8) then
         call readfits_wfc3uv_WJ2_rast(FILENAME,pixv,pixe,pixu,
     .                                 ic,jc,_TDIM_,_TDIM_)
         do i = 1, _TDIM_
         do j = 1, _TDIM_
            if (pixu(i,j).eq.0) pixv(i,j) = pixv(i,j)-SKY
            enddo
            enddo
c
c now, do the pixel-area correction
c
         ilo = max(ic-_TDIM_/2,0001)
         ihi = max(ic+_TDIM_/2,4096)
         jlo = max(jc-_TDIM_/2,0001)
         jhi = max(jc+_TDIM_/2,4096)
         f00 = 0.00
         f10 = 0.00
         f01 = 0.00
         f11 = 0.00
         if (KKK.eq.8) then
            f00 =  wfc3uv_zpa(ilo*1.0d0,jlo*1.0d0,0)
            f10 =  wfc3uv_zpa(ihi*1.0d0,jlo*1.0d0,0)
            f01 =  wfc3uv_zpa(ilo*1.0d0,jhi*1.0d0,0)
            f11 =  wfc3uv_zpa(ihi*1.0d0,jhi*1.0d0,0)
            endif
         if (KKK.eq.5) then
            f00 =  wfc_zpa(ilo*1.0d0,jlo*1.0d0,0)
            f10 =  wfc_zpa(ihi*1.0d0,jlo*1.0d0,0)
            f01 =  wfc_zpa(ilo*1.0d0,jhi*1.0d0,0)
            f11 =  wfc_zpa(ihi*1.0d0,jhi*1.0d0,0)
            endif
         if (ihi.gt.ilo.and.jhi.gt.jlo) then
            do i = 0001, _TDIM_
            do j = 0001, _TDIM_
               ii = ic + (i-_TCEN_)
               jj = jc + (j-_TCEN_)
               if (ii.ge.ilo.and.ii.le.ihi.and.
     .             jj.ge.jlo.and.jj.le.jhi) then
                   fx  = (ii-ilo)/1.0/(ihi-ilo)
                   fy  = (jj-jlo)/1.0/(jhi-jlo)
                   fff = (1-fx)*(1-fy)*f00
     .                 + (1-fx)*( fy )*f01
     .                 + ( fx )*(1-fy)*f10
     .                 + ( fx )*( fy )*f11
                   ffz = 10**(-fff/2.5)
                   pixv(i,j) = pixv(i,j)*ffz
                   endif
               enddo
               enddo
            endif
         endif
 
      if (KKK.eq.9) then
         call readfits_wfc3ir_flt_rast(FILENAME,pixv,pixe,pixu,
     .                                          ic,jc,_TDIM_,_TDIM_)
c
c now, do the pixel-area correction
c
         ilo = max(ic-_TDIM_/2,0001)
         ihi = max(ic+_TDIM_/2,1014)
         jlo = max(jc-_TDIM_/2,0001)
         jhi = max(jc+_TDIM_/2,1014)
         f00 =  wfc3ir_zpa(ilo*1.0d0,jlo*1.0d0)
         f10 =  wfc3ir_zpa(ihi*1.0d0,jlo*1.0d0)
         f01 =  wfc3ir_zpa(ilo*1.0d0,jhi*1.0d0)
         f11 =  wfc3ir_zpa(ihi*1.0d0,jhi*1.0d0)
         if (ihi.gt.ilo.and.jhi.gt.jlo) then
            do i = 0001, _TDIM_
            do j = 0001, _TDIM_
               ii = ic + (i-_TCEN_)
               jj = jc + (j-_TCEN_)
               if (ii.ge.ilo.and.ii.le.ihi.and.
     .             jj.ge.jlo.and.jj.le.jhi) then
                   fx  = (ii-ilo)/1.0/(ihi-ilo)
                   fy  = (jj-jlo)/1.0/(jhi-jlo)
                   fff = (1-fx)*(1-fy)*f00
     .                 + (1-fx)*( fy )*f01
     .                 + ( fx )*(1-fy)*f10
     .                 + ( fx )*( fy )*f11
                   ffz = 10**(-fff/2.5)
                   pixv(i,j) = pixv(i,j)*ffz
                   endif
               enddo
               enddo
            endif
         endif
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/reg_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine reg_tile(Ls,ul,vl,wl,NIT)
      implicit none
 
      integer Ls
      real    ul(_LDIM_)
      real    vl(_LDIM_)
      integer wl(_LDIM_)
      integer NIT
 
      real         RSIZ_NIT(11)
      common      /RSIZ_NIT/RSIZ_NIT
 
      character*7  RCOL_NIT(11)
      common      /RCOL_NIT/RCOL_NIT
 
      integer      RWID_NIT(11)
      common      /RWID_NIT/RWID_NIT
 
      character*40 FILENAME
 
      integer n
      integer L
      integer w
      integer NITu
 
      integer NITMINU
      integer NITMAXU
      common /NITMINMAXU_/NITMINU,NITMAXU
 
      logical first
      common /first_reg/first
      data first/.true./
 
      logical VERBOSE
      common /VERBOSE/VERBOSE
 
      if (VERBOSE) write(*,'(''ENTER reg_tile... '',i4)') Ls
 
      write(FILENAME,
     .      '(''AUX/SHOW_TILE_LOG.FIND_NIT'',i2.2,''.reg'')') 9
      if (first) then
         open(61,file=FILENAME,status='unknown')
         first = .false.
         endif
      write(FILENAME,
     .      '(''AUX/SHOW_TILE_LOG.FIND_NIT'',i2.2,''.reg'')') NIT
      open(60,file=FILENAME,status='unknown')
      do L = 1, Ls
         w  = wl(L)
         if (w.eq.0) w = 11
         write(60,112) ul(L), vl(L), RSIZ_NIT(W),
     .                               RCOL_NIT(W),RWID_NIT(W)
         write(61,112) ul(L), vl(L), RSIZ_NIT(NIT+1),
     .                               RCOL_NIT(W),RWID_NIT(W)
  112    format('linear;circle( ',f8.1,',',f8.1,
     .          ',',f6.3,') # color=',a7,' width=',i1)
 
         enddo
      close(60)
      if (NIT.eq.NITMAXU) close(61)
      if (VERBOSE) write(*,'('' EXIT reg_tile... '',i4)') Ls
 
      return
      end
 
 
 
c--------------------------------------------------
c
c
c
      subroutine barsig_ze(zl,el,ul,Ls,zbar,zsig,esig,Lu)
      implicit none
 
      integer Ls
      real    zl(Ls)
      real    el(Ls)
      integer ul(Ls)
      real    zbar, zsig, esig
      integer Lu
 
      integer NIT
      real    wl(999), wtot
      real    cl(999)
      integer L, Luo
      real    ptot, etot
      real    stot, zabs
      integer utot
 
      if (Ls.gt.999) stop 'barsig_ze: Ls.gt.999'
      do L = 1, Ls
         ul(L) = 1
         enddo
 
      wtot = 0.
      do L = 1, Ls
         wtot = wtot + (1/el(L))**2
         enddo
 
      do L = 1, Ls
         wl(L) = (1/el(L))**2 * Ls / wtot
         enddo
 
      ptot = 0.
      wtot = 0.
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*zl(L)
         wtot = wtot + ul(L)*wl(L)
         enddo
      zbar = ptot / wtot
 
      ptot = 0.
      wtot = 0.
      do L = 1, Ls
         ptot = ptot + ul(L)*wl(L)*(zl(L)-zbar)**2
         wtot = wtot + ul(L)*wl(L)
         enddo
      zsig = sqrt(ptot/wtot)
 
      Lu = 0
      do L = 1, Ls
         if (abs(zl(L)-zbar).gt.5.0*zsig) ul(L) = 0
         if (wl(L).lt.0.1) ul(L) = 0
         Lu = Lu + ul(L)
         enddo
 
 
   1  continue
      Luo = Lu
 
      ptot = 0.
      utot = 0.
      do L = 1, Ls
         ptot = ptot + ul(L)*zl(L)
         utot = utot + ul(L)
         enddo
      zbar = ptot / utot
 
      ptot = 0.
      stot = 0.
      utot = 0.
      etot = 0.
      do L = 1, Ls
         ptot = ptot + ul(L)*(zl(L)-zbar)**2
         stot = stot + ul(L)*abs(zl(L)-zbar)
         etot = etot + ul(L)* el(L)
         utot = utot + ul(L)
         enddo
      zsig = sqrt(ptot/utot)
      esig =      etot/utot
      zabs =      stot/utot
      if (zabs.lt.esig) zabs = esig
 
      Lu = 0
      do L = 1, Ls
         if (ul(L).eq.1) then
            if (abs(zl(L)-zbar).gt.2.40*zabs) ul(L) = 0
            endif
         Lu = Lu + ul(L)
         enddo
 
      if (Lu.lt.Luo) goto 1
 
      return
      end
 
 
 
 
      subroutine barsig_2w(ulist,vlist,wlist,Ls,
     .                     ubar,vbar,usig,vsig,Lu)
      implicit none
 
      integer Ls
      real*8 ulist(Ls)
      real*8 vlist(Ls)
      real   wlist(Ls)
 
      real*8 ubar, vbar
      real   usig, vsig
      integer Lu
      integer qlist(999), qtot, qtot0
 
      real*8 utot, vtot
      real   wtot
      real   rtot, rsig
      real    r, rmax
      integer l, lmax
 
      if (Ls.gt.999) stop 'barsig_2w: Ls.gt.999'
      do L = 1, Ls
         qlist(L) = 1
         enddo
 
    1 continue
 
      utot = 0.
      vtot = 0.
      wtot = 0.
      qtot = 0
      do L = 1, Ls
         utot = utot + qlist(L)*wlist(L)*ulist(L)
         vtot = vtot + qlist(L)*wlist(L)*vlist(L)
         wtot = wtot + qlist(L)*wlist(L)
         qtot = qtot + qlist(L)
         enddo
      ubar = utot/wtot
      vbar = vtot/wtot
 
      utot = 0.
      vtot = 0.
      rtot = 0.
      rmax = 0.
      lmax = 0
      do L = 1, Ls
         utot = utot + qlist(L)*wlist(L)*(ulist(L)-ubar)**2
         vtot = vtot + qlist(L)*wlist(L)*(vlist(L)-vbar)**2
         wtot = wtot + qlist(L)*wlist(L)
         r = 0.
         if (qlist(L).eq.1) then
            r = sqrt((ulist(L)-ubar)**2+(vlist(L)-vbar)**2)
            rtot = rtot + wlist(L)*r**2
            if (r.gt.rmax) then
               rmax = r
               lmax = l
               endif
            endif
         enddo
      usig = sqrt(utot/wtot)
      vsig = sqrt(vtot/wtot)
      rsig = sqrt(rtot/wtot)
 
      if (rmax.gt.3*rsig) then
         qlist(lmax) = 0
         goto 1
         endif
 
      Lu = qtot
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/reset_local.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c zero out the local array
c
      subroutine reset_local(u0_l,v0_l,su0_L,sv0_l, z0_lf, sz0_lf,
     .                       b0_l,n0_l, o0_l, w0_l,
     .                       uF_l,vF_l,mF_L,y0_L,
     .                       cfnd_l,
     .                       qmin_l,qfnd_l,
     .                       dmin_l,dfnd_l,
     .                       pmin_l,pfnd_l,
     .                       ubri_l, vbri_l,  zbri_l,
     .                       flux_l, mask_l)
      implicit none
 
      real    u0_l(_LDIM_)
      real    v0_l(_LDIM_)
      real   su0_l(_LDIM_)
      real   sv0_l(_LDIM_)
      real   z0_lf(_LDIM_,_FDIM_)
      real  sz0_lf(_LDIM_,_FDIM_)
 
      integer b0_l(_LDIM_)
      integer n0_l(_LDIM_)
      integer o0_l(_LDIM_)
      integer w0_l(_LDIM_)
 
      real    uF_l(_LDIM_), vF_l(_LDIM_)       ! the initial found coordinates (master frame)
      real    mF_l(_LDIM_)                     !     (the rough flund flux in exposure#1)
      integer y0_l(_LDIM_)                     ! why was this found? 1=quality, 2=proximity, 3=quantity
      integer cfnd_l(_LDIM_)
      integer qmin_l(_LDIM_), qfnd_l(_LDIM_)   ! info on the q-based finding criteria
      integer dmin_l(_LDIM_), dfnd_l(_LDIM_)   ! info on the d-based finding criteria
      integer pmin_l(_LDIM_), pfnd_l(_LDIM_)   ! info on the p-based finding criteria
      real*8  ubri_l(_LDIM_), vbri_l(_LDIM_)   ! proximity to bright star
      real    zbri_l(_LDIM_)                   ! flux of prox bright stars
      real    flux_l(_LDIM_)                   ! flux over sky from stacked image#1
      real    mask_l(_LDIM_)                   ! mask value at central pixel
 
 
      integer L, F
 
      do L = 1, _LDIM_
          u0_l(L) = 0.
          v0_l(L) = 0.
         su0_l(L) = 9.99
         sv0_l(L) = 9.99
         do F = 1, _FDIM_
            z0_lf(L,F) = 0.
           sz0_lf(L,F) = 0.
            enddo
         b0_l(L) = 0
         n0_l(L) = 0
         o0_l(L) = 1
         w0_l(L) = 0
         uf_L(L) = 0.
         vf_L(L) = 0.
         mf_L(L) = 0.
         y0_L(L) = 0
         cfnd_l(L) = 0
         qmin_l(L) = 0
         qfnd_l(L) = 0
         dmin_l(L) = 0
         dfnd_l(L) = 0
         pmin_l(L) = 0
         pfnd_l(L) = 0
         flux_l(L) = 0.
         mask_l(L) = 0.
         ubri_l(L) = 0.
         vbri_l(L) = 0.
         zbri_l(L) = 0.
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/rmssky_xyz_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------------
c
c the goal of this routine is compute rmssky from
c between r=2.5 and r=4.5 for each filter
c
      subroutine rmssky_xyz_tile(
     .                  Ls, u_l, v_l,
     .                  Ns, UTAB_N,VTAB_N,XTAB_N,YTAB_N,
     .                      barsk_lf, rmssk_lf,
     .                      pixv_n, pixe_n, pixm_n, pixu_n, psf_n,
     .                  Fs, FFF_N)
      implicit none
 
      integer Ls
      real    u_l(*),  v_l(*)
 
 
      integer Ns
      real    UTAB_N(_TTAB_,_TTAB_,Ns)
      real    VTAB_N(_TTAB_,_TTAB_,Ns)
      real    XTAB_N(_TTAB_,_TTAB_,Ns)
      real    YTAB_N(_TTAB_,_TTAB_,Ns)
 
      real    barsk_lf(_LDIM_,_FDIM_)
      real    rmssk_lf(_LDIM_,_FDIM_)
 
      real    pixv_n(_TDIM_,_TDIM_,Ns)
      real    pixe_n(_TDIM_,_TDIM_,Ns)
      real    pixm_n(_TDIM_,_TDIM_,Ns)
      byte    pixu_n(_TDIM_,_TDIM_,Ns)
      real    psf_n(101,101,Ns)
      integer RAP_N(Ns)
      integer Fs
      integer FFF_N(Ns)
c
c-------------------------------------------------------
c
      real    dx, dy, dd
      integer L
      integer F
      integer n
 
      logical unim(_NDIM_)
      real x_n(_NDIM_)
      real y_n(_NDIM_)
      real xt_tuv, yt_tuv
      real ut_txy, vt_txy
 
      integer icen
      integer jcen
      integer i, imin_n(_NDIM_), imax_n(_NDIM_)
      integer j, jmin_n(_NDIM_), jmax_n(_NDIM_)
 
      integer S, Ss
      real    slists(121)
      real    stot, sbar, ssig
      integer U, Us, Uu
      real    blistu(_NDIM_)
      real    slistu(_NDIM_)
      real    bar, sig
 
      logical VERBOSE
      common /VERBOSE/VERBOSE
 
      real*4, dimension(:,:), allocatable :: tempv
      allocate(tempv(_TDIM_,_TDIM_))
 
      if (VERBOSE) then
         write(*,'(''rmssky_xyz_tile...'')')
         write(*,'(''---> Ls = '',1x,i4)') Ls
         write(*,'(''---> Ns = '',1x,i4)') Ns
         write(*,'(''---> Fs = '',1x,i4)') Fs
         endif
 
 
c--------------------------------
c
c go through the stars one by one
c
      do L = 1, Ls
      do F = 1, _FDIM_
        !print*,'LF: ',L,F
         rmssk_lf(L,F) = 0.
         Us = 0
         do N = 1, Ns
           !print*,'LFN: ',L,F,N,FFF_N(N)
            unim(N) = .false.
            if (F.eq.FFF_N(N)) then
              !print*,'a...'
               x_n(N) = xt_tuv(u_l(L),v_l(L),xtab_n(1,1,N),  ! location of the target
     .                                       ytab_n(1,1,N))  ! star in the image
               y_n(N) = yt_tuv(u_l(L),v_l(L),xtab_n(1,1,N),
     .                                       ytab_n(1,1,N))
               icen = int(x_n(N)+0.5)
               jcen = int(y_n(N)+0.5)
               imin_n(N) = max(int(x_n(N)-5+0.5), 0001 )
               imax_n(N) = min(int(x_n(N)+5+0.5),_TDIM_)
               jmin_n(N) = max(int(y_n(N)-5+0.5), 0001 )
               jmax_n(N) = min(int(y_n(N)+5+0.5),_TDIM_)
              !print*,'b...'
               do i = imin_n(N), imax_n(N)
               do j = jmin_n(N), jmax_n(N)
                  if (pixu_n(i,j,N).ne.0) goto 333
                  enddo
                  enddo
              !print*,'c...'
               do i = imin_n(N), imax_n(N)
               do j = jmin_n(N), jmax_n(N)
                  tempv(i,j) = pixv_n(i,j,N)                           ! the observed value
                  enddo
                  enddo
              !print*,'d...'
               unim(N) = .true.
               Ss = 0
               stot = 0
               do i = imin_n(N), imax_n(N)
               do j = jmin_n(N), jmax_n(N)
                 !print*,'d...',i,j,Ss
                  dx = i-x_n(N)
                  dy = j-y_n(N)
                  dd = sqrt(dx**2+dy**2)
                  if (dd.ge.2.50.and.dd.le.4.50) then
                     Ss = Ss + 1
                     slists(Ss) = tempv(i,j)
                     stot = stot + slists(Ss)
                     endif
                  enddo
                  enddo
              !print*,'e...',Ss
               if (Ss.lt.5) goto 333
               sbar = stot/Ss
               stot = 0.
              !print*,'f...',Ss
               do S = 1, Ss
                  stot = stot + abs(slists(S)-sbar)
                  enddo
               ssig = stot/(Ss-1)
               Us = Us + 1
              !print*,'g...',Us
               blistu(Us) = sbar
               slistu(Us) = ssig
              !print*,'h...',Us
 333           continue
               endif!Fuse
            enddo!N
         call barsig(blistu,Us,bar,sig,Uu)
         barsk_lf(L,F) = bar
         call barsig(slistu,Us,bar,sig,Uu)
         rmssk_lf(L,F) = bar
         enddo!F
         enddo!L
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/show_mosaic_b1_b1.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------------------------
c
c
c
      subroutine show_mosaic_b1_b1(LAB9,pixu_n,GGG_n,CCC_n,FFF_n,Ns)
      implicit none
 
      integer     Ns
      character*9 LAB9
      byte        pixu_n(_TDIM_,_TDIM_,Ns)
      integer     GGG_n(Ns)
      integer     CCC_n(Ns)
      integer     FFF_n(Ns)
c
c--------------------------------------------------------
c
      integer   N
      integer   G, C, F
      integer   NX, NY
      integer   i, j
      character*80 FILENAME
      character*14 LABX
      integer ic, jc
      integer ii, jj
      integer jmax
      byte, dimension(:,:), allocatable :: pixout
      allocate(pixout(3000,9000))
 
      do i = 00001, 03000
      do j = 00001, 09000
         pixout(i,j) = 10
         enddo
         enddo
 
      jmax = 0
      do N = 1, Ns
         G = GGG_n(N)
         C = CCC_n(N)
         F = FFF_n(N)
         NX = N - (N-1)/10*10
         NY = 1 + (N-1)/10
         do i = -145, 145
         do j = -145, 145
            ii = 151+(NX-1)*300+i
            jj = 151+(NY-1)*300+j
            if (ii.ge.00001.and.ii.le.03000.and.
     .          jj.ge.00001.and.jj.le.09000)
     .          pixout(ii,jj) = pixu_n(151+i,151+j,N)
            if (jj.gt.jmax) jmax = jj
            enddo
            enddo
         ic = 11+(NX-1)*300
         jc = 11+(NY-1)*300
         write(LABX,'(''F'',i3.3,'' G'',i3.3,''.'',i1,'' F'',i1)')
     .                  N,G,C,F
         call img2putstr_b1(LABX,14,10,ic,jc,pixout,03000,09000)
         enddo
 
 
      write(FILENAME,'(''MOSAIC_'',a9,''.fits'')') LAB9
      call writfits_b1(FILENAME,pixout,03000,jmax)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/show_mosaic_r4_j2.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c----------------------------------------------------------
c
c
c
      subroutine show_mosaic_r4_j2(LAB9,pix_n,GGG_n,CCC_n,FFF_n,Ns)
      implicit none
 
      integer      Ns
      character*09 LAB9
      real*4       pix_n(_TDIM_,_TDIM_,Ns)
      integer      GGG_n(Ns)
      integer      CCC_n(Ns)
      integer      FFF_n(Ns)
c
c-----------------------------------------
c
      integer      N
      integer      G, C, F
      integer      NX, NY
      integer      i, j
      character*80 FILENAME
      real      pval
      integer*2 ival
      integer   ii, jj
      integer   ic, jc
      character*14 LABX
      integer   JMAX
      integer*2,dimension(:,:), allocatable :: pixout
      allocate(pixout(3000,9000))
 
      do i = 00001, 3000
      do j = 00001, 9000
         pixout(i,j) = 0
         enddo
         enddo
 
 
      jmax = 0
      do N = 1, Ns
         G = GGG_n(N)
         C = CCC_n(N)
         F = FFF_n(N)
         NX = N - (N-1)/10*10
         NY = 1 + (N-1)/10
         do i = -145, 145
         do j = -145, 145
            ii = 151+(NX-1)*300+i
            jj = 151+(NY-1)*300+j
            if (ii.ge.00001.and.ii.le.03000.and.
     .          jj.ge.00001.and.jj.le.09000) then
                pval = int(pix_n(151+i,151+j,N)+0.5) - 32000.0
                if (pval.lt.-32750) pval = -32750.
                if (pval.gt. 32750) pval =  32750.
                ival = int(pval+0.5)
                pixout(ii,jj) = ival
                endif
            if (jj.gt.jmax) jmax = jj
            enddo
            enddo
         ic = 11+(NX-1)*300
         jc = 11+(NY-1)*300
         write(LABX,'(''N'',i3.3,'' G'',i3.3,''.'',i1,'' F'',i1)')
     .                  N,G,C,F
         call img2putstr_i2(LABX,14,10,ic,jc,pixout,03000,09000)
         enddo
 
      write(FILENAME,'(''MOSAIC_'',a9,''.fits'')') LAB9
      call writfits_j2(FILENAME,pixout,3000,jmax)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/show_pixn_b1.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------------------------
c
c
c
      subroutine show_pixu(pix_n,C,Ns)
      implicit none
 
      byte      pix_n(_TDIM_,_TDIM_,Ns)
      character c
      integer   Ns
c
c---------------------------------------------------
c
      integer N
      character*80 FILENAME
 
      integer i, j
 
      print*,'ENTER show_pixu...'
 
      do N = 1, Ns
         write(FILENAME,
     .         '(''AUX/INDIV_PIX'',a1,''_N'',i3.3,''.fits'')') C,N
         call writfits_b1(FILENAME,pix_n(1,1,N),_TDIM_,_TDIM_)
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/show_pixn_r4.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-----------------------------------------------------------------
c
c
c
      subroutine show_pixn_r4(pix_n,C,Ns)
      implicit none
 
      real        pix_n(_TDIM_,_TDIM_,Ns)
      character*1 C
      integer Ns
 
      integer N
      character*80 FILENAME
 
      integer i, j
 
      print*,'ENTER show_pix: ',C,Ns
 
      do N = 1, Ns
         write(FILENAME,
     .         '(''AUX/INDIV_PIX'',a1,''_N'',i3.3,''.fits'')') C,N
         call writfits_r4(FILENAME,pix_n(1,1,N),_TDIM_,_TDIM_)
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/stack_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------------------------
c
c
c
c
      subroutine stack_tile(Ns, FFF_N,
     .                          UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                          pixv_n, pixe_n, pixm_n, pixu_n,
     .                          stack_tf,stackn_tf,NIT, SIG)
      implicit none
 
      integer   Ns
      integer   FFF_N(Ns)
 
      real      UTAB_N(31,31,Ns), VTAB_N(31,31,Ns)
      real      XTAB_N(31,31,Ns), YTAB_N(31,31,Ns)
 
      real      pixv_n(_TDIM_,_TDIM_,Ns)
      real      pixe_n(_TDIM_,_TDIM_,Ns)
      real      pixm_n(_TDIM_,_TDIM_,Ns)
      byte      pixu_n(_TDIM_,_TDIM_,Ns)
 
      real      stack_tf(_TDIM_,_TDIM_,_FDIM_)
      integer*2 stackn_tf(_TDIM_,_TDIM_,_FDIM_)
      integer   NIT
      real      SIG
c
c-------------------------------------------------------------------
c
      integer   N, F
      real*8    u,  v
      real*8    x,  y
      integer   i,  j
      integer   ii, jj
      real      xt_tuv
      real      yt_tuv
 
      character*80 FILENAME
 
      integer NF, NFs, NFu
      real pbar, psig
      real wtot
      integer ntot
      integer nsat, usat
      real*4, dimension(:), allocatable :: pl
      real*4, dimension(:), allocatable :: wl
 
c     integer*2 , dimension(:,:,:), allocatable :: pixn
c     allocate(pixn(_TDIM_,_TDIM_,_FDIM_))
 
      allocate(pl(Ns))
      allocate(wl(Ns))
 
      do F = 1, _FDIM_
         do i = 1, _TDIM_
         do j = 1, _TDIM_
            stack_tf(i,j,F)  = 0.00
            stackn_tf(i,j,F) = 0
            wtot = 0.
            NFu = 0
            NFs = 0
            ntot = 0
            nsat = 0
            do N = 1, Ns
               if (FFF_N(N).eq.F) then
                  x = xt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
                  y = yt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
                  ii = x + 0.5
                  jj = y + 0.5
                  if (ii.ge.0001+1.and.ii.le._TDIM_-1.and.
     .                jj.ge.0001+1.and.jj.le._TDIM_-1) then
                      ntot = ntot + 1
                      usat = 0
                      if (pixu_n(ii  ,jj-1,N).eq.1) usat = 1
                      if (pixu_n(ii  ,jj  ,N).eq.1) usat = 1
                      if (pixu_n(ii  ,jj+1,N).eq.1) usat = 1
                      if (pixu_n(ii+1,jj-1,N).eq.1) usat = 1
                      if (pixu_n(ii+1,jj  ,N).eq.1) usat = 1
                      if (pixu_n(ii+1,jj+1,N).eq.1) usat = 1
                      if (pixu_n(ii-1,jj-1,N).eq.1) usat = 1
                      if (pixu_n(ii-1,jj  ,N).eq.1) usat = 1
                      if (pixu_n(ii-1,jj+1,N).eq.1) usat = 1
                      if (usat.eq.1) nsat = nsat + 1
                      if (pixu_n(ii  ,jj  ,N).le.0.and.
     .                    pixu_n(ii+1,jj  ,N).le.0.and.
     .                    pixu_n(ii-1,jj  ,N).le.0.and.
     .                    pixu_n(ii  ,jj+1,N).le.0.and.
     .                    pixu_n(ii  ,jj-1,N).le.0.and.
     .                    pixu_n(ii+1,jj-1,N).le.0.and.
     .                    pixu_n(ii-1,jj-1,N).le.0.and.
     .                    pixu_n(ii+1,jj+1,N).le.0.and.
     .                    pixu_n(ii-1,jj+1,N).le.0) then
                         NFs = NFs + 1
                         pl(NFs) = pixv_n(ii,jj,N)
                         wl(NFs) = 1000./pixe_n(ii,jj,N)**2
                         wtot = wtot + wl(NFs)
c                        if (_DOC_STAC_)                        ! to document the creation of the stack;
c    .                   write(37,119) NIT,F,i,j,N,ii,jj,       ! very hard-core
c    .                                 pixv_n(ii,jj,N),
c    .                                 pixe_n(ii,jj,N),
c    .                                 pixu_n(ii,jj,N),
c    .                                 NFs,wl(NFs)
c 119                    format('NIT',i1.1,1x,'F ',i1,1x,i3.3,1x,i3.3,
c    .                          5x,i3,1x,i3.3,1x,i3.3,
c    .                          5x,f8.1,1x,f8.2,1x,i1,
c    .                          5x,i3,1x,f13.4,1x,i4,1x,i4)
                         endif
                      endif
                  endif
               enddo
 
            call barsigw(pl,wl,NFs,pbar,psig,NFu,SIG)
            if (NFs.le.10.and.SIG.lt.10)
     .          call barsig_sns(pl,NFs,pbar,psig,NFu)
            if (NFu.eq.0.and.nsat.gt.0) pbar = (_SATVAL_)
            if (.not.(pbar.gt.-9999)) pbar = 0.000
            stack_tf(i,j,F) = pbar
            stackn_tf(i,j,F) = NFu
           !pixn(i,j,F) = NFs
c           if (_DOC_STACK_)
c    .      write(37,119) NIT,F,i,j,NFs,0,0,pbar,psig,0,NFu,wtot,
c    .                    ntot,nsat
            enddo
            enddo
 
 
         enddo
      close(37)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/stack_tile_rej.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------------------------
c
c
c
c
      subroutine stack_tile_rej(Ns, FFF_N,
     .                              UTAB_N, VTAB_N, XTAB_N, YTAB_N,
     .                              pixv_n, pixt_n, pixe_n,
     .                                      pixm_n, pixu_n,
     .                              stack_tf,stackn_tf,NIT)
      implicit none
 
      integer   Ns
      integer   FFF_N(Ns)
 
      real      UTAB_N(31,31,Ns), VTAB_N(31,31,Ns)
      real      XTAB_N(31,31,Ns), YTAB_N(31,31,Ns)
 
      real      pixv_n(_TDIM_,_TDIM_,Ns)
      real      pixt_n(_TDIM_,_TDIM_,Ns)
      real      pixe_n(_TDIM_,_TDIM_,Ns)
      real      pixm_n(_TDIM_,_TDIM_,Ns)
      byte      pixu_n(_TDIM_,_TDIM_,Ns)
 
      real      stack_tf(_TDIM_,_TDIM_,_FDIM_)
      integer*2 stackn_tf(_TDIM_,_TDIM_,_FDIM_)
      integer   NIT
c
c-------------------------------------------------------------------
c
      integer   N, F, NN
      real*8    u,  v
      real*8    x,  y
      integer   i,  j
      integer   ii, jj
      integer   iii,jjj
      real      xt_tuv
      real      yt_tuv
 
      character*80 FILENAME
 
      integer   L, Ls, Lu, LL
      real bar, sig
      real p15, p50, p85
 
      real*4   , dimension(:),   allocatable :: pl, ql, el
      integer*4, dimension(:),   allocatable :: nl, il, jl, cl, nu
      real*4   , dimension(:,:), allocatable :: pixr
      byte     , dimension(:,:), allocatable :: pixu
 
      allocate(pl(9999))
      allocate(ql(9999))
      allocate(el(9999))
      allocate(nl(9999))
      allocate(il(9999))
      allocate(jl(9999))
      allocate(cl(9999))
      allocate(nu(Ns))
 
      allocate(pixr(301,301))
      allocate(pixu(301,301))
 
 
      print*,'ENTER stack_tile_rej...  Ns: ',Ns
 
      do i = 0001, _TDIM_
      do j = 0001, _TDIM_
         do N = 1, Ns
            pixt_n(i,j,N) = -500
            enddo
         enddo
         enddo
 
      do F = 1, _FDIM_
         print*,'----> F: ',F
         do i = 1, _TDIM_
         do j = 1, _TDIM_
c        do i = 117, 117
c        do j = 160, 160
            Lu = 0
            Ls = 0
            do N = 1, Ns
               nu(N) = 0
               if (FFF_N(N).eq.F) then
                  nu(N) = 1
                  x = xt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
                  y = yt_tuv(i*1.0,j*1.0,XTAB_N(1,1,N),YTAB_N(1,1,N))
                  ii = x + 0.5
                  jj = y + 0.5
                  do iii = max(ii-1,0001+1), min(ii+1,_TDIM_-1)
                  do jjj = max(jj-1,0001+1), min(jj+1,_TDIM_-1)
                     pixt_n(i,j,N) = pixv_n(ii,jj,N)
                     if (pixu_n(iii,jjj,N).ne.0) nu(N) = 0
                     if (pixu_n(iii,jjj,N).le.0) then
                        Ls = Ls + 1
                        if (Ls.gt.9999) stop 'Ls.gt.9999'
                        pl(Ls) = pixv_n(iii,jjj,N)
                        el(Ls) = pixe_n(iii,jjj,N)
                        nl(Ls) = N
                        il(Ls) = iii
                        jl(Ls) = jjj
                        cl(Ls) = 0
                        if (iii.eq.ii.and.jjj.eq.jj) cl(Ls) = 1 ! central
                        endif
                     enddo
                     enddo
                  endif
               enddo
            if (Ls.ge.9) then
               do L = 1, Ls
                  if (cl(L).eq.1) then
                     bar = 0.00
                     sig = 9.e9
                     Lu = 0
                     do LL = 1, Ls
                        if (nl(LL).ne.nl(L).and.
     .                      nu(nl(LL)).eq.1) then
                           Lu = Lu + 1
                           ql(Lu) = pl(LL)
                           endif
                        enddo
                     if (Lu.ge.9) then
                        call rbubble(ql,Lu)
                        p15 = ql(1+  Lu/6)
                        p50 = ql(1+  Lu/2)
                        p85 = ql(1+5*Lu/6)
                        sig = p85-p15
                        bar = p50
                        if (pl(L).gt.bar+7.5*sig.and.
     .                      pl(L).gt.bar+7.5*el(L)) then
                            pixu_n(il(L),jl(L),nl(L)) = 1
                            endif
                        endif
                     endif
                  enddo
               endif
            enddo
            enddo
         enddo!F
 
      print*,'EXIT  stack_tile_rej...'
c     if (.true.) stop
 
      return
      end
 
 
 
c--------------------------------------------------
c
c
      subroutine cosort_rcnijij(pl,cl,nl,il,jl,iil,jjl,Ls)
      implicit none
 
      integer   Ls
      real      pl(Ls)
      character cl(Ls)
      integer   nl(Ls)
      integer   il(Ls)
      integer   jl(Ls)
      integer  iil(Ls)
      integer  jjl(Ls)
 
      real      pt
      character ct
      integer   nt, it, jt, iit, jjt
      logical   chg
      integer L
 
    1 continue
      chg = .false.
      do L = 1, Ls-1
         if (pl(L).gt.pl(L+1)) then
            pt  = pl(L)
            ct  = cl(L)
            nt  = nl(L)
            it  = il(L)
            jt  = jl(L)
            iit = iil(L)
            jjt = jjl(L)
            pl(L)    = pl(L+1)
            cl(L)    = cl(L+1)
            nl(L)    = nl(L+1)
            il(L)    = il(L+1)
            jl(L)    = jl(L+1)
            iil(L)   = iil(L+1)
            jjl(L)   = jjl(L+1)
            pl(L+1)  = pt
            cl(L+1)  = ct
            nl(L+1)  = nt
            il(L+1)  = it
            jl(L+1)  = jt
            iil(L+1) = iit
            jjl(L+1) = jjt
            chg = .true.
            endif
         enddo
      if (chg) goto 1
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/sub_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c---------------------------------------------------------------
c
c
      subroutine sub_tile(pixv_n,pixf_n,pixs_n,pixu_n)
      implicit none
 
      real   pixv_n(_TDIM_,_TDIM_)
      real   pixf_n(_TDIM_,_TDIM_)
      real   pixs_n(_TDIM_,_TDIM_)
      byte   pixu_n(_TDIM_,_TDIM_)
      integer Ns
 
      integer i, j
 
      do i = 001, _TDIM_
      do j = 001, _TDIM_
         pixs_n(i,j) = 0.
         if (pixu_n(i,j).eq.0)
     .   pixs_n(i,j) = pixv_n(i,j) - pixf_n(i,j)
         enddo
         enddo
 
      return
      end
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/trans_tile.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c--------------------------------------------------------------------------
c
c this routine will find the local tile coordinate-system projection...
c
      subroutine trans_tile(UREF, VREF,         ! (input)  integer ref frame center of tile
     .                      ILOC, JLOC,         !          integer center of this local tile
     .                      XLOC, YLOC,         !          dist-corr center of local tile
     .                      ULOC, VLOC,         !          ref-frame trans'd center of local tile
     .                      GA,GB,GC,GD,        !          linear terms
     .                      KKK, CCC, FLT,      !          attributes of local tile
     .                      FILEGCS,
     .                      utab_txy,vtab_txy,  ! (output) table-based trans from loc (xy) to loc (uv)
     .                      xtab_tuv,ytab_tuv)  !          table-based trans from loc (uv) to loc (xy)
      implicit none
 
      integer      UREF, VREF
      integer      ILOC, JLOC
      real*8       XLOC, YLOC
      real*8       ULOC, VLOC
 
      real*8       GA, GB, GC, GD
      integer      KKK
      integer      CCC
      integer      FLT
      character*80 FILEGCS
      real         utab_txy(_TTAB_,_TTAB_), vtab_txy(_TTAB_,_TTAB_)
      real         xtab_tuv(_TTAB_,_TTAB_), ytab_tuv(_TTAB_,_TTAB_)
c
c-------------------------------------------------
c
      real*8    ABCD
      real*8    AG, BG, CG, DG
 
      real*8    uu, vv
      real*8    xr, yr
      real*8    xc, yc
 
      real      xt, yt
      real      ut, vt
      real      xtt,ytt
 
      integer   i, j
      integer   ii,jj
 
      real      rtab_tt
c
c-------------------------------------------------
c
      real*8 uu_txy
      real*8 vv_txy
      real   xt_uv,   yt_uv
      real   xr_uv,   yr_uv
      real   ut_uv,   vt_uv
      real   ut_txy,  vt_txy
      real   xt_tuv,  yt_tuv
      real   xr_txy,  yr_txy
      real*8 uu_tuv,  vv_tuv
      integer iyt, ixt
c
c-------------------------------------------------
c
      xr = ILOC
      yr = JLOC
      call gc_cf(xr,yr,xc,yc,KKK,FLT,CCC,FILEGCS)
      uu = ULOC + GA*(xc-XLOC) + GB*(yc-YLOC)
      vv = VLOC + GC*(xc-XLOC) + GD*(yc-YLOC)
 
c     write(*,'(''                   '')')
c     write(*,'(''ENTER ABCD_TILE... '')')
c     write(*,'(''     UREF:  '',i4,4x,2x,i4,2x)') UREF,VREF
c     write(*,'(''     ILOC:  '',i4,4x,2x,i4,2x)') ILOC,JLOC
c     write(*,'(''     XLOC:  '',f8.3 ,2x,f8.3 )') XLOC,YLOC
c     write(*,'(''     ULOC:  '',f8.3 ,2x,f8.3 )') ULOC,VLOC
c     write(*,'(''                   '')')
 
      ABCD = GA*GD-GB*GC
      AG =  GD/ABCD
      BG = -GB/ABCD
      CG = -GC/ABCD
      DG =  GA/ABCD
 
      if ((_TTAB_).ne.31) stop '_TTAB_.ne.31... hard-code problem.'
 
      do i = 01, 31
      do j = 01, 31
         ii = 1 + (i-1)*10
         jj = 1 + (j-1)*10
         uu = UREF + (ii-_TCEN_)/2.0
         vv = VREF + (jj-_TCEN_)/2.0
         xc = XLOC + AG*(uu-ULOC) + BG*(vv-VLOC)
         yc = YLOC + CG*(uu-ULOC) + DG*(vv-VLOC)
         call cg_cf(xc,yc,xr,yr,KKK,FLT,CCC,FILEGCS)
         xtab_tuv(i,j) = _TCEN_ + (xr-ILOC)
         ytab_tuv(i,j) = _TCEN_ + (yr-JLOC)
         enddo
         enddo
 
      do i = 01, 31
      do j = 01, 31
         ii = 1 + (i-1)*10
         jj = 1 + (j-1)*10
         xr = ILOC + (ii-_TCEN_)
         yr = JLOC + (jj-_TCEN_)
         call gc_cf(xr,yr,xc,yc,KKK,FLT,CCC,FILEGCS)
         uu = ULOC + GA*(xc-XLOC) + GB*(yc-YLOC)
         vv = VLOC + GC*(xc-XLOC) + GD*(yc-YLOC)
         utab_txy(i,j) = _TCEN_ + (uu-UREF)*2
         vtab_txy(i,j) = _TCEN_ + (vv-VREF)*2
         enddo
         enddo
 
 
      if (.false.) then  ! test upside down and inside out
         print*,'TRANS_TILE... fort.31'
         do ixt = 001, 301, 005
         do iyt = 001, 301, 005
            xt = ixt
            yt = iyt
            ut  = rtab_tt(xt,yt,utab_txy)
            vt  = rtab_tt(xt,yt,vtab_txy)
            xtt = rtab_tt(ut,vt,xtab_tuv)
            ytt = rtab_tt(ut,vt,ytab_tuv)
            xr = ILOC + (xt-_TCEN_)
            yr = JLOC + (yt-_TCEN_)
            call gc_cf(xr,yr,xc,yc,KKK,FLT,CCC,FILEGCS)
            uu = ULOC + GA*(xc-XLOC) + GB*(yc-YLOC)
            vv = VLOC + GC*(xc-XLOC) + GD*(yc-YLOC)
            write(31,133)
     .          int(xt+0.5),int(yt+0.5),
     .          ut,vt,xtt,ytt,
     .          xr,yr,uu,vv,
     .          uu_txy(xt,yt,utab_txy,vtab_txy,UREF,VREF)-uu,
     .          vv_txy(xt,yt,utab_txy,vtab_txy,UREF,VREF)-vv,
     .          xt_uv(uu,vv,xtab_tuv,ytab_tuv,UREF,VREF)-xt,
     .          yt_uv(uu,vv,xtab_tuv,ytab_tuv,UREF,VREF)-yt,
     .          xr_uv(uu,vv,xtab_tuv,ytab_tuv,ILOC,JLOC,UREF,VREF)-xr,
     .          yr_uv(uu,vv,xtab_tuv,ytab_tuv,ILOC,JLOC,UREF,VREF)-yr,
     .          ut_uv(uu,vv,UREF,VREF)-ut,
     .          vt_uv(uu,vv,UREF,VREF)-vt,
     .          ut_txy(xt,yt,utab_txy,vtab_txy)-ut,
     .          vt_txy(xt,yt,utab_txy,vtab_txy)-vt,
     .          xt_tuv(ut,vt,xtab_tuv,ytab_tuv)-xt,
     .          yt_tuv(ut,vt,xtab_tuv,ytab_tuv)-yt,
     .          xr_txy(xt,yt,ILOC,JLOC)-xr,
     .          yr_txy(xt,yt,ILOC,JLOC)-yr,
     .          uu_tuv(ut,vt,UREF,VREF)-uu,
     .          vv_tuv(ut,vt,UREF,VREF)-vv
  133       format(1x,i3.3,1x,i3.3,
     .             6x,f9.3,1x,f9.3,1x,3x,f9.3,1x,f9.3,1x,
     .             6x,f9.3,1x,f9.3,1x,3x,f9.3,1x,f9.3,1x,
     .             9x,20(f6.2,1x,f6.2,3x))
            enddo
            enddo
         stop
         endif
 
      return
      end
 
 
c------------------------------------
c
c will interpolate the tabular function
c
      real function rtab_tt(x,y,rtab)
      implicit none
 
      real x, y
      real rtab(_TTAB_,_TTAB_)
 
      real    rx, ry
      integer ii, jj
      real    fx, fy
 
      rx = 1 + (x-1)/10.
      ry = 1 + (y-1)/10.
 
      ii = int(rx)
      jj = int(ry)
      if (ii.le.01) ii = 01
      if (ii.gt.30) ii = 30
      if (jj.le.01) jj = 01
      if (jj.gt.30) jj = 30
      fx = rx-ii
      fy = ry-jj
 
 
      rtab_tt = (1-fx)*(1-fy)*rtab(ii  ,jj  )
     .        + (1-fx)*( fy )*rtab(ii  ,jj+1)
     .        + ( fx )*(1-fy)*rtab(ii+1,jj  )
     .        + ( fx )*( fy )*rtab(ii+1,jj+1)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real*8 function uu_txy(xt,yt,utab_txy,vtab_txy,UREF,VREF)
      implicit none
 
      real    xt  , yt
      real    utab_txy(31,31)
      real    vtab_txy(31,31)
      integer UREF, VREF
      real    rtab_tt
 
      uu_txy = UREF + (rtab_tt(xt,yt,utab_txy)-_TCEN_)*0.5d0
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real*8 function vv_txy(xt,yt,utab_txy,vtab_txy,UREF,VREF)
      implicit none
 
      real    xt,   yt
      real    utab_txy(31,31)
      real    vtab_txy(31,31)
      integer UREF, VREF
      real    rtab_tt
 
      vv_txy = VREF + (rtab_tt(xt,yt,vtab_txy)-_TCEN_)*0.5d0
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function xt_uv(uu,vv,xtab_tuv,ytab_tuv,UREF,VREF)
      implicit none
 
      real*8  uu, vv
      real    xtab_tuv(31,31)
      real    ytab_tuv(31,31)
      integer UREF, VREF
      real    rtab_tt
 
      real ut, vt
 
      ut = _TCEN_ + (uu-UREF)*2
      vt = _TCEN_ + (vv-VREF)*2
 
      xt_uv = rtab_tt(ut,vt,xtab_tuv)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function yt_uv(uu,vv,xtab_tuv,ytab_tuv,UREF,VREF)
      implicit none
 
      real*8 uu, vv
      real   xtab_tuv(31,31)
      real   ytab_tuv(31,31)
      integer UREF, VREF
      real   rtab_tt
 
      real ut, vt
 
      ut = _TCEN_ + (uu-UREF)*2
      vt = _TCEN_ + (vv-VREF)*2
 
      yt_uv = rtab_tt(ut,vt,ytab_tuv)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function xr_uv(uu,vv,xtab_tuv,ytab_tuv,
     .                    ILOC,JLOC,UREF,VREF)
      implicit none
 
      real*8  uu, vv
      real    xtab_tuv(31,31)
      real    ytab_tuv(31,31)
      integer ILOC, JLOC
      integer UREF, VREF
 
      real ru, rv
      real rtab_tt
 
      ru = _TCEN_ + (uu-UREF)*2
      rv = _TCEN_ + (vv-VREF)*2
 
      xr_uv = ILOC + (rtab_tt(ru,rv,xtab_tuv)-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function yr_uv(uu,vv,xtab_tuv,ytab_tuv,
     .                    ILOC,JLOC,UREF,VREF)
      implicit none
 
      real*8  uu, vv
      real    xtab_tuv(31,31)
      real    ytab_tuv(31,31)
      integer ILOC, JLOC
      integer UREF, VREF
 
      real ru, rv
      real rtab_tt
 
      ru = _TCEN_ + (uu-UREF)*2
      rv = _TCEN_ + (vv-VREF)*2
 
      yr_uv = JLOC + (rtab_tt(ru,rv,ytab_tuv)-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function ut_uv(uu,vv,UREF,VREF)
      implicit none
 
      real*8  uu, vv
      integer UREF, VREF
 
      ut_uv = _TCEN_ + (uu-UREF)*2
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function vt_uv(uu,vv,UREF,VREF)
      implicit none
 
      real*8  uu, vv
      integer UREF, VREF
 
 
      vt_uv = _TCEN_ + (vv-VREF)*2
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function ut_txy(xt,yt,utab_txy,vtab_txy)
      implicit none
 
      real   xt, yt
      real   utab_txy(31,31)
      real   vtab_txy(31,31)
      real   rtab_tt
 
      ut_txy = _TCEN_ + (rtab_tt(xt,yt,utab_txy)-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function vt_txy(xt,yt,utab_txy,vtab_txy)
      implicit none
 
      real   xt, yt
      real   utab_txy(31,31)
      real   vtab_txy(31,31)
      real   rtab_tt
 
      vt_txy = _TCEN_ + (rtab_tt(xt,yt,vtab_txy)-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function xt_tuv(ut,vt,xtab_tuv,ytab_tuv)
      implicit none
 
      real   ut,  vt
      real   xtab_tuv(31,31),ytab_tuv(31,31)
      real   rtab_tt
 
      xt_tuv = _TCEN_ + (rtab_tt(ut,vt,xtab_tuv)-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function yt_tuv(ut,vt,xtab_tuv,ytab_tuv)
      implicit none
 
      real   ut, vt
      real   xtab_tuv(31,31)
      real   ytab_tuv(31,31)
      real   rtab_tt
 
      yt_tuv = _TCEN_ + (rtab_tt(ut,vt,ytab_tuv)-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function xr_txy(xt,yt,ILOC,JLOC)
      implicit none
 
      real    xt,   yt
      integer ILOC, JLOC
 
      xr_txy = ILOC + (xt-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real function yr_txy(xt,yt,ILOC,JLOC)
      implicit none
 
      real    xt, yt
      integer ILOC, JLOC
 
      yr_txy = JLOC + (yt-_TCEN_)
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real*8 function uu_tuv(ut,vt,UREF,VREF)
      implicit none
 
      real    ut,   vt
      integer UREF, VREF
 
      uu_tuv = UREF + (ut-_TCEN_)*0.5d0
 
      return
      end
 
 
c---------------------------------------------------------------------
c
      real*8 function vv_tuv(ut,vt,UREF,VREF)
      implicit none
 
      real    ut,   vt
      integer UREF, VREF
 
      vv_tuv = VREF + (vt-_TCEN_)*0.5d0
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/find_brite_prox.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
      subroutine find_brite_prox(umast0,vmast0,
     .                           ubri,vbri,zbri,
     .                           uref_b,vref_b,zref_bf,Bs)
      implicit none
 
      real*8  umast0, vmast0
      real*8  ubri, vbri
      real    zbri
      integer Bs
      real*8  uref_b(Bs)
      real*8  vref_b(Bs)
      real    zref_bf(Bs,_FDIM_)
      real    dref
 
      integer B
      real    dbri
 
      ubri = 0.00
      vbri = 0.00
      zbri = 0.00
      dbri = 9e9
      do B = 1, Bs
         dref = sqrt((uref_b(B)-umast0)**2
     .              +(vref_b(B)-vmast0)**2)
         if (dref.lt.dbri) then
            dbri = dref
            ubri = uref_b(B)
            vbri = vref_b(B)
            zbri = zref_bf(B,1)
            endif
         enddo
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/loc_mask.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------------
c
c this routine will extract a local flux from the stack ; this is
c to be compared with the mask to see whether it is or isn't confusable
c with bright-star PSF artifacts
c
      real function loc_mask(ucen,vcen,stackm)
      implicit none
 
      real ucen
      real vcen
      real stackm(301,301)
 
      integer icen
      integer jcen
 
      real    fvtot
      real    svtot
      integer fntot
      integer sntot
 
      loc_mask = 0.
 
      icen = int(ucen+0.5)
      jcen = int(vcen+0.5)
 
      if (icen.lt.001) return
      if (jcen.lt.001) return
      if (icen.gt.301) return
      if (jcen.gt.301) return
 
      loc_mask = stackm(icen,jcen)
 
      return
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/TILE/loc_flux.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
c-------------------------------------------------------------------
c
c this routine will extract a local flux from the stack ; this is
c to be compared with the mask to see whether it is or isn't confusable
c with bright-star PSF artifacts
c
      real function loc_flux(ucen,vcen,stackv)
      implicit none
 
      real ucen
      real vcen
      real stackv(301,301)
 
      real ucenu
      real vcenu
 
      real    fvtot
      real    svtot
      integer fntot
      integer sntot
 
      integer ii,jj
 
      real    sky
      real    flx
 
      integer iucenu
      integer ivcenu
 
      loc_flux = 0.
 
      if (ucen.lt.001+9) return
      if (vcen.lt.001+9) return
      if (ucen.gt.301-9) return
      if (vcen.gt.301-9) return
 
      do iucenu = int(ucen+0.5)-1, int(ucen+0.5)+1
      do ivcenu = int(vcen+0.5)-1, int(vcen+0.5)+1
         fvtot = 0.
         fntot = 0
         svtot = 0.
         sntot = 0
         do ii = int(ucen+0.5)-5, int(ucen+0.5)+5
         do jj = int(vcen+0.5)-5, int(vcen+0.5)+5
            if ((ii-iucenu)**2+(jj-ivcenu)**2.le.05) then  ! one of inner 4 true...
               fvtot = fvtot + stackv(ii,jj)
               fntot = fntot + 1
               endif
            if ((ii-iucenu)**2+(jj-ivcenu)**2.gt.05.and.
     .          (ii-iucenu)**2+(jj-ivcenu)**2.lt.25) then  ! one of ring of 16...
               svtot = svtot + stackv(ii,jj)
               sntot = sntot + 1
               endif
            enddo
            enddo
         if (sntot.gt.0) then
            sky = svtot/sntot
            flx = (fvtot-fntot*sky)/4.0
            if (flx.gt.loc_flux) loc_flux = flx
            endif
         enddo
         enddo
 
      return
      end
 
 
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_i2_ltv.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
      subroutine writfits_i2_ltv(FILE,pix,PXDIMX,PXDIMY,SCL)
      implicit none
 
      character*(*) FILE
      integer PXDIMX,PXDIMY
      integer*2 pix(PXDIMX,PXDIMY)
      real SCL
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffc,buffb)
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*70 HDR(25)
      common/HDR/HDR
 
      character*80 FILEU
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
c     write(*,'(''ENTER   writfits_b1: '',80a)') FILEU
 
!$omp critical(writfits_b1)
      open(26,file=FILEU,
     .     status='unknown',
     .     err   =900,
     .     recl  =2880,
     .     form  ='UNFORMATTED',
     .     access='DIRECT')
 
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T    '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  =  16  '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   = '',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  = '',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  = '',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE= '',9a)')
     .                          ' ''BYTE    '''
      write(buffc( 6*80+1: 7*80),'(''DATE    = '',11a)')
     .                          ' ''28/01/00'''
      write(buffc( 7*80+1: 8*80),'(''BSCALE  = '',i12)') 00001
      write(buffc( 8*80+1: 9*80),'(''BZERO   = '',i12)') 00000
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',15x,i5)') 1
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',15x,i5)') 1
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',f20.7)') 1.000
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',f20.7)') 1.000
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a10)') ''' '''
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a10)') ''' '''
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',e20.7)')  1.0/SCL
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',e20.7)')  0.0
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',e20.7)')  0.0
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',e20.7)')  1.0/SCL
      write(buffc(19*80+1:20*80),'(''COMMENT'')')
      write(buffc(20*80+1:21*80),'(''LTV1    = '',f20.7)') 0.
      write(buffc(21*80+1:22*80),'(''LTV2    = '',f20.7)') 0.
      write(buffc(22*80+1:23*80),'(''LTM1_1  = '',f20.7)') SCL
      write(buffc(23*80+1:24*80),'(''LTM1_2  = '',f20.7)') 0.00
      write(buffc(24*80+1:25*80),'(''LTM2_1  = '',f20.7)') 0.00
      write(buffc(25*80+1:26*80),'(''LTM2_2  = '',f20.7)') SCL
      write(buffc(26*80+1:27*80),'(''TARGNAME= '',a20)') 'PKMAP'
      write(buffc(27*80+1:28*80),'(''COMMENT'')')
      write(buffc(28*80+1:29*80),'(''COMMENT'')')
      write(buffc(29*80+1:30*80),'(''COMMENT'')')
      write(buffc(30*80+1:31*80),'(''COMMENT'')')
      write(buffc(31*80+1:32*80),'(''COMMENT'')')
      write(buffc(32*80+1:33*80),'(''COMMENT'')')
      write(buffc(33*80+1:34*80),'(''COMMENT'')')
      write(buffc(34*80+1:35*80),'(''COMMENT'')')
      write(buffc(35*80+1:36*80),'(''END       '')')
 
c     print*,buffc
      write(26,rec=i,iostat=ios) buffc
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  = 2*PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         np1 = (nbyte0-nbyte1)/2 + 1
         np2 = (nbyteE-nbyte1)/2 + 1
         call pix2buff_i2(buffb,pix,np1,npt)
         write(26,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'WRITFITS.f ERROR'
      stop
  901 continue
      close(26)
!$omp end critical(writfits_b1)
      return
 
      end
 
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/FITS/writfits_r4_ltv.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
 
 
 
      subroutine writfits_r4_ltv(FILE,pix,PXDIMX,PXDIMY,SCL)
      implicit none
 
      character*(*) FILE
      integer PXDIMX,PXDIMY
      real    pix(PXDIMX,PXDIMY)
      real    SCL
 
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios
 
      character*2880 buffc
      byte buffb(2880)
      equivalence (buffb,buffc)
 
      integer ifirst, i1, i2
 
      integer np1, np2, npt
 
      character*80 FILEU
      character*70 HDR(25)
      common/HDR/HDR
 
      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo
 
c      write(*,'(''writfits_r4:  '',i5,''x'',i5,1x,80a)')
c     .            PXDIMX,PXDIMY,FILEU
 
!$omp critical(writfits_r4)
      open(23,file=FILEU,status='unknown',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')
 
      i = 1
      write(buffc( 0*80+1: 1*80),'(''SIMPLE  = T      '')')
      write(buffc( 1*80+1: 2*80),'(''BITPIX  = -32    '')')
      write(buffc( 2*80+1: 3*80),'(''NAXIS   ='',i12)') 2
      write(buffc( 3*80+1: 4*80),'(''NAXIS1  ='',i12)') PXDIMX
      write(buffc( 4*80+1: 5*80),'(''NAXIS2  ='',i12)') PXDIMY
      write(buffc( 5*80+1: 6*80),'(''DATATYPE='',9a)')
     .                          ' ''REAL*4'''
      write(buffc( 6*80+1: 7*80),'(''DATE    ='',11a)')
     .                          ' ''28/01/00'''
      write(buffc(07*80+1:08*80),'(''COMMENT  '',a05)') '     '
      write(buffc(08*80+1:09*80),'(''COMMENT  '',a05)') '     '
      write(buffc(09*80+1:10*80),'(''CRPIX1  = '',15x,i5)') 1
      write(buffc(10*80+1:11*80),'(''CRPIX2  = '',15x,i5)') 1
      write(buffc(11*80+1:12*80),'(''CRVAL1  = '',f20.7)')  1.000
      write(buffc(12*80+1:13*80),'(''CRVAL2  = '',f20.7)')  1.000
      write(buffc(13*80+1:14*80),'(''CTYPE1  = '',a10)') ''' '''
      write(buffc(14*80+1:15*80),'(''CTYPE2  = '',a10)') ''' '''
      write(buffc(15*80+1:16*80),'(''CD1_1   = '',e20.7)')  1.0/SCL
      write(buffc(16*80+1:17*80),'(''CD1_2   = '',e20.7)')  0.0
      write(buffc(17*80+1:18*80),'(''CD2_1   = '',e20.7)')  0.0
      write(buffc(18*80+1:19*80),'(''CD2_2   = '',e20.7)')  1.0/SCL
      write(buffc(19*80+1:20*80),'(''COMMENT'')')
      write(buffc(20*80+1:21*80),'(''LTV1    = '',f20.7)') (1.0-SCL)
      write(buffc(21*80+1:22*80),'(''LTV2    = '',f20.7)') (1.0-SCL)
      write(buffc(22*80+1:23*80),'(''LTM1_1  = '',f20.7)') SCL
      write(buffc(23*80+1:24*80),'(''LTM1_2  = '',f20.7)') 0.00
      write(buffc(24*80+1:25*80),'(''LTM2_1  = '',f20.7)') 0.00
      write(buffc(25*80+1:26*80),'(''LTM2_2  = '',f20.7)') SCL
      write(buffc(26*80+1:27*80),'(''TARGNAME= '',a20)') 'PKMAP'
      write(buffc(27*80+1:28*80),'(''COMMENT'')')
      write(buffc(28*80+1:29*80),'(''COMMENT'')')
      write(buffc(29*80+1:30*80),'(''COMMENT'')')
      write(buffc(30*80+1:31*80),'(''COMMENT'')')
      write(buffc(31*80+1:32*80),'(''COMMENT'')')
      write(buffc(32*80+1:33*80),'(''COMMENT'')')
      write(buffc(33*80+1:34*80),'(''COMMENT'')')
      write(buffc(34*80+1:35*80),'(''COMMENT'')')
      write(buffc(35*80+1:36*80),'(''END      '')')
 
      write(23,rec=i,iostat=ios) buffc
 
 
      ifirst = i+1
      i1 = i
      i2 = i
 
      nbper  = 4*PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880
 
      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         call pix2buff_r4(buffb,pix,np1,npt)
         write(23,rec=i,iostat=ios) buffc
         enddo
 
      goto 901
  900 continue
      print*,'writfits_r4.f ERROR'
      print*,'   FILEU: ',FILEU
      stop
  901 continue
      close(23)
!$omp end critical(writfits_r4)
      return
 
 
      end
 
 
c--------------------------------------------------
c GC - DISTORTION CORRECTION
c--------------------------------------------------
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/GEN/copy_j2_b1.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c-------------------------------------
c
c
      subroutine copy_j2_b1(a,b,NX,NY)
      implicit none
 
      integer NX, NY
      integer*2 a(NX,NY)
      byte      b(NX,NY)
 
      integer i,j
 
      do i = 01, NX
      do j = 01, NY
         b(NX,NY) = max(127,a(NX,NY))
         enddo
         enddo
 
      return
      end
 
c*********************************************
                                              
c*********************************************
c****                                         
c**** #include "ROUTINES/SETUP/extract_GsFsCs.f"
c****                                         
c*********************************************
                                              
c*********************************************
 
c----------------------------------------------
c
c
      subroutine extract_GsFsCs(INFILENAME,Gs,Fs,Cs)
      implicit none
 
      character*80 INFILENAME
      integer Gs, Fs, Cs
 
      character*20 STRING
      integer G, F
 
      logical VERBOSE
      common /VERBOSE_/VERBOSE
 
      Gs = 0
      Fs = 0
      Cs = 2
 
!$omp critical(extract_GsFsCs)
      open(89,file=INFILENAME,status='unknown')
    1 read(89,'(a20)',end=2) STRING
      if (STRING(1:8).eq.'VERBOSE+') VERBOSE = .true.
      if (STRING(1:8).eq.'VERBOSE-') VERBOSE = .false.
      if (STRING(1:6).eq.'F_SLOT') then
         read(STRING(9:12),*) F
         if (F.gt.Fs) Fs = F
         goto 1
         endif
      if (STRING(1:1).eq.' ') stop 'no leading blanks in infile...'
      if (STRING(1:1).ge.'1'.and.
     .    STRING(1:1).le.'9') stop 'any numbers must start with 0...'
      if (STRING(1:1).ne.'0') goto 1
      if (STRING(1:1).eq.'0') then
          read(STRING,*) G
          if (G.gt.Gs) Gs = G
          goto 1
          endif
      goto 1
    2 close(89)
!$omp end critical(extract_GsFsCs)
      return
      end
 
 
 
 
 
      subroutine psf_taper(psf,PSFTAPERR1,PSFTAPERR2)
      implicit none
      real psf(101,101)
      real PSFTAPERR1
      real PSFTAPERR2
 
      real    rpsf, fpsf
      integer ipsf, jpsf
 
      do ipsf = 001, 101
      do jpsf = 001, 101
         rpsf = sqrt((ipsf-51.)**2+(jpsf-51.)**2)*0.25
         fpsf = 1.0-(rpsf        -_PSFTAPERR1_)/
     .              (_PSFTAPERR2_-_PSFTAPERR1_)
         if (fpsf.lt.0) fpsf = 0.
         if (fpsf.gt.1) fpsf = 1.
         psf(ipsf,jpsf) = fpsf*psf(ipsf,jpsf)
         enddo
         enddo
 
      return
      end
 
 
 
